#include <math.h>
#include <stdlib.h>

#ifdef __cplusplus
#define Dmalloc(T,n)  new T[n]
#define Dfree(p)      delete[] p
#else
#define Dmalloc(T,n)  malloc(sizeof(T)*(n))
#define Dfree(p)      free(p)
#endif

#ifdef KR_headers
double *Dpaf (x, nx, c, nc, nres)
double *x; long nx; double *c; long nc; long *nres;
#else
double *Dpaf (double *x, long nx, double *c, long nc, long *nres)
#endif
{ long i, j, k, l, nloop;
  double *res;
  long *cl;

  nloop = nx/nc;
  cl    = Dmalloc(long,nc);
  for (*nres=i=0; i<nc; i++)
    if (c[i]) cl[(*nres)++] = i;
  if (*nres==0) { Dfree(cl); return (NULL); }

  res = Dmalloc(double,*nres*nloop);
  for (k=j=0; j<nloop; j++)
  { for (i=0; i<*nres; i++,k++)
      res[k] = x[j*nc+cl[i]];
  }
  /*  for (k=l=i=0; i<nx; i++)
  { if (l==nc) l=0;
    if (cl[l])res[k++] = x[l];
    } */
  Dfree(cl);
  return (res);
}

/*
#include <time.h>

int main ()
{ double x[1000], c[1000];
  long r, rep = 25000L, pn = 500;
  time_t start, end;

  for (r=0; r<1000; r++)
  { x[r] = 0;
    c[r] = (r<pn);
  }

  time (&start);  
  while (rep--)
    Dpaf(x, 1000, c, 1000, &r);
  time (&end);
  printf ("Used time: %f\n", difftime(end,start)); 
  return 0;
}

*/
