/* $Header: /home/xplore/cvs/xpl4gr/axe.h,v 1.3 2002/08/16 12:31:36 sigbert Exp $ */

#ifndef _AXE_H
#define _AXE_H

#include <math.h>
#include <malloc.h>
#include <stdio.h>
#include <string.h>
#include "xplmat.h"

class Achse	{	
	
	int dimension;		/* 1 by x, 2 by y, 3 by z...	*/
		
	float position[2];	//from_to
				
	float tickmarkpos[3]; 
				/*	1. for origin		*/
				/*	2. for major_offset	*/
				/*	3. for minor_offset	*/
				
	float tickmarkvalue[2];
				/*	m+l*k			*/
				/*	1. for m( default=0)	*/
				/*	2. for k( default=0)		*/
				
	char *axis_text;	/*	zb: "x=steurabgaben"	*/
	
	int ComputeTicks();
	/* sets automatically the whole tickmarkpos and values*/
	
public:
	XplMatrix all_koord;	/* position of axe in space (from)*/

	int font_number;
	
	bool visible;
	bool label_visible;
	bool ticktext_visible;

	xplmask line_out;	/* 	color, art, thickness	*/ 
	
	xplmask mark_out;	/* 	color, art, size	*/ 

	Achse();

	Achse(const int dim, const float from, const float to);

	~Achse();
	
	Achse(const Achse & old);

	Achse(const Achse * old);
	
	Achse & operator= (const Achse &);

	int SetPosition(const float from, const float to);
	/* set position[] und automatic tickmarkpos und values*/
	
	int SetTicks(const float origin, const float major, 
			const float minor=0);
	/* 	computes the tickmarks;
		if minor==0 then minor =major/5		*/
	
	int SetValues(const float m, const float mm); 
	
	int SetString(const char *string);
	
	int GetDimension()	const;

	Vector <float>  GetContent() const;
	
	char *GetString()	const;
	
	void Out();
	
//	double (*transf) (double) ;
		
			};
#endif

