/* $Header: /home/xplore/cvs/xpl4gr/chol.C,v 1.3 2002/08/16 12:31:39 sigbert Exp $ */

#include <math.h>

// SWS funcdef  

int chol(double *B, double *len, double *bb)
{
  // computes the Cholesky decomposition of a band matrix B
  //    B = L*D*L^T
  // where D is a diagonal matrix and L is a lower triangular band
  // matrix with diagonal elements all equal to 1. 
  //
  // it is assumed that only 2*band+1 main subdigonals
  // of the matrix B may be nonzero. The others entries of B must be zero. 
  //
  // allocation in the memory:
  // the matrix B is stored in the diagonal form 
  //     the diagonal B_{i,i} is stored in B[i*(band+1)]
  //     the subdiagonal B_{i,i-k} is stored in B[i*(band+1)+k]
  // 
  // the function "chol" replace B by its Choleski decomposition
  // the diagonal matrix D_{ii} is  allocated in B[i*(band+1)];
  // the low diagonals of the matrix L_{i,i-k} are stored in B[i*(band+1)+k],
  //  1=< k <= band 
long i,s,l, length,band;
double sum;
 length = (long)*len; band = (long)*bb;
 band = band-1;
 
       for(i=0;i< band; i++){
             for(l=i+1; l<=band;l++)
               {B[i*(band+1)+l]=0.0;}
       }
  
     for(i=1;i<length; i++){
       
         for(s=band;s> 0; s--){
            sum=0.0;
            for(l=s+1;l<= band;l++){
               if(i-l>= 0)
                 { sum=sum+B[i*(band+1)+l]*B[(i-l)*(band+1)]*
                   B[(i-s)*(band+1)+l-s];}
            }
 
           if (i>=s)
                 B[i*(band+1)+s] = (B[i*(band+1)+s]-sum)/B[(i-s)*(band+1)];
           
         }
       
         sum=0.0;
         for(l=1;l<= band;l++){
             if(i-l>=0)
              sum=sum+B[i*(band+1)+l]*B[(i-l)*(band+1)]*B[i*(band+1)+l];
            }
           
           B[i*(band+1)]=B[i*(band+1)]-sum;
         
     }
 
return 0;
}



