/* $Header: /home/xplore/cvs/xpl4gr/command.C,v 1.4 2003/02/23 16:45:58 cizek Exp $ */

/* PC MAC */
#ifdef __APPLE_CC__
char *cuserid(char *buf) 
{ 
     if (buf) 
          return buf; 
     else return "";
}
#endif

#include <stdio.h>
#include <sys/types.h>
#include <fstream.h>
#include <time.h>

#include "function.h"
#include "xplfun2.h"
#include "macro.h"

#include "main.h"
#include "init.h"
#include "color.h"
#include "display.h"
#include "plot.h"

#include "xplio.h"
#include "xchar.hpp"
#include "xarray.hpp"
#include "property.h"
#include "directory.h"
#include "logfile.h"

#ifndef X4batch         // SK 20.02.99
#include <X11/keysym.h>
#include <X11/keysymdef.h>
#endif

#ifdef _GRAPHICS_
extern Colormap cmap;	//OK
#endif

//char *infostring();


extern "C"	{

#ifdef _GUIDO_
	extern int starttime;
	extern char *gformat="%s %4d\t%s\t%s\t%s\n";
	extern char *gfname;
#endif

#ifdef _GRAPHICS_
extern Liste <Widget> *top_liste;
extern BS_Glob_Variable bs_glob_variable;


Widget com_wid;
Widget dialog;
Widget out_text;
Widget error_text=NULL;
Widget warning_text;

extern void ask_for_quitCB(Widget w, XtPointer p1, XtPointer p2);
extern void icon_all(Widget w, XtPointer p, XEvent *cbs, char *ch);
extern void selected_to_parser(Widget, XtPointer, XmListCallbackStruct *);
extern void try_quitCB(Widget w, XtPointer p1, XtPointer p2);
extern void startup();

extern void show_prog_box(Widget w, XtPointer p1, XtPointer p2);
extern Widget init_axisborders_menu();

void ParseCallback(Widget w, XtPointer p1, XtPointer p2)
{	XmCommandCallbackStruct *cs=(XmCommandCallbackStruct *)p2;
	char *line;
	XmString xmline;
	int lc, i;
	lc=XmStringLineCount(cs->value);
	if (lc==1)
	{	XmStringGetLtoR(cs->value, XmSTRING_DEFAULT_CHARSET, &line);
		write_to_log(line);
		write_to_log("\n");
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Command",
	 		"ENTER", line);
	fclose(gfile);
#endif
		parse(line);
		XtFree(line);
		return;
	}
	XmStringContext conni;
	if (!XmStringInitContext(&conni, cs->value))
	{	globalError.Set (ERR_INTERN, "Sorry, I cannot read it!");
		globalError.ShowError();
		return;
	}
	XmStringCharSet chari;
	XmStringDirection diri;
	Boolean sepi;
	char *text, buf[1024], *p;
	p=buf;
	for (i=0; i<lc; i++)
	{	if (XmStringGetNextSegment(conni, &text, &chari, &diri, &sepi))
		{	//cout<<i<<". zeile ist:"<<text<<"!!!\n";
			p+=strlen(strcpy(p, text));
			if (sepi)
			{	*p++='\n';
				*p=0;
			}
			XtFree(text);
		}
		else
		{	globalError.Set (ERR_INTERN, 
		"Sorry, I cannot read it!");
		globalError.ShowError();
			return;
		}
	}
	XmStringFreeContext(conni);
	//cout<<"TEXT:\n"<<buf<<"!!!"<<endl;
	write_to_log(buf);
	write_to_log("\n");
	parse(buf);
	
	/*
	XtVaGetValues( XmCommandGetChild( w, XmDIALOG_COMMAND_TEXT),
		XmNhistoryItemCount, & i, NULL);
	cout<<"in parser sind es "<<i<< " Eintraege"<<endl;
	*/
}

void helpCB(Widget w, XtPointer p1, XtPointer p2)  // SK 23.06.98
{	// extern char * WWWBrowser;
	extern char * WWWStartPage;
        char *WWWPage;

  
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Command", "CLICK",
			"Help");
	fclose(gfile);
#endif	
	char cmd[1024]; 

        WWWPage = openfile (HELP, WWWStartPage, "r");
	sprintf (cmd, "%s %s &", property.getProperty("browser"), WWWPage);

	system (cmd);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Html", "CONNECTED", "");
	fclose(gfile);
#endif	
}


Boolean functions_exist=False;
Boolean macros_exist=False;
Boolean objects_exist=False;
Boolean info_exist=False;


void not_implemented(Widget w, XtPointer p1, XtPointer p2)
{	cerr << "SORRY!!!"<<endl<<"Is  not implemented"<<endl;
	return;
}

typedef struct for_find{	Widget str;
				Widget list;
			}
	ForFind;

void findCB(Widget w, XtPointer p1, XtPointer p2)
{	ForFind *ff=(ForFind *) p1;
	char *te=XmTextGetString(ff->list);

	static char *last_str=NULL;
	static int topch=0;

	char *str=XmTextFieldGetString(ff->str);
	char *str_de=str;
	while (str[0]==' ') str++;
	while (str[strlen(str)-1]==' ')  str[strlen(str)-1]=0;
	
	if ( last_str==NULL || strcmp(last_str, str))
	{	topch=0;
	}

	char *wo=strstr(te+topch+1, str);
	if (! (wo==NULL))
	{	XmTextSetHighlight(ff->list, 
			0, strlen(te), XmHIGHLIGHT_NORMAL);
		int top=(int)(wo-te);
#ifndef _DECALPHA_
		XmTextSetTopPosition(ff->list, top);
#endif
		XmTextSetHighlight(ff->list, 
			top, top+strlen(str), XmHIGHLIGHT_SELECTED);
		topch=top;
	}
	else
	{	XmTextSetHighlight(ff->list, 
			0, strlen(te), XmHIGHLIGHT_SELECTED);

		XmTextSetHighlight(ff->list, 
			0, strlen(te), XmHIGHLIGHT_NORMAL);
	}
	last_str=strdup(str);
	delete te;
	delete str_de;
	
}

void addtostr(Widget w, XtPointer p, XmTextVerifyCallbackStruct *cbs)
{	ForFind * ff;
	cbs->doit=True;
	char buffer[1];
	char *str1, str2[256];
	Boolean *which=(Boolean *)p;	
	int i, oldl;

	XtVaGetValues(w, XmNuserData, &ff, NULL);
	str1=XmTextGetString(ff->str);
	oldl=strlen(str1);

	if (cbs->startPos+strlen(str1)==cbs->endPos && strlen(str1)!=0 
			&& cbs->text->length!=0)	
		//kommt nach SetString; kein Backspace!
	{	for (i=0; i<cbs->text->length; i++)
			str2[i]=buffer[i];
		str2[i]=0;
	}
	else
		if (cbs->startPos<cbs->currInsert)	//BackSpace
		{	if (!strcmp(str1, " "))
			{	XtFree(str1);
				return;
			}
			str1[oldl-1]=0;
			if (strlen(str1)==0)
				sprintf(str2, "%s", " ");
			else
				sprintf(str2, "%s", str1);		
		}			
		else	
		if (!strcmp(str1, " "))
		{	buffer[0]=cbs->text->ptr[0];	
			str2[0]=buffer[0];
			str2[1]=0;
			oldl=0;
		}
		else
			if (oldl<5)
		{	buffer[0]=cbs->text->ptr[0];	
			sprintf(str2, "%s%c", str1, buffer[0]);
		}
		else
		{	XtFree(str1);
			return;
		}

	//XmTextSetString(ff->str, str2);
	XtFree(str1);
	if (!strcmp(str2, " "))
		return;
	
	if (which==&functions_exist)
	{	for (i=0; i<funList->laenge(); i++)
			if (!strncmp((*funList)[i]->Name(), str2, strlen(str2)))
				break;
		if (i==funList->laenge())
			XBell(XtDisplay(bs_glob_variable.main_shell),100);
			
		else
		{	XmListSetPos(ff->list, i);
			XmListSelectPos(ff->list, i+1, True);
		}
	}
	if (which==&macros_exist)
	{	for (i=0; i<macList->laenge(); i++)
			if (!strncmp((*macList)[i]->Name(), str2, strlen(str2)))
				break;
			
		if (i==macList->laenge())
			XBell(XtDisplay(bs_glob_variable.main_shell), 100);	
		else
		{	XmListSetPos(ff->list, i);
			XmListSelectPos(ff->list, i+1, False);
		}
	}		
	if (which==&objects_exist)
	{	for (i=0; i<objList->laenge(); i++)
			if (!strncmp((*objList)[i]->Name(), str2, strlen(str2)))
				break;
			
		if (i==objList->laenge())
			XBell(XtDisplay(bs_glob_variable.main_shell), 100);	
		else
		{	XmListSetPos(ff->list, i);
			XmListSelectPos(ff->list, i+1, False);
		}
	}	
}
void keyhandler(Widget w, XtPointer p, XEvent *cbs, char *ch)
{	char buffer[1];

	XComposeStatus com;
	KeySym ks;
	int i, oldl;
	ForFind * ff;
	char *str1, str2[32], str3[32];
	Boolean *which=(Boolean *)p;	
	i=XLookupString(&(cbs->xkey), buffer, 1, &ks, &com);
	
	//cout<<"keysym="<<ks<<endl;
	
	if ((!(((ks>=XK_KP_Space) && (ks<=XK_KP_9)) || 
		((ks>=XK_space) && (ks<=XK_asciitilde)))) && (ks!=XK_BackSpace))
		return;
	//cout<<"keysym="<<ks<<endl;
	
	XtVaGetValues(w, XmNuserData, &ff, NULL);
		
	str1=XmTextGetString(ff->str);
	oldl=strlen(str1);
	
	if (ks==XK_BackSpace)
	{	if (oldl==0)
		{	XtFree(str1);
			return;
		}
		XtFree(str1);
		XmTextReplace(ff->str, oldl-1, oldl, "");
		return;
	}
		str2[0]=buffer[0];
		str2[1]=0;
		XmTextInsert(ff->str, oldl, str2);
		XtFree(str1);

}

Widget macros_text;

void refresh_macros()
{	if (!macros_exist)
		return;
	char * str;
	XmString xms;

	int i;
	XmListDeleteAllItems(macros_text);
	for (i=0; i<macList->laenge(); i++)
	{	str=strdup((*macList)[i]->Name());
		xms=XmStringCreateSimple(str);
		XmListAddItem(macros_text, xms, 0);
		XmStringFree(xms);
		delete str;
	}
}

Widget show_liste(char *title, char *name, Boolean *which)
{	Widget some_list;
	Widget out_shell, form, menu, fi_bu, fi_te;
	ForFind *ff;
	
#ifdef _BLABLA_
	cout<<"show_liste"<<endl;
#endif
	out_shell=XtCreatePopupShell(title,
	 		topLevelShellWidgetClass,
			bs_glob_variable.main_shell, (Arg*)NULL, 0);
//	SWS!	top_liste->haengeAn(out_shell);
	form=XmCreateForm(out_shell, "fun_form", (Arg *)NULL, 0);
	some_list=XmCreateScrolledList(form, name, (Arg *)NULL, 0);
	menu=XmCreateRowColumn(form, "menu_fun",
				(Arg *)NULL, 0);

	XtVaSetValues(menu, XmNorientation, XmHORIZONTAL, 
			XmNrightAttachment, XmATTACH_FORM, 
			XmNleftAttachment, XmATTACH_FORM, 
			XmNtopPosition, 90, 
			XmNtopAttachment, XmATTACH_POSITION, 
		//	XmNtopWidget, some_list, 
		// 	XmNtopAttachment, XmATTACH_WIDGET,
		 	XmNbottomAttachment, XmATTACH_FORM, 
		 	XmNheight, 50,
		 	XmNresizeHeight, False,	NULL);
	//	fi_bu=XmCreatePushButton(menu, "Find", (Arg *)NULL, 0);
	fi_bu=XmCreateLabel(menu, "Search for :", (Arg *)NULL, 0);
	fi_te=XmCreateTextField(menu, "fite", (Arg *)NULL, 0);
	XtVaSetValues(fi_te, XmNcolumns, 5, XmNeditable, True, NULL);
	XmTextFieldSetString(fi_te, "");

	XtVaSetValues(XtParent(some_list), 
		 		XmNtopAttachment, XmATTACH_FORM,
		 		XmNrightAttachment, XmATTACH_FORM,
		 		XmNleftAttachment, XmATTACH_FORM, 
			XmNbottomPosition, 90, 
			XmNbottomAttachment, XmATTACH_POSITION, 
				NULL);

/*	XtVaSetValues(XtParent(some_list), 
		 		XmNtopAttachment, XmATTACH_WIDGET,
		 		XmNtopWidget, menu, 
		 		XmNrightAttachment, XmATTACH_FORM,
		 		XmNleftAttachment, XmATTACH_FORM,
		 		XmNbottomAttachment, XmATTACH_FORM, NULL);
*/
	ff=new ForFind ;
	ff->str=fi_te;
	ff->list=some_list;

	XtAddCallback(fi_te, XmNmodifyVerifyCallback, addtostr, 
		(XtPointer) which);

	XtVaSetValues(fi_te, XmNuserData, (XtPointer ) ff, NULL);
	XtVaSetValues(some_list, XmNeditable, False, 
				XmNselectionPolicy, XmSINGLE_SELECT, 
				//XmNscrollingPolicy, XmAPPLICATION_DEFINED,
				//XmNvisualPolicy, XmVARIABLE,
				//XmNscrollBarDisplayPolicy, XmSTATIC, 
				XmNeditMode, XmMULTI_LINE_EDIT,
				XmNscrollHorizontal, False,
				XmNscrollVertical, True, 
				XmNuserData, (XtPointer ) ff,
				XmNvisibleItemCount, 9,	NULL);
		 	
	XtManageChild(some_list);
	XtManageChild(fi_te);
	XtManageChild(fi_bu);
	
	XtManageChild(menu);
	
	XtManageChild(form);
	XtAddEventHandler(some_list,  KeyPressMask,
				False, keyhandler, (XtPointer) which);
	//	XtAddCallback(fi_bu, XmNactivateCallback, findCB, ff);
	//XtAddCallback(fi_te, XmNactivateCallback, findCB, ff);
	return(some_list);		 
}

void setnull(Widget w, XtPointer p1, XmListCallbackStruct *cbs)
{	Widget help_text;
	
	//cout<<XtName(w)<<", "<<XtName( (Widget) p1)<<endl;

	if (	strcmp(XtName(w), "Functions")==0 || 
		strcmp(XtName(w), "Help")==0)
	{	functions_exist=False;
#ifdef _BLABLA_
	cout<<"setnull for functions"<<endl;
#endif
		help_text= (Widget)p1;
		XtRemoveCallback(help_text, XmNdestroyCallback, 
			setnull, (XtPointer)w);
		if (	strcmp(XtName(w), "Functions")!=0)
			help_text=XtParent(XtParent(help_text));

		XtPopdown(XtParent(help_text));
		XtDestroyWidget(XtParent(help_text));
	}		
	if (	strcmp(XtName(w), "Objects")==0 || 
		strcmp(XtName(w), "Content")==0)
	{	objects_exist=False;
#ifdef _BLABLA_
	cout<<"setnull for objects"<<endl;
#endif
		help_text= (Widget)p1;
		XtRemoveCallback(help_text, XmNdestroyCallback, 
				setnull, (XtPointer) w);
		if (	strcmp(XtName(w), "Objects")!=0)
			help_text=XtParent(XtParent(help_text));

		XtPopdown(XtParent(help_text));
		XtDestroyWidget(XtParent(help_text));
	}	
	if (	strcmp(XtName(w), "Macros")==0 )
	{	macros_exist=False;
#ifdef _BLABLA_
	cout<<"setnull for macros, "<<XtName(p1)<<endl;
#endif
		help_text= (Widget)p1;
		XtRemoveCallback(help_text, XmNdestroyCallback, 
			setnull, (XtPointer)w);

		XtPopdown(XtParent(XtParent(XtParent(help_text))));
		XtDestroyWidget(XtParent(XtParent(XtParent(help_text))));
	}		
	if (	strcmp(XtName(w), "info_text")==0 )
	{	info_exist=False;
#ifdef _BLABLA_
	cout<<"setnull for info, "<<XtName((Widget)p1)<<endl;
#endif
		help_text= (Widget)p1;
		XtRemoveCallback(help_text, XmNdestroyCallback, 
			setnull, (XtPointer)w);

		XtPopdown(XtParent(help_text));
		XtDestroyWidget(XtParent(help_text));
	}		

}
void shorthelp(Widget w, XtPointer p1, XmListCallbackStruct *cbs)
{	char *item, *sh;
	int sic;
	
	Widget help_text= (Widget)p1;
	sic=cbs->selected_item_count;
	if (sic==0)	//item is deselected!
	{	XtPopdown(XtParent(help_text));
		return;
	}	
	XmStringGetLtoR(cbs->item, XmSTRING_DEFAULT_CHARSET, &item);	
	sh=GetHelp(item);
	XtFree(item);

	if( sh==NULL)
		sh=strdup("no shorthelp \nfor this function");
	//	cout<<sh<<", count="<<sic<<endl;
#ifdef _BLABLA_
	cout<<"ShortHelp:"<<endl;
	cout<<sh<<endl;
#endif


	if (sh[strlen(sh)-1]=='\n')
		sh[strlen(sh)-1]=0;
	XmTextSetString(help_text, sh);
	int lines=0; 
	int cols=0;
	int len=strlen(sh);
	char *nlb=sh;
	int i;
	for (i=0; i<len; i++)
	if ((sh+i)[0]=='\n' || i==len-1)
		{	lines++;
			if (cols<sh+i-nlb+1)
				cols=sh+i-nlb+1;
			nlb=sh+i+1;
		}
	
	//cout<<cols<<" columns, "<<lines<<" lines"<<endl;
	if (lines>0)
		XtVaSetValues(help_text, XmNcolumns, cols, XmNrows, lines, NULL);
	XtPopup(XtParent(help_text), XtGrabNone);
	delete sh;
}

void show_macros(Widget w, XtPointer p1, XtPointer p2)
{	int ic, i;
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Command", "CLICK",
			"Macros");
	fclose(gfile);
#endif	

	if (!macros_exist)
	{	macros_text=show_liste("XploRe_Macros", "Macros",&macros_exist);
		macros_exist=True;
		XtAddCallback(macros_text, XmNdestroyCallback, setnull, 
			(XtPointer)macros_text);
	}
	else
	{	XtVaGetValues(macros_text, XmNitemCount, &ic, NULL);
		for (i=0; i<ic; i++)
			XmListDeletePos(macros_text, 0);
	}
	char * str;
	XmString xms;

	for (i=0; i<macList->laenge(); i++)
	{	str=strdup((*macList)[i]->Name());
		xms=XmStringCreateSimple(str);
		XmListAddItem(macros_text, xms, 0);
		XmStringFree(xms);
		delete str;

#ifdef _BLABLA_
		cout<<(*macList)[i]->Name()<<endl;
#endif	
	}
#ifdef _BLABLA_
	cout<<i<<" macros\n";
#endif	
	
	XtManageChild(macros_text);
	XtPopup(XtParent(XtParent(XtParent(macros_text))), XtGrabNone);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Macros", "OPENED", "");
	fclose(gfile);
#endif	
}

void show_functions(Widget w, XtPointer p1, XtPointer p2)
{	static Widget functions_text;
	Widget help_shell, help_text;

#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Command", "CLICK",
			"Functns");
	fclose(gfile);
#endif	

	Dimension x, y;
	int i, ic;	

	if (! functions_exist)
	{	functions_text=show_liste("XploRe_Functions", "Functions",
				&functions_exist);
		help_shell=XtCreatePopupShell("ShortHelp",
	 		topLevelShellWidgetClass,
			bs_glob_variable.main_shell, (Arg*)NULL, 0);
		help_text=XmCreateText(help_shell, "Help", (Arg *)NULL, 0);
		XtVaSetValues(help_shell, XmNallowShellResize, True, NULL);
		XtVaSetValues(help_text, XmNeditable, False, 
			XmNeditMode, XmMULTI_LINE_EDIT, NULL);
		XtManageChild(help_text);
	
		XtVaSetValues(functions_text, 
			XmNselectionPolicy, XmSINGLE_SELECT, NULL);
		XtAddCallback(functions_text, XmNsingleSelectionCallback, 
			shorthelp, XtPointer(help_text));
		XtAddCallback(functions_text, XmNdestroyCallback, setnull, 
			(XtPointer)help_text);
		XtAddCallback(help_text, XmNdestroyCallback, setnull, 
			(XtPointer)functions_text);
		functions_exist=True;
	}
	
	else
	{	XtVaGetValues(functions_text, XmNitemCount, &ic, NULL);
		for (i=0; i<ic; i++)
			XmListDeletePos(functions_text, 0);
	}
	char * str;
	XmString xms;
	
	for (i=0; i<funList->laenge(); i++)
	{	str=strdup((*funList)[i]->Name());
		xms=XmStringCreateSimple(str);
		XmListAddItem(functions_text, xms, 0);
		XmStringFree(xms);
		delete str;

#ifdef _BLABLA_
		cout<<(*funList)[i]->Name()<<endl;
#endif	
	}
#ifdef _BLABLA_
	//cout<<i<<" functions\n";
#endif		
	XtManageChild(functions_text);
	XtPopup(XtParent(XtParent(XtParent(functions_text))), XtGrabNone);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Functns", "OPENED", "");
	fclose(gfile);
#endif	
}
     
Widget objects_text;

void objcontent(Widget w, XtPointer p1, XmListCallbackStruct *cbs)
{	Widget con_text= (Widget)p1;
	if (cbs->selected_item_count==0)	//item is deselected!
	{	XtPopdown(XtParent(con_text));
		return;
	}	

	int line_num=cbs->item_position-1;

	char textstr[32560];
	textstr[0]=0;
	char *t;
	XplDouble *xpld;
	int j, k, ro, co, x, y;
	Component *comp=(*objList)[line_num]->DefaultComponent();
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Objects", "CLICK",
			(*objList)[line_num]->Name());
	fclose(gfile);
#endif	
	XplChar *xxx;
	SubDisplay *sd;
	int r, c;
	
	switch	(comp->Type())
	{	case C_XPLDOUBLE:
			xpld=comp->Content().xpldouble;
			ro=xpld->dimension(0);
			co=xpld->dimension(1);
			if (ro>20 || co>10)
			{	sprintf(textstr, "%s\n%s%d%s%d%s\n",
				"Matrix is too large to view",
				"Only first ",  
				20, 
				" rows and ", 10, " columns are viewed");
				ro=ro>20 ? 20 : ro;
				co=co>10 ? 10 : co;
			}
			k=0;
			for (j=0; j<ro ; j++)
			{	for (k=0; k<co; k++)
				sprintf(textstr, "%s%7.7f ", textstr,
				 	(*xpld)(j,k));
				sprintf(textstr, "%s\n", textstr);
			}
			break;
		case C_DISPLAY:
			r=comp->Content().display->GetRows();
			c=comp->Content().display->GetColumns();
			for (j=1; j<c+1; j++)
			for (k=1; k<r+1; k++)
			{	sd=comp->Content().display->GetElement(k, j);
				switch(sd->WhatIs())
				{case TEXT:
					sprintf(textstr, "%s TEXT",
					 	textstr);
				 	break;
				 case UPLOT:
					sprintf(textstr, "%s PLOT",
					 	textstr);
					 break;
				 default:
					sprintf(textstr, "%s DEFAULT",
					 	textstr);
					 break;
				}
				if (j==c)
					sprintf(textstr, "%s\n",
					 	textstr);
			}
			break;
			
		case C_XPLCHAR:
#ifdef _XPLCDEF_
			xxx=comp->Content().xplchar;
  			t = (*xxx)(0).tostr();	//OK!
#else
  			t = comp->Content().text;
#endif
			sprintf(textstr, "%s", t);
#ifdef _XPLCDEF_
			delete t;
#endif
			break;
		default:
			sprintf(textstr, "is an unknown type");
			break;
	}

	char *sh=textstr;
	if (sh[strlen(sh)-1]=='\n')
		sh[strlen(sh)-1]=0;
	XmTextSetString(con_text, sh);
	int lines=0; 
	int cols=0;
	int len=strlen(sh);
	char *nlb=sh;
	int i;

	for (i=0; i<len; i++)
	if ((sh+i)[0]=='\n' || i==len-1)
		{	lines++;
			if (cols<sh+i-nlb+1)
				cols=sh+i-nlb+1;
			nlb=sh+i+1;
		}
	
	if (lines>0)
		XtVaSetValues(con_text, XmNcolumns+5, cols, XmNrows, lines+1, NULL);
	XtPopup(XtParent(con_text), XtGrabNone);
	delete sh;
}

void show_objects(Widget w, XtPointer p1, XtPointer p2)
{	Widget con_shell, con_text;
	int ic;
	int i, child_count, lae;

#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Command", "CLICK",
			"Objects");
	fclose(gfile);
#endif	

	if (!objects_exist)
	{	objects_text=show_liste("XploRe_Objects", "Objects",
				&objects_exist);
		con_shell=XtCreatePopupShell("Object_Content",
	 		topLevelShellWidgetClass,
			bs_glob_variable.main_shell, (Arg*)NULL, 0);
		con_text=XmCreateText(con_shell, "Content", (Arg *)NULL, 0);
		XtVaSetValues(con_shell, XmNallowShellResize, True, NULL);
		XtVaSetValues(con_text, XmNeditable, False, 
			XmNeditMode, XmMULTI_LINE_EDIT, NULL);
		XtManageChild(con_text);
	
		XtVaSetValues(objects_text, 
			XmNselectionPolicy, XmSINGLE_SELECT, NULL);
	
		XtAddCallback(objects_text, XmNsingleSelectionCallback, 
			objcontent, XtPointer(con_text));
	
		XtAddCallback(objects_text, XmNdestroyCallback, setnull, (XtPointer) con_text);

		XtAddCallback(con_text, XmNdestroyCallback, setnull, (XtPointer) objects_text);

		objects_exist=True;
	}
	else
	{	XtVaGetValues(objects_text, XmNitemCount, &ic, NULL);
		for (i=0; i<ic; i++)
			XmListDeletePos(objects_text, 0);
	}

	char * str;
	XmString xms;

	const char *text;
	char text1[1024], text_all[32000], *t;
	text_all[0]=0;
	Component *comp;
	XplChar *xxx;
	int j;
	int di[MAX_XARRAY];

	for (i=0; i<objList->laenge(); i++)
	{	text=(*objList)[i]->Name();
		comp=(*objList)[i]->DefaultComponent();
#ifdef _BLABLA_
		cout<<"Object "<<text<<" has MotherId "<<
				(*objList)[i]->Id()<<endl;
#endif
		switch((*objList)[i]->DefaultType())
		{	case C_XPLDOUBLE:
			for (j=0; j<MAX_XARRAY; j++)
			di[j]=comp->Content().xpldouble->
			 			dimension(j);
			sprintf(text1, "%s has dimension (", text);
			for (j=0; j<MAX_XARRAY-1; j++)
			 	sprintf(text1, "%s%d, ", text1, di[j]);
			sprintf(text1, "%s, %d)", text1, di[MAX_XARRAY-1]);
			
			break;
			 
			case C_DISPLAY :
			sprintf(text1, "%s is a display (%d, %d)", text,
					comp->Content().display->GetRows(),
					comp->Content().display->GetColumns()); 
	 		break;
	 		
			case C_XPLCHAR:

#ifdef _XPLCDEF_
			xxx=comp->Content().xplchar;
  				t = (*xxx)(0).tostr();	//OK!
#else
  			t = comp->Content().text;
#endif
			sprintf(text1, "%s is a XplChar with %d chars", text,
					strlen(t)); 
#ifdef _XPLCDEF_
			delete t;
#endif
	 		break;


	 		default:
	 		sprintf(text1, "%s has an unknown type", text);
	 		break;
	 	}
		str=text1;
		xms=XmStringCreateSimple(str);
		XmListAddItem(objects_text, xms, 0);
		XmStringFree(xms);
	}
	XtManageChild(objects_text);
	XtPopup(XtParent(XtParent(XtParent(objects_text))), XtGrabNone);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Objects", "OPENED", "");
	fclose(gfile);
#endif	
}

/*
void infostring(char *str)
{
#ifdef _EXPIRE_
        sprintf (str, "License will expire on %s\n", expireString);
#else
        str[0] = 0;
#endif
        dump(str, DATA, 0); strcat(str, "\n");
        dump(str, LIB, 0); strcat(str, "\n");
        dump(str, DLL, 0); strcat(str, "\n");
        dump(str, HELP, 0); strcat(str, "\n");
        dump(str, PROG, 0); strcat(str, "\n");
        dump(str, TEMP, 0); strcat(str, "\n\n");
        dump(str, DATA, 1); strcat(str, "\n");
        dump(str, LIB, 1); strcat(str, "\n");
        dump(str, DLL, 1); strcat(str, "\n");
        dump(str, HELP, 1); strcat(str, "\n");
        dump(str, PROG, 1); strcat(str, "\n");
        dump(str, TEMP, 1); strcat(str, "\n\n");

#ifdef _BLABLA_
	cout<<str<<endl;
#endif

}
*/
void infoCB(Widget w, XtPointer p1, XtPointer p2)
{	Widget out_shell;
	static Widget info_text;
//	static Boolean on=True;
	char str[16384], backstr[64];
	time_t tim;
	char *timestr, *userstr;
	
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Command", "CLICK",
			"Info");
	fclose(gfile);
#endif	

	if (!info_exist)
	{	out_shell=XtCreatePopupShell("XploRe_Info", 			
			topLevelShellWidgetClass,
			bs_glob_variable.main_shell, (Arg*)NULL, 0);
		top_liste->haengeAn(out_shell);
		info_text=XmCreateText(out_shell,
		 "info_text", (Arg *)NULL, 0);
		 XtVaSetValues(info_text, XmNrows, 10, 
		 		XmNcolumns, 45, 
		 		XmNeditable, False,
		 		XmNeditMode, XmMULTI_LINE_EDIT, NULL);
		XtAddCallback(info_text, XmNdestroyCallback, setnull, 
			(XtPointer)info_text);
		info_exist=True;
	}
/*
	if (! on)
	{	XtPopdown(XtParent(info_text));
		on=!on;

#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Info", "CLOSED", "");
	fclose(gfile);
#endif	
		return;
	}
*/
	tim=time(NULL);
	timestr=ctime(&tim);
	userstr=cuserid(NULL);
		
/*	if (xpl4backup==NULL)
		sprintf(backstr, "XPL4BACKUP is not set");
	else
		sprintf(backstr, "XPL4BACKUP=%s", xpl4backup);
*/ // SK 25.06.98	
	infostring(str);

	XmTextSetString(info_text, str);
	XtManageChild(info_text);
	XtPopup(XtParent(info_text), XtGrabNone);
//	on=!on;
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Info", "OPENED", "");
	fclose(gfile);
#endif	

}

extern char * data_name;
extern Boolean data_read_ready;
extern XplDouble *read_res;

void read_dataCB(Widget w, XtPointer p1, XtPointer p2)
{	Widget list;	
	int pos, resres;
	XmString tstr;
	XmFileSelectionBoxCallbackStruct *cbs=
				(XmFileSelectionBoxCallbackStruct *) p2;
	char *var_n, str[1024];
	XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &var_n);	
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "DataW", "CLICK",
			"OK");
	fclose(gfile);
#endif
	sprintf(str, "noname=read(\"%s\")", var_n);
	
	if (!data_read_ready)
	{	
#ifdef MATRIX
    	if (ReadMatrix (var_n, *read_res) == 0)
#else
    	resres=read_res->ReadASCIIXplArray(var_n);
    	if (resres==0 || read_res->size()==0)
#endif
      		{	XtFree(var_n);
      			delete read_res;	
      				//war allociert in readFromFileSelectionBox
			XtUnmanageChild(w);
      			read_res=NULL;
      			data_read_ready=True;
      			return;
		}
      		XtFree(var_n);
      		data_read_ready=True;
		XtUnmanageChild(w);
      		return;
	}
	
	//cout<<"data_read_ready"<<endl;
	tstr=XmStringCreateSimple(str);
	XtUnmanageChild(w);
	
	list=XmCommandGetChild(com_wid, XmDIALOG_HISTORY_LIST);
	XtVaGetValues(list, XmNtopItemPosition, &pos, NULL);
	if (pos>1)	pos++;
	XmListAddItem(list, tstr, 0);
	XtVaSetValues(list, XmNtopItemPosition, pos, NULL);
	XmStringFree(tstr);	//OK
//	cout<<str<<endl;
	write_to_log(str);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "XploRe", "TO READ",
			var_n);
	fclose(gfile);
#endif
	parse(str);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "XploRe", "READ END",
			var_n);
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "DataW", "CLOSED",
			var_n);
	fclose(gfile);
#endif
	XtFree(var_n);
}

void data_unmanageCB(Widget w, XtPointer p1, XtPointer p2)
{	XtUnmanageChild(w);
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "DataW", "CLICK",
			"Cancel");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "DataW", "CLOSED",
			"");
	fclose(gfile);
#endif
}

void prog_cancelCB(Widget w, XtPointer p1, XtPointer p2)
{	
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Program", "CLICK",
			"Cancel");
	fclose(gfile);
#endif

	XtUnmanageChild(w);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Program", "CLOSED", "");
	fclose(gfile);
#endif
}


Widget data_fsb;

void show_data_box(Widget w, XtPointer p1, XtPointer p2)
{	static Widget data_box=NULL;
	Widget child1;
	Boolean ja;
	XmString xms;
	

#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Command", "CLICK",
			"Data");
	fclose(gfile);
#endif

	if (data_box==NULL)
	{	data_box=XmCreateFileSelectionDialog(
			bs_glob_variable.main_shell, "data_box", 
				NULL, 0);
		data_fsb=data_box;
	/*	child1=XmFileSelectionBoxGetChild(data_box,
		 			XmDIALOG_FILTER_TEXT);
		XtVaGetValues(child1, XmNautoShowCursorPosition, &ja, NULL);
		if (ja)
			cout<<"VISIBLE!!!!\n";
		else
			cout<<"UNVISIBLE!!!!\n";
			
		XtVaGetValues(child1, XmNcursorPositionVisible, &ja, NULL);
		if (ja)
			cout<<"VISIBLE!!!!\n";
		else
			cout<<"UNVISIBLE!!!!\n";
	*/	
		xms=XmStringCreateSimple(NULL); // ( xpl4data);
		XtVaSetValues(data_box, XmNdirectory, xms, NULL);
		XmStringFree(xms); 	//OK
		XtAddCallback(data_box, XmNokCallback, read_dataCB, 
					XtPointer(NULL));
		XtAddCallback(data_box, XmNcancelCallback, data_unmanageCB, 
					XtPointer(NULL));		
	}
	XtManageChild(data_box);
	if (!data_read_ready)	// read() as command...
		XtUnmanageChild(XmFileSelectionBoxGetChild(data_box,
		 			XmDIALOG_CANCEL_BUTTON));
	else
		XtManageChild(XmFileSelectionBoxGetChild(data_box,
		 			XmDIALOG_CANCEL_BUTTON));
	XtManageChild(data_box);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "DataW", "OPENED", "");
	fclose(gfile);
#endif	
}

void text_to_parse(char *str)
{	char *current, *next;
	Widget list;
	XmString tstr;
	int pos, len;
	char strtopar[612];

	list=XmCommandGetChild(com_wid, XmDIALOG_HISTORY_LIST);
	XtVaGetValues(list, XmNtopItemPosition, &pos, NULL);
#ifdef _BLABLA_
	cout<<"text_to_parse: "<<str<<" ENDE"<<endl;
#endif	
	int i;
	write_to_log(str);	
	parse(str);

	/*
	for (i=0; i<strlen(str); i++)
		if ( ((int)(str[i])<32 || (int)(str[i])> 126) &&
			str[i]!='\n' && str[i]!='\t' )
		{	str[i]=' ';
		}
	
	char *sss=new char [strlen(str)+2];
	sprintf(sss, "%s\n", str);
	current=sss;
	next=strchr(current, '\n');
	while (next)
	{	len=next-current;
//		cout<<"len="<<len<<endl;
		if (len>611)
			cerr<<"string is too lang!"<<endl;
		else
		{	strncpy(strtopar, current, len);
			strtopar[len]=0;
//			cout<<"strtopar:"<<strtopar<<" ENDE"<<endl;
			tstr=XmStringCreateSimple(strtopar);
			XmListAddItem(list, tstr, 0);
			XmStringFree(tstr);	//OK
			pos++;
		}
		while (next[0]=='\n')
				next++;
		current=next;
		next=strchr(current, '\n');
	}
	delete sss;
	XtVaSetValues(list, XmNtopItemPosition, pos, NULL);
	*/
}

extern Liste <char *> to_destroy;

Widget each_obj_text;

void show_this_object(Widget w, XtPointer p, 
		XmTextVerifyCallbackStruct *cbs)
{	if (cbs->reason!=XmCR_MOVING_INSERT_CURSOR)
		return;

	Widget out_shell;
	if (each_obj_text==NULL)
	{	out_shell=XtCreatePopupShell("Objects",
	 		transientShellWidgetClass,
			w, (Arg*)NULL, 0);
		top_liste->haengeAn(out_shell);
		each_obj_text=XmCreateScrolledText(out_shell, "obj_t", 
			(Arg *)NULL, 0);
		XtVaSetValues(each_obj_text, 
			XmNeditable, False, 
			XmNeditMode, XmMULTI_LINE_EDIT, 
			XmNcolumns, 25,
			XmNrows, 10, NULL);
		XtManageChild(each_obj_text);
	}
	
	char *text=XmTextGetString(w);
	char *curr=text;
	int line_num=0;
	int i=0;
	while (i<cbs->newInsert)
	{	if (curr[0]=='\n')
			line_num++;
		curr++;
		i++;
	}

	int from, to;
	if (line_num > objList->laenge()-1)
		return;
	if (line_num==0)	//ERSTE ZEILE
	{	from=0;
		to=1;
	}
	else
	{	int line_curr=0;
		for (i=0; i<strlen(text); i++)
			if (text[i]=='\n')
			{	line_curr++;
				if (line_curr==line_num)
					break;
			}
		from=to=i+1;
	}
	while ( to<strlen(text) && text[to]!='\n')
		to++;
	XmTextSetHighlight(w, 
			0, strlen(text), 
			XmHIGHLIGHT_NORMAL);
	XmTextSetHighlight(w, 
			from, to, 
			XmHIGHLIGHT_SELECTED);
	XtFree(text);

	char textstr[32560];
	textstr[0]=0;
	char *t;
	XplDouble *xpld;
	int j, k, ro, co, x, y;
	Component *comp=(*objList)[line_num]->DefaultComponent();
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Objects", "CLICK",
			(*objList)[line_num]->Name());
	fclose(gfile);
#endif	

	XplChar *xxx;
	SubDisplay *sd;
	int r, c;
	
	switch	(comp->Type())
	{	case C_XPLDOUBLE:
			xpld=comp->Content().xpldouble;
			ro=xpld->dimension(0);
			co=xpld->dimension(1);
			if (ro>20 || co>10)
			{	sprintf(textstr, "%s\n%s%d%s%d%s\n",
				"Matrix is too large to view",
				"Only first ",  
				20, 
				" rows and ", 10, " columns are viewed");
				ro=ro>20 ? 20 : ro;
				co=co>10 ? 10 : co;
			}
			k=0;
			for (j=0; j<ro ; j++)
			{	for (k=0; k<co; k++)
				sprintf(textstr, "%s%g\t", textstr,
				 	(*xpld)(j,k));
				sprintf(textstr, "%s\n", textstr);
			}
			break;
		case C_DISPLAY:
			r=comp->Content().display->GetRows();
			c=comp->Content().display->GetColumns();
			for (j=1; j<c+1; j++)
			for (k=1; k<r+1; k++)
			{	sd=comp->Content().display->GetElement(k, j);
				switch(sd->WhatIs())
				{case TEXT:
					sprintf(textstr, "%s\tTEXT",
					 	textstr);
				 	break;
				 case UPLOT:
					sprintf(textstr, "%s\tPLOT",
					 	textstr);
					 break;
				 default:
					sprintf(textstr, "%s\tDEFAULT",
					 	textstr);
					 break;
				}
				if (j==c)
					sprintf(textstr, "%s\n",
					 	textstr);
			}
			break;
			
		case C_XPLCHAR:
#ifdef _XPLCDEF_
			xxx=comp->Content().xplchar;
  			t = (*xxx)(0).tostr();	//OK!
#else
  			t = comp->Content().text;
#endif
			sprintf(textstr, "%s", t);
#ifdef _XPLCDEF_
			delete t;
#endif
			break;
		default:
			sprintf(textstr, "is an unknown type");
			break;
	}
	XmTextSetString(each_obj_text, textstr);

	Dimension xx, yy, width;
	XtVaGetValues(XtParent(XtParent(w)), XmNx, &xx, XmNy, &yy, 
			XmNwidth, &width, NULL);

	//Position posx, posy;
	//XmTextPosition pos;
	//pos=XmTextGetInsertionPosition(w);
	//XmTextPosToXY(w, pos, &posx, &posy);
//	cout<<"pos, posx, posy="<<pos<<", "<<posx<<","<<posy<<endl;

	XtVaSetValues(XtParent(XtParent(each_obj_text)),
		XmNx, xx+width, XmNy, yy, NULL);	
	XtPopup( XtParent(XtParent(each_obj_text)), XtGrabNone);
	
}
void jump_to_this_object(Widget w, XtPointer p, 
	XmTextVerifyCallbackStruct *cbs)
{	if (cbs->reason!=XmCR_MODIFYING_TEXT_VALUE)
		return;
	static Boolean neugeboren=True;
	if (neugeboren)
	{	neugeboren=False;
		return;
	}
	if (cbs->text->length!=1)
		return;	// update the list?
	

	cbs->doit=False;
	char *text=cbs->text->ptr;
	int lae=objList->laenge();
	int i=0;
	while (i<lae && (*objList)[i]->Name()[0]!=text[0])
		i++;

	if (i==lae)
	{	globalError.Set (ERR_INTERN, "not found");
		globalError.ShowError();
		return;
	}
	int line_count=i;
	int from, to;
	char *textstr=XmTextGetString(w);
	if (line_count==0)	//ERSTE ZEILE
	{	from=0;
		to=1;
	}
	else
	{	int line_curr=0;
		for (i=0; i<strlen(textstr); i++)
			if (textstr[i]=='\n')
			{	line_curr++;
				if (line_curr==line_count)
					break;
			}
		from=to=i+1;
	}
	while ( to<strlen(textstr) && textstr[to]!='\n')
		to++;
	XmTextSetHighlight(w, 
			0, strlen(textstr), 
			XmHIGHLIGHT_NORMAL);
	XmTextSetHighlight(w, 
			from, to, 
			XmHIGHLIGHT_SELECTED);
	XmTextSetInsertionPosition(w, from);
	XmTextShowPosition(w, from);
	XtFree(textstr);
}

#define OBJECT_HEIGHT 210
#define OBJECT_WIDTH 350

/*
void show_objects(Widget w, XtPointer p1, XtPointer p2)
{	static Widget all_obj_text=NULL;
	Widget out_shell;
	static Boolean on=False;
	
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Command", "CLICK",
			"Objects");
	fclose(gfile);
#endif
	if (on==True)
	{	XtPopdown(XtParent( XtParent(all_obj_text)));
		if (each_obj_text!=NULL)
		XtPopdown(XtParent( XtParent(each_obj_text)));
		on=False;
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Objects", "CLOSED", "");
	fclose(gfile);
#endif			
	return;
	}
	if (all_obj_text==NULL)
	{	out_shell=XtCreatePopupShell("Objects",
	 		transientShellWidgetClass,
			bs_glob_variable.main_shell, (Arg*)NULL, 0);
		top_liste->haengeAn(out_shell);
		all_obj_text=XmCreateScrolledText(out_shell, "obj_t", 
			(Arg *)NULL, 0);
		XtVaSetValues(all_obj_text, 
			XmNeditable, False, 
			XmNverifyBell, False,
			XmNeditMode, XmMULTI_LINE_EDIT, NULL);
		XtAddCallback(all_obj_text,
			XmNmotionVerifyCallback, show_this_object, NULL);
		XtAddCallback(all_obj_text,
			XmNmodifyVerifyCallback, jump_to_this_object, NULL);
		XtManageChild(all_obj_text);
		Dimension x, y;
		XtVaGetValues(w, XmNx, &x, XmNy, &y, NULL);
		XtVaSetValues(XtParent(XtParent(all_obj_text)),
			XmNx, x, XmNy, y+50, XmNheight, OBJECT_HEIGHT, 
			XmNwidth, OBJECT_WIDTH, NULL);	
		each_obj_text=NULL;
	}
			
	Widget obj_but;
	const char *text;
	char text1[1024], text_all[32000], *t;
	int i, child_count, lae;
	text_all[0]=0;
	Component *comp;
	XplChar *xxx;
	
	
	lae=objList->laenge();
	int columns=0;
	for (i=0; i<lae; i++)
	{	text=(*objList)[i]->Name();
		comp=(*objList)[i]->DefaultComponent();
#ifdef _BLABLA_
		cout<<"Object "<<text<<" has MotherId "<<
				(*objList)[i]->Id()<<endl;
#endif
		switch((*objList)[i]->DefaultType())
		{	case C_XPLDOUBLE:
			int j;
			int di[MAX_XARRAY];
			//cout<<text;
			for (j=0; j<MAX_XARRAY; j++)
			di[j]=comp->Content().xpldouble->
			 			dimension(j);
			sprintf(text1, "%s has dimension (", text);
			for (j=0; j<MAX_XARRAY-1; j++)
			 	sprintf(text1, "%s%d, ", text1, di[j]);
			sprintf(text1, "%s, %d)", text1, di[MAX_XARRAY-1]);
			//cout<<"text1="<<text1<<endl;
			break;
			 
			case C_DISPLAY :
			sprintf(text1, "%s is a display (%d, %d)", text,
					comp->Content().display->GetRows(),
					comp->Content().display->GetColumns()); 
	 		break;
	 		
			case C_XPLCHAR:

#ifdef _XPLCDEF_
			xxx=comp->Content().xplchar;
  				t = (*xxx)(0).tostr();	//OK!
#else
  			t = comp->Content().text;
#endif
			sprintf(text1, "%s is a XplChar with %d chars", text,
					strlen(t)); 
#ifdef _XPLCDEF_
			delete t;
#endif
	 		break;


	 		default:
	 		sprintf(text1, "%s has an unknown type", text);
	 		break;
		}
		if (strlen(text1)>columns)
			columns=strlen(text1);
		strcat(text_all, text1);
		strcat(text_all, "\n");
		}

	text_all[strlen(text_all)-1]=0;	// last \n ...
#ifdef _BLABLA_
	cout<<"text_all="<<endl<<text_all<<endl;
#endif
	XmTextSetString(all_obj_text, text_all);
	XtVaSetValues(all_obj_text, XmNrows, lae, 
			XmNcolumns, columns, NULL);
	XtPopup( XtParent(XtParent(all_obj_text)), XtGrabNone);
	on=True;
	
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Objects", "OPENED", "");
	fclose(gfile);
#endif	
}
*/
#endif

#ifdef _GRAPHICS_
void error_ok(Widget w, XtPointer p, XtPointer p2)
{	XmString xms=XmStringCreateLtoR("       ", XmSTRING_DEFAULT_CHARSET);
	XtVaSetValues(error_text, XmNmessageString, xms, NULL);
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "ErrorW", "CLICK",
			"OK");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "ErrorW", "CLOSED",
			"");
	fclose(gfile);
#endif	
	XmStringFree(xms);	//OK
}
void warning_ok(Widget w, XtPointer p, XtPointer p2)
{	XmString xms=XmStringCreateLtoR("       ", XmSTRING_DEFAULT_CHARSET);
	XtVaSetValues(warning_text, XmNmessageString, xms, NULL);
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "WarningW", "CLICK",
			"OK");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "WarningW", "CLOSED",
			"");
	fclose(gfile);
#endif	
	XmStringFree(xms);	//OK
}
#endif

int matrix_count=0;

int InitCommandFenster(char *argv0)
{	
#ifdef _GRAPHICS_
	char com_line[256];
	Widget out_shell;
	Widget kiste;
	Widget menu, button;
	Widget com_text, com_child1, com_child2;
	Widget axis_part;
	Widget main_shell=bs_glob_variable.main_shell;
	XmString progstr, datastr, objstr, infostr,  
	savestr, quitstr, helpstr, macrostr, funstr;
			
	matrix_count=0;
	
	XtAddEventHandler(main_shell, 
		StructureNotifyMask,
				False, icon_all, (XtPointer) NULL);

	Display *dis=XtDisplay(main_shell);

/*	XSelectInput(dis, RootWindow(dis,DefaultScreen(dis)),
		ButtonPressMask|KeyPressMask);

*/	out_shell=XtCreatePopupShell("XploRe_out", topLevelShellWidgetClass,
			main_shell, (Arg*)NULL, 0);
	top_liste=new Liste <Widget >;
	top_liste->haengeAn(out_shell);			
	funstr=XmStringCreateSimple("Functions");
	macrostr=XmStringCreateSimple("Macros");
	progstr=XmStringCreateSimple("Programs");
	datastr=XmStringCreateSimple("Data");
	objstr=XmStringCreateSimple("Objects");
	infostr=XmStringCreateSimple("Info");
	quitstr=XmStringCreateSimple("Quit");
	helpstr=XmStringCreateSimple("Help");

//	cout<<"OK:::"<<endl;
		
	out_text=XmCreateScrolledText(out_shell, "out_text", (Arg *)NULL, 0);
	XtAddCallback(out_text, XmNdestroyCallback, try_quitCB, 
					(XtPointer)NULL);
	XtManageChild(out_text);

	XtVaSetValues(main_shell, XmNtitle, "XploRe", NULL);
	kiste=	XtVaCreateManagedWidget("kiste", xmFormWidgetClass,
			main_shell, NULL);
//	cout<<"OK:::"<<endl;
//	Creating menubar
	menu=	XmVaCreateSimpleMenuBar(kiste, "menu_bar",
				XmVaCASCADEBUTTON, progstr, 'P',	//F5
				XmVaCASCADEBUTTON, datastr, 'D',	//F4
				XmVaCASCADEBUTTON, infostr, 'I',	//F3
				XmVaCASCADEBUTTON, objstr, 'O',		//F2

				XmVaCASCADEBUTTON, funstr, 'F',	//F1
				XmVaCASCADEBUTTON, macrostr, 'M',	//F6
				XmVaCASCADEBUTTON, quitstr, 'Q',	//F9
				XmVaCASCADEBUTTON, helpstr, 'H',	//F10
				NULL);
	XtVaSetValues(menu, 	XmNtopAttachment,XmATTACH_FORM, 
				XmNleftAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_FORM,
				NULL);
//	 for button "Programs"???
	button=XtNameToWidget(menu, "button_0");
	XtAddCallback(button, XmNactivateCallback, show_prog_box, 
				(XtPointer) NULL);
	XtVaSetValues(button, NULL);

//	 for button "Data"???
	button=XtNameToWidget(menu, "button_1");
	XtAddCallback(button, XmNactivateCallback, show_data_box, 
				(XtPointer) NULL);
	XtVaSetValues(button, NULL);

//	Bind button "Info" with callback 
	button=XtNameToWidget(menu, "button_2");
	XtAddCallback(button, XmNactivateCallback, infoCB, 
				(XtPointer) NULL);
	XtVaSetValues(button, NULL);

//	Bind  button "Objects" with callback pop_objCB
	button=XtNameToWidget(menu, "button_3");
	XtAddCallback(button, XmNactivateCallback, show_objects, 
				(XtPointer) NULL);

	XtVaSetValues(button, NULL);
	
//	Bind button "Functions" with callback 
	button=XtNameToWidget(menu, "button_4");
	XtAddCallback(button, XmNactivateCallback, show_functions, 
				(XtPointer) NULL);
	XtVaSetValues(button, NULL);

				
//	Bind button "Macros" with callback 
	button=XtNameToWidget(menu, "button_5");
	XtAddCallback(button, XmNactivateCallback, show_macros, 
				(XtPointer) NULL);
	XtVaSetValues(button, NULL);
				

//	Bind button "Quit" with callback
	button=XtNameToWidget(menu, "button_6");
	XtAddCallback(button, XmNactivateCallback, ask_for_quitCB, NULL);
	XtVaSetValues(button, NULL);

		
//	Bind button "Help" with callback 
	button=XtNameToWidget(menu, "button_7");
	XtAddCallback(button, XmNactivateCallback, helpCB, 
				(XtPointer) NULL);
	XtVaSetValues(button, NULL);

//	cout<<"OK:::"<<endl;
//	Creating commandline
	com_text=XmCreateCommand(kiste, "com_text", (Arg*) NULL, 0);
	
	com_child1=XmCommandGetChild(com_text, XmDIALOG_HISTORY_LIST);
	com_child2=XmCommandGetChild(com_text, XmDIALOG_COMMAND_TEXT);
	
	XtVaSetValues(com_child1, 
			XmNselectionPolicy, XmSINGLE_SELECT, NULL);				
	XtVaSetValues(com_child2, 
			 NULL);	
	XtVaSetValues(XmCommandGetChild(com_text, XmDIALOG_PROMPT_LABEL), 
			 NULL);
	XtAddCallback(com_child1, 
			XmNextendedSelectionCallback, selected_to_parser,
			(XtPointer) com_child2); 
			
			
	XtVaSetValues(com_text, XmNleftAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, menu, 
				XmNbottomAttachment,XmATTACH_FORM, 
				NULL);
	com_wid=com_text;
	XtAddCallback(com_text, XmNcommandEnteredCallback, ParseCallback, NULL);
	XtManageChild(menu);
	XtManageChild(com_text);
	
	dialog=XmCreatePromptDialog(main_shell, "prodia",
				 (Arg*) NULL,0);
	
	error_text=XmCreateErrorDialog(main_shell, "error",
				 (Arg*) NULL,0);
	XtAddCallback(error_text, XmNokCallback, error_ok, NULL);

	XtUnmanageChild(XmMessageBoxGetChild(error_text, 	
				XmDIALOG_CANCEL_BUTTON));
	
	XtUnmanageChild(XmMessageBoxGetChild(error_text, 	
				XmDIALOG_HELP_BUTTON));
	

	warning_text=XmCreateErrorDialog(main_shell, "warning",
				 (Arg*) NULL,0);
	XtAddCallback(warning_text, XmNokCallback, warning_ok, NULL);

	XtUnmanageChild(XmMessageBoxGetChild(warning_text, 	
				XmDIALOG_CANCEL_BUTTON));
	
	XtUnmanageChild(XmMessageBoxGetChild(warning_text, 	
				XmDIALOG_HELP_BUTTON));
	


	axis_part=init_axisborders_menu();
//	cout<<"OK:::"<<endl;
	XtPopup(out_shell, XtGrabNone);
	XtRealizeWidget(main_shell);
//#ifdef _COLOR_
	XSetWindowColormap(XtDisplay(main_shell), 	//OK
			XtWindow(kiste), cmap);
	XSetWindowColormap(XtDisplay(main_shell), 	//OK
			XtWindow(main_shell), cmap);
	XSetWindowColormap(XtDisplay(main_shell), 	//OK
			XtWindow(com_text), cmap);

#ifdef _BLABLA_
	int ret;
	Colormap * ccmm=XListInstalledColormaps(dis, XtWindow(kiste) ,
				&ret);
	cout<<" By CommandWindow "<<ret<<" colormaps are installed"<<endl;
	XFree(ccmm);	
#endif
//#endif
	startup(argv0);
	return(0);

#else
	char com[256];
	//cout<<"XploRe ohne Grafik!"<<endl;
	fgets(com, 254, stdin);
	while (! (com[0]=='q') )
	{	write_to_log(com);
		parse(com);
		fgets(com, 255, stdin);
	}	
#endif
}

	}

