/* $Header: /home/xplore/cvs/xpl4gr/directory.C,v 1.3 2002/08/16 12:31:40 sigbert Exp $ */
                                         
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#ifdef _XOPEN_SOURCE
#include <unistd.h>
#endif

#include "machine.h"
#include "directory.h"
#include "property.h"

#ifndef HAS_STRCMPI
#define strcmpi strcasecmp
#endif

X4Directory x4dir[40];
X4MacroList x4ml;

char tmppath[256], tmpdir[256];

extern void logt (const char *txt);

void X4Filename::setname (const char *name1, const char *name2)
{ int i, j;
  if (name2==NULL)
    sprintf (workname, "%s", name1);
  else
    sprintf (workname, "%s/%s", name1, name2);

  for (j=i=0; i<=strlen(workname); i++, j++)
  { if (workname[i]=='\\')
    { filename[j]='/';
    }
    else if (workname[i]=='\t')
    { filename[j]='/';
      j++;
      filename[j]='t';
    }
    else if (workname[i]=='\r')
    { filename[j]='/';
      j++;
      filename[j]='r';
    }
    else if (workname[i]=='\n')
    { filename[j]='/';
      j++;
      filename[j]='n';
    }
    else
    { filename[j]=workname[i];
    }
  }

  strcpy (workname, filename);
  for (j=i=1; i<=strlen(workname); i++, j++)
  { filename[j] = workname[i];
    if ((workname[i] == '/') && (filename[j-1]=='/')) j--;
  }
}

void X4Filename::setext (const char *ext)
{ strcat (filename, ext); }


int X4Filename::isabspath()
{
#if (defined(X4server) || defined (X4singleserver))
//  printf ("File access refused to %s\n", path);
  return 0;
#else
  return ((strchr(filename, ':')!=NULL) || (filename[0]=='/'));
#endif
}

// PC 20010510
int X4Filename::isrelpath()
{
#if (defined(X4server) || defined (X4singleserver))
//  printf ("File access refused to %s\n", path);
  return 0;
#else
  return (strchr(filename, '/')!=NULL);
#endif
}

char *X4Filename::getname()
{ int i;
  strcpy (workname, filename);
  for (i=0; i<=strlen(workname); i++)
    if (workname[i]=='/') workname[i] = SEPCHAR[0];
  return (workname);
}

// PC 20010510
char *X4Filename::getonlyfilename(bool withoutext)
{ int i, li = -1;
  strcpy (workname, filename);
  for (i=0; i<=strlen(workname); i++)
    if (workname[i]=='/')
    	li = i;

  if (li > -1)
  {
  	 if (li + 1 >= strlen(workname))
    	*workname = '\0';
    else
      strcpy(workname, filename + li + 1);
  }

  if (withoutext && (strlen(workname) > 0))
  {
  		char *ext = strrchr(workname, '.');
      if (ext)
      	*ext = '\0';
  }

  return (workname);
}

char *X4Filename::getpath()
{ int i, li = -1;
  strcpy (workname, filename);
  for (i=0; i<=strlen(workname); i++)
  { if (workname[i]=='/')
    { workname[i] = SEPCHAR[0];
      li = i;
    }
  }
  if (li>-1)
  { workname[li+1] = 0; }
  else
  { sprintf (workname, ".%c", SEPCHAR[0]); }
  return (workname);
}


char *getx4cwd (char *subdir = NULL)
{
  getcwd (tmppath, 255);
  if (subdir)
  { strcat (tmppath, SEPCHAR);
    strcat (tmppath, subdir);
  }
  return (tmppath);
}

char *getx4out (char *subdir = NULL)
{ char *tmp;
#ifdef __BORLANDC__
  if (getenv ("HOMEDRIVE") && getenv ("HOMEPATH"))
  { if (subdir)
      sprintf (tmppath, "%s%s%s%s", getenv ("HOMEDRIVE"), getenv ("HOMEPATH"), SEPCHAR, subdir);
    else
      sprintf (tmppath, "%s%s", getenv ("HOMEDRIVE"), getenv ("HOMEPATH"));
  }
  else
#endif
  { getx4cwd ();
    if (subdir)
    { strcat (tmppath, SEPCHAR);
      strcat (tmppath, subdir);
    }
  }
  return (tmppath);
}

X4Directory::X4Directory ()
{ len = 0;
  dirs = NULL;
}

int X4Directory::getenv (char *envvar, char *subdir)
{ int i, k, n, lz = -1;
  char *contents = property.getProperty(envvar);
// printf ("%s %p\n", envvar, contents);
  if ((contents!=NULL) && strlen(contents))
  { // delete old stuff
    for (i=0; i<len; i++)
      delete[] dirs[i];
    if (dirs) delete[] dirs;

    n = strlen(contents);
    for (len=i=0; i<n; i++)
    { if (contents[i]==':')
      { if ((i-lz==5) && (strncmp(&contents[lz+1], "http:", 5)==0)) {}
        else if ((i-lz==5) && (strncmp(&contents[lz+1], "file:", 5)==0)) {}
        else if ((i-lz==4) && (strncmp(&contents[lz+1], "ftp:", 4)==0)) {}
        else if ((i-lz==7) && (strncmp(&contents[lz+1], "server:", 7)==0)) {}
        else if (i-lz==2) {}
        else
        { contents[i] = 0;
          lz = i;
          len++;
        }
      }
      else if (contents[i]==';')
      { contents[i] = 0;
        lz = i;
        len++;
      }
    }
    len++;
    // printf ("%i %s\n", len, contents);
    dirs = new charp[len];


    strcpy (tmppath, contents);
    if (subdir)
    { strcat (tmppath, SEPCHAR);
      strcat (tmppath, subdir);
    }

    dirs[0] = strdup(tmppath);
    for (k=i=1; i<n; i++)
    { if (contents[i]==0)
      { strcpy (tmppath, &contents[i+1]);
        if (subdir)
        { strcat (tmppath, SEPCHAR);
          strcat (tmppath, subdir);
        }
        dirs[k] = strdup(tmppath);
        k++;
      }
    }
  }
  else
  { len = 0;
    dirs = NULL;
  }

  return (len);
}

int X4Directory::getpath (char *contents)
{ int i, k, n, lz = -1;
  if (contents && strlen(contents))
  { n = strlen(contents);
    for (len=i=0; i<n; i++)
    { if (contents[i]==':')
      { if ((i-lz==5) && (strncmp(&contents[lz+1], "http:", 5)==0)) {}
        else if ((i-lz==5) && (strncmp(&contents[lz+1], "file:", 5)==0)) {}
        else if ((i-lz==4) && (strncmp(&contents[lz+1], "ftp:", 4)==0)) {}
        else if ((i-lz==7) && (strncmp(&contents[lz+1], "server:", 7)==0)) {}
        else if (i-lz==2) {}
        else
        { contents[i] = 0;
          lz = i;
          len++;
        }
      }
      else if (contents[i]==';')
      { contents[i] = 0;
        lz = i;
        len++;
      }
    }
    len++;
    dirs = new charp[len];
    dirs[0] = strdup(contents);
    for (k=i=1; i<n; i++)
    { if (contents[i]==0)
      { dirs[k] = strdup(&contents[i+1]);
        k++;
      }
    }
//    printf ("getenv: %i\n", len);
  }
  else
  { len = 0;
    dirs = NULL;
//    printf ("getenv: %i\n", len);
  }
  return (len);
}

char* X4Directory::getpath ()
{ char *pathes = new char[1024];
  int i;
  pathes[0]=0;
  for (i=0; i<len; i++)
  { if (i)
    { strcat (pathes, ";");
      strcat (pathes, dirs[i]);
    }
    else
      strcpy (pathes, dirs[i]);
  }
  return (pathes);
}

X4Directory::~X4Directory ()
{ int i;
  for (i=0; i<len; i++)
    if (dirs[i]) delete[] (dirs[i]);
  if (dirs) delete[] dirs;
}

void X4Directory::dump (char *var)
{ int i;
  printf ("%s:\n", var);
  for (i=0; i<len; i++)
    printf ("  Dir %2i: %s\n", i, dirs[i]);
}

void replace (X4Directory *x4sdir)
{ charp *newdir, *tmp;
  int i, j, k, newlen = x4sdir->len, no;
  
  if (newlen)
  { newdir = new charp[newlen];
    for (j=k=0; k<x4sdir->len; k++)
    { newdir[j] = x4sdir->dirs[k];
      if ((newdir[j][0]=='$') || (newdir[j][0]=='%'))
      { no = -1;
        if (strcmpi(&((newdir[j])[1]), "xpl4nethome")==0) no = XPL4NETHOME;     
        if (strcmpi(&((newdir[j])[1]), "xpl4netlib")==0)  no = XPL4NETLIB;    
        if (strcmpi(&((newdir[j])[1]), "xpl4netdata")==0) no = XPL4NETDATA;   
        if (strcmpi(&((newdir[j])[1]), "xpl4nethelp")==0) no = XPL4NETHELP;   
        if (strcmpi(&((newdir[j])[1]), "xpl4netdll")==0)  no = XPL4NETDLL;    
        if (strcmpi(&((newdir[j])[1]), "xpl4netprog")==0) no = XPL4NETPROG;   
        if (strcmpi(&((newdir[j])[1]), "xpl4nettemp")==0) no = XPL4NETTEMP;   
        if (strcmpi(&((newdir[j])[1]), "xpl4syshome")==0) no = XPL4SYSHOME;   
        if (strcmpi(&((newdir[j])[1]), "xpl4syslib")==0)  no = XPL4SYSLIB;    
        if (strcmpi(&((newdir[j])[1]), "xpl4sysdata")==0) no = XPL4SYSDATA;   
        if (strcmpi(&((newdir[j])[1]), "xpl4syshelp")==0) no = XPL4SYSHELP;   
        if (strcmpi(&((newdir[j])[1]), "xpl4sysdll")==0)  no = XPL4SYSDLL;    
        if (strcmpi(&((newdir[j])[1]), "xpl4sysprog")==0) no = XPL4SYSPROG;   
        if (strcmpi(&((newdir[j])[1]), "xpl4systemp")==0) no = XPL4SYSTEMP;   
        if (strcmpi(&((newdir[j])[1]), "xpl4home")==0)    no = XPL4HOME;      
        if (strcmpi(&((newdir[j])[1]), "xpl4lib")==0)     no = XPL4LIB;       
        if (strcmpi(&((newdir[j])[1]), "xpl4data")==0)    no = XPL4DATA;      
        if (strcmpi(&((newdir[j])[1]), "xpl4help")==0)    no = XPL4HELP;      
        if (strcmpi(&((newdir[j])[1]), "xpl4dll")==0)     no = XPL4DLL;       
        if (strcmpi(&((newdir[j])[1]), "xpl4prog")==0)    no = XPL4PROG;      
        if (strcmpi(&((newdir[j])[1]), "xpl4temp")==0)    no = XPL4TEMP;      
        if (strcmpi(&((newdir[j])[1]), "xpl4outhome")==0) no = XPL4OUTHOME;
        if (strcmpi(&((newdir[j])[1]), "xpl4outlib")==0)  no = XPL4OUTLIB;    
        if (strcmpi(&((newdir[j])[1]), "xpl4outdata")==0) no = XPL4OUTDATA;   
        if (strcmpi(&((newdir[j])[1]), "xpl4outhelp")==0) no = XPL4OUTHELP;   
        if (strcmpi(&((newdir[j])[1]), "xpl4outdll")==0)  no = XPL4OUTDLL;    
        if (strcmpi(&((newdir[j])[1]), "xpl4outprog")==0) no = XPL4OUTPROG;   
        if (strcmpi(&((newdir[j])[1]), "xpl4outtemp")==0) no = XPL4OUTTEMP;   
        if (no>-1)
        { if (x4sdir->dirs!=x4dir[no].dirs)
          { // ignore recursive call
            newlen = x4sdir->len+x4dir[no].len-1;
            tmp = new charp[newlen];
            for (i=0; i<j; i++)
              tmp[i] = newdir[i];
            for (i=0; i<x4dir[no].len; i++, j++)
              tmp[j] = strdup(x4dir[no].dirs[i]);
            delete[] newdir;
            newdir = tmp;
          }
          else
          { newlen--; }  
        }
      }
      else
      { j++; }  
/*      for (int l=0; l<newlen; l++)
        printf ("%i %s\n", l, newdir[l]);
      printf ("\n");
      getch();
 */   }
    x4sdir->len = newlen;
    delete[] x4sdir->dirs;
    x4sdir->dirs = newdir;
  }
}

char *openfile (int type, const char *name, const char *mode)
{ int i, j, t;
  FILE *f;
  X4Filename fn;
  //  logt(name);
  fn.setname(name);

#if (defined(X4server) || defined (X4singleserver))
  if (strstr(name, "..") || strchr(name, '~')) 
  { // printf ("File access refused to %s\n", name);
    return (NULL);
  }
#endif

  if (fn.isabspath())   // SK 21.07.98 check for absolute pathes
                                         // PC 20010510 check for relative pathes
  { strcpy (tmppath, fn.getname());
  // logt(tmppath);
    f = fopen (tmppath, mode);
    if (f==NULL) return NULL;
    fclose(f);
    return (tmppath);
  }

  if (fn.isrelpath())
  { strcpy (tmppath, fn.getname());
  // logt(tmppath);
    f = fopen (tmppath, mode);
    if (f!=NULL)
    { fclose(f);
      return (tmppath);
    }
  }

  if (strchr (mode, 'r')==NULL)
  { 
    t = 30+type;
    for (j=0; j<x4dir[t].len; j++)
    { fn.setname (x4dir[t].dirs[j], name);
      strcpy (tmppath, fn.getname());
      // logt(tmppath);
      f = fopen (tmppath, mode);
      if (f)
      { fclose(f);
        return (tmppath);
      }
    }
  }
  else
  { for (i=30; i>-1; i-=10)
    { t = i+type;
      for (j=0; j<x4dir[t].len; j++)
      { fn.setname (x4dir[t].dirs[j], name);
        strcpy (tmppath, fn.getname());
        // logt (tmppath);
        f = fopen (tmppath, mode);
        if (f)
	  { // logt ("Success");
          fclose(f);
          return (tmppath);
        }
        // logt ("Failed");
        if (type==DATA)
        { fn.setname (x4dir[t].dirs[j], name);
          fn.setext (".dat");
          strcpy (tmppath, fn.getname());
          f = fopen (tmppath, mode);
          if (f)
          { fclose(f);
            return (tmppath);
          }
        }
        if (type==LIB)
        { fn.setname (x4dir[t].dirs[j], name);
          fn.setext (".lib");
          strcpy (tmppath, fn.getname());
          f = fopen (tmppath, mode);
          if (f)
          { fclose(f);
            return (tmppath);
          }
        }
      }
    }
    if (type==HELP)  // SK 29.07.98 
    { sprintf (tmppath, "http://www.xplore-stat.de/help/%s", name);
      return (tmppath);
    }
  }
  return (NULL);
}


char *opendir (int type, const char *name, const char *mode)
{ int i, j, t, plen;
  FILE *f;

// PC 20010510 added check for absolute and relative pathes
  X4Filename fn;
  fn.setname(name);

  if (fn.isabspath() || fn.isrelpath())
  { strcpy (tmppath, fn.getname());
    f = fopen (tmppath, mode);
    if (f==NULL) return NULL;
    fclose(f);

    strcpy (tmppath, fn.getpath());
    plen = strlen(tmppath);
    // remove last sepchar - other pathes are also without it
    if (plen > 0)
    {
    	if (plen > 1)
      {
    		if ((tmppath[plen - 1] == SEPCHAR[0]) && (tmppath[plen - 2] != SEPCHAR[0]))
         	tmppath[plen - 1] = '\0';
      }

    	return (tmppath);
    }
  }
// end of check for abs and rel pathes

  if (strchr (mode, 'r')==NULL)
  { t = 30+type;
    for (j=0; j<x4dir[t].len; j++)
    { strcpy (tmppath, x4dir[t].dirs[j]);
      strcpy (tmpdir, x4dir[t].dirs[j]);
      strcat (tmppath, SEPCHAR);
      strcat (tmppath, name);
      f = fopen (tmppath, mode);
      if (f)
      { fclose(f);
        return (tmpdir);
      }
    }
  }
  else
  { for (i=30; i>-1; i-=10)
    { t = i+type;
      for (j=0; j<x4dir[t].len; j++)
      { strcpy (tmppath, x4dir[t].dirs[j]);
        strcpy (tmpdir, x4dir[t].dirs[j]);
        strcat (tmppath, SEPCHAR);
        strcat (tmppath, name);
        f = fopen (tmppath, mode);
        if (f)
        { fclose(f);
          return (tmpdir);
        }
        if (type==DATA)
        { strcpy (tmppath, x4dir[t].dirs[j]);
          strcpy (tmpdir, x4dir[t].dirs[j]);
          strcat (tmppath, SEPCHAR);
          strcat (tmppath, name);
          strcat (tmppath, ".dat");
          f = fopen (tmppath, mode);
          if (f)
          { fclose(f);
            return (tmppath);
          }
        }
        if (type==LIB)
        { strcpy (tmppath, x4dir[t].dirs[j]);
          strcpy (tmpdir, x4dir[t].dirs[j]);
          strcat (tmppath, SEPCHAR);
          strcat (tmppath, name);
          strcat (tmppath, ".lib");
          f = fopen (tmppath, mode);
          if (f)
          { fclose(f);
            return (tmpdir);
          }
        }
      }
    }
    if (type==HELP)  // SK 29.07.98 
    { sprintf (tmpdir, "http://www.xplore-stat.de/help");
      return (tmpdir);
    }
  }
  return (NULL);
}

void dump (char *buf, int offset, int out=0)
{ int i, j, l;
  switch (offset)
  { case HOME : (out ? strcat (buf, "XPL4OUTHOME=") : strcat (buf, "XPL4HOME=")); break;
    case LIB  : (out ? strcat (buf, "XPL4OUTLIB=")  : strcat (buf, "XPL4LIB=")); break;
    case DATA : (out ? strcat (buf, "XPL4OUTDATA=") : strcat (buf, "XPL4DATA=")); break;
    case HELP : (out ? strcat (buf, "XPL4OUTHELP=") : strcat (buf, "XPL4HELP=")); break;
    case DLL  : (out ? strcat (buf, "XPL4OUTDLL=")  : strcat (buf, "XPL4DLL=")); break;
    case PROG : (out ? strcat (buf, "XPL4OUTPROG=") : strcat (buf, "XPL4PROG=")); break;
    case TEMP : (out ? strcat (buf, "XPL4OUTTEMP=") : strcat (buf, "XPL4TEMP=")); break;
  }
  l = 1;
  for (i=30; i>-1+out*30; i-=10)
  { for (j=0; j<x4dir[i+offset].len; j++)
    { if (*(x4dir[i+offset].dirs[j])!='\0')
      { if (l)
          l=0;
        else
          strcat(buf, ";");
        strcat (buf, x4dir[i+offset].dirs[j]);
      }
    }
  }
}

void directoryupdate (const char *s)
{ 
  if (strcmpi(s, "XPL4LIB")==0)     { x4dir[XPL4LIB].getenv("XPL4LIB"); }
  if (strcmpi(s, "XPL4DATA")==0)    { x4dir[XPL4DATA].getenv("XPL4DATA");}
  if (strcmpi(s, "XPL4HELP")==0)    { x4dir[XPL4HELP].getenv("XPL4HELP"); }
  if (strcmpi(s, "XPL4DLL")==0)     { x4dir[XPL4DLL].getenv("XPL4DLL"); }
  if (strcmpi(s, "XPL4PROG")==0)    { x4dir[XPL4PROG].getenv("XPL4PROG"); }
  if (strcmpi(s, "XPL4TEMP")==0)    { x4dir[XPL4TEMP].getenv("XPL4TEMP"); }
  if (strcmpi(s, "XPL4OUTLIB")==0)  { x4dir[XPL4OUTLIB].getenv("XPL4OUTLIB"); }
  if (strcmpi(s, "XPL4OUTDATA")==0) { x4dir[XPL4OUTDATA].getenv("XPL4OUTDATA"); }
  if (strcmpi(s, "XPL4OUTHELP")==0) { x4dir[XPL4OUTHELP].getenv("XPL4OUTHELP"); }
  if (strcmpi(s, "XPL4OUTDLL")==0)  { x4dir[XPL4OUTDLL].getenv("XPL4OUTDLL"); }
  if (strcmpi(s, "XPL4OUTPROG")==0) { x4dir[XPL4OUTPROG].getenv("XPL4OUTPROG"); }
  if (strcmpi(s, "XPL4OUTTEMP")==0) { x4dir[XPL4OUTTEMP].getenv("XPL4OUTTEMP"); }
}

long tmpnum;

char* xtmpnam(void)
{ char tmpname[512];
  long i;
  FILE *f;

  if (x4dir[XPL4OUTTEMP].len==0) return (NULL);

  for (i=tmpnum;i!=0;i++)
  { sprintf (tmpname, "%s%stmp%+09li", x4dir[XPL4OUTTEMP].dirs[0], SEPCHAR, i);
    f = fopen (tmpname, "r");
    // logt (tmpname);
    if (f==NULL)
    { f = fopen (tmpname, "w");
      if (f==NULL) return (NULL);
      fclose(f);
      tmpnum = i+1;  
      return (strdup(tmpname));
    }
    fclose(f);
  }

  logt ("xtmpnam: no temporary space found ...\r\n");
  // printf ("xtmpnam: no temporary space found ...\r\n");
  exit (1);
  return (NULL);
}

void writetest (char *name)
{ FILE *f;
  f = fopen (name, "w");
  fprintf (f, "hallo welt!");
  fclose(f);
}

void initdirectories ()
{
  int i;
 
  tmpnum = 1;

  // XPL4NETHOME
  if (x4dir[XPL4NETHOME].getenv("XPL4NETHOME")==0)
    x4dir[XPL4NETHOME].getpath ("http://www.xplore-stat.de");
  replace (&x4dir[XPL4NETHOME]);
  property.setProperty ("xpl4nethome", x4dir[XPL4NETHOME].getpath(), 0);

  // XPL4NETLIB
  if (x4dir[XPL4NETLIB].getenv("XPL4NETLIB")==0)
  { if (x4dir[XPL4NETLIB].getenv("XPL4NETHOME", "lib")==0)
      x4dir[XPL4NETLIB].getpath("http://www.xplore-stat.de/lib");
  }
  replace(&x4dir[XPL4NETLIB]);
  property.setProperty ("xpl4netlib", x4dir[XPL4NETLIB].getpath(), 0);  

  // XPL4NETDATA
  if (x4dir[XPL4NETDATA].getenv("XPL4NETDATA")==0)
  { if (x4dir[XPL4NETDATA].getenv("XPL4NETHOME", "data")==0)
      x4dir[XPL4NETDATA].getpath("http://www.xplore-stat.de/data");
  }
  replace(&x4dir[XPL4NETDATA]);
  property.setProperty ("xpl4netdata", x4dir[XPL4NETDATA].getpath(), 0);

  // XPL4NETHELP
  if (x4dir[XPL4NETHELP].getenv("XPL4NETHELP")==0)
  { if (x4dir[XPL4NETHELP].getenv("XPL4NETHOME", "help")==0)
      x4dir[XPL4NETHELP].getpath("http://www.xplore-stat.de/help");
  }
  replace(&x4dir[XPL4NETHELP]);
  property.setProperty ("xpl4nethelp", x4dir[XPL4NETHELP].getpath(), 0);

  // XPL4NETDLL
  if (x4dir[XPL4NETDLL].getenv("XPL4NETDLL")==0)
  { if (x4dir[XPL4NETDLL].getenv("XPL4NETHOME", "dll")==0)
      x4dir[XPL4NETDLL].getpath("http://www.xplore-stat.de/dll");
  }
  replace(&x4dir[XPL4NETDLL]);
  property.setProperty ("xpl4netdll", x4dir[XPL4NETDLL].getpath(), 0);

  // XPL4NETPROG
  // XPL4NETTEMP


  //dump(DATA);

  // XPL4SYSHOME
  x4dir[XPL4SYSHOME].getenv("XPL4SYSHOME");
  replace(&x4dir[XPL4SYSHOME]);
  property.setProperty ("xpl4syshome", x4dir[XPL4SYSHOME].getpath(), 0);

  // XPL4SYSLIB
  if (x4dir[XPL4SYSLIB].getenv("XPL4SYSLIB")==0)
    x4dir[XPL4SYSLIB].getenv("XPL4SYSHOME", "lib");
  replace(&x4dir[XPL4SYSLIB]);
  property.setProperty ("xpl4syslib", x4dir[XPL4SYSLIB].getpath(), 0);
 
  // XPL4SYSDATA
  if (x4dir[XPL4SYSDATA].getenv("XPL4SYSDATA")==0)
    x4dir[XPL4SYSDATA].getenv("XPL4SYSHOME", "data");
  replace(&x4dir[XPL4SYSDATA]);
  property.setProperty ("xpl4sysdata", x4dir[XPL4SYSDATA].getpath(), 0);

  // XPL4SYSHELP
  if (x4dir[XPL4SYSHELP].getenv("XPL4SYSHELP")==0)
    x4dir[XPL4SYSHELP].getenv("XPL4SYSHOME", "help");
  replace(&x4dir[XPL4SYSHELP]);
  property.setProperty ("xpl4syshelp", x4dir[XPL4SYSHELP].getpath(), 0);

  // XPL4SYSDLL
  if (x4dir[XPL4SYSDLL].getenv("XPL4SYSDLL")==0)
    x4dir[XPL4SYSDLL].getenv("XPL4SYSHOME", "dll");
  replace(&x4dir[XPL4SYSDLL]);
  property.setProperty ("xpl4sysdll", x4dir[XPL4SYSDLL].getpath(), 0);

  // XPL4SYSPROG
  // XPL4SYSTEMP

  //dump(DATA);

  // XPL4HOME
  if (x4dir[XPL4HOME].getenv("XPL4HOME")==0)
    x4dir[XPL4HOME].getpath (getx4cwd());
  replace(&x4dir[XPL4HOME]);
  property.setProperty ("xpl4home", x4dir[XPL4HOME].getpath(), 0);

  // XPL4LIB
  if (x4dir[XPL4LIB].getenv("XPL4LIB")==0)
  { if (x4dir[XPL4LIB].getenv("XPL4HOME", "lib")==0)
      x4dir[XPL4LIB].getpath (getx4cwd("lib"));
  }
  replace(&x4dir[XPL4LIB]);
  property.setProperty ("xpl4lib", x4dir[XPL4LIB].getpath(), 0);  

  // XPL4DATA
  if (x4dir[XPL4DATA].getenv("XPL4DATA")==0)
  { if (x4dir[XPL4DATA].getenv("XPL4HOME", "data")==0)
      x4dir[XPL4DATA].getpath (getx4cwd("data"));
  }
  replace(&x4dir[XPL4DATA]);
  property.setProperty ("xpl4data", x4dir[XPL4DATA].getpath(), 0);
  
  // XPL4HELP
  if (x4dir[XPL4HELP].getenv("XPL4HELP")==0)
  { if (x4dir[XPL4HELP].getenv("XPL4HOME", "help")==0)
      x4dir[XPL4HELP].getpath (getx4cwd("help"));
  }
  replace(&x4dir[XPL4HELP]);
  property.setProperty ("xpl4help", x4dir[XPL4HELP].getpath(), 0);

  // XPL4DLL
  if (x4dir[XPL4DLL].getenv("XPL4DLL")==0)
  { if (x4dir[XPL4DLL].getenv("XPL4HOME", "dll")==0)
      x4dir[XPL4DLL].getpath (getx4cwd("dll"));
  }
  replace(&x4dir[XPL4DLL]);
  property.setProperty ("xpl4dll", x4dir[XPL4DLL].getpath(), 0);  
  
  // XPL4PROG
  // XPL4TEMP

  //dump(DATA);

  // XPL4OUTHOME
  // XPL4OUTDATA
  if (x4dir[XPL4OUTDATA].getenv ("XPL4OUTDATA")==0)
    x4dir[XPL4OUTDATA].getpath(getx4out());
  replace(&x4dir[XPL4OUTDATA]);
  property.setProperty ("xpl4outdata", x4dir[XPL4OUTDATA].getpath(), 0);  

  // XPL4OUTHELP
  if (x4dir[XPL4OUTHELP].getenv("XPL4OUTHELP")==0)
    x4dir[XPL4OUTHELP].getpath(getx4out());
  replace(&x4dir[XPL4OUTHELP]);
  property.setProperty ("xpl4outhelp", x4dir[XPL4OUTHELP].getpath(), 0);  
  
  // XPL4OUTDLL
  // XPL4OUTPROG
  if (x4dir[XPL4OUTPROG].getenv("XPL4OUTPROG")==0)
    x4dir[XPL4OUTPROG].getpath(getx4out());
  replace(&x4dir[XPL4OUTPROG]);
  property.setProperty ("xpl4outprog", x4dir[XPL4OUTPROG].getpath(), 0);  

  // XPL4OUTTEMP
  if (x4dir[XPL4OUTTEMP].getenv("XPL4OUTTEMP")==0)
  {
#ifdef HAS_TMP
    if (x4dir[XPL4OUTTEMP].getpath("/tmp")==0)
#else
    if (x4dir[XPL4OUTTEMP].getpath(::getenv("TEMP"))==0)
#endif
    x4dir[XPL4OUTTEMP].getpath(getx4out());
  }
  replace(&x4dir[XPL4OUTTEMP]);
  property.setProperty ("xpl4outtemp", x4dir[XPL4OUTTEMP].getpath(), 0);

// Test
  /*  printf ("openfile(DATA, \"test00000\", \"w\") = %s\n", openfile(DATA, "test00000", "w"));
  writetest (openfile(DATA, "test00000", "w"));
  printf ("openfile(DATA, \"test00000\", \"r\") = %s\n", openfile(DATA, "test00000", "r"));
#if defined(__BORLANDC__) || defined(__SC_)
  getch();
#endif
*/

  // SK 20.01.99
  //  char buffer[1024];
  //  infostring (buffer);
  //  printf ("directories:\n%s", buffer);
  // SK end
	
       	/* for Win32 Console Applications, _CONSOLE is defined */
#ifdef _CONSOLE  
   {
    /* Print a prompt prior to exiting so that you can view output */
    int c;
    printf ("Press Return To Exit: ");
    c = getc(stdin);
   }
#endif
}

extern char *expireString;

void infostring(char *str)
{
#ifdef _EXPIRE_
        sprintf (str, "License will expire on %s\n", expireString);
#else
        str[0] = 0;
#endif
        dump(str, DATA, 0); strcat(str, "\n");
        dump(str, LIB, 0); strcat(str, "\n");
        dump(str, DLL, 0); strcat(str, "\n");
        dump(str, HELP, 0); strcat(str, "\n");
        dump(str, PROG, 0); strcat(str, "\n");
        dump(str, TEMP, 0); strcat(str, "\n\n");
        dump(str, DATA, 1); strcat(str, "\n");
        dump(str, LIB, 1); strcat(str, "\n");
        dump(str, DLL, 1); strcat(str, "\n");
        dump(str, HELP, 1); strcat(str, "\n");
        dump(str, PROG, 1); strcat(str, "\n");
        dump(str, TEMP, 1); strcat(str, "\n\n");

#ifdef _BLABLA_
	cout<<str<<endl;
#endif

}


X4MacroList::X4MacroList()
{ int i;
  len = MAXX4ML;
  macroname = new charp[len];
  dirname   = new charp[len];
  for (i=0; i<len; i++)
  { macroname[i] = NULL;
    dirname[i]   = NULL; 
  }
}

X4MacroList::~X4MacroList()
{ int i;
  for (i=0; i<len; i++)
  { if (macroname[i]) delete[] macroname[i];
    if (dirname[i]) delete[] dirname[i];
  }
  delete[] macroname;
  delete[] dirname;
}

void X4MacroList::insert (char *name, char *dir)
{ int i, j;
  charp *tmp;
  // SK 25.07.2001
  for (i=0; i<len; i++)
    if (macroname[i] && (strcmp(macroname[i], name)==0)) return;
  for (i=0; i<len; i++)
  { if (macroname[i]==NULL)
    { macroname[i] = strdup(name);
      dirname[i]   = strdup(dir);
      return;
    }
  }
  len += MAXX4ML;
  tmp = new charp[len];
  memcpy (tmp, macroname, sizeof(charp)*(len-MAXX4ML));
  delete[] macroname;
  macroname = tmp;
  tmp = new charp[len];
  memcpy (tmp, dirname, sizeof(charp)*(len-MAXX4ML));
  delete[] dirname;
  dirname = tmp;
  macroname[i] = strdup(name);
  dirname[i]   = strdup(dir);
  for (j=i+1; j<len; j++)
  { macroname[j] = NULL;
    dirname[j] = NULL;
  }
  return;
}

char *X4MacroList::getdir (const char *name)
{ int i;
  char *ret;
  for (i=0; i<len; i++)
  { if (macroname[i])
    { if (strcmp(macroname[i], name)==0)
      { delete[] macroname[i];
        ret = dirname[i];
        macroname[i] = NULL;
        dirname[i] = NULL;
        return (ret);
      }
    }
  }
  return (NULL);
}

int X4MacroList::length ()
{ int i, ret = 0;
  for (i=0; i<len; i++)
  { if (macroname[i]) ret++; }
  return (ret);
}
