/* $Header: /home/xplore/cvs/xpl4gr/directory.h,v 1.3 2002/08/16 12:31:40 sigbert Exp $ */

#ifndef X4DIRECTORY
#define X4DIRECTORY

#define HOME            0
#define LIB             1
#define DATA            2
#define HELP            3
#define DLL             4
#define PROG            5
#define TEMP            6

#define XPL4NETHOME     0
#define XPL4NETLIB      1
#define XPL4NETDATA     2
#define XPL4NETHELP     3
#define XPL4NETDLL      4
#define XPL4NETPROG     5
#define XPL4NETTEMP     6
#define XPL4SYSHOME    10
#define XPL4SYSLIB     11
#define XPL4SYSDATA    12
#define XPL4SYSHELP    13
#define XPL4SYSDLL     14
#define XPL4SYSPROG    15
#define XPL4SYSTEMP    16
#define XPL4HOME       20
#define XPL4LIB        21
#define XPL4DATA       22
#define XPL4HELP       23
#define XPL4DLL        24
#define XPL4PROG       25
#define XPL4TEMP       26
#define XPL4OUTHOME    30
#define XPL4OUTLIB     31
#define XPL4OUTDATA    32
#define XPL4OUTHELP    33
#define XPL4OUTDLL     34
#define XPL4OUTPROG    35
#define XPL4OUTTEMP    36

typedef char* charp;

char *getx4cwd (char *subdir);
// char *gethome (char *subdir = NULL);
char *openfile (int type, const char *name, const char *mode);
char *opendir (int type, const char *name, const char *mode);

class X4Filename
{ char filename[1024], workname[1024];

  public:

  void setname(const char *name1, const char *name2 = NULL);
  void setext(const char *ext);
  int isabspath();
  int isrelpath();	// PC 20010510
  char *getname();
  char *getonlyfilename(bool withoutext = false);	// PC 20010510
  char *getpath();

};

class X4Directory
{ public:

  int len;
  charp *dirs;

  X4Directory ();
  int getenv(char *envvar, char *subdir = NULL);
  int getpath(char *contents);
  char *getpath();
  ~X4Directory ();

  void dump(char *var = NULL);
  

};

void replace (X4Directory *x4sdir);

extern X4Directory x4dir[40];

void dump (char *buf, int offset, int out);
void directoryupdate (const char *s);
void initdirectories ();
char* xtmpnam(void);
int isabspath (const char *s);
void infostring (char *str);

#define MAXX4ML 256

class X4MacroList
{ public:
  
  int len;
  charp *macroname;
  charp *dirname;

  X4MacroList(); 
  ~X4MacroList(); 
  void insert (char *name, char *dir);
  char *getdir (const char *name);
  int length();
};

extern X4MacroList x4ml;
#endif


