/* $Header: /home/xplore/cvs/xpl4gr/disp.C,v 1.4 2002/10/31 18:22:45 cizek Exp $ */

#include "main.h"
#include "display.h"
#include "plot.h"
#ifdef _UNIX_
#include "uplot.h"
#endif
#include "text.h"
#include "directory.h"

int xpldisplay_height=500;
int xpldisplay_width=500;
int xpldisplay_left=-1;
int xpldisplay_top=-1;

void XplDisplay::XUpdate()
{  int k=0;
	int i, j;
   int rows=vertical.cols();
	int cols=horizontal.cols();
	for (i=0; i<rows; i++)
	for (j=0; j<cols; j++)
	{	content[k]->Resize(
			GetElementWidth(i+1, j+1), GetElementHeight(i+1, j+1));
		content[k]->Replace(
			GetElementTopPosition(i+1, j+1),
			GetElementBottomPosition(i+1, j+1),
			GetElementLeftPosition(i+1, j+1),
			GetElementRightPosition(i+1, j+1));
		k++;
	}
}

XplDisplay::XplDisplay(const XplDisplay *old)
{	int i, j, k, all, hi;
#ifdef _BLABLA_
/*OK*/	cout<<"XplDisplay(const XplDisplay *old) ist aufgerufen\n";
#endif	

	type=DISPLAY;

	name=strdup(old->name);
	width=old->width;
	height=old->height;
	//cout<<"width und height soll : "<<width<<", "<<height<<endl;
	x=old->x;
	y=old->y;
	vertical=old->vertical;
	horizontal=old->horizontal;
	all=vertical.cols()* horizontal.cols();

	#ifndef __BORLANDC__
	content=new (SubDisplay *) [all];
	#else
	content=new (SDP*) [all];
	#endif
	k=0;
	SubDisplay *p;
	
	for (j=0; j<vertical.cols(); j++)
	for (i=0; i<horizontal.cols(); i++)
	{	p=old->GetElement(j+1, i+1);
		if (p==NULL)
		{		
			content[k]=NULL;
		}
		else
		switch(p->WhatIs())
		{	case PLOT: case UPLOT:
			content[k]=new Plot ((Plot *)p, this, j+1, i+1);
			//content[k]->refresh();
			break;
						
			case TEXT:
			content[k]=new VisText ((VisText *)p, this, j+1, i+1);
			break;
			
			default:
			content[k]=new VisText( (VisText *)p, this, j+1, i+1); 
			break;
		}

		k++;
	}

} 

XplDisplay::XplDisplay(XplDouble hori, XplDouble veri)
{	
	
#ifdef _BLABLA_
cout<<"XplDisplay::XplDisplay(XplDouble hori, XplDouble veri )"<<endl;
#endif

	type=DISPLAY;

int i, j, k, all, hi, d_rows, d_cols;
	double sum;
	if (hori.dimension(0)!=1 || veri.dimension(0)!=1)
	{	globalError.Set (ERR_INTERN, "XplError by XplDisplay::XplDisplay");
		globalError.ShowError();
		XplDouble hhh(1), vvv(1);
		hhh(0)=1;
		vvv(0)=1;
		hori=hhh;
		veri=vvv;
	}

	sum=0;
	d_cols=hori.dimension(1);
	d_rows=veri.dimension(1);
	for (i=0; i<d_cols; i++)
		sum=sum+hori(0, i);
	//cout<<"hori_sum="<<sum<<endl;
	
	XplMatrix h(1, d_cols);
	int sumto100=0;
	for (i=0; i<d_cols; i++)
	{	h(0, i)=(int)(hori(0, i)*100/sum+0.5);
		sumto100+=(int)(hori(0, i)*100/sum+0.5);
	}
	//cout<<"sumto100="<<sumto100<<endl;
	if (sumto100<100)
	for (i=0; i<100-sumto100; i++)
		h(0, i)=h(0,i)+1;
	if (sumto100>100)
	for (i=0; i<sumto100-100; i++)
		h(0, i)=h(0,i)-1;
	horizontal=h;

	sum=0;
	for (i=0; i<d_rows; i++)
		sum=sum+veri(0, i);
	//cout<<"veri_sum="<<sum<<endl;
	XplMatrix v(1, d_rows);
	sumto100=0;
	for (i=0; i<d_rows; i++)
	{	v(0, i)=(int)(veri(0, i)*100/sum+0.5);
		sumto100+=(int)(veri(0, i)*100/sum+0.5);
	}	
	for (i=0; i<100-sumto100; i++)
		v(0, i)=v(0,i)+1;
	if (sumto100>100)
	for (i=0; i<sumto100-100; i++)
		v(0, i)=v(0,i)-1;
	vertical=v;	
	
#ifdef _BLABLA_
	cout<<"Hori:"<<endl;
	horizontal.out();
	//cout<<"SUMSUM: "<<h(0,0)+h(0,1)+h(0,2);
	cout<<"Veri:"<<endl;
	vertical.out();
	//cout<<"SUMSUM: "<<v(0,0)+v(0,1)+v(0,2);
#endif
	name=strdup("display");

	for (i=1; i<d_cols; i++)
		if (!(h(0, 0)==h(0, i)))
			break;
	if (i==d_cols && d_cols!=1)			//gleich
	//	width=(xpldisplay_width/d_cols)*d_cols;
		width=(xpldisplay_width/100)*(int)h(0,0)*d_cols;
	else
		width=xpldisplay_width;

	for (i=1; i<d_rows; i++)
		if (!(v(0, 0)==v(0, i)))
			break;
#ifdef _BLABLA_
	cout<<"global: width="<<xpldisplay_width<<", height="<<
		xpldisplay_height<<endl;
#endif
	if (i==d_rows && d_cols!=1)			//gleich
		height=(xpldisplay_height/100)*(int)v(0,0)*d_rows;
	else
		height=xpldisplay_height;
#ifdef _BLABLA_
	cout<<"width und height: "<<width<<", "<<height<<endl;
#endif	
	x=y=100;
	all=veri.dimension(1)*hori.dimension(1);
#ifndef __BORLANDC__
	content=new (SubDisplay *) [all];
#else
	content=new SDP[all];
#endif
	for (i=0; i<all; i++)
		content[i]=NULL;
	
	k=0;
	SubDisplay *sd;
	for (j=0; j<veri.dimension(1); j++)
	for (i=0; i<hori.dimension(1); i++)
	{	sd=new Plot(this, j+1, i+1);
		content[k]=sd;
		k++;
	}
}

XplDisplay::~XplDisplay()	
{
#ifdef _BLABLA_
/*OK*/	cout<<"Destruktor fuer XplDisplay "<<name<<endl;
#endif
	int i, j, k;
	int rows, cols;
	rows=vertical.cols();
	cols=horizontal.cols();
		
	i=0;
	for (i=0; i<rows*cols; i++)
/*	switch(content[i]->WhatIs())
		{	case PLOT:	delete (Plot *)(content[i]);
				break;
			case TEXT:	delete (VisText *)(content[i]);
				break;
			default:	delete content[i];
				break;
		}
*/
		delete content[i];

	delete content;
	delete name;


	
}
void XplDisplay::SetElement(const Liste <XplObject *> * data_list,
		int di_x, int di_y)
{	int rows, cols;

	rows=vertical.cols();
	cols=horizontal.cols();
#ifdef _BLABLA_
/*OK*/	cout<<"SetElement: 1"<<endl; 
#endif		
	if (di_x<1 || di_y<1 || di_x>rows || di_y>cols )
	{	
#ifdef _BLABLA_
/*OK*/	cerr<<"ERROR by SetElement: x="<<di_x<<", soll !>"<<rows<<
	", di_y="<<di_y<<", soll !<"<<cols<<endl; 
#endif		
		globalError.Set (ERR_INTERN, "ERROR by SetElement");
		globalError.ShowError();
		return;
	}
	int text_lines, i;
	
	SubDisplay *sd;
	sd=content[cols*(di_x-1)+di_y-1];
/*	switch(sd->WhatIs())
	{	case PLOT:	delete (Plot *)(sd);
				break;
		case TEXT:	delete (VisText *)(sd);
				break;
		default:	delete sd;
				break;
	}
*/

	delete sd;

	content[cols*(di_x-1)+di_y-1]=NULL;
	SubDisplay *p;

	p=NULL;
	
	if ( (*(*data_list)[0])[0]->Type ()== O_XPLDOUBLE ||
		(*data_list)[0]->GetComponent("data")!=NULL)
		p=new Plot(data_list, this, di_x, di_y);
	
	if ( p==NULL && (*data_list)[0]->Type () == O_XPLCHAR)
	{	char *line, string[32555];
		string[0]=0;
		text_lines=(*data_list)[0]->DefaultComponent()
			->Content().xplchar->dimension(0) ;
		for (i=0; i<text_lines; i++)
		{	char *line=(*((*data_list)[0]->DefaultComponent()
			->Content().xplchar) )(i).tostr();	//OK!
			strcat(string, line);	
			delete line;
			strcat(string, "\n");
		}
#ifdef _BLABLA_
		cout<<string<<endl;
#endif
		p=new VisText(string, this, di_x, di_y);
	}

	if (p==NULL)
	{	globalError.Set (ERR_INTERN, "Something is wrong by SetElement! or Display");
		globalError.ShowError();
		p=new Plot(this, di_x, di_y);
	}


	content[cols*(di_x-1)+di_y-1]=p;

//	Dimension w, h;
//	XtVaGetValues(menu, XmNwidth, &w, XmNheight, &h, NULL);
//	cout<<"menu width="<<w<<", height="<<h<<endl;
	
	return;
}	


char * XplDisplay::GetName() const
{	char *str;
	str=strdup(name);
	return(str);
}
void XplDisplay::SetName(const char * newname)
{	if (name!=NULL && strlen(name))
		 delete name;
	name=strdup(newname);
	return;
}

SubDisplay* XplDisplay::GetElement(int di_x, int di_y) const
{	int rows, cols;
	rows=vertical.cols();
	cols=horizontal.cols();
	if (di_x<1 || di_y<1 || di_x>rows || di_y>cols )
	{
#ifdef _BLABLA_
/*OK*/	cerr<<"ERROR by GetSubDisplay: x="<<di_x<<", soll !>"<<rows<<
	", di_y="<<di_y<<", soll !<"<<cols<<endl; 
#endif
		globalError.Set (ERR_INTERN, "ERROR by GetElement");
		globalError.ShowError();
		return(NULL);
	}
	return(content[(di_x-1)*horizontal.cols()+di_y-1]);
}

int XplDisplay::GetElementWidth(int i, int j) const
{	if (i<1 || i>vertical.cols()+1 || j<1 || j>horizontal.cols()+1)
	{	globalError.Set (ERR_INTERN, "No such plot in display!");
		globalError.ShowError();
		return(0);	
	}
/*
	int w;
	w=(int)(horizontal(0, j-1)*width/100);
	cout<<"width ="<<w;
	Dimension ww;
	XtVaGetValues(kiste, XmNwidth, &ww, NULL);
	w=(int)(horizontal(0, j-1)*ww/100);
	cout<<" oder "<<w<<endl;
*/
	//int ret=(int)(horizontal(0, j-1)*(width-horizontal.cols())/100.0+0.5);
	int ret=(int)(horizontal(0, j-1)*width/100.0+0.5);
	return( ret );
}

int XplDisplay::GetElementHeight(int i, int j) const
{	if (i<1 || i>vertical.cols()+1 || j<1 || j>horizontal.cols()+1)
	{	globalError.Set (ERR_INTERN, "No such plot in display!");
		globalError.ShowError();
		return(0);	
	}
/*
	int h;
	h=(int)(horizontal(0, j-1)*height/100);
	cout<<"height="<<h;
	Dimension hh;
	XtVaGetValues(kiste, XmNheight, &hh, NULL);
	h=(int)(horizontal(0, j-1)*hh/100);
	cout<<" oder "<<h<<endl;

*/
	int ret= (int)(vertical(0, i-1)*height/100.0+0.5 );
	return( ret );
}

int XplDisplay::GetElementTopPosition(int i, int j) const
{	if (i<1 || i>vertical.cols()+1 || j<1 || j>horizontal.cols()+1)
	{	globalError.Set (ERR_INTERN, "No such plot in display!");
		globalError.ShowError();
		return(0);	
	}
	float w_x=0;
	int hi; 
	for (hi=0; hi<(i-1); hi++)
		w_x=w_x+vertical(0, hi);
	//cout<<"GetElementTopPosition: "<<w_x<<endl;
	return( (int)(w_x+0.5) );
}
int XplDisplay::GetElementBottomPosition(int i, int j) const
{	if (i<1 || i>vertical.cols()+1 || j<1 || j>horizontal.cols()+1)
	{	globalError.Set (ERR_INTERN, "No such plot in display!");
		globalError.ShowError();
		return(0);	
	}
	if (i==vertical.cols())
		return(100);
	float w_x=0;
	int hi; 
	for (hi=0; hi<i; hi++)
		w_x=w_x+vertical(0, hi);
	//cout<<"GetElementBottomPosition: "<<w_x<<endl;
	return( (int)(w_x+0.5) );
}
int XplDisplay::GetElementLeftPosition(int i, int j) const
{	if (i<1 || i>vertical.cols()+1 || j<1 || j>horizontal.cols()+1)
	{	globalError.Set (ERR_INTERN, "No such plot in display!");
		globalError.ShowError();
		return(0);	
	}
	float w_x=0;
	int hi; 
	for (hi=0; hi<(j-1); hi++)
		w_x=w_x+horizontal(0, hi);
	return( (int)(w_x+0.5) );
}
int XplDisplay::GetElementRightPosition(int i, int j) const
{	if (i<1 || i>vertical.cols()+1 || j<1 || j>horizontal.cols()+1)
	{	globalError.Set (ERR_INTERN, "No such plot in display!");
		globalError.ShowError();
		return(0);	
	}
	if (j==horizontal.cols())
		return(100);	
	float w_x=0;
	int hi; 
	for (hi=0; hi<j; hi++)
		w_x=w_x+horizontal(0, hi);
	return((int)(w_x+0.5) );
}

int XplDisplay::GetWidth()
{	return(width);	}

int XplDisplay::GetHeight()
{	return(height);	}

int XplDisplay::GetRows()
{	return(vertical.cols());	}

int XplDisplay::GetColumns()
{	return(horizontal.cols());	}

#define PAPER_OFFSET 20 //Abstand von papierrand unten links
#define WIDTHA4	555	//595-2*20

void XplDisplay::Print(const char *file_name) const
{	FILE *ps_file = NULL;
	char fname[124];
	char line[256];
	
	static int n=1;
//	cout<<"PRINT!!!"<<endl;
#ifdef _BLABLA_
	cout<<"PRINT width="<<width<<", height="<<height<<endl;
#endif
	if (file_name==NULL)
		sprintf(fname, "%s%d.ps", "subd", n);
	else
		sprintf(fname, "%s", file_name);
	//	cout<<"filename: "<<fname<<endl;
// SK 23.06.98 begin	
        char *tfname = fname; 
        if (tfname!=NULL) ps_file=fopen(tfname, "w");
	if (ps_file==NULL)
	{ if (tfname)
	    sprintf (line, " fstream '%s' is bad", tfname);
          else
	    sprintf (line, " fstream '%s' is bad", fname);
          globalError.Set (ERR_INTERN, line);
	  globalError.ShowError();
	  return;
	}
// SK 23.06.98 end	
	fprintf(ps_file, "%s\n",
		"%!PS-Adobe-2.0 EPSF-1.2");

	int ww, hh;
	ww=width;
	hh=height;
	
	double sc;
	sc=(ww>hh) ? (double)ww/WIDTHA4 : (double)hh/WIDTHA4;
	
	if (sc>1)
	{	ww=(int)(ww/sc);
		hh=(int)(hh/sc);
	}
	
	fprintf(ps_file, "%s 0 0 %d %d\n",
		"%%BoundingBox:",
		ww+2*PAPER_OFFSET, hh+2*PAPER_OFFSET);

	fprintf(ps_file, "%d %d translate\n", PAPER_OFFSET,
			 PAPER_OFFSET);
	/*
	fprintf(ps_file, "%d %d div %d %d div  scale\n",
			 ww+2*PAPER_OFFSET, width+2*PAPER_OFFSET,
			 hh+2*PAPER_OFFSET, height+2*PAPER_OFFSET);
	*/
	fprintf(ps_file, "%d %d div %d %d div  scale\n",
			 ww, width,
			 hh, height);
	
	
	fprintf(ps_file, "1 setlinejoin\n 1 setlinecap\n");

/* PC 001122 - not needed, frames are supposed to be drawn for subdisplays
	fprintf(ps_file,
"0 0 moveto\n%d 0 lineto\n%d %d lineto\n0 %d lineto \n0 0 lineto stroke\n",
		width, width, height, height);
*/

	fprintf(ps_file, "%s\n",
		"/POINT {1 0 360 arc fill} def" 	);

     	fprintf(ps_file, "%s\n",
		"/RECTANGLE {moveto 4 4  rmoveto 0 -8 rlineto -8 0 rlineto 0 8 rlineto 8 0 rlineto stroke} def" 	);

	fprintf(ps_file, "%s\n",
		"/CIRCLE {4 0 360 arc stroke} def" 	);

	fprintf(ps_file, "%s\n",
		"/TRIANGLE {moveto 0 -4  rmoveto -4 8 rlineto 8 0 rlineto -4 -8   rlineto stroke} def" 	);

	fprintf(ps_file, "%s\n",
"/XSYM {moveto 4 4 rmoveto -8 -8 rlineto 8 0 rmoveto -8 8 rlineto stroke} def" 	);

	fprintf(ps_file, "%s\n",
		"/RHOMBUS {moveto 0 4  rmoveto -4 -4 rlineto 4 -4 rlineto 4 4 rlineto -4 4 rlineto stroke} def" 	);

	fprintf(ps_file, "%s\n",
		"/FLD_RECTANGLE {moveto 4 4 rmoveto 0 -8 rlineto -8 0 rlineto 0 8 rlineto 8 0 rlineto  closepath gsave fill grestore stroke} def" );

	fprintf(ps_file, "%s\n",
		"/FLD_CIRCLE {4 0 360 arc fill} def" 	);
		
	fprintf(ps_file, "%s\n",
		"/FLD_ROMB {moveto 0 4  rmoveto -4 -4 rlineto 4 -4 rlineto 4 4 rlineto -4 4 rlineto closepath gsave fill grestore stroke} def" 	);

	fprintf(ps_file, "%s\n",
		"/FLD_TRIANGLE {moveto 0 -4  rmoveto -4 8 rlineto 8 0 rlineto -4 -8   rlineto closepath gsave fill grestore stroke} def" 	);

	fprintf(ps_file, "%s\n",
"/CROSS {moveto -4 0 rmoveto 8 0 rlineto -4 -4 rmoveto 0 8 rlineto stroke} def" 	);

	fprintf(ps_file, "%s\n",
"/STAR {moveto -4 0 rmoveto 8 0 rlineto -4 -4 rmoveto 0 8 rlineto 4 0 rmoveto -8 -8 rlineto 8 0 rmoveto -8 8 rlineto stroke} def" 	);

	fprintf(ps_file, "%s\n",
"/GRID {moveto -4 0 rmoveto 8 0 rlineto -4 -4 rmoveto 0 8 rlineto 4 0 rmoveto 0 -8 rlineto -8 0 rlineto 0 8 rlineto 8 0 rlineto  stroke} def" 	);

	fprintf(ps_file, "%s\n",
"/GRID_RHOMBUS {moveto -4 0 rmoveto 8 0 rlineto -4 -4 rmoveto 0 8 rlineto -4 -4 rlineto 4 -4 rlineto 4 4 rlineto -4 4 rlineto   stroke} def" 	);

	fprintf(ps_file, 
	"/XplShow {moveto dup stringwidth pop 2 div neg 0 rmoveto show stroke} def\n");
		
	fprintf(ps_file, 
	"/XplShow0 {moveto dup stringwidth 2 div exch 2 div neg exch rmoveto show stroke} def\n");
	fprintf(ps_file, 
	"/XplShow3 {moveto show} def\n");
	fprintf(ps_file, 
	"/XplShow6 {moveto dup stringwidth exch 2 div neg exch rmoveto show} def\n");
	fprintf(ps_file, 
	"/XplShow9 {moveto dup stringwidth pop neg 0 rmoveto show} def\n");
	fprintf(ps_file, 
	"/XplShow12 {moveto dup stringwidth neg exch 2 div neg exch rmoveto show} def\n");

	fprintf(ps_file, 
	"/XplRotShow {moveto -90 rotate dup stringwidth pop 2 div neg 0 rmoveto show 90 rotate stroke} def\n");
	
	fprintf(ps_file, 
	"/XplClip {/h exch def /w exch def w 0 rlineto 0 h rlineto w neg 0 rlineto gsave fill grestore newpath} def\n");

	fprintf(ps_file, 
	"/XplLine {moveto lineto stroke} def\n");
	
	fprintf(ps_file, 
	"/XplPointAs {gsave 0 0 7 1 roll 7 1 roll translate div  dup scale cvx cvn exec grestore} def\n");
	
	fprintf(ps_file, "/XAS {XplPointAs} def\n");
	fprintf(ps_file, "/P {POINT} def\n");	
	fprintf(ps_file, "/R {RECTANGLE} def\n");	
	fprintf(ps_file, "/C {CIRCLE} def\n");	
	fprintf(ps_file, "/T {TRIANGLE} def\n");	
	fprintf(ps_file, "/X {XSYM} def\n");	
	fprintf(ps_file, "/RH {RHOMBUS} def\n");	
	fprintf(ps_file, "/FR {FLD_RECTANGLE} def\n");	
	fprintf(ps_file, "/FC {FLD_CIRCLE} def\n");	
	fprintf(ps_file, "/FRH {FLD_ROMB} def\n");	
	fprintf(ps_file, "/FT {FLD_TRIANGLE} def\n");	
	fprintf(ps_file, "/CR {CROSS} def\n");
	fprintf(ps_file, "/S {STAR} def\n");
	fprintf(ps_file, "/G {GRID} def\n");
	fprintf(ps_file, "/GR {GRID_RHOMBUS} def\n");

	int i, j;
	int rows=vertical.cols();
	int cols=horizontal.cols();
	SubDisplay *sd;
	int left, top, right, bottom;

/* PC 001122 - rewritten, see below
	for (j=1; j<rows; j++)
	{	top=(int)
		(height-
		GetElementBottomPosition(j, 1)*(double)(height)/100.0+0.5);
		fprintf(ps_file, "0 %d moveto\n%d %d lineto\nstroke\n",
		top, width, top);
	}

	for (i=1; i<cols; i++)
	{	left=(int)
		(GetElementRightPosition(1, i)*(double)(width)/100.0+0.5);
		fprintf(ps_file, "%d 0 moveto\n%d %d lineto\nstroke\n",
		left, left, height);
	}
	//fprintf(ps_file, "stroke\n");
*/
// PC 001122 - frame drawn for every subdisplay separately
	for (j=0; j<cols; j++)
	{	for (i=0; i<rows; i++)
		{
         sd=GetElement(i+1, j+1);
         if (!sd->GetBorder())
      		continue;

		   left=(int)(0.5+GetElementLeftPosition(i+1, j+1)*
				(double)(width)/100);
		   right=(int)(0.5+GetElementRightPosition(i+1, j+1)*
				(double)(width)/100);
		   top=(int)(0.5+(100-GetElementTopPosition(i+1, j+1))*
				(double)height/100);
		   bottom=(int)(0.5+(100-GetElementBottomPosition(i+1, j+1))*
				(double)height/100);
     		fprintf(ps_file,
						"%d %d moveto\n%d %d lineto\n%d %d lineto\n%d %d lineto \n%d %d lineto stroke\n",
						left, top, left, bottom, right, bottom, right, top, left, top);
      }
   }

	for (j=0; j<cols; j++)
	{	for (i=0; i<rows; i++)
		{	sd=GetElement(i+1, j+1);
		left=(int)(0.5+GetElementLeftPosition(i+1, j+1)*
				(double)(width)/100);
		top=(int)(0.5+(100-GetElementBottomPosition(i+1, j+1))*
				(double)height/100);
			sprintf(line, "%d %d translate \n", left, top);
			fprintf(ps_file, line);
/*			switch(sd->WhatIs())
			{	case PLOT: case UPLOT:
				((Plot *)sd)->Print(ps_file);
				break;
				case TEXT:
				((VisText *)sd)->Print(ps_file);
				break;
				default:
				break;
			}
*/
			sd->Print(ps_file);
			sprintf(line, "-%d -%d translate \n", left, top);
			fprintf(ps_file, line);
			fprintf(ps_file, "stroke\n");
		}
	}
	 
	fprintf(ps_file, "showpage");
	fclose(ps_file);
	n++;
}


void XplDisplay::Resize(int wi, int he)
{
if (width==wi && height==he)
		return;
#ifdef _BLABLA_
	cout<<"	XplDisplay::Resize from ("<<width<<", "<<height<<") to ("<<
	wi<<", "<<he<<")\n";
#endif
	width=wi;
	height=he;
	int i, j, k=0;
	int rows=vertical.cols();
	int cols=horizontal.cols();
	for (i=0; i<rows; i++)
	for (j=0; j<cols; j++)
	{	content[k]->Resize(
			GetElementWidth(i+1, j+1), GetElementHeight(i+1, j+1));
		content[k]->Replace(
			GetElementTopPosition(i+1, j+1),
			GetElementBottomPosition(i+1, j+1),
			GetElementLeftPosition(i+1, j+1),
			GetElementRightPosition(i+1, j+1));
		k++;
	}

}


void XplDisplay::SetVertical(XplMatrix &v)
{	double sum=0;
	int i, j;
	if (v.rows()!=vertical.rows() || v.cols()!=vertical.cols())
	{	globalError.Set (ERR_INTERN, "Dimensions do not match!");
		globalError.ShowError();
		return;
	}
	SubDisplay *sd;
	for (i=0; i<v.cols(); i++)
		sum=sum+v(0, i);
	for (i=0; i<v.cols(); i++)
		vertical(0, i)=(int)(v(0, i)*100.0/sum);
	sum=0;
	for (i=0; i<v.cols(); i++)
		sum=sum+vertical(0, i);
	i=0;
	while (sum<100 && i<vertical.cols()/2)
	{	vertical(0, i)=vertical(0, i)+1;
		sum++;
		i++;		
		if (sum<100)
			vertical(0, vertical.cols()-i)=
				vertical(0, vertical.cols()-i)+1;
		sum++;
			
	}
	if (sum<100)
	{	cerr<<"Oh Gott...."<<endl;
		exit(0);
	}
	
	int top, bottom, right, left, k;
	for (i=0; i<v.cols(); i++)
	for (j=0; j<horizontal.cols(); j++)
	{	sd=GetElement(i+1, j+1);
		top=bottom=left=right=0;
		double ve, ho;
		ve=0;
		for (k=0; k<i; k++)
			ve=ve+vertical(0, k);
		top=(int)(top+ve+0.5);

		bottom=(int)(top+vertical(0, i)+0.5);
		ho=0;
		for (k=0; k<j; k++)
			ho=ho+horizontal(0, k);
		left=(int)(left+ho+0.5);
		right=left+(int)(0.5+horizontal(0, j));
		sd->Replace(top, bottom, left, right);
	}

#ifdef _BLABLA_
	cout<<"Verti:"<<endl;
	vertical.out();
#endif

}
void XplDisplay::SetHorizontal(XplMatrix &h)
{	double sum=0;
	int i, j;
	if (h.rows()!=horizontal.rows() || h.cols()!=horizontal.cols())
	{	globalError.Set (ERR_INTERN, "Dimensions do not match!");
		globalError.ShowError();
		return;
	}
	for (i=0; i<h.cols(); i++)
		sum=sum+h(0, i);
	for (i=0; i<h.cols(); i++)
		horizontal(0, i)=(int)(h(0, i)*100.0/sum);
#ifdef _BLABLA_
	cout<<"H:"<<endl;
	h.out();
	cout<<"Hori:"<<endl;
	horizontal.out();
#endif
	sum=0;
	for (i=0; i<h.cols(); i++)
		sum=sum+horizontal(0, i);
	i=0;
	while (sum<100 && i<horizontal.cols())
	{	horizontal(0, i)=horizontal(0, i)+1;
		i++;
		sum++;
		if (sum<100)
			horizontal(0, horizontal.cols()-i)=
				horizontal(0, horizontal.cols()-i)+1;
		sum++;
	}
	if (sum<100)
	{	cerr<<"Oh Gott...."<<endl;
		exit(0);
	}

	int top, bottom, right, left, k;
	SubDisplay *sd;
	for (i=0; i<vertical.cols(); i++)
	for (j=0; j<horizontal.cols(); j++)
	{	sd=GetElement(i+1, j+1);
		top=bottom=left=right=0;
		double ve=0;
		double ho=0;
		for (k=0; k<i; k++)
			ve=ve+vertical(0, k);
		top+=(int)(0.5+ve);
		bottom=top+(int)(0.5+vertical(0, i));
		for (k=0; k<j; k++)
			ho=ho+horizontal(0, k);
		left+=(int)(0.5+ho);
		right=left+(int)(0.5+horizontal(0, j));
		sd->Replace(top, bottom, left, right);
    }
         //sd->Refresh();

#ifdef _BLABLA_
	cout<<"H:"<<endl;
	h.out();
	cout<<"Hori:"<<endl;
	horizontal.out();
#endif
}



