/* $Header: /home/xplore/cvs/xpl4gr/dllfun.h,v 1.3 2002/08/16 12:31:41 sigbert Exp $ */

#ifndef _XPLDLLFUN_H_
#define _XPLDLLFUN_H_

#ifdef HAS_DLL

#ifdef __hpux
#include <dl.h>
#endif


typedef double* doublep;
typedef char*   charp;
typedef void*   voidp;

class Dll
{ char *name, *location, *callformat;
  int count;

#if HAS_DLL==UNIXDLL
#ifdef __hpux
  shl_t Dllhandle;
#else
  void *Dllhandle;
#endif
#endif
#if HAS_DLL==WINDLL
  HMODULE Dllhandle;
#endif

  public:


  Dll();
  ~Dll();

  int open (const char *newname);
  int open ();
  int close ();

  int call (const char *func, int param, doublep *c);
  int callex (const char *func, int param, int *type, voidp *c);

  int is (const char *qname);
  char *getlocation();
  char *getname();
  int getcount();
};

typedef Dll* dllp;

class Dlllist
{ int maxlist, lasthandle;
  dllp *dlllist;

  public:

  Dlllist (int length);
  ~Dlllist ();
  int gethandle (const char *hname);
  int gethandle (int handle);
  int open (const char *hname);
  int open (int handle);
  int close (int handle);
  int close ();
  char *getlocation (int handle);
  int call (int handle, const char *func, int nop, doublep *param);
  int callex (int handle, const char *func, int nop, int *type, voidp *param);

  int getsize();
  int getname(charp *p);
  int getlocation(charp *p);
  int getcount(int *p);

};

extern Dlllist x4dlllist;

XplObject* DLLopen   (Liste<XplObject*> *argl);
XplObject* DLLclose  (Liste<XplObject*> *argl);
XplObject* DLLcall   (Liste<XplObject*> *argl);
XplObject* DLLcallEx (Liste<XplObject*> *argl);
XplObject* DLLquery  (Liste<XplObject*> *argl);

#endif

#endif





