/* $Header: /home/xplore/cvs/xpl4gr/ed_data.C,v 1.3 2002/08/16 12:31:41 sigbert Exp $ */

#ifdef _UNIX_

#include "main.h"
#include "motif.h"
#include "uplot.h"
#include "color.h"

#ifdef _GUIDO_
extern	int starttime;
extern	char *gformat;
extern char *gfname;
#endif

#define FONT_COUNT 1
extern Liste <XplColor *> all_colors;
extern Liste <XplSymbol *> all_symbols;

extern int SymbolSizeToMask(xplmask *xplm);

extern char *xplfont_name[];

extern "C"	{

#include <Xm/DrawnB.h>

void wrefresh(Widget);
extern GC every_gc;
extern BS_Glob_Variable bs_glob_variable;
extern XmFontList PlotAllFont;

struct Contr_DataPart_Struct
		{	Widget label;

			Widget point_art[POINT_ART_COUNT];
			Widget point_opt;

			Widget line_art[LINE_ART_COUNT];
			Widget line_opt;

			Widget point_color[COLOR_COUNT];
			Widget point_color_opt;

			Widget line_color[COLOR_COUNT];
			Widget line_color_opt;
			
			XtPointer callback_data;
};
struct DataPart_Change_Data
		{	Widget draw;
			Widget contr_pan;
			int data_num;
			Outfit po_out;
			Lines_Outfit li_out;
			int po_col;
			int li_col;
	/*fi, li, po_col, li_col werden fuer cancel gebraucht*/
		};

struct Contr_String_Struct
		{	UPlot *which_plot;
			
			Widget text;
		
			Widget color_art[COLOR_COUNT];
			Widget color_opt;
			
			Widget font_art[FONT_COUNT];
			Widget font_opt;
			
			Widget res_str;
			Widget ind_label;
			Widget draw;
			
			int font_num;
			
			int color_num;
		};
			
static Boolean FontsGeladen=False;

char *symname[]={"NOPOINT", "POINT", "RECTANGLE", "CIRCLE", "TRIANGLE", "XSYM ",
		"RHOMBUS", "FLD_RECTANGLE", "FLD_CIRCLE", "FLD_ROMB", 
		"FLD_TRIANGLE", "PLUS", "STAR", "GRID", "GRID_RHOMBUS", 	
		"NOPOINT"};

void change_lineartCB(Widget menu_item, XtPointer p1, XtPointer p2)
{	int data_num;
	Widget w, draw;
	Wid_Data *wid_data;
	int item_no=(int) p1;
	struct DataPart_Change_Data *callback_data;
	struct Contr_DataPart_Struct *contr_info;
	int col;
	//VisMatrix *vm;
	UPlot *plot;
		
	//cout<<"Change_line: item_no="<<item_no<<endl;	
	w=XtParent(XtParent(XtParent(menu_item)));
	//cout<<XtName(w)<<endl;
	XtVaGetValues(w, XmNuserData, &contr_info, NULL);
	callback_data=(DataPart_Change_Data *) contr_info->callback_data;
	data_num=callback_data->data_num;
	//cout<<"data_num:"<<data_num<<endl;
	draw=callback_data->draw;	
	XtVaGetValues(draw, XmNuserData, &wid_data, NULL);	
	plot=(UPlot*)(wid_data->subdis);
#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64], line[64];
	Plot *p=plot;
	XplDisplay *xpld=p->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, p->GetY(), p->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	sprintf(line, "DataW\t%d\tChangeLineArt\t%d", data_num+1, 
			item_no+1);
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif

	switch(plot->GetPolygonCount(data_num+1))
	{	case 0:	//noch nicht verbunden
			plot->AddPolygon(data_num+1,
			 	plot->GetPointCount(data_num+1));
			plot->SetPolygonColor(callback_data->li_col, data_num+1);
			break;
		case 1: break;
		default:
			return;
	}
	
	switch(item_no)	//welche art ist ausgewaehlt
	{	case SOLID:	plot->SetPolygonLayout(SOLID, data_num+1);
			break;
		case ONOFFDASH: plot->SetPolygonLayout(ONOFFDASH, data_num+1);
			break;
		case DOUBLEDASH: plot->SetPolygonLayout(DOUBLEDASH, data_num+1);
			break;	
		case NOLINE: plot->DeletePolygon();
			break;		
	}
	XtVaSetValues(contr_info->line_opt, 
		XmNmenuHistory, menu_item, NULL);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif

}
void change_pointartCB(Widget menu_item, XtPointer p1, XtPointer p2)
{	int data_num;
	Widget w, draw, button;
	Wid_Data *wid_data;
	int item_no=(int) p1;
	struct DataPart_Change_Data *callback_data;
	UPlot *plot;
		
	struct Contr_DataPart_Struct *contr_info;
		
	//cout<<"Change_Art: item_no="<<item_no<<endl;	
	w=XtParent(XtParent(XtParent(menu_item)));
	//cout<<XtName(w)<<endl;
	XtVaGetValues(w, XmNuserData, &contr_info, NULL);
	callback_data=(DataPart_Change_Data *) contr_info->callback_data;
	data_num=callback_data->data_num;
	//cout<<"data_num:"<<data_num<<endl;
	draw=callback_data->draw;	
	XtVaGetValues(draw, XmNuserData, &wid_data, NULL);	
	plot=((UPlot*)(wid_data->subdis));
	
#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64], line[64];
	Plot *p=plot;
	XplDisplay *xpld=p->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, p->GetY(), p->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	sprintf(line, "DataW\t%d\tChangePointArt\t%s", data_num+1, 
			symname[item_no]);
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif

	int old_lay, neu_lay, old_sym, old_size, i, neu_size, neu_sym;
	old_lay=plot->GetPointLayout(data_num+1, 0);
	if (item_no==0 || item_no==1)
		plot->SetPointLayout(item_no, data_num+1);
	else
	{	switch(old_lay)	//NO POINT
		{	case 0: case 1: //NO POINT or POINT
			neu_size=8;
			neu_sym=item_no;
			neu_lay=item_no;			
			break;
			
			default:
			old_size=all_symbols[old_lay-2]->size;
			old_sym=all_symbols[old_lay-2]->symbol;
			for (i=0; i<all_symbols.laenge(); i++)
				if ( 	all_symbols[i]->symbol==item_no &&
					all_symbols[i]->size==old_size)
				break;
			if (i<all_symbols.laenge())	//gefunden..
				neu_lay=2+i;
			else
			for (i=0; i<all_symbols.laenge(); i++)
				if ( 	all_symbols[i]->symbol==item_no)
				break;
			if (i<all_symbols.laenge())	//sym gefunden..
				neu_lay=2+i;
			else 
			{	neu_lay=1;
				cerr<<"Something wrong by change art..."<<endl;
			}
		
		}
		plot->SetPointLayout(neu_lay, data_num+1);
	}
		
	//cout<<"vor change_art :"<<endl;
	//plot->vis_data[data_num]->out();

	//cout<<"nach change_art :"<<endl;
	//plot->vis_data[data_num]->out();
	

	button=(contr_info->point_art)[item_no];
	XtVaSetValues(contr_info->point_opt, XmNmenuHistory, button, NULL);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
}
void change_point_colorCB(Widget menu_item, XtPointer p1, XtPointer p2)
{	int data_num;
	Widget w, draw, button;
	Wid_Data *wid_data;
	int item_no=(int) p1;
	int which_color;
	struct DataPart_Change_Data *callback_data;
	struct Contr_DataPart_Struct *contr_info;
		
	//cout<<"Change_color: item_no="<<item_no<<" heisst "
	//<<color_name[item_no]<<endl;	

	w=XtParent(XtParent(XtParent(menu_item)));
	//cout<<XtName(w)<<endl;
	XtVaGetValues(w, XmNuserData, &contr_info, NULL);
	callback_data=(DataPart_Change_Data *) contr_info->callback_data;
	data_num=callback_data->data_num;
	//cout<<"data_num:"<<data_num<<endl;
	draw=callback_data->draw;	
	XtVaGetValues(draw, XmNuserData, &wid_data, NULL);	
#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64], line[64];
	Plot *p=(Plot *)(wid_data->subdis);
	XplDisplay *xpld=p->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, p->GetY(), p->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	sprintf(line, "DataW\t%d\tChangePointColor\t%s", data_num+1, 
			all_colors[item_no]->color_name);
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
	((UPlot*)(wid_data->subdis))->SetPointColor(item_no, data_num+1);
 	button=menu_item;
 	which_color=item_no;
	XtVaSetValues(contr_info->point_color_opt, 
			XmNmenuHistory, button, NULL);
	XtVaSetValues(XmOptionButtonGadget(contr_info->point_color_opt), 
			XmNforeground, all_colors[which_color]->pixel,
			 		NULL);
	XtVaSetValues(XmOptionLabelGadget(contr_info->point_color_opt), 
			XmNforeground, all_colors[which_color]->pixel,
			 NULL);
	XtVaSetValues(contr_info->point_color_opt, 
			XmNforeground, all_colors[which_color]->pixel,
			 NULL);
 	
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
 }

void change_line_colorCB(Widget menu_item, XtPointer p1, XtPointer p2)
{	int data_num;
	Widget w, draw;
	Wid_Data *wid_data;
	int item_no=(int) p1;
	struct DataPart_Change_Data *callback_data;
	struct Contr_DataPart_Struct *contr_info;
	Lines_Outfit fi;
	UPlot *plot;
		
	//cout<<"Change_color: item_no="<<item_no<<" heisst "
	//	<<color_name[item_no]<<endl;	
	w=XtParent(XtParent(XtParent(menu_item)));
	//cout<<XtName(w)<<endl;
	XtVaGetValues(w, XmNuserData, &contr_info, NULL);
	callback_data=(DataPart_Change_Data *) contr_info->callback_data;
	data_num=callback_data->data_num;
	//cout<<"data_num:"<<data_num<<endl;
	draw=callback_data->draw;	
	XtVaGetValues(draw, XmNuserData, &wid_data, NULL);	
	plot=(UPlot*)(wid_data->subdis);
#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64], line[64];
	Plot *p=plot;
	XplDisplay *xpld=p->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, p->GetY(), p->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	sprintf(line, "DataW\t%d\tChangeLineColor\t%s", data_num+1, 
			all_colors[item_no]->color_name);
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
	if (plot->GetPolygonCount(data_num+1)==0)
	{	callback_data->li_col=item_no;
		return;
	}
	plot->SetPolygonColor(item_no, data_num+1);
	XtVaSetValues(contr_info->line_color_opt, 
			XmNmenuHistory, menu_item, NULL);
	XtVaSetValues(XmOptionButtonGadget(contr_info->line_color_opt), 
			XmNforeground, all_colors[item_no]->pixel,
			 		NULL);
	XtVaSetValues(XmOptionLabelGadget(contr_info->line_color_opt), 
			XmNforeground, all_colors[item_no]->pixel,
			 NULL);
	XtVaSetValues(contr_info->line_color_opt, 
			XmNforeground, all_colors[item_no]->pixel,
			 NULL);
}

void control_panel_cancel(Widget push, XtPointer p1, XtPointer p2);

void control_panel_apply(Widget push, XtPointer p1, XtPointer p2)
{	struct Contr_DataPart_Struct * contr_info=(Contr_DataPart_Struct *) p1;
	struct DataPart_Change_Data *callback_data=
			(DataPart_Change_Data *) contr_info->callback_data;

	XtPopdown(XtParent( callback_data->contr_pan));
	wrefresh(callback_data->draw);
#ifdef _GUIDO_
	Wid_Data *wid_data; 
	XtVaGetValues(callback_data->draw, XmNuserData, &wid_data, NULL);
		FILE *gfile;
	char *ndis;
	char name[64], line[64];
	Plot *p=(Plot *)(wid_data->subdis);
	XplDisplay *xpld=p->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, p->GetY(), p->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	sprintf(line, "DataW\tCLICK\tApply");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	sprintf(line, "DataW\tCLOSED");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
}

extern BS_Glob_Variable bs_glob_variable;

Widget control_panel_init(Widget draw)
{	Widget control_panel;
	Widget pulldown, shell, option;
	Widget label, button;
	XmString datastr, punktstr, kreisstr, nichtsstr, pointstr;
	//	SOLID, ONOFFDASH, DOUBLEDASH, NOLINE
	int i;
//	static int ii=0;
//	XColor colorcell, rgb_exact;
	Display *dis;
	struct Contr_DataPart_Struct * contr_info;
	
	dis=XtDisplay(bs_glob_variable.main_shell);
	contr_info= (Contr_DataPart_Struct *)
			XtMalloc(sizeof(Contr_DataPart_Struct));


	
	shell=XtCreatePopupShell("shell", overrideShellWidgetClass,
				bs_glob_variable.main_shell, (Arg*) NULL, 0);
	control_panel=XtVaCreateManagedWidget("control_panel",
				xmRowColumnWidgetClass,
				shell, NULL);
	label=XtVaCreateManagedWidget("contr_panel_0", xmLabelWidgetClass,
				control_panel, NULL);
	contr_info->label=label;

	//	dann separator
	button=XtVaCreateManagedWidget("contr_sep", 	
 				xmSeparatorWidgetClass, control_panel,
				NULL);	
	// create point_art_menus
	pulldown= XmCreatePulldownMenu(control_panel, "point_pulldown",
				(Arg *)NULL, 0);
	Pixmap pm;
	int sym_size, size2;
	XSetForeground(XtDisplay(button),
				every_gc, 
				all_colors[4]->pixel);	
	char *name;
	for (i=0; i<POINT_ART_COUNT; i++)
	{	switch(i)
		{	case 0:	name="NOPOINT";
				break;
			case 1:	name="POINT";
				break;
			case 2:	name="RECTANGLE";
				break;
			case 3:	name="CIRCLE"; 
				break;
			case 4:	name="TRIANGLE"; 
				break;
			case 5:	name="XSYM ";
				break;
			case 6:	name="RHOMBUS";	
				break;
			case 7:	name="FLD_RECTANGLE"; 
				break;
			case 8:	name="FLD_CIRCLE"; 
				break;
			case 9:	name="FLD_ROMB";
				break;
			case 10:	name="FLD_TRIANGLE";	
				break;
			case 11:	name="PLUS";		
				break;
			case 12:	name="STAR";		
				break;
			case 13:	name="GRID";		
				break;
			case 14:	name="GRID_RHOMBUS";	
				break;
			default:	name="NOPOINT";
				break;
		}
		button=XtVaCreateManagedWidget(name,
				xmPushButtonWidgetClass, pulldown, 
				NULL);
		XtAddCallback(button, XmNactivateCallback, 
				change_pointartCB, (XtPointer)i);
		(contr_info->point_art)[i]=button;
	}
	option=XmCreateOptionMenu(control_panel, "point_option",
				(Arg *) NULL, 0);
	XtVaSetValues(option, XmNsubMenuId, pulldown, NULL);
	XtManageChild(option);	
	contr_info->point_opt=option;
	
	// create color_menu
	pulldown= XmCreatePulldownMenu(control_panel, "color_pulldown",
				(Arg *)NULL, 0);
	XmString xmsii;
	for (i=0; i<COLOR_COUNT; i++)
	{	xmsii=XmStringCreateSimple(all_colors[i]->color_name);
		button=XtVaCreateManagedWidget("contr_panel_8",
				xmPushButtonWidgetClass,
				pulldown,  
				XmNforeground, all_colors[i]->pixel,
				XmNlabelString, xmsii, 
				NULL);
		XmStringFree(xmsii);	//OK
		XtAddCallback(button, XmNactivateCallback, 
				change_point_colorCB, (XtPointer)i);
		(contr_info->point_color)[i]=button;
	}
	option=XmCreateOptionMenu(control_panel, "color_option",
				(Arg *) NULL, 0);
	XtVaSetValues(option, XmNsubMenuId, pulldown, NULL);
	XtManageChild(option);	
	contr_info->point_color_opt=option;

	//	dann separator
	button=XtVaCreateManagedWidget("contr_sep", 	
 				xmSeparatorWidgetClass, control_panel,
				NULL);	
				
	// create line_art_menus
	//	SOLID, ONOFFDASH, DOUBLEDASH, NOLINE
	pulldown= XmCreatePulldownMenu(control_panel, "line_pulldown",
				(Arg *)NULL, 0);
	for (i=0; i<LINE_ART_COUNT; i++)
	{	switch(i)
		{	case NOLINE:	//art=NOLINE
			button=XtVaCreateManagedWidget("contr_panel_4",
				xmPushButtonWidgetClass,
				pulldown, NULL);
			XtAddCallback(button, XmNactivateCallback, 
				change_lineartCB, (XtPointer)i);
			break;
			case SOLID:	//art=SOLID
			button=XtVaCreateManagedWidget("contr_panel_5",
				xmPushButtonWidgetClass,
				pulldown, NULL);
			XtAddCallback(button, XmNactivateCallback, 
				change_lineartCB, (XtPointer)i);
			break;
			case ONOFFDASH:	//art=ONOFFDASH
			button=XtVaCreateManagedWidget("contr_panel_6",
				xmPushButtonWidgetClass,
				pulldown, NULL);
			XtAddCallback(button, XmNactivateCallback, 
				change_lineartCB, (XtPointer)i);
			break;
			case DOUBLEDASH:	//art=DOUBLEDASH
			button=XtVaCreateManagedWidget("contr_panel_7",
				xmPushButtonWidgetClass,
				pulldown, NULL);
			XtAddCallback(button, XmNactivateCallback, 
				change_lineartCB, (XtPointer)i);
			break;

		}
		(contr_info->line_art)[i]=button;
	}
	option=XmCreateOptionMenu(control_panel, "line_option",
				(Arg *) NULL, 0);
	XtVaSetValues(option, XmNsubMenuId, pulldown, NULL);
	XtManageChild(option);	
	contr_info->line_opt=option;
	
	// create color_menu
	pulldown= XmCreatePulldownMenu(control_panel, "color_pulldown",
				(Arg *)NULL, 0);
	for (i=0; i<COLOR_COUNT; i++)
	{	xmsii=XmStringCreateSimple(all_colors[i]->color_name);
		button=XtVaCreateManagedWidget("contr_panel_8",
				xmPushButtonWidgetClass,
				pulldown,  
				XmNforeground, all_colors[i]->pixel, 
				XmNlabelString, xmsii,
				NULL);
		XmStringFree(xmsii);	//OK
		XtAddCallback(button, XmNactivateCallback, 
				change_line_colorCB, (XtPointer)i);
		(contr_info->line_color)[i]=button;
	}
	option=XmCreateOptionMenu(control_panel, "color_option",
				(Arg *) NULL, 0);
	XtVaSetValues(option, XmNsubMenuId, pulldown, NULL);
	XtManageChild(option);	
	contr_info->line_color_opt=option;
	
	//	dann separator
	button=XtVaCreateManagedWidget("contr_sep", 	
 				xmSeparatorWidgetClass, control_panel,
				NULL);

	//	dann apply_button
 	button=XtVaCreateManagedWidget("contr_apply", 	
 				xmPushButtonWidgetClass, control_panel,	NULL);
	XtAddCallback(button, XmNactivateCallback,
			control_panel_apply, XtPointer(contr_info));
	//	dann close_button
 	button=XtVaCreateManagedWidget("contr_close", 	
 				xmPushButtonWidgetClass, control_panel,	NULL);
	XtAddCallback(button, XmNactivateCallback,
			control_panel_cancel, XtPointer(contr_info));
            	
	XtVaSetValues(control_panel, XmNuserData, contr_info, NULL);
	XtManageChild(control_panel);
	return(control_panel);
					
}

void control_panel_ausgeben(Widget push, XtPointer p1, XtPointer p2)
{	
	Wid_Data *wid_data;
	Widget *child, draw;
	int data_num;
	int x, y, i;
	Window dummyW;
	int dummyI;
	unsigned int dummyII;
	XmString datastr;
	Widget contr_pan;
	Widget button;
	int which;
	unsigned long which_color;
	struct DataPart_Change_Data *callback_data, *current;
	struct Contr_DataPart_Struct *contr_info;	
	Lines_Outfit fi;
			
	callback_data=(DataPart_Change_Data *) p1;
	contr_pan=callback_data->contr_pan;
	data_num=callback_data->data_num;
	draw=callback_data->draw;

	XtVaGetValues(contr_pan, XmNuserData, &contr_info, NULL);
	current=(DataPart_Change_Data *) 
			XtMalloc(sizeof(DataPart_Change_Data));
	current->draw=draw;
	current->contr_pan=contr_pan;
	current->data_num=data_num;
	contr_info->callback_data=(XtPointer) current;
	XtVaGetValues(draw, XmNuserData, &wid_data, NULL);

	UPlot *plot=(UPlot*)(wid_data->subdis);	
#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64], line[64];;
	XplDisplay *xpld=plot->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, plot->GetY(), plot->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	sprintf(line, "CLICK\tData\t%d", data_num+1);
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif

	datastr=XmStringCreateSimple(plot->GetDataName(data_num+1));
	//cout<<"data_num:"<<data_num<<" und heisst "
	//<<((UPlot*)(wid_data->subdis))->GetDataName(data_num)<<endl;
	
	XtVaSetValues(contr_info->label, XmNlabelString, 
			datastr, NULL);
	// andere options auch aktualisieren mit XmNmenuHistory!
	// zuerst point_art
	which=(int)(plot->GetPointLayout(data_num+1, 0));
	
	if (which>1)	// nicht NOPOINT oder POINT
		which=all_symbols[which-2]->symbol;
	//cout<<"point_as: which="<<which<<endl;

	button=(contr_info->point_art)[which];
	XtVaSetValues(contr_info->point_opt, XmNmenuHistory, button, NULL);
	
	current->po_out=which;
	
	// dann point_color
	which_color=current->po_col=plot->GetPointColor(data_num+1, 0);
	if (which_color==-1)
		;//cout<<"control_panel_ausgeben::ist nicht homogen\n";
	else
	{	//cout<<"color: "<<color_name[which_color]<<endl;
 		button=(contr_info->point_color)[which_color];
		XtVaSetValues(contr_info->point_color_opt, 
			XmNmenuHistory, button, NULL);
		XtVaSetValues(XmOptionButtonGadget(contr_info->point_color_opt), 
			XmNforeground, all_colors[which_color]->pixel,
			 		NULL);
		XtVaSetValues(XmOptionLabelGadget(contr_info->point_color_opt), 
			XmNforeground, all_colors[which_color]->pixel,
			 NULL);
		XtVaSetValues(contr_info->point_color_opt, 
			XmNforeground, all_colors[which_color]->pixel,
			 NULL);
 	}
	// dann line_art
	if (plot->GetPolygonCount(data_num+1)==1)
		fi=plot->GetPolygonLayout(data_num+1, 1);
	else fi=NOLINE;
	current->li_out=fi;
	which=(int)fi;
	button=(contr_info->line_art)[which];
	XtVaSetValues(contr_info->line_opt, XmNmenuHistory, button, NULL);
	
	// dann line_color
	if (plot->GetPolygonCount(data_num+1)==1)
		which_color=plot->GetPolygonColor(data_num+1, 1);
	else which_color=0;
	current->li_col=which_color;
	if (plot->GetPolygonCount(data_num+1)==0)
		;//cout<<"control_panel_line_art_ausgeben::ist nicht homogen\n";
	else
	{	//cout<<"line_color: "<<color_name[which_color]<<endl;
 		button=(contr_info->point_color)[which_color];
		XtVaSetValues(contr_info->line_color_opt, 
			XmNmenuHistory, button, NULL);
		XtVaSetValues(XmOptionButtonGadget(contr_info->line_color_opt), 
			XmNforeground, all_colors[which_color]->pixel,
			 		NULL);
		XtVaSetValues(XmOptionLabelGadget(contr_info->line_color_opt), 
			XmNforeground, all_colors[which_color]->pixel,
			 NULL);
		XtVaSetValues(contr_info->line_color_opt, 
			XmNforeground, all_colors[which_color]->pixel,
			 NULL);
 	}
 	XQueryPointer(XtDisplay(push), XtWindow(push),
				&dummyW, &dummyW,
				&x, &y, &dummyI,
				&dummyI, &dummyII);
	XtVaSetValues(XtParent(contr_pan), XmNx, (Position)x, 
				XmNy, (Position)y, NULL);
	XtPopup(XtParent(contr_pan), XtGrabNone);
	
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	sprintf(line, "DataW\t%d\tOPENED", data_num+1);
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif

}

void control_panel_cancel(Widget push, XtPointer p1, XtPointer p2)
{	struct DataPart_Change_Data *callback_data;
	struct Contr_DataPart_Struct *contr_info=(Contr_DataPart_Struct *)p1;
	UPlot *plot;
	Wid_Data *wid_data;
	
	callback_data=(DataPart_Change_Data *)contr_info->callback_data;
	XtVaGetValues(callback_data->draw, XmNuserData, &wid_data, NULL);
	plot=((UPlot*)(wid_data->subdis));
	plot->SetPointLayout(callback_data->po_out, callback_data->data_num);
	plot->SetPointColor(callback_data->po_col, callback_data->data_num);
	if (callback_data->li_out==NOLINE)
		plot->DeletePolygon((callback_data->data_num)+1);
	else
		plot->AddPolygon(callback_data->data_num+1, 
			plot->GetPointCount(callback_data->data_num+1), NULL,
			callback_data->li_col, callback_data->li_out);
	 	
	XtPopdown( XtParent(XtParent(push)));

#ifdef _GUIDO_
	XtVaGetValues(callback_data->draw, XmNuserData, &wid_data, NULL);
	FILE *gfile;
	char *ndis;
	char name[64], line[64];
	Plot *p=(Plot *)(wid_data->subdis);
	XplDisplay *xpld=p->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, p->GetY(), p->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	sprintf(line, "DataW\tCLICK\tCancel");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	sprintf(line, "DataW\tCLOSED");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif

}    

Widget init_data_menu(Widget draw, Widget menu, UPlot *plot, Wid_Data *wid_data)
{	int i;		
	Widget data_menu, data_but, contr_pan;
	XmString datastr;
	struct DataPart_Change_Data* callback_data;
	data_menu=XmCreatePulldownMenu(menu, "data_menu",
				(Arg *) NULL, 0);
	contr_pan=control_panel_init(draw);
	wid_data->contr_pan=contr_pan;
	
	int sym;
	for (i=0; i<plot->GetDataCount(); i++)
	{	
		//cout<<"Variable "<<i<<" :"<<plot->GetDataName(i+1)<<endl;	
		sym=plot->GetPointLayout(i+1, 0);
		datastr=XmStringCreateSimple(plot->GetDataName(i+1));
		data_but=XtVaCreateManagedWidget("data_but", 
				xmPushButtonWidgetClass, data_menu,
				XmNlabelString,  datastr, 
				NULL);
	//cout<<"sym-2="<<sym-2<<"?<?"<<all_symbols.laenge()<<endl;
/*		if (sym>1 && sym-2<all_symbols.laenge())
			XtVaSetValues(data_but, 
				XmNbackgroundPixmap, all_symbols[sym-2]->pixy,
				NULL);
*/
//		cout<<"es geht noch weiter..."<<endl;
		XmStringFree(datastr);	//OK
		callback_data=(DataPart_Change_Data*)
			XtMalloc(sizeof(DataPart_Change_Data));
		callback_data->draw=draw;
		callback_data->contr_pan=contr_pan;
		callback_data->data_num=i;
		callback_data->po_out=plot->GetPointLayout(i+1, 0);
		callback_data->po_col=plot->GetPointColor(i+1, 0);
		if (plot->GetPolygonCount(i+1)>0)
		{	callback_data->li_out=
				plot->GetPolygonLayout(i+1, 1);
			callback_data->li_col=
				plot->GetPolygonColor(i+1, 1);
		}
		else 
		{	callback_data->li_out=NOLINE;
			callback_data->li_col=0;
		}
		  
		XtAddCallback(data_but, XmNactivateCallback,
			control_panel_ausgeben, XtPointer(callback_data));
			
	}
	
	return(data_menu);
}

void add_data_to_menu(Widget draw, UPlot *plot)
{	Widget data_menu;
	int i;	
	Widget data_but;
	XmString datastr;
	struct DataPart_Change_Data* callback_data;

	Wid_Data *wid_data;
	
	XtVaGetValues(draw, XmNuserData, &wid_data, NULL);
	int sym;
	data_menu=wid_data->data_menu;
	i=plot->GetDataCount()-1;	
	if (i<0)
	{	cerr<<"add_data_to_menu: ERROR"<<endl;
		return;
	}
	//cout<<"Variable "<<i<<" :"<<plot->GetDataName(i)<<endl;	
	sym=plot->GetPointLayout(i, 0);
	datastr=XmStringCreateSimple(plot->GetDataName(i));
	data_but=XtVaCreateManagedWidget("data_but", 
				xmPushButtonWidgetClass, data_menu,
				XmNlabelString,  datastr, NULL);
	XmStringFree(datastr);	//OK
	callback_data=(DataPart_Change_Data*)
			XtMalloc(sizeof(DataPart_Change_Data));
	callback_data->draw=draw;
	callback_data->contr_pan=wid_data->contr_pan;
	callback_data->data_num=i;
	callback_data->po_out=plot->GetPointLayout(i, 0);
	callback_data->po_col=plot->GetPointColor(i, 0);
	if (plot->GetPolygonCount(i+1)>0)
	{	callback_data->li_out=plot->GetPolygonLayout(i+1, 1);
		callback_data->li_col=plot->GetPolygonColor(i+1, 1);
	}
	else 
	{	callback_data->li_out=NOLINE;
		callback_data->li_col=0;
	}
		  
	XtAddCallback(data_but, XmNactivateCallback,
		control_panel_ausgeben, XtPointer(callback_data));
}

void change_string_colorCB(Widget w1, XtPointer p1, XtPointer p2)
{	struct Contr_String_Struct* contr_info=(Contr_String_Struct*) p1;
	int which_color;

	for (which_color=0; which_color<COLOR_COUNT; which_color++)
		if (contr_info->color_art[which_color]==w1)
			break;
	if (which_color==COLOR_COUNT)
	{	globalError.Set (ERR_INTERN, "Error bei change_string_colorCB!");
		return;
	}

	XtVaSetValues(contr_info->res_str, 
		XmNforeground, all_colors[which_color]->pixel, NULL);
	XtVaSetValues(contr_info->color_opt, 
		XmNforeground, all_colors[which_color]->pixel, NULL);
	contr_info->color_num=which_color;
}

void change_string_fontCB(Widget w1, XtPointer p1, XtPointer p2)
{	struct Contr_String_Struct* contr_info=(Contr_String_Struct*) p1;
	int which_font;
	XmString xms;
	char *s;

	for (which_font=0; which_font<FONT_COUNT; which_font++)
		if (contr_info->font_art[which_font]==w1)
			break;
	//cout<<"change_string_fontCB: "<<xplfont_name[which_font]<<endl;
	if (which_font==FONT_COUNT)
	{	globalError.Set (ERR_INTERN, "Error bei change_string_fontCB!");
		return;
	}
	s=XmTextGetString(contr_info->text);
	xms=XmStringCreate(s, xplfont_name[which_font]);
	XtVaSetValues(contr_info->res_str, XmNlabelString, xms, NULL);
	contr_info->font_num=which_font;
	XtFree(s);
	XmStringFree(xms);	//OK
}

extern "C" void draw_text(Widget);
void string_panel_apply(Widget w1, XtPointer p1, XtPointer p2)
{	struct Contr_String_Struct* contr_info=(Contr_String_Struct*) p1;
	Text_Data *te_da;
	
/*	if (	contr_info->which_plot->mouse_function!=STRING )
		return;

*/
	contr_info->which_plot->Refresh();
//	contr_info->which_plot->mouse_function=INDEX;
	XtPopdown(XtParent(XtParent(w1)));
	XtPopdown(XtParent(contr_info->ind_label));
	draw_text(contr_info->draw);

	return;
}

void string_move(Widget w1, XtPointer p1, XtPointer p2)
{	struct Contr_String_Struct* contr_info=(Contr_String_Struct*) p1;
	Text_Data *te_da;
	UPlot *plot;
	int x, y;
	
	plot=contr_info->which_plot;
		te_da= (Text_Data *)
			new Text_Data;
	
		te_da->text=XmTextGetString(contr_info->text);
		te_da->font_number=contr_info->font_num;
		te_da->color_number=contr_info->color_num;
		//Defaulte koordinaten:
		
		XplMatrix mini=plot->PlotMinToDimension();
		XplMatrix maxi=plot->PlotMaxToDimension();
		XplMatrix ori=(mini+maxi)/2.0;

		//cout<<"ori:"<<endl;
		ori.out();
		//cout<<"TE_DATA:"<<endl;
		//cout<<te_da->text<<endl;
		te_da->where=ori;
		//cout<<"OKOKOKOK..."<<endl;
		(plot->text_liste).haengeAn(te_da);
		
		//cout<<(plot->text_liste).laenge()
		//<<" angehaengt"<<endl;
	//	plot->click_function=SINGLE_STRING;
		//plot->repaint();
		
}

void popdown_parent(Widget w1, XtPointer p1, XtPointer p2)
{	Widget parent=XtParent(w1);
	while (! (XtIsSubclass(parent, transientShellWidgetClass) ) )
		parent=XtParent(parent);
	XtPopdown(parent);
}		
	

void update_resCB(Widget w1, XtPointer p1, XtPointer p2)
{	struct Contr_String_Struct* contr_info=(Contr_String_Struct*) p1;
	char *s;
	XmString xms;
	
	s=XmTextGetString(w1);
	xms=XmStringCreate(s, xplfont_name[contr_info->font_num]);
	XtVaSetValues(contr_info->res_str, XmNlabelString, xms, NULL);
	XtFree(s);
	XmStringFree(xms);	//OK
}
	

Widget init_text_menu(Widget draw, Widget menu, UPlot* plot, Wid_Data* wid_data)
{	Widget shell;
	Widget row_c, text1, text2;
	Widget button;
	Widget pulldown, option;
	int i;
	struct Contr_String_Struct* contr_info;
	XmString xms;
	
/*	if (FontsGeladen==False)
	{	font_init();	
		FontsGeladen=True;
	}
*/	
	contr_info= (Contr_String_Struct *)
			XtMalloc(sizeof(Contr_String_Struct));
			
//	//cout<<"init_text_menu 0"<<endl;
	shell=XtCreatePopupShell("Draw_String", transientShellWidgetClass,
				bs_glob_variable.main_shell, (Arg*) NULL, 0);
//	//cout<<"init_text_menu 1"<<endl;
	row_c=XtVaCreateWidget("string_panel",
				xmRowColumnWidgetClass, shell,
				NULL);
				
//	//cout<<"init_text_menu 2"<<endl;
	text1=XtVaCreateManagedWidget("string_panel_1",
		xmTextFieldWidgetClass, row_c,
		NULL);
	XmTextSetString(text1, "     ");
	XtAddCallback(text1, XmNactivateCallback, update_resCB,
	 	XtPointer(contr_info));
	contr_info->text=text1;
	
//	//cout<<"init_text_menu 3"<<endl;
	//	dann separator
	button=XtVaCreateManagedWidget("contr_sep", 	
 				xmSeparatorWidgetClass, row_c,
				NULL);	
	
	//cout<<"init_text_menu"<<endl;

	// create color_menu
	pulldown= XmCreatePulldownMenu(row_c, "color_pulldown",
				(Arg *)NULL, 0);
	XmString xmsi;
	for (i=0; i<COLOR_COUNT; i++)
	{	xmsi=XmStringCreateSimple(all_colors[i]->color_name);
		button=XtVaCreateManagedWidget("str_color",
				xmPushButtonWidgetClass,
				pulldown,  
				XmNforeground, all_colors[i]->pixel, 
				XmNfontList, PlotAllFont,
				XmNlabelString, xmsi, 
				NULL);
		XmStringFree(xmsi);	//OK
		XtAddCallback(button, XmNactivateCallback, 
				change_string_colorCB, (XtPointer)contr_info);
		contr_info->color_art[i]=button;
	}
	option=XmCreateOptionMenu(row_c, "color_option",
				(Arg *) NULL, 0);
	XtVaSetValues(option, XmNsubMenuId, pulldown, NULL);
	XtManageChild(option);	
	contr_info->color_opt=option;
	
	//	dann separator
	button=XtVaCreateManagedWidget("contr_sep", 	
 				xmSeparatorWidgetClass, row_c,
				NULL);

	// create font_menu
	pulldown= XmCreatePulldownMenu(row_c, "font_pulldown",
				(Arg *)NULL, 0);
	//cout<<"jetzt font..."<<endl;
	
	for (i=0; i<FONT_COUNT; i++)
	{	xms=XmStringCreate("Font", xplfont_name[i]);
	 	button=XtVaCreateManagedWidget("str_font",
				xmPushButtonWidgetClass,
				pulldown,  
				XmNlabelString, xms,
				XmNfontList, PlotAllFont,
				NULL);
		XmStringFree(xms);	//OK
	//	//cout<<xplfont_name[i]<<endl;
		XtAddCallback(button, XmNactivateCallback, 
				change_string_fontCB, (XtPointer)contr_info);
		contr_info->font_art[i]=button;
	}
	option=XmCreateOptionMenu(row_c, "font_option",
				(Arg *) NULL, 0);
	XtVaSetValues(option, XmNsubMenuId, pulldown, NULL);
	XtManageChild(option);	
	contr_info->font_opt=option;
	
	//	dann separator
	button=XtVaCreateManagedWidget("contr_sep", 	
 				xmSeparatorWidgetClass, row_c,
				NULL);

	button=XtVaCreateManagedWidget("result",
				xmLabelWidgetClass, row_c, NULL);
	xms=XmStringCreate("blabla", xplfont_name[0]);
	button=XtVaCreateManagedWidget("res_string",
				xmLabelWidgetClass, row_c,  
				XmNlabelString, xms,
				XmNfontList, PlotAllFont,
				NULL);
	contr_info->res_str=button;
	contr_info->color_num=0;
	contr_info->font_num=0;
	contr_info->which_plot=plot;

	contr_info->ind_label=wid_data->ind_label;
	Widget *lab;
	XtVaGetValues(wid_data->ind_label, XmNchildren, &lab, NULL);
	XtVaSetValues(lab[0], XmNfontList, PlotAllFont, NULL);

	contr_info->draw=draw;
	//	dann separator
	button=XtVaCreateManagedWidget("contr_sep", 	
 				xmSeparatorWidgetClass, row_c,
				NULL);

//	dann move_button
 	button=XtVaCreateManagedWidget("string_move", 	
 				xmPushButtonWidgetClass, row_c,	NULL);
	XtAddCallback(button, XmNactivateCallback,
			string_move, XtPointer(contr_info));
			
//	dann apply_button
 	button=XtVaCreateManagedWidget("contr_apply", 	
 				xmPushButtonWidgetClass, row_c,	NULL);
	XtAddCallback(button, XmNactivateCallback,
			string_panel_apply, XtPointer(contr_info));
	//cout<<"it was init_text_menu"<<endl;
 
 //	dann cancel_button
 	button=XtVaCreateManagedWidget("Cancel", 	
 				xmPushButtonWidgetClass, row_c,	NULL);
	XtAddCallback(button, XmNactivateCallback,
			popdown_parent, XtPointer(NULL));
	//cout<<"it was init_text_menu"<<endl;
	XtManageChild(row_c);
	return(shell);

}

	}
#endif
