/* $Header: /home/xplore/cvs/xpl4gr/edit.C,v 1.3 2002/08/16 12:31:41 sigbert Exp $ */

#ifdef _GRAPHICS_

#include "main.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#define FORMAT_WIDTH 15	//15=8+1+6
#define EDIT_FORMAT_STRING "%8.6g"
#define UNDO_COUNT 10

#ifndef MATRIX
#define cols() dimension(1)
#define rows() dimension(0)
#endif

extern "C" 	{
#include <Xm/List.h>
#include <Xm/Text.h>

extern BS_Glob_Variable bs_glob_variable;
extern Liste <Widget> *top_liste;
struct Edit_Matrix_Struct
	{	long	row;
		long	col;
		Widget	text_w;
		Widget	row_w;
		Widget 	col_w;
		Widget 	info_w;
		Liste <String> *undo_liste;
		XplDouble *for_save;
	};

long MaxColumnCount(char *str)
{	long cc, cc_curr, rc;
	long sl=strlen(str);
	long i=0;
	char *curr=str;
	cc=rc=cc_curr=0;
	
	while (i<sl)
	{	switch( curr[0])
		{	case ' ':
			case '\t':	
				if ( (curr-1)[0]=='\n' || (curr-1)[0]=='\t' 
					|| (curr-1)[0]==' ' || i==0 )
					break;
				cc_curr++;
				break;
			case '\n':	
				if ( !((curr-1)[0]=='\n' || (curr-1)[0]=='\t' 
					|| (curr-1)[0]==' ') )
					cc_curr++;
				if (cc<cc_curr)
					cc=cc_curr;
				cout<<rc<<". Line enthaelt "<<cc_curr
						<<" Spalten\n";
				cc_curr=0;
				rc++;
				break;
		}
		i++;
		curr++;
	}
	return(cc);
}		
long RowCount(char *str)
{	long cc, cc_curr, rc;
	long sl=strlen(str);
	long i=0;
	char *curr=str;
	cc=rc=cc_curr=0;
	char last_st;
	
	while (i<sl)
	{	if (curr[0]=='\n')
			rc++;
		i++;
		curr++;
	}
	return(rc);
}			


void help_showCB(Widget w, XtPointer xtp1, XtPointer p)
{	static Widget help_shell=NULL;
	Widget help_lab;
	XmString lst;

	if (help_shell==NULL)
	{	lst=XmStringCreateLtoR(
		"CTRL-X	Delete column\nCTRL-Y Delete line", 
			XmSTRING_DEFAULT_CHARSET);
		help_shell=XtCreatePopupShell("shell", overrideShellWidgetClass,
				w, (Arg*)NULL, 0);
		help_lab=XtVaCreateManagedWidget("help_lab", xmLabelWidgetClass,
				help_shell, XmNlabelString, lst, NULL);
	}
	XtPopup(help_shell, XtGrabNone);
}
void gotolineCB(Widget w, XtPointer xtp1, XtPointer p)
{	struct Edit_Matrix_Struct *e_m_s=(Edit_Matrix_Struct *) xtp1; 
	Widget t;
	int pos;
	char *str;
	
	
	t=XmSelectionBoxGetChild(w, XmDIALOG_TEXT);
	str=XmTextGetString(t);
	sscanf(str, "%d", &pos);
	cout<<pos<<" oder "<<pos*(e_m_s->col)*(FORMAT_WIDTH+1)<<endl;
	XtVaSetValues(e_m_s->text_w, 
		XmNcursorPosition, (pos-1)*(e_m_s->col)*(FORMAT_WIDTH+1), NULL);
}

void edit_gotoCB(Widget edit_text, XtPointer xtp1, XtPointer p)
{	struct Edit_Matrix_Struct *e_m_s=(Edit_Matrix_Struct *) xtp1; 
	static Widget dial=NULL;
	
	if (dial==0)
	{	dial=XmCreatePromptDialog(edit_text, "go_to_line",
				 (Arg *)NULL, 0);
		XtAddCallback(dial, XmNokCallback, gotolineCB,
				(XtPointer) e_m_s);
	}
	XtManageChild(dial);
}

void edit_saveCB(Widget edit_text, XtPointer xtp1, XtPointer p)
{	struct Edit_Matrix_Struct *e_m_s=(Edit_Matrix_Struct *) xtp1; 
	char *tstr;
	
	
	tstr =XmTextGetString(e_m_s->text_w);

	cout<<"FOR_SAVE:\n"<<tstr;
	
	cout<<"MaxColumnCount="<<MaxColumnCount(tstr)<<endl;

	FILE *file;
	file=fopen("/tmp/tmp.dat", "w");
	if (file==NULL)
	{	globalError.Set (ERR_INTERN, "ERROR bei oeffnen /tmp/tmp.dat!");
		globalError.ShowError();
		return;
	}
	fputs(tstr, file);
	fclose(file);
	XplDouble m(1);
#ifdef MATRIX
	ReadMatrix("/tmp/tmp.dat", &m);
#else
	if (m.ReadASCIIXplArray("/tmp/tmp.dat")==0)
		cerr<<"Save XplArray ERROR"<<endl;
	else (*e_m_s->for_save)=m;
#endif
	XtFree(tstr);
	remove("/tmp/tmp.dat");
}

void edit_quitCB(Widget edit_text, XtPointer xtp1, XtPointer p)
{	struct Edit_Matrix_Struct *e_m_s=(Edit_Matrix_Struct *) xtp1; 
	
	XtDestroyWidget(XtParent(XtParent(XtParent(e_m_s->text_w))));
}
char * delete_column(Widget text_w, long c_n, struct Edit_Matrix_Struct *e_m_s)
{	char *old_t, *new_t, *line, *new_line, *curr_text, *word;
	long k;
	char str[16];
	XmString xms;
	
	if (e_m_s->col==0)
	{	globalError.Set (ERR_INTERN, "delete column is unpossible");
		globalError.ShowError();
		return(NULL);
	}	
	cout<<" delete_column "<<c_n<<endl;
	cout<<" delete_column col="<<e_m_s->col<<endl;
	if (e_m_s->col==1)
	{	new_t=strdup(" ");
		cout<<"new_l="<<new_t<<"ende"<<endl;
		e_m_s->col=e_m_s->col-1;
		sprintf(str, " %ld rows, %ld columns ", 
			e_m_s->row, e_m_s->col); 
		cout<<str<<endl;
		xms=XmStringCreateSimple(str);
		XtVaSetValues(e_m_s->info_w, XmNlabelString, xms, NULL);
		XmStringFree(xms);	//OK
		return(new_t);
	}
	old_t=XmTextGetString(text_w);
	new_t=(char *)XtMalloc( sizeof(char)*(strlen(old_t)+1)+1);
	curr_text=new_t;
	k=0;
	word=strtok(old_t, "\n\t");
	while (word)
	{	//cout<<"word="<<word<<"!!!"<<endl;
		if ( (k!=c_n) )
		{	sprintf(curr_text, "%s\t", word);
			curr_text=curr_text+strlen(word)+1;
		}
		k++;
		if (k==e_m_s->col)
		{	sprintf(curr_text-1, "\n");
			//cout<<"newline"<<endl;
			k=0;
		}
		word=strtok(NULL, "\n\t");
	}
	//cout<<"new_l="<<new_t<<"ende"<<endl;
	e_m_s->col=e_m_s->col-1;
	sprintf(str, " %ld rows, %ld columns ", e_m_s->row, e_m_s->col); 
	xms=XmStringCreateSimple(str);
	XtVaSetValues(e_m_s->info_w, XmNlabelString, xms, NULL);
	XmStringFree(xms);	//OK
	XtFree(old_t);	
	return(new_t);
}
char* delete_line(long l_n, struct Edit_Matrix_Struct *e_m_s)
{	char *old_l, *new_l, *line, *curr_line;
	char str[32];
	XmString xms;
	long k;

	if (e_m_s->row==0)
	{	globalError.Set (ERR_INTERN, "delete line is unpossible");
		globalError.ShowError();
		return NULL;
	}
	old_l=XmTextGetString(e_m_s->text_w);
	cout<<"delete_line "<<l_n<<endl;
	new_l=(char *)XtMalloc( sizeof(char)*(strlen(old_l)+1)+1);
	curr_line=new_l;
	k=0;
	line=strtok(old_l, "\n");
	while (line)
	{	//cout<<line<<endl;
		if ( (k!=l_n) )
		{	sprintf(curr_line, "%s\n", line);
			curr_line=curr_line+strlen(line)+1;
			//cout<<k<<endl;
		}
		k++;
		line=strtok(NULL, "\n");
	}
	curr_line[0]=0;
	
	cout<<"delete_line:liste has "<<e_m_s->undo_liste->laenge()<<endl;

	e_m_s->row=e_m_s->row-1;
	sprintf(str, " %ld rows, %ld columns ", e_m_s->row, e_m_s->col); 
	xms=XmStringCreateSimple(str);
	XtVaSetValues(e_m_s->info_w, XmNlabelString, xms, NULL);
	XmStringFree(xms);	//OK
	return(new_l);
}     

void edit_motionVerifyCB(Widget edit_text, XtPointer xtp1, 
			XmTextVerifyCallbackStruct *cbs)
{	struct Edit_Matrix_Struct *e_m_s=(Edit_Matrix_Struct *) xtp1; 
	XmTextPosition pos;
	int row_length, cur_col, cur_row;
	char labstr[16], *new_text, *str, *n_l;
	XmString xms;
	XmTextBlock *new_text_block;
	Liste<String> *undo_liste=e_m_s->undo_liste;
	
	pos=cbs->newInsert;
	switch (cbs->reason)
	{	case XmCR_LOSING_FOCUS:
			cout<<"XmCR_LOSING_FOCUS\n";
			break;
		case XmCR_MODIFYING_TEXT_VALUE:
			new_text=cbs->text->ptr;
			row_length=(FORMAT_WIDTH+1) * e_m_s->col;
			if (row_length==0)
				cur_row=cur_col=0;
			
			else
			{	cur_row=pos/row_length;
				cur_col=(pos%row_length) / (FORMAT_WIDTH+1);
			}
			cout<<"XmCR_MODIFYING_TEXT_VALUE\n";
		//	cout<<cbs->text->length<<" Char"<<endl;
			cout<<"new_text:"<<new_text<<"!!!"<<endl;
			cout<<"int="<<(int)(new_text[0])<<endl;
			if ( (int)(new_text[0])==24)
			{	cout<<"CTRL-X: delete_column\n";
				cbs->doit=False;
				n_l=delete_column(e_m_s->text_w, 
					cur_col, e_m_s);
				if (n_l==NULL)
					break;
				XmTextSetString(edit_text, n_l);
				//XtFree(n_l);
					
				break;
			}
			if ( (int)(new_text[0])==25)
			{	cout<<"CTRL-Y: delete_line\n";
				cbs->doit=False;
				n_l=delete_line(cur_row, e_m_s);
				if (n_l==NULL)
					break;
				XmTextSetString(edit_text, n_l);
				XtFree(n_l);
				break;
			}
			str=XmTextGetString(edit_text);
			cout<<"save vor: liste has "<<
			undo_liste->laenge()<<" elements\n";
			undo_liste->fuegeEin(str, 0);
			cout<<"save nach:liste has "<<
			undo_liste->laenge()<<" elements\n";
			break;
		case XmCR_MOVING_INSERT_CURSOR:
		//	cout<<"XmCR_MOVING_INSERT_CURSOR\n";
			row_length=(FORMAT_WIDTH+1) * e_m_s->col;
			cur_row=pos/row_length;
			cur_col=(pos%row_length) / (FORMAT_WIDTH+1);
			sprintf(labstr, "%ld", cur_row+1);
			xms=XmStringCreateSimple(labstr);
			XtVaSetValues(e_m_s->row_w, XmNlabelString, xms, NULL);
			XmStringFree(xms);	//OK
			sprintf(labstr, "%ld", cur_col+1);
			xms=XmStringCreateSimple(labstr);
			XtVaSetValues(e_m_s->col_w, XmNlabelString, xms, NULL);
			XmStringFree(xms);	//OK
			break;
	}
}
void mat_undo_CB(Widget but, XtPointer p1, XtPointer p2)
{	struct Edit_Matrix_Struct *e_m_s=(Edit_Matrix_Struct *) p1; 
	Widget text_w=e_m_s->text_w;
	Liste <String> *undo_liste =e_m_s->undo_liste;
	XmString lst;
	char zahl[22];
	
	if (undo_liste->laenge()<2)
	{	globalError.Set (ERR_INTERN, "Undo is not possible");
		globalError.ShowError();
		return;
	}
//	cout<<"undo_CB vor:liste has "<<undo_liste->laenge()<<" elements\n";
	e_m_s->col=MaxColumnCount((*undo_liste)[0]);
	e_m_s->row=RowCount((*undo_liste)[0]);
	XmTextSetString(text_w, (*undo_liste)[0]);

	sprintf(zahl, " %ld rows, %ld columns ", e_m_s->row, e_m_s->col); 
	lst=XmStringCreateSimple(zahl);
	XtVaSetValues(e_m_s->info_w, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
	
	undo_liste->loesche(0);
//	cout<<"undo_CB mitten:liste has "<<undo_liste->laenge()<<" elements\n";
	undo_liste->loesche(0);
//	cout<<"undo_CB nach:liste has "<<undo_liste->laenge()<<" elements\n";
}

void edit(XplDouble &m)
{	Widget edit_shell, kiste, menu_line, info_line, curr_line, but;
	Widget edit_text;
	Widget sep;
	long i, j, k;
	double d;
	char *string, *currstr, zahl[32];
	XmString lst; 
	struct Edit_Matrix_Struct *e_m_s;
	
	Liste <String> *undo_liste;
 
	undo_liste=new Liste <String>;
	string=XtMalloc( sizeof(char)*m.rows()*m.cols()*(FORMAT_WIDTH+2)  );
	if (string==NULL)
	{	cout<<"SORRY... No memory enough..."<<endl;
		return;
	}
	string[0]=0;
	//cout<<"OK... I shall try...allociert for "<<
	//	sizeof(char)*m.rows()*m.cols()*(FORMAT_WIDTH+2)<<" chars"<<endl;
	e_m_s=(Edit_Matrix_Struct *)
			XtMalloc(sizeof(Edit_Matrix_Struct));
	e_m_s->row=m.rows();
	e_m_s->col=m.cols();
	edit_shell=XtCreatePopupShell("XploRe_edit", topLevelShellWidgetClass,
				bs_glob_variable.main_shell, (Arg*) NULL, 0);
	top_liste->haengeAn(edit_shell);
	kiste=	XtVaCreateManagedWidget("e_kiste", xmFormWidgetClass,
			edit_shell, NULL);
	menu_line=XtVaCreateManagedWidget("menu_line", 	
				xmRowColumnWidgetClass, kiste,
			 	XmNtopAttachment,XmATTACH_FORM, 
				XmNleftAttachment, XmATTACH_FORM,
			//	XmNrightAttachment, XmATTACH_FORM,
				XmNorientation, XmHORIZONTAL, 
				NULL);
	lst=XmStringCreateSimple("Undo");
	but=	XtVaCreateManagedWidget("e_but", xmPushButtonWidgetClass,
			menu_line, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
	XtAddCallback(but, XmNactivateCallback, 
			mat_undo_CB, (XtPointer) e_m_s);
	
	lst=XmStringCreateSimple("Go to");
	but=	XtVaCreateManagedWidget("e_but", xmPushButtonWidgetClass,
			menu_line, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
	XtAddCallback(but, XmNactivateCallback, 
			edit_gotoCB, (XtPointer) e_m_s);
	
	lst=XmStringCreateSimple("Save");
	but=	XtVaCreateManagedWidget("e_but", xmPushButtonWidgetClass,
			menu_line, XmNlabelString, lst, NULL);
	XtAddCallback(but, XmNactivateCallback, edit_saveCB, (XtPointer) e_m_s);
	XmStringFree(lst);	//OK

	lst=XmStringCreateSimple("Quit");
	but=	XtVaCreateManagedWidget("e_but", xmPushButtonWidgetClass,
			menu_line, XmNlabelString, lst, NULL);
	XtAddCallback(but, XmNactivateCallback, edit_quitCB, (XtPointer) e_m_s);
	XmStringFree(lst);	//OK
	
	lst=XmStringCreateSimple("Help");
	but=	XtVaCreateManagedWidget("e_but", xmPushButtonWidgetClass,
			menu_line, XmNlabelString, lst, NULL);
	XtAddCallback(but, XmNactivateCallback, help_showCB, (XtPointer) e_m_s);
	XmStringFree(lst);	//OK
	
	info_line=	XtVaCreateManagedWidget("info_line",
	 			xmRowColumnWidgetClass, kiste, 	
				XmNtopAttachment,XmATTACH_WIDGET,
				XmNtopWidget, menu_line, 
				XmNleftAttachment, XmATTACH_FORM,
		//		XmNrightAttachment, XmATTACH_FORM,
				XmNorientation, XmHORIZONTAL, 
				NULL);

	sprintf(zahl, " %ld rows, %ld columns ", m.rows(), m.cols()); 
	//cout<<zahl<<endl;
	lst=XmStringCreateSimple(zahl);
	but=	XtVaCreateManagedWidget("e_but", xmLabelWidgetClass,
			info_line, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
	e_m_s->info_w=but;
	
	curr_line=	XtVaCreateManagedWidget("curr_line",
	 			xmRowColumnWidgetClass, kiste, 	
				XmNtopAttachment,XmATTACH_WIDGET,
				XmNtopWidget, info_line, 
				XmNleftAttachment, XmATTACH_FORM,
			//	XmNrightAttachment, XmATTACH_FORM,
				XmNorientation, XmHORIZONTAL, 
				NULL);

	lst=XmStringCreateSimple("current line:");
	but=	XtVaCreateManagedWidget("e_but", xmLabelWidgetClass,
			curr_line, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
	
	sprintf(zahl, "%ld3", 1); 
	lst=XmStringCreateSimple(zahl);
	but=	XtVaCreateManagedWidget("e_but", xmLabelWidgetClass,
			curr_line, XmNlabelString, lst, NULL);
	e_m_s->row_w=but;
	XmStringFree(lst);	//OK

	lst=XmStringCreateSimple("current column:");
	but=	XtVaCreateManagedWidget("e_but", xmLabelWidgetClass,
			curr_line, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
	
	sprintf(zahl, "%ld3", 1); 
	lst=XmStringCreateSimple(zahl);
	but=	XtVaCreateManagedWidget("e_but", xmLabelWidgetClass,
			curr_line, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
	e_m_s->col_w=but;
	
	edit_text=XmCreateScrolledText(kiste, "edit_text", 
				(Arg *)NULL, 0);
	e_m_s->text_w=edit_text;
	e_m_s->undo_liste=undo_liste;
	e_m_s->for_save=&m;
	XtVaSetValues(edit_text, XmNeditMode, XmMULTI_LINE_EDIT,
				XmNeditable, True, 
				XmNverifyBell, False,
				NULL);
	XtVaSetValues(XtParent(edit_text), XmNtopAttachment,XmATTACH_WIDGET,
				XmNtopWidget, curr_line, 
				XmNleftAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_FORM,
				XmNbottomAttachment, XmATTACH_FORM,
				NULL);

	currstr=string;
	for (i=0; i<m.rows(); i++)
		for (j=0; j<m.cols(); j++)
		{	sprintf(zahl, EDIT_FORMAT_STRING, m(i,j));
			//cout<<"zahl:"<<zahl<<endl;
			strcpy(currstr, zahl);
			currstr+=strlen(zahl);
			if (j==m.cols()-1)
			{	currstr[0]='\n';
				//if (fmod(i,5000)==0)	
				//	cout<<"Bitte warten\n";
				//cout<<"String:\n"<<string;
			}
			else currstr[0]='\t';
			currstr++;
		}
	currstr[0]=0;
	//cout<<"string hat "<<strlen(string)<<" chars"<<endl;
	XmTextSetString(edit_text, string);
	undo_liste->haengeAn(string);
	//cout<<"nach initial. hat liste "<<undo_liste->laenge()<<" elemente\n";
	XtManageChild(edit_text);
	
	XtAddCallback(edit_text, XmNmotionVerifyCallback, 
			edit_motionVerifyCB, (XtPointer) e_m_s);
	XtAddCallback(edit_text, XmNmodifyVerifyCallback, 
			edit_motionVerifyCB, (XtPointer) e_m_s);
/*	XtAddCallback(edit_text, XmNvalueChangedCallback,
			save_for_undoCB, (XtPointer) (undo_liste));
*/	XtPopup(edit_shell, XtGrabNone);
	XtFree(string);
}
	}
#endif
