/* $Header: /home/xplore/cvs/xpl4gr/function.h,v 1.3 2002/08/16 12:31:42 sigbert Exp $ */

#ifndef _FUNCTION_H_
#define _FUNCTION_H_

#include <string.h>
#include "object.h"

typedef	XplObject* (*FP) (Liste<XplObject*> *);

class Function {
 public:  Function (const char *n, FP f, int t=TRUE)
                          : name (strdup(n)), fun (f), nt (t) {}
          ~Function        ()                 { delete[] name; }
          const FP    Fun       (void) const  { return (fun);  }
          const char* Name      (void) const  { return (name); }
          const int   needTemps (void) const  { return (nt);   }

          const int   operator< (const Function &r)
	    {
	      return (strcmp (name, r.name) < 0);
	    }
          const int   operator> (const Function &r)
	    {
	      return (strcmp (name, r.name) > 0);
	    }
 private: char *name;
          FP   fun;
          int  nt;         // flag, whether function needs copies of arguments
};

#endif
