/* $Header: /home/xplore/cvs/xpl4gr/globlist.C,v 1.4 2003/05/23 15:37:45 cizek Exp $ */

// GlobalList Klasse

// TTK 10.10.94

#include "machine.h"

#ifdef HAS_IOSTREAMH
#include <iostream.h>
#else
#include <stream.h>
#endif

// #pragma implementation

#include "liste.h"
#include "xplpp.h"
#include "object.h"
#include "function.h"
#include "globlist.h"
#include "xplcalc.h"
#include "xplore_strings.h"

#ifdef __BORLANDC__
#include "xplwin.h"
#endif

int tok, position;


TokenElement leerTE;

//GlobalList::GlobalList (Liste<TokenElement> *t)
GlobalList::GlobalList (Vector<TokenElement> *t)
{
  pos = jump = 0L;
  tokenlist = new Vector<TokenElement> (*t);

#ifdef TTKDEBUG
  if (ttkdebug)
    cerr << "Glbl:\tconstruct\t" << this << '\t'  << endl;
#endif
}

GlobalList::GlobalList ()
{
  pos = jump = 0L;
  tokenlist = new Vector<TokenElement>;
#ifdef TTKDEBUG
  if (ttkdebug)
    cerr << "Glbl:\tconstruct\t" << this << '\t'  << endl;
#endif
}

void GlobalList::DeleteElements ()
{
  long i, length = tokenlist->laenge ();

  for (i=0; i<length; i++)
    if ((*tokenlist)[i].token == VARIABLE)
      {
      if ((*tokenlist)[i].content.Var->Constant ())
	{
        (*tokenlist)[i].content.Var->GetXplObject()->DelWriteProtection ();
        delete (*tokenlist)[i].content.Var->GetXplObject ();
        }
      delete (*tokenlist)[i].content.Var;
      }
  tokenlist->remove();
}


GlobalList& GlobalList::operator= (const GlobalList& gl)
{
  if (this == &gl)
    return (*this);

  pos = gl.pos;
  jump = gl.jump;
  
  *tokenlist = *(gl.tokenlist);

  return (*this);
}

void GlobalList::Clear (void)
{
  tokenlist->remove ();
  pos = jump = 0L;
}

long GlobalList::CurrentLine (void)
{ 
  pos = pos >= tokenlist->laenge() ? tokenlist->laenge()-1 : pos;
  if (pos == -1)
    return (0L);
  else
    return ((*tokenlist)[pos].SourceLine);
}

void GlobalList::PrintCurrentToken (void)
/* TTK, 8.3.98  deaktiviert, gibt mehr Info auf Shell aus */
{
  int i, m;
  YYSTYPE content;


  return;


  cout << "Current token " << (*tokenlist)[pos].token << " on position " << pos << endl;
  cout << "in line " << (*tokenlist)[pos].SourceLine << endl;

  m = pos - 4 < 0 ? 0 : pos - 4;

  cout << "Error Begin pos = " << pos << ":\n-----------------------" << endl;

 for (i=m; i<pos; i++)
   {
     //  PrintToken ((*tokenlist)[pos].token);
     //  switch ((*tokenlist)[pos].token)
  cout << i << '\t';
  PrintToken ((*tokenlist)[i].token);
  content = (*tokenlist)[i].content;
  switch ((*tokenlist)[i].token)
    {
    case VARIABLE:
      cout << "Variable  " << content.Var->Name() << endl;
      break;
    case FUNCTION:
      cout << "Function  " << content.Fun->Name() << endl;
      break;
    case MACRO:
      cout << "Macro     " << content.Mac->Name() << endl;
      break;
    case NEWSTRING:
      cout << "Newstring " << content.Name << endl;
      break;
    case CONSTANT:
      cout << "value " << content.Real << endl;
      break;
    case OP_PM:
      cout << "operator " << content.Index << endl;
      break;
    default:
      cout << "Token has no name" << endl;
    }
   }
  cout << "Error: End\n-----------------------" << endl;

  //  pos++;
}

void GlobalList::GetCurrentToken (char text[])
/* TTK, 8.3.98  Ausgabe der letzten drei Token. IdR nur 'unknown object'
   Vorige Position wg look-ahead-token.

   Spezialfall: unknown object

   noch weiter ausbaufaehig: Ausgabe der zuletzt geparsten Token
*/
{
  YYSTYPE content;
  int     i, m;
  char    buffer[256];

  *text = '\0';
  strcat (text, "... ");

  m = pos - 2 < 0 ? 0 : pos - 2;

  for (i=m; i<pos; i++)
    {
    content = (*tokenlist)[i].content;
    switch ((*tokenlist)[i].token)
      {
      case VARIABLE:
	sprintf (buffer, XMSG_GLOBLIST_VARIABLE_FMTSTR_STR, content.Var->Name());
	break;
      case FUNCTION:
	sprintf (buffer, XMSG_GLOBLIST_FUNCTION_FMTSTR_STR, content.Fun->Name());
	break;
      case MACRO:
	sprintf (buffer, XMSG_GLOBLIST_MACRO_FMTSTR_STR, content.Mac->Name());
	break;
      case NEWSTRING:
        *text = '\0';
	sprintf (buffer, XMSG_GLOBLIST_UNKNOWN_FMTSTR_STR, content.Name);
	strcat (text, buffer);
	return;
	break;
      case CONSTANT:
	sprintf (buffer, "%g", content.Real);
	break;
      case OP_PM:
      case OP_MD:
      case OP_TMD:
      case OP_P:
      case OP_REL:
      case OP_AND:
      case OP_OR:
      case OP_SEQ:
      case OP_CON:
	switch (content.Index)
	  {
	  case PLUS:    strcpy (buffer, "+");   break;
	  case MINUS:   strcpy (buffer, "-");   break;
	  case MULT:    strcpy (buffer, "*");   break;
	  case DIV:     strcpy (buffer, "/");   break;
	  case MMULT:   strcpy (buffer, "*");   break;
	  case TMULT:   strcpy (buffer, "*");   break;
	  case EQUAL:   strcpy (buffer, "==");  break;
	  case NEQ:     strcpy (buffer, "!=");  break;
	  case LESS:    strcpy (buffer, "<");   break;
	  case GREATER: strcpy (buffer, ">");   break;
	  case LEQ:     strcpy (buffer, "<=");  break;
	  case GEQ:     strcpy (buffer, ">=");  break;
	  case AND:     strcpy (buffer, "&&");  break;
	  case OR:      strcpy (buffer, "||");  break;
	  case SEQ:     strcpy (buffer, ":");   break;
	  case RBIND:   strcpy (buffer, "|");   break;
	  case CBIND:   strcpy (buffer, "~");   break;
	  case POW:     strcpy (buffer, "^");   break;
	  case MOD:     strcpy (buffer, "%");   break;
	  case TRANS:   strcpy (buffer, "'");   break;
	  case NOT:     strcpy (buffer, "!");   break;
	  default:
	    sprintf (buffer, "#internal error: Please report##");
            break;
	  }
	break;
      default:
	//	sprintf (buffer, "###");
	*buffer = '\0';
      }
    strcat (text, buffer);
    }
  strcat (text, " ...");
}


