/* $Header: /home/xplore/cvs/xpl4gr/hlp2html.C,v 1.3 2002/08/16 12:31:43 sigbert Exp $ */

#define LIBFILTER    "*.xpl"
#define LIBDIR       "lib"
#define HLPFILTER    "*.hlp2"
#define HLPDIR       "hlp2"


#define HTMLDIR      "help"
#define ASCIIDIR     "text"
#define LATEXDIR     "overview.tex"

#define LINKHLP2     "#0000FF"
#define LINKXPL      "#FF0000"

#define MAX_TEXT_LENGTH 32000

#include 	<iostream.h>
#include    <stdio.h>
#include    <string.h>
#include    <ctype.h>
#include    <stdlib.h>
#include    <stdarg.h>

#include "directory.h"
#include "property.h"
#include "machine.h"


#ifdef HAS_STRCMPI
#define strcasecmp strcmpi
#endif

int error, m3, simple, ret;
FILE *logfile;
char *lastparam = NULL;

void print (int lp, char *fmt, char *txt1 = NULL, char *txt2 = NULL, char *txt3=NULL)
{
  char buf[1024];

  if ((lp!=1) && lastparam)
  { if (lp==0)
    { if (logfile)
       fprintf (logfile, "%s", lastparam);
    }
    if (lastparam) delete[] lastparam;
    lastparam = NULL;
  }

  if (txt3==NULL)
  { if (txt2==NULL)
    { if (txt1==NULL)
      { if (lp==1)
        { if (lastparam) delete[] lastparam;
            lastparam = strdup(fmt);
	}
        else if (logfile)
          fprintf (logfile, fmt);
      }
      else
      { sprintf (buf, fmt, txt1);
        if (lp==1)
        { if (lastparam) delete[] lastparam;
          lastparam = strdup(buf);
        }
        else if (logfile)
          fprintf (logfile, fmt, txt1);
      }
    }
    else
    { sprintf (buf, fmt, txt1, txt2);
      if (lp==1)
      { if (lastparam) delete[] lastparam;
        lastparam = strdup(buf);
      }
      else if (logfile)
        fprintf (logfile, fmt, txt1, txt2);
    }
  }
  else
  { sprintf (buf, fmt, txt1, txt2, txt3);
    if (lp==1)
    { if (lastparam) delete[] lastparam;
      lastparam = strdup(buf);
    }
    else if (logfile) 
      fprintf (logfile, fmt, txt1, txt2, txt3);
  }
  if (logfile) fflush(logfile);
}

void print (int lp, char *fmt, int txt)
{ char buf[1024];
  if ((lp!=1) && lastparam)
  { if (lp==0)
    { if (logfile) fprintf (logfile, "%s", lastparam); }
    delete[] lastparam;
    lastparam = NULL;
  }
  sprintf (buf, fmt, txt);
  if (lp==1)
  { if (lastparam) delete[] lastparam;
    lastparam = strdup(buf);
  }
  else if (logfile)
  { fprintf (logfile, fmt, txt);
    fflush(logfile);
  }
}

int less (char *left, char *right)
{ int i;
  for (i=0;; i++)
  { if (isalnum(left[i]))
    { if (!isalnum(right[i]))
        return 0;
      else if (tolower(left[i])!=tolower(right[i]))
        return (tolower(left[i])<tolower(right[i]));
    }
    else
    { if (isalnum(right[i]))
        return 1;
      else if (left[i]!=right[i])
        return (left[i]<right[i]);
    }
    if (left[i]==0)  return 0;
    if (right[i]==0) return 0;
  }
}

char n2nout[1024];

char *name2number (char *n2nin)
{ sprintf (n2nout, "0%s", n2nin);
  return (n2nout);
}

int numberoflinks (char *txt)
{ char *tok;
  int ret = 0;
  tok = strtok (txt, " ,\t\r\n");
  while (tok)
  { ret++;
    tok = strtok(NULL, " ,\t\r\n");
  }
  return (ret);
}

char *cutnewline (char *txt)
{ int i;
  if (txt)
  { for (i=0; i<strlen(txt); i++)
    { if ((txt[i]=='\n') || (txt[i]=='\r'))
      { txt[i] = 0;
        return (txt);
      }
    }
  }
  return (txt);
}

char *replace1 (char *old) 
{int i, j, k, l, lold, m, h; 
 char *c=new char[10000];
 char n1[]="<DL><DT>";
 char n2[]="</DD><DT>";
 char n3[]="</DT><DD>";
 char n4[]="</DD></DL>";
 char s1[]="&val;";
 char s2[]="&means;";
 char s3[]="&";
 lold = strlen(old);
 { for (i=0,j=0; (i<lold) && (j<10000); i++)
    {if ( strncmp(&old[i],s1,strlen(s1))==0)
       { i += strlen(s1);
         for(k=0; k<strlen(n1); k++, j++)
           c[j]=n1[k];
         break;  
       }
      else
         c[j] = old[i];
          j++;
    }
         
  for(m=j, l=i; (l<lold) && (m<10000); l++)
    { if (strncmp(&old[l],s1,strlen(s1))==0) 
       { l += strlen(s1); 
         for (k=0; k<strlen(n2); k++, m++)
           c[m] = n2[k];
       }
      else if (strncmp(&old[l],s2,strlen(s2))==0) 
       { l += strlen(s2);
         for (k=0; k<strlen(n3); k++,m++) 
           c[m] = n3[k]; 
         for (h=l; (h<lold) && (m<10000); h++)
           { if (strncmp(&old[h],s1,strlen(s1))==0)
              break;
             else if ((strncmp(&old[h],s1,strlen(s1))!=0) && (h==lold-strlen(s1)+1))
              { for (k=h; k<lold; k++,m++)
                  c[m] = old[k];
                strcat(c,n4);
                m += strlen(n4)-1;
              }
             else
              { c[m] = old[h];
                m++;
                l=h;
              }  
           }
       }   
      else
       { c[m] = old[l];
         m++;
       }
    } 
    c[m]=0;
    return (c); 
   }
 } 

char *replace2 (char *old, char s[], char n[])
{ int i, j, k, lold;
  char *c = new char[MAX_TEXT_LENGTH], *ret;
  lold = strlen(old);
  { for(j=0, i=0; (i<lold) && (j<MAX_TEXT_LENGTH); i++)
    { if (strncmp(&old[i],s,strlen(s))==0)
      { i += (strlen(s)-1);
        for (k=0; k<strlen(n); k++, j++)
          c[j] = n[k];
      }
      else
      { c[j] = old[i];
        j++;
      }
    }
    c[j] = 0;
    ret = strdup(c);
    delete[] c;
    return (ret);
  }
} 

char *insertchar  (char *old, char s[], char n[])
{ int i, j, k, l, lold;
  char c[10000];
  lold = strlen(old);
  for(j=0, i=0; (i<lold)&&(i<10000); i++)
  { if (strncmp(&old[i],s,strlen(s))==0) 
    {   for (k=0; k<strlen(n); k++, j++)
        c[j] = n[k];
    }
    c[j] = old[i];
    j++;     
  }
  c[j]=0;
  return (strdup(c));
}

void correcttext1( FILE *f,char *t)
{ char *ptr1, *ptr2, *ptr3, *ptr4, *ptr5, *ptr6, *ptr7;
  if (t)
  { ptr1=replace2(t,"&","&amp;");
    ptr2=replace2(ptr1,"<","&lt;");
    delete[] ptr1;
    ptr3=replace2(ptr2,">","&gt;");
    delete[] ptr2;
    ptr4=replace2(ptr3,"&amp;nl;&amp;nl;" , "<P>");
    delete[] ptr3;
    ptr5=replace2(ptr4,"&amp;nl;" , "<BR>");
    delete[] ptr4;
    ptr6=replace2(ptr5,"\"","&quot;");
    delete[] ptr5;
    ptr7=insertchar(ptr6, "\n\n" , "<P>");
    delete[] ptr6;
    fprintf (f, "%s", ptr7);
    delete[] ptr7;
  }
}

void correcttext2( FILE *f,char *t)
{   char *ptr1, *ptr2, *ptr3, *ptr4, *ptr5, *ptr6, *ptr7, *ptr8, *ptr9;
    char *ptr10,*ptr11, *ptr12, *ptr13, *ptr14, *ptr15 ,*ptr16, *ptr17, *ptr18;
    if (t)
  { ptr1=replace2(t,"\\" , "\\/");
    ptr2=replace2(ptr1,"&nl;" , " \\newline ");
    delete[] ptr1;
    ptr3=replace2(ptr2,"\n\n" , " \\newline ");
    delete[] ptr2;
    ptr4=replace2(ptr3, "_" , "\\_");
    delete[] ptr3;
    ptr5=replace2(ptr4,"%","\\%");
    delete[] ptr4;
    ptr6=replace2(ptr5,"&","\\&");
    delete[] ptr5;
    ptr7=replace2(ptr6,"{","\\{");
    delete[] ptr6;
    ptr8=replace2(ptr7,"}","\\}");
    delete[] ptr7;
    ptr9=replace2(ptr8,"#","\\#");
    delete[] ptr8;
    ptr10=replace2(ptr9,"^"," $\\hat{ }$");
    delete[] ptr9;
    ptr11=replace2(ptr10,"~"," $\\sim$");
    delete[] ptr10;
    ptr12=replace2(ptr11,"<"," $<$");
    delete[] ptr11;
    ptr13=replace2(ptr12,">"," $>$");
    delete[] ptr12;
    ptr14=replace2(ptr13,"-"," $-$");
    delete[] ptr13;
    ptr15=replace2(ptr14,"||"," $\\parallel$");
    delete[] ptr14;
    ptr16=replace2(ptr15,"|"," $\\mid$");
    delete[] ptr15;
    ptr17=replace2(ptr16,"&val;","\\ &   ");
    delete[] ptr16;
    ptr18=replace2(ptr17,"&means;","\\ &  \\hspace{0.8cm}");
    delete[] ptr17;
    fprintf (f, " & \\sl{ %s } & \n", ptr18);
    delete[] ptr18;
  }
}

void correcttext3( FILE *f,char *t)
{   char *ptr1, *ptr2, *ptr3, *ptr4, *ptr5, *ptr6, *ptr7, *ptr8, *ptr9;
    char *ptr10, *ptr11, *ptr12, *ptr13, *ptr14, *ptr15, *ptr16, *ptr17, *ptr18;
    if (t)
  { ptr1=replace2(t,"\\","\\/");
    ptr2=replace2(ptr1,"&nl;" , " \\newline ");
    delete[] ptr1;
    ptr3=replace2(ptr2,"\n\n" , " \\newline ");
    delete[] ptr2;
    ptr4=replace2(ptr3, "_" , "\\_");
    delete[] ptr3;
    ptr5=replace2(ptr4,"%","\\%");
    delete[] ptr4;
    ptr6=replace2(ptr5,"&","\\&");
    delete[] ptr5;
    ptr7=replace2(ptr6,"{","\\{");
    delete[] ptr6;
    ptr8=replace2(ptr7,"}","\\}");
    delete[] ptr7;
    ptr9=replace2(ptr8,"#","\\#");
    delete[] ptr8;
    ptr10=replace2(ptr9,"^"," $\\hat{ }$");
    delete[] ptr9;
    ptr11=replace2(ptr10,"~"," $\\sim$");
    delete[] ptr10;
    ptr12=replace2(ptr11,"<"," $<$");
    delete[] ptr11;
    ptr13=replace2(ptr12,">"," $>$");
    delete[] ptr12;
    ptr14=replace2(ptr13,"-"," $-$");
    delete[] ptr13;
    ptr15=replace2(ptr14,"||"," $\\parallel$");
    delete[] ptr14;
    ptr16=replace2(ptr15,"|"," $\\mid$");
    delete[] ptr15;
    ptr17=replace2(ptr16,"&val;","\\ &   ");
    delete[] ptr16;
    ptr18=replace2(ptr17,"&means;","\\ &  \\hspace{0.8cm}");
    delete[] ptr17;
    fprintf (f, "%s", ptr18);
    delete[] ptr18;
  }
}

void correcttext4( FILE *f,char *t)
{   char *ptr1, *ptr2, *ptr3, *ptr4, *ptr5, *ptr6, *ptr7, *ptr8, *ptr9;
    char *ptr10, *ptr11, *ptr12, *ptr13, *ptr14,*ptr15, *ptr16;
    if (t)
  { ptr1=replace2(t,"\\","\\/");
    ptr2=replace2(ptr1,"&nl;" , " \\newline ");
    delete[] ptr1;
    ptr3=replace2(ptr2,"\n\n" , " \\newline ");
    delete[] ptr2;
    ptr4=replace2(ptr3, "_" , "\\_");
    delete[] ptr3;
    ptr5=replace2(ptr4,"%","\\%");
    delete[] ptr4;
    ptr6=replace2(ptr5,"&","\\&");
    delete[] ptr5;
    ptr7=replace2(ptr6,"{","\\{");
    delete[] ptr6;
    ptr8=replace2(ptr7,"}","\\}");
    delete[] ptr7;
    ptr9=replace2(ptr8,"#","\\#");
    delete[] ptr8;
    ptr10=replace2(ptr9,"^"," $\\hat{ }$");
    delete[] ptr9;
    ptr11=replace2(ptr10,"~"," $\\sim$");
    delete[] ptr10;
    ptr12=replace2(ptr11,"<"," $<$");
    delete[] ptr11;
    ptr13=replace2(ptr12,">"," $>$");
    delete[] ptr12;
    ptr14=replace2(ptr13,"-"," $-$");
    delete[] ptr13;
    ptr15=replace2(ptr14,"||"," $\\parallel$");
    delete[] ptr14;
    ptr16=replace2(ptr15,"|"," $\\mid$");
    delete[] ptr15;
    fprintf (f, " {\\rm\\bf\\Large %s }}}} \\\\ \n ", ptr16);
    delete[] ptr16;
  }
}

void trim (char *txt)
{ int i, j, blank = 1, back = 1;
  for (j=i=0; i<strlen(txt); i++)
  { if (txt[i]==' ')
    { if (!blank)
      { txt[j]=txt[i];
        j++;
      }
    }
    else
    { blank = 0;
      txt[j] = txt[i];
      j++;
    }

    if (back && (txt[strlen(txt)-i-1]==' '))
      txt[strlen(txt)-i-1] = 0;
    else
      back = 0;
  }
  txt[j] = 0;
}

char *ignorenewline (char *txt)
{ int i;
  if (txt)
  { for (i=0; i<strlen(txt); i++)
     if (txt[i]=='\n') txt[i] = ' ';
     if (txt[i]=='\r') txt[i] = ' ';
  }
  return (txt);
}

class TEXTXPL
{
  public:
  char *txt1;
  char *txt2;

  TEXTXPL *next;

  TEXTXPL ()
  { txt1 = NULL;
    txt2 = NULL;
    next = NULL;
  }

  ~TEXTXPL ()
  { if (txt1) delete[] txt1;
    if (txt2) delete[] txt2;
  }

};

typedef char* charp;

class OBJECT
{
  public:

  char *group;
  char *subgroup;
  char *name;
  char *see;
  char *note;
  char *link;
  char *description;
  char *author;
  char *usage;
  char *program;
  char *reference;
  char *keywords;

  char *filename;
  char *filegroup;
  char *filesubgroup;
  char *filelink;

  char type;
  int  nsee;
  int  ingroup;
  void *seeobj;
  charp *seetok;

  OBJECT *next;
  OBJECT *last;

  TEXTXPL *in;
  TEXTXPL *out;
  TEXTXPL *example;

  OBJECT (char newtype)
  {
    group        = NULL;
    subgroup     = NULL;
    name         = NULL;
    see          = NULL;
    note         = NULL;
    link         = NULL;
    description  = NULL;
    author       = NULL;
    usage        = NULL;
    program      = NULL;
    reference    = NULL;
    keywords     = NULL;

    filename     = NULL;
    filegroup    = NULL;
    filesubgroup = NULL;
    filelink     = NULL;

    type         = newtype;
    nsee         = 0;
    ingroup      = 0;
    seeobj       = NULL;
    seetok       = NULL;
    next         = NULL;
    last         = NULL;
    in           = NULL;
    out          = NULL;
    example      = NULL;
  }

  ~OBJECT()
  { TEXTXPL *xt, *xtn;
    char *tmp;
    int i;

    if (group)        delete[] group;
    if (subgroup)     delete[] subgroup;
    if (name)         delete[] name;
    if (see)          delete[] see;
    if (note)         delete[] note;
    if (link)         delete[] link;
    if (description)  delete[] description;
    if (author)       delete[] author;
    if (usage)        delete[] usage;
    if (program)      delete[] program;
    if (reference)    delete[] reference;
    if (keywords)     delete[] keywords;

    if (filename)     delete[] filename;
    if (filegroup)    delete[] filegroup;
    if (filesubgroup) delete[] filesubgroup;
    if (filelink)     delete[] filelink;

    if (seeobj)       delete[] seeobj;
    if (seetok)
    { for (i=0; i<nsee; i++)
        if (seetok[i]) delete[] (seetok[i]);
      delete[] seetok;
    }

    if (in)
    { xt = in;
      do
      { xtn = xt->next;
        tmp = xt->txt1;
        if (tmp)
        { delete[] tmp;
          xt->txt1 = NULL;
        }
        tmp = xt->txt2;
        if (tmp)
        { delete[] tmp;
          xt->txt2 = NULL;
        }
        delete xt;

        xt = xtn;
      }
      while (xt);
    }
    if (out)
    { xt = out;
      do
      { xtn = xt->next;
        tmp = xt->txt1;
        if (tmp) 
        { delete[] tmp;
          xt->txt1 = NULL;
        }
        tmp = xt->txt2;
        if (tmp) 
        { delete[] tmp;
          xt->txt2 = NULL;
        }
        delete xt;
        xt = xtn;
      }
      while (xt);
    }
    if (example)
    { xt = example;
      do
      { xtn = xt->next;
        tmp = xt->txt1;
        if (tmp) 
        { delete[] tmp;
          xt->txt1 = NULL;
        }
        tmp = xt->txt2;
        if (tmp) 
        { delete[] tmp;
          xt->txt2 = NULL;
        }
        delete xt;
        xt = xtn;
      }
      while (xt);
    }
  }

  void check()
  { if (filename==NULL)
    { print (0, "    error: no filename found\r\n");
      ret = 2;
      return;
    }
    if (filegroup==NULL)
      print (0, "    warning: no group/library found\r\n");
    if (name==NULL)
    { print (0, "    warning: no name found\r\n");
      name = strdup(filename);
    }
    if (group==NULL)
    { print (0, "    warning: no group/library name found\r\n"); }
    if (see==NULL)
      print (0, "    warning: no see/see also found\r\n");
    
    TEXTXPL *tmp;
    int set;
    
    if (in)  
    { tmp = in;
      while (tmp)
      { set = (tmp->txt1==NULL) + 2* (tmp->txt2==NULL);
        switch (set)
        { case 1 : print (0, "    warning: Input parameter found without explanation\r\n");
                   break;
          case 2 : print (0, "    warning: Input definition found without explanation\r\n");
                   break;
          case 3 : print (0, "    warning: Input parameter and definition found without explanation\r\n");
                   break;
        }
        tmp = tmp->next;
      }
    }
    if (out)
    { tmp = out;
      while (tmp)
      { set = (tmp->txt1==NULL) + 2* (tmp->txt2==NULL);
        switch (set)
        { case 1 : print (0, "    warning: Output parameter found without explanation\r\n");
                   break;
          case 2 : print (0, "    warning: Output definition found without explanation\r\n");
                   break;
          case 3 : print (0, "    warning: Output parameter and definition found without explanation\r\n");
                   break;
        }
        tmp = tmp->next;
      }
    }
    if (example)
    { tmp = example;
      while (tmp)
      { set = (tmp->txt1==NULL) + 2* (tmp->txt2==NULL);
        switch (set)
        { case 1 : print (0, "    warning: Example found without explanation\r\n");
                   break;
          case 2 : print (0, "    warning: Example result found without explanation\r\n");
                   break;
          case 3 : print (0, "    warning: Example and result found without explanation\r\n");
                   break;
        }
        tmp = tmp->next;
      }
    }
  }


  void dump (FILE *f)
  { int i;
    TEXTXPL *t;

    if (f==NULL) return;

    fprintf (f, "Name        : %s %s\n", name, filename);
    fprintf (f, "Group       : %s %s\n", group, filegroup);
    fprintf (f, "Subgroup    : %s %s\n", subgroup, filesubgroup);
    fprintf (f, "Usage       : %s\n", usage);
    fprintf (f, "Program     : %s\n", program);
    fprintf (f, "Author      : %s\n", author);
    fprintf (f, "Reference   : %s\n", reference);
    fprintf (f, "Keyowrd(s)  : %s\n", keywords);
    fprintf (f, "Link        : %s %s\n", link, filelink);
    fprintf (f, "Type/Ingroup: %1i %i\n", type, ingroup);

    fprintf (f, "Description :\n%s\n", description);
    fprintf (f, "Notes       :\n%s\n", note);
    fprintf (f, "See also    :\n");

    for (i=0; i<nsee; i++)
    { if (((OBJECT **) seeobj)[i])
        fprintf (f, "%s, ", ((OBJECT **) seeobj)[i]->name);
      else
        fprintf (f, "(null), ");
    }
    fprintf (f, "\n");

    t = in;
    fprintf (f, "Input       :\n");
    while (t)
    { fprintf (f, "%s\n%s\n", t->txt1, t->txt2);
      t = t->next;
    }
    t = out;
    fprintf (f, "Output      :\n");
    while (t)
    { fprintf (f, "%s\n%s\n", t->txt1, t->txt2);
      t = t->next;
    }
    t = example;
    fprintf (f, "Example      :\n");
    while (t)
    { fprintf (f, "%s\n%s\n", t->txt1, t->txt2);
      t = t->next;
    }
    fprintf (f, "----------------------------------------------------------------\n");
    fflush(f);
  }

} root(255);

typedef OBJECT* OBJECTP;

class KEYWORD
{ public:
    
  char *text;
  int nobj;
  OBJECTP *objptr;
  KEYWORD *next, *back;
  
  private:
  
  void insert (char *word, OBJECT *t)
  { if (text==NULL) 
    { if (next) 
        next->insert(word, t); 
      else
        next = new KEYWORD(this, word, t);
    }
    else if (less(text, word)) 
    { if (next) 
        next->insert(word, t); 
      else
        next = new KEYWORD (this, word, t);      
    }
    else if (strcasecmp(text,word)==0)
    { OBJECTP *newptr;
      newptr = new OBJECTP[nobj+1];
      memcpy (newptr, objptr, sizeof(OBJECTP)*nobj);
      newptr[nobj] = t;
      nobj++;
      delete[] objptr;
      objptr = newptr;
    }
    else
    { KEYWORD *tmp;
      tmp = new KEYWORD(back, word, t);
      tmp->next = this;
      (tmp->back)->next = tmp;
      back = tmp;
    }
  }
 
  public:
  
  KEYWORD ()
  { text = NULL;
    nobj = 0;
    objptr = NULL;
    next = NULL;
    back = NULL;
  }
  
  KEYWORD (KEYWORD *last, char *newtext, OBJECT *t)
  { text = strdup(newtext);
    nobj = 1;
    objptr = new OBJECTP[nobj];
    objptr[0] = t;
    next = NULL;
    back = last;  
  }
  
  ~KEYWORD ()
  { if (next)   delete next;
    if (text)   delete[] text;
    if (objptr) delete[] objptr;
    
  }
  
  void add (char *newkeywords, OBJECT *t)
  { char *word, *tok, *nkws;
    if (newkeywords)
    { nkws = strdup(newkeywords);
      tok = strtok (nkws, ",\r\n");
      while (tok)
      { word = strdup(tok);
        trim (word);
        if (strlen(word)) insert (word, t);
        tok = strtok(NULL, ",\r\n");
      }
      delete[] nkws;
    }
  }
  
} keywordroot;

char *h2htext, *h2hdup;

#define GROUP       1
#define SUBGROUP    2
#define NAME        3
#define DESCRIPTION 4
#define SEE         5
#define NOTE        6
#define LINK        7
#define AUTHOR      8
#define USAGE       9
#define INPUT      10
#define OUTPUT     11
#define SOURCE     12
#define RESULT     13
#define VARIABLE   14
#define DEFINITION 15
#define REFERENCE  16
#define KEYWORDS   17

int ismacro (char *fn)
{ return (strcasecmp(&fn[strlen(fn)-4], ".xpl")==0); }

int ishelp2 (char *fn)
{ return (strcasecmp(&fn[strlen(fn)-4], ".hlp2")==0); }

void readhlp2file (char *basedir, char *fn)
{ FILE *f;
  int i, j, mode = 0, newmode, parammode = 0;
  char tmp[1024], *tok = NULL;
  OBJECT *obj = NULL, *t = NULL;
  TEXTXPL *actparam = NULL, *actexample = NULL;

  if (ismacro(fn)) return;

  if (basedir)
    sprintf (tmp, "%s%s%s%s%s", basedir, SEPCHAR, HLPDIR, SEPCHAR, fn);
  else if (m3 || ishelp2(fn))
    sprintf (tmp, "%s", fn);
  else
    sprintf (tmp, "%s%s%s", HLPDIR, SEPCHAR, fn);

  f = fopen (tmp, "r");

  if (f)
  { obj = new OBJECT(0);
    // check(obj);
    strcpy (tmp, fn);
    for (i=strlen(tmp)-1; i>-1; i--)
      if (tmp[i]=='.') break;
    if (i>0)
    { tmp[i] = 0;
      for (j=strlen(tmp); j>-1; j--)
        if ((tmp[j]=='\\') || (tmp[j]=='/')) break;
      obj->filename = strdup(tmp+(j+1));
    }
    h2htext[0] = 0;
    while (fgets(tmp, 1023, f))
    { //print ("    > %s", tmp);
      strcpy (h2hdup, tmp);
      tok = strtok (tmp, " \t\r\n");
      if (tok)
      { if (strcmp(tok, "&group;")==0)
        { tok = strtok(NULL, " \t\r\n");
          if (tok) obj->filegroup = strdup(name2number(tok));
          newmode = GROUP;
        }
        else if (strcmp(tok, "&subgrp;")==0)
        { tok = strtok(NULL, " \t\r\n");
          if (tok) obj->filesubgroup = strdup(tok);
          newmode = SUBGROUP;
        }
        else if (strcmp(tok, "&see;")==0)
        { newmode = SEE;
        }
        else if (strcmp(tok, "&cmd;")==0)
        { tok = strtok(NULL, " \t\r\n");
          if (tok) obj->name = strdup(tok);
          newmode = 0;
        }
        else if (strcmp(tok, "&desc;")==0)
        { newmode = DESCRIPTION;
        }
        else if (strcmp(tok, "&usage;")==0)
        { newmode = USAGE;
        }
        else if (strcmp(tok, "&xin;")==0)
        { newmode = 0;
          parammode = INPUT;
        }
        else if (strcmp(tok, "&nin;")==0)
        { newmode = 0;
          parammode = INPUT;
        }
        else if (strcmp(tok, "&xout;")==0)
        { newmode = 0;
          parammode = OUTPUT;
        }
        else if (strcmp(tok, "&nout;")==0)
        { newmode = 0;
          parammode = OUTPUT;
        }
        else if (strcmp(tok, "&exsource;")==0)
        { newmode = SOURCE;
          tok = strstr (h2hdup, "&exsource;");
          tok = &tok[10];
        }
        else if (strcmp(tok, "&exresult;")==0)
        { newmode = RESULT;
          tok = strstr (h2hdup, "&exresult;");
          tok = &tok[10];
        }
        else if (strcmp(tok, "&link;")==0)
        { tok = strtok(NULL, " \t\n\r");
          if (tok) obj->filelink = strdup(tok);
          newmode = LINK;
        }
        else if (strcmp(tok, "&note;")==0)
        { newmode = NOTE;
        }
        else if (strcmp(tok, "&author;")==0)
        { newmode = AUTHOR;
        }
        else if (strcmp(tok, "&refer;")==0)
        { newmode = REFERENCE;
        }
        else if (strcmp(tok, "&keywords;")==0)
        { newmode = KEYWORDS;
        }
        else if (strcmp(tok, "&var;")==0)
        { newmode = VARIABLE;
        }
        else if (strcmp(tok, "&def;")==0)
        { newmode = DEFINITION;
        }
        else if (mode) 
        { switch (mode)
          { case SOURCE:
            case RESULT:
              strcat(h2htext, h2hdup);
              tok = NULL;
              break;
            default:
//              if (mode==SEE) obj->nsee++;
              strcat (h2htext, tok);
              strcat (h2htext, " ");
          }
        }
      }
      
      if (newmode!=mode)
      { switch (mode)
        { case GROUP :
            obj->group = strdup(h2htext);
            break;
          case SUBGROUP:
            obj->subgroup = strdup(h2htext);
            break;
          case DESCRIPTION:
            obj->description = strdup(h2htext);
            break;
          case SEE:
            obj->see = strdup(h2htext);
//            obj->nsee = numberoflinks(h2htext);
            break;
          case NOTE:
            obj->note = strdup(h2htext);
            break;
          case LINK:
            obj->link = strdup(h2htext);
            break;
          case AUTHOR:
            obj->author = strdup(h2htext);
            break;
          case REFERENCE:
            obj->reference = strdup(h2htext);
            break;
          case KEYWORDS:
            obj->keywords = strdup(h2htext);
            break;
          case USAGE:
            obj->usage = strdup(h2htext);
            break;
          case SOURCE:
            if (obj->example) 
            { actexample->next = new TEXTXPL;
              // check (actexample->next);
              actexample = actexample->next;
            }
            else
            { obj->example = actexample = new TEXTXPL;
              // check (obj->example);
            }
            actexample->txt1 = strdup(h2htext);
            break;
          case RESULT:
            if (actexample==NULL)
              print (0, "    warning: example result without source\r\n");
            else
              actexample->txt2 = strdup(h2htext);
            break;
          case VARIABLE:
            switch (parammode)
            { case INPUT :
                if (obj->in) 
                { actparam = obj->in;
                  while (actparam->next) actparam = actparam->next;
                  actparam->next = new TEXTXPL;
                  // check (actparam->next); 
                  actparam = actparam->next;
                }
                else
                { obj->in = actparam = new TEXTXPL;
                  // check (obj->in);
                }
                actparam->txt1 = cutnewline(strdup(h2htext));
                break;
              case OUTPUT:
                if (obj->out) 
                { actparam = obj->out;
                  while (actparam->next) actparam = actparam->next;
                  actparam->next = new TEXTXPL;
                  // check (actparam->next);
                  actparam = actparam->next;
                }
                else
                { obj->out = actparam = new TEXTXPL;
                  // check (obj->out);
                }
                actparam->txt1 = cutnewline(strdup(h2htext));
                break;
              default:
                print (0, "    warning: variable without input/output\r\n");
            }
            break;
          case DEFINITION:
            if (actparam==NULL)
              print (0, "    warning: variable definiton without variable name\r\n");
            else
              actparam->txt2 = strdup(h2htext);
            break;
        }
        h2htext[0] = 0;
        mode = newmode;
      }
      
      if (mode)
      { switch (mode)
        { case SOURCE:
          case RESULT:
            if (tok) strcat (h2htext, tok);
            break;
          default:
            tok = strtok(NULL, " \t\n\r"); 
            while (tok)
            { //if (mode==SEE) obj->nsee++;
              strcat(h2htext, tok);
              strcat(h2htext, " ");
              tok = strtok(NULL, " \t\n\r");
            }
            strcat (h2htext, "\n");
        }
      }    
    }
    
    switch (mode)
    { case GROUP :
        obj->group = strdup(h2htext);
        break;
      case SUBGROUP:
        obj->subgroup = strdup(h2htext);
        break;
      case DESCRIPTION:
        obj->description = strdup(h2htext);
        break;
      case SEE:
        obj->see = strdup(h2htext);
//        obj->nsee = numberoflinks(h2htext);
        break;
      case NOTE:
        obj->note = strdup(h2htext);
        break;
      case LINK:
        obj->link = strdup(h2htext);
        break;
      case AUTHOR:
        obj->author = strdup(h2htext);
        break;
      case REFERENCE:
        obj->reference = strdup(h2htext);
        break;
      case KEYWORDS:
        obj->keywords = strdup(h2htext);
        break;
      case USAGE:
        obj->usage = strdup(h2htext);
        break;
      case SOURCE:
        if (obj->example)
        { actexample->next = new TEXTXPL;
          // check (actexample->next);
          actexample = actexample->next;
        }
        else
        { obj->example = actexample = new TEXTXPL;
          // check (obj->example);
        }
        actexample->txt1 = strdup(h2htext);
        break;
      case RESULT:
        if (actexample==NULL)
          print (0, "    warning: example result without source\r\n");
        else
          actexample->txt2 = strdup(h2htext);
        break;
      case VARIABLE:
        switch (parammode)
        { case INPUT :
            if (obj->in)
            { actparam = obj->in;
              while (actparam->next) actparam = actparam->next;
              actparam->next = new TEXTXPL;
              // check (actparam->next);
              actparam = actparam->next;
            }
            else
            { obj->in = actparam = new TEXTXPL;
              // check (obj->in);
            }
            actparam->txt1 = cutnewline(strdup(h2htext));
            break;
          case OUTPUT:
            if (obj->out)
            { actparam = obj->out;
              while (actparam->next) actparam = actparam->next;
              actparam->next = new TEXTXPL;
              // check (actparam->next);
              actparam = actparam->next;
            }
            else
            { obj->out = actparam = new TEXTXPL;
              // check (obj->out);
            }
            actparam->txt1 = cutnewline(strdup(h2htext));
            break;
          default:
            print (0, "    warning: variable without input/output\r\n");
        }
        break;
      case DEFINITION:
        if (actparam==NULL)
          print (0, "    warning: variable definiton without variable name\r\n");
        else
          actparam->txt2 = strdup(h2htext);
        break;
    }

    fclose(f);

    if (obj->see)
    { strcpy (h2htext, obj->see);
      obj->nsee = numberoflinks(h2htext);
    }
  
    // check obj

    obj->check();

    // find place

    if (root.next==NULL)
    { root.next = obj;
      obj->last  = &root;
    }
    else
    { t = root.next;
      while (t)
      { if (less(t->name, obj->name))
        { if (t->next)
            t = t->next;
          else
          { t->next = obj;
            obj->last = t;
            break;
          }
        }
        else
        { (t->last)->next = obj;
          obj->last = t->last;
          t->last = obj;
          obj->next = t;
          break;
        }
      }
    }
  }
}

void readhlp2(char *basedir)
{ char searchwhat[512], *filename;

  if (ismacro(basedir)) return; 

  if (!ishelp2(basedir))
  { if (basedir)
      sprintf (searchwhat, "%s%s%s", basedir, SEPCHAR, HLPDIR);
    else if (m3)
      sprintf (searchwhat, ".");
    else
      sprintf (searchwhat, "%s", HLPDIR);

    print (2, "\r\nLooking for %s%s%s\r\n", searchwhat, SEPCHAR, HLPFILTER);
    filename = x4findfirst (searchwhat, HLPFILTER);

    while (filename)
    { print (1, "  %s\r\n", filename);
      readhlp2file (basedir, filename);
      filename = x4findnext();
    }
    print (2, "\r\n");
  }
  else
    readhlp2file (NULL, basedir);
}

void readxplfile (char *basedir, char *fn)
{ FILE *f;
  int i, j, mode = 0, newmode, parammode = 0;
  char tmp[1024], *tok = NULL, *cpdup = NULL;
  OBJECT *obj = NULL, *t = NULL;
  TEXTXPL *actparam = NULL, *actexample = NULL;

  if (ishelp2(fn)) return;

  if (basedir)
    sprintf (tmp, "%s%s%s%s%s",  basedir, SEPCHAR, LIBDIR, SEPCHAR, fn);
  else if (m3 || ismacro(fn))
    sprintf (tmp, "%s", fn);
  else
    sprintf (tmp, "%s%s%s", LIBDIR, SEPCHAR, fn);

  f = fopen (tmp, "r");
  if (f)
  { obj = new OBJECT(1);
    // check (obj);
    strcpy (tmp, fn);
    for (i=strlen(tmp)-1; i>-1; i--)
      if (tmp[i]=='.') break;
    if (i>0)
    { tmp[i] = 0;
      for (j=strlen(tmp); j>-1; j--)
        if ((tmp[j]=='\\') || (tmp[j]=='/')) break;
      obj->filename = strdup(tmp+(j+1));
    }
    h2htext[0] = 0;
    while (fgets(tmp, 1023, f))
    { // print ("    > %s", tmp);
      strcpy (h2hdup, tmp);
      tok = strtok (tmp, " \t\n\r");
      // need at least ; at the begining
      if (tok && (strcmp(tok, ";")==0))
      { cpdup = strstr (h2hdup, ";");
        cpdup = &cpdup[1];
        tok = strtok (NULL, " \t\n\r");
        if (tok)
        { if (strcmp(tok, "Library")==0)
          { tok = strtok(NULL, " \t\n\r");
            if (tok) 
            { obj->filegroup = strdup(name2number(tok));
              obj->group     = strdup(tok);
            }
            newmode = GROUP;
          }
          else if (strcmp(tok, "Sublibrary")==0)
          { tok = strtok(NULL, " \t\n\r");
            if (tok) obj->filesubgroup = strdup(tok);
            newmode = SUBGROUP;
          }
          else if (strcmp(tok, "See_also")==0)
          { newmode = SEE;
          }
          else if (strcmp(tok, "Macro")==0)
          { tok = strtok(NULL, " \t\n\r");
            if (tok) obj->name = strdup(tok);
            newmode = 0;
          }
          else if (strcmp(tok, "Description")==0)
          { newmode = DESCRIPTION;
          }
          else if (strcmp(tok, "Usage")==0)
          { newmode = USAGE;
          }
          else if (strcmp(tok, "Input")==0)
          { newmode = 0;
            parammode = INPUT;
          }
          else if (strcmp(tok, "Output")==0)
          { newmode = 0;
            parammode = OUTPUT;
          }
          else if (strcmp(tok, "Example")==0)
          { newmode = SOURCE;
            tok = strstr (cpdup, "Example");
            tok = &tok[7];
          }
          else if (strcmp(tok, "Result")==0)
          { newmode = RESULT;
            tok = strstr (cpdup, "Result");
            tok = &tok[6];
          }
          else if (strcmp(tok, "Link")==0)
          { tok = strtok(NULL, " \t\n\r");
            if (tok) obj->filelink = strdup(tok);
            newmode = LINK;
          }
          else if (strcmp(tok, "Notes")==0)
          { newmode = NOTE;
          }
          else if (strcmp(tok, "Author")==0)
          { newmode = AUTHOR;
          }
          else if (strcmp(tok, "Reference")==0)
          { newmode = REFERENCE;
          }
          else if (strcmp(tok, "Keywords")==0)
          { newmode = KEYWORDS;
          }
          else if (strcmp(tok, "Parameter")==0)
          { newmode = VARIABLE;
          }
          else if (strcmp(tok, "Definition")==0)
          { newmode = DEFINITION;
          }
          else if (strncmp(tok, "---", 3)==0)
          { newmode = 0;
          }
          else if (mode) 
          { switch (mode)
            { case SOURCE:
              case RESULT:
                strcat(h2htext, cpdup);
                tok = NULL;
                break;
              default:
                //if (mode==SEE) obj->nsee++;
                strcat (h2htext, tok);
                strcat (h2htext, " ");
            }
          }

          if (newmode!=mode)
          { switch (mode)
            { case GROUP :
                // obj->group = strdup(obj->filegroup);
                break;
              case SUBGROUP:
                obj->subgroup = strdup(h2htext);
                break;
              case DESCRIPTION:
                obj->description = strdup(h2htext);
                break;
              case SEE:
                obj->see = strdup(h2htext);
             //   obj->nsee = numberoflinks (h2htext);
                break;
              case NOTE:
                obj->note = strdup(h2htext);
                break;
              case LINK:
                obj->link = strdup(h2htext);
                break;
              case AUTHOR:
                obj->author = strdup(h2htext);
                break;
              case REFERENCE:
                obj->reference = strdup(h2htext);
                break;
              case KEYWORDS:
                obj->keywords = strdup(h2htext);
                break;
              case USAGE:
                obj->usage = strdup(h2htext);
                break;
              case SOURCE:
                if (obj->example) 
                { actexample->next = new TEXTXPL;
                  // check (actexample->next);
                  actexample = actexample->next;
                }
                else
                { obj->example = actexample = new TEXTXPL;
                  // check (obj->example);
                }
                actexample->txt1 = strdup(h2htext);
                break;
              case RESULT:
                if (actexample==NULL)
                  print (0, "    warning: example result without source\r\n");
                else
                  actexample->txt2 = strdup(h2htext);
                break;
              case VARIABLE:
                switch (parammode)
                { case INPUT :
                    if (obj->in) 
                    { actparam = obj->in;
                      while (actparam->next) actparam = actparam->next;
                      actparam->next = new TEXTXPL;
                      // check (actparam->next); 
                      actparam = actparam->next;
                    }
                    else
                    { obj->in = actparam = new TEXTXPL;
                      // check (obj->in);
                    }
                    actparam->txt1 = cutnewline(strdup(h2htext));
                    break;
                  case OUTPUT:
                    if (obj->out) 
                    { actparam = obj->out;
                      while (actparam->next) actparam = actparam->next;
                      actparam->next = new TEXTXPL;
                      // check (actparam->next); 
                      actparam = actparam->next;
                    }
                    else
                    { obj->out = actparam = new TEXTXPL;
                      // check (obj->out);
                    }
                    actparam->txt1 = cutnewline(strdup(h2htext));
                    break;
                  default:
                    print (0, "    warning: variable without input/output\r\n");
                }
                break;
              case DEFINITION:
                if (actparam==NULL)
                  print (0, "    warning: variable definiton without variable name\r\n");
                else
                  actparam->txt2 = strdup(h2htext);
                break;
            }
            h2htext[0] = 0;
            mode = newmode;
          } 
        }
        if (mode)
        { switch (mode)
          { case SOURCE:
            case RESULT:
              if (tok) strcat (h2htext, tok);
              break;
            default:
              tok = strtok(NULL, " \t\n\r"); 
              while (tok)
              { //if (mode==SEE) obj->nsee++;
                strcat(h2htext, tok);
                strcat(h2htext, " ");
                tok = strtok(NULL, " \t\n\r");
              } 
              strcat (h2htext, "\n");
          }
        }
      }
    }
    
    switch (mode)
    { case GROUP :
        // obj->group = strdup(obj->filegroup);
        break;
      case SUBGROUP:
        obj->subgroup = strdup(h2htext);
        break;
      case DESCRIPTION:
        obj->description = strdup(h2htext);
        break;
      case SEE:
        obj->see = strdup(h2htext);
      //  obj->nsee = numberoflinks(h2htext);
        break;
      case NOTE:
        obj->note = strdup(h2htext);
        break;
      case LINK:
        obj->link = strdup(h2htext);
        break;
      case AUTHOR:
        obj->author = strdup(h2htext);
        break;
      case REFERENCE:
        obj->reference = strdup(h2htext);
        break;
      case KEYWORDS:
        obj->keywords = strdup(h2htext);
        break;
      case USAGE:
        obj->usage = strdup(h2htext);
        break;
      case SOURCE:
        if (obj->example) 
        { actexample->next = new TEXTXPL;
          // check (actexample->next);
          actexample = actexample->next;
        }
        else
        { obj->example = actexample = new TEXTXPL;
          // check (obj->example);
        }
        actexample->txt1 = strdup(h2htext);
        break;
      case RESULT:
        if (actexample==NULL)
          print (0, "    warning: example result without source\r\n");
        else
          actexample->txt2 = strdup(h2htext);
        break;
      case VARIABLE:
        switch (parammode)
        { case INPUT :
            if (obj->in) 
            { actparam = obj->in;
              while (actparam->next) actparam = actparam->next;
              actparam->next = new TEXTXPL;
              // check (actparam->next); 
              actparam = actparam->next;
            }
            else
            { obj->in = actparam = new TEXTXPL;
              // check (obj->in);
            }
            actparam->txt1 = cutnewline(strdup(h2htext));
            break;
          case OUTPUT:
            if (obj->out) 
            { actparam = obj->out;
              while (actparam->next) actparam = actparam->next;
              actparam->next = new TEXTXPL;
              // check (actparam->next); 
              actparam = actparam->next;
            }
            else
            { obj->out = actparam = new TEXTXPL;
              // check (obj->out);
            }
            actparam->txt1 = cutnewline(strdup(h2htext));
            break;
          default:
            print (0, "    warning: variable without input/output\r\n");
        }
        break;
      case DEFINITION:
        if (actparam==NULL)
          print (0, "    warning: variable definiton without variable name\r\n");
        else
          actparam->txt2 = strdup(h2htext);
        break;
    }

    fclose(f);

    if (obj->see)
    { strcpy (h2htext, obj->see);
      obj->nsee = numberoflinks(h2htext);
    }
    // check obj

    obj->check();

    // find place

    if (root.next==NULL)
    { root.next = obj;
      obj->last  = &root;
    }
    else
    { t = root.next;
      while (t)
      { if (less(t->name, obj->name))
        { if (t->next)
            t = t->next;
          else
          { t->next = obj;
            obj->last = t;
            break;
          }
        }
        else
        { (t->last)->next = obj;
          obj->last = t->last;
          t->last = obj;
          obj->next = t;
          break;
        }
      }
    }
  }
}

void readxpl(char *basedir)
{ char searchwhat[512], *filename;

  if (!ismacro(basedir))
  { if (basedir)
      sprintf (searchwhat, "%s%s%s", basedir, SEPCHAR, LIBDIR);
    else if (m3)
      sprintf (searchwhat, ".");
    else
      sprintf (searchwhat, "%s", LIBDIR);

    print (2, "\r\nLooking for %s%s%s\r\n", searchwhat, SEPCHAR, LIBFILTER);
    filename = x4findfirst (searchwhat, LIBFILTER);

    while (filename)
    { print (1, "  %s\r\n", filename);
      readxplfile (basedir, filename);
      filename = x4findnext();
    }
    print (2, "\r\n");
  }
  else
    readxplfile (NULL, basedir);
}

void deletenewline (char *txt)
{ int i, j;
  if (txt)
  { strcpy (h2hdup, txt);
    for (j=i=0; i<strlen(h2hdup); i++)
    { if ((h2hdup[i]!='\n') && (h2hdup[i]!='\n'))
      { txt[j] = h2hdup[i];
        j++;
      }
    }
    txt[j] = 0;
  }
}

char *exampblanks1(char *old1)
{ int i, j, k, l, m, nlnec, ab, nb;
  char *old2=new char[10000];
  char *c=new char[10000] ;
  char s1[]="proc";
  char s2[]="if";
  char s3[]="else";
  char s4[]="while";
  char s5[]="do";
  char s7[]="case";
  char s6[]="switch";
  char s8[]="default";
  char c1[]="endp";
  char c2[]="endif";
  char c3[]="endo";
  char c4[]="until";
  char c5[]="endsw";
  char leer[]=" ";


  {for(i=0,j=0; i<strlen(old1) && j<10000; i++,j++)
    { while((old1[i]==' ') || (old1[i]=='\t')) i++;
      while((old1[i]!='\n') && (old1[i]!=0))
       {old2[j]=old1[i];
        i++;
        j++;
       }
      old2[j]=old1[i];
    }
  old2[j]=0;

  for(i=0,j=0,nb=0,ab=0;i<strlen(old2) && j<10000; i++, j++)
  { nlnec = 0;
    if (strncmp(&old2[i], s1, 4)==0)
     { if(isalnum(old2[i+4])==0) nb += 2;
     }
    if (strncmp(&old2[i], c1, 4)==0 )
     { nlnec = !isalnum(old2[i+4]);
       if(nlnec)
        { ab -= 2;
          nb -= 2;
        }
     }
    if (strncmp(&old2[i], s2, 2)==0)
     { nb += 2;
     }
    if (strncmp(&old2[i], s3, 4)==0)
     { ab -= 2;
     }
    if (strncmp(&old2[i], c2, 5)==0)
     { ab -= 2;
       nb -= 2;
     }
    if (strncmp(&old2[i], s4, 5)==0)
     { nb += 2;
     }
    if (strncmp(&old2[i], c3, 4)==0)
     { ab -= 2;
       nb -= 2;
     }
    if (strncmp(&old2[i], s5, 2)==0)
     { nb += 2;
     }
    if (strncmp(&old2[i], c4, 5)==0)
     { ab -= 2;
       nb -= 2;
     }
    if (strncmp(&old2[i], s6, 6)==0)
     { nb += 2;
     }
    if (strncmp(&old2[i], s7, 4)==0)
     { ab -= 2;
     }
    if (strncmp(&old2[i], s8, 7)==0)
     { ab -= 2;
     }
    if (strncmp(&old2[i], c5, 5)==0)
     { ab -= 2;
       nb -= 2;
     }

    if (strncmp(&old2[i], ";", 1)==0)   ab = 0;    // SK 12.11.98
    if (strncmp(&old2[i], "//", 2)==0) ab = 0;    // SK 12.11.98

    for (k=0; k<ab; k++, j++)
      { c[j] = ' ';
      }

    for (l=i,m=j;(l<strlen(old2)) && (m<10000) && (old2[l]!='\n') ; l++, m++)
     { c[m] = old2[l];

     }
    c[m]=old2[l];
    i=l;
    j=m;


    if(nlnec)
     {
#ifdef __BORLANDC__
       j++;
       c[j]='\r';
#endif
       j++;
       c[j]='\n';
     }

    ab = nb;

  }
 c[j]=0;
 delete[] old1;
 delete[] old2;
 old2 = strdup(c);
 delete[] c;
 return (old2);
 }
}


char *exampblanks2(char *old)
{ int i, j;
  char *c=new char[10000], *old2;
  { for(i=0,j=0; i<strlen(old) && j<10000; i++,j++)
    { while((old[i]==' ') || (old[i]=='\t')) i++;
      while((old[i]!='\n') && (old[i]!=0))
       {c[j]=old[i];
        i++;
        j++;
       }
      c[j]=old[i];
    }
  c[j]=0;
  delete[] old;
  old2=strdup(c);
  delete[] c;
  return (old2);
  }
}

void linkall()
{ OBJECT *t, *s;
  TEXTXPL *ex;
  int i, k;
  char *tok;

  print (2, "\r\nChecking link(s)\r\n");
  t = root.next;
  while (t)
  { print (1, "  %s\r\n", t->name);
    t->ingroup = 0;
    deletenewline (t->name);
    deletenewline (t->filename);
    deletenewline (t->group);
    deletenewline (t->filegroup);
    deletenewline (t->subgroup);
    deletenewline (t->filesubgroup);

    if (t->see && t->nsee)
    { t->seeobj = (void *) new OBJECTP[t->nsee];
      t->seetok = (charp *) new charp[t->nsee];
      // check (t->seeobj);
      for (i=0; i<t->nsee; i++)
      { ((OBJECTP *) t->seeobj)[i] = NULL;
        t->seetok[i] = NULL;
      }
      i = 0;
      tok = strtok (t->see, " ,\t\n\r");
      while (tok)
      { t->seetok[i] = strdup(tok);
        s = root.next;
        while (s)
	     { if (strcmp(s->name,t->seetok[i])==0) break;
          s = s->next;
        }
        ((OBJECTP*)(t->seeobj))[i] = s;
        if (s==NULL) print (0, "    warning: link %s not found\r\n", t->seetok[i]);
        i++;
        tok = strtok (NULL, " ,\t\n\r");
      }
      delete[] t->see;
      t->see  = NULL;
    }

    ex = t->example;
    while (ex)
    { if (ex->txt1) ex->txt1 = exampblanks1(ex->txt1);
//        delete[] tok;
      if (ex->txt2) ex->txt2 = exampblanks2(ex->txt2);
     ex = ex->next;
    }

    keywordroot.add (t->keywords, t);

    t = t->next;
  }
}

void htmlstart (FILE *f, char *title)
{ fprintf (f, "<HTML><HEAD>\n");
  fprintf (f, "<META NAME=\"Author\" CONTENT=\"Sigbert Klinke\">\n");
  fprintf (f, "<META NAME=\"GENERATOR\" CONTENT=\"HLP2HTML v 2.1\">\n");
  if (title) fprintf (f, "<TITLE>XploRe Help : %s</TITLE>\n", title);
  fprintf (f, "</HEAD><BODY TEXT=\"#000000\" BGCOLOR=\"#FFFFFF\">\n");
}

void htmlgroup (FILE *f, OBJECT *t)
{ OBJECT *s;
  int i;
  char buffer[128], *ln;

  fprintf (f, "<TABLE>\n<TR>\n<TD><I><FONT COLOR=\"#00BB00\" SIZE=+1><B>");
  if (t->type)
    fprintf (f, "Library");
  else
    fprintf (f, "Group");
  fprintf (f, ": </B></FONT></I></TD>\n<TD><BIG><B>");
  if (t->filegroup && t->group)
    fprintf (f, "<A HREF=\"%s.html\">%s</A>", t->filegroup, t->group);
  fprintf (f, "</B></BIG></TD></TR>\n");
  if (t->filesubgroup && t->subgroup)
  { fprintf (f, "<TR>\n<TD><I><FONT COLOR=\"#00BB00\" SIZE=+1><B>");
    fprintf (f, "Topic:</B></FONT></I></TD>\n<TD><BIG><B><A HREF=\"");
    fprintf (f, "%s.html#%s\">%s", t->filegroup, t->filesubgroup, t->subgroup);
    fprintf (f, "</A></B></BIG></TD></TR>\n");
  }
  if (t->nsee)
  { fprintf (f, "<TR><TD><I><FONT COLOR=\"#00BB00\" SIZE=+1><B>See also: </B></FONT></I></TD><TD>");
    for (i=0; i<t->nsee; i++)
    { s = ((OBJECTP*) (t->seeobj))[i];
      if (s)
        fprintf (f, "<A HREF=\"%s.html\">%s</A>\n ", s->filename, s->name);
      else if ((t->seetok[i]) && m3==0)
      { sprintf (buffer, "%s.html", t->seetok[i]);
        ln = openfile(HELP, buffer, "r");
        if (ln) fprintf (f, "<A HREF=\"%s\">%s</A>\n ", ln,  t->seetok[i]);
      }
    }
    fprintf (f, "</TR>\n");
  }
  fprintf (f, "</TABLE><HR>\n\n");
  fflush(f);
}

void htmldescription (FILE *f, OBJECT *t)
{ fprintf (f, "<TABLE>\n<TR>\n<TD><I><FONT COLOR=\"#00BB00\" SIZE=+1><B>\n");
  if (t->type)
    fprintf (f, "Quantlet");
  else
    fprintf (f, "Function");
  fprintf (f, ":</B></FONT></I></TD>\n<TD></TD>\n<TD><FONT SIZE=+3>");
  if (t->name)
    fprintf (f, "<B>%s</B>", t->name);
  fprintf (f, "</FONT></TD></TR>\n");
  if (t->description)
  { fprintf (f, "<TR VALIGN=baseline>\n<TD><I><FONT COLOR=\"#00BB00\" SIZE=+1><B>");
    fprintf (f, "Description:</B></FONT></I></TD>\n<TD></TD>\n<TD><FONT SIZE=+1>\n");
    correcttext1( f, t->description); //fprintf (f, t->description);
    fprintf (f, "</FONT></TD>\n</TR></TABLE><HR>\n\n");
  }
  fflush(f);
}

void htmlusage (FILE *f, OBJECT *t)
{ TEXTXPL *p;
  char *ptr;
  fprintf (f, "<TABLE><TR VALIGN=baseline><TD><I><FONT COLOR=\"#00BB00\" SIZE=+1>");
  if (t->usage)
  { fprintf (f, "<B>Usage:</B></FONT></I></TD>\n");
    fprintf (f, "<TD COLSPAN=2><FONT SIZE=5><B><TT>%s</TT></B></FONT></TD></TR>", t->usage);
  }
  p = t->in;
  if (p)
    fprintf (f, "<TR><TD><I><FONT COLOR=\"#00BB00\" SIZE=+1><B>Input:</B></FONT></I></TD></TR>");
  while (p)
  { fprintf (f, "<TR VALIGN=baseline><TD></TD><TD><FONT SIZE=5><B><TT>%s ", p->txt1);
    if (p->txt2)
    { ptr=replace1(p->txt2);
      fprintf (f, "</TT></B></FONT></TD><TD>%s </TD></TR>\n", ptr);
      delete[] ptr;
    }
   else
      fprintf (f, "</TT></B></FONT></TD><TD></TD></TR>\n");
    p = p->next;
  }
  p = t->out;
  if (p)
    fprintf (f, "<TR><TD><I><FONT COLOR=\"#00BB00\" SIZE=+1><B>Output:</B></FONT></I></TD></TR>\n");
  while (p)
  { fprintf (f, "<TR VALIGN=baseline><TD></TD><TD><FONT SIZE=5><B><TT>%s ", p->txt1);
    if (p->txt2)
    { ptr=replace1(p->txt2);
      fprintf (f, "</TT></B></FONT></TD><TD>%s </TD></TR>\n", ptr);
      delete[] ptr;
    }
    else
      fprintf (f, "</TT></B></FONT></TD><TD></TD></TR>\n");
    p = p->next;
  }
  fprintf (f, "</TABLE><HR>\n\n");
}

void htmlsource (FILE *f, OBJECT *t)
{ if (t->type)
  { fprintf (f, "<I><FONT COLOR=\"#00BB00\" SIZE=+1><B>Source code:</B></FONT></I>\n");
    fprintf (f, "<A HREF=\"../lib/%s.xpl\">%s.xpl</A><HR>\n", t->filename, t->filename);
  }
}

void htmlletter (FILE *f, int j = 100)
{ int i;

  fprintf (f, "<CENTER><B>");
  if (j!=-2)
    fprintf (f, "<A HREF=\"02.html\">Keywords</A> - \n");
  else
    fprintf (f, "<FONT COLOR=\"#00BB00\">Keywords </FONT>- \n");
  if (j!=-1)
    fprintf (f, "<A HREF=\"01.html\">Function groups</A> - \n");
  else
    fprintf (f, "<FONT COLOR=\"#00BB00\">Function groups </FONT>- \n");
  if (j==0)
    fprintf (f, "<FONT COLOR=\"#00BB00\">@ </FONT>\n");
  else
    fprintf (f, "<A HREF=\"00.html\">@</A> \n");
  for (i=1; i<27; i++)
  { sprintf (h2hdup, "%c%c", 64+i, 0);
    if (j==i)
      fprintf (f, "<FONT COLOR=\"#00BB00\">%c</FONT> \n", 64+i);
    else
      fprintf (f, "<A HREF=\"%s.html\">%c</A> \n", name2number(h2hdup), 64+i);
  }
  fprintf (f, "</B></CENTER><HR>\n");
}


void htmlend (FILE *f)
{ int day, month, year;
  x4date (&day, &month, &year);
  fprintf (f, "<FONT SIZE=-2>(C) MD*TECH Method and Data Technologies, %i.%i.%i</FONT></BODY></HTML>\n",
    day, month, year);
  fflush(f);
}

int ccmp (char c, int i)
{ if (i==0) return (!isalpha(c));
  return (64+i==toupper(c));
}

void htmlindex (FILE *f, OBJECT *t, int i, int diff)
{ OBJECT *s, *l;
  int j, found;

  s = t;
  j = found = 0;
  while (s)
  { if (ccmp(s->name[0],i))
    { if ((j%diff)==0)
      { if (j) fprintf (f, " - ");
        fprintf (f, "<A HREF=\"#%s\"><TT>%s</TT></A>", s->filename, s->name);
      }
      j++;
      l = s;
      found = 1;
    }
    s = s->next;
  }
  if (found==0) return;

  if ((j%diff)!=1)
  { fprintf (f, " - ");
    fprintf (f, "<A HREF=\"#%s\"><TT>%s</TT></A>", l->filename, l->name);
  }
  fprintf (f, "<HR>\n");

  s = t;
  fprintf (f, "<TABLE BORDER=0 CELLSPACING=5 CELLPADDING=0>\n");
  while (s) 
  { if (ccmp(s->name[0], i)) 
    { fprintf (f, "<TR><TD VALIGN=top><A NAME=\"%s\"></A>\n", s->filename);
      fprintf (f, "<A HREF=\"%s.html\"><TT>", s->filename);
      if (s->type)
        fprintf (f, "<FONT COLOR=\"%s\"><TT>%s</TT></FONT></TD><TD VALIGN=top>\n", LINKXPL, s->name);
      else
        fprintf (f, "<FONT COLOR=\"%s\"><TT>%s</TT></FONT></TD><TD VALIGN=top>\n", LINKHLP2, s->name);
      if (s->description) 
      { correcttext1 (f, s->description);
        fprintf (f, "\n");
      }
      else
        fprintf (f, "\n");
      fprintf (f, "</TD></TR>\n");
    }
    s = s->next;
  }
  fprintf (f, "</TABLE><HR>\n");
}

void htmlgroupindex (FILE *f, OBJECT *t)
{ OBJECT *s, *r;
  int elemfound = 0;

  // subgroup NULL
  s = t;

  if (t->type)
    fprintf (f, "<H1> Library: %s</H1>\n", t->group);
  else
    fprintf (f, "<H1> %s </H1>\n", t->group);

  while (s)
  { if (s->ingroup==0)
    { if (s->group && (strcmp(t->group, s->group)==0))
      { if (s->subgroup==NULL)
        { if (elemfound==0)
          { fprintf (f, "<TABLE>\n");
            elemfound++;
          }
          fprintf (f, "<TR><TD VALIGN=top><A HREF=\"%s.html\"><TT>%s</TT></A></TD><TD VALIGN=top>\n", s->filename, s->name);
          if (s->description) 
            correcttext1 (f, s->description);
          fprintf (f, "</TD></TR>\n");
          s->ingroup = 1;
        }
      }
    }
    s = s->next;
  }
  if (elemfound==1) fprintf (f, "</TABLE>\n");

  r = t;
  while (r)
  { if (r->ingroup==0)
    { if (r->group && (strcmp (r->group, t->group)==0))
      { s = r;
        elemfound = 0;
        while (s)
        { if (s->ingroup==0)
          { if (s->group && (strcmp (r->group, s->group)==0) && (strcmp (r->subgroup, s->subgroup)==0) && strlen(r->subgroup) )
            { if (elemfound==0)
              { fprintf (f, "<H2><A NAME=\"%s\">%s</A></H2>\n", r->filesubgroup, r->subgroup);
                fprintf (f, "<TABLE>\n");
                elemfound++;
              }
              fprintf (f, "<TR><TD VALIGN=top><A HREF=\"%s.html\"><TT>%s</TT></A></TD><TD VALIGN=top>\n", s->filename, s->name);
              correcttext1 (f, s->description);
              fprintf (f, "</TD></TR>\n");
              s->ingroup = 1;
            }
          }
          s = s->next;
        }
        if (elemfound==1) fprintf (f, "</TABLE>\n");
      }
    }
    r = r->next;
  }
  fprintf (f, "<HR>\n");

  t->ingroup = 2;
}

void htmlcontent (FILE *f)
{ OBJECT *t;
  OBJECT *s;
  int k;

  htmlletter (f, -1);

  t = root.next;
  if (t==NULL) return;
  s = NULL;
  k = 1;
  while (k)
  { if (t->ingroup==2)
    { if (s)
      { if (less(t->group, s->group)) s = t; }
      else
        s = t;
    }

    t = t->next;
    if (t==NULL)
    { if (s)
      { fprintf (f, "<A HREF=\"%s.html\">\n", s->filegroup);
        if (s->type)
          fprintf (f, "<FONT COLOR=\"%s\">%s</FONT>", LINKXPL, s->group);
        else
          fprintf (f, "<FONT COLOR=\"%s\">%s</FONT>", LINKHLP2, s->group);
        fprintf (f, "</A><BR>\n");
        s->ingroup = 1;
      }
      else
        k = 0;

      t = root.next;
      s = NULL;
    }

  }
  fprintf (f, "<HR>");

  htmlletter(f, -1);
  htmlend(f);
}

void htmlkeyword (FILE *f)
{ OBJECT *t;
  KEYWORD *s;
  int k;

  htmlletter (f, -2);

  s = keywordroot.next;
  
  fprintf (f, "<UL>\n");
  
  while (s)
  { fprintf (f, "<LI><B>%s</B><BR><UL>\n", s->text);
    
    for (k=0; k<s->nobj; k++)
    { t = s->objptr[k];
      if (t && t->name)
      { if (t->filename)
          fprintf (f, "<A HREF=\"%s.html\">%s</A>", t->filename, t->name);
        else
          fprintf (f, "%s", t->name);
        if (k<(s->nobj-1))
          fprintf (f, ", \n");
        else
          fprintf (f, "<br>\n");
      }
    }
    
    fprintf (f, "</UL>\n");
    s = s->next;
  }

  fprintf (f, "</UL>\n");
  fprintf (f, "<HR>");

  htmlletter(f, -2);
  htmlend(f);
}

void htmlreferences (FILE *f, OBJECT *t)
{ if (t->reference)
  { fprintf (f, "<I><FONT COLOR=\"#00BB00\" SIZE=+1><B>Reference(s):</B></FONT></I><BR><UL>\n");
  correcttext1 (f, t->reference); // 12.02.99
    //    fprintf (f, "%s", t->reference);
    fprintf (f, "</UL><HR>\n");
  }
}

void htmlnote (FILE *f, OBJECT *t)
{ if (t->note)
  { fprintf (f, "<I><FONT COLOR=\"#00BB00\" SIZE=+1><B>Note:</B></FONT></I><BR><UL>\n");
    correcttext1 (f, t->note);
    fprintf (f, "</UL><HR>\n");
  }
}

void htmlauthor (FILE *f, OBJECT *t)
{ if (t->author)
  { fprintf (f, "<I><FONT COLOR=\"#00BB00\" SIZE=+1><B>Author:</B></FONT></I>\n");
    fprintf (f, "%s", t->author);
    fprintf (f, "<HR>\n");
  }
}

void htmllink (FILE *f, OBJECT *t)
{ if (t->filelink)
  { fprintf (f, "<I><FONT COLOR=\"#00BB00\" SIZE=+1><B>Link: </B></FONT></I>\n");
    fprintf (f, "<UL><A HREF=\"%s\" target=\"_top\">%s</A></UL><HR>\n", t->filelink, t->link);
  }
}

int linkname (FILE *f, char *s, int i, int l)
{ int j, k;
  OBJECT *u;
  char *si = &s[i], t[256];
  
  for (j=i; j<l; j++)
  { if ((s[j]==' ') || (s[j]=='\t') || (s[j]=='\n') || !isalnum(s[j])) break;}
            
  if (j>i)
  { u = root.next;
    while (u)
    { if ((strncmp(si, u->name, j-i)==0) && (strlen(u->name)==j-i))
      { if (u->type)
          fprintf (f, "<A HREF=\"%s.html\"><FONT COLOR=\"%s\">%s</FONT></A>", u->name, LINKXPL, u->name);
        else
          fprintf (f, "<A HREF=\"%s.html\"><FONT COLOR=\"%s\">%s</FONT></A>", u->name, LINKHLP2, u->name);
        return (strlen(u->name)-1);
      }
      u = u->next;
    }
  
    for (k=i; k<j; k++)
      t[k-i] = s[k];
    t[j-i] = 0;
    fprintf (f, "%s", t);
    return (strlen(t)-1);
  }
  else if (s[i]==';')
  { for (j=i+1; j<l; j++)
      if (s[j]=='\n') break;
    for (k=i; k<j; k++)
      t[k-i] = s[k];
    t[j-i] = 0;
    fprintf (f, "%s", t);
    return (strlen(t)-1);
  }
  else if (s[i]=='\"')
  { for (j=i+1; j<l; j++)
    { if (s[j]=='\"') 
      { j++; 
        break;
      }
    }
    for (k=i; k<j; k++)
      t[k-i] = s[k];
    t[j-i] = 0;
    fprintf (f, "%s", t);
    return (strlen(t)-1); 
  }
  fprintf (f, "%c", s[i]);
  return 0;
}
    

void htmlexample (FILE *f, OBJECT *t)
{ TEXTXPL *ex;
  int nob = 0, i, j, k, l, mode, lob;
  char *s, *si, *ptr1, *ptr2;
  OBJECT *u;

  if (t->example)
  { ex = t->example;
    fprintf (f, "<DL>\n");
    while (ex)
    { // if (ex->txt1 && ex->txt2)
      { fprintf (f, "<DT><I><FONT COLOR=\"#00BB00\" SIZE=+1><B>Example:</B></FONT></I></DT>\n");
        fprintf (f, "<DD><B><PRE>\n");
//        fprintf (f, "%s", ex->txt1);
        s = ex->txt1;
        if (s)
        { l = strlen(s);
          for (mode=i=0; i<l; i++)
          { if (s[i]=='\n')
            { mode = 0;
              fprintf (f, "%c", s[i]);
            }
            else 
            { if ((s[i]==' ') || (s[i]=='\t'))
              { if (mode) fprintf (f, "%c", s[i]);
              }
              else 
              { if (mode)
                { i += linkname (f, s, i, l);
                }
                else
                { mode = 1;
                  si = &s[i];
              
                  if (strstr(si, "endp")==si) nob -= 2;
                  if (strstr(si, "endif")==si) nob -= 2;
                  if (strstr(si, "endo")==si) nob -= 2;
                  if (strstr(si, "until")==si) nob -= 2;
                  if (strstr(si, "endsw")==si) nob -= 2;
              
                  lob = (strstr(si, "else")==si ? -2 : 0);
                  for (j=0; j<nob+lob; j++)
                    fprintf (f, " ");
               
                  if (strstr(si, "proc")==si) nob += 2;
                  if (strstr(si, "if")==si) nob += 2;
                  if (strstr(si, "do")==si) nob += 2;
                  if (strstr(si, "while")==si) nob += 2;
                  if (strstr(si, "switch")==si) nob += 2;              
           
                  i += linkname (f, s, i, l);
                }
              }
            }
          }
        }

        fprintf (f, "</PRE></B></DD>\n");
        fprintf (f, "<DT><I><FONT COLOR=\"#00BB00\" SIZE=+1><B>Result:</B></FONT></I></DT>\n");
        fprintf (f, "<DD><PRE>\n");
        s = ex->txt2;
        if (s)
        { ptr1=replace2(s,"&nl;","<BR>");
          ptr2=replace2(ptr1,"&rem;","<BR>");
          delete[] ptr1;
          l = strlen(ptr2);
          for (mode=i=0; i<l; i++)
          { if (ptr2[i]=='\n')
            { mode = 0;
              fprintf (f, "%c", ptr2[i]);
            }
            else 
            { if ((ptr2[i]==' ') || (ptr2[i]=='\t'))
              { if (mode) fprintf (f, "%c", ptr2[i]); }
              else 
              { mode = 1;
                fprintf (f, "%c", ptr2[i]);
              }
            }
  // fprintf (f, "%s", ex->txt2);
          }
        delete[] ptr2;  
        }
        fprintf (f, "</PRE></DD>\n");
      }
      ex = ex->next;
    }
    fprintf (f, "</DL><HR>\n");
  }
}

void generatehtml(char *basedir, int full)
{ OBJECT *t;
  FILE *f;
  int i, ap = 0;
  char dir[512];
  // generate single pages

  ap = ismacro(basedir) || ishelp2(basedir);
  if (ap)
    sprintf (dir, "%s", property.getProperty("XPL4OUTHELP"));
  else if (basedir)
    sprintf (dir, "%s%s%s", basedir, SEPCHAR, HTMLDIR);
  else if (m3)
    sprintf (dir, ".");
  else
    sprintf (dir, "%s", HTMLDIR);

  print (2, "\r\nWriting HTML page(s) to %s\r\n", dir);

  t = root.next;
  while (t)
  {
    print (1, "  %s.html\r\n", t->filename);
    if (ap)
      sprintf (h2hdup, "%s%s%s.html", dir, SEPCHAR, t->filename);
    else
      sprintf (h2hdup, "%s%s%s.html", dir, SEPCHAR, t->filename);
    f = fopen (h2hdup, "w");
    if (f)
    { htmlstart (f, t->filename);
      if (!simple)
      { htmlletter (f);
        htmlgroup (f, t);
      }

      htmldescription (f, t);
      htmlreferences (f, t);
      htmllink (f, t);
      htmlusage (f, t);
      htmlnote (f, t);
      htmlexample (f, t);
      if (full) htmlsource(f, t);
      if (!simple)
      { htmlgroup (f, t);
        htmlletter (f);
      }
      htmlauthor (f, t);

      htmlend (f);
      fclose(f);
    }
    else
      print (0, "    can not open file\r\n");

    t = t->next;
  }

  if (simple) return;
  if (ap) return;
// generate alphabetical list

  t = root.next;
  i = 0;

  while (i<27)
  {
    if (i==0)
    { print (1, "  00.html\r\n");
      if (basedir)
        sprintf (h2hdup, "%s%s%s%s00.html", basedir, SEPCHAR, HTMLDIR, SEPCHAR);
      else if (m3)
        sprintf (h2hdup, "00.html");
      else
        sprintf (h2hdup, "%s%s00.html", HTMLDIR, SEPCHAR);
    }
    else
    { sprintf (h2hdup, "%c%c", 64+i, 0);
      print (1, "  %s.html\r\n", name2number (h2hdup));
      if (basedir)
        sprintf (h2hdup, "%s%s%s%s%s.html", basedir, SEPCHAR, HTMLDIR, SEPCHAR, name2number (h2hdup));
      else if (m3)
        sprintf (h2hdup, "%s.html", name2number(h2hdup));
      else
        sprintf (h2hdup, "%s%s%s.html", dir, SEPCHAR, name2number (h2hdup));

    }

    f = fopen (h2hdup, "w");
    if (f)
    { htmlstart (f, "Alphabetical index");
      htmlletter (f, i);
      htmlindex (f, root.next, i, 10);
      htmlletter (f, i);
      htmlend (f);
      fclose(f);
    }
    else
      print (0, "    can not open file");
    i++;
  }

// generate group files

  t = root.next;

  while (t)
  { if (t->ingroup==0)
    { if (t->group)
      { print (1, "  %s.html\r\n", t->filegroup);
        sprintf (h2hdup, "%s%s%s.html", dir, SEPCHAR, t->filegroup);

        f = fopen (h2hdup, "w");
        if (f)
        { htmlstart (f, "Function index");
          htmlletter (f);
          htmlgroupindex (f, t);
          htmlletter (f);
          htmlend(f);

          fclose (f);
        }
        else
          print (0, "    can not open file\r\n");
      }
      /* else
        print (0, "    warning : %s no group\n", t->name);  */
    }
    t = t->next;
  }

// generate content file

  print (1, "  01.html\r\n");
  sprintf (h2hdup, "%s%s01.html", dir, SEPCHAR);
  f = fopen (h2hdup, "w");
  if (f)
  { htmlstart (f, "Function index");
    htmlcontent(f);
    fclose(f);
  }
  else
    print (0, "    can not open file\r\n");

// generate keyword file

  print (1, "  02.html\r\n");
  sprintf (h2hdup, "%s%s02.html", dir, SEPCHAR);
  f = fopen (h2hdup, "w");
  if (f)
  { htmlstart (f, "Keywords");
    htmlkeyword(f);
    fclose(f);
  }
  else
    print (0, "    can not open file\r\n");


}

void generatedump()
{ OBJECT *t;
  FILE *f = fopen ("hlp2html.dmp", "w");
  if (f==NULL) return;

  t = root.next;
  while (t)
  { print (2, "Dump: %s\r\n", t->name);
    t->dump(f);
    t = t->next;
  }

  fclose(f);
}

void asciifile (OBJECT *t, FILE *f)
{ TEXTXPL *p;
  int i, day, month, year;
  if (t->usage)
    fprintf (f, " Usage:  %s\n", ignorenewline (t->usage));
  p = t->in;
  if (p) fprintf (f, " \n Input:\n");
  while (p)
  { if (p->txt1)
    { fprintf (f, "\n  %-22s ", p->txt1);
      if (p->txt2)
      { for (i=0; i<strlen(p->txt2); i++)
        { fputc (p->txt2[i], f);
          if (p->txt2[i]=='\n')
            fprintf (f, "                         ");            
        }    
      }       
    }
    p = p->next;
  }
  p = t->out;
  if (p) fprintf (f, "\n Output:\n");
  while (p)
  { if (p->txt1)
    { fprintf (f, "\n  %-22s ", p->txt1);
      if (p->txt2)
      { for (i=0; i<strlen(p->txt2); i++)
        { fputc (p->txt2[i], f);
          if (p->txt2[i]=='\n')
            fprintf (f, "                         ");
        }
      }
    }
    p = p->next;
  }

  x4date (&day, &month, &year);
  fprintf (f, "\n--------------------------------------------------------------\n");
  fprintf (f, "(C) MD*TECH Method and Data Technologies, %i.%i.%i\n", day, month, year);
  fflush(f);

}

void generateascii(char *basedir)
{ OBJECT *t;
  FILE *f;
  int i, ap = 0;
  char dir[512];

// generate single pages
  // PC 20010723 - check for quantlets added from generatehtml
  ap = ismacro(basedir) || ishelp2(basedir);
  if (ap)
    sprintf (dir, "%s", property.getProperty("XPL4OUTHELP"));
  else
  if (basedir)
    sprintf (dir, "%s%s%s%s%s", basedir, SEPCHAR, HTMLDIR, SEPCHAR, ASCIIDIR);
  else if (m3)
    sprintf (dir, ".");
  else
    sprintf (dir, "%s%s%s", HTMLDIR, SEPCHAR, ASCIIDIR);

  print (2, "\r\nWriting ASCII page(s) to %s\r\n", dir);

  t = root.next;
  sprintf (h2hdup, "%p", t);

  while (t)
  { print (1, "  %s.txt\r\n", t->filename);
    if (m3)
      sprintf (h2hdup, "%s.txt", t->filename);
    else
      sprintf (h2hdup, "%s%s%s.txt", dir, SEPCHAR, t->filename);
    f = fopen (h2hdup, "w");
    if (f)
    { asciifile(t, f);
      fclose(f);
    }
    else
      print (0, "    can not open file\r\n");
    t = t->next;
  }
}

void generatertf()
{ print (2, "\r\nWriting RTF page(s) not yet implemented\r\n");
}

void latexfile( OBJECT *t, FILE *f)
{TEXTXPL *p;
 OBJECT *s;
 char *ptr1, *ptr2, *ptr3;
 int i;
 printf ("%s\n",t->name);

      if (t->keywords)
       { ptr1=strdup(t->keywords);
         ptr2=strtok(ptr1,",");
         while(ptr2!=NULL)
          { ptr3=replace2(ptr2,"\n"," ");
            fprintf(f,"\\index{%s} \n",ptr3);
            delete[] ptr3;
            ptr2=strtok(NULL,",");
          }
         delete[] ptr1;
         delete[] ptr2;

       }

      fprintf(f,"\\begin{longtable}{lp{13.0cm}} \n");
      if (t->group)
       { if (t->type)
          fprintf(f,"{\\rm\\bf Library:} &  ");
         else
          fprintf(f,"{\\rm\\bf Group:} & ");
         correcttext3(f,t->group);
         fprintf(f,"\\\\ \n & \\\\ \n");
       }

      if(t->subgroup)
       { fprintf(f,"{\\rm\\bf Subgroup:} &  ");
         correcttext3(f,t->subgroup);
         fprintf(f,"\\\\ \n & \\\\ \n");
       }

      if (t->type)
       fprintf(f,"\\multicolumn{2}{l}{\\setlength{\\fboxsep}{4pt}\\setlength{\\fboxrule}{1pt}\\fcolorbox{red}{white}{\\parbox{17cm}{{\\rm\\bf Quantlet:}\\hspace{11mm}   ");
      else
       fprintf(f,"\\multicolumn{2}{l}{\\setlength{\\fboxsep}{4pt}\\setlength{\\fboxrule}{1pt}\\fcolorbox{blue}{white}{\\parbox{17cm}{{\\rm\\bf Function:}\\hspace{7mm}  ");
      correcttext4(f,t->name);
      fprintf(f,"\\\\ \n & \\\\ \n");

      if (t->nsee)
       { fprintf(f,"{\\rm\\bf See also:} & ");
         for (i=0; i<t->nsee; i++)
           { s = ((OBJECTP*) (t->seeobj))[i];
             if (s)
              { if(i) fprintf(f,", ");
                correcttext3(f,s->name);
              }
           }
         fprintf(f,"\\\\ \n & \\\\ \n");
       }

      if (t->link)
       { fprintf(f,"{\\rm\\bf Link(s):} & ");
         correcttext3(f,t->link);
         fprintf(f,"\\\\ \n & \\\\ \n");
       }

      if (t->description)
       { fprintf(f,"{\\rm\\bf Description:}  & ");
         correcttext3(f,t->description);
         fprintf(f,"\\\\ \n & \\\\ \n");
       }

      if (t->usage)
       { fprintf(f,"{\\rm\\bf Usage:} & {\\sl  ");
         correcttext3(f,t->usage);
         fprintf(f,"} \\\\ \n");
       }

      fprintf(f,"\\end{longtable} \n");
      fprintf(f,"\\begin{longtable}{llp{10.0cm}} \n");

      p = t->in;
      if (p)
       { fprintf (f, "{\\rm\\bf Input:}\\hspace{11mm}");
         while (p)
          { if (p->txt1)
             { correcttext2(f,p->txt1);
               if (p->txt2)
                correcttext3(f,p->txt2);
                fprintf(f,"\\\\ \n");
             }
            p = p->next;
          }
         fprintf(f," & & \\\\ \n");
       }

      p = t->out;
      if (p)
       { fprintf (f, "{\\rm\\bf Output:}\\hspace{6.0mm}");
         while (p)
          { if (p->txt1)
             { correcttext2(f,p->txt1);
               if (p->txt2)
                correcttext3(f,p->txt2);
                fprintf(f,"\\\\ \n");
             }
            p = p->next;
           }
       }

      fprintf(f,"\\end{longtable} \n");
      fprintf(f,"\\pagebreak[0] \n");
      fprintf(f,"\\begin{longtable}{lp{13.0cm}} \n");

      if (t->note)
       { fprintf(f,"{\\rm\\bf Note:} \\hspace{12.03mm} & ");
         correcttext3(f,t->note);
         fprintf(f,"\\\\ \n & \\\\ \n");
       }


      if (t->example)
       { p=t->example;
         while(p)
          { if (p->txt1)
             {// p->txt1=exampblanks(p->txt1);
              fprintf(f,"{\\rm\\bf Example:}& \\begin{verbatim}\n");
              fprintf(f,"%s \n",p->txt1);
              fprintf(f,"\\end{verbatim} \\\\ \n");
              // delete[] ptr1;
             }
            if (p->txt2)
             { ptr1=replace2(p->txt2,"&nl;","\n");
               fprintf(f,"{\\rm\\bf Result:}& \\begin{verbatim}\n");
               fprintf(f,"%s \n", ptr1);
               fprintf(f,"\\end{verbatim} \\\\ \n");
               delete[] ptr1;
             }
            p=p->next;
          }

       }
        /*
      if (t->example)
       { fprintf(f,"{\\rm\\bf Example:}& \\begin{verbatim}\n");
         p=t->example;
         while(p)
          { if (p->txt1)
             {fprintf(f,"%s \n",p->txt1);
             }
            p=p->next;
          }
         fprintf(f,"\\end{verbatim} \\\\ \n");
       }


      if (t->example)
       { fprintf(f,"{\\rm\\bf Result:}& \\begin{verbatim}\n");
         p=t->example;
         while(p)
          { if (p->txt2)
             { ptr1=replace2(p->txt2,"&nl;","\n");
               fprintf(f,"%s \n", ptr1);
               delete[] ptr1;
             }
            p=p->next;
          }
         fprintf(f,"\\end{verbatim} \\\\  \n");
      }
          */
      fprintf(f,"\\end{longtable} \n");
      fprintf(f,"\\pagebreak[0] \n");
      fprintf(f,"\\begin{longtable}{lp{13.0cm}} \n");

    /*  if(t->author)
       { fprintf(f,"{\\rm\\bf Author:} \\hspace{8.0mm} & ");
         correcttext3(f,t->author);
         fprintf(f,"\\\\ \n & \\\\ \n");
       } */

      if(t->reference)
       { fprintf(f,"{\\rm\\bf References:} & ");
         correcttext3(f,t->reference);
         fprintf(f,"\\\\");
       }
      fprintf(f,"\\end{longtable} \n\n");
      fprintf(f,"\\pagebreak[4] \n");



}

void generatelatex(char *basedir)
{ // print (2, "\r\nWriting LaTeX page(s) not yet implemented\r\n");
  OBJECT *t;
  FILE *f;
  int i;
  char dir[512], *lastname ;

  if (basedir)
   sprintf ( dir,"%s%s%s",basedir, SEPCHAR, LATEXDIR);
  else
   sprintf( dir,"%s",LATEXDIR);
  print( 2, "\r\nWriting %s\r\n", dir);

  t=root.next;

  f=fopen (dir, "w");
  if (f==NULL)
    print (0, "         can not open file\r\n");
  else
  {
    fprintf(f,"\\chapter{XploRe: Quantlets \\& Functions} \n\n");
    lastname=t->name;
    while (t)
    { if(t->name[0]!=lastname[0] && isalpha(t->name[0])!=0 )
       fprintf(f,"\\addcontentsline{toc}{subsection}{%c} \n",t->name[0]);
      latexfile(t,f);
      lastname=t->name;
      t=t->next;
    }
    fclose (f);
  }
}

void vertestfile(OBJECT *t,  FILE *f)
{ TEXTXPL *exam;
  fprintf ( f,"\n\"%s\" \n", t->name);
  
  exam=t->example;
   
  while(exam)
    { if (exam->txt1)
       fprintf ( f,"\n     %s", exam->txt1);
       exam=exam->next;
    }
 }    

void generatevertest(char *basedir)
{ OBJECT *t;
  FILE *f;
  int i;
  char dir[512];
  
  
  if (basedir)
    sprintf ( dir,"%s%s%s", basedir, SEPCHAR, "vertestn.xpl");
  else
    sprintf ( dir,"%s", "vertestn.xpl");
        
  print (2, "\r\nWriting %s\r\n", dir);  
  
  t=root.next;
  
  f=fopen (dir, "w");
  if (f==NULL)
    print (0, "         can not open file\r\n");
  else
  { 
   // fprintf (f,"\n proc()=vertestn()\n");
    while (t)
    { vertestfile(t,f);
      t=t->next;
    }
   // fprintf(f, "\n endp \n");
    fclose (f);
  }
}

void deleteallobjects()
{ OBJECT *t, *tn;

  if (root.next==NULL) return;
  t = root.next;
  do
  { tn = t->next;
    delete t;
    t = tn;
  }
  while (t!=NULL);

  root.next = NULL;
}

int dohlp2html (int argc, char *argv[])
{   char c, *basedir = NULL;
    int i, makehtml = 0, makeascii = 0, makelatex = 0, makertf = 0,
           makedump = 0, makevertest = 0;
    simple = m3 = ret = 0;

     logfile = fopen ("makehelp.log", "w");
     h2htext = new char[8192];
     // check (h2htext);
     h2hdup  = new char[4096];
     // check (h2hdup);
     error = 0;

     // Just for Windows
     makehtml = 0;
     makeascii = 0;

     for (i=1; i<argc; i++)
     { if (strcmp(argv[i], "-html")==0) makehtml = 1;
       if (strcmp(argv[i], "-fullhtml")==0) makehtml = 2;
       if (strcmp(argv[i], "-ascii")==0) makeascii = 1;
       if (strcmp(argv[i], "-latex")==0) makelatex =1;
       if (strcmp(argv[i], "-rtf")==0) makertf = 1;
       if (strcmp(argv[i], "-vertest")==0) makevertest = 1;
       if (strcmp(argv[i], "-dump")==0) makedump =1;
       if (strcmp(argv[i], "-m3")==0) m3 = 1;
       if (strcmp(argv[i], "-simple")==0) simple = 1;
/*       if (strcmp(argv[i], "-help")==0)
       { printf ("Usage:   hlp2html {option} name \r\n");
         printf ("Options: -html       Make HTML help\r\n");
         printf ("         -fullhtml   Make HTML help with source code link\r\n");
         printf ("         -ascii      Make ASCII help\r\n");
         printf ("         -rtf        Make RTF file for Windows help\r\n");
         printf ("         -latex      Make LaTeX file\r\n");
         printf ("         -help       Show this help\r\n");
         printf ("         -vertest    Make vertest.xpl\r\n");
         printf ("         -m3         Ignores all directory settings :)\r\n");
         printf ("         -simple     Generate no alphabetical list etc. \r\n");
         printf ("         name        Directory where xplore.exe is\r\n");
         exit(0);
       }
*/       if (argv[i][0]!='-')
         basedir = strdup(argv[i]);
     }

     lastparam = NULL;
     print (2, "\r\nHLP2HTML v 2.1 (");
     print (2, __DATE__);
     print (2, ") \r\n\r\n");

     if (makehtml + makeascii + makevertest + makedump + makertf + makelatex)
     { if (!simple) readhlp2(basedir);
       readxpl(basedir);
       if (root.next==NULL)
         print (2, "  Nothing to do!\r\n");
       else
       { linkall();

         if (error)
         { print (2, "\r\nSerious ERRORS found. Stop executing HLP2HTML.\r\n");
           return 2;
         }
         else
         { if (makehtml) generatehtml (basedir, makehtml-1);
	   if (makertf) generatertf();
	   if (makelatex) generatelatex(basedir);
	   if (makeascii) generateascii(basedir);
	   if (makevertest) generatevertest(basedir);
	   if (makedump) generatedump();
	 }
       // free mem
         deleteallobjects();
       }
    }
    else
      print (2, "  Nothing to do!\r\n");
    print (2, "\r\nGenerating helpsystem(s) finished\r\n\r\n");    
    
    if (logfile)
    { fflush(logfile);
      fclose (logfile);
    }
    else
      ret = 1;

// now give all memory free
  if (basedir) delete[] basedir;
  delete[] h2htext;
  delete[] h2hdup;
  return ret;
}

