/* $Header: /home/xplore/cvs/xpl4gr/incol.C,v 1.3 2002/08/16 12:31:43 sigbert Exp $ */

#include <sys/types.h>
#include <time.h>

#include "function.h"
#include "macro.h"

#include "main.h"
#include "color.h"
#include "display.h"
#include "plot.h"

#include "xplio.h"
#include "xchar.hpp"

#ifdef _UNIX_
Colormap cmap;	//wird hier created
int WhichColor;
#define TRUECOLOR 5
extern "C" BS_Glob_Variable bs_glob_variable;

static char *vis_class[]=	{"StaticGray", "GrayScale", "StaticColor",
		 "PseudoColor", "TrueColor", "DirectColor"};

#endif

Liste <XplColor *> all_colors;	//wird hier created
Liste <unsigned long> system_pixels;	//wird hier created

extern XplObject * FreeColor(Liste <XplObject*> *argl);

int FindColor(int r, int g, int b)
{	int i;
	XplMatrix rgb(1, 3);
	rgb(0, 0)=r;
	rgb(0, 1)=g;
	rgb(0, 2)=b;
	for (i=0; i<all_colors.laenge(); i++)
		if (	(all_colors[i]->requested==rgb)==True)
			break;
	if (i<all_colors.laenge())
		return(i);
	return(-1);
}	

#ifdef _UNIX_

void PrepareColormap()
{
	Display *dis;
	XColor rgb_exact;
	dis=XtDisplay(bs_glob_variable.main_shell);
		
	int r, g, b, i, j;
	int colors_allowed=0;
	
	int snum=DefaultScreen(dis);
	XVisualInfo vis_info;

	XVisualInfo *vlist, vinfo_template, *v;
	int count, num_vis;
	
	i=5;
	
	while (!XMatchVisualInfo(dis, snum, DefaultDepth(dis, snum), 
			i--, &vis_info) && i>-2)
		;
	cout<<"A Visual Class is "<<vis_class[i++]<<endl;	
	
	WhichColor=i;
		
	vinfo_template.screen=snum;
	vinfo_template.depth=DefaultDepth(dis, snum);
	vlist=XGetVisualInfo(dis, VisualNoMask, 
			&vinfo_template, &num_vis);
	if (num_vis==0)
	{	cerr<<"No match!"<<endl;
		exit(1);
	}

	// Read DefaultColormap ...
	
	Boolean colormap_ok=True; 	//SWS 23.09;

	if (WhichColor==TRUECOLOR)
	{	XColor all_col[256];
		int frec=0;
		for (i=0; i<256; i++)
			all_col[i].pixel=i;
		XQueryColors(dis, DefaultColormap(dis, snum), all_col, 256);
		for (i=0; i<256; i++)
		{	
/*
#ifdef _BLABLA_
		cout<<"DefMap vor dem free:"<<all_col[i].pixel<<
		", r="<<(all_col[i].red)/256<<", g="<<
		(all_col[i].green)/256<<", b="<<(all_col[i].blue)/256<<endl;
#endif
*/
		if (all_col[i].red==0 && all_col[i].green==0
				 && all_col[i].blue==0)
			frec++;
		}

#ifdef _BLABLA_
	cout<<frec-1<< " Colors frei"<<endl;
#endif

		cmap=XCreateColormap(dis, RootWindow(dis, snum),	//OK
			vlist[0].visual, AllocNone);
		int already;
		for (i=0; i<256 && colormap_ok; i++)
		{	already=0;
			while (!(	all_col[already].red== all_col[i].red 
			&& 	all_col[i].green==all_col[already].green
			&& 	all_col[i].blue==all_col[already].blue))
			already++;
			if (already<i)
			{	
/*
#ifdef _BLABLA_
			cout<<" Pixel "<<already<<"=="<<i<<endl;
#endif
*/
			break;
			}
			else
			if (!XAllocColor(dis, cmap, all_col+i))
			{	cerr<<"Error bei Copy default colormap!"<<endl;
				colormap_ok=False;	//SWS 23.09
			}
			else
				system_pixels.haengeAn(all_col[i].pixel);
		}
#ifdef _BLABLA_
		XQueryColors(dis, cmap, all_col, 256);
/*
		for (i=0; i<256; i++)
		{	cout<<"CMAP: "<<all_col[i].pixel<<
		", r="<<(all_col[i].red)/256<<", g="<<
		(all_col[i].green)/256<<", b="<<(all_col[i].blue)/256<<endl;
		}
		for (i=0; i<system_pixels.laenge(); i++)
		cout<<"Sys_PIXEL "<<i<<" , pixel="<<system_pixels[i]<<endl;	
*/

#endif

		if (colormap_ok)
			XInstallColormap(dis, cmap);	//OK
		else
			cmap=DefaultColormap(dis, snum);	//OK

	//XSetWindowColormap(dis, RootWindow(dis, snum), cmap);	//OK
#ifdef _BLABLA_
		int ret;
	Colormap * ccmm=XListInstalledColormaps(dis, RootWindow(dis, snum), 
				&ret);
	cout<<" By RootWindow "<<ret<<" colormaps are installed"<<endl;
	XFree(ccmm);			
#endif
	}	//of WhichColor
	else
		cmap=DefaultColormap(dis, snum);			//OK

	XFree(vlist);


}
#endif


int InitColorList()
{
#ifdef _UNIX_
	Display *dis;
	XColor rgb_exact;
	dis=XtDisplay(bs_glob_variable.main_shell);
#endif


	//cout<<"Die Farben werden geladen..."<<endl;
	int r, g, b, red, green, blue, i;
	char *color_name[]={ 	"black", "blue", "green", "cyan", 
			"red", "magenta", "yellow", "white" };

	XplColor * new_col;
	XplMatrix rgb(1,3);
	
	for (i=0; i<COLOR_COUNT; i++)
	{	new_col=new XplColor;
		all_colors.haengeAn(new_col);
		r=i/4;
		g=(i-4*r)/2;
		b=i%2;
		switch(r)
		{	case 0:	all_colors[i]->red=0;
				break;
			case 1:	all_colors[i]->red=256*255;
				break;
		}
		switch(g)
		{	case 0:	all_colors[i]->green=0;
				break;
			case 1:	all_colors[i]->green=256*255;
				break;
		}

		switch(b)
		{	case 0:	all_colors[i]->blue=0;
				break;
			case 1:	all_colors[i]->blue=256*255;
				break;
		}

		all_colors[i]->color_name=strdup(color_name[i]);
		
		rgb(0,0)=(all_colors[i]->red)/256;
		rgb(0,1)=(all_colors[i]->green)/256;
		rgb(0,2)=(all_colors[i]->blue)/256;
		
		all_colors[i]->requested=rgb;
		
		
	}
	//	GRAY!
	
		new_col=new XplColor;
		all_colors.haengeAn(new_col);
		all_colors[i]->red=128*255;
		all_colors[i]->green=128*255;
		all_colors[i]->blue=128*255;
		all_colors[i]->color_name=strdup("gray");
		
		rgb(0,0)=(all_colors[i]->red)/256;
		rgb(0,1)=(all_colors[i]->green)/256;
		rgb(0,2)=(all_colors[i]->blue)/256;
		
		all_colors[i]->requested=rgb;

#ifdef _UNIX_
	int snum=DefaultScreen(dis);
	//for (i=0; i<COLOR_COUNT; i++)	
	for (i=0; i<all_colors.laenge(); i++)	
	{	rgb_exact.red=all_colors[i]->red;
		rgb_exact.green=all_colors[i]->green;
		rgb_exact.blue=all_colors[i]->blue;
		
		if (XAllocColor(dis, DefaultColormap(dis, snum),
				&rgb_exact)!=True)
		{	xplerror(
		"Error by allocating basic colors for standard colormap!");
			if (WhichColor==TRUECOLOR)
				all_colors[i]->pixel=256;
			else
				all_colors[i]->pixel=0;
		}
		else
		{	all_colors[i]->pixel=rgb_exact.pixel;
			all_colors[i]->red=rgb_exact.red;
			all_colors[i]->green=rgb_exact.green;
			all_colors[i]->blue=rgb_exact.blue;
		}

	}
	
	PrepareColormap();

	if (WhichColor==TRUECOLOR)
	{	for (i=0; i<COLOR_COUNT; i++)	
		if (all_colors[i]->pixel==256)	
		{	rgb_exact.red=all_colors[i]->red;
			rgb_exact.green=all_colors[i]->green;
			rgb_exact.blue=all_colors[i]->blue;
		
			if (XAllocColor(dis, cmap,
				&rgb_exact)==True)
			{	all_colors[i]->pixel=rgb_exact.pixel;
				all_colors[i]->red=rgb_exact.red;
				all_colors[i]->green=rgb_exact.green;
				all_colors[i]->blue=rgb_exact.blue;
/*
#ifdef _BLABLA_
			cout<<"RGB_EXACT:"<<rgb_exact.red<<
			", "<<rgb_exact.green<<", "<<
			rgb_exact.blue<<", PIXEL="<<rgb_exact.pixel<<endl;
				rgb.out();
#endif
*/
			}
			else
			{	all_colors[i]->pixel=all_colors[i]->red=
				all_colors[i]->green=all_colors[i]->blue=0;
				cerr<<color_name[i]<<": COLOR_ERROR"<<endl;
			}
		}
	}
/*
#ifdef _BLABLA_
	for (i=0; i<all_colors.laenge(); i++)
	{	all_colors[i]->requested.out();
		cout<<"pixel="<<all_colors[i]->pixel<<endl;
	}
#endif
*/
#endif			//of UNIX

}
