/* $Header: /home/xplore/cvs/xpl4gr/init.C,v 1.10 2003/07/28 17:24:34 cizek Exp $ */

// Initialization of Interpreter
//  TTK  11.2.95

// tk + sk 31.10.97
#include "machine.h"

#ifdef __BORLANDC__
#include <windows.h>
#elif HAS_DLL==WINDLL
#include <windows.h>
#endif

#include <time.h>
#include <math.h>
#include <new.h>
#include <string.h>


#if !defined(__BORLANDC__)  && !defined (WIN32)
#include <unistd.h>
#else
#include <process.h>
#endif

#include <signal.h>

#include "liste.h"
#include "qsort.h"
#include "init.h"
#include "function.h"
#include "macro.h"
#include "xplfun.h"
#include "xplfun2.h"
#include "xplfun3.h"
#include "xplbasefun.h"
#include "property.h"
#include "directory.h"
#include "xplio.h"
#include "system.h"
#include "build.h"
#include "xplore_strings.h"

extern XplObject* SetXplPointsMask(Liste<XplObject*> *argl);
extern XplObject* SetXplLinesMask(Liste<XplObject*> *argl);
extern XplObject* SetText(Liste<XplObject*> *argl);

#ifdef HAS_DLL        // SK 30.04.99
#include "dllfun.h"
#endif

extern int quiet;

#ifdef _RPCXGOBI_         // SKs parameter evaluation
#include "xplxgobi.h"

extern "C" void internRPCStartServer (unsigned long);
extern "C" int  internRPCStartClient (unsigned long);
#endif

/* TTK 21.2.99
#ifdef SOCKETSERVER  
#include "xsockio.h"

int      sock;
#endif
*/

#if defined (PSGEN) || defined (_UNIX_) || defined (_GRAPHICS_)  || defined (__BORLANDC__)
//	SWS	!
#include "initsws.h"
#endif

#ifdef _XPLTIME_
#include "xpltimefun.h"
#endif

#ifndef MATRIX
#include "xnewf.h"
#include "xint.hpp"       // SK typedefs
#endif

#ifdef __BORLANDC__
#include "xplwin.h"
extern char* xpl4homewin;
char * SetTempDir();
#endif

#if !defined (__BORLANDC__) && !defined (WIN32) //LOOK!
#include <sys/time.h>           /* to limit the core */
#ifndef __MINGW32__
#include <sys/resource.h>
#endif
#else
#include <time.h>
#endif

#define MAX_CORE        (1L << 20L)     /* 1 MB */
#define CORE_LIMIT              // if undefined core is not limited

#ifdef TTKDEBUG
#ifdef MATRIX
extern int ttkdebug;
#else
int ttkdebug;
#endif
int tracedebug, docheck;
#endif

char *programId;
char CommandLine[] = XMSG_INITTEXT_COMMANDLINE_STR;
char *xpl4parsefile;

#ifdef MATRIX
char *xpl4data;
#endif

char *WWWStartPage;
const char *CurrentMacro;
char *expireString;

FILE *XplOutputFile = NULL;

void InitializeXplArray (void);

extern void logt (const char *txt);
extern void logptr (void *ptr);

void InitializeProperties (int argc, char **argv)
{ int i;
  char *p, path[2048], build[10];
// read ini file	sk + tk 090798
// SK 24.06.98
  quiet = 0; // SK 16.11.2004

// global property default settings

//  property.setProperty ("system", "unknown");
#ifdef __BORLANDC__
  property.setProperty ("system", "i686-pc-cygwin32");
#else
  property.setProperty ("system", SYSTEM);
#endif
#if defined(__BORLANDC__) || defined(WIN32)
  property.setProperty ("os", "windows");
/*  OSVERSIONINFO os;
  os.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
  GetVersionEx(&os);
  if (os.dwPlatformId==VER_PLATFORM_WIN32s)
    property.setProperty ("system", "win32s");
  else if (os.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS)
    property.setProperty ("system", "windows 95");
  else if (os.dwPlatformId==VER_PLATFORM_WIN32_NT)
    property.setProperty ("system", "windows nt");
    */
#else
  if (strcmp(SYSTEM, "i686-pc-cygwin32"))
    property.setProperty ("os", "unix");
  else
    property.setProperty ("os", "windows");
#endif
  sprintf (build, "%i", BUILD);
  property.setProperty ("build", build);
  property.setProperty ("builddate", __DATE__);
  property.protectProperty ("os");
  property.protectProperty ("system");
  property.protectProperty ("build");
  property.protectProperty ("builddate");

  //MS 20030611
#ifdef X4standalone
	property.setProperty ("buildtype", "standalone"); // MS 20030611
#endif

#ifdef X4batch
	property.setProperty ("buildtype", "batch"); // MS 20030611
#endif

#if defined (X4batch) && defined (X4singleserver)
	property.setProperty ("buildtype", "server"); // MS 20030611
#endif

	property.protectProperty ("buildtype");

  property.setProperty ("outheadline", XMSG_INITTEXT_OUTHEADLINE_STR);
  property.setProperty ("outlayerline", "[,,%li,%li,%li,%li,%li,%li]\r\n");
  property.setProperty ("outlineno", "[%*li,] ");
  property.setProperty ("outmaxdata", "2048");
  property.setProperty ("outputformat", "% 8.5g");
  property.setProperty ("outputstringformat", "\"%s\"");
  property.setProperty ("outmaxdata", "2048");
#if !defined(__BORLANDC__) && !defined(_MSC_VER)
  property.setProperty ("browser", "netscape");
#endif
  property.setProperty ("startup", "startup.xpl");
  property.setProperty ("logfile", "xplore.log");
#ifdef SOCKETSERVER
  property.setProperty ("port", "8888");
  property.setProperty ("maxClients", "5");
#endif

// PC 20021001 - numerical properties
  char pombuf[32];
  sprintf(pombuf, "%20.16g", DBL_EPSILON);
  property.setProperty ("machineeps", pombuf);
  property.protectProperty ("machineeps");
// PC 20030202
  property.setProperty ("statusmessage", "on"); // pc 20030131

// process global settings

  for (i=0; i<argc; i++)
  {
    if (strcmp (argv[i], "-v") == 0)
      {
      cout << programId << endl;
      exit (0);
      }
    if (strcmp (argv[i], "-ini") == 0) // SK 25.06.98
      {
      if (++i >= argc)
	{
#ifdef __BORLANDC__
   MessageBox (NULL, "missing argument for -ini", XMSG_INITTEXT_FATALERRORSTRING_STR,  MB_OK|MB_ICONSTOP|MB_TASKMODAL);
#else
	cerr << "missing argument for -ini" << endl;
#endif
	exit (1);
        }
        if ((strchr(argv[i], ':')!=NULL) || (argv[i][0]=='/') || (strncmp(argv[i], "\\\\", 2)==0))
	{ //logt(argv[i]);
          property.load(argv[i]);
        }
        else
        { sprintf (path, "%s%s%s", getx4cwd(NULL), SEPCHAR, argv[i]);
	  //logt(path);
          property.load(path);
        }
      }

    if (strcmp(argv[i], "-quiet") == 0) { // SK 16.11.2004
      quiet = 1;
    }
#ifdef _RPCXGOBI_
// SKs parameter evaluation   10.4.97
      if (strcmp(argv[i], "-startup")==0)
      {
      if (argv[i+1][0]!='-')
	{  property.setProperty ("startup", argv[i+1]);
        }
      }
      if (strcmp(argv[i], "-client")==0)
      {
      if (argv[i+1][0]!='-')
	{
	sscanf(argv[i+1], "%x", &xpl_client_number);
        if (xpl_client_number)
          internRPCStartClient (xpl_client_number);
        i++;
        }
      }
     if (strcmp(argv[i], "-server")==0)
      {
      if (argv[i+1][0]!='-')
	{
	sscanf(argv[i+1], "%x", &xpl_server_number);
        if (xpl_server_number)
          internRPCStartServer (xpl_server_number);
        i++;
        }
      }
      if (strcmp(argv[i], "-link")==0)
      {
      if (argv[i+1][0]!='-')
	{
	xpl_start_as_link = TRUE;
        i++;
        }
      }
// end of SKs
#endif

    }

  sprintf (path, "%s%sXploRe.ini", getx4cwd(NULL), SEPCHAR);
  //logt(path);
  property.load(path);
	  //  property.load("XploRe.ini");

#ifdef _RPCXGOBI_
  p = property.getProperty ("rpcclient");
  if (p)
  { sscanf(p, "%x", &xpl_client_number);
    if (xpl_client_number)
      internRPCStartClient (xpl_client_number);
  }

  p = property.getProperty ("rpcserver");
  if (p)
  { sscanf(argv[i+1], "%x", &xpl_server_number);
    if (xpl_server_number)
      internRPCStartServer (xpl_server_number);
  }

  p = property.getProperty ("rpclink");
  xpl_start_as_link = (p!=NULL);
#endif

  initdirectories();

  property.protectProperty ("xpl4nethome");
  property.protectProperty ("xpl4netlib");
  property.protectProperty ("xpl4netdata");
  property.protectProperty ("xpl4nethelp");
  property.protectProperty ("xpl4netdll");
  property.protectProperty ("xpl4netprog");
  property.protectProperty ("xpl4nettemp");
  property.protectProperty ("xpl4syshome");
  property.protectProperty ("xpl4syslib");
  property.protectProperty ("xpl4sysdata");
  property.protectProperty ("xpl4syshelp");
  property.protectProperty ("xpl4sysdll");
  property.protectProperty ("xpl4sysprog");
  property.protectProperty ("xpl4systemp");

  property.protectProperty ("xpl4home");

  #ifdef X4server
  property.protectProperty ("xpl4lib");   // just temporary SK 12.08.98
  property.protectProperty ("xpl4data");
  property.protectProperty ("xpl4help");
  property.protectProperty ("xpl4dll");
  property.protectProperty ("xpl4prog");
  property.protectProperty ("xpl4temp");
  property.protectProperty ("xpl4outlib");
  property.protectProperty ("xpl4outdata");
  property.protectProperty ("xpl4outhelp");
  property.protectProperty ("xpl4outdll");
  property.protectProperty ("xpl4outprog");
  property.protectProperty ("xpl4outtemp");
#endif

#ifdef SOCKETSERVER
  property.protectProperty ("port");
  property.protectProperty ("maxClients");
#endif

}

void  InitializeInterpreter (int argc, char** argv)
{

  char x4date[12], *tok, *month[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
  int i, exday, exmonth, exyear;
  char msg[256];
  

// SK 030898
// __DATE__ form : "mmm dd yyyy"

   strcpy (x4date, __DATE__);
   tok = strtok (x4date, " ");
   for (i=0; i<12; i++)
     if (strcmp(tok, month[i])==0) exmonth = i;
   exday  = atoi(strtok(NULL, " "));
   exday  = 1;
   exyear = atoi(strtok(NULL, " "));

   // SK 051098,140700

   programId = new char[256];
   sprintf (programId, "%s\r\n", PROGRAMID);

// tk 170298
   exmonth += 2;  // SK 31.12.98
   if (exmonth>11)
   { exmonth -= 12;
     exyear++;
   }
// tk 170298 end

  static int alreadyInvoked = FALSE;

#ifdef HAS_CORE
// Set the core limit to MAX_CORE
   struct rlimit        rlp;
   rlp.rlim_cur = MAX_CORE;
   rlp.rlim_max = MAX_CORE;

#ifdef CORE_LIMIT
   setrlimit (RLIMIT_CORE, &rlp);       /* sets core limit      */
#endif
#endif

  WWWStartPage = strdup ("_Xpl_Start.html");

  // check date for expiration
  time_t sec;
  time (&sec);
  struct tm *ts = localtime (&sec);
  char exstring[16];

#ifdef JAPANESE
/* Modefied by D-TEC */
  sprintf (exstring, "%d/%d/%d", exyear, 1+exmonth, exday);
#else
  sprintf (exstring, "%d.%d.%d", exday, 1+exmonth, exyear);
#endif

  expireString =  new char[256];
  sprintf (expireString, XMSG_INITTEXT_EXPIRESTRING_STR, exstring);

  int isExpired = FALSE, tmyear;
  tmyear = 1900 + ts->tm_year;

#ifdef _EXPIRE_
  isExpired  = (exyear < tmyear);
  isExpired |= (exyear == tmyear) && (exmonth < ts->tm_mon);
  isExpired |= (exyear == tmyear) && (exmonth == ts->tm_mon) && (exday < ts->tm_mday);
#endif

  logt ("check expiring");
  if (isExpired)
    { logt ("Server expired !!!!");
#ifdef SOCKETSERVER
      //    sockout ("Server License expired on ");
      //    sockout (exstring);
      //    sockout ('\n');
    protocol->sendString ("Server License expired on ");
    protocol->sendString (exstring);
    protocol->sendString ("\n");
#else
#ifdef __BORLANDC__
   int sel;
   sprintf (msg, XMSG_INITTEXT_EXPIREDSTRING_STR, exstring);
   sel = MessageBox (NULL, msg, XMSG_INITTEXT_FATALERRORSTRING_STR,  MB_YESNO|MB_ICONSTOP|MB_TASKMODAL);

   if (sel==IDYES)
   { //sprintf (msg, "%s/Request.html", property.getProperty("xpl4nethome"));
     sprintf (msg, "%s/download/download.html", property.getProperty("xpl4nethome"));
     ShellExecute(NULL,"open",msg,"","",SW_SHOWNORMAL);
   }
#else
   cerr << "License expired on " << exstring << endl;
#endif
#endif
   logt ("before exit");
   exit (0);
    }
  logt ("nach check expire");


  /*
#if !defined (INETD) && !defined (_JAVA_)
  sprintf (msg, "%s\r\n", programId);
  xplmessage (msg);
  //  cerr << programId << endl;
#endif
#if !defined (INETD) && !defined (_JAVA_) && defined (_EXPIRE_)
  sprintf (msg, "License will expire on %s\r\n", exstring);
  xplmessage (msg);
 //  cerr << "License will expire on " << exstring << endl;
#endif
*/

#if defined (SOCKETSERVER) && defined (_EXPIRE_)
  logt ("Send expire string");
  protocol->sendString ("Server License will expire on ");
  protocol->sendString (exstring);
  protocol->sendString ("\n");
#endif

  if (alreadyInvoked)
    { logt ("already Invoked");
    cerr << "ERROR:  InitializeInterpreter already called. Ignored!" << endl;
    return;
    }

  xpl4parsefile = NULL;

#if !defined (INETD) && !defined (_JAVA_)
  // cout << programId; // Sk 29.04.99
  // SendToOutput (programId);
  //  cout << programId << endl;
#endif

#ifdef SOCKETSERVER
  char tmp[256];

  sprintf (tmp, "%ld", (long) getpid ());
  logt (tmp);

  protocol->sendString (programId);
  protocol->sendString ("\nServer PID: ");
  protocol->sendString (tmp);
  protocol->sendString ("\n");
#endif

#ifdef TTKDEBUG
docheck = TRUE;
#endif

// check how Win32 set_new_handler works  10.12.98 TTK
#ifndef WIN32
  set_new_handler (NewHandler);
#endif

#if !defined (__BORLANDC__) && !defined (WIN32)   //SWS 16.09
  if ((long) signal (SIGINT, SIG_IGN) != (long) SIG_IGN)
    signal (SIGINT, InterruptHandler);
#ifndef __MINGW32__
  if ((long) signal (SIGHUP, SIG_IGN) != (long) SIG_IGN)
    signal (SIGHUP, InterruptHandler);
#endif
#endif	//SWS 16.09

  globObjList = objList  = new Liste<XplObject*>;
  constList   = new Liste<XplObject*>;
  displayList = new Liste<XplObject*>;
  funList     = new Vector<Function*>;
  macList     = new Vector<Macro*>;
  tmparg      = new Liste<XplObject*>;
  seltmp      = new Liste<XplObject*>;
  ctmp        = new Liste<const char*>;
  origmtp     = new MacroText;

  logt ("InstallFunctions");
  InstallFunctions ();
  logt ("InstallObjects");
  InstallObjects   ();
  logt ("InstallErrorList");
  InitializeErrorList ();

  logt ("CurrentMacro");
  CurrentMacro = CommandLine;        // used by xplerror

// tk + sws 150498
  logt ("xtmpnam");
  xpl4parsefile = xtmpnam ();
  logt (xpl4parsefile);
  if (xpl4parsefile == NULL)
    { sprintf (msg, XMSG_INITTEXT_NOTEMPSPACE_STR, x4dir[XPL4OUTTEMP].dirs[0]);
#ifdef __BORLANDC__
   MessageBox (NULL, msg, XMSG_INITTEXT_FATALERRORSTRING_STR,  MB_OK|MB_ICONSTOP|MB_TASKMODAL);
#else
   cerr << msg << endl;
#endif
    exit (1);
    }

#ifndef MATRIX
  InitializeXplArray ();
#endif

#if ((defined (INETD) || defined (_JAVA_)) && !defined (SOCKETSERVER) && !defined(X4singleserver))
  logt ("TTK's alter Kram");
  //#if ((defined (INETD) || defined (_JAVA_)) && !defined (SOCKETSERVER))
  xpl4home = new char[256];
  if (xpl4home == NULL)
    { 
    cerr << "InitializeInterpreter: no memory for 256 byte ! ..." << endl;
    exit (1);
    }
  *xpl4home = '\0';
  strcat (xpl4home, "/user5/stranger/xplore4");

  xpl4lib = new char[256];
  if (xpl4lib == NULL)
    {
    cerr << "InitializeInterpreter: no memory for 256 byte ! ..." << endl;
    exit (1);
    }
  *xpl4lib = '\0';
  strcat (xpl4lib, "/user5/stranger/xplore4/lib");

  xpl4dll = new char[256];
  if (xpl4dll == NULL)
    {
    cerr << "InitializeInterpreter: no memory for 256 byte ! ..." << endl;
    exit (1);
    }
  *xpl4dll = '\0';
  strcat (xpl4dll, "/user5/stranger/xplore4");

  xpl4help = new char[256];
  if (xpl4help == NULL)
    {
    cerr << "InitializeInterpreter: no memory for 256 byte ! ..." << endl;
    exit (1);
    }
  *xpl4help = '\0';
  strcat (xpl4help, "/user5/stranger/xplore4/help");

extern char* xpl4data;     // Sigbert !
  xpl4data = new char[256];
  if (xpl4data == NULL)
    {
    cerr << "InitializeInterpreter: no memory for 256 byte ! ..." << endl;
    exit (1);
    }
  *xpl4data = '\0';
  strcat (xpl4data, "/user5/stranger/xplore4/data");

  alreadyInvoked = TRUE;
  return;
#endif

#ifdef SOCKETSERVER
  time (&sec);
  ts = localtime (&sec);
  logt ("tell cout when XploRe starts");
  cout << asctime (ts) << "\tXploRe(" << (long) getpid () << ") starts ..." << endl;
#endif
  alreadyInvoked = TRUE;
  logt ("End of Interpreter");
}

void InstallObjects ()
{
  XplDouble *x;
  XplObject *o;
  static int alreadyInvoked = FALSE;

  if (alreadyInvoked)
    { logt ("objects: alreadyInvoked");

    cerr << "ERROR:  InstallObjects already called. Ignored!" << endl;
    return;
    }
logt ("objects: pi");
  x = new XplDouble(1);
logptr(x);
  (*x)(0) = M_PI;
o = new XplObject (x, "pi");
logptr(o);
  o->SetWriteProtection ();
logt ("objects: Protection/haengeAn");
  constList->haengeAn (o);

logt ("objects: e");
  x = new XplDouble(1);
  (*x)(0) = M_E;
  o = new XplObject (x, "eh");
  o->SetWriteProtection ();
  constList->haengeAn (o);

logt ("objects: nan");
  x = new XplDouble(1);
  (*x)(0) = sqrt(-1.0);
  o = new XplObject (x, "NaN");
  o->SetWriteProtection ();
  constList->haengeAn (o);

logt ("objects: inf");
  x = new XplDouble(1);
  (*x)(0) = 0.0;                 // due to BC, Vis C++
  (*x)(0) = 1.0 / (*x)(0);       // generates Inf
  o = new XplObject (x, "Inf");
  o->SetWriteProtection ();
  constList->haengeAn (o);
logt ("objects: set alreadyInvoked");

  alreadyInvoked = TRUE;
}

#ifdef _JAVA_
// dummies fuer graphic routinen
XplObject* dummyFun (Liste<XplObject*> *argl)
  { return (NULL); }
#endif

void InstallFunctions ()
{
  static int alreadyInvoked = FALSE;

  if (alreadyInvoked)
    {
    cerr << "ERROR:  InstallFunctions already called. Ignored!" << endl;
    return;
    }

// no DLLs in Vis C++ at the moment  10.12.98  TTK
#ifdef HAS_DLL  // SK 19.02.99 
// DLL
  funList->haengeAn (new Function ("dlopen",   DLLopen,    FALSE));
  funList->haengeAn (new Function ("dlclose",  DLLclose,   FALSE));
  funList->haengeAn (new Function ("dlcall",   DLLcall,    FALSE));
  funList->haengeAn (new Function ("dlcallex", DLLcallEx,  FALSE));
  funList->haengeAn (new Function ("dlquery",  DLLquery,   FALSE));
#endif

#ifdef _JAVA_

// dummies fuer graphic routinen
  //  funList->haengeAn (new Function ("setmaskl",     dummyFun));
  funList->haengeAn (new Function ("setfractions", dummyFun));
/* SK+TK 02.11.98
  funList->haengeAn (new Function ("setmaskp",     setMaskpJava, FALSE));
  funList->haengeAn (new Function ("setmaskl",     setMasklJava, FALSE));
*/
  funList->haengeAn(new Function ("setmaskp", SetXplPointsMask));
  funList->haengeAn(new Function ("setmaskl", SetXplLinesMask));
// End of SK+TK 02.11.98

  funList->haengeAn (new Function ("deletedata",   dummyFun));
  funList->haengeAn (new Function ("axeson",       AxesOnJava));
  funList->haengeAn (new Function ("axesoff",      AxesOffJava));
  funList->haengeAn (new Function ("connect",      dummyFun));
  funList->haengeAn (new Function ("createcolor",  dummyFun));
  funList->haengeAn (new Function ("freecolor",    dummyFun));
  funList->haengeAn (new Function ("print",        dummyFun));
  funList->haengeAn (new Function ("getgopt",      dummyFun));
  funList->haengeAn (new Function ("setgopt",      SetGrOptionsJava));
  funList->haengeAn (new Function ("setsize",      SetSizeJava));
  funList->haengeAn (new Function ("setheadline",  dummyFun));
  funList->haengeAn (new Function ("setxaxis",     dummyFun));
  funList->haengeAn (new Function ("setyaxis",     dummyFun));
  funList->haengeAn (new Function ("setmaskt",     SetText));


  funList->haengeAn (new Function ("createdisplay",  createJavaDisplay));
  funList->haengeAn (new Function ("show",           showJava));
#ifdef _XPLCDEF_
  funList->haengeAn (new Function ("selectitem",     selectItemJava));
  funList->haengeAn (new Function ("readvalue",      readValueJava));
  funList->haengeAn (new Function ("slidevalue",     slideValueJava)); //SK 16.01.02
  funList->haengeAn (new Function ("adddata",        addDataJava)); //SK 16.01.02
#endif

  funList->haengeAn (new Function ("write",     dummyFun));  // SK 12.03.99
  funList->haengeAn (new Function ("link",     dummyFun));   // SK 12.03.99
  funList->haengeAn (new Function ("setmode",     dummyFun));   // SK 12.03.99
//  funList->haengeAn (new Function ("setbrushfunc",     dummyFun));   // SK 12.0  funList->haengeAn (new Function ("addbutton",     dummyFun));   // SK 12.03.99
  funList->haengeAn (new Function ("setfractions",     dummyFun));   // SK 12.0
  funList->haengeAn (new Function ("setbrushfunc",     dummyFun));   // SK 12.0

/*
XplObject* Java2d (Liste<XplObject*> *argl);
XplObject* Java3d (Liste<XplObject*> *argl);
XplObject* catFile (Liste<XplObject*> *argl);
  funList->haengeAn (new Function ("ifc",   Java2d));
  funList->haengeAn (new Function ("ifc3d", Java3d));
//  funList->haengeAn (new Function ("cat",   catFile));
*/

#if !defined(SOCKETSERVER) && !defined(X4singleserver)
  //#ifndef SOCKETSERVER
system ("/bin/echo `/bin/date` >> /user5/stranger/java.connections ");
system ("/bin/netstat | /bin/grep xpl4 >> /user5/stranger/java.connections ");
system ("/bin/echo `` >> /user5/stranger/java.connections ");
#endif

#else      // following I/O ops are not allowed with Java

#ifndef MATRIX
  funList->haengeAn (new Function ("write",   writeVar));
//  funList->haengeAn (new Function ("writeappend", writeappendVar));
#endif
  funList->haengeAn (new Function ("savemac", saveMacroText));
//  funList->haengeAn (new Function ("helpsystem", startNetscape));
// SK 23.06.98 undocumented function

#ifdef _XPLCDEF_
XplObject* TestGemischtesLesen (Liste<XplObject*> *argl);
//  funList->haengeAn (new Function ("readm",   TestGemischtesLesen));  //auskomm. von tk 980608
#endif

#endif   // JAVA
  funList->haengeAn (new Function ("read",    readVar));

//  funList->haengeAn (new Function ("help",      PrintHelp));
//  funList->haengeAn (new Function ("html",      GenerateHTML));

  funList->haengeAn (new Function ("free",      deleteObj, FALSE));
  funList->haengeAn (new Function ("setenv",    setenv));
  funList->haengeAn (new Function ("getenv",    getenv));

//  funList->haengeAn (new Function ("testexec",  testExec));
//  funList->haengeAn (new Function ("testint",   testIntervall));
  funList->haengeAn (new Function ("nelmin",    testNelmin));
  funList->haengeAn (new Function ("bfgs",      testBFGS));
  funList->haengeAn (new Function ("simpsonint",testSimpson));
  funList->haengeAn (new Function ("genar",     testArloop));

  funList->haengeAn (new Function ("abs",   matabs));
  funList->haengeAn (new Function ("acos",  matacos));
  funList->haengeAn (new Function ("asin",  matasin));
  funList->haengeAn (new Function ("asinh", matasinh));
  funList->haengeAn (new Function ("acosh", matacosh));
  funList->haengeAn (new Function ("atan",  matatan));
  funList->haengeAn (new Function ("atanh", matatanh));
  funList->haengeAn (new Function ("erf",   materf));
  funList->haengeAn (new Function ("erfc",  materfc));
  funList->haengeAn (new Function ("expm1", matexpm1));
  funList->haengeAn (new Function ("log1p", matlog1p));

//  funList->haengeAn (new Function ("atan2",  xaAtan2));
  funList->haengeAn (new Function ("ceil",  matceil));
  funList->haengeAn (new Function ("cos",   matcos));
  funList->haengeAn (new Function ("cosh",  matcosh));
  funList->haengeAn (new Function ("exp",   matexp));
  funList->haengeAn (new Function ("floor", matfloor));
//  funList->haengeAn (new Function ("gamma", matgamma));
  funList->haengeAn (new Function ("lgamma", matlgamma));
  funList->haengeAn (new Function ("log",   matlog));
  funList->haengeAn (new Function ("log10", matlog10));

  funList->haengeAn (new Function ("rint",  matrint));

  funList->haengeAn (new Function ("sin",   matsin));
  funList->haengeAn (new Function ("sinref",   matsin, FALSE));
  funList->haengeAn (new Function ("sinh",  matsinh));
  funList->haengeAn (new Function ("sqrt",  matsqrt));
  funList->haengeAn (new Function ("tan",   mattan));
  funList->haengeAn (new Function ("tanh",  mattanh));

#ifdef _XPLCDEF_
  funList->haengeAn (new Function ("string",      xaMakeString));
  funList->haengeAn (new Function ("atof",        xaAtof));
  funList->haengeAn (new Function ("substr",      xaSubString));
  funList->haengeAn (new Function ("strlen",      xaStrlen));
  funList->haengeAn (new Function ("strtok",      xaStrtok));
#endif

// time
#ifdef _XPLTIME_
  funList->haengeAn (new Function ("settime",      settime));
  funList->haengeAn (new Function ("settimegran",  settimegran));
  funList->haengeAn (new Function ("settimezero",  settimezero));
  funList->haengeAn (new Function ("filltime",     filltime));
  funList->haengeAn (new Function ("getnow",       getnow));
  funList->haengeAn (new Function ("getlocalnow",  getlocalnow));

#ifdef _XPLCDEF_
  funList->haengeAn (new Function ("year",        year));
  funList->haengeAn (new Function ("month",       month));
  funList->haengeAn (new Function ("dayofmonth",  dayofmonth));
  funList->haengeAn (new Function ("dayofweek",   dayofweek));
  funList->haengeAn (new Function ("hour",        hour));
  funList->haengeAn (new Function ("minute",      minute));
  funList->haengeAn (new Function ("second",      second));
#endif  //of _XPLCDEF_

  funList->haengeAn (new Function ("nyear",       nyear));
  funList->haengeAn (new Function ("nmonth",      nmonth));
  funList->haengeAn (new Function ("ndayofmonth", ndayofmonth));
  funList->haengeAn (new Function ("ndayofweek",  ndayofweek));
  funList->haengeAn (new Function ("nhour",       nhour));
  funList->haengeAn (new Function ("nminute",     nminute));
  funList->haengeAn (new Function ("nsecond",     nsecond));
#endif

/*
  funList->haengeAn (new Function ("cdfn2",  cdfn));
  funList->haengeAn (new Function ("pdfn2",  pdfn));
  funList->haengeAn (new Function ("qfn2",   qfn));
*/

//  funList->haengeAn (new Function ("printObj", print));
  funList->haengeAn (new Function ("list",     list, FALSE));
//  funList->haengeAn (new Function ("ncomp",    NumberOfComponents, FALSE));
  funList->haengeAn (new Function ("size",     NumberOfComponents, FALSE));
  funList->haengeAn (new Function ("append",   appendObject, FALSE));
  funList->haengeAn (new Function ("insert",   insertObject, FALSE));
  funList->haengeAn (new Function ("delete",   deleteObject, FALSE));
  funList->haengeAn (new Function ("comp",     containsComponent, FALSE));
#ifdef _XPLCDEF_
  funList->haengeAn (new Function ("names",    namesOfComponents, FALSE));
#endif
//  funList->haengeAn (new Function ("prmac",    printMacroText));
//  funList->haengeAn (new Function ("prmactl",  printMacroTL));
  funList->haengeAn (new Function ("uniform",  runif, FALSE));
  funList->haengeAn (new Function ("normal",   rnorm, FALSE));
  funList->haengeAn (new Function ("trans",    transpose));
  funList->haengeAn (new Function ("execfile", execFile));
  funList->haengeAn (new Function ("func",     readMac));
  funList->haengeAn (new Function ("library",  X4LoadLibrary));
  funList->haengeAn (new Function ("exec",     ExecCommand));
  funList->haengeAn (new Function ("inv",      inverse));
  funList->haengeAn (new Function ("rows",     matrows, FALSE));
  funList->haengeAn (new Function ("cols",     matcols, FALSE));
  funList->haengeAn (new Function ("paf",      paf, FALSE));
  funList->haengeAn (new Function ("diag",     diag, FALSE));
  funList->haengeAn (new Function ("eye",      eye, FALSE));	  //MS 20030713
  funList->haengeAn (new Function ("unit",     eye, FALSE));	  //MS 20030723

//  funList->haengeAn (new Function ("printObjects",showObjects));
  funList->haengeAn (new Function ("error",       setError));
  funList->haengeAn (new Function ("warning",     setWarning));
//  funList->haengeAn (new Function ("comp",        isComp));
  funList->haengeAn (new Function ("exist",       isNotEmpty, FALSE));
  funList->haengeAn (new Function ("existglobal", existGlobal));
  funList->haengeAn (new Function ("getglobal",   getGlobal));
  funList->haengeAn (new Function ("putglobal",   putGlobal));

  funList->haengeAn (new Function ("vec",       vectorize));

#ifndef MATRIX
  // function defined in xplfun3
  funList->haengeAn (new Function ("pdfb",  xaPdfb));
  funList->haengeAn (new Function ("pdfc",  xaPdfc));
  funList->haengeAn (new Function ("pdft",  xaPdft));
  funList->haengeAn (new Function ("pdfn",  xaPdfn));
  funList->haengeAn (new Function ("pdff",  xaPdff));

  funList->haengeAn (new Function ("cdfn",  xaCdfn));
  funList->haengeAn (new Function ("cdft",  xaCdft));
  funList->haengeAn (new Function ("cdfc",  xaCdfc));
  funList->haengeAn (new Function ("cdfb",  xaCdfb));
  funList->haengeAn (new Function ("cdff",  xaCdff));

  funList->haengeAn (new Function ("qfn",  xaQfn));
  funList->haengeAn (new Function ("qft",  xaQft));
  funList->haengeAn (new Function ("qfc",  xaQfc));
  funList->haengeAn (new Function ("qff",  xaQff));

  funList->haengeAn (new Function ("nninit",  xaNNinit));
  funList->haengeAn (new Function ("nnfunc",  xaNNfunc));
  funList->haengeAn (new Function ("nnvisu",  xaNNvisu));

  funList->haengeAn (new Function ("isoreg",  xaIsoReg));
  funList->haengeAn (new Function ("rmed",    xaRmed));
  funList->haengeAn (new Function ("l1line",  xaL1line));
  funList->haengeAn (new Function ("lowess",  xaLowess));

  funList->haengeAn (new Function ("locpol",    xaLocPol));
  funList->haengeAn (new Function ("locpoldis", xaLocH));

  funList->haengeAn (new Function ("atan2",   xaAtan2));

  funList->haengeAn (new Function ("randomize", InitRandom, FALSE));
  funList->haengeAn (new Function ("matrix",    bmatrixnew, FALSE));
  funList->haengeAn (new Function ("zeros",    bzeromatrixnew, FALSE)); /* PC 20021122 */
  funList->haengeAn (new Function ("dim",       dim, FALSE));
  funList->haengeAn (new Function ("reshape",   reshape));
  funList->haengeAn (new Function ("mknn",      xaMKnn));
  funList->haengeAn (new Function ("sknn",      xaSknn));
  funList->haengeAn (new Function ("bindata",   xaBinData));
  funList->haengeAn (new Function ("index",     xaIndex));
  funList->haengeAn (new Function ("sort",      xaSort));
  funList->haengeAn (new Function ("fft",       xaFFT));
  funList->haengeAn (new Function ("invfft",    xaInvFFT));
  funList->haengeAn (new Function ("fwt",       xaFWT));
  funList->haengeAn (new Function ("invfwt",    xaInvFWT));
  funList->haengeAn (new Function ("fwtin",     xaFWTin));
  funList->haengeAn (new Function ("invfwtin",  xaInvFWTin));
  funList->haengeAn (new Function ("fwtinshift",xaFWTinShift));

  funList->haengeAn (new Function ("nnrsetnet",   xaNNrsetnet));
  funList->haengeAn (new Function ("nnrsettrain", xaNNrsettrain));
  funList->haengeAn (new Function ("nnrdovm",     xaNNrdovm));
  funList->haengeAn (new Function ("nnrtest",     xaNNrtest));

  funList->haengeAn (new Function ("eigsm",     xaEigsm));
  funList->haengeAn (new Function ("det",       xaDet));
  funList->haengeAn (new Function ("ludecomp",  xaLU));
//  funList->haengeAn (new Function ("distance",  xaDistance));
  funList->haengeAn (new Function ("sker",      xaSker));
  funList->haengeAn (new Function ("contour2",  xaContour2));
  funList->haengeAn (new Function ("contour3",  xaContour3));
//  funList->haengeAn (new Function ("dump",      dump));

  funList->haengeAn (new Function ("conv",    xaConv));
  funList->haengeAn (new Function ("grid",    xaGrid));
  funList->haengeAn (new Function ("sum",     xaSum, FALSE));
//  funList->haengeAn (new Function ("sumnan",  xaSumNaN, FALSE)); // PC 20010125 
  funList->haengeAn (new Function ("prod",    xaMul, FALSE));
//  funList->haengeAn (new Function ("prodnan", xaMulNaN, FALSE)); // PC 20010125
  funList->haengeAn (new Function ("max",     xaMax, FALSE));
  funList->haengeAn (new Function ("min",     xaMin, FALSE));
  funList->haengeAn (new Function ("cumsum",  xaCumsum, FALSE));
//  funList->haengeAn (new Function ("cumsumnan", xaCumsumNaN, FALSE)); // PC 20010125 
  funList->haengeAn (new Function ("cumprod",  xaCummul, FALSE));
//  funList->haengeAn (new Function ("cumprodnan", xaCummulNaN, FALSE)); // PC 20010125
  funList->haengeAn (new Function ("mean",    xaMean, FALSE));
//  funList->haengeAn (new Function ("meannan", xaMeanNaN, FALSE)); // PC 20010125
  funList->haengeAn (new Function ("var",     xaVar, FALSE));
//  funList->haengeAn (new Function ("varnan",  xaVarNaN, FALSE)); // PC 20010125
  funList->haengeAn (new Function ("cov",     xaCov, FALSE));    // PC 20010124
//  funList->haengeAn (new Function ("covnan",  xaCovNaN, FALSE)); // PC 20010125
  funList->haengeAn (new Function ("minind",  xaMinInd));
  funList->haengeAn (new Function ("maxind",  xaMaxInd));
  funList->haengeAn (new Function ("median",  xaMedian));        // PC 20010221
//  funList->haengeAn (new Function ("mediannan", xaMedianNaN));   // PC 20010221
  funList->haengeAn (new Function ("mseq", xaMseq, FALSE));      // PC 20010222
  funList->haengeAn (new Function ("aseq", xaAseq, FALSE));      // PC 20010222
#endif

  funList->haengeAn (new Function ("knn",       knn));
  funList->haengeAn (new Function ("##",        vectorize));

#ifdef MATRIX
  funList->haengeAn (new Function ("matrix",   bmatrix));
  funList->haengeAn (new Function ("min",   minc));
  funList->haengeAn (new Function ("max",   maxc));
  funList->haengeAn (new Function ("sum",   sumc));
  funList->haengeAn (new Function ("prod",  prodc));
  funList->haengeAn (new Function ("eigsm", eigen));
  funList->haengeAn (new Function ("sort",  sort));
#endif

#ifdef _GRAPHICS_  
  funList->haengeAn (new Function ("editmac",  editMacroText));
  funList->haengeAn (new Function ("edit",     editXplDouble));
#endif

  funList->haengeAn (new Function ("logfile",  logfile));  // SK 10.02.99
  funList->haengeAn (new Function ("output",   outputFile));
  funList->haengeAn (new Function ("info",     xaInfo));  // SK 04.02.02

#if defined (PSGEN) || defined (_UNIX_) ||  defined (_GRAPHICS_)  || defined (__BORLANDC__)
  InstallGraphicsFunctions();	//SWS!!!
#endif

#ifndef MATRIX
  initsk ();                    // Sigbert's functions
#endif

  // Now sort the functions in alphabetic order
  qsortlist (*funList, 0, funList->laenge()-1);

  alreadyInvoked = TRUE;
}

void NewHandler ()
{
extern class GlobalList parselist;

#ifndef SOCKETSERVER
  cerr << "In " << CurrentMacro << " line " << parselist.CurrentLine () << endl;
  cerr << "Error in new: No memory left" << endl;
  cerr << "XploRe(" << (long) getpid() << ") goes down ..." << endl;
#else


  //  sockout ("Error in new: No memory left\n");
  //  sockout ("Server goes down\n");
  //  close (sock);
  protocol->sendString ("Error in new: No memory left\n");
  protocol->sendString ("Server goes down\n");
  delete protocol;
#endif


  globalError.Set (ERR_INTERN, "no mem ttk");
//  return;
  exit(1);
}

void InterruptHandler (int i)
{
#ifdef SOCKETSERVER
  time_t sec;
  time (&sec);
  struct tm *ts = localtime (&sec);

  if (i != SIGINT)
    {
    cout << asctime (ts) << "\tXploRe socket server(" << (long) getpid();
    cout << ") goes down" << endl;

    //    cout << "sock = " << sock << endl;
    //    close (sock);
    protocol->close ();
    exit (0);
    }
#else
  cerr << "in InterruptHandler i = " << i << endl;
#endif

  if ((long) signal (SIGINT, SIG_IGN) != (long) SIG_IGN)       // reinstall handler
    signal (SIGINT, InterruptHandler);

  if (globalError.GetNumber () == ERR_INTR)      // interrupt already notified
    return;
 
  globalError.Set (ERR_INTR, "Interrupted");
}


#ifdef _RPCXGOBI_         // SKs parameter evaluation
void parse (const char*);                         // prototyping 

extern "C" {                        // we need C now

void ccparse (char *line)    { parse(line); }

void writevarinstring (char *instr, char *outstr)
// SKs RPC extension   10.4.97
{ long i, s;
  char tmp[80];
  const char *text;
 
 
  //  printf ("XploRe: getvar %s\n", instr);
  sprintf (outstr, "");
  if (instr==NULL) return;
  s = objList->laenge();
  for (i=0; i<s; i++)
  { text = (*objList)[i]->Name();
    if (strcmp(text, instr)==0)
      break;
 
  }
  if (i==s) return;
    switch((*objList)[i]->DefaultType())
    { case C_XPLDOUBLE: 
        XplDouble *rx;
        rx = (*objList)[i]->DefaultXplDouble();
        for (i=0; i<rx->size(); i++)
        { sprintf (tmp, "%f ", (*rx)[i]); 
          strcat (outstr, tmp);
        }
        break;   
    }
 
}

}  // of C
#endif

#ifdef __BORLANDC__           //SWS 16.09
#include <math.h>
int _matherr (struct exception *a)
{
	 return 1;
}
#endif

