/* $Header: /home/xplore/cvs/xpl4gr/init.h,v 1.3 2002/08/16 12:31:43 sigbert Exp $ */

#ifndef _INIT_H_
#define _INIT_H_

// #pragma interface

// Initializes Interpreter
// TTK 11.2.95

#include "machine.h"

#ifdef HAS_IOSTREAMH
#include <iostream.h>
#else
#include <stream.h>
#endif

#ifdef _RPCXGOBI_
#define STARTUPNAMELENGTH 1024

extern char startupname[STARTUPNAMELENGTH];     // SKs paramter evaluation
#endif

#include "liste.h"
#include "object.h"
#include "macro.h"
#include "xplcalc.h"
#include "xplpp.h"
#include "xplerror.h"


void  InitializeProperties  (int argc, char** argv);

void  InitializeInterpreter (int argc, char** argv);
void  InstallFunctions      (void);
void  InstallObjects        (void);
void  NewHandler            (void);
void  InterruptHandler      (int);

extern Liste<XplObject*>    *displayList, *constList, *objList, *globObjList;
extern Vector<Macro*>        *macList;
extern Vector<Function*>     *funList;
extern Liste<XplObject*>    *tmparg, *seltmp;

extern class GlobalList     *newgl;
extern MacroText            *mtp, *origmtp;
extern Liste<const char*>   *ctmp;

extern char *xpl4home, *xpl4lib, *xpl4dll, *xpl4help, *xpl4parsefile, *outputformat;
extern char *xpl4prog, *xpl4backup;
extern char *outputstringformat;

extern char *WWWBrowser;
extern char *WWWStartPage;
extern const char *CurrentMacro;
extern char *programId, *expireString;


extern char *xpl4data;

#ifdef TTKDEBUG
extern int ttkdebug;
#endif

inline int InMacro (void)  { return (objList != globObjList); }

#endif   // of INIT

