/* $Header: /home/xplore/cvs/xpl4gr/initgra.C,v 1.4 2003/05/23 15:50:17 cizek Exp $ */

#include <sys/types.h>
#include <fstream.h>
#include <time.h>

#include "machine.h" // SK 03.05.99
#include "function.h"
#include "xplfun2.h"
#include "macro.h"

#include "main.h"
#include "init.h"
#include "color.h"
#include "display.h"
#include "plot.h"

#include "xplio.h"
#include "xchar.hpp"
#include "directory.h"
#include "logfile.h"

#include "xplore_strings.h"

#ifdef _GRAPHICS_

#include <X11/keysym.h>
#include <X11/keysymdef.h>

extern int which_font(int);

#ifdef _GUIDO_
	int starttime;
	char *gformat="%s %4d\t%s\t%s\t%s\n";
	char *gfname;
#endif

/* in vismat.h steht #define FONTS_TO_LOAD 8	*/
char *xplfont_name[]={	
                         XMSG_UNIXFONT_TIMES10_STR,
                         XMSG_UNIXFONT_TIMES12_STR,
                         XMSG_UNIXFONT_TIMES14_STR,
                         XMSG_UNIXFONT_TIMES16_STR,
                         XMSG_UNIXFONT_TIMES18_STR,
                         XMSG_UNIXFONT_TIMES20_STR,
                         XMSG_UNIXFONT_TIMES22_STR,
                         XMSG_UNIXFONT_TIMES24_STR
			};
char *xplfont_vorname[]={	"Roman-10", "Roman-12", "Roman-14", "Roman-16",
			"Roman-18", "Roman-20",  "Roman-22", "Roman-24"}; 

XFontStruct * every_font_info[FONTS_TO_LOAD];
XmFontList PlotAllFont;
extern Colormap cmap;	//OK

#endif

extern void InstallGraphicsFunctions();

//Liste <XplColor *> all_colors;
//Liste <XplSymbol *> all_symbols;

//extern int InitSymbolList();
//extern int InitColorList();

extern "C"	{


#ifdef _UNIX_
extern BS_Glob_Variable bs_glob_variable;
#endif

extern char *xpl4home;	

#ifdef _GRAPHICS_

Liste <Widget> *top_liste;
GC every_gc;
extern Widget com_wid;


void try_quitCB(Widget w, XtPointer p1, XtPointer p2)
{	int i, j;
/*	globalError.Set (ERR_INTERN, "Bye-bye");
	for (i=0; i<10; i++)
			globalError.Set (ERR_INTERN, "Bye-bye");
*/
	exit(1);
} 

static String fallbacks[]=	{
	"Xplore*plotdef.borderWidth:	1",
	"Xplore*plotdef.borderColor:	grey50",

	"Xplore*visibleItemCount:	10", 
	"Xplore*XploRe_dialog.dialogStyle:	XmDIALOG_SYSTEM_MODAL",

	"Xplore*error.dialogStyle:	XmDIALOG_SYSTEM_MODAL",
	"Xplore*warning.dialogStyle:	XmDIALOG_SYSTEM_MODAL",

	"Xplore*XploRe_Functions.y:	100",
	"Xplore*XploRe_Macros.x:	400",
	"Xplore*XploRe_Macros.y:	100",
	"Xplore*XploRe_macro_edit.width:	500",

//	"Xplore*fontList:	-*-helvetica-bold-r-*--18-*-*-*-*-*-*-*=times-18",
	"Xplore*com_text.background:	blue",
	"Xplore*background:	white",

	"Xplore*error.foreground:	black",
	"Xplore*error.background:	red",
	"Xplore*error_popup.title:	XploRe_Error_Box",

	"Xplore*warning.foreground:	black",
	"Xplore*warning.background:	green",
	"Xplore*warning_popup.title:	XploRe_Warning_Box",

	"Xplore*XploRe_out.x:	500",

	"Xplore*text.value:	Default",

	"Xplore*functions.editMode:	MULTI_LINE_EDIT",
	"Xplore*XploRe_Functions.width:	250",
	"Xplore*out_text.rows:	10",
	"Xplore*out_text.editMode:	MULTI_LINE_EDIT",
	"Xplore*out_text.editable:	False",

	"Xplore*XploRe_edit.x:	500",
	"Xplore*XploRe_edit.y:	100",

	"Xplore*XploRe_edit.width:	550",

	"Xplore*XploRe_out.width:	400",

	"Xplore*XploRe_Info.width:	500",
	"Xplore*XploRe_Info.y:	55",

	"Xplore*XploRe_macroedit.width:	400",
//	Xplore*draw.width:	500

	"Xplore*default_menu.height:	50",

	"Xplore*edit_text.editMode:	MULTI_LINE_EDIT",
	"Xplore*edit_text.rows:	7",

	"Xplore*info_text.rows:	3",

	"Xplore*filename_di_popup.title:	Save Program as...",
	"Xplore*filename_di.textString:	xplore.log",

//	"Xplore*prog_text*fontList:	-*-courier-medium-r-*--18-*-*-*-*-*-*-*",

        XMSG_UNIXFONT_FL_COURIER18_STR,

//	CommandoWidget
	"Xplore*com_text.promptString:	Please enter command:",
	"Xplore*button_0.labelString:	Help",
	"Xplore*button_1.labelString:	Objects",
	"Xplore*button_2.labelString:	Info",
	"Xplore*button_3.labelString:	Data",
	"Xplore*button_4.labelString:	Programs",
	"Xplore*button_5.labelString:	Help",
	"Xplore*button_6.labelString:	Info",
	"Xplore*button_7.labelString:	Save",
	"Xplore*button_8.labelString:	Quit",
	"Xplore*button_9.labelString:	Help",

//	Dialoganfrage fuer Data laden
	"Xplore*data_box.pattern:	*.dat",
//	"Xplore*data_box.dirMask:	/user/schmelzer/xplore4/data/*.dat", // */
	"Xplore*data_box_popup.title:	XploRe_data_selection",

//	Dialoganfrage fuer Programm laden
	"Xplore*prog_box.pattern:	*.xpl",
//	"Xplore*prog_box.dirMask:	/user/schmelzer/xplore4/programm/*.prg",  // */
	"Xplore*prog_box_popup.title:	XploRe_programs_manager",

//	Xplore*file_box_popup.title:	XploRe_programs_box",

	"Xplore*prog_popup.title:	XploRe_programs_editor",
	"Xplore*go_to_line_popup.title:	XploRe_goto",

	"Xplore*go_to_line.selectionLabelString:	Go to line:",

//	Menu zum Aendern Window_part
	"Xplore*window_menu_1.labelString:	Headline on",
//	"Xplore*window_menu_2.labelString:	Axis off",
	"Xplore*window_menu_3.labelString:	Edit headline",
	"Xplore*window_menu_4.labelString:	Edit axis",

//	Menu zum Aendern Axiseinstellung
	"Xplore*axis_option.labelString:	Axis:",
	"Xplore*axis_lab_2.labelString:	Origin:",
	"Xplore*axis_lab_3.labelString:	Step:",
	"Xplore*axis_lab_4.labelString:	m:",
	"Xplore*axis_lab_5.labelString:	k:",

	"Xplore*ax_1*labelString:	1. column: X",
	"Xplore*ax_2*labelString:	2. column: Y",

//	Menu zum Aendern data_art
	"Xplore*contr_panel_0.labelString:	Anything",
	"Xplore*contr_panel_1.labelString:	As Point",
	"Xplore*contr_panel_2.labelString:	As Circle",
	"Xplore*contr_panel_3.labelString:	As Nothing",
	"Xplore*contr_panel_9.labelString:	As FillCircle",
	"Xplore*point_option.labelString:	Point",

	"Xplore*contr_panel_4.labelString:	No Line",
	"Xplore*contr_panel_5.labelString:	Solid",
	"Xplore*contr_panel_6.labelString:	OnOffDash 1",
	"Xplore*contr_panel_7.labelString:	OnOffDash 2",
	"Xplore*line_option.labelString:	Lines",

	"Xplore*str_color.labelString:	this",
	"Xplore*contr_panel_8.labelString:	this",
	"Xplore*color_option.labelString:	Color",

	"Xplore*contr_close.labelString:	Cancel",
	"Xplore*contr_apply.labelString:	Apply",
	"Xplore*contr_apply.mnemonic:A",
	"Xplore*alignment:	ALIGNMENT_CENTER",

//	labelstrings fuer dialogs
	"Xplore*okLabelString:	OK",
	"Xplore*cancelLabelString:	Cancel",
	"Xplore*helpLabelString:	Help",

//	Labels und Mnemonic fuer plotwidget
	"Xplore*data_but.labelString:	Data",
	"Xplore*data_but.mnemonic:	D",
	"Xplore*win_but.labelString:	Window",
	"Xplore*win_but.mnemonic:	W",
	"Xplore*quit_but.labelString:	Close",
	"Xplore*quit_but.mnemonic:	C",
	"Xplore*Demo_but.labelString:	DeMo",
	"Xplore*Demo_but.mnemonic:	M",
	"Xplore*reset_but.labelString:	Reset",
	"Xplore*reset_but.mnemonic:	R",
	"Xplore*dr_st_but.labelString:	Draw String",
	"Xplore*dr_st_but.mnemonic:	S",

	"Xplore*string_move.labelString:	Move",
	"Xplore*string_move.mnemonic:	M",


	"Xplore*head.labelString:	PICTURE",

	"Xplore*head_di.selectionLabelString:	Enter headline please:",

//	Xplore*file_box.okLabelString:	\nClose
//	Xplore*file_box.applyLabelString:	Select\nand\nexecute",
//	Xplore*file_box.cancelLabelString:	Select\nand\nedit",

	"Xplore*edit_prog.okLabelString:	Execute",

	"Xplore*go_to_line.okLabelString:	go to",

	"Xplore*filename_di.selectionLabelString:	Enter filename please:",

	"Xplore*result.labelString:	Result:",
			
	
	"Xplore*index_label.borderWidth:	0",

//	"Xplore*draw.borderWidth:	1",
	"Xplore*text.borderWidth:	1",
//	"Xplore*draw.borderColor:	light grey",
		NULL
				};
				
#endif


#if defined (_GRAPHICS_)
#ifdef _DECALPHA_
int InitShellOnly(unsigned int argc, char** argv)
#else
int InitShellOnly(int argc, char** argv)
#endif
{
	bs_glob_variable.main_shell=	
			XtVaAppInitialize(&(bs_glob_variable.kontext),"Xplore",
				(XrmOptionDescRec*)NULL, 0,
				&argc, argv,
			fallbacks, NULL);
	if (bs_glob_variable.main_shell==NULL)
		return(1);
}
#endif

int InitMainShell(int argc, char** argv)
{	
#ifdef _GUIDO_
#define GUIDOTRY 64
	int num=1;
	Boolean found=False;
	int mal=0;
	FILE *nf;
	gfname=new char [124];
	while ( (! found ) && (mal<GUIDOTRY))
	{	sprintf(gfname, "guido%d.log", num); 
#ifdef _BLABLA_
		cout<<"ziel="<<gfname<<endl;
#endif
		nf=fopen(gfname, "r");
		if (!(nf==NULL)) 
		{	fclose(nf);
#ifdef _BLABLA_
		cout<<gfname<<" exists already"<<endl;
#endif					
		num++;
		}
		else
		{	fclose(nf);
			nf=fopen(gfname, "w");
			if (!(nf==NULL))
			{	fclose(nf);
#ifdef _BLABLA_
			cout<<"hurra! "<<gfname<<endl;
#endif				
			found=True;
			}
			else 
				num++;
		}
			mal++;
	}	
	if (mal==GUIDOTRY)
	{	globalError.Set (ERR_FILE, gfname);
		globalError.ShowError();
		return(0);
	}		
	FILE *gfile=fopen(gfname, "w+");
	long lt=time(NULL);
	fprintf(gfile, "%s", ctime(&lt));
	starttime=time(NULL);
	fclose(gfile);
#endif

	//InstallGraphicsFunctions();
#ifdef _GRAPHICS_
	XColor rgb_exact;
	Display *dis;
	int i, j, bitwi, bithe, x_hot, y_hot;
	Widget out_shell;
	char fname[126];

	
//	XtWorkProcId work_id;


/*	bs_glob_variable.main_shell=	
			XtVaAppInitialize(&(bs_glob_variable.kontext),"Xplore",
				(XrmOptionDescRec*)NULL, 0,
				&argc, argv,
				fallbacks, NULL);
	if (bs_glob_variable.main_shell==NULL)
		return(1);
*/
	dis=XtDisplay(bs_glob_variable.main_shell);

//	work_id=XtAppAddWorkProc(bs_glob_variable.kontext, font_init, 
//				(XtPointer) dis);	
		

	//cout<<"Die Farben werden geladen..."<<endl;
	//InitColorList();
	//cout<<"Die Bitmaps werden geladen..."<<endl;
	//InitSymbolList();

	every_gc=XCreateGC(dis, 
			RootWindow(dis,DefaultScreen(dis)),
			0, NULL);
	if (every_gc==NULL)
	{	printf("ERROR: Cannot create GC\n");
		return(1);
	}
#ifdef _BLABLA_
		cout<<" Load fonts..."<<endl;
#endif
	for (i=0; i<FONTS_TO_LOAD; i++)
	{	every_font_info[i]=XLoadQueryFont(dis, xplfont_name[i]);
		if (every_font_info[i]== NULL)
		{	cerr<<xplfont_name[i]<<" fonterror"<<endl;
			every_font_info[i]=XLoadQueryFont(dis,
			 	"-*-*-*-*-*--12-*-*-*-*-*-*-*");
		}
		PlotAllFont=	i==0 ?
			XmFontListCreate(every_font_info[i],
					xplfont_vorname[i])	:
			XmFontListAdd(PlotAllFont,
					every_font_info[i], xplfont_vorname[i]);
			
	}

//	XSetFont(dis, every_gc, every_font_info->fid);

	return(0);
#endif
return(0);
}

void startup(char *argv0)
{	char line[256];
//        printf ("ARGV[0]=%s\n", argv0);
/*
        X4Filename autoload;
        autoload.setname(argv0);
	*/
#ifdef _GRAPHICS_
	Widget list;
	XmString xms;
#endif
	int pos;
	char text[50000];

/*
#ifdef _RPCXGOBI_
	ifstream f(startupname);
#else
	ifstream f("startup.xpl");
#endif
*/
	// SK 03.05.99
        xplmessage (programId);
#ifdef _EXPIRE_
        xplmessage (expireString);
#endif

	/*
        // SK 27.10.2000 autoexec.xpl wg. autoload
        sprintf (line, "%sautoload.xpl", autoload.getpath());
	//	printf ("AUTOLOAD=%s ARGV0=%s\n", line, argv0);
        ifstream g(line);
	if (!g || (!g.good()) || g.eof())
	{
	  sprintf (text, "Warning: No autoload.xpl loaded\n         Autoloading may not work correctly !\n");
	  xplmessage(text);
	}
        else
	{ while ( g.getline(line, 255, '\n'))
	  {
		strcat(text, line);
		strcat(text, "\n");
		pos++;
  	  }
  	  write_to_log(text);
	  parse(text);
        }
	*/
	char *startupname = property.getProperty("startup");
        ifstream f(startupname); // SK 17.07.98

	if (!f || (!f.good()) || f.eof())
	{
/*#ifdef _RPCXGOBI_
	sprintf (text, "Warning: no %s loaded\n", startupname);
#else
	sprintf (text, "Warning: no %s loaded\n", "startup.xpl");
#endif
*/
	  sprintf (text, XMSG_INITTEXT_WARNNOSTARTUP_STR, startupname); // SK 17.07.98
	  xplmessage(text);
          if (startupname) delete[] startupname;
	  return;
	}
	pos=0;
	text[0]=0;
#ifdef _GRAPHICS_
	list=XmCommandGetChild(com_wid, XmDIALOG_HISTORY_LIST);
#endif

#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
#endif
	while ( f.getline(line, 255, '\n'))
	{
#ifdef _GRAPHICS_
		xms=XmStringCreateSimple(line);
		XmListAddItem(list, xms, 0);
		XmStringFree(xms);	//OK
#endif
		strcat(text, line);
		strcat(text, "\n");
#ifdef _GUIDO_
	fprintf(gfile, gformat, "S", time(NULL)-starttime,
			"Startup", "CONTENT", line);
#endif
	//	cout<<"PARSE: "<<line<<endl;
		pos++;
	}
#ifdef _GRAPHICS_
	if (pos>10)
		XtVaSetValues(list, XmNtopItemPosition, pos-10, NULL);
#endif
	// si. visibleItemCount !!
	//cout<<"TEXT:\n"<<text<<"ENDE"<<endl;

#ifdef _GUIDO_
	fclose(gfile);
#endif


	write_to_log(text);
	parse(text);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime,
			"Startup", "EXECUTED", "");
	fclose(gfile);
#endif


}
#ifdef _GRAPHICS_

extern void selected_to_parser(Widget, XtPointer, XmListCallbackStruct *);
//extern Widget init_objects(Widget menu, Widget button);
//extern void update_objCB(Widget w, XtPointer p1, XtPointer p2);
extern void show_prog_box(Widget w, XtPointer p1, XtPointer p2);
extern Widget init_axisborders_menu();

extern Liste <char *> to_destroy;

void quit_allCB(Widget w, XtPointer p1, XtPointer p2)
{	Widget file_list=XmCommandGetChild(com_wid, XmDIALOG_HISTORY_LIST);
	String str;
	XmString *strtable;
	char msg[256];
	int n, count;
	char *fn;
	
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Command", "CLICK",
			"Quit");
	fclose(gfile);
#endif	

#ifdef _BLABLA_
	cout<<to_destroy.laenge()<<" files to destroy\n";
#endif
	for (n=0; n<to_destroy.laenge(); n++)
		{	//cout<<to_destroy[n]<<endl;
			remove(to_destroy[n]);
			delete to_destroy[n];
		}
#if defined (_BLABLA_)
	int ret;
	Display *dis=XtDisplay(bs_glob_variable.main_shell);
	int snum=DefaultScreen(dis);

	Colormap * ccmm=XListInstalledColormaps(dis, RootWindow(dis, snum) ,
				&ret);
	cout<<" By CommandWindow "<<ret<<" colormaps are installed"<<endl;
	XFree(ccmm);	
	//XUninstallColormap(XtDisplay(w), cmap);	//OK
#endif
	exit(0);
}

void ask_for_quitCB(Widget w, XtPointer p1, XtPointer p2)
{	Widget ask;
	ask=XmCreateWarningDialog(bs_glob_variable.main_shell, "warning",
				 (Arg*) NULL,0);
	XtAddCallback(ask, XmNokCallback, quit_allCB, NULL);

	XtUnmanageChild(XmMessageBoxGetChild(ask, 	
				XmDIALOG_HELP_BUTTON));
	XmString result=XmStringCreateLtoR("Do you really to want to exit?", 
			XmSTRING_DEFAULT_CHARSET);
	XtVaSetValues(ask, XmNmessageString, result, NULL);
	XtManageChild(ask);
	
	
}

void icon_all(Widget w, XtPointer p, XEvent *cbs, char *ch)
{	int co, i;
	Widget *wi;
	
	if (cbs->xany.type!=UnmapNotify)
	return;
	co=top_liste->laenge();
	for (i=0; i<co; i++)
	{	//cout<<XtName((*top_liste)[i])<<endl;
		XIconifyWindow(XtDisplay(bs_glob_variable.main_shell),
		XtWindow((*top_liste)[i]),
		DefaultScreen(XtDisplay(bs_glob_variable.main_shell)));
	}
}		
#endif // GRAPHICS


int LoopMainShell()
{
#ifdef _GRAPHICS_
	XtRealizeWidget(bs_glob_variable.main_shell);
	//extern void 	TestScaledPix(void);
	//TestScaledPix();
	//startup();
	XtAppMainLoop(bs_glob_variable.kontext);

#endif
	return(0);
}
		}
