/* $Header: /home/xplore/cvs/xpl4gr/main.C,v 1.4 2003/02/23 16:56:42 cizek Exp $ */

#ifdef __MINGW32__
#include "windows.h"
#endif

#include "main.h"
#include "init.h"
#include "xplpp.h"

#ifdef _RPCXGOBI_
#include "startup.h"
#include "xplxgobi.h"
#endif

#ifndef __BORLANDC__
#ifndef __APPLE_CC__
#include <stream.h>
#else
#include <iostream.h>
#endif
#endif

#include <fstream.h>
#ifdef SOCKETSERVER    // SK 20.02.99
#include <osfcn.h>
#endif
#include <string.h>

extern void logt (const char *txt);
extern void loginit ();

extern int quiet;

char **make_arg (int *argc, char *cmdline)
{ char **argv, *cmd = strdup (cmdline);
  char seps[]   = " ,\t\n";
  char *token;

// translate cmdline into argc, argc format
  token = strtok (cmd, seps);
  *argc = 0;

  while (token != NULL)
  { (*argc)++;
    token = strtok (NULL, seps);
  }
  
  argv = new char*[(*argc)+1];
  strcpy (cmd, cmdline);

  token = strtok (cmd, seps);

  int i = 0;
  while (token != NULL)
  { argv[i++] = token;
    token = strtok (NULL, seps);
  }

  return (argv);
}

#ifdef X4standalone
// Standalone versions

#include "plot.h"

#ifdef __BORLANDC__

// Windows standalone

extern int X4OwlMain(int argc, char* argv []);

int OwlMain(int argc, char* argv [])
{ loginit();
  return (X4OwlMain(argc, argv)); 
}

#else 
// Unix standalone

//BS_Glob_Variable	bs_glob_variable;

//void InitializeProperties (int argc, char **argv);
		
// Unix standalone

int main(int argc, char** argv)
{ int swedebug=True;

  loginit();
  X4Start (argc, argv);
  InitMainShell(argc, argv);
  InitCommandFenster(argv[0]);
  LoopMainShell();
}
#endif

#endif // X4standalone

#ifdef X4batch
// Batch oder Singleserver version

#ifdef X4singleserver
// Singleserver version

#ifdef __MINGW32__
// Windows singleserver


int STDCALL WinMain (HINSTANCE hInstCurrent, HINSTANCE hInstPrevious,
                     LPSTR lpszCmdLine, int nCmdShow)
{ int argc;
  char **argv;

  loginit ();
  //logt ("WinMain");
  argv = make_arg (&argc, lpszCmdLine);
  ttkdebug = (argc == 2) || (argc >= 4);

  //logt ("X4Start");
  X4Start(argc, argv);
  //logt ("StartXploRe");
  StartXploRe (argc, argv);
  if (!quiet) { // SK 16.11.2004
    cout << "XploRe: Good bye ..." << endl;
  }
  //  exit (0);
  //  cerr << "should never be seen ..." << endl;
  return (0);
}

#else
// Unix singleserver

int main (int argc, char **argv)
{
  ttkdebug = (argc == 2) || (argc >= 4);

  loginit();
  X4Start(argc, argv);
  StartXploRe (argc, argv);
  if (!quiet) { // SK 16.11.2004
    cerr << "XploRe: Good bye ..." << endl;
  }
  exit (0);
  cerr << "should never be seen ..." << endl;
  return (0);
}

#endif
#else
// Batch Version

int main (int argc, char **argv)
{
  loginit();
  X4Start(argc, argv);
  StartXploRe (argc, argv);
  if (!quiet) { // SK 16.11.2004
    cerr << "XploRe: Good bye ..." << endl;
  }
  exit (0);

  cerr << "should never be seen ..." << endl;
  return (0);
}

/*
#ifdef __BORLANDC__
// Windows batch version

#else
// Unix batch version

#endif
*/

#endif // X4singleserver

#endif // X4batch

