/* $Header: /home/xplore/cvs/xpl4gr/nelmin4.C,v 1.3 2002/08/16 12:31:46 sigbert Exp $ */

#include<stdio.h>
#include<math.h>

#include "object.h"   
#include "xplexec.h"
#include "xplerror.h"

#ifndef MATRIX
#define rows() dimension(0)
#define cols() dimension(1)
#define out()  dump("%lg")
#endif


  void       mean     (XplDouble &M, XplDouble S, int dim, XplDouble d, int p);
  double     var      (XplDouble V, int p, int m);
  double     Diff_FV  (XplDouble V, int n);
  void       Voutp    (XplDouble &Erg, XplDouble V, XplDouble P, int l, int k);
  void       Vout     (XplDouble &Erg, XplDouble V, int l, int P);
  void       maxindex (XplDouble &ind, XplDouble V, int dim, int p);
  int        minindex (XplDouble V, int dim, int p);
  void       reflex   (XplDouble &Erg, XplDouble V1, XplDouble V2, 
		       int dim, int p);
  void       funct    (XplDouble &Erg, XplDouble D, int p);
  void       Simplex  (XplDouble &Erg, XplDouble In, double St, 
		       int p, int n, XplDouble C);




XplDouble nelmin(XplDouble StV, const char *fun, double reqmin, double Step, int &icount)

{
int  p, n, konv, count, i, j, k, l, Mini,MaxIter, funcount;                        
void *id;

id = StartExecution ();

p=StV.cols();
n=StV.rows(); 


double    fmin, NiFun, yxk1, yxk2, Di, VM; 
int	  SumCh, NachIter, NI_N, Mitte, Minimum, NI_Zaeh, NI_icount, NI_icount_old;          

XplDouble ysk(p*(n+1)), sk(n,p*(n+1)), yR(4*p), *xk, V(p), 			 	//   *   double
	  R(n,4*p), D(n,p), Min(n), A(n,p), f(p+2), Erg(n,p),ErgZ(n),			//   *   double
	  NI(n,p), NIa(n,p), *yxk, NI_Min2(n),						//   *   double
 	  notzero(p), funcval(p), Mind(p), MiniV1(p), MiniV2(p), Ch(p);    			//   *   integer

long      translated = 0L;

char      cmd[1024];



// Fehlerkontrolle
if (reqmin<0) 
	{
	globalError.Set(ERR_NELMIN, "eps (4. argument) must be >= 0");
	return(Erg);
	}
if (icount<1) 
	{
	globalError.Set(ERR_NELMIN, "maxiter (3. argument) must be >= 1");
	return(Erg);
	}
if (Step<=0) 
	{
	globalError.Set(ERR_NELMIN, "step (5. argument) must be > 0");
	return(Erg);
	}

XplDouble xkinit(n), yxkinit(1);


GenerateXplObject ("yy", &xkinit, id, TRUE);
// GenerateXplObject ("x", &yxkinit, id, TRUE);





//        ***************   MAIN   *****************************+

 

MaxIter=icount;
funcount=0;
SumCh=1;
for (i=0; i<p; ++i) Ch(i)=1.0;
NI_N=0;

while ((SumCh>0) && (icount>0))
{

for (i=0; i<p; ++i) 
	{
	notzero(i)=1;
	funcval(i)=1;
	}


konv=1;


Simplex(sk, StV, Step, p, n, Ch);




while ((icount>0) && (konv>0))
{

xk  = (XplDouble *) GetXplObject ("yy", id);
sprintf (cmd, "x = %s (yy)", fun);

for (j=0; j<p; ++j)
  {
  if ((notzero(j)==1) && (funcval(j)==1))
    {
    funcount=funcount+1;	
    for (l=0; l<(n+1); ++l)
	{
	for (i=0; i<n; ++i) (*xk)(i)=sk(i,j*(n+1)+l);
	Execute (cmd, id, translated);            // x = fun (xk)
	yxk = (XplDouble *) GetXplObject ("x", id);
	if (yxk == NULL) 
		{
		globalError.Set(ERR_NELMIN, "Null pointer error");
		return(Erg);
		}
	ysk(j*(n+1)+l)=(*yxk)(0);
	}
    funcval(j)=0;
    }
  }


//  funct(ysk, sk,(n+1)*p);

maxindex(Mind,ysk,n+1,p);
Voutp(A, sk, Mind, n,p);
mean(D, sk, n, Mind,p);
reflex(R, A, D, n, p);

// GenerateXplObject ("yy", xk, TRUE);
// GenerateXplObject ("x", yxk, TRUE);

xk  = (XplDouble *) GetXplObject ("yy", id);
sprintf (cmd, "x = %s (yy)", fun);


for (j=0; j<4*p; ++j)
	{
	for (i=0; i<n; ++i) (*xk)(i)=R(i,j);
	Execute (cmd, id, translated);            // x = fun (l)
	yxk = (XplDouble *) GetXplObject ("x", id);
	if (yxk == NULL) 
		{
		globalError.Set(ERR_NELMIN, "Null pointer error");
		return(Erg);
		}
	yR(j)=(*yxk)(0);
	}

for (k=0; k<p; k++)
{
    if (notzero(k)==1)
    {
	count=0;
	for (i=0; i<n+1; ++i)
		{
		if (i!=(int)Mind[k])
			{
			if (yR(k*4+0) >= ysk(k*(n+1)+i)) ++count;
			}
		}
	if (count == n)
		{
		if (ysk(k*(n+1)+(int)Mind(k)) < yR(k*4+0)) 
			{
			Vout(Min,R,n,k*4+3);
			fmin=yR(k*4+3);
			if (fmin > ysk(k*(n+1)+(int)Mind(k)))
				{
				Mini=minindex(ysk,n+1,k*(n+1));
				for (l=0; l<(n+1); l++)
					{
					if (l!=Mini)
					{
					for(j=0; j<n; j++)
						sk(j,k*(n+1)+l)=.5*(sk(j,k*(n+1)+Mini)+sk(j,k*(n+1)+l));
					}
					}
				fmin=ysk(k*(n+1)+Mini);
				funcval(k)=1;
				}
			else
				{
				for (i=0; i<n; ++i)   sk(i,(n+1)*k+(int)Mind(k))=Min(i);
				ysk(k*(n+1)+(int)Mind(k))=fmin;
				}
			}
		else 
			{
			Vout(Min,R,n,k*4+2);
			fmin=yR(k*4+2);
			if (fmin > yR(k*4+0))
				{
				Mini=minindex(ysk,n+1,k*(n+1));
				for (l=0; l<(n+1); l++)
					{
					if (l!=Mini)
					{
					for(j=0; j<n; j++)
						sk(j,k*(n+1)+l)=.5*(sk(j,k*(n+1)+Mini)+sk(j,k*(n+1)+l));
					}
					}
				fmin=ysk(k*(n+1)+Mini);
				funcval(k)=1;
				}
			else
				{
				for (i=0; i<n; ++i)   sk(i,(n+1)*k+(int)Mind(k))=Min(i);
				ysk(k*(n+1)+(int)Mind(k))=fmin;
				}
			}
		}
	else
		{
		fmin=yR(0+k*4);
		Vout(Min,R,n,k*4);
		if ((count==0) && (yR(k*4)>yR(k*4+1)))
			{
			fmin=yR(k*4+1);
			Vout(Min,R,n,k*4+1);
			}
		for (i=0; i<n; ++i)   sk(i,(n+1)*k+(int)Mind(k))=Min(i);
		ysk(k*(n+1)+(int)Mind(k))=fmin;
		}

	V(k)=var(ysk,(n+1)*k,n+1);

	if((int)Ch(k)==1)
		{
		Di=Diff_FV(ysk,n);
		if (Di < 1e-8*fabs(ysk(k*(n+1)+minindex(ysk,n+1,k*(n+1))))+1e-8)  notzero(k)=0;
		}
	else
		{
		if (V(k) < reqmin) notzero(k)=0;
		}
    }




}
//  k=0...p-1 Schleife Ende


		

icount--;
konv=0;
for (i=0; i<p; ++i)
	{
	if (notzero(i)!=0) ++konv;
	}


}
// while Ende



xk  = (XplDouble *) GetXplObject ("yy", id);

sprintf (cmd, "x = %s (yy)", fun);


for (j=0; j<(n+1)*p; ++j)
	{
	for (i=0; i<n; ++i) (*xk)(i)=sk(i,j);
	Execute (cmd, id, translated);            // x = fun (l)
	yxk = (XplDouble *) GetXplObject ("x", id);
	if (yxk == NULL) 
		{
		globalError.Set(ERR_NELMIN, "Null pointer error");
		return(Erg);
		}
	ysk(j)=(*yxk)(0);
	}


for (k=0; k<p; ++k)
	{
	Mini=minindex(ysk,n+1,k*(n+1));
	Vout(ErgZ, sk, n, k*(n+1)+Mini);
	MiniV1(k)=Mini;
	for (i=0; i<Mini; ++i) NI_Min2(i)=ysk(k*(n+1)+i);
	for (i=(Mini+1); i<(n+1); ++i)
		{ 
		NI_Min2(i-1)=ysk(k*(n+1)+i);
		}
	Mini=minindex(NI_Min2,n,0);            		
	if ((int)MiniV1(k)>Mini) 
		MiniV2(k)=Mini;	
	else
		MiniV2(k)=Mini+1;		
	for (i=0; i<n; i++) Erg(i,k)=ErgZ(i);

        }


// *************  Nachiteration  ******************

mean(NI, sk, n, MiniV1,p);
NIa=Erg; 
NI_icount_old=0;
for (k=0; k<p; ++k)
   {	
      if ((int)Ch(k)==1)
	{	
	NI_icount=0;
	Ch(k)=0;
	NachIter=1;
	NiFun=ysk(k*(n+1)+(int)MiniV1(k));
	NI_Zaeh=0;
	Mitte=0; 	
	Minimum=0;
	while ((NachIter == 1) && (NI_icount<icount))
	   {


	   if (NI_Zaeh==0) 
		{
		for (i=0; i<n; ++i)	(*xk)(i)=NIa(i,k)+NIa(i,k)-NI(i,k);
		Execute (cmd, id, translated);            // x = fun (l)	
		yxk = (XplDouble *) GetXplObject ("x", id);
		if (yxk == NULL) 
			{
			globalError.Set(ERR_NELMIN, "Null pointer error");
			return(Erg);
			}
		yxk1=(*yxk)(0);	
		for (i=0; i<n; ++i)	(*xk)(i)=NIa(i,k)+NIa(i,k)-sk(i,k*(n+1)+(int)MiniV2(k));

		Execute (cmd, id, translated);            // x = fun (l)
		yxk = (XplDouble *) GetXplObject ("x", id);	
		if (yxk == NULL) 
			{
			globalError.Set(ERR_NELMIN, "Null pointer error");
			return(Erg);
			}
		yxk2=(*yxk)(0);	

		if (yxk2>yxk1) 
			{
			(*yxk)(0)=yxk1;
			for (i=0; i<n; ++i)	(*xk)(i)=NIa(i,k)+NIa(i,k)-NI(i,k);
			Mitte=1;
			}
		else 
			{
			(*yxk)(0)=yxk2;
			for (i=0; i<n; ++i)	(*xk)(i)=NIa(i,k)+NIa(i,k)-sk(i,k*(n+1)+(int)MiniV2(k));	
			Minimum=1;
			}
		}
	    else
		{
		if (Mitte == 1)
			{
			for (i=0; i<n; ++i)	(*xk)(i)=NIa(i,k)+NIa(i,k)-NI(i,k);	
			Execute (cmd, id, translated);            // x = fun (l)	
			yxk = (XplDouble *) GetXplObject ("x", id);
			if (yxk == NULL) 
				{
				globalError.Set(ERR_NELMIN, "Null pointer error");
				return(Erg);
				}
			}
		if (Minimum == 1)
			{
			for (i=0; i<n; ++i)	(*xk)(i)=NIa(i,k)+NIa(i,k)-sk(i,k*(n+1)+(int)MiniV2(k));	
			Execute (cmd, id, translated);            // x = fun (l)	
			yxk = (XplDouble *) GetXplObject ("x", id);
			if (yxk == NULL) 
				{
				globalError.Set(ERR_NELMIN, "Null pointer error");
				return(Erg);
				}
			}
		}


	    if ((*yxk)(0) < NiFun)
		{
		for (i=0; i<n; ++i) NIa(i,k)=(*xk)(i);
		NiFun=(*yxk)(0);
		NachIter=1;
		Ch(k)=1;
		}
	    else    
		{
		NachIter=0;
		}
	    NI_Zaeh++;
	    NI_icount++;
	    }
      	for (i=0; i<n; ++i) StV(i,k)=NIa(i,k);
	if (NI_icount > NI_icount_old) NI_icount_old = NI_icount;
      }
    }
    SumCh=0;
    icount=icount-NI_icount_old;
    VM=0;	
    for (i=0; i<p; ++i) 
	{
	SumCh=SumCh+(int)Ch(i);
	if (V(i)>VM) VM=V(i);
	}
    
    if ((SumCh==0) && (VM>=reqmin)) SumCh=1;



}
//  ******  Ergebnis gefunden (Ch == (0,0,...,0))




icount=MaxIter-icount;

  EndExecution (id);


if (icount>=MaxIter) 
	{
//	globalError.Set(ERR_NELMIN, "Konvergenzkriterium nicht erreicht");
//	globalWarning.Set (WARN_NOCONVERGENCE, "nelmin");
	}

return (Erg);


}
// Functionsende




//  ***************************************************************************



// initial function
void funct(XplDouble &Erg, XplDouble D, int p)
{
int i;

for (i=0; i<p; ++i)
		{
	//      Erg[i]=100*pow(D[i*2+1]-pow(D[i*2],2),2)+pow(1-D[i*2],2)+D[i*2+2];
		Erg(i)=pow(D(0,i)+6,2)+pow(D(1,i)-1,2)+pow(D(2,i)+9,2);
		}
}

 



void Simplex(XplDouble &Erg, XplDouble In, double St, int p, int n, XplDouble C)
{
int j, k, i;
for (j=0; j<p; ++j)
	{
	if (C(j)==1)
	{
	    for (k=0; k<n+1; ++k)
		{
		for (i=0; i<n; ++i)
			if (i==k-1)   Erg(i,j*(n+1)+k) = In(i,j)+St;
			else          Erg(i,j*(n+1)+k) = In(i,j);
		}
	    }
	}
}


// initial mean
void mean(XplDouble &M, XplDouble S, int dim, XplDouble d, int p)

{
int i,j,k;
double sum;

for (k=0; k<p; ++k)
{
     for (i=0; i<dim; ++i)
     {
	sum=0;
	for (j=0; j<(int)d(k); ++j)
	{
		sum=S(i,k*(dim+1)+j)+sum;
	}
	for (j=(int)d(k)+1; j<dim+1; ++j)
	{
		sum=S(i,k*(dim+1)+j)+sum;
	}
	M(i,k)=sum/dim;
     }
}
}



double var(XplDouble V, int p, int m)
{
int i;
double Erg,ErgZ,M;

Erg=0.0;
M=0.0;
for (i=0; i<m; i++)     M=M+V(i+p);
M=M/m;
for (i=0; i<m; i++)
	{
	ErgZ=(V(i+p)-M) * (V(i+p)-M);
	Erg=Erg+ErgZ;
	}
	Erg=Erg/m;
return Erg;
} 


double Diff_FV(XplDouble V, int n)
{
int i,j;
double Erg,ErgZ;

Erg=0.0;
for (i=0; i<n; ++i)
	{
	for (j=i+1;j<n;++j)
		{
		ErgZ=(V(i)-V(j));
		if (ErgZ<0) ErgZ=(-1)*ErgZ;
		if (ErgZ<Erg) Erg=ErgZ;
		}
	}
return(Erg);
}
		

// sucht k Vectoren der Lnge L raus, beginnt jeweils an P[i]  i=0...k-1
void Voutp(XplDouble &Erg, XplDouble V, XplDouble P, int l, int k)

{
int i,j;
XplDouble ErgZ(l);

for (i=0; i<k; i++)
	{
	Vout(ErgZ,V, l, i*(l+1)+(int)P(i));
	for (j=0; j<l; ++j) Erg(j,i)=ErgZ(j);
	}
}


// sucht Teilvektor der Lnge L aus einem Vektor raus, beginnt mit Position P
void Vout(XplDouble &Erg, XplDouble V, int l, int P)

{
int i;

for (i=0;i<l;i++)
	{
	Erg(i)=V(i,P);
	}
}


// Index des groeten Werts bestimmen
void maxindex(XplDouble &ind, XplDouble V, int dim, int p)

{
int i,k;
double max;


for (k=0; k<p; k++)
{
max=V(k*dim);
ind(k)=0;
for (i=1; i<dim; ++i)
	{
	if (max<V(i+k*dim))
		{
		max=V(i+k*dim);
		ind(k)=i;
		}
	}
}
}



// Index des kleinsten Werts bestimmen
int minindex(XplDouble V, int dim, int p)

{
int i,ind;
double min;

min=V(p);
ind=0;
for (i=1; i<dim; ++i)
	{
	if (min>V(i+p))
		{
		min=V(i+p);
		ind=i;
		}
	}
return ind;
}


// Reflexion von V1 an V2
void reflex(XplDouble &Erg, XplDouble V1, XplDouble V2, int dim, int p)

{
int i,j;

for (j=0; j<p; j++)
{
for (i=0; i<dim; ++i)
	{
	Erg(i,j*4)   = V2(i,j)+(V2(i,j)-V1(i,j));
	Erg(i,j*4+1) = V2(i,j)+2*(V2(i,j)-V1(i,j));
	Erg(i,j*4+2) = V2(i,j)+0.5*(V2(i,j)-V1(i,j));
	Erg(i,j*4+3) = V2(i,j)-0.5*(V2(i,j)-V1(i,j));
	}
}
}

XplDouble bfgs(XplDouble xk, const char *g, const char *dg, int &maxiter, double eps, double gamma)

/*
Dokumentation
--------------

Eingabe:
xk	= n x p Matrix, mit p Startwerten der Laenge n
*g	= Name der zu minimierenden Fkt.
*dg	= Name der Ableitung von g
maxiter = Maximale Anzahl der Iterationen
eps	= Abbruchkriterium
hk	= n*n x p Matrix, Startwerte fuer Hessematrix
gamma	= Startvalue for linesearch

Standart:
gamma=1.0, eps=1.0e-3
hk=Einheitsmatrix (p mal)

Ausgabe:
bfgs	= n x p Matrix, Koordinaten der p gefundenen Minimas
hk	= n x n x p Matrix, Hessematrix in den Minima
maxiter = Anzahl der durchgefhrten Iterationen
*/

{

double ptq, qthq, pup, pdn, cmpval, compval, pqth, hqpt, alpha=0.5;
int n, p, i, j, k, l, m, statsum, stepsum, zerosum, fail;

void *id;

id = StartExecution ();

p=xk.cols();
n=xk.rows();

// Fehlerkontrolle
if (eps<0) 
	{
	globalError.Set(ERR_NELMIN, "eps (5. argument) must be >= 0");
	return(xk);
	}
if (maxiter<1) 
	{
	globalError.Set(ERR_NELMIN, "maxiter (4. argument) must be >= 1");
	return(xk);
	}
if (p!=1) 
	{
	globalError.Set(ERR_NELMIN, "x0 (1.argument) must be a n x 1 vector");
	return(xk);
	}
// Fehlerkontrolle
if (gamma<=0) 
	{
	globalError.Set(ERR_NELMIN, "gamma (6. argument)  must be > 0");
	return(xk);
	}



XplDouble gk(p), gk1(p), dgk(n,p), dgk1(n,p), dgam(p), sk(n,p), work(n,n);
XplDouble xg(n,p), xk1(n,p), pk(n,p), qk(n,p), hk(n*n,p);
XplDouble gammak(p), gammar(p), gammal(p), gammam(p), gammaw(p), dgsk(p);
XplDouble *Xxk, *Xyxk, *dXyxk;

XplDouble step(p), stat(p), notzero(p);		// integer

long      translated1 = 0L, translated2 = 0L;

char      cmd1[1024], cmd2[1024];

XplDouble Xxkinit(n), Xyxkinit(1), dXyxkinit(n);

GenerateXplObject ("x", &Xxkinit, id, TRUE);
// GenerateXplObject ("y", &Xyxkinit, id, TRUE);
// GenerateXplObject ("dy", &dXyxkinit, id, TRUE);


 for (i=0; i<p; i++) notzero(i) = 1;
 zerosum=p;

//  hk = Einheitsmatrix muss spaeter uebergeben werden
	for (i=0;i<p;i++)
	{
		for (j=0;j<n;j++)
		{
			for (k=0;k<n;k++)
			{
				if (k==j) hk(j*n+k,i) = 1.0;
				if (k!=j) hk(j*n+k,i) = 0.0;
			}
		}

	}


// Berechnen der ersten Fkt.werte d. Ableitung dgk=dg(xk)

Xxk  = (XplDouble *) GetXplObject ("x", id);
sprintf (cmd1, "dy = %s (x)", dg);
sprintf (cmd2, "y = %s (x)", g);
short IsError = 0;

for (j=0; j<p; j++)
{
	for (k=0; k<n; k++) (*Xxk)(k) = xk(k,j);
	Execute(cmd1, id, translated1);
	dXyxk = (XplDouble *) GetXplObject ("dy", id);
	if (dXyxk == NULL)
		{
		IsError = 1;
		k=n;
		j=p;
		globalError.Set(ERR_NELMIN, "Null pointer error");
		}
	else
		{
		for (k=0; k<n; k++) dgk(k,j) = (*dXyxk)(k);
		}
}


// Berechnen der ersten Fkt.werte gk=g(xk)



for (j=0; j<p; j++)
{
	for (k=0; k<n; k++) (*Xxk)(k) = xk(k,j);
	Execute(cmd2, id, translated2);
	Xyxk = (XplDouble *) GetXplObject ("y", id);
	if (Xyxk == NULL)
		{
		IsError = 1;
		k=n;
		j=p;
		globalError.Set(ERR_NELMIN, "Null pointer error");
		}
	else
		{
		for (k=0; k<n; k++) gk(j) = (*Xyxk)(0);
		}
}

if(IsError == 1)
	{
	return (xk);
	}
else
{
// Beginn der Iteration
  for (i=0; zerosum && (i<maxiter); i++)
  { // Compute sk = Hk dgk 
    for (j=0; j<p; j++)
    { if ((int)notzero(j))
      { for (k=0; k<n; k++)
        { sk(k,j) = 0.0;
          for (l=0; l<n; l++)
            sk(k,j) += hk(k+l*n,j) * dgk(l,j);
        }
      }
    }


    // Do the line search (alternate algorithm)

    statsum = 0;
    for (j=0; j<p; j++)
    { stat(j)   = notzero(j);
      statsum  += (int)stat(j);
    }

    for (j=0; j<p; j++)
    { stat(j) = 1;
      gammaw(j) = gamma;
    }  
    while (statsum)
    { for (j=0; j<p; j++)
      { if (stat(j))
        { for (k=0; k<n; k++)
           xg(k,j) = xk(k,j) - gammaw(j) * sk(k,j);
        }
        step(j) = stat(j);
      }

//    dgam=g(xg)


      for (j=0; j<p; j++)
      {
	for (k=0; k<n; k++) (*Xxk)(k) = xg(k,j);
	Execute(cmd2, id, translated2);
	Xyxk = (XplDouble *) GetXplObject ("y", id);
	dgam(j) = (*Xyxk)(0);
      }


      for (j=0; j<p; j++)
      { statsum = 0;
        if (stat(j))
        { switch ((int)stat(j))
          { case 0 : if (gk(j) > dgam(j))
                     { stat(j) = 2;  
                       gammaw(j) = gammaw(j) / alpha; // Aufweitung
                       dgsk(j) = dgam(j);
                     }
                     else
                     { stat(j) = 1;
                       gammaw(j) = gammaw(j) * alpha; // Kontraktion
                     }
                     break;
            case 1 : if (gk(j) > dgam(j))
                     { stat(j) = 3;
                       gammaw(j) = gammaw(j) * alpha; // Kontraktion
                       dgsk(j) = dgam(j);
                     }
                     else
                     { gammaw(j) = gammaw(j) * alpha; // Kontraktion
                       if (gammaw(j)<1.0e-10)  // Kontraktion failed
                       { gammak(j) = 0;
                         stat(j) = 0;
                         fail = 1;
                       }
                     }
                     break;
            case 2 : if (dgsk(j) > dgam(j))
                     { gammaw(j) = gammaw(j) / alpha; // Aufweitung
                       dgsk(j) = dgam(j);
                     }
                     else
                     { stat(j) = 0;
                       gammak(j) = gammaw(j) * alpha;
                     }
                     break;
            case 3 : if (dgsk(j) > dgam(j))
                     { gammaw(j) = gammaw(j) * alpha;
                       dgsk(j) = dgam(j);
                     }
                     else
                     { stat(j) = 0;
                       gammak(j) = gammaw(j) / alpha;
                     }
                     break;
          }
        }
        statsum += (stat(j)>0);
      }
    }

    // Build up xk+1

    for (j=0; j<p; j++)
    { for (k=0; k<n; k++)
        xk1(k,j) = xk(k,j) - gammak(j) * sk(k,j); 
    }

    // Build up dgk+1

//  dgk1 = dg(xk1)


    for (j=0; j<p; j++)
    {
	for (k=0; k<n; k++) (*Xxk)(k) = xk1(k,j);
	Execute(cmd1, id, translated1);
	dXyxk = (XplDouble *) GetXplObject ("dy", id);
	for (k=0; k<n; k++) dgk1(k,j) = (*dXyxk)(k);
    }

        
    // pk = xk+1 - xk, qk = dgk+1 - dgk
    if (fail)
    { fail = 0;
      for (j=0; j<p; j++)
      { for (k=0; k<n; k++)
          for (l=0; l<n; l++)
            hk(k*n+l,j) = (k==l);
      }
    }
    else
    { for (j=0; j<p; j++)
      { for (k=0; k<n; k++)
        { pk(k,j) = xk1(k,j) - xk(k,j);
          qk(k,j) = dgk1(k,j) - dgk(k,j);
        }
      }  
      // Hk = PSI (1, 1, hk, pk, qk)
      for (j=0; j<p; j++)
      { if (notzero(j))
        { ptq = qthq = 0.0;
          for (k=0; k<n; k++)
          { ptq += (pk(k,j) * qk(k,j));
            for (l=0; l<n; l++)
            { qthq += hk(k*n+l,j) * qk(k,j) * qk(l,j);
              work(l,k) = 0.0;
            }  
          }
          qthq = 1 + qthq / ptq;
  
          for (k=0; k<n; k++)
          { for (l=0; l<n; l++)
            { pqth = hqpt = 0.0;
              for (m=0; m<n; m++)
              { pqth += (hk(k*n+m,j) * qk(m,j));
                hqpt += (hk(m*n+l,j) * qk(m,j));
              }
              pqth *= pk(l,j);
              hqpt *= pk(k,j);
              work(l,k) = (qthq * pk(k,j) * pk(l,j) - pqth - hqpt) / ptq;
            }
          }
  
          for (k=0; k<n; k++)
	  {
            for (l=0; l<n; l++) hk(l*n+k,j) += work(k,l);
	  }
        }
      }
    }

    // Copy now values

    xk = xk1;
    dgk = dgk1;

//    memcpy (xk, xk1, sizeof(double)*n*p);
//    memcpy (dgk, dgk1, sizeof(double)*n*p);
    
//    berechne g(x0)
//    gk=g(xk);


    for (j=0; j<p; j++)
    {
	for (k=0; k<n; k++) (*Xxk)(k) = xk(k,j);
	Execute(cmd2, id, translated2);
	Xyxk = (XplDouble *) GetXplObject ("y", id);
	gk(j) = (*Xyxk)(0);
    }


    for (j=0; j<p; j++)
    { notzero(j) = 0;
      for (k=0; k<n; k++)
        notzero(j) = notzero(j) || (fabs(dgk(k,j)) > eps);
      zerosum -= (!notzero(j));
    }
   
  }
  if (i>=maxiter)
	{
	 // globalWarning.Set (WARN_NOCONVERGENCE, "bfgs");
	}
	
  maxiter=i;
  EndExecution (id);

  return (xk);
}
}

//  Die Declaration der globalen Variablen dient zur Verbesserung der rekursiven Aufrufe. 

XplDouble Simpson_xa, Simpson_xb, Simpson_m;
char *Simpson_Fun;
void *Simpson_id;
char      Simpson_cmd[1024];
long      Simpson_translated;
XplDouble *Simpson_xx;

XplDouble simpsonint (int n, XplDouble c);




XplDouble simpson(const char *Fun, XplDouble Xa, XplDouble Xb, XplDouble M)
{
XplDouble Erg(1);

// Fehlerkontrolle

if ((Xa.rows() != Xb.rows()) || (Xa.rows() != M.rows()))
	{
	globalError.Set(ERR_SIMPSON, "a, b, m (2., 3. and 4. argument) must have the same dimension");
	return(Erg);
	}
if ((Xa.cols() != 1) || (Xb.cols() != 1) || (M.cols() != 1))
	{
	globalError.Set(ERR_SIMPSON, "a, b, m (2., 3. and 4. argument) must have 1 columm");
	return(Erg);
	}


   Simpson_Fun = strdup (Fun);
   Simpson_xa = Xa;
   Simpson_xb = Xb;
   Simpson_m = M;
   int n = Simpson_xa.rows();
   XplDouble c(n);


  // ***  Vorbereitung auf die Berechnung von Funktionswerten der XploRe-funktion Simpson_Fun **

  Simpson_id = StartExecution ();
  XplDouble xinit(Simpson_xa.rows()), yinit(1);
  GenerateXplObject ("x", &xinit, Simpson_id, TRUE);
  Simpson_translated = 0L;
  sprintf (Simpson_cmd, "y = %s (x)", Simpson_Fun);
  Simpson_xx = (XplDouble *) GetXplObject ("x", Simpson_id);
 
  // ***  Ende der Vorbereitung  

   Erg = simpsonint(n-1, c);
   EndExecution (Simpson_id);
   delete[] Simpson_Fun;
   return Erg;
};





XplDouble simpsonint (int n, XplDouble c)
{

  XplDouble *yy;
  double h = (Simpson_xb(n) - Simpson_xa(n))/(2*Simpson_m(n));  // Intervallnge
  int i,k;
  XplDouble x(2*(int)Simpson_m(n)+1), y(2*(int)Simpson_m(n)+1);  // Argumente und Funktionswerte der n- ten Dim
  short IsError = 0;


  //  *********** Berechnung der Funktionswerte ********************************

  for (i = 0; i <= 2*(int)Simpson_m(n); i++)   
  {
    x(i) = Simpson_xa(n) + i*h;  	// Berechnung der Argumente
    c(n) = x(i);		// Auffllen von c beginnend mit dim-1

    if (n == 0)			// die unterste Dim wurde erreicht 
    {    	
	for (k=0; k<Simpson_xa.rows(); ++k) (*Simpson_xx)(k) = c(k);
	Execute (Simpson_cmd, Simpson_id, Simpson_translated);            
	yy = (XplDouble *) GetXplObject("y", Simpson_id);
	if (yy == NULL) 
		{
		i=2*(int)Simpson_m(n)+1;
		k=Simpson_xa.rows();
		globalError.Set(ERR_SIMPSON, "Null pointer error");
		IsError = 1;
		}
	else
		{
        	y(i) = (*yy)(0);
		}
    }

    else			// die unterste Dim wurde nicht erreicht 
    {
   	XplDouble yd = simpsonint(n-1,c);
	y(i) = yd(0);
    }

  }


  //  Ende Berechnung der Funktionswerte
  

  // ******** Beginn des Algorithmus von simpson *************************************
  // Der Aldorithmus wird nur gestarted, wenn kein Fehler bei der Berechnung der Fkt.-werte auftrat

  XplDouble erg(1);

  if (IsError == 1)
  {
	return (erg);
  }
  else
  {
  	// Summe ber die Funktionswerte mit geraden bez. ungeraden Indizes

  	XplDouble rg(1), ru(1);
  	double ir;	
  	rg(0)=0; ru(0)=0;
  	for (i=1; i < 2*(int)Simpson_m(n); i++)
  	{
   	  ir = i;
   	  if (ir/2 == i/2)  {rg(0) = rg(0) + y(i);}  else  {ru(0) = ru(0) + y(i);};
  	}

  	// Ergebnis mit Simpson formel
  
  	erg(0) = (h/3 * (y(0) + y(2*(int)Simpson_m(n)) + 2*rg(0) + 4* ru(0)));
   	return erg;
  }
}

