/* $Header: /home/xplore/cvs/xpl4gr/nelmin4.h,v 1.3 2002/08/16 12:31:47 sigbert Exp $ */

// Xplore 4 function
// nelmin

// TK, 10.08.95


/*
Berechnet lokale Minima von Funktionen fun: RxRx...xR -> R 
nach einem Algorithmus von Nelder und Mead 
Simplexmethode

StV 	n x p Matrix mit Startwerten
fun	Pointer auf Xplore-Funktion
reqmin  double, Abbruchkriterium
Step	double, Seitenlaenge des Starsimplex
icount  int, maximale Anzahl der Iterationen
*/

XplDouble nelmin(XplDouble StV, const char *fun, double reqmin, double Step, int &icount);

/*
Berechnet Minimum einer Fkt

Eingabe:
xk	= n x p Matrix, mit p Startwerten der Laenge n
*g	= Name der zu minimierenden Fkt.
*dg	= Name der Ableitung von g
maxiter = Maximale Anzahl der Iterationen
eps	= Abbruchkriterium
hk	= n*n x p Matrix, Startwerte fuer Hessematrix
gamma	= Startvalue for Linesearch

Standart:
eps=1.0e-03, gamma=1.0
hk=Einheitsmatrix (p mal)

Ausgabe:
bfgs	= n x p Matrix, Koordinaten der p gefundenen Minimas
hk	= n x n x p Matrix, Hessematrix in den Minima
maxiter = Anzahl der durchgefuehrten Iterationen

Abbruch:
Die Iteration bricht ab, wenn alle partiellen Ableitungen dg/dx_i(x) < eps sind.

*/

XplDouble bfgs(XplDouble xk, const char *g, const char *dg, int &maxiter, double eps, double gamma);


// simpson integration
// TK, 16.10.96



XplDouble simpson(const char *Fun, XplDouble Xa, XplDouble Xb, XplDouble M);





/*  *************************************************************************** 

Beschreibung von simpsonint:

Integration von Funktionen f : R^dim --> R nach der Simpson formel
dim ist die Anzahl der Dimensionen 

	Input: 	
		Fun	Name der XploRe-funktion
		Xa	Vector der Lnge dim, der die Anfangspunkte der 
			Intervale fr jede Dimension enthlt.
		Xb	Vector der Lnge dim, der die Endpunkte der 
			Intervale fr jede Dimension enthlt.
		M	Vector der Lnge dim, der die Hlfte der Anzahl der 
			Teilintervale fr jede Dimension enthlt.
	Output:
			Wert des Integrals

Bemerkung:  Die Anzahl der Fnktionsaufrufe ist   (m[0]+1) * ... * (m[dim-1]+1)

****************************************************************************  */

