/* $Header: /home/xplore/cvs/xpl4gr/object.C,v 1.4 2003/02/23 16:59:20 cizek Exp $ */

// PC MAC
#if !defined(__APPLE_CC__) && !defined (__BORLANDC__) && !defined (WIN32) //LOOK!
#include <stream.h>
#else
#include "xplerror.h"
#include <iostream.h>
#endif

// #pragma implementation

#include <string.h>
#include "object.h"


#if defined (_GRAPHICS_) || defined (PSGEN) || defined (__BORLANDC__)
#include "plot.h"
#include "xplio.h"

#endif

#if defined (_GRAPHICS_)
#include "udisp.h"
#endif

#ifndef MATRIX
// #include "xchar.hpp"
#endif

#ifdef __BORLANDC__
#include "xplwin.h"
//#include "wdispl.h"
#endif

#ifdef TTKDEBUG
long objcounter = 0;
extern int ttkdebug;
#endif

// from xplpp.h
XplObject *  GetXplObject    (Liste<XplObject*> *, const char *n, long &pos);

//static 
long XplObjectId = 1L;     // ids for XplObjects

extern Liste<XplObject*>    *globObjList, *displayList;  // init.C

void dispAppend (XplObject *o)    // impossible to use displayList
{                                 // in XplObject constructor

  // there must not be any element twice in the list
  for (int i=0; i<displayList->laenge(); i++)
    if (o->Id() == (*displayList)[i]->Id())
      return;

  displayList->haengeAn (o);
}

void dispRemove (long i)  // impossible to use displayList
{                               // in XplObject constructor
  displayList->loesche (i);
}

#ifdef REFERENCE
Reference::Reference (Liste<TokenElement> *tl, Liste<long> *idl)
{
  tlist  = tl;
  idlist = idl;
}

Dependence::Dependence (Liste<long> *idl)
{
  idlist = idl;
}

#endif

Component::Component (XplDouble* x, const char *n)
{
  name = n == NULL ? (char*) NULL : strdup (n);
  type = C_XPLDOUBLE;
  content.xpldouble = x;
#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Comp:\tconstruct\t" << this  << endl;
#endif
}

#ifdef _XPLCDEF_
Component::Component (XplChar* x, const char *n)
{
  name = n == NULL ? (char*) NULL : strdup (n);
  type = C_XPLCHAR;
  content.xplchar = x;
#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Comp:\tconstruct\t" << this  << endl;
#endif
}
#endif

#ifdef _XPLTIME_
Component::Component (XplTime* x, const char *n)
{
  name = n == NULL ? (char*) NULL : strdup (n);
  type = C_XPLTIME;
  content.xpltime = x;
#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Comp:\tconstruct\t" << this  << endl;
#endif
}
#endif

#ifdef _XPLMASK_
Component::Component (XplMask* x, const char *n)
{
  name = n == NULL ? (char*) NULL : strdup (n);
  type = C_XPLMASK;
  content.xplmask = x;
#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Comp:\tconstruct\t" << this  << endl;
#endif
}
#endif

#if defined (_GRAPHICS_) || defined (PSGEN) || defined (__BORLANDC__)
Component::Component (XplDisplay *disp, const char *n)
{
  name = n == NULL ? (char*) NULL : strdup (n);
  type = C_DISPLAY;
  content.display = disp;
#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Comp:\tconstruct\t" << this  << endl;
#endif
}
#endif

Component::Component (char *t, const char *n)
{
  name = n == NULL ? (char*) NULL : strdup (n);
  type = C_TEXT;
  content.text = t;
#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Comp:\tconstruct\t" << this  << endl;
#endif
}

Component::Component (XplObject* o)
{
  name = o->Name () == NULL ? (char*) NULL : strdup (o->Name ());
  type = C_XplObject;
  content.xplobject = o;
#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Comp:\tconstruct\t" << this  << endl;
#endif
}

Component::Component (Component* c)
{
  name = c->name == NULL ? (char*) NULL : strdup (c->name);
  type = c->type;

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Comp:\tconstruct\t" << this  << endl;
#endif
  switch (type)         // Test !!
    {
    case C_XPLDOUBLE:   content.xpldouble = new XplDouble (c->content.xpldouble);
			break;
    case C_XplObject:      content.xplobject = new XplObject (c->content.xplobject);
			break;
//#if (defined (_GRAPHICS_) || defined (__BORLANDC__)) && !defined (PSGEN)
#if (defined (_GRAPHICS_) ) && !defined (PSGEN)
/*   case C_PLOT:        content.plot = new Plot (c->content.plot);
			break;
     case C_DISPLAY:     content.display = new XplDisplay (c->content.display);
*/
    case C_DISPLAY:     content.display = new UDisplay ((UDisplay *)(c->content.display));
			break;
#endif
#ifdef __BORLANDC__
    case C_DISPLAY: //content.display = new WDisplay ( (WDisplay *)(c->content.display) );
         //xplerror("Unable to put an Display into an List"); // DS: 11.02.99
         // cerr<<"Unable to put an Display into an List"<<endl;         // SK 13.04.2000
          globalError.Set (LIST, "list: Unable to put a display into a list");
      break;
#endif*/ // ds, 27.01.00
#ifdef PSGEN
   case C_DISPLAY:     content.display = new XplDisplay (c->content.display);
                       break;
#endif

#ifdef _XPLCDEF_
    case C_XPLCHAR:     content.xplchar = new XplChar (*c->content.xplchar);
			break;
#else
    case C_TEXT:        content.text = strdup (c->content.text);
			break;
#endif
#ifdef _XPLTIME_
    case C_XPLTIME:     content.xpltime = new XplTime (*c->content.xpltime);
			break;
#endif
#ifdef _XPLMASK_
    case C_XPLMASK:     content.xplmask = new XplMask (*c->content.xplmask);
			break;
#endif
    default:            cerr << "Comp::Comp(Comp*) Error in Constructor: type = ??";
			exit(1);
    }
}


Component::~Component ()
{

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Comp: destruct\t\t" << this  << endl;
#endif
  if (name != NULL)
    delete[] name;
  switch (type)         // Test !!
    {
    case C_XPLDOUBLE:   if (content.xpldouble != NULL) // SK: TTK 17.08.99
                          delete content.xpldouble;  break;
    case C_XplObject:   if (content.xplobject != NULL)
                          if (!content.xplobject->WriteProtection())
                            delete content.xplobject;
/*                          else
			    cerr << "should not happen " << content.xplobject->Name() << endl;
SWS 3.6.98 */
                        break;
#ifdef _XPLTIME_
    case C_XPLTIME:     delete content.xpltime;  break;
#endif
#ifdef _XPLMASK_
    case C_XPLMASK:     delete content.xplmask;  break;
#endif
#ifdef _XPLCDEF_
      //    case C_XPLCHAR:     break; // delete content.xplchar;  break;
    case C_XPLCHAR:      delete content.xplchar;  break;
#else
    case C_TEXT:        delete content.text;  break;
#endif
#if defined (_GRAPHICS_) || defined (PSGEN) || defined (__BORLANDC__)
    case C_DISPLAY:
XplObject *x, *obj;
long pos;

x = GetXplObject (content.display);
if (x != NULL)
  {
//  obj = GetXplObject (displayList, x->Name(), pos);
  obj = GetXplObject (displayList, x->Id(), pos);
  if (x != obj)
    {
    cerr << "Fatal error in ~Comp! displayList inconsistent" << endl;
//    exit (1);
    }
  else
    displayList->loesche (pos);
  }
delete content.display;  break;
#endif
    default:            cerr << "Comp::~Comp() Error in Destructor: type = ??";
			exit(1);
    }
}

void Component::Print (const char *objname) const
{ char *outputformat = property.getProperty("outputformat");
  char *outputstringformat = property.getProperty("outputstringformat");
// SK 06.07.98

  // SK 20.02.99
  /*
#if !defined (INETD) && !defined (_JAVA_) && !defined (SOCKETSERVER) && defined (TTKDEBUG)
if (ttkdebug)
  if (name != NULL)
    cout << '\t' << name << '\n';
  else
    cout << "\ttemp\n";
#endif
  */
  switch (type)
    {
    case C_XPLDOUBLE:
      /*
#if !defined (INETD) && !defined (_GRAPHICS_) && !defined (_JAVA_) && !defined (__BORLANDC__)
   cout << "XplDouble\t" << content.xpldouble << '\n';
#endif
      */
#ifdef INETD
   cout << "\"-------=_aaaaaaa\"\nContent-Type: text/plain\n\n";
#endif

#if defined(SOCKETSERVER) || defined(X4singleserver)
   //#ifdef SOCKETSERVER
                        protocol->sendContent (*content.xpldouble, objname, outputformat);
                        break;
#endif

#if defined (_GRAPHICS_) || defined (PSGEN) || defined (__BORLANDC__)
			xplout (*content.xpldouble, objname, outputformat);
                        break;
#endif

#ifdef MATRIX
			content.xpldouble->out();
                        break;
#else
			content.xpldouble->mdump(outputformat, NULL, objname);
			break;
#endif

    case C_XplObject:   content.xplobject->Print(objname);  break;

#if defined (_GRAPHICS_) || defined (PSGEN) || defined (__BORLANDC__)
    case C_PLOT:        // TTK 22.1.96, new Graphics content.plot->manage();
                        break;
    case C_DISPLAY:     /*nothing to do */  break;
#endif

#ifdef _XPLTIME_
    case C_XPLTIME:     
                        globalError.Set (TIME, "You can not show a time vector directly, please use dayofweek etc.");
      // content.xpldoule->mdump("%li", NULL, objname);
                        break;
#endif

#ifdef _XPLMASK_
    case C_XPLMASK:     content.xplmask->mdump ();  break;
#endif

#ifdef _XPLCDEF_
    case C_XPLCHAR:

#if defined(SOCKETSERVER) || defined(X4singleserver)
      //#ifdef SOCKETSERVER
                        protocol->sendContent (*content.xplchar, objname, outputformat);
                        break;
#endif

#if defined (_GRAPHICS_) || defined (PSGEN) || defined (__BORLANDC__)
                        xplout (*content.xplchar, objname);
                        break;
#endif
			//			content.xpldouble->mdump(outputstringformat, NULL, objname);
			content.xplchar->mdump(outputstringformat, NULL, objname);
                        break;
#else  // XPLCDEF
    case C_TEXT:        cout << content.text;
			cout << '\t' << strlen(content.text) << endl;  break;
#endif
    default:            cout << "unkonwn Component Type !!" << endl;  break;
    }
}

void XplObject::init (void)
{
#ifdef TTKDEBUG
  objcounter++;
#endif
  defx  = NULL;
  defc  = NULL;
  empty = TRUE;         // set explicitly
  type  = O_EMPTY;

  motherid = 0L;

#ifdef REFERENCE
  ref  = NULL;
  dep  = NULL;
#endif
}

XplObject::XplObject (const char *n)
{
  init ();
  name = n == NULL ? (char*) NULL : strdup (n);

  writeprotection = FALSE;    // instead of SetXplDouble
  id   = XplObjectId++;
  defc = NULL;
  defx = NULL;
  type = O_EMPTY;

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Obj:\tconstruct\t" << this << '\t' << id << endl;
#endif
}

XplObject::XplObject (Component* c, const char *n)
{
  init ();
  name = n == NULL ? (char*) NULL : strdup (n);

  if (c != NULL)
    elements.haengeAn (c);

  if (c->Type() == C_DISPLAY)
    dispAppend (this);

  writeprotection = FALSE;
  id   = XplObjectId++;

  SetDefaultXplDouble ();

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Obj:\tconstruct\t" << this << '\t' << id << '\t' << name << endl;
#endif
}

#ifdef _XPLCDEF_
XplObject::XplObject (XplChar* x, const char *n)
{
// Attention:   x is NOT copied !!
  init ();
  name = n == NULL ? (char*) NULL : strdup (n);

  if (x != NULL)
    elements.haengeAn (defc = new Component (x, n));

  writeprotection = FALSE;
  id   = XplObjectId++;

  SetDefaultXplDouble ();
#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Obj:\tconstruct\t" << this << '\t' << id << '\t' << name << endl;
#endif
}
#endif

#ifdef _XPLTIME_
XplObject::XplObject (XplTime* x, const char *n)
{
// Attention:   x is NOT copied !!
  init ();
  name = n == NULL ? (char*) NULL : strdup (n);

  if (x != NULL)
    elements.haengeAn (defc = new Component (x, n));

  writeprotection = FALSE;
  id   = XplObjectId++;

  SetDefaultXplDouble ();

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Obj:\tconstruct\t" << this << '\t' << id << '\t' << name << endl;
#endif
}
#endif

#ifdef _XPLMASK_
XplObject::XplObject (XplMask* x, const char *n)
{
// Attention:   x is NOT copied !!
  init ();
  name = n == NULL ? (char*) NULL : strdup (n);

  if (x != NULL)
    elements.haengeAn (defc = new Component (x, n));

  writeprotection = FALSE;
  id   = XplObjectId++;

  SetDefaultXplDouble ();
#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Obj:\tconstruct\t" << this << '\t' << id << '\t' << name << endl;
#endif
}
#endif

XplObject::XplObject (XplDouble* x, const char *n)
{
// Attention:   x is NOT copied !!
  init ();
  name = n == NULL ? (char*) NULL : strdup (n);

  if (x != NULL)
    elements.haengeAn (defc = new Component (x, n));

  empty = FALSE;           // a little bit more efficient 
  defx  = x;               // than SetXplDouble 
  type  = O_XPLDOUBLE;
  id    = XplObjectId++;
  writeprotection = FALSE;
#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Obj:\tconstruct\t" << this << '\t' << id << '\t' << name << endl;
#endif
}

#if defined (_GRAPHICS_) || defined (PSGEN) || defined (__BORLANDC__)
XplObject::XplObject (XplDisplay *disp, const char *n)
{
// Attention:   disp is NOT copied !!
  init ();
  name = n == NULL ? (char*) NULL : strdup (n);
  
  if (disp != NULL)
    elements.haengeAn (defc = new Component(disp));

  writeprotection = FALSE;        // in order to allow TransferComponents
  id   = XplObjectId++;
  SetDefaultXplDouble ();

  if (GetXplObject (disp) == NULL)  // new display
dispAppend (this);//    displayList->haengeAn (this);

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Obj:\tconstruct\t" << this << '\t' << id << '\t' << name << endl;
#endif
}
#endif

XplObject::XplObject (const XplObject* o)
{
  init ();
  motherid = o->id;                   // only here the motherid is set
#ifdef TTKDEBUG                       // ATTENTION: copy of copy of obj has wrong mother id
if ((!o->writeprotection) && motherid != 0)
  {
extern int tracedebug;
  if (tracedebug)
  {
  cerr << "XplO::XplO (" << id << "): motherid (" << motherid;
  cerr << ") set although object was not writeprotected" << endl;
  }
  }
#endif
  long i, length = o->elements.laenge ();

  name = o->name == NULL ? (char*) NULL : strdup (o->name);

  for (i=0; i<length; i++)
    elements.haengeAn (new Component ((o->elements)[i]));

  writeprotection = FALSE;
  id   = XplObjectId++;

  SetDefaultXplDouble ();

  // if a new display is created store in displayList
  if (this->Type() == O_DISPLAY)
    dispAppend (this);

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Obj:\tconstruct\t" << this << '\t' << id << '\t' << name << endl;
#endif
}

XplObject::XplObject (const XplObject* o, const char *n)
{
  long i, length = o->elements.laenge ();

  init ();
  name = n == NULL ? (char*) NULL : strdup (n);

  for (i=0; i<length; i++)
    elements.haengeAn (new Component ((o->elements)[i]));

  // if the default component of o is a display
  // append the display of this into displayList
  if (o->DefaultComponent()->Type() == C_DISPLAY)
    dispAppend (this);

  writeprotection = FALSE;
  id   = XplObjectId++;
  SetDefaultXplDouble ();

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Obj:\tconstruct\t" << this << '\t' << id << '\t' << name << endl;
#endif
}

XplObject::~XplObject ()
{
  long i, length = elements.laenge ();

  if (writeprotection)
    {
    cerr << "internal ERROR: ~Obj:  XplObject was write protected!" << endl;
    return;
    }

  if (type == O_DISPLAY)
    {
    //    cerr << "~XplObject " << name << " is display" << endl;
    //    XplObject *o = GetXplObject (displayList, name, i);
    XplObject *o = GetXplObject (displayList, this->Id(), i);
    if (this == o)
      displayList->loesche (i);
    else
      cerr << "display not found in displayList" << endl;
// Fehler: if objList = globObjList
    //    o = GetXplObject (globObjList, name, i);
    o = GetXplObject (globObjList, this->Id(), i);
    if (this == o)
      globObjList->loesche (i);
    //    else
    //      cerr << "display not found in globObjList" << endl;

    for (i=0; i<length; i++)
      delete elements[i];

    elements.remove ();       // don't delete content of pointers
    length = 0;               // because DISPLAYS are always global
    }

#ifdef TTKDEBUG
  if (ttkdebug)
    cerr << "Obj: destruct\t\t" << this << '\t' << id << '\t' << name << endl;

  objcounter--;
#endif

  if (name != NULL)
    delete[] name;

  if (writeprotection)
    {
    cerr << "ERROR: ~Obj:  XplObject was write protected!" << endl;
    return;
    }

  for (i=0; i<length; i++)
    delete elements[i];

  elements.remove ();
}

XplObject& XplObject::operator= (const XplObject& o)
{
  if (this == &o)  return (*this);

  *this = XplObject (o);         // TEST !!

  return (*this);
}

XplObject * XplObject::ContainsXplObject (const long ident)
{
  if (id == ident)
    return (this);

  if (type & O_SIMPLE)
    return (NULL);

  XplObject *r;

  for (long j=0; j<elements.laenge (); j++)
    {
    if (elements[j]->Type () == C_XplObject)
      {
      r = elements[j]->Content().xplobject->ContainsXplObject (ident);
      if (r != NULL)
	return (r);
      }
    }
  return (NULL);
}

void XplObject::SetWriteProtection ()
{
long i, length = elements.laenge ();

  writeprotection = TRUE;

  for (i=0; i<length; i++)
    if (elements[i]->Type () == C_XplObject)
      elements[i]->Content().xplobject->SetWriteProtection ();
}

void XplObject::DelWriteProtection ()
{
long i, length = elements.laenge ();

  writeprotection = FALSE;

  for (i=0; i<length; i++)
    if (elements[i]->Type () == C_XplObject)
      elements[i]->Content().xplobject->DelWriteProtection ();
}

void XplObject::SetName (const char *n)
{
  if (name != NULL)
    delete[] name;

  name = n == NULL ? (char*) NULL : strdup (n);

#if defined (_GRAPHICS_) || defined (PSGEN) || defined (__BORLANDC__)
  if (defc != NULL)
    if (defc->Type () == C_PLOT)
;// TTK 22.1.96, new Graphics       defc->Content().plot->SetPlotName (name);
#endif
}

void XplObject::SetDefaultXplDouble ()
{
  defx = NULL;
  defc = NULL;

  SetType ();           // determines whether this is empty, simple, or composed

  if (empty)
    return;

  defc = elements[0];             // is it enough ?
  switch (elements[0]->Type ())
    {
    case C_XPLDOUBLE:  defx = elements[0]->Content().xpldouble;  break;
    case C_XplObject:  elements[0]->Content().xplobject->SetDefaultXplDouble ();
		       defc = elements[0]->Content().xplobject->DefaultComponent ();
		       defx = elements[0]->Content().xplobject->DefaultXplDouble ();
		       break;
#ifdef _XPLTIME_
    case C_XPLTIME:    break;   // nothing to do
#endif
#ifdef _XPLMASK_
    case C_XPLMASK:    break;   // nothing to do
#endif
#ifdef _XPLCDEF_
    case C_XPLCHAR:    break;   // nothing to do
#else
    case C_TEXT:       break;   // nothing to do
#endif
#if defined (_GRAPHICS_) || defined (PSGEN) || defined (__BORLANDC__)
    case C_PLOT:       break;   // nothing to do
    case C_DISPLAY:    break;   // nothing to do
#endif
    default:           cerr << "XplObject: SetDefaultXplDouble: unknown type" << endl;
		       break;
    }
}

void XplObject::SetType (void)
{
  switch (elements.laenge ())
    {
    case  0 :  type = O_EMPTY;  empty = TRUE;  return;   break;
    case  1 :  switch (elements[0]->Type())
	         {
		 case C_XPLDOUBLE:  type = O_XPLDOUBLE;  break;
		 case C_XPLLONG:    type = O_XPLLONG;    break;
#ifdef _XPLTIME_
		 case C_XPLTIME:    type = O_XPLTIME;    break;
#endif
#ifdef _XPLMASK_
		 case C_XPLMASK:    type = O_XPLMASK;    break;
#endif
#ifdef _XPLCDEF_
		 case C_XPLCHAR:    type = O_XPLCHAR;    break;
#else
		 case C_TEXT:       type = O_TEXT;       break;
#endif
		 case C_MACRO:      type = O_MACRO;      break;
		 case C_DISPLAY:    type = O_DISPLAY;    break;
		 case C_PLOT:       type = O_PLOT;       break;
		 case C_XplObject:  type = O_COMPOSED;   break;
                 default:           cerr << "XplObj: unknown type" << endl;
		                    exit (1);
		 }  break;
    default :  type = O_COMPOSED;  break;
    }
  empty = FALSE;
}

void   XplObject::TransferComponents (XplObject *o)
// transfers components of o to *this. If o->type is O_DISPLAY, then
// the list of components is copied, but nothing is moved
// I.e., that *this is another reference of *o and must NOT be deleted
{
  if (this == o)
    return;

  int  wp;
  long i, length = o->elements.laenge ();

  if (length == 0)
    {
#ifdef SHOWERROR
    cerr << "XplObject " << o->Name () << " never initialized !" << endl;
#endif
      return;       // there is nothing to do
    exit (1);    // has to be changed
    }

  wp = this->WriteProtection ();      // store state of protection TTK, 21.5.98
  if (wp == TRUE)
    {
    //    cerr << name << " was writeprotected" << endl;
    this->DelWriteProtection ();
    }

  if (motherid != o->Id ())           // if this is contained in o
    {
    length = elements.laenge ();      // do not delete

    for (i=0; i<length; i++)
      delete elements[i];

    elements.remove ();
    }

  if (o->Type () == O_DISPLAY)
    {
    long pos;

    XplObject *x = GetXplObject (displayList, o->Id(), pos);
    if (o == x)
      {
      dispRemove (pos);              // altes Obj raus
      dispAppend (this);             // neues rein
      }
    else
      dispAppend (this);             // neues rein
    }

  if (o->writeprotection)
    {
    length = o->elements.laenge ();
    for (i=0; i<length; i++)
      elements.haengeAn (new Component (o->elements[i]));
    // new Comp (Comp)  makes deep copy 
    }
  else
    {
    elements = o->elements;   // DEEP copy
    o->elements.remove();
    o->empty = TRUE;
    o->SetType ();
    }

  empty    = FALSE;
  SetType ();
  SetDefaultXplDouble ();
  o->SetDefaultXplDouble ();
  if (wp == TRUE)                    // set old state   TTK, 21.5.98
    this->SetWriteProtection ();
}


XplObject * XplObject::TransferXplObject (XplObject *o)
{
  XplObject *obj;
  long i, length = elements.laenge ();

  for (i=0; i<length; i++)
    if ((obj = elements[i]->TransferXplObject (o)) != NULL)
      {
      DeleteComponent (i);
      return (obj);
      }

  return (NULL);
}

Component* XplObject::GetComponent (const char *n) const
{
  long i, length = elements.laenge ();

  for (i=0; i<length; i++)
    if (strcmp(elements[i]->Name (), n) == 0)
      return (elements[i]);

  return (NULL);
}

Component* XplObject::GetComponent (const char *n, long &pos) const
{
  long i, length = elements.laenge ();

  for (i=0; i<length; i++)
    if (strcmp(elements[i]->Name (), n) == 0)
      {
      pos = i;
      return (elements[i]);
      }

  return (NULL);
}

void XplObject::DeleteComponents ()
{
  long i, length = elements.laenge();

  for (i=0; i<length; i++)
    delete  elements[i];

  elements.remove();
  type = O_EMPTY;
  defc = NULL;
  defx = NULL;
}

void XplObject::DeleteComponent (long i)
{
  if ((0<=i) && (i<elements.laenge()))
    {
    delete  elements[i];
    elements.loesche(i);
    }
  SetDefaultXplDouble ();
}

void XplObject::InsertComponent (long i, Component *c)
{
  if ((0<=i) && (i<=elements.laenge()))
    {
    empty = FALSE;
    elements.fuegeEin (c, i);
    }
  SetType ();
  SetDefaultXplDouble ();
}

void XplObject::CopyComponent (Component *c, int New, long pos)
{
  pos = (pos <= 0) || (pos > elements.laenge ()) ? elements.laenge () : pos;

  if (New)
    switch (c->Type ())
      {
      case C_XPLDOUBLE:
        this->InsertComponent (pos, new Component (c->Content().xpldouble));
	break;
#ifdef _XPLCDEF_
      case C_XPLCHAR:
        this->InsertComponent (pos, new Component (c->Content().xpldouble));
	break;
#else
      case C_TEXT:
        this->InsertComponent (pos, new Component (c->Content().xpldouble));
	break;
#endif
      case C_XplObject:
        this->InsertComponent (pos, new Component (c->Content().xpldouble));
	break;
      default:  cerr << "SelectComponents:  unknown type" << endl;
	exit (1);
      }
  else
    switch (c->Type ())
      {
      case C_XPLDOUBLE:    this->InsertComponent (pos, c);
			   break;
#ifdef _XPLCDEF_
      case C_XPLCHAR:      this->InsertComponent (pos, c);
			   break;
#else
      case C_TEXT:         this->InsertComponent (pos, c);
			   break;
#endif
      case C_XplObject:    this->InsertComponent (pos, c);
			   break;
      default:             cerr << "SelectComponents:  unknown type" << endl;
			   exit (1);
      }
}

void XplObject::Print(const char *objname) const
{
  // SK 20.02.99

  static int ofi = 0;
  char *t, of[256];

  long i, l = elements.laenge();
  /*
  for (i=0; i<ofi; i++)
    of[i] = '\t';
  of[i] = '\0';
  ofi++;
 
#if !defined (INETD) && !defined (_GRAPHICS_) && !defined (_JAVA_) && !defined (__BORLANDC__)
  cout << of << "XplObject:\t" << this << '\t' << id << '\t';
  switch (type)
    {
    case O_EMPTY:      cout << "EMPTY\t";      break;
    case O_XPLDOUBLE:  cout << "XPLDOUBLE\t";  break;
    case O_XPLLONG:    cout << "XPLLONG\t";    break;
    case O_XPLCHAR:    cout << "XPLCHAR\t";    break;
    case O_XPLTIME:    cout << "XPLTIME\t";    break;
    case O_XPLMASK:    cout << "XPLMASK\t";    break;
    case O_MACRO:      cout << "MACRO\t";      break;
    case O_PLOT:       cout << "PLOT\t";       break;
    case O_DISPLAY:    cout << "DISPLAY\t";    break;
    case O_COMPOSED:   cout << "COMPOSED\t";   break;
    default:           cout << "** UNKNOWN ** ERROR\t";  break;
    }

    cout << this->Name() << "\t Components: "<< l << '\n';
#endif
*/
  if (empty)
    {
      /*
#if !defined (INETD) && !defined (_GRAPHICS_) && !defined (_JAVA_) && !defined (__BORLANDC__)
    cout << "\t is empty\n";
#endif
  */
#if defined(SOCKETSERVER) || defined(X4singleserver)
      //#ifdef SOCKETSERVER
   protocol->sendString ("\t is empty\n");
#endif
    return;
    }
 
  if (objname != NULL)
    {
    t = new char[strlen(this->Name())+strlen(objname)+2];   // '.' and \0 !!
    sprintf (t, "%s.%s", objname, this->Name());
    }
  else
    t = strdup (this->Name());
  
  for (i=0; i<l; i++)
    {
      /*
#if !defined (INETD) && !defined (_GRAPHICS_) && !defined (_JAVA_) && !defined (__BORLANDC__)
    cout << of <<'\t' << "component: " << elements[i]->Name() << '\t' << i << '\t';
    #endif
*/
    elements[i]->Print (t);
    }
  /*
  ofi--;

  delete[] t;
*/
}

Variable::Variable (XplObject *o)
{
  useObj    = o;
  simpleVar = TRUE;
  position  = -1;
  name      = o->Name () == NULL ? strdup ("_tmp") : strdup(o->Name ());

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Var:\tconstruct\t" << this << endl;
#endif
}

Variable::Variable (char *n, long pos)
{
  useObj    = NULL;
  simpleVar = TRUE;
  position  = pos;  
  name      = n == NULL ? strdup ("_tmp") : strdup (n);

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Var:\tconstruct\t" << this << endl;
#endif
}


Variable::~Variable ()
{
#ifdef TTKDEBUG
if (ttkdebug)
cerr << "Var: destruct\t\t" << this << endl;
#endif
  delete[] name;
}

XplObject * Variable::GetXplObject ()
{
extern Liste<class XplObject*> *objList;

  if (useObj != NULL)
    return (useObj);

  if (position == -1)
    cerr << "Variable::XplObject:   Fatal error: Can't get UseXplObject!" << endl;

  useObj = (*objList)[position];          // determine XplObject

if (!useObj->WriteProtection ())
  {
#ifdef TTKDEBUG
  extern int tracedebug;
  if (tracedebug)
  {
  cerr << "Variable::XplObject: Error: useObj (" << useObj->Id();
  cerr << ", " << useObj->Name() << ") not write protected!" << endl;
  }
#endif
  useObj->SetWriteProtection ();          // don't allow to delete
  }

  return (useObj);
}

int IsEqual (XplObject *l, XplObject *r)
{
  XplDouble *lo = l->DefaultXplDouble (),
            *ro = r->DefaultXplDouble (); 

  if (l == r)
    return (TRUE);

  if ((*lo)(0) == (*ro)(0))        // !! checks only the first element
    return (TRUE);
  else
    return (FALSE);
}

