/* $Header: /home/xplore/cvs/xpl4gr/otxtstream.C,v 1.3 2002/08/16 12:31:47 sigbert Exp $ */

#include <iostream.h>
#include <string.h>
#include "otxtstream.hpp"

#define BLOCKSIZE 16384

otxtstream::otxtstream()
{ ptr = NULL; size = len = 0; }

otxtstream::~otxtstream()
{ if (ptr)
    delete[] ptr;
  ptr = NULL;
  len = 0;
}

otxtstream& otxtstream::operator<<(const char *s)
{ if (len+1+strlen(s)>size)
  { char *newptr;
    while (len+1+strlen(s)>size) size += BLOCKSIZE;
    newptr = new char[size];
    if (newptr)
    { if (ptr) 
      { memcpy (newptr, ptr, sizeof(char)*(1+len));
        delete[] ptr;
      }
      else // SK 28.10.97
        newptr[0] = 0; 
      ptr = newptr;
    }
  }
  strcat (ptr, s);
  len += strlen(s);
  return (*this);
}

Xplostream::Xplostream()
{ type = 1;
  fp = 1;
  s2 = new otxtstream[1];
}

Xplostream::Xplostream (Xplostream *s)
{ s1 = NULL;
  s2 = NULL;
  if (s)
  { type = s->type;
    s1 = s->s1;
    s2 = s->s2;
    fp = 0;
  }
  else
  { type = 0;
    s1 = &cout;
    fp = 0;
  }
}

#ifndef __BORLANDC__
Xplostream::Xplostream(ostream& s)
{ type = 0;
  s1 = &s;
  fp = 1;
}
#else
Xplostream::Xplostream(lostream& s)
{ type = 0;
  s1 = &s;
  fp = 1;
}
#endif

Xplostream& Xplostream::operator<<(const char *s)
{ if (type)
    *s2 << s;
  else
    *s1 << s;
  return (*this);
}

Xplostream::~Xplostream()  // SWS 5.11.97
{ if (type && fp) delete[] s2; }

char* Xplostream::ptr()
{ return s2->ptr; }

long Xplostream::len()
{ return s2->len; }
