/* $Header: /home/xplore/cvs/xpl4gr/plot.h,v 1.5 2003/06/17 14:57:04 cizek Exp $ */

#ifndef _PLOT_H
#define _PLOT_H

#include <math.h>
#include <malloc.h>
#include <stdio.h>
#include <string.h>

#include "object.h"
#include "vismat.h"
#include "xplio.h"
#include "xplmat.h"
#include "display.h"
#include "subdis.h"
#include "axe.h"
#include "xplore_strings.h"

#define AXIS_FORMAT "%.2f"
#define MARK_SYMBOL 9	//nummer des kreuzes in all_symbols liste; si. insym.C
#define AXIS_OFFSET 10	//raum zwishen punkte und axen 10=3+2+3+2 rahmenbreite;
			//proportional bemessen!
//#define MIN_BORDER 25	//minimal offset to draw the axis values; in PIXEL
#define MIN_BORDER 16	//minimal offset to draw the axis values; in PIXEL
//#define MIN_FONT 11	//minimal font_groesse
#define MIN_FONT 6	//minimal font_groesse

#define HEAD_HEIGHT	0.7	//head-string height is 0.7 from offset
#define FONT_PROP	0.8	//font proportions; used inWindows
#define PSFONT_PROP 	0.7	//makes the ps-font to look out as windows font

#define TICK_STRING_HEIGHT 0.4	//tick-string height is 0.4 from offset
#define TICK_HEIGHT 0.1	//strich-height is 0.1 .....
/* IMPORTANT: TICK_STRING_HEIGHT + TICK_STRING_HEIGHT + TICK_HEIGHT must be < 1 */
//#define DEFAULT_FONT "-*-*-*-*-*--*-*-*-*-*-*-*-*"
#define DEFAULT_FONT 	XMSG_UNIXFONT_TIMES12_STR

#define PSFN_SERIF       "Times-Roman"
#define PSFN_SANSSERIF   "Helvetica"
#define PSFN_MONOSPACE   "Courier"

class Plot;

/*-----------------------------------------------------------------------*/

#define ZWEI 2		//	2-dimens. plot

/*-----------------------------------------------------------------------*/

#define BRUSH_SIZE 10	// 10 % from width and height for brush rectangle
/* 	AXIS_OFFSET and BRUSH_SIZE are global for all plots	*/

/*-----------------------------------------------------------------------*/

struct _Data2MCL	{	Plot * plot;
				int data;
				int my_data;
			};
typedef _Data2MCL DataToLink;
/*	Data2MCL is needed for plots linking	*/
				
/*-----------------------------------------------------------------------*/

struct _Text_Data	{	char *text;
				int font_number;
				int color_number;
				XplMatrix where;
			};
typedef struct _Text_Data Text_Data;
/*	Text_Data is needed for Draw String	*/

/*-----------------------------------------------------------------------*/
	
struct _Button_Struct	{	char *button_name;
				char *button_function;
			};
typedef struct _Button_Struct Button_Struct;
/*	Button_Struct is needed for AddButton, DeleteButton, etc			
/*-----------------------------------------------------------------------*/

enum MouseFunction	{	
	NOTHING, 
	INDEX, 		//show the info about the next point
	STRING, 	//show the string ???? 
	SINGLE_BRUSH,	//make brush
	SINGLE_ZOOM, 	//make zoom with constant size
	BRUSH, 		// make XploRe-Brush
	ZOOM, 		//make XploRe-Zoom
	ADD_POINT	// add a one-point data set to a plot
			};
			
enum PointerFunction	{
	PNOTHING,
	PREPARE_BRUSH,
	PREPARE_ZOOM,
	PSTRING,
	PINDEX		};
						
enum BrushFunction		{XPLDELETE, HIGHLIGHT};
enum Mode 			{TRANSIENT, LAST};
enum ClickMode 			{CLOSEST, XPLTHIS};
enum FontType                   { FT_SERIF, FT_SANSSERIF, FT_MONOSPACE }; // PC 20010702

/*-----------------------------------------------------------------------*/

class Plot 	: 	public SubDisplay	{
	
private:
	
	XplMatrix RotationPoint;	// Klar? (1*n)

	XplMatrix FirstSkalierung;	//(n*n) diagonal, etwas Speicherplatz
					//wird vershenkt

	XplMatrix RotationCosinus;	//n*n mit cos, 0 und 1 gefuellt.
					//erledigt auch "andere Axen"
	XplMatrix SecondSkalierung;	//(n*n) diagonal, etwas Speicherplatz
					//wird vershenkt

	XplMatrix Translation;		//Translation zum Schluss
	
	XplMatrix Deformation[2];

	XplMatrix BackDeformation[2];
	
	
/*(x1, y1, z1)	=	((x, y, z)-RotationPoint) * FirstSkalierung * 
			RotationCosinus * SecondSkalierung - 
		-	Translation	UFFFF! Ob man auch zurueck findet??
			Mal sehen!
  (x, y, z)	=	((x1, y1, z1)+Translation) * 
  				(inverse zu SecondSkalierung) *
  				(transp. zu RotationCosinus)* 
  				(inverse zu FirstSkalierung) 
  		+	RotationPoint  
*/
	XplMatrix BackupRotationPoint;	

	XplMatrix BackupRotationCosinus;	
					
	XplMatrix BackupFirstSkalierung;	

	XplMatrix BackupSecondSkalierung;	
					
	XplMatrix BackupTranslation;		
	
	MyPoint *PointKoord;

	Liste < Button_Struct * > user_buttons;

	MyPoint cursor_from; 
	MyPoint cursor_to;		//start and finish von click_and_move
	Outfit brushed_outfit;
	int brushed_color;			
	Liste <VisMatrix *> origin_data;	//by brush save origin data!

	void UpdateDeformations();
	//	Die 4 Deformations weden updated

	void ConstructTransformations(int columncount);
	
	void GetGlobals();	//only for constructor!
	
	char * after_brush;	//a link that must be done after brush

protected:
	int voffset[2];	
	int hoffset[2];

	char *head_line;

	Liste <VisMatrix *> vis_data;

        enum FontType desc_font_type;

public:

	bool offset_equal;	//ALSO, was passiert bei resize?
				//falls offset_equal,
				//wird groesserer rahmen and kleineren rahmen angepasst;
				//dabei aendert sich z.b. voffset
				//SONST werden die rahmen unterschiedlich breit
				//default ist true;
				// after getgot with offsets it is false.

	Liste <Achse > Axis;
	Liste <Achse > BackupAxis;

	Liste <Text_Data *> text_liste;

	Liste <DataToLink *> link_liste;	//	Make Color Link

	int last_click_x;
	int last_click_y;

	MouseFunction	mouse_function[3];	//ZOOM, NOTHING, INDEX
	/*	action after mouse-action for 3 mouse buttons	*/

	PointerFunction pointer_function;	//NOTHING!
	/*	action for mouse motion 			*/

	BrushFunction	brush_function;		//HIGHLIGHT
	Mode 		brush_mode;		//TRANSIENT
	Mode 		index_mode;		//TRANSIENT

	ClickMode	click_mode;

	int brush_size[4];

	bool axis_on;

	bool rotation_point_on;

	bool rotation_point_move_mode;

	bool refresh_automatic;

/*	Darstellung:		*/

	bool xtickmarks;
   bool ytickmarks;
   bool xaxisline;	// PC 001206 - draw x / y line for axis?
   bool yaxisline;	// PC 001206

	bool head_on;

	bool is_linked; /* for RPC */
	int linked_to;
	unsigned long client_address;

/*-------------Parser- Relevant:-----------------------------------------*/
/*-----------------------------------------------------------------------*/


	Plot(const Plot * plot=NULL, XplDisplay* dixi=NULL,
		const int di_x=1, const int di_y=1);

	/*	Plot(const Plot &, XplDisplay* dixi=NULL,
		const int di_x=1, const di_y=1);

	*/
	Plot(const Liste <XplObject *> * data_list,
		XplDisplay* dixi=NULL,
		const int di_x=1, const int di_y=1);

	Plot(XplDisplay* dixi=NULL,
		const int di_x=1, const int di_y=1);


/*----------------------------------------------------------------------*/

	virtual ~Plot()	;

/*----------------------------------------------------------------------*/

	virtual void InFocus();

	virtual void Refresh() const;

	virtual int redraw_points(int data_num, XplMatrix & only_these);
/* 	to use only after color_brush	!!!!!			*/
	
	virtual int repaint_part(int part_x, int part_y, 
		int part_width, int part_height) const;

/*-----------------------------------------------------------------------*/	

	int GetDimension() const;	// to get the number of columns

/*----------------------------------------------------------------------*/
/*	Foolowing functions allow to rotate and rescale Plot and data:	*/

	void SetTransformation(	XplMatrix *RP, XplMatrix *FSkal,
				XplMatrix *R, XplMatrix *Sk,
				XplMatrix *Tr);
	//	If you use it with some NULL's as pointer, 
	//	the previous value will not changed.
			
	void MakeBackup() ; 	//before you zoom, you must backup the axis
				//and all the Transformation!
	void GetBackup();	//by Reset or smth else

	XplMatrix GetRotationPoint() const;	

	XplMatrix GetRotationCosinus() const;

	XplMatrix GetSecondSkalierung() const;		

	XplMatrix GetFirstSkalierung() const;		

	XplMatrix GetTranslation() const;

/*-----------------------------------------------------------------------*/

	void Print(FILE *psf) const;
	void Print(const char * file_name) const;
	/*----------------------------------------------------------------------*/

	virtual void Resize(int wi, int he);	
	//The data and axis will be rescaled

	virtual void Replace(int ttop, int bbottom, int lleft, int rright);
	/* is needed by setfractions and Resize)		*/
	
/*-----------------------------------------------------------------------*/

	void Out(int data_num) const;	// 
	void Out() const;	// for all all datasets

/*--------------------------------------------------------------------*/

	int GetDataCount()	const
	{	return(vis_data.laenge());	}

	void DeleteAll();
	
	int DeleteData(int i);
//           	returns i, falls erfolgreich, 0 sonst.
// 		i = 1 .. vis_data.laenge() sein

	int AddData(XplObject *m);

	XplObject * GetXplObject(int data_num) const;
//           	returns XplObject(data), falls erfolgreich, 0 sonst.
// 		i = 1 .. vis_data.laenge() sein
	
/*-----------------------------------------------------------------------*/

	MyPoint* GetPointKoord() const;		// please, make NO delete at it!

/*-----------------------------------------------------------------------*/

	// data_num=0 	: 	for all data_parts in plot!
	// which_point=0:	for all points!
	//line_num=0	:	for all lines in data_part!
	//some=NULL	:	connect all points!
	// sonst:	data_num : 1.. vis_data.laenge() 
	//		color	 : 1 .. all_colors.laenge()
	//		line_outfit: 1(solid, thickness=1) ......
	

	int GetPointCount(int data_num) const;

	void SetPointColor(int color, int data_num=0, int which_point=0);
	
	void SetPointColor(int color, int data_num, const XplMatrix);
	
	void SetPointLayout(Outfit out, int data_num=0, int which_point=0);

	int GetPointColor(int data_num, int which_point) const;

	int GetPointLayout(int data_num, int which_point) const;
		
	void SetPointLayout(int layout, int data_num, const XplMatrix);

/*-----------------------------------------------------------------------*/

	Liste <MyPolygon *> GetPolygons() const;	//gets all polygons!

	int GetPolygonCount(int data_num) const;

	void AddPolygon(int data_num, int how_much, int *some=NULL, 
				int color=1, int line_outfit=1);	
	void DeletePolygon(int data_num=0, int line_num=0);

	void SetPolygonColor(int color, int data_num=0, int line_num=0);

	void SetPolygonLayout(int line_out, int data_num=0, int line_num=0);

	void SetPolygonThick(int th, int data_num=0, int line_num=0);

	int GetPolygonColor(int data_num, int line_num) const;

	int GetPolygonLayout(int data_num, int line_num) const;

	int GetPolygonThick(int data_num, int line_num) const;
	
	int GetPolygonSize(int data_num, int line_num) const;
	
	MyPoint* GetPointsToPolygon(int dat_num, int polli_num) const;

/*	The same for labels						*/

	Boolean SomeLabels(int data_num) const;

	Liste <XplLabel > GetLabels(int data_num, int point_number=0) const;

	int SetLabels(int data_num, const Liste <int>, 
		const Liste <XplLabel> & );

/*-----------------------------------------------------------------------*/
/*	The following functions can be helpfull:			*/

//	A Function to get a i. row:
//	data_num=1, ..., vis_data.laenge()
//	i=1, ..., number of points in this dataset
	XplMatrix &  RealPoint(int data_num, int i) const;

	bool IsHomogen(int data_num) const;	
//	whether all points of this set have the same color and layout

/*	Two functions to bind real coordinates and screen coordinates:	*/

	MyPoint GetImage(XplMatrix &x) const;
	XplMatrix GetOrigin(MyPoint &x) const;

/*-----------------------------------------------------------------------*/

	int QuadrDistToPoint(MyPoint & mouse_pointer,
				int data_number,
				int point_number);
	int QuadrDistToLine(MyPoint & mouse_pointer,
				int data_number,
				int line_number);
	/* 	return the quadrat from disatance in window geometry	*/
	
	int NearestPointTo(MyPoint &x) const;	//get the index (1, ..., n)
	int NearestLineTo(MyPoint &x) const;	//get the line index (1, ..., n)

	Boolean IsThisPoint(	MyPoint & mouse_pointer, 
				int data_number,
				int point_number);
	/* 	uses the pointsize and QuadrDistToPoint*/

	MyPoint CenterOfPolygon(int data_number,
				int line_number);
	Boolean InThisLine(	MyPoint & mouse_pointer, 
				int data_number,
				int line_number);
	/* 	for lines: uses the linewidth and QuadrDistToLine	*/

	Boolean InThisPolygon(	MyPoint & mouse_pointer, 
				int data_number,
				int line_number);
	/* 	for polygons: uses the linewidth;			*/
	/*	is ==0 if the point belongs the polygon or the border	*/

//	data_num=1, ..., vis_data.laenge()
//	point_number=1, ..., number of points in this dataset
//	line_number=1, ..., number of lines in this dataset


/*-----------------------------------------------------------------------*/

   bool GetAxes() const { return(axis_on); } 	//MS 030611
   void SetAxes(bool setaxes) { axis_on = setaxes; } 	//MS 030611

/*-----------------------------------------------------------------------*/

	void SetHOffset(int left, int right);	
	void SetVOffset(int top, int bottom);
	
/* 	You can get offsets( int[2] ) with :				*/
	XplMatrix GetHOffset() const;	//dont forget to delete it later!
	XplMatrix GetVOffset() const;	//dont forget to delete it later!

/* -----------------------------------------------------------------------*/

        void SetFontType(char *type);             // PC 20010702
        void SetFontType(enum FontType type);     // PC 20010702
        
        const char *GetFontTypeA(void) const;      // PC 20010702
        enum FontType GetFontTypeI(void) const;    // PC 20010702
        
/* -----------------------------------------------------------------------*/
	
	void SetHeadline(const char *name);

	char* GetHeadline() const ;	//you must delete it later yourselves!

	char* GetDataName(int i) const;//you must delete it later yourselves!
		
	void SetDataName(int i, const char *name);	

	char *GetColumnName(int data_num, int i) const;
		//you must delete it later yourselves!

	void SetColumnName(int data_num, int i, const char *c);

/*-----------------------------------------------------------------------*/

	Achse GetAchse(int i) const;
//	i soll 1 oder 2 oder ... sein
	
	int SetAchse(const Achse & ach);
	
/*--------Grenzwerte TOTAL::----------------------------------*/

	XplMatrix PlotMinToDimension()  const;
	
	XplMatrix PlotMaxToDimension()  const;
	
/*-----------------------------------------------------------------------*/

	virtual void AddButton(const char *, const char*);

	virtual void DeleteButton(const char *);

/*-----------------------------------------------------------------------*/

	void MakeAfterBrush();

	virtual void 	SetBrushFunction(const char *);

	virtual void SetBrushBoard(MyPoint from, MyPoint to);

	virtual XplMatrix GetBrushed(int data_num);	//liefert index_vector

	virtual XplMatrix SetBrushOutfit(Outfit ou);

	virtual XplMatrix SetBrushColor(int color);

	virtual void SetBrushed(int data_num, XplMatrix ind_vec);

/*-----------------------------------------------------------------------*/	

	bool left_frame_visible() const;
	bool right_frame_visible() const;
	bool top_frame_visible() const;
	bool bottom_frame_visible() const;
	bool frame_visible() const;

/*-----------------------------------------------------------------------*/	

        const char *GetPSFontName(void) const;

		};
		
extern void SetXYtoPlot(Plot &p, int x, int y);
extern char * axisstring(const Plot *plot, int i);
extern void prepare_string(char * str);
#endif

		
