/* $Header: /home/xplore/cvs/xpl4gr/plot0.C,v 1.3 2002/08/16 12:31:48 sigbert Exp $ */

#include <stdio.h>

#ifndef __BORLANDC__ //LOOK!
#include <unistd.h>
#else
#include <process.h>
#include "xplore.h"

#endif

#include "plot.h"
#include "color.h"
typedef Achse* AchseP;

//#include "psstr.h"

static int n=0;		//zahler der plots

bool global_axis_on=(0==0);
bool global_head_on=(0==1);

int global_hoffset[]={AXIS_OFFSET, AXIS_OFFSET};	//	rahmenbreite
int global_voffset[]={AXIS_OFFSET, AXIS_OFFSET};	//	rahmenbreite
bool global_offset_equal=(0==0);
bool global_rotation_point_on=(0==1);
bool global_rotation_point_move_mode=(0==1);
MouseFunction global_mouse_function[]={ZOOM, NOTHING, INDEX};
PointerFunction global_pointer_function=PNOTHING;
BrushFunction global_brush_function=HIGHLIGHT;
Mode global_brush_mode=TRANSIENT;
Mode global_index_mode=TRANSIENT;
int  global_brush_size[]={BRUSH_SIZE, BRUSH_SIZE, BRUSH_SIZE, BRUSH_SIZE};
ClickMode global_click_mode=CLOSEST;

#define RP_SIZE 4
#define SCAL_SIZE 100
void Plot::GetGlobals()
{	hoffset[0]=global_hoffset[0];
	voffset[0]=global_voffset[0];
	hoffset[1]=global_hoffset[1];
	voffset[1]=global_voffset[1];
	
	axis_on=global_axis_on;
	head_on=global_head_on;
	rotation_point_on=global_rotation_point_on;
	rotation_point_move_mode=global_rotation_point_move_mode;

	mouse_function[0]=global_mouse_function[0];
	mouse_function[1]=global_mouse_function[1];
	mouse_function[2]=global_mouse_function[2];
	pointer_function=global_pointer_function;

	brush_function=global_brush_function;
	brush_mode=global_brush_mode;
	index_mode=global_index_mode;
	click_mode=global_click_mode;
	
	brush_size[0]=global_brush_size[0];
	brush_size[1]=global_brush_size[1];
	brush_size[2]=global_brush_size[2];
	brush_size[3]=global_brush_size[3];
}

extern int checkup(Liste <XplObject*> vars);
/* prueft, ob man diese liste ploten kann	*/

extern void set_automatic_tickmark (Achse * ach);


Plot::Plot(const Plot *plot, XplDisplay* dixi,
		const int di_x, const int di_y): refresh_automatic((0==0)),
		SubDisplay(dixi, di_x, di_y), after_brush(NULL),
		offset_equal((0==0))
{
   desc_font_type = FT_SERIF;    // 20010702
   xaxisline=true;	// PC 001206
   yaxisline=true;
#ifdef _BLABLA_
	xtickmarks=true;
   ytickmarks=true;
	cout<<"Plot(const Plot *plot=NULL, XplDisplay* dixi=NULL,
		const int di_x=1, const di_y=1) ist aufgerufen"<< endl;
#endif	
	int i;	

	type=PLOT;
	is_linked=(0==1);

	if (dixi==NULL)
	{	XplDouble veri(1), hori(1);
		SubType was[1];
		was[0]=PLOT;
		veri.fill(1.0);
		hori.fill(1.0);
		dixi=new XplDisplay(veri, hori);
		exit(12);
	}

	if (plot==NULL)
	{	globalError.Set (ERR_INTERN, "ERROR::plot ist leer");
		globalError.ShowError();
#ifdef _BLABLA_
		cerr<<"ERROR::plot ist leer"<<endl;
#endif		
		PointKoord=NULL;
		ConstructTransformations(ZWEI);
		GetGlobals();
		head_line=strdup("PICTURE");
		width=500;
		height=500;	
		exit(111);
	}
	else
	{	GetGlobals();
		head_line=strdup(plot->head_line);
		if (plot->vis_data.laenge()==0)
		{	PointKoord=NULL;
			return;
		}
		
		int rows, cols;	
		Text_Data *text_struct;

		RotationPoint=plot->RotationPoint;
		RotationCosinus=plot->RotationCosinus;
		FirstSkalierung=plot->FirstSkalierung;
		SecondSkalierung=plot->SecondSkalierung;
		Translation=plot->Translation;
		Deformation[0]=plot->Deformation[0];
		Deformation[1]=plot->Deformation[1];
		BackDeformation[0]=plot->BackDeformation[0];
		BackDeformation[1]=plot->BackDeformation[1];
	
		cols=RotationPoint.cols();

		hoffset[0]=plot->hoffset[0];
		hoffset[1]=plot->hoffset[1];
		voffset[0]=plot->voffset[0];
		voffset[1]=plot->voffset[1];
		axis_on=plot->axis_on;
		head_on=plot->head_on;
		rotation_point_on=plot->rotation_point_on;
		mouse_function[0]=plot->mouse_function[0];
		mouse_function[1]=plot->mouse_function[1];
		mouse_function[2]=plot->mouse_function[2];
		brush_function=plot->brush_function;
		brush_mode=plot->brush_mode;
		for (i=0; i<4; i++)
			brush_size[i]=plot->brush_size[i];


/*
#ifndef __BORLANDC__
		axis=new (Achse *) [cols];
#else
		axis=new AchseP[cols];
#endif
*/		
		for (i=0; i<plot->Axis.laenge(); i++)
			Axis.haengeAn(plot->Axis[i]);
		for (i=0; i<plot->BackupAxis.laenge(); i++)
			BackupAxis.haengeAn(plot->BackupAxis[i]);
		
	/*	for (i=0; i<cols; i++)
			Axis.haengeAn(plot->Axis[i]);
	*/	
		VisMatrix *vm;
		for (i=0; i<plot->vis_data.laenge(); i++)
		{	vm=new VisMatrix( *(plot->vis_data[i]));
			vis_data.haengeAn(vm);	
		}
	// das da oben ist wohl zu speicherverschenkend...???
		for (i=0; i<plot->text_liste.laenge(); i++)
		{	text_struct=new Text_Data;
			memcpy(text_struct, plot->text_liste[i],
				 sizeof(Text_Data));
			text_struct->text=strdup(plot->text_liste[i]->text);
			text_liste.haengeAn((text_struct));
		}
	
	/*
		DataToLink *dtl1, *dtl2;
		for (i=0; i<plot->link_liste.laenge(); i++)
		{	dtl1=new DataToLink;
			memcpy(dtl1, plot->link_liste[i],
				 sizeof(DataToLink));
			link_liste.haengeAn((dtl1));
			dtl2=new DataToLink;
			link_liste->plot->link_liste.haengeAn((dtl2));
			
		}
	*/
		rows=0;
		
		for (i=0; i<vis_data.laenge(); i++)
			rows+=vis_data[i]->GetPointCount();
		PointKoord=new MyPoint [rows];
		UpdateDeformations();
		//memcpy(PointKoord, plot->PointKoord, sizeof(MyPoint)*rows);
	}
}




Plot::Plot(	XplDisplay* dixi,
		const int di_x, const int di_y): refresh_automatic((0==0)),
		SubDisplay(dixi, di_x, di_y), after_brush(NULL),
		offset_equal((0==0))
{
   desc_font_type = FT_SERIF;    // 20010702
   xaxisline=true;	// PC 001206
   yaxisline=true;
	xtickmarks=true;
   ytickmarks=true;
#ifdef _BLABLA_
/*OK*/	cout<<"Plot(XplDisplay* dixi=NULL, 
		const int di_x=1, const di_y=1) ist aufgerufen"<< endl;
#endif	
	GetGlobals();
	type=PLOT;
	is_linked=(0==1);
	head_line=strdup("PICTURE");
	PointKoord=NULL;
	axis_on=False;
	//	ConstructTransformations(ZWEI);
}
	
Plot::Plot(const Liste <XplObject*> *vars, XplDisplay* dixi,
		const int di_x, const int di_y): refresh_automatic((0==0)),
		SubDisplay(dixi, di_x, di_y), after_brush(NULL),
		offset_equal((0==0))
{	int i, j;
	type=PLOT;

	head_on=(0==1);
	head_line=strdup("PICTURE");
   desc_font_type = FT_SERIF;    // 20010702
   xaxisline=true;	// PC 001206
   yaxisline=true;
	xtickmarks=true;
   ytickmarks=true;

#ifdef _BLABLA_
/*OK*/	cout<<"Plot(const Liste <XplObject*> *vars, XplDisplay* dixi=NULL,
		const int di_x=1, const di_y=1) ist aufgerufen"<< endl;
#endif
	if (dixi==NULL)
	{
#ifdef _BLABLA_
/*OK*/	cout<<"Create new dixi,..."<<endl;
#endif	
		XplDouble veri(1), hori(1);
		SubType was[1];
		was[0]=PLOT;
		veri.fill(1.0);
		hori.fill(1.0);
		dixi=new XplDisplay(veri, hori);
		exit(1);
	}


#ifdef _BLABLA_
/*OK*/	cout<<"	Plot mit "<<
	"vars->laenge()="<<vars->laenge()<<endl;
#endif
	if (vars->laenge()==0)
	{	//cout<<"	Plot(const Liste <XplObject*> *vars) mit "<<
		//"vars->laenge()==0"<<endl;
		globalError.Set (ERR_INTERN, "ERROR::plot ist leer");
		globalError.ShowError();

		ConstructTransformations(ZWEI);
		GetGlobals();
/*
#ifndef __BORLANDC__
		axis=new (Achse *) [ZWEI];
#else
		axis=new AchseP[ZWEI];
#endif
*/
		for (i=0; i<ZWEI; i++)
		{	Achse ach(i+1, 0, 1);
			Axis.haengeAn(ach);
		}
//	SubDisplayInFokus();
		return;
	}



	int checked_cols, rows;
	MyPoint *mp;
	checked_cols=checkup(*vars);
	VisMatrix *visi;
	for (i=0; i<vars->laenge(); i++)
	{	visi=new VisMatrix((*vars)[i]);
		vis_data.haengeAn(visi);				
	}

	ConstructTransformations(checked_cols);

	n++;
	GetGlobals();
/*
#ifndef __BORLANDC__
	axis=new (Achse *) [checked_cols];
#else
	axis=new AchseP[checked_cols];
#endif
*/	

	XplMatrix  mini=PlotMinToDimension();

	XplMatrix  maxi=PlotMaxToDimension();


	RotationPoint=(maxi+mini)/2.0;

#ifdef _BLABLA_
	cout<<"RotPoint:"<<endl;
	RotationPoint.out();
#endif
	//es soll in Rahmen passen:

/* 	SWS 4.2.98		*/

	if (hoffset[0]*width/100<MIN_BORDER) // offset is too small!
	{	hoffset[0]= MIN_BORDER*100/width+2;
		hoffset[1]= MIN_BORDER*100/width+2;
	}

	if (voffset[0]*height/100<MIN_BORDER) // offset is too small!
	{	voffset[0]= MIN_BORDER*100/height+2;
		voffset[1]= MIN_BORDER*100/height+2;
	}



//cout<<"VBORDER="<<voffset[0]*height/100<<endl;
//cout<<"HBORDER="<<hoffset[0]*width/100<<endl;

	if (	50<hoffset[0]+hoffset[1] ||
	 	50<voffset[0]+voffset[1]) 
	{	hoffset[0]=hoffset[1]=voffset[0]=voffset[1]=0;
		axis_on=(0==1);
		head_on=(0==1);
	//	cerr<<"Something is wrong with hoffset or voffset!"<<endl;
	}
	//	erst einheitlich skalieren:
	for (i=0; i<checked_cols; i++)
		FirstSkalierung(i, i)=maxi(0,i)-mini(0,i) >0.0 ?
		SCAL_SIZE/(maxi(0,i)-mini(0,i)) :
		SCAL_SIZE/2.0;

	SecondSkalierung(0,0)=
		(width-(hoffset[0]+hoffset[1])*width/100.0-2*SYMBOL_SIZE)/
				SCAL_SIZE;
	for (i=1; i<checked_cols; i++)
	SecondSkalierung(i,i)=
		(height-(voffset[0]+voffset[1])*height/100.0-2*SYMBOL_SIZE)/
				SCAL_SIZE;
#ifdef _BLABLA_
	cout<<"FirstSkalierung:\n";
	FirstSkalierung.out();
	cout<<"SecondSkalierung:\n";
	SecondSkalierung.out();
#endif	
	if (checked_cols>2)
	for (i=0; i<checked_cols; i++)
		FirstSkalierung(i, i)=FirstSkalierung(i, i)/1.44;
	
	//dabei wird RotPoint zum Center:
	XplMatrix  gr(1, checked_cols);
	gr.fill(0.0);
	gr(0,0)=-(width-(hoffset[0]+hoffset[1])*width/100.0)/2-
				hoffset[0]*width/100.0;
	/*
	gr(0,1)=-(height-(voffset[0]+voffset[1])*height/100.0)/2
				-voffset[0]*height/100.0;
	*/
	gr(0,1)=-(height-(voffset[0]+voffset[1])*height/100.0)/2
				-voffset[1]*height/100.0;
	for (i=2; i<checked_cols; i++)
		gr(0,i)=-width/2;
	Translation=gr;
		
	//cout<<"Translation:"<<endl;
	//Translation.out();

	rows=0;
		
	for (i=0; i<vis_data.laenge(); i++)
		rows+=vis_data[i]->GetPointCount();
	PointKoord=new MyPoint [rows];
	
	//cout<<"PointKoord Alloced fuer "<<rows<<endl;
		
	UpdateDeformations();
	
	float from, to, achoff;
	Achse ach(0, 0, 0);
	MyPoint untenlinks, obenrechts;
	untenlinks.y=(int)(voffset[1]*height/100.0+0.5);
	untenlinks.x=(int)(hoffset[1]*width/100.0+0.5);
	
	obenrechts.y=(int)(height-voffset[0]*height/100.0+0.5);
	obenrechts.x=(int)(width-hoffset[0]*width/100.0+0.5);
	
	XplMatrix oriuntenlinks, oriobenrechts;
	oriuntenlinks=GetOrigin(untenlinks);
	oriobenrechts=GetOrigin(obenrechts);
#ifdef _BLABLA_
	oriuntenlinks.out();
	oriobenrechts.out();
#endif	
	//cout<<"achoff="<<achoff<<endl;
		
	Achse *achi;

	if (checked_cols==2)
	for (i=0; i<checked_cols; i++)
	{	from=maxi(0, i)-mini(0, i) > 0.0 ?
			mini(0,i) : mini(0, i)-1;
		to=maxi(0, i)-mini(0, i) > 0.0 ?
			maxi(0,i) : maxi(0, i)+1;
		switch(i)
		{	case 0:	
			achoff=SYMBOL_SIZE*(to-from)/
		(width-hoffset[0]*width/100.0-hoffset[1]*width/100.0-2*SYMBOL_SIZE);
				break;
			
			case 1:	
			achoff=SYMBOL_SIZE*(to-from)/
	(height-(voffset[0]+voffset[1])*height/100.0-2*SYMBOL_SIZE);
				break;
			
			default: achoff=0;
				break;
		}
		achi=new Achse(i+1, from-achoff, to+achoff);
		Axis.haengeAn(*achi);
		delete achi;
	}
	else
	for (i=0; i<checked_cols; i++)
	{	switch(i)
		{	case 0:	
			from=oriuntenlinks(0,0);
			to=oriobenrechts(0,0);
				break;
			
			case 1:	
			to=oriuntenlinks(0,1);
			from=oriobenrechts(0,1);
				break;
			
			default: 
			from=maxi(0, i)-mini(0, i) > 0.0 ?
			mini(0,i)-(maxi(0, i)-mini(0, i))*0.1 : mini(0, i)-1;
			to=maxi(0, i)-mini(0, i) > 0.0 ?
			maxi(0,i)+(maxi(0, i)-mini(0, i))*0.1 : maxi(0, i)+1;
			break;
		}
		achi=new Achse(i+1, from, to);
		Axis.haengeAn(*achi);
		delete achi;
	}
		



}

/*-----------------------------------------------------------------------*/

Plot::~Plot()
	{	int i;
#ifdef _BLABLA_
	cout<<"Plot::~Plot() aufgerufen"<<endl;
#endif
/*	WANN WIRD ES AUFGERUFEN???????*/
/*	1.	delete p;	//p st Plot *
			Man soll unterscheiden, ob es ein plot oder display war.
			Fuer plot fenster vernichten;
			fuer display nur inhalt und menu loeschen.
	2.	dixi[1,1]=plot(x~y)	(parser)
			Dabei soll inhalt und menu geloescht werden
			und dann Plot::Plot(..., dixi, 1, 1) aufgerufen.
*/	
		for (i=0; i<text_liste.laenge(); i++)
		{	delete text_liste[i]->text;
			delete text_liste[i];
		}
		
		for (i=0; i<user_buttons.laenge(); i++)
		{	delete user_buttons[i]->button_name;
			delete user_buttons[i]->button_function;
			delete user_buttons[i];
		}
			

		for (i=0; i<vis_data.laenge(); i++)
			delete vis_data[i];
		if (head_line!=NULL)
			delete head_line;
		if (PointKoord!=NULL)
			delete PointKoord;
					
	Plot *plot_to_link;
		
	int pln, j;
#ifdef _BLABLA_
	cout<<"Plot::~Plot() :"<<link_liste.laenge()<<" links to delete!"<<endl;
#endif
/*
	for (i=0; i<link_liste.laenge(); i++)
	{	plot_to_link=link_liste[i]->plot;

#ifdef _BLABLA_
	cout<<"Plot::~Plot() : link to "<<link_liste[i]->data
	<<" to "<<link_liste[i]->my_data<<endl;
#endif


		for (j=0; j<plot_to_link->link_liste.laenge(); j++)
		if (plot_to_link->link_liste[j]->plot==this)
			break;
		if (j==plot_to_link->link_liste.laenge())	
		{	cerr<<"darf nicht passieren!"<<endl;
			exit(1);
		}
		//delete (plot_to_link->link_liste[j]);
		plot_to_link->link_liste.loesche(j);
	}
				
#ifdef _BLABLA_
	cout<<"Plot::~Plot() :"<<link_liste.laenge()<<" links to delete!"<<endl;
#endif

	for (i=0; i<link_liste.laenge(); i++)
	{	//delete (link_liste[i]);
		link_liste.loesche(i);
	}		
*/
#ifdef _BLABLA_

	for (i=0; i<Axis.laenge(); i++)
		Axis[i].Out();
		
	for (i=0; i<BackupAxis.laenge(); i++)
		BackupAxis[i].Out();
		
	cout<<"Plot::~Plot() : ends here"<<endl;
#endif
		
}	
	
