/* $Header: /home/xplore/cvs/xpl4gr/printing.h,v 1.3 2002/08/16 12:31:48 sigbert Exp $ */

//----------------------------------------------------------------------------
// ObjectWindows
// Copyright (c) 1991, 1995 by Borland International, All Rights Reserved
//  This application displays and prints a Ruler using OWL printer classes.
//----------------------------------------------------------------------------
#include <owl/pch.h>
#include <owl/applicat.h>
#include <owl/framewin.h>
#include <owl/dc.h>
#include <owl/printer.h>
#include <owl/editfile.rh>
#include <winsys/system.h>
#include <stdlib.h>
#include <string.h>

#include "xplore.rh"

#define ZeilenProSeite 40
//
// class TWindowPrintout
// ~~~~~ ~~~~~~~~~~~~~~~
class TWindowPrintout : public TPrintout {
  public:
    TWindowPrintout(const char* title, TWindow* window,
                    int pn = 1, unsigned long lines = 1,
                    TRect *margins = NULL, TPoint *paper = NULL,
                    unsigned tab = 8, char *fontname = NULL, unsigned fontsize = 0);

    void GetDialogInfo(int& minPage, int& maxPage,
                       int& selFromPage, int& selToPage);
    void PrintPage(int page, TRect& rect, unsigned flags);
    void SetBanding(bool b)
    {
      Banding = b;
    }
    bool HasPage(int pageNumber);
    int ActPage;	// need for multiple pages

  protected:
    TWindow* Window;
    bool     Scale;
    int pn;		        // total pagenumber - ignored if it is not positive
    unsigned long numlines;	// remaining number of lines to be printed
                                // used if pn is not positive 
    TRect    printmargins;	// margins for printing
    TPoint   papersize;		// page size
    TRect    devicemargins;     // print margins transformed to device points

    unsigned tabsize;           // size of the tabelator

#define DEFAULTPRTFONT   "Courier New"
#define DEFAULTPRTSIZE   10
#define PRTFONTNAMELEN   256
    char PrtFontName[PRTFONTNAMELEN + 4];    // name of the font for printing
    unsigned PrtFontSize;       // size of the print font
};


