/* $Header: /home/xplore/cvs/xpl4gr/property.C,v 1.3 2002/08/16 12:31:48 sigbert Exp $ */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "machine.h"
#include "initxa.hpp"
#include "property.h"

#ifndef HAS_STRCMPI
#define strcmpi strcasecmp
#endif

Properties property;

Properties::Properties ()
{ key = NULL;
  con = NULL;
  n=0;
}

Properties::Properties (int argc, char *argkey[], char *argdef[])
{ int i;
  n = argc;
  key = new charp[n];
  con = new charp[n];
  for (i=0; i<n; i++)
  { key[i] = strdup (argkey[i]);
    con[i] = strdup (argdef[i]);
  }
}
 
Properties::~Properties()
{ int i;
  for (i=0; i<n; i++)
  { if (key[i]) delete[] key[i];
    if (con[i]) delete[] con[i];
  }
  delete[] key;
  delete[] con;
  n   = 0;
  key = NULL;
  con = NULL;
}

void Properties::load (char *filename)
{ FILE *f = fopen (filename, "r");
  char line[1024], *newkey, *newcon;
  int i, ln;  

  if (f==NULL) return;
  while (fgets(line, 1023, f))
  { ln = strlen(line);
    // check for whitespaces
    for (i=0; i<ln; i++)
      if (strchr("\t\n\f\r ", line[i])==NULL) break; 
    // if anything left and not comment line
    if ((i<ln) && (strchr("#!", line[i])==NULL))
    { newkey = &line[i];
      // look for delimiter char
      for (;i<ln; i++)
      { if (strchr("\t\n\f\r =:", line[i])!=NULL)
        { line[i]= 0;
          i++;
          break;
        }
      }
      // ignore all whitespaces, = and :
      for (;i<ln; i++)
      { if (strchr("\t\n\f\r =:", line[i])==NULL) break; }
      newcon = &line[i];
      // delete all trailing whitespaces
      for (i=ln-1;; i--)
      { if (strchr("\t\n\f\r ", line[i])==NULL)
        { line[i+1]= 0;
          break;
        }
      }
      setProperty (newkey, newcon);
    }
  }
}

char* Properties::getProperty (char *searchkey)
{ int i;
  for (i=0; i<n; i++)
    if (strcmpi(searchkey, key[i])==0)
      return (strdup(con[i]));
  return (NULL);
}

int Properties::setProperty (const char *newkey, const char *newcon, int fmt)
{ int i;
  char **list, *lprot;
  if (newcon==NULL) return 1;
  for (i=0; i<n; i++)
  { if (strcmpi(newkey, key[i])==0)
    { if (!prot[i])
      { if (con[i]) delete[] con[i];
        con[i] =strdup(newcon);
        // if (strncmp("xpl4", newkey, 4)!=0) makefmtstring(con[i]);
/*        FILE *f = fopen ("prop", "a");
        fprintf (f, "%s=%s\n", newkey, con[i]);
        fclose(f);
*/        return 0;
      }
      return 1;
    }
  }
  if (i==n) // no property found
  { n++;

    list = new charp[n];
    if (key)
    { memcpy (list, key, (n-1)*sizeof(char *));
      delete[] key;
    }
    key = list;
    key[n-1] = strdup(newkey);

    list = new charp[n];
    if (con)
    { memcpy (list, con, (n-1)*sizeof(char *));
      delete[] con;
    }
    con = list;
    con[n-1] = strdup(newcon);
    if (fmt) makefmtstring(con[n-1]);

    lprot = new char[n];
    if (prot)
    { memcpy (lprot, prot, (n-1)*sizeof(char));
      delete[] prot;
    }
    prot = lprot;
    prot[n-1] = 0;
  }
  return 0;
}

void Properties::protectProperty (char *searchkey)
{ int i;
  char **list, *lprot;
  for (i=0; i<n; i++)
  { if (strcmpi(searchkey, key[i])==0)
    { prot[i] = 1;
      break;
    }
  }
  if (i==n)
  { setProperty (searchkey, "");
    prot[i] = 1;
  }
}

extern void logt (const char *txt);

void Properties::dump ()
{ int i;
  char tmp[1024];
  for (i=0; i<n; i++)
  { if (prot[i])
      sprintf (tmp, "protected  : %s=%s\r\n", key[i], con[i]);
    else
      sprintf (tmp, "unprotected: %s=%s\r\n", key[i], con[i]);
    logt(tmp);
  }
}

int Properties::length()
{ return n; }

char* Properties::propertyName(int i)
{ return (key[i]); }

