/* $Header: /home/xplore/cvs/xpl4gr/qsort.h,v 1.3 2002/08/16 12:31:48 sigbert Exp $ */

#ifndef	_QSORT_H_
#define _QSORT_H_

// #pragma interface

// Implements quicksort for Pointers arranged in type 'liste' or arrays

// TTK, 16.2.97

template<class T>
void qsortlist (Liste<T> &feld, long left, long right)
{
  long   links, rechts, mitte;
  T      hilf, x;

  if (left >= right)
    return;

  links  = left;
  rechts = right;
  mitte  = (left+right)/2;
  x = feld[mitte];
  do {
     while (*(feld[links])  < *x)  links++;
     while (*(feld[rechts]) > *x)  rechts--;
     if (links <= rechts)
       {
       hilf = feld[rechts];
       feld[rechts] = feld[links];
       feld[links] = hilf;
       links++;  rechts--;
       }
     } while (links < rechts);

  if (left < rechts)
    qsortlist (feld, left, rechts);
  if (links < right)
    qsortlist (feld, links, right);
}

template<class T>
void qsortlist (Vector<T> &feld, long left, long right)
{
  long   links, rechts, mitte;
  T      hilf, x;

  if (left >= right)
    return;

  links  = left;
  rechts = right;
  mitte  = (left+right)/2;
  x = feld[mitte];
  do {
     while (*(feld[links])  < *x)  links++;
     while (*(feld[rechts]) > *x)  rechts--;
     if (links <= rechts)
       {
       hilf = feld[rechts];
       feld[rechts] = feld[links];
       feld[links] = hilf;
       links++;  rechts--;
       }
     } while (links < rechts);

  if (left < rechts)
    qsortlist (feld, left, rechts);
  if (links < right)
    qsortlist (feld, links, right);
}

template<class T>
void bsortlist (Vector<T> &feld)
{
  long i, length = feld.laenge ();
  T    x = feld[length-1];             // last element has to be sorted in

  for (i=length-2; i>=0; i--)
    if (*(feld[i]) > *x)
      feld[i+1] = feld[i];             // shift element to the top
    else
      {
      feld[i+1] = x;                   // insert x
      return;
      }
      
  feld[0] = x;                         // x is the smallest element

}

#endif // _QSORT_H_
  
