/* $Header: /home/xplore/cvs/xpl4gr/remnan.C,v 1.3 2002/08/16 12:31:49 sigbert Exp $ */

#include "object.h"

extern int  XisNumber (double x);

bool NANorINF(double x)
{return(!XisNumber(x));}

bool * RowHasNaN(XplDouble &quelle)
{	int rows=quelle.dimension(0);
  	int cols=quelle.dimension(1);
  	bool * nan_found = new bool [rows];
  	int i, j, k;
  	for (i=0; i<rows; i++)
	{	nan_found[i]=(1==0);
		for (j=0; (j<cols)&&(!nan_found[i]); j++)
			nan_found[i]=NANorINF(quelle(i, j));
  				
	}
 	return(nan_found);
}     

XplObject * RemoveNaN( XplObject * const m )
{
	int i, j, k, l, rows, cols, real_rows;
	char *la;
	Component *comp;
		
	XplDouble *xpld=m->DefaultXplDouble();
	rows=xpld->dimension(0);
	cols=xpld->dimension(1);
		
	bool *where_nans=RowHasNaN(*xpld);
	real_rows=0;
	for (i=0; i<rows; i++)
		if (!where_nans[i])
			real_rows++;
	if (real_rows==rows)
	{	delete[]  where_nans;
		return(m);
	}
		
	if (real_rows==0)
	{	globalError.Set (ERR_INTERN, "there are only NaNs!");
		delete [] where_nans;
		return(NULL);
	}

	int * ind=new int [rows];
	k=0;
	for (i=0; i<rows; i++)
	{	if (!where_nans[i])
		{	k++;
			ind[i]=k;
		}
		else
			ind[i]=0;
		//cout<<i+1<<": "<<ind[i]<<endl;
	}			
				
		
	XplDouble neudouble(real_rows, cols);	
	k=0;
	for (i=0; i<rows; i++)
	if (!where_nans[i])
	{	for (j=0; j<cols; j++)
			neudouble(k, j)=(*xpld)(i, j);
		k++;
	}

  	XplObject *o  = new XplObject (new XplDouble (neudouble), m->Name());
		
	XplMask *mask_to_use=NULL;
	
	XplMask * neumask=NULL;

    	XplArray<long>  r(1), g(1), b(1), a(1), s(1);
    	XplArray<long> *rr, *gg, *bb, *ss, *aa;

	comp=m->GetComponent("_pmask");
	if (comp!=NULL)
	{	mask_to_use=comp->Content().xplmask;
		if (mask_to_use==NULL)
			globalError.Set(ERR_INTERN, "pmask is bad");
		
		else
		{	if (mask_to_use->dimension(0)==1)
			{	//homogen
				neumask=new XplMask(*mask_to_use);
			}
			if (mask_to_use->dimension(0)==rows)
			{	neumask=new XplMask(real_rows);
				r=mask_to_use->getred();
				g=mask_to_use->getgreen();
				b=mask_to_use->getblue();
				a=mask_to_use->getsymbol();
				s=mask_to_use->getsize();
				rr=new XplArray<long>(real_rows);
				gg=new XplArray<long>(real_rows);
				bb=new XplArray<long>(real_rows);
				aa=new XplArray<long>(real_rows);
				ss=new XplArray<long>(real_rows);
				
				k=0;
				for (i=0; i<rows; i++)
				{
				if (!where_nans[i])
				{	(*rr)(k)=r(i);
					(*gg)(k)=g(i);
					(*bb)(k)=b(i);
					(*ss)(k)=s(i);
					(*aa)(k)=a(i);
					k++;
				}
				}
				neumask->setred(*rr);
				neumask->setgreen(*gg);
				neumask->setblue(*bb);
				neumask->setsymbol(*aa);
				neumask->setsize(*ss);
				
				delete rr;
				delete gg;
				delete bb;
				delete ss;
				delete aa;
			
			}				
			if (neumask==NULL)
				globalError.Set(ERR_INTERN, "pmask is bad");
			
		}
	}
	if (neumask!=NULL)
		o->AppendComponent (new Component (neumask ,"_pmask"));

	XplDouble * neulines=NULL;
	XplDouble * neulcolor=NULL;
	XplDouble * neulsize=NULL;
	XplDouble * neulstyle=NULL;
	XplDouble * to_use=NULL;
	int lines_rows=0, lines_cols=0;
	int el;

	comp=m->GetComponent("_poly");
	if (comp!=NULL)
	{	to_use=comp->Content().xpldouble;
		if (to_use==NULL)
			globalError.Set(ERR_INTERN, "lines vector is bad");
		else
		{	lines_rows=(int) (to_use->dimension(0));
			lines_cols=(int) (to_use->dimension(1));
			neulines= new XplDouble(lines_rows, lines_cols);
			for (i=0; i<lines_rows; i++)
			for (j=0; j<lines_cols; j++)
			{	el=(int)((*to_use)(i, j));
				if ( el<0 || el>rows)
				{	globalError.Set (ERR_INTERN, 
						"lines vector is bad");
					(*neulines)(i, j)=0;
				}
				(*neulines)(i, j)=ind[el-1];
			
			}
		}
	}
	if (neulines!=NULL)
		o->AppendComponent (new Component (neulines ,"_poly"));
  	else
  	{	delete ind;
		delete where_nans;
		return(o);
  	}

	neumask=NULL;
	comp=m->GetComponent("_lmask");
	if (comp!=NULL)
	{	mask_to_use=comp->Content().xplmask;
		if (mask_to_use==NULL)
			globalError.Set(ERR_INTERN, "pmask is bad");
		
		else
		{	if (mask_to_use->dimension(0)==1)
			{	//homogen
				neumask=new XplMask(*mask_to_use);
			}
			if (mask_to_use->dimension(0)==rows)
			{	neumask=new XplMask(real_rows);
				r=mask_to_use->getred();
				g=mask_to_use->getgreen();
				b=mask_to_use->getblue();
				a=mask_to_use->getsymbol();
				s=mask_to_use->getsize();
				rr=new XplArray<long>(real_rows);
				gg=new XplArray<long>(real_rows);
				bb=new XplArray<long>(real_rows);
				aa=new XplArray<long>(real_rows);
				ss=new XplArray<long>(real_rows);
				
				k=0;
				for (i=0; i<rows; i++)
				{
				if (!where_nans[i])
				{	(*rr)(k)=r(i);
					(*gg)(k)=g(i);
					(*bb)(k)=b(i);
					(*ss)(k)=s(i);
					(*aa)(k)=a(i);
					k++;
				}
				}
				neumask->setred(*rr);
				neumask->setgreen(*gg);
				neumask->setblue(*bb);
				neumask->setsymbol(*aa);
				neumask->setsize(*ss);
				
				delete rr;
				delete gg;
				delete bb;
				delete ss;
				delete aa;

			}
		}


	}
	if (neumask!=NULL)
		o->AppendComponent (new Component (neumask ,"_lmask"));

	
		
	delete ind;
	delete where_nans;
	return(o);
	
}

