/* $Header: /home/xplore/cvs/xpl4gr/rpcfun.C,v 1.3 2002/08/16 12:31:49 sigbert Exp $ */

#pragma implementation "liste.h"

#include <math.h>
#include <stdlib.h>
#include <sys/types.h> 
#include <stdio.h>
#include <new.h>
#ifndef __BORLANDC__
#include <unistd.h>
#else
#include <process.h>
#endif
#include <signal.h>

#include "liste.h"
#include "init.h"
#include "function.h"
#include "macro.h"
#include "xplfun.h"
#include "xplfun2.h"
#include "xplfun3.h"
#include "xplbasefun.h"
#include "plot.h"
#include "color.h"

#define READ_ONLY_COUNT 9

extern Liste <XplSymbol *> all_symbols;
extern Liste <XplColor *> all_colors;

extern int FindColor(int, int, int);

#ifdef _UNIX_
extern "C" BS_Glob_Variable bs_glob_variable;
#endif
extern Plot * PlotRequested(Liste<XplObject*> *argl);

#ifdef _RPCXGOBI_
int   XGobiHandle;
unsigned long XGobiPortnumber;

extern "C" void internRPCStartServer (unsigned long);
extern "C" void internRPCStopServer ();

extern "C" int internRPCStartClient (unsigned long);
extern "C" void internRPCStopClient (int);

extern "C" char * internRPCSendRequest (int, int, char *, double);

extern "C" char * xgobi_const_colors ();

extern "C" int airequest (int, unsigned long, char *, char *, double);

struct TIMER_S	{	int id;
			int time;
			char *botschaft;
		};	

Liste <int> all_timers;


extern void parse (const char *line);

extern "C" void cparse (char *line)
{	parse(line);
}

Boolean IsTimer(int id)
{	int i;
	for (i=0; i<all_timers.laenge(); i++)
		if (all_timers[i]==id)
			return(True);
	return(False);
}

#include <rpc/rpc.h>

Boolean RunWorkProcs ()

{
  int   i;

  fd_set readfds,
         writefds,
         exceptfds;

  struct timeval timeout;

  FD_ZERO (&readfds);
  FD_ZERO (&writefds);
  FD_ZERO (&exceptfds);

  timeout.tv_sec = 0;
  timeout.tv_usec = 100;

  for (i = 0; i < howmany (FD_SETSIZE, NFDBITS); i++)
    readfds.fds_bits[i] = svc_fdset.fds_bits[i];

  select (FD_SETSIZE, &readfds, &writefds, &exceptfds, &timeout);
  svc_getreqset (&readfds);

}

void MyTimer(struct TIMER_S *ds, XtIntervalId *idPtr)
{	if (!(IsTimer(ds->id)))
		return;

	RunWorkProcs ();

	
	XtAppAddTimeOut(bs_glob_variable.kontext, ds->time, MyTimer, 
				(caddr_t) ds);
	return;
}

XplObject * StartServer(Liste<XplObject*> *argl)
{	
	unsigned long port = 0L;
	XplChar *c;
	char *t;

	
	if (argl->laenge()!=1)
	{	globalError.Set(ERR_INTERN, "wrong number of arguments - must be 1");
		globalError.ShowError();
		return(NULL);
	}

	c=(*argl)[0]->DefaultComponent()->Content().xplchar;
	if (c==NULL)
	{	globalError.Set(ERR_INTERN, "the first parameter must be a hex string");
		globalError.ShowError();
		return(NULL);
	}
	t=(*c)(0).tostr();
	
	if (sscanf(t, "%x", &port) != 1)
	{	globalError.Set(ERR_INTERN, "the first parameter must be a hex string");
		globalError.ShowError();
		return(NULL);
	}
	
	if ((port<0x40000000) || (port>0x7FFFFFFF))
	{	globalError.Set(ERR_INTERN, "the hex string is invalid");
		globalError.ShowError();
		return(NULL);
	}

	internRPCStartServer (port);
	
	return(NULL);
}

XplObject * StopServer(Liste<XplObject*> *argl)
{
  	if (argl->laenge()!=0)
  	{	globalError.Set(ERR_INTERN, "wrong number of arguments - must be 0");
		globalError.ShowError();
		return (NULL);
	}

	internRPCStopServer();
	
	return(NULL);
}

XplObject * StartClient(Liste<XplObject*> *argl)
{	
	XplDouble *d1;
	XplObject *o;
	unsigned long port = 0L;
	int id;
	XplChar *c;
	char *t;


	if (argl->laenge()!=1)
	{	globalError.Set(ERR_INTERN, "wrong number of arguments - must be 1");
		globalError.ShowError();
		return(NULL);
	}

	c=(*argl)[0]->DefaultComponent()->Content().xplchar;
	if (c==NULL)
	{	globalError.Set(ERR_INTERN, "the first parameter must be a hex string");
		globalError.ShowError();
		return(NULL);
	}
	t=(*c)(0).tostr();
	
	if (sscanf(t, "%x", &port) != 1)
	{	globalError.Set(ERR_INTERN, "the first parameter must be a hex string");
		globalError.ShowError();
		return(NULL);
	}
	
	if ((port<0x40000000) || (port>0x7FFFFFFF))
	{	globalError.Set(ERR_INTERN, "the hex string is invalid");
		globalError.ShowError();
		return(NULL);
	}
	
	id = internRPCStartClient (port);
	
	d1 = new XplDouble(1);
	(*d1)(0) = (double) id;
	o = new XplObject (d1, "client_id");
	return (o);
}

XplObject * StopClient(Liste<XplObject*> *argl)
{	
	XplDouble *d0;
	int id;
	
  	if (argl->laenge()!=1)
  	{	globalError.Set(ERR_INTERN, "wrong number of arguments - must be 1");
		globalError.ShowError();
		return (NULL);
	}

	d0=(*argl)[0]->DefaultXplDouble();
  	if (d0==NULL)
  	{	globalError.Set(ERR_INTERN, "first argument must be a scalar");
		globalError.ShowError();
		return (NULL);
	}
	id= (int)( (*d0)[0]);
	if (id<0)
  	{	globalError.Set(ERR_INTERN, "first argument must be >= 0");
		globalError.ShowError();
		return (NULL);
	}

	internRPCStopClient (id);
	
	return(NULL);
}

XplObject * StartTimer(Liste<XplObject*> *argl)
{	
	int time, id;
	XplDouble *d0, *d1;
	XplChar *c;
	char *t;
	
	if (argl->laenge()!=3)
	{	globalError.Set(ERR_INTERN, "wrong number of arguments - must be 3");
		globalError.ShowError();
		return(NULL);
	}

	d0=(*argl)[0]->DefaultXplDouble();
  	if (d0==NULL)
  	{	globalError.Set(ERR_INTERN, "first argument must be a scalar");
		globalError.ShowError();
		return (NULL);
	}
	time= (int)( (*d0)[0]);
	if (time<0)
  	{	globalError.Set(ERR_INTERN, "first argument must be >= 0");
		globalError.ShowError();
		return (NULL);
	}

	d1=(*argl)[1]->DefaultXplDouble();
  	if (d1==NULL)
  	{	globalError.Set(ERR_INTERN, "second argument must be a scalar");
		globalError.ShowError();
		return (NULL);
	}
	id= (int)( (*d1)[0]);
	if (id<0)
  	{	globalError.Set(ERR_INTERN, "second argument must be >= 0");
		globalError.ShowError();
		return (NULL);
	}


	c=(*argl)[2]->DefaultComponent()->Content().xplchar;
  	if (c==NULL)
  	{	globalError.Set(ERR_INTERN, "third argument must be a string");
		globalError.ShowError();
		return (NULL);
	}
	t=(*c)(0).tostr();

	struct TIMER_S *ds=(struct TIMER_S *)(new (struct TIMER_S));
	ds->time=time;
	ds->botschaft=t;
	ds->id=id;
	XtAppAddTimeOut(bs_glob_variable.kontext, time, MyTimer, (caddr_t) ds);
	all_timers.haengeAn(id);
	return(NULL);
}

XplObject * StopTimer(Liste<XplObject*> *argl)
{	int id;
	XplDouble *d1;
	int i=0;
	
  	if (argl->laenge()!=1)
  	{	globalError.Set(ERR_INTERN, "wrong number of arguments - must be 1");
		globalError.ShowError();
		return (NULL);
	}

//	cout<<"all_timers::"<<endl;
//	while (i<all_timers.laenge())
//		cout<<all_timers[i]<<endl, i++;	

	d1=(*argl)[0]->DefaultXplDouble();
	if (d1==NULL)
  	{	globalError.Set(ERR_INTERN, "first argument must be a scalar");
		globalError.ShowError();
		return (NULL);
	}
	id= (int)( (*d1)[0]);
	if (id<0)
  	{	globalError.Set(ERR_INTERN, "first argument must be >= 0");
		globalError.ShowError();
		return (NULL);
	}
		
	if (!(IsTimer(id)))
	{	globalError.Set(ERR_INTERN, "no such timer at all");
		globalError.ShowError();
		return(NULL);
	}
	i=0;
	while (all_timers[i]!=id)
		i++;
	all_timers.loesche(i);
	return(NULL);
}	

XplObject * SendRequest(Liste<XplObject*> *argl)
{	
	int id, functnr;
	double timeout;
	XplDouble *d0, *d1, *d2;
	XplChar *c;
	char *t;
	
  	
  	if (argl->laenge()!=4)
  	{	globalError.Set(ERR_INTERN, "wrong number of arguments - must be 4");
		globalError.ShowError();
		return (NULL);
	}
	
	d0=(*argl)[0]->DefaultXplDouble();
  	if (d0==NULL)
  	{	globalError.Set(ERR_INTERN, "first argument must be a scalar");
		globalError.ShowError();
		return (NULL);
	}
	id= (int)( (*d0)[0]);

	d1=(*argl)[1]->DefaultXplDouble();
  	if (d1==NULL)
  	{	globalError.Set(ERR_INTERN, "second argument must be a scalar");
		globalError.ShowError();
		return (NULL);
	}
	functnr= (int)( (*d1)[0]);

	c=(*argl)[2]->DefaultComponent()->Content().xplchar;
  	if (c==NULL)
  	{	globalError.Set(ERR_INTERN, "third argument must be a string");
		globalError.ShowError();
		return (NULL);
	}
	t=(*c)(0).tostr();

	d2=(*argl)[3]->DefaultXplDouble();
  	if (d2==NULL)
  	{	globalError.Set(ERR_INTERN, "fourth argument must be a scalar");
		globalError.ShowError();
		return (NULL);
	}
	timeout= (double)( (*d2)[0]);
	
	char * reply=internRPCSendRequest(id, functnr, t, timeout);
	
	delete t;
	
	XplObject *o;
	xplstring xpls=reply;
	XplChar *xplc=new XplChar(1);
	(*xplc)(0)=xpls;
	delete reply;
	o=new XplObject(xplc);
	return(o);
}

XplObject * SystemCall(Liste<XplObject*> *argl)
{	
	XplChar *c;
	char *t;

	if (argl->laenge()!=1)
	{	globalError.Set(ERR_INTERN, "wrong number of arguments - must be 1");
		globalError.ShowError();
		return(NULL);
	}

	c=(*argl)[0]->DefaultComponent()->Content().xplchar;
  	if (c==NULL)
  	{	globalError.Set(ERR_INTERN, "first argument must be a string");
		globalError.ShowError();
		return (NULL);
	}
	t=(*c)(0).tostr();
	
	system(t);
	
	return(NULL);
}


#define NCOLORS 10


extern "C" {
int brush_plot(Plot * foundplot, char *to, XplDouble *gcolors)
{ char* tokptr, *dummy;
  int rows;  
  int color, size, glyph, erase, remainder;
  int number, pointtype;
  int lay;
  int xplsize, xplsym;
  unsigned long client_id = 0L;

  tokptr=strdup(to);
  dummy=tokptr; // to delete later
//cout<<"tokptr:"<<endl<<dummy<<endl;
  if (foundplot->GetDataCount()==0)	// der plot ist leer
      return(-1);		

   	/* jetzt geht es richtig los! */
   	      
  
  tokptr = strtok (tokptr," ");
  if (!sscanf (tokptr, "%x", &client_id))
  {
    //sprintf (outstr, "02.01");
    return(-1);
  }
  rows=foundplot->GetPointCount(1);
  while ((tokptr = strtok (NULL, " ")) != NULL)
  {
    if (sscanf (tokptr, "%d:%d", &number, &pointtype) < 2)
    {
      cerr<<"sscanf (tokptr .... pointtype) < 2!"<<endl;
      //sprintf (outstr, "02.03");
      return(-1);
    }

    if (number < 0 || number >= rows )
    {
      //sprintf (outstr, "02.04");
       cerr<<"number < 0 || number >= rows-1 "<<endl;
     return(-1);
    }

    size = pointtype / 1000 ;
    remainder = pointtype % 1000;
    glyph = remainder / 100;
    remainder = remainder % 100;
    erase = remainder / (NCOLORS + 1);
    color = remainder % (NCOLORS + 1);

    xplsize=2+3*size;
	
    switch(glyph)
    {	case 0: xplsym=11;
			break;
		case 1: xplsym=5;
			break;
		case 2: xplsym=2;
			break;
		case 3: xplsym=7;
			break;
		case 4: xplsym=3;
			break;
		case 5: xplsym=8;
			break;
		case 6: xplsym=1; /* Point in XGobi */
			break;
    }
		
    color=FindColor( (int) ((*gcolors)(color, 0)), (int)  ((*gcolors)(color, 1)), 
 		(int) ((*gcolors)(color, 2)));

    foundplot->SetPointColor(color, 1, number+1);
   	
    if (xplsym==1)
   	  lay=-1;
   	else
     	  lay=-2;
   	
    if (erase)
		foundplot->SetPointLayout(0, 1, number+1);
    else
    if (xplsym == 1)
		foundplot->SetPointLayout(1, 1, number+1);
    else
    {	for (lay=0; lay<all_symbols.laenge(); lay++)
   	  if (	all_symbols[lay]->symbol==xplsym && 
   			all_symbols[lay]->size==xplsize)
   	    break;
   	  if (lay==all_symbols.laenge())
          {	cerr<<"error by  size="<<xplsize<<", symbol="<<xplsym<<endl;
   			lay=3;
   	  }
   	  foundplot->SetPointLayout(lay+2, 1, number+1);
    }
  }
  delete dummy;
  foundplot->Refresh();
}

int read_brush_string(char *instr)
{
  int i, j, k, hasrows, hascols;
  unsigned long client_id = 0L;
  char *tokptr;

  const char *text;
  Component *comp;
  Plot *foundplot=NULL;		//besser so... SWS 26.2
  SubDisplay *sd;  
  char *instrcopy;
  int rows;
  XplDisplay *xpld;
 
  instrcopy = (char *) XtMalloc(strlen(instr)+1);
  strcpy (instrcopy, instr);
  
  if ((instr == NULL) || !strcmp (instr, ""))	//gleich hier! SWS 26.2.
  {
     //sprintf (outstr, "02.01");
     return(-1);
  } 

  tokptr = strtok (instr," ");
  if (!sscanf (tokptr, "%x", &client_id))
  {
    //sprintf (outstr, "02.01");
    return(-1);
  }

  XplObject *o;
 	
  for (j=0; j<objList->laenge(); j++)
  {
  		if (!strcmp("XGobiColormap", (*objList)[j]->Name()))
  			break;
  }
  	
  if (j==objList->laenge())
  {	globalError.Set(ERR_INTERN, " XGobiColormap not set!");
		globalError.ShowError();
		return (-1);
  }
  	
  XplDouble *gcolors=(*objList)[j]->DefaultXplDouble();
  if (gcolors==NULL)
  {	globalError.Set(ERR_INTERN, " XGobiColormap is invalid!");
		globalError.ShowError();
		return (-1);
  }	
	
  for (i=0; i<displayList->laenge(); i++)	//SWS 26.2
  {
    text=(*displayList)[i]->Name();
//    cout<<1+i<<". display's name:"<<text<<endl;
    comp=(*displayList)[i]->DefaultComponent();

    xpld=comp->Content().display;

    hasrows = xpld->GetRows();
    hascols = xpld->GetColumns();
    
    for (j = 1; j <= hasrows; j++)
    for (k = 1; k <= hascols; k++)
    {	sd = xpld->GetElement(j, k);
	if (sd->WhatIs()==UPLOT)
	{	foundplot= (Plot *) (*displayList)[i]->DefaultComponent()
  		->Content().display->GetElement(j, k); 
  		if (foundplot!=NULL && client_id == foundplot->client_address)
		//	j=hasrows, k= hascols;	//schleife verlassen
			brush_plot(foundplot, instrcopy, gcolors);
	}
    }
  }

  strcpy (instr, instrcopy);
  XtFree((char *) instrcopy);
}

}	//end of extern "C"



XplObject * RPCBrush(Liste<XplObject*> *argl)
{	Plot *p1;
	XplDouble *d3;
	int id;
	unsigned long address = 0L;
	XplChar *c;
	char *t;

	char RetStr[30];
	

	if (argl->laenge()!=5)
	{	globalError.Set(ERR_INTERN, "wrong number of arguments - must be 5");
		globalError.ShowError();
		return(NULL);
	}
	
	p1=PlotRequested(argl);
	if (p1==NULL)
	{	globalError.Set(ERR_INTERN, "no such plot");
		globalError.ShowError();
		return(NULL);
	}
	
	d3=(*argl)[3]->DefaultXplDouble();
	if (d3==NULL)
	{	globalError.Set(ERR_INTERN, "the fourth parameter must be an integer");
		globalError.ShowError();
		return(NULL);
	}
	id= (int)( (*d3)[0]);

	c=(*argl)[4]->DefaultComponent()->Content().xplchar;
	if (c==NULL)
	{	globalError.Set(ERR_INTERN, "the fifth parameter must be a hex string");
		globalError.ShowError();
		return(NULL);
	}
	t=(*c)(0).tostr();

	if (sscanf(t, "%x", &address) != 1)
	{	globalError.Set(ERR_INTERN, "the fifth parameter must be a hex string");
		globalError.ShowError();
		return(NULL);
	}


	if ((address<0x40000000) || (address>0x7FFFFFFF))
	{	globalError.Set(ERR_INTERN, "the hex string is invalid");
		globalError.ShowError();
		return(NULL);
	}

	p1->is_linked = True;
	p1->linked_to = id;
	p1->client_address = address;
	
	airequest (id, 14, "LINKED", RetStr, 10.0);
	
	return(NULL);
}

#endif 	// end of RPC

XplObject * Add2MCL(Liste<XplObject*> *argl)
{	Plot *p1, *p2;
	int data1, data2, wo_beg;
	
	if (argl->laenge()!=6 && argl->laenge()!=8)
	{	globalError.Set(ERR_ARGS, " must be 6 or 8");
		return(NULL);
	}
	p1=PlotRequested(argl);
	if (p1==NULL)
	{	globalError.Set(ERR_INTERN, "no such plot");
		return(NULL);
	}
	
	if ( argl->laenge()==6)
	{	data1=1;
		data2=1;
		wo_beg=0;
	}
	else
	{	if (	(*argl)[3]->DefaultXplDouble()==NULL ||
			(*argl)[7]->DefaultXplDouble()==NULL)
		{	globalError.Set(ERR_INTERN, "bad 4. or 8. parameter");
			return(NULL);
		}
		data1=(int)( (*((*argl)[3]->DefaultXplDouble()))[0]);
		data2=(int)( (*((*argl)[7]->DefaultXplDouble()))[0]);
		wo_beg=1;
	}
	
	Liste <XplObject *> li;
	li.haengeAn( (*argl)[3+wo_beg]);
	li.haengeAn( (*argl)[4+wo_beg]);
	li.haengeAn( (*argl)[5+wo_beg]);

#ifdef _BLABLA_
	cout<<"LINK zwischen"<<endl;
	cout<<(int)( (*((*argl)[1]->DefaultXplDouble()))[0])<<", ";
	cout<<(int)( (*((*argl)[2]->DefaultXplDouble()))[0])<<"\n ";
	cout<<"und"<<endl;
	cout<<(int)( (*((*argl)[4]->DefaultXplDouble()))[0])<<", ";
	cout<<(int)( (*((*argl)[5]->DefaultXplDouble()))[0])<<endl;
#endif

	p2=PlotRequested(&li);
	if (p2==NULL)
	{	globalError.Set(ERR_INTERN, "no such plot");
		return(NULL);
	}
	
	int i;
		for (i=0; i<p1->link_liste.laenge(); i++)
	if ( 	p1->link_liste[i]->plot==p2 && 
		p1->link_liste[i]->data==data2 &&
		p1->link_liste[i]->my_data==data1)
		break;
	if (i<p1->link_liste.laenge())
	{	// cout<<"are already plotted .. "<<endl;
		return(NULL);
	}

	XplDouble *xpld;
	DataToLink * elem= (DataToLink *) new DataToLink;
	elem->plot= p2;
	elem->data=data2;
	elem->my_data=data1;	
	p1->link_liste.haengeAn(elem);
	
	elem= (DataToLink *) new DataToLink;
	elem->plot= p1;
	elem->data=data1;
	elem->my_data=data2;	
	p2->link_liste.haengeAn(elem);
	
	return(NULL);
}

XplObject * SetBrushFunction(Liste<XplObject*> *argl)
{	Plot *p1;
	
	if (argl->laenge()!=4)
	{	globalError.Set(ERR_ARGS, " must be 6 or 8");
		return(NULL);
	}
	p1=PlotRequested(argl);
	if (p1==NULL)
	{	globalError.Set(ERR_INTERN, "no such plot");
		return(NULL);
	}
		
	if (! ((*argl)[3]->Type()==O_XPLCHAR))
	{	globalError.Set (ERR_INTERN, "fourth parameter must be a XplChar!");
		return(NULL);
	}

	char*b_n=(*(*argl)[3]->DefaultComponent()->
			Content().xplchar)(0).tostr();	//OK!

	p1->SetBrushFunction(b_n);
	delete b_n;
	return(NULL);
}





