/* $Header: /home/xplore/cvs/xpl4gr/setmask.C,v 1.3 2002/08/16 12:31:49 sigbert Exp $ */

#include <math.h>
#include <string.h>

//#include "display.h"
#include "xplmat.h"              // Definition of Boolean

#include "object.h"
//#include "function.h"
//#include "xplfun.h"
#include "xplerror.h"
#include "init.h"
//#include "ttkio.h"
//#include "xplexec.h"

#define DEFAULT_LINE_WIDTH 0
#define DEFAULT_COLOR 0
#define DEFAULT_SYMBOL 3
#define DEFAULT_SIZE 8
#define DEFAULT_LINE_ART 1
#define DEFAULT_LINE_THICK 0
#define DEFAULT_TEXT_DIR 0
#define DEFAULT_TEXT_SIZE 16


void DeleteComponent(XplObject *m, const char * name)
{	
  	if (m->GetComponent(name)==NULL)
  		return;
	int count, i;
	count=m->ComponentNumber();
  	for (i=0; i<count; i++)
   		if (strcmp(name, (*m)[i]->Name())==0)
   			break;
   	if (i!=count)
		m->DeleteComponent(i);
}

Boolean GoodColor(XplDouble * to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 && to_use->dimension(1)!=3)
		return(False);
	int color_number, i;
	int r, g, b;
	
	if (to_use->dimension(1)==1)
 	{	color_number=(int)( (*to_use)(0) );
		if (color_number<0 || color_number>7)
			return(False);
 		for (i=0; i<to_use->dimension(0); i++)
		if ((*to_use)(i)<0 || (*to_use)(i)>7)
			return(False);
	}
	else	// to_use->dimension(1)==3
	{	r=(int)( (*to_use)(0,0));
	 	g=(int)( (*to_use)(0,1));
	 	b=(int)( (*to_use)(0,2));
/* SK+TK 02.11.98
                color_number=FindColor(r, g, b);
		if (color_number<0 || color_number>all_colors.laenge()-1)
		{	return(False);
		}
*/
 		for (i=0; i<to_use->dimension(0); i++)
 		{	r=(int)( (*to_use)(i,0));
	 		g=(int)( (*to_use)(i,1));
	 		b=(int)( (*to_use)(i,2));
/* SK+TK 02.11.98
	 		color_number=FindColor(r, g, b);
			if (color_number<0 ||
				 	color_number>all_colors.laenge()-1)
				return(False);
*/
		}
	}
	return(True);
}

Boolean GoodPointSize(XplDouble * to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 )
		return(False);
	int i;
	
 	for (i=0; i<to_use->dimension(0); i++)
 	if (	(*to_use)(i)<0 || (*to_use)(i)>15 )
 			return(False);
 	return(True);
 }

Boolean GoodSymbol(XplDouble * to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 )
		return(False);
	int i;
	
 	for (i=0; i<to_use->dimension(0); i++)
 	if (	(*to_use)(i)<0 || (*to_use)(i)>16 )
 			return(False);
 	return(True);
 }

Boolean GoodLineSize(XplDouble * to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 )
		return(False);
	int i;
	
 	for (i=0; i<to_use->dimension(0); i++)
 	if (	(*to_use)(i)<0 || (*to_use)(i)>15 )
 			return(False);
 	return(True);
 }

Boolean GoodLineArt(XplDouble *to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 )
		return(False);
	int i;
	
 	for (i=0; i<to_use->dimension(0); i++)
 	if (	(*to_use)(i)<0 || (*to_use)(i)>15 )
 			return(False);
 	return(True);
 }

void torgb (int color_number, int *r, int *g, int *b)
{		          switch(color_number)
 { case 0: // black 
     *r= 0;
     *g= 0;
     *b= 0;
     break;
   case 1: // blue
     *r= 0;
     *g= 0;
     *b= 255;
     break;
   case 2: // green
     *r= 0;
    *g= 255;
     *b= 0;
     break;
   case 3: // cyan
     *r= 0;
     *g= 255;
     *b= 255;
     break;
   case 4: // red
     *r= 255;
     *g= 0;
     *b= 0;
     break;
   case 5: // magenta
     *r= 255;
     *g= 0;
     *b= 255;
     break;
   case 6: // yellow
     *r= 255;
     *g= 255;
     *b= 0;
     break;
   case 7: // white
     *r= 255;
     *g= 255;
     *b= 255;
     break;
   }
}


XplDouble MakeColor(XplDouble * to_use, int rows)
{	XplDouble newcolor(rows, 3);

 	Boolean homogen;
 	homogen=(to_use->dimension(0)==1);
#ifdef _BLABLA_
	cout<<	 to_use->dimension(0)<<" rows and "<<to_use->dimension(1)<<" cols"<<endl;
#endif	
	int color_number, i;
	int r, g, b;
	if (to_use->dimension(1)==1)
 	{	color_number=(int)( (*to_use)(0) );
                torgb (color_number, &r, &g, &b);
 		for (i=0; i<rows; i++)
 		{	if (!homogen)	//not homogen
 			{ color_number=(int)( (*to_use)(i) );
                          torgb (color_number, &r, &g, &b);
                        }
                                newcolor(i, 0)=r;
 				newcolor(i, 1)=g;
 				newcolor(i, 2)=b;
 		}
	}
	else	// to_use->dimension(1)==3
	{	r=(int)( (*to_use)(0,0));
	 	g=(int)( (*to_use)(0,1));
	 	b=(int)( (*to_use)(0,2));
 		for (i=0; i<rows; i++)
 		{	if (!homogen)	// not homogen
 			{	r=(int)( (*to_use)(i,0));
	 			g=(int)( (*to_use)(i,1));
	 			b=(int)( (*to_use)(i,2));
			}
 			newcolor(i, 0)=r;
 			newcolor(i, 1)=g;
 			newcolor(i, 2)=b;
		}
	}
	return(newcolor);
}       

XplObject* SetXplPointsMask(Liste<XplObject*> *argl)
{
	long      length = argl->laenge ();
  	XplDouble *x;
  	int i;
  	XplObject *o;

  	if (length < 2 )
   	 {
   	 globalError.Set (ERR_ARGS, "wrong number of args");
   	 return (NULL);
    	}

  	if ((*argl)[0]->DefaultComponent()->Type () != C_XPLDOUBLE)
   	 {
   	 globalError.Set (ERR_NUM, "setmaskp: first argument");
   	 return (NULL);
    	}

	if (GetXplObject (objList, (*argl)[0]->MotherId())==NULL)
  	 {
   	 globalError.Set (ERR_INTERN, "first  argument does not exist");
   	 return (NULL);
    	}
	
	XplObject *m=(*argl)[0];
    	x = m->DefaultXplDouble ();
  	int rows=(int) (x->dimension(0));
   	XplDouble *to_use;
	    		  
	if ((*argl)[1]->DefaultComponent()->Type () != C_XPLDOUBLE)
   	{	globalError.Set (ERR_NUM, "second argument");
    		return (NULL);
    	}
	to_use=(*argl)[1]->DefaultXplDouble ();
	if (!GoodColor(to_use, rows))
	{	globalError.Set (ERR_INTERN, "color vector is bad!");
		return(NULL);
	}
	if ( argl->laenge()>2)		
  	{	if ((*argl)[2]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "third argument");
    			return (NULL);
    		}
   		to_use=(*argl)[2]->DefaultXplDouble ();	//direction...
		if (!GoodSymbol(to_use, rows))
		{	globalError.Set (ERR_INTERN, 
				"symbol vector is bad!");
			//	to_use->mdump("%f");
			return(NULL);
		}			
	}
  	
  	if ( argl->laenge()>3)		
  	{	if ((*argl)[3]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "fourth argument");
    			return (NULL);
    		}
   		to_use=(*argl)[3]->DefaultXplDouble ();	//size...

		if (!GoodPointSize(to_use, rows))
		{	globalError.Set (ERR_INTERN, 
			 "size vector is bad!");
			return(NULL);
		}
	}
   	if ( argl->laenge()>4)		
	{	globalError.Set (ERR_INTERN, "too many arguments!");
		return(NULL);
	}

	XplDouble newcolor(rows, 3), newsymbol(rows), newsize(rows);
	newcolor.fill(DEFAULT_COLOR); 	
	newsymbol.fill(DEFAULT_SYMBOL); 	
	newsize.fill(DEFAULT_SIZE); 	

	/*::::::  WEITER MIT DER COLOR::::*/

	to_use=(*argl)[1]->DefaultXplDouble ();
	newcolor=MakeColor(to_use, rows);
 
 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"pcolor");
	if (argl->laenge()>2 )
 	{	to_use=(*argl)[2]->DefaultComponent()->Content().xpldouble;
		if (to_use->dimension(0)==1)
			newsymbol.fill( (*to_use)(0,0));
		else
			newsymbol=(*to_use);
 		DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"pstyle");
	}

	if (argl->laenge()>3 )
 	{	to_use=(*argl)[3]->DefaultComponent()->Content().xpldouble;
		if (to_use->dimension(0)==1)
			newsize.fill( (*to_use)(0,0));
		else
			newsize=(*to_use);
 		DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"psize");
	}
		
	if ((*argl)[0]->ComponentNumber()==1)
	{	XplDouble *xx =new XplDouble (*x);
		GetXplObject (objList, (*argl)[0]->MotherId())
  		->DeleteComponents();
  		GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(xx,"data")));
  	}

	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newcolor),"pcolor")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newsymbol),"pstyle")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newsize),"psize")));		

 	return (NULL);

}

XplObject* SetXplLinesMask  (Liste<XplObject*> *argl)
// generates a Maskvektor
{
  	long      length = argl->laenge ();
  	XplDouble *x, *ind_vec;
  	int i, j;	
  	XplObject *o;
	XplDouble *to_use;
	XplChar *tto_use;

  /* 	erwarted: 	data matrix; 
  			index vector mit werte 1 .. rows(data matrix);
  	optional:	color_number: 0 ..7
  			art_number  : 0 ..15
  			thick	    : 1 ..  			
  		
  */		
  	if (length < 2)
   	 {
   	 globalError.Set (ERR_ARGS, "Must be mind. 2");
   	 return (NULL);
    	}

  	if ((*argl)[0]->DefaultComponent()->Type () != C_XPLDOUBLE)
   	 {
   	 globalError.Set (ERR_NUM, "first argument");
   	 return (NULL);
    	}

 	if (GetXplObject (objList, (*argl)[0]->MotherId())==NULL)
  	 {
   	 globalError.Set (ERR_INTERN, "first  argument does not exist");
   	 return (NULL);
    	}

 	XplObject *m=(*argl)[0];
  	x = m->DefaultXplDouble ();
	 
    	int rows=(int) (x->dimension(0));
  
	/* index vector auslesen..	*/

 	if ((*argl)[1]->DefaultComponent()->Type () != C_XPLDOUBLE)
   	{	globalError.Set (ERR_INTERN, "SetXplLinesMask: second argument");
    		return (NULL);
    	}

	ind_vec=(*argl)[1]->DefaultXplDouble ();
	if (ind_vec->dimension(1)==1 )	
	{	globalError.Set (ERR_INTERN, "index is bad!");
		return(NULL);
	}
		
	int lines_rows=(int) (ind_vec->dimension(0));
	int lines_cols=(int) (ind_vec->dimension(1));
	for (i=0; i<lines_rows; i++)
	for (j=0; j<lines_cols; j++)
		if ( (*ind_vec)(i, j)<0 || (*ind_vec)(i, j)>rows)
	{	globalError.Set (ERR_INTERN, "index is bad!");
		return(NULL);
	}
	
	if ( argl->laenge()>2)		
	{	if ((*argl)[2]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "third argument");
    			return (NULL);
    		}
		to_use=(*argl)[2]->DefaultXplDouble ();
		if (!GoodColor(to_use, lines_rows))
		{	globalError.Set (ERR_INTERN, "color vector is bad!");
			return(NULL);
		}
	}
	if ( argl->laenge()>3)		
  	{	if ((*argl)[3]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "fourth argument");
    			return (NULL);
    		}
   		to_use=(*argl)[3]->DefaultXplDouble ();	//direction...
		if (!GoodLineArt(to_use, lines_rows))
		{	globalError.Set (ERR_INTERN, 
				"line art vector is bad!");
			return(NULL);
		}			
	}
  	
  	if ( argl->laenge()>4)		
  	{	if ((*argl)[4]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "fivth argument");
    			return (NULL);
    		}
   		to_use=(*argl)[4]->DefaultXplDouble ();	//size...

		if (!GoodPointSize(to_use, lines_rows))
		{	globalError.Set (ERR_INTERN, 
			 "size vector is bad!");
			return(NULL);
		}
	}
  	if ( argl->laenge()>5)		
  	{	if ((*argl)[5]->DefaultComponent()->Type () != C_XPLCHAR)
   		{	globalError.Set (ERR_NUM, "sixth argument");
    			return (NULL);
    		}
   		tto_use=(*argl)[5]->DefaultComponent()
   			->Content().xplchar ;	//text?...
   		if (tto_use->dimension(0)!=1 
   			&& tto_use->dimension(0)!=lines_rows)
   		{	globalError.Set (ERR_NUM, "text vector is bad");
    			return (NULL);
    		}
   		if (tto_use->dimension(1)!=1)
   		{	globalError.Set (ERR_NUM, "text vector is bad");
    			return (NULL);
    		}

	}
   	if ( argl->laenge()>6)		
	{	globalError.Set (ERR_INTERN, "too many arguments!");
		return(NULL);
	}

	XplDouble newcolor(lines_rows, 3), newsymbol(lines_rows);
	XplDouble newsize(lines_rows);
	XplChar newtext(lines_rows);
	newcolor.fill(DEFAULT_COLOR); 	
	newsymbol.fill(DEFAULT_LINE_ART); 	
	newsize.fill(DEFAULT_LINE_THICK); 	

	if (argl->laenge()>2 )
	{	to_use=(*argl)[2]->DefaultXplDouble ();
		newcolor=MakeColor(to_use, lines_rows);
 		DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"lcolor");
	}
	if (argl->laenge()>3 )
 	{	to_use=(*argl)[3]->DefaultComponent()->Content().xpldouble;
		if (to_use->dimension(0)==1)
			newsymbol.fill( (*to_use)(0,0));
		else
			newsymbol=(*to_use);
 	//	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
	//	 	"lstyle");
	}
	if (argl->laenge()>4 )
 	{	to_use=(*argl)[4]->DefaultComponent()->Content().xpldouble;
		if (to_use->dimension(0)==1)
			newsize.fill( (*to_use)(0,0));
		else
			newsize=(*to_use);
 	//	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
	//	 	"lsize");
	}
  	if ( argl->laenge()>5)		
  	{	if (tto_use->dimension(0)==1)
   			newtext.fill((*tto_use)(0));
   		else
   			newtext=(*tto_use);
 	//	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
	//	 	"ltext");
	}

 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"lines");
 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"lstyle");
 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"lcolor");
 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"lsize");
 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"ltext");
	
	if ((*argl)[0]->ComponentNumber()==1)
	{	XplDouble *xx =new XplDouble (*x);
		GetXplObject (objList, (*argl)[0]->MotherId())
  		->DeleteComponents();
  		GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(xx,"data")));
  	}

	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  		(new XplDouble (*ind_vec),"lines")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newcolor),"lcolor")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newsymbol),"lstyle")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newsize),"lsize")));	
  	if ( argl->laenge()>5)		
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplChar (newtext),"ltext")));	
	return(NULL); 
}

Boolean GoodDirection(XplDouble * to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 )
		return(False);
	int i;
	
 	for (i=0; i<to_use->dimension(0); i++)
 	if (	(*to_use)(i)!=-1 &&
 		(*to_use)(i)!=0 &&
 		(*to_use)(i)!=12 &&
 		(*to_use)(i)!=3 &&
 		(*to_use)(i)!=6 &&
 		(*to_use)(i)!=9 )
 			return(False);
 	return(True);
 }

Boolean GoodTextSize(XplDouble * to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 )
		return(False);
	int i;
	
 	for (i=0; i<to_use->dimension(0); i++)
 	if (	(*to_use)(i)<8 || (*to_use)(i)>128 ) 	// PC 20020227 - changed lower bound to 8
 			return(False);
 	return(True);
 }

XplObject* SetText  (Liste<XplObject*> *argl)
{
	long      length = argl->laenge ();
  	XplDouble *x;
  	XplChar  *newtext=NULL;
  	int i;
  	XplObject *o;

  	if (length < 2 )
   	 {
   	 globalError.Set (ERR_ARGS, "wrong number of args");
   	 return (NULL);
    	}

  	if ((*argl)[0]->DefaultComponent()->Type () != C_XPLDOUBLE)
   	 {
   	 globalError.Set (ERR_NUM, "setmaskt: first argument");
   	 return (NULL);
    	}

	if (GetXplObject (objList, (*argl)[0]->MotherId())==NULL)
  	 {
   	 globalError.Set (ERR_INTERN, "first  argument does not exist");
   	 return (NULL);
    	}
	
   	if ((*argl)[1]->DefaultComponent()->Type () != C_XPLCHAR)
   	 {
   	 globalError.Set (ERR_TEXT, "second argument");
   	 return (NULL);
    	}

	XplObject *m=(*argl)[0];
    	x = m->DefaultXplDouble ();
  	int rows=(int) (x->dimension(0));
   	XplDouble *to_use;
	    		  
 	newtext=(*argl)[1]->DefaultComponent()
			->Content().xplchar;
 
 	if    (rows!=newtext->dimension(0) || newtext->dimension(1)!=1)
   	 {
   	 globalError.Set (ERR_INTERN, "second argument has a wrong dimension");
   	 return (NULL);
    	}
				
	if (argl->laenge()>2)
	{	if ((*argl)[2]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "third argument");
    			return (NULL);
    		}
		to_use=(*argl)[2]->DefaultXplDouble ();
		if (!GoodColor(to_use, rows))
		{	globalError.Set (ERR_INTERN, "color vector is bad!");
			return(NULL);
		}
	}  	
	if ( argl->laenge()>3)		
  	{	if ((*argl)[3]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "fourth argument");
    			return (NULL);
    		}
   		to_use=(*argl)[3]->DefaultXplDouble ();	//direction...
		if (!GoodDirection(to_use, rows))
		{	globalError.Set (ERR_INTERN, 
				"direction vector is bad!");
			return(NULL);
		}			
	}
  	
  	if ( argl->laenge()>4)		
  	{	if ((*argl)[4]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "fivth argument");
    			return (NULL);
    		}
   		to_use=(*argl)[4]->DefaultXplDouble ();	//size...

		if (!GoodTextSize(to_use, rows))
		{	globalError.Set (ERR_INTERN, 
			 "size vector is bad!");
			return(NULL);
		}
	}
   	if ( argl->laenge()>5)		
	{	globalError.Set (ERR_INTERN, "too many arguments!");
		return(NULL);
	}

	XplDouble newcolor(rows, 3), newdir(rows), newsize(rows);
	newcolor.fill(DEFAULT_COLOR); 	
	newdir.fill(DEFAULT_TEXT_DIR); 	
	newsize.fill(DEFAULT_TEXT_SIZE); 	

	/*::::::  WEITER MIT DER COLOR::::*/

	if (argl->laenge()>2 )
	{	to_use=(*argl)[2]->DefaultXplDouble ();
		newcolor=MakeColor(to_use, rows);
 		DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"tcolor");
	}
	if (argl->laenge()>3 )
 	{	to_use=(*argl)[3]->DefaultComponent()->Content().xpldouble;
		if (to_use->dimension(0)==1)
			newdir.fill( (*to_use)(0,0));
		else
			newdir=(*to_use);
 		DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"tdirection");
	}
	if (argl->laenge()>4 )
 	{	to_use=(*argl)[4]->DefaultComponent()->Content().xpldouble;
		if (to_use->dimension(0)==1)
			newsize.fill( (*to_use)(0,0));
		else
			newsize=(*to_use);
 		DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"tsize");
	}
 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"ptext");
	
	if ((*argl)[0]->ComponentNumber()==1)
	{	XplDouble *xx =new XplDouble (*x);
		GetXplObject (objList, (*argl)[0]->MotherId())
  		->DeleteComponents();
  		GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(xx,"data")));
  	}
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  		(new XplChar (*newtext),"ptext")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newcolor),"tcolor")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newdir),"tdirection")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newsize),"tsize")));		
  	return (NULL);

}

