/* $Header: /home/xplore/cvs/xpl4gr/socket.C,v 1.3 2002/08/16 12:31:50 sigbert Exp $ */

// Socket class: Implementation of server and client

// TTK, 19.7.98

#ifndef X4singleserver

#include<iostream.h>

#include "socket.h"
#include "string.h"


SocketIO * SocketServer::open (const int portnumber,
		 	       const int maxFork, const int queuelength)
{
  if ((s = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    return (NULL);

  port     = portnumber;
  queuelen = queuelength;

  /*  service = getservbyname ("xpl4", "tcp");
  if (service != NULL)
    ep_addr.server_port = service->s_port;
  else */
    {
    server.sin_family      = AF_INET;
    server.sin_addr.s_addr = INADDR_ANY;
    server.sin_port        = htons (port);
    }

  if (bind (s, (struct sockaddr*) &server, sizeof (server)) < 0)
    {
    cerr << "Socket server could not bind at port " << port << endl;
    exit (0);
    }

  listen (s, queuelen);

  return (NULL);
}

SocketIO * SocketServer::accept ()
{
#ifdef _XOPEN_SOURCE && _XOPEN_SOURCE_EXTENDED
  sock = ::accept (s, (struct sockaddr*) &client_addr, (socklen_t *) &c_addrlen);
#else
  sock = ::accept (s, (struct sockaddr*) &client_addr, &c_addrlen);
#endif

  // determine client address
#ifdef _XOPEN_SOURCE && _XOPEN_SOURCE_EXTENDED
  if (getpeername (sock,  (struct sockaddr*) &client, (socklen_t *) &cllen) < 0)
    return (NULL);
#else
  if (getpeername (sock,  (struct sockaddr*) &client, &cllen) < 0)
    return (NULL);
#endif

  // translate into dot notation
  ipaddrclient = inet_ntoa (client.sin_addr);
  // try to get the host name where the client runs
  in     = inet_addr (inet_ntoa (client.sin_addr));
  host   = gethostbyaddr ((char*)&in, sizeof(in), AF_INET);

  sockIO = new SocketIO (sock, TRUE);
  sockIO->establish ();

  return (sockIO);
}

SocketIO * SocketClient::connect (const char *serveraddr, int portnumber)
{
  hostInfo = gethostbyname (serveraddr);

  if (hostInfo == NULL)
    return (NULL);

  servername = strdup (hostInfo->h_name);

  serviceInfo = getservbyport (htons (portnumber), "tcp");

  //  if (serviceInfo == NULL)
  //    return (NULL);

  // vgl Netzwerkprogrammierung unter Linux und UNIX
  memcpy ((char *) &server.sin_addr, hostInfo->h_addr, hostInfo->h_length);
  //  server.sin_port = htons ((u_short) serviceInfo->s_port);

  server.sin_port   = htons ((u_short) portnumber);
  server.sin_family = AF_INET;

  if ((sock = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    return (NULL);

  if (::connect (sock, (struct sockaddr*) &server, sizeof (server)) < 0)
    return (NULL);

  return (sockIO = new SocketIO (sock, FALSE));
}

// Microsoft needs special startup code
#ifdef WIN32
void WindowsSocketStartup ()
{
  static int alreadyRun = FALSE;

  if (alreadyRun)
    return;

  alreadyRun = TRUE;

  WORD    wVersionRequested;
  WSADATA wsaData;
  int     err;

  wVersionRequested = MAKEWORD (2, 0);
 
  err = ::WSAStartup (wVersionRequested, &wsaData);
  if ( err != 0 )
    {
    // Tell the user that we couldn't find a usable
    // WinSock DLL.
    exit (1);
    }
}
#endif

#endif


