/* $Header: /home/xplore/cvs/xpl4gr/socket.h,v 1.3 2002/08/16 12:31:50 sigbert Exp $ */

// Socket class: Implementation of server and client

// TTK, 19.7.98

#ifndef X4singleserver

#ifndef _SOCKET_
#define _SOCKET_

// Microsoft does not have these includes
#ifndef WIN32

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>

#include <sys/wait.h>
#include <netinet/in.h>

#else

#include <winsock2.h>
void WindowsSocketStartup ();

#endif

#include "socketio.h"

class SocketServer
{
public:
  SocketServer  ()  { cllen     = sizeof (sockaddr_in);
                      c_addrlen = sizeof (sockaddr);
#ifdef WIN32
		      WindowsSocketStartup ();
#endif
                    }

  ~SocketServer ()  { delete sockIO; }

  SocketIO*  open  (const int portnumber,
		    const int maxFork = 0, const int queuelength = 5);

  SocketIO*  accept ();

  void close ();

private:
  struct hostent     *hostInfo;
  struct servent     *serviceInfo;
  struct sockaddr_in server, client;
  struct sockaddr    ep_addr, client_addr;
  int                c_addrlen;
  int                cllen;
  hostent            *host;
  unsigned long      in;
  char               *ipaddrclient;

  int  port, queuelen, sock, s;
  char *servername;

  SocketIO *sockIO;
};

class SocketClient
{
public:
  SocketClient  ()   { cllen     = sizeof (sockaddr_in);
                       c_addrlen = sizeof (sockaddr);  
#ifdef WIN32
		       WindowsSocketStartup ();
#endif
                     }
  ~SocketClient ()   { delete sockIO; }

  SocketIO*  connect  (const char *server, int portnumber);
//  void       close () { sockIO; }

private:
  struct hostent     *hostInfo;
  struct servent     *serviceInfo;
  struct sockaddr_in server, client;
  struct sockaddr    ep_addr, client_addr;
  int                c_addrlen, cllen;
  hostent            *host;
  unsigned long      in;
  char               *ipaddr;

  int  port, queuelen, sock;
  char *servername;
  SocketIO *sockIO;
};

#endif


#endif
