/* $Header: /home/xplore/cvs/xpl4gr/subdis.h,v 1.3 2002/08/16 12:31:50 sigbert Exp $ */

#ifndef _SUBDIS_H
#define _SUBDIS_H

#include <math.h>
#include <malloc.h>
#include <stdio.h>
#include <string.h>

#include "object.h"
#include "vismat.h"
#include "xplio.h"
#include "xplmat.h"
#include "display.h"

enum SubType	{	TEXT, PLOT, MENUE, 
			UPLOT, UTEXT, UMENUE, 
			WTEXT, WPLOT, WMENUE, 
			JPLOT, JTEXT, JMENUE, 
			SUBDIS
		};

class SubDisplay 	{
/*		 an abstract class				*/
protected:
/*		Window attributs:					*/
	SubType type;
	int width;
	int height;

	int top;	// to place a SubDisplsy in XplDisplay
	int bottom;
	int left;
	int right;

	XplDisplay * display;	// The container.
				// You may need it for Constructor
	int di_x, di_y;

   bool border;	// PC 001122 - border around subdisplay?

public:
	SubDisplay(const SubDisplay * sd, XplDisplay* dixi,
		const int di_x=1, const int di_y=1);

	SubDisplay(XplDisplay* dixi,
		const int di_x=1, const int di_y=1);

/*-----------------------------------------------------------------------*/

	virtual ~SubDisplay()	;

/*-----------------------------------------------------------------------*/

	int GetX() const	{	return(di_x);}
	int GetY() const	{	return(di_y);}

	int GetWidth() const	{	return(width);}
	int GetHeight() const	{	return(height);}

   bool GetBorder() const { return(border); } 	// PC 001122
   void SetBorder(bool setborder) { border = setborder; } 	// PC 001122

	XplDisplay * GetDisplay() const	{ return(display); }

	SubType WhatIs() const 	{	return(type);	}

	virtual void Replace(int ttop, int bbottom, int lleft, int rright);
	/* is needed by setfractions and Resize)		*/

	virtual void Resize(int wi, int he);	// Plot.h

/*	All the following functions must be defined			*/
/*	for Plot, VisText and Menue	:				*/

	virtual void Out() const =0;

	virtual void Print(FILE *psf) const =0 ;
	virtual void Print(const char * file_name) const=0;

	virtual void Refresh() const=0;

/*-----------------------------------------------------------------------*/

		};

#ifdef __BORLANDC__
typedef SubDisplay* SDP;
#endif

#endif	//end of ifdef _SUBDIS_

		
