/* $Header: /home/xplore/cvs/xpl4gr/swefun1.C,v 1.3 2002/08/16 12:31:50 sigbert Exp $ */

#include <math.h>
#include <string.h>

#ifdef _UNIX_
#include "udisp.h"
#else
#ifdef __BORLANDC__
#include "xplore.h"
#include "wdisp.h"
#include "xplore.rh"
#else
#include "display.h"
#endif
#endif

#include "object.h"
#include "function.h"
#include "xplfun.h"
#include "xplerror.h"
#include "init.h"
#include "ttkio.h"
#include "xplexec.h"



#include "text.h"
#include "plot.h"
#include "color.h"

extern Liste <XplColor *> all_colors;
extern Liste <XplSymbol *> all_symbols;

extern Plot * PlotRequested (Liste<XplObject*> *argl);

#define TEXTLENGTH  1024L

#define LABEL_SIZE 10 

extern int FindColor(int, int, int);

void DeleteComponent(XplObject *m, const char * name)
{	
  	if (m	->GetComponent(name)==NULL)
  		return;
	int count, i;
	count=m->ComponentNumber();
  	for (i=0; i<count; i++)
   		if (strcmp(name, (*m)[i]->Name())==0)
   			break;
   	if (i!=count)
		m->DeleteComponent(i);
}

Boolean GoodColor(XplDouble * to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 && to_use->dimension(1)!=3)
		return(False);
	int color_number, i;
	int r, g, b;
	
	if (to_use->dimension(1)==1)
 	{	color_number=(int)( (*to_use)(0) );
		if (color_number<0 || color_number>all_colors.laenge()-1)
			return(False);
 		for (i=0; i<to_use->dimension(0); i++)
		if ((*to_use)(i)<0 || (*to_use)(i)>all_colors.laenge()-1)
			return(False);
	}
	else	// to_use->dimension(1)==3
	{	r=(int)( (*to_use)(0,0));
	 	g=(int)( (*to_use)(0,1));
	 	b=(int)( (*to_use)(0,2));
	 	color_number=FindColor(r, g, b);
		if (color_number<0 || color_number>all_colors.laenge()-1)
		{	return(False);
		}
 		for (i=0; i<to_use->dimension(0); i++)
 		{	r=(int)( (*to_use)(i,0));
	 		g=(int)( (*to_use)(i,1));
	 		b=(int)( (*to_use)(i,2));
	 		color_number=FindColor(r, g, b);
			if (color_number<0 ||
				 	color_number>all_colors.laenge()-1)
				return(False);
		}
	}
	return(True);
}
	
Boolean GoodDirection(XplDouble * to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 )
		return(False);
	int i;
	
 	for (i=0; i<to_use->dimension(0); i++)
 	if (	(*to_use)(i)!=-1 &&
 		(*to_use)(i)!=0 &&
 		(*to_use)(i)!=12 &&
 		(*to_use)(i)!=3 &&
 		(*to_use)(i)!=6 &&
 		(*to_use)(i)!=9 )
 			return(False);
 	return(True);
 }

Boolean GoodTextSize(XplDouble * to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 )
		return(False);
	int i;
	
 	for (i=0; i<to_use->dimension(0); i++)
 	if (	(*to_use)(i)<8 || (*to_use)(i)>128 )	// PC 20020227 - changed lower bound to 8
 			return(False);
 	return(True);
 }

Boolean GoodPointSize(XplDouble * to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 )
		return(False);
	int i;
	
 	for (i=0; i<to_use->dimension(0); i++)
 	if (	(*to_use)(i)<0 || (*to_use)(i)>15 )
 			return(False);
 	return(True);
 }

Boolean GoodSymbol(XplDouble * to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 )
		return(False);
	int i;
	
 	for (i=0; i<to_use->dimension(0); i++)
 	if (	(*to_use)(i)<0 || (*to_use)(i)>16 )
 			return(False);
 	return(True);
 }

Boolean GoodLineSize(XplDouble * to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 )
		return(False);
	int i;
	
 	for (i=0; i<to_use->dimension(0); i++)
 	if (	(*to_use)(i)<0 || (*to_use)(i)>15 )
 			return(False);
 	return(True);
 }

Boolean GoodLineArt(XplDouble *to_use, int rows)
{	if (to_use->dimension(0)!=1 && to_use->dimension(0)!=rows)
		return(False);
	if (to_use->dimension(1)!=1 )
		return(False);
	int i;
	
 	for (i=0; i<to_use->dimension(0); i++)
 	if (	(*to_use)(i)<0 || (*to_use)(i)>15 )
 			return(False);
 	return(True);
 }
XplDouble MakeColor(XplDouble * to_use, int rows)
{	XplDouble newcolor(rows, 3);

 	Boolean homogen;
 	homogen=(to_use->dimension(0)==1);
#ifdef _BLABLA_
	cout<<	 to_use->dimension(0)<<" rows and "<<to_use->dimension(1)<<" cols"<<endl;
#endif	
	int color_number, i;
	int r, g, b;
	if (to_use->dimension(1)==1)
 	{	color_number=(int)( (*to_use)(0) );
	//all_colors[color_number]->requested.out();
		r=(int) ( (all_colors[color_number]->requested)(0,0) );
		g=(int) ( (all_colors[color_number]->requested)(0,1) );
		b=(int) ( (all_colors[color_number]->requested)(0,2) );
 		for (i=0; i<rows; i++)
 		{	if (homogen)	//homogen
 			{	newcolor(i, 0)=r;
 				newcolor(i, 1)=g;
 				newcolor(i, 2)=b;
 			}
 			else
 			{	 color_number=(int)( (*to_use)(i) );
				newcolor(i, 0)=
				(all_colors[color_number]->requested)(0,0);
				newcolor(i, 1)=
				(all_colors[color_number]->requested)(0,1);
				newcolor(i, 2)=
				(all_colors[color_number]->requested)(0,2);
			}

		}
	}
	else	// to_use->dimension(1)==3
	{	r=(int)( (*to_use)(0,0));
	 	g=(int)( (*to_use)(0,1));
	 	b=(int)( (*to_use)(0,2));
	 	color_number=FindColor(r, g, b);
		r=(int) ( (all_colors[color_number]->requested)(0,0) );
		g=(int) ( (all_colors[color_number]->requested)(0,1) );
		b=(int) ( (all_colors[color_number]->requested)(0,2) );

 		for (i=0; i<rows; i++)
 		{	if (homogen)	//homogen
 			{	newcolor(i, 0)=r;
 				newcolor(i, 1)=g;
 				newcolor(i, 2)=b;
 			}
 			else
 			{	r=(int)( (*to_use)(i,0));
	 			g=(int)( (*to_use)(i,1));
	 			b=(int)( (*to_use)(i,2));
	 			color_number=FindColor(r, g, b);
				newcolor(i, 0)=
				(all_colors[color_number]->requested)(0,0);
				newcolor(i, 1)=
				(all_colors[color_number]->requested)(0,1);
				newcolor(i, 2)=
				(all_colors[color_number]->requested)(0,2);
			}

		}
	}
	return(newcolor);
}

XplObject* SetText  (Liste<XplObject*> *argl)
{
	long      length = argl->laenge ();
  	XplDouble *x;
  	XplChar  *newtext=NULL;
  	int i;
  	XplObject *o;

  	if (length < 2 )
   	 {
   	 globalError.Set (ERR_ARGS, "wrong number of args");
   	 return (NULL);
    	}

  	if ((*argl)[0]->DefaultComponent()->Type () != C_XPLDOUBLE)
   	 {
   	 globalError.Set (ERR_NUM, "setmaskt: first argument");
   	 return (NULL);
    	}

	if (GetXplObject (objList, (*argl)[0]->MotherId())==NULL)
  	 {
   	 globalError.Set (ERR_INTERN, "first  argument does not exist");
   	 return (NULL);
    	}
	
   	if ((*argl)[1]->DefaultComponent()->Type () != C_XPLCHAR)
   	 {
   	 globalError.Set (ERR_TEXT, "second argument");
   	 return (NULL);
    	}

	XplObject *m=(*argl)[0];
    	x = m->DefaultXplDouble ();
  	int rows=(int) (x->dimension(0));
   	XplDouble *to_use;
	    		  
 	newtext=(*argl)[1]->DefaultComponent()
			->Content().xplchar;
 
 	if    (rows!=newtext->dimension(0) || newtext->dimension(1)!=1)
   	 {
   	 globalError.Set (ERR_INTERN, "second argument has a wrong dimension");
   	 return (NULL);
    	}
				
	if (argl->laenge()>2)
	{	if ((*argl)[2]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "third argument");
    			return (NULL);
    		}
		to_use=(*argl)[2]->DefaultXplDouble ();
		if (!GoodColor(to_use, rows))
		{	globalError.Set (ERR_INTERN, "color vector is bad!");
			return(NULL);
		}
	}  	
	if ( argl->laenge()>3)		
  	{	if ((*argl)[3]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "fourth argument");
    			return (NULL);
    		}
   		to_use=(*argl)[3]->DefaultXplDouble ();	//direction...
		if (!GoodDirection(to_use, rows))
		{	globalError.Set (ERR_INTERN, 
				"direction vector is bad!");
			return(NULL);
		}			
	}
  	
  	if ( argl->laenge()>4)		
  	{	if ((*argl)[4]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "fivth argument");
    			return (NULL);
    		}
   		to_use=(*argl)[4]->DefaultXplDouble ();	//size...

		if (!GoodTextSize(to_use, rows))
		{	globalError.Set (ERR_INTERN, 
			 "size vector is bad!");
			return(NULL);
		}
	}
   	if ( argl->laenge()>5)		
	{	globalError.Set (ERR_INTERN, "too many arguments!");
		return(NULL);
	}

	XplDouble newcolor(rows, 3), newdir(rows), newsize(rows);
	newcolor.fill(DEFAULT_COLOR); 	
	newdir.fill(DEFAULT_TEXT_DIR); 	
	newsize.fill(DEFAULT_TEXT_SIZE); 	

	/*::::::  WEITER MIT DER COLOR::::*/

	if (argl->laenge()>2 )
	{	to_use=(*argl)[2]->DefaultXplDouble ();
		newcolor=MakeColor(to_use, rows);
 		DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"tcolor");
	}
	if (argl->laenge()>3 )
 	{	to_use=(*argl)[3]->DefaultComponent()->Content().xpldouble;
		if (to_use->dimension(0)==1)
			newdir.fill( (*to_use)(0,0));
		else
			newdir=(*to_use);
 		DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"tdirection");
	}
	if (argl->laenge()>4 )
 	{	to_use=(*argl)[4]->DefaultComponent()->Content().xpldouble;
		if (to_use->dimension(0)==1)
			newsize.fill( (*to_use)(0,0));
		else
			newsize=(*to_use);
 		DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"tsize");
	}
 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"ptext");
	
	if ((*argl)[0]->ComponentNumber()==1)
	{	XplDouble *xx =new XplDouble (*x);
		GetXplObject (objList, (*argl)[0]->MotherId())
  		->DeleteComponents();
  		GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(xx,"data")));
  	}
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  		(new XplChar (*newtext),"ptext")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newcolor),"tcolor")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newdir),"tdirection")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newsize),"tsize")));		
  	return (NULL);

}
XplObject* SetXplPointsMask(Liste<XplObject*> *argl)
{
	long      length = argl->laenge ();
  	XplDouble *x;
  	int i;
  	XplObject *o;

  	if (length < 2 )
   	 {
   	 globalError.Set (ERR_ARGS, "wrong number of args");
   	 return (NULL);
    	}

  	if ((*argl)[0]->DefaultComponent()->Type () != C_XPLDOUBLE)
   	 {
   	 globalError.Set (ERR_NUM, "setmaskp: first argument");
   	 return (NULL);
    	}

	if (GetXplObject (objList, (*argl)[0]->MotherId())==NULL)
  	 {
   	 globalError.Set (ERR_INTERN, "first  argument does not exist");
   	 return (NULL);
    	}
	
	XplObject *m=(*argl)[0];
    	x = m->DefaultXplDouble ();
  	int rows=(int) (x->dimension(0));
   	XplDouble *to_use;
	    		  
	if ((*argl)[1]->DefaultComponent()->Type () != C_XPLDOUBLE)
   	{	globalError.Set (ERR_NUM, "second argument");
    		return (NULL);
    	}
	to_use=(*argl)[1]->DefaultXplDouble ();
	if (!GoodColor(to_use, rows))
	{	globalError.Set (ERR_INTERN, "color vector is bad!");
		return(NULL);
	}
	if ( argl->laenge()>2)		
  	{	if ((*argl)[2]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "third argument");
    			return (NULL);
    		}
   		to_use=(*argl)[2]->DefaultXplDouble ();	//direction...
		if (!GoodSymbol(to_use, rows))
		{	globalError.Set (ERR_INTERN, 
				"symbol vector is bad!");
			//	to_use->mdump("%f");
			return(NULL);
		}			
	}
  	
  	if ( argl->laenge()>3)		
  	{	if ((*argl)[3]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "fourth argument");
    			return (NULL);
    		}
   		to_use=(*argl)[3]->DefaultXplDouble ();	//size...

		if (!GoodPointSize(to_use, rows))
		{	globalError.Set (ERR_INTERN, 
			 "size vector is bad!");
			return(NULL);
		}
	}
   	if ( argl->laenge()>4)		
	{	globalError.Set (ERR_INTERN, "too many arguments!");
		return(NULL);
	}

	XplDouble newcolor(rows, 3), newsymbol(rows), newsize(rows);
	newcolor.fill(DEFAULT_COLOR); 	
	newsymbol.fill(DEFAULT_SYMBOL); 	
	newsize.fill(DEFAULT_SIZE); 	

	/*::::::  WEITER MIT DER COLOR::::*/

	to_use=(*argl)[1]->DefaultXplDouble ();
	newcolor=MakeColor(to_use, rows);
 
 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"pcolor");
	if (argl->laenge()>2 )
 	{	to_use=(*argl)[2]->DefaultComponent()->Content().xpldouble;
		if (to_use->dimension(0)==1)
			newsymbol.fill( (*to_use)(0,0));
		else
			newsymbol=(*to_use);
 		DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"pstyle");
	}

	if (argl->laenge()>3 )
 	{	to_use=(*argl)[3]->DefaultComponent()->Content().xpldouble;
		if (to_use->dimension(0)==1)
			newsize.fill( (*to_use)(0,0));
		else
			newsize=(*to_use);
 		DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"psize");
	}
		
	if ((*argl)[0]->ComponentNumber()==1)
	{	XplDouble *xx =new XplDouble (*x);
		GetXplObject (objList, (*argl)[0]->MotherId())
  		->DeleteComponents();
  		GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(xx,"data")));
  	}

	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newcolor),"pcolor")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newsymbol),"pstyle")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newsize),"psize")));		

 	return (NULL);

}

XplObject* SetXplLinesMask  (Liste<XplObject*> *argl)
// generates a Maskvektor
{
  	long      length = argl->laenge ();
  	XplDouble *x, *ind_vec;
  	int i, j;	
  	XplObject *o;
	XplDouble *to_use;
	XplChar *tto_use;

  /* 	erwarted: 	data matrix; 
  			index vector mit werte 1 .. rows(data matrix);
  	optional:	color_number: 0 ..7
  			art_number  : 0 ..15
  			thick	    : 1 ..  			
  		
  */		
  	if (length < 2)
   	 {
   	 globalError.Set (ERR_ARGS, "Must be mind. 2");
   	 return (NULL);
    	}

  	if ((*argl)[0]->DefaultComponent()->Type () != C_XPLDOUBLE)
   	 {
   	 globalError.Set (ERR_NUM, "first argument");
   	 return (NULL);
    	}

 	if (GetXplObject (objList, (*argl)[0]->MotherId())==NULL)
  	 {
   	 globalError.Set (ERR_INTERN, "first  argument does not exist");
   	 return (NULL);
    	}

 	XplObject *m=(*argl)[0];
  	x = m->DefaultXplDouble ();
	 
    	int rows=(int) (x->dimension(0));
  
	/* index vector auslesen..	*/

 	if ((*argl)[1]->DefaultComponent()->Type () != C_XPLDOUBLE)
   	{	globalError.Set (ERR_INTERN, "SetXplLinesMask: second argument");
    		return (NULL);
    	}

	ind_vec=(*argl)[1]->DefaultXplDouble ();
	if (ind_vec->dimension(1)==1 ) return (NULL);
/* SK 24.04.99 hinesplot
	{	globalError.Set (ERR_INTERN, "index is bad!");
		return(NULL);
	}
*/
	int lines_rows=(int) (ind_vec->dimension(0));
	int lines_cols=(int) (ind_vec->dimension(1));
	for (i=0; i<lines_rows; i++)
	for (j=0; j<lines_cols; j++)
		if ( (*ind_vec)(i, j)<0 || (*ind_vec)(i, j)>rows)
	{	globalError.Set (ERR_INTERN, "index is bad!");
		return(NULL);
	}
	
	if ( argl->laenge()>2)		
	{	if ((*argl)[2]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "third argument");
    			return (NULL);
    		}
		to_use=(*argl)[2]->DefaultXplDouble ();
		if (!GoodColor(to_use, lines_rows))
		{	globalError.Set (ERR_INTERN, "color vector is bad!");
			return(NULL);
		}
	}
	if ( argl->laenge()>3)		
  	{	if ((*argl)[3]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "fourth argument");
    			return (NULL);
    		}
   		to_use=(*argl)[3]->DefaultXplDouble ();	//direction...
		if (!GoodLineArt(to_use, lines_rows))
		{	globalError.Set (ERR_INTERN, 
				"line art vector is bad!");
			return(NULL);
		}			
	}
  	
  	if ( argl->laenge()>4)		
  	{	if ((*argl)[4]->DefaultComponent()->Type () != C_XPLDOUBLE)
   		{	globalError.Set (ERR_NUM, "fivth argument");
    			return (NULL);
    		}
   		to_use=(*argl)[4]->DefaultXplDouble ();	//size...

		if (!GoodPointSize(to_use, lines_rows))
		{	globalError.Set (ERR_INTERN, 
			 "size vector is bad!");
			return(NULL);
		}
	}
  	if ( argl->laenge()>5)		
  	{	if ((*argl)[5]->DefaultComponent()->Type () != C_XPLCHAR)
   		{	globalError.Set (ERR_NUM, "sixth argument");
    			return (NULL);
    		}
   		tto_use=(*argl)[5]->DefaultComponent()
   			->Content().xplchar ;	//text?...
   		if (tto_use->dimension(0)!=1 
   			&& tto_use->dimension(0)!=lines_rows)
   		{	globalError.Set (ERR_NUM, "text vector is bad");
    			return (NULL);
    		}
   		if (tto_use->dimension(1)!=1)
   		{	globalError.Set (ERR_NUM, "text vector is bad");
    			return (NULL);
    		}

	}
   	if ( argl->laenge()>6)		
	{	globalError.Set (ERR_INTERN, "too many arguments!");
		return(NULL);
	}

	XplDouble newcolor(lines_rows, 3), newsymbol(lines_rows);
	XplDouble newsize(lines_rows);
	XplChar newtext(lines_rows);
	newcolor.fill(DEFAULT_COLOR); 	
	newsymbol.fill(DEFAULT_LINE_ART); 	
	newsize.fill(DEFAULT_LINE_THICK); 	

	if (argl->laenge()>2 )
	{	to_use=(*argl)[2]->DefaultXplDouble ();
		newcolor=MakeColor(to_use, lines_rows);
 		DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"lcolor");
	}
	if (argl->laenge()>3 )
 	{	to_use=(*argl)[3]->DefaultComponent()->Content().xpldouble;
		if (to_use->dimension(0)==1)
			newsymbol.fill( (*to_use)(0,0));
		else
			newsymbol=(*to_use);
 	//	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
	//	 	"lstyle");
	}
	if (argl->laenge()>4 )
 	{	to_use=(*argl)[4]->DefaultComponent()->Content().xpldouble;
		if (to_use->dimension(0)==1)
			newsize.fill( (*to_use)(0,0));
		else
			newsize=(*to_use);
 	//	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
	//	 	"lsize");
	}
  	if ( argl->laenge()>5)		
  	{	if (tto_use->dimension(0)==1)
   			newtext.fill((*tto_use)(0));
   		else
   			newtext=(*tto_use);
 	//	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
	//	 	"ltext");
	}

 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"lines");
 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"lstyle");
 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"lcolor");
 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"lsize");
 	DeleteComponent( GetXplObject (objList, (*argl)[0]->MotherId()),
		 	"ltext");
	
	if ((*argl)[0]->ComponentNumber()==1)
	{	XplDouble *xx =new XplDouble (*x);
		GetXplObject (objList, (*argl)[0]->MotherId())
  		->DeleteComponents();
  		GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(xx,"data")));
  	}

	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  		(new XplDouble (*ind_vec),"lines")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newcolor),"lcolor")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newsymbol),"lstyle")));
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplDouble (newsize),"lsize")));	
  	if ( argl->laenge()>5)		
	GetXplObject (objList, (*argl)[0]->MotherId())
  		->AppendComponent (new Component (new XplObject 
  			(new XplChar (newtext),"ltext")));	
	return(NULL); 
}
XplObject* getDataFromPlot (Liste<XplObject*> *argl)
{
  Plot      *p;
  int       i;
  VisMatrix *part;

  if (argl->laenge () != 4)
    {
    globalError.Set (ERR_ARGS, "getDataFromPlot: Must be 4");
    return (NULL);
    }

  p=PlotRequested(argl);
  if (p==NULL)
  {	globalError.Set (ERR_INTERN, "No such plot!");
  	return(NULL);
  }

  if ((*argl)[3]->Type() != O_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "getDataFromPlot: fourth argument");
    return (NULL);
    }

  i = (int) (*(*argl)[3]->DefaultXplDouble())(0);
  
  if (i<1 || i>p->GetDataCount())
   {
    globalError.Set (ERR_NUM, "getDataFromPlot: no such part");
    return (NULL);
   }
  
  
	XplObject *ooo= p->GetXplObject(i);
	if (ooo==NULL)
	{	globalError.Set (ERR_INTERN, "Error by GetXplObject");
		return(NULL);
	}
	

  	return (ooo);
}

extern int  XisNumber (double x);
extern bool NANorINF(double x);
extern bool * RowHasNaN(XplDouble &quelle);

XplObject* Show (Liste<XplObject*> *argl);

XplObject * AddData (Liste<XplObject*> *argl)
{
  XplObject *o;
  long      ind;
  int       length, dataPart;
  Plot      *p;
  XplDouble  *hor, *ver, *x, *data=NULL;


  length = argl->laenge();

  // PC 20020410 - adddata can take any number of objects
  if (length < 4)
  {
    globalError.Set (ERR_ARGS, "AddData: Must be at least 4");
    return (NULL);
  }

	Component *comp;
	p = PlotRequested(argl);
	if (p == NULL)
	{	globalError.Set (ERR_INTERN, "No such plot!");
		return(NULL);
	}

   // empty plot - use show
   if (p->GetDataCount() == 0)
   {	Show(argl);
   	return(NULL);
   }

   // PC 20020410 - check all data objects
   for(ind = 3; ind < length; ind++)
   {
 	  o = (*argl)[ind];
     if (o->ComponentNumber()==1)
     {
	    if (o->DefaultComponent()->Type () == O_XPLDOUBLE)
			data=o->DefaultXplDouble();
		 else
    	 {
    	   globalError.Set (ERR_NUM, "AddData: wrong argument, data must be numeric ");
    		return (NULL);
       }
     }
     else
     {
       comp=o->GetComponent("data");
       if (comp==NULL)
    	 {
    	   globalError.Set (ERR_NUM, "AddData: wrong argument, missing data ");
        	return (NULL);
       }
		 if (comp->Content().xplobject->Type () == O_XPLDOUBLE)
			data=comp->Content().xplobject->DefaultXplDouble();
		 else
       {
    	   globalError.Set (ERR_NUM, "AddData: wrong argument, data must be numeric ");
    		return (NULL);
       }
     }
   }

   // PC 20020410 - add all data
   for(ind = 3; ind < length; ind++)
   {
 	  o = (*argl)[ind];
#ifdef _BLABLA_
     if (o->ComponentNumber()==1)
     {
 		 data=o->DefaultXplDouble();
     }
     else
     {
       comp=o->GetComponent("data");
       data=comp->Content().xplobject->DefaultXplDouble();
     }

	  int rows = data->dimension(0);
     bool *nans;
	  nans = RowHasNaN(*data);
	  int rrows=0;
	  int i;

	  for (i=0; i<rows; i++)
	    if (! nans[i])
			rrows++;

     cout<<rows<<endl;
     cout<<rrows<<endl;
#endif

/* PC 20020410
 * if (p->GetDataCount()==0) checked already at the start of the function

  hor = (*argl)[1]->DefaultXplDouble ();
  ver = (*argl)[2]->DefaultXplDouble ();

  Liste<XplObject*>  lo;
  XplDisplay *xpld=(*argl)[0]->DefaultComponent()->Content().display;
  if (p->GetDataCount()==0)
  {	lo.haengeAn((*argl)[3]);
   	xpld->SetElement(&lo, (int)(*hor)(0), (int)(*ver)(0));
  }
  else
*/
 	  p->AddData (o);
   }


//  const char *text=(*argl)[0]->Name();
//  xpld->SetName(text);
  p->Refresh();

  return(NULL);
}

XplObject* DeleteData (Liste<XplObject*> *argl)
{
    //test for sweta2/deletedata(dixi, 1,1, 3)
    
    long length = argl->laenge ();
	//i, j sind windowskoordinaten
	//x, y, z sind XplDouble
	
  if (length <4)
    {
    globalError.Set (ERR_ARGS, "deletedata: Must be min. 4");
    return (NULL);
    }

  	Plot * p=PlotRequested(argl);
  	if (p==NULL)
 	{	globalError.Set (ERR_INTERN, "No such plot!");
  		return(NULL);
  	}
  
  	if ((*argl)[3]->Type () != O_XPLDOUBLE)
    	{
    	globalError.Set (ERR_NUM, "deletedata: third argument must be a Xpldouble");
    		return (NULL);
    	}

 	XplDouble *o = (*argl)[3]->DefaultXplDouble ();
	
   	p->DeleteData( (int)((*o)(0)) );
	p->Refresh();
	return (NULL);
}



XplObject* createDisplay (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *hor, *ver;
  XplObject *o;
 
  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "createDisplay: Must be 2");
    return (NULL);
    }

  hor = (*argl)[0]->DefaultXplDouble ();
  if (hor == NULL)
    {
    globalError.Set (ERR_NUM, "createDisplay: first argument");
    return (NULL);
    }
  // PC 20020304
  if ((int)(*hor)(0,0) <= 0)
    {
    globalError.Set (ERR_NUM, "createDisplay: first argument must be positive");
    return (NULL);
    }

  ver = (*argl)[1]->DefaultXplDouble ();
  if (ver == NULL)
    {
    globalError.Set (ERR_NUM, "createDisplay: second argument");
    return (NULL);
    }
  // PC 20020304
  if ((int)(*ver)(0,0) <= 0)
    {
    globalError.Set (ERR_NUM, "createDisplay: second argument must be positive");
    return (NULL);
    }

  XplDouble h(1, (int)(*hor)(0,0)), v(1, (int)(*ver)(0,0));
//du kannst in h und v die proportionen festlegen!! Irgendwann....
  h.fill(1.00);
  v.fill(1.00);

  XplDisplay *di;

#ifdef _UNIX_
  di=new UDisplay (v, h);
#else
#ifdef __BORLANDC__

  di=new WDisplay (v, h);

  //SWS TMDIChild *child = new TMDIChild(*TXploreClient::Client,"Display",(WDisplay*)di);

	//SWS	child->SetMenuDescr(TMenuDescr(IDM_DISPLAY,0,0,0,1,0,0));
	 //SWS	child->Create();
  //((WDisplay*)di)->Create();
#else
  di=new XplDisplay (v, h);
#endif
#endif
  o  = new XplObject (di, "display");
  //di->SetParent(o);
  return (o);
}

XplDouble  NaNsFilterOut(XplDouble &quelle)
{	int rows=quelle.dimension(0);
	int cols=quelle.dimension(1);
	int rows_ohne_nans=0;
	Boolean *nan_found = new Boolean[rows];
	XplDouble erret(1);
	erret(0)=0;
	int i, j, k;
	for (i=0; i<rows; i++)
	{	nan_found[i]=False;
		for (j=0; j<cols,(!nan_found[i]); j++)
			if (NANorINF(quelle(i, j)))
				nan_found[i]=True;
		if (!nan_found[i])
			rows_ohne_nans++;
	}
	if (rows_ohne_nans==rows)
		return(quelle);
	if (rows_ohne_nans==0)
	{	globalError.Set (ERR_INTERN, "too many NaNs or Infs");
		return(erret);
	}
	XplDouble m(rows_ohne_nans, cols);
	k=0;
	for (i=0; i<rows; i++)
		if (nan_found[i])
		{	for (j=0; j<cols; j++)
				m(k, j)=quelle(i, j);
			k++;
		}
	delete[] nan_found;
	return(m);
  }

XplObject* Show (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble  *hor, *ver, *x;
 // Plot       *p;
  //XplObject  *o;
  Liste<XplObject*>  lo;

	//syntax: show( display, i, j, x, y, z)
	//i, j sind windowskoordinaten
	//x, y, z sind die erweiterten XplDouble

	if (length <4)
		{
		globalError.Set (ERR_ARGS, "show: Must be min. 4");
		return (NULL);
		}

	if ((*argl)[0]->Type () != O_DISPLAY)
		{
		globalError.Set (ERR_NUM, "show: first argument must be display");
		return (NULL);
		}
	XplDisplay *disp = (*argl)[0]->DefaultComponent()->Content().display;

	const char *text=(*argl)[0]->Name();

	if ((*argl)[1]->Type () != O_XPLDOUBLE)
		{
		globalError.Set (ERR_NUM, "show: second argument must be a Xpldouble");
			return (NULL);
		}
	hor = (*argl)[1]->DefaultXplDouble ();

	if ((*argl)[2]->Type () != O_XPLDOUBLE)
		{
		globalError.Set (ERR_NUM, "show: third argument must be a Xpldouble");
			return (NULL);
		}
	 ver = (*argl)[2]->DefaultXplDouble ();

	int i, j;
	if ((*argl)[3]->Type () == O_XPLCHAR)
	{	lo.haengeAn ((*argl)[3]);
		if (lo[0]->Type () == O_XPLCHAR)
		disp->SetElement(&lo, (int)(*hor)(0), (int)(*ver)(0));
			return(NULL);
	}

	XplObject *o;
	Component * comp;
	XplDouble *data;
	int cols=0;
	int rows, rrows;
	bool *nans;

	for (i=3; i<length; i++)
	{	o=(*argl)[i];
		if (o->ComponentNumber()==1)
			if (o->DefaultComponent()->Type () == O_XPLDOUBLE)
				data=o->DefaultXplDouble();
			else
   	 		{
    	globalError.Set (ERR_NUM, "Show: wrong fourth argument ");
    			return (NULL);
    			}
    		else
 		{	comp=o->GetComponent("data");
 			if (comp==NULL)
    			{
    	globalError.Set (ERR_NUM, "Show: wrong fourth argument ");
    			return (NULL);
    			}
			if (comp->Content().xplobject->Type () == O_XPLDOUBLE)
			data=comp->Content().xplobject->DefaultXplDouble();
			else
    			{
    	globalError.Set (ERR_NUM, "Show: wrong fourth argument ");
    				return (NULL);
    			}
    		}
    		if (cols==0)
    			cols=data->dimension(1);
    		else
    		if (cols!=data->dimension(1) )
      		{
    	globalError.Set (ERR_NUM, "Show: wrong count of column ");
    				return (NULL);
    		}
    		if (cols==1)
         	{	
    	globalError.Set (ERR_NUM, "Show: wrong count of column ");
    				return (NULL);
    		}
   		rows=data->dimension(0);
		nans=RowHasNaN( * data);
		rrows=0;
		for (j=0; j<rows; j++)
		if (! nans[j])
			rrows++;
#ifdef _BLABLA_
	cout<<"rows="<<rows<<endl;
	cout<<"rrows="<<rrows<<endl;
#endif
		if (rrows==0)
		{	globalError.Set (ERR_INTERN, 
		"show: there are too many nans!");
        	delete nans;
        	return(NULL);
		} 		 		
    	}

  	for (i=3; i<length; i++)
		lo.haengeAn ((*argl)[i]);
 	
  	disp->SetElement(&lo, (int)(*hor)(0), (int)(*ver)(0));
 
   	disp->SetName(text);
        delete nans;

	return(NULL);
}

