/* $Header: /home/xplore/cvs/xpl4gr/swefun5.C,v 1.3 2002/08/16 12:31:51 sigbert Exp $ */

// Erweiterung of SWS_Interpreter
//  SWS 26.2.95

#pragma implementation "liste.h"

#include <math.h>
#include <new.h>
#ifndef __BORLANDC__
#include <unistd.h>
#else
#include <process.h>
#endif
#include <signal.h>

#include "liste.h"
#include "init.h"
#include "function.h"
#include "macro.h"
#include "xplfun.h"
#include "xplfun2.h"
#include "xplfun3.h"
#include "xplbasefun.h"
#include "plot.h"
#include "color.h"

extern Liste <XplColor * > all_colors;
extern Liste <XplSymbol* > all_symbols;

extern Plot *PlotRequested(Liste<XplObject*> *argl);

XplObject* GetMask(Liste<XplObject*> *argl)
/*******************************************************
1 arg wanted!
*******************************************************/
{	if (argl->laenge()!=1)
	{	globalError.Set (ERR_INTERN, "wrong count of args");
		return(NULL);
	}
	if ( (*argl)[0]->ComponentNumber()==1)
	{	globalError.Set (ERR_INTERN, "no mask at all");
		return(NULL);
	}
	int i;
	XplMask * points_mask=NULL;
	XplObject *m=(*argl)[0];
	for (i=0; i<m->ComponentNumber(); i++)
		if ( (! strcmp( (*m)[i]->Name(), "pm")  ) &&
				( ((*m)[i]->Content().xplobject->Type()
				 	& O_XPLMASK) ))
				{	points_mask=(*(*m)[i]->Content().
					xplobject)[0]->Content().xplmask;
					break;
				}
	if (i==m->ComponentNumber())
	{	globalError.Set (ERR_INTERN, "no points mask found");
		return(NULL);
	}
	
	XplLong red(1), green(1), blue(1), symbol(1), size(1), rgb(1);
	red=points_mask->getred();
	green=points_mask->getgreen();
	blue=points_mask->getblue();
	rgb=red.bind(green, 1);
	rgb=rgb.bind(blue, 1);
	symbol=points_mask->getsymbol();
	size=points_mask->getsize();

	XplChar xplc(1);
	xplc(0)=xplstring("getmask");
	XplObject *com;

	XplDouble ach(1);
	ach=cast(rgb);
	XplObject * ret=new XplObject(new XplChar (xplc), "getmask");
	com = new XplObject(new XplDouble(ach), "rgb");
	ret->AppendComponent(new Component (com));
	ach=cast(symbol);
	com = new XplObject(new XplDouble(ach), "symbol");
	ret->AppendComponent(new Component (com));
	ach=cast(size);
	com = new XplObject(new XplDouble(ach), "size");
	ret->AppendComponent(new Component (com));

	return(ret);	
}

XplObject* SetFractions(Liste <XplObject*> *argl)
{	if (argl->laenge()!=3)
	{	globalError.Set (ERR_INTERN, "setfractions: wrong count of args");
		return(NULL);
	}
	if ((*argl)[0]->Type() != O_DISPLAY)
	{	globalError.Set (ERR_INTERN, "setfractions: first argument must be a display");
		return(NULL);
	}
  XplDisplay *disp = (*argl)[0]->DefaultComponent()->Content().display;
	XplDouble *hor, *ver; 
	if ((*argl)[1]->Type () != O_XPLDOUBLE)
    	{	globalError.Set (ERR_INTERN, "setfractions: second argument must be a XplDouble");
    		return (NULL);
    	}
  	ver = (*argl)[1]->DefaultXplDouble ();

  	if ((*argl)[2]->Type () != O_XPLDOUBLE)
    	{	globalError.Set (ERR_INTERN, "setfractions: third argument must be a XplDouble");
    		return (NULL);
    	}
 	hor = (*argl)[2]->DefaultXplDouble ();
 	int disprows, dispcols;
 	disprows=ver->dimension(0);
 	dispcols=hor->dimension(0);
#ifdef _BLABLA_
 	cout<<"rows, cols: "<<disprows<<", "<<dispcols<<endl;
#endif
 	if (disprows!=disp->GetRows() || dispcols!=disp->GetColumns())
   	{	globalError.Set (ERR_INTERN, "setfractions: dimensions do not match!");
    		return (NULL);
    	}
 	
 	XplMatrix mver(1, disprows);
 	XplMatrix mhor(1, dispcols);
	int i;
	for (i=0; i<disprows; i++)
		if (	(*ver)[i]>0)
			mver(0, i)=(*ver)[i];
		else
   		{	globalError.Set (ERR_INTERN, "setfractions: negative value!");
    			return (NULL);
    		}		
#ifdef _BLABLA_
	cout<<"mver:"<<endl;
	mver.out();
#endif
	for (i=0; i<dispcols; i++)
		if (	(*hor)[i]>0)
		mhor(0, i)=(*hor)[i];
		else
   		{	globalError.Set (ERR_INTERN, "setfractions: negative value!");
    			return (NULL);
    		}	
#ifdef _BLABLA_
    	cout<<"mhor:"<<endl;
	mhor.out();
#endif
	disp->SetHorizontal(mhor);
	disp->SetVertical(mver);
   disp->XUpdate();
	return(NULL);
}

XplObject* SetXAxis(Liste <XplObject*> *argl)
/*	Mindestens: 	Display
			Zeile
			Spalte
			X-Minimum
			Y-Maximum
	Optional:	origin
			major
			minor
			m	:	m+k*x
			k
*/
{	if (argl->laenge()<5)
	{	globalError.Set (ERR_INTERN, "SetAxis: min. 5 args wanted!");
		return(NULL);
	}

	Plot *plot=PlotRequested(argl);
	if (plot==NULL)
	{	globalError.Set (ERR_INTERN, "SetAxis: no such plot!");
		return(NULL);
	}

	XplDisplay * disp=(*argl)[0]->DefaultComponent()->Content().display;
	int ver=(int)(*   ( (*argl)[1]->DefaultXplDouble() ))[0];	
	int hor=(int)(*   ( (*argl)[2]->DefaultXplDouble() ))[0];	

	int width=disp->GetElementWidth(ver, hor);
	//cout<<"width by GetElementWidth: "<<width;
	
	double axismin, axismax;
	if ( (*argl)[3]->Type()!=O_XPLDOUBLE)	
	{	globalError.Set (ERR_INTERN, "SetAxis: 4. arg must be a value!");
		return(NULL);
	}
	XplDouble * xpld=(*argl)[3]->DefaultXplDouble();
	axismin= (*xpld)[0];
		
	if ( (*argl)[4]->Type()!=O_XPLDOUBLE)	
	{	globalError.Set (ERR_INTERN, "SetAxis: 5. arg must be a value!");
		return(NULL);
	}
	xpld=(*argl)[4]->DefaultXplDouble();
	axismax= (*xpld)[0];
	

	Achse ach=plot->GetAchse(1);
	ach.SetPosition(axismin, axismax);
	if (argl->laenge()==5 || argl->laenge()==6)
	{	plot->SetAchse(ach);
		plot->Refresh();
		return(NULL);
	}
	// sonst origin, major, minor auswerten
	
	double ori, ma, mi;

	if ( (*argl)[5]->Type()!=O_XPLDOUBLE)	
	{	globalError.Set (ERR_INTERN, "SetAxis: 6. arg must be a value!");
		return(NULL);
	}
	xpld=(*argl)[5]->DefaultXplDouble();
	ori=(*xpld)[0];
	
	if ( (*argl)[6]->Type()!=O_XPLDOUBLE)	
	{	globalError.Set (ERR_INTERN, "SetAxis: 7. arg must be a value!");
		return(NULL);
	}
	xpld=(*argl)[6]->DefaultXplDouble();
	ma=(*xpld)[0];
	
	mi=ma/5.0;
	
	if (argl->laenge()>7)
	{	if ( (*argl)[7]->Type()!=O_XPLDOUBLE)	
		{	globalError.Set (ERR_INTERN, "SetAxis: 8. arg must be a value!");
			return(NULL);
		}
		xpld=(*argl)[7]->DefaultXplDouble();
		mi=(*xpld)[0];
	}
	ach.SetTicks(ori, ma, mi);
	
	double m, k;
	if (argl->laenge()==10)
	{	if ( (*argl)[8]->Type()!=O_XPLDOUBLE)	
		{	globalError.Set (ERR_INTERN, "SetAxis: 9. arg must be a value!");
			return(NULL);
		}
		xpld=(*argl)[8]->DefaultXplDouble();
		m=(*xpld)[0];
		if ( (*argl)[9]->Type()!=O_XPLDOUBLE)	
		{	globalError.Set (ERR_INTERN, "SetAxis: 10. arg must be a value!");
			return(NULL);
		}
		xpld=(*argl)[9]->DefaultXplDouble();
		k=(*xpld)[0];
		ach.SetValues(m, k);
	}
	
	plot->SetAchse(ach);

	return(NULL);
}	

	
XplObject* SetYAxis(Liste <XplObject*> *argl)
/*	Mindestens: 	Display
			Zeile
			Spalte
			X-Minimum
			Y-Maximum
	Optional:	origin
			major
			minor
*/
{	if (argl->laenge()<5)
	{	globalError.Set (ERR_INTERN, "SetAxis: min. 5 args wanted!");
		return(NULL);
	}

	Plot *plot=PlotRequested(argl);
	if (plot==NULL)
	{	globalError.Set (ERR_INTERN, "SetAxis: no such plot!");
		return(NULL);
	}

	XplDisplay * disp=(*argl)[0]->DefaultComponent()->Content().display;
	int ver=(int)(*   ( (*argl)[1]->DefaultXplDouble() ))[0];	
	int hor=(int)(*   ( (*argl)[2]->DefaultXplDouble() ))[0];	

	int height=disp->GetElementHeight(ver, hor);
	//cout<<"height by GetElementHeight: "<<height;

	double axismin, axismax;
	if ( (*argl)[3]->Type()!=O_XPLDOUBLE)	
	{	globalError.Set (ERR_INTERN, "SetAxis: 4. arg must be a value!");
		return(NULL);
	}
	XplDouble * xpld=(*argl)[3]->DefaultXplDouble();
	axismin= (*xpld)[0];
		
	if ( (*argl)[4]->Type()!=O_XPLDOUBLE)	
	{	globalError.Set (ERR_INTERN, "SetAxis: 5. arg must be a value!");
		return(NULL);
	}
	xpld=(*argl)[4]->DefaultXplDouble();
	axismax= (*xpld)[0];
	
	Achse ach=plot->GetAchse(2);
	ach.SetPosition(axismin, axismax);
	if (argl->laenge()==5 || argl->laenge()==6)
	{	plot->SetAchse(ach);
		plot->Refresh();
		return(NULL);
	}
	// sonst origin, major, minor auswerten
	
	double ori, ma, mi;

	if ( (*argl)[5]->Type()!=O_XPLDOUBLE)	
	{	globalError.Set (ERR_INTERN, "SetAxis: 6. arg must be a value!");
		return(NULL);
	}
	xpld=(*argl)[5]->DefaultXplDouble();
	ori=(*xpld)[0];
	
	if ( (*argl)[6]->Type()!=O_XPLDOUBLE)	
	{	globalError.Set (ERR_INTERN, "SetAxis: 7. arg must be a value!");
		return(NULL);
	}
	xpld=(*argl)[6]->DefaultXplDouble();
	ma=(*xpld)[0];
	
	mi=ma/5.0;
	
	if (argl->laenge()>7)
	{	if ( (*argl)[7]->Type()!=O_XPLDOUBLE)	
		{	globalError.Set (ERR_INTERN, "SetAxis: 8. arg must be a value!");
			return(NULL);
		}
		xpld=(*argl)[7]->DefaultXplDouble();
		mi=(*xpld)[0];
	}
	ach.SetTicks(ori, ma, mi);
	double m, k;
	if (argl->laenge()==10)
	{	if ( (*argl)[8]->Type()!=O_XPLDOUBLE)	
		{	globalError.Set (ERR_INTERN, "SetAxis: 9. arg must be a value!");
			return(NULL);
		}
		xpld=(*argl)[8]->DefaultXplDouble();
		m=(*xpld)[0];
		if ( (*argl)[9]->Type()!=O_XPLDOUBLE)	
		{	globalError.Set (ERR_INTERN, "SetAxis: 10. arg must be a value!");
			return(NULL);
		}
		xpld=(*argl)[9]->DefaultXplDouble();
		k=(*xpld)[0];
		ach.SetValues(m, k);
	}
		
	plot->SetAchse(ach);
	plot->Refresh();
	return(NULL);
}	
