/* $Header: /home/xplore/cvs/xpl4gr/swefun7.C,v 1.7 2003/06/17 15:01:15 cizek Exp $ */

// Erweiterung of SWS_Interpreter
//  SWS 26.2.95

#pragma implementation "liste.h"

#include <math.h>
#include <new.h>
#ifndef __BORLANDC__
#include <unistd.h>
#else
#include <process.h>
#endif
#include <signal.h>

#include "liste.h"
#include "init.h"
#include "function.h"
#include "macro.h"
#include "xplfun.h"
#include "xplfun2.h"
#include "xplfun3.h"
#include "xplbasefun.h"
#include "plot.h"
#include "color.h"

extern XplMatrix XplDouble2XplMatrix(XplDouble &);
extern XplDouble XplMatrix2XplDouble(XplMatrix &);

/* Folgende Sachen muessen uebereinstimmen!!!		*/

#include "setgopt.h"

/*	Ende der uebereinstimmung...*/

extern Plot * PlotRequested(Liste<XplObject*> *argl);

int SearchForOption(const char * opt)
{	int i;
	for (i=0; i<OPTNUM; i++)
		if (! strcmp(options[i], opt))
			return(i);
	//if not found...
	return(-1);
}

XplObject* SetGrOptions(Liste<XplObject*> *argl)
{	int i;
   int xint, yint;
	Component *comp;
	Plot * p;
	int found;
	const char *compname;
	char *tosi, *head_line;
	XplChar *xplc, *xplcc;
	XplDouble *xpld;
	double axismin, axismax;
	Achse *ach;
	XplMatrix xplm;

	if (argl->laenge()==4)
	{	p=PlotRequested(argl);
		if (p==NULL)
		{	globalError.Set (ERR_INTERN, "setgopt: no plot found!");
			return(NULL);
		}
#ifdef _BLABLA_
		cout<<(*argl)[3]->ComponentNumber()<<endl;
#endif
		//  1. comp. ist "setgopt"!
		// erst test : name und type!
		for (i=1; i<(*argl)[3]->ComponentNumber(); i++)
		{	comp = (* ((*argl)[3]) )[i];
			if (comp==NULL)
			{	globalError.Set (ERR_INTERN, "setgopt: error!");
				return(NULL);
			}
#ifdef _BLABLA_
			cout<<comp->Name()<<endl;
#endif
			compname=comp->Name();
			found=SearchForOption(compname);
			if (found==-1)
			{	globalError.Set (ERR_INTERN, "setgopt: error!");
				return(NULL);
			}
			if (comp->Content().xplobject->Type()!=opt_type[found])
			{	globalError.Set (ERR_INTERN, "setgopt: error! Wrong type");
				return(NULL);
			}
			
		}
//cout<<"Es geht weiter!"<<endl;
		for (i=1; i<(*argl)[3]->ComponentNumber(); i++)
		{	comp = (* ((*argl)[3]) )[i];
			compname=comp->Name();

			found=SearchForOption(compname);
			switch(found)
			{	case TITLE_NUM:
				xplcc=comp->Content().xplobject->
					DefaultComponent()->Content().xplchar;
				if ((*xplcc)(0).xplstrlen()==0)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad string for title!");
					return(NULL);
			}
				head_line=(*xplcc)(0).tostr();
				p->SetHeadline(head_line);
				delete head_line;
				p->head_on=(1==1);
				break;

				case XLIM_NUM: case YLIM_NUM:	//xlim, ylim
				xpld=comp->Content().xplobject->
					DefaultComponent()->Content().xpldouble;
				if (xpld->dimension(0)!=2)
			{	globalWarning.Set (ERR_INTERN, "setgopt: a bad value for xlim or ylim!");
				xpld->mdump("%f");
				break;
			}
				axismin= (*xpld)(0);
				axismax= (*xpld)(1);
				if (! (axismin<axismax))
			{	globalError.Set (ERR_INTERN, "setgopt: a bad value for xlim or ylim!");
				cout<<"(! (axismin<axismax))"<<endl;
				xpld->mdump("%f");
				return(NULL);
			}
				if (found== XLIM_NUM )
					ach=new Achse(p->GetAchse(1));
				else
					ach=new Achse(p->GetAchse(2));
				ach->SetPosition(axismin, axismax);
				p->SetAchse(*ach);
				delete ach;

				break;

				case XORIGIN_NUM: case YORIGIN_NUM:
					//xorigin, yorigin
				xpld=comp->Content().xplobject->
					DefaultComponent()->Content().xpldouble;
				if (xpld->dimension(0)!=1)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad value for xorigin or yorigin!");
				return(NULL);
			}
  				if (found==XORIGIN_NUM)
					ach = new Achse(p->GetAchse(1));
				else
					ach = new Achse(p->GetAchse(2));

				ach->SetTicks((*xpld)(0), -1);
				p->SetAchse(*ach);
				delete ach;
				break;

            // PC 20010418
				case XAXIS_NUM: case YAXIS_NUM:
					//xaxis, yaxis
				xpld=comp->Content().xplobject->
					DefaultComponent()->Content().xpldouble;
				if (xpld->dimension(0)!=1)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad value for xaxis or yaxis!");
				return(NULL);
			}

            if ( (*xpld)(0) == 0 )
            {
            	  if ( found== XAXIS_NUM ) {
                   	p->xaxisline = false;
                 	   p->xtickmarks = false;
                 }
                 else {
                    p->yaxisline = false;
                    p->ytickmarks = false;
                 }
            }
            else
				{
            	  if ( found== XAXIS_NUM ) {
                   	p->xaxisline = true;
                 	   p->xtickmarks = true;
                 }
                 else {
                    p->yaxisline = true;
                    p->ytickmarks = true;
                 }
            }
				break;

				case XMAJOR_NUM:case YMAJOR_NUM:
					//xmajor, ymajor
				xpld=comp->Content().xplobject->
					DefaultComponent()->Content().xpldouble;
				if (xpld->dimension(0)!=1)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad value for xmajor or ymajor!");
				return(NULL);
			}
  				if (found==XMAJOR_NUM)
					ach = new Achse(p->GetAchse(1));
				else
					ach = new Achse(p->GetAchse(2));

            if ( (*xpld)(0) <= 0 )	// PC 001206 - was missing here - copy from the other part for setgopt
            {
            	if ( found== XMAJOR_NUM )
               	p->xtickmarks = false;
               else
                  p->ytickmarks = false;

               if ( (*xpld)(0) < 0 )	// PC 001206
               {
            	  if ( found== XMAJOR_NUM )
                   	p->xaxisline = false;
                 else
                    p->yaxisline = false;
               }
            }
            else
				{
				  ach->SetTicks(0,	//origin default...
			 	  (*xpld)(0));
				  p->SetAchse(*ach);
            }

				delete ach;
				break;

				case XLABEL_NUM: case YLABEL_NUM:
					//xlabel, ylabel
				xplcc=comp->Content().xplobject->
					DefaultComponent()->Content().xplchar;
				tosi=(*xplcc)(0).tostr(); 	//OK!
				if (strlen(tosi)==0)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad string for label!");
				return(NULL);
			}
				if (found==XLABEL_NUM)
					ach = new Achse(p->GetAchse(1));
				else
					ach = new Achse(p->GetAchse(2));

				ach->SetString(tosi);
				delete tosi;
				p->SetAchse(*ach);
				delete ach;
				break;

				case XVALUE_NUM: case YVALUE_NUM:
				xpld=comp->Content().xplobject->
					DefaultComponent()->Content().xpldouble;
				if (xpld->dimension(0)!=2)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad value for xtrans or ytrans!");
				return(NULL);
			}
				if (found==XVALUE_NUM)
					ach = new Achse(p->GetAchse(1));
				else
					ach = new Achse(p->GetAchse(2));

				ach->SetValues((*xpld)(0), (*xpld)(1));
				p->SetAchse(*ach);
				delete ach;
				break;

				case ROTPOINT_NUM:	//rotpoint
				xpld=comp->Content().xplobject->
					DefaultComponent()->Content().xpldouble;
				xplm=XplDouble2XplMatrix(*xpld);
				p->SetTransformation(&xplm,
					NULL, NULL, NULL, NULL);
				break;

			 	case ROTCOS_NUM:	//rotcos
			 	xpld=comp->Content().xplobject->
			 		DefaultComponent()->Content().xpldouble;
				xplm=XplDouble2XplMatrix(*xpld);
				p->SetTransformation(NULL, NULL,
				&xplm, NULL, NULL);
				break;

/* PC 20020627: omited, does not work
				case SCAL_NUM:	//scal
				xpld=comp->Content().xplobject->
					DefaultComponent()->Content().xpldouble;
				xplm=XplDouble2XplMatrix(*xpld);
				p->SetTransformation(NULL, NULL, NULL,
				&xplm, NULL);
				break;
*/
				case FSCAL_NUM:	//first scal
				xpld=comp->Content().xplobject->
					DefaultComponent()->Content().xpldouble;
				xplm=XplDouble2XplMatrix(*xpld);
				p->SetTransformation(NULL,
				&xplm, NULL, NULL, NULL);
				break;

				case BORDER_NUM:	// PC 001122 - border on/off option
				xpld=comp->Content().xplobject->
					DefaultComponent()->Content().xpldouble;
				p->SetBorder((-1e-10 < (*xpld)(0)) && ((*xpld)(0) < 1e-10) ? false : true);
				break;

  				case AXES_NUM:	
				xpld=comp->Content().xplobject->
					DefaultComponent()->Content().xpldouble;
				p->SetAxes((-1e-10 < (*xpld)(0)) && ((*xpld)(0) < 1e-10) ? false : true);
				break;


				case TRANS_NUM:	//transl
				xpld=comp->Content().xplobject->
					DefaultComponent()->Content().xpldouble;
				xplm=XplDouble2XplMatrix(*xpld);
				p->SetTransformation(NULL, NULL, NULL, NULL,
					&xplm);
				break;

				case XOFFSET_NUM: case YOFFSET_NUM:
				xpld=comp->Content().xplobject->
					DefaultComponent()->Content().xpldouble;
				if (xpld->dimension(0)!=2)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad value for xoffset");
				return(NULL);
			}
				if ((*xpld)(0)<0 || (*xpld)(0)>100 ||
					(*xpld)(1)>100 || (*xpld)(1)<0
					|| (*xpld)(0)+(*xpld)(1)>100)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad value for xoffset or yoffset!");
				return(NULL);
			}
				if (found==XOFFSET_NUM)
					p->SetHOffset((int)((*xpld)(0)+0.5),
						(int)((*xpld)(1)+0.5));
				else
					p->SetVOffset((int)((*xpld)(0)+0.5),
						(int)((*xpld)(1)+0.5));
				p->offset_equal=false;
				break;

                                case FONTTYPE_NUM:     // PC 20010702
				xplcc=comp->Content().xplobject->DefaultComponent()->Content().xplchar;
				if ((*xplcc)(0).xplstrlen()==0)
			        {  globalError.Set (ERR_INTERN, "setgopt: a bad string for fonttype!");
				   return(NULL);
			        }
				p->SetFontType( (*xplcc)(0).tostr() );
                                break;

  				case DISPSIZE_NUM:	// PC 20021123
				xpld=comp->Content().xplobject->DefaultComponent()->Content().xpldouble;
				if (xpld->dimension(0)!=2)
            {	globalError.Set (ERR_INTERN, "setgopt: a bad value for dispsize");
					return(NULL);
				}
            else
            {
               xint = (int)((*xpld)(0));
               if (xint <= 0) xint = 1;

               yint = (int)((*xpld)(1));
               if (yint <= 0) yint = 1;

					p->GetDisplay()->DoWinResize( xint, yint );
            }
				break;

  				case DISPPOS_NUM:	// PC 20021123
				xpld=comp->Content().xplobject->DefaultComponent()->Content().xpldouble;
				if (xpld->dimension(0)!=2)
            {	globalError.Set (ERR_INTERN, "setgopt: a bad value for disppos");
					return(NULL);
				}
            else
            {
               xint = (int)((*xpld)(0));
               if (xint <= 0) xint = 0;

               yint = (int)((*xpld)(1));
               if (yint <= 0) yint = 0;

					p->GetDisplay()->DoWinPosition( xint, yint );
            }
				break;

				case BRUSHSIZE_NUM:
				xpld=comp->Content().xplobject->
					DefaultComponent()->Content().xpldouble;
				int dim=xpld->dimension(0);
				if (	dim!=2 && dim!=4)
			{	globalError.Set (ERR_INTERN,
				"setgopt: a bad value for brushsize");
				return(NULL);
			}
				int ddd;
				for (ddd=0; ddd<dim; ddd++)
					if ((*xpld)(ddd)<0 || (*xpld)(ddd)>100)
			{	globalError.Set (ERR_INTERN,
				"setgopt: a bad value for brushsize");
				return(NULL);
			}
				switch(dim)
				{	case 2:
					p->brush_size[0]=(int)(*xpld)(0);
					p->brush_size[2]=(int)(*xpld)(0);
					p->brush_size[1]=(int)(*xpld)(1);
					p->brush_size[3]=(int)(*xpld)(1);
					break;
					case 4:
					p->brush_size[2]=(int)(*xpld)(0);
					p->brush_size[0]=(int)(*xpld)(2);
					p->brush_size[1]=(int)(*xpld)(1);
					p->brush_size[3]=(int)(*xpld)(3);
					break;
				}
/*
				cout<<"BRUSHS: "<<p->brush_size[0]<<", "<<
				p->brush_size[1]<<", "<<
				p->brush_size[2]<<", "<<
				p->brush_size[3]<<", "<<endl;
*/
				break;


			}
		}
		p->Refresh();
		return(NULL);
	}
	if (argl->laenge()<5)
	{	globalError.Set (ERR_INTERN, "setgopt: min 5 args are wanted!");
		return(NULL);
	}

	if ((argl->laenge()%2)==0) // SK 25.08.00
	{	globalError.Set (ERR_INTERN, "setgopt: odd number of parameters expected!");
		return(NULL);
	}
	p=PlotRequested(argl);
	if (p==NULL)
	{	globalError.Set (ERR_INTERN, "setgopt: no plot found!");
		return(NULL);
	}

	// Erst testen...
	for (i=0; 3+i<argl->laenge(); i+=2)
	{	if ((*argl)[3+i]->Type()!=O_XPLCHAR)
		{	globalError.Set (ERR_INTERN, "setgopt: wrong kind of arg!");
			return(NULL);
		}		
		xplc=(*argl)[3+i]->DefaultComponent()->Content().xplchar;
#ifdef _BLABLA_
		cout<<i+1<<" Paar of args..."<<endl;
		tosi=(*xplc)(0).tostr();	//OK!
		cout<<tosi<<endl;
		delete tosi;
#endif
		tosi=(*xplc)(0).tostr();	//OK!
		found=SearchForOption(tosi);
		delete tosi;
		if (found==-1)
		{	globalError.Set (ERR_INTERN, "setgopt: no such option!");
			cerr<<"setgopt: no such option! "<<(*xplc)(0).tostr();
			return(NULL);
		}
		if ((*argl)[4+i]->Type()!=opt_type[found])
		{	globalError.Set (ERR_INTERN, "setgopt: wrong type!");
			return(NULL);
		}
	}
	for (i=0; 3+i<argl->laenge(); i+=2)
	{	xplc=(*argl)[3+i]->DefaultComponent()->Content().xplchar;
		tosi=(*xplc)(0).tostr();	//OK!
		found=SearchForOption(tosi);
		delete tosi;
		switch(found)
		{	case TITLE_NUM:		//title
			xplcc=(*argl)[4+i]->DefaultComponent()->
			Content().xplchar;
			if ((*xplcc)(0).xplstrlen()==0)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad string for title!");
				return(NULL);
			}
			head_line=(*xplcc)(0).tostr();
			p->SetHeadline(head_line);
			delete head_line;
			p->head_on=(1==1);
			break;

			case XLIM_NUM: case YLIM_NUM:		//xlim, ylim
			xpld=(*argl)[4+i]->DefaultXplDouble();
			if (xpld->dimension(0)!=2)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad value for xlim!");
				return(NULL);
			}
			axismin= (*xpld)(0);
			axismax= (*xpld)(1);
			if (! (axismin<axismax))
			{	globalError.Set (ERR_INTERN, "setgopt: a bad value for xlim!");
				return(NULL);
			}
				if (found==XLIM_NUM)
					ach = new Achse(p->GetAchse(1));
				else
					ach = new Achse(p->GetAchse(2));

			ach->SetPosition(axismin, axismax);
			p->SetAchse(*ach);
			delete ach;

			break;

			case XORIGIN_NUM: case YORIGIN_NUM:
				//xorigin, yorigin
			if (found==XORIGIN_NUM)
					ach = new Achse(p->GetAchse(1));
			else
					ach = new Achse(p->GetAchse(2));

			xpld=(*argl)[4+i]->DefaultXplDouble();
			ach->SetTicks((*xpld)(0), -1);
			p->SetAchse(*ach);
			delete ach;
			break;

         // PC 20010418
   		case XAXIS_NUM: case YAXIS_NUM:
				//xaxis, yaxis
			xpld=(*argl)[4+i]->DefaultXplDouble();

         if ( (*xpld)(0) == 0 )
         {
           	  if ( found== XAXIS_NUM ) {
                 	p->xaxisline = false;
            	   p->xtickmarks = false;
             }
             else {
                p->yaxisline = false;
                p->ytickmarks = false;
             }
         }
         else
		   {
          	  if ( found== XAXIS_NUM ) {
                 	p->xaxisline = true;
             	   p->xtickmarks = true;
              }
              else {
                 p->yaxisline = true;
                 p->ytickmarks = true;
              }
         }
 			break;

			case XMAJOR_NUM: case YMAJOR_NUM:
				//xmajor, ymajor

				if (found==XMAJOR_NUM)
					ach = new Achse(p->GetAchse(1));
				else
					ach = new Achse(p->GetAchse(2));

			xpld=(*argl)[4+i]->DefaultXplDouble();

            if ( (*xpld)(0) <= 0 )
            {
            	if ( found== XMAJOR_NUM )
               	p->xtickmarks = false;
               else
                  p->ytickmarks = false;

               if ( (*xpld)(0) < 0 )	// PC 001206
               {
            	  if ( found== XMAJOR_NUM )
                   	p->xaxisline = false;
                 else
                     p->yaxisline = false;
               }
            }
            else
				{
					ach->SetTicks(0,	//origin default...
					 	(*xpld)(0));
					p->SetAchse(*ach);
					delete ach;
            }
			break;

			case XLABEL_NUM: case YLABEL_NUM:
				//xlabel, ylabel
			xplcc=(*argl)[4+i]->DefaultComponent()->
			Content().xplchar;
			tosi=(*xplcc)(0).tostr();	//OK!
			if (strlen(tosi)==0)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad string for title!");
				return(NULL);
			}
				if (found==XLABEL_NUM)
					ach = new Achse(p->GetAchse(1));
				else
					ach = new Achse(p->GetAchse(2));

			ach->SetString(tosi);
			p->SetAchse(*ach);
			delete tosi;
			delete ach;
			break;

			case XVALUE_NUM:	case YVALUE_NUM:
			xpld=(*argl)[4+i]->DefaultXplDouble();
			if (xpld->dimension(0)!=2)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad value for xtrans or ytrans!");
				return(NULL);
			}
				if (found==XVALUE_NUM)
					ach = new Achse(p->GetAchse(1));
				else
					ach = new Achse(p->GetAchse(2));

			ach->SetValues((*xpld)(0), (*xpld)(1));
			p->SetAchse(*ach);
			delete ach;
			break;

			case ROTPOINT_NUM:	//rotpoint
			xpld=(*argl)[4+i]->DefaultComponent()->
					Content().xpldouble;
			xplm=XplDouble2XplMatrix(*xpld);
			p->SetTransformation(&xplm,
					NULL, NULL, NULL, NULL);
			break;

			case ROTCOS_NUM:	//rotcos
			xpld=(*argl)[4+i]->DefaultComponent()
					->Content().xpldouble;
			xplm=XplDouble2XplMatrix(*xpld);
			p->SetTransformation(NULL, NULL,
				&xplm, NULL, NULL);
			break;

			case FSCAL_NUM:	//first scal
			xpld=(*argl)[4+i]->DefaultComponent()
					->Content().xpldouble;
			xplm=XplDouble2XplMatrix(*xpld);
			p->SetTransformation(NULL,
				&xplm, NULL, NULL, NULL);
			break;

   		case BORDER_NUM:	// PC 001122 - border on/off option
			xpld=(*argl)[4+i]->DefaultComponent()
					->Content().xpldouble;
			p->SetBorder((-1e-10 < (*xpld)(0)) && ((*xpld)(0) < 1e-10) ? false : true);
			break;

				case AXES_NUM:
				xpld=(*argl)[4+i]->DefaultComponent()
					->Content().xpldouble;
				p->SetAxes((-1e-10 < (*xpld)(0)) && ((*xpld)(0) < 1e-10) ? false : true);
				break;

			case SCAL_NUM:	//scal
			xpld=(*argl)[4+i]->DefaultComponent()
					->Content().xpldouble;
			xplm=XplDouble2XplMatrix(*xpld);
			p->SetTransformation(NULL, NULL, NULL,
				&xplm, NULL);
			break;

			case TRANS_NUM:	//transl
			xpld=(*argl)[4+i]->DefaultComponent()
					->Content().xpldouble;
			xplm=XplDouble2XplMatrix(*xpld);
			p->SetTransformation(NULL, NULL, NULL, NULL,
					&xplm);
			break;

         case DISPSIZE_NUM:	// PC 20021123
				xpld=(*argl)[4+i]->DefaultComponent()->Content().xpldouble;
				if (xpld->dimension(0)!=2)
            {	globalError.Set (ERR_INTERN, "setgopt: a bad value for dispsize");
					return(NULL);
				}
            else
            {
               xint = (int)((*xpld)(0));
               if (xint <= 0) xint = 1;

               yint = (int)((*xpld)(1));
               if (yint <= 0) yint = 1;

					p->GetDisplay()->DoWinResize( xint, yint );
            }
				break;

         case DISPPOS_NUM:	// PC 20021123
				xpld=(*argl)[4+i]->DefaultComponent()->Content().xpldouble;
				if (xpld->dimension(0)!=2)
            {	globalError.Set (ERR_INTERN, "setgopt: a bad value for disppos");
					return(NULL);
				}
            else
            {
               xint = (int)((*xpld)(0));
               if (xint <= 0) xint = 0;

               yint = (int)((*xpld)(1));
               if (yint <= 0) yint = 0;

					p->GetDisplay()->DoWinPosition( xint, yint );
            }
				break;


			case XOFFSET_NUM: case YOFFSET_NUM:
				xpld=(*argl)[4+i]->
					DefaultComponent()->Content().xpldouble;
				if (xpld->dimension(0)!=2)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad value for xoffset");
				return(NULL);
			}
				if ((*xpld)(0)<0 || (*xpld)(0)>100 ||
					(*xpld)(1)>100 || (*xpld)(1)<0
					|| (*xpld)(0)+(*xpld)(1)>100)
			{	globalError.Set (ERR_INTERN, "setgopt: a bad value for xoffset or yoffset!");
				return(NULL);
			}
				if (found==XOFFSET_NUM)
					p->SetHOffset((int)((*xpld)(0)+0.5),
						(int)((*xpld)(1)+0.5));
				else
					p->SetVOffset((int)((*xpld)(0)+0.5),
						(int)((*xpld)(1)+0.5));
				p->offset_equal=false;
				break;

                                case FONTTYPE_NUM:     // PC 20010702
                                   xplcc=(*argl)[4+i]->
                                   	DefaultComponent()->Content().xplchar;
                                   if ((*xplcc)(0).xplstrlen()==0)
                                   {  globalError.Set (ERR_INTERN, "setgopt: a bad string for fonttype!");
                                        return(NULL);
                                   }
                                   p->SetFontType( (*xplcc)(0).tostr() );
                                break;

				case BRUSHSIZE_NUM:
				xpld=(*argl)[4+i]->
					DefaultComponent()->Content().xpldouble;
				int dim=xpld->dimension(0);
				if (	dim!=2 && dim!=4)
			{	globalError.Set (ERR_INTERN,
				"setgopt: a bad value for brushsize");
				return(NULL);
			}
				int ddd;
				for (ddd=0; ddd<dim; ddd++)
					if ((*xpld)(ddd)<0 || (*xpld)(ddd)>100)
			{	globalError.Set (ERR_INTERN,
				"setgopt: a bad value for brushsize");
				return(NULL);
			}
				switch(dim)
				{	case 2:
					p->brush_size[0]=(int)(*xpld)(0);
					p->brush_size[2]=(int)(*xpld)(0);
					p->brush_size[1]=(int)(*xpld)(1);
					p->brush_size[3]=(int)(*xpld)(1);
					break;
					case 4:
					p->brush_size[2]=(int)(*xpld)(0);
					p->brush_size[0]=(int)(*xpld)(2);
					p->brush_size[1]=(int)(*xpld)(1);
					p->brush_size[3]=(int)(*xpld)(3);
					break;
				}
	/*			cout<<"BRUSHS: "<<p->brush_size[0]<<", "<<
				p->brush_size[1]<<", "<<
				p->brush_size[2]<<", "<<
				p->brush_size[3]<<", "<<endl;
	*/
				break;

		}
	}
	p->Refresh();

	return(NULL);
}

XplObject* GetGrOptions(Liste<XplObject*> *argl)
{
	if (argl->laenge()!=3)
	{	globalError.Set (ERR_INTERN, "getgopt: 3 args are wanted!");
		return(NULL);
	}
	
	Plot * p=PlotRequested(argl);
	if (p==NULL)
	{	globalError.Set (ERR_INTERN, "setgopt: no plot found!");
		return(NULL);
	}

	XplChar xplc(1), xplcc(1);
	XplDouble xpld(1), xpldd(2), xplddd(4);
	XplMatrix xplma;
	Vector <float> achcon1, achcon2;
	int d=p->GetDimension();
	int i;
	double axismin, axismax, ori, major, k, l;
	Achse ach1(0, 0, 0), ach2(0, 0, 0);
	XplObject *curr;
	char *str, *head_line;
	XplMatrix xoffset, yoffset;

	ach1=p->GetAchse(1);
	ach2=p->GetAchse(2);
	achcon1=ach1.GetContent();
	achcon2=ach2.GetContent();
	xoffset=p->GetHOffset();
	yoffset=p->GetVOffset();


	xplc(0)=xplstring("getgropt");
	XplObject *ret= new XplObject (new XplChar (xplc), "getgropt");

	for (i=0; i<OPTNUM; i++)
	{	curr=NULL;
		switch(i)
		{	case TITLE_NUM:
			head_line=p->GetHeadline();
			xplc(0)=xplstring(head_line);
			delete head_line;
			curr=new XplObject(new XplChar (xplc), options[i]);
			break;
			
			case XLIM_NUM:	case YLIM_NUM:
			xpldd(0)= i==XLIM_NUM ? achcon1[0] : achcon2[0];
			xpldd(1)= i==XLIM_NUM ? achcon1[1] : achcon2[1];
			curr=new XplObject(new XplDouble(xpldd), options[i]);
			break;

			case XORIGIN_NUM: case YORIGIN_NUM:
			xpld(0)= i==XORIGIN_NUM ? achcon1[2] : achcon2[2];
			curr=new XplObject(new XplDouble(xpld), options[i]);
			break;

			case XMAJOR_NUM: case YMAJOR_NUM:
			xpld(0)= i==XMAJOR_NUM ? achcon1[3] : achcon2[3];
			curr=new XplObject(new XplDouble(xpld), options[i]);
			break;

			case XVALUE_NUM: case YVALUE_NUM:
			xpldd(0)= i==XVALUE_NUM ? achcon1[5] : achcon2[5];
			xpldd(1)= i==XVALUE_NUM ? achcon1[6] : achcon2[6];
			curr=new XplObject(new XplDouble(xpldd), options[i]);
			break;

			case XLABEL_NUM: case YLABEL_NUM:
			str= i==XLABEL_NUM ? ach1.GetString():ach2.GetString();
			xplc(0)=xplstring(str);
			delete str;
			curr=new XplObject(new XplChar (xplc), options[i]);
			break;

         // PC 20021122
			case DISPSIZE_NUM:
         xpldd(0) = p->GetDisplay()->GetWidth();
         xpldd(1) = p->GetDisplay()->GetHeight();
			curr=new XplObject(new XplDouble(xpldd), options[i]);
         break;

         case DISPPOS_NUM:
         xpldd(0) = p->GetDisplay()->GetWinLeft();
         xpldd(1) = p->GetDisplay()->GetWinTop();
			curr=new XplObject(new XplDouble(xpldd), options[i]);
			break;


			case ROTPOINT_NUM:
			xplma=p->GetRotationPoint();
			xpld=XplMatrix2XplDouble(xplma);
			curr = new XplObject(new XplDouble(xpld), options[i]);
			break;

			case ROTCOS_NUM:			
			xplma=p->GetRotationCosinus();
			xpld=XplMatrix2XplDouble(xplma);
			curr = new XplObject(new XplDouble(xpld), options[i]);
			break;

			case SCAL_NUM:
			xplma=p->GetSecondSkalierung();
			xpld=XplMatrix2XplDouble(xplma);
			curr = new XplObject(new XplDouble(xpld), options[i]);
			break;

			case FSCAL_NUM:
			xplma=p->GetFirstSkalierung();
			xpld=XplMatrix2XplDouble(xplma);
			curr = new XplObject(new XplDouble(xpld), options[i]);
			break;

   		case BORDER_NUM:	// PC 001122 - border on/off option
         {
         	XplDouble xpldpom(1);
			   xpldpom(0) = p->GetBorder();
			   curr=new XplObject(new XplDouble(xpldpom), options[i]);
         }
			break;

   		case AXES_NUM:	//MS 030613 - axes on/off option
         {
         	XplDouble xpldpom(1);
			   xpldpom(0) = p->GetAxes();
			   curr=new XplObject(new XplDouble(xpldpom), options[i]);
         }
			break;

			case TRANS_NUM:
			xplma=p->GetTranslation();
			xpld=XplMatrix2XplDouble(xplma);
			curr = new XplObject(new XplDouble(xpld), options[i]);
			break;

			case XOFFSET_NUM: case YOFFSET_NUM:
			

			xpldd(0)= i==XOFFSET_NUM ? 	xoffset(0,0):
							yoffset(0,0);
			xpldd(1)= i==XOFFSET_NUM ? 	xoffset(0,1):
							yoffset(0,1);
			curr=new XplObject(new XplDouble(xpldd), options[i]);
			break;

			case BRUSHSIZE_NUM:
			xplddd[0]=p->brush_size[0];
			xplddd[1]=p->brush_size[1];
			xplddd[2]=p->brush_size[2];
			xplddd[3]=p->brush_size[3];
			curr=new XplObject(new XplDouble(xplddd), options[i]);
			break;

         		case XAXIS_NUM:  // PC 20010702
                        {
                        XplDouble xdres(1);
                        xdres(0) = (p->xaxisline) ? 1 : 0;
                        curr=new XplObject(new XplDouble(xdres), options[i]);
                        }
                        break;

                        case YAXIS_NUM: // PC 20010702
                        {
                        XplDouble xdres(1);
                        xdres(0) = (p->yaxisline) ? 1 : 0;
                        curr=new XplObject(new XplDouble(xdres), options[i]);
                        }
                        break;

                        case ZAXIS_NUM: // not implemented
                        {
                        XplDouble xdres(1);
                        xdres(0) = 1;
                        curr=new XplObject(new XplDouble(xdres), options[i]);
                        }
                        break;


                        case FONTTYPE_NUM:   // PC 20010702
			xplc(0)=xplstring( p->GetFontTypeA() );
			curr=new XplObject(new XplChar (xplc), options[i]);
			break;

			default:
			globalError.Set (ERR_INTERN, "no such option found!");
			cout<<"no such option found! "<<i<<endl;
			break;
		}
		if (curr!=NULL)
			ret->AppendComponent(new Component( curr));
	}


/*
#ifdef _BLABLA_
	ret->Print();
#endif
*/
	return(ret);
}


XplObject* SetTransformations(Liste<XplObject*> *argl){return(NULL);}
XplObject* GetTransformations(Liste<XplObject*> *argl){return(NULL);}

