/* $Header: /home/xplore/cvs/xpl4gr/swefun8.C,v 1.3 2002/08/16 12:31:51 sigbert Exp $ */

// Erweiterung of SWS_Interpreter
//  SWS 26.2.95

#pragma implementation "liste.h"

#include <math.h>
#include <new.h>
#ifndef __BORLANDC__
#include <unistd.h>
#else
#include <process.h>
#endif
#include <signal.h>

#include "liste.h"
#include "init.h"
#include "function.h"
#include "macro.h"
#include "xplfun.h"
#include "xplfun2.h"
#include "xplfun3.h"
#include "xplbasefun.h"
#include "plot.h"
#include "color.h"

#define READ_ONLY_COUNT 9

extern Liste <XplColor *> all_colors;

extern int FindColor(int, int, int);

#ifdef _UNIX_
extern "C" BS_Glob_Variable bs_glob_variable;
#endif




#ifdef _UNIX_

extern "C" BS_Glob_Variable bs_glob_variable;

extern Colormap cmap;	//OK

XplObject * ColorTest(Liste<XplObject*> *argl)
{	Display *dis;
	XColor rgb_exact;
	dis=XtDisplay(bs_glob_variable.main_shell);
		
	int i, j;
	int colors_allowed=0;
	
	int snum=DefaultScreen(dis);
	long unsigned all_pixels[256];

	XColor query[256];
	for (i=0; i<256; i++)
		query[i].pixel=i;
	XQueryColors(dis, cmap, query, 256);
	for (i=0; i<256; i++)
	{	if (query[i].red==0 && query[i].green==0 && query[i].blue==0)
			colors_allowed++;
#ifdef _BLABLA_
		cout<<query[i].pixel<<", r="<<(query[i].red)/256<<", g="<<
		(query[i].green)/256<<", b="<<(query[i].blue)/256<<endl;
#endif
	}
	XplDouble xpld(1, 1);
	xpld(0)=colors_allowed-1;
	
	return(new XplObject( new XplDouble(xpld)));
}

extern Liste <unsigned long > system_pixels;

XplObject* FreeColor(Liste<XplObject*> *argl)
{	int k;
	unsigned long i; 
	Display *dis;
	Boolean only_read;
	dis=XtDisplay(bs_glob_variable.main_shell);	
	int snum=DefaultScreen(dis);

	char * word=NULL;
	XplChar * xplcc;
	
 	if (argl->laenge () >1)
    	{
    	globalError.Set (ERR_ARGS, "freecolor: Must be max. 1");
    	return (NULL);
    	}

	if (argl->laenge () ==1 && (*argl)[0]->Type () == O_XPLCHAR)
  	{	xplcc=(*argl)[0]->DefaultComponent()->Content().xplchar;
		word=(*xplcc)(0).tostr();
		if (strcmp(word, "system") && strcmp(word, "user"))
		{	globalError.Set(ERR_INTERN, "Only system and user are allowed!");
			return(NULL);
		}
  	}
  	if (argl->laenge () ==0 || !(strcmp(word, "system")))
  	{	for (i=0; i<system_pixels.laenge(); i++)
		{	k=0;
			while (k<all_colors.laenge() && 
				all_colors[k]->pixel!=system_pixels[i])
				k++;
			if (k<READ_ONLY_COUNT)	//read_only!
			;
			else
				XFreeColors(dis, cmap, &(system_pixels[i]),
						 1, 0);
		}	
		Liste <unsigned long > s;
		system_pixels=s;
	}
  	if (argl->laenge () ==0 || !(strcmp(word, "user")))
  	{	for (i=READ_ONLY_COUNT; i<all_colors.laenge(); i++)
		if (all_colors[i]->pixel>1 && all_colors[i]->pixel<256)
		{	XFreeColors(dis, cmap, &(all_colors[i]->pixel),
						 1, 0);
			all_colors[i]->pixel=1;
		}	
	}
	return(NULL);
}

#endif	//von _UNIX_


//extern int FindColor(int, int, int);

XplObject* CreateColorPalette(Liste<XplObject*> *argl)
{	if (argl->laenge()!=1)
	{	globalError.Set (ERR_INTERN, "1 Arg wanted");
		return(NULL);
	}
		
	XplDouble *xpld=(*argl)[0]->DefaultXplDouble();
	if (	xpld->dimension(1)!=3 )
	{	globalError.Set (ERR_INTERN, "3 columns are wanted");
		return(NULL);
	}
				
	int i, colors_req, col_number;
	colors_req=xpld->dimension(0);
	
	for (i=0; i<colors_req; i++)
	if (	(*xpld)(i, 0)<0 || !((*xpld)(i, 0)<256) ||
		(*xpld)(i, 1)<0 || !((*xpld)(i, 1)<256) ||
		(*xpld)(i, 2)<0 || !((*xpld)(i, 2)<256) )
		
	{	globalError.Set (ERR_INTERN, "createcolor: Color vector is bad!");
		cout<<"("<<(*xpld)(i, 0)<<", "<<(*xpld)(i, 1)<<", "<<
			(*xpld)(i, 2)<<")\n";
		return(NULL);
	}


#ifdef _BLABLA_
	cout<<colors_req<<endl;
#endif	

#ifdef _UNIX_
	Display *dis;
	XColor rgb_exact;
	dis=XtDisplay(bs_glob_variable.main_shell);
	int snum=DefaultScreen(dis);
#endif
	long unsigned *all_pixels= new long unsigned [colors_req];
	for (i=0; i<colors_req; i++)
		all_pixels[i]=0;

	XplColor * new_col;
	XplMatrix rgb(1, 3);
	int k=0;
	int found;
	int colors_already=all_colors.laenge();
	for (i=0; i<colors_req; i++)
	{	found=FindColor((int)(*xpld)(i, 0), (int)(*xpld)(i, 1),
			(int)(*xpld)(i, 2));
		if (	(found==-1) ||
			(found>7
#ifdef _UNIX_
			&& all_colors[found]->pixel==1
#endif
			))
			// neu allocieren...
		{
#ifdef _UNIX_
			rgb_exact.red=(int)(*xpld)(i, 0)*256;
			rgb_exact.green=(int)(*xpld)(i, 1)*256;
			rgb_exact.blue=(int)(*xpld)(i, 2)*256;
#endif
			rgb(0, 0)=(int)(*xpld)(i, 0);
			rgb(0, 1)=(int)(*xpld)(i, 1);
			rgb(0, 2)=(int)(*xpld)(i, 2);

#ifdef _BLABLA_
	cout<<" Color allocate for ("<<(int)rgb(0, 0)<<", "<<(int)rgb(0, 1)<<
			", "<<(int)rgb(0, 2)<<")"<<endl;
#endif
#ifdef _UNIX_
			if (!XAllocColor(dis, cmap, &rgb_exact))
			{	globalError.Set (ERR_INTERN,
			"Cannot alocate color...");
			// und die allocated colors frei geben?
			cout<<all_colors.laenge()-colors_already<<
				" allocated\n";
				if (all_colors.laenge()==colors_already)
	         { delete all_pixels;
					return(NULL);
            }
				XFreeColors(dis, cmap, all_pixels,
					all_colors.laenge()-colors_already, 0);
				while (all_colors.laenge()>colors_already)
				{	delete all_colors
						[all_colors.laenge()-1];
					all_colors.
					loesche(all_colors.laenge()-1);
				}
				delete all_pixels;
            return(NULL);
			}
#ifdef _BLABLA_
			cout<<"Pixel :"<<rgb_exact.pixel<<endl;
#endif
			all_pixels[k]=rgb_exact.pixel;
#endif


			if (found==-1)
				new_col=new XplColor;
			else
				new_col=all_colors[found];

#ifdef _UNIX_
			new_col->pixel=rgb_exact.pixel;
			new_col->red=rgb_exact.red/256;
			new_col->green=rgb_exact.green/256;
			new_col->blue=rgb_exact.blue/256;
#else
			new_col->red=rgb(0,0)*256;
			new_col->green=rgb(0,1)*256;
			new_col->blue=rgb(0,2)*256;
#endif

			new_col->color_name=strdup("noname");
			new_col->requested=rgb;
			if (found==-1)
				all_colors.haengeAn(new_col);
			k++;
		}
	}


#ifdef _BLABLA_
	for (i=0; i<all_colors.laenge(); i++)
	{	cout<<(int)(all_colors[i]->red)<<
		", "<<(int)(all_colors[i]->green)<<
		", "<<(int)(all_colors[i]->blue)<<endl;
	}
	cout<<"Allocated were "<<colors_req<<" colors"<<endl;
#endif
	delete all_pixels;
	return(NULL);
}

#ifndef _UNIX_
XplObject* FreeColor(Liste<XplObject*> *argl)
{	//cout<<"freecolor:	sorry, it is not implemented"<<endl;
	return(NULL);
}
#endif
#ifndef _UNIX_
XplObject* AddButton(Liste<XplObject*> *argl)
{	cout<<"addbutton:	sorry, it is not implemented"<<endl;
	return(NULL);
}
#endif
#ifndef _UNIX_
XplObject* SetMode(Liste<XplObject*> *argl)
{	cout<<"setmode:	sorry, it is not implemented"<<endl;
	return(NULL);
}
#endif
#ifndef _UNIX_
XplObject* BorlandDummy(Liste<XplObject*> *argl)
{	cout<<"sorry, it is not implemented"<<endl;
	return(NULL);
}
#endif
