/* $Header: /home/xplore/cvs/xpl4gr/text.C,v 1.3 2002/08/16 12:31:51 sigbert Exp $ */

#include <stdio.h>
#ifndef __BORLANDC__
#include <unistd.h>
#else
#include <process.h>
#endif

#include "directory.h"
#include "text.h"
#include "plot.h"

char * VisText::VisTextGetText() const
{	return(strdup(text));
}

void VisText::VisTextSetText(const char *te)
{	if (te==NULL || strlen(te)==0)
		return;
	if (text!=NULL )
		delete text;
	text=strdup(te);
}

char * VisText::VisTextGetSelectedText() const
{	return(NULL);
}

	

VisText::VisText(const VisText *ttext, XplDisplay* dixi, 
		const int di_x, const int di_y):SubDisplay(dixi, di_x, di_y)
{
#ifdef _BLABLA_
	cout<<"VisText(const VisText *ttext=NULL, XplDisplay* dixi=NULL, 
		const int di_x=1, const di_y=1) ist aufgerufen"<< endl;
#endif
	
	if (dixi==NULL)
	{	XplDouble veri(1), hori(1);
		veri.fill(1.0);
		hori.fill(1.0);
		dixi=new XplDisplay(veri, hori);
	}

}



VisText::VisText(const char *ti, XplDisplay* dixi, 
		const int di_x, const int di_y):SubDisplay(dixi, di_x, di_y)
{	int i, j;	

	text=strdup(ti);

#ifdef _BLABLA_
	cout<<"VisText(const char *t, XplDisplay* dixi=NULL, 
		const int di_x=1, const di_y=1) ist aufgerufen"<< endl;
#endif
	
	if (dixi==NULL)
	{	cout<<"Create dixi,..."<<endl;
		XplDouble veri(1), hori(1);
		SubType was[1];
		was[0]=TEXT;
		veri.fill(1.0);
		hori.fill(1.0);
		dixi=new XplDisplay(veri, hori);
	}

	top=dixi->GetElementTopPosition(di_x, di_y);
	bottom=dixi->GetElementBottomPosition(di_x, di_y);
	left=dixi->GetElementLeftPosition(di_x, di_y);
	right=dixi->GetElementRightPosition(di_x, di_y);
	width=dixi->GetElementWidth(di_x, di_y);
	height=dixi->GetElementHeight(di_x, di_y);

#ifdef _BLABLA_
	cout<<"	VisText mit "<<
	strlen(ti)<<" chars"<<endl;
#endif
		
//	manage();
	
}

/*-----------------------------------------------------------------------*/

VisText::~VisText()	
	{	int i;
#ifdef _BLABLA_
		cout<<"VisText destruktor"<<endl;
#endif
		delete text;
//		SetTitle("INCOMPLETE!!!");

/*	WANN WIRD ES AUFGERUFEN???????*/
/*	1.	delete p;	//p st VisText *
			Man soll unterscheiden, ob es ein text oder display war.
			Fuer text fenster vernichten;
			fuer display nur inhalt und menu loeschen.
	2.	dixi[1,1]=text(x~y)	(parser)
			Dabei soll inhalt und menu geloescht werden
			und dann VisText::VisText(..., dixi, 1, 1) aufgerufen.
*/

	}	
void VisText::Out() const
{	xplmessage(text);
}	

void VisText::Print(FILE * ps_file) const
{	
#ifdef _BLABLA_
	cout<<text<<endl;
#endif
#ifndef PAPER_OFFSET
#define PAPER_OFFSET 0
#endif

	fprintf(ps_file, "%d %d translate\n", PAPER_OFFSET, PAPER_OFFSET);
	
	fprintf(ps_file, "/Courier findfont 10 scalefont setfont\n5 5 moveto\n");
	
/*	fprintf(ps_file, 
"0 0 moveto\n%d 0 lineto\n%d %d lineto\n0 %d lineto \n0 0 lineto stroke\n",
		width, width, height, height);
*/
	fprintf(ps_file, "0.000 0.000 0.000 setrgbcolor\n");

	int all_count=strlen(text);
	int i, j, li=1;
	char line[256];
	for (i=0; i<all_count; i++)
	{	j=0;
		while ( i<all_count && text[i]!='\n')
		{	line[j]=text[i];
			i++;
			j++;
		}
		line[j]=0;
#ifdef _BLABLA_
		cout<<j+1<<line<<endl;
#endif
		fprintf(ps_file, "5 %d moveto \n", height-li*15);
		fprintf(ps_file, "(%s) show\n", line);
		li++;
	}	
	
	fprintf(ps_file, "-%d -%d translate\n", PAPER_OFFSET, PAPER_OFFSET);
}	

void VisText::Print(const char * file_name) const
{	FILE *ps_file;
	char line[256];
	char fname[16];
	
	static int n=1;
//	cout<<"PRINT!!!"<<endl;
//	cout<<"width="<<width<<", height="<<height<<endl;
	if (file_name==NULL)
		sprintf(fname, "%s%d.ps", "subd", n);
	else
		sprintf(fname, "%s", file_name);
	//	cout<<"filename: "<<fname<<endl;
	ps_file=fopen(fname, "w"); // SK 23.06.98
	fprintf(ps_file, "%s\n",
		"%!PS-Adobe-2.0 EPSF-1.2");
	fprintf(ps_file, "%s 0 0 %d %d\n",
		"%%BoundingBox:",
		width+PAPER_OFFSET, height+PAPER_OFFSET);
	Print(ps_file);
	fprintf(ps_file, "showpage");
	fclose(ps_file);
}
	
void VisText::Refresh() const
{	
;
}	
