/* $Header: /home/xplore/cvs/xpl4gr/uplot.C,v 1.3 2002/08/16 12:31:52 sigbert Exp $ */

#ifdef _UNIX_

#include "uplot.h"
#include "udisp.h"
	
extern Colormap cmap;			//OK

extern "C" BS_Glob_Variable bs_glob_variable;
	
Widget UPlot::GetWidget() const
{ return(widgi);
}

extern "C"

{	void redraw_part(Widget draw,  Dimension x, Dimension y,
 		Dimension part_wi, Dimension part_he);
	void redraw_some_points(Widget draw, int data_num, 
		XplMatrix & which_points);
	void userCB(Widget w, XtPointer p1, XtPointer p2);
	Widget CreateMenuToPlot(Widget draw, Plot *plot, 
			Wid_Data *wid_data, XplDisplay * dixi);
	void pophandler(Widget w, XtPointer p, XEvent *cbs, char *ch);
	void	wrefresh(Widget);
	void add_data_to_menu(Widget, Plot *);
	void resizeCB(Widget w, XtPointer p1, XtPointer p2);
	void last_cry(Widget w, XtPointer p1, XtPointer p2)
	{
#ifdef _BLABLA_
	cout<<"last_cry fuer "<<XtName(w)<<endl;
#endif
	}
void create_pixmap_gc(Wid_Data *wid_data, int wi, int he)
{	Display *dis;
	dis=XtDisplay(bs_glob_variable.main_shell);
	wid_data->pixy=XCreatePixmap( dis,
		RootWindowOfScreen(XtScreen(bs_glob_variable.main_shell)),
		wi, he, DefaultDepth(dis, DefaultScreen(dis)));
	wid_data->bitmap_gc=XCreateGC(dis, wid_data->pixy, 0, NULL);
	XSetFunction(dis, 
		wid_data->bitmap_gc, GXcopy);	
	XSetForeground(dis,
				wid_data->bitmap_gc, 0);	
	XFillRectangle(dis, 
		wid_data->pixy, wid_data->bitmap_gc, 
		0, 0, wi, he);

	
}
}		//end of extern "C"

UPlot::UPlot(const Liste <XplObject *> * data_list,
		XplDisplay* dixi, 
		const int di_x, const int di_y):
			Plot(data_list, dixi, di_x, di_y)
{	Widget kiste, menu_parent;
	Wid_Data *wid_data;
	
	type=UPLOT;

#ifdef _BLABLA_
	cout<<"UPlot::UPlot(const Liste <XplObject *> * data_list,
		XplDisplay* dixi, 
		const int di_x, const int di_y)"<<endl;
	cout<<"left="<<left<<", top="<<top<<", right="<<right<<", bottom"<<bottom<<endl;
#endif
	kiste=((UDisplay *)(dixi))->GetKiste();
	menu_parent=((UDisplay *)(dixi))->GetMenu();
	char na[32];
	//sprintf(na, "plotdef(%d, %d)", di_x, di_y);
	sprintf(na, "plotdef");
	widgi=XtVaCreateWidget(na,
				xmDrawingAreaWidgetClass,
				kiste,
	   			XmNleftAttachment, XmATTACH_POSITION, 
	   			XmNleftPosition, left, 
	   			XmNtopAttachment, XmATTACH_POSITION, 
	   			XmNtopPosition, top,	
	   			XmNbottomAttachment, XmATTACH_POSITION, 
	   			XmNbottomPosition, bottom, 
	   			XmNrightAttachment, XmATTACH_POSITION, 
	   			XmNrightPosition, right, 
	   			NULL);

	XtManageChild(widgi);
	
	wid_data=new Wid_Data;
	create_pixmap_gc(wid_data, width, height);
	wid_data->subdis=this;
	XtVaSetValues(widgi, XmNuserData, wid_data, NULL);
//	XtManageChild(menu);

	menu=CreateMenuToPlot(widgi, this, wid_data, dixi);	
//	cout<<"CreateMenu beendet"<<endl;
	XtVaSetValues(widgi, XmNuserData, wid_data, NULL);
//	XtAddCallback(widgi, XmNresizeCallback, resizeCB, NULL);
	XtAddCallback(widgi, XmNdestroyCallback, last_cry, NULL);

	XtAddEventHandler(widgi, EnterWindowMask | LeaveWindowMask
	 |PointerMotionMask |
		ButtonMotionMask | ButtonPressMask | ButtonReleaseMask |
		StructureNotifyMask | ExposureMask | KeyPressMask |
		ColormapChangeMask,			//OK
				False, pophandler, (XtPointer) widgi);
		
	XSetWindowColormap(XtDisplay(bs_glob_variable.main_shell),
		 XtWindow(widgi), cmap);	//OK
	XtManageChild(widgi);
	Dimension wi, he;
	XtVaGetValues(widgi, XmNwidth, &wi, XmNheight, &he, NULL);
#ifdef _BLABLA_
	cout<<"by constructor: "<<wi<<", "<<he<<endl;
#endif	
	Resize(wi, he);
//	Refresh();

}
		
UPlot::UPlot(XplDisplay* dixi, 
		const int di_x, const int di_y):
			Plot(dixi, di_x, di_y)
{	Widget kiste, menu_parent;
	Wid_Data *wid_data;
	
#ifdef _BLABLA_
	cout<<"UPlot::UPlot(XplDisplay* dixi, 
		const int di_x, const int di_y)"<<endl;
#endif
	type=UPLOT;
	
	kiste=((UDisplay *)(dixi))->GetKiste();
/*
#ifdef _BLABLA_
	Dimension ww, hh;
	XtVaGetValues(kiste, XmNwidth, &ww, XmNheight, &hh, NULL);	
	cout<<"1: w="<<ww<<", h="<<hh<<endl;
#endif
*/
	menu_parent=((UDisplay *)(dixi))->GetMenu();
	char na[10];
	sprintf(na, "plotdef");
	widgi=XtVaCreateWidget(na,
				xmDrawingAreaWidgetClass,
				kiste,
	   			XmNleftAttachment, XmATTACH_POSITION, 
	   			XmNleftPosition, left, 
	   			XmNtopAttachment, XmATTACH_POSITION, 
	   			XmNtopPosition, top,	
	   			XmNbottomAttachment, XmATTACH_POSITION, 
	   			XmNbottomPosition, bottom, 
	   			XmNrightAttachment, XmATTACH_POSITION, 
	   			XmNrightPosition, right, 
	   			NULL);


	wid_data=new Wid_Data;
	create_pixmap_gc(wid_data, width, height);
	wid_data->subdis=this;
	XtVaSetValues(widgi, XmNuserData, wid_data, NULL);
//	XtManageChild(menu);
	menu=CreateMenuToPlot(widgi, this, wid_data, dixi);	
	XtVaSetValues(widgi, XmNuserData, wid_data, NULL);
//	XtAddCallback(widgi, XmNresizeCallback, resizeCB, NULL);
	XtAddCallback(widgi, XmNdestroyCallback, last_cry, NULL);

/*
#ifdef _BLABLA_
	XtVaGetValues(kiste, XmNwidth, &ww, XmNheight, &hh, NULL);	
	cout<<"2: w="<<ww<<", h="<<hh<<endl;
#endif
*/
	XtAddEventHandler(widgi, EnterWindowMask | LeaveWindowMask
	 |PointerMotionMask |
		ButtonMotionMask | ButtonPressMask | ButtonReleaseMask |
		StructureNotifyMask | ExposureMask | KeyPressMask |
		ColormapChangeMask,			//OK
				False, pophandler, (XtPointer) widgi);
		
/*
#ifdef _BLABLA_
	XtVaGetValues(kiste, XmNwidth, &ww, XmNheight, &hh, NULL);	
	cout<<"3: w="<<ww<<", h="<<hh<<endl;
#endif
*/
	XtManageChild(widgi);
//	Refresh();


}
UPlot::UPlot(XplDisplay* dixi, 
		const int di_x, const int di_y, const Plot *plot):
			Plot(plot, dixi, di_x, di_y)
{	Widget kiste, menu_parent;
	Wid_Data *wid_data;
	
#ifdef _BLABLA_
	cout<<"UPlot::UPlot(XplDisplay* dixi, 
		const int di_x, const int di_y, Plot *)"<<endl;
#endif
	type=UPLOT;
	
	kiste=((UDisplay *)(dixi))->GetKiste();
	menu_parent=((UDisplay *)(dixi))->GetMenu();
	char na[10];
	sprintf(na, "plotdef");
	widgi=XtVaCreateWidget(na,
				xmDrawingAreaWidgetClass,
				kiste,
	   			XmNleftAttachment, XmATTACH_POSITION, 
	   			XmNleftPosition, left, 
	   			XmNtopAttachment, XmATTACH_POSITION, 
	   			XmNtopPosition, top,	
	   			XmNbottomAttachment, XmATTACH_POSITION, 
	   			XmNbottomPosition, bottom, 
	   			XmNrightAttachment, XmATTACH_POSITION, 
	   			XmNrightPosition, right, 
	   			NULL);


	wid_data=new Wid_Data;
	create_pixmap_gc(wid_data, width, height);
	wid_data->subdis=this;
	XtVaSetValues(widgi, XmNuserData, wid_data, NULL);
//	XtManageChild(menu);
	menu=CreateMenuToPlot(widgi, this, wid_data, dixi);	
	XtVaSetValues(widgi, XmNuserData, wid_data, NULL);
//	XtAddCallback(widgi, XmNresizeCallback, resizeCB, NULL);
	XtAddCallback(widgi, XmNdestroyCallback, last_cry, NULL);

	XtAddEventHandler(widgi, EnterWindowMask | LeaveWindowMask
	 |PointerMotionMask |
		ButtonMotionMask | ButtonPressMask | ButtonReleaseMask |
		StructureNotifyMask | ExposureMask | KeyPressMask |
		ColormapChangeMask,			//OK
				False, pophandler, (XtPointer) widgi);
		
	XtManageChild(widgi);
//	Refresh();


}
 
/*-----------------------------------------------------------------------*/

//extern "C" Widget dialog;

extern Liste<XplObject*> *objList;

UPlot::~UPlot()	
{
#ifdef _BLABLA_

/*OK*/		cout<<"UPlot destruktor fuer "<<XtName(widgi)<<endl;
#endif
//	XtRemoveCallback(widgi, XmNresizeCallback, resizeCB, NULL);
	XtRemoveCallback(widgi, XmNdestroyCallback, last_cry, NULL);

	XtRemoveEventHandler(widgi, EnterWindowMask | LeaveWindowMask
	 |PointerMotionMask |
		ButtonMotionMask | ButtonPressMask | ButtonReleaseMask |
		StructureNotifyMask | ExposureMask | KeyPressMask |
		ColormapChangeMask,			//OK
				False, pophandler, (XtPointer) widgi);
	
	Wid_Data *wd;
	XtVaGetValues(widgi, XmNuserData, &wd, NULL);
	
	XtDestroyWidget(XtParent(wd->contr_pan));
	XtDestroyWidget(widgi);
	XtDestroyWidget(menu);
	wd->subdis=NULL;
	//XtUnmanageChild(dialog);
	Display *dis;
	dis=XtDisplay(bs_glob_variable.main_shell);
	
	XFreePixmap(dis, wd->pixy);
	XFreeGC(dis, wd->bitmap_gc);
	
	delete wd;	
	/*
	int i;
	Plot *plot_to_link;
		long my_id;
		XplDisplay *dispi;
		
		int pln, j;
		dispi=GetDisplay();
		cout<<dispi->GetName()<<endl;
		for (j=0; j<objList->laenge(); j++)
		{	cout<<"Obj "<<(*objList)[j]->Name()<<endl;
			if ((*objList)[j]->Id()!=0 && 
		(*objList)[j]->DefaultComponent()->Content().display!=NULL &&
		(*objList)[j]->DefaultComponent()->Content().display==dispi)
			{	cout<<"gefunden!"<<endl;		
				break;
			}
		}	
		
		if (j==objList->laenge())
		{	cout<<" ID- krise!"<<endl;
			exit(0);
		}
		for (i=0; i<link_liste.laenge(); i++)
		{	for (j=0; j<objList->laenge(); j++)
			if ((*objList)[j]->Id()==
				link_liste[i]->DisplayID)
				break;
			if (j==objList->laenge())
				cerr<<"no such display found!"<<endl;
				
			else
			{	dispi=(*objList)[j]->DefaultComponent()
				->Content().display;
				plot_to_link=(Plot *)(dispi->
						GetElement(
						link_liste[i]->row,
						link_liste[i]->col));
				
			}
		}
	*/
}


/*-----------------------------------------------------------------------*/

void UPlot::Replace(int ttop, int bbottom, int lleft, int rright)
{	SubDisplay::Replace(ttop, bbottom, lleft, rright);
	XtVaSetValues(widgi,	XmNleftAttachment, XmATTACH_POSITION, 
	   			XmNleftPosition, left, 
	   			XmNtopAttachment, XmATTACH_POSITION, 
	   			XmNtopPosition, top,	
	   			XmNbottomAttachment, XmATTACH_POSITION, 
	   			XmNbottomPosition, bottom, 
	   			XmNrightAttachment, XmATTACH_POSITION, 
	   			XmNrightPosition, right, 
	   			NULL);

}

/*-----------------------------------------------------------------------*/

void UPlot::Resize(int wiwi, int hehe)
{	Wid_Data *wd;
	Display *dis;
	
	Dimension wi=wiwi, he=hehe; //ALT!
	dis=XtDisplay(bs_glob_variable.main_shell);

	XtVaGetValues(widgi, XmNuserData, &wd, 
	/* neu */ XmNwidth, &wi, XmNheight, &he,
	NULL);
	if (wd==NULL)
	{	cout<<"wd==NULL:::"<<endl;
		return;
	}	
	XFreePixmap(dis, wd->pixy);
	XFreeGC(dis, wd->bitmap_gc);
	wd->pixy=XCreatePixmap( dis,
		RootWindowOfScreen(XtScreen(bs_glob_variable.main_shell)),
		wi, he, DefaultDepth(dis, DefaultScreen(dis)));
	wd->bitmap_gc=XCreateGC(dis,
		wd->pixy, 0, NULL);
	XSetFunction(dis, 
		wd->bitmap_gc, GXcopy);	
	XSetForeground(dis,
				wd->bitmap_gc, 0);	
	XFillRectangle(dis, 
		wd->pixy, wd->bitmap_gc, 
		0, 0, wi, he);
#ifdef _BLABLA_
	cout<<"UPLOT::RESIZE... "<<endl;	
#endif
	Plot::Resize(wi, he);
	}


void UPlot::AddButton(const char *na, const char* com)
{	Widget user_b;
	XplDisplay *di;
	int i, j;
	char *ucom=strdup(com);
	
	user_b=XtVaCreateManagedWidget(na, 
				xmCascadeButtonWidgetClass, menu, 
				NULL);
	XtAddCallback(user_b, XmNactivateCallback, userCB,	
				 (XtPointer) ucom);
}


void UPlot::DeleteButton(const char *)
{	cout<<"sorry, not implemented yet"<<endl;
}

void UPlot::InFocus()
{
#ifdef _BLABLA_
		cout<<"UPLot::InFocus"<<endl;
#endif
	Widget disp_wid, *children;
	int num, i;
	char *name;
	Display *dis;
	Wid_Data *wid_data;
		
	dis=XtDisplay(widgi);
	disp_wid=XtParent(widgi);
	XtVaGetValues(widgi, XmNuserData, &wid_data, NULL);

	XtVaGetValues(disp_wid, XmNnumChildren, &num, 
				XmNchildren, &children, NULL);
	for (i=1; i<num; i++)	//0 ist draw_temp!
/*	if ( (widgi==children[i]) )	
		XtVaSetValues(widgi, XmNborderColor, 
			BlackPixel(dis, DefaultScreen(dis)), NULL);
	else
	{	XtVaSetValues(children[i], XmNborderColor, 
				WhitePixel(dis, DefaultScreen(dis)), NULL);
		XtManageChild(children[i]);
	}
*/	if ( (widgi==children[i]) )	
		XtVaSetValues(widgi, XmNborderColor, 
			0, NULL);
	else
	{	XtVaSetValues(children[i], XmNborderColor, 
				1, NULL);
		XtManageChild(children[i]);
	}

		
	Window win;
	XWindowAttributes wa;

	win=XtWindow(menu);
	
	if (XGetWindowAttributes(dis, win, &wa)==0)
	{	//cout<<"NULL!"<<endl;
		return;
	}
	
	if (wa.map_state==IsViewable)
	{	XtManageChild(XtParent(menu));
		XMapRaised(dis, XtWindow(menu));
	}
}		/*-----------------------------------------------------------------------*/
/*----------Nicht mehr relevant fuer Parser------------------------------*/
/*-----------------------------------------------------------------------*/		
int UPlot::redraw_points(int data_num, XplMatrix & only_these)
{	if (data_num<1 || data_num>GetDataCount())
	{	globalError.Set(ERR_INTERN, "Error by link");
		globalError.ShowError();
		return(-1);
	}
	if (	GetPointCount(data_num)!=
		only_these.rows()	)
	{	globalError.Set(ERR_INTERN, "Error by link");
		globalError.ShowError();
		return(-1);
	}		
	redraw_some_points(widgi, data_num, only_these);
	return(0);
}
	
int UPlot::repaint_part(int part_x, int part_y, 
		int part_width, int part_height) const
{;}

void UPlot::Refresh() const
{
wrefresh(widgi);
}

const char *UPlot::GetUnixFontName(void)
{
     if (desc_font_type == FT_MONOSPACE)
          return UFN_MONOSPACE;
     else if (desc_font_type == FT_SANSSERIF)
          return UFN_SANSSERIF;
     else return UFN_SERIF;
}

#endif
