/* $Header: /home/xplore/cvs/xpl4gr/vismat.C,v 1.3 2002/08/16 12:31:53 sigbert Exp $ */

#include "vismat.h"
#include "xplio.h"


#include "color.h"
//#include "xmask.hpp"

extern Liste <XplColor *> all_colors;
extern Liste <XplSymbol *> all_symbols;

extern Boolean GoodColor(XplDouble * to_use, int rows);
extern Boolean GoodDirection(XplDouble * to_use, int rows);
extern Boolean GoodTextSize(XplDouble * to_use, int rows);
extern Boolean GoodPointSize(XplDouble * to_use, int rows);
extern Boolean GoodLineArt(XplDouble *to_use, int rows);
extern Boolean GoodLineSize(XplDouble * to_use, int rows);
extern Boolean GoodSymbol(XplDouble * to_use, int rows);

extern int FindColor(int, int, int);
extern XplDouble MakeColor(XplDouble * to_use, int rows);

extern int  XisNumber (double x);

#ifndef X4singleserver
bool NANorINF(double x)
{return(!XisNumber(x));}

bool * RowHasNaN(XplDouble &quelle)
{	int rows=quelle.dimension(0);
  	int cols=quelle.dimension(1);
  	bool * nan_found = new bool [rows];
  	int i, j, k;
  	for (i=0; i<rows; i++)
	{	nan_found[i]=(1==0);
		for (j=0; (j<cols)&&(!nan_found[i]); j++)
			nan_found[i]=NANorINF(quelle(i, j));
  				
	}
 	return(nan_found);
}
#else
#include "remnan.h" 
#endif


extern XplObject * RemoveNaN( XplObject * const m );

/*
XplObject * RemoveNaN( XplObject * const m )
{
	int i, j, k, l, rows, cols, real_rows;
	char *la;
	Component *cobj;
		
	XplDouble *xpld=m->DefaultXplDouble();
	rows=xpld->dimension(0);
	cols=xpld->dimension(1);
		
	bool *where_nans=RowHasNaN(*xpld);
	real_rows=0;
	for (i=0; i<rows; i++)
		if (!where_nans[i])
			real_rows++;
	if (real_rows==rows)
	{	delete[]  where_nans;
		return(m);
	}
		
	if (real_rows==0)
	{	globalError.Set (ERR_INTERN, "there are only NaNs!");
		delete [] where_nans;
		return(NULL);
	}

	int * ind=new int [rows];
	k=0;
	for (i=0; i<rows; i++)
	{	if (!where_nans[i])
		{	k++;
			ind[i]=k;
		}
		else
			ind[i]=0;
		//cout<<i+1<<": "<<ind[i]<<endl;
	}			
				
		
	XplDouble neudouble(real_rows, cols);	
	k=0;
	for (i=0; i<rows; i++)
	if (!where_nans[i])
	{	for (j=0; j<cols; j++)
			neudouble(k, j)=(*xpld)(i, j);
		k++;
	}

  	XplObject *o  = new XplObject (new XplDouble (neudouble), m->Name());
		
	XplDouble *to_use=NULL;

	XplDouble * neucolor=NULL;
	XplDouble * neusize=NULL;
	XplDouble * neustyle=NULL;

	cobj=m->GetComponent("pcolor");
	if (cobj!=NULL)
	{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
		if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "pcolor is bad");
		
		else
		{	if (to_use->dimension(0)==1)
			{	//homogen
				neucolor=new XplDouble(1, to_use->dimension(1));
				for (j=0; j<to_use->dimension(1); j++)
					(*neucolor)(0, j)=(*to_use)(0, j);
			}
			if (to_use->dimension(0)==rows)
			{	neucolor=new XplDouble(real_rows, 
					to_use->dimension(1));
				k=0;
				for (i=0; i<rows; i++)
				if (!where_nans[i])
				{	for (j=0; j<to_use->dimension(1); j++)
						(*neucolor)(k, j)=(*to_use)(i, j);
					k++;
				}
			}				
			if (neucolor==NULL)
				globalWarning.Set(ERR_INTERN, "pcolor is bad");
			
		}
	}
	if (neucolor!=NULL)
		o->AppendComponent (new Component (new XplObject 
  		(neucolor ,"pcolor")));

	cobj=m->GetComponent("pstyle");
	if (cobj!=NULL)
	{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
		if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "pstyle is bad");
		
		else
		{	if (to_use->dimension(0)==1)
			{	//homogen
				neustyle=new XplDouble(1, 1);
				(*neustyle)(0, 0)=(*to_use)(0, 0);
			}
			if (to_use->dimension(0)==rows)
			{	neustyle=new XplDouble(real_rows, 1);
				k=0;
				for (i=0; i<rows; i++)
				if (!where_nans[i])
				{	(*neustyle)(k, 0)=(*to_use)(i, 0);
					k++;
				}
			}				
			if (neustyle==NULL)
				globalWarning.Set(ERR_INTERN, "pstyle is bad");
			
		}
	}
	if (neustyle!=NULL)
		o->AppendComponent (new Component (new XplObject 
  		(neustyle ,"pstyle")));

	cobj=m->GetComponent("psize");
	if (cobj!=NULL)
	{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
		if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "psize is bad");
		
		else
		{	if (to_use->dimension(0)==1)
			{	//homogen
				neusize=new XplDouble(1, 1);
				(*neusize)(0, 0)=(*to_use)(0, 0);
			}
			if (to_use->dimension(0)==rows)
			{	neusize=new XplDouble(real_rows, 1);
				k=0;
				for (i=0; i<rows; i++)
				if (!where_nans[i])
				{	(*neusize)(k, 0)=(*to_use)(i, 0);
					k++;
				}
			}				
			if (neusize==NULL)
				globalWarning.Set(ERR_INTERN, "psize is bad");
			
		}
	}
	if (neusize!=NULL)
		o->AppendComponent (new Component (new XplObject 
  		(neusize ,"psize")));

	XplDouble * neulines=NULL;
	XplDouble * neulcolor=NULL;
	XplDouble * neulsize=NULL;
	XplDouble * neulstyle=NULL;
	int lines_rows=0, lines_cols=0;
	int el;

	cobj=m->GetComponent("lines");
	if (cobj!=NULL)
	{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
		if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "lines vector is bad");
		else
		{	lines_rows=(int) (to_use->dimension(0));
			lines_cols=(int) (to_use->dimension(1));
			neulines= new XplDouble(lines_rows, lines_cols);
			for (i=0; i<lines_rows; i++)
			for (j=0; j<lines_cols; j++)
			{	el=(int)((*to_use)(i, j));
				if ( el<0 || el>rows)
				{	globalWarning.Set (ERR_INTERN, 
						"lines vector is bad");
					(*neulines)(i, j)=0;
				}
				(*neulines)(i, j)=ind[el-1];
			
			}
		}
	}
	if (neulines!=NULL)
		o->AppendComponent (new Component (new XplObject 
  		(neulines ,"lines")));
  	else
  	{	delete ind;
		delete where_nans;
		return(o);
  	}

	 cobj=m->GetComponent("lcolor");
	if (cobj!=NULL)
	{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
		if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "lcolor is bad");
		else
			neulcolor=new XplDouble(*to_use);	
	}
	
	if (neulcolor!=NULL)
		o->AppendComponent (new Component (new XplObject 
  		(neulcolor ,"lcolor")));

	cobj=m->GetComponent("lstyle");
	if (cobj!=NULL)
	{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
		if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "ldashes is bad");
		else
			neulstyle=new XplDouble(*to_use);	
	}
	
	if (neulstyle!=NULL)
		o->AppendComponent (new Component (new XplObject 
  		(neulstyle,"lstyle")));

	

	cobj=m->GetComponent("lsize");
	if (cobj!=NULL)
	{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
		if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "ldashes is bad");
		else
			neulsize=new XplDouble(*to_use);	
	}
	
	if (neulsize!=NULL)
		o->AppendComponent (new Component (new XplObject 
  		(neulsize,"lsize")));
		
	delete ind;
	delete where_nans;
	return(o);
	
}


*/

int ColorFromXplDouble(XplDouble xpld)
{	int  i;
	XplMatrix rgb(1, 3);
	rgb(0, 0)=xpld(0);
	rgb(0, 1)=xpld(1);
	rgb(0, 2)=xpld(2);
	for (i=0; i<all_colors.laenge(); i++)
		if (	(all_colors[i]->requested==rgb)==(0==0))
			break;
	if (i==all_colors.laenge())
	{	globalWarning.Set(WARN_OUTPUT, "No such color!");
		return(0);
	}
	return(i);
}

int SymbolSize(int symbol, int size)
{	int i;
	if (size==0)
		return(0);
	if (symbol==0)
		return(0);
	if (symbol==1)
		return(1);
/*	if (size==1)
		return(1);
*/
	for (i=0; i<all_symbols.laenge(); i++)
		if (	all_symbols[i]->symbol==symbol &&
			all_symbols[i]->size==size )
			break;
	if (i==all_symbols.laenge())
	{	globalWarning.Set(WARN_OUTPUT, "No such size or symbol!");
		return(0);
	}
	return(i+2);
}	

 
 //	Konstructor fuer ein Polygon aus ccount linien
MyPolygon::MyPolygon(int ccount, const int *ind_vec,
		int co, int out, int th, char *t)
		:count(ccount), thick(th), color(co), layout(out)
{	int i;
	if (t==NULL)
		text=NULL;
	else
	text=strdup(t);
	index=new int [ccount];
	for (i=0; i<ccount; i++)
		index[i]=ind_vec[i];
	points=NULL;
}

MyPolygon::MyPolygon(const MyPolygon * mp)
		:count(mp->count), thick(mp->thick),
		color(mp->color), layout(mp->layout)
{	int i;
	if (mp->text==NULL)
		text=NULL;
	else
		text=strdup(mp->text);
	if (mp->index==NULL)
		index=NULL;
	else
	{	index=new int [count];
		for (i=0; i<count; i++)
			index[i]=mp->index[i];
	}
	if (mp->points==NULL)
		points==NULL;
	else
	{	points=new MyPoint [count];
		for (i=0; i<count; i++)
		{	points[i].x=mp->points[i].x;
			points[i].y=mp->points[i].y;
		}
	}
}

int MyPolygon::GetPointCount() const {return(count);	}

int * MyPolygon::GetIndex() const
{	int i;
	int *itoret= new int [count];
	for (i=0; i<count; i++)
		itoret[i]=index[i];
	return(itoret);
}

//	Erstellen einen Array aus Koordinaten fuer z.b. DrawLines
/*
MyPoint* MyPolygon::VisPointToPolygon(const MyPoint *points) const
{	MyPoint* mp;
	int i;
	mp=new MyPoint [count];
	for (i=0; i<count; i++)
	{	mp[i].x=points[index[i]].x;
		mp[i].y=points[index[i]].y;
	}
	return(mp);
}
*/

MyPoint * MyPolygon::GetPoints() const 		//with copy!
{	int i;
	if (points==NULL)
	{	cerr<<"error by GetPoints"<<endl;
		return(NULL);
	}
	MyPoint *itoret= new MyPoint [count];
	for (i=0; i<count; i++)
		itoret[i]=points[i];
	
	return(itoret);
}



void MyPolygon::ComputePoints(const MyPoint *plotpoints)	
{	MyPoint* mp;
	int i;
	//if (index==NULL)		//schon passiert
	//	return;
	if (points==NULL)
		mp=new MyPoint [count];
	else
		mp=points;
	for (i=0; i<count; i++)
	{	mp[i].x=plotpoints[index[i]].x;
		mp[i].y=plotpoints[index[i]].y;
	}
	points=mp;
	//delete index;
	//index=NULL;
}

XplMatrix VisMatrix::GetContent() const
{	XplMatrix m=mat;
	return(m);
}

XplLabel::XplLabel(	const char *t, int co,  int di, int rad, 
			int fn, int s):
		color(co), direction(di), radius(rad), font_number(fn), size(s)
{	if (t==NULL || strlen(t)==0)
		text="";
	else
		text=strdup(t);
}
XplLabel::XplLabel(const XplLabel *lab):
		color(lab->color), direction(lab->direction), 
		radius(lab->radius), font_number(lab->font_number), 
		size(lab->size)
{	
#ifdef _BLABLA_
	//cout<<"XplLabel::XplLabel(const XplLabel *lab)"<<endl;
#endif	
	if (lab->text==NULL || strlen(lab->text)==0)
		text="";
	else
		text=strdup(lab->text);
}

XplLabel::XplLabel(const XplLabel &lab):
		color(lab.color), direction(lab.direction), 
		radius(lab.radius), font_number(lab.font_number), 
		size(lab.size)
{	
#ifdef _BLABLA_
	//cout<<"XplLabel::XplLabel(const XplLabel &lab)"<<endl;
#endif
	if (lab.text==NULL || strlen(lab.text)==0)
		text="";
	else
		text=strdup(lab.text);
}
	
XplLabel& XplLabel::operator=(const  XplLabel & lab)//Zuweisungsoperator
{	color=lab.color;
	direction=lab.direction; 
	radius=lab.radius;
	font_number=lab.font_number;
	size=lab.size;
#ifdef _BLABLA_
	cout<<"XplLabel::operator=(const XplLabel &lab)"<<endl;
#endif
	if (lab.text==NULL || strlen(lab.text)==0)
		text="";
	else
		text=strdup(lab.text);
	return(*this);
}

XplLabel::~XplLabel()
{	
	if (text!=NULL && strlen(text)>0)
		delete text;		
}

int XplLabel::SetText(const char *t)
{	if (text!=NULL && strlen(text)>0)
		delete text;
	if (t==NULL || strlen(t)==0)
		text="";
	else
		text=strdup(t);
	return(0);
}

char * XplLabel::GetText() const
{	if (text==NULL || strlen(text)==0)
		return(strdup(""));
	else 
		return(strdup(text));
}

Liste <XplLabel > VisMatrix::GetLabels(int i) const	
		//i=1, ..., point_count
		//bei i=0 alle labels!
{	Liste < XplLabel> labli;	

#ifdef _BLABLA_
	cout<<"VisMatrix::GetLabels: Begin"<<endl;
#endif	
	if (i>0)
	{	XplLabel labsi=labels[i-1];
		labli.haengeAn(labsi);
		return(labli);
	}
	int k;
	for (k=0; k<mat.rows(); k++)
		labli.haengeAn(labels[k]);
#ifdef _BLABLA_
	cout<<"VisMatrix::GetLabels: End"<<endl;
#endif	
	return(labli);
}		
	
int VisMatrix::SetLabels(const Liste <int> inti, 
			const Liste <XplLabel> & labli)
{	cout<<" VisMatrix::SetLabels(const Liste <int> inti, const Liste <XplLabel> & labli)!"<<endl;
	return(0);
}

Boolean VisMatrix::SomeRespPoints() const
{	if (!some_labels)
		return(False);
	
	int k;
	for (k=0; k<mat.rows(); k++)
		if (labels[k].direction==-1)
			return(True);
	return(False);
}

Liste <XplLabel > VisMatrix::GetRespLabels() const	
{	Liste < XplLabel> labli;	
	if (!some_labels)
		return(labli);
	int k;
	for (k=0; k<mat.rows(); k++)
	if (labels[k].direction==-1)
		labli.haengeAn(labels[k]);
	return(labli);
}

Liste <int > VisMatrix::GetRespIndex() const	
{	Liste <int> labli;	
	if (!some_labels)
		return(labli);
	int k;
	for (k=0; k<mat.rows(); k++)
	if (labels[k].direction==-1)
		labli.haengeAn(k);
	return(labli);
}

	
	/*
VisMatrix::VisMatrix(const XplObject & m):all_color(0), all_layout(CIRCLE)	
{	
#ifdef _BLABLA_
cout<<"VisMatrix(const XplObject & m) ist aufgerufen"<<endl;	
#endif
	int i, j, rows, cols;
		
	XplDouble xpld=m.DefaultXplDouble();


	rows=xpld.dimension(0);
	cols=xpld.dimension(1);		
	mat=*(new XplMatrix(rows, cols));
		
		
		
	for (i=0; i<rows; i++)
	for (j=0; j<cols; j++)
		mat(i, j)=xpld(i, j);

	each_color=NULL;
	each_layout=NULL;

	data_name=strdup(m.Name());
	column_name=new char* [cols];
	for (i=0; i<cols; i++)
	{	column_name[i]=new char [16];
		sprintf(column_name[i], "%d. column", i);
	}
		//cout<<"vismat mit mat= "<<endl;
		//	mat.out();
	}
*/



VisMatrix::VisMatrix( XplObject * const m ):all_color(0), all_layout(CIRCLE), some_labels(False), labels(NULL)	
{
#ifdef _BLABLA_
	cout<<"VisMatrix(XplObject * m) ist aufgerufen"<<endl;	
#endif
#ifdef _SWSDBG_
	cout<<"VisMatrix(XplObject * m) ist aufgerufen"<<endl;	
#endif



	/*
	cout<<"Vor:"<<m->ComponentNumber()<<endl;
	XplObject *oooo=RemoveNaN(m);
	cout<<"Nach:"<<oooo->ComponentNumber()<<endl;
	*/
		
	int i, j, k, l, rows, cols, real_rows;
	char *la;
	Component *cobj;
		
	XplDouble *xpld=m->DefaultXplDouble();
	rows=xpld->dimension(0);
	cols=xpld->dimension(1);
		
	bool *where_nans=RowHasNaN(*xpld);
	int * ind=new int [rows];
	k=0;
	for (i=0; i<rows; i++)
	{	if (!where_nans[i])
		{	k++;
			ind[i]=k;
		}
		else
			ind[i]=0;
			//cout<<i+1<<": "<<ind[i]<<endl;
	}			
				
	real_rows=0;
	for (i=0; i<rows; i++)
		if (!where_nans[i])
			real_rows++;
		
	if (real_rows==0)
	{	cerr<<"Exit in vismat with 0 real_rows..."<<endl;
		xpld->mdump("%f"); 
		exit(1);
	}
	XplMatrix tempi(real_rows, cols);
	mat=tempi;

	XplMatrix sel(real_rows,2);
	sel.fill(0.0);
	selected=sel;
	XplMatrix sm(1,1);
	selmode=sm;
	sm(0,0)=S_COPY;
		
	k=0;
	for (i=0; i<rows; i++)
	if (!where_nans[i])
	{	for (j=0; j<cols; j++)
			mat(k, j)=(*xpld)(i, j);
		k++;
	}

	each_color=NULL;
	each_layout=NULL;

	XplDouble *pcolor=NULL, *psymbol=NULL, *psize=NULL; 		
	XplDouble ppcolor(rows,3), ppsymbol(rows,1), ppsize(rows,1); 		
	XplDouble *to_use=NULL;

	cobj=m->GetComponent("pcolor");
	if (cobj!=NULL)
	{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
		if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "pcolor is bad");
		else
			if (!GoodColor(to_use, rows))
				globalError.Set (ERR_INTERN, 
				"pcolor is bad!");
			else
				pcolor=to_use;
	}
	if (pcolor==NULL)
		ppcolor.fill(DEFAULT_COLOR);
	else
		ppcolor=MakeColor(pcolor, rows);
	cobj=m->GetComponent("pstyle");
	if (cobj!=NULL)
		{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
			if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "pstyle is bad");
			else
				if (!GoodSymbol(to_use, rows))
					globalError.Set (ERR_INTERN, 
					"pstyle is bad!");
				else
					psymbol=to_use;
		}
		if (psymbol==NULL)
			ppsymbol.fill(DEFAULT_SYMBOL);
		else
		if (psymbol->dimension(0)==1)
			ppsymbol.fill((*psymbol)(0,0));
		else
			ppsymbol=(*psymbol);			
		
		cobj=m->GetComponent("psize");
		if (cobj!=NULL)
		{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
			if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "pcolor is bad");
			else
				if (!GoodPointSize(to_use, rows))
					globalError.Set (ERR_INTERN, 
					"psize is bad!");
				else
					psize=to_use;
		}
		
		if (psize==NULL)
			ppsize.fill(DEFAULT_SIZE);
		else
		if (psize->dimension(0)==1)
			ppsize.fill((*psize)(0,0));
		else
			ppsize=(*psize);	
		
		for (i=0; i<ppcolor.dimension(0); i++)
		if ( ! ((ppcolor(i,0)==ppcolor(0,0)) &&
			(ppcolor(i,1)==ppcolor(0,1)) &&
			(ppcolor(i,2)==ppcolor(0,2))) )
				break;

		if (i==ppcolor.dimension(0)) // homogen color
			all_color=FindColor((int)ppcolor(0,0), 
				(int)ppcolor(0,1), (int)ppcolor(0,2));
		else
		{	each_color=new int [real_rows];
#ifdef _SWSDBG_
	cout<<"each_color=new int [real_rows];"<<real_rows<<endl;
#endif
			k=0;
			for (i=0; i<rows; i++)
			if (!where_nans[i])
			{	each_color[k]=FindColor((int)ppcolor(i,0), 
				(int)ppcolor(i,1), (int)ppcolor(i,2));
				k++;				
			}
		}


		for (i=0; i<rows; i++)
		if (ppsymbol(i,0)!=ppsymbol(0,0)
				|| ppsize(i,0)!=ppsize(0,0) )
				break;
		if (i==rows) //homogen
			all_layout=SymbolSize((int)(ppsymbol(0)), (int)(ppsize(0)));
		else
		{	each_layout=new int [real_rows];
#ifdef _SWSDBG_
	cout<<"each_layout=new int [real_rows];"<<real_rows<<endl;
#endif
			k=0;
			for (i=0; i<rows; i++)
			if (!where_nans[i])
			{	each_layout[k]=SymbolSize((int)(ppsymbol(i)), 
						(int)(ppsize(i)));
				k++;				
			}
		}


	XplDouble *ind_vec=NULL;
	XplObject * etwa_line;
	int *some, lines_rows=0, lines_cols=0;
	MyPolygon *poli;
	XplDouble *lcolor=NULL, *ldashes=NULL, *lthick=NULL; 		

	cobj=m->GetComponent("lines");
	if (cobj!=NULL)
	{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
			if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "lines vector is bad");
			else
			{	lines_rows=(int) (to_use->dimension(0));
				lines_cols=(int) (to_use->dimension(1));
				for (i=0; i<lines_rows; i++)
				for (j=0; j<lines_cols; j++)
					if ( 	(*to_use)(i, j)<0 || 
						(*to_use)(i, j)>rows)
					{	globalError.Set (ERR_INTERN, 
						"lines vector is bad");
						break;
					}
				if (i==lines_rows && j==lines_cols)
					ind_vec=to_use;
			}
	}
	else
#ifdef _SWSDBG_
	cout<<"no lines 1"<<endl;
#else
	;
#endif
	if (ind_vec!=NULL)
	{	XplDouble llcolor(lines_rows, 3), lldashes(lines_rows);
		XplDouble llthick(lines_rows);
		XplDouble this_line(1, lines_cols);
		
#ifdef _BLABLA_
	 	cout<<"try to create "<<lines_rows<<" lines "<<
	 		" with "<<lines_cols<<" elements"<<endl;
#endif	 	
	 	cobj=m->GetComponent("lcolor");
		if (cobj!=NULL)
		{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
			if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "lcolor is bad");
			else
				if (!GoodColor(to_use, lines_rows))
					globalError.Set (ERR_INTERN, 
					"lcolor is bad!");
				else
					lcolor=to_use;
		}
	  	if (lcolor==NULL)
			llcolor.fill(DEFAULT_COLOR);
		else
			llcolor=MakeColor(lcolor, lines_rows);


		cobj=m->GetComponent("lstyle");
		if (cobj!=NULL)
		{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
			if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "ldashes is bad");
			else
				if (!GoodLineArt(to_use, lines_rows))
					globalError.Set (ERR_INTERN, 
					"ldashes is bad!");
				else
					ldashes=to_use;
		}
		if (ldashes==NULL)
			lldashes.fill(DEFAULT_LINE_ART);
		else
		if (ldashes->dimension(0)==1)
			lldashes.fill((*ldashes)(0,0));
		else
			lldashes=(*ldashes);			
		
		cobj=m->GetComponent("lsize");
		if (cobj!=NULL)
		{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
			if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "lcolor is bad");
			else
				if (!GoodLineSize(to_use, lines_rows))
					globalError.Set (ERR_INTERN, 
					"lthick is bad!");
				else
					lthick=to_use;
		}
		
		if (lthick==NULL)
			llthick.fill(DEFAULT_LINE_THICK);
		else
		if (lthick->dimension(0)==1)
			llthick.fill((*lthick)(0,0));
		else
			llthick=(*lthick);	
			
		int *some=new int [lines_cols];
		int segment_size=0;	
		int * segment_some=some;

		for (i=0; i<lines_rows; i++)
		{	segment_size=0;
			segment_some=some;
			for (j=0; j<lines_cols; j++)
			{	if ((*ind_vec)(i,j)==0 || 	
			ind[(int)((*ind_vec)(i,j))-1]==0)
				some[j]=-1;
				else
				some[j]=ind[(int)((*ind_vec)(i,j))-1]-1;

	//cout<<i<<j<<"index="<<(*ind_vec)(i,j)<<", some="<<some[j]<<"  ss="<<
	//segment_size<<endl;

				if (some[j]==-1) 
				//NaN aufgetreten or linie unterbrochen!
				{	if (segment_size>1)
					{	poli=new MyPolygon(
						segment_size,
				 			segment_some, 
				 		FindColor((int)llcolor(i,0),
				 			 (int)llcolor(i,1), 
				 			 (int)llcolor(i,2)),
				 			(int)lldashes(i),
				 			(int)llthick(i));
						poli_li.haengeAn(poli);
				/*
					cout<<"make a polygon with "<<
						segment_size<<" segments";
					for (k=0; k<segment_size; k++)
						cout<<segment_some[k]<<", ";
					cout<<endl;
				*/						
					}
					segment_some+=segment_size+1;
					segment_size=0;													
				}
				else
					segment_size++;
			}
		/*
		cout<<" Das segment::"<<endl;
			for (k=0; k<segment_size; k++)
					cout<<segment_some[k]<<endl;
		cout<<", lldashes="<<
			(int)lldashes(i)<<", thick="<<(int)llthick(i)<<endl;
		cout<<" Das war ..."<<endl;
		*/
			if (segment_size>0)
			{	poli=new MyPolygon(segment_size,
					 segment_some, 
					 FindColor((int)llcolor(i,0),
				 		(int)llcolor(i,1), 
				 		(int)llcolor(i,2)),
				 		(int)lldashes(i), 
				 		(int)llthick(i));
				poli_li.haengeAn(poli);
				/*	cout<<"make a last polygon with "<<
						segment_size<<" segments; ";
					for (k=0; k<segment_size; k++)
						cout<<segment_some[k]<<", ";
					cout<<endl;
				*/							
			}
		}
		delete some;	
	}
	else	// end of read lines....
#ifdef _SWSDBG_
	cout<<"no lines 2"<<endl;
#else
	;
#endif


	XplDouble *tcolor=NULL, *tdirection=NULL, *tsize=NULL; 		
	XplChar * text_to_use=NULL;
	XplDouble ttcolor(rows,3), ttdirection(rows,1), ttsize(rows,1);

	cobj=m->GetComponent("ptext");
	if (cobj!=NULL)
	{	if (cobj->Content().xplobject->DefaultComponent()->Type ()
					 == C_XPLCHAR) 
		{	text_to_use=cobj->Content().xplobject->
				DefaultComponent()->Content().xplchar;
			if (	text_to_use->dimension(0)!=rows || 
				text_to_use->dimension(1)!=1)
			{	globalError.Set(ERR_INTERN, 
					"dim:text vector is bad");
				text_to_use=NULL;
			}
		}
		else
			globalError.Set(ERR_INTERN, "type:text vector is bad");
	}		
	else
#ifdef _SWSDBG_
	cout<<"no text 1"<<endl;
#else
	;
#endif

	if (text_to_use!=NULL)
	{	// some text found
		cobj=m->GetComponent("tcolor");
		if (cobj!=NULL)
		{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
			if (to_use==NULL)
				globalWarning.Set(ERR_INTERN, "tcolor is bad");
			else
				if (!GoodColor(to_use, rows))
					globalError.Set (ERR_INTERN, 
					"tcolor is bad!");
				else
					tcolor=to_use;
		}
		if (tcolor==NULL)
			ttcolor.fill(DEFAULT_COLOR);
		else
			ttcolor=MakeColor(tcolor, rows);

		cobj=m->GetComponent("tdirection");
		if (cobj!=NULL)
		{	to_use=cobj->Content().xplobject->
				DefaultXplDouble ();
			if (to_use==NULL)
				globalWarning.Set(ERR_INTERN, 
				"tdirection is bad");
			else
				if (!GoodDirection(to_use, rows))
					globalError.Set (ERR_INTERN, 
					"tdirection is bad!");
				else
					tdirection=to_use;
			}
		if (tdirection==NULL)
			ttdirection.fill(DEFAULT_TEXT_DIR);
		else
		if (tdirection->dimension(0)==1)
			ttdirection.fill((*tdirection)(0,0));
		else
			ttdirection=(*tdirection);			
		
		cobj=m->GetComponent("tsize");
		if (cobj!=NULL)
		{	to_use=cobj->Content().xplobject->DefaultXplDouble ();
			if (to_use==NULL)
			globalWarning.Set(ERR_INTERN, "tcolor is bad");
			else
				if (!GoodTextSize(to_use, rows))
					globalError.Set (ERR_INTERN, 
					"tsize is bad!");
				else
					tsize=to_use;
		}
		
		if (tsize==NULL)
			ttsize.fill(DEFAULT_TEXT_SIZE);
		else
		if (tsize->dimension(0)==1)
			ttsize.fill((*tsize)(0,0));
		else
			ttsize=(*tsize);	

		some_labels=True;
		labels=new XplLabel [real_rows];
		k=0;
		for (j=0; j<text_to_use->dimension(0); j++)
		if (!where_nans[j])
		{	la=(*text_to_use)(j).tostr();
			labels[k].SetText(la);
			labels[k].direction=(int)(ttdirection(j));
			labels[k].color=FindColor((int)ttcolor(j,0), 
					(int)ttcolor(j,1), (int)ttcolor(j,2));
			labels[k].size=(int)(ttsize(j));
			delete la;
			k++;
		}

	}
#ifdef _SWSDBG_
	cout<<"no text 2"<<endl;
#endif

	delete where_nans;
	delete ind;

		data_name=strdup(m->Name());
		column_name=new char* [cols];
		for (i=0; i<cols; i++)
		{	column_name[i]=new char [16];
			sprintf(column_name[i], "%d. column", i);
		}
		
/*
#ifdef _BLABLA_
		out();
		delete ind;
#endif
*/
}



VisMatrix::VisMatrix(XplDouble & m):all_color(0), all_layout(CIRCLE),
				some_labels(False), labels(NULL)
	//mit Kopieren von m
	{
#ifdef _BLABLA_
	cout<<"VisMatrix(const XplDouble &) ist aufgerufen"<<endl;
#endif
		int i, j, rows, cols;
		
		rows=m.dimension(0);
		cols=m.dimension(1);
		
		mat=*(new XplMatrix(rows, cols));

		for (i=0; i<rows; i++)
			for (j=0; j<cols; j++)
				mat(i, j)=m(i, j);

		each_color=NULL;
		each_layout=NULL;

		data_name=strdup("noname");
		column_name=new char* [cols];
		for (i=0; i<cols; i++)
		{	column_name[i]=new char [16];
			strcpy(column_name[i], "noname");
		}
		XplMatrix sel(rows,2);
		sel.fill(0.0);
		selected=sel;
		XplMatrix sm(1,1);
		selmode=sm;
		sm(0,0)=S_COPY;
	}




VisMatrix::VisMatrix(const VisMatrix & vis):
	all_color(vis.all_color), all_layout(vis.all_layout),
				some_labels(vis.some_labels), labels(NULL)	
	{
#ifdef _BLABLA_
	cout<<"VisMatrix(const VisMatrix &) ist aufgerufen"<<endl;
#endif
#ifdef _SWSDBG_
	cout<<"VisMatrix(const VisMatrix &) ist aufgerufen"<<endl;
#endif
		int i, rows, cols;
		
		//	vis.out();
		mat=vis.mat;
		rows=mat.rows();
		cols=mat.cols();

		if (vis.each_color==NULL)
			each_color=NULL;
		else
		{	each_color=new int [rows];
			for (i=0; i<rows; i++)
				each_color[i]=vis.each_color[i];
		}
		if (vis.each_layout==NULL)
			each_layout=NULL;
		else
		{	each_layout=new Outfit [rows];
			for (i=0; i<rows; i++)
				each_layout[i]=vis.each_layout[i];
		}

		data_name=strdup(vis.data_name);
		column_name=new char* [cols];
		for (i=0; i<cols; i++)
		{	column_name[i]=new char [16];
			strcpy(column_name[i], vis.column_name[i]);
		}

		int lines_count=vis.poli_li.laenge();
		for (i=0; i<lines_count; i++)
			poli_li.haengeAn( new MyPolygon( vis.poli_li[i]));

		if (vis.labels!=NULL)
		{	labels= new XplLabel [rows];
			for (i=0; i<rows; i++)
				labels[i]=vis.labels[i];
						
		}	
		XplMatrix sel(rows,2);
		sel.fill(0.0);
		selected=sel;
		XplMatrix sm(1,1);
		selmode=sm;
		sm(0,0)=S_COPY;
		//cout<<" Das war VisMatrix(const VisMatrix & vis)"<<endl;
	}

VisMatrix& VisMatrix::operator=(const VisMatrix & vis)
	{	
#ifdef _BLABLA_
	cout<<"operator=(const VisMatrix &) ist aufgerufen"<<endl;
#endif
#ifdef _SWSDBG_
	cout<<"operator=(const VisMatrix &) ist aufgerufen"<<endl;
#endif
		int i, rows, cols;
		
		//	//cout<<"es war "<<endl;
		//	out();
		if ( !(each_color==NULL))
			delete each_color;
		if ( !(each_layout==NULL))
			delete each_layout;
		delete data_name;
		cols=mat.cols();
		for (i=0; i<cols; i++)
			delete [](column_name[i]);
		delete [] column_name;		
		
		mat=vis.mat;
		rows=mat.rows();
		cols=mat.cols();

		if (vis.each_color==NULL)
			each_color=NULL;
		else
		{	each_color=new int [rows];
			for (i=0; i<rows; i++)
				each_color[i]=vis.each_color[i];
		}
		if (vis.each_layout==NULL)
			each_layout=NULL;
		else
		{	each_layout=new Outfit [rows];
			for (i=0; i<rows; i++)
				each_layout[i]=vis.each_layout[i];
		}
		all_color=vis.all_color;
		all_layout=vis.all_layout;

		data_name=strdup(vis.data_name);
		column_name=new char* [cols];
		for (i=0; i<cols; i++)
		{	column_name[i]=new char [16];
			strcpy(column_name[i], vis.column_name[i]);
		}
		XplMatrix sel(rows,2);
		sel.fill(0.0);
		selected=sel;
		XplMatrix sm(1,1);
		selmode=sm;
		sm(0,0)=S_COPY;
		//	out();
		//	//cout<<" Das war VisMatrix(const VisMatrix & vis)"<<endl;
		return(*this);
	}
VisMatrix::VisMatrix():mat(), all_color(0), all_layout(CIRCLE),
 	some_labels(False), labels(NULL)
	{	
#ifdef _BLABLA_
	cout<<"VisMatrix() ist aufgerufen"<<endl;
#endif
		//cout<<"mit "<<mat.cols()<<" spalten"<<endl;
		each_color=NULL;
		each_layout=NULL;
		data_name=strdup("noname");
		column_name=NULL;
		XplMatrix sel(1,2);
		sel.fill(0.0);
		selected=sel;
		XplMatrix sm(1,1);
		selmode=sm;
		sm(0,0)=S_COPY;
		//	out();
	}

VisMatrix::~VisMatrix()	
	{	
#ifdef _BLABLA_
	cout<<"Destructor ~VisMatrix!"<<endl;
#endif
#ifdef _SWSDBG_
	cout<<"Destructor ~VisMatrix!"<<endl;
#endif
		int i, cols;
		if (! (each_color==NULL) )
			delete each_color;
		if (! (each_layout==NULL) )
			delete each_layout;
				
		cols=mat.cols();
		////cout<<"Es war eine Vismat mit "<<cols<<" spalten"<<endl;
		delete data_name;
		for (i=0; i<cols; i++)
			delete [](column_name[i]);
		delete [] column_name;
		if (labels!=NULL)
		/*
		for (i=0; i<cols; i++)
			delete [] (labels[i]);
		*/
		delete [] labels;
#ifdef _BLABLA_
	cout<<"Destructor ~VisMatrix ends here"<<endl;
#endif
	}	

int VisMatrix::GetPointCount() const	
{	
	return mat.rows();	
}

void VisMatrix::out() const	
	{	char xplm[256];
		int i;
		if (data_name==NULL)
			sprintf(xplm,
		"Vismat onhe name besteht aus: %d  Punkte und %d Polygonen\n",
		GetPointCount(), poli_li.laenge());
		else
			sprintf(xplm,
		"Vismat %s besteht aus: %d  Punkte und %d Polygonen\n",
		data_name, GetPointCount(), poli_li.laenge());
		cout<<xplm<<"\n";
		//cout<<mat.rows()<<" zeilen und "<<mat.cols()<<" spalten\n";
		
		if (IsHomogen())
			cout<<"homogen"<<endl;
		else
			cout<<"nicht homogen"<<endl;
		cout<<"Oder :"<<endl;
		for (i=0; i<mat.rows(); i++)
			cout<<GetPointLayout(i+1)<<"\t";
		cout<<endl;		
	}

//	Zwei Funktionen zum Berrechnen der Grenzwerte der i-ter Spalte:
XplMatrix VisMatrix::MinCol() const
	{		//cout<<"MinCol..."<<endl;
		//	mat.out();
		XplMatrix ret=mat.min_col();
		return(ret);	
	}

XplMatrix VisMatrix::MaxCol() const
	{		//cout<<"MaxCol..."<<endl;
		//	mat.out();
		XplMatrix ret=mat.max_col();
		return(ret);	
		
	}

XplMatrix VisMatrix::Extremum() const
	{		//cout<<"Extremum..."<<endl;
		//	mat.out();
		XplMatrix ret=mat.extremum();
		return(ret);	
	}
/*--------------Punkt-Funktionen:----------------------------------------*/

void VisMatrix::SetPointColor(const int color, const int c)
{	int i;
	int rows;

	rows=mat.rows();
	
	if (c<0 || c>rows)
	{	xplerror("Error by SetPointColor!");
		return;
	}
	if (c==0)
	{	if (!(each_color==NULL))
		{	delete each_color;
			each_color=NULL;
		}
		all_color=color;
		return;
	}
	else
	{	if (each_color==NULL)
		{	each_color=new int [rows];
			for (i=0; i<rows; i++)
				each_color[i]=all_color;
		}
		each_color[c-1]=color;
	}
}

					
void VisMatrix::SetPointColor(const int color, const XplMatrix which_point)
{	int i;
	int rows;

	rows=mat.rows();
	
	if (which_point.rows()!=rows)
	{	xplerror("Error by SetPointColor!");
		return;
	}
	if (each_color==NULL)
	{	each_color=new int [rows];
		for (i=0; i<rows; i++)
			each_color[i]=which_point(i, 0)==0 ?
				all_color	:	color;
	}
	else
		for (i=0; i<rows; i++)
			each_color[i]=which_point(i, 0)==0 ?
				each_color[i]	:	color;
	
}

int VisMatrix::GetPointColor(const int which)	const	
{	int co, i;
	int rows;

	rows=mat.rows();

	if (which<0 || which>rows)
	{	xplerror("Error by GetPointColor!");
		return(0);
	}
	if (which==0 || each_color==NULL)
		return(all_color);
	return(each_color[which-1]);
}
				
/*-----------------------------------------------------------------------*/


void VisMatrix::SetPointLayout(const int fi, const int c)
{	int rows, i;
	
	rows=mat.rows();

	if (c<0 || c>rows)
	{	xplerror("Error by SetPointLayout!");
		return;
	}
	if (c==0)
	{	if (!(each_layout==NULL))
		{	delete each_layout;
			each_layout=NULL;
		}
		all_layout=fi;
	//cout<<"set_point_layout..."<<endl;
	//out();
		return;
	}
	else
	{	if (each_layout==NULL)
		{	each_layout=new int [rows];
			for (i=0; i<rows; i++)
				each_layout[i]=all_layout;
		}
		each_layout[c-1]=fi;
	}
}

void VisMatrix::SetPointLayout(const int lay, const XplMatrix which_point)
{	int i;
	int rows;

	rows=mat.rows();
	
	if (which_point.rows()!=rows)
	{	xplerror("Error by SetPointColor!");
		return;
	}
	if (each_layout==NULL)
	{	each_layout=new int [rows];
		for (i=0; i<rows; i++)
			each_layout[i]=which_point(i, 0)==0 ?
			all_layout	:	lay;
	}
	else
		for (i=0; i<rows; i++)
			each_layout[i]=which_point(i, 0)==0 ?
			each_layout[i]	:	lay;

}

Outfit VisMatrix::GetPointLayout(const int which) const
{	int rows;
	rows=mat.rows();

	if (which<0 || which>rows)
	{	xplerror("Error by GetPointLayout!");
		return(0);
	}

	if (which==0 || each_layout==NULL)
		return(all_layout);
	return(each_layout[which-1]);
}
bool VisMatrix::IsHomogen() const
{	int rows=mat.rows();
	int i, li, ci;
	if (each_color==NULL)
	{	if (each_layout==NULL)
			return((0==0));
		li=each_layout[0];
		i=1;
		while(li==each_layout[i] && i<rows)
			i++;
		if (i==rows)	//war doch homogen!
			return(0==0);
		else
			return(0==1);
	}
	if (each_layout==NULL)	//each_color aber nicht!
	{	li=each_color[0];
		i=1;
		while(li==each_color[i] && i<rows)
			i++;
		if (i==rows)	//war doch homogen!
			return((0==0));
		else
			return((0==1));
	}
	//sonst
	li=each_layout[0];
	ci=each_color[0];
	i=1;
	while(ci==each_color[i] && li==each_layout[i] && i<rows)
		i++;
	if (i==rows)	//war doch homogen!
		return((0==0));
	
	else
		return((0==1));
}


/*-----------------------------------------------------------------------*/
void VisMatrix::SetColumnName(int i, const char *c)
	{	int cols;
	
		cols=mat.cols();

		if (i<0)	return;
		if (i>cols-1) return;
		delete []column_name[i];
		column_name[i]=strdup(c);
	
}	

/*----------------------------------------------------------------------*/	

int * VisMatrix::GetPolygonIndex(int line_num) const
{	if (line_num<1 || line_num> poli_li.laenge())
	{	xplerror("Error by VisMatrix::GetPolygonIndex");
		return(NULL);
	}
	return(poli_li[line_num-1]->GetIndex());
}



Liste <MyPolygon *> VisMatrix::GetPolygons() const
{	int k;
	Liste <MyPolygon *> result;
	for (k=0; k<poli_li.laenge(); k++)
		result.haengeAn(poli_li[k]);
	return(result);
}
		
/*----------------------------------------------------------------------*/	

int IsNotNaN(XplDouble & xpld);

	

/*----------------------------------------------------------------------*/



/*void VisMatrix::ConnectAllPoints(int co, Lines_Outfit fi)
	{	int i, j, rows, count, cols;
		char xplme[256];
		rows=mat.rows();
		cols=mat.cols();
		XplDouble *res=new XplDouble(1, cols);
		XplSelection sel(1);

		count=0;
		
		int* in=new int [rows];
		for (i=0; i<rows; i++)
		{
		
			in[count]=i;
			count++;

		}
		//cout<<"Polygon hat "<<count<<" Punkte\n";
		MyPolygon *polli=new MyPolygon(count, in, co, fi);
		delete in;
		while (poli_li.laenge()>0)
			{	delete poli_li[0];
				poli_li.loesche(0);
			}
		poli_li.haengeAn(polli);

		return;
	}
*/	

int IsNotNaN(XplDouble & xpld)
{	int i;
	int cols=xpld.dimension(1);
	//cout<<"IsNotNaN???"<<endl;
	xpld.dump("%f");
	for (i=0; i<cols; i++)
	{	//cout<<i<<endl;
	}
	//cout<<"IsnotNan"<<endl;
	return(0);
}


void VisMatrix::DeletePolygon(int num)
{	if (num<0 || num >poli_li.laenge())
	{	xplerror("no such line!");
		return;
	}
	if (num==0)
	{	while (poli_li.laenge()>0)
		{	delete poli_li[0];
			poli_li.loesche(0);
		}
		return;
	}
	delete poli_li[num-1];
	poli_li.loesche(num-1);
	}
	
void VisMatrix::AddPolygon(const int count, const int * some, 
		int co, Lines_Outfit fi, int thick)
	{	MyPolygon *mp;
		int *so, i;
		
		if (count<2)
		{	xplerror("VisMatrix::AddPolygon: error 1");	
			return;
		}
		if (count==2 && !(some==NULL) && 
			mat(some[0],0)==mat(some[1],0)
			&& mat(some[0],1)==mat(some[1],1))
		{	cerr<<"try to connect a point with itself"<<endl;
			return;
		} 
		
		if (some==NULL)
		{	if (count>mat.rows())
			{	xplerror("VisMatrix::AddPolygon: error 2");	
				return;
			}
			
			so= new int [count];
			for (i=0; i<count; i++)
				so[i]=i;
			mp=new MyPolygon(count, so, co, fi, thick);
			delete so;
		}
		else 
		{	for (i=0; i<count; i++)
				if (some[i]<0 || some[i]>mat.rows()-1)
			{	xplerror("VisMatrix::AddPolygon: error 3");	
				return;
			}
				
			mp=new MyPolygon(count, some, co, fi, thick);
		}
		poli_li.haengeAn(mp);
	}

void VisMatrix::SetPolygonColor(int color, int num)
{	int i;
	if (num==0)
	{	for (i=0; i<poli_li.laenge(); i++)
			poli_li[i]->color=color;			
		return;
	}
	if (num<0 || num >poli_li.laenge())
	{	xplerror("no such line!");
		return;
	}
	poli_li[num-1]->color=color;			
}
void VisMatrix::SetPolygonLayout(int out, int num)
{	int i;
	if (num==0)
	{	for (i=0; i<poli_li.laenge(); i++)
			poli_li[i]->layout=out;			
		return;
	}
	if (num<0 || num >poli_li.laenge())
	{	xplerror("no such line!");
		return;
	}
	poli_li[num-1]->layout=out;			
}
	
void VisMatrix::SetPolygonThick(int th, int num) 
{	int i;
	if (num==0)
	{	for (i=0; i<poli_li.laenge(); i++)
			poli_li[i]->thick=th;			
		return;
	}
	if (num<0 || num >poli_li.laenge())
	{	xplerror("no such line!");
		return;
	}
	poli_li[num-1]->thick=th;			
}
			
int VisMatrix::GetPolygonColor(int p_n) const
{	if (p_n<1 || p_n>poli_li.laenge())
	{	xplerror("no such line!");
		return(0);
	}
	 return(poli_li[p_n-1]->color); 
}

int VisMatrix::GetPolygonLayout(int p_n) const
{	if (p_n<1 || p_n>poli_li.laenge())
	{	xplerror("no such line!");
		return(0);
	}
	return(poli_li[p_n-1]->layout);	
}

int VisMatrix::GetPolygonThick(int p_n) const
{	if (p_n<1 || p_n>poli_li.laenge())
	{	xplerror("no such line!");
		return(0);
	}
	return(poli_li[p_n-1]->thick);	
}

int VisMatrix::GetPolygonSize(int i)  const
{	if (i<1 || i>poli_li.laenge())
	{	xplerror("no such line!");
		return(0);
	}
	return(poli_li[i-1]->GetPointCount());	
}


/*-----------------------------------------------------------------------*/


XplMatrix & VisMatrix::RealPoint(int i)
	{	XplMatrix *m = new XplMatrix(1, mat.cols());
		int ii, cols;
		cols=mat.cols();
		double d;
		
		for (ii=0; ii<cols; ii++)
		{	d=mat(i,ii);
			(*m)(0,ii)=d;
		}
		return(*m);
	}


/*-----------------------------------------------------------------------*/



XplObject * VisMatrix::GetXplObject() const
{	int i, j;
	int rows=mat.rows();
	int cols=mat.cols();
	Boolean something_false=False;
	
	XplDouble di(rows, cols);
		for (i=0; i<rows; i++)
		for (j=0; j<cols; j++)
				di(i, j)=mat(i, j);
	XplObject * o= new XplObject(new Component 
		(new XplObject(new XplDouble(&di), "data")));
	//XplObject * o= new XplObject(new XplDouble(&di), "data");
	
	//jetzt sollte man noch alle masken auswerten und anhaengen! 
	
	int color_number, layout_number, symbol, size;
	XplDouble ppcolor(rows, 3), ppsymbol(rows), ppsize(rows);
	if (each_color==NULL)
	{	if (all_color<0 || all_color>all_colors.laenge()-1)
		{	something_false=True;
			color_number=DEFAULT_COLOR;
		}
		else
			color_number=all_color;
		for (i=0; i<rows; i++)
		{	ppcolor(i,0)=all_colors[color_number]->requested(0,0);
  			ppcolor(i,1)=all_colors[color_number]->requested(0,1);
  			ppcolor(i,2)=all_colors[color_number]->requested(0,2);
  		}
  	}
  	else
  	for (i=0; i<rows; i++)
  	{	if (each_color[i]<0 || each_color[i]>all_colors.laenge()-1)
		{	something_false=True;
			color_number=DEFAULT_COLOR;
		}
		else
			color_number=each_color[i];
		ppcolor(i,0)=all_colors[color_number]->requested(0,0);
  		ppcolor(i,1)=all_colors[color_number]->requested(0,1);
  		ppcolor(i,2)=all_colors[color_number]->requested(0,2);
  	}
	
	if (each_layout==NULL)
	{	if (all_layout<0 || all_layout>all_symbols.laenge()+1)
		{	something_false=True;
			symbol=DEFAULT_SYMBOL;
			size=DEFAULT_SIZE;
		}
		else
		{	if (all_layout==0)
			symbol=size=0;
			if (all_layout==1)
			symbol=size=1;
			if (all_layout>1)
			{	symbol=all_symbols[all_layout-2]->symbol;
				size=all_symbols[all_layout-2]->size;
			}
		}
		for (i=0; i<rows; i++)
		{	ppsymbol(i)=symbol;
  			ppsize(i)=size;
  		}
  	}
  	else
  	for (i=0; i<rows; i++)
  	{	if (each_layout[i]<0 || each_layout[i]>all_symbols.laenge()+1)
		{	something_false=True;
			symbol=DEFAULT_SYMBOL;
			size=DEFAULT_SIZE;
		}
		else
		{	if (each_layout[i]==0)
			symbol=size=0;
			if (each_layout[i]==1)
			symbol=size=1;
			if (each_layout[i]>1)
			{	symbol=all_symbols[each_layout[i]-2]->symbol;
				size=all_symbols[each_layout[i]-2]->size;
			}
		}
		
		ppsymbol(i)=symbol;
  		ppsize(i)=size;

   	}

	o->AppendComponent (new Component 
		(new XplObject ( new XplDouble(ppcolor), "pcolor")));
	o->AppendComponent (new Component 
		(new XplObject ( new XplDouble(ppsymbol), "pstyle")));
	o->AppendComponent (new Component 
		(new XplObject ( new XplDouble(ppsize), "psize")));

	if (some_labels)
	{	XplDouble ttcolor(rows, 3), ttdir(rows), ttsize(rows);
		XplChar pptext(rows);
		char * labtext;
		for (i=0; i<rows; i++)
		{	labtext=labels->GetText();
			pptext(i)=labtext;
			color_number=labels->color;
			if (color_number<0 || 
				color_number>all_colors.laenge()-1)
			{	something_false=True;
				color_number=DEFAULT_COLOR;
			}
			ttcolor(i,0)=all_colors[color_number]->requested(0,0);
			ttcolor(i,1)=all_colors[color_number]->requested(0,1);
			ttcolor(i,2)=all_colors[color_number]->requested(0,2);
			ttdir(i)=labels->direction;
			ttsize(i)=labels->size;
			delete labtext;
		}
	o->AppendComponent (new Component 
		(new XplObject ( new XplChar(pptext), "ptext")));
	o->AppendComponent (new Component 
		(new XplObject ( new XplDouble(ttcolor), "tcolor")));
	o->AppendComponent (new Component 
		(new XplObject ( new XplDouble(ttdir), "tdirection")));
	o->AppendComponent (new Component 
		(new XplObject ( new XplDouble(ttsize), "tsize")));
	}
	
	if (poli_li.laenge()>0)
	{	int lines_rows, lines_cols;
		lines_rows=poli_li.laenge();
		lines_cols=0;
		for(i=0; i<lines_rows; i++)
		if (poli_li[i]->GetPointCount()>lines_cols)
			lines_cols=poli_li[i]->GetPointCount();		
		
#ifdef _BLABLA_
		cout<<lines_rows<<" lines with max. "<<lines_cols<<" sgms"<<endl;
#endif
		
		
		XplDouble llcolor(lines_rows, 3), lldashes(lines_rows),
			 llthick(lines_rows);
		XplDouble lines(lines_rows, lines_cols);
		int *indy;
		
		for(i=0; i<lines_rows; i++)
		{	color_number=poli_li[i]->color;
			if (color_number<0 || 
				color_number>all_colors.laenge()-1)
			{	something_false=True;
				color_number=DEFAULT_COLOR;
			}
			llcolor(i,0)=all_colors[color_number]->requested(0,0);
			llcolor(i,1)=all_colors[color_number]->requested(0,1);
			llcolor(i,2)=all_colors[color_number]->requested(0,2);
			lldashes(i)=poli_li[i]->layout;
			llthick(i)=poli_li[i]->thick;
			indy=poli_li[i]->GetIndex();
			for (j=0; j<lines_cols; j++)
				lines(i,j)=(double)(indy[j])+1;
			delete indy;
		}
		o->AppendComponent (new Component 
			(new XplObject( new XplDouble(lines), "lines")));
		o->AppendComponent (new Component 
			(new XplObject ( new XplDouble(llcolor), "lcolor")));
		o->AppendComponent (new Component 
			(new XplObject ( new XplDouble(lldashes), "lstyle")));
		o->AppendComponent (new Component 
			(new XplObject ( new XplDouble(llthick), "lsize")));
	}
	return(o);
  		
}

	




	
