/* $Header: /home/xplore/cvs/xpl4gr/vismat.h,v 1.5 2004/02/18 12:01:12 xplore Exp $ */

#ifndef _VISMAT_H
#define _VISMAT_H

#include "xplmat.h"

extern bool NANorINF(double x);

/* PC MAC */
#if !defined(__BORLANDC__) && !defined(__APPLE_CC__)  //LOOK!
#include <stream.h>           // needed by xreal.hpp
#else
#include <iostream.h>
#endif
#include "xreal.hpp"
typedef XplReal<double> XplDouble;

#include "object.h"
#include "xplio.h"

#include <string.h>	//nur wegen strdup
//#include <stdio.h>

typedef int Outfit;
typedef int Lines_Outfit;

/*	INFO		*/
/*	int color is a number of requested color in allcolors!		*/
/*	int layout is a number of requested layout in alllayouts!	*/

#define COLOR_COUNT 8

/*---------------------POINT_ART----------------------------------------*/
#define POINT_ART_COUNT 16

//	diverse punktdarstellung; attribute von data_part, si. initsym.h


#define SYMBOL_SIZE 8

#ifdef __BORLANDC__  //LOOK!
#define POINT1 		1
#else
#define POINT 		1
#endif

#define NOPOINT 	0
#define RECTANGLE 	2
#define CIRCLE 		3
#define TRIANGLE 	4
#define XSYM 		5
#define RHOMBUS		6
#define FLD_RECTANGLE 	7
#define FLD_CIRCLE 	8
#define FLD_ROMB	9
#define FLD_TRIANGLE 	10
#define CROSS		11
#define STAR		12
#define GRID		13
#define GRID_RHOMBUS	14
			
/*---------------------LINE_ART----------------------------------------*/

//	diverse liniendarstellung; attribute von data_part
#define DEFAULT_LINE_WIDTH 0
#define LINE_ART_COUNT 16

#define NOLINE 0
#define SOLID 1
#define ONOFFDASH 4	//uralt
#define DOUBLEDASH 7	//auch uralt

#define DEFAULT_COLOR 0
#define DEFAULT_SYMBOL 3
#define DEFAULT_SIZE 8
#define DEFAULT_LINE_ART 1
#define DEFAULT_LINE_THICK 0
#define DEFAULT_TEXT_DIR 0
#define DEFAULT_TEXT_SIZE 16

/*	Es sind a und b - dashes; aaaaabbbbbbbbbaaaaabbbbbbbb
	a=1+ (layout-2) / 4;
	b=1+ (layout-2) - ((layout-2)/4)*4= layout-1 - ((layout-2)/4)*4;
*/

inline int ADashOfPolygon(int layout)
//{	return(1+ (layout-2) / 4);	}
{	return( 1 + 4 * (layout-2) );	}

inline int BDashOfPolygon(int layout)
//{	return(layout-1 - ((layout-2)/4)*4);}
//{	return(layout - ((layout-2)/4)*4);}
{ 	return(4 + 2 * (layout-2)  ); }

/*--------------------------------------------------------------------*/

//	MyPolygon ist ein Polygon aus homogene Linien.
//	Bezieht sich auf MyPoint*, d.h. die Koordinaten von Punkt[i]
//	sollen anhand index[i] aus MyPoint gelesen werden

class MyPolygon		{	
	int count;		//	Anzahl der Punkte zum verbinden

	int* index;		//	enthaelt count int
	MyPoint *points;	// enthaelt plot-coord. fuer alle punkte
		
public:	
	int color;		//	ein fuer alle Linien
	int layout;	
	int thick;		//	ein fuer alle Linien
	char * text;		//enthaelt text for polygon (popup!) 

	
//	Konstructor fuer ein Polygon aus ccount linien
	MyPolygon(	int ccount, const int *ind_vec, 
			int co=0, int out=SOLID, 
			int th=1, char *t=NULL);

	MyPolygon(const MyPolygon * mp) ;


	~MyPolygon()
		{	delete index;	
			if (text!=NULL)
			delete text;
			if (points!=NULL)
				delete points;
			if (index!=NULL)
				delete index;
		}
	
	int GetPointCount() const ;	

	int * GetIndex() const ;	//with copy!

	MyPoint * GetPoints() const ;		//with copy!



//	Erstellen einen Array aus Koordinaten fuer z.b. DrawLines
//	MyPoint* VisPointToPolygon(const MyPoint *points) const     ;
	
	void ComputePoints(const MyPoint *points);	

		
};

#define FONTS_TO_LOAD 8
/* 	fonts selbst siehe initgra.C	*/

class XplLabel 	{	char * text;	//default ""
public:
			int color;	//default 0
			int direction; 	//default -1; sonst 0, 3, 6, 9, 12
			int radius; 	//default 0; 
					//spielt by direction=-1, 3 keine Rolle
			MyPoint offset;	//enthaelt x und y von offset

			int font_number;//enthaelt auch size!
			int size;	//spielt noch keine Rolle

	XplLabel(	const char *t=NULL, int co=0,  int di=-1, int rad=0, 
			int fn=0, int s=0);
	XplLabel(const XplLabel & );		
	XplLabel(const XplLabel * );		
	XplLabel& operator=(const  XplLabel & vis);	//Zuweisungsoperator

	~XplLabel();
	int SetText(const char *t);
	char * GetText() const;
};

#define S_AND 	0	//Schnitt
#define S_OR	1	//Vereinigung; last mode
#define S_CLEAR	2	//clear	
#define S_COPY	3	//transient mode
#define S_INVERTED	4


/*--------------------------------------------------------------------*/

class  VisMatrix	{

	XplMatrix mat;
	
	int all_color;
	int all_layout;
	
	int* each_color;
	int* each_layout;
		
	Boolean some_labels;
	Boolean some_lines_labels;

	Liste <MyPolygon *> poli_li;
	
	XplLabel * labels;
	
	char *data_name; //z.b. "x"
	char **column_name;	//default:{"1. column", ...., "10. column"}
//	MyPoint *vis_point;

public:
	
	XplMatrix selected;	//at first two columns; rows=mat.rows; 
				//filled with NULL;
	XplMatrix selmode;	//at first S_COPY

	 VisMatrix(const XplObject & m);	//mit Kopieren von m

	 VisMatrix(XplObject * const var);	//mit Kopieren von var
	
	 VisMatrix(XplDouble & m);	//mit Kopieren von m
					//m sollte const sein!

	 VisMatrix(const  VisMatrix & vis);	//Kopy-Kon
	 
	 VisMatrix& operator=(const  VisMatrix & vis);	//Zuweisungsoperator
		
	 VisMatrix();

	~ VisMatrix();
/*-----------------------------------------------------------------------*/	
			
	int GetPointCount() const;

	void out() const;	

/*-----------------------------------------------------------------------*/	
//	Eine Funktion zum auslesen der i-ter Zeile:::

	XplMatrix &  RealPoint(int i) ;

/*-----------------------------------------------------------------------*/	
//	Eine Funktion zum kopieren des Inhalts:::

	XplMatrix GetContent() const    ;

/*-----------------------------------------------------------------------*/
//	Zwei Funktionen zum Berrechnen der Grenzwerte :
	XplMatrix MinCol() const;

	XplMatrix MaxCol() const;

	XplMatrix Extremum() const;

/*-----------------------------------------------------------------------*/
/*--------------Punkt-Funktionen:----------------------------------------*/

	void SetPointColor(const int color, const int which_point=0);	
	/*	which_point =1...count;				*/
	/*	by which_point==0 all_color is set to this color*/		
	/*	and each_color is set to NULL			*/ 									
	void SetPointColor(const int color, const XplMatrix which_point);	
	/* 	set color for points tjat have 1 in which_point	*/
	/*	you need it for brush!				*/
	/* 	XplMatrix(rows,1) filled with 0 and 1		*/
								
	int GetPointColor(const int which_point=0)	const;
	/*	which_point =1...count;			*/
	/*	by which_point==0 all_color is returned	*/					
	/*-----------------------------------------------------------------------*/

	void SetPointLayout(const int fi, const int which_point=0);	
	/*	which_point =1...count;				*/
	/*	by which_point==0 all_layout is set to this layout*/		
	/*	and each_layout is set to NULL			*/ 													
	int GetPointLayout(const int which_point=0)	const;
	/*	which_point =1...count;			*/
	/*	by which_point==0 all_layout is returned	*/						
	void SetPointLayout(const int color, const XplMatrix which_point);	
	/* 	set layout for points tjat have 1 in which_point	*/
	/*	you need it for brush!				*/
	/* 	XplMatrix(rows,1) filled with 0 and 1		*/

	bool IsHomogen() const;	
	/*-----------------------------------------------------------------------*/
/*--------------Polygon-Funktionen:--------------------------------------*/

	Liste <MyPolygon *> GetPolygons() const;

	int GetPolygonCount() const	
	{	return(poli_li.laenge());	
	}

	void AddPolygon(const int count, const int * some=NULL, 
			int color=1, int fi=1, int thick=1);
	void DeletePolygon(int num=0);	//num=0->delete all lines
	
	void SetPolygonColor(int color=1, int which_poli=0);
	void SetPolygonLayout(int out=1, int which_poli=0);
	void SetPolygonThick(int thick, int which_poli=0);	
	
	int GetPolygonColor(int p_n) const;
	int GetPolygonLayout(int p_n) const;	
	int GetPolygonThick(int p_n) const;	
	
	int * GetPolygonIndex(int p_n) const;    
	//which points; you must delete it later yourself!
	
	int GetPolygonSize(int p_n) const;	//how much points... 

	
/*-----------------------------------------------------------------------*/
/*		Labels							*/

	Boolean SomeLabels() const
	{	return(some_labels);	}
	
	Liste <XplLabel > GetLabels(int i) const;	//i=1, ..., point_count
							//bei i=0 alle labels!
	int SetLabels(const Liste <int>, const Liste <XplLabel> & );

	/* dealing with responding points...*/
	Boolean SomeRespPoints() const;	
	Liste <XplLabel > GetRespLabels() const;	
	Liste <int > GetRespIndex() const;	

	/* dealing with responding polygons...*/
	Boolean SomeRespPolygons() const
	{	return(some_lines_labels);	}
		
	char * GetLineLabel(const int line_number) const;	
	
/*-----------------------------------------------------------------------*/
/*------------------Und noch ein Paar Kleinigkeiten:---------------------*/

	char *GetName()	 const {	return(strdup(data_name));	}	

	char *GetColumnName(int i) const 
				{	return(strdup(column_name[i]));	}

	void SetName(const char *c){	delete []data_name;
					data_name=strdup(c);	}
	void SetColumnName(int i, const char *c);
	
	XplObject * GetXplObject() const;
};
		
#endif
