#include "wdisp.h"
#include "xplwin.h"
#include <owl/printer.h>
#include "printing.h"
#include <owl/textgadg.h>
#include "display.h"
#include "wplot.h"	// PC 20010502
#include "color.h"	// PC 20010502

// localized strings - PC 20010320
#include "wed_strings.h"
#include "xplore_strings.h"

typedef WDisplay* wdp;
typedef wdp* wdpp;

extern int  xpldisplay_width;
extern int xpldisplay_height;
extern int  xpldisplay_left;
extern int xpldisplay_top;
#define FRAME_OFFSET 20

extern Liste <XplSymbol *> all_symbols;		// PC 20010502

//TXploreClient* TXploreClient::Client;
//DEFINE_RESPONSE_TABLE1(WDisplay, TFrameWindow)
DEFINE_RESPONSE_TABLE1(WDisplay, TWindow)
  EV_WM_LBUTTONDOWN,
  EV_WM_LBUTTONUP,	// PC 20010418
  EV_WM_RBUTTONDOWN,	// PC 20010420
  EV_WM_MOUSEMOVE,	// PC 20010418
//  EV_WM_RBUTTONDOWN,
  EV_COMMAND(VK_UP, CmUp),
  EV_COMMAND(VK_DOWN, CmDown),
  EV_COMMAND(VK_LEFT, CmLeft),
  EV_COMMAND(VK_RIGHT, CmRight),

  EV_COMMAND(CM_FILEPRINT, CmFilePrint),
  EV_COMMAND(CM_PRINTITEM1, SaveAsBitmap),
  EV_COMMAND(CM_PRINTITEM2, SaveAsPostscript),
  EV_COMMAND(CM_PRINTITEM3, SaveAsGif),
  EV_COMMAND(CM_DISPTOOLTIP, CmDispToolTips),	// PC 20010420
  EV_COMMAND(CM_COPYITEM1, CopyAsBitmap),	// PC 20020227

  EV_COMMAND(CM_PAINT, CmPaint),
  EV_COMMAND(CM_CHOOSE_COLORS, CmChooseColor),
  EV_WM_SIZE,
  EV_WM_DESTROY,	//SWS 20.11.97

END_RESPONSE_TABLE;

// PC 20010424 - class for displaying tooltips
class MyControl : public TControl
{
private:
     TRect tiprect;		// rect for tooltip
     TRect client;	// client area of parent window
#define MYCONTROL_TEXT_LENGTH 1024
     char text[MYCONTROL_TEXT_LENGTH];
     bool sizeset;

public:
     MyControl(TWindow* parent, int id, const char far* title, int x, int y, int w, int h);

     void Paint(TDC& dc, bool erase, TRect& rect);
};

     MyControl::MyControl(TWindow* parent, int id, const char far* title, int x, int y, int w, int h)  : TControl(parent, id, title, x, y, w, h)
     {
          strncpy(text, title, MYCONTROL_TEXT_LENGTH-1);
          text[MYCONTROL_TEXT_LENGTH-1] = '\0';

          client = parent->GetClientRect();

          tiprect.SetWH(x,y,w,h);
          sizeset=false;
     }

     void MyControl::Paint(TDC& dc, bool erase, TRect& rect)
     {
          // settings
          dc.SetTextColor(GetSysColor(COLOR_INFOTEXT));
          dc.SetBkColor(GetSysColor(COLOR_INFOBK));
          dc.SelectStockObject(ANSI_VAR_FONT);

          // find the size of window
          if (!sizeset)
          {
         		TRect temprect = tiprect;
               char *pomuk = strchr(text, '\n');
               bool isspace = true;

               // get size of tooltip
               if (pomuk)
               {
                    *pomuk = '\0';
                    dc.DrawText(text, -1, temprect, DT_CALCRECT);
                    *pomuk = '\n';
               }
               dc.DrawText(text, -1, temprect, DT_CALCRECT);

               tiprect.SetWH(tiprect.left, tiprect.top, temprect.Width() + 4, temprect.Height() + 4);

               // adjust position so that it fits to the window
					if (tiprect.Width() + 2 >= client.Width())
               {
               	tiprect = tiprect.MoveTo(client.left+1, tiprect.top);
                  isspace = false;
               }
					if (tiprect.Height() + 2 >= client.Height())
               {
               	tiprect = tiprect.MoveTo(tiprect.left, client.top+1);
                  isspace = false;
               }

               if (isspace)
               {
               	int offx = 0, offy = 0;
               	if (tiprect.Right() >= client.Right())
                  	offx = client.Right() - 1 - tiprect.Right();
               	if (tiprect.Bottom() >= client.Bottom())
                  	offy = client.Bottom() - 1 - tiprect.Bottom();
                  if (offx || offy)
                  	tiprect = tiprect.OffsetBy(offx, offy);
               }

               this->SetWindowPos(NULL, tiprect, SWP_NOACTIVATE | SWP_NOZORDER | /* SWP_NOMOVE | */ SWP_SHOWWINDOW | SWP_DRAWFRAME);
               sizeset = true;
          }

          // draw text
          rect.SetWH(rect.left, rect.top, tiprect.Width(), tiprect.Height());
          dc.DrawText(text, -1, rect, DT_VCENTER);
     }

static MyControl *tooltipwin = NULL;
// end of tooltip class


int WDisplay::doAll=1;
//typedef (TPlot*) PlotP;
//typedef (TPlot**) PlotPP;

extern TApplication *myapp;

WDisplay::WDisplay(const WDisplay *old):XplDisplay(old),TWindow(0,0,0)          //SVEN
{
}

WDisplay::WDisplay(XplDouble hori, XplDouble veri):
		XplDisplay(hori, veri), TWindow(0, 0, 0)
      {

	type=WDISPLAY;
 //  AssignMenu(IDM_DISPLAY);

/*	Attention!							*/
/*	After the XplDisplay(hori, veri) the WDisplay contents	*/
/*	already some Plots!						*/

  	int all=veri.dimension(1)*hori.dimension(1);
	SelPlot = all;
	for (int i=0; i<all; i++)
		delete (Plot *)(content[i]);



/*	Don't forget to build your grafic extension anywhere...		*/
  //	SelPlot=TPoint(I,J);

  	 Attr.AccelTable = "XPLOREDISP";

    Printer=new TPrinter;
    child = new TMDIChild(*TXploreClient::Client, XMSG_DISPLAY_WIN_CAPTION_STR, this);
 // Tdisplay->mdiChild = child; // need it to activate display
 /*
 labelchild=new TMDIChild(*TXploreClient::Client,"HIHI", this);
          labelchild->Create();
          	labelchild->Attr.X=100;
   	labelchild->Attr.Y=200;
   	labelchild->Attr.W=400;
   	labelchild->Attr.H=500;
      //labelchild->ShowWindow(SW_SHOW);
   */

		child->SetMenuDescr(TMenuDescr(IDM_DISPLAY,0,0,0,1,0,0));
      child->SetIcon(myapp, AAA32);
      child->SetIconSm(myapp, AAA32);
      
   	child->Attr.W=xpldisplay_width + 2*GetSystemMetrics(SM_CXEDGE) + GetSystemMetrics(SM_CXSIZEFRAME); //8;
   	child->Attr.H=xpldisplay_height  + 2*GetSystemMetrics(SM_CYEDGE) + GetSystemMetrics(SM_CYSIZEFRAME) + GetSystemMetrics(SM_CYCAPTION); //+FRAME_OFFSET+7;
        // Pc 20021031 - added user-set default position
      if (TXploreClient::Client)		// PC 20011213 - changed the default position
      {
      	TRect clientrect = TXploreClient::Client->GetClientRect();

         if (xpldisplay_left < 0)
     	   	child->Attr.X = (clientrect.Width() - child->Attr.W) / 2;
         else
     	   	child->Attr.X = xpldisplay_left;
         if (child->Attr.X < 0) child->Attr.X = 0;

         if (xpldisplay_top < 0)
   	      child->Attr.Y = (clientrect.Height() - child->Attr.H) / 2;
         else
     	   	child->Attr.Y = xpldisplay_top;
			if (child->Attr.Y < 0) child->Attr.Y = 0;
      }
      else
      {
     	  child->Attr.X=200;
   	  child->Attr.Y=100;
      }
  		child->Create();

      tooltips = false;	// PC 20010420
}

WDisplay::~WDisplay()
{
	//delete dc;
   int all, i, j, k;
	all=vertical.cols()*horizontal.cols();
	SubType st;
   delete Printer;

	for (i=0; i<all; i++)
	{	st=content[i]->WhatIs();
		switch(st)
		{	case WPLOT:	delete (WPlot *)(content[i]);
				break;
			case PLOT:   delete (Plot *)(content[i]);
				break;
         case WTEXT:   delete (WText *)(content[i]);
				break;

/*	what else You must know it better...			*/

			default:
            delete (content[i]);
				break;
		}
	}

  //delete child;
  	k=0;

	Plot *up;

	for (j=0; j<vertical.cols(); j++)
	for (i=0; i<horizontal.cols(); i++)
	{	up=new Plot(this, j+1, i+1);
		content[k]=up;
		k++;
	}
/*	Don't forget to destroy your grafic extension anywhere...	*/
/*	Attention! Now the XplDisplay::~XplDisplay  comes!		*/
}

void WDisplay::SaveAsPostscript()
{TOpenSaveDialog::TData data (
    OFN_HIDEREADONLY|OFN_FILEMUSTEXIST|OFN_NOREADONLYRETURN,
    XMSG_PS_FILE_FILTER_STR,
    0,
    "",
    "PS"
  );
  if (TFileSaveDialog(this, data).Execute() == IDOK) {
    char fileTitle[256];
    TOpenSaveDialog::GetFileTitle(data.FileName, fileTitle, 256);
  Print(data.FileName);
  }
}

void WDisplay::SaveAsGif()
{cout<<"sorry, not implemented..."<<endl;}

void WDisplay::SaveAsBitmap()
{  TOpenSaveDialog::TData data (
    OFN_HIDEREADONLY|OFN_FILEMUSTEXIST|OFN_NOREADONLYRETURN,
    XMSG_BITMAP_FILE_FILTER_STR,
    0,
    "",
    "BMP"
  );
  if (TFileSaveDialog(this, data).Execute() == IDOK) {
    char fileTitle[256];
    TOpenSaveDialog::GetFileTitle(data.FileName, fileTitle, 256);

   TWindowDC *wdc= new TWindowDC(((TWindow *)this)->HWindow);
  	TBitmap bm(*wdc, width, height);
   TMemoryDC tmdc(bm);

   TRect bb;                                                                    // SVEN
   GetClientRect(bb);
   Paint(tmdc, false, bb);

   //tmdc.BitBlt(5, 5, width, height, *wdc, 0, 0, SRCCOPY);
	TDib Dib(bm, 0);
   Dib.WriteFile(data.FileName);
   }
}

// PC 20020227 - copy bitmap to clipboard
void WDisplay::CopyAsBitmap()
{
   TClipboard clip(((TWindow *)this)->HWindow);

   if (!clip.EmptyClipboard())
   {
 		globalError.Set (ERR_INTERN, MSG_ERROR_CLIPEMPTY_STR);
		globalError.ShowError();
      return;
   }

   TWindowDC *wdc= new TWindowDC(((TWindow *)this)->HWindow);
   TBitmap bm(*wdc, width, height);
   TMemoryDC tmdc(bm);

   TRect bb;                                                                    // SVEN
   GetClientRect(bb);
   Paint(tmdc, false, bb);

   TDib Dib(bm, 0);
   Dib.ToClipboard(clip);
   clip.CloseClipboard();
}

// PC 20010420
void WDisplay::CmDispToolTips()
{
	tooltips = ! tooltips;
   if (!tooltips && tooltipwin) // is there a tooltip window open?
     {
          // tooltipwin->Destroy();
          delete tooltipwin;
          tooltipwin = NULL;
     }
}

void WDisplay::CmFilePrint()
{ if (!Printer)
	return;
   TWindowPrintout printout(XplDisplay::name, this);
    //
    // Using OWL's banding support under Win95 _when_ the EXE's marked 4.0
    // (under Options|Project|Linker|General) will cause the print to fail.
    //
    if(!TSystem::IsWin95())
      printout.SetBanding(true);

    Printer->Print(this, printout, true);
}

void WDisplay::DoWinResize(int width, int height)
{
  int w = width + 2*GetSystemMetrics(SM_CXEDGE) + GetSystemMetrics(SM_CXSIZEFRAME);
  int h = height + 2*GetSystemMetrics(SM_CYEDGE) + GetSystemMetrics(SM_CYSIZEFRAME) + GetSystemMetrics(SM_CYCAPTION);

  TWindow *toresize = this->GetParentO();
  toresize->SetWindowPos(0, 0, 0, w, h, SWP_DRAWFRAME | SWP_NOCOPYBITS | SWP_FRAMECHANGED | SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOZORDER | SWP_SHOWWINDOW );
}

void WDisplay::DoWinPosition(int left, int top)
{
  TWindow *tomove = this->GetParentO();
  tomove->SetWindowPos(0, left, top, 0, 0, SWP_DRAWFRAME | SWP_NOCOPYBITS | SWP_FRAMECHANGED | SWP_NOACTIVATE | SWP_NOSIZE | SWP_NOZORDER | SWP_SHOWWINDOW );
}

int WDisplay::GetWinWidth()
{
  TWindow *toget = this->GetParentO();
  TRect rect;
  toget->GetWindowRect(rect);
  return (rect.right - rect.left);
}

int WDisplay::GetWinHeight(void)
{
  TWindow *toget = this->GetParentO();
  TRect rect;
  toget->GetWindowRect(rect);
  return (rect.bottom - rect.top);
}

int WDisplay::GetWinLeft()
{
  TWindow *toget = this->GetParentO();
  TWindow *parent = toget->GetParentO();
  TRect rect;
  toget->GetWindowRect(rect);
  TPoint p(rect.left, rect.top);
  parent->ScreenToClient(p);
  return (p.x);
}

int WDisplay::GetWinTop()
{
  TWindow *toget = this->GetParentO();
  TWindow *parent = toget->GetParentO();
  TRect rect;
  toget->GetWindowRect(rect);
  TPoint p(rect.left, rect.top);
  parent->ScreenToClient(p);
  return (p.y);
}

void WDisplay::SetElement(const Liste <XplObject *> * data_list,
		int di_x, int di_y)
{	int rows, cols;
	rows=vertical.cols();
	cols=horizontal.cols();
	if (di_x<1 || di_y<1 || di_x>rows || di_y>cols )
	{

		globalError.Set (ERR_INTERN, XMSG_SETELEMENT_ERROR_STR);
		globalError.ShowError();
		return;
	}
	int num, i, text_lines;


	SubDisplay *sd;

	sd=content[cols*(di_x-1)+di_y-1];
 /*
 	int st=sd->WhatIs();
		switch(st)
		{	case WPLOT:	delete (WPlot *) sd;
				break;
			case PLOT:   delete (Plot *) sd;
			break;
         case WTEXT:   delete (WText *) sd;
				break;

			default:
            delete sd;
				break;
		}
  */
  delete sd;
	content[cols*(di_x-1)+di_y-1]=NULL;
	SubDisplay *p;

	p=NULL;

	if ( (*(*data_list)[0])[0]->Type ()== O_XPLDOUBLE ||
		(*data_list)[0]->GetComponent("data")!=NULL)
	{	p=new WPlot(data_list, this, di_x, di_y);
		p->Refresh();
	}

/*	Think at following lines too:				*/
/*--------------------------------------------------------------*/
if ( p==NULL && (*data_list)[0]->Type () == O_XPLCHAR)
	{	char *line, string[32555];
		string[0]=0;
		text_lines=(*data_list)[0]->DefaultComponent()
			->Content().xplchar->dimension(0) ;
		for (i=0; i<text_lines; i++)
		{	char *line=(*((*data_list)[0]->DefaultComponent()
			->Content().xplchar) )(i).tostr();	//OK!
			strcat(string, line);
			delete line;
			strcat(string, "\n");
		}

		p=new WText(string, this, di_x, di_y);
	}
/*--------------------------------------------------------------*/

	if (p==NULL)
	{	globalError.Set (ERR_INTERN, XMSG_SETELEMENT_WRONG_STR);
		globalError.ShowError();
		p=new WPlot(this, di_x, di_y);
	}

	content[cols*(di_x-1)+di_y-1] = p;
 //  cout<<SelPlot<<" oder "  <<cols*(di_x-1)+di_y-1<<endl;
   
   if (SelPlot==  cols*(di_x-1)+di_y-1)
   	((WPlot*)p)->selected=true;
}

void WDisplay::SetName(const char * newname)
{	XplDisplay::SetName(newname);
	TWindow::SetCaption(newname);     //SWS 20.11
	TWindow::SetDocTitle(newname, 0);

/*	here you must make your name visible 			*/
}

//***************************************************
// WIndows functions


void
WDisplay::SetupWindow() {
  //TWindow::SetupWindow();
  TWindow::SetupWindow();
  //dc = new TWindowDC(((TWindow *)this)->HWindow);
/*	Now it is your turn....						*/

//	WPlot *wp;

	int k=0;

	for (int j=0; j<GetRows(); j++)
	for (int i=0; i<GetColumns(); i++)
	{
		content[k++]=new WPlot(this, j+1, i+1);
	}
  // TMDIChild *ed = new TDisplayWindow(*MainCl,"Display: ", (TWindow *) this);

 //	ed->SetMenuDescr(TMenuDescr(200, 1, 2, 0, 0, 0, 0));

	 //editor->SetIcon(this, IDI_DOC);

//	 TMDIChild* curChild = this->GetActiveMDIChild();
 //	 if (curChild && (curChild->GetWindowLong(GWL_STYLE) & WS_MAXIMIZE))
  //	 editor->Attr.Style |= WS_MAXIMIZE;

  //	 ed->Create();
  // SetMenuDescr(TMenuDescr(IDM_DISPLAY, 1, 0, 0, 0, 0, 0));
  // DrawMenuBar();
 	 //SetMenu(TMenu(, 200));

	 //Create();

/*  for (int ii=0; ii<I; ii++) {
  for (int jj=0; jj<J; jj++) {
  plot[ii][jj]= new TPlot(this, ii, jj);
  }
  }
  */

 //  	child->Attr.W=xpldisplay_width+7;
 //  	child->Attr.H=xpldisplay_height+FRAME_OFFSET+7;
 //     cout<<(int) xpldisplay_width<<", xdh="<<(int)( xpldisplay_height+FRAME_OFFSET)
  //    <<endl;
      }

extern bool isrunning;

void WDisplay::EvDestroy()         //SWS 20.11.97
{	if (isrunning)
   	globalError.Set(ERR_ARGS, "na und?");
   	
	XplDisplay *di=(XplDisplay *)this;
	int removed=RemoveDisplay (GetXplObject(di));

 /*	if (removed==TRUE)
		cout<<"removed=TRUE\n";
	else
		cout<<"removed=FALSE\n";
*/
}

bool WDisplay::CanClose()
{	if (isrunning)
  {	cerr<<"sorry, you cannot close it now"<<endl;
   return(false);
   }
   return(true);
}

void
WDisplay::EvSize(UINT sizeType, TSize& size) {
  TWindow::EvSize(sizeType, size);
  if (size.cx>5 && size.cy>5)        // only if not to icon!
{  		XplDisplay::Resize(size.cx, size.cy);

}
//else

  //doAll=1; // to paint the whole display


  Invalidate();
}

void
WDisplay::Paint(TDC& DC, bool, TRect& bb ) {

  DC.SaveDC();
//   cout<<"PAINT!"<<endl;
   RefreshAll(bb.left,bb.top,bb.right,bb.bottom, &DC);
    DC.RestoreDC();

}

// don't need it yet
void
WDisplay::PaintDisplay(TWindowDC*, bool, TSize&) {
//RefreshAll();
}

// Paints a plot (without stretching)
void
WDisplay::RefreshAll(int ax, int ay,int bx,int by, TDC *tdc) {
	int all=vertical.cols()*horizontal.cols();
	TRect trec(ax, ay, bx, by);
   TRect *plotrec;
   TRect result;
   SubType st;
	for (int j=0; j<all; j++)
	{	st=content[j]->WhatIs();
   	switch (st)
   	{	case WPLOT:
         plotrec= new TRect(  ((WPlot *)(content[j]))->delX,
						((WPlot *)(content[j]))->delY,
						((WPlot *)(content[j]))->delX+content[j]->GetWidth(),
						((WPlot *)(content[j]))->delY+content[j]->GetHeight());
			result=trec&(*plotrec);
		  	if (!(result.IsNull()) && content[j]->WhatIs()==WPLOT)
			/*	((WPlot *)(content[j]))->repaint_part(
						result.Left(),
							result.Top(),
							result.Width(), result.Height(), tdc);
			 */
          ((WPlot *)(content[j]))->repaint_part(
						((WPlot *)(content[j]))->delX,
                  ((WPlot *)(content[j]))->delY,
						((WPlot *)(content[j]))->delX+content[j]->GetWidth(),
						((WPlot *)(content[j]))->delY+content[j]->GetHeight(), tdc);

        	delete plotrec;
         break;
        	case WTEXT:
         ((WText *) (content[j]))->Refresh(tdc);
        		break;
        	default:
                  	content[j]->Refresh();
      }
  }



 // if (SelPlot.x<I) plot[SelPlot.x][SelPlot.y]->paint(0);
//  doAll=0;

}
//determines, wether 2 rectangles are overlapping or not
int WDisplay::Ueberlappt(int ax,int ay,int bx,int by,
											 int cx,int cy,int dx,int dy) {
	if (bx<cx || ax>dx || by<cy || ay>dy) return 0; else return 1;
}
// Selects a TPlot by clicking the left mouse button and
// unselects the old one (with index SelPlot)
void
WDisplay::EvLButtonDown(UINT, TPoint& point)
{
	int all = GetColumns() * GetRows() - 1;
   WPlot *pl;
 	int x, y;
   x=point.x;
   y=point.y;
   char line[256];
   sprintf(line, "x=%d\ny=%d", x, y);
  /* TStatic *tega=new TStatic(this, 700, "hoho", x, y, 100, 100, 256);
   tega->Attr.Style &=~SS_LEFT;
   tega->SetText(line);
  */
 //  cout<<line<<endl;


 	for (int ii=0; ii <= all; ii++){
      if (content[ii]->WhatIs() == WPLOT) {
      	pl = (WPlot*) content[ii];
		 	if ((pl->delX <= point.x) && (pl->delX + pl->getWidth() > point.x) &&
   	  		(pl->delY <= point.y) && (pl->delY + pl->getHeight() > point.y)) {
      		if (SelPlot != ii) {
         		if (SelPlot <= all) {
           			((WPlot*)content[SelPlot])->selected = false;
               	((WPlot*)content[SelPlot])->paint(0);
					}
					SelPlot = ii;
					((WPlot*)content[SelPlot])->paint(0);
	      	}
  	      	pl->selected = true;
            pl->mousedown = true;	// PC 20010418
            pl->lastpoint = point;	// PC 20010418

		 		break;
 			}
      }
	}
   SetCapture();	         // PC 20010418

   TClientDC dc(*this);

/* TMDIChild *labelchild=new TMDIChild(*TXploreClient::Client,"HIHI", this);
          labelchild->Create();
          	labelchild->Attr.X=child->Attr.X+x;
   	labelchild->Attr.Y=child->Attr.Y+y;
   	labelchild->Attr.W=100;
   	labelchild->Attr.H=100;
      //labelchild->ShowWindow(SW_SHOW);
     //dc.TextOut(x, y, line, strlen(line));
*/
}

// PC 20010420
// RMB invokes context menu
void WDisplay::EvRButtonDown(UINT, TPoint&point)
{
  TPopupMenu cmenu;

  // construct menu
  cmenu.AppendMenu(MF_ENABLED, CM_COPYITEM1, XMSG_DISPPOP_COPYTOCLIP_STR);
  cmenu.AppendMenu(MF_ENABLED | MF_SEPARATOR);
  cmenu.AppendMenu(MF_ENABLED, CM_FILEPRINT, XMSG_DISPPOP_PRINT_STR);
  cmenu.AppendMenu(MF_ENABLED, CM_PRINTITEM1, XMSG_DISPPOP_BITMAP_STR);
  cmenu.AppendMenu(MF_ENABLED, CM_PRINTITEM2, XMSG_DISPPOP_POSTSCRIPT_STR);
  cmenu.AppendMenu(MF_ENABLED | MF_SEPARATOR);
  cmenu.AppendMenu(tooltips ? MF_ENABLED | MF_CHECKED : MF_ENABLED, CM_DISPTOOLTIP, XMSG_DISPPOP_TOOLTIP_STR);

  // display menu
  ClientToScreen(point);
  cmenu.TrackPopupMenu(TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point, 0, *this);
}

// PC 20010418
// Clear active plot mousedown flag
void
WDisplay::EvLButtonUp(UINT , TPoint& point)
{
	int all = GetColumns() * GetRows() - 1;
   WPlot *pl;

   ReleaseCapture();	         // PC 20010418

 	for (int ii=0; ii <= all; ii++){
      if (content[ii]->WhatIs() == WPLOT) {
      	pl = (WPlot*) content[ii];
      	if (pl->selected && pl->mousedown)
         {
            pl->mousedown = false;
				MouseRotate(pl->lastpoint, point);
  			   pl->paint(0);
 			}
         pl->mousedown = false;
      }
	}
}

// PC 20010418
// Rotate graph
int WDisplay::MouseRotate(TPoint &lastpoint, TPoint &actpoint)
{
#define MOUSE_ROTATE_STEP	 5
  int i, dif, num, ret = 0;

  dif = actpoint.x - lastpoint.x;
  num = abs(dif) / MOUSE_ROTATE_STEP;

  if ((dif > 0) && (num > 0))
  {
    ret = 1;
    for(i = 0; i < num; i++)
      CmRight();
  }

  if ((dif < 0) && (num > 0))
  {
    ret = 1;
    for(i = 0; i < num; i++)
      CmLeft();
  }

  dif = actpoint.y - lastpoint.y;
  num = abs(dif) / MOUSE_ROTATE_STEP;

  if ((dif > 0) && (num > 0))
  {
    ret = 1;
    for(i = 0; i < num; i++)
      CmUp();
  }

  if ((dif < 0) && (num > 0))
  {
    ret = 1;
    for(i = 0; i < num; i++)
      CmDown();
  }

  return ret;
}

// PC 20010418
// Rotate graph by mouse
void WDisplay::EvMouseMove(uint modKeys, TPoint& point)
{
     int all = GetColumns() * GetRows() - 1;
     WPlot *pl;

     for (int ii=0; ii <= all; ii++){
          if (content[ii]->WhatIs() == WPLOT) {
               pl = (WPlot*) content[ii];
               if (pl->selected && pl->mousedown)
               {
                    if (MouseRotate(pl->lastpoint, point))
                         pl->lastpoint = point;
                    return;   // nothing else to do
               }
          }
     }

     // should we display tooltips?
	  if (!tooltips) return;

     // no rotation - check whether tooltips should be shown
     static char string[MYCONTROL_TEXT_LENGTH + 4];
     static TPoint tp;   // last point

     char pomstr[MYCONTROL_TEXT_LENGTH + 4];
     bool showtext = false;

     if ((tp.x == point.x) && (tp.y == point.y))  // position changed?
          return;
     tp = point;

     if (tooltipwin) // is there a tooltip window open?
     {
          // tooltipwin->Destroy();
          delete tooltipwin;
          tooltipwin = NULL;
     }

     // create text
     *string = '\0';
     // format : Data #set/#point [x, y{, z}]
#define TT_DATA_3D_FORMAT "Data %d/%d [%.2G %.2G %.2G]\n"
#define TT_DATA_2D_FORMAT "Data %d/%d [%.2G %.2G]\n"

// search plot
	pl = NULL;
 	for (int ii=0; ii <= all; ii++)
   {
      if (content[ii]->WhatIs() == WPLOT)
      {
      	pl = (WPlot*) content[ii];
		 	if ((pl->delX <= point.x) && (pl->delX + pl->getWidth() > point.x) &&
   	  		(pl->delY <= point.y) && (pl->delY + pl->getHeight() > point.y))
            {	// we have found the plot we are in
		 			break;
	      	}
         pl = NULL;	// pl was not the correct one
      }
	}
   if (pl == NULL) return;	// no plot found

	  // search data points in plot pl
     MyPoint *points;
  	  int i, j, k, p_co;
     Outfit homo_outfit;
  	  int homo_size, homo_halb, centerx, centery;

     points = pl->GetPointKoord();
   for (j = 1; j <= pl->GetDataCount(); j++)
   {
      p_co = pl->GetPointCount(j);
      for(k = 1; k <= p_co; k++)
      {
      	// get size of point
			homo_outfit = pl->GetPointLayout(j,k);
         if (homo_outfit<2)
         	homo_size=1;
         else
       	{
         	homo_size=all_symbols[homo_outfit-2]->size;
            homo_outfit=all_symbols[homo_outfit-2]->symbol;
         }
         homo_halb=(int)((homo_size+1)/2);
         // PC 20020227 - min radius should be 4
         if (homo_halb < 4) homo_halb = 4;

         // homo_halb contain now the size/2 of the object
         // check whether the point is under mouse
         centerx = pl->delX + points->x;
         centery = pl->delY + points->y;
         if ( (abs(tp.x - centerx) <= homo_halb) &&
              (abs(tp.y - centery) <= homo_halb) )
         {
         	XplMatrix realpoint = pl->RealPoint(j,k-1);
            int dim = realpoint.cols();	// row is just one
            double rpx, rpy, rpz;

            if (dim < 2) continue;
            rpx = realpoint(0,0);
            rpy = realpoint(0,1);
            if (dim > 2)
            {
            	rpz = realpoint(0,2);
         		sprintf(pomstr, TT_DATA_3D_FORMAT, j, k, rpx, rpy, rpz);
            }
            else
            {
         		sprintf(pomstr, TT_DATA_2D_FORMAT, j, k, rpx, rpy);
            }

            if (MYCONTROL_TEXT_LENGTH > strlen(string) + 2)
            	strncat(string, pomstr, MYCONTROL_TEXT_LENGTH - strlen(string));
            showtext = true;
         }

         // go to next point
         points++;
      }
   }


     // is there any text to show?
     if (!showtext) return;

     // remove last EOL
     k = strlen(string);
     if (k > 0)
     		if (string[k-1] == '\n')
         	string[k-1] = '\0';

     // open win
     // ClientToScreen(point);
     tooltipwin = new MyControl(this, 0, string, point.x, point.y + GetSystemMetrics(SM_CYCURSOR) + 2, 1, 1);
     tooltipwin->SetStyle(tooltipwin->GetStyle() | WS_BORDER /* | WS_POPUP*/);
     tooltipwin->SetBkgndColor(GetSysColor(COLOR_INFOBK));

     // open window
     tooltipwin->Create();
}

void WDisplay::CmUp () {
 // cout<<"UP"<<endl;
  int all=GetRows()*GetColumns();
//  CmFilePrint();
  for (int i=0; i<all; i++)
     {
     if ((content != NULL) && content[i]->WhatIs()==WPLOT &&
			   (((WPlot *)content[i])->selected) &&
           ((Plot *)content[i])->GetRotationCosinus().rows()>2)
        					   			((WPlot *)content[i])->RotateUp();
        //  else
        //   cout<<i+1 <<" plot: kann nicht drehen!"<<endl;

    /*if ((content != NULL) && content[i]->WhatIs()==WPLOT )
            cout<<i+1 <<" (content != NULL) && content[i]->WhatIs()==WPLOT "<<endl;
    else   cout<<i+1 <<" nix mit (content != NULL) && content[i]->WhatIs()==WPLOT "<<endl;
          if (((WPlot *)content[i])->selected)
           cout<<" selected"<<endl;
                    else
           cout<<" nix selected"<<endl;
          if (((Plot *)content[i])->GetRotationCosinus().rows()>2)
                    cout<<" more than 2"<<endl;
                             else
                    cout<<" 3 or less"<<endl;

          */
         }
}

void WDisplay::CmDown () {
  //cout<<"DOWN"<<endl;
  int all=GetRows()*GetColumns();
  for (int i=0; i<all; i++)
      if ((content != NULL) && content[i]->WhatIs()==WPLOT &&
			   (((WPlot *)content[i])->selected) &&
           ((Plot *)content[i])->GetRotationCosinus().rows()>2)
      					   			((WPlot *)content[i])->RotateDown();
}
void WDisplay::CmLeft () {
  //cout<<"LEFT"<<endl;
  int all=GetRows()*GetColumns();
  for (int i=0; i<all; i++)
      if ((content != NULL) && content[i]->WhatIs()==WPLOT &&
			   (((WPlot *)content[i])->selected) &&
           ((Plot *)content[i])->GetRotationCosinus().rows()>2)
      					   			((WPlot *)content[i])->RotateLeft();
}
void WDisplay::CmRight () {
  //cout<<"RIGHT"<<endl;
  int all=GetRows()*GetColumns();
  for (int i=0; i<all; i++)
      if ((content != NULL) && content[i]->WhatIs()==WPLOT &&
			   (((WPlot *)content[i])->selected) &&
           ((Plot *)content[i])->GetRotationCosinus().rows()>2)
      					   			((WPlot *)content[i])->RotateRight();

}

// Adjust default colors of a current (selected) plot.
void
WDisplay::CmChooseColor()
{
  static TColor custColors[16] =
  {
	 0x010101L, 0x101010L, 0x202020L, 0x303030L,
	 0x404040L, 0x505050L, 0x606060L, 0x707070L,
	 0x808080L, 0x909090L, 0xA0A0A0L, 0xB0B0B0L,
	 0xC0C0C0L, 0xD0D0D0L, 0xE0E0E0L, 0xF0F0F0L
  };

  ColorData.Flags = CC_RGBINIT;
  ColorData.Color = TColor(0,0,0);
  ColorData.CustColors = custColors;
//  *ColorData.Color = 0;
  if (TChooseColorDialog(this, ColorData).Execute() == IDOK) {
	 /*	if (SelPlot.x<I) {
		  plot[SelPlot.x][SelPlot.y]->pColor[0]=ColorData.Color;
		  plot[SelPlot.x][SelPlot.y]->paint(1);

		} else {
			 for (int ii=0; ii<I; ii++) {
			 for (int jj=0; jj<J; jj++) {
				 plot[ii][jj]->pColor[0]=ColorData.Color;
			 plot[ii][jj]->paint(1);
			 }
			 }
		}
		*/
  }
}

// don't need this function at all!
void
WDisplay::CmPaint() {
//cout<<"PAINT?"<<endl;
//TWIndowDC dc2(HWindow);

}


