/*
 * BDT-Dispatch.c       modul s hlavni funkci pro rozbor a zpracovani zprav
 */

#define BDT_DISPATCH_C

#include "wed_editor.h"
/*** Modify Start : d-tec  ***/
#include <mbctype.h>
/*** Modify End : d-tec  ***/



// fills indent_buffer with white_spaces from the beginning of para
// buffer has length at least maxlen
// returns the number of filled characters
ULONG GetIndentBuffer(Paragraph *para, UBYTE *indent_buffer, ULONG maxlen)
{
     MemoryBlock *mb = para->block_first;
     ULONG off = para->off_first;
     ULONG pos;
     UBYTE *line;

     for(pos = 0, line = GetPosMB(mb, off); NOT ENDLINE(*line) && (pos + 1 < maxlen); pos++, line = IncrementPosMB(&mb, &off))
          if ((*line == CH_SPACE) || (*line == CH_TAB))
               indent_buffer[pos] = *line;
          else break;

     indent_buffer[pos] = '\0';

     return pos;
}

// definice tykajici se dontdraw modu
#define DELAY_AFTER_DONTDRAW  6    // musi byt mensi nez nejmensi pocet cursor ticks
#define MAX_TOLERATE_CHARS    2
#define DELAY_BEFORE_RELFORMAT     50

/* hlavni funkce tohoto modulu - provede akce ze seznamu zprav Commands */
/* navratova hodnota urcuje, zda se ma jiz BDT ukoncit ci ne */
// pri zpracovani zprav od ARexxu muze menit result!
// pkoud je zadano mistart - zacne se od neho a provede se to jenom jednou!
// musi to byt ukazatel do pole a alespon jeden prvek za nim!
// nasledujici je pak ukoncen COMM_Dummy
//   --- not valid anymore, just one command is processed at time
BOOL DispatchMessages(TEditFile *teditfile, Command comm, UWORD code, APTR address, BOOL blockqual)
//BOOL DispatchMessages(LONG *result, MessageItem *mistart)
// new parameters:
// doc - description of the edited file (structure EditFile)
// comm - command to be executed
// code - data for command (code of key etc.)
// address - ptr to data
// blockqual - qualifier for block selection pressed (TRUE) ... for cursor movements
// new return value
//		TRUE - send WM_PAINT to redraw the window

//>>
{
     EditFile *doc = teditfile->GetEditFile();

     BOOL send_paint = FALSE;	// has to be adjusted - only TRUE when something is drawn!

// definice pro ticks mode ...
#define CURSOR      1
#define HORIZLEFT   2
#define HORIZRIGHT  3
#define VERTUP      4
#define VERTDOWN    5
//     static ticks_mode = CURSOR;
//     static ignore_outofRAM = FALSE;

     EditFile *act_doc, *pomdoc;
     Location loc, loc1, loc2, l1, l2, setcursor_oldcursor_location;
//     MessageItem *mi;
     Command act_comm = SPEC_NoneOperation, orig_act_comm;

     Paragraph *parapom;

     LONG i;
     UBYTE *pomstrptr;
     ULONG menu_refresh, gadget_refresh; // urcuje, zda se ma aktualizovat nastaveni gadgetu a menu, popr. i co
     ULONG old_num_pages, specid, pomulong, pomulong2;
     ULONG undo_data;
//     ULONG macro_data1;
//     APTR macro_data2;
     UWORD prikaz, co, val, pomuword;
     UWORD new_undo;
//     BOOL record_macro, record_next_macro = TRUE;
     BOOL enddispatch = FALSE;     // urcuje, zda se maji preskocit dalsi zpravy ve fronte
          // (napr. pro situace, kdy se okna editoru zavrela apod.)
     BOOL check_cursor;  // urcuje, zda se ma kontrolovat, je-li kurzor videt
     BOOL refresh_rooler;// urcuje, zda obnovit symboly na pravitku ...
//     BOOL del_new_ts;    // urcuje, zda se ma smazat novy TextStyle
     BOOL pombool;       // pomocna promenna
     BOOL pombool2;      // pomocna promenna
//     BOOL blockqual;     // kvalifikator bloku stisknut
//     BOOL newtextstyle;  // urcuje, zda byl pridan novy styl
     UBYTE buffer[/* MAXCOMMANDS + */ MAXWORDLEN + 8], *l, pomznak, *pomuk;    // na leccos ...
     UBYTE indent_buffer[MAXWORDLEN + 4];
     BOOL dontdraw = FALSE;      // urcuje, zda se nemusi prekreslovat obrazovka
     BOOL actdoc_changes;     // pamatuje si stav changes

     UWORD num_commands;
//     UWORD baknumcommands = num_commands;    // zaloha

// invalidate variables
     BOOL invalidate1, invalidate2, invalidate_erase1, invalidate_erase2;
     unsigned invalidate_offset1, invalidate_offset2;
     long invalidate_lines1, invalidate_lines2;
     
     num_commands = 1;
//     if (mistart) num_commands = 1;

/* hlavni smycka */
for( /* mi = (mistart) ? mistart : commands,*/ prikaz = 0;
     (comm != COMM_Dummy) && (prikaz < num_commands) && NOT enddispatch;
     /*mi++,*/ prikaz++)
{
/* kontrola dostatku pameti */
//     if (NOT ignore_outofRAM)
//          if (NOT CheckFreeMemory(0))
//               if (AlertQuestion(GS(MSG_IGNORE_ABORT_MEM)))
//                    ignore_outofRAM = TRUE;
//               else return(FALSE);

  // nastaveni BOOLeovskych promennych
     menu_refresh = 0;             gadget_refresh = 0;
     check_cursor = FALSE;         // del_new_ts = FALSE;
     refresh_rooler = FALSE;
     pombool = FALSE;    // spoleha se na to!
     invalidate1 = FALSE; invalidate2 = FALSE;
  // nastaveni akt. polozek pro tento prubeh
     act_doc = doc;
     if (act_doc == NULL) continue;
//     act_doc  = (mi->mi_Type == MI_OBJ_EDIT_FILE) ? mi->mi_Object : NULL;
     orig_act_comm = act_comm = comm;
     new_undo = UNDO_Empty;        undo_data = 0L;
//     record_macro = record_next_macro;
//     record_next_macro = TRUE;
//     macro_data1 = 0;              macro_data2 = NULL;

// ROZBOR ZPRAV PRO DOKUMENTOVA OKNA - SEM NESMI PRIJIT JINE ZPRAVY //
     if (act_doc)
     {    // act_win = act_doc->win;
          // ModifyIDCMP(act_win, DOC_IDCMPFLAGS_NOTICKS);
          // old_num_pages = act_doc->num_pages;
          // ts = act_doc->cursor.style;
          // ps = act_doc->cursor.para->style;

          actdoc_changes = act_doc->changes;
     }
//#ifdef CHECK_BUGS
//     else if (NOT ((COMM_MENU <= act_comm) && (act_comm <= COMM_REFRESH))) InternalError("DispatchMessGES");
//#else
//     else if (NOT ((COMM_MENU <= act_comm) && (act_comm <= COMM_REFRESH))) continue;
//#endif

  /* konverze pripadna nekterych zprav na jine, napr. MN_InsertDate -->BO_InsertSpecial */

  /* podle typu prikazu je nutno vysetrit, co se stane s blokem, je-li oznacen
   * a dale, co se ma provest s pripadnym newstyle ... */

// zviditelneni kurzoru -- ? kdo vsechno to potrebuje ?
// Basic Operations - ostatni se spoleha na ochranu ve FormatLines
     if (NOT act_doc->cursor_checked)
//     if (NOT act_doc->cursor_checked && NOT act_doc->frame)
     if ( ((COMM_BO <= act_comm) && (act_comm < COMM_TEXT)) )
          if (MakeCursorVisible(teditfile, 0, 0, FALSE))
               send_paint = TRUE;

//>> COMM_BO
     if ((COMM_BO <= act_comm) && (act_comm < COMM_TEXT))
//     if ((COMM_BO <= act_comm) && (act_comm < COMM_TEXT) && NOT act_doc->frame)
     {    /* zakladni operace */
          Location *cursor = &act_doc->cursor, *cursorline = &act_doc->cursorline;
          Location oldcursor = *cursor;

       // kontrola pri pohybu kurzoru ...
          if ((BO_CursorLeft <= act_comm) && (act_comm <= BO_EndSentence))
          {
               if ( ((act_comm - BO_CursorLeft) % 2 == 0) &&
                    FirstParaChar(cursor) && (cursor->para->prev == NULL) && NOT act_doc->block )
               {    BeepEditor();  act_comm = SPEC_NoneOperation;     }
               if ( ((act_comm - BO_CursorLeft) % 2 == 1) &&
                    LastParaChar(cursor) && (cursor->para->next == NULL)  && NOT act_doc->block )
               {    BeepEditor();  act_comm = SPEC_NoneOperation;     }
          }
       // kontrola pri mazani ...
          if ((BO_DelNext <= act_comm) && (act_comm <= BO_DelBOL))
          {
               if ( ((act_comm - BO_DelNext) % 2 == 1) &&
                    FirstParaChar(cursor) && (cursor->para->prev == NULL) && NOT act_doc->block )
               {    BeepEditor();  act_comm = SPEC_NoneOperation;     }
               if ( ((act_comm - BO_DelNext) % 2 == 0) &&
                    LastParaChar(cursor) && (cursor->para->next == NULL) && NOT act_doc->block )
               {    BeepEditor();  act_comm = SPEC_NoneOperation;     }
          }
          if (act_comm == BO_DelLine)
               if ((cursor->para == act_doc->para_last) && LastParaLine(cursor))
               {    BeepEditor();  act_comm = SPEC_NoneOperation;     }
       // kontrola pri prepisovani ! overwriteword neexistuje !
       // musi to byt az za smazanim bloku! --> menime na insert
          if ((act_comm == BO_OverwriteChar) || (act_comm == BO_OverwriteTab) || (act_comm == BO_OverwriteSpecial))
          {
               // overwrite = insert if we overwrite block!
               if ( LastParaChar(cursor) || act_doc->block )
                    switch (act_comm)
                    {
                         case BO_OverwriteChar:   comm = act_comm = BO_InsertChar;     break;
                         case BO_OverwriteTab:    comm = act_comm = BO_InsertTab;      break;
                         case BO_OverwriteSpecial:comm = act_comm = BO_InsertSpecial;  break;
//                         case BO_OverwriteChar:   mi->mi_Command = act_comm = BO_InsertChar;     break;
//                         case BO_OverwriteTab:    mi->mi_Command = act_comm = BO_InsertTab;      break;
//                         case BO_OverwriteSpecial:mi->mi_Command = act_comm = BO_InsertSpecial;  break;
                    }
          }
       // pokud se nejedna o pohyb kurzoru a je oznacen blok --> smazame
          if (act_doc->block && (BO_InsertChar <= act_comm))
          { // undo - dokud je blok oznacen
//               if (GETGLOBALPREFS->delete_block_by_key)
//               if (Prefs.general.delete_block_by_key)
//               if (Prefs.general.undo_active && Prefs.general.delete_block_by_key)
                    undo_data = SaveUndoInfo(teditfile, new_undo = UNDO_DelBlock, 0, 0, 0);

               l1 = act_doc->block_begin;   l2 = act_doc->block_end;
               UnmarkBlock(teditfile, TRUE);
               check_cursor = TRUE;     // del_new_ts = TRUE;
               menu_refresh = ~0UL; gadget_refresh = ~0UL;
               refresh_rooler = TRUE;
            // smazeme to, co bylo oznaceno
//               if (GETGLOBALPREFS->delete_block_by_key)
//               if (Prefs.general.delete_block_by_key)
               {
                    GetPrevPos(teditfile, &l2, TRUE, 1);
                 // nasledovat bude mazani/prepis/vkladani
                 // pokud jsme jiz v dontdraw modu, tak ho to nechame
                    dontdraw = FALSE;
//                    dontdraw = (act_doc->last_dontdraw_para) ? TRUE : FALSE;
                    DeleteDataLoc(teditfile, &l1, &l2, TRUE, TRUE, dontdraw);
                    act_doc->newfile = FALSE;    act_doc->changes = TRUE;
               }
            // pokud se melo neco mazat, jsme hotovi ...
               if ((BO_DelNext <= act_comm) && (act_comm <= BO_DelLine))
                    act_comm = COMM_Dummy;
          }

       // zapamatovani puvodniho stylu odstavce a pisma
       // rozbor jednotlivych akci ...
          switch (act_comm)
          {
            // PRIKAZY TYKAJICI SE POHYBU KURZORU ...
               case BO_SetCursor:  // predpoklada se, ze vse je jiz spravne nastaveno!
                    if (act_comm == BO_SetCursor)
                    {
                         new_undo = UNDO_Special; // undo info not affected - for break later must be set here
                         oldcursor = setcursor_oldcursor_location;
                         if (NOT blockqual && act_doc->block)
                         {
                              loc = *cursor;
                              blockqual = FALSE;  // mi->mi_Qual = 0;
                              UnmarkBlock(teditfile, TRUE);
                              *cursor = loc;
                         }
                         if (blockqual)
                         {
                              if ( (cursor->block == oldcursor.block) &&
                                   (cursor->para == oldcursor.para) &&
                                   (cursor->block_off == oldcursor.block_off) &&
                                   (cursor->chars_off == oldcursor.chars_off) &&
                                   (cursor->line_num == oldcursor.line_num)
                                 )
                                   break;
                         }
                    }
               case BO_CursorLeft: if (act_comm == BO_CursorLeft)
                                        (void) GetPrevPos(teditfile, cursor, TRUE, 1);
               case BO_CursorRight:if (act_comm == BO_CursorRight)
                                        (void) GetNextPos(teditfile, cursor, TRUE, 1);
               case BO_CursorUp:   if (act_comm == BO_CursorUp)
                                   {
                                   	pomulong = GetCursorColumn(teditfile, cursor);
                                        pombool = (cursor->para == act_doc->para_first) ? TRUE : FALSE;
                                        *cursor = *cursorline;

//                                       pombool = (cursor->line == act_doc->line_first) ? TRUE : FALSE;
                                        (void) GetPrevPos(teditfile, cursor, TRUE,  0);
                                        (void) GetPrevPos(teditfile, cursor, FALSE, 0);
                                   }
               case BO_CursorDown: if (act_comm == BO_CursorDown)
                                   {
                                   	pomulong = GetCursorColumn(teditfile, cursor);
                                        pombool = (cursor->para == act_doc->para_last) ? TRUE : FALSE;
//                                        pombool = (cursor->line == act_doc->line_last) ? TRUE : FALSE;
                                        (void) GetNextPos(teditfile, cursor, TRUE,  0);
                                   }
                                   if ((act_comm == BO_CursorUp) || (act_comm == BO_CursorDown))
                                   {
//#ifdef CHECK_BUGS
//                                        if (NOT act_doc->old_ok) InternalError("NOT ACT_DOC->OLD_OK");
//#endif
                                     // pombool - je-li TRUE, pak jsme na pocatku/konci dokumentu
                                     // cursor pak nemusi byt nutne na pocatku radku --> to nesmi
                                     // prijit do CoordsToLoc --> zblbne to LineLength (dosadi delku do LineNode)
                                        pomulong = GetCharoffColumn(teditfile, cursor, pomulong);
                                        if (NOT pombool && pomulong)
                                             GetNextPos(teditfile, cursor, FALSE, (LONG) min_ul(pomulong, cursor->para->length));
                                   }
               case BO_NextWord:   if (act_comm == BO_NextWord)
                                        (void) GetNextWord(teditfile, cursor, NULL, NULL, NULL, FALSE, TRUE, FALSE);
               case BO_NextWhiteWord: if (act_comm == BO_NextWhiteWord)
                                        (void) GetNextWord(teditfile, cursor, NULL, NULL, NULL, FALSE, FALSE, FALSE);
               case BO_NextWordEnd:if (act_comm == BO_NextWordEnd)
                                        (void) GetNextWord(teditfile, cursor, NULL, NULL, NULL, FALSE, TRUE, TRUE);
               case BO_PrevWord:   if (act_comm == BO_PrevWord)
                                        (void) GetPrevWord(teditfile, cursor, NULL, NULL, NULL, FALSE, TRUE);
               case BO_PrevWhiteWord: if (act_comm == BO_PrevWhiteWord)
                                        (void) GetPrevWord(teditfile, cursor, NULL, NULL, NULL, FALSE, FALSE);
               case BO_PageUp:     if (act_comm == BO_PageUp)
                                   {
                                        ULONG lines;

                                   	pomulong = GetCursorColumn(teditfile, cursor);

                                        *cursor = *cursorline;
                                        for(lines = 0; lines < doc->wincheight; lines++)
                                        {
                                             if (NOT GetPrevPos(teditfile, cursor, TRUE, 0)) break;
                                             if (NOT GetPrevPos(teditfile, cursor, FALSE, 0)) break;
                                        }

                                        pomulong = GetCharoffColumn(teditfile, cursor, pomulong);
                                        if (pomulong)
                                             GetNextPos(teditfile, cursor, FALSE, (LONG) min_ul(pomulong, cursor->para->length));
                                   }
               case BO_PageDown:   if (act_comm == BO_PageDown)
                                   {
                                        ULONG lines;

                                   	pomulong = GetCursorColumn(teditfile, cursor);

                                        *cursor = *cursorline;
                                        for(lines = 0; lines < doc->wincheight; lines++)
                                             if (NOT GetNextPos(teditfile, cursor, TRUE, 0)) break;

                                        pomulong = GetCharoffColumn(teditfile, cursor, pomulong);
                                        if (pomulong)
                                             GetNextPos(teditfile, cursor, FALSE, (LONG) min_ul(pomulong, cursor->para->length));
                                   }
               case BO_BegLine:    if (act_comm == BO_BegLine)
                                        *cursor = *cursorline;
               case BO_EndLine:    if (act_comm == BO_EndLine)
                                        (void) GetNextPos(teditfile, cursor, FALSE, 0);
               case BO_ParaUp:     if (act_comm == BO_ParaUp)
                                   {
                                   	parapom = cursor->para;
                                        parapom = (parapom->prev && FirstParaChar(cursor)) ? parapom->prev : parapom;
                                        pomulong2 = (parapom->prev && FirstParaChar(cursor)) ? cursor->line_num - 1 : cursor->line_num;
                                        (void) BlockToLocation(teditfile, cursor, parapom->block_first, parapom->off_first, parapom, pomulong2);
                                   }
               case BO_ParaDown:   if (act_comm == BO_ParaDown)
                                   {
                                   	parapom = cursor->para;
                                        if (parapom->next)
                                        {    parapom = parapom->next;
                                             (void) BlockToLocation(teditfile, cursor, parapom->block_first, parapom->off_first, parapom, cursor->line_num + 1);
                                        }
                                        else act_comm = BO_EndFile;
                                   }
               case BO_BegFile:    if (act_comm == BO_BegFile)
                                        (void) BlockToLocation(teditfile, cursor, act_doc->block_first, 0, NULL, 0);
               case BO_EndFile:    if (act_comm == BO_EndFile)
                                        (void) BlockToLocation(teditfile, cursor, act_doc->block_last, act_doc->block_last->size - act_doc->block_last->free - 1, act_doc->para_last, act_doc->num_lines - 1);
               case BO_BegView:    if (act_comm == BO_BegView)
                                        *cursor = act_doc->display_begin;
               case BO_EndView:    if (act_comm == BO_EndView)
                                        *cursor = act_doc->display_end;
               case BO_BegSentence:if (act_comm == BO_BegSentence)
                                        (void) GetPrevWord(teditfile, cursor, NULL, NULL, NULL, TRUE, FALSE);
               case BO_EndSentence:if (act_comm == BO_EndSentence)
                                        (void) GetNextWord(teditfile, cursor, NULL, NULL, NULL, TRUE, FALSE, FALSE);
//>> "vlastni zpracovani pohybu kurzoru"
                    loc1 = act_doc->block_begin;
                    pombool = act_doc->block;     pombool2 = FALSE;
                    new_undo = UNDO_Special; // undo info not affected
//                    blockqual comes as a parameter
//                    if (Prefs.general.cursorkeys != CK_BDEDITOR)
//                         blockqual = ((mi->mi_Qual & IEQUALIFIER_LSHIFT) || (mi->mi_Qual & IEQUALIFIER_RSHIFT)) ? TRUE : FALSE;
//                    else blockqual = (mi->mi_Qual & IEQUALIFIER_CONTROL) ? TRUE : FALSE;

                    if (NOT act_doc->block)
                    if (blockqual)      // zavedeni noveho bloku
                    {
//                    	 DrawCursor(teditfile, TRUE, 0, 0, 0, 0, FALSE, TRUE);
                         act_doc->block_select = TRUE;
                         act_doc->zamena_bb_be = FALSE;
                         act_doc->blockpoint = oldcursor;
                         act_doc->block = TRUE;
                         act_doc->block_begin = oldcursor;
                         act_doc->block_end = oldcursor;
                    }
                    else
                    {
                      // vykresleni kurzoru
                         *cursorline = *cursor;
                         (void) GetPrevPos(teditfile, cursorline, FALSE, 0);
//                         DrawCursor(teditfile, TRUE, 0, 0, 0, 0, FALSE, TRUE);
//                         DrawLine(teditfile, cursorline, 0, NULL, 0, 0, 0, act_doc->block, FALSE, FALSE, FALSE, FALSE, FALSE);
//                         if (NOT DrawLine(act_doc, cursorline, 0, NULL, 0, 0, 0, act_doc->block, FALSE, FALSE, FALSE, FALSE, FALSE))
//                         {    pombool2 = TRUE;
//                              FormatLines(act_doc, GetFirstFormatLine(act_doc, &loc, FALSE, FALSE), TRUE, FALSE, TRUE, FALSE, TRUE, 0, newtextstyle, FALSE, FALSE, FALSE, FALSE);
//                         }
                         check_cursor = TRUE;     // del_new_ts = TRUE;
                      // nastaveni obnovy
//                         if (pspom != cursor->para->style)
                         {
                              menu_refresh |= MG_ALIGNMENT | MG_SPACING | MG_LINEHEIGHT | MG_SPELLHYP;
                              gadget_refresh |= GG_ALIGNMENT | GG_SPACING;
                              refresh_rooler = TRUE;
                         }
//                         if (tspom != cursor->style)
                         {
                              menu_refresh |= MG_STYLES | MG_POSITIONS | MG_COLORS;
                              gadget_refresh |= GG_STYLES | GG_POSITIONS;
                         }
                         if (NOT pombool2) new_undo = UNDO_Special;
// not needed                         break;
                    }
                 // pokud je blok, pokracujeme ...
                    if (act_doc->block)
                    {    if (blockqual)      // znaceni bloku
                         {
                           // nastaveni bloku
                              oldcursor = *cursor;
                              ChangeBlockSelection(teditfile, &oldcursor);
                              *cursor = (act_doc->zamena_bb_be) ? act_doc->block_begin : act_doc->block_end;
                              *cursorline = *cursor;
                              (void) GetPrevPos(teditfile, cursorline, FALSE, 0);
                           // v pripade znaceni bloku je akt. styl urcen stylem
                           // akt. znaku a ne znaku predchoziho!
                              loc2 = act_doc->block_begin;
//                              if ( (pombool != act_doc->block) ||
//                                   (loc1.block !=loc2.block) ||
//                                   (loc1.block_off != loc2.block_off) )
//                                // doslo ke zmene block_begin
//                                // (zrusime-li blok, je jedno, co je v block_begin)
//                                   if (loc2.style->next)
//                                   {    if (loc2.style->next->offset == loc2.chars_off)
//                                             act_doc->block_begin.style = loc2.style->next;
//                                   }
                           // nastaveni obnovy
//                              if (pspom != act_doc->block_begin.para->style)
                              {
                              	   menu_refresh |= MG_ALIGNMENT | MG_SPACING | MG_LINEHEIGHT | MG_SPELLHYP;
                                   gadget_refresh |= GG_ALIGNMENT | GG_SPACING;
                                   refresh_rooler = TRUE;
                              }
//                              if (tspom != act_doc->block_begin.style)
                              {
                                   menu_refresh |= MG_STYLES | MG_POSITIONS | MG_COLORS;
                                   gadget_refresh |= GG_STYLES | GG_POSITIONS;
                              }
                         }
                         else // odznaceni bloku
                         {
                              UnmarkBlock(teditfile, ((act_comm - BO_CursorLeft) % 2 == 0) ? TRUE : FALSE);
                              check_cursor = TRUE;     // del_new_ts = TRUE;
                              menu_refresh = ~0UL; gadget_refresh = ~0UL;
                              refresh_rooler = TRUE;
                              if (NOT pombool2) new_undo = UNDO_Special;
// not needed here                              break;
                         }
                    }
//                    act_doc->act_page = act_doc->cursor.page->num;
                    if (NOT pombool2) new_undo = UNDO_Special;
// invalidate lines
                    if ( (act_doc->display_begin.line_num <= cursor->line_num) &&
                         (act_doc->display_end.line_num >= cursor->line_num) )
                    {
                    	 invalidate1 = TRUE;
                         invalidate_lines1 = 1;
                         invalidate_offset1 = cursor->line_num - act_doc->display_begin.line_num;
                         invalidate_erase1 = FALSE;
                    }
                    if ( (act_doc->display_begin.line_num <= oldcursor.line_num) &&
                         (act_doc->display_end.line_num >= oldcursor.line_num) )
                    {
                    	 invalidate2 = TRUE;
                         invalidate_lines2 = 1;
                         invalidate_offset2 = oldcursor.line_num - act_doc->display_begin.line_num;
                         invalidate_erase2 = FALSE;
                    }

                    break;
//<<

            // PRIKAZY PRO VKLADANI A PREPISOVANI TEXTU ...
               case BO_InsertChar: case BO_InsertTab: case BO_InsertSpecial:
                    {    // EditFile *pomfile = mi->mi_Object;

//                         i = 0;
//                         while ( (mi->mi_Type == MI_OBJ_EDIT_FILE) &&
//                                 (mi->mi_Object == pomfile) &&
//                                 ((mi->mi_Command == BO_InsertChar) || (mi->mi_Command == BO_InsertTab) || (mi->mi_Command == BO_InsertSpecial))
//                               )
//                         {    buffer[i++] = (UBYTE) mi->mi_Code; mi++;    }
//                         mi--;     buffer[i] = '\0';   // ukonceni retezce
                         buffer[0] = (UBYTE) code;
                         buffer[1] = '\0';
                    }    // v bufferu je nyni retezec znaku
               case BO_InsertWord:
//>> "vkladani"
                    if (act_comm == BO_InsertWord)
                    {
                         clrmem(buffer, /* MAXCOMMANDS + */ MAXWORDLEN);
                         strncpy((char *) buffer, (char *) address, /* MAXCOMMANDS + */ MAXWORDLEN - 1);
                    }
                 // pokud se prubezne kontroluje pravopis, zjistime, kolik
                 // se prave vklada slov (totez pro autokorekce)
//                    i = 0;
//                    if ( GETGLOBALPREFS->autocorrect // ||
////                         ( Prefs.speller.while_typing && (SpellerInit != NOINIT) )
//                       )
//                    {    if (cursor->block_off > 0)
//                              pomznak = *(cursor->block->memory + cursor->block_off - 1);
//                         else pomznak = 'a';
//                      // pomznak obsahuje predchozi znak...
//                         for(i = 0, pomuk = buffer; *pomuk; pomuk++)
//                         {    if (SEPARATOR(teditfile, *pomuk) && NOT SEPARATOR(teditfile, pomznak))
//                                   i++;
//                              pomznak = *pomuk;
//                         }
//                    }
                 // potrebujeme urcit, zda se ma kreslit ci ne
                    dontdraw = FALSE;
//                 // 1. musi byt nasl. prikaz schopen take nekreslit (jinak to nema cenu)
//                 // 2. pokud uz neco prekresleno neni, je to jedno
//                    if ( act_doc->last_dontdraw_para ||
//                         ((act_comm != BO_InsertWord) && (strlen(buffer) > MAX_TOLERATE_CHARS)) )
//                         dontdraw = TRUE;
//                    else if ((mi[1].mi_Command == COMM_Dummy) || (prikaz + 1 >= num_commands))
//                         dontdraw = TRUE;
//                    else if (testdontdraw(mi[1].mi_Command) || (mi[1].mi_Command == SPEC_IntuiTick))
//                         dontdraw = TRUE;
//                    act_doc->refresh_ticks = 0;

                 // undo
//                    if (Prefs.general.undo_active)
//                    if (new_undo == UNDO_DelBlock)
//                         undo_data += strlen(buffer);
//                    else undo_data = SaveUndoInfo(teditfile, new_undo = UNDO_InsText, (ULONG) strlen(buffer), 0, 0);
                    if (new_undo != UNDO_Empty)
                         UpdateUndoInfo(teditfile, new_undo, undo_data);
                    undo_data = SaveUndoInfo(teditfile, new_undo = UNDO_InsText, (ULONG) strlen(buffer), 0, 0);
//                 // makro_data
//                    macro_data2 = buffer;
                 // vlastni vlozeni; i obsahuje pocet vlozenych slov
//                    pombool = (NULL == GetFirstFormatLine(act_doc, &loc, FALSE, TRUE)) ? TRUE : FALSE;
                    if (NOT InsertInBlock(teditfile, cursor, buffer, (ULONG) strlen(buffer), FALSE, NUM_DOC_LOCATIONS, NULL, FALSE))
                         BeepEditor();
//                    else FormatLines(act_doc, GetFirstFormatLine(act_doc, &loc, pombool, FALSE), TRUE, FALSE, TRUE, newtextstyle, TRUE, 0, newtextstyle, FALSE, FALSE, dontdraw, FALSE);
                    act_doc->newfile = FALSE;    act_doc->changes = TRUE;
                 // nyni je treba zkontrolovat vlozeny text; i = pocet slov
//                    if ( (i > 0) && (GETGLOBALPREFS->autocorrect // ||
////                         (Prefs.speller.while_typing && (SpellerInit != NOINIT)))
//                       ) )
//                    {
//                    	 BOOL pomres;
//
//                         loc = l1 = l2 = *cursor;
//                      // skok na prvni kontrolovane slovo
//                         while (i > 0)
//                         {    GetPrevWord(teditfile, &l1, NULL, NULL, NULL, FALSE, TRUE);
//                              i--;
//                         }
//                         if (SEPARATOR(teditfile, *(cursor->block->memory + cursor->block_off)))
//                              GetNextWord(teditfile, &l2, NULL, NULL, NULL, FALSE, TRUE, FALSE);
//                      // urcime, zda jsme na konci dokumentu...
//                         pombool = (LastParaChar(&l2) && (l2.para == act_doc->para_last)) ? TRUE : FALSE;
//                      // vlastni kontrola...
//                         pomres = FALSE;
//                         if (GETGLOBALPREFS->autocorrect)
//                              if (CheckSpelling(teditfile, &l1, (pombool) ? NULL : &l2, FALSE, TRUE))
//                              {    pomres = TRUE;
//                                // zajistime novy prubeh ...
//                                   comm = BO_CursorRight;
//                                   prikaz--;
////                                   record_next_macro = FALSE;
////                                   mi--;
//                              }
////                         if (NOT pomres && Prefs.speller.while_typing && (SpellerInit != NOINIT))
////                              if (Prefs.speller.markwrongcol == 0)
////                                   CheckSpelling(act_doc, &l1, (pombool) ? NULL : &l2, FALSE, FALSE);
//                    }
                 // nastaveni obnovy - _refresh nema smysl ...
                    check_cursor = TRUE;
                    if ( (act_doc->display_begin.line_num <= cursor->line_num) &&
                         (act_doc->display_end.line_num >= cursor->line_num) )
                    {
                    	 invalidate1 = TRUE;
                         invalidate_lines1 = 1;
                         invalidate_offset1 = cursor->line_num - act_doc->display_begin.line_num;
                         invalidate_erase1 = FALSE;
                    }
//<<
                    break;

               case BO_OverwriteChar: case BO_OverwriteTab: case BO_OverwriteSpecial:
//>> "overwrite"
                 // pomocny blok, ve kterem pripadne posuneme TextStyle
                    {    // TextStyle *next = NULL, *nextnext = NULL;
                         BOOL opakovat;

//                      // urcime, zda je nutno provest formatovani
//                         pombool = TRUE;
//                      // posunuti dalsiho stylu
                         do
                         {    opakovat = FALSE;
                           // preskoceni CH_EOL
                              l = cursor->block->memory + cursor->block_off;
                              if (ENDLINE(*l))
                              {    (void) GetNextPos(teditfile, cursor, TRUE, 1);
                                   l = cursor->block->memory + cursor->block_off;
                                   opakovat = TRUE;
                              }
                         } while (opakovat);
                    }
#ifdef CHECK_BUGS
                    if (ENDLINE(*l)) { InternalError("Dispatch - Overwrite ENDLINE"); break; }
#else
                    if (ENDLINE(*l)) break;
#endif
                 // podivame se, zda je treba provadet kontrolu; ignorujeme pametove bloky!!!
                    pombool = FALSE;
//                    if ( GETGLOBALPREFS->autocorrect // ||
////                         (Prefs.speller.while_typing && (SpellerInit != NOINIT))
//                       )
////                    {    if (SEPARATOR(mi->mi_Code) && NOT SEPARATOR(l[-1]))
//                    {
//                         if (SEPARATOR(teditfile, code) && NOT SEPARATOR(teditfile, l[-1]))
//                              pombool = TRUE;
//                    }
                 // undo
//                    if (Prefs.general.undo_active)
//                    if (new_undo == UNDO_DelBlock)
//                         undo_data += 1;
//                    else undo_data = SaveUndoInfo(teditfile, new_undo = UNDO_OverwriteText, 1, 1, 0);
                    if (new_undo != UNDO_Empty)
                         UpdateUndoInfo(teditfile, new_undo, undo_data);
                    undo_data = SaveUndoInfo(teditfile, new_undo = UNDO_OverwriteText, 1, 1, 0);
                 // makro_data
//                    buffer[0] = (UBYTE) mi->mi_Code;   buffer[1] = '\0';
//                    macro_data2 = buffer;
                 // prepis
                    *l = (UBYTE) code;
//                    *l = (UBYTE) mi->mi_Code;
                 // nastavime kurzor na spravnou pozici
                    (void) GetNextPos(teditfile, cursor, TRUE, 1);
                    *cursorline = *cursor;
                    (void) GetPrevPos(teditfile, cursorline, FALSE, 0);
                 // zobrazovani + formatovani
//                    FormatLines(act_doc, GetFirstFormatLine(act_doc, &loc, FALSE, FALSE), TRUE, FALSE, TRUE, newtextstyle, TRUE, 0, newtextstyle, FALSE, FALSE, FALSE, FALSE);
                 // nyni je treba zkontrolovat vlozeny text;
//                    if ( pombool && (GETGLOBALPREFS->autocorrect  // ||
////                         (Prefs.speller.while_typing && (SpellerInit != NOINIT)))
//                       ) )
//                    {    BOOL pomres;
//
//                         loc = l1 = l2 = *cursor;
//                      // presun na kontrolovane slovo
//                         GetPrevWord(teditfile, &l1, NULL, NULL, NULL, FALSE, TRUE);
//                         if (SEPARATOR(teditfile, *(cursor->block->memory + cursor->block_off)))
//                              GetNextWord(teditfile, &l2, NULL, NULL, NULL, FALSE, TRUE, FALSE);
//                      // urcime, zda jsme na konci dokumentu...
//                         pombool = (LastParaChar(&l2) && (l2.para == act_doc->para_last)) ? TRUE : FALSE;
//                      // vlastni kontrola...
//                         pomres = FALSE;
//                         if (GETGLOBALPREFS->autocorrect)
//                              if (CheckSpelling(teditfile, &l1, (pombool) ? NULL : &l2, FALSE, TRUE))
//                              {    pomres = TRUE;
//                                // zajistime novy prubeh ...
//                                   comm = BO_CursorRight;
////                                   mi->mi_Command = BO_CursorRight;
//                                   prikaz--;
////                                   record_next_macro = FALSE;
////                                   mi--;
//                              }
////                         if (NOT pomres && Prefs.speller.while_typing && (SpellerInit != NOINIT))
////                              if (Prefs.speller.markwrongcol == 0)
////                                   CheckSpelling(act_doc, &l1, (pombool) ? NULL : &l2, FALSE, FALSE);
//                    }
                    act_doc->newfile = FALSE;    act_doc->changes = TRUE;
                 // nastaveni obnovy - nelze prejit mimo odstavec!
                    check_cursor = TRUE;
//                    if (tspom != cursor->style)
                    {    menu_refresh |= MG_STYLES | MG_POSITIONS | MG_COLORS;
                         gadget_refresh |= GG_STYLES | GG_POSITIONS;
                    }
                    if ( (act_doc->display_begin.line_num <= cursor->line_num) &&
                         (act_doc->display_end.line_num >= cursor->line_num) )
                    {
                    	 invalidate1 = TRUE;
                         invalidate_lines1 = 1;
                         invalidate_offset1 = cursor->line_num - act_doc->display_begin.line_num;
                         invalidate_erase1 = FALSE;
                    }
                    break;
//<<

//               case BO_OverwriteWord: break; // ZATIM NEIMPLEMENTOVANO
            // PRIKAZY PRO MAZANI TEXTU ...
                    // v prislusnem case vetvi se loc1 na zacatek mazane casti,
                    // loc2 na konec; zbytek se provede hromadne na konci
               case BO_DelNext:    break;    // ???
               case BO_DelPrev:    break;    // ???
               case BO_DelChar:    if (act_comm == BO_DelChar)
                                   {    
                                        loc1 = *cursor; loc2 = *cursor;
                                        if (ENDLINE(*(cursor->block->memory + cursor->block_off)) && NOT LastParaChar(cursor))
                                             (void) GetNextPos(teditfile, &loc2, TRUE, 0);
                                   }
               case BO_DelPrevChar:if (act_comm == BO_DelPrevChar)
                                   {    
                                        if ((cursor->block == cursorline->block) && (cursor->block_off == cursorline->block_off))
                                        {    (void) GetPrevPos(teditfile, cursor, TRUE, 1);
                                             if (NOT LastParaChar(cursor))
                                                  (void) GetPrevPos(teditfile, cursor, FALSE, 1);
                                        }
                                        else (void) GetPrevPos(teditfile, cursor, FALSE, 1);
                                        loc1 = *cursor; loc2 = *cursor;
                                   }
               case BO_DelWord: case BO_DelEOS:
                                   if ((act_comm == BO_DelWord) || (act_comm == BO_DelEOS))
                                   {    
                                        loc1 = *cursor; loc2 = *cursor;
                                        (void) GetNextWord(teditfile, &loc2, NULL, NULL, NULL, (act_comm == BO_DelEOS) ? TRUE : FALSE, FALSE, FALSE);
                                        (void) GetPrevPos(teditfile, &loc2, TRUE, 1);
                                   }
               case BO_DelPrevWord: case BO_DelBOS:
                                   if ((act_comm == BO_DelPrevWord) || (act_comm == BO_DelBOS))
                                   {    
                                        loc2 = *cursor;
                                        (void) GetPrevPos(teditfile, &loc2, TRUE, 1);
                                        (void) GetPrevWord(teditfile, cursor, NULL, NULL, NULL, (act_comm == BO_DelBOS) ? TRUE : FALSE, FALSE);
                                        loc1 = *cursor;
                                   }
               case BO_DelLine:    if (act_comm == BO_DelLine)
                                   {    
                                        loc1 = loc2 = *cursorline;
                                        *cursor = *cursorline;
                                        GetNextPos(teditfile, &loc2, FALSE, 0);
                                   }
               case BO_DelEOP:     if (act_comm == BO_DelEOP)
                                   {
                                        if (cursor->chars_off + 1 >= cursor->para->length) break;
                                        loc1 = loc2 = *cursor;
                                        GetNextPos(teditfile, &loc2, FALSE, 0);
                                   }
               case BO_DelBOP:     if (act_comm == BO_DelBOP)
                                   {
                                        if (cursor->chars_off == 0) break;
                                        loc1 = *cursorline;
                                        loc2 = *cursor;
                                        (void) GetPrevPos(teditfile, &loc2, TRUE, 1);
                                   }
               case BO_DelEOL:     if (act_comm == BO_DelEOL) break;  // NOT IMPLEMENTED YET
               case BO_DelBOL:     if (act_comm == BO_DelBOL) break;  // NOT IMPLEMENTED YET
                 // potrebujeme urcit, zda se ma kreslit ci ne - obsolete here
                    dontdraw = FALSE;

                 // undo
//                    if (Prefs.general.undo_active)
                         if (new_undo != UNDO_Empty)
                              UpdateUndoInfo(teditfile, new_undo, undo_data);
                         undo_data = SaveUndoInfo(teditfile, new_undo = UNDO_DelText, (ULONG) &loc1, (ULONG) &loc2, (ULONG) &oldcursor);

                 // vvv - provede i formatovani; predpoklad - cursor spravne nastaven
                 // predavame take dontdraw...
                    pombool = (loc1.para == loc2.para) ? TRUE : FALSE;
                    pomulong = doc->num_lines;
                    DeleteDataLoc(teditfile, &loc1, &loc2, TRUE, TRUE, dontdraw);
                    act_doc->newfile = FALSE;    act_doc->changes = TRUE;
                    // del_new_ts = TRUE;
                    check_cursor = TRUE;
                 // nastaveni obnovy
//                    if (pspom != cursor->para->style)
                    {    menu_refresh |= MG_ALIGNMENT | MG_SPACING | MG_LINEHEIGHT | MG_SPELLHYP;
                         gadget_refresh |= GG_ALIGNMENT | GG_SPACING;
                         refresh_rooler = TRUE;
                    }
//                    if (tspom != cursor->style)
                    {    menu_refresh |= MG_STYLES | MG_POSITIONS | MG_COLORS;
                         gadget_refresh |= GG_STYLES | GG_POSITIONS;
                    }
                    if ( (act_doc->display_begin.line_num <= cursor->line_num) &&
                         (act_doc->display_end.line_num >= cursor->line_num) )
                    {
                    	 invalidate1 = TRUE;
                         invalidate_offset1 = cursor->line_num  - act_doc->display_begin.line_num;
                         invalidate_lines1 = (pombool && (pomulong == act_doc->num_lines)) ? 1 : doc->wincheight;
                         invalidate_erase1 = TRUE;
                    }
                    else // deleting moves us outside of the display
                    {
                    	 invalidate1 = TRUE;
                         invalidate_offset1 = 0;
                         invalidate_lines1 = doc->wincheight;
                         invalidate_erase1 = TRUE;
                    }
                    break;
            // PRIKAZY PRO VYTVARENI NOVYCH ODSTAVCU A STRANEK ...
               case BO_NewPara:
               case BO_NewParaBP:  
                    // save actual paragraph
                    parapom = cursor->para;
                 // undo
//                    if (Prefs.general.undo_active)
//                    if (new_undo == UNDO_DelBlock)
//                         undo_data = UNDO_INSPARA;
//                    else undo_data = SaveUndoInfo(teditfile, new_undo = UNDO_InsText, UNDO_INSPARA, 0, 0);
                    if (new_undo != UNDO_Empty)
                         UpdateUndoInfo(teditfile, new_undo, undo_data);
                    undo_data = SaveUndoInfo(teditfile, new_undo = UNDO_InsText, UNDO_INSPARA, 0, 0);
                 // vlastni rozdeleni...
                 // zde se dontdraw modus zapina automaticky ve SplitParagraph
                    SplitParagraph(teditfile, cursor, /* cursor->page,*/ (act_comm == BO_NewParaBP) ? TRUE : FALSE, TRUE, TRUE);
                    act_doc->newfile = FALSE;    act_doc->changes = TRUE;
                    check_cursor = TRUE;
                    if ( (act_doc->display_begin.line_num <= cursor->line_num) &&
                         (act_doc->display_end.line_num + 1 >= cursor->line_num) )
                         // + 1 = refresh the actual and the previous lines!
                    {
                    	 invalidate1 = TRUE;
                         invalidate_lines1 = doc->wincheight;
                         invalidate_offset1 = cursor->line_num - act_doc->display_begin.line_num;
                         if (invalidate_offset1 > 0) invalidate_offset1--;
                         invalidate_erase1 = TRUE;
                    }

                 // do autoindenting: spaces and tabs are copied to the next line
                    if (GetIndentBuffer(parapom, indent_buffer, MAXWORDLEN))
                    {
                         comm = BO_InsertWord;
                    	 address = indent_buffer;
                    	 prikaz--;
                    }

                    menu_refresh |= MG_STYLES | MG_POSITIONS | MG_COLORS;
                    gadget_refresh |= GG_STYLES | GG_POSITIONS;
                    break;

               case BO_JoinPara:   break;    // neni nutne - zahrnuto v mazani
               case BO_JoinParaBS: break;    // neni nutne - zahrnuto v mazani
            // ZOBRAZENI NOVEHO VYREZU DOKUMENTU ...
               case BO_GetClip: break;
          }
     }
//<<
//>> COMM_TEXT
     else if ((COMM_TEXT <= act_comm) && (act_comm < COMM_REQ)  /* && NOT act_doc->frame*/ )
     {    /* globalnejsi operace s textem */
     }
//<<
//>> COMM_REQ
     else if ((COMM_REQ <= act_comm) && (act_comm <= COMM_MENU) /* && NOT act_doc->frame */)
     {    /* vyvolavani ruznych requesteru */
     }
//<<
//>> COMM_MENU
     else if ((COMM_MENU <= act_comm) && (act_comm <= COMM_REFRESH))
     {    
          Location *cursor, *cursorline, oldcursor;
          Location pomloc, pomloc1, pomloc2;
          Paragraph *act_para, *pom_para;

          cursor = &act_doc->cursor;
          cursorline = &act_doc->cursorline;
          oldcursor = *cursor;

          switch (act_comm)
          {
               case MN_OpenDoc:
               case MN_ImportDocASCII:
                    // it is assumed that document is empty

#ifdef CHECK_BUGS
                    if (NOT act_doc->newfile) InternalError("Open: not empty document");
#endif
                    if (NOT act_doc->newfile) break;

// no, for new document is undo cleared                     new_undo = UNDO_Special;
                    {    
                         char *filename = (char *) address;

                         if (NOT BDTFileRequester(teditfile, GS(MSG_REQ_SELECT_FILE), GS(MSG_REQ_OPEN_TEXT), NULL, FALSE, filename))
                         {    
                              break;    
                         }

                         // vlastni nahrani...
                         pombool = LoadDiskDoc(teditfile, TRUE);

                         // jiz je nahran: nastavime zobrazovani
                         SetDisplayBegEnd(teditfile, TRUE, 0);

                         act_doc->newfile = FALSE;

//                         // zaznamenani noveho zprac. souboru
//                         if (act_comm != MN_InitFile)
//                              UpdateRecentDocsMenu(pomdoc);
                    }
                    check_cursor = TRUE;

                    invalidate1 = TRUE;
                    invalidate_lines1 = doc->wincheight;
                    invalidate_erase1 = TRUE;
                    invalidate_offset1 = 0;
                    break;
//<<

               case MN_CloseFile:  new_undo = UNDO_Special;
                                   CloseDoc(teditfile, TRUE);
                                   enddispatch = TRUE;
                                   act_doc = NULL;
                                   break;

               case MN_SaveDoc:    case MN_SaveAsDoc:
//                    if ((act_comm == MN_SaveDoc) || (act_comm == MN_SaveAsDoc)) specid = FILTER_FORMBDED;

                    new_undo = UNDO_Special;
//>> "realizace export"
                    {    
                         char path[PATH_LEN + FILENAME + 16], name[FILENAME + 2];
//                         BOOL export = ((act_comm != MN_SaveAsDoc) && (act_comm != MN_SaveDoc)) ? TRUE : FALSE;
                         BOOL uspech, testover = FALSE;
                         BOOL saveas = FALSE;

                         strcpy(path, act_doc->path);
                         strcpy(name, act_doc->name);
                         
                         if (NOT ((act_doc->last_saved != 0) && (act_comm == MN_SaveDoc)))
                         {
                              char *filename = (char *) address;    
                              saveas = TRUE;
//                              if ((mi->mi_From == MI_FROM_AREXX) && mi->mi_Address)
//                              {    strcpy(act_doc->path, mi->mi_Address);
//                                   pomstrptr = FilePart(act_doc->path);
//                                   strcpy(act_doc->name, pomstrptr);
//                                   *pomstrptr = '\0';
//                              }
//                              else
                              if (NOT BDTFileRequester(teditfile, GS(MSG_REQ_SELECT_FILE), GS(MSG_REQ_SAVE_TEXT), NULL, TRUE, filename)) break;
                              testover = TRUE;
                         }
                         uspech = SaveDiskDoc(teditfile, testover, BDE_SAVE_NEWEST);
                         act_doc->changes = FALSE;
                         // zaznam vzniklych zmen
                         act_doc->newfile = FALSE;
                         // zaznam noveho aktualniho souboru
//                         if (uspech)
//                              if (saveas)
//                                   UpdateRecentDocsMenu(act_doc);

                         if (NOT uspech)
                         {    
                              strcpy(act_doc->path, path);
                              strcpy(act_doc->name, name);
                         }
                         // tituly oken se jen ctou... OK pro  PPC
                         SetWindowTitle(teditfile, act_doc->name);
                    }    
                    break;
//<<

//               case MN_Undo:
////                    if (Prefs.general.undo_active)
//                    {    
//                         DoUndoOperation(teditfile);
//                         act_doc->new = FALSE;    act_doc->changes = TRUE;
//                      // nastaveni obnovy
//                         send_paint = TRUE;  // invalidating is done inside of DoUndoOperation()
//
//                         check_cursor = TRUE;     // del_new_ts = TRUE;
//                         menu_refresh = ~0UL;      gadget_refresh = ~0UL;
//                         refresh_rooler = TRUE;
//                    }
//                    break;

               case MN_Cut:   case MN_Copy:  case MN_Paste:
// set always below                    if (act_comm == MN_Copy) new_undo = UNDO_Special;
               case MN_Erase:
               // if address != NULL, it is taken as the source of paste!
//>> "realizace operaci s blokem"
                 // zvlast je osetreno mazani obrazku/ramu - erase
                    pombool2 = FALSE;   // ulozila se undo pro smazany blok
                    new_undo = UNDO_Special;
                    
                 // normalni operace s textem
                    if (NOT act_doc->block && (act_comm != MN_Paste))
                         break;

                    ChangePointer(teditfile, NULL, TRUE, TRUE);
                    
                    if ((act_comm == MN_Cut) || (act_comm == MN_Copy))
                         if (NOT BlockToClip(teditfile, FALSE)) 
                              BeepEditor();
                    
                    if (act_doc->block) // kvuli Paste ..
                    if ( (act_comm == MN_Cut) || (act_comm == MN_Erase) || (act_comm == MN_Paste) )
                    { 
                      // undo - dokud je blok jeste oznacen
//                         if (Prefs.general.undo_active)
//                         if ((act_comm != MN_Paste) || GETGLOBALPREFS->delete_block_by_key)
                         {    
                              pombool2 = TRUE;
                              undo_data = SaveUndoInfo(teditfile, new_undo = UNDO_DelBlock, 0, 0, 0);
                         }

                      // smazani bloku
                         l1 = act_doc->block_begin;   l2 = act_doc->block_end;
                         UnmarkBlock(teditfile, TRUE);
                      // smazeme to, co bylo oznaceno
//                         if ((act_comm != MN_Paste) || GETGLOBALPREFS->delete_block_by_key)
                         {    
                              GetPrevPos(teditfile, &l2, TRUE, 1);
                              DeleteDataLoc(teditfile, &l1, &l2, TRUE, TRUE, FALSE);
                         }
                         act_doc->newfile = FALSE;
                         act_doc->changes = TRUE;
                      // nastaveni obnovy
                         check_cursor = TRUE;     // del_new_ts = TRUE;
                         menu_refresh = ~0UL;      gadget_refresh = ~0UL;
                         refresh_rooler = TRUE;
                    }

                    if (act_comm == MN_Paste)
                    {
                         char *textsrc = (char *) address;

                      // set window refresh variables
                         invalidate1 = TRUE;
                         invalidate_lines1 = doc->wincheight;
                         invalidate_erase1 = FALSE;
                         if (cursor->line_num < doc->display_begin.line_num)
                              invalidate_offset1 = 0;
                         else
                              invalidate_offset1 = cursor->line_num - act_doc->display_begin.line_num;

                      // vlozeni + uchovani pozice kurzoru
                         loc = *cursor;
                         if (NOT ClipToText(teditfile, &pomulong, FALSE, textsrc))
                              Information2(teditfile, GS(MSG_NOT_ENOUGH_MEMORY));
                      // aktualni kurzor = konec vlozeni dame do block_end
                      // blok neni oznacen a tak to lze
                      // vysledek je, ze se to ve FormatLines upravi
                         (void) BlockToLocation(teditfile, cursor, cursor->block, cursor->block_off, NULL, 0);
                         act_doc->block_end = *cursor;
                      // poloha kurzoru - pred vlozenim
                         (void) BlockToLocation(teditfile, &loc, loc.block, loc.block_off, NULL, NULL);
                         *cursorline = *cursor = loc;
                         (void) GetPrevPos(teditfile, cursorline, FALSE, 0);
                      // preformatovani
                         SetDisplayBegEnd(teditfile, TRUE, 0);
//                         pombool = (NULL == GetFirstFormatLine(act_doc, &loc, FALSE, TRUE)) ? TRUE : FALSE;
//                         FormatLines(act_doc, GetFirstFormatLine(act_doc, &loc, pombool, FALSE), TRUE, FALSE, TRUE, TRUE, TRUE, (LONG) pomulong, newtextstyle, FALSE, TRUE, FALSE, FALSE);
                         act_doc->newfile = FALSE;
                         act_doc->changes = TRUE;
                      // nastaveni obnovy
                         check_cursor = TRUE;     // del_new_ts = TRUE;
                         menu_refresh = ~0UL;      gadget_refresh = ~0UL;
                         refresh_rooler = TRUE;

                      // undo - dokud je vime zacatek (loc) i konec
//                         if (Prefs.general.undo_active)
                              if (new_undo != UNDO_Empty)
                                   UpdateUndoInfo(teditfile, new_undo, undo_data);
                              undo_data = SaveUndoInfo(teditfile, new_undo = UNDO_InsClip, (ULONG) &act_doc->cursor, (ULONG) &act_doc->block_end, (ULONG) pombool2);
                      // smazeme block_end
                         clrmem(&act_doc->block_end, sizeof(Location));
                    }

                    ChangePointer(teditfile, NULL, FALSE, FALSE);
//                    SetWindowTitles(act_doc->win, TextTitleDocWindow(act_doc), (STRPTR) -1);
                    break;

               case MN_SelectAll:
//>> "realizace SelectAll"
                    new_undo = UNDO_Special;
                    if ((act_doc->block_first == act_doc->block_last) && (act_doc->block_last->size <= act_doc->block_last->free + 1))
                         break;
                    if (act_doc->block)
                         UnmarkBlock(teditfile, TRUE);
                 // urcime pocatek a konec textu
                    (void) BlockToLocation(teditfile, &l1, act_doc->block_first, 0, NULL, 0);
                    (void) BlockToLocation(teditfile, &l2, act_doc->block_last, act_doc->block_last->size - act_doc->block_last->free - 1, act_doc->para_last, act_doc->num_lines - 1);
                 // provedeme oznaceni bloku
                    act_doc->block_select = TRUE; act_doc->zamena_bb_be = FALSE;
                    act_doc->blockpoint = l1;     act_doc->block = TRUE;
                    act_doc->block_begin = l1;    act_doc->block_end = l2;
                    *cursor = l2;                 *cursorline = l2;
                    (void) GetPrevPos(teditfile, cursorline, FALSE, 0);
                 // obarveni
                    invalidate1 = TRUE;
                    invalidate_offset1 = 0;
                    invalidate_lines1 = doc->wincheight;
                    invalidate_erase1 = FALSE;

                    menu_refresh = ~0UL; gadget_refresh = ~0UL;
                    refresh_rooler = TRUE;
                    break;
//<<
               case MN_SelectWord:
                    new_undo = UNDO_Special;
                    if ((act_doc->block_first == act_doc->block_last) && (act_doc->block_last->size <= act_doc->block_last->free + 1))
                         break;
                    if (act_doc->block)
                         UnmarkBlock(teditfile, TRUE);
                 // provedeme oznaceni bloku
                    SelectActualWord(teditfile, FALSE, &l1, &l2);
                    *cursor = l2;                 *cursorline = l2;
                    (void) GetPrevPos(teditfile, cursorline, FALSE, 0);
                 // obarveni
                    if ( (act_doc->display_begin.line_num <= cursor->line_num) &&
                         (act_doc->display_end.line_num >= cursor->line_num) )
                    {
                    	 invalidate1 = TRUE;
                         invalidate_lines1 = 1;
                         invalidate_offset1 = cursor->line_num - act_doc->display_begin.line_num;
                         invalidate_erase1 = FALSE;
                    }

                    menu_refresh = ~0UL; gadget_refresh = ~0UL;
                    refresh_rooler = TRUE;
                    break;

                    // the following commands assume that Replace structure is correctly initialized!
                    // if code is 1 - called by Replace All! : no change pointer
                    // if code is 2 - Search for Replace in requester : do not skip chars
               case MN_SearchNext:
               case MN_ReplaceNext:
                    {
                         ReplaceState *replace = teditfile->GetReplaceData();

                         new_undo = UNDO_Special; // undo info not affected

                         if (act_doc->block)
                              UnmarkBlock(teditfile, TRUE);
                         if ((act_comm != MN_ReplaceNext) || (code != 1))
                              ChangePointer(teditfile, (act_comm == MN_SearchNext) ? GS(MSG_SEARCHING_TITLE) : GS(MSG_REPLACING_TITLE), TRUE, TRUE);

                         // search...
                         replace->success = FindSearchWord(teditfile, replace, &loc1, &loc2, (UWORD) ((act_comm == MN_ReplaceNext) || (code == 2)) ? 0 : 1);
                         if (NOT replace->success)
                         {
                              if ((act_comm != MN_ReplaceNext) || (code != 1))
                                   ChangePointer(teditfile, act_doc->name, FALSE, FALSE);
                              break;
                         }

                         // set cursor / select the word + set refresh - before set cursor position as then UnmarkBlock and MakeCursorVisible takes place
                         if ( (act_doc->display_begin.line_num <= cursor->line_num) &&
                              (act_doc->display_end.line_num >= cursor->line_num) )
                         {
                              invalidate1 = TRUE;
                              invalidate_lines1 = 1;
                              invalidate_offset1 = cursor->line_num - act_doc->display_begin.line_num;
                              invalidate_erase1 = FALSE;
                         }
                         if ( (act_doc->display_begin.line_num <= loc1.line_num) &&
                              (act_doc->display_end.line_num >= loc1.line_num) )
                         {
                              invalidate2 = TRUE;
                              invalidate_lines2 = 1;
                              invalidate_offset2 = loc1.line_num - act_doc->display_begin.line_num;
                              invalidate_erase2 = FALSE;
                         }

//  dist and format FALSE - have to be done after MakeCursor visible                        SetCursorPosition(teditfile, &loc1, (act_comm == MN_ReplaceNext) ? NULL : &loc2, FALSE, TRUE, (BOOL) ((replace->str1 == '\0') ? FALSE : TRUE));
                         SetCursorPosition(teditfile, &loc1, (act_comm == MN_ReplaceNext) ? NULL : &loc2, FALSE, FALSE, (BOOL) ((replace->str1 == '\0') ? FALSE : TRUE));

                         // replace
                         if (act_comm == MN_ReplaceNext)
                         {
                              undo_data = SaveUndoInfo(teditfile, new_undo = UNDO_ReplaceText, (ULONG) &loc1, (ULONG) &loc2, 0);
                              ReplaceThisWord(teditfile, replace, &loc1, &loc2, TRUE, FALSE);
                         }
                         else new_undo = UNDO_Special; // undo info not affected

                         if ((act_comm != MN_ReplaceNext) || (code != 1))
                              ChangePointer(teditfile, act_doc->name, FALSE, FALSE);
                    }

                 // nastaveni obnovy
                    //if ((act_comm != MN_ReplaceNext) || (code == 0))
                         check_cursor = TRUE;     // del_new_ts = TRUE;
//                    if (pspom != cursor->para->style)
                    {    menu_refresh |= MG_ALIGNMENT | MG_SPACING | MG_LINEHEIGHT | MG_SPELLHYP;
                         gadget_refresh |= GG_ALIGNMENT | GG_SPACING;
                         refresh_rooler = TRUE;
                    }
//                    if (tspom != cursor->style)
                    {    menu_refresh |= MG_STYLES | MG_POSITIONS | MG_COLORS;
                         gadget_refresh |= GG_STYLES | GG_POSITIONS;
                    }
                    break;
//<<

               case MN_SetBookmark:
                                   new_undo = UNDO_Special;
                                   act_doc->bookmark = *cursor;
                                   break;
               case MN_SetBookmark2:
                                   new_undo = UNDO_Special;
                                   act_doc->bookmark2 = *cursor;
                                   break;
               case MN_SetBookmark3:
                                   new_undo = UNDO_Special;
                                   act_doc->bookmark3 = *cursor;
                                   break;

               case MN_GoToLine:
               case MN_GoToLineBlock:
                    // addr is not NULL, it points to ULONG with the line number
                    new_undo = UNDO_Special;
                    {
                         ULONG *linenum = (ULONG *) address;
                         ULONG newline;

                         // get line number
                         if (linenum == NULL)
                         {
                              char numbuf[32], textbuf[64];
                              sprintf(numbuf, "%lu", cursor->line_num + 1);
                              sprintf(textbuf, MSG_WINREQ_LINENUMBER_STR, doc->num_lines);

                              TValidator *rangevalidator = new TRangeValidator(1, doc->num_lines);
                              TInputDialog getnumdlg(teditfile, MSG_WINREQ_GOTOLINE_STR, textbuf, numbuf, sizeof(numbuf), NULL, rangevalidator);

                              if (getnumdlg.Execute() == IDOK)
                                   newline = (ULONG) atol(numbuf);
                              else break;
                         }
                         else newline = min_ul(*linenum, doc->num_lines);

			 // set the cursor to the right position
                         {
                              Paragraph *para = doc->para_first;
                              ULONG i;

                              for(i = 1; para && (i < newline); para = para->next, i++);
#ifdef CHECK_BUGS
                              if (para == NULL) { InternalError("Dispatcher - neexistuje radek pro GoToLinePage"); break; }
#else
                              if (para == NULL) break;
#endif
                              if  (NOT BlockToLocation(teditfile, &loc, para->block_first, para->off_first, para, i - 1))
                                   break;

                           // zajistime novy prubeh ...
                              *cursor = loc;
                              comm = BO_SetCursor;     blockqual = FALSE;
                              setcursor_oldcursor_location = oldcursor;
                              prikaz--;

                              if (act_comm == MN_GoToLineBlock)
                                   blockqual = TRUE;
                         }
                    }
                 // nastaveni obnovy
                    check_cursor = TRUE;     // del_new_ts = TRUE;
                    menu_refresh = ~0UL;      gadget_refresh = ~0UL;
                    refresh_rooler = TRUE;
               	    break;

               case MN_GoToColumn:
               case MN_GoToColumnBlock:
                    // addr is not NULL, it points to ULONG with the line number
                    new_undo = UNDO_Special;
                    {
                         ULONG *colnum = (ULONG *) address;
                         ULONG newcol;

                         // get line number
                         if (colnum == NULL)
                         {
                              char numbuf[32], textbuf[64];
                              sprintf(numbuf, "%lu", cursor->chars_off + 1);
                              sprintf(textbuf, MSG_WINREQ_CHARNUMBER_STR, cursor->para->length);

                              TRangeValidator *rangevalidator = new TRangeValidator(1, cursor->para->length);
                              TInputDialog getnumdlg(teditfile, MSG_WINREQ_GOTOCHAR_STR, textbuf, numbuf, sizeof(numbuf), NULL );
// rangevalidator



                              if (getnumdlg.Execute() == IDOK)

                                  if (rangevalidator->IsValid(numbuf)){
                                   newcol = (ULONG) atol(numbuf);
                                        }
                                      else {
                                      ::MessageBox(NULL,"Not so many characters in this line!","Error", MB_OK);
                                       }


                              else break;
                         }
                         else newcol = min_ul(*colnum, cursor->para->length);

			 // set the cursor to the right position
                         {
                              ULONG i;

                              loc = *cursorline;

                              for(i = 1; i < newcol; i++)
                              {
                                   /*** Modify Start : d-tec ***/
                                   if (_ismbslead(loc.block->memory, loc.block->memory+loc.block_off)) i++;
                                   /*** Modify End : d-tec ***/
                                   (void) GetNextPos(teditfile, &loc, FALSE, 1);
                              }

                           // zajistime novy prubeh ...
                              *cursor = loc;
                              comm = BO_SetCursor;     blockqual = FALSE;
                              setcursor_oldcursor_location = oldcursor;
                              prikaz--;

                              if (act_comm == MN_GoToColumnBlock)
                                   blockqual = TRUE;
                         }
                    }
                 // nastaveni obnovy
                    check_cursor = TRUE;     // del_new_ts = TRUE;
                    menu_refresh = ~0UL;      gadget_refresh = ~0UL;
                    refresh_rooler = TRUE;
               	    break;
                    
               case MN_GoToBookmark:
                    new_undo = UNDO_Special;
               	    if (act_comm == MN_GoToBookmark)
                    {
                         if (act_doc->bookmark.block == NULL) break;
                         *cursor = act_doc->bookmark;
                    }
               case MN_GoToBookmark2:
                    new_undo = UNDO_Special;
               	    if (act_comm == MN_GoToBookmark2)
                    {
                         if (act_doc->bookmark2.block == NULL) break;
                         *cursor = act_doc->bookmark2;
                    }
               case MN_GoToBookmark3:
                    new_undo = UNDO_Special;
               	    if (act_comm == MN_GoToBookmark3)
                    {
                         if (act_doc->bookmark3.block == NULL) break;
                         *cursor = act_doc->bookmark3;
                    }
               case MN_GoToCursor:
                    new_undo = UNDO_Special;
                    if (act_comm == MN_GoToCursor)
                    {
                         int *coords = (int *) address;
                         int x = coords[0], y = coords[1];
                         
                         if (NOT CoordsToLocation(teditfile, &pomloc, x, y, blockqual))
                              break;
                         *cursor = pomloc;
                    }

//>> "realizace GoToBookmark"
                    new_undo = UNDO_Special;
                 // zajistime novy prubeh ...
                    comm = BO_SetCursor;     
                    if (act_comm != MN_GoToCursor)     // gotocursor allow us to select block
                         blockqual = FALSE;
// always needed                    if (blockqual)
                    setcursor_oldcursor_location = oldcursor;
//                    mi->mi_Command = BO_SetCursor;
//                    record_next_macro = FALSE;
//                    mi--;
                    prikaz--;
//                    act_doc->act_page = act_doc->cursor.page->num;
                 // nastaveni obnovy
                    check_cursor = TRUE;     // del_new_ts = TRUE;
                    menu_refresh = ~0UL;      gadget_refresh = ~0UL;
                    refresh_rooler = TRUE;

 		    // set refresh - this line will be erased                    
                    if ( (act_doc->display_begin.line_num <= oldcursor.line_num) &&
                         (act_doc->display_end.line_num >= oldcursor.line_num) )
                    {
                    	 invalidate2 = TRUE;
                         invalidate_lines2 = 1;
                         invalidate_offset2 = oldcursor.line_num - act_doc->display_begin.line_num;
                         invalidate_erase2 = FALSE;
                    }
                    break;
//<<

               case MN_CaseLower:       case MN_CaseUpper:
               case MN_CaseChange:      case MN_CaseCapital:
                 // undo akce
                    undo_data = SaveUndoInfo(teditfile, new_undo = UNDO_FontFormat, 0, 0, 0);

                    ChangeBlockCase(teditfile, act_comm);
                    // redraw the selected lines
                    if (act_doc->block)
                    {
                         if ( (act_doc->display_begin.line_num <= act_doc->block_begin.line_num) &&
                              (act_doc->display_end.line_num >= act_doc->block_begin.line_num) )
                         {
                              invalidate1 = TRUE;
                              invalidate_lines1 = act_doc->block_end.line_num - act_doc->block_begin.line_num + 1;
                              invalidate_offset1 = act_doc->block_begin.line_num - act_doc->display_begin.line_num;
                              invalidate_erase1 = FALSE;
                         }
                         else
                         if ( (act_doc->display_begin.line_num <= act_doc->block_end.line_num) &&
                              (act_doc->display_end.line_num >= act_doc->block_end.line_num) )
                         {
                              invalidate1 = TRUE;
                              invalidate_lines1 = act_doc->block_end.line_num - act_doc->display_begin.line_num + 1;
                              invalidate_offset1 = 0;
                              invalidate_erase1 = FALSE;
                         }
                    }
                    else
                    {
                         if ( (act_doc->display_begin.line_num <= cursor->line_num) &&
                              (act_doc->display_end.line_num >= cursor->line_num) )
                         {
                              invalidate1 = TRUE;
                              invalidate_lines1 = 1;
                              invalidate_offset1 = cursor->line_num - act_doc->display_begin.line_num;
                              invalidate_erase1 = FALSE;
                         }
                    }

                    act_doc->newfile = FALSE;    act_doc->changes = TRUE;
                    break;
          }
     }
//<<
//>> COMM_REFRESH
     else if ((COMM_REFRESH <= act_comm) && (act_comm <= COMM_SPEC) /* && NOT act_doc->frame */)
     {    /* ruzne refresh operace apod. */
          new_undo = UNDO_Special;
     }
//<<
//>> COMM_SPEC
     else if (COMM_SPEC <= act_comm)
     {
          Location *cursor, *cursorline, oldcursor;

          cursor = &act_doc->cursor;
          cursorline = &act_doc->cursorline;
          oldcursor = *cursor;

          new_undo = UNDO_Special;

          switch (act_comm)
          {
               case SPEC_DisplayBeep:   new_undo = UNDO_Special;
                                        BeepEditor();
                                        break;

               case SPEC_NewVertPos:
                    // address points to ULONG - the new position
                    {
                         ULONG newpos = *( (ULONG *) address);

                         new_undo = UNDO_Special;
                         act_doc->cursor_checked = FALSE;
                         if (SetNewVertPos(teditfile, newpos, 0, TRUE))
                              send_paint = TRUE;
                    }
                    break;

               case SPEC_ScrollUp:
               case SPEC_ScrollDown:
                    // these two are equivalent
                    // address points to LONG - delta position
                    {
                         LONG delta = *( (LONG *) address);

                         new_undo = UNDO_Special;
                         act_doc->cursor_checked = FALSE;
                         if (SetNewVertPos(teditfile, 0, delta, TRUE))
                              send_paint = TRUE;
                    }
                    break;

               case SPEC_NewHorizPos:
                    // address points to ULONG - the new position
                    {
                         ULONG newpos = *( (ULONG *) address);

                         new_undo = UNDO_Special;
                         act_doc->cursor_checked = FALSE;
                         if (SetNewHorizPos(teditfile, newpos, 0, TRUE))
                              send_paint = TRUE;
                    }
                    break;

               case SPEC_ScrollLeft:
               case SPEC_ScrollRight:
                    // these two are equivalent
                    // address points to LONG - delta position
                    {
                         LONG delta = *( (LONG *) address);

                         new_undo = UNDO_Special;
                         act_doc->cursor_checked = FALSE;
                         if (SetNewHorizPos(teditfile, 0, delta, TRUE))
                              send_paint = TRUE;
                    }
                    break;

               case SPEC_GetCursorWord:
                    // addr should point to the buffer, code contains its length
                    // if blockqual is true, then the cursor is set to the beg of the word
                    // get the word
                    {
                         Location pom = act_doc->cursor, pom1;
                         MemoryBlock *mb, *mbend;
                         ULONG off, i, offend, buflen = code;
                         UBYTE *znak, *strbuf = (char *) address;

                         new_undo = UNDO_Special;

                         if ((code <= 0) || (strbuf == NULL))
                              break;
                         clrmem(strbuf, buflen);

                         GetPrevWord(teditfile, &pom, NULL, NULL, NULL, FALSE, TRUE);
                         pom1 = pom;
                         GetNextWord(teditfile, &pom1,NULL, NULL, NULL, FALSE, TRUE, FALSE);
                         if ( (pom1.block == act_doc->cursor.block) && (pom1.block_off == act_doc->cursor.block_off) &&
                               NOT (LastParaChar(&pom1) && (pom1.para == act_doc->para_last))
                            )
                              pom = doc->cursor;
                         pom1 = pom;
                         GetNextWord(teditfile, &pom1, NULL, NULL, NULL, FALSE, TRUE, TRUE);

                         mb = pom.block;          mbend = pom1.block;
                         off = pom.block_off;     offend = pom1.block_off;
                         znak = mb->memory + off; i = 0;

                         while ((mb != mbend) || (off != offend))
                         {
                              if (NOT ENDLINE(*znak))
                                   strbuf[i++] = *znak;
                              /*** Modify Start : d-tec  ***/
                              if (_ismbslead(mb->memory, znak))
                                   strbuf[i++] = *znak;
                              /*** Modify End : d-tec  ***/
                              if (i + 2 >= buflen)
                                   break;
                              znak = IncrementPosMB(&mb, &off);
                              if (znak == NULL)
                                   break;
                         }

                         // set cursor to the beg of the word
                         if (blockqual)
                         {
                              *cursor = pom;
                              comm = BO_SetCursor;   	blockqual = FALSE;
                              setcursor_oldcursor_location = oldcursor;
                              prikaz--;
                         }
                    }
                    break;
          }
     }
//<<

end_of_doc_comm:
     if (act_doc)        // nasl. upravy jsou jen pro dokumenty
     { // prace s undo
          if (act_comm == SPEC_NoneOperation)
               new_undo = UNDO_Special;
          // update undo information if there is any 
          if (/* Prefs.general.undo_active && */ (new_undo != UNDO_Special))    
               UpdateUndoInfo(teditfile, new_undo, undo_data);

// invalidate necessary regions
          if (invalidate1)
               InvalidateLines(teditfile, invalidate_lines1, invalidate_offset1, invalidate_erase1);
          if (invalidate2)
               InvalidateLines(teditfile, invalidate_lines2, invalidate_offset2, invalidate_erase2);
          if (invalidate1 || invalidate2)
               send_paint = TRUE;

       /* ma se kontrolovat, zda je kurzor ve viditelnem vyrezu */
          if (check_cursor)
          {    // if (old_num_pages != act_doc->num_pages) gadget_refresh |= GG_PAGEINFO | GG_SCROLLERS;
               if (MakeCursorVisible(teditfile, menu_refresh, gadget_refresh, refresh_rooler))
                    send_paint = TRUE;
          }
//          else
//          { /* prekresleni gadgetu a menu ... aby indikovaly spravny stav */
//               if (menu_refresh) RedrawMenus(act_doc, menu_refresh);
//               if (gadget_refresh) RedrawGadgets(act_doc, gadget_refresh, TRUE);
//            /* prekresleni symbolu na liste ... */
//               if (refresh_rooler) DrawSymbols(act_doc, ~0, 0, FALSE, TRUE);
//          }
       // oprava titulku okna pri zmene statutu; cte se jen, titulek muze byt v PPC pameti
          if (act_doc->changes != actdoc_changes)
               SetWindowTitle(teditfile, NULL);
     }
} // konec hlavni for() smycky

  // obnovime pozmenenou promenou
//     if (mistart) num_commands = baknumcommands;

     return(send_paint);
} /* DispatchMessages */
//<<

