/*
 * BDT-Hook.c       modul s hook fcemi.
 */

#define BDT_HOOK_C

#include "wed_editor.h"
/*** Modify Start : d-tec  ***/
#include <mbctype.h>
/*** Modify End : d-tec  ***/



/* nahrazeni maker Defs.h */
/* pomocna fce ENDLINE nahrazujici makro ... */
BOOL ENDLINE(UBYTE znak)
//>>
{
     return((BOOL) (((znak == CH_EOL) || (znak == CH_EOLD) || (znak == CH_EOP)) ? TRUE : FALSE) );
}
//<<

/* pomocna fce SPECIALCHAR nahrazujici makro ... */
BOOL SPECIALCHAR(UBYTE znak)
//>>
{
     return (FALSE);
//     return((BOOL) (((CH_NUMBER <= znak) && (znak <= CH_PAGECOUNT)) ? TRUE : FALSE) );
}
//<<

/* pomocna fce SEPARATOR; urcuje, co povazujeme za oddelovace slov */
BOOL SEPARATOR(TEditFile *teditfile, UBYTE znak)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     if (doc->no_separator_separator) return(FALSE);
     return((BOOL) ((((znak < 127) && NOT isalnum(znak)) || (znak == 160)) ? TRUE : FALSE) );
//     return((BOOL) ((((znak < 127) && NOT isalnum(znak)) || (znak == 160)) ? TRUE : FALSE) );
}
//<<

/* pomocne funkce, ktere k zadane poloze MemoryBlock/Offset urci nasledujici,
 * resp. predchazejici polohu a vrati jako vysledek ukazatel na dany znak;
 * vrati-li NULL = jsme na konci nebo na zacatku; predpoklada se, ze dana
 * poloha existuje */
// tato funkce je obsazena v import/export knihovnach !!!
UBYTE *IncrementPosMB(MemoryBlock **mb, ULONG *off)
//>>
{
     MemoryBlock *block = *mb;

/*** Modify Start : d-tec  ***/
	do {
/*** Modify End : d-tec  ***/

     (*off)++;
  /* zajisteni pripadneho preskoku na dalsi pametovy blok */
     if (*off + block->free >= block->size)
     {
          if (block->next == NULL)
          {
               (*off)--;           return(NULL);
          }
          *mb = block = block->next;         *off = 0;
     }

/*** Modify Start : d-tec  ***/
	} while (_ismbstrail(block->memory, block->memory + *off));
/*** Modify End : d-tec  ***/

     return(block->memory + *off);
}
//<<

UBYTE *DecrementPosMB(MemoryBlock **mb, ULONG *off)
//>>
{
     MemoryBlock *block = *mb;

/*** Modify Start : d-tec  ***/
	do {
/*** Modify End : d-tec  ***/

  /* zajisteni pripadneho preskoku na dalsi pametovy blok */
     if (*off > 0) (*off)--;
     else
     {
          if (block->prev == NULL)
          {
               return(NULL);
          }
          *mb = block = block->prev;    *off = block->size - block->free - 1;
     }

/*** Modify Start : d-tec  ***/
	} while (_ismbstrail(block->memory, block->memory + *off));
/*** Modify End : d-tec  ***/

     return(block->memory + *off);
}
//<<

/* male fce umistene sem kvuli rychlosti - Line.c */
/* tato fce provede test pocatku odstavce ... */
BOOL FirstParaChar(Location *loc)
//>>
{
     if (loc->chars_off == 0)
#ifdef CHECK_BUGS
          if (NOT ((loc->block == loc->para->block_first) && (loc->block_off == loc->para->off_first)) )
          {    InternalError("First/Last Para/Page char/Line");    return(FALSE);     }
          else return(TRUE);
#else
          return(TRUE);
#endif

#ifdef CHECK_BUGS
     if ((loc->block == loc->para->block_first) && (loc->block_off == loc->para->off_first))
     {    InternalError("First/Last Para/Page char/Line");    return(TRUE);    }
#endif
     return(FALSE);
}
//<<

/* tato fce provede test konce odstavce ... */
BOOL LastParaChar(Location *loc)
//>>
{
     if (loc->chars_off + 1 == loc->para->length)
#ifdef CHECK_BUGS
          if (NOT ((loc->block == loc->para->block_last) && (loc->block_off == loc->para->off_last)) )
          {    InternalError("First/Last Para/Page char/Line");    return(FALSE);     }
          else return(TRUE);
#else
          return(TRUE);
#endif

#ifdef CHECK_BUGS
     if ((loc->block == loc->para->block_last) && (loc->block_off == loc->para->off_last)) 
     {    InternalError("First/Last Para/Page char/Line");    return(TRUE);    }
#endif
     return(FALSE);
}
//<<

/* pomocne fce - urci, zda se jedna o prvni/posledni radku odstavce */

BOOL FirstParaLine(Location *loc)
//>>
{
     return(TRUE);
//     if (loc->line == loc->para->line_first)
//          return(TRUE);
//     else return(FALSE);
}
//<<

BOOL LastParaLine(Location *loc)
//>>
{
     return(TRUE);
//     if (loc->line == loc->para->line_last)
//          return(TRUE);
//     else return(FALSE);
}
//<<

/* vypocet absolutni hodnoty a maxima a minima - pro WORD a LONG */
//WORD abs_w(WORD x)
////>>
//{
//     return((WORD) ((x > 0) ? x : -x) );
//}
////<<

ULONG abs_l(LONG x)
//>>
{
     return((ULONG) ((x > 0) ? x : -x) );
}
//<<

//// maxima
//WORD max_w(WORD a, WORD b)
////>>
//{
//     return((WORD) ((a > b) ? a : b) );
//}
////<<

UWORD max_uw(UWORD a, UWORD b)
//>>
{
     return((UWORD) ((a > b) ? a : b) );
}
//<<

LONG max_l(LONG a, LONG b)
//>>
{
     return((LONG) ((a > b) ? a : b) );
}
//<<

ULONG max_ul(ULONG a, ULONG b)
//>>
{
     return((ULONG) ((a > b) ? a : b) );
}
//<<

//// minima
//WORD min_w(WORD a, WORD b)
////>>
//{
//     return((WORD) ((a < b) ? a : b) );
//}
////<<

UWORD min_uw(UWORD a, UWORD b)
//>>
{
     return((UWORD) ((a < b) ? a : b) );
}
//<<

LONG min_l(LONG a, LONG b)
//>>
{
     return((LONG) ((a < b) ? a : b) );
}
//<<

ULONG min_ul(ULONG a, ULONG b)
//>>
{
     return((ULONG) ((a < b) ? a : b) );
}
//<<

int sign(int i)
{
     if (i > 0)
     	return 1;
     else if (i < 0)
     	return -1;
     else
     	return 0;
}

void UpdateColumnsNumber(TEditFile *teditfile, BOOL all)
// if all == TRUE, whole file is scanned; otherwise only cursor row
{
     return;
}

