/*
 * BDT-Docs-Import+Export.c   modul s obecne uzitecnymi fcemi pro import a export
 */

#define BDT_DOCS_IMPORT_EXPORT_C

#include "wed_editor.h"



/* pomocne fce */
// fce na test existence souboru - na zadost se rovnou prepta, zda se ma
// soubor prepsat a otestuje, zda to neni adresar
BOOL CanWriteToFile(TEditFile *teditfile, STRPTR name, BOOL ask_overwrite, BOOL only_files)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

//     BPTR flock = Lock(name, SHARED_LOCK);
//     struct FileInfoBlock *FIB;
     int filemode = ExamineFileMode((char *) name);
     BOOL dotaz = FALSE, warndir = FALSE, canwrite = FALSE;

     if ((filemode == EX_FM_DOESNOTEXIST) || (filemode == EX_ERROR))
          return (canwrite = TRUE);
     else if (filemode == EX_FM_REGULARFILE)
          dotaz = TRUE;
     else if (filemode == EX_FM_DIRECTORY)
          warndir = (only_files) ? TRUE : FALSE;
     else warndir = TRUE;

// nelze-li soubor zamknout - patrne neexistuje ... (popr. nepujde otevrit)
//     if (flock)
//     {    dotaz = TRUE;
//          if ( ((FIB  = AllocDosObject(DOS_FIB, NULL)) == NULL) )
//               dotaz = TRUE;
//          else
//          {
//               if (Examine( flock, FIB ) == 0) dotaz = TRUE;
//               else
//               {    
//                    if (only_files && (FIB->fib_DirEntryType > 0))
//                         warndir = TRUE;
//               }
//               FreeDosObject(DOS_FIB, FIB);
//          }
//          UnLock(flock);
//     }
     
     if (warndir) 
          Information2(teditfile, GS(MSG_YOU_MUST_SELECT_FILE));
     else if (NOT dotaz || NOT ask_overwrite) 
               canwrite = TRUE;
          else canwrite = TRUE;
// Windows dialog window checks this already! canwrite = (1 == QuestionYesNo(teditfile, doc->name, GS(MSG_ASK_OVERWRITE_FILE))) ? TRUE : FALSE;
//          else canwrite = (1 == Question(doc->name, GS(MSG_ASK_OVERWRITE_FILE), GS(MSG_OVERWRITE_CANCEL))) ? TRUE : FALSE;

     return(canwrite);
}
//<<

// nasledujici fce provadi zalohovani souboru, do nehoz se bude
// ukladat text - ten je dan obsahem doc->path & name
void MakeBackup(TEditFile *teditfile)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     char savefile[PATH_LEN + FILENAME + 6], bakfile[PATH_LEN + FILENAME + 16];

  // vytvorime jmeno souboru se zalohou; bakfile ma rezervu na ".bak"
// on DOS/Windows should path contain the whole path including the name of the document
     strcpy(savefile, doc->path);
//     (void) AddPart(savefile, doc->name, PATH_LEN + FILENAME + 4);
     strcpy(bakfile, savefile);
     strcat(bakfile, ".bak");
  // DeleteFile a Rename by mely data jen cist - ok pro PPC
  // pokusime se jiz existujici zalozni soubor smazat
     (void) DeleteFile(bakfile);
  // puvodni soubor, do nehoz se ted bude zapisovat, prejmenujeme na ".bak"
     (void) Rename(savefile, bakfile);
}
//<<

void PrevodMeziKody(UBYTE *mem, ULONG *len, ULONG buflen)
//void PrevodMeziKody(UBYTE *mem, ULONG len, CodePage code, BOOL toKOI, int mode)
// ASCII editor: this function ignores codepage and mode and does the following:
//   - does not allow any nonprintable characters except for CH_TAB and CH_EOL
//   - converts { CH_EOLD, CH_EOL } --> { CH_EOL }
//   - converts single CH_EOLD --> CH_EOL
//   - variable len is adjusted for removed CH_EOLDs
//   - buflen sets the length of the buffer in which the data are
//   - if buflen == 0 -> CH_EOLD replaced by spaces
//>>
{
     ULONG zbyva;
     
     // buflen shows the number of bytes from mem to the end of buffer
     if (buflen < *len) buflen = 0;
     for(zbyva = *len; zbyva > 0; zbyva--, mem++, buflen--)
     {
          if (*mem >= CH_SPACE)
               continue;

          if ((*mem == CH_EOL) || (*mem == CH_TAB))
               continue;

          if (*mem == CH_EOLD)
          {
               if ((zbyva > 1) && (mem[1] == CH_EOL)) // we are not at the last character in the buffer
               {
                    if (buflen > 0)
                    {
                         // remove CH_EOLD + decrease len
                         memmove(mem, mem + 1, buflen - 1);
                         *len -= 1;
                         mem--;	// pointer does not have to be moved
                    }
                    // replace CH_EOLD by space
                    else *mem = CH_SPACE;
               }
               else *mem = CH_EOL;
               continue;
          }
               
          *mem = CH_SPACE;
     }
} /* end PrevodMeziKody */
//<<

