/*
 * BDT-Docs-Init+Close.c rutiny pro inicializaci novych dokumentu a jejich zavirani
 */

#define BDT_DOCS_INIT_CLOSE_C

#include "wed_editor.h"



// FCE PRO INICIALIZACI/UVOLNENI PAMETI PRO DOKUMENT //

/* fce pro inicializaci struktur, pameti apod. pro vytvoreni noveho dokumentu
 * (ci nasledneho nacteni existujiciho); globalni promenne - CreateNewDoc */
// vraci ukazatel na EditFile (OK) nebo NULL (neni dost pameti)
EditFile *InitDocObjects(TEditFile *teditfile)
//>>
{
     EditFile *newdoc = teditfile->GetEditFile();

//     EditFile *new = InitStructure(EDITFILE, NULL);
     UBYTE *mem = (UBYTE *) LibAllocPooled(GETPOOLHEADER, SIZE_TEXT);
//     UBYTE *mem = (new) ? LibAllocPooled(PoolHeader, SIZE_TEXT) : NULL;
     ULONG dummy;
     APTR objects[] = {  (APTR) 1234,
                         (APTR) -1,                     (APTR) -1,                      NULL /* MemoryBlock*/,
                         (APTR) -1,                     (APTR) -1,                      (APTR) -1,                     
                         (APTR) -1,                     (APTR) -1,                      (APTR) -1 /* Location */,
                         (APTR) -1,                     NULL /* Paragraph */,           (APTR) -1,
                         (APTR) -1,                     (APTR) -1,                      (APTR) -1,                     
                         (APTR) -1,                     (APTR) -1,                      (APTR) -1,                     
                         (APTR) -1,                     (APTR) -1,                      (APTR) -1,                     
                         (APTR) -1,                     (APTR) -1,                      (APTR) -1,                    
                         (APTR) -1,                     (APTR) -1,                      (APTR) -1,                     
                         (APTR) -1 /* GlobalPrefs */,   (APTR) -1 /* EditFile */,       (APTR) -1,                     
                         (APTR) -1,                     (APTR) -1 /* ReplaceState */,   (APTR) -1,                     
                         (APTR) -1,                     (APTR) -1,                      (APTR) -1,
                         (APTR) -1,                     (APTR) -1,                      (APTR) -1
                      };
     BOOL alloc_ok = TRUE;
     ULONG i;

// new doc is not allocated by InitStructure - we have to clean it first
     clrmem(newdoc, sizeof(EditFile));
     
//     if (new == NULL) return(NULL);
     if (mem == NULL) return(NULL);     // not enough memory
//     if (mem == NULL) { FreeStructure(EDITFILE, new); return(NULL); }
/* alokace potrebne pameti */
     for( i = 1; i <= NUM_STRUCTS; i++)
	  if (objects[i] == NULL) objects[i] = InitStructure(i, NULL);
     for( i = 1; i <= NUM_STRUCTS; i++)
	  if (objects[i] == NULL) alloc_ok = FALSE;

     if (NOT alloc_ok)
     { /* neni pamet pro pozadovane objekty */
	  for( i = 1; i <= NUM_STRUCTS; i++)
	       if ((objects[i] != NULL) && (objects[i] != (APTR) -1))
		    FreeStructure(i, objects[i]);
	  LibFreePooled(GETPOOLHEADER, mem, SIZE_TEXT);
//	  FreeStructure(EDITFILE, new);
	  return(NULL);  // not enough memory
     }

/* inicializace polozek po rade za sebou */
/* AmigaDOS */
     strcpy(newdoc->name, GS(MSG_DEF_DOC_NAME));
// on DOS/Windows... path have to contain the whole path including the file name
     strcpy(newdoc->path, GS(MSG_DEF_DOC_NAME));
     CurrentTime(&newdoc->opened, &dummy);

/* udaje z Prefs ...; napred, aby se dalo vyuzivat ruznych fci */
//     newdoc->show_invisibles = GETGLOBALPREFS->show_invisibles;
//     newdoc->show_guides     = Prefs.show_guides;
//     newdoc->show_pictures   = Prefs.show_pictures;
//     newdoc->show_headers    = Prefs.show_headers;
//     newdoc->show_footers    = Prefs.show_footers;
//     newdoc->ruler_horiz     = Prefs.ruler_horiz;
//     newdoc->ruler_vert      = Prefs.ruler_vert;
     newdoc->insert          = GETGLOBALPREFS->insert;
//     newdoc->display         = Prefs.display;
//     newdoc->def_items       = Prefs.def_items;
//     newdoc->def_tabs        = Prefs.def_tabs;
     newdoc->tab_size        = GETGLOBALPREFS->tab_size;
//     newdoc->def_indexprefs  = Prefs.def_index;
//     newdoc->def_numformat   = Prefs.def_numformat;
//     newdoc->indexfonts      = NULL;
//     if (newdoc->def_tabs.uselocale)
//	  if (LocaleAvail)
//	       newdoc->def_tabs.dec_char = (*Country->loc_DecimalPoint == CH_PUNCT) ? DC_POINT : DC_COMMA;
//	  else newdoc->def_tabs.dec_char = DC_POINT;
///* merne jednotky ... */
//     if (Prefs.display.unit != MU_LOCALE)
//	  newdoc->munit = Prefs.display.unit;
//     else if (LocaleAvail)
//	       newdoc->munit = (Country->loc_MeasuringSystem == MS_ISO) ? MU_METRIC : MU_INCHES;
//	  else newdoc->munit = MU_METRIC;
//     if (newdoc->munit == MU_METRIC)
//	  {    newdoc->main_coef = CM_MUNIT;    newdoc->coef = MM_MUNIT;    }
//     else {    newdoc->main_coef = INCH_MUNIT;  newdoc->coef = INCH_8_MUNIT;     }
///* znamenko pro deleni slov - co kdyz ta funkce vrati NULL! */
//     if (LocaleAvail)
//	  strncpy(newdoc->softhyph, GetLocaleStr(Country, SOFTHYPHEN), 3);
//     else {    newdoc->softhyph[0] = '-';  newdoc->softhyph[1] = '\0';    }
//     newdoc->softhyph[3] = '\0';
//     newdoc->hyphen_enabled = Prefs.speller.hyphenation;
//     if (Prefs.speller.hyphenation && Prefs.speller.hyph_dict && (SpellerInit == NOINIT))
//	  InitSpeller(MININIT);
///* nastavime zoom na 100% a prislusne veliciny ...; horiz nutno delit 8 */
//     newdoc->doc_zoom = 100;
//     newdoc->zoom_horiz_dpi = newdoc->display.horiz_dpi / 8;
//     newdoc->zoom_vert_dpi  = newdoc->display.vert_dpi;

/* polozky popisujici primo obsah editovaneho souboru */
/* MemoryBlock */
     {    
          MemoryBlock *mb = (MemoryBlock *) objects[MEMORYBLOCK];
          
	  mb->memory = mem;        mb->size = SIZE_TEXT;
	  mb->free = SIZE_TEXT - 1;
	  *mb->memory = CH_EOL;
	  newdoc->block_first = mb;newdoc->block_last = mb;
     }
     
/* Paragraph */
     {    
          Paragraph *p = (Paragraph *) objects[PARAGRAPH];
//	  TextStyle *ts = &newdoc->parastyle_first->ts, *ts2 = objects[TEXTSTYLE];
	  MemoryBlock *mb = newdoc->block_first;

	  p->block_first = mb;     p->block_last = mb;
	  p->length = 1;           // p->lines = 1;
	  p->explength = 0; // PC 20020420 - not initialized here
//	  p->style = newdoc->parastyle_first;
//	  memcpy(ts2, ts, sizeof(struct TextStyle));
//	  ts2->next = NULL;   ts2->prev = NULL;   ts2->offset = 0;
//	  p->ts_first = ts2;  p->ts_last = ts2;

//	  p->topedge = newdoc->actlayout.tm;       // horni okraj
//	  p->line_first = newdoc->line_first;   p->line_last = newdoc->line_first;
	  newdoc->para_first = p;  newdoc->para_last = p;
     }
     
/* Location */
     {    
          Location *cursor = &newdoc->cursor;
//	  ParaStyle *ps = newdoc->para_first->style;

	  cursor->block = newdoc->block_first;
          cursor->block_off = 0;
	  cursor->para = newdoc->para_first;
          cursor->chars_off = 0;
          cursor->line_num = 0;
//	  cursor->page = newdoc->page_first;
//	  cursor->style = newdoc->para_first->ts_first;
//	  cursor->line = newdoc->line_first;
//	  cursor->para_off = GetFirstLineHeight(ps, newdoc->line_first, TRUE, FALSE);
//	  cursor->page_off = cursor->para->topedge + cursor->para_off;
//          CorrectNumeric2(newdoc, &cursor->para_off);
//          CorrectNumeric2(newdoc, &cursor->page_off);

	  newdoc->cursorline = newdoc->display_begin = newdoc->display_end = newdoc->cursor;
     }
/* numericke udaje ... */
//     newdoc->num_pages = 1;
//     newdoc->act_page  = 1;
     newdoc->num_lines = 1;
     newdoc->num_columns = 1;

     // other display parameters (win width and height) are set in UpdateDocWindow or Paint
     newdoc->disp_offset = 0;

     newdoc->undo_steps = 0;	// no undo yet

/* booleovske udaje ... */
     newdoc->active = TRUE;
     newdoc->newfile = TRUE;

     newdoc->block = FALSE;
     newdoc->changes = FALSE;
     newdoc->undo = FALSE;

     newdoc->ticks = 0;
     newdoc->saveticks = 0;
     newdoc->no_separator_separator = FALSE;

/* ruzne vyrezy a graficke informace - viz InitDocWindow */

// pomocne promenne - vetsina FALSE, je jiz nastaveno
//     newdoc->clear_before_writing = TRUE;
//     newdoc->last_dontdraw_para = NULL;
//     newdoc->lostpages_frames = NULL;
//     newdoc->nps_first = NULL;        newdoc->nps_last = NULL;

// alokace undo
     InitUndoInfo(teditfile);
//// macro recors
//     newdoc->macro_file = NULL;

/* navrat ukazatele na EditFile */
     return(newdoc);
} /* end InitDocObjects */
//<<

/* fce pro uvolneni vseho (objektu, pameti) po uzavrenem dokumentu;
 * nestara se o opravu globalnich promennych - viz CloseDoc - ani
 * se nedotazuje uzivatele, zda si to nechce rozmyslet */
void CloseDocObjects(TEditFile *teditfile)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

/* MemoryBlock */
     {    
          MemoryBlock *mb = doc->block_first;
	  while (mb)
	  {    LibFreePooled(GETPOOLHEADER, mb->memory, mb->size);
	       mb = (MemoryBlock *) FreeStructure(MEMORYBLOCK, mb);
	  }

          // clear so that it can be called more times
          doc->block_first = doc->block_last = NULL;
     }
/* Paragraph */
     {
          Paragraph *p = doc->para_first;
//	  TextStyle *ts;

	  while (p)  // prvni TextStyle je primo v ParaStyle - neuvolnuje se
	  {
               // for(ts = p->ts_first; ts; ts = FreeStructure(TEXTSTYLE, ts));
	       p = (Paragraph *) FreeStructure(PARAGRAPH, p);
	  }

          // clear so that it can be called more times
          doc->para_first = doc->para_last = NULL;
     }

// uvolneni undo
     FreeUndoInfo(teditfile);
//// pokud je aktivni zaznam, musi soubor zavrit
//     if (doc->macro_file) StopMacroRecord(doc);

///* pripadne new_ts - novy styl */
//     if (doc->new_ts) FreeStructure(TEXTSTYLE, doc->new_ts);
/* objekty Intuitionu - zavre CloseDocWindow */
} /* end CloseDocObjects */
//<<

// FUNKCE PRO CELE DOKUMENTY //

/* funkce pro vytvoreni noveho (prazdneho dokumentu) */
// vraci TRUE (OK) ci FALSE (not enough memory)
BOOL CreateDoc(TEditFile *teditfile)
//>>
{
//     BOOL pos[NUMEDITEDFILES + 4]; // pro urceni volneho mista pro novy dokument
//     int i, freepos;               // nalezene volne misto...
     EditFile *newdoc;
//     WORD le, te;

//     if (NumDocs == NUMEDITEDFILES)
//     {    Information2(NULL, GS(MSG_MAX_NUM_FILES_REACHED)); return(FALSE);   }

/* alokace potrebne pameti ... */
     if ((newdoc = InitDocObjects(teditfile)) == NULL)
     {    
          Information2(teditfile, GS(MSG_NO_MEMORY_FOR_NEW_DOC)); 
          return(FALSE);   
     }

//     OpenedDocs++;

///* oprava globalnich promennych editoru - uz je vse otevreno */
//     Docs[NumDocs++] = newdoc;     ActiveDoc = NumDocs - 1;
//  // nutno zde - po nastaveni docs
//     if (EasyRexxBase && ARexxContext)
//	  SetMacroMenu();
//  // totez pro recentdocs
//     UpdateRecentDocsMenu(NULL);

     return(TRUE);
} /* end CreateDoc */
//<<

/* fce pro uzavreni dokumentu - opravi vsechny globalni promenne, prepta se
 * uzivatele na potvrzeni akce (je-li to zadano - confirm) ... */
// vraci TRUE (OK - zavreno) ci FALSE (zruseno zavreni)
BOOL CloseDoc(TEditFile *teditfile, BOOL confirm)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

//     struct Window *win;
     int i, id = -1;
     BOOL testover = FALSE;
//     extern __far BOOL ARexxCloseForce;
//     extern __far BOOL ARexxQuitForce;

//     if (FALSE)
////     if (doc->changes)
////     if (doc->changes && NOT ARexxCloseForce && NOT ARexxQuitForce)
//     { /* dotaz, zda chce uzivatel opravdu zavrit dokument */
//       /* je-li confirm == TRUE, pak ma moznost to zrusit */
//	  LONG i = (confirm) ? QuestionYesNoCancel(teditfile, doc->name, GS(MSG_TEXT_NOT_SAVED)) : 
//	                       QuestionYesNo(teditfile, doc->name, GS(MSG_TEXT_NOT_SAVED));
////	  LONG i = Question(doc->win, &doc->req, doc->name, GS(MSG_TEXT_NOT_SAVED),
////			    (confirm) ? GS(MSG_YES_NO_CANCEL_ANSWER) : GS(MSG_YES_NO_ANSWER), NULL);
////
//	  if (confirm && (i == 0)) 
//               return(FALSE);
//          
//	  if (i == 1)
//	  { // ulozeni dokumentu
//	       testover = FALSE;
//	       if (doc->last_saved == 0)
//	       {    
//                    if (NOT BDTFileRequester(teditfile, GS(MSG_REQ_SELECT_FILE), GS(MSG_REQ_SAVE_TEXT), NULL, TRUE))
////                    if (NOT BDTFileRequester(teditfile, GS(MSG_REQ_SELECT_FILE), GS(MSG_REQ_SAVE_TEXT), NULL, TRUE, FALSE, FILTER_FORMBDED))
//			 return(FALSE);
//		    testover = TRUE;
//	       }
//	       if (NOT SaveDiskDoc(teditfile, testover, BDE_SAVE_NEWEST)) return(FALSE);
//	  }
//     }
//     ARexxCloseForce = FALSE;

///* oprava globalnich promennych */
//     Docs[NUMEDITEDFILES + 1] = NULL;
//     for(i = 0, id = -1; i <= NUMEDITEDFILES; i++)
//	  if (doc == Docs[i]) id = i;
//#ifdef CHECK_BUGS
//     if (id == -1) InternalError("CloseDoc");
//#endif
//     if (id >= 0)
//	  memmove(Docs + id, Docs + id + 1, (size_t) ((NUMEDITEDFILES - id) * sizeof(EditFile *)));
//     NumDocs--;

/* uvolneni veskere pameti */
     CloseDocObjects(teditfile);

     return(TRUE);
} /* CloseDoc */
//<<

