/*
 * BDT-Memory.c     modul s fcemi pro operace s blokove organizovanou pameti
 */

// ! funkce pro prace s pameti NEMODIFIKUJI zadane location ! //

#define BDT_MEMORY_C

#include "wed_editor.h"
/*** Modify Start : d-tec  ***/
#include <mbctype.h>
/*** Modify End : d-tec  ***/



// pomocne makro pro fce vkladani a mazani z bloku - testuje, zda se nejedna
// o zacatek prvniho meneneho bloku - ten se totiz nezmeni ...;
// pouzije se pouze pri mazani !
#define NOTBEGFIRSTBLOCK(b1, off1, fb, foff) (NOT ((b1 == fb) && (off1 < foff)))

// vkladani musi zatim vystacit s vyse uvedenou fci na vlozeni neformatovaneho
// textu do odstavce; vlozeni obecne bude specialne vyrobeno pouze pro
// vlozeni bloku z clipboardu !



/* interni promenne tohoto modulu */
  /* pomocna vyrovnavaci pamet pro prenos dat pri zarovnavani pametovych bloku */
// musi byt lokalni static UBYTE buffer_pro_prenos[FREEMEM_MAX + 4];
  /* pomocna vyrovnavaci pamet pro kopirovani do bloku -
   * musi byt vetsi nez TEXT_SIZE blok */
static UBYTE trans_buffer[SIZE_TEXT + 4];
  /* booleovska promenna - udava, zda byly ubrany ci pridany pametove bloky */
// static BOOL blocks_changed = FALSE;     // asi jen pro mazani bloku ...

/* interni fce tohoto modulu */
// PRED DULEZITYMI OPERACEMI S DOKUMENTEM SE BUDE KONTROLOVAT DOSTATEK    //
// PAMETI PRO POZADOVANE OPERACE, TJ. PRITOMNOST ALESPON 10 - 20 KB VOLNA //
BOOL CheckFreeMemory(ULONG req)
//>>
{
//     ULONG free = AvailMem(MEMF_PUBLIC);
//
//     if (free > PUDDLESIZE + req)
//     {    if (free > 4*PUDDLESIZE) return(TRUE);
//       // pokud je jiz malo pameti --> overime spojity usek...
//	  free = AvailMem(MEMF_PUBLIC | MEMF_LARGEST);
//	  if (free > PUDDLESIZE + TRESHSIZE) return(TRUE);
//     }
//// ohlaseni nedostatku pameti //
//     AlertMessage(GS(MSG_ALERT_NO_MEMORY_AVAILABLE), NULL);
//     return(FALSE);
     return(TRUE);
}
//<<

/* pomocna fce pro smazani flagu mb->changed a mb->user pred nekterymi operacemi */
void ClearBlockChanges(MemoryBlock *mb)
//>>
{
     for(; mb; mb = mb->next)
     {    mb->changed = FALSE;
	  mb->user = 0;            mb->user2 = 0;
     }
}
//<<

/* pomocna fce pro porovnani dvou pozic radek udanych v LineNode;
 * vraci -1 (prvni je mensi), 0 (rovnaji se), 1 (druhy je mensi) */
/* predpoklada se, ze obe zadane radky jsou ze stejneho seznamu */
short CompareParaLinePos(Paragraph *p1, Paragraph *p2)
//>>
{ // uzly jsou shodne
     if ((p1 == NULL) || (p2 == NULL)) return(0);
     if (p1 == p2) return(0);
  // uzly jsou ruzne
     for(; p1 && (p1 != p2); p1 = p1->next);
     if (p1 == NULL) return(1); else /* p1 == p2 */ return(-1);
} /* end CompareParaLinePos */
//<<

/* pomocna fce pro porovnani dvou pozic udanych v pametovych blocich;
 * vraci -1 (prvni je mensi), 0 (rovnaji se), 1 (druhy je mensi) */
/* predpoklada se, ze oba zadane bloky jsou ze stejneho seznamu */
short CompareBlockPos(MemoryBlock *mb1, ULONG off1, MemoryBlock *mb2, ULONG off2)
//>>
{ // bloky jsou shodne
     if ((mb1 == NULL) || (mb2 == NULL)) return(0);
     if (mb1 == mb2)
	  if (off1 < off2) return(-1);
	  else if (off1 == off2) return(0);
	       else return(1);
  // bloky jsou ruzne
     for(; mb1 && (mb1 != mb2); mb1 = mb1->next);
     if (mb1 == NULL) return(1); else /* mb1 == mb2 */ return(-1);
} /* end CompareBlockPos */
//<<

/* fce, ktera zjisti, zda je pozice v pametovem bloku mezi druhymi dvema
 * zadanymi pozicemi; mb1 je blizsi, mb2 vzdalenejsi od pocatku - EXISTUJI !!! */
BOOL BlockPosBetween(MemoryBlock *mbtest, ULONG offtest,
		     MemoryBlock *mb1, ULONG off1,
		     MemoryBlock *mb2, ULONG off2)
//>>
{    MemoryBlock *pom;
  // nejprve specialni pripad
     if ((mb1 == mbtest) && (off1 <= offtest) && (mb2 == mbtest) && (offtest <= off2))
	  return(TRUE);

     for(pom = mb1; (pom != mbtest) && (pom != mb2) && pom; pom = pom->next);
#ifdef CHECK_BUGS
     if (pom == NULL) InternalError("BlockPosBetween");
#endif
     if (pom == mbtest)
	  if (
	      ( ((mbtest == mb1) && (off1 <= offtest)) || (mbtest != mb1) ) &&
	      ( ((mbtest == mb2) && (offtest <= off2)) || (mbtest != mb2) )
	     )
	       return(TRUE);

     return(FALSE);
} /* end BlockPosBetween */
//<<

/* tato fce k zadanemu pametovemu bloku a offsetu urci novy pametovy blok
 * a offset pri zadanem posunuti ... o change; vraci FALSE, pokud
 * takove posunuti neni mozne v danem systemu bloku - provedeno kvuli
 * jednoduchosti a rychlosti ve variante pricitani a odcitani */
BOOL NewBlockOffsetAdd(MemoryBlock **pmb, ULONG *offset, ULONG change)
//>>
{
     MemoryBlock *mb = *pmb;
     ULONG newoff, pom;

#ifdef CHECK_BUGS
     if (mb == NULL) { InternalError("NewBlockOffsetAdd ... mb = NULL"); return(FALSE); }
#else
     if (mb == NULL) return(FALSE);
#endif
     newoff = *offset + change;
  /* zustaneme v tomtez bloku */
     pom = mb->size - mb->free;
     if ( newoff < pom )
     {    *offset = newoff;   return(TRUE);    }
     else
     do
     {    newoff -= pom;      // vime, ze newoff >= pom !
       // prechod na dalsi blok
	  if ((mb = mb->next) == NULL)
#ifdef CHECK_BUGS
	  {    InternalError("NewBlockOffsetAdd - chybi MB->next"); return(FALSE);    }
#else
	  {    return(FALSE);    }
#endif
	  pom = mb->size - mb->free;
     } while ( newoff >= pom );

  /* pokud jsme nasli novou pozici - vratime ji */
     *offset = newoff;             *pmb = mb;
     return(TRUE);
} /* end NewBlockOffsetAdd */
//<<

// tato funkce musi pocitat s tim, ze pri mazani v blocich dochazi
// na konci k vyrovnavani bloku, tj. presunum (doplneni) drivejsich bloku
// daty ze vzdalenejsich, aby byly zaplneny
// stav pred temito presuny zachycuje mb->user2 (= mb->free pred presuny)
BOOL NewBlockOffsetSub(TEditFile *teditfile, MemoryBlock **pmb, ULONG *offset, ULONG change)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     MemoryBlock *mb = *pmb, *mbpom, *mbpos;
     ULONG skip, posoff;
     ULONG addchange;
     BOOL firstblock;

#ifdef CHECK_BUGS
     if (NOT mb->changed) InternalError("NBOSub - not changed");
#endif
// pokud v bloku mb doslo k presunu do predchozich bloku --> nelze
// mechanicky provest nasledujici postup, nebot prislusny blok muze byt
// prazdny (ackoli puvodne *offset >= change)
// je tedy treba nalezt aktualni pozici odpovidajici puvodni poloze
// mb, offset... vyuzijeme predchozi funkci...
// spravne by tady melo byt ... !
//      if ((mb->free != mb->user2) || (mb->free == mb->user2 == INITIALSTATE))
// protoze pokud je blok na pocatku v INITIALSTATE a provedou se presuny
// pak dojde ke zmenam, ale blok po nich bude opet v INITIALSTATE !
// zatim to zjednodusime a budeme to delat vzdy, kdyz bude mb->changed
     if (mb->changed || (mb->free != mb->user2))    // doslo k presunum
     {
       // nalezneme prvni blok, kde k posunum nedoslo (napr. blok v nemz se zacalo mazat)
       //   for( mbpom = mb; mbpom && (mbpom->free != mbpom->user2) && mbpom->changed;
       //        mbpom = mbpom->prev);
       // nalezneme posledni blok (od pocatku), ktery se nemenil
	  for(mbpom = doc->block_first; mbpom && NOT mbpom->changed; mbpom = mbpom->next);
#ifdef CHECK_BUGS
	  if (mb == NULL) InternalError("NBOSub - mb == NULL");
#endif
// POZOR ! vsechny menene bloky ... changed ... musi mit user2 != 0
       // mame mbpom (prvni meneny) a urcime, kde zacinaji prisunovana data
       // pokud dojedeme k nemenemu odstavci --> posoff bude take dobre...
	  if (mbpom->prev)    // ma predchudce ? ten se nemenil
	  {    mbpos = mbpom->prev;
	       posoff = mbpos->size - mbpos->free;     // mbpom - zde je uz totozne user2 a free
	       firstblock = FALSE;
	  }
	  else // menilo se i v prvnim bloku
	  {    mbpos = doc->block_first;
	       posoff = 0;
	       firstblock = TRUE;
	  }
       // nyni musime zjistit, kde lezi skutecne pozice - pomoci NBOAdd
       // spocteme ale nejprve, o kolik se musime posunout
	  addchange = 0;
	  for( mbpom = (firstblock) ? doc->block_first : mbpom;
	       mbpom && (mbpom != mb); mbpom = mbpom->next)
	  {
	       addchange += mbpom->size - mbpom->user2;
#ifdef CHECK_BUGS
	       if (mbpom->user2 == 0) InternalError("NBOSub - user2 je 0");
#endif
	  }
       // na zaver pripocteme offset v tom kritickem poslednim odstavci
	  addchange += *offset;
       // v pripade prvni varianty lezi poloha mimo data ! (mimo blok)
       // protoze ukazuje prave za nej
       // --> v pripade zmeny 0 a vetsi (!) --> nutno NBOAdd
       // v opacnem pripade dojde k odecitani a i presto, ze jsme za daty
       // v bloku, posuneme se do nich (change bude zaporne...)

// POKUD BY NASTAVALY PROBLEMY, LZE NA KONEC PRIDAT NBOAdd s offsetem 0 !

       // pokud se ma pridavat - odecteme to, o co pak pujdeme zpet, jinak
       // by NBOAdd davala chybu no next mb...
	  if (addchange >= change) // zde musi byt >= ! viz vyse
	  {    addchange -= change;
	       (void) NewBlockOffsetAdd(&mbpos, &posoff, addchange);
	       change = 0;    // uz jsme hotovi...
	  }
	  else change -= addchange;
       // nasli jsme - musime (aby to dale fungovalo postaru) vratit
       // vse do mb, *offset, *pmb...
	  mb = mbpos;         *pmb = mbpos;       *offset = posoff;
     }

// puvodni kod funkce...
#ifdef CHECK_BUGS
     if (mb == NULL) { InternalError("NewBlockOffsetSub, mb = NULL"); return(FALSE); }
#else
     if (mb == NULL) return(FALSE);
#endif
  /* zustaneme v tomtez bloku */
     if ( change <= (skip = *offset) )
     {    *offset -= change;  return(TRUE);    }
     else
     do
     {
	  if ((mb = mb->prev) == NULL)
#ifdef CHECK_BUGS
	  {    InternalError("NewBlockOffsetSub - chybi mb->prev");    return(FALSE);    }
#else
	  {    return(FALSE);    }
#endif
	  change -= skip;
     } while ( change > (skip = (mb->size - mb->free)) );

  /* pokud jsme nasli novou pozici - vratime ji */
     *offset = mb->size - mb->free - change;      *pmb = mb;
     return(TRUE);
} /* end NewBlockOffsetSub */
//<<



// VLASTNI VYKONNE FCE PRO VKLADANI //

/* toto je pomocna fce pro InsertInBlock, ktera provadi (rekurzivne) vlastni
 * vkladani zadanych dat, ale nedela zadne posuny offsetu apod. */
/* tato fce provede vlozeni dat do bloku a na to, co zbyde se zavola rekurzivne */
/* pokud je treba zarovnat blok, prepoklada se, ze buffer je dost veliky,
 * aby do nej slo pridavat ... */
void WriteDataInBlock(MemoryBlock *mb, ULONG off, UBYTE *data, ULONG len, ULONG databuf)
//>>
{
     UBYTE *kam = mb->memory + off, *konec;  // kam = kam se ma zapisovat
     ULONG kolik = mb->size - mb->free - off;
	  // kolik je dat v bloku za zapisovanou pozici - za kam
     ULONG bytudat;      // kolik dat se presune do pametoveho bloku
     ULONG pom;
     BOOL blokstaci = (mb->free >= len + FREEMEM_MIN) ? TRUE : FALSE;
	  // data se vejdou cela do tohoto bloku
     BOOL correct = (mb->free >= FREEMEM_INITIALSTATE) ? TRUE : FALSE;
	  // da se to zarovnat rovnou

#ifdef CHECK_BUGS
     if (mb == NULL) InternalError("Vkladani do bloku, writedata, mb = NULL");
     if (mb->free < FREEMEM_MIN) InternalError("Vkladani do bloku, writedata, - mb->free < FREEMEM_MIN");
     if (NOT mb->changed) InternalError("WriteDataInBLock - piseme do bloku, do nehoz se psat nemelo");
     if (mb->user != len) InternalError("WriteDataInBlock - piseme jiny pocet bytu nez se spocetlo");
#endif
     if ((mb == NULL) || (mb->free < FREEMEM_MIN)) return;

  // kolik dat muzeme vsunout do bloku ... (aby to neprelezlo)
     pom = (blokstaci) ? len : mb->free - ((correct) ? FREEMEM_INITIALSTATE : FREEMEM_MIN);
  /* kopirovani dat, resp. tech, co se tam jen tak vejdou - ? memcpy umi pocet bytu _0_ ? - neumi */
     if (pom)
     {    if (kolik) memmove(kam + pom, kam, (size_t) kolik);   // odsun dat za pozici kam
	  memcpy(kam, data, (size_t) pom);  // nakopirovani novych do vznikleho prostoru
	  mb->free -= pom;         kam += pom;         off += pom;
     }
  /* pokud se data vejdou cela do bloku, koncime */
     if (blokstaci) return;
  /* v opacnem pripade upravime stav dat (je jich jiz mene) a pokracujeme */
     if (pom) memmove(data, data + pom, (size_t) (len -= pom));

/* data se do bloku nevejdou, dojde k presunu do dalsiho, tj. co pujde,
 * tak nakopirujeme do bloku, co z nej vypadne, to se pripoji na konec
 * zatim vkladanych dat... */
 // off byl posunut o pocet bytu vlozenych dat --> ukazuje za ne!!!
     pom = mb->size - mb->free - off;   // kolik jich lze do bloku max. dat
     pom = bytudat = min_ul(len, pom);// kolik jich presoupneme z bloku do dat ...
     konec = mb->memory + mb->size - mb->free;    // uk. za posl. znak bloku

// neni to treba delat v cyklu - trans_buf je dost velky ... SIZE_TEXT
//     while (bytudat > 0) // provadi se opakovane jeden elementarni presun data <-> MemoryBlock
//     {    pom = (bytudat > TRANSBUFSIZE) ? TRANSBUFSIZE : bytudat;
       // kolik preneseme v tomto cyklu ...
#ifdef CHECK_BUGS
     if (bytudat > SIZE_TEXT) InternalError("WriteDataInBlock - moc bytudat");
#endif
     pom = bytudat;

     memcpy(trans_buffer, data, (size_t) pom);   // data -> pomocna pamet
     if (len > pom)   // moc dat --> musi se zbyla posunout na zacatek ...
	  memmove(data, data + pom, (size_t) (len - pom));// posun dat (uvolni misto na konci)
     memcpy(data + len - pom, konec - pom, (size_t) pom);// konec MemoryBlock -> do pameti dat
     if (konec > kam + pom)   // v bloku zbyla po presunu za vkladanymi jeste nejaka data
	  memmove(kam + pom, kam, (size_t) (konec - kam - pom));   // presun v MemoryBlock -> vznikne misto pro vkladana data
     memcpy(kam, trans_buffer, (size_t) pom);               // presun vkladanych dat na misto

// asi zbytecne, ale zatim to tu nechame ... kam, pom, off se dale neuzivaji
// pouziva se uz jen promenna *konec*!

/* nyni rekurzivne zbyvajici data vlozime do nasledujiciho bloku */
  /* uprava delky obsazene casti bloku na spravnou delku */
  /* predpoklada se, ze blok je cely zaplnen, jinak by nemusela tato operace probihat */
     if (NOT correct)
     { // protoze data na konci predchazeji v textu tem, co jsou jiz
       // v buferu s daty! --> nutno predradit!
#ifdef CHECK_BUGS
	  if (mb->free != FREEMEM_MIN) InternalError("WriteDataInBlock - correct chybne");
	  if (len == 0) InternalError("WriteDataInBlock - len == 0");
	  if (konec != mb->memory + mb->size - FREEMEM_MIN) InternalError("WriteDataInBlock - spatny *konec*");
#endif
	  memmove(data + FREEMEM_CORRECT, data, (size_t) len);
	  memcpy(data, konec - FREEMEM_CORRECT, FREEMEM_CORRECT);
	  mb->free = FREEMEM_INITIALSTATE;   // konec prenesen dale !
	  len += FREEMEM_CORRECT;
#ifdef CHECK_BUGS
	  if (len > databuf) InternalError("WriteDataInBlock - maly databuf");
#endif
     }
#ifdef CHECK_BUGS
     else if (mb->free != FREEMEM_INITIALSTATE) InternalError("WriteDataInBlock - mb->free != FREEMEM_INITIALSTATE");
#endif
  /* rekurentni volani ... vlozeni zbytku */
     WriteDataInBlock(mb->next, 0, data, len, databuf);
} /* end WriteDataInBlock */
//<<

/* nasledujici fce provede kontrolu pro InsertInBlock, zda je dost mista
 * pro vlozeni textu a popr. zkusi naalokovat novou pamet ...;
 * vrati uspech/neuspech */
/* prida-li bloky na konec seznamu - opravi udaje v doc; predpoklad mb != NULL */
BOOL CheckFreeSpace(TEditFile *teditfile, MemoryBlock *mb, ULONG offset, ULONG add, UBYTE **newbuf, ULONG *newbufsize)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     ULONG blocks = 0, len = add;

     *newbuf = NULL;          *newbufsize = 0;
#ifdef CHECK_BUGS
     if (mb == NULL) { InternalError("Vkladani do bloku, checkfree - mb = NULL"); return(FALSE); }
#else
     if (mb == NULL) return(FALSE);
#endif
  // alokace potrebnych novych bloku
     for(; add > 0; mb = mb->next)
     {    mb->user = add;     mb->changed = TRUE;      blocks++;
       // vejde se to do bloku ?
	  if (mb->free >= add + FREEMEM_MIN) { add = 0; break; }
       // nevejde se - zjistime, kolik zbyde
	  if (mb->free >= FREEMEM_INITIALSTATE)
	       add -= mb->free - FREEMEM_INITIALSTATE;
	  else add += FREEMEM_INITIALSTATE - mb->free;
       // je-li treba, vytvorime novy pametovy blok ...
	  if ((add >= mb->size - FREEMEM_INITIALSTATE) || (mb->next == NULL))
	       if (NULL == AddNewMemoryBlock(teditfile, mb, mb->size))
		    return(FALSE);
     } // end for(;;)

// alokace noveho bufferu -- z pool kvuli rychlosti (PPC)
     if (NULL == (*newbuf = (UBYTE *) LibAllocPooled(GETPOOLHEADER, *newbufsize = len + blocks * FREEMEM_CORRECT + 2 * FREEMEM_MAX)))
	  return(FALSE);

     return(TRUE);
} /* end CheckFreeSpace */
//<<

/* nasledujici fce slouzi k vlozeni zadaneho textu (retezce) do/za zadany
 * odstavec; o strukture textu se nic nepredpoklada, proste se vlozi;
 * fce vraci BOOL - uspech/neuspech */
/* location udava, kam se vklada z hlediska dokumentu - a umozni
 * provest pak prislusne zmeny offsetu; after to doplnuje o udaj, ze se vklada
 * za odstavec ...; data je ukazatel na vkladana data, len pocet bytu techto dat;
 * tato fce take musi prekontrolovat seznam pameti, zda se nezvetsil */
/* pridani za odstavec je urceno after - ve skutecnosti se ale vklada pred
 * posledni znak odstavce ('\n') a udaje se pak spravne upravi ==
 * DOHODA - VKLADA-LI SE ZA ODSTAVEC, BUDE PRVNI VKLADANY ZNAK CH_EOL; POZOR !
 * ma to predpoklad, ze vzdy je odstavec tvoren celymi radky a kazdy radek
 * je samozrejme ukoncen '\n'; loccheck - pocet location ke kontrole */
/* locs - seznam Locations k pripadne modifikaci; modifikuji se stejne
 * jako CURSOR ! */
/* signlocs udava hodnotu j pri oprave externich locs */
/* POZOR ! POKUD NEKDO VLOZI I CH_EOL APOD., MUSI SI SAM VSE POTREBNE OPRAVIT ! */
BOOL InsertInBlock(TEditFile *teditfile, Location *loc, UBYTE *data, ULONG len,
		   BOOL after, short loccheck, Location *locs, BOOL signlocs1)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     Location /* pomloc = *loc,*/ origloc = *loc;
     MemoryBlock *mb = loc->block;      // popis pozice, kam se
     ULONG off = loc->block_off;        // budou vkladat nova data
     int i, j;
     UBYTE *newbuf = NULL;
     ULONG newbufsize = 0;

     Paragraph *p;
//     TextStyle *ts;
     Location *l;
//     Picture *pic;

#ifdef CHECK_BUGS
     if (len == 0) { InternalError("InsertInBlock - vkladame nic"); return(TRUE); }
#else
     if (len == 0) return(TRUE);
#endif
/* smazeme nastaveni mb->changed */
     ClearBlockChanges(doc->block_first);
/* nutno provest kontrolu dostatku mista a popr. vytvorit nove bloky !!! */
// musime vytvorit novy buffer, do ktere bude mozne pridavat zbytky - kvuli vyrovnani!
     if (NOT CheckFreeSpace(teditfile, mb, off, len, &newbuf, &newbufsize))
     { // uvolneni pridanych bloku ...
	  MemoryBlock *pom;
	  for(pom = mb; pom; )
	       if (pom->size == pom->free) pom = RemoveMemoryBlock(teditfile, pom);
	       else pom = pom->next;
       // uvolneni newbuf (vyrovnavaci buffer) - v pool kvuli ryclosti (PPC)
	  if (newbuf) LibFreePooled(GETPOOLHEADER, newbuf, newbufsize); // FreeMem(newbuf, newbufsize);
       // ?! indikace nedostatku pameti !?
	  return(FALSE);
     }
/* do pomocneho bufferu je treba nakopirovat vkladana data ... */
     memcpy(newbuf, data, (size_t) len);

/* CheckFreeSpace - zada hodnoty do MemoryBlock user a changed;
 * user udava, o kolik bytu se posun provadi v danem bloku;
 * changed urcuje bloky, s nimz se manipuluje */

/* nyni muzeme provest vlastni vlozeni - pameti je dost */
     WriteDataInBlock(mb, off, newbuf, len, newbufsize);
/* pomocny buffer jiz neni treba - v pool kvuli ryclosti (PPC) */
     if (newbuf) LibFreePooled(GETPOOLHEADER, newbuf, newbufsize);

/* nyni se musi opravit vsechny potrebne ukazatele do pametovych bloku apod */
/* pritom se predpokladalo, ze text se vklada do (nebo tesne za) odstavec
 * tedy zadny novy odstavec zatim nevznika - to musi zaridit volajici fce;
 * vsechny nasledujici odstavce, stranky apod. se tedy odsunou dal, ale cele */
     if (NOT after)
     { 
//       // TextStyle
//	  for(ts = loc->style->next; ts; ts = ts->next) ts->offset += len;
       // Paragraph - aktualni
	  p = loc->para;           p->length += len;		p->explength = 0; // PC 20020420 
	  if (p->block_last->changed)
	       NewBlockOffsetAdd(&p->block_last, (ULONG *) &p->off_last, p->block_last->user);
	  if (p->block_first->changed)  // popr. uprava pocatku odstavce
	       NewBlockOffsetAdd(&p->block_first, (ULONG *) &p->off_first, 0);
     }
  // Paragraph - naslednici
     for(p = loc->para->next; p; p = p->next)
     {
	  if (NOT p->block_first->changed) break;
	  NewBlockOffsetAdd(&p->block_first, (ULONG *) &p->off_first, p->block_first->user);
	  if (NOT p->block_last->changed) break;
	  NewBlockOffsetAdd(&p->block_last, (ULONG *) &p->off_last,  p->block_last->user);
     }
  // Paragraph - predchudci
     for(p = loc->para->prev; p; p = p->prev)
     {
	  if (NOT p->block_last->changed) break;
	  NewBlockOffsetAdd(&p->block_last, (ULONG *) &p->off_last,  0);
	  if (NOT p->block_first->changed) break;
	  NewBlockOffsetAdd(&p->block_first, (ULONG *) &p->off_first, 0);
     }

///* page locations - pripojime do seznamu locs a provede se to automaticky */
//   // Page - aktualni
//      pg = loc->page;
//      if (locs == NULL) { locs = &pomloc;  lastloc = locs; }
//      else for(lastloc = locs; lastloc && lastloc->next; lastloc = lastloc->next);
//      lastloc->next = &pg->end;          lastloc = lastloc->next;
// #ifdef fgCHECK_BUGS
//      if (NULL == (pageloc = lastloc)) InternalError("comment Vkladani do bloku"); // 1. Location ze seznamu se strankami
// #endif
//   // Page - ostatni
//      for(pg = loc->page->next; pg; pg = pg->next)
//      {    lastloc->next = &pg->begin;        lastloc = lastloc->next;
//           lastloc->next = &pg->end;          lastloc = lastloc->next;
//      }
//      lastloc->next = NULL;

  // Location z EditFile - jejich celkem 7; cursor je prvni, cursorline druhy
  // zde se automaticky projdou i Pages ... a upravi se jejich poloha
#ifdef CHECK_BUGS
     if (NUM_DOC_LOCATIONS < loccheck) InternalError("Vkladani do bloku - NUM_DOC_LOCS < loccheck");
#endif
     for( i = 0, j = 0, l = &doc->cursor; l; ) // pro cursor ... i == 0 !
//        // POZOR ! Ve fazi stranek j = 0 pro end, j = 1 pro begin; prepoklad = 1. page->end
     {    if (l->block != NULL)
	  {    if (l->block->changed)
		    if (sign(j) <= CompareBlockPos(l->block, l->block_off, mb, off))
			 NewBlockOffsetAdd(&l->block, &l->block_off, l->block->user);
		    else NewBlockOffsetAdd(&l->block, &l->block_off, 0);
	       if ((l->para == origloc.para) && (l->chars_off + 1 - sign(j) > origloc.chars_off))
		    l->chars_off += len;
	  }
       /* prechod na dalsi Location */       i++; j++;
	  if (i < loccheck) l++;
	  else
	  {    l = (i == loccheck) ? locs : l->next;
//               if (pageloc == l) { j = 0; pageloc = NULL; } else
//               if (pageloc == NULL) { if (j > 1) j = 0; } else
	       j = (signlocs1) ? 1 : 0;
	  }
     }

/* nastaveni indikace provedene zmeny v odstavci */
     if (NOT after) origloc.para->changed = TRUE;

     return(TRUE);
} /* end InsertInBlock */
//<<



// VLASTNI VYKONNE FCE PRO MAZANI //

/* toto je pomocna fce pro DeleteInBlock, ktera provadi vlastni
 * smazani zadanych dat, ale nedela zadne posuny offsetu apod. */
/* tato fce provede smazani dat v blocich a popr. je i zarovna */
/* tato funkce vrati pocet nesmazanych znaku CH_EOL; pokud je zapnuto
 * clear_end, pak se maze vsechno -> a vraci tedy automaticky 0 */
// pri mazani pouzivame mb->user i user2
// mb->user ma tentyz vyznam jako obvykle, user2 je stav promenne
// mb->free pred prisunovanim ze vzdalenejsich bloku; pokud dojde
// k prisunovani, pak se samozrejme free zmeni
ULONG DeleteDataInBlock(MemoryBlock *mb, ULONG off, ULONG del, BOOL clear_ends)
//>>
{
     MemoryBlock *mbdel, *mbpom;
     UBYTE *kde, *hledej;
     ULONG kolik;        // kolik je dat v bloku
     ULONG pom, radku, pomeols, userdel, pom2;
     BOOL blokstaci, del0;     // data lze vzit cela z tohoto bloku

#ifdef CHECK_BUGS
     if (mb == NULL) { InternalError("Mazani v bloku, mb = NULL"); return(0); }
#else
     if (mb == NULL) return(0);
#endif

/* smazani pozadovanych dat */
     for(radku = 0, mbdel = mb, userdel = del;
	 mbdel && ((del > 0) || (userdel > 0));
	 radku += pomeols, mbdel = mbdel->next)
     {    del0 = (del == 0) ? TRUE : FALSE;
       // pozn.: je-li del = 0, muzeme cyklem projit, aniz se cokoli stane ...
	  pomeols = 0;        // CYKLUS MUSI FUNGOVAT I PRO DEL = 0
	  kde = mbdel->memory + ((mbdel == mb) ? off : 0);
	  kolik = mbdel->size - mbdel->free - ((mbdel == mb) ? off : 0);
	  pom = min_ul(kolik, del);
       /* zjistime, kolik je v danem useku znaku CH_EOL */
	  if (NOT clear_ends)
	       for(hledej = kde; hledej < kde + pom; hledej++)
		    if (ENDLINE(*hledej)) pomeols++;
       /* mazani dat, co se daji rovnou smazat */
	  if ((kolik - pom) && (pomeols < pom))
	       memmove(kde + pomeols, kde + pom, (size_t) (kolik - pom));
	  mbdel->free += pom - pomeols; del -= pom;
       /* "napiseme" tam ony "zachovane" konce radku; POZOR ! nemelo by vadit,
	* ze vsude dame CH_EOL; ty znaky se maji stejne smazat a tedy zmizi */
	  if (pomeols) memset(kde, CH_EOL, (size_t) pomeols);
       /* nastaveni promennych v bloku */
#ifdef CHECK_BUGS
	  if (userdel < pomeols) InternalError("DeleteDataInBlock - userdel < pomeols");
#endif
	  mbdel->changed = TRUE;
 //  mbdel->user = userdel - pomeols; zapamatujeme si, kolik se v tomto bloku
 // smazalo... pokud uz nemazeme ... user ponechame 0, changed je ale TRUE
	  mbdel->user = (del0) ? 0 : pom - pomeols;
// ??? puvodne - neni to divne        userdel -= del;     // chybi-li kus, budeme doplnovat ...
	  if (del0) userdel -= (pom2 = (kolik <= userdel) ? kolik : userdel);
	  else userdel -= pom;     // chybi-li kus, budeme doplnovat ...
       // musime si predstavit situaci, jak to bude po odebrani userdel !
       // to se tyka situace del0 = TRUE, kdy se ve skutecnosti jiz nemaze ...
	  if (del0) mbdel->free += pom2;
	  if (mbdel->free > FREEMEM_MAX) userdel += mbdel->free - FREEMEM_INITIALSTATE;
       // musime urcit, kdy dojde k zarovnavani ... (v dusledku zarovnani predchozich odstavcu)
	  else if (userdel + mbdel->free <= FREEMEM_MAX) userdel = del;
	       else if (FREEMEM_INITIALSTATE > mbdel->free)
			 userdel -= FREEMEM_INITIALSTATE - mbdel->free;
		    else userdel += mbdel->free - FREEMEM_INITIALSTATE;
       // po oprave userdel se vsak musi mbdel->free vratit na puv. hodnotu
       // to se tyka situace del0 = TRUE, kdy se ve skutecnosti jiz nemaze ...
	  if (del0) mbdel->free -= pom2;
       /* pokud se data vzala cela z bloku, koncime */
     }
#ifdef CHECK_BUGS
     if (del > 0) InternalError("DeleteDataInBlock, del > 0");
#endif
/* nez se provede zarovani bloku na spravne hodnoty, ulozime obsahy
 * mb->free do polozky user2 - tam budou ulozeny */
     for(mbdel = mb; mbdel; mbdel = mbdel->next)
	  mbdel->user2 = mbdel->free;

/* nasledne provedeme zarovnani vsech bloku na spravne hodnoty */
     for(mbdel = mb; mbdel; mbdel = mbdel->next)
     {    if (mbdel->free <= FREEMEM_MAX) continue;
	  kde = mbdel->memory + mbdel->size - mbdel->free;
	  kolik = mbdel->free - FREEMEM_INITIALSTATE;
       /* projdeme nasledujici bloky a zkusime najit potrebna data na prisunuti */
	  for(mbpom = mbdel->next; mbpom && (kolik > 0); mbpom = mbpom->next)
	  {    ULONG datainblock = mbpom->size - mbpom->free;
	       blokstaci = ((pom = datainblock) >= kolik) ? TRUE : FALSE;
	       if (blokstaci) pom = kolik;
	    /* pretazeni dat, ktera jsou k dispozici + zbytek presuneme na zacatek bloku */
	       if (pom) memcpy(kde, mbpom->memory, (size_t) pom);
	       if (pom < datainblock)
		    memmove(mbpom->memory, mbpom->memory + pom, (size_t) (datainblock - pom));
	       mbpom->free += pom;      
	    /* musime opravit ridici promenne */
#ifdef CHECK_BUGS
	       if (mbdel->free < pom) InternalError("DeleteDataInBlock - free < pom!");
#endif
	       kolik -= pom;       kde += pom;
	       mbdel->free -= pom;
	    /* pokud se data vzala cela z bloku, koncime */
	       if (blokstaci) break;
	  }
	  if (kolik > 0) break;    // vycerpali jsme vsechna data v pameti
     }

/* pokud jsme nenaplnili vse, co se naplnit melo --> nutno opravit userdel */
/* znamena to, ze jsme vsechny bloky za mbdel vycerpali, jsou prazdne */
//     if (kolik > 0)      // v mbdel je ten prvni nenaplneny blok
//     { // kolik obsahuje pocet zbyvajicich bytu, ktere chybely
//          for(; mbdel && mbdel->changed; mbdel = mbdel->next)
//          { // prvni pruchod - kolik, dale uz v kolik delka prazdnych bloku
//               for(mbpom = mbdel->next; mbpom && mbpom->changed; mbpom = mbpom->next)
//                    mbpom->user -= kolik;
//            // nastaveni pro dalsi pruchody
//               kolik = mbdel->next->size - FREEMEM_INITIALSTATE;
//          }
//     }
     
     return(radku);
} /* end DeleteDataInBlock */
//<<

// v nasledujici funkci muze dojit take k smazani nekterych Locations !
// pak budou nastaveny ukazatele do pameti (block a offset) na pocatek
// mazaneho useku !

/* nasledujici fce slouzi k smazani zadaneho textu (retezce) zadaneho
 * odstavce; o strukture textu se nic nepredpoklada, proste se smaze; */
/* location udava, kde se maze z hlediska dokumentu - a umozni
 * provest pak prislusne zmeny offsetu; len urcuje pocet bytu ke smazani;
 * tato fce musi prekontrolovat seznam pameti, zda se neda zmensit */
/* loccheck - pocet location ke kontrole; (jako vyse)
 * POZOR ! Tato fce by nemela smazat posledni znak dokumentu - posl. '\n';
 * UMLUVA - POCET MAZANYCH BYTU NENI VETSI NEZ POCET EXISTUJICICH - 1 ! */
/* locs - seznam dalsich Locations k pripadne k modifikaci */
/* bude nutno asi vzdy preformatovat a opravit Locations - to si udela nadrazena fce */
/* POZOR ! znaky konce radku budou smazany pouze pri clear_ends ! LineNode
 * apod. ale opraveny nebudou - to musi udelat volajici fce (asi jen Format) */
void DeleteInBlock(TEditFile *teditfile, Location *loc, ULONG len, short loccheck,
		   Location *locs, BOOL clear_ends)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     MemoryBlock *mb = loc->block;      // popis pozice, kam se
     ULONG off = loc->block_off;        // budou vkladat nova data
     ULONG endoff = loc->chars_off + len;// offset konce mazane casti
     int i;
     MemoryBlock *mbpom = mb, **block;
     ULONG pom = off, smazano_radku; // nepouzito , delete = len;
     BOOL end;

//     Page *page;
     Paragraph *p;
//     TextStyle *ts;
     Location *l;
//     LineNode *ln, *lnnew, *next, *prev;
//     Picture *pic;

#ifdef CHECK_BUGS
     if (NOT NewBlockOffsetAdd(&mbpom, &pom, len - 1)) { InternalError("Mazani v bloku - NOT NewBlockOffsetAdd"); return; }
#else
     if (NOT NewBlockOffsetAdd(&mbpom, &pom, len - 1)) return;
#endif

#ifdef CHECK_BUGS
     if (len == 0) { InternalError("DeleteInBlock - mazeme nic"); return; }
#else
     if (len == 0) return;
#endif

/* smazeme nastaveni mb->changed */
     ClearBlockChanges(doc->block_first);
/* zjistime zmeny, ktere vzniknou mazanim */
//     CheckDelResult(mb, off, len);
/* rekurzivne se provede vlastni vypusteni zadanych dat */
     smazano_radku = DeleteDataInBlock(mb, off, len, clear_ends);
     if (NOT clear_ends)
     {    
#ifdef CHECK_BUGS
	  if (len < smazano_radku) InternalError("DeleteInBlock - len < smazano_radku");
#endif
	  len -= smazano_radku;
     }
/* je nutno se pojistit pred tim, ze by loc najednou ukazovalo mimo data;
 * loc je na pocatku, para_beg je pred pocatkem mazaneho useku --> lze to...
 * totez plati pro pocatek odstavce */
     NewBlockOffsetAdd(&loc->block, &loc->block_off, 0);
     p = loc->para;
     NewBlockOffsetAdd(&p->block_first, &p->off_first, 0);

/* nasleduje oprava ruznych ukazatelu do systemu pametovych bloku; POZOR -
 * ma se kontrolovat, zda data, na ktera to ukazuje jiz neexistuji - ano;
 * s temi neexistujicimi - budou nastavena na nejblizsi predchozi hodnotu
 * s vyjimkou TextStyle - ty jsou rovnou smazany ...
 * zde se provede test - pokud dany ukazatel nalezi do smazane oblasti,
 * bude nastaven i s offsetem na nulu */

/* nejprve opravime polohy ukazatelu na zacatky a konce odstavcu */
/* nebot mazani probiha UVNITR daneho odstavce, dochazi jen k posunu;
 * u aktualniho odstavce navic zmenime nektere dalsi hodnoty */
//     doc->lines--;     ? jak to bude se vsemi numerickymi udaji v EditFile
  // Paragraph - aktualni; je-li smazan i koncovy znak -> lines obsahuje o radek mene !
  // a block obsahuje NULU ! - pouzit jen pri mazani odstavce
     p = loc->para;      p->length -= len;		p->explength = 0; // PC 20020420 
//     if (clear_ends) p->lines -= smazano_radku;
#ifdef CHECK_BUGS
     if (1 == CompareBlockPos(p->block_first, p->off_first, p->block_last, p->off_last)) InternalError("DeleteInBlock - neshoda pocatku a konce odstavce 1");
#endif
     block = &p->block_last;
     if ((*block)->changed)
	  if (BlockPosBetween(*block, p->off_last, mb, off, mbpom, pom))
	  {    *block = loc->block;     p->off_first = loc->block_off;    }
	  else if (NOTBEGFIRSTBLOCK(*block, p->off_last, mb, off))
		    NewBlockOffsetSub(teditfile, block, (ULONG *) &p->off_last, (*block)->user);
#ifdef CHECK_BUGS
     if (1 == CompareBlockPos(p->block_first, p->off_first, p->block_last, p->off_last)) InternalError("DeleteInBlock - neshoda pocatku a konce odstavce 2");
#endif


  // Paragraph - ostatni; zde nedojde ani k smazani LineNode apod. !
     for(end = FALSE, p = loc->para->next; p && NOT end; p = p->next)
     {    ULONG *bloff;
	  int bl = 0;
	  for( block = &p->block_first, bloff = &p->off_first;
	       bl < 2;
	       block = &p->block_last, bloff = &p->off_last, bl++)
	  {
	       if (NOT (*block)->changed) { end = TRUE; break; }
	       if (BlockPosBetween(*block, *bloff, mb, off, mbpom, pom))
#ifdef CHECK_BUGS
		    InternalError("Mazani v bloku - BlockPosBetween");    // toto nesmi nastat - mazeme jen uvnitr odstavce
#else
		    *block = loc->block;
#endif
	       else if (NOTBEGFIRSTBLOCK(*block, *bloff, mb, off))
			 NewBlockOffsetSub(teditfile, block, bloff, (*block)->user);
	  }
     }

// /* page locations - pripojime do seznamu locs -> pak budou vsechny potrebne
//  * operace provedeny automaticky spolu s DOC Locations */
//   // Page - aktualni
//      pg = loc->page;
//      if (locs == NULL) { locs = &pomloc;  lastloc = locs; }
//      else for(lastloc = locs; lastloc && lastloc->next; lastloc = lastloc->next);
//      lastloc->next = &pg->end;          lastloc = lastloc->next;
//   // Page - ostatni
//      for(pg = loc->page->next; pg; pg = pg->next)
//      {    lastloc->next = &pg->begin;        lastloc = lastloc->next;
//           lastloc->next = &pg->end;          lastloc = lastloc->next;
//      }
//      lastloc->next = NULL;

  // nasleduje oprava ukazatelu do pameti pro prislusne Locations
  // pokud jsou v mazanem pasmu, bude jejich pozice nastavena na pocatek
  // mazaneho useku - plati pro vsechny Location (projdou se i pro Pages)
  // Location z EditFile - jejich celkem 7; cursor je prvni, bookmark druhy ...
#ifdef CHECK_BUGS
     if (NUM_DOC_LOCATIONS < loccheck) InternalError("Mazani v bloku, NUM_DOC_LOCATIONS < loccheck");
#endif
     for( i = 0, l = &doc->cursor; l; )
     {    block = &l->block;
	  if (*block != NULL)
	  {    if ((*block)->changed)
	       {    if (BlockPosBetween(*block, l->block_off, mb, off, mbpom, pom))
		    {    *block = loc->block;     l->block_off = loc->block_off;
			 l->chars_off = loc->chars_off;
		    }
		    else if (NOTBEGFIRSTBLOCK(*block, l->block_off, mb, off))
		    { // vyjimka - prvni meneny blok - zacatek se neposkodil
			 NewBlockOffsetSub(teditfile, block, &l->block_off, (*block)->user);
			 if ((l->para == loc->para) && (l->chars_off >= loc->chars_off))
			      l->chars_off -= len;
		    }
	       }
	       else // blok zmenen nebyl, ale u Location mohlo dojit 
	       {    // ke zmene v chars_off, pokud se v odstavci mazalo
		    if ((l->para == loc->para) && (l->chars_off >= loc->chars_off))
			 l->chars_off -= len;
	       }
	  }
       /* prechod na dalsi Location */       i++;
	  if (i < loccheck) l++;
	  else l = (i == loccheck) ? locs : l->next;
     }

/* zde musi dojit k smazani vsech nyni jiz prazdnych a nepouzitych bloku */
     for(mbpom = mb; mbpom;)
	  if (mbpom->size == mbpom->free)
	       mbpom = RemoveMemoryBlock(teditfile, mbpom);
	  else mbpom = mbpom->next;

/* nastaveni indikace odstavce, v nemz doslo ke zmene */
     loc->para->changed = TRUE;
} /* end DeleteInBlock */
//<<

// POZOR ! jestlize se smazou konce radku v blocich ->je treba umazat prislusne
// LineNode (resp. opravit udaje) a opravit udaje v odstavci;
// LineNode se nemazou -> musi zajistit volajici fce; lze ale zakazat mazani CH_EOL
// pak je samozrejme treba provest formatovani ...

// nutno vytvorit funkci, ktere nam spoji dva odstavce, tj. umaze znak
// konce odstavce a provede vsechny potrebne zmeny (napr. napoji seznam
// textovych stylu apod.)
/* nasledujici funkce provede spojeni dvou odstavcu (tj. smaze jeden Paragraph
 * a spoji seznamy stylu pisma; vstup je ukazatel na prvni odstavec */
/* musi se ovsem opravit vsechny Locations s ukazatelem na mazany odstavec */
/* page_#? udava prvni a posl. stranku - neni nutne; locs - Locations k oprave */
void JoinTwoParagraphs(TEditFile *teditfile, Paragraph *first, /* Page *page_first, Page *page_last, */
		       Location *locs)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     Paragraph *second = first->next;
//     TextStyle *ts1 = first->ts_last, *ts2 = second->ts_first, *tspom;
//     Page *pompage;
     Location *loc;
//     ULONG hdelta = second->topedge - first->topedge, i;
     ULONG firstlen = first->length, i;

#ifdef CHEC_BUGS
     if ((first == NULL) || (second == NULL)) InternalError("JoinTwoParas, first, sec = NULL");
//     if ((ts1 == NULL) || (ts2 == NULL) || (ts3 == NULL)) InternalError("JoinTwoParas - ts? == NULL");
#endif
// pametove bloky
     first->block_last = second->block_last;
     first->off_last   = second->off_last;
// ostatni udaje
     first->length += second->length;   // first->lines += second->lines;
     first->explength = 0; // PC 20020420 
// musi se jeste opravit vsechny Locations; page_last je NULL nebo neco !
//  // pro stranky
//     for( pompage = (page_first) ? page_first : doc->page_first;
//	  pompage != page_last; pompage = pompage->next)
//     {  
//	  if (pompage->para_first == second) pompage->para_first = first;
//	  if (pompage->para_last  == second) pompage->para_last  = first;
//     }
  // pro dokument
     for( loc = &doc->cursor, i = 0; loc; )
     {    if (loc->para == second)
	  {    loc->para = first;  // loc->para_off += hdelta;
	       loc->chars_off += firstlen;
#ifdef CHECK_BUGS
               if (loc->line_num == 1) InternalError("JoinPara - num_line < 0!");
#endif
               loc->line_num--;    // joining paragraphs = joining two lines together
	  }
	  if (++i < NUM_DOC_LOCATIONS) loc++;
	  else if (i == NUM_DOC_LOCATIONS) loc = locs;
	       else loc = loc->next;
     }
#ifdef CHECK_BUGS
     if (doc->num_lines < 1) InternalError("JoinPara - num_lines == 0!");
#endif
// decreasing doc->num_lines--; is done by RemoveParagraph
     
// uvolneni odstavce - tim se nastavi i next, prev
//     if (doc->last_dontdraw_para == second)
//	  doc->last_dontdraw_para = first;
     (void) RemoveParagraph(teditfile, second, FALSE);  // neuvolnime styly
}
//<<

// dale se musi vytvorit funkce, ktera smaze vse mezi zadanymi Locations
// prvni odstavec do konce, dalsi cele a z posledniho jen zacatek
// nasledujici funkce smaze vsechno mezi danymi Locations ...
// maze se od Loc1 do loc2 VCETNE !; format, zobraz se tyka preformatovani
// JE-LI FORMAT = TRUE ==> vzdy bude cursor nastaven na pocatek 
// mazaneho useku !
void DeleteDataLoc(TEditFile *teditfile, Location *loc1, Location *loc2,
		   BOOL format, BOOL zobraz, BOOL dontdraw)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     Location pomloc, pomend;
     Paragraph *para;
     BOOL nextpara = LastParaChar(loc2) /* , indisp */;
     BOOL joinparas = FALSE;       // byly spojeny odstavce?
     BOOL delonechar = ((loc1->block == loc2->block) && (loc1->block_off == loc2->block_off)) ? TRUE : FALSE;
     ULONG delka;

#ifdef CHECK_BUGS
     if (1 == CompareBlockPos(loc1->block, loc1->block_off, loc2->block, loc2->block_off)) { InternalError("DeleteDataLoc - chybne loc"); return; }
     if (LastParaChar(loc2) && (loc2->para->next == NULL)) { InternalError("DeleteDataLoc - na konci dokumentu"); return; }
#else
     if (1 == CompareBlockPos(loc1->block, loc1->block_off, loc2->block, loc2->block_off)) return;
     if (LastParaChar(loc2) && (loc2->para->next == NULL)) return;
#endif

     if (NOT delonechar)
	  ChangePointer(/* doc->win, &doc->req, */ teditfile, NULL, TRUE, TRUE);
// urcime, zda bude cursor stale videt
//     indisp = ((doc->te_dclip < loc1->page_off) && (loc1->page_off + loc1->line->height < doc->te_dclip + doc->h_dclip)) ? TRUE : FALSE;
     pomend = doc->display_end;    GetNextPos(teditfile, &pomend, FALSE, 0);
//     indisp = ( (-1 == CompareBlockPos(doc->display_begin.block, doc->display_begin.block_off, loc1->block, loc1->block_off)) && (-1 == CompareBlockPos(loc2->block, loc2->block_off, pomend.block, pomend.block_off)) ) ? TRUE : FALSE;
// pokus
//     indisp = ( (0 >= CompareBlockPos(doc->display_begin.block, doc->display_begin.block_off, loc1->block, loc1->block_off)) && (-1 == CompareBlockPos(loc1->block, loc1->block_off, pomend.block, pomend.block_off)) ) ? TRUE : FALSE;

// nejprve smazame vsechny odstavce v danem rozmezi -> vznikne jeden dlouhy
// v tom pak provedeme zadane smazani cele
     loc1->next = NULL;       loc2->next = NULL;
     for(para = loc1->para; para != loc2->para; joinparas = TRUE)
	  JoinTwoParagraphs(teditfile, para, /* loc1->page, loc2->page->next, */ loc2);
     if (nextpara)
     {    JoinTwoParagraphs(teditfile, para, /* loc1->page, loc2->page->next, */ loc2);
	  joinparas = TRUE;
     }

// zjistime delku mazanych dat
     delka = loc2->chars_off - loc1->chars_off + 1;
/*** Modify Start : d-tec ***/
     if (_ismbslead(loc2->block->memory, loc2->block->memory + loc2->block_off))
     {
          delka++;
     }
/*** Modify End : d-tec ***/

// vlastni smazani
     pomloc = *loc1;     // nechame pomloc spravne modifikovat pro cursor
     pomloc.next = NULL;
     // we have to clear the EOLS in joined paragraphs!
     DeleteInBlock(teditfile, loc1, delka, NUM_DOC_LOCATIONS, &pomloc, TRUE);
//     DeleteInBlock(teditfile, loc1, delka, NUM_DOC_LOCATIONS, &pomloc, FALSE);

// formatovani
     if (format)
     {    doc->cursor = pomloc;
	  GetPrevPos(teditfile, &pomloc, FALSE, 0);  // loc1 --> na zacatek radku
	  doc->cursorline = pomloc;
       // a zde uz je pomloc na neco jineho ... pomomcna pro GFFL
//	  FormatLines(doc, GetFirstFormatLine(doc, &pomloc, FALSE, FALSE), zobraz && indisp, FALSE, TRUE, FALSE, TRUE, (LONG) ((joinparas) ? 1 : 0), FALSE, FALSE, (delka >= 16) ? TRUE : FALSE, dontdraw, FALSE);
       // Locations - display_end
          SetDisplayBegEnd(teditfile, FALSE, 0);
     }
     if (NOT delonechar)
	  ChangePointer(/* doc->win, &doc->req, */ teditfile, NULL, FALSE, FALSE);
} /* end DeleteDataLoc */
//<<

/* nasledujici fce provadi rozdeleni odstavce na dva na zadanem miste;
 * doc -jasne, misto - udava, kam se ma vlozit ten konec odstavce,
 * pbreak - ma koncit pagebreak ?, format urcuje, zda se ma preformatovat,
 * cursor - cursor nastavit na pocatek noveho odstavce ...
 * text a ostatni polozky urcuji, co se ma
 * vsechno opravit - jako u JoinTwoParagraphs */
// deleni - misto rozdeleni odstavce; toto Location zustane
// na miste, tj. na konci rozdelovaneho odstavce!
// POZOR ! Pokud ma tato funkce provadet formatovani, automaticky
// dojde k volbe "dontdraw" modu !
// pokud je cursor = FALSE --> nedela se CheckTextStyleList na novy odstavec
void SplitParagraph(TEditFile *teditfile, Location *deleni, /* Page *page, */
		    BOOL pbreak, BOOL format, BOOL cursor)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     Location oldcursorline = doc->cursorline, misto = *deleni, *cur = &doc->cursor;
     Location from = *deleni, pomloc;
     Paragraph *orig = misto.para, *newpara, *ppom, *testpara;
     MemoryBlock *mb = misto.block;
//     TextStyle *ts, *testts;
//     Page *pompage;
//     ParaStyle *pspom = InitStructure(PARASTYLE, NULL);
//     LineNode *testln;

     ULONG orig_off = misto.chars_off, mboff = misto.block_off;
//     MUNIT hpage = doc->pagesize.height;
     BOOL endind, begline, enoughmem = TRUE;
     BOOL firstdocline = (misto.para == doc->para_first) ? TRUE : FALSE;
     BOOL lastdocline  = (misto.para == doc->para_last)  ? TRUE : FALSE;
//     BOOL firstdocline = (misto.line == doc->line_first) ? TRUE : FALSE;
//     BOOL lastdocline  = (misto.line == doc->line_last)  ? TRUE : FALSE;
// nepouzito ...     BOOL firstparachar = FirstParaChar(deleni);
     UBYTE end[4] = { CH_EOL, '\0', CH_EOL, '\0' };

// overime, zda je dost pameti
     if (testpara = (Paragraph *) InitStructure(PARAGRAPH, NULL))
         FreeStructure(PARAGRAPH, testpara);
     else enoughmem = FALSE;
//<<
// neni pamet ...   #define KRIZE neni pamet !!!
     if (NOT enoughmem)
     {    AlertMessage(teditfile, GS(MSG_NO_MEMORY_ALERT1), GS(MSG_NO_MEMORY_ALERT2));
	  return;
     }
//     if (pspom == NULL) return;

     if ((mb != doc->block_first) || (mboff != 0))
	  begline = (ENDLINE(*DecrementPosMB(&mb, &mboff))) ? TRUE : FALSE;
     else begline = TRUE;
// nastavime from na pocatek radku ...
      (void) GetPrevPos(teditfile, &from, FALSE, 0);
      if (NOT firstdocline)
      {    (void) GetPrevPos(teditfile, &from, TRUE, 0);
	   (void) GetPrevPos(teditfile, &from, FALSE, 0);
      }
// na pozadovane misto vlozime znak konce odstavce (podle pbreak - upravime az dale)
     oldcursorline.next = NULL;         pomloc = misto;
     if (NOT InsertInBlock(teditfile, &misto, end, 1, FALSE, NUM_DOC_LOCATIONS, &oldcursorline, FALSE)) return;
     misto = pomloc;
  // misto se diky pomloc nezmenilo --> musime ale prislusne pozmenit
  // mb + offset, pokud doslo k presunum mezi bloky
     (void) NewBlockOffsetAdd(&misto.block, &misto.block_off, 0);
  // na pocatku: misto = *deleni;  nezmenene, ale opravene misto dame do *deleni
     *deleni = misto;

//// pridame novy LineNode (stejny jako je prislusna radka, kde delime)
//     if (NOT AddNewLineNode(doc, misto.line)) return;

// pridame novy odstavec; neni-li pamet --> melo by byt overeno vyse...
     newpara = AddNewParagraph(teditfile, orig, /*orig->style,*/ FALSE /*, orig->nps_para */);
     if (newpara == NULL) return;

// nastavime pagebreak u stranky ? - pouze pri pagebreak, bude-li treba
//      if (pbreak) deleni->page->pagebreak = pbreak;
// upravime seznamy stylu, zacatky/konce ruznych struktur v odstavci apod.
  // next, prev jiz je
  // bloky
     newpara->block_first = misto.block;    newpara->off_first = misto.block_off;
     (void) IncrementPosMB(&newpara->block_first, &newpara->off_first);
     newpara->block_last = orig->block_last;newpara->off_last  = orig->off_last;
     orig->block_last = misto.block;    orig->off_last = misto.block_off;
  // length, lines ...
     newpara->length    = orig->length - misto.chars_off - 1;		newpara->explength = 0; // PC 20020420 
     orig->length   = misto.chars_off + 1;								orig->explength = 0; // PC 20020420 
//     newpara->lines     = 1 + orig->lines - CountNumLines(orig->line_first, misto.line);
//     orig->lines   -= newpara->lines - 1;
//  // style a textstyles - do jiz existujicich stylu se nesmi psat
//     *pspom = *newpara->style;             pspom->ts = *misto.style;
//     *newpara->ts_first = *misto.style;    newpara->ts_first->prev = NULL;   // newpara->ts_first->next - je uz spravne
//     newpara->ts_last   = (newpara->ts_first->next) ? orig->ts_last : newpara->ts_first;
//     orig->ts_last  = misto.style;     orig->ts_last->next = NULL;   // orig->ts_last->prev - je uz spravne
//     if (newpara->ts_first->next) newpara->ts_first->next->prev = newpara->ts_first;
//  // vytvarime novy ParaStyle --> used pro prislusny font nastavi AddNewParaStyle
//  // menime take TextStyle --> staremu fontu musime used zmensit, novemu zvetsit
//  // stary font se neuvolnuje, je i nadale v misto.style, tj. posl. stylu orig
//     orig->style->ts.font->used--;      // stary, puvodni font; podle nej vytvoren 'newpara'
//#ifdef CHECK_BUGS
//     if (orig->style->ts.font->used == 0) InternalError("SplitPara - blby ParaStyle font");
//#endif
//     newpara->ts_first->font->used++;       // novy font
//  // oprava offsetu vsech TextStyle
//     orig_off++;
//     for(ts = newpara->ts_first, ts->offset = orig_off; ts; ts = ts->next)
//	  ts->offset -= orig_off;
//     orig_off--;
//  // topedge ? - asi pomoci para_off a dopocitat; ne - NECHAT FORMATOVANI ?
//     newpara->topedge = misto.page_off + (misto.page->num - 1) * hpage;
//  // LineNodes
//     newpara->line_first= misto.line;
//     (void) NextPosLN(&newpara->line_first);     // posuneme se na nove vytvoreny LineNode
//     newpara->line_last = orig->line_last;
//     if (newpara->line_last == misto.line) (void) NextPosLN(&newpara->line_last);
//     orig->line_last= misto.line;
//  // ParaStyle ... a kdo ho odstrani; neni treba - byl pouzit alespon 2x
//     newpara->style->used--;
//#ifdef CHECK_BUGS
//     if (newpara->style->used == 0) InternalError("SplitPara - blby ParaStyle");
//#endif
//// // //     *pspom = *newpara->style;         pspom->ts = *newpara->ts_first;
//     if (newpara->style = AddNewParaStyle(doc, pspom))     // styl jiz existuje
//	  (void) FreeStructure(PARASTYLE, pspom);
//     else newpara->style = pspom;
//     newpara->style->used++;

// zamenime koncovy znak prvniho a druheho odstavce 
     {    // nepouzito char *oldend = newpara->block_last->memory + newpara->off_last; // konec noveho odstavce
	  UBYTE *newend = misto.block->memory + misto.block_off;

//          *newend = *oldend;       *oldend = (pbreak) ? CH_EOP : CH_EOL;
#ifdef CHECK_BUGS
	  if (*newend != CH_EOL) InternalError("SplitParas - newend blbe");
#endif
	  *newend = (pbreak) ? CH_EOP : CH_EOL;
     }

  // Locations - zatim vynechano - provede se v ramci formatovanni
//>>
//      for(loc = &doc->cursor, i = 0; i < NUM_DOC_LOCATIONS; loc++, i++)
//
//      { // para_off apod. se doladi pri formatovani
//           if (loc->para == orig)
//           {    if (1 == CompareBlockPos(loc->block, loc->block_off, misto.block, misto.block_off))
//                {    loc->para = orig;   loc->chars_off -= orig->length;    }
//           }
//           if (loc->line == misto.line)
//           {
//                if ( (loc->linedim_off > misto.linedim_off) ||
//                     (begline && (loc->linedim_off == misto.linedim_off) )
//                     loc->linedim_off++;
//           }
//           if (loc->style == misto.style)    // ==> je to ve stejnem odstavci
//           {
//           }
//      }
// 
//<<

// Locations have to be updated - done below only if format is specified!
//>> "oprava Locations"
     if (format)
     {    
          Location *pom;
	  int i;

                                             // NUM_DOC_LOCATIONS - 1 ... display_end set later
	  for( i = 0, pom = &doc->cursor; i < NUM_DOC_LOCATIONS - 1; i++, pom++)
	  {    
               if (i == DOC_LOCATION_CURSOR) continue;    // CURSOR nastavime dale ...
	       if (i == DOC_LOCATION_CURSORLINE) continue;    // CURSOR_LINE nastavime dale ...

	       if (pom->block == NULL) continue;              // napr. neni-li blok aktivni, neni treba
                                                            // block == NULL - locations is not set
#ifdef CHECK_BUGS
	       if (NOT BlockToLocation(teditfile, pom, pom->block, pom->block_off, NULL, 0)) InternalError("FormatLines - blocktolocation prevod");
#else
	       (void) BlockToLocation(teditfile, pom, pom->block, pom->block_off, NULL, 0);
#endif
	  }
     }
//<<

// Locations - cursor and cursor line
     cur->block = newpara->block_first;     cur->block_off = newpara->off_first;
//          cur->page= ???;                  cur->page_off  = ???;
     cur->para = newpara;               // cur->para_off  = ???;
//	  cur->line  = newpara->line_first;   // neexistuje    cur->linedim_off = newpara->ld_first;
     cur->chars_off = 0;
     cur->line_num++;    // we are one line further
     
     doc->cursorline = *cur;
     (void) GetPrevPos(teditfile, &doc->cursorline, FALSE, 0);

     if (cursor)    // zbytek se nastavi pri format
     {
//#ifdef CHECK_BUGS
//	  if (NOT format) InternalError("SplitParagraph - cursor && NOT format");
//#endif
//	  DrawCursor(teditfile, TRUE, 0, 0, 0, 0, FALSE, TRUE);
     }

// Locations - display_end
     if (format)
          SetDisplayBegEnd(teditfile, FALSE, 0);

// document - total number of lines
// change doc->num_lines++; is done by AddNewParagraph
}
//<<

