/*
 * BDT-Mouse.c      modul s funkcemi pro zpracovani reakci na mys
 */

#define BDT_MOUSE_C

#include "wed_editor.h"



// lokalni deklarace
void SelectActualWord(TEditFile *teditfile, BOOL sentence, Location *beg, Location *end);
void SelectActualPara(TEditFile *teditfile, Location *beg, Location *end);
void SelectActualDoc(TEditFile *teditfile, Location *beg, Location *end);
void UnmarkBlock(TEditFile *teditfile, BOOL beg);

/* pomocna fce pro znaceni bloku - ma dan doc a novy konec bloku
 * a provede vse potrebne pro prezobrazeni apod.; pouziva zamena_bb_be */
void ChangeBlockSelection(TEditFile *teditfile, Location *newend)
//>>
{    
     EditFile *doc = teditfile->GetEditFile();

     Location lastpos, first, last, pomloc, bb, be;
//     struct Window *win = doc->win;
     BOOL redraw = TRUE, block = doc->block, blockfalse = FALSE;

/* pokud kurzor = poc. pozice mysi --> block = FALSE,
 * jinak blok existuje, dame block = TRUE a nastavime novy konec */
     if ((doc->blockpoint.block == newend->block) && (doc->blockpoint.block_off == newend->block_off))
	  blockfalse = TRUE;
     else
     {
//     	  if (NOT doc->block_select)    // pokud byl kurzor videt --> smazeme
//	       DrawCursor(teditfile, TRUE, 0, 0, 0, 0, FALSE, TRUE);
	  doc->block = TRUE;  doc->block_select = TRUE;
     }
     if (doc->zamena_bb_be)
     {    lastpos = doc->block_begin;
	  doc->block_begin = *newend;
     }
     else
     {    lastpos = doc->block_end;
	  doc->block_end = *newend;
     }
  // nutno zajistit, aby v block_begin byl opravdu pocatek
     if (0 <= CompareBlockPos(doc->block_begin.block, doc->block_begin.block_off, doc->block_end.block, doc->block_end.block_off))
     {    pomloc = doc->block_end;
	  doc->block_end = doc->block_begin;
	  doc->block_begin = pomloc;
	  doc->zamena_bb_be = NOT doc->zamena_bb_be;
     }

/* prekreslime radky mezi starou a novou pozici kurzoru v modu block
 * (podle predchoziho nastaveni) */
     switch (CompareBlockPos(lastpos.block, lastpos.block_off, newend->block, newend->block_off))
     {    case -1:  first = lastpos;    last = *newend; break;
	  case  0:  redraw = FALSE; break;
	  case  1:  first = *newend;    last = lastpos; break;
     }
     if (redraw)
     { // nutno provest upravy pro DrawLine
	  bb = doc->block_begin;
	  be = doc->block_end;
	  doc->block_begin = first;
	  doc->block_end   = last;
       // vlastni vykresleni
	  GetPrevPos(teditfile, &first, FALSE, 0);
	  GetPrevPos(teditfile, &last, FALSE, 0);
	  // omezime se jen na viditelny vyrez
	  if (1 == CompareParaLinePos(doc->display_begin.para, first.para))
	       first = doc->display_begin;
	  if (1 == CompareParaLinePos(last.para, doc->display_end.para))
	       last = doc->display_end;

	  doc->cursor = *newend;
	  doc->cursorline = doc->cursor;
	  GetPrevPos(teditfile, &doc->cursorline, FALSE, 0);
// invalidate the area
#ifdef CHECK_BUGS
          if (first.line_num < doc->display_begin.line_num) InternalError("ChangeBlockSelection - first before begin");
          if (last.line_num > doc->display_end.line_num) InternalError("ChangeBlockSelection - last after end");
          if (first.line_num > last.line_num) InternalError("ChangeBlockSelection - last before first");
#endif
          InvalidateLines(teditfile, last.line_num - first.line_num + 1, first.line_num - doc->display_begin.line_num);
//	  RedrawVisibleClip(doc, &first, &last, 0, 0, FALSE, FALSE);
       // obnova block_#?
	  doc->block_begin = bb;
	  doc->block_end   = be;
       // zviditelneni pozice kurzoru 
	  MakeCursorVisible(teditfile, 0, 0, TRUE);
     }
     if (blockfalse) doc->block = FALSE;
  // je-li zruseno oznaceni bloku ...
     if (NOT doc->block && block)
     {
	  doc->block_select = FALSE;
	  doc->cursorline = doc->cursor = doc->block_begin;
	  GetPrevPos(teditfile, &doc->cursorline, FALSE, 0);
//	  (void) DrawLine(doc, &doc->cursorline, 0, NULL, 0, 0, 0, doc->block, TRUE, FALSE, FALSE, FALSE, TRUE);
     }
}
//<<

/* funkce pro zruseni oznaceni bloku, cursor umisti na pocatek
 * nebo konec byvaleho bloku podle 'beg' */
void UnmarkBlock(TEditFile *teditfile, BOOL beg)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     Location *begin = &doc->display_begin, *end = &doc->display_end;
     Location startredraw = doc->block_begin, endredraw = doc->block_end;
     Location *redraw1 = &startredraw, *redraw2 = &endredraw;
//     struct Window *win = doc->win;
     BOOL redraw = TRUE; // ma se prekreslit, aby zmizel blok?
     BOOL onepara;

     GetPrevPos(teditfile, &startredraw, FALSE, 0);
     GetPrevPos(teditfile, &endredraw, FALSE, 0);
#ifdef CHECK_BUGS
     if (1 == CompareBlockPos(startredraw.block, startredraw.block_off, endredraw.block, endredraw.block_off))
	  InternalError("Unmark block - start < end");
#endif
  // for display update - do we delete within one line?
     onepara = (redraw1->para == redraw2->para) ? TRUE : FALSE;
  // pro prekresleni = smazani bloku je potreba urcit odkud kam
  // (protoze blok muze zabirat jen malou cast viditelneho vyrezu)
  // musi se urcit, zda se vubec prekresluje ... (blok nemusi byt videt)
     if (1 == CompareBlockPos(begin->block, begin->block_off, startredraw.block, startredraw.block_off))
	  redraw1 = NULL;     // kresli se od display_begin
     if (1 == CompareBlockPos(begin->block, begin->block_off, endredraw.block, endredraw.block_off))
	  redraw = FALSE;     // end je pred zacatkem obr. --> nemusime
     if (1 == CompareBlockPos(startredraw.block, startredraw.block_off, end->block, end->block_off))
	  redraw = FALSE;     // beg za koncem obr. --> nemusime
     if (1 == CompareBlockPos(endredraw.block, endredraw.block_off, end->block, end->block_off))
	  redraw2 = NULL;     // kresli se do display_end
// v redraw* jsou ukazatele na Loc (nebo NULL) urcujici, co se prekresli

// vlastni odznaceni - na obrazovce i v EditFile
     doc->block_select = TRUE;
  // smazame oznaceni na obrazovce
//     RedrawVisibleClip(doc, NULL, NULL, 0, 0, TRUE);
  // zobrazeni kurzoru ! a nastaveni cursorline !
     doc->block_select = FALSE;
//     doc->old_ok = FALSE;
     doc->cursor = (beg) ? doc->block_begin : doc->block_end;
     doc->cursorline = doc->cursor;
     GetPrevPos(teditfile, &doc->cursorline, FALSE, 0);
  // smazeme blok
     doc->block = FALSE;
     clrmem(&doc->block_begin, sizeof(Location));
     clrmem(&doc->block_end, sizeof(Location));
  // vykresleni
     if (redraw)
     {
#ifdef CHECK_BUGS
          if (redraw2 && (redraw2->line_num < begin->line_num)) InternalError("UnmarkBlock - redraw2 < begin");
          if (redraw1 && redraw2 && (redraw2->line_num < redraw1->line_num)) InternalError("UnmarkBlock - redraw2 < redraw1");
          if (redraw1 && (end->line_num < redraw1->line_num)) InternalError("UnmarkBlock - end < redraw1");
#endif
          if (onepara)
          {
               if (redraw1 == NULL) // redraw from the display_begin
                    InvalidateLines(teditfile);
               else InvalidateLines(teditfile, 1, redraw1->line_num - begin->line_num);
          }
          else
          {
               if (redraw1 == NULL) // redraw from the display_begin
                    InvalidateLines(teditfile);
               else InvalidateLines(teditfile, doc->wincheight, redraw1->line_num - begin->line_num);
	  }
     }
//	  RedrawVisibleClip(doc, redraw1, redraw2, 0, 0, TRUE, FALSE);
//     (void) DrawLine(doc, &doc->cursorline, 0, NULL, 0, 0, 0, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE);
}
//<<

/* funkce, ktera oznaci zvolene rozmezi textu */
void SelectTextBlock(TEditFile *teditfile, Location *beg, Location *end)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     if (doc->block) UnmarkBlock(teditfile, TRUE);
     if ((beg->block == end->block) && (beg->block_off == end->block_off))
	  return;   // jsou-li totozne, blok neznacime

//     DrawCursor(teditfile, TRUE, 0, 0, 0, 0, FALSE, TRUE);
     doc->block_select = TRUE;     doc->zamena_bb_be = FALSE;

  // pocatecni zavedeni
     doc->block = FALSE;           doc->zamena_bb_be = FALSE;
     doc->cursor = *beg;           doc->blockpoint = *beg;
     doc->block_begin = *beg;      doc->block_end = *beg;
     doc->block_select = FALSE;
  // vlastni oznaceni
     ChangeBlockSelection(teditfile, end);
}
//<<

/* funkce pro oznaceni slova, v nemz je kurzor */
// moveatbeg udava, zda si ma funkce presunout kurzor na pocatek
// pokud byl zvolen blok --> nebude to fungovat, nebot se musi odznacit...
// sentence ... udela totez pro vetu
// pokud je dano beg/end, dosadi se do nich pocatek/konec znaceneho bloku
void SelectActualWord(TEditFile *teditfile, BOOL sentence, Location *beg, Location *end)
//>>
{    
     EditFile *doc = teditfile->GetEditFile();

     Location pom;

     if (doc->block) UnmarkBlock(teditfile, TRUE);
  // presun kurzoru na pocatek
     GetPrevWord(teditfile, &doc->cursor, NULL, NULL, NULL, sentence, FALSE);
     doc->cursorline = doc->cursor;
     (void) GetPrevPos(teditfile, &doc->cursorline, FALSE, 0);
  // nalezeni konce bloku
     pom = doc->cursor;
     (void) GetNextWord(teditfile, &pom, NULL, NULL, NULL, sentence, FALSE, TRUE);
  // zvyrazneni textu + dosazeni
     if (beg) *beg = doc->cursor;
     if (end) *end = pom;
     SelectTextBlock(teditfile, &doc->cursor, &pom);
}
//<<

// podobna funkce pro volbu odstavce / dokumentu
void SelectActualPara(TEditFile *teditfile, Location *beg, Location *end)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     Location pom;
     Paragraph *para;

     if (doc->block) UnmarkBlock(teditfile, TRUE);
     para = doc->cursor.para;
  // zacatek
     (void) BlockToLocation(teditfile, &pom, para->block_first, para->off_first, para, NULL);
     doc->cursorline = doc->cursor = pom;
     (void) GetPrevPos(teditfile, &doc->cursorline, FALSE, 0);

  // nalezeni konce bloku
     if (para->next)
     {    para = para->next;
	  (void) BlockToLocation(teditfile, &pom, para->block_first, para->off_first, para, NULL);
     }
     else (void) BlockToLocation(teditfile, &pom, para->block_last, para->off_last, para, NULL);

  // zvyrazneni textu + dosazeni
     if (beg) *beg = doc->cursor;
     if (end) *end = pom;
     SelectTextBlock(teditfile, &doc->cursor, &pom);
}
//<<

void SelectActualDoc(TEditFile *teditfile, Location *beg, Location *end)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     Location pom;

     if (doc->block) UnmarkBlock(teditfile, TRUE);
  // zacatek
     (void) BlockToLocation(teditfile, &pom, doc->block_first, 0, NULL, NULL);
     doc->cursorline = doc->cursor = pom;
     (void) GetPrevPos(teditfile, &doc->cursorline, FALSE, 0);

  // nalezeni konce bloku
#ifdef CHECK_BUGS
	if (doc->num_lines < 1) InternalError("SelectActualDoc - num_lines < 1");
#endif
     (void) BlockToLocation(teditfile, &pom, doc->block_last, doc->block_last->size - doc->block_last->free - 1, doc->para_last, doc->num_lines - 1 /*, doc->page_last */);

  // zvyrazneni textu + dosazeni
     if (beg) *beg = doc->cursor;
     if (end) *end = pom;
     SelectTextBlock(teditfile, &doc->cursor, &pom);
}
//<<

