/*
 * BDT-Move.c       modul s fcemi pro zmeny struktur pri pohybu v dokumentu
 */

#define BDT_MOVE_C

#include "wed_editor.h"
/*** Modify Start : d-tec  ***/
#include <mbctype.h>
/*** Modify End : d-tec  ***/



// ZMENY LOCATION //

/* fce, ktera zadanou Location strukturu upravi na ukazatel na nasledujici
 * radek k zadanemu, resp. konec zadaneho, resp. pro posun v tomto smeru;
 * je-li newline == TRUE, pak hledame novy radek, jinak konec aktualniho;
 * pokud je zadano numchars, posun je o nejvyse tento pocet znaku */
/* fce vraci FALSE, kdyz se dojde na konec textu dokumentu */
BOOL GetNextPos(TEditFile *teditfile, Location *loc, BOOL newline, LONG numchars)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

//     TextStyle *next = loc->style->next;
     MemoryBlock *mb = loc->block;
//     ULONG change_offset = (next) ? next->offset : ~0L;
     BOOL countchars = (numchars) ? TRUE : FALSE;
//     BOOL lastpageline = LastPageLine(loc);
     UBYTE *l = mb->memory + loc->block_off;
     UBYTE znak = *l;     // (newline) ? '\0': *l;

  // hledame konec radku - pritom prubezne menime polozky *line*
  // odstavec se v ramci radku nemeni; je-li newline == TRUE, zastavi se to za
  // znakem '\n' na novem radku; je newline == FALSE, zastavi se na '\n', tj.
  // na konci radku
	  // newline + jsme na konci radku ...
     if (newline && ENDLINE(znak))
     {    loc->chars_off++;
/*** Modify Start : d-tec  ***/
          if (_ismbslead(mb->memory, mb->memory + loc->block_off)) {
               loc->chars_off++;
               if (numchars > 0) numchars--;
          }
/*** Modify End : d-tec  ***/
	  if ((l = IncrementPosMB(&mb, &loc->block_off)) == NULL) { loc->chars_off--; return(FALSE); }
	  else loc->block = mb;
     }
     while (NOT ENDLINE(znak))
     {    if (newline) znak = *l;      loc->chars_off++;        numchars--;
/*** Modify Start : d-tec  ***/
          if (_ismbslead(mb->memory, mb->memory + loc->block_off)) {
               loc->chars_off++;
               if (numchars > 0) numchars--;
          }
/*** Modify End : d-tec  ***/
       /* zajisteni pripadneho preskoku na dalsi pametovy blok */
	  if ((l = IncrementPosMB(&mb, &loc->block_off)) == NULL) { loc->chars_off--; return(FALSE); }
	  else { loc->block = mb; if (NOT newline) znak = *l; }
//       /* test zmeny polozek - zde pouze TextStyle; nic jineho se v radku nemeni */
//	  if (change_offset < loc->chars_off)
//	  {    next = (loc->style = next)->next;
//	       change_offset = (next) ? next->offset : ~0L;
//	  }
	  if (countchars && (numchars == 0)) break;    // uz jsme prosli dost
     } // end while
  // je-li prechod na novou radku - zmena polozek, ktere se meni s novym radkem
     if ( newline && ENDLINE(znak) && NOT (countchars && (numchars == 0)) )
     {    Paragraph *p = loc->para;
//	  LineNode *ln = loc->line;
//	  MUNIT addh = GetFirstLineHeight(p->style, ln, FALSE, TRUE); // zmena polohy ...

#ifdef CHECK_BUGS
          if (loc->chars_off != p->length) InternalError("GetNextPos - newline and no new paragraph"); 
#endif
       /* Paragraph */
	  if (loc->chars_off == p->length)
	  { // prechod na novy odstavec, pokud jsme tam jiz dorazili - nejaky musi nasledovat !
#ifdef CHECK_BUGS
	       if (p->next == NULL) { InternalError("GetNextPos"); return(FALSE); }
	       if ((loc->block != p->next->block_first) || (loc->block_off != p->next->off_first))
		    InternalError("GetNextPos - neshoda char_off a memoryblock");
#else
	       if (p->next == NULL) return(FALSE);
#endif
	       p = loc->para = p->next;
//	       loc->style = p->ts_first;
//	       loc->para_off = GetFirstLineHeight(p->style, ln, TRUE, FALSE);
	       loc->chars_off = 0;
               loc->line_num++;    // new paragraph = new line ... we have to update counter
	  }
//	  else loc->para_off += addh;
     }

     return(TRUE);
} /* end GetNextPos */
//<<

/* nasledujici fce dela totez jako predchozi, ale ve smeru k zacatku dokumentu */
/* vrati FALSE, pokud se dorazilo predcasne na zacatek dokumentu */
BOOL GetPrevPos(TEditFile *teditfile, Location *loc, BOOL newline, LONG numchars)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

//     PageSize *pgs = &doc->pagesize;
//     TextStyle *prev = loc->style;
     MemoryBlock *mb = loc->block;
//     ULONG change_offset = (prev) ? prev->offset : ~0L;
     ULONG chars_def = 0;
     BOOL countchars = (numchars) ? TRUE : FALSE;
//     BOOL firstpageline = FirstPageLine(loc);
     UBYTE *l = mb->memory + loc->block_off;
     UBYTE znak;

  // hledame konec radku - pritom prubezne menime polozky *line*
  // odstavec se v ramci radku nemeni; je-li newline == TRUE, zastavi se to za
  // znakem '\n' na novem radku; je newline == FALSE, zastavi se na '\n', tj.
  // na konci radku
     do
     { 
//       /* test zmeny polozek - zde pouze TextStyle; nic jineho se v radku nemeni */
//	  if (change_offset == loc->chars_off)
//	  {    prev = prev->prev;
//	       if (prev) loc->style = prev;
//	       change_offset = (prev) ? prev->offset : ~0L;
//	  }
	  if (countchars && (numchars == 0)) break;    // uz jsme prosli dost

////          if (newline) znak = *l;          to je nejak spatne
	  if (loc->chars_off > 0) loc->chars_off--;
	  else chars_def++;
          numchars--;
       /* zajisteni pripadneho preskoku na dalsi pametovy blok */
	  if ((l = DecrementPosMB(&mb, &loc->block_off)) == NULL) return((BOOL) NOT newline);
	  else
	  {    loc->block = mb;
////               if (NOT newline) znak = *l;     to je nejak spatne
	       znak = *l;
	  }
/*** Modify Start : d-tec  ***/
          /* PC ??? ismbtrail ??? */
      if (_ismbslead(mb->memory, mb->memory + loc->block_off)) loc->chars_off--;
/*** Modify End : d-tec  ***/
     } while (NOT ENDLINE(znak));
  // je-li prechod na novou radku - zmena polozek, ktere se meni s novym radkem
  // chceme-li pri countchars povolit prechod na novy radek -->
  // musime polozit newline = TRUE
     if ( NOT newline && ENDLINE(znak) /* && NOT countchars */)
     {    loc->chars_off++;   
#ifdef CHECK_BUGS
	  if (chars_def > loc->chars_off) InternalError("GetPrevPos - chars_def too large");
#endif
	  loc->chars_off -= chars_def;
/*** Modify Start : d-tec  ***/
      if (_ismbslead(loc->block->memory, loc->block->memory + loc->block_off)) loc->chars_off++;
/*** Modify End : d-tec  ***/
	  (void) IncrementPosMB(&loc->block, &loc->block_off);
     }
     if ( newline && ENDLINE(znak) )
     {    Paragraph *p = loc->para;
//	  LineNode *ln = loc->line;
//	  MUNIT addh = GetFirstLineHeight(p->style, ln->prev, FALSE, TRUE);

#ifdef CHECK_BUGS
          if (loc->chars_off != 0) InternalError("GetPrevPos - newline and no new paragraph"); 
#endif
       /* Paragraph */
	  if (loc->chars_off == 0)
	  { // prechod na predchozi odstavec, pokud jsme tam jiz dorazili
#ifdef CHECK_BUGS
	       if (p->prev == NULL) { InternalError("GetPrevPos - chybi predchozi odstavec"); return(FALSE); }
	       if ((loc->block != p->prev->block_last) || (loc->block_off != p->prev->off_last))
		    InternalError("GetPrevPos - neshoda char_off a memoryblock");
#else
	       if (p->prev == NULL) return(FALSE);
#endif
	       p = loc->para = p->prev;      // ukazatel na odstavec
//	    // ukazatel na styl pisma
//	       loc->style = p->ts_last;
//	    // lineNode
//// zbytecne               loc->line = p->line_last;     // neexistuje loc->linedim_off = p->ld_last;
//	    // offset od pocatku odstavce
//	       loc->para_off = p->next->topedge - p->topedge -
//			       GetLastLineHeight(p->style, ln, TRUE, TRUE);
	    // a nakonec chars_off
	       loc->chars_off = p->length - 1;
               loc->line_num--;    // new paragraph = new line ... we have to update counter
	  }
//	  else loc->para_off -= addh;
     }

     return(TRUE);
} /* end GetPrevPos */
//<<

// pomocne makro - je to znak konce vety
#define ENDSENTENCE(znak)     ((znak == '.') || (znak == '!') || (znak == '?'))
/* je treba vytvorit podobne fce take pro slova - lze ovsem vyuzit jiz ^^^
 * existujich pro zmenu Location a hledat jenom, o kolik se to ma posunout */
/* nasledujici fce slouzi k nalezeni nasledujiciho slova v pameti - vstup
 * i vystup je dan MemoryBlock a ofsetem nebo pomoci Location;
 * je-li zadano Location, vraci se Location, jinak se pracuje s MemoryBlock
 * a offsetem; fce vraci FALSE, pokud bylo predcasne dosazeno konce dokumentu */
/* pokud sentence je TRUE, pak hledame zacatek nasledujici vety */
// use_separators --> (pro slova) ma se uzivat oddeleni slov mezerou ci separatory?
// wordend ... (jen pro preskok slova) skonci na konci slova = pocatku mezer
// normalni hodnota wordend je tedy FALSE
BOOL GetNextWord(TEditFile *teditfile, Location *loc, Paragraph *para,
		 MemoryBlock **block, ULONG *offset, BOOL sentence,
		 BOOL use_separators, BOOL wordend)
//>>
{    
     EditFile *doc = teditfile->GetEditFile();

//     extern BOOL no_separator_separator;
     MemoryBlock *mb;
     ULONG off;
     BOOL MBModus = (loc == NULL) ? TRUE : FALSE;
     BOOL space, spaceskip = FALSE, docend = FALSE, eop = FALSE;
     UWORD charsoff = 0, linesoff = 0, i;
     UBYTE *l, znak = '\0', prevznak = '\0';

     if (doc->no_separator_separator) use_separators = TRUE;
#ifdef CHECK_BUGS
     if (MBModus && ((block == NULL) || (offset == NULL) || (para == NULL)))
     {    InternalError("GetNextWord"); return(FALSE);    }
#else
     if (MBModus && ((block == NULL) || (offset == NULL) || (para == NULL)))
	  return(FALSE);
#endif

     mb = (MBModus) ? *block : loc->block;
     off = (MBModus) ? *offset : loc->block_off;
     l = mb->memory + off;    // toto je spatne loc->block_off;
     if (NOT MBModus) para = loc->para;

/* nalezeni zacatku dalsiho slova v MemoryBlock */
     FOREVER
     {    if (znak) prevznak = znak;    znak = *l;
	  if (ENDLINE(znak))
          {
               if (wordend) break;	// ASCII editor: ENDLINE = End of Paragraph!
               charsoff = 0; linesoff++;
          }
	  else if (sentence)  // hledani dalsi vety
	       { // nasli jsme, co bylo treba, dohledame zacatek slova
		    if (ENDSENTENCE(prevznak) && ((znak == CH_SPACE) || (znak == CH_TAB)))
		    {    spaceskip = TRUE;   sentence = FALSE;   }
		    charsoff++;
	       }
	       else /* nejprve preskocime znaky, pak mezery */
	       {    if (use_separators)
			 space = SEPARATOR(teditfile, znak);
		    else space = ((znak == CH_SPACE) || (znak == CH_TAB)) ? TRUE : FALSE;
		    if (spaceskip)
		    {    if (NOT space) break;    }
		    else if (space)
			      if (wordend)
				   break;
			      else spaceskip = TRUE;
		    charsoff++;
	       }

	  if ((mb == para->block_last) && (off == para->off_last)) eop = TRUE;
       /* zajisteni pripadneho preskoku na dalsi pametovy blok */
/*** Modify Start : d-tec  ***/
      if (_ismbslead(mb->memory, mb->memory + off)) charsoff++;
/*** Modify End : d-tec  ***/
	  if ((l = IncrementPosMB(&mb, &off)) == NULL) { docend = TRUE; break; }
       /* konec odstavce -> konec */    if (eop) break;
     } // end while

     if (MBModus)        // to uz mame hotovo
     {    *block = mb;   *offset = off;      return((BOOL) NOT docend);    }
/* nalezeni Location - pomoci vyse uvedenych fci */
     for(i = 0; i < linesoff; i++ ) GetNextPos(teditfile, loc, TRUE, 0);
     if (charsoff) GetNextPos(teditfile, loc, TRUE, charsoff);
     return((BOOL) NOT docend);
} /* end GetNextWord */
//<<

BOOL GetPrevWord(TEditFile *teditfile, Location *loc, Paragraph *para,
		 MemoryBlock **block, ULONG *offset, BOOL sentence, BOOL use_separators)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

//     extern BOOL no_separator_separator;
     MemoryBlock *mb; /*, *mbpom; */
     ULONG off; /*, offpom; */
     BOOL MBModus = (loc == NULL) ? TRUE : FALSE, dogetprev = FALSE;
     BOOL space, spaceskip = TRUE, startend = FALSE, firstchar = TRUE, dec = FALSE;
     UWORD charsoff = 0, linesoff = 0, i;
     UBYTE *l, znak = '\0', prevznak = '\0';

     if (doc->no_separator_separator) use_separators = TRUE;
#ifdef CHECK_BUGS
     if (MBModus && ((block == NULL) || (offset == NULL) || (para == NULL)))
     {    InternalError("GetPrevWord"); return(FALSE);    }
#else
     if (MBModus && ((block == NULL) || (offset == NULL) || (para == NULL)))
	  return(FALSE);
#endif

     mb = (MBModus) ? *block : loc->block;
     off = (MBModus) ? *offset : loc->block_off;
     l = mb->memory + off;    // toto je spatne loc->block_off;
     if (NOT MBModus)    
     {    para = loc->para;    }
	  if ((mb == para->block_first) && (off == para->off_first))
	       if (para->prev) para = para->prev;
//     }

/* nalezeni zacatku dalsiho slova v MemoryBlock */
     FOREVER
     { // test zacatku odstavce //
	  if ((mb == para->block_first) && (off == para->off_first) && NOT firstchar)
	  {    l = mb->memory + off;    dec = FALSE;     break;    }
	  if ((l = DecrementPosMB(&mb, &off)) == NULL)
	  {    startend = TRUE;    dec = FALSE;   break;    }
       /* test znaku, na nemz se nachazime */
	  if (znak) prevznak = znak;    znak = *l;     firstchar = FALSE;
	  if (ENDLINE(znak)) { charsoff = 0; linesoff++; }
	  else if (sentence)
	       {    if (ENDSENTENCE(znak) && ((prevznak == CH_SPACE) || (prevznak == CH_TAB)))
		    if (NOT ((linesoff == 0) && (charsoff <= 1)))
		    {    if (charsoff > 0) charsoff--;
			 else { linesoff--; charsoff = 0; }
			 dogetprev = TRUE;
			 dec = TRUE;    break;
		    }
		    charsoff++;
	       }
	       else /* nejprve preskocime mezery, pak znaky */
	       {    if (use_separators)
			 space = SEPARATOR(teditfile, znak);
		    else space = ((znak == CH_SPACE) || (znak == CH_TAB)) ? TRUE : FALSE;
		    if (NOT spaceskip)
		    {    if (space) {   dec = TRUE;    break;    }
		    }
		    else if (NOT space) spaceskip = FALSE;
		    charsoff++;
	       }
     } // end while

  // pri hledani jsme "prejeli" o jeden znak ...
     if (dec)
     {    l = IncrementPosMB(&mb, &off);
	  if (ENDLINE(*l))
	  {    IncrementPosMB(&mb, &off);
	       linesoff--;    charsoff = 0;  dogetprev = TRUE;
	  }
     }

     if (MBModus)        // to uz mame hotovo
     {    *block = mb;   *offset = off;      return((BOOL) NOT startend);     }
/* nalezeni Location - pomoci vyse uvedenych fci */
     for( i = 0; i < linesoff; i++ ) GetPrevPos(teditfile, loc, TRUE, 0);
     if (charsoff || dogetprev) GetPrevPos(teditfile, loc, FALSE, charsoff);
     return((BOOL) NOT startend);
} /* end GetPrevWordL */
//<<



// NASLEDUJI TRANSFORMACNI A VYHLEDAVACI FCE //

/* tato fce opet vytvori strukturu Location k zadane pozici v textu - vstup
 * je ukazatel na znak dany MemoryBlock a offsetem, vrati vyplnenou strukturu
 * Location odpovidajici tomuto znaku; FALSE vrati, je-li pozice mimo dokument */
// if para1 != NULL, linenum has to be entered too!
BOOL BlockToLocation(TEditFile *teditfile, Location *loc, MemoryBlock *mb, ULONG off, Paragraph *para1, ULONG linenum)
//		     Paragraph *para1, Page *page1)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

//     Page *page;
     Paragraph *para;
//     ParaStyle *ps;
//     TextStyle *ts;
     MemoryBlock *mbpom;
     ULONG offpom, pomoff, line;
     UBYTE *l;

     loc->block = mb;              loc->block_off = off;
/* nalezeneme odstavec, v nemz lezi dana poloha */
#ifdef CHECK_BUGS
     if (para1 && (CompareBlockPos(para1->block_first, para1->off_first, mb, off) == 1))
     {    InternalError("BlockToLocation - chybne para1");   para1 = NULL;    }
#endif
     for( para = (para1 && linenum) ? para1 : doc->para_first, line = (para1 && linenum) ? linenum : 0;
	  para && (CompareBlockPos(para->block_last, para->off_last, mb, off) == -1);
	  para = para->next, line++ );
#ifdef CHECK_BUGS
     if (para == NULL) { InternalError("BlockToLocation - para == NULL"); return(FALSE); }
#else
     if (para == NULL) return(FALSE);
#endif
/* naplneni Location ... */
//     ps = para->style;
//     loc->line = para->line_first; // neexistuje loc->linedim_off = para->ld_first;
     loc->para = para;             // loc->para_off = GetFirstLineHeight(ps, loc->line, TRUE, FALSE);
     loc->chars_off = 0;           // loc->style = para->ts_first;
     loc->line_num = line;

/* nalezeni pozice v MemoryBlock */
     for( mbpom = para->block_first, offpom = para->off_first, l = mbpom->memory + offpom /*, ts = loc->style->next */;
	  (mbpom != mb) || (offpom != off); )
     {    
//	  if (ts && (loc->chars_off >= ts->offset))
//	  {    loc->style = ts;    ts = ts->next;    }
#ifdef CHECK_BUGS
          // paragraph = one line!
	  if (ENDLINE(*l)) InternalError("BlockToLocation - EOL!");
#endif
//	  if (ENDLINE(*l))
//	  {    if (LastPageLine(loc))   // ? prechod na dalsi stranku
//	       {    loc->para_off += doc->pagesize.height - loc->page_off;
//		    loc->page_off  = doc->actlayout.tm + GetFirstLineHeight(ps, loc->line, FALSE, FALSE);
//		    loc->para_off += loc->page_off;
//		    loc->page = loc->page->next;
//#ifdef CHECK_BUGS
//		    if (loc->page == NULL) InternalError("BlockToLocation - loc->page == NULL");
//#endif
//		    if (loc->page == NULL) loc->page = doc->page_last;
//	       }
//	       else
//	       {    pomoff = GetFirstLineHeight(ps, loc->line, FALSE, TRUE);
//		    loc->para_off += pomoff; loc->page_off += pomoff;
//	       }
////               CorrectNumeric2(doc, &loc->para_off);
////               CorrectNumeric2(doc, &loc->page_off);
//	       (void) NextPosLN(&loc->line);
//	  }
/*** Modify Start : d-tec  ***/
      if (_ismbslead(mbpom->memory, mbpom->memory + offpom)) loc->chars_off++;
/*** Modify End : d-tec  ***/
	  l = IncrementPosMB(&mbpom, &offpom);
	  loc->chars_off++;
     } // end for

     return(TRUE);
} /* end BlockToLocation */
//<<

/* tato fce provede zmenu velikosti pismen v bloku textu podle
 * zadaneho modu */
void ChangeBlockCase(TEditFile *teditfile, ULONG mode)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     Paragraph *para = doc->block_begin.para, *endpara = doc->block_end.para, *parapom;
     MemoryBlock *mb = doc->block_begin.block, *endmb = doc->block_end.block, *mbpom;
     ULONG off = doc->block_begin.block_off, endoff = doc->block_end.block_off, offpom;
     ULONG pom, pompom;
     UBYTE *line, *linepom;

     if (NOT doc->block)
     {
          line = GetPosMB(doc->cursor.block, doc->cursor.block_off);
	  pom = *line;
          
	  switch (mode)
	  {
	       case MN_CaseLower:
		    *line = (UBYTE) LetterLowerCase(pom);
		    break;
	       case MN_CaseUpper:
		    *line = (UBYTE) LetterUpperCase(pom);
		    break;
	       case MN_CaseChange:
		    *line = (UBYTE) LetterChangeCase(pom);
		    break;
	  }
     }
     else
     {
          // vlastni konverze pro block
          line = GetPosMB(mb, off);
          for(; (mb != endmb) || (off != endoff); line = IncrementPosMB(&mb, &off))
          {
               if (line == NULL)
               {
#ifdef CHECK_BUGS
                    InternalError("ChangeCaseBlock - line = NULL");
#endif
                    return;
               }
               pom = *line;
          // prevod znaku podle aktualniho modu
               switch (mode)
               {
                    case MN_CaseLower:
                         *line = (UBYTE) LetterLowerCase(pom);
//                    if (Prefs.general.czech_convert && (*line > 160))
//                         *line = (UBYTE) (LocaleAvail) ? ConvToUpper(Country, pom) : ToUpper(pom);
//                    else *line = (UBYTE) (LocaleAvail) ? ConvToLower(Country, pom) : ToLower(pom);
                         break;
                    case MN_CaseUpper:
                         *line = (UBYTE) LetterUpperCase(pom);
//                    if (Prefs.general.czech_convert && (*line > 160))
//                         *line = (UBYTE) (LocaleAvail) ? ConvToLower(Country, pom) : ToLower(pom);
//                    else *line = (UBYTE) (LocaleAvail) ? ConvToUpper(Country, pom) : ToUpper(pom);
                         break;
                    case MN_CaseChange:
                         *line = (UBYTE) LetterChangeCase(pom);
//                    if (isalpha(*line) || (192 <= *line))
//                         *line = (*line & 0x20) ? (*line & ~0x20) : (*line | 0x20);
                         break;
//	       case MN_CaseCapital:     // not implemented here ...
//		    mbpom = mb;    offpom = off;       pompom = 0;
//		 // test, zda nejsme na pocatku odstavce
//		    for(parapom = para; parapom; parapom = parapom->next)
//		    {
//			 if ((parapom->block_first == mbpom) && (parapom->off_first == offpom))
//			 {    pompom = ' ';       break;    }
//			 if (parapom == endpara) break;     // jsme na konci
//		    }
//		    if (pompom == 0)    // neni to pocatek odstavce
//		    {
//			 do
//			      linepom = DecrementPosMB(&mbpom, &offpom);
//			 while ((linepom != NULL) && ENDLINE(*linepom));
//			 pompom = (linepom) ? *linepom : ' ';
//		    }
//
//		    if (isalpha((int) pompom) || (192 <= pompom))
//			 *line = (UBYTE) LetterLowerCase(pom);
//		    else *line = (UBYTE) LetterUpperCase(pom);
//		    break;
               }
          }
     }
}
//<<


//////////////////////
// CURSOR FUNCTIONS //
//////////////////////

ULONG GetCursorColumn(TEditFile *teditfile, Location *loc)
// computes in which column is cursor - location
// if not found - return 0xFFFFFFFFL
{
     EditFile *doc = teditfile->GetEditFile();

     MemoryBlock *mb = loc->para->block_first, *mbcur = loc->block;
     ULONG mboff = loc->para->off_first, mbcuroff = loc->block_off;

     ULONG scrpos, curpos = 0xFFFFFFFFL;
     UWORD tabsize = GETGLOBALPREFS->tab_size;

     UBYTE *line;

     for(scrpos = 0, line = GetPosMB(mb, mboff); !ENDLINE(*line); line = IncrementPosMB(&mb, &mboff))
     {
          if ((mb == mbcur) && (mboff == mbcuroff))
               curpos = scrpos;
          if (*line == CH_TAB)
               scrpos += tabsize - scrpos % tabsize;
          else scrpos++;
/*** Modify Start : d-tec  ***/
          if (_ismbslead(mb->memory, mb->memory + mboff)) scrpos++;
/*** Modify End : d-tec  ***/
     }
     if ((mb == mbcur) && (mboff == mbcuroff))
          curpos = scrpos;

     return curpos;
}

ULONG GetCharoffColumn(TEditFile *teditfile, Location *loc, ULONG column)
// computes the character offset of the character in column
// if column is too far, the offset of EOL is returned
{
     EditFile *doc = teditfile->GetEditFile();

     MemoryBlock *mb = loc->para->block_first;
     ULONG mboff = loc->para->off_first;
     ULONG scrpos, charoff;
     UWORD tabsize = GETGLOBALPREFS->tab_size;
/*** Modify Start : d-tec  ***/
     BOOL bMBCS = FALSE;
/*** Modify End : d-tec  ***/

     UBYTE *line;

     for( charoff = 0, scrpos = 0, line = GetPosMB(mb, mboff);
          !ENDLINE(*line);
          line = IncrementPosMB(&mb, &mboff), charoff++)
     {
          if (scrpos >= column)
          {
               if (scrpos > column)
                    if (charoff > 0) 
                    {
                         charoff--;
                         /*** Modify Start : d-tec  ***/
                         if (bMBCS) charoff--;
                         /*** Modify End : d-tec  ***/
                    }
               break;
          }

          if (*line == CH_TAB)
               scrpos += tabsize - scrpos % tabsize;
          else scrpos++;
/*** Modify Start : d-tec  ***/
          if (_ismbslead(mb->memory, mb->memory + mboff))
          {
               scrpos++;
               charoff++;
               bMBCS = TRUE;
          } else {
               bMBCS = FALSE;
          }
/*** Modify End : d-tec  ***/
     }

     return charoff;
}

/* tato fce urci k zadanym souradnicim v okne strukturu Location popisujici
 * polohu kurzoru v textu; patrne vyuzije LineLength ve specialnim modu
 * vyhledavani (dodelat); pokud je bod mimo vyrez dokumentu, vrati FALSE;
 * vysledek zapise do zadane struktury Location;
 * POZOR - LineLength bude volat 2x - zjisti delku apod. a s temito informacemi
 * ji zavola ve vyhledavacim modu ! */
/* useoldtab slouzi k tomu, aby se sdelilo, ze se maji pouzit jiz drive urcene
 * formatovaci informace a ne znovu 2x volat LineLength */
// o x, y se predpoklada, ze jsou v souradnicich obrazovky !
// je-li useline = TRUE --> loc musi ukazovat na pocatek radku !
BOOL CoordsToLocation(TEditFile *teditfile, Location *loc, int x, int y, BOOL block)
// has to be completely rewritten
// gets location corresponding to x, y coordinates
// return TRUE (OK) or FALSE (not successful)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     int wh = doc->winheight, ww = doc->winwidth;
     ULONG fh = doc->fontheight, fw = doc->fontwidth;
     ULONG wch = doc->wincheight, wcw = doc->wincwidth;
     ULONG dispoff = doc->disp_offset;

     ULONG line, col, i;

     // zero dimension - nothing done
     if ( (ww == 0) || (wh == 0) || (wcw == 0) || (wch == 0) || (fw == 0) || (fh == 0) )
          return(FALSE);

     // find line
     line = max_l(y, 0) / fh;      if (line >= wch) line = wch - 1;
     *loc = doc->display_begin;
     for(i = 0; i < line; i++)
          if (NOT GetNextPos(teditfile, loc, TRUE, 0))
          {
               (void) GetPrevPos(teditfile, loc, FALSE, 0);
               break;
          }
     // if block - scrolling of the document has to be allowed
     if (block)
     {
          if (y < 0)     // go one line up = before display_begin
          {
               if (GetPrevPos(teditfile, loc, TRUE, 0))
	            (void) GetPrevPos(teditfile, loc, FALSE, 0);
          }
          if (y > wh)    // go one line down = after display_end
          {
               if (NOT GetNextPos(teditfile, loc, TRUE, 0))
                    (void) GetPrevPos(teditfile, loc, FALSE, 0);
          }
     }

     // find column
     col = max_l(x, 0) / fw;       if (col >= wcw) col = wcw - 1;
     col += doc->disp_offset;
     if (block)		// block selection - scrolling is allowed
     {
          if (x < 0)
               if (col > 0) col--;
          if (x > ww)
               col++;
     }

     col = GetCharoffColumn(teditfile, loc, col);
     if (col)
          GetNextPos(teditfile, loc, FALSE, (LONG) min_ul(col, loc->para->length));

     return(TRUE);
} /* end CoordsToLocation */
//<<

