/*
 * BDT-Docs-Open+Import.c  modul obsahujici fce pro cteni/import dokumentu
 */

#define BDT_DOCS_OPEN_IMPORT_C

#include "wed_editor.h"



// fce pro nahrani dokumentu ve formatu ASCII, kodovani se hleda v doc->code
BOOL LoadDiskASCII(TEditFile *teditfile, BOOL close_on_error)
//>>
{    
     EditFile *doc = teditfile->GetEditFile();

     MemoryBlock *mb_last, *mb_act = doc->block_first;
     ULONG off_last, off_act = 0;

     UBYTE blok_pom[BLOKPOM_VELIKOST + 16];   // buffer pro nacitani
     UBYTE *pozice;
     BPTR soubor;                // ukazuje na soubor, do nehoz se zapisuje
					// zamek - pro zjisteni delky pomoci Examine
     LONG pompompom;
     ULONG dummy;
     ULONG kolik_nacist, volne_misto;   // pro praci s bloky pameti
     ULONG zbyva_nacist, prave_nacteno; // pro evidenci pri postupnem nacitani textu
     int i;
     BOOL uspech = TRUE;                // navratova hodnota
     BOOL mustclose = FALSE;            // urcuje, zda se dokument musi zavrit pri neuspechu
     BOOL byl_eol = FALSE, eol = FALSE;
     BOOL last_buffer_eold = FALSE;     // the previously read block of data in blok_pom ended with CH_EOLD
     char *errorcode = NULL;
//     ERRORCODE errorcode = 0;

//     char cesta[PATH_LEN + FILENAME + 6];
     char *cesta = doc->path;

// dotaz, jak interpretovat EOL
//     eol = (0 == Question(doc->win, &doc->req, doc->name, GS(MSG_LINE_FEEDS_TEXT), GS(MSG_LINE_FEEDS_ANSWERS), NULL)) ? TRUE : FALSE;
     eol = FALSE;        // ASCII editor = EOL ends every line = paragraph

//     strcpy(cesta, doc->path);
//     (void) AddPart(cesta, doc->name, PATH_LEN + FILENAME + 4);

  // otevreni souboru, cesta se jen cte - PPC OK
     if (NULL == (soubor = Open(cesta, MODE_OLDFILE)))
     {    
          errorcode = GS(MSG_ERROR_OPEN_FILE); 
          goto end;   
     }
     ChangePointer(teditfile, GS(MSG_LOADING_DOC), TRUE, TRUE);

  // zjisteni delky souboru
     if ((pompompom = GetOpenFileSize(soubor)) < 0)
     {    
          errorcode = GS(MSG_ERROR_EXAMINE_FILE); 
          goto end;   
     }
     zbyva_nacist = (ULONG) pompompom;
     if (zbyva_nacist == 0) goto end;

// nastaveni mustclose - pri nasledujicim zasahujeme jiz do dokumentu
     mustclose = TRUE;

     doc->block_first->free = doc->block_first->size;

     volne_misto = doc->block_first->free - FREEMEM_INITIALSTATE;

     // nacitani textu
     while (zbyva_nacist > 0)
     {
#ifdef CHECK_BUGS
	  if (doc->block_first == NULL) { InternalError("LoadASCII - no block 1"); uspech = FALSE; goto end; }
	  if (doc->block_last  == NULL) { InternalError("LoadASCII - no block 2"); uspech = FALSE; goto end; }
#else
	  if (doc->block_first == NULL) { uspech = FALSE; goto end; }
	  if (doc->block_last  == NULL) { uspech = FALSE; goto end; }
#endif
	  kolik_nacist = min_ul(BLOKPOM_VELIKOST, zbyva_nacist);
	  if (NOT (kolik_nacist == (prave_nacteno = Read(soubor, blok_pom, kolik_nacist))))
	  { 
               errorcode = GS(MSG_ERROR_OPENING_FILE); 
               goto end; 
          }

          // has to be done before PrevodMeziKody - it can change prave_nacteno!
	  zbyva_nacist -= prave_nacteno;
	  if (zbyva_nacist == 0)
	  {    // zajisteni znacek na konci souboru, i kdyz tam nejsou
	       if (blok_pom[prave_nacteno - 1] != CH_EOL)
		    blok_pom[prave_nacteno++] = CH_EOL;
//	       if (eol)
//	       { // pokud je eol, musi byt na konci textu sudy pocet ENTERu!
//		    LONG pocet = 0, pozice = prave_nacteno - 1;
//
//		    for(; (pozice >= 0) && (blok_pom[pozice] == CH_EOL); pozice--)
//			 pocet++;
//
//		    if (pocet % 2 != 0)
//			 blok_pom[prave_nacteno++] = CH_EOL;
//	       }
	  }
	  // nacten text o velikosti kolik_nacist == prave_nacteno;
          // if the previous block of data ended with CH_EOLD and the new one starts with CH_EOL, this CH_EOL has to be erased
          //   exception: if CH_EOL is the last character in file, we do not erase it
          if (last_buffer_eold && (prave_nacteno > 1) && (blok_pom[0] == CH_EOL))
          {
               prave_nacteno--;
               memmove(blok_pom, blok_pom + 1, prave_nacteno);
          }
          
          // set new value of last_buffer_eold
          last_buffer_eold = (blok_pom[prave_nacteno - 1] == CH_EOLD) ? TRUE : FALSE;
          
	  // nacitame cely text jako jediny odstavec (pak ho rozdelime dle
	  // eolu, ktere jiz znamenaji jen konec odstavcu)
	  // upravime konce radku, je-li to treba
//	  if (eol)     // znak EOL na konci kazdeho radku
//	       for(i = 0; i < prave_nacteno; i++)
//		    if (blok_pom[i] == CH_EOL)
//		    {    
//                         if (byl_eol)
//			      byl_eol = FALSE;
//			 else
//			 {    byl_eol = TRUE;     // konce radku se nahrazuji mezerami
//			   // memmove(blok_pom + i, blok_pom + i + 1, --prave_nacteno - i);
//			      blok_pom[i] = CH_SPACE;
//			 }
//		    }
//		    else byl_eol = FALSE;

	  // umistime nacteny text do jedineho odstavce, ktery v tuto chvili mame
	  PrevodMeziKody(blok_pom, &prave_nacteno, BLOKPOM_VELIKOST + 4);
//	  PrevodMeziKody(blok_pom, prave_nacteno, code, TRUE, 2);

          // for correct display of ASCII files, we have to add one CH_EOL to the end
          // if there are not more of them at the end of the text
	  if (zbyva_nacist == 0)
	  {    // zajisteni znacek na konci souboru, i kdyz tam nejsou
	       if ( (blok_pom[prave_nacteno - 1] != CH_EOL) || (blok_pom[prave_nacteno - 2] != CH_EOL) )
                    blok_pom[prave_nacteno++] = CH_EOL;
	  }

          // set loop variables
	  kolik_nacist = prave_nacteno; // udava, kolik se toho ma dat do pameti
	  pozice = blok_pom;            // udava pozici v pomocnem bloku pameti

	  while (kolik_nacist > 0)
	  {
               if (volne_misto == 0)    // alokujeme novy blok
	       {
                    MemoryBlock *mb;

		    if ( NULL == (mb = AddNewMemoryBlock(teditfile, doc->block_last, SIZE_TEXT)) )
		    {
                         errorcode = GS(MSG_NOT_ENOUGH_MEMORY); 
                         goto end; 
                    }

		    // oprava konce odstavce
		    mb_act = mb;
		    off_act = 0;

		    volne_misto = SIZE_TEXT - FREEMEM_INITIALSTATE;
	       }    // konec alokace noveho bloku

	       prave_nacteno = min_ul(kolik_nacist, volne_misto);
	       // tolik toho presuneme do pameti z bufferu
	       memcpy(mb_act->memory + off_act, pozice, (size_t) prave_nacteno);

	       volne_misto -= prave_nacteno;
	       kolik_nacist -= prave_nacteno;
	       off_act += prave_nacteno;
	       pozice += prave_nacteno;
	       mb_act->free -= prave_nacteno;
	  }    // konec cyklu, v nemz se zapisuje z bufferu do odstavce

     }    // konec cyklu, v nemz se nacita obsah souboru
#ifdef CHECK_BUGS
     if (mb_act != doc->block_last) InternalError("LoadASCII - posl. block neni akt.");
#endif

     mb_last = mb_act;        // ke zjisteni, zda jsme jiz na konci
     off_last = off_act - 1;  // off_act ukazuje na nasl. polohu

     // rozdeleni na jednotlive odstavce:
     // budou se prochazet postupne bloky pameti, sledovat, ve kterem jsme
     // bloku a pozice v nem, kdyz narazime na konec odstavce, vytvorime novy
     // odstavec a priradime mu akt. blok a akt. offset (pozici v tom bloku);
     // ten odstavec bude mit stejny styl jako 1. odstavec v dokumentu a bude 
     // to ted posledni odstavec v dokumentu ( to ale zaridi fce AddNew... )
     mb_act = doc->block_first;    // zrovna prohledavany blok
     off_act = 0;                  // offset v tomto bloku
     prave_nacteno = 0;            // kolik bytu jiz bylo nacteno v akt. odstavci
//  // existujici LineNode musime smazat
//     FreeStructure(LINEDIM, doc->para_first->line_first);
//     doc->para_first->line_first = NULL;
//     doc->para_first->line_last  = NULL;
//     doc->page_first->begin.line = NULL;
//     doc->page_first->end.line   = NULL;
//     doc->line_first             = NULL;
//     doc->line_last              = NULL;
//     doc->cursor.line            = NULL;
//     doc->cursorline.line        = NULL;
//     doc->display_begin.line     = NULL;
//     doc->display_end.line       = NULL;

     FOREVER
     {    
          Paragraph *pompara;
          
	  for(pozice = mb_act->memory, kolik_nacist = mb_act->size - mb_act->free; off_act < kolik_nacist; off_act++)
	  {    
               prave_nacteno++;
	       if (*(pozice + off_act) == CH_EOL) // ma se rozdelit odstavec
	       {    
                    pompara = doc->para_last;
		    pompara->block_last = mb_act;
		    pompara->off_last   = off_act;
		    pompara->length     = prave_nacteno;
          pompara->explength  = 0; // PC 20020420 
                    
		    if ((mb_act != mb_last) || (off_act != off_last))
		    {    
                         prave_nacteno = 0;
//			 // pridame LineNode pro dalsi odstavec;
			 // nastavi se to v ramci AddNewParagraph
//			 if (NOT AddNewLineNode(doc, pompara->line_last))
//			 {    errorcode = MSG_NOT_ENOUGH_MEMORY; goto end;    }
			 if (NULL == (pompara = AddNewParagraph(teditfile, pompara, /* doc->para_first->style,*/  TRUE /*, NULL*/)))
			 {    
                              errorcode = GS(MSG_NOT_ENOUGH_MEMORY); 
                              goto end;    
                         }

		      // dovyplneni odstavce ...
//			 pompara->lines = 1;
//			 pompara->topedge = pompara->prev->topedge + pompara->line_last->height;
		    }
	       }
	  }
	  if (mb_act->next == NULL) break;   // jsme na konci dokumentu
	  mb_act = mb_act->next;        off_act = 0;
     } // end FOREVER

#ifdef CHECK_BUGS
     if (mb_act != mb_last) InternalError("LoadDiskASCII - mb_act != mb_last");
#endif

// dokonceni inicializace dokumentu ...
// set locations: cursor, cursorline, display
     {    
          Location *cursor = &doc->cursor;

	  cursor->block = doc->block_first;
          cursor->block_off = 0;
	  cursor->para = doc->para_first;
          cursor->chars_off = 0;
          cursor->line_num = 0;

	  doc->cursorline = doc->display_begin = doc->display_end = doc->cursor;

          SetDisplayBegEnd(teditfile, FALSE, 0);
     }
     doc->active = TRUE;
     doc->block = FALSE;
     doc->newfile = FALSE;
     doc->changes = FALSE;
     doc->undo = FALSE;
     doc->disp_offset = 0;
// num_lines - set by AddPara
     
end: if (errorcode)
     {
          uspech = FALSE;
	  Information2(teditfile, errorcode);
     }

     ChangePointer(teditfile, doc->name, FALSE, FALSE);
     if (soubor) Close(soubor);

     CurrentTime(&doc->last_saved, &dummy);  // tento radek bude posledni
     doc->opened = doc->last_saved;

     // if there was a problem - close the document
     if (close_on_error && errorcode && mustclose)
     {
          // should be closed the whole window!?!?
          // SendMessage(WM_DESTROY);
          //CloseDoc(doc, FALSE);
          // alternativey - we can close and reopen = clear
          doc->changes = FALSE;
          CloseDoc(teditfile, FALSE);
          if (NOT CreateDoc(teditfile))
          	teditfile->SendMessage(WM_DESTROY);
          // + CreateDoc + initwindow
     }

     return (uspech);
} /* end LoadDiskASCII() */
//<<

/* vlastni fce pro komunikaci s jadrem BD Editoru - nacteni dokumentu */
// in case of error (return value = FALSE), the window info (size and font)
// has to be updated!
BOOL LoadDiskDoc(TEditFile *teditfile, BOOL close_on_error)
{
    return LoadDiskASCII(teditfile, close_on_error);
}

