/*
 * BDT-Defs-Protos.h          header file with extern definitions
 */

#define BDT_DEFS_PROTOS_H



////////////////////////////////
// DEKLARACE EXTERNICH FUNKCI //
////////////////////////////////

/* BDT-Dispatch.c */
#ifndef BDT_DISPATCH_C
BOOL DispatchMessages(TEditFile *teditfile, Command comm, UWORD code, APTR address, BOOL blockqual);
//extern BOOL DispatchMessages(LONG *result, MessageItem *mistart);
#endif

/* BDT-DispatchFuncs.c */
#ifndef BDT_DISPATCHFUNCS_C
#endif

/* BDT-Draw.c */
#ifndef BDT_DRAW_C
extern void UpdateWindowInfo(TEditFile *teditfile);
extern void UpdateFontInfo(TEditFile *teditfile);
extern void UpdateFontInfo(TEditFile *teditfile, TDC& dc);

extern void DrawCursor(TEditFile *teditfile, TDC& dc, ULONG curpos);
extern void DrawLine(TEditFile *teditfile, TDC& dc, Location *loc, LONG drawfrom, LONG drawto,
                     BOOL block, BOOL text, BOOL cursor);

extern BOOL RedrawEditorRect(TEditFile *teditfile, TDC& dc, TRect& rect, BOOL cursor);

extern void SetDisplayBegEnd(TEditFile *teditfile, BOOL check, long smer);

extern  BOOL MakeCursorVisible(TEditFile *teditfile, ULONG menu_refresh, ULONG gadget_refresh, BOOL refresh_rooler);
extern  BOOL SetNewHorizPos(TEditFile *teditfile, ULONG newpos, long delta, BOOL draw_cursor);
extern  BOOL SetNewVertPos(TEditFile *teditfile, ULONG newpos, LONG delta, BOOL draw_cursor);
#endif

/* BDT_Docs_Init+Close.c */
#ifndef BDT_DOCS_INIT_CLOSE_C
//extern  BOOL InitDocWindow(TEditFile *teditfile, short position, short le, short te);
extern  BOOL CreateDoc(TEditFile *teditfile);
//extern  void CloseDocWindow(TEditFile *teditfile);
extern  BOOL CloseDoc(TEditFile *teditfile, BOOL confirm);
#endif

/* BDT_Docs_Import+Export.c */
#ifndef BDT_DOCS_IMPORT_EXPORT_C
extern  BOOL CanWriteToFile(TEditFile *teditfile, STRPTR name, BOOL ask_overwrite, BOOL only_files);
extern  void MakeBackup(TEditFile *teditfile);
extern  void PrevodMeziKody(UBYTE *mem, ULONG *len, ULONG buflen /*, CodePage code, BOOL toKOI, int mode*/);
// extern  BOOL LoadDiskExternal(EditFile *doc, BOOL close_on_error, ULONG format);
// extern  BOOL SaveDiskExternal(EditFile *doc, ULONG format);
#endif

/* BDT_Docs_Open+Import.c */
#ifndef BDT_DOCS_OPEN_IMPORT_C
extern  BOOL LoadDiskDoc(TEditFile *teditfile, BOOL close_on_error);
extern  BOOL LoadDiskASCII(TEditFile *teditfile, BOOL close_on_error);
#endif

/* BDT_Docs_Save+Export.c */
#ifndef BDT_DOCS_SAVE_EXPORT_C
extern  BOOL SaveDiskDoc(TEditFile *teditfile, BOOL testover, UWORD version);
extern  BOOL SaveDiskASCII(TEditFile *teditfile, BOOL testover);
#endif

/* BDT-Docs-Clipboard.c */
#ifndef BDT_DOCS_CLIPBOARD_C
extern ULONG GetLineSize(TEditFile *teditfile, BOOL max);
extern ULONG GetBlockSize(TEditFile *teditfile, BOOL block);
extern char *LoadClipASCII(TEditFile *teditfile, CLIPHANDLE clip, ULONG *num_paras);
extern char *SaveClipASCII(TEditFile *teditfile, CLIPHANDLE clip, BOOL do_crlf);

extern  BOOL BlockToClip(TEditFile *teditfile, BOOL undo);
extern  BOOL ClipToText(TEditFile *teditfile, ULONG *num_paras, BOOL undo, char *textsrc);
#endif

/* BDT-Lists.c */
#ifndef BDT_LISTS_C
extern  APTR InitStructure(ULONG id, APTR init_val);
extern  APTR FreeStructure(ULONG id, APTR structure);
extern  MemoryBlock *AddNewMemoryBlock(TEditFile *teditfile, MemoryBlock *kam, ULONG size);
extern  MemoryBlock *RemoveMemoryBlock(TEditFile *teditfile, MemoryBlock *mb);
extern  Paragraph *AddNewParagraph(TEditFile *teditfile, Paragraph *prev, /* ParaStyle *ps, */ BOOL set_mb_line /* , NamedParaStyle *nps */);
extern  Paragraph *RemoveParagraph(TEditFile *teditfile, Paragraph *para, BOOL free_ts);
#endif

/* BDT-Memory.c */
#ifndef BDT_MEMORY_C
extern  BOOL CheckFreeMemory(ULONG req);
extern  short CompareParaLinePos(Paragraph *p1, Paragraph *p2);
extern  short CompareBlockPos(MemoryBlock *mb1, ULONG off1, MemoryBlock *mb2, ULONG off2);
extern  BOOL BlockPosBetween(MemoryBlock *mbtest, ULONG offtest,
                                  MemoryBlock *mb1, ULONG off1,
                                  MemoryBlock *mb2, ULONG off2);
extern  BOOL InsertInBlock(TEditFile *teditfile, Location *loc, UBYTE *data, ULONG len,
                                BOOL after, short loccheck, Location *locs, BOOL signlocs1);
//extern  void DeleteInBlock(TEditFile *teditfile, Location *loc, ULONG len,
//                                short loccheck, Location *locs, BOOL clear_ends);
extern  void JoinTwoParagraphs(TEditFile *teditfile, Paragraph *first, /* Page *page_first, Page *page_last, */
                               Location *locs);
extern  void DeleteDataLoc(TEditFile *teditfile, Location *loc1, Location *loc2,
                                BOOL format, BOOL zobraz, BOOL dontdraw);
extern  void SplitParagraph(TEditFile *teditfile, Location *misto, /* Page *page, */
                                  BOOL pbreak, BOOL format, BOOL cursor);
#endif

/* BDT-Mouse.c */
#ifndef BDT_MOUSE_C
extern  void ChangeBlockSelection(TEditFile *teditfile, Location *newend);
extern  void UnmarkBlock(TEditFile *teditfile, BOOL beg);
extern  void SelectTextBlock(TEditFile *teditfile, Location *beg, Location *end);
extern  void SelectActualWord(TEditFile *teditfile, BOOL sentence, Location *beg, Location *end);
#endif

/* BDT-Move.c */
#ifndef BDT_MOVE_C
extern  BOOL GetNextPos(TEditFile *teditfile, Location *loc, BOOL newline, LONG numchars);
extern  BOOL GetPrevPos(TEditFile *teditfile, Location *loc, BOOL newline, LONG numchars);
extern  BOOL GetNextWord(TEditFile *teditfile, Location *loc, Paragraph *para,
                              MemoryBlock **block, ULONG *offset, BOOL sentence,
                              BOOL use_separators, BOOL wordend);
extern  BOOL GetPrevWord(TEditFile *teditfile, Location *loc, Paragraph *para,
                              MemoryBlock **block, ULONG *offset, BOOL sentence, BOOL use_separators);
extern  BOOL BlockToLocation(TEditFile *teditfile, Location *loc, MemoryBlock *mb, ULONG off, Paragraph *para1, ULONG linenum);
extern  BOOL CoordsToLocation(TEditFile *teditfile, Location *loc, int x, int y, BOOL block);
extern  void ChangeBlockCase(TEditFile *teditfile, ULONG mode);

extern ULONG GetCursorColumn(TEditFile *teditfile, Location *loc);
extern ULONG GetCharoffColumn(TEditFile *teditfile, Location *loc, ULONG column);
#endif

/* BDT-AsynchReqs.c */
#ifndef BDT_ASYNCHREQS_C
extern  void SetCursorPosition(TEditFile *teditfile, Location *pos, Location *end, BOOL format, BOOL disp, BOOL trueend);
extern  BOOL FindSearchWord(TEditFile *teditfile, ReplaceState *state, Location *beg, Location *end, UWORD skipchars);
extern  void ReplaceThisWord(TEditFile *teditfile, ReplaceState *state, Location *beg, Location *end, BOOL format, BOOL staybefore);
extern  void FindReplaceDialog(TEditFile *teditfile, ULONG *macro_data);
#endif

/* BDT-Hook.c */
#ifndef BDT_HOOK_C
inline BOOL WHITESPACE(UBYTE znak)
{
     return (BOOL) ((znak <= CH_SPACE) && (znak != CH_EOL) && (znak != CH_EOLD) || (znak == 160));
}
inline BOOL ENDLINE(UBYTE znak)
{
     return((BOOL) (((znak == CH_EOL) || (znak == CH_EOLD) || (znak == CH_EOP)) ? TRUE : FALSE) );
}
extern  BOOL SPECIALCHAR(UBYTE znak);
extern  BOOL SEPARATOR(TEditFile *teditfile, UBYTE znak);
inline UBYTE *GetPosMB(MemoryBlock *mb, ULONG off) // just returns the byte pointer
{
     return(mb->memory + off);
}
extern  UBYTE *IncrementPosMB(MemoryBlock **mb, ULONG *off);
extern  UBYTE *DecrementPosMB(MemoryBlock **mb, ULONG *off);
extern  BOOL FirstParaChar(Location *loc);
extern  BOOL LastParaChar(Location *loc);
extern  BOOL FirstParaLine(Location *loc);
extern  BOOL LastParaLine(Location *loc);
//extern  WORD abs_w(WORD x);
extern  ULONG abs_l(LONG x);
//extern  WORD max_w(WORD a, WORD b);
extern  UWORD max_uw(UWORD a, UWORD b);
extern  LONG max_l(LONG a, LONG b);
extern  ULONG max_ul(ULONG a, ULONG b);
//extern  WORD min_w(WORD a, WORD b);
extern  UWORD min_uw(UWORD a, UWORD b);
extern  LONG min_l(LONG a, LONG b);
extern  ULONG min_ul(ULONG a, ULONG b);
extern int sign(int i);

extern void UpdateColumnsNumber(TEditFile *teditfile);
#endif

#ifndef BDT_UNDO_C
extern  void InitUndoInfo(TEditFile *teditfile);
extern  void FreeUndoInfo(TEditFile *teditfile);
extern  void FreeUndoData(TEditFile *teditfile);
extern  void FreeAllUndoData(TEditFile *teditfile);
extern  void UpdateUndoInfo(TEditFile *teditfile, UWORD new_undo, ULONG data);
extern  ULONG SaveUndoInfo(TEditFile *teditfile, UWORD new_undo, ULONG data1, ULONG data2, ULONG data3);
//extern  void DoUndoOperation(TEditFile *teditfile);
#endif

