/*
 * BDT-Docs-Save+Export.c  modul obsahujici fce pro zapis/export dokumentu
 */

#define BDT_DOCS_SAVE_EXPORT_C

#include "wed_editor.h"



// velikost pomocneho bloku pameti, do ktereho kopirujeme text urceny
// k ulozeni; zde se provadi konverze kodovani
//#define REZERVA               (MAX(MAX_NUMBER_LEN, MAX(MAX_DATETIME_LEN, MAX(MAX_PAGENUM_LEN, 4))))
#define REZERVA     16

// nasledujici fce slouzi pro ulozeni dokumentu ve formatu ASCII,
// parametr eol = TRUE <=> ma byt znak konce radku na konci kazdeho radku
BOOL SaveDiskASCII(TEditFile *teditfile, BOOL testover)
//>>
{
     EditFile *doc = teditfile->GetEditFile();

     BPTR soubor;
     Paragraph *para_act;
     MemoryBlock *mb, *mbpom;
     UBYTE *pozice;
     ULONG char_offset;
     ULONG block_offset, offpom, size, dummy;
     UBYTE *line, *pom, *lineend;
     UBYTE znak;
//     char cesta[PATH_LEN + FILENAME + 6];
     char *cesta = doc->path; // path should contain also the filename under Windows/DOS
     UBYTE blok_pom[BLOKPOM_VELIKOST + REZERVA + 4];
     char *errorcode = NULL;
//     ERRORCODE errorcode = 0;
     BOOL uspech = TRUE, eopar, special, setpom, konecradku, nenimisto, block_change, eol = FALSE;
     BOOL do_crlf = GETGLOBALPREFS->crlf_eols;

// dotaz, jak interpretovat EOL
//     eol = (0 == Question(doc->win, &doc->req, doc->name, GS(MSG_LINE_FEEDS_TEXT), GS(MSG_LINE_FEEDS_ANSWERS), NULL)) ? TRUE : FALSE;
     eol = FALSE;   // ASCII editor: only at the end of line = para is written (one) EOL
     
//     strcpy(cesta, doc->path);
//     (void) AddPart(cesta, doc->name, PATH_LEN + FILENAME + 4);
//     if (NOT CanWriteToFile(doc, cesta, TRUE, TRUE)) return(FALSE);

     // test whether user really wants to overwrite the file
     if (testover)
	  if (NOT CanWriteToFile(teditfile, cesta, TRUE, TRUE)) 
	       return(FALSE);
     
     // create backup
     if (GETGLOBALPREFS->backup) 
          MakeBackup(teditfile);

     if (NULL == (soubor = Open(cesta, MODE_NEWFILE)))
     { 
          errorcode = GS(MSG_ERROR_SAVE_FILE); 
          goto end; 
     }
     ChangePointer(teditfile, GS(MSG_SAVING_DOC), TRUE, TRUE);

     pozice = blok_pom;  // init temp buffer pointer
     for(para_act = doc->para_first; para_act; para_act = para_act->next)
     { 
       // pocatecni inicializace
	  eopar = FALSE;
	  char_offset = 0;
	  mb = para_act->block_first;   block_offset = para_act->off_first;
	  lineend = line = mb->memory + block_offset;
// !!! important change - pozice = blok_pom only after Write, not after every para;

	  // vykonny cyklus - prochazeni odstavce
	  block_change = FALSE;

	  for(pom = line; TRUE; char_offset++)
	  {    
               size = (ULONG) (lineend - pom);

	       znak = *line;
	       setpom = FALSE;
	       konecradku = (ENDLINE(znak)) ? TRUE : FALSE;
	       special = SPECIALCHAR(znak);

	       if ((mb == para_act->block_last) && (block_offset == para_act->off_last))
		    eopar = TRUE;    // dosli jsme na konec odstavce

	       if ( konecradku || block_change || eopar || special ||
		    (nenimisto = ((pozice - blok_pom) + size + REZERVA >= BLOKPOM_VELIKOST))
                  )
	       // s rezervou na vepsani konce radku, data ci cisla stranky...
	       // musime provest zapis do pomocneho bloku pameti
	       {    
                    if (size) 
                         memcpy(pozice, pom, (size_t) size);
		    pozice += size;

		    if ((eol && konecradku) || eopar)    // je konec radku a ma se to zapsat
			 switch (znak)
			 {    // in ASCII editor, only CH_EOL is possible
                              case CH_EOLD:
//				   *pozice++ = '-';
			      case CH_EOL:
			      case CH_EOP:
                                   if (do_crlf)
                                        *pozice++ = CH_EOLD;
				   *pozice++ = CH_EOL;
//				   if (eol && eopar) *pozice++ = CH_EOL;
				   break;
			 }
                    
		    if (nenimisto)  // zde prekonvertovat a zapsat do souboru:
// !!! important change - write not afterevery para, only if nenimisto!		    if (nenimisto || eopar)  // zde prekonvertovat a zapsat do souboru:
		    {    
//                         PrevodMeziKody(blok_pom, pozice - blok_pom, code, FALSE, 2);
                         ULONG pom = pozice - blok_pom;

                         if (pom != Write(soubor, blok_pom, pom))
//			 if ((pozice - blok_pom) != Write(soubor, blok_pom, pozice - blok_pom))
			 {
                              errorcode = GS(MSG_ERROR_SAVING_FILE);
                              goto end;
                         }
			 pozice = blok_pom;
		    }
		    pom = line;
	       } // end if (preruseni ...)

	       if (eopar) break;     // je konec odstavce ?
//#ifdef CHECK_BUGS
//	       else if (znak == CH_EOP) InternalError("Save+Export - ma byt konec odstavce");
//#endif
	       // znak konce radku ci specialni znaky preskocime - viz vyse
	       if (konecradku || special) 
                    setpom = TRUE;

	       // ziskani dalsiho znaku
	       mbpom = mb;
	       offpom = block_offset;
	       lineend = line + 1;
	       line = IncrementPosMB(&mb, &block_offset);
	       if (mb == mbpom)         // zmena pametoveho bloku ?
	       { 
                    block_change = FALSE;
                    lineend = line; 
               }
	       else block_change = TRUE;

	       if (setpom) pom = line;  // EOL and special characters were immediately written to the output buffer
	  } // konec prochazeni odstavce
     } // konec cyklu pro dokument

     if (pozice != blok_pom)	// we have not flushed the buffer
     {
     	  ULONG pom = pozice - blok_pom;

          if (pom != Write(soubor, blok_pom, pom))
//			 if ((pozice - blok_pom) != Write(soubor, blok_pom, pozice - blok_pom))
          {
               errorcode = GS(MSG_ERROR_SAVING_FILE);
               goto end;
          }
     }

end: if (soubor)
          Close(soubor);
     if (errorcode)
     {
       // smazani nedodelaneho souboru - ?! it would be better to ask user whether he wants to do it
	  (void) DeleteFile(cesta);

	  uspech = FALSE;
	  Information2(teditfile, errorcode);
     }
//     else if (Prefs.ioprefs.save_icon) AddIconToText(doc, NULL, TRUE);

     ChangePointer(teditfile, doc->name, FALSE, FALSE);
     CurrentTime(&doc->last_saved, &dummy);  // note the save time!
     doc->changes = FALSE;
     return (uspech);
}    /* end SaveDiskASCII() */
//<<

/* vlastni fce pro komunikaci s jadrem BD Editoru - ulozeni dokumentu */
BOOL SaveDiskDoc(TEditFile *teditfile, BOOL testover, UWORD version)
{
     return SaveDiskASCII(teditfile, testover);
}

