/*
 *   BDT-Defs-Tags.h     header file with tags (= commands) definitions
 */

#ifndef BDT_DEFS_TAGS_H
#define BDT_DEFS_TAGS_H

////////////////////////////////////////////////////////////////////////////
// TENTO SOUBOR OBSAHUJE DEFINICE PRIKAZU EDITORU; VYUZITY JSOU K INTERNI //
// KOMUNIKACI PRI PREDAVANI ZPRAV, PRO UNDO A PRO MAKROJAZYK (AREXX)      //
////////////////////////////////////////////////////////////////////////////

#define COMM_Dummy       0

//////////////////////////////////////////////////////////////////
// ZAKLADNI OPERACE PROVADENE S TEXTEM PRI EDITACI Z KLAVESNICE //
//////////////////////////////////////////////////////////////////

#define COMM_BO          (COMM_Dummy + 1000) // for Basic Operations

// POHYBY V TEXTU //
#define BO_SetCursor     (COMM_BO + 1)
     // elementarni pohyby = kurzor samotny
     // vzdy musi byt v paru za sebou pohyb VLEVO - VPRAVO a NAHORU - DOLU
#define BO_CursorLeft    (COMM_BO + 2)
#define BO_CursorRight   (COMM_BO + 3)
#define BO_CursorUp      (COMM_BO + 4)
#define BO_CursorDown    (COMM_BO + 5)
     // pohyby kurzoru s SHIFT
#define BO_PrevWord      (COMM_BO + 6)
#define BO_NextWord      (COMM_BO + 7)
#define BO_PageUp        (COMM_BO + 8)
#define BO_PageDown      (COMM_BO + 9)
#define BO_ParaUp        (COMM_BO + 10)
#define BO_ParaDown      (COMM_BO + 11)
     // pohyby kurzoru s CTRL = znaceni bloku textu
     // pohyby kurzoru s ALT
#define BO_BegLine       (COMM_BO + 12)
#define BO_EndLine       (COMM_BO + 13)
#define BO_BegFile       (COMM_BO + 14)
#define BO_EndFile       (COMM_BO + 15)
#define BO_PrevWhiteWord (COMM_BO + 16)
#define BO_NextWhiteWord (COMM_BO + 17)
#define BO_BegView       (COMM_BO + 18)
#define BO_EndView       (COMM_BO + 19)
#define BO_PrevWordEnd   (COMM_BO + 20)	// not implemented
#define BO_NextWordEnd   (COMM_BO + 21)
#define BO_BegSentence   (COMM_BO + 22)
#define BO_EndSentence   (COMM_BO + 23)
// ! *** BO_EndSentence musi byt posledni (mit nejvetsi hodnotu) *** !

// OPERACE VKLADANI A PREPISOVANI V TEXTU //
/* vsechny nasledujici prikazy se deji v kontextu *JEDNOHO* odstavce */
#define BO_InsertChar    (COMM_BO + 30)      // *
     // vlozeni tabelatoru - specialni akce
#define BO_InsertTab     (COMM_BO + 31)
     // vlozeni specialniho znaku (cislo strany, datum, ...)
#define BO_InsertSpecial (COMM_BO + 32)
     // prepsani znaku; jediny parametr obsahuje novou hodnotu znaku
#define BO_OverwriteChar (COMM_BO + 33) // - spolecne je BO_InsertChar (ridi se to vkladanim/prepisem
     // vlozeni tabelatoru s prepsanim akt. znaku - specialni akce
#define BO_OverwriteTab  (COMM_BO + 34)
     // prepis specialnim znakem ...
#define BO_OverwriteSpecial   (COMM_BO + 35)

     // vlozeni slova (neobsahuje znaky konce odstavce, tabelator apod.!)
     // mi_Address: ukazatel na vkladany retezec
#define BO_InsertWord    (COMM_BO + 36)      // *
     // prepsani slova - ma smysl napr. pri prepsani bloku ci nahrazovani
#define BO_OverwriteWord (COMM_BO + 37)      // - opet pouze insert word

// OPERACE MAZANI V TEXTU - opet vztazeno k aktualni pozici kurzoru //
/* vsechny nasledujici prikazy se deji v kontextu *JEDNOHO* odstavce */
// VZDY MUSI BYT V PARU ZA SEBOU POHYB VPRAVO - VLEVO
     // mazani zadaneho poctu nasledujich znaku; parametr = pocet mazanych znaku
#define BO_DelNext       (COMM_BO + 41) // MUSI ZDE BYT LICHY OFFSET JAKO U BO_DelChar
     // mazani zadaneho poctu predchozich znaku; parametr = pocet mazanych znaku
#define BO_DelPrev       (COMM_BO + 42)
     // nasledujici operace nemaji zadne parametry a vzdy se vztahuji k aktualni
     // pozici kurzoru v zadanem textu
#define BO_DelChar       (COMM_BO + 45) // smazani znaku, ne nemz je kurzor
#define BO_DelPrevChar   (COMM_BO + 46) // smazani predchoziho znaku (BcSp)
#define BO_DelWord       (COMM_BO + 47) // smazani slova
#define BO_DelPrevWord   (COMM_BO + 48) // smazani predchoziho slova
#define BO_DelEOS        (COMM_BO + 49) // smazani do konce vety
#define BO_DelBOS        (COMM_BO + 50) // smazani do zacatku vety
#define BO_DelEOP        (COMM_BO + 51) // smazani do konce odstavce
#define BO_DelBOP        (COMM_BO + 52) // smazani do zacatku odstavce
#define BO_DelEOL        (COMM_BO + 53) // smazani do konce radku
#define BO_DelBOL        (COMM_BO + 54) // smazani do zacatku radku
#define BO_DelLine       (COMM_BO + 55) // smazani celeho radku
// ! *** DelLine musi zustat posledni *** !

// OPERACE PRIDANI A SLOUCENI ODSTAVCE //
#define BO_NewPara       (COMM_BO + 60)
     // jako predchozi, ale vlozi mezi novy a puvodni odstavec Page Break
#define BO_NewParaBP     (COMM_BO + 61)
     // spoji dva odstavce
#define BO_JoinPara      (COMM_BO + 62)
#define BO_JoinParaBS    (COMM_BO + 63)

/* POHYB PO TEXTU nemusi byt nutne svazan s pohybem kurzoru ... */
#define BO_GetClip       (COMM_BO + 80)



///////////////////////////////////////////////////////////////////
// ZAKLADNI OPERACE PROVADENE SE STRUKTUROVANYMI TEXTOVYMI BLOKY //
///////////////////////////////////////////////////////////////////
// Jedna se napr. o vlozeni odstavce ci textu, ktery obsahuje    //
// typy pisma apod.                                              //
///////////////////////////////////////////////////////////////////

#define COMM_TEXT        (COMM_Dummy + 2000) // for Text Operations

// VKLADANI STRUKTUROVANEHO TEXTU //
#define TO_FormatText    (COMM_TEXT + 10)
// #define TO_InsertText    (COMM_TEXT + 11)
// #define TO_MakePara      (COMM_TEXT + 12)
#define TO_ChangePara    (COMM_TEXT + 13)
// #define TO_InsertDocPart (COMM_TEXT + 14)

// MAZANI STRUKTUROVANEHO TEXTU //
#define TO_DelDocPart    (COMM_TEXT + 20)



//////////////////////////////////////////////////
// ZAKLADNI OPERACE PRO KOMUNIKACI S UZIVATELEM //
//////////////////////////////////////////////////

#define COMM_REQ         (COMM_Dummy + 3000) // for ReQuests

#define RQ_AskRequest    (COMM_REQ + 1)
#define RQ_StringRequest (COMM_REQ + 2)
#define RQ_ChoiceRequest (COMM_REQ + 3)
#define RQ_FileRequest   (COMM_REQ + 4)
#define RQ_FontRequest   (COMM_REQ + 5)
#define RQ_ColorRequest  (COMM_REQ + 6)



///////////////////////////////////////////////
// OPERACE PROVEDENE PRIKAZY ZE SYSTEMU MENU //
///////////////////////////////////////////////

#define COMM_MENU        (COMM_Dummy + 4000) // prikazy spojene s MENU

/////////////
// PROJECT //
/////////////

     // toto je PROJECT/New
#define MN_InitFile      (COMM_MENU + 1)
#define MN_InsertFile    (COMM_MENU + 2)
     // nasledujici funkce slouzi k importu textu v jinych formatech
#define MN_ImportFile    (COMM_MENU + 3)
     // ekvivalent PROJECT/Open ...
#define MN_OpenDoc       (COMM_MENU + 4)
     // ekvivalent PROJECT/Import/...
#define MN_ImportDocASCII     (COMM_MENU + 5)
#define MN_ImportDocRTF       (COMM_MENU + 6)
#define MN_ImportDocWoWo      (COMM_MENU + 7)
#define MN_ImportDocProWrite  (COMM_MENU + 8)
#define MN_ImportDocBDE1x     (COMM_MENU + 9)

     // PROJECT/Close
#define MN_CloseFile     (COMM_MENU + 10)
#define MN_SaveFile      (COMM_MENU + 11)
     // nasledujici funkce slouzi k exportu textu v jinych formatech
#define MN_ExportFile    (COMM_MENU + 12)
     // PROJECT/Save ...
#define MN_SaveDoc       (COMM_MENU + 13)
     // PROJECT/Save as ...
#define MN_SaveAsDoc     (COMM_MENU + 14)
     // PROJECT/Export/...
#define MN_ExportDocASCII     (COMM_MENU + 15)
#define MN_ExportDocRTF       (COMM_MENU + 16)
#define MN_ExportDocWoWo      (COMM_MENU + 17)
#define MN_ExportDocProWrite  (COMM_MENU + 18)
#define MN_ExportDocBDE1x     (COMM_MENU + 19)

     // nahrani obrazku ve formatu IFF do dokumentu; nezobrazuje ho 
#define MN_ImportPicture (COMM_MENU + 20)

     // dalsi slouzi ke smazani souboru (ne adresare!)
#define MN_DeleteFile    (COMM_MENU + 30)

     // nasledujici funkce nastavi parametry tiskarny a tisku
#define MN_SetupPrinter  (COMM_MENU + 40)
     // nasledujici funkce vytiskne zadany dokument
#define MN_PrintFile     (COMM_MENU + 41)
     // funkce pro tzv. Preview
#define MN_PreviewFile   (COMM_MENU + 42)
     // funkce pro zoom v dokumentu
#define MN_ZoomDoc       (COMM_MENU + 43)
     // nasledujici slouzi k tzv. slucovani
#define MN_PrintMerge    (COMM_MENU + 44)
     // dalsi zoom
#define MN_ZoomDoc100    (COMM_MENU + 45)
#define MN_ZoomDocFitWidth    (COMM_MENU + 46)
#define MN_ZoomDocFitPage     (COMM_MENU + 47)

     // fce pro vytvoreni okna pro text podle zadanych voleb - v EditFile
#define MN_OpenWindow    (COMM_MENU + 50)
     // fce pro uzavreni okna (vcetne menu, gadgetu ... )
#define MN_CloseWindow   (COMM_MENU + 51)
     // nasledujici funkce provede ikonifikaci souboru
#define MN_Iconify       (COMM_MENU + 52)
     // zvetseni na okno z ikony
#define MN_UnIcon        (COMM_MENU + 53)

     // ukonceni BD Editoru ...
#define MN_QuitBDT       (COMM_MENU + 60)

     // dalsi importy a exporty
#define MN_ImportDocT602 (COMM_MENU + 80)
#define MN_ExportDocT602 (COMM_MENU + 81)
#define MN_ImportDocHTML (COMM_MENU + 82)
#define MN_ExportDocHTML (COMM_MENU + 83)
#define MN_ImportDocAG   (COMM_MENU + 84)
#define MN_ExportDocAG   (COMM_MENU + 85)

     // rychle otevreni naposledy pouzitych souboru
     // code pak udava cislo slotu = souboru
#define MN_OpenRecentDoc1 (COMM_MENU + 95)
#define MN_OpenRecentDoc2 (COMM_MENU + 96)
#define MN_OpenRecentDoc3 (COMM_MENU + 97)
#define MN_OpenRecentDoc4 (COMM_MENU + 98)



//////////
// EDIT //
//////////

/* nasledujici operace s clipboardem maji vse v EditFile */
#define MN_Cut           (COMM_MENU + 100)        // CUT -> Clip
#define MN_Copy          (COMM_MENU + 101)        // COPY -> Clip
#define MN_Paste         (COMM_MENU + 102)        // Clip -> PASTE
#define MN_Erase         (COMM_MENU + 103)        // smaze bez Clip
#define MN_Undo          (COMM_MENU + 104)        // undo

     // operace pro volbu celeho textu - vse je v EditFile
#define MN_SelectAll     (COMM_MENU + 110)
#define MN_SelectWord    (COMM_MENU + 111)

/* nasledujici operace slouzi ke zmene velikosti pisma; budou asi aktivni
 * pri zvolenem bloku; vse je opet obsazeno EditFile */
#define MN_CaseLower     (COMM_MENU + 120)   // na mala
#define MN_CaseUpper     (COMM_MENU + 121)   // na velka
#define MN_CaseChange    (COMM_MENU + 122)   // zmena
#define MN_CaseCapital   (COMM_MENU + 123)   // kapitalky

/* nasledujici operace slouzi k vlozeni zvlastnich znaku */
/* s vyjimkou ASCII ... nemaji zadny parametr - vse je v EditFile */
#define MN_PageNumber    (COMM_MENU + 130)   // cisla stran
#define MN_PageCount     (COMM_MENU + 131)   // pocet stran
#define MN_PageBreak     BO_NewParaBP        // (COMM_MENU + 132)
     // zlom stranky - duplikovano ^^^ viz BO_NewPara
#define MN_Date          (COMM_MENU + 133)   // datum
#define MN_Time          (COMM_MENU + 134)   // cas
#define MN_Space         (COMM_MENU + 135)   // mezera
     // nasledujici slouzi k zapnuti okna (panelu) s moznosti
     // vyberu libovolneho ASCII znaku - to je globalni pro cely editor a
     // vklada vzdy do aktivniho dokumentu
#define MN_ASCII         (COMM_MENU + 136)   // ASCII znak
#define MN_DateString    (COMM_MENU + 137)   // datum
#define MN_TimeString    (COMM_MENU + 138)   // cas
#define MN_HardSpace     (COMM_MENU + 139)   // tvrda mezera

/* operace COPY a PASTE pro pravitko - vse je opet v EditFile */
/* tyto operace kopiruji do vnitrni pameti, ne do Clip */
#define MN_CopyRuler     (COMM_MENU + 140)
#define MN_PasteRuler    (COMM_MENU + 141)

// vlozeni cisla
#define MN_InsertSimpleNum    (COMM_MENU + 150)
#define MN_InsertHierarchyNum (COMM_MENU + 151)

// preformatovani
#define MN_ReformatDoc   (COMM_MENU + 160)

////////////
// SEARCH //
////////////

     // elementarni akce na vyhledavani v zadaneho slova
#define MN_SearchText    (COMM_MENU + 200)
     // elementarni akce na zmenu zadaneho slova v nejake jine
#define MN_ReplaceText   (COMM_MENU + 201)
     // jako predchozi, ale s naslednym vyhledanim
#define MN_ReplaceFind   (COMM_MENU + 202)
     // vyhledani vseho - jinak jako Replace
#define MN_ReplaceAll    (COMM_MENU + 203)
     // vyhledej nasleudujici
#define MN_SearchNext    (COMM_MENU + 204)
     // nahrad nasledujici
#define MN_ReplaceNext   (COMM_MENU + 205)

     // operace aktivujici okno pro hledani slov - otevre jen to okno, nic vic
#define MN_SearchWindow  (COMM_MENU + 210)
     // operace aktivujici okno pro nahrazovani slov - otevre jen to okno
#define MN_ReplaceWindow (COMM_MENU + 211)

     // prechod na zadanou stranku (na cislo se zepta samostatne)
#define MN_GoToPage      (COMM_MENU + 220)
     // nastaveni zalozky
#define MN_SetBookmark   (COMM_MENU + 221)
     // prechod na zalozku
#define MN_GoToBookmark  (COMM_MENU + 222)

#define MN_SetBookmark2  (COMM_MENU + 223)
#define MN_GoToBookmark2 (COMM_MENU + 224)
#define MN_SetBookmark3  (COMM_MENU + 225)
#define MN_GoToBookmark3 (COMM_MENU + 226)

#define MN_GoToLine      (COMM_MENU + 227)
#define MN_GoToColumn    (COMM_MENU + 228)

     // prechod na misto, kde je prave kurzor
#define MN_GoToCursor    (COMM_MENU + 229)

     // nalezeni zadaneho obrazku (na jeho jmeno se prikaz zepta sam)
#define MN_FindPicture   (COMM_MENU + 230)

#define MN_GoToLineBlock      (COMM_MENU + 240)
#define MN_GoToColumnBlock    (COMM_MENU + 241)

//////////
// TEXT //
//////////

     // funkce, ktera nastavi zadany font jako aktualni pro psani
#define MN_SetActFont    (COMM_MENU + 300)
     // ekvivalent TEXT/Font ...
#define MN_ChooseFont    (COMM_MENU + 301)
     // ekvivalent TEXT/Font style...
#define MN_SetFontStyle  (COMM_MENU + 302)

     // nasledujici polozka nastavuje aktualni styl pisma
#define MN_SetSoftStyle  (COMM_MENU + 310)
     // nastaveni pozice textu
#define MN_SetPosition   (COMM_MENU + 311)
     // nastaveni barvy textu
#define MN_SetColor      (COMM_MENU + 312)

     // nastaveni zpusobu zarovnavani odstavce
#define MN_SetAlignment  (COMM_MENU + 320)
     // nastaveni radkovani
#define MN_SetSpacing    (COMM_MENU + 321)
     // nasledujici dva prikazy slouzi ke zmene (on/off) mezery pred/za odstavcem
#define MN_ChangeSpaceBefore  (COMM_MENU + 322)
#define MN_ChangeSpaceAfter   (COMM_MENU + 323)
#define MN_NoSpacePara        (COMM_MENU + 324)
     // nastavi automaticke urcovani vysky radku pro dany odstavec
#define MN_AutoLine      (COMM_MENU + 325)
     // nastavi pevnou vysku radku pro odstavec (zepta se na hodnotu)
#define MN_FixedLine     (COMM_MENU + 326)
     // nastavi velikost prokladu
#define MN_SpaceOut      (COMM_MENU + 327)

     // vyvolani nastaveni pro obrazek
#define MN_PictSettings  (COMM_MENU + 330)
     // obrazek - presun do pozadi a do popredi
#define MN_PictToFront   (COMM_MENU + 331)
#define MN_PictToBack    (COMM_MENU + 332)

     // uzitecne je nastaveni (celkove) aktualniho stylu pisma
#define MN_SetStyle      (COMM_MENU + 340)
/* operace COPY a PASTE pro styl pisma - vse je opet v EditFile */
/* tyto operace kopiruji do vnitrni pameti, ne do Clip */
#define MN_CopyStyle     (COMM_MENU + 341)
#define MN_PasteStyle    (COMM_MENU + 342)

/* podrobna specifikace pro SetAlignment */
#define MN_SetAlignLeft       (COMM_MENU + 350)
#define MN_SetAlignRight      (COMM_MENU + 351)
#define MN_SetAlignCenter     (COMM_MENU + 352)
#define MN_SetAlignJustify    (COMM_MENU + 353)

/* podrobna specifikace pro MN_SetSpacing */
#define MN_SetSpacing1   (COMM_MENU + 360)
#define MN_SetSpacing15  (COMM_MENU + 361)
#define MN_SetSpacing2   (COMM_MENU + 362)

/* podrobna specifikace MN_SetPosition */
#define MN_SetPosNormal  (COMM_MENU + 370)
#define MN_SetPosSuper   (COMM_MENU + 371)
#define MN_SetPosSub     (COMM_MENU + 372)

/* specifikace MN_SetSoftStyle */
#define MN_SetPlain      (COMM_MENU + 380)
#define MN_SetBold       (COMM_MENU + 381)
#define MN_SetItalic     (COMM_MENU + 382)
#define MN_SetUnderline  (COMM_MENU + 383)
#define MN_SetAllCaps    (COMM_MENU + 384)
#define MN_SetOverline   (COMM_MENU + 385)

/* pokyny pro manipulaci s okraji */
#define MN_MPosIndent    (COMM_MENU + 390)
#define MN_MNoIndent     (COMM_MENU + 391)
#define MN_MNegIndent    (COMM_MENU + 392)
#define MN_MListIndent   (COMM_MENU + 393)

#define MN_LeftMLeft     (COMM_MENU + 395)
#define MN_LeftMRight    (COMM_MENU + 396)
#define MN_RightMLeft    (COMM_MENU + 397)
#define MN_RightMRight   (COMM_MENU + 398)



//////////////
// DOCUMENT //
//////////////

/* nasledujici funkce prepinaji to, co se prave edituje */
#define MN_OddHeader     (COMM_MENU + 400)
#define MN_EvenHeader    (COMM_MENU + 401)
#define MN_OddFooter     (COMM_MENU + 402)
#define MN_EvenFooter    (COMM_MENU + 403)
#define MN_Document      (COMM_MENU + 404)
/* a dalsi prepinaji zobrazovani hlavicky a paticky */
#define MN_ChangeShowHeader   (COMM_MENU + 410)
#define MN_ChangeShowFooter   (COMM_MENU + 411)
#define MN_ChangeActiveHeader (COMM_MENU + 412)
#define MN_ChangeActiveFooter (COMM_MENU + 413)

/* nastaveni tykajici se odstavce ... */
     // nastaveni (celkove) stylu odstavce - jiz kompletne inicializovaneho
#define MN_SetParaStyle  (COMM_MENU + 420)
     // ekvivalent DOC/Paragraph/Setting ...
#define MN_ParaSettings  (COMM_MENU + 421)
     // ekvivalent DOC/Paragraph/Create named style...
#define MN_NamedParaStyle     (COMM_MENU + 422)
     // nahrani stylu odstavce z disku
#define MN_LoadParaStyle (COMM_MENU + 423)
     // ulozeni stylu odstavce na disk
#define MN_SaveParaStyle (COMM_MENU + 424)

     // vyvola nastaveni layoutu dokumentu
#define MN_Layout        (COMM_MENU + 430)
     // vyvola nastaveni stranky
#define MN_PageSetup     (COMM_MENU + 431)
     // vyvola requester pro nastaveni tabelatoru
#define MN_TabsSetup     (COMM_MENU + 432)
     // vyvola requester pro definici stylu
#define MN_StyleSetup    (COMM_MENU + 433)
     // generovani obsahu
#define MN_CreateContents     (COMM_MENU + 434)
     // generovani seznamu obrazku
#define MN_CreateIlusList     (COMM_MENU + 435)
     // oramovani odstavce
#define MN_BorderSetup   (COMM_MENU + 436)
     // generovani obecneho seznamu
#define MN_CreateList    (COMM_MENU + 437)
     // formatovani tabulek
#define MN_TableFormat   (COMM_MENU + 438)

/* nasledujici se tyka jazykovych voleb */
     // zmena deleni/nedeleni slov
#define MN_ChangeHyph    (COMM_MENU + 440)
     // kontrola pravopisu - aktivace okna, resp. jeho presun do popredi
#define MN_SpellWindow   (COMM_MENU + 441)
     // zmena stavu prubezne kontroly
#define MN_ChangeWTSpell (COMM_MENU + 442)
     // zmena hlavniho jazyka pro kontrolu
#define MN_CzechLang     (COMM_MENU + 443)
#define MN_SlovakLang    (COMM_MENU + 444)
#define MN_EnglishLang   (COMM_MENU + 445)
     // vyvola prekladovy modul (pokud existuje, jeho okno do popredi)
#define MN_Translate     (COMM_MENU + 450)

     // poda souhrnne informace o dokumentu
#define MN_GetSummary    (COMM_MENU + 460)

     // jako requester pro definici stylu, ale slouzi pro nastaveni nasledujiciho stylu
#define MN_NextStyleSetup     (COMM_MENU + 490)
     // nastaveni stylu z klavesnice
#define MN_KeyStyleSetup      (COMM_MENU + 491)



//////////////
// SETTINGS //
//////////////

/* nasledujici CS (= ChangeShow) prikazy prepinaji stavy jimi jmenovanych voleb */
#define MN_CSInvisibles  (COMM_MENU + 500)
#define MN_CSPageGuides  (COMM_MENU + 501)
#define MN_CSPictures    (COMM_MENU + 502)
#define MN_CSHorizRuler  (COMM_MENU + 503)
#define MN_CSVertRuler   (COMM_MENU + 504)

     // prepinani mezi modem Insert a Overwrite
#define MN_InsOver       (COMM_MENU + 510)
     // nastaveni kodovani pro dany dokument
#define MN_SetCodePage   (COMM_MENU + 511)
     // nastaveni klavesnice pro editor
#define MN_SetKeymap     (COMM_MENU + 512)
     // prepinani active/nonactive objects
#define MN_DeactivateObj (COMM_MENU + 513)

/* nasledujici funkce slouzi k vyvolani ruznych preferenci */
#define MN_PrefsDisplay  (COMM_MENU + 520)
#define MN_PrefsItems    (COMM_MENU + 521)
#define MN_PrefsTabs     (COMM_MENU + 522)
#define MN_PrefsGeneral  (COMM_MENU + 523)
#define MN_PrefsLocale   (COMM_MENU + 524)
#define MN_PrefsIO       (COMM_MENU + 525)
#define MN_PrefsScreen   (COMM_MENU + 526)
#define MN_PrefsColors   (COMM_MENU + 527)
#define MN_PrefsSpeller  (COMM_MENU + 528)
#define MN_PrefsAutoCorr (COMM_MENU + 529)

#define MN_PrefsIndex    (COMM_MENU + 540)   // nutno preskocit vvv
#define MN_PrefsToolbar  (COMM_MENU + 541)
#define MN_PrefsNumbers  (COMM_MENU + 542)

/* toto je pro ulozeni a nahrani konfigurace editoru */
#define MN_LoadSettings  (COMM_MENU + 530)
#define MN_SaveSettings  (COMM_MENU + 531)
#define MN_StandardSettings   (COMM_MENU + 532)

/* podrobne MN_SetCodePage */
#define MN_SetCPKeybCS  (COMM_MENU + 550)
#define MN_SetCPKOI8    (COMM_MENU + 551)
#define MN_SetCPLATIN2  (COMM_MENU + 552)
#define MN_SetCPWinEE   (COMM_MENU + 553)
#define MN_SetCPMacCE   (COMM_MENU + 554)

/* podrobne MN_SetKeyMap */
#define MN_SetKMCS      (COMM_MENU + 560)
#define MN_SetKMCS_CAPS (COMM_MENU + 561)
#define MN_SetKMAmater  (COMM_MENU + 562)
#define MN_SetKMSystem  (COMM_MENU + 563)


////////////
// MACROS //
////////////

/* nasledujici funkce zapocne/ukonci v *DANEM OKNE* zaznam makra, na jehoz
 * cislo se predem zepta - nepovinne - a se zepta na jmeno souboru, kam
 * prijde ulozit - vzdy; po ukonceni se makro samozrejme ulozi */
#define MN_StartMacro    (COMM_MENU + 600)
#define MN_EndMacro      (COMM_MENU + 601)
     // funkce pro provedeni libovolneho makra na disku
#define MN_ExecuteMacro  (COMM_MENU + 602)
     // funkce pro nahrani/ulozeni prednastavenych maker na pozice v menu
#define MN_LoadMacros    (COMM_MENU + 603)
#define MN_SaveMacros    (COMM_MENU + 604)

/* podrobnejsi prikazy pro predefinovana makra - musi nasledovat za sebou */
#define MN_Macro1       (COMM_MENU + 610)
#define MN_Macro2       (COMM_MENU + 611)
#define MN_Macro3       (COMM_MENU + 612)
#define MN_Macro4       (COMM_MENU + 613)
#define MN_Macro5       (COMM_MENU + 614)
#define MN_Macro6       (COMM_MENU + 615)
#define MN_Macro7       (COMM_MENU + 616)
#define MN_Macro8       (COMM_MENU + 617)
#define MN_Macro9       (COMM_MENU + 618)
#define MN_Macro10      (COMM_MENU + 619)

#define MN_Macro11      (COMM_MENU + 620)
#define MN_Macro12      (COMM_MENU + 621)
#define MN_Macro13      (COMM_MENU + 622)
#define MN_Macro14      (COMM_MENU + 623)
#define MN_Macro15      (COMM_MENU + 624)
#define MN_Macro16      (COMM_MENU + 625)
#define MN_Macro17      (COMM_MENU + 626)
#define MN_Macro18      (COMM_MENU + 627)
#define MN_Macro19      (COMM_MENU + 628)
#define MN_Macro20      (COMM_MENU + 629)

#define MN_Macro21      (COMM_MENU + 630)
#define MN_Macro22      (COMM_MENU + 631)
#define MN_Macro23      (COMM_MENU + 632)
#define MN_Macro24      (COMM_MENU + 633)
#define MN_Macro25      (COMM_MENU + 634)
#define MN_Macro26      (COMM_MENU + 635)
#define MN_Macro27      (COMM_MENU + 636)
#define MN_Macro28      (COMM_MENU + 637)
#define MN_Macro29      (COMM_MENU + 638)
#define MN_Macro30      (COMM_MENU + 639)

#define MN_Macro31      (COMM_MENU + 640)
#define MN_Macro32      (COMM_MENU + 641)
#define MN_Macro33      (COMM_MENU + 642)
#define MN_Macro34      (COMM_MENU + 643)
#define MN_Macro35      (COMM_MENU + 644)
#define MN_Macro36      (COMM_MENU + 645)
#define MN_Macro37      (COMM_MENU + 646)
#define MN_Macro38      (COMM_MENU + 647)
#define MN_Macro39      (COMM_MENU + 648)
#define MN_Macro40      (COMM_MENU + 649)



//////////
// HELP //
//////////

/* operace z menu HELP */
     // vyvola napovedu, neni-li aktivni
#define MN_GetHelp       (COMM_MENU + 700)
     // informace o programu
#define MN_About         (COMM_MENU + 701)
     // informace o funkcnich klavesach
#define MN_FKeys         (COMM_MENU + 702)
     // informace o klavesovych zkratkach
#define MN_ShortCuts     (COMM_MENU + 703)
     // vyvolani contextoveho menu z klavesnice
#define MN_ContextMenu   (COMM_MENU + 704)

     // umozni usporadat okna do libovolneho poradi
#define MN_ArrangeWins   (COMM_MENU + 710)


//////////////////////
// CO V MENU NEBYLO //
//////////////////////

/* fce pro nastaveni typu tabelatoru */
#define MN_SetTabType    (COMM_MENU + 800)
/* podrobne */
#define MN_SetTabLeft    (COMM_MENU + 801)
#define MN_SetTabRight   (COMM_MENU + 802)
#define MN_SetTabCenter  (COMM_MENU + 803)
#define MN_SetTabDecimal (COMM_MENU + 804)
// nove volba aktivni tabelator x linka
#define MN_SetTabActive  (COMM_MENU + 805)
#define MN_SetLineActive (COMM_MENU + 806)

/* pohyb o stranku vpred / vzad */
#define MN_PageUp        (COMM_MENU + 820)
#define MN_PageDown      (COMM_MENU + 821)

////////////////
// TOOLS MENU //
////////////////

#define MN_ImportGraphics     (COMM_MENU + 900)
#define MN_CreateObject       (COMM_MENU + 901)
#define MN_ObjectInfo         (COMM_MENU + 902)
#define MN_ObjectForward      (COMM_MENU + 910)
#define MN_ObjectBackward     (COMM_MENU + 911)
#define MN_ObjectToFront      (COMM_MENU + 912)
#define MN_ObjectToBack       (COMM_MENU + 913)
#define MN_GroupObjects       (COMM_MENU + 915)
#define MN_UngroupObject      (COMM_MENU + 916)
#define MN_DuplicateObject    (COMM_MENU + 920)
#define MN_ReloadExtPicture   (COMM_MENU + 930)



////////////////////////////////////
// RUZNE REDRAW & REFRESH OPERACE //
////////////////////////////////////

#define COMM_REFRESH          (COMM_Dummy + 5000)

     // znovu vykresleni aktualniho vyrezu
#define RF_RedrawClip         (COMM_REFRESH + 1)
     // vykresleni vyrezu zadaneho souradnicemi
#define RF_GetClip            (COMM_REFRESH + 2)

     // funkce pro vertikalni (svisly) posun vyrezu
#define RF_VertMoveClip       (COMM_REFRESH + 10)
     // totez, ale posun je zadan v bodech
#define RF_PVertMoveClip      (COMM_REFRESH + 11)
     // funkce pro horizontalni (vodorovny) posun vyrezu
#define RF_HorizMoveClip      (COMM_REFRESH + 12)
     // totez, ale posun je zadan v bodech
#define RF_PHorizMoveClip     (COMM_REFRESH + 13)


     // fce pro prekresleni pravitek (tech, co se prave zobrazuji)
#define RF_RedrawRuler        (COMM_REFRESH + 20)
     // fce pro prekresleni tlacitkoveho panelu
#define RF_RedrawPanel        (COMM_REFRESH + 21)


/////////////////
// MISCELANOUS //
/////////////////

#define COMM_MISC             (COMM_Dummy + 10000)

     // fce pro zmenu stavu Workbenchove obrazovky - zapnout/vypnout
#define MISC_Workbench        (COMM_MISC + 1)



/////////////////////////////
// SPECIALNI AKCE A ZPRAVY //
/////////////////////////////

#define COMM_SPEC             (COMM_Dummy + 12000)

// vyslani signalu intuitick
#define SPEC_IntuiTick        (COMM_SPEC + 1)
#define SPEC_Verification     (COMM_SPEC + 2)
#define SPEC_NoneOperation    (COMM_SPEC + 3)

// zavreni dokumentu
#define SPEC_CloseDoc         (COMM_SPEC + 5)

// operace rolovani pomoci gadgetu "sipek" vedle soupatek
#define SPEC_ScrollLeft       (COMM_SPEC + 10)
#define SPEC_ScrollRight      (COMM_SPEC + 11)
#define SPEC_ScrollDown       (COMM_SPEC + 12)
#define SPEC_ScrollUp         (COMM_SPEC + 13)
#define SPEC_ScrollEnd        (COMM_SPEC + 15)

// operace s mysi - stisknuti, presun kurzoru, oznaceni bloku //
#define SPEC_MouseDown        (COMM_SPEC + 20)
#define SPEC_MouseUp          (COMM_SPEC + 21)

// zmena velikosti ci polohy okna, resp. zprava o nutnosti prekresleni okna
#define SPEC_WinboxChanged    (COMM_SPEC + 30)
     // a nyni je treba provest obnoveni obsahu okna
#define SPEC_RefreshWin       (COMM_SPEC + 31)

// aktivace okna nejakeho dokumentu
#define SPEC_ActiveDoc        (COMM_SPEC + 40)
#define SPEC_InactiveDoc      (COMM_SPEC + 41)

// opusteni a uzavreni dokumentu
//#define SPEC_CloseDoc         (COMM_SPEC + 50)

// zpravy pro specialni okna)
#define SPEC_InsertLiteral    (COMM_SPEC + 100)
#define SPEC_Search           (COMM_SPEC + 101)
#define SPEC_Replace          (COMM_SPEC + 102)
#define SPEC_Speller          (COMM_SPEC + 103)

// zprava od soupatek - ma se z nich urcit nova pozice textu a prekreslit
#define SPEC_NewHorizPos      (COMM_SPEC + 120)
#define SPEC_NewVertPos       (COMM_SPEC + 121)

// get word under cursor
#define SPEC_GetCursorWord    (COMM_SPEC + 130)

// stalo se neco, co se nema delat (vlozeni ESC, posun kurzorem za konec apod.)
#define SPEC_DisplayBeep      (COMM_SPEC + 200)
#define SPEC_UnknownRAWKEY    (COMM_SPEC + 201)

// zpravy tykajici se napovedy z klavesnice
#define SPEC_HelpAll          (COMM_SPEC + 300)
#define SPEC_HelpShortCuts    (COMM_SPEC + 301)
#define SPEC_HelpHelp         (COMM_SPEC + 302)
#define SPEC_HelpWindow       (COMM_SPEC + 303)




/////////////////////////////
// TAGS pro BDTFileRequest //
/////////////////////////////

#define FILTER_NONE           0
#define FILTER_FORMBDED       1
#define FILTER_FORMWOWO       2
#define FILTER_RTF            3
#define FILTER_FORMILBM       4
#define FILTER_FORMWORD       5
#define FILTER_FORMT602       6
#define FILTER_FORMAG         7
#define FILTER_FORMHTML       8

// ma se pouzit cesta k editoru?
#define FILTER_MASK           0xFFFFL
#define FILTER_EDITOR_PATH    0x10000L

// ma se ulozit v nejnovejsim = aktualnim formatu editoru
#define BDE_SAVE_NEWEST       0
// ulozeni ve formatu BDE 1.x
#define BDE_SAVE_BDE1x        1


///////////////////////////////
// TAGS pro MakeNewTextStyle //
///////////////////////////////

#define TSGROUP_STYLE         1
#define TSGROUP_POSITION      2
#define TSGROUP_COLOR         3
#define TSGROUP_STYLESET      4

/////////////////////////////
// TAGS pro SetSpecPointer //
/////////////////////////////

#define POINT_NORMAL          0
#define POINT_BUSY            1
#define POINT_LM_FIRST        2
#define POINT_LM_OTHER        3
#define POINT_RM              4
#define POINT_TAB             5
#define POINT_TAB_LEFT        6
#define POINT_TAB_RIGTH       7
#define POINT_TAB_CENTER      8
#define POINT_TAB_DECIMAL     9
#define POINT_LINE_12         10
#define POINT_LINE_1          11
#define POINT_LINE_2          12
#define POINT_LINE_3          13
#define POINT_LINE_4          14

///////////////////////////////////////////////////
// TAGS MODY PRO RUTINY ASYNCHRONNICH REQUESTERU //
///////////////////////////////////////////////////

#define ASREQ_CREATE          1
#define ASREQ_DESTROY         2
#define ASREQ_IDCMP           3

///////////////////////////////////////////////////
// FLAGY PRO PREVODY MUNIT <--> ZOBRAZOVACI BODY //
///////////////////////////////////////////////////

// standardne se uvazuje svisly smer, pokud chceme vodorovny
// musime nastavit tento bit
#define PUUP_HORIZ       (1L << 1)

// pokud chceme zaokrouhlovat nahoru v prevodech (standardne se
// pri celociselnem deleni zaokrouhluje dolu), nastavime tento bit
#define PUUP_UPPER       (1L << 2)
// pokud nastavime select, vybere se varianta blizsi k dane hodnote
#define PUUP_SELECT      (1L << 3)


///////////////////////////
// FLAGY PRO LibQuestion //
///////////////////////////

// urcuji poradi parametru pro LibQuestion
#define Q_TITLE     0
#define Q_BODY      1
#define Q_ANSWER    2



////////////////////////////////
// FLAGY PRO LibChangePointer //
////////////////////////////////

// flagy pro LibChangePointer
#define CHP_WAIT         (1L << 1)
#define CHP_BLOCKINPUT   (1L << 2)



////////////////////////////////
// FLAGY PRO LibSetSpellErros //
////////////////////////////////

#define NUM_SPELL_ERRORS      10

/* skupiny menu a gadgetu k prekreslovani */
/* pro RedrawMenus */
#define MG_STYLES        (1L << 0)
#define MG_POSITIONS     (1L << 1)
#define MG_COLORS        (1L << 2)
#define MG_ALIGNMENT     (1L << 3)
#define MG_SPACING       (1L << 4)
#define MG_LINEHEIGHT    (1L << 5)
#define MG_HEADFOOT      (1L << 6)
#define MG_SPELLHYP      (1L << 7)
#define MG_SHOW          (1L << 8)
#define MG_RULERS        (1L << 9)
#define MG_INSERT        (1L << 10)
#define MG_CODEPAGE      (1L << 11)
#define MG_KEYMAP        (1L << 12)
#define MG_ACTIVEOBJS    (1L << 13)
/* pro RedrawGadgets */
#define GG_REFRESHALL    0
#define GG_ALIGNMENT     (1L << 1)
#define GG_TABS          (1L << 2)
#define GG_SPACING       (1L << 3)      // oboji!
#define GG_STYLES        (1L << 4)
#define GG_POSITIONS     (1L << 5)
#define GG_SCROLLERS     (1L << 6)
#define GG_PAGEINFO      (1L << 7)
/* pro DrawSymbol */
#define DS_BEGIN_PARA    (1L << 0)
#define DS_BEGIN_LINE    (1L << 1)
#define DS_END_LINE      (1L << 2)
#define DS_TABELATOR     (1L << 3)
#define DS_TAB_LINES     (1L << 4)



////////////////////////
// KONSTANTY PRO UNDO //
////////////////////////

#define UNDO_Empty            0
#define UNDO_Special          1

#define UNDO_DelText          10
#define UNDO_InsText          11
#define UNDO_DelBlock         12
#define UNDO_InsClip          13
#define UNDO_OverwriteText    14
#define UNDO_ReplaceText      15

#define UNDO_InsFrame         20
#define UNDO_DelFrame         21

#define UNDO_ParaFormat       30
#define UNDO_FontFormat       31

#endif /* BDT-Defs-Tags.h */

