/* $Header: /home/xplore/cvs/xpl4gr/wplot.cpp,v 1.4 2004/02/18 12:01:12 xplore Exp $ */

#include "wplot.h"
#include "wdisp.h"
#include "color.h"
#include "xplwin.h"

// localized strings - PC 20010320
#include "xplore_strings.h"

#ifndef CONVEX
#define CONVEX 15
#endif

#ifndef ASK
#define ASK 15
#endif

#define LAB_FONT 10
#define MAL 32

#define SYMBOL_COUNT 16
#define SIZE_COUNT 16

extern HINSTANCE hinst;

extern char * axisstring(const Plot *plot, int i);

extern  TMemoryDC *alldcs[(SYMBOL_COUNT-1)][(SIZE_COUNT-1)];

extern Liste <XplColor *> all_colors;
extern Liste <XplSymbol *> all_symbols;
Boolean visible(int x, int y, int width, int height,
		const int * xoffset, const int *yoffset, const Plot *p);
void prepare_string(char * str);

WPlot::WPlot(const WPlot *wplot, WDisplay* dixi,
		const int di_x, const di_y) :Plot (wplot,dixi,di_x,di_y)                      	// SVEN
{
	type=WPLOT;
	selected=0;
   mousedown=false;
	PlotProfile = new TProfile("WPlot", "xplore.ini");

	delX=display->GetWidth()*display->GetElementLeftPosition(di_x,di_y)/100;
	delY=display->GetHeight()*display->GetElementTopPosition(di_x,di_y)/100;
   Resize(display->GetElementWidth(di_x,di_y),display->GetElementHeight(di_x,di_y));

}



WPlot::WPlot(const Liste <XplObject *> * data_list,
		WDisplay* wdixi,
		const int di_x, const int di_y):
			Plot(data_list, wdixi, di_x, di_y), Wdixi(wdixi)
/* 	this constructor shall be used by show(d, 1, 1, x)		*/
/*	Plot(data_list, dixi, di_x, di_y) gets the size and the place 	*/
/* of WPlot, gets the data and scaled it, computes the axis...	*/
{
	type=WPLOT;
		selected=0;
		PlotProfile = new TProfile("Plot", "xplore.ini");

		 delX=display->GetWidth()*display->GetElementLeftPosition(di_x,di_y)/100;
		 delY=display->GetHeight()*display->GetElementTopPosition(di_x,di_y)/100;

        delX=display->GetWidth()*display->GetElementLeftPosition(di_x,di_y)/100;
	 delY=display->GetHeight()*display->GetElementTopPosition(di_x,di_y)/100;
    Resize(display->GetElementWidth(di_x,di_y),
    		display->GetElementHeight(di_x,di_y));
	  	Replace(
			display->GetElementTopPosition(di_x,di_y),
			display->GetElementBottomPosition(di_x,di_y),
			display->GetElementLeftPosition(di_x,di_y),
			display->GetElementRightPosition(di_x,di_y));

         ((XplDisplay*)display)->Resize( display->GetWidth(), display->GetHeight());
/*	here you must create all what you need....			*/

  	Refresh();	// your own member function

}

WPlot::WPlot(WDisplay* wdixi,
		const int di_x, const di_y):
			Plot(wdixi, di_x, di_y), Wdixi(wdixi)
/* 	this constructor shall be used by createdisplay(n, m)		*/
/*	Plot(data_list, dixi, di_x, di_y) gets the size and the place 	*/
/*	of WPlot, but there are no data there!			*/
{

		type=WPLOT;
		selected=0;
		PlotProfile = new TProfile("Plot", "xplore.ini");

		 delX=display->GetWidth()*display->GetElementLeftPosition(di_x,di_y)/100;
		 delY=display->GetHeight()*display->GetElementTopPosition(di_x,di_y)/100;

        delX=display->GetWidth()*display->GetElementLeftPosition(di_x,di_y)/100;
	 delY=display->GetHeight()*display->GetElementTopPosition(di_x,di_y)/100;
    Resize(display->GetElementWidth(di_x,di_y),
    		display->GetElementHeight(di_x,di_y));
	  	Replace(
			display->GetElementTopPosition(di_x,di_y),
			display->GetElementBottomPosition(di_x,di_y),
			display->GetElementLeftPosition(di_x,di_y),
			display->GetElementRightPosition(di_x,di_y));

         ((XplDisplay*)display)->Resize( display->GetWidth(), display->GetHeight());
/*	here you must create all what you need....			*/

  	Refresh();	// your own member function

}

/*-----------------------------------------------------------------------*/

WPlot::~WPlot()
{
/* 	here you delete all that, that you have alloced by constructor..*/
/*	remember, that the UPlot::~UPlot comes as next!			*/
delete PlotProfile;
}


/*-----------------------------------------------------------------------*/


void WPlot::Refresh() const
{
/*	that is the most important function!				*/
	 //	 Resize();
paint(1);
}
void WPlot::Resize(int wi, int he) {
		 Plot::Resize(wi, he);
       int uiu = display->GetElementLeftPosition(di_x,di_y);
		 delX=display->GetWidth()*display->GetElementLeftPosition(di_x,di_y)/100;
		 delY=display->GetHeight()*display->GetElementTopPosition(di_x,di_y)/100;
	//	 width=display->width*(display->GetElementRightPosition(di_x,di_y)-
	//					display->GetElementLeftPosition(di_x,di_y))/100;
	//	 height=display->height*(display->GetElementBottomPosition(di_x,di_y)-
	//					display->GetElementTopPosition(di_x,di_y))/100;
   Refresh();                                                                        // SVEN

}

void WPlot::AddButton(const char *na, const char* com)
{	Plot::AddButton(na, com);
/*	now you must really add smth as button to your ???Plot		*/
}


void WPlot::DeleteButton(const char * str)
{
	Plot::DeleteButton(str);
/*	now you must really delet it 					*/
}

void WPlot::InFocus()
{
/* you must raise the menu from this Plot and make its border visible	*/
}


	int WPlot::redraw_points(int data_num, XplMatrix & only_these) {return 0;}
/* 	to use only after color_brush	!!!!!			*/
	/*	you can make it later....			*/

 //	int WPlot::repaint_part(int part_x, int part_y,
 //		int part_width, int part_height) const {
  //		}
	/*	you can make it later....			*/

//***********************************************************
// Windows functions

void WPlot::paint(int mitgrap) const {
	  int part_x=delX;
	  int part_y=delY;
	  int part_width=width;
	  int part_height=height;
	  repaint_part(part_x, part_y,
		part_width, part_height);
		}

int WPlot::repaint_part(int part_x, int part_y,
		int part_width, int part_height, TDC *memDC) const {
#ifndef LTEST
	int c1;

	// can be TMemoryDC
	//TWindowDC  *memDC=Wdixi->dc;

    bool newdc=False;
   if (memDC==NULL)
   {   memDC= new TWindowDC(((TWindow *)Wdixi)->HWindow);
       newdc=True;
   }
   //  	return(0);

   memDC->SaveDC();

/* Now prepare gc ...*/

	TRect trec1(delX, delY, width + delX, height + delY);
	memDC->IntersectClipRect (trec1);



	//clear the plot area
	//memDC->PatBlt(delX, delY, width + delX, height + delY, WHITENESS);
	// PAint the frame

	// PC 001122 - no blue color in frame - c1 = selected ?  250 : 0;
   c1 = 0;
	TPen pen(TColor(0,0,c1), 1);
  	memDC->SelectObject(pen);
/*
   memDC->MoveTo(delX + 1,delY + 1);
	memDC->LineTo(width + delX - 1, delY + 1);
	memDC->LineTo(width + delX - 1, height + delY - 1);
	memDC->LineTo(delX + 1, height + delY - 1);
	memDC->LineTo(delX + 1,delY + 1);
*/
/* PC 001122 - not needed
   {
	  memDC->MoveTo(delX ,delY );
	  //memDC->LineTo(width + delX -1, delY );
     memDC->LineTo(width + delX , delY );        // SVEN
	  //memDC->LineTo(width + delX -1, height + delY -1);
     memDC->LineTo(width + delX , height + delY ); // SVEN
	  //memDC->LineTo(delX , height + delY -1);
     memDC->LineTo(delX , height + delY );    // SVEN
	  memDC->LineTo(delX ,delY);
   }
*/

   memDC->RestorePen();
  //	memDC->RestoreBrush();

  //	TRect trec(part_x, part_y, part_x+part_width, part_y+part_height);
   TRect trec2(delX, delY, width + delX, height + delY);            // PC 001122
  // TRect trec2(delX+1, delY+1, width + delX-1, height + delY-1);            //SVEN
  // TRect trec2(delX+2, delY+2, width + delX-2, height + delY-2);
  //  TRect trec2(delX+1, delY+1, width + delX-2, height + delY-2);
  //  cout<<"x="<<part_x<<", y="<<part_y<<", to x="<<part_x+part_width<<
  //  ", to y="<<part_y+part_height<<endl;

   memDC->IntersectClipRect(trec2);
	memDC->PatBlt(delX, delY, width + delX, height + delY, WHITENESS);

			//TBrush brush1(TColor(210,210,210));
			//memDC->SelectObject(brush1);
//			memDC->FillRect(delX+2, delY+2, width + delX-2, height + delY-2, brush1);
			//memDC->RestoreBrush();
			memDC->SetBkColor(TColor(255,255,255)); // have to be changed
			//paint the headline

	memDC->IntersectClipRect(trec2);

	float red, green, blue;
   int dim;
	int lefto, righto, bottomo, topo;
	bool rotated;
	XplMatrix rotpoint;
	int which_x, which_y;
   int i, j;

	int tm_count;
	char zahl[128];
	char* zahl_beg;
	XplMatrix do_von, do_bis, do_tima, secsk;

	MyPoint von, bis, tima;
	bool str_visible;
	float origin, tm;
   double prop=0.4;	//needed for font

	Achse ax_da(0, 0, 0), ay_da(0, 0, 0);
	Vector <float> xcontent, ycontent;
	char *axis_string;

	XplMatrix timm;

		if (axis_on)
	{	//cout<<"print axen..."<<endl;
  TColor lc(0, 0, 0);
memDC->SetTextColor(lc);
		red=all_colors[0]->red/(float)(65536);
		green=all_colors[0]->green/(float)(65536);
		blue=all_colors[0]->blue/(float)(65536);


		TPen pen(TColor(red, green, blue), 1);
		memDC->SelectObject(pen);

		dim=GetDimension();
		do_von=GetRotationPoint();
		do_bis=GetRotationPoint();
		do_tima=GetRotationPoint();
		rotpoint=GetRotationCosinus();
		//nur wegen dimension???
		int axis_font=0;
		if ( 	bottom_frame_visible()&& left_frame_visible())
      {
			//beide sichtbar!
			axis_font=hoffset[0]*width>voffset[1]*height ?
			voffset[1]*height*TICK_STRING_HEIGHT/100	:
			hoffset[0]*width*TICK_STRING_HEIGHT/100;
      }

		if ( 	(!bottom_frame_visible())&& left_frame_visible()  )
      {
			//nur ver.  sichtbar!
			axis_font=hoffset[0]*width*TICK_STRING_HEIGHT/100;
      }

		if ( bottom_frame_visible()&& (!left_frame_visible() ) )
      {
			//nur hor.  sichtbar!
			axis_font=voffset[1]*height*TICK_STRING_HEIGHT/100;
      }
      if (axis_font <= 0) axis_font = 1;	// PC 20010420: axis_font must have a positive size

      // cout<<"axis_font="<<     axis_font<<endl;
      TFont *fontx=NULL, *fonty=NULL;
      int logpx, logpy;
 //     logpx=memDC->GetDeviceCaps(LOGPIXELSX);
 //     logpy=memDC->GetDeviceCaps(LOGPIXELSY);
//      cout<<"x="<<logpx<<", y="<<logpy<<endl;

      if (axis_font!=0)
      {	fontx=new TFont(GetWinFontName(), axis_font, axis_font*prop, 0, 0);     // PC 20010702 - changed name of the font
      	fonty=new TFont(GetWinFontName(), axis_font, axis_font*prop, 900, 0);
      }

  		for (i=0; i<dim; i++)
		{	for (j=0; j<dim; j++)
			{	if (! (rotpoint(i,j)==0 || rotpoint(i,j)==1) )
				break;
         if ( rotpoint(i,j)==1 &&  j==0)
				which_x=i;
			if ( rotpoint(i,j)==1 &&  j==1)
				which_y=i;
			}
         if (j<dim)
         	if (! (rotpoint(i,j)==0 || rotpoint(i,j)==1) )
         		break;
      }
		if (i==dim && j==dim && axis_font>0)
		// plot ist nicht verdreht!
		{	float x_origin, y_origin;

			ax_da=GetAchse(which_x+1);
			ay_da=GetAchse(which_y+1);

			xcontent=ax_da.GetContent();
			ycontent=ay_da.GetContent();

			do_von.fill(0.0);	//eine ecke
			do_von(0, which_x)=xcontent[0];
			do_von(0, which_y)=ycontent[0];

			do_bis.fill(0.0);
			do_bis(0, which_x)=xcontent[1];
			do_bis(0, which_y)=ycontent[1];

			von=GetImage(do_von);
			bis=GetImage(do_bis);

	/*		von.x=von.x-AXIS_OFFSET;
			von.y=von.y+AXIS_OFFSET;
			bis.x=bis.x+AXIS_OFFSET;
			bis.y=bis.y-AXIS_OFFSET;
	*/
			topo=height-1; // PC 001122	- -1 replaced by -2
			bottomo=0;	// PC 001122 - 1;
			lefto=0;	// PC 001122 - 1;
			righto=width-1; // PC001122	- -1 replaced by -2

			// PC 001122 - no blue color in frame - c1 = selected ?  250 : 0;
         c1 = 0;
			TPen pen(TColor(0,0,c1), 1);
		  	memDC->SelectObject(pen);

         if (GetBorder())	// PC 001122 - border drawn optionally
         {
		  	  memDC->MoveTo(delX+lefto,delY+bottomo);
			  memDC->LineTo(delX+lefto,delY+topo);
			  memDC->LineTo(delX+righto,delY+topo);
			  memDC->LineTo(delX+righto,delY+bottomo);
			  memDC->LineTo(delX+lefto,delY+bottomo);
         }
         memDC->RestorePen();

//			fprintf(ps_file, "%d %d %d %d XplLine\n",
//				von.x, von.y, bis.x, von.y);
         if (xaxisline)
         {
			  memDC->MoveTo(delX+von.x,delY+von.y);
			  memDC->LineTo(delX+bis.x,delY+von.y);
         }

//			fprintf(ps_file, "%d %d %d %d XplLine\n",
//				von.x, von.y, von.x, bis.y);
         if (yaxisline)
         {
			  memDC->MoveTo(delX+von.x,delY+von.y);
			  memDC->LineTo(delX+von.x,delY+bis.y);
         }

//			fprintf(ps_file, "%d %d %d %d XplLine\n",
//				bis.x, bis.y, bis.x, von.y);
         if (yaxisline)
         {
			  memDC->MoveTo(delX+bis.x,delY+bis.y);
			  memDC->LineTo(delX+bis.x,delY+von.y);
         }

//			fprintf(ps_file, "%d %d %d %d XplLine\n",
//				bis.x, bis.y, von.x, bis.y);
         if (xaxisline)
         {
			  memDC->MoveTo(delX+bis.x,delY+bis.y);
			  memDC->LineTo(delX+von.x,delY+bis.y);
		   }

		//do_von=GetOrigin(von);
		//	do_bis=GetOrigin(bis);

			x_origin=xcontent[2];
			while (x_origin<do_von(0, which_x))
				x_origin=x_origin+xcontent[3];
			while (x_origin>do_von(0, which_x)+
					xcontent[3])
				x_origin=x_origin-xcontent[3];
		//	cout<<"X_origin="<<x_origin<<endl;

			y_origin=ycontent[2];
			while (y_origin<do_von(0, which_y))
				y_origin=y_origin+ycontent[3];
			while (y_origin>do_von(0, which_y)+
					ycontent[3])
				y_origin=y_origin-ycontent[3];
		//	cout<<"Y_origin="<<y_origin<<endl;

			do_tima.fill(0.0);
			do_tima(0, which_x)=x_origin;

			str_visible=bottom_frame_visible();

		  //	cout<<"voffset="<<voffset[1]*height/100<<endl;
         if (str_visible && fontx!=NULL)
                 memDC->SelectObject(*fontx);
         while( !(do_tima(0, which_x)>do_bis(0, which_x)) && xtickmarks )
			{	tima=GetImage(do_tima);

//				fprintf(ps_file, "%d %d %d %d XplLine\n",
//					tima.x,
//					von.y+voffset[1]*height/100/10,
//					tima.x, von.y);
				memDC->MoveTo(delX+tima.x,delY+von.y+voffset[1]*height/100/MIN_FONT);
				memDC->LineTo(delX+tima.x,delY+von.y);


//				fprintf(ps_file, "%d %d %d %d XplLine\n",
//					tima.x, bis.y,
//					tima.x, bis.y-voffset[1]*height/100/10);
				memDC->MoveTo(delX+tima.x, delY+bis.y);
				memDC->LineTo(delX+tima.x, delY+bis.y-voffset[1]*height/100/MIN_FONT);

				tm=(do_tima(0,which_x)-xcontent[5])/
						xcontent[6];

				if (str_visible)
				{   sprintf(zahl, AXIS_FORMAT, tm);
					prepare_string(zahl);
//					fprintf(ps_file,
//					"(%s) %d %d XplShow\n", zahl,
//					tima.x,
//					von.y+voffset[1]*height/100/2);

					memDC->TextOut(delX+tima.x-
					memDC->GetTextExtent(zahl, strlen(zahl)).cx/2,
				 	delY+von.y+voffset[1]*height/100.0/MIN_FONT,
					zahl, strlen(zahl));

				}
				do_tima(0, which_x)=do_tima(0, which_x)+ xcontent[3];

			}
	//	string m+0.001*x
			if ( str_visible && xtickmarks )
			{	axis_string=axisstring(this, 1);
					memDC->TextOut(delX+width/2 -
					memDC->GetTextExtent(axis_string, strlen(axis_string)).cx/2,
							  //		delY+von.y+voffset[1]*height*9.5/1000,
									delY+height-voffset[1]*height*0.4/100-1,
                          		axis_string, strlen(axis_string));
				  delete axis_string;
			}

			do_tima.fill(0.0);
			do_tima(0, which_y)=y_origin;

	  //		cout<<"hoffset="<<hoffset[0]*width/100<<endl;
         str_visible=left_frame_visible();
         if (str_visible && fonty!=NULL)
					memDC->SelectObject(*fonty);

     		while( ! (do_tima(0, which_y)>do_bis(0, which_y) ) && ytickmarks )
			{	tima=GetImage(do_tima);
				memDC->MoveTo(delX+von.x-hoffset[0]*width/100/MIN_FONT, delY+tima.y);
				memDC->LineTo(delX+von.x, delY+tima.y);


				memDC->MoveTo(delX+bis.x, delY+tima.y);
				memDC->LineTo(delX+bis.x+hoffset[1]*width/100/MIN_FONT, delY+tima.y);

				tm=(do_tima(0,which_y)-ycontent[5])/
				ycontent[6];

				if (str_visible)
				{	sprintf(zahl, AXIS_FORMAT, tm);
					prepare_string(zahl);
		 //			fprintf(ps_file,
		 //			"(%s) %d %d XplRotShow\n", zahl,
		 //			von.x-hoffset[0]*width*2/100/10,
		 //			tima.y);
					memDC->TextOut(delX + hoffset[0]*width/100/2,
		 delY + tima.y+memDC->GetTextExtent(zahl, strlen(zahl)).cx/2,
										zahl, strlen(zahl));
				}
				//	30=10+40/2!!
				do_tima(0, which_y)=do_tima(0, which_y)+
				ycontent[3];

			}
	//	string m+0.001*y

			if ( str_visible && ytickmarks )
			{	axis_string=axisstring(this, 2);
    			memDC->TextOut(delX + 2,  // PC 000925 - offset increased by 1
            //hoffset[0]*(width/100)/MIN_FONT,
			delY + height/2+
			memDC->GetTextExtent(axis_string, strlen(axis_string)).cx/2,
								axis_string, strlen(axis_string));
				delete axis_string;
			}
         if (fontx!=NULL)
         	delete fontx;
        if (fonty!=NULL)
         	delete fonty;
		//	kein AXIS_STRING_OFFSET+ noetig!
		} else {
			TFont font(GetWinFontName(), 10, 5, 0);       // PC 20010702 - changed name of the font
			memDC->SelectObject(font);
			do_von=GetRotationPoint();
			von=GetImage(do_von);
			if (von.x>0 && von.x<width && von.y>0 && von.y<height)
			for (i=0; i<dim; i++)
			{  ax_da=GetAchse(1);	// NUR!
				xcontent=ax_da.GetContent();
				timm=GetRotationPoint();
				timm.fill(0.0);
				secsk=GetFirstSkalierung();
				timm(0, i)=xcontent[3]*secsk(0,0)/secsk(i,i);

				do_bis=do_von+timm;
				do_tima=do_bis+timm*0.2;

				bis=GetImage(do_bis);
				memDC->MoveTo(delX+von.x,delY+von.y);
				memDC->LineTo(bis.x + delX, delY+bis.y);

				tima=GetImage(do_tima);
					sprintf(zahl, "%d", i+1);
		 //			memDC->TextOut(delX+tima.x*3/4, delY+tima.y*3/4,
		 //						 zahl, strlen(zahl));
					memDC->TextOut(delX+tima.x, delY+tima.y,
								 zahl, strlen(zahl));
			}
		}

}



       /*
         if (head_on)
         	cout<<"head_on"<<endl;
         else
         cout<<"head_out"<<endl;
         if (voffset[0]*height/2/100>MIN_FONT)
         	cout<<"genuegt"<<endl;
         else
         cout<<"nich genuegt"<<endl;
      */
			if (head_on && voffset[0]*height/2/100>MIN_FONT)
			{  int wf=voffset[0]*height/2/100;
            wf=voffset[0]*height/2/100;
				TFont font(GetWinFontName(), wf, wf*prop, 0); //font for headline - PC 20010702 - changed font name
				memDC->SelectObject(font);
				int textw, texth;

				textw=memDC->GetTextExtent(head_line, strlen(head_line)).cx;
				texth=memDC->GetTextExtent(head_line, strlen(head_line)).cy;
				memDC->TextOut(
					delX+width/2-textw/2,
					delY + (int)((double)voffset[0]*height/200+0.5)-texth/2,
									  head_line, strlen(head_line));
				}

	dim=GetDimension();
	rotpoint=GetRotationCosinus();

	for (i=0; i<dim; i++)
		for (j=0; j<dim; j++)
		{	if (! (rotpoint(i,j)==0 || rotpoint(i,j)==1) )
				break;
			if ( rotpoint(i,j)==1 &&  j==0)
				which_x=i;
			if ( rotpoint(i,j)==1 &&  j==1)
				which_y=i;
		}
	if (i==dim && j==dim)
		rotated=(1==0);
	else
		rotated=(0==0);

	if (axis_on && !rotated)		//clear frame!
	{	topo=height-(int)(voffset[1]*height/100.0+0.5);
		bottomo=(int)(voffset[0]*height/100.0+0.5);
		lefto=(int)(hoffset[0]*width/100.0+0.5); // PC 20010215 - left ~ hoffset[0]
		righto=width-(int)(hoffset[1]*width/100.0+0.5); // PC 20010215 - right ~ hoffset[1]
	}
	else
	{	topo=height-1;
		bottomo=0;	// PC 001122 - 1;
		lefto=0;	// PC 001122 - 1;
		righto=width-1;
	}

	TRect trecpoints(delX+lefto, delY+bottomo, delX+righto, delY+topo);
	memDC->IntersectClipRect(trecpoints);

	 TColor white(255, 255, 255);
    memDC->SetBkMode(OPAQUE);

	//SWS memDC->SetBkColor(white);

	MyPoint *points=GetPointKoord();
	Lines_Outfit fi;
	int k, p_co, count;
	MyPoint *my_p=points;
	int gemalt, homogen, homo_color, poli_count, color, line_num;
	Outfit homo_outfit;
	int homo_size;

	XplColor *col_num;

	for (j=0; j<vis_data.laenge(); j++)
	{	p_co=vis_data[j]->GetPointCount();
		gemalt=0;
      while (gemalt < p_co)
		{	homo_color=vis_data[j]->GetPointColor(gemalt+1);
		  //	cout<<"homo_outfit="<<homo_outfit<<endl;
			if (homo_color>-1 && homo_color<all_colors.laenge())
			{	col_num=all_colors[homo_color];
				red=col_num->red/(float)(256);
				green=col_num->green/(float)(256);
				blue=col_num->blue/(float)(256);
            //cout<<red<<", "<<blue<<", "<<green<<endl;
			}
			else
			//	z.b. bei PSGEN
				red=green=blue=0.0;
 			TPen pen(TColor(red, green, blue), 1);
			memDC->SelectObject(pen);
         TBrush fb(TColor(red, green, blue));

         while (	gemalt < p_co &&
		vis_data[j]->GetPointColor(gemalt+1)==homo_color  )

		   {	homo_outfit=vis_data[j]->GetPointLayout(gemalt+1);
        		if (homo_outfit<2)
         		homo_size=1;
         	else
         	{	homo_size=all_symbols[homo_outfit-2]->size;
               homo_outfit=all_symbols[homo_outfit-2]->symbol;
         	}
            int homo_halb=(int)((homo_size+1)/2);
            TPoint *tpi;

			 /*	switch(homo_outfit)
				{	case NOPOINT:
					break;

           case POINT1:

			cout<<"point1"<<endl;

				break;

            case RECTANGLE:

            	cout<<"point2"<<endl;
            break;

				case CIRCLE:

                	cout<<"point3"<<endl;
            break;
            case TRIANGLE:


                 	cout<<"point4"<<endl;
           	break;

				case XSYM:
                    	cout<<"point5"<<endl;
            break;

				case RHOMBUS:
                  	cout<<"point6"<<endl;
               break;

				case FLD_RECTANGLE:
                    	cout<<"point7"<<endl;
               break;

				case FLD_CIRCLE:
                   	cout<<"point8"<<endl;
               break;

				case FLD_ROMB:
                    	cout<<"point9"<<endl;
               break;

				case FLD_TRIANGLE:
                     	cout<<"point10"<<endl;
               break;

				case CROSS:
                    	cout<<"point11"<<endl;
               break;

				case GRID:
                    	cout<<"point12"<<endl;
               break;

				case GRID_RHOMBUS:
            	cout<<"grid_modus"<<endl;

            break;

            default:
					cout<<"sonst was"<<endl;
				break;
				}
 				*/
            switch(homo_outfit)
				{	case NOPOINT:
					break;

           case POINT1:

					memDC->Ellipse(delX+points->x-1,
										delY+points->y-1,
										delX+points->x+1,
										delY+points->y+1);

				break;

            case RECTANGLE:

					memDC->Rectangle(delX+points->x-homo_halb,
										delY+points->y-homo_halb,
										delX+points->x+homo_size/2,
										delY+points->y+homo_halb);
            break;

				case CIRCLE:

					memDC->Ellipse(delX+points->x-homo_halb,
										delY+points->y-homo_halb,
										delX+points->x+homo_halb,
										delY+points->y+homo_halb);
            break;
            case TRIANGLE:

                 tpi=new TPoint [4];
               	 TPoint  *curr;
                   curr=new TPoint(delX+points->x-homo_halb,
						 						delY+points->y-homo_halb);
               	 tpi[0]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x,
                                     delY+points->y+homo_halb);
                   tpi[1]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x+homo_halb,
                                     delY+points->y-homo_halb);
                   tpi[2]=(*curr);
                   delete curr;

                   tpi[3]=tpi[0];


                   memDC->Polygon(tpi, 4);

           	break;

				case XSYM:
                   memDC->MoveTo(delX+points->x,delY+points->y);
                   memDC->LineTo(delX+points->x-(homo_halb),
                                   delY+points->y-(homo_halb));
                   memDC->MoveTo(delX+points->x,delY+points->y);
                   memDC->LineTo(delX+points->x+(homo_halb),
                                  delY+points->y+(homo_halb));
                   memDC->MoveTo(delX+points->x,delY+points->y);
                   memDC->LineTo(delX+points->x-(homo_halb),
                                   delY+points->y+(homo_halb));
                   memDC->MoveTo(delX+points->x,delY+points->y);
                   memDC->LineTo(delX+points->x+(homo_halb),
                                  delY+points->y-(homo_halb));

                           break;

				case RHOMBUS:

                 tpi=new TPoint [5];

                   curr=new TPoint(delX+points->x,
						 						delY+points->y-homo_halb);
               	 tpi[0]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x-homo_halb,
                                     delY+points->y);
                   tpi[1]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x,
                                     delY+points->y+homo_halb);
                   tpi[2]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x+homo_halb,
                                     delY+points->y);
                   tpi[3]=(*curr);
                   delete curr;

                   tpi[4]=tpi[0];

                   /*memDC->SelectObject(fb);*/
                   memDC->Polygon(tpi, 5);
                   /*memDC->RestoreBrush();*/

               break;

				case FLD_RECTANGLE:
                	memDC->FillRect(delX+points->x-homo_halb,
										delY+points->y-homo_halb,
										delX+points->x+homo_halb,
										delY+points->y+homo_halb,
                              fb);
               break;

				case FLD_CIRCLE:
                  memDC->SelectObject(fb);
                 	memDC->Ellipse(delX+points->x-homo_halb,
										delY+points->y-homo_halb,
										delX+points->x+homo_halb,
										delY+points->y+homo_halb);
                   memDC->RestoreBrush();
               break;

				case FLD_ROMB:
                    tpi=new TPoint [5];

                   curr=new TPoint(delX+points->x,
						 						delY+points->y-homo_halb);
               	 tpi[0]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x-homo_halb,
                                     delY+points->y);
                   tpi[1]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x,
                                     delY+points->y+homo_halb);
                   tpi[2]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x+homo_halb,
                                     delY+points->y);
                   tpi[3]=(*curr);
                   delete curr;

                   tpi[4]=tpi[0];

                   memDC->SelectObject(fb);
                   memDC->Polygon(tpi, 5);
                   memDC->RestoreBrush();
               break;

				case FLD_TRIANGLE:
                    tpi=new TPoint [4];

                   curr=new TPoint(delX+points->x-homo_halb,
						 						delY+points->y-homo_halb);
               	 tpi[0]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x,
                                     delY+points->y+homo_halb);
                   tpi[1]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x+homo_halb,
                                     delY+points->y-homo_halb);
                   tpi[2]=(*curr);
                   delete curr;

                   tpi[3]=tpi[0];

                   memDC->SelectObject(fb);
                   memDC->Polygon(tpi, 4);
                   memDC->RestoreBrush();
               break;

				case CROSS:
                  memDC->MoveTo(delX+points->x,
                                   delY+points->y);
                  memDC->LineTo(delX+points->x,
                                   delY+points->y+homo_halb);
                  memDC->MoveTo(delX+points->x,
                                   delY+points->y);
                  memDC->LineTo(delX+points->x+homo_halb,
                                   delY+points->y);
                  memDC->MoveTo(delX+points->x,
                                   delY+points->y);
                  memDC->LineTo(delX+points->x,
                                   delY+points->y-homo_halb);
                  memDC->MoveTo(delX+points->x,
                                   delY+points->y);
                  memDC->LineTo(delX+points->x-homo_halb,
                                   delY+points->y);




               break;
           case STAR:
                  memDC->MoveTo(delX+points->x,
                                   delY+points->y);
                  memDC->LineTo(delX+points->x,
                                   delY+points->y+homo_halb);
                  memDC->MoveTo(delX+points->x,
                                   delY+points->y);
                  memDC->LineTo(delX+points->x+homo_halb,
                                   delY+points->y);
                  memDC->MoveTo(delX+points->x,
                                   delY+points->y);
                  memDC->LineTo(delX+points->x,
                                   delY+points->y-homo_halb);
                  memDC->MoveTo(delX+points->x,
                                   delY+points->y);
                  memDC->LineTo(delX+points->x-homo_halb,
                                   delY+points->y);


                   memDC->MoveTo(delX+points->x,delY+points->y);
                   memDC->LineTo(delX+points->x-(homo_halb-1),
                                   delY+points->y-(homo_halb-1));
                   memDC->MoveTo(delX+points->x,delY+points->y);
                   memDC->LineTo(delX+points->x+(homo_halb-1),
                                  delY+points->y+(homo_halb-1));
                   memDC->MoveTo(delX+points->x,delY+points->y);
                   memDC->LineTo(delX+points->x-(homo_halb-1),
                                   delY+points->y+(homo_halb-1));
                   memDC->MoveTo(delX+points->x,delY+points->y);
                   memDC->LineTo(delX+points->x+(homo_halb-1),
                                  delY+points->y-(homo_halb-1));


               break;


				case GRID:
                  	memDC->Rectangle(delX+points->x-homo_halb,
										delY+points->y-homo_halb,
										delX+points->x+homo_halb,
										delY+points->y+homo_halb);
                     memDC->Rectangle(delX+points->x-homo_halb+1,
										delY+points->y-homo_halb+1,
										delX+points->x+homo_halb-1,
										delY+points->y+homo_halb-1);
                      memDC->MoveTo(delX+points->x,
                                   delY+points->y-homo_halb);
                      memDC->LineTo(delX+points->x,
                                   delY+points->y+homo_halb);
                      memDC->MoveTo(delX+points->x-homo_halb,
                                   delY+points->y);
                      memDC->LineTo(delX+points->x+homo_halb,
                                   delY+points->y);

               break;

				case GRID_RHOMBUS:
                    tpi=new TPoint [5];

                   curr=new TPoint(delX+points->x,
						 						delY+points->y-homo_halb);
               	 tpi[0]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x-homo_halb,
                                     delY+points->y);
                   tpi[1]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x,
                                     delY+points->y+homo_halb);
                   tpi[2]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x+homo_halb,
                                     delY+points->y);
                   tpi[3]=(*curr);
                   delete curr;

                   tpi[4]=tpi[0];


                   memDC->Polygon(tpi, 5);

                      tpi=new TPoint [5];

                   curr=new TPoint(delX+points->x,
						 						delY+points->y-homo_halb+1);
               	 tpi[0]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x-homo_halb+1,
                                     delY+points->y);
                   tpi[1]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x,
                                     delY+points->y+homo_halb-1);
                   tpi[2]=(*curr);
                   delete curr;
                   curr=new TPoint (delX+points->x+homo_halb-1,
                                     delY+points->y);
                   tpi[3]=(*curr);
                   delete curr;

                   tpi[4]=tpi[0];


                   memDC->Polygon(tpi, 5);

                  memDC->MoveTo(delX+points->x,
                                   delY+points->y-homo_halb);
                  memDC->LineTo(delX+points->x,
                                   delY+points->y+homo_halb);
                  memDC->MoveTo(delX+points->x-homo_halb,
                                   delY+points->y);
                  memDC->LineTo(delX+points->x+homo_halb,
                                   delY+points->y);

            break;

            default:
					memDC->Ellipse(delX+points->x-homo_halb,
										delY+points->y-homo_halb,
										delX+points->x+homo_halb,
										delY+points->y+homo_halb);
				break;
				}
      	points++;
      	gemalt++;
         }
		}
	}

    memDC->SetBkColor(white);

	int a, b;
	for (j=0; j<vis_data.laenge(); j++)
	{	poli_count=vis_data[j]->GetPolygonCount();
#ifdef _BLABLA_
	cout<<"Data "<<j<<" hat "<<poli_count<<" Polygons"<<endl;
#endif
		for (i=0; i<poli_count; i++)
		{ 	count=vis_data[j]->GetPolygonSize(i+1);
			points=GetPointsToPolygon(j+1, i+1);
			color=vis_data[j]->GetPolygonColor(i+1);
			fi=vis_data[j]->GetPolygonLayout(i+1);
			if (fi!=NOLINE  )
			{	col_num=all_colors[color];
				red=col_num->red/(float)(256);
				green=col_num->green/(float)(256);
				blue=col_num->blue/(float)(256);

/*				sprintf(line, "%1.3f %1.3f %1.3f setrgbcolor",
				red, green, blue);
				fprintf(ps_file, "%s \n", line);
*/

//		The style parameter can be one of the following values:
//		PS_SOLID, PS_DASH, PS_DOT, PS_DASHDOT, PS_DASHDOTDOT, PS_NULL,
//   or PS_INSIDEFRAME
//  	TPen(TColor color, int width=1, int style=PS_SOLID);

				a=ADashOfPolygon(fi);
            b=BDashOfPolygon(fi);
            int c=vis_data[j]->GetPolygonThick(i+1);
      //      cout<<a<<" und "<<b<<" und c="<<c<<endl;
            int dashi=PS_SOLID;
            if (fi!=SOLID)
            {
	            if (a<=15)
            		dashi=PS_DASHDOT;
            	else
            		dashi=PS_DASHDOTDOT;
	            if (a<=10)
            		dashi=PS_DASH;
               if (a<=5)
               	dashi=PS_DOT;
            }

            if (fi==SOLID)
            	dashi=PS_SOLID;
            else
            	c=1;

            TPen pen(TColor(red, green, blue),
           // 		vis_data[j]->GetPolygonThick(i+1), dashi);
				c, dashi);
            	memDC->SelectObject(pen);
            			memDC->SelectObject(pen);
		//		fprintf(ps_file, "[%d %d] 0 setdash\n", a, b);
				//} PC 20010129
				//?????? Levon
				//fprintf(ps_file, "%d %d moveto\n",
				//(points)->x, (points)->y);

				memDC->MoveTo(delX+points->x, delY+points->y);
				for (line_num=1; line_num<count; line_num++)
				{	if (line_num%100==0)
						memDC->LineTo(delX + (points+line_num)->x, delY+(points+line_num)->y);
					if (!((points+line_num)->x==(points+line_num-1)->x
						&&
						(points+line_num)->y==(points+line_num-1)->y))

						memDC->LineTo(delX + (points+line_num)->x, delY+(points+line_num)->y);
				}
//				if (vis_data[j]->GetPolygonThick(i+1)!=CONVEX)
//					fprintf(ps_file, "stroke\n");
//				else
//					fprintf(ps_file, "fill\n");
			}// PC 20010129
			delete points;
		}
	}

	char *labsi;
	Liste <XplLabel> labs;
	int which_current;
	int which=LAB_FONT;

  	points=my_p;
	int last_color;
   uint lastalign = memDC->GetTextAlign();

	for (j=0; j<GetDataCount(); j++)
	if (SomeLabels(j+1))
	{	TFont font(GetWinFontName(),  which, 0); //font for labels - PC 20010702 - changed font name
		memDC->SelectObject(font);
		p_co=GetPointCount(j+1);
		labs=GetLabels(j+1);
		last_color=-1;	// PC 20020128 - changed to -1 so that it cannot be equal to any color first
		for (i=0; i<p_co; i++,points++)
		{	labsi=labs[i].GetText();
			if (labs[i].color!=last_color)
			{
			TColor lc(all_colors[labs[i].color]->red/(float)(256),
									all_colors[labs[i].color]->green/(float)(256),
									all_colors[labs[i].color]->blue/(float)(256) );
			memDC->SetTextColor(lc);
         last_color = labs[i].color;	// PC 20020128 - added missing assignment
			}
			which_current=labs[i].size;
			if (!(which==which_current) && labs[i].direction!=-1)
			{		TFont font1(GetWinFontName(),  which_current, 0); //font for labels
          		memDC->SelectObject(font1);
			}

      // PC : old version of setmaskt
		/* zdes uj ty sam kak-nibud'...
			labs[i].direction oznachajet naprawlenije:
			0: pr'amo na tochke;
			3: sprawa;
			6: wnizu;
			9: slea;
			12: nad;
			-1 - poka ignoriruj, eto TAJNA.
			dal'she:

			if (labs[i].direction!=-1)
				memDC->TextOut(delX + points->x,
										delY + points->y, labsi, strlen(labsi));
      */

      // PC 20010212 : new setmaskt
			if (labs[i].direction!=-1)
         {
            uint localalign = lastalign;

            localalign &= ~(TA_LEFT | TA_RIGHT | TA_CENTER | TA_TOP | TA_BOTTOM | TA_BASELINE | TA_UPDATECP);
            localalign |= TA_NOUPDATECP;

            // set align
				switch(labs[i].direction)
				{
					case 0: localalign |= TA_CENTER | TA_BASELINE;
					break;

					case 3: localalign |= TA_LEFT | TA_BASELINE;
					break;

					case 6: localalign |= TA_CENTER | TA_TOP;
					break;

					case 9: localalign |= TA_RIGHT | TA_BASELINE;
					break;

					case 12: localalign |= TA_CENTER | TA_BOTTOM;
					break;

            	default: localalign = lastalign;
            	break;
            }
            localalign = memDC->SetTextAlign(localalign);

            // text out
            (void) memDC->SetBkMode(TRANSPARENT);
				memDC->TextOut(delX + points->x, delY + points->y, labsi, strlen(labsi));
//            ExtTextOut(int x, int y, uint16 options, const TRect* r, const char far* string, int count, const int far* dx = 0);
         }

			/* Unix version of print
				switch(labs[i].direction)
				{	case -1:
				break;
				
				case 0:
				newline=line;
				if (lines_count>1)
				for (ijk=0; ijk<lines_count; ijk++)
				{	sprintf(oneline, "%s", newline);
					ii=0;
					while (oneline[ii]!='\n' &&
						ii<strlen(oneline))
						ii++;
					oneline[ii]='\0';
					XDrawString(dis, wid_data->pixy,
						wid_data->bitmap_gc,
					mp->x-te_wi/2,
					mp->y+te_he/2*(1-lines_count+2*ijk),
					oneline,
					strlen( oneline));
					newline+=strlen(oneline);
					newline++;
				}
				else
				XDrawString(dis, wid_data->pixy, wid_data->bitmap_gc,
				mp->x-te_wi/2,
				mp->y+te_he/2,
				labsi,
				strlen( labsi));
				break;

				case 3:
				XDrawString(dis, wid_data->pixy, wid_data->bitmap_gc, 
				mp->x+te_he/2, 
				mp->y+te_he/2,
				labsi,
				strlen( labsi));
				break;

				case 6:
				XDrawString(dis, wid_data->pixy, wid_data->bitmap_gc,
				mp->x-te_wi/2,
				mp->y+3*te_he/2,
				labsi,
				strlen( labsi));
				break;

				case 9:
				XDrawString(dis, wid_data->pixy, wid_data->bitmap_gc,
				mp->x-te_wi-te_he/2,
				mp->y+te_he/2,
				labsi,
				strlen( labsi));
				break;

				case 12:
				XDrawString(dis, wid_data->pixy, wid_data->bitmap_gc,
				mp->x-te_wi/2,
				mp->y-te_he/2,
				labsi,
				strlen( labsi));
				break;

			*/
			delete labsi;

		}
	}
	else
		points+=GetPointCount(j+1);

   // restore TextAlign in DC
   memDC->SetTextAlign(lastalign);

#else //LTEST


#endif //LTEST
memDC->RestoreDC();
if (newdc)
	delete memDC;
return(0);
}

void WPlot::RotateUp() {
			int dim;
			XplMatrix RC(GetRotationCosinus());
			dim=RC.rows();	// oder 1, ist egal
			double pi=3.14156;
			double angle=2*pi/MAL;
			double cosi=cos(angle);
			double sini=sin(angle);

			XplMatrix NRC(dim, dim);
			NRC.fill(0.0);
			for (int i=0; i<dim; i++)
				NRC(i,i)=1.0;


			NRC(1,1)=cos(angle);
			NRC(2,2)=cos(angle);
			NRC(1,2)=-sin(angle);
			NRC(2,1)=+sin(angle);
			NRC(0,0)=1.0;


			RC=RC*(NRC);
			MakeBackup();
			SetTransformation(NULL, NULL, &RC, NULL, NULL),
			Refresh();

}

void WPlot::RotateDown() {
			int dim;
			XplMatrix RC(GetRotationCosinus());
			dim=RC.rows();	// oder 1, ist egal
			double pi=3.14156;
			double angle=2*pi/MAL;
			double cosi=cos(angle);
			double sini=sin(angle);

			XplMatrix NRC(dim, dim);
			NRC.fill(0.0);
			for (int i=0; i<dim; i++)
				NRC(i,i)=1.0;

			NRC(1,1)=cos(angle);
			NRC(2,2)=cos(angle);
			NRC(1,2)=sin(angle);
			NRC(2,1)=-sin(angle);
			NRC(0,0)=1.0;

			RC=RC*(NRC);
			MakeBackup();
			SetTransformation(NULL, NULL, &RC, NULL, NULL),
			Refresh();


}

void WPlot::RotateLeft() {
			int dim;
			XplMatrix RC(GetRotationCosinus());
			dim=RC.rows();	// oder 1, ist egal
			double pi=3.14156;
			double angle=2*pi/MAL;
			double cosi=cos(angle);
			double sini=sin(angle);

			XplMatrix NRC(dim, dim);
			NRC.fill(0.0);
			for (int i=0; i<dim; i++)
				NRC(i,i)=1.0;

			NRC(0,0)=cos(angle);
			NRC(2,2)=cos(angle);
			NRC(0,2)=-sin(angle);
			NRC(2,0)=sin(angle);
			NRC(1,1)=1.0;

			RC=RC*(NRC);
			MakeBackup();
			SetTransformation(NULL, NULL, &RC, NULL, NULL),
			Refresh();

}

void WPlot::RotateRight() {
			int dim;
			XplMatrix RC(GetRotationCosinus());
			dim=RC.rows();	// oder 1, ist egal
			double pi=3.14156;
			double angle=2*pi/MAL;
			double cosi=cos(angle);
			double sini=sin(angle);

			XplMatrix NRC(dim, dim);
			NRC.fill(0.0);
			for (int i=0; i<dim; i++)
				NRC(i,i)=1.0;

			NRC(0,0)=cos(angle);
			NRC(2,2)=cos(angle);
			NRC(0,2)=sin(angle);
			NRC(2,0)=-sin(angle);
			NRC(1,1)=1.0;

			RC=RC*(NRC);
			MakeBackup();
			SetTransformation(NULL, NULL, &RC, NULL, NULL),
			Refresh();

}

WText::WText(const char *ct, XplDisplay* dixi,
			const int di_x, const di_y):
			VisText(ct, dixi, di_x, di_y)
{
	char *brumbrum;
	brumbrum=strdup(ct);
	type=WTEXT;

	Wdixi = (WDisplay *)(dixi);

	char na[32];
	sprintf(na, "utext");
   int len = 8*strlen(ct);
  	//TWindowDC  *memDC=Wdixi->dc;

 	Refresh();

}

WText::~WText()
{
}

void WText::Refresh(TDC *memDC) const{
   bool newdc=False;
   if (memDC==NULL)
   {   memDC= new TWindowDC(((TWindow *)Wdixi)->HWindow);
       newdc=True;
   }
   memDC->SaveDC();
   //return;
   char *te=VisTextGetText();

   int delX=Wdixi->GetWidth()*Wdixi->GetElementLeftPosition(di_x,di_y)/100;
   int delY=Wdixi->GetHeight()*Wdixi->GetElementTopPosition(di_x,di_y)/100;
//   cout<<"delX="<<delX<<" delY="<<delY<<"\n";
	TRect trec(delX, delY, delX+width, delY+height);

   memDC->IntersectClipRect( trec);

//	memDC->PatBlt(delX+3, delY+3, width + delX -3, height + delY - 3, WHITENESS);
 	memDC->PatBlt(delX, delY, width + delX, height + delY, WHITENESS);
	// PAint the frame
	TPen pen(TColor(0,0,0), 1);
	memDC->SelectObject(pen);

  /* 	memDC->MoveTo(delX + 1,delY + 1);
	memDC->LineTo(width + delX - 1, delY + 1);
	memDC->LineTo(width + delX - 1, height + delY - 1);
	memDC->LineTo(delX + 1, height + delY - 1);
	memDC->LineTo(delX + 1,delY + 1);
 */
  	memDC->MoveTo(delX ,delY );
	memDC->LineTo(width + delX-1 , delY );
	memDC->LineTo(width + delX-1 , height + delY-1 );
	memDC->LineTo(delX , height + delY-1 );
	memDC->LineTo(delX ,delY );

   	memDC->RestoreBrush();

	memDC->SetBkColor(TColor(255,255,255)); // have to be changed
 //	TFont font("Times Roman", 15, 10, 0, 0); //fon
	TFont font(XMSG_TEXT_FONT_NAME_STR, 15, 10, 0, 0); //font for text
		memDC->SelectObject(font);

	char *brumbrum=strdup(te);
   char *tok;
	int len, delta = -10;

	tok = strtok(brumbrum, "\n");
	do {
		len = 10*strlen(tok);
 //		memDC->TextOut(delX+width/2 - len/2, delY+height/2 + delta,
 //  				tok, strlen(tok));
			memDC->TextOut(delX+10, delY+ 20 + delta,
					tok, strlen(tok));
			delta += 16;  //(15+1)              //SWS
			tok = strtok(NULL, "\n");
	} while (tok);

	delete brumbrum;
	delete te;
   memDC->RestoreDC();
   if (newdc)
   	delete memDC;
}

void WText::VisTextSetText(const char *te)
{	VisText::VisTextSetText(te);
  Refresh();
}

char * WText::VisTextGetSelectedText()const
{	return(NULL);
}

// PC 20010702
const char *WPlot::GetWinFontName(void) 
{
     if (desc_font_type == FT_MONOSPACE)
          return XMSG_DISP_FONT_MONOSPACE_STR;
     else if (desc_font_type == FT_SANSSERIF)
          return XMSG_DISP_FONT_SANSSERIF_STR;
     else return XMSG_DISP_FONT_SERIF_STR;
}

