#include <math.h>
#include "xnan.h"
#include "x4math2.h"


#ifdef __GNUC__
  double dnan = 0.0/0.0, dinf = 1.0/0.0;
#endif

/**** Visual C++  */
#ifdef _MSC_VER
  #include <ymath.h>
  double dnan = _Nan._D, dinf = _Inf._D;
#endif

/**** Borland C++  */
#ifdef __BORLANDC__ 
  double dnan = 0.0/0.0, dinf = 1.0/0.0;
#endif

#ifdef __SC__
  #include <fp.h>
  double dnan = NAN, dinf = INFINITY;
#endif

/**** If none applies then set some defaults values */
/**** not done yet                                  */ 

/* #ifndef NaN
#define NaN 0.0/0.0
#endif */


double x4exp(double x) {
  if (XisNaN(x)) return(x);
  if (XisNegInf(x)) return(0);
  if (XisPosInf(x)) return(x);
  return(exp(x));
}

double x4expm1(double x) {
  //  if (XisNaN(x)) return(x);
  if (XisNegInf(x)) return(-1);
  if (XisPosInf(x)) return(x);
  return((x4exp(x)-1));
}

double x4tanh(double x) {
  if (XisNaN(x)) return(x);
  if (XisPosInf(x)) return(1);
  if (XisNegInf(x)) return(-1);
  return(tanh(x));
}

double x4cosh(double x) {
  if (XisNaN(x)) return(x);
  if (XisInf(x)) return(dinf);
  return(cosh(x));
}

double x4asin(double x) {
  if (x<-1 || x>1) return (dnan);
  if (XisInf(x)) return (dnan);
  return(asin(x));
}

double x4log(double x) {
  if (x<0) return (dnan);
  if (XisNegInf(x)) return(dnan);
  return (log(x));
}

double x4log10(double x) {
  if (x<0) return (dnan);
  if (XisNegInf(x)) return(dnan);
  return (log10(x));
}
//double x4asinh(double x) {
//  if (x
