/* $Header: /home/xplore/cvs/xpl4gr/xchar.C,v 1.3 2002/08/16 12:31:54 sigbert Exp $ */

#include "xchar.hpp"
#include "x4math2.h"

int seq  (const xplstring l, const xplstring r)  
{ char const *lp, *rp;
  long len, i;
  int sl;
  lp = l.tocstr();
  rp = r.tocstr();
  sl = strlen(lp) > strlen(rp);
  len = (sl ? strlen(lp) : strlen(rp));
  if (sl) return 0;
  for (i=0; i<len; i++)
    if (lp[i]!=rp[i]) return 0;
  return 1;
}
  
int sleq (const xplstring l, const xplstring r)  
{ char const *lp, *rp;
  long len, i;
  int sl;
  lp = l.tocstr();
  rp = r.tocstr();
  sl = (strlen(lp) > strlen(rp));
  len = (sl ? strlen(lp) : strlen(rp));
  for (i=0; i<len; i++)
  { if (lp[i]>rp[i]) return 0;
    if (lp[i]<rp[i]) return 1;
  }
  if (strlen(lp)==strlen(rp)) return 1;
  return (sl ? 0 : 1);
}

int sneq (const xplstring l, const xplstring r)
{ char const *lp, *rp;
  long len, i;
  int sl;
  lp = l.tocstr();
  rp = r.tocstr();
  sl = (strlen(lp) > strlen(rp));
  len = (sl ? strlen(lp) : strlen(rp));
  if (sl) return 1;
  for (i=0; i<len; i++)
    if (lp[i]!=rp[i]) return 1;
  return 0;
}

int sgeq (const xplstring l, const xplstring r)  
{ char const *lp, *rp;
  long len, i;
  int sl;
  lp = l.tocstr();
  rp = r.tocstr();
  sl = (strlen(lp) > strlen(rp));
  len = (sl ? strlen(lp) : strlen(rp));
  for (i=0; i<len; i++)
  { if (lp[i]>rp[i]) return 1;
    if (lp[i]<rp[i]) return 0;
  }
  if (strlen(lp)==strlen(rp)) return 1;
  return (sl ? 1 : 0);
}

int sle (const xplstring l, const xplstring r)  
{ char const *lp, *rp;
  long len, i;
  int sl;
  lp = l.tocstr();
  rp = r.tocstr();
  sl = (strlen(lp) > strlen(rp));
  len = (sl ? strlen(lp) : strlen(rp));
  for (i=0; i<len; i++)
  { if (lp[i]>rp[i]) return 0;
    if (lp[i]<rp[i]) return 1;
  }
  return (sl ? 0 : 1);
}

int sge  (const xplstring l, const xplstring r)  
{ char const *lp, *rp;
  long len, i;
  int sl;
  lp = l.tocstr();
  rp = r.tocstr();
  sl = (strlen(lp) > strlen(rp));
  len = (sl ? strlen(lp) : strlen(rp));
  for (i=0; i<len; i++)
  { if (lp[i]>rp[i]) return 1;
    if (lp[i]<rp[i]) return 0;
  }
  return (sl ? 1 : 0);
}

xplstring ssubstr(const xplstring &str, long l, long r)
{ xplstring ret;
  char *newstr, *insstr;
  long t;

  
  if (l>r) 
  { XAerrort (STRINGBAD, "substr : l>r");
    return(ret);
  }
  if (l<0)
  { XAerrort (STRINGBAD, "substr : l<1");
    return (ret);
  }
  newstr = str.tostr();
  if (strlen(newstr)<l)
  { XAerrort (STRINGBAD, "substr : strlen(str)<l");
    return ret;
  }
  if (strlen(newstr)<r)
    t = strlen(newstr) - r;
  else
    t = r-l;
  insstr = &(newstr[l]);
  insstr[t] = 0;;
  ret = xplstring (insstr);
  delete newstr;
  return (ret);
}

xplstring sconcat(const xplstring &l, const xplstring &r)
{ return (l.xplstrcat(r)); }

  XplChar::XplChar (const XplIndex newdim) : XplArray<xplstring>(newdim) 
  { };

  XplChar::XplChar ()
  { ptr = NULL; }

  XplChar::XplChar (long d0, long d1, long d2, long d3, long d4, long d5, long d6, long d7) : XplArray<xplstring>(d0, d1, d2, d3, d4, d5, d6, d7) { };

  XplChar::~XplChar () 
  { long i, s;
    if (ptr)
    { s = size();
      for (i=0; i<s; i++)
        (*(ptr+i)).kill();
/*
#ifndef MEMDEBUG
      delete[] ptr;  //not necessary because ~XplArray<T> will be called ???
#else
      xmem.delptr (ptr);   
#endif
*/
    }
  }

  XplChar::XplChar (const XplArray<xplstring>& x) : XplArray<xplstring>(x) 
  {};

  XplChar::XplChar (const XplChar &x)
  { long i,s;
    dim = x.dim;
#ifndef MEMDEBUG 
    ptr = new xplstring[x.size()]; // malloc(x.size()*sizeof(T));
#else
    ptr = (xplstring *) xmem.newptr (sizeof(xplstring), x.size(), "XplChar", "XplChar", "ptr");
#endif
    ::memcopy (ptr, x.ptr, x.size()); //*sizeof(xplstring));
  }

  XplChar& XplChar::operator= (const XplChar &x)		
  { if (this != &x)
    { long i,s;
      if (ptr !=NULL)
      { s = size();
        for (i=0; i<s; i++)
          (*(ptr+i)).kill();
#ifndef MEMDEBUG
        delete[] ptr;
#else
        xmem.delptr (ptr);
#endif
      }
      dim = x.dim; 
#ifndef MEMDEBUG 
       ptr = new xplstring[x.size()]; // malloc(x.size()*sizeof(T));
#else
       ptr = (xplstring *) xmem.newptr (sizeof(xplstring), x.size(), "XplChar", "XplChar", "ptr");
#endif
      ::memcopy (ptr, x.ptr, x.size()); //*sizeof(xplstring));
    }
    return (*this);
  }  

  XplChar& XplChar::operator= (const XplArray<xplstring> &x)		
  { if (this != &x)
    { long i,s;
      if (ptr !=NULL)
      { s = size();
        for (i=0; i<s; i++)
          (*(ptr+i)).kill();
#ifndef MEMDEBUG
        delete[] ptr;
#else
        xmem.delptr (ptr);
#endif
      }
      dim = x.dim;
#ifndef MEMDEBUG 
       ptr = new xplstring[x.size()]; // malloc(x.size()*sizeof(T));
#else
       ptr = (xplstring *) xmem.newptr (sizeof(xplstring), x.size(), "XplChar", "operator=", "ptr");
#endif
      ::memcopy (ptr, &(x[0]), x.size()); //*sizeof(xplstring));
    }
    return (*this);
  }  

  XplArray<double> XplChar::strlen () const
  { XplArray<double> ret(dim);
    long i, s;
    char *str;
    s = size();
    for (i=0; i<s; i++)
    { str = (*(ptr+i)).tostr();
      ret[i] = ::strlen(str);
      delete str;
    }
    return ret;
  }

  XplArray<double> XplChar::atof () const
  { XplArray<double> ret(dim);
    long i, s;
    char *str;
    s = size();
    for (i=0; i<s; i++)
    { str = (*(ptr+i)).tostr();
      ret[i] = ::x4atof(str);
      delete str;
    }
    return ret;
  }
  XplArray<long> XplChar::atol () const
  { XplArray<long> ret(dim);
    long i, s;
    char *str;
    s = size();
    for (i=0; i<s; i++)
    { str = (*(ptr+i)).tostr();
      ret[i] = ::atoi(str);
      delete str;
    }
    return ret;
  }

  int XplChar::ReadASCIIXplArray (char const *datei)
  { FILE *f = NULL;

    xplstring *newptr;
    xplstring *tmpt;
    long actualsize = MAX_BLOCKSIZE, count, rows = 0, cols = 0, linecol, i, j, k, s;
    char *epl, line[MAX_LINE_LENGTH], *tok, l=0, *tmpc, errmsg[1024];

//    if (ReadXXplArray(datei)==1) return (1);

    f = opendatafile (datei, "r");
    if (f==NULL)
    { sprintf (errmsg, "Can not open data file : %s", datei);
      XAerrort (STRBAD, errmsg);
      return(0);
    }

#ifndef MEMDEBUG
    newptr = new xplstring[actualsize];
    epl    = new char[actualsize];
#else
    newptr = (xplstring *) xmem.newptr (sizeof(xplstring), actualsize, "XplChar", "ReadASCIIXplArray", "newptr");
    epl = (char *) xmem.newptr (sizeof(char), actualsize, "XplChar", "ReadASCIIXplArray", "epl");
#endif
    count = 0;
    while (fgets(line, MAX_LINE_LENGTH-1, f))
    { rows++;
      tok = ::strtok (line, " \t\n");
      linecol = 0;
      while (tok)
      { *(newptr+count) = xplstring(tok);
        *(epl+count) = l;   
        count++;
        linecol++;
        if (count==actualsize)
        { actualsize += MAX_BLOCKSIZE;
#ifndef MEMDEBUG
          tmpt = new xplstring[actualsize];
          tmpc = new char[actualsize];
#else
          tmpt = (xplstring *) xmem.newptr (sizeof(xplstring), actualsize, "XplChar", "ReadASCIIXplArray", "tmpt");
          tmpc = (char *) xmem.newptr (sizeof(char), actualsize, "XplChar", "ReadASCIIXplArray", "tmpc");
#endif
          memcpy (tmpt, newptr, actualsize*sizeof(xplstring));
          memcpy (tmpc, epl, actualsize*sizeof(char));
#ifndef MEMDEBUG
          delete[] newptr;
          delete[] epl;
#else
          xmem.delptr (newptr);
          xmem.delptr (epl);
#endif
          newptr = tmpt;
          epl    = tmpc;
        }
        tok = ::strtok (NULL, " \t\n");
      }
      if (linecol==0) 
        rows--;
      else
        l = 1-l;
      if (linecol>cols) cols = linecol;
    }
    fclose(f);
    dim = XplIndex (rows, cols);
    l = 0;
#ifndef MEMDEBUG
    delete[] ptr;
#else
    xmem.delptr (ptr);
#endif
    s = dim.prod();
#ifndef MEMDEBUG
    ptr = new xplstring[s];
#else
    ptr = (xplstring *) xmem.newptr (sizeof(xplstring), s, "XplChar", "ReadASCIIXplArray", "ptr");
#endif
    i = 0;
    j = 0;
    l = 0;
    for (k=0; k<count; k++)
    { if (*(epl+k)==l)
      { *(ptr+j*rows+i) = *(newptr+k);
        (newptr[k]).kill();
        j++;
      }
      else
      { while (j<cols)
        { *(ptr+count) = xplstring("");
          j++; 
        }
        i++;
        *(ptr+i) = *(newptr+k);
        (newptr[k]).kill();
        j = 1;
        l = 1-l;
      }  
    }
    for (k=count; k<s; k++)
      *(ptr+count) = xplstring("");
#ifndef MEMDEBUG
    delete[] newptr;
#else
    xmem.delptr (newptr);
#endif
    return (1);
  }

  XplChar XplChar::makestring (int n, XplReal<double> **xd) const
  { long i, j, nlen;
    XplArray<double> *xa;
    XplIndex adim;
    const char *fmt;
    char *res;
    double par[5];
    XplChar ret(1);
    xplstring *strptr;
    if (n<1) 
    { XAerrort(PARAMFALSE, "string: no of params < 1");
      return (ret);
    }
    if (n>5) 
    { XAerrort(PARAMFALSE, "string: no of params > 5");
      return (ret);
    }
    nlen = 0;
    for (j=0; j<n; j++)
    { xa = xd[j];
      adim = xa->getdim();
      if (adim(0)>nlen) nlen = adim(0);
      for (i=1; i<MAX_XARRAY; i++)
      { if (adim(i)!=1) 
        { XAerrort(DIMCON, "string: layer(x_i)<>1");
          return (ret);
        }
      }
    }
#ifndef MEMDEBUG
    res = new char[256*n];
#else
    res  = (char *) xmem.newptr (sizeof(char), 256*n, "XplChar", "makestring", "res");
#endif
    adim = 1;
    adim.setdim (0, nlen);
#ifndef MEMDEBUG
    strptr = new xplstring[nlen];
#else
    strptr  = (xplstring *) xmem.newptr (sizeof(xplstring), nlen, "XplChar", "makestring", "res");
#endif
    ret.setdim(adim);
    ret.setptr(strptr);
    for (i=0; i<nlen; i++)
    { fmt = (*(ptr+(i%dim(0)))).tocstr();
      for (j=0; j<n; j++)
      { xa = xd[j];
        par[j] = (*xa)[i%(xa->size())];
      }
      switch (n)
      { case 1: sprintf (res, fmt, par[0]); break;
        case 2: sprintf (res, fmt, par[0], par[1]); break;
        case 3: sprintf (res, fmt, par[0], par[1], par[2]); break;
        case 4: sprintf (res, fmt, par[0], par[1], par[2], par[3]); break;
        case 5: sprintf (res, fmt, par[0], par[1], par[2], par[3], par[4]); break;
      }
      ret[i] = xplstring(res);
    }
#ifndef MEMDEBUG
    delete[] res;
#else
    xmem.delptr (res);
#endif
    return (ret);
  }

  XplChar XplChar::makestring (int n, XplChar **xd) const
  { long i, j, nlen;
    XplChar *xa;
    XplIndex adim;
    const char *fmt;
    char *res;
    xplstring par[5];
    XplChar ret(1);
    xplstring *strptr;
    if (n<1) 
    { XAerrort(PARAMFALSE, "string: no of params < 1");
      return (ret);
    }
    if (n>5) 
    { XAerrort(PARAMFALSE, "string: no of params > 5");
      return (ret);
    }
    nlen = 0;
    for (j=0; j<n; j++)
    { xa = xd[j];
      adim = xa->getdim();
      if (adim(0)>nlen) nlen = adim(0);
      for (i=1; i<MAX_XARRAY; i++)
      { if (adim(i)!=1) 
        { XAerrort(DIMCON, "string: layer(x_i)<>1");
          return (ret);
        }
      }
    }
#ifndef MEMDEBUG
    res = new char[256*n];
#else
    res  = (char *) xmem.newptr (sizeof(char), 256*n, "XplChar", "makestring", "res");
#endif
    adim = 1;
    adim.setdim (0, nlen);
#ifndef MEMDEBUG
    strptr = new xplstring[nlen];
#else
    strptr  = (xplstring *) xmem.newptr (sizeof(xplstring), nlen, "XplChar", "makestring", "res");
#endif
    ret.setdim(adim);
    ret.setptr(strptr);
    for (i=0; i<nlen; i++)
    { fmt = (*(ptr+(i%dim(0)))).tocstr();
      for (j=0; j<n; j++)
      { xa = xd[j];
        par[j] = (*xa)[i%(xa->size())];
      }
      switch (n)
      { case 1: sprintf (res, fmt, par[0].tocstr()); break;
        case 2: sprintf (res, fmt, par[0].tocstr(), par[1].tocstr()); break;
        case 3: sprintf (res, fmt, par[0].tocstr(), par[1].tocstr(), 
			 par[2].tocstr()); break;
        case 4: sprintf (res, fmt, par[0].tocstr(), par[1].tocstr(), 
			 par[2].tocstr(), par[3].tocstr()); break;
        case 5: sprintf (res, fmt, par[0].tocstr(), par[1].tocstr(), 
			 par[2].tocstr(), par[3].tocstr(), par[4].tocstr()); break;
      }
      ret[i] = xplstring(res);
    }
#ifndef MEMDEBUG
    delete[] res;
#else
    xmem.delptr (res);
#endif
    return (ret);
  }

  long XplChar::xpltypeof (void) const
  { return (TYPE_STRING); }

  int XplChar::WriteXArray (FILE *f)
  { long i, s = size(), type = TYPE_STRING, md = MAX_XARRAY, adim;
    XplIndex d = getdim();
    char *t;
    fwrite (&type, sizeof(long), 1, f);
    fwrite (&md, sizeof(long), 1, f);
    for (i=0; i<MAX_XARRAY; i++)
    { adim = d(i);
      fwrite (&adim, sizeof(long), 1, f);
    }
    for (i=0; i<s; i++)
    { t = (*(ptr+i)).tostr();
      fwrite (t, sizeof(char), 1+::strlen(t), f);
    } 
    return 0;
  }

  void XplChar::mdump (const char *fmt, Xplostream *stream, const char *varname, int pdim)
  { char out[32767], *outstr; 
    xplstring *subptr;
    long i, j, k, l, s, m, starfmt;
    unsigned long count, maxcount;
    XplIndex tmp;
    Xplostream streammdump(stream);
    char 
      *outheadline = property.getProperty("outheadline"), 
      *outlineno = property.getProperty("outlineno"), 
      *outlayerline = property.getProperty("outlayerline"),
      *outputstringformat = property.getProperty("outputstringformat");
    long outmaxdata = ::atol (property.getProperty("outmaxdata"));
    if (size()<=0)
    { XAerrort (ARRAYBAD, "Arraysize <= 0");
      return;
    }
    l = dim(0)*dim(1);    
    s = size()/l;
    m = (long) (1.0+x4log10((double) (dim(0))));
 
    if (varname)
      sprintf (out, outheadline, varname);
    else
      sprintf (out, outheadline, "unnamed object");

    streammdump << out;
    starfmt = (strchr(outlineno, '*') != NULL);
    maxcount = (outmaxdata<1 ? 0xffffffff : outmaxdata); 
    count    = 0L;

    for (tmp=0, k=0; (k<s) && (count<maxcount); k++)
    { subptr = ptr+k*l;
      if (pdim)
      { if (s>1)
        { sprintf (out, outlayerline, 
                    tmp(2)+1,tmp(3)+1,tmp(4)+1,tmp(5)+1,tmp(6)+1,tmp(7)+1);
          streammdump << out;
        }
      }
      for (i=0; (i<dim(0)) && (count<maxcount); i++)
      { if (starfmt)
          sprintf (out, outlineno, m, i+1);
        else
          sprintf (out, outlineno, i+1);
        streammdump << out;

        for (j=0; (j<dim(1)) && (count<maxcount); j++, tmp.inc(dim), count++)
        { outstr = (*(subptr+j*dim(0)+i)).tostr();
          sprintf (out, outputstringformat, outstr);
          delete[] outstr;
          streammdump << out;
          if (j<(dim(1)-1)) streammdump << " ";
        }
        streammdump << "\n";
      }
    } 
    if (count==maxcount)
      streammdump << "\r\nSorry, this object is too big !!\r\n";
  }

  void XplChar::print() const
  { long i;
    printf ("%p : ", ptr);
    for (i=0; i<size(); i++)
      ptr[i].print();
    printf ("\n");
  }

  XplNumber<int> XplChar::operator==(const XplChar &right) const
  { return (ifunctt(right, ::seq)); }

  XplNumber<int> XplChar::operator<=(const XplChar &right) const
  { return (ifunctt(right, ::sleq)); }

  XplNumber<int> XplChar::operator!=(const XplChar &right) const
  { return (ifunctt(right, ::sneq)); }

  XplNumber<int> XplChar::operator>=(const XplChar &right) const
  { return (ifunctt(right, ::sgeq)); }

  XplNumber<int> XplChar::operator<(const XplChar &right) const
  { return (ifunctt(right, ::sle)); }

  XplNumber<int> XplChar::operator>(const XplChar &right) const
  { return (ifunctt(right, ::sge)); }

  XplChar XplChar::substr (const XplNumber<long> &left, const XplNumber<long> &right) const
  { XplChar ret(dim);
    XplIndex tmp;
    long *lptr, *rptr;
    long lind, rind, tind;
    lptr = left.getptr();
    rptr = right.getptr();
    tmp = 0L;
    do
    { tind = dim.value(tmp);
      rind = right.dim.value(tmp % right.dim);
      lind = left.dim.value(tmp % left.dim);
      ret[tind] = ssubstr(*(ptr+tind), *(lptr+lind)-1, *(rptr+rind)-1);
    }
    while (tmp.inc(dim));
    return (ret);
  }

  XplChar XplChar::concat (const XplChar &right) const
  { XplChar ret(dim);
    XplIndex tmp;
    xplstring *rptr;
    long rind, tind;
    rptr = right.getptr();
    tmp = 0L;
    do
    { tind = dim.value(tmp);
      rind = right.dim.value(tmp % right.dim);
      ret[tind] = sconcat(*(ptr+tind), *(rptr+rind));
    }
    while (tmp.inc(dim));
    return (ret);
  }


  void XplChar::makechar (const XplReal<double> &x)
  { char c[2];
    double *xptr;
    xplstring *rptr = new xplstring[x.size()];
    long i;

    xptr = x.getptr();

    c[1] = 0;
    for (i=0; i<x.size(); i++)
    { c[0] = (char) *(xptr+i);
      *(rptr+i) = xplstring(c);
    }

    setdim (x.dim);
    setptr (rptr);
  }

  XplChar XplChar::strtok (const XplChar &pattern) const
  {
    long *pptr;
    char *str, *pstr;
    int i, j, n, len;

    str = ptr->tostr();
    pstr = (pattern.getptr())->tostr();
    n = ::strlen(str);
    for (len=i=0; i<n; i++)
    { if (strchr(pstr, str[i]))
      { str[i] = 0;
        len++;
      }
    }
    len++;
    delete[] pstr;

    XplChar ret(len);
    xplstring *rptr;
    rptr = ret.getptr();
    pstr = str;
    for (j=i=0; i<=n; i++)
    { if (str[i]==0)
      { *(rptr+j) = xplstring (pstr);
        pstr = &str[i+1];
        j++;
      }
    }

    delete[] str;
    return (ret);
  }
