/* $Header: /home/xplore/cvs/xpl4gr/xchar.hpp,v 1.3 2002/08/16 12:31:54 sigbert Exp $ */

#include "xreal.hpp"

#ifndef XPLCHAR
#define XPLCHAR

int seq  (const xplstring l, const xplstring r);  
int sleq (const xplstring l, const xplstring r);  
int sneq (const xplstring l, const xplstring r);  
int sgeq (const xplstring l, const xplstring r);  
int sle (const xplstring l, const xplstring r);  
int sge  (const xplstring l, const xplstring r);  

xplstring ssubstr(const xplstring &str, long l, long r);
xplstring sconcat(const xplstring &l,  const xplstring &r);


class XplChar : public XplArray<xplstring> {

  public:
  
  XplChar (const XplIndex newdim);
  XplChar ();
  XplChar (long d0, long d1=1 , long d2=1, long d3=1, long d4=1, long d5=1, long d6=1, long d7=1);
  ~XplChar ();
  XplChar (const XplArray<xplstring>& x);
  XplChar (const XplChar &x);

  XplChar& operator= (const XplChar &x);		
  XplChar& operator= (const XplArray<xplstring> &x);		

  XplArray<double> atof () const;
  XplArray<double> strlen () const;
  XplArray<long> atol () const;

  int ReadASCIIXplArray (char const *datei);

  XplChar makestring (int n, XplReal<double> **xd) const;
  XplChar makestring (int n, XplChar **xd) const;

  long xpltypeof (void) const;

  int WriteXArray (FILE *f);

  void mdump (const char *fmt, Xplostream *stream = NULL, const char *varname=NULL,
              int pdim = 1);

  void print() const;

  XplNumber<int> operator==(const XplChar &right) const;
  XplNumber<int> operator<=(const XplChar &right) const;
  XplNumber<int> operator!=(const XplChar &right) const;
  XplNumber<int> operator>=(const XplChar &right) const;
  XplNumber<int> operator<(const XplChar &right) const;
  XplNumber<int> operator>(const XplChar &right) const;

  XplChar substr (const XplNumber<long> &left, const XplNumber<long> &right) const;
  XplChar concat (const XplChar &right) const;
  void makechar (const XplReal<double> &x);
  XplChar strtok (const XplChar &pattern) const;

};

#endif
