/* $Header: /home/xplore/cvs/xpl4gr/xindex.hpp,v 1.3 2002/08/16 12:31:55 sigbert Exp $ */

#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include "global.h"

#ifndef XPLINDEX
#define XPLINDEX

class XplIndex 
//L \section{XplIndex}
//L Class for indexing arrays.
//L \begin{enumerate}
{ long index[MAX_XARRAY];
  long shift[MAX_XARRAY];
  long pind;

  long update(void);

  public:

  XplIndex (long d0=1, long d1=1, long d2=1, long d3=1, 
            long d4=1, long d5=1, long d6=1, long d7=1);

  XplIndex& operator= (const XplIndex &x);

  XplIndex& operator= (long val);

  int operator< (XplIndex& x);

  XplIndex operator<< (int s);

  XplIndex operator>> (int s);

  void setdim(unsigned no, long newdim);

  long operator()(unsigned no) const;

  long prod (int k) const ;
  inline long prod () const { return pind; }
  void swap (long l, long r);

  XplIndex operator% (const XplIndex& x) const;

  int inc (const XplIndex& x, long dim = -1);

  int equal (XplIndex&  x, unsigned k) const;

  int matequal (XplIndex&  x) const;

  XplIndex sum (XplIndex& x, unsigned k) const;

  int isconf (const XplIndex& x) const;

  long value (XplIndex act) const;

  XplIndex value (long pos) const;

  XplIndex maxindex (const XplIndex& right) const;

  XplIndex maxmatindex (XplIndex& right);

  void dump (void) const;

  int operator== (const XplIndex &right) const;

 };
//L \end{enumerate}

#endif
