/* $Header: /home/xplore/cvs/xpl4gr/xio.C,v 1.3 2002/08/16 12:31:55 sigbert Exp $ */

#include "xio.h"


#ifdef HAS_STRCMPI
#define strcasecmp strcmpi
#endif

int WriteXHeader (FILE *f) 
{ int i;
  char format[8];
  for (i=0; i<8; i++)
    format[i] = (i ? 28 : 26);
  if (fwrite (format, sizeof(char), 8, f)!=8*sizeof(char)) return 0;
  return 1;
}

int ReadXHeader (FILE *f) 
{ int i;
  char format[8];
  fread (format, sizeof(char), 8, f);
  for (i=0; i<8; i++)
    if (format[i] != (i ? 28 : 26)) return 0;
  return 401;
}

void *ReadXArray (FILE *f, long *type, int int_fmt)
{ XplChar *rs;
  static char ps[MAXINPUTLINE];
  xplstring *pc;
  XplArray<double> *rd; 
  double *pd;
  XplArray<long> *rl;
  XplTime *rt;
  long *pl;
  XplIndex d;
  long s, md, di, i;

  fread (type, sizeof(long), 1, f);
  fread (&md, sizeof(long), 1, f);
  if (md>MAX_XARRAY) 
  { *type = TYPE_UNKNOWN;
    return (NULL);
  }
  if (*type==TYPE_STRING)
  { for (i=0; i<md; i++)
    { fread (&di, sizeof(long), 1, f);
      d.setdim (i, di);
    }
    rs = new XplChar(d);
    s = d.prod();
    pc = new xplstring[s];
    for (i=0; i<s; i++)
    { di = 0;
      do
      { fread (&ps[di], sizeof(char), 1, f);
        di++;
      }
      while (ps[di-1]);
      pc[i] = xplstring(ps);
    }

    rs->setdim(d);
    rs->setptr(pc);
    return (rs);
  }
  else if (*type==TYPE_DOUBLE)
  { for (i=0; i<md; i++)
    { fread (&di, sizeof(long), 1, f);
      d.setdim (i, di);
    }
    rd = new XplArray<double>(d);
    s = d.prod();
    pd = new double[s];
    fread (pd, sizeof(double), s, f);

    rd->setdim(d);
    rd->setptr(pd);
    return (rd);
  } 
  else if (*type==TYPE_LONG)
  { for (i=0; i<md; i++)
    { fread (&di, sizeof(long), 1, f);
      d.setdim (i, di);
    }
    rl = new XplArray<long>(d);
    s = d.prod();
    pl = new long[s];
    fread (pl, sizeof(long), s, f);

    rl->setdim(d);
    rl->setptr(pl);
    return (rl);
  } 
  else if (*type==TYPE_TIME)
  { XGran gran;
    long zd;
    for (i=0; i<md; i++)
    { fread (&di, sizeof(long), 1, f);
      d.setdim(i, di);
    }
    fread (&gran, sizeof(XGran), 1, f);
    fread (&zd, sizeof(long), 1, f);

    rt = new XplTime(d);
    s = d.prod();
    pl = new long[s];
    fread (pl, sizeof(long), s, f);
    rt->SetXplTimeGran (gran);
    rt->SetXplTimeZero (zd);
    rt->setdim(d);
    rt->setptr(pl);
    return (rt);
  } 

  *type == TYPE_UNKNOWN;
  return (NULL);
}

int ReadXplArray (const char *name, XplChar &rs, 
                  XplArray<double> &rd, XplArray<long> &rl,
                  XplArray<long> &colvec)
{ char line[MAXINPUTLINE], symbol[MAXINPUTLINE], errmsg[80];
  FILE *f = NULL;
  xplstring *ps, *rsp;
  long *pl, rows, trows, colsd, colss, colsl, countd, counts, countl;
  double *pd, *rdp;
  void *newptr;

  long acts, actl, actd, maxs, maxl, maxd, acttyp, i, maxcol, linecol, j,
       *rlp;
  char *type, *tok, *coltype;
  XplIndex dim;

  ps = new xplstring[maxs=1024];
  pl = new long[maxl=1024];
  pd = new double[maxd=2048];
  acts = actl = actd = 0;
  type = new char[2*(maxs+maxl+maxd)];


  f = opendatafile (name, "r");
  if (f==NULL)
  { XAerrort (STRBAD, "Can not open inputfile");
    return(0);
  }

  line[0] = 0;
  acttyp = 0;
  while (fgets(line, MAXINPUTLINE-1, f))
  { tok = line;
    for (i=0; i<strlen(tok); i++)
      if ((!isprint(tok[i])) && (tok[i]!='\n')) tok[i] = ' '; 
    while (*tok)
    { while ((*tok==' ') || (*tok=='\t') || (*tok=='\n')) tok++;
      if (*tok=='\0') break;
      if (*tok=='\"') 
      { // string found
        tok++;
        type[acttyp] = 1;
        for (i=1; (*tok!='\"') && (*tok!='\0'); i++, tok++)
	    symbol[i-1] = *tok;
        symbol[i] = 0;
        if (*tok=='"') tok++; 
      }
      else if (isalpha(*tok))
      { // string found
        type[acttyp] = 1;
        for (i=0; (*tok!=' ') && (*tok!='\t') && 
                  (*tok!='\n') && (*tok!='\0'); i++, tok++)
	  symbol[i] = *tok;
        symbol[i] = 0;
      }
      else 
      { // number or string found
        type[acttyp] = 2;
        i = 1;
        for (i=0; (*tok!=' ') && (*tok!='\t') && 
                  (*tok!='\n') && (*tok!='\0'); i++, tok++)
        { switch (type[acttyp])
          { case  2 : if ((*tok=='d') || (*tok=='e') || 
                          (*tok=='D') || (*tok=='E'))
                        type[acttyp] = 10;
                      if (*tok=='.')
                        type[acttyp] = 11;
                      break;
	    case 10 : if (isalpha(*tok) || (*tok=='.'))
                        type[acttyp] = 1;
                      break; 
            case 11 : if ((*tok=='d') || (*tok=='e') || 
                          (*tok=='D') || (*tok=='E'))
                        type[acttyp] = 10;
                      break;
          }
          symbol[i] = *tok; 
	}
        symbol[i] = 0;
      }
      switch (type[acttyp])
      { case  1 : ps[acts++] = xplstring(symbol);
                  if (acts==maxs)
                  { newptr = (void *) new xplstring[maxs+1024];
                    memcpy (newptr, ps, sizeof(xplstring)*maxs);
                    delete[] ps;
                    ps = (xplstring *) newptr;
                    newptr = (void *) new char[2*(1024+maxs+maxl+maxd)];
                    memcpy (newptr, type, sizeof(char)*2*(maxs+maxl+maxd));
                    delete[] type;
                    type = (char *) newptr;
                    maxs += 1024;
                  }
                  break;
        case  2 : pl[actl++] = atol(symbol);
                  if (actl==maxl)
                  { newptr = (void *) new long[maxl+1024];
                    memcpy (newptr, pl, sizeof(long)*maxl);
                    delete[] pl;
                    pl = (long *) newptr;
                    newptr = (void *) new char[2*(1024+maxs+maxl+maxd)];
                    memcpy (newptr, type, sizeof(char)*2*(maxs+maxl+maxd));
                    delete[] type;
                    type = (char *) newptr;
                    maxl += 1024;
                  }
                  break;
        case 10 :
        case 11 : type[acttyp] = 3;
        case  3 : if ((strlen(symbol)==1) && (symbol[0]=='.'))
                    pd[actd++] = sqrt(-1.0);
                  else
                    pd[actd++] = atof(symbol);
                  if (actd==maxd)
                  { newptr = (void *) new double[maxd+2048];
                    memcpy (newptr, pd, sizeof(double)*maxd);
                    delete[] pd;
                    pd = (double *) newptr;
                    newptr = (void *) new char[2*(2048+maxs+maxl+maxd)];
                    memcpy (newptr, type, sizeof(char)*2*(maxs+maxl+maxd));
                    delete[] type;
                    type = (char *) newptr;
                    maxd += 2048;
                  }
                  break;
      }
      acttyp++;
//      tok = strtok(NULL, " \t\n");
    }
    type[acttyp++] = 0x7f;
  }
  fclose(f);
  type[acttyp] = 0;
#ifdef SKDEBUG
  printf ("Mixed read:\n");
  printf ("  Long  : %li\n", actl);
  printf ("  Float : %li\n", actd);
  printf ("  String: %li\n", acts);
#endif
  trows = rows = colsd = colss = colsd = countd = counts = countl = 0;
  linecol = maxcol = 0;
  coltype = new char[maxs+maxl+maxd];
  for (i=0; i<acttyp; i++)
  { if (type[i]==0x7f)
    { if (type[i-1]==0x7f)
      { memcpy (&(type[i-1]), &(type[i]), sizeof(char)*(acttyp-i));
        i--;
        acttyp--;
      }
      else
      { rows++;
        if (countd>colsd) colsd = countd;
        if (countl>colsl) colsl = countl;
        if (counts>colss) colss = counts;
      }
      linecol = countd = counts = countl = 0;
      trows++;
    }
    else 
    { switch (type[i])
      { case 1 : counts++;
                 if (linecol==maxcol)
                 { coltype[linecol] = type[i];
                   maxcol++;
                 }
                 else if (coltype[linecol]!=1)
                 { sprintf (errmsg, "Text expected in line %li and col %li", 
                                     trows+1, linecol+1); 
                   XAerrort (FORMAT, errmsg);
                   return 0;
                 }
                 linecol++;
                 break;
        case 2 : countl++; 
                 if (linecol==maxcol)
                 { coltype[linecol] = type[i];
                   maxcol++;
                 }
                 else
	         { if (coltype[linecol]==1)
                   { sprintf (errmsg, "Int expected in line %li and col %li",
                                       trows+1, linecol+1); 
                     XAerrort (FORMAT, errmsg);
                     return 0;
                   }
                   if (coltype[linecol]==3)
		   { countl--;
                     countd++;
                   }
                 }
                 linecol++;
                 break;
	case 3 : countd++; 
                 if (linecol==maxcol)
                 { coltype[linecol] = type[i];
                   maxcol++;
                 }
                 else
		 { if (coltype[linecol]==2)
                   { coltype[linecol] = 3;
                     colsl--; 
                     colsd++; 
                   }
                   if (coltype[linecol]==1)
                   { sprintf (errmsg, "Float expected in line %li and col %li", 
                                       trows+1, linecol+1); 
                     XAerrort (FORMAT, errmsg);
                     return 0;
                   }  
                 }
                 linecol++;
                 break;
      }
    }
  }
  dim = 1;
//  for (i=2; i<MAX_XARRAY; i++)
//    dim[i] = 1;
  dim.setdim (0, rows);
  dim.setdim (1, colss);
  rs.setdim(dim);
  if (colss)
  { rsp = new xplstring[dim.prod()];
    rs.setptr(rsp);
  }

  dim.setdim (0, rows);
  dim.setdim (1, colsl);
  rl.setdim(dim);
  if (colsl)
  { rlp = new long[dim.prod()];
    rl.setptr(rlp);
  }

  dim.setdim (0, rows);
  dim.setdim (1, colsd);
  rd.setdim(dim);
  if (colsd)
  { rdp = new double[dim.prod()];
    rd.setptr(rdp);
  }

  acttyp = countd = counts = countl = 0;
  for (i=0; i<rows; i++)
  { colsd = colss = colsl = 0;
    for (j=0; j<maxcol; j++, acttyp++)
    { switch (coltype[j])
      { case 1 : rs(i,colss) = ps[counts];
                 colss++;
                 counts++;
                 break;
        case 2 : if (type[acttyp]==3)
                 { rl(i,colsl) = (long) pd[countd];
                   countd++;
                 }
                 else
                 { rl(i,colsl) = pl[countl];
                   countl++;
                 }
                 colsl++;
                 break;
        case 3 : if (type[acttyp]==3)
                 { rd(i,colsd) =  pd[countd];
                   countd++;
                 }
                 else
                 { rd(i,colsd) = (double) pl[countl];
                   countl++;
                 }
                 colsd++;
                 break;
      }
    }
    while (type[acttyp]==0x7f) acttyp++; 
  }

  dim = 1;
//  for (i=1; i<MAX_XARRAY; i++)
//    dim[i] = 1;
  dim.setdim (0, maxcol);
  colvec.setdim(dim);
  for (i=0; i<maxcol; i++)
    colvec(i) = coltype[i];

  delete[] ps;
  delete[] pl;
  delete[] pd;
  delete[] type;
  delete[] coltype;

  return 1;
}
    
// PC - auxiliary function for ReadASCIIData - checks conditions
// index should range from 1..n
bool checkreadasciidatacondition(long index, long *list, long listlen,
                                 long *cindex, long *conds, long condslen,
                                 bool increment)
{
     long i, pom, bottom, top;
     int type;
     bool res1, res2;

     if (index <= 0)
          return false;

     // list of inclusion (pos) / exclusion (neg) intervals
     // we assume that the lower index comes always first!
     if ((list != NULL) && (listlen > 0))
     {
          // check what is default for res1:
          //   if only exclusion restrictions are present, res1 = true by default
          //   if only inclusion restrictions are present, res1 = false by default
          //   mixture -- we return false always, so nothing is read at all
          type = (list[0] > 0) ? 1 : -1;
          for(i = 1; i < 2*listlen; i++)
          {
               if ((list[i] > 0) && (type <= 0))
               {
                    type = 0;
                    break;
               }
               if ((list[i] < 0) && (type >= 0))
               {
                    type = 0;
                    break;
               }
          }
          if (type == 0)
               res1 = true;
          else if (type > 0)
               res1 = false;  // inclusion
          else if (type < 0)
               res1 = true;   // exclusion

          if (type != 0)		// we check it only if one type of conditions is present
          for(i = 0; i < listlen; i++)
          {
               bottom = list[i];
               top = list[listlen + i];

               if ((bottom < 0) && (top < 0)) // exclusion
               {
                    bottom *= -1;
                    top *= -1;
                    if ((bottom <= index) && (index <= top))
                    {
                         res1 = false;
                         break;
                    }
               }
               else if ((bottom > 0) && (top > 0)) // inclusion
               {
                    if ((bottom <= index) && (index <= top))
                    {
                         res1 = true;
                         break;
                    }
               }
               // otherwise ignored
          } // end for
     }
     else res1 = true;   // no list

     // boolean condition vector - evaluate only if res1 == true
     if (res1)
     {
          if (increment)
               *cindex += 1;
          if (*cindex <= 0)
               return false;
          if ((conds != NULL) && (condslen > 0))
               res2 = (conds[(*cindex-1) % condslen] != 0) ? true : false;
          else res2 = true;   // no conditions
     }

     return (res1 && res2) ? true : false;
}

#define NUMBER   0
#define MISSING  1
#define TEXT    10
#define EOL     20
#define MAX_LINE_LENGTH 2560
#define MAX_IOBLOCKSIZE  8192

char *readasciistrtok(char *s, const char *sep, int multisep)
{
  static char *str = NULL;
  char *pom, *ret;

  if (multisep)
  {
  	 ret = strtok(s, sep);
  }
  else
  { // PC 20020320
    if (s)
    {
      str = s;
      if ( (strlen(s) <= 1) && ((*s == '\n') || (*s == '\0')) )
      {
      	str = NULL;
         return NULL;
      }
    }
      
    if ((str == NULL) || (*str == '\0'))
    {
    	str = NULL;
      return NULL;
    }

    pom = strpbrk(str, sep);
    if (pom == NULL)
    {
      ret = str;
      str += strlen(str); 
    }
    else
    {
      ret = str;
      *pom = '\0';
      str = pom + 1;
    }
  }

  return ret;
}

// PC 20020219 - new ReadASCIIData
int ReadASCIIData (const char *datei, const char *separator, XplChar *data, 
                   XplArray<long> *type, int check, int multisep,
                   XplArray<long> *selrows, XplArray<long> *selcols,
                   XplArray<long> *rowconds, XplArray<long> *colconds)
{ FILE *f = NULL; 

  xplstring *newptr, *tmpt;
  long *epl, *tmpc, actualsize = MAX_IOBLOCKSIZE, count,  i, j, mode;
  char errmsg[1024], line[MAX_LINE_LENGTH], *tok, *usesep;
  XplIndex dim;
    
    // PC: condition variables
    long truerows = 0, truelinecols = 0;
    long truecondrows = 0, truecondlinecols = 0;
    long *selrowsptr = NULL, *selcolsptr = NULL, *rowcondsptr = NULL, *colcondsptr = NULL;
    long selrowslen = 0, selcolslen = 0, rowcondslen = 0, colcondslen = 0, pomstrlen;

//  if (ReadXXplArray(datei)==1) return (1);

  usesep = strdup(separator);
  makefmtstring (usesep);

//  printf ("seplen=%i %s\n", strlen(usesep), usesep);

  f = opendatafile (datei, "r");
  if (f==NULL)
  { sprintf (errmsg, "Can not open data file : %s", datei);
    XAerrort (STRBAD, errmsg);
    return(0);
  }

// check parameters regarding conditions
     if (selrows != NULL)
     if ((selrows->dim(1) == 2) && (selrows->dim.prod(2) == selrows->dim.prod(MAX_XARRAY)))
     {
          selrowsptr = selrows->getptr();
          selrowslen = selrows->dim(0);
     }
     if (selcols != NULL)
     if ((selcols->dim(1) == 2) && (selcols->dim.prod(2) == selcols->dim.prod(MAX_XARRAY)))
     {
          selcolsptr = selcols->getptr();
          selcolslen = selcols->dim(0);
     }
     if (rowconds != NULL)
     if (rowconds->dim.prod(MAX_XARRAY) > 1)
     {
          rowcondsptr = rowconds->getptr();
          rowcondslen = rowconds->dim.prod(MAX_XARRAY);
     }
     if (colconds != NULL)
     if (colconds->dim.prod(MAX_XARRAY) > 1)
     {
          colcondsptr = colconds->getptr();
          colcondslen = colconds->dim.prod(MAX_XARRAY);
     }

#ifndef MEMDEBUG
  newptr = new xplstring[actualsize];
  epl    = new long[actualsize];
#else
  newptr = (xplstring *) xmem.newptr (sizeof(xplstring), actualsize, "XplArray", "ReadASCIIXplArray", "newptr");
  epl    = (long *) xmem.newptr (sizeof(long), actualsize, "XplArray", "ReadASCIIXplArray", "epl");
#endif
  count = 0;
  while (fgets(line, MAX_LINE_LENGTH-1, f))
  { 
    truerows++;
    // check whether the line should be read
    if ( !checkreadasciidatacondition(truerows, selrowsptr, selrowslen, &truecondrows, rowcondsptr, rowcondslen, true) )
         continue;

    truelinecols = 0;
    truecondlinecols = 0;

    tok = readasciistrtok (line, usesep, multisep);
    while (tok)
    { //printf ("%s\n", tok);
      truelinecols++;
      if (!checkreadasciidatacondition(truelinecols, selcolsptr, selcolslen, &truecondlinecols, colcondsptr, colcondslen, true) )
      {
          tok = readasciistrtok (NULL, usesep, multisep);
          continue;
      }
          
      newptr[count] = xplstring(tok);
      epl[count]    = TEXT;
      if (check)
      { if ((strcasecmp(tok, ".")==0) || (strcasecmp(tok, "nan")==0) || (strcasecmp(tok, "na")==0))
          epl[count] = MISSING;
        else
        { for (mode=i=0; i<strlen(tok); i++)
          { // printf ("%i %i %i %c\n", strlen(tok), mode, i, tok[i]);
            switch (mode)
	    { case  0 :
                mode = -1; 
                if (strchr("+-", tok[i]))
	          mode = 1;
                else if (strchr("0123456789", tok[i]))
                  mode = 2;
                else if (strchr(".,", tok[i]))
                  mode = 3;
                break;
              case  1 :
                mode = -1; 
                if (strchr("0123456789", tok[i]))
                  mode = 2;
                else if (strchr(".,", tok[i]))
                  mode = 3;
                break;
              case  2 :
                mode = -1; 
                if (strchr("0123456789", tok[i]))
                  mode = 2;
                else if (strchr(".,", tok[i]))
                  mode = 3;
                else if (strchr("edED", tok[i]))
                  mode = 5;
                break;
              case  3 :
                mode = -1; 
                if (strchr("0123456789", tok[i]))
                  mode = 4;
                else if (strchr("edED", tok[i]))
                  mode = 5;
                break;
              case  4 :
                mode = -1; 
                if (strchr("0123456789", tok[i]))
                  mode = 4;
                else if (strchr("edED", tok[i]))
                  mode = 5;
                break;
              case  5 :
                mode = -1; 
                if (strchr("0123456789", tok[i]))
                  mode = 7;
                else if (strchr("-+", tok[i]))
                  mode = 7;
                break;
              case  7 :
                mode = -1; 
                if (strchr("0123456789", tok[i]))
                  mode = 7;
                break;
	      default :
                i = strlen(tok);
            }  
          }
          if (mode>0) epl[count] = NUMBER;
        }
      }
//      printf ("type=%li\n", epl[count]); 
      count++;
      if (count==actualsize)
      { actualsize += MAX_IOBLOCKSIZE;
#ifndef MEMDEBUG
        tmpt = new xplstring[actualsize];
        tmpc = new long[actualsize];
#else
        tmpt = (xplstring *) xmem.newptr (sizeof(xplstring), actualsize, "XplArray", "ReadASCIIXplArray", "tmpt");
        tmpc = (long *) xmem.newptr (sizeof(long), actualsize, "XplArray", "ReadASCIIXplArray", "tmpc");
#endif
        ::memcopy (tmpt, newptr, actualsize-MAX_IOBLOCKSIZE); //sizeof(T)*actualsize);
        ::memcopy (tmpc, epl, actualsize-MAX_IOBLOCKSIZE); //sizeof(long)*actualsize);

#ifndef MEMDEBUG
        delete[] newptr;
        delete[] epl;
#else
        xmem.delptr (newptr);
        xmem.delptr (epl);
#endif
        newptr = tmpt;
        epl    = tmpc;
      }
      tok = readasciistrtok (NULL, usesep, multisep);
    }
    newptr[count] = xplstring("\n");
    epl[count]    = EOL;
    count++;
    if (count==actualsize)
    { actualsize += MAX_IOBLOCKSIZE;
#ifndef MEMDEBUG
      tmpt = new xplstring[actualsize];
      tmpc = new long[actualsize];
#else
      tmpt = (xplstring *) xmem.newptr (sizeof(xplstring), actualsize, "XplArray", "ReadASCIIXplArray", "tmpt");
      tmpc = (long *) xmem.newptr (sizeof(long), actualsize, "XplArray", "ReadASCIIXplArray", "tmpc");
#endif
      ::memcopy (tmpt, newptr, actualsize-MAX_IOBLOCKSIZE); //sizeof(T)*actualsize);
      ::memcopy (tmpc, epl, actualsize-MAX_IOBLOCKSIZE); //sizeof(long)*actualsize);

#ifndef MEMDEBUG
      delete[] newptr;
      delete[] epl;
#else
      xmem.delptr (newptr);
      xmem.delptr (epl);
#endif
      newptr = tmpt;
      epl    = tmpc;
    }
  }
  fclose(f);
  delete[] usesep;

  if (count <= 0)
  {
       delete[] newptr;
       delete[] epl;
       
       sprintf (errmsg, "No data found: %s", datei);
       XAerrort (STRBAD, errmsg);
       return(0);
  }

  //  printf ("read: %li values and newlines read\n", count);
  dim.setdim (0, count);
  data->setptr (newptr);
  data->setdim (dim);
  type->setptr (epl);
  type->setdim (dim);
  return (1);
}

// PC ReadASCIIData rewritten
//int ReadASCIIData (const char *datei, const char *separator, XplChar *data, XplArray<long> *type, int check)
//{ FILE *f = NULL; 
//
//  xplstring *newptr, *tmpt;
//  long *epl, *tmpc, actualsize = MAX_IOBLOCKSIZE, count,  i, j, mode;
//  char errmsg[1024], line[MAX_LINE_LENGTH], *tok, *usesep;
//  XplIndex dim;
//    
////  if (ReadXXplArray(datei)==1) return (1);
//
//  usesep = strdup(separator);
//  makefmtstring (usesep);
//
////  printf ("seplen=%i %s\n", strlen(usesep), usesep);
//
//  f = opendatafile (datei, "r");
//  if (f==NULL)
//  { sprintf (errmsg, "Can not open data file : %s", datei);
//    XAerrort (STRBAD, errmsg);
//    return(0);
//  }
//
//#ifndef MEMDEBUG
//  newptr = new xplstring[actualsize];
//  epl    = new long[actualsize];
//#else
//  newptr = (xplstring *) xmem.newptr (sizeof(xplstring), actualsize, "XplArray", "ReadASCIIXplArray", "newptr");
//  epl    = (long *) xmem.newptr (sizeof(long), actualsize, "XplArray", "ReadASCIIXplArray", "epl");
//#endif
//  count = 0;
//  while (fgets(line, MAX_LINE_LENGTH-1, f))
//  { tok = strtok (line, usesep);
//    while (tok)
//    { //printf ("%s\n", tok);
//      newptr[count] = xplstring(tok);
//      epl[count]    = TEXT;
//      if (check)
//      { if ((strcasecmp(tok, ".")==0) || (strcasecmp(tok, "nan")==0) || (strcasecmp(tok, "na")==0))
//          epl[count] = MISSING;
//        else
//        { for (mode=i=0; i<strlen(tok); i++)
//          { // printf ("%i %i %i %c\n", strlen(tok), mode, i, tok[i]);
//            switch (mode)
//	    { case  0 :
//                mode = -1; 
//                if (strchr("+-", tok[i]))
//	          mode = 1;
//                else if (strchr("0123456789", tok[i]))
//                  mode = 2;
//                else if (strchr(".,", tok[i]))
//                  mode = 3;
//                break;
//              case  1 :
//                mode = -1; 
//                if (strchr("0123456789", tok[i]))
//                  mode = 2;
//                else if (strchr(".,", tok[i]))
//                  mode = 3;
//                break;
//              case  2 :
//                mode = -1; 
//                if (strchr("0123456789", tok[i]))
//                  mode = 2;
//                else if (strchr(".,", tok[i]))
//                  mode = 3;
//                else if (strchr("edED", tok[i]))
//                  mode = 5;
//                break;
//              case  3 :
//                mode = -1; 
//                if (strchr("0123456789", tok[i]))
//                  mode = 4;
//                else if (strchr("edED", tok[i]))
//                  mode = 5;
//                break;
//              case  4 :
//                mode = -1; 
//                if (strchr("0123456789", tok[i]))
//                  mode = 4;
//                else if (strchr("edED", tok[i]))
//                  mode = 5;
//                break;
//              case  5 :
//                mode = -1; 
//                if (strchr("0123456789", tok[i]))
//                  mode = 7;
//                else if (strchr("-+", tok[i]))
//                  mode = 7;
//                break;
//              case  7 :
//                mode = -1; 
//                if (strchr("0123456789", tok[i]))
//                  mode = 7;
//                break;
//	      default :
//                i = strlen(tok);
//            }  
//          }
//          if (mode>0) epl[count] = NUMBER;
//        }
//      }
////      printf ("type=%li\n", epl[count]); 
//      count++;
//      if (count==actualsize)
//      { actualsize += MAX_IOBLOCKSIZE;
//#ifndef MEMDEBUG
//        tmpt = new xplstring[actualsize];
//        tmpc = new long[actualsize];
//#else
//        tmpt = (xplstring *) xmem.newptr (sizeof(xplstring), actualsize, "XplArray", "ReadASCIIXplArray", "tmpt");
//        tmpc = (long *) xmem.newptr (sizeof(long), actualsize, "XplArray", "ReadASCIIXplArray", "tmpc");
//#endif
//        ::memcopy (tmpt, newptr, actualsize-MAX_IOBLOCKSIZE); //sizeof(T)*actualsize);
//        ::memcopy (tmpc, epl, actualsize-MAX_IOBLOCKSIZE); //sizeof(long)*actualsize);
//
//#ifndef MEMDEBUG
//        delete[] newptr;
//        delete[] epl;
//#else
//        xmem.delptr (newptr);
//        xmem.delptr (epl);
//#endif
//        newptr = tmpt;
//        epl    = tmpc;
//      }
//      tok = strtok (NULL, usesep);
//    }
//    newptr[count] = xplstring("\n");
//    epl[count]    = EOL;
//    count++;
//    if (count==actualsize)
//    { actualsize += MAX_IOBLOCKSIZE;
//#ifndef MEMDEBUG
//      tmpt = new xplstring[actualsize];
//      tmpc = new long[actualsize];
//#else
//      tmpt = (xplstring *) xmem.newptr (sizeof(xplstring), actualsize, "XplArray", "ReadASCIIXplArray", "tmpt");
//      tmpc = (long *) xmem.newptr (sizeof(long), actualsize, "XplArray", "ReadASCIIXplArray", "tmpc");
//#endif
//      ::memcopy (tmpt, newptr, actualsize-MAX_IOBLOCKSIZE); //sizeof(T)*actualsize);
//      ::memcopy (tmpc, epl, actualsize-MAX_IOBLOCKSIZE); //sizeof(long)*actualsize);
//
//#ifndef MEMDEBUG
//      delete[] newptr;
//      delete[] epl;
//#else
//      xmem.delptr (newptr);
//      xmem.delptr (epl);
//#endif
//      newptr = tmpt;
//      epl    = tmpc;
//    }
//  }
//  fclose(f);
//  delete[] usesep;
//
//  //  printf ("read: %li values and newlines read\n", count);
//  dim.setdim (0, count);
//  data->setptr (newptr);
//  data->setdim (dim);
//  type->setptr (epl);
//  type->setdim (dim);
//  return (1);
//}



