/* $Header: /home/xplore/cvs/xpl4gr/xnew.C,v 1.3 2002/08/16 12:31:56 sigbert Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include "xnew.hpp"

  XPtr::XPtr ()
  { ptr   = NULL; 
    classn = NULL;
    proc  = NULL;
    var   = NULL;
  }

  XPtr* XPtr::set (void *p, char *cn, char *pn, char *vn, long nv, long ptrsize)
  { ptr = p;
    printf ("New Ptr: %p\n", ptr);
    next = new XPtr;
    classn = cn;
    proc  = pn;
    var   = vn;
    val   = nv;
    size  = ptrsize;
    return (next);
  }

  XPtr* XPtr::getnext ()
  { return (next); }

  char* XPtr::getproc ()
  { return (proc); }

  char* XPtr::getclass ()
  { return (classn); }

  char* XPtr::getvar ()
  { return (var); }

  long XPtr::getval ()
  { return (val); }

  void* XPtr::getptr ()
  { return (ptr); }
  
  long XPtr::getsize ()
  { return (size); }

  void XPtr::setnext (XPtr *newnext)
  { next = newnext; }
 
  int XPtr::has (void *p)
  { return (p==ptr); }



  XMemory::XMemory ()
  { last = root = new XPtr(); 
    val = 0;
    if (id==0x34686759)
    { printf ("ERROR: id had magic number !!!\nERROR: pointer list corrupted !!!\nERROR: crahes may occur !!!");
    } 
    id = 0x34686759;
  }

  XMemory::~XMemory ()
  { //dump(-1); 
    id = 0;
  }

  void XMemory::dump (int d)
  { XPtr *act = root;
    printf ("\nPointerdump (%i)\n\n", val);
    while (act!=last)
    { if (((d>0) && (act->getval()>=d)) ||
          (d<0) || (act->getval()>=val))
        printf ("Pointer %p (%10li): %+10s::%-10s %s\n", act->getptr(), act->getsize(), act->getclass(), act->getproc(), act->getvar());
      act = act->getnext();
    }
    printf ("\n\n");
  }

  void* XMemory::newptr (long size, long s, char *cn, char *pn, char *vn)
  { char *ptr;
    long i, sxsize;
    sxsize = s*size;
    ptr = new char[sxsize];
    for (i=0; i<sxsize; i++)
      *(ptr+i) = 0;
    if (id==0x34686759)
      last = last->set (ptr, cn, pn, vn, val, sxsize);
    return ptr;
  }

  void XMemory::delptr (void *p)
  { XPtr *act, *lact;
    if (id==0x34686759)
    { lact = act = root;
      while (act!=last)
      { if (act->has(p))
        { if (act==root)
            root = root->getnext();
          else
            lact->setnext(act->getnext());
          delete act;
          delete [] p;
          printf ("Del Ptr: %p\n", p);
          return;
        }
        lact = act;
        act = act->getnext();
      }    
      printf ("Pointer not found: %p\n", p);
    }
    else
      delete[] p;
  }

  int XMemory::operator++ (void)
  { val++; 
    return 0;
  }

  int XMemory::operator-- (void)
  { // dump();
    val--;
    return 0;
  }

template<class T> XplPtr<T>::XplPtr ()
{ ptr = NULL;
#ifdef MEMDEBUG
  from = to = 0;
  kill = 0;
#endif
}

template<class T> XplPtr<T>::~XplPtr ()
{ 
#ifdef MEMDEBUG 
  if (kill && ptr) xmem.delptr(ptr);
  ptr = NULL;
  from = to = 0;
  kill = 0;
#else
  if (ptr) delete[] ptr;
#endif
}   
    
template<class T> void XplPtr<T>::xmalloc (long len, char *cn, char *pn, char *vn)
{
#ifdef MEMDEBUG 
  if (ptr)
  { if (kill) xmem.delptr (ptr);
    ptr  = NULL;
    from = to = 0;
    kill = 0;
  }
  ptr = (T*) xmem.newptr (sizeof(T), len, cn, pn, vn); 
  if (ptr==NULL)
  { printf ("Error: Allocation results in NULL pointer\n");
    exit(9);
  }
  from = 0;
  to   = len;
  kill = 1;
#else
  if (ptr) 
    delete[] ptr;
  ptr  = new T[len];
#endif
}

template<class T> void XplPtr<T>::xfree ()
{ if (ptr)
  { 
#ifdef MEMDEBUG 
    if (kill) xmem.delptr(ptr);
    ptr = NULL;
    from = to = 0;
    kill = 0;
#else
    delete[] ptr;
#endif
  }
}

template<class T> XplPtr<T> XplPtr<T>::operator+ (long i)
{ XplPtr<T> ret; 
#ifdef MEMDEBUG
  if ((i<from) || (i>=to))
  { printf ("Error: Access violation\n");
    exit(9);
  }
  ret.kill = 0;
  ret.from = from-i;
  ret.to   = to-i;
  if (i==0)
    printf ("Warning: Delete conflict may occur\n");
#endif
  ret.ptr = ptr+i;
  return (ret);
}

template<class T> T& XplPtr<T>::operator* ()
{ 
#ifdef MEMDEBUG
  if (ptr==NULL)
  { printf ("Error: Access to NULL pointer\n");
    exit(9);
  }
#endif
  return (*ptr);
}

template<class T> T& XplPtr<T>::operator[] (long i)
{ 
#ifdef MEMDEBUG
  if (ptr==NULL)
  { printf ("Error: Access to NULL pointer\n");
    exit(9);
  }
  if ((i<from) || (i>=to))
  { printf ("Error: Access violation\n");
    exit(9);
  }
#endif
  return (*ptr);
}

template class XplPtr<int>;
template class XplPtr<long>;
template class XplPtr<double>;
/*
template class XplPtr<xplmask>;
template class XplPtr<xplstring>;
*/
