/* $Header: /home/xplore/cvs/xpl4gr/xnew.hpp,v 1.3 2002/08/16 12:31:56 sigbert Exp $ */

#include <stdio.h>
#include <stdlib.h>

#ifndef XPLMEMORY
#define XPLMEMORY

class XPtr
{ void *ptr;
  char *classn, *proc, *var;
  XPtr *next;
  long val, size;

  public:

  XPtr ();
  XPtr* set (void *p, char *cn, char *pn, char *vn, long nv, long ptrsize);
  XPtr* getnext ();
  char* getproc ();
  char* getclass ();
  char* getvar ();
  void* getptr ();
  long getval ();
  long getsize ();
  void setnext (XPtr *newnext);
  int has (void *p);

};

class XMemory
{ XPtr *root, *last;
  long id, val;

  public:

  XMemory ();
  ~XMemory ();
  void dump (int d = 0);
  void *newptr (long size, long s, char *cn, char *pn, char *vn);
  void delptr (void *p);
  int operator++ (void);
  int operator-- (void);
};

extern XMemory xmem;

template<class T> class XplPtr {
  T *ptr;
#ifdef MEMDEBUG
  long from, to;
  int kill;
#endif

  public:

  inline XplPtr ();
  inline ~XplPtr ();

  inline void xmalloc (long len, char *cn, char *pn, char *vn);
  inline void xfree ();

  inline XplPtr<T> operator+ (long i);
  inline T& operator*  (void);
  inline T& operator[] (long i);

};

#endif



