/* $Header: /home/xplore/cvs/xpl4gr/xnewf.C,v 1.3 2002/08/16 12:31:56 sigbert Exp $ */

// #ifdef TTKDEBUG
#include "machine.h"

#include "xnew.hpp"
#include "xio.h"
#include "xnewf.h"

#ifdef HAS_STRCMPI
#define strcasecmp strcmpi
#endif

extern Vector<Function*> *funList;

int dohlp2html (int argc, char *argv[]);

XplObject* xaMemDebug (Liste<XplObject*> *argl)
{
  long   i, length = argl->laenge ();
  XplObject *obj;
  XplDouble *x;

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
  { globalError.Set (ERR_INP, "xaMemDebug:  first argument");
    return (NULL);
  }
  if (length > 1)
  { globalError.Set (ERR_INP, "xaMemDebug:  only one argument expected");
    return (NULL);
  }

  if ((*x)(0)<-0.5)
    --xmem;
  else if ((*x)(0)>0.5)
    ++xmem;
  else
    xmem.dump();
  return (NULL);
}



// PC - new xaReadASCII 20020219
XplObject* xaReadASCII (Liste<XplObject*> *argl)
{
  XplObject *o, *o1, *o2;
  XplDouble *cond;
  XplLong *rowlist, *collist, *rowconds, *colconds;
  XplChar *res;
  XplArray<long> *type;
  XplDouble *rx;
  char *fn, *sep;
  const char *ffn, *ssep;
  int check;
  int multisep;

  if ((argl->laenge ()<2)||(argl->laenge ()>8))
  {
    globalError.Set (ERR_ARGS, "readascii: Must have 2 to 8 parameters");
    return (NULL);
  }

  if ((*argl)[0]->DefaultComponent()->Type() == C_TEXT)
  {
#ifdef _XPLCDEF_
    ffn = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    ffn = (*argl)[0]->DefaultComponent()->Content().text;
#endif
  }
  else
  {
    globalError.Set (ERR_TEXT, "readascii: in arg1 filename expected");
    return (NULL);
  }

  if (argl->laenge ()>2)
  { if ((*argl)[2]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
      globalError.Set (ERR_NUM, "readascii: in arg3 number expected");
      return (NULL);
    }

    rx = (*argl)[2]->DefaultXplDouble();
    check = (int) (*rx)[0];
  }
  else
    check = 1;

  if ((*argl)[1]->DefaultComponent()->Type() == C_TEXT)
  {
#ifdef _XPLCDEF_
    ssep = (*(*argl)[1]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    ssep = (*argl)[1]->DefaultComponent()->Content().text;
#endif
  }
  else
  {
    globalError.Set (ERR_TEXT, "readascii: in arg2 seperator chars expected");
    return (NULL);
  }

// new parameters
  // multiple separators are taken as one?
  if (argl->laenge ()>=4)
  { if ((*argl)[3]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
      globalError.Set (ERR_NUM, "readascii: in arg4 number expected");
      return (NULL);
    }

    rx = (*argl)[3]->DefaultXplDouble();
    multisep = (int) (*rx)[0];
  }
  else
    multisep = 1;

     // row list
     if (argl->laenge () >= 5)
     {
          cond = (*argl)[4]->DefaultXplDouble ();

          if (cond == NULL)
          {
               globalError.Set (ERR_NUM, "readVar:  fourth argument");
               return (NULL);
          }
          if ((cond->dim(1) == 2) && (cond->dim.prod(2) == cond->dim.prod(MAX_XARRAY)))
          {
               rowlist = new XplLong (1);
               *rowlist = cast (*cond);
          }
          else
          {
               rowlist = NULL;
          }
     }
     else
     {
          rowlist = NULL;
     }

     // col list
     if (argl->laenge () >= 6)
     {
          cond = (*argl)[5]->DefaultXplDouble ();

          if (cond == NULL)
          {
               globalError.Set (ERR_NUM, "readVar:  fifth argument");
               return (NULL);
          }
          if ((cond->dim(1) == 2) && (cond->dim.prod(2) == cond->dim.prod(MAX_XARRAY)))
          {
               collist = new XplLong (1);
               *collist = cast (*cond);
          }
          else
          {
               collist = NULL;
          }
     }
     else
     {
          collist = NULL;
     }

     // row conds
     if (argl->laenge () >= 7)
     {
          cond = (*argl)[6]->DefaultXplDouble ();

          if (cond == NULL)
          {
               globalError.Set (ERR_NUM, "readVar:  sixth argument");
               return (NULL);
          }

          if (cond->dim.prod(MAX_XARRAY) > 1)
          {
               rowconds = new XplLong (1);
               *rowconds = cast (*cond);
          }
          else
          {
               rowconds = NULL;
          }
     }
     else
     {
          rowconds = NULL;
     }

     // col conds
     if (argl->laenge () >= 8)
     {
          cond = (*argl)[7]->DefaultXplDouble ();

          if (cond == NULL)
          {
               globalError.Set (ERR_NUM, "readVar:  seventh argument");
               return (NULL);
          }


          if (cond->dim.prod(MAX_XARRAY) > 1)
          {
               colconds = new XplLong (1);
               *colconds = cast (*cond);
          }
          else
          {
               colconds = NULL;
          }
     }
     else
     {
          colconds = NULL;
     }

// end of new parameters

  fn   = strdup(ffn);
  sep  = strdup(ssep);
  res  = new XplChar(1);
  type = new XplArray<long>(1);

  if (ReadASCIIData (fn, sep, res, type, check, multisep, rowlist, collist, rowconds, colconds)==0)
  {
    globalError.Set  (ERR_FILE, "readascii: ");
    globalError.AppendText  (ERR_FILE, fn);
    delete fn;
    delete sep;
    delete res;
    return (NULL);  
  }

  rx = new XplDouble(1);
  *rx = cast(*type);
  o1 = new XplObject (res, "data");
  o2 = new XplObject (rx, "type");

  o  = new XplObject ("readascii");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));

//  o->SetDefaultXplDouble ();    // only for sure

  delete fn;
  delete sep;
  delete type;
  return (o);
}

// PC ReadASCII is rewritten ^^^
//XplObject* xaReadASCII (Liste<XplObject*> *argl)
//{
//  XplObject *o, *o1, *o2;
//  XplLong *rowlist, *collist, *rowconds, *colconds;
//  XplChar *res;
//  XplArray<long> *type;
//  XplDouble *rx;
//  char *fn, *sep;
//  const char *ffn, *ssep;
//  int check;
//
//  if ((argl->laenge ()<2)||(argl->laenge ()>3)) 
//  {
//    globalError.Set (ERR_ARGS, "readascii: Must be 2 or 3");
//    return (NULL);
//  }
//
//  if ((*argl)[0]->DefaultComponent()->Type() == C_TEXT)
//  {
//#ifdef _XPLCDEF_
//    ffn = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
//#else
//    ffn = (*argl)[0]->DefaultComponent()->Content().text;
//#endif
//  }
//  else
//  {
//    globalError.Set (ERR_TEXT, "readascii: in arg1 filename expected");
//    return (NULL);
//  }
//
//  if (argl->laenge ()>2)
//  { if ((*argl)[2]->DefaultComponent()->Type() != C_XPLDOUBLE)
//    {
//      globalError.Set (ERR_NUM, "readascii: in arg3 number expected");
//      return (NULL);
//    }
//
//    rx = (*argl)[2]->DefaultXplDouble();
//    check = (int) (*rx)[0];
//  }
//  else
//    check = 1;
//
//  if ((*argl)[1]->DefaultComponent()->Type() == C_TEXT)
//  {
//#ifdef _XPLCDEF_
//    ssep = (*(*argl)[1]->DefaultComponent()->Content().xplchar)(0).tocstr();
//#else
//    ssep = (*argl)[1]->DefaultComponent()->Content().text;
//#endif
//  }
//  else
//  {
//    globalError.Set (ERR_TEXT, "readascii: in arg2 seperator chars expected");
//    return (NULL);
//  }
//
//  fn   = strdup(ffn);
//  sep  = strdup(ssep);
//  res  = new XplChar(1);
//  type = new XplArray<long>(1);
//
//  if (ReadASCIIData (fn, sep, res, type, check)==0)
//  {
//    globalError.Set  (ERR_FILE, "readascii: ");
//    globalError.AppendText  (ERR_FILE, fn);
//    delete fn;
//    delete sep;
//    delete res;
//    return (NULL);  
//  }
//
//  rx = new XplDouble(1);
//  *rx = cast(*type);
//  o1 = new XplObject (res, "data");
//  o2 = new XplObject (rx, "type");
//
//  o  = new XplObject ("readascii");
//
//  o->AppendComponent (new Component (o1));
//  o->AppendComponent (new Component (o2));
//
////  o->SetDefaultXplDouble ();    // only for sure
//
//  delete fn;
//  delete sep;
//  delete type;
//  return (o);
//}

XplObject* xaSvd (Liste<XplObject*> *argl)
{
  XplObject *o, *o1, *o2, *o3;
  XplDouble *rx, *ru, *rl, *rv;

  if (argl->laenge ()!=1)
  {
    globalError.Set (ERR_ARGS, "svd: Must be 1");
    return (NULL);
  }

  if ((*argl)[0]->DefaultComponent()->Type() == C_XPLDOUBLE)
  { rx = (*argl)[0]->DefaultXplDouble();
  }
  else
  {
    globalError.Set (ERR_NUM, "svd: in arg1 numeric matrix expected");
    return (NULL);
  }

  ru = new XplDouble(1);
  rl = new XplDouble(1);
  rv = new XplDouble(1);
      
  rx->svd (ru, rl, rv);
  if (globalError.Get())       //delete vals vecs
  {
    delete ru;
    delete rl;
    delete rv;
    return (NULL);
  
  }

  o1 = new XplObject (ru, "u");
  o2 = new XplObject (rl, "l");
  o3 = new XplObject (rv, "v");

  o  = new XplObject ("svd");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));
  o->AppendComponent (new Component (o3));

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}

// SK 02.09.97
XplObject* xaKmeans (Liste<XplObject*> *argl)
{
/*      ( g     c     v     s ) = KMEANS ( x     b    (r)   (w)   (m) )       */

  XplObject *o, *o1, *o2, *o3, *o4;
  XplDouble *rg, *rc, *rv, *rs, *rx, *rb, *rr, *rw, *rm;
  XplLong *lb, *lg, *lr;

  lb = lr = NULL;
  rb = rr = NULL;
  rw = NULL;
  rm = NULL;
  switch (argl->laenge())
  { case 5 : 
      if ((*argl)[4]->DefaultComponent()->Type() == C_XPLDOUBLE)
        rm = (*argl)[4]->DefaultXplDouble();
      else
      { globalError.Set (ERR_NUM, "kmeans: in arg5 numeric matrix expected");
        return (NULL);
      }
    case 4 :
      if ((*argl)[3]->DefaultComponent()->Type() == C_XPLDOUBLE)
        rw = (*argl)[3]->DefaultXplDouble();
      else
      { globalError.Set (ERR_NUM, "kmeans: in arg4 numeric matrix expected");
        return (NULL);
      }
    case 3 :
      if ((*argl)[2]->DefaultComponent()->Type() == C_XPLDOUBLE)
        rr = (*argl)[2]->DefaultXplDouble();
      else
      { globalError.Set (ERR_NUM, "kmeans: in arg3 numeric matrix expected");
        return (NULL);
      }
      lr  = new XplLong(1);
      *lr = cast (*rr);
    case 2 :
      if ((*argl)[1]->DefaultComponent()->Type() == C_XPLDOUBLE)
        rb = (*argl)[1]->DefaultXplDouble();
      else
      { globalError.Set (ERR_NUM, "kmeans: in arg2 numeric matrix expected");
        return (NULL);
      }
      lb = new XplLong(1);
      *lb = cast (*rb);
      if ((*argl)[0]->DefaultComponent()->Type() == C_XPLDOUBLE)
        rx = (*argl)[0]->DefaultXplDouble();
      else
      { globalError.Set (ERR_NUM, "kmeans: in arg1 numeric matrix expected");
        return (NULL);
      }
      break;
    default:
      globalError.Set (ERR_ARGS, "kmeans: Must be 2 to 5 args");
      return (NULL);
  } 

  rg = new XplDouble(1);
  lg = new XplLong(1);
  rc = new XplDouble(1);
  rv = new XplDouble(1);
  rs = new XplDouble(1);
      
//  printf ("b[0]=%li\n", (*lb)(0));
//  (rx->dim).dump();
  rx->xplkmeans (*lb, lr, lg, rc, rv, rs, rw, rm);

  if (globalError.Get())       //delete vals vecs
  {
    delete lr;
    delete lb;
    delete lg;
    delete rg;
    delete rc;
    delete rv;
    delete rs;
    return (NULL);
  }

  *rg = cast (*lg);

  o1 = new XplObject (rg, "g");
  o2 = new XplObject (rc, "c");
  o3 = new XplObject (rv, "v");
  o4 = new XplObject (rs, "s");

  o  = new XplObject ("kmeans");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));
  o->AppendComponent (new Component (o3));
  o->AppendComponent (new Component (o4));

  o->SetDefaultXplDouble ();    // only for sure

  delete lr;
  delete lb;
  delete lg;

  return (o);
}

// SK 02.09.97
XplObject* xaAgglom (Liste<XplObject*> *argl)
{
/*   (  p      t       g   pd d) = AGGLOM (   d    mtd    l   (b)    (w) ) 
*/
  XplObject *o, *o1, *o2, *o3, *o4, *o5;
  XplDouble *rw, *rd, *rr, *rp, *rt, *rg, *rpd, *rdd;
  XplNumber<long> lr(1);
  const char *sep;
  long imtd;

  rw = NULL;
  switch (argl->laenge())
  {  case 4 :
      if ((*argl)[3]->DefaultComponent()->Type() == C_XPLDOUBLE)
        rw = (*argl)[3]->DefaultXplDouble();
      else
      { globalError.Set (ERR_NUM, "agglom: in arg4 numeric matrix expected");
        return (NULL);
      }
    case 3 :
      if ((*argl)[2]->DefaultComponent()->Type() == C_XPLDOUBLE)
        rr = (*argl)[2]->DefaultXplDouble();
      else
      { globalError.Set (ERR_NUM, "agglom: in arg3 numeric matrix expected");
        return (NULL);
      }
      lr = cast (*rr);

      if ((*argl)[1]->DefaultComponent()->Type() == C_TEXT)
      {
#ifdef _XPLCDEF_
        sep = (*(*argl)[1]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
        sep = (*argl)[1]->DefaultComponent()->Content().text;
#endif
      }
      else
      {
        globalError.Set (ERR_TEXT, "agglom: in arg2 method name expected");
        return (NULL);
      }
      imtd = 0;
      if (!strcasecmp("SINGLE", sep))        imtd = 1;
      if (!strcasecmp("COMPLETE", sep))      imtd = 2;
      if (!strcasecmp("MEAN_LINK", sep))     imtd = 3;
      if (!strcasecmp("MEDIAN_LINK", sep))   imtd = 4;
      if (!strcasecmp("AVERAGE", sep))       imtd = 5;
      if (!strcasecmp("CENTROID", sep))      imtd = 6;
      if (!strcasecmp("WARD", sep))          imtd = 7;
      if (!strcasecmp("LANCE", sep))         imtd = 8;

      if ((*argl)[0]->DefaultComponent()->Type() == C_XPLDOUBLE)
        rd = (*argl)[0]->DefaultXplDouble();
      else
      { globalError.Set (ERR_NUM, "agglom: in arg1 numeric matrix expected");
        return (NULL);
      }
      break;
    default:
      globalError.Set (ERR_ARGS, "agglom: Must be 3 or 4");
      return (NULL);
  } 

//printf ("Imtd=%i\n", imtd);
//rd.dump();

  rp  = new XplDouble(1);
  rt  = new XplDouble(1);
  rg  = new XplDouble(1);
  rpd = new XplDouble(1);
  rdd = new XplDouble(1);

  rd->xplagglom (imtd, lr, rp, rt, rg, rpd, rdd, rw);

  if (globalError.Get())       //delete vals vecs
  {
    delete rp;
    delete rt;
    delete rg;
    delete rpd;
    delete rdd;
//    if (rw) delete[] rw;
    return (NULL);
  }

  o1 = new XplObject (rp, "p");
  o2 = new XplObject (rt, "t");
  o3 = new XplObject (rg, "g");
  o4 = new XplObject (rpd, "pd");
  o5 = new XplObject (rdd, "d");

  o  = new XplObject ("agglom");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));
  o->AppendComponent (new Component (o3));
  o->AppendComponent (new Component (o4));
  o->AppendComponent (new Component (o5));

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}

// SK 02.09.97
XplObject* xaTree (Liste<XplObject*> *argl)
{
/*   (t) = AGGLOM (ta c (opt)) 
*/
  const char *argv;
  XplChar *opttxt;
  XplDouble *tmat, *gmat, *cmat, *imat;
  double cut;
  long i, opt = 0;
  XplObject *o;

  switch (argl->laenge())
  { case 3:
      if ((*argl)[2]->DefaultComponent()->Type() == C_TEXT)
      {
#ifdef _XPLCDEF_
        opttxt = (*argl)[2]->DefaultComponent()->Content().xplchar;
        for (i=0; i<(*opttxt).size(); i++)
        { argv = (*opttxt)(0).tocstr();
          if (!strcmp(argv,"LEFT"))
          { opt = opt & 0xfc; }
          else if (!strcmp(argv,"RIGHT"))
          { opt = 0x02 | (opt & 0xfa); }
          else if (!strcmp(argv,"CENTER"))
          { opt = 0x01 | (opt & 0xfc); }
          else if (!strcmp(argv,"YAXIS"))
          { opt = (opt & 0xfb); }
          else if (!strcmp(argv,"XAXIS"))
          { opt = 0x04 | (opt & 0xfb); }
          else if (!strcmp(argv,"GREATER"))
          { opt = 0x08 | (opt & 0xf7); }
          else if (!strcmp(argv,"SMALLER"))
          { opt = opt & 0xf7; }
          else if (!strcmp(argv,"SQUARE"))
          { opt = opt & 0xef; }
          else if (!strcmp(argv,"TRIANGLE"))
          { opt = 0x10 | (opt & 0xef); }
          else 
	  { globalError.Set (PARAMFALSE, "tree: unknown option");
            return (NULL);
          }
        }
#else
         globalError.Set (ERR_TEXT, "tree: in arg3 textmatrix expected");
#endif
      }
      else
      { globalError.Set (ERR_TEXT, "tree: in arg3 textmatrix expected");
        return (NULL);
      }
    case 2:
      if ((*argl)[1]->DefaultComponent()->Type() != C_XPLDOUBLE)
      {
        globalError.Set (ERR_NUM, "tree: in arg2 number expected");
        return (NULL);
      }

      cmat = (*argl)[1]->DefaultXplDouble();
      cut  = (*cmat)[0];
      if ((*argl)[0]->DefaultComponent()->Type() != C_XPLDOUBLE)
      {
        globalError.Set (ERR_NUM, "tree: in arg1 number matrix expected");
        return (NULL);
      }
      tmat = (*argl)[0]->DefaultXplDouble();
      break;
    default:
       globalError.Set (ERR_ARGS, "tree: args must be 2 or 3");
       return (NULL);
  }

  gmat = new XplDouble(1);
  imat = new XplDouble(1);

//printf ("xpltree(%f, %li)\n", cut, opt);
  tmat->xpltree (cut, opt, gmat, imat);  
   
  if (globalError.Get())       //delete vals vecs
  {
    delete gmat;
    return (NULL);
  }

  o  = new XplObject ("tree");

  o->AppendComponent (new Component (new XplObject (gmat, "points")));
  o->AppendComponent (new Component (new XplObject (imat, "index")));
  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}

// SK 02.09.97
XplObject* xaDistance (Liste<XplObject*> *argl)
{
/*   (t) = DISTANCE (x mtd (w)) 
*/
  const char *sep;
  XplChar *opttxt;
  XplDouble *xmat, *tmat, *wmat;
  long i, opt = 0;
  int imtd;

  wmat = NULL;
  imtd = 0;
  switch (argl->laenge())
  { case 3: 
      if ((*argl)[2]->DefaultComponent()->Type() == C_XPLDOUBLE)
        wmat = (*argl)[2]->DefaultXplDouble();
      else
      { globalError.Set (ERR_NUM, "distance: in arg3 numeric matrix expected");
        return (NULL);
      }
    case 2:
      if ((*argl)[1]->DefaultComponent()->Type() == C_TEXT)
      {
#ifdef _XPLCDEF_
        sep = (*(*argl)[1]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
        sep = (*argl)[1]->DefaultComponent()->Content().text;
#endif
      }
      else
      {
        globalError.Set (ERR_TEXT, "distance: in arg2 method name expected");
        return (NULL);
      }

      if (!strcasecmp("EUCLID", sep))        imtd = 1;
      if (!strcasecmp("L2", sep))            imtd = 1;
      if (!strcasecmp("L1", sep))            imtd = 2;
      if (!strcasecmp("MAXIMUM", sep))       imtd = 3;
      if (!strcasecmp("COSINE", sep))        imtd = 4;
      if (!strcasecmp("CHISQUARE", sep))     imtd = 5;
      if (!strcasecmp("CENTROID", sep))      imtd = 6;
      if (!strcasecmp("TANIMOTO", sep))      imtd = 7;
      if (!strcasecmp("MATCHING", sep))      imtd = 8;

      if (imtd==0)
      {
        globalError.Set (ERR_TEXT, "distance: in arg2 invalid method name found");
        return (NULL);
      }


    case 1:
      if (imtd==0) imtd = 1;

      if ((*argl)[0]->DefaultComponent()->Type() != C_XPLDOUBLE)
      {
        globalError.Set (ERR_NUM, "tree: in arg1 number matrix expected");
        return (NULL);
      }
      xmat = (*argl)[0]->DefaultXplDouble();
      break;

    default:
       globalError.Set (ERR_ARGS, "distance: args must be 1, 2 or 3");
       return (NULL);
  }

  tmat = new XplDouble(1);

  xmat->xpldistance (imtd, tmat, wmat);

  if (globalError.Get())       //delete vals vecs
    return (NULL);

  return (new XplObject (tmat, "distance"));

}

// SK 08.09.97
XplObject* xaFwt2 (Liste<XplObject*> *argl)
{ XplDouble *xmat, *timat, *lmat, *imat, *hmat;
  long level, asm_index;

  if (argl->laenge()!=4)
  { globalError.Set (ERR_ARGS, "fwt2: args must be 4");
    return (NULL);
  }

  if ((*argl)[0]->DefaultComponent()->Type() != C_XPLDOUBLE)
  {
    globalError.Set (ERR_NUM, "fwt2: in arg1 number matrix expected");
    return (NULL);
  }
  xmat = (*argl)[0]->DefaultXplDouble();
 
  if ((*argl)[2]->DefaultComponent()->Type() != C_XPLDOUBLE)
  {
    globalError.Set (ERR_NUM, "fwt2: in arg3 number matrix expected");
    return (NULL);
  }
  hmat = (*argl)[2]->DefaultXplDouble();
 
  if ((*argl)[1]->DefaultComponent()->Type() != C_XPLDOUBLE)
  {
    globalError.Set (ERR_NUM, "fwt2: in arg2 number matrix expected");
    return (NULL);
  }
  lmat = (*argl)[1]->DefaultXplDouble();
  level = (long) (*lmat)(0);

  if ((*argl)[3]->DefaultComponent()->Type() != C_XPLDOUBLE)
  {
    globalError.Set (ERR_NUM, "fwt2: in arg4 number matrix expected");
    return (NULL);
  }

  imat = (*argl)[3]->DefaultXplDouble();
  asm_index = (long) (*imat)(0);

  timat = new XplDouble(1);

  xmat->fwt2 (timat, hmat, level, asm_index);
  if (globalError.Get())       //delete vals vecs
  {
    delete timat;   
    return (NULL);
  
  }

  return (new XplObject (timat, "fwt2"));
}

// SK 08.09.97
XplObject* xaInvfwt2 (Liste<XplObject*> *argl)
{ XplDouble *xmat, *timat, *lmat, *imat, *hmat;
  long level, asm_index;

  if (argl->laenge()!=4)
  { globalError.Set (ERR_ARGS, "invfwt2: args must be 4");
    return (NULL);
  }

  if ((*argl)[0]->DefaultComponent()->Type() != C_XPLDOUBLE)
  {
    globalError.Set (ERR_NUM, "invfwt2: in arg1 number matrix expected");
    return (NULL);
  }
  xmat = (*argl)[0]->DefaultXplDouble();

  if ((*argl)[2]->DefaultComponent()->Type() != C_XPLDOUBLE)
  {
    globalError.Set (ERR_NUM, "invfwt2: in arg3 number matrix expected");
    return (NULL);
  }
  hmat = (*argl)[2]->DefaultXplDouble();
 
  if ((*argl)[1]->DefaultComponent()->Type() != C_XPLDOUBLE)
  {
    globalError.Set (ERR_NUM, "invfwt2: in arg2 number matrix expected");
    return (NULL);
  }
  lmat = (*argl)[1]->DefaultXplDouble();
  level = (long) (*lmat)(0);

  if ((*argl)[3]->DefaultComponent()->Type() != C_XPLDOUBLE)
  {
    globalError.Set (ERR_NUM, "invfwt2: in arg4 number matrix expected");
    return (NULL);
  }
  imat = (*argl)[3]->DefaultXplDouble();
  asm_index = (long) (*imat)(0);

  timat = new XplDouble(1);

  xmat->invfwt2 (timat, hmat, level, asm_index);
  if (globalError.Get())       //delete vals vecs
  {
    delete timat;   
    return (NULL);
  
  }

  return (new XplObject (timat, "invfwt2"));
}

// SK 29.09.97
XplObject*	xaDwt (Liste<XplObject*> *argl)
{
  long      i, length = argl->laenge ();
  XplDouble *x, *levd, *h, *a, *b;
  XplLong   levl(1);
  XplObject *o, *o1, *o2;
  char      text[TEXTLENGTH];
 
  if (length != 3)
    {
    globalError.Set (ERR_ARGS, "dwt: Must be 3");
    return (NULL);
    }

for (i=0; i<length; i++)
  if ((*argl)[i]->DefaultType () != C_XPLDOUBLE)
    {
    sprintf (text, "dwt: %d. argument", i);
    globalError.Set (ERR_NUM, text);
    return (NULL);
    }

  x    = (*argl)[0]->DefaultXplDouble ();
  levd = (*argl)[1]->DefaultXplDouble ();
  h    = (*argl)[2]->DefaultXplDouble ();

  levl = cast (*levd);

  a = new XplDouble(1);

  x->dwt (levl, *h, *a);

  if (globalError.Get())     // delete a
    {
    delete a;
    return (NULL);
    }

  return ( new XplObject (a, "d"));
}

XplObject*	xaInvDwt (Liste<XplObject*> *argl)
{
  long      i, length = argl->laenge ();
  XplDouble *r, *a, *b, *nd, *ld, *h;
  XplLong   n(1), l(1);
  char      text[TEXTLENGTH];
 
  if (length != 3)
    {
    globalError.Set (ERR_ARGS, "invdwt: Must be 3");
    return (NULL);
    }

for (i=0; i<length; i++)
  if ((*argl)[i]->DefaultType () != C_XPLDOUBLE)
    {
    sprintf (text, "invdwt: %d. argument", i);
    globalError.Set (ERR_NUM, text);
    return (NULL);
    }

  a    = (*argl)[0]->DefaultXplDouble ();
  ld   = (*argl)[1]->DefaultXplDouble ();
  h    = (*argl)[2]->DefaultXplDouble ();

  l = cast (*ld);
  r = new XplDouble(1);

  a->invdwt (*r, l, *h);

  if (globalError.Get())    // delete r
    {
    delete r;
    return (NULL);
    }

  return (new XplObject (r, "invdwt"));
}

XplObject*	xaCartSplit (Liste<XplObject*> *argl)
{
  long      i, j, length = argl->laenge (), nn, nmingrp, nmaxgrp;
  XplDouble *x=NULL, *y=NULL, *n=NULL, *d=NULL, *vec=NULL, *mean=NULL,
             *var=NULL, *nelem=NULL, *t=NULL, *endpoint=NULL;
  double    vmaxgrp;
  XplObject *o=NULL, *o1=NULL, *o2=NULL, *o3=NULL, *o4=NULL, *o5=NULL, *o6=NULL;
  char      text[32768], buf[256];
  XplChar   *val=NULL;
  CartSplit *cs=NULL; 
  Component *c=NULL;

  if ((length != 4) && (length != 3)) 
  {
    globalError.Set (ERR_ARGS, "cartsplit: Must be 3 or 4");
    return (NULL);
  }

  for (i=0; i<length; i++)
    if ((*argl)[i]->DefaultType () != C_XPLDOUBLE)
    { sprintf (text, "cartsplit: %d. argument", i);
      globalError.Set (ERR_NUM, text);
      return (NULL);
    }

  x   = (*argl)[0]->DefaultXplDouble ();
  y   = (*argl)[1]->DefaultXplDouble ();
  t   = (*argl)[2]->DefaultXplDouble ();

  nmaxgrp = 1;
  nmingrp = 1;
  vmaxgrp = 0;
  
  if (length==4)
  { i = 0;
    c   = (*argl)[3]->GetComponent("mincut");
    if (c)
    { n = c->Content().xplobject->DefaultXplDouble ();
      if (n) 
      { nmaxgrp = (long) (*n)(0);
        i++;
      }
      else
      { globalError.Set (ERR_NUM, "cartsplit: numeric argument for opt.minsize expected");      
        return NULL;
      }
    }  

    c   = (*argl)[3]->GetComponent("minsize");
    if (c)
    { n = c->Content().xplobject->DefaultXplDouble ();
      if (n)
      { nmingrp = (long) (*n)(0);
        i++;
      }
      else
      { globalError.Set (ERR_NUM, "cartsplit: numeric argument for opt.mincut expected");      
        return NULL;
      }
    }  

    c   = (*argl)[3]->GetComponent("mindev");
    if (c)
    { n = c->Content().xplobject->DefaultXplDouble ();
      if (n) 
      { vmaxgrp = (*n)(0);
        i++;
        if (vmaxgrp<0)
        { globalError.Set (ERR_VAL, "cartsplit: split deviation < 0");      
          return NULL;
        }
      }
      else
      { globalError.Set (ERR_NUM, "cartsplit: numeric argument for opt.mindev expected");      
        return NULL;
      }
    }  

    if (i==0)
    { globalError.Set (ERR_VAL, "cartsplit: optional parameter given, but not used");      
      return (NULL);
    }
  }
// printf ("%i %i %f\n", nmaxgrp, nmingrp, vmaxgrp);

  d = new XplDouble(1);
  (*d)(0) = 0.0;
  vec      = new XplDouble(1);
  mean     = new XplDouble(1);
  var      = new XplDouble(1);
  nelem    = new XplDouble(1);
  endpoint = new XplDouble(1);
  cs       = new CartSplit(1+2*(x->dim(0)));

  x->cartsplit (*y, *d, *t, *n, vec, cs, mean, var, nelem, nmaxgrp, nmingrp, vmaxgrp, endpoint);

  delete d;

  if (globalError.Get())    // delete r
  { delete vec;
    delete cs;
    return (NULL);
  }
  
  o1  = new XplObject ("val");
  for (i=0; i<cs->length(); i++)
  { if ((*cs)(0,i))
    { val = new XplChar(2);
      text[0] = 0;
      for (j=0; j<(*cs)(1,i); j++)
      { sprintf (buf, "%g", (*cs)(1,i,j));
        strcat(text, buf);
        if (j<(*cs)(1,i)-1) strcat(text, ",");
      }
#ifdef WIN32
      XplChar rt_help(1);
	  (*val)(0) = rt_help(0) = xplstring(text);
#else
      (*val)(0) = xplstring(text);
#endif
      text[0] = 0;
      for (j=0; j<(*cs)(0,i); j++)
      { sprintf (buf, "%g", (*cs)(0,i,j));
        strcat(text, buf);
        if (j<(*cs)(0,i)-1) strcat(text, ",");
      }
#ifdef WIN32
//      XplChar rt_help(1);
	  (*val)(1) = rt_help(0) = xplstring(text);
#else
      (*val)(1) = xplstring(text);
#endif
    }
    else
    { val = new XplChar(1);
      text[0] = 0;
      for (j=0; j<(*cs)(1,i); j++)
      { sprintf (buf, "%g", (*cs)(1,i,j));
        strcat(text, buf);
        if (j<(*cs)(1,i)-1) strcat(text, ",");
      }
#ifdef WIN32
      XplChar rt_help(1);
	  (*val)(0) = rt_help(0) = xplstring(text);
#else
      (*val)(0) = xplstring(text);
#endif
    }
    sprintf (text, "split%i", i);
    o1->AppendComponent (new Component (new XplObject (val, text)));
  }
  delete cs;

  o2 = new XplObject (vec, "vec");
  o3 = new XplObject (mean, "mean");
  o4 = new XplObject (var, "ssr");
  o5 = new XplObject (nelem, "nelem");
  o6 = new XplObject (endpoint, "endpoint");

  o  = new XplObject ("cs");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));
  o->AppendComponent (new Component (o3));
  o->AppendComponent (new Component (o4));
  o->AppendComponent (new Component (o5));
  o->AppendComponent (new Component (o6));

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}

// SK 07.01.98
XplObject* xaChar (Liste<XplObject*> *argl)
{ XplChar *c;
  XplDouble *x;

  if (argl->laenge()!=1)
  { globalError.Set (ERR_ARGS, "char: args must be 1");
    return (NULL);
  }

  if ((*argl)[0]->DefaultComponent()->Type() != C_XPLDOUBLE)
  {
    globalError.Set (ERR_NUM, "char: in arg number matrix expected");
    return (NULL);
  }

  x = (*argl)[0]->DefaultXplDouble();
 
  c = new XplChar(1);

  c->makechar (x);

  if (globalError.Get())       
  {
    delete c;
    return (NULL);
  
  }

  return (new XplObject (c, "char"));
}

// SK 24.02.98
XplObject* xaEiggn (Liste<XplObject*> *argl)
{ long length = argl->laenge ();
  XplDouble *re, *im, *vecr, *veci, *valr, *vali;
  Component *c=NULL;
  XplObject *o, *o1, *o2, *o3, *o4;

  switch (length)
  { case 1:
      c = (*argl)[0]->GetComponent("re");
      if (c)
      { re = c->Content().xplobject->DefaultXplDouble ();
        c = (*argl)[0]->GetComponent("im");
        im = c->Content().xplobject->DefaultXplDouble ();
      }
      else
      { re = (*argl)[0]->DefaultXplDouble();
        im = NULL;
      }
      break;
    case 2:
      if ((*argl)[0]->DefaultComponent()->Type() != C_XPLDOUBLE)
      { globalError.Set (ERR_NUM, "eiggn: in arg1 number matrix expected");
        return (NULL);
      }
      if ((*argl)[1]->DefaultComponent()->Type() != C_XPLDOUBLE)
      { globalError.Set (ERR_NUM, "eiggn: in arg2 number matrix expected");
        return (NULL);
      }
      re = (*argl)[0]->DefaultXplDouble();
      im = (*argl)[1]->DefaultXplDouble();
      break;
    default:
      globalError.Set (ERR_ARGS, "eiggn: args must be 1 or 2");
      return (NULL); 
  }

  vecr = new XplDouble(1);
  veci = new XplDouble(1);
  valr = new XplDouble(1);
  vali = new XplDouble(1);

  re->eiggn (vecr, veci, valr, vali, im);

  if (globalError.Get())       
  { delete vecr;
    delete veci;
    delete valr;
    delete vali;
    return (NULL);
  }

  o1 = new XplObject (vecr, "re");
  o2 = new XplObject (veci, "im");
  o3 = new XplObject ("vectors");
  o3->AppendComponent (new Component (o1));
  o3->AppendComponent (new Component (o2));

  o1 = new XplObject (valr, "re");
  o2 = new XplObject (vali, "im");
  o4 = new XplObject ("values");
  o4->AppendComponent (new Component (o1));
  o4->AppendComponent (new Component (o2));
  
  o = new XplObject ("eigwv");
  o->AppendComponent (new Component (o4));
  o->AppendComponent (new Component (o3));
  
  o->SetDefaultXplDouble ();    // only for sure
  return (o);
}

typedef char* charp;

XplObject* xaMakehelp (Liste<XplObject*> *argl)
{ long length = argl->laenge ();
  XplChar *type, *idir, *odir;

  int argc, i, j, ts;
  char buffer[16];
  charp *argv;

  if ((length<2) || (length>3))
  {
    globalError.Set (ERR_ARGS, "makehelp: Must be 2 or 3");
    return (NULL);
  }

  if ((*argl)[0]->DefaultComponent()->Type() != C_TEXT)
  {
    globalError.Set (ERR_TEXT, "makehelp: first argument");
    return (NULL);
  }
  type = (*argl)[0]->DefaultComponent()->Content().xplchar;

  if ((*argl)[1]->DefaultComponent()->Type() != C_TEXT)
  {
    globalError.Set (ERR_TEXT, "makehelp: second argument");
    return (NULL);
  }
  idir = (*argl)[1]->DefaultComponent()->Content().xplchar;

  odir = NULL;
  if (length==3)
  { if ((*argl)[2]->DefaultComponent()->Type() != C_TEXT)
    {
      globalError.Set (ERR_TEXT, "makehelp: third argument");
      return (NULL);
    }
    odir = (*argl)[2]->DefaultComponent()->Content().xplchar;
  }

  ts   = type->size();
  argc = 1+ts+idir->size();
  argv = new charp[argc];
  argv[0] = NULL;
  j       = 1;
  for (i=0; i<ts; i++, j++)
  { sprintf (buffer, "-%s", (*type)(i).tostr());
    argv[j] = strdup(buffer);
  }
  ts = idir->size();
  for (i=0; i<ts; i++, j++)
    argv[j] = strdup((*idir)(i).tostr());

  switch (dohlp2html (argc, argv))
  { case 0 : 
      break;
    case 1 :
      globalError.Set (ERR_INTERN, "makehelp: could not open 'makehelp.log'");
      break;
    case 2 :
      globalError.Set (ERR_INTERN, "makehelp: serious errors, please check 'makehelp.log'");
      break;
    default:
      globalError.Set (ERR_INTERN, "makehelp: unknown error, please check 'makehelp.log'");
      break;
  }

  for (i=1; i<argc; i++)
    delete[] argv[i];
  delete[] argv;

  return (NULL);
}

// SK 16.11.01
void double2string (XplDouble *x, XplChar *c) {
  char *res;
  double *ptr;
  int i, n;

  n   = x->size();
  res = new char[1+n];   
  ptr = x->getptr();
  for (i=0; i<n; i++) {
    res[i] = (char) ptr[i];
  }
  res[i] = 0;
  (*c)[0] = xplstring(res);
  delete[] res;
}

void string2double (XplChar *c, XplDouble *x) {
  const char *res = ((*c)[0]).tocstr();
  double *ptr;
  int i, n;
  XplIndex dim;

  n   = strlen(res);
  ptr = new double[1+n];
  for (i=0; i<n; i++) {
    ptr[i] = (double) res[i];
  }
  ptr[i] = 0;
  x->setptr (ptr);
  dim.setdim (0, n+1);
  x->setdim(dim);
}

XplObject* xaConvert (Liste<XplObject*> *argl) {
  XplChar *c;
  XplDouble *x;
  XplObject *res;

  if (argl->laenge()!=1)
  { globalError.Set (ERR_ARGS, "convert: args must be 1");
    return (NULL);
  }

  if ((*argl)[0]->DefaultComponent()->Type() == C_XPLDOUBLE)
  {
    x = (*argl)[0]->DefaultXplDouble();
    c = new XplChar(1);

    double2string (x, c);

    res = new XplObject (c, "convert");
  }
  else if ((*argl)[0]->DefaultComponent()->Type() == C_XPLCHAR) {
    c =  (*argl)[0]->DefaultComponent()->Content().xplchar;
    x = new XplDouble(1);

    string2double (c, x);

    res = new XplObject (x, "convert");
  }
  else {
    globalError.Set (ERR_ARGS, "convert: arg must be text or numeric");
    return (NULL); 
  }

  if (globalError.Get()) {
    delete res;
    return (NULL);  
  }

  return (res);
}

void initsk (void)
{ funList->haengeAn (new Function ("readascii",  xaReadASCII));
  funList->haengeAn (new Function ("svd",  xaSvd));
  funList->haengeAn (new Function ("kmeans",  xaKmeans));       // SK 02.09.97
  funList->haengeAn (new Function ("agglom",  xaAgglom));       // SK 02.09.97
  funList->haengeAn (new Function ("tree",  xaTree));           // SK 02.09.97
  funList->haengeAn (new Function ("distance",  xaDistance));   // SK 02.09.97
  funList->haengeAn (new Function ("fwt2",  xaFwt2));           // SK 08.09.97
  funList->haengeAn (new Function ("invfwt2",  xaInvfwt2));     // SK 08.09.97
  funList->haengeAn (new Function ("dwt",  xaDwt));             // SK 29.09.97
  funList->haengeAn (new Function ("invdwt",  xaInvDwt));       // SK 29.09.97
  funList->haengeAn (new Function ("cartsplit",  xaCartSplit)); // SK 05.11.97
  funList->haengeAn (new Function ("char",  xaChar));           // SK 07.01.98
  funList->haengeAn (new Function ("eiggn",  xaEiggn));         // SK 24.02.98
//  funList->haengeAn (new Function ("makehelp",  xaMakehelp));   // SK 29.07.98, SK 06.05.02
  funList->haengeAn (new Function ("convert",  xaConvert));     // SK 16.11.01
  foreigncmd ();
}

// #endif

