/* $Header: /home/xplore/cvs/xpl4gr/xnumber.C,v 1.3 2002/08/16 12:31:57 sigbert Exp $ */

#include "xnan.h"
#include "xnumber.hpp"

template<class T> T plus (T l, T r)   { return (l+r); }
template int plus (int l, int r);
template long plus (long l, long r);
template double plus (double l, double r);

template<class T> T minus (T l, T r)  { return (l-r); }
template int minus (int l, int r);
template long minus (long l, long r);
template double minus (double l, double r);

template<class T> T divi (T l, T r)   { return (l/r); }
template int divi (int l, int r);
template long divi (long l, long r);
template double divi (double l, double r);

template<class T> T modu (T l, T r)   { return (l%r); }
template int modu (int l, int r);
template long modu (long l, long r);
double modu (double l, double r)      { return (::fmod(l,r));}
float  modu (float l, float r)        { return (::fmod(l,r));}

template<class T> T mult (T l, T r)   { return (l*r); }
template int mult (int l, int r);
template long mult (long l, long r);
template double mult (double l, double r);


template<class T> int ge (const T l, const T r)   { return (l>r); }
template<class T> int eq (const T l, const T r)   { return (l==r); }
template<class T> int leq (const T l, const T r)  { return (l<=r); }
template<class T> int neq (const T l, const T r)  { return (l!=r); }
template<class T> int geq (const T l, const T r)  { return (l>=r); }
template<class T> int le (const T l, const T r)   { return (l<r); }

template int ge (const int l, const int r); 
template int eq (const int l, const int r); 
template int leq (const int l, const int r);
template int neq (const int l, const int r);
template int geq (const int l, const int r);
template int le (const int l, const int r);

template int ge (const long l, const long r); 
template int eq (const long l, const long r); 
template int leq (const long l, const long r);
template int neq (const long l, const long r);
template int geq (const long l, const long r);
template int le (const long l, const long r);

/*template int ge (const double l, const double r); 
template int eq (const double l, const double r); 
template int leq (const double l, const double r);
template int neq (const double l, const double r);
template int geq (const double l, const double r);
template int le (const double l, const double r);
*/

//template 
int ge (const double l, const double r)
{ if (XisNumber(l))
  { if (XisNumber(r))
      return (l>r);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (1);
    else //r is NaN
      return (0);
  }
  else if (XisPosInf(l))
  { if (XisNumber(r))
      return (1);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (1);
    else //r is NaN
      return (0);
  }
  else if (XisNegInf(l))
  { if (XisNumber(r))
      return (0);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (0);
  }
  else // l is NaN
  { if (XisNumber(r))
      return (0);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (0);
  }
}

//template
int eq (const double l, const double r)
{ if (XisNumber(l))
  { if (XisNumber(r))
      return (l==r);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (0);
  }
  else if (XisPosInf(l))
  { if (XisNumber(r))
      return (0);
    else if (XisPosInf(r))
      return (1);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (0);
  }
  else if (XisNegInf(l))
  { if (XisNumber(r))
      return (0);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (1);
    else //r is NaN
      return (0);
  }
  else // l is NaN
  { if (XisNumber(r))
      return (0);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (1);
  }
}

//template
int leq (const double l, const double r)
{ if (XisNumber(l))
  { if (XisNumber(r))
      return (l<=r);
    else if (XisPosInf(r))
      return (1);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (0);
  }
  else if (XisPosInf(l))
  { if (XisNumber(r))
      return (0);
    else if (XisPosInf(r))
      return (1);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (0);
  }
  else if (XisNegInf(l))
  { if (XisNumber(r))
      return (1);
    else if (XisPosInf(r))
      return (1);
    else if (XisNegInf(r))
      return (1);
    else //r is NaN
      return (0);
  }
  else // l is NaN
  { if (XisNumber(r))
      return (0);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (1);
  }
}

//template
int neq (const double l, const double r)
{ if (XisNumber(l))
  { if (XisNumber(r))
      return (l!=r);
    else if (XisPosInf(r))
      return (1);
    else if (XisNegInf(r))
      return (1);
    else //r is NaN
      return (1);
  }
  else if (XisPosInf(l))
  { if (XisNumber(r))
      return (1);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (1);
    else //r is NaN
      return (1);
  }
  else if (XisNegInf(l))
  { if (XisNumber(r))
      return (1);
    else if (XisPosInf(r))
      return (1);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (1);
  }
  else // l is NaN
  { if (XisNumber(r))
      return (1);
    else if (XisPosInf(r))
      return (1);
    else if (XisNegInf(r))
      return (1);
    else //r is NaN
      return (0);
  }
}

//template
int geq (const double l, const double r)
{ if (XisNumber(l))
  { if (XisNumber(r))
      return (l>=r);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (1);
    else //r is NaN
      return (0);
  }
  else if (XisPosInf(l))
  { if (XisNumber(r))
      return (1);
    else if (XisPosInf(r))
      return (1);
    else if (XisNegInf(r))
      return (1);
    else //r is NaN
      return (0);
  }
  else if (XisNegInf(l))
  { if (XisNumber(r))
      return (0);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (1);
    else //r is NaN
      return (0);
  }
  else // l is NaN
  { if (XisNumber(r))
      return (0);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (1);
  }
}

//template
int le (const double l, const double r)
{ if (XisNumber(l))
  { if (XisNumber(r))
      return (l<r);
    else if (XisPosInf(r))
      return (1);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (0);
  }
  else if (XisPosInf(l))
  { if (XisNumber(r))
      return (0);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (0);
  }
  else if (XisNegInf(l))
  { if (XisNumber(r))
      return (1);
    else if (XisPosInf(r))
      return (1);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (0);
  }
  else // l is NaN
  { if (XisNumber(r))
      return (0);
    else if (XisPosInf(r))
      return (0);
    else if (XisNegInf(r))
      return (0);
    else //r is NaN
      return (0);
  }
}

template<class T> void fillgrid (T* ptr, long p, long *n, T* start, T* inc)
{
 long maxlen, i, j;
 long *index;

#ifndef MEMDEBUG
  index = new long[p];
#else
  index = (long *) xmem.newptr (sizeof(long), p, "XplNumber", "fillgrid", "index");
#endif  
  maxlen = 1;
  for (i=0; i<p; i++)
  { maxlen *= n[i];
    index[i] = 0;
  }

  for (i=0; i<maxlen; i++)
  { for (j=0; j<p; j++)
      *(ptr+maxlen*j+i) = *(start+j) + index[j] * *(inc+j);

    for (j=0; j<p; j++)
    { index[j]++;
      if (index[j]<n[j]) break;
      index[j] = 0;
    }
  }
#ifndef MEMDEBUG
  delete[] index;
#else
  xmem.delptr (index);
  index = NULL;
#endif
} 

template void fillgrid (int* ptr, long p, long *n, int* start, int* inc);
template void fillgrid (long* ptr, long p, long *n, long* start, long* inc);
template void fillgrid (double* ptr, long p, long *n, double* start, double* inc);

template<class T> XplNumber<T>::XplNumber (const XplIndex newdim) : XplArray<T>(newdim) { };

  template<class T> XplNumber<T>::XplNumber ()
  { ptr = NULL; }

  template<class T> XplNumber<T>::XplNumber (long d0, long d1, long d2, long d3, long d4, long d5, long d6, long d7) : XplArray<T>(d0, d1, d2, d3, d4, d5, d6, d7) { };

  template<class T> XplNumber<T>::~XplNumber () { };

  template<class T> XplNumber<T>::XplNumber (const XplArray<T> &x) : XplArray<T>(x) {}; 

/*  template<class T> XplNumber<T>::XplNumber (const XplNumber<T> &x)
  { //assignment(x);
    dim=x.dim;
#ifndef MEMDEBUG
    ptr = new T[x.size()];
#else
    ptr = (T *) xmem.newptr (sizeof(T), x.size(), "XplReal", "XplReal", "ptr");
#endif  
    memcpy (ptr, x.ptr, x.size()*sizeof(T));
  }  
*/

  template<class T> XplNumber<T>& XplNumber<T>::operator= (const XplArray<T> &x)		
  { assignment (x);
    return (*this);
  }  

  template<class T> XplNumber<T>& XplNumber<T>::operator= (const XplNumber<T> &x)
  { assignment (x);
    return (*this);
  }  

  template<class T> XplNumber<T> XplNumber<T>::operator+(const XplNumber<T> &right) const
  { long i, w = 0;
    for (i=0; i<MAX_XARRAY; i++)
      if ((dim(i)!=1) && (right.dim(i)!=1) && (dim(i)!=right.dim(i))) w=1;
    if (w) XAwarning (OPCON);  
    return (tfunctt(right, ::plus));
  }

  template<class T> XplNumber<T> XplNumber<T>::operator-(const XplNumber<T> &right) const
  { long i, w = 0;
    for (i=0; i<MAX_XARRAY; i++)
      if ((dim(i)!=1) && (right.dim(i)!=1) && (dim(i)!=right.dim(i))) w=1;
    if (w) XAwarning (OPCON);  
    return (tfunctt(right, ::minus));
  }

  template<class T> XplNumber<T> XplNumber<T>::operator*(const XplNumber<T> &right) const
  { XplNumber<T> res (dim.maxindex(right.dim));
    long i, w = 0;
    for (i=0; i<MAX_XARRAY; i++)
      if ((dim(i)!=1) && (right.dim(i)!=1) && (dim(i)!=right.dim(i))) w=1;
    if (w) XAwarning (OPCON);  
    return (tfunctt(right, ::mult));
  }

  template<class T> XplNumber<T> XplNumber<T>::operator/(const XplNumber<T> &right) const
  { long i, w = 0;
    for (i=0; i<MAX_XARRAY; i++)
      if ((dim(i)!=1) && (right.dim(i)!=1) && (dim(i)!=right.dim(i))) w=1;
    if (w) XAwarning (OPCON);  
    return (tfunctt(right, ::divi));
  }

  template<class T> XplNumber<T> XplNumber<T>::operator%(const XplNumber<T> &right) const
  { long i, w = 0;
    for (i=0; i<MAX_XARRAY; i++)
      if ((dim(i)!=1) && (right.dim(i)!=1) && (dim(i)!=right.dim(i))) w=1;
    if (w) XAwarning (OPCON);  
    return (tfunctt(right, ::modu));
  }

  template<class T> XplNumber<int> XplNumber<T>::operator==(const XplNumber<T> &right) const
  { long i, w = 0;
    for (i=0; i<MAX_XARRAY; i++)
      if ((dim(i)!=1) && (right.dim(i)!=1) && (dim(i)!=right.dim(i))) w=1;
    if (w) XAwarning (OPCON);  
    return (ifunctt(right, ::eq)); 
  }

  template<class T> XplNumber<int> XplNumber<T>::operator<=(const XplNumber<T> &right) const
  { long i, w = 0;
    for (i=0; i<MAX_XARRAY; i++)
      if ((dim(i)!=1) && (right.dim(i)!=1) && (dim(i)!=right.dim(i))) w=1;
    if (w) XAwarning (OPCON);  
    return (ifunctt(right, ::leq)); 
  }

  template<class T> XplNumber<int> XplNumber<T>::operator!=(const XplNumber<T> &right) const
  { long i, w = 0;
    for (i=0; i<MAX_XARRAY; i++)
      if ((dim(i)!=1) && (right.dim(i)!=1) && (dim(i)!=right.dim(i))) w=1;
    if (w) XAwarning (OPCON);  
    return (ifunctt(right, ::neq)); 
  }

  template<class T> XplNumber<int> XplNumber<T>::operator>=(const XplNumber<T> &right) const
  { long i, w = 0;
    for (i=0; i<MAX_XARRAY; i++)
      if ((dim(i)!=1) && (right.dim(i)!=1) && (dim(i)!=right.dim(i))) w=1;
    if (w) XAwarning (OPCON);  
    return (ifunctt(right, ::geq)); 
  }

  template<class T> XplNumber<int> XplNumber<T>::operator<(const XplNumber<T> &right) const
  { long i, w = 0;
    for (i=0; i<MAX_XARRAY; i++)
      if ((dim(i)!=1) && (right.dim(i)!=1) && (dim(i)!=right.dim(i))) w=1;
    if (w) XAwarning (OPCON);  
    return (ifunctt(right, ::le)); 
  }

  template<class T> XplNumber<int> XplNumber<T>::operator>(const XplNumber<T> &right) const
  { long i, w = 0;
    for (i=0; i<MAX_XARRAY; i++)
      if ((dim(i)!=1) && (right.dim(i)!=1) && (dim(i)!=right.dim(i))) w=1;
    if (w) XAwarning (OPCON);  
    return (ifunctt(right, ::ge)); 
  }

  template<class T> XplNumber<T> XplNumber<T>::extreme (const XplNumber<T> &right, int dir, int cmp)
  { T *newptr;
    long newsize = right.dim.prod() / right.dim(dir), i, j, l, n;
    XplIndex tmp, tmpr;
#ifndef MEMDEBUG
    newptr = new T[newsize];
#else
    newptr = (T *) xmem.newptr (sizeof(T), newsize, "XplNumber", "operator>", "newptr");
#endif  
    setptr (newptr);
    dim = right.dim;
    dim.setdim (dir, 1);
    
    if (dir)
    { tmp = 0;
      do
        *(ptr+dim.value(tmp)) = *(right.ptr+right.dim.value(tmp));
      while (tmp.inc(dim));

      for (i=1; i<right.dim(dir); i++)
      { tmp = 0;
        do
        { tmpr = tmp;
          tmpr.setdim(dir, i);
          if (cmp)
          { if (*(ptr+dim.value(tmp))< *(right.ptr+right.dim.value(tmpr)))
              *(ptr+dim.value(tmp)) = *(right.ptr+right.dim.value(tmpr));
          }
          else
          { if (*(ptr+dim.value(tmp))> *(right.ptr+right.dim.value(tmpr)))
              *(ptr+dim.value(tmp)) = *(right.ptr+right.dim.value(tmpr));
          }
        } 
        while (tmp.inc(dim));
      }
    }
    else
    { n = right.dim(0);
      l = right.size()/n;
      for (i=0; i<l; i++)
        *(ptr+i)=*(right.ptr+i*n);
      for (j=1; j<n; j++)
      { for (i=0; i<l; i++) 
        { if (cmp)
          { if (*(ptr+i)< *(right.ptr+i*n+j))
              *(ptr+i) = *(right.ptr+i*n+j);
          }
          else
          { if (*(ptr+i)> *(right.ptr+i*n+j))
              *(ptr+i) = *(right.ptr+i*n+j);
          }
        }
      }
    }
    return (*this);
  }

  template<class T> XplNumber<long> XplNumber<T>::mknn (int knn, const XplNumber<T> &xest) const
  { long i, layer, j, k, l;
    T *xl, *xle, *x, *xe, *dist, tmp;
    long *rptr, xs, xse, *rl, rs, *index, tmpl;
    XplIndex newdim;
    for (i=1; i<MAX_XARRAY; i++)
      if (dim(i)!=xest.dim(i)) XAerrort(DIMCON, "mknn : dim(x) <> dim (xest)");
    layer = 1;
    for (i=2; i<MAX_XARRAY; i++)
      layer *= dim(i);
    newdim = xest.dim;
    newdim.setdim (1, knn);
    XplNumber<long> ret(newdim);
    rptr = ret.getptr();
#ifndef MEMDEBUG
    dist = new T[dim(0)];
    index = new long[dim(0)];
#else
    dist = (T *) xmem.newptr (sizeof(T), dim(0), "XplNumber", "mknn", "dist");
    index = (long *) xmem.newptr (sizeof(long), dim(0), "XplNumber", "mknn", "index");
#endif  

    x  = getptr();
    xs = dim(0)*dim(1);
    xe = xest.getptr();
    xse = xest.dim(0)*xest.dim(1);
    rs = newdim(0)*newdim(1);
    for (i=0; i<layer; i++)
    { xl  = x+i*xs;
      xle = xe+i*xse;
      rl = rptr+i*rs;
      for (j=0; j<xest.dim(0); j++)
      { for (k=0; k<dim(0); k++)
        { dist[k]  = 0;
          index[k] = k;
          for (l=0; l<dim(1); l++)
          { tmp = *(xl+l*dim(0)+k) - *(xle+l*xest.dim(0)+j);
            dist[k] += (tmp*tmp);
          }
        }
  //    qsort(index, dim(0), sizeof(long), qmknn);
  //    jetzt wird erst mal gnadenlos gebubbelt !!
        for (k=0; k<dim(0); k++)
        { for (l=k+1; l<dim(0); l++)
          { if (dist[index[k]]>dist[index[l]])
            { tmpl = index[k];
              index[k] = index[l];
              index[l] = tmpl;
            }
          }
        } 
        for (k=0; k<knn; k++)
          *(rl+k*xest.dim(0)+j) = index[k]+1;
      }
    }
#ifndef MEMDEBUG
    delete[] dist;
    delete[] index;
#else
    xmem.delptr (dist);
    xmem.delptr (index);
    dist = NULL;
    index = NULL;
#endif
    return (ret);
  }

  template<class T> XplNumber<T> XplNumber<T>::matmult (const XplNumber<T> &right) const      
  { XplIndex newind;
    long tmp, layer, lse, lsl, lsr, ne, nl, nr, pe, pl, pr, i, j, k;
    T *rtptr, *ergptr, *ltptr;
    for (i=2; i<MAX_XARRAY; i++)
      if (dim(i)!=right.dim(i)) XAerrort(DIMCON, "matmult : layer(x) <> layer(y)");
    if (dim(1)!=right.dim(0)) XAerrort(DIMCON, "matmult: cols(x) <> rows(y)");
    newind    = dim;
    newind.setdim (0, dim(0));
    newind.setdim (1, right.dim(1));
    XplNumber<T> erg(newind);
    ne = dim(0);
    pe = right.dim(1);
    lse = ne*pe;
    nl = dim(0);
    pl = dim(1);
    lsl = nl*pl;
    nr = right.dim(0);
    pr = right.dim(1);
    lsr = nr*pr;
    layer = size()/lsl;
    ltptr = ptr;
    ergptr = erg.getptr();
    rtptr = right.getptr();
    for (tmp=0; tmp < layer; tmp++, ergptr += lse, ltptr += lsl, rtptr += lsr)
    { for (i=0; i<nl; i++)
      { for (j=0; j<pr; j++)
        { *(ergptr+j*ne+i) = 0;
          for (k=0; k<pl; k++)
            *(ergptr+j*ne+i) += *(ltptr+k*nl+i) * *(rtptr+j*nr+k);
        }
      }
    }
    return (erg);
  }

  template<class T> void XplNumber<T>::bindata (const XplNumber<T> delta, const XplNumber<T> orig, XplNumber<T> *y,
                XplNumber<long> *xb, XplNumber<T> *yb) const
  { XplIndex xbd, ybd, loop, tmp, tmp2;
    long i, j, k, m, xbs, ybs, *xbptr, *xbbinptr, noofbin, sum, n, p, q;
    T *xbinptr, *dbinptr, *obinptr, *ybptr, *ybinptr, *xptr, *dptr, *optr,
      *yptr, *ybbinptr;    

    if (dim(1)!=delta.dim(0))   
    { XAerrort (DIMCON, "bindata : cols(x) <> rows(delta)");
      return;
    }
    if (delta.dim(1)!=1)        
    { XAerrort (DIMCON, "bindata : cols(delta) <> 1");
      return;
    }
    if (dim(1)!=orig.dim(0))
    { XAerrort (DIMCON, "bindata : cols(x) <> rows(origin)");
      return;
    }
    if (orig.dim(1)!=1)
    { XAerrort (DIMCON, "bindata : cols(origin) <> 1");
      return;
    }
  
    ybd.setdim (0, dim(0));
    xbd.setdim (0, dim(0));
    xbd.setdim (1, dim(1));
    ybd.setdim (1, 1);
    if (y)
    { if (dim(0)!=y->dim(0))     
      { XAerrort(DIMCON, "bindata : rows(x) <> rows(y)");
        return;
      }
      ybd.setdim (1, ybd(1)+y->dim(1));
    }

    for (i=2; i<MAX_XARRAY; i++)
    { m = dim(i);
      if (m==1)
        m = delta.dim(i);
      else if (delta.dim(i)!=1) 
      { XAerrort (DIMCON, "bindata : layer(delta) <> 1");
        return;
      }

      if (m==1)
        m = orig.dim(i);
      else if (orig.dim(i)!=1) 
      { XAerrort (DIMCON, "bindata : layer(origin) <> 1");
        return;
      }

      if (y)
      { if (m==1)
          m = y->dim(i);
        else if (y->dim(i)!=1) 
        { XAerrort(DIMCON, "bindata : layer(y) <> 1");
          return;
        }
      }

      xbd.setdim (i, m);
      ybd.setdim (i, m);
    }

    for (i=0; i<delta.size(); i++)
    { if (delta[i]<= (T) 0.0)
      { XAerrort(RANGE, "bindata : Expected postive delta");
        return;
      }
    }

    xbs     = xbd.prod();
    ybs     = ybd.prod();
#ifndef MEMDEBUG
    xbptr   = new long[xbs];
    ybptr   = new T[ybs];
/*    xbinptr = new T[dim(0)*dim(1)];
    dbinptr = new T[delta.dim(0)*delta.dim(1)];
    obinptr = new T[orig.dim(0)*orig.dim(1)];
    ybinptr = new T[ybs];
*/
#else
    xbptr   = (long *) xmem.newptr (sizeof(long), xbs, "XplNumber", "bindata", "xbptr");
    ybptr   = (T *) xmem.newptr (sizeof(T), ybs, "XplNumber", "bindata", "ybptr");
/*    xbinptr   = (T *) xmem.newptr (sizeof(T), dim(0)*dim(1), "XplNumber", "bindata", "xbinptr");
    dbinptr   = (T *) xmem.newptr (sizeof(T), delta.dim(0)*delta.dim(1), "XplNumber", "bindata", "dbinptr");
    obinptr   = (T *) xmem.newptr (sizeof(T), orig.dim(0)*orig.dim(1), "XplNumber", "bindata", "obinptr");
    ybinptr   = (T *) xmem.newptr (sizeof(T), ybs, "XplNumber", "bindata", "ybinptr"); 
*/
#endif  

    xptr    = ptr;
    dptr    = delta.getptr();
    optr    = orig.getptr();
    if (y)
      yptr  = y->getptr();
    else
      yptr  = NULL;

    tmp = 0;
    tmp2 = 0;
    loop = xbd;
//    for (i=2; i<MAX_XARRAY; i++)
//      loop[i] = xbd[i];
    loop.setdim (0, 1);
    loop.setdim (1, 1);

  
    n = dim(0); p = dim(1); 
    if (y)
      q = y->dim(1);
    else
      q = 0;

    do
    { tmp2=tmp<<2;
      tmp2=tmp2%dim; xbinptr = xptr+dim.value(tmp2); 

      tmp2=tmp<<2;
      tmp2=tmp2%delta.dim; dbinptr = dptr+(delta.dim).value(tmp2); 

      tmp2=tmp<<2;
      tmp2=tmp2%orig.dim; obinptr = optr+(orig.dim).value(tmp2); 

      if (y)
      { tmp2=tmp<<2;
        tmp2=tmp2%y->dim; ybinptr = yptr+(y->dim).value(tmp2); 
      }
      else
        ybinptr = NULL;

      tmp2=tmp<<2;
      xbbinptr = xbptr+xbd.value(tmp2); 
      ybbinptr = ybptr+ybd.value(tmp2); 

// from here we do bindata in layers
// here comes the XploRe 3.2 routine

      for (i=0; i<n; i++)
      { for (j=0; j<p; j++)
          *(xbbinptr+j*n+i) = (long) ::floor((*(xbinptr+j*n+i) - *(obinptr+j)) / *(dbinptr+j));
        for (j=0; j<q+1; j++) 
          *(ybbinptr+j*n+i) = 0;
        for (k=0; k<i; k++)
        { sum = 0;
          for (j=0; j<p; j++)
            sum += labs(*(xbbinptr+j*n+i) - *(xbbinptr+j*n+k));
          if (sum==0) break;
        }
        if (k==i)
        { *(ybbinptr+k) = 1;
          for (j=1; j<q+1; j++)
            *(ybbinptr+j*n+k) = *(ybinptr+(j-1)*n+k);
        }
        else
        { (*(ybbinptr+k))++;
          for (j=1; j<q+1; j++)
            *(ybbinptr+j*n+k) += *(ybinptr+(j-1)*n+i);
        }
      }

// end of XploRe 3.2 routine

    }
    while (tmp.inc(loop));

    xb->setdim(xbd);
    xb->setptr(xbptr);
    yb->setdim(ybd);
    yb->setptr(ybptr);

  }

  template<class T> XplNumber<T> XplNumber<T>::tmatmult (const XplNumber<T> &right) const      
  { XplIndex newind;
    long tmp, layer, lse, lsl, lsr, ne, nl, nr, pe, pl, pr, i, j, k;
    T *rtptr, *ergptr, *ltptr;
    for (i=2; i<MAX_XARRAY; i++)
      if (dim(i)!=right.dim(i)) XAerrort (DIMCON, "tmatmult : layer(x) <> layer(y)");
    if (dim(0)!=right.dim(0)) XAerrort (DIMCON, "tmatmult : rows(x) <> rows(y)");
    newind    = dim;
    newind.setdim (0, dim(1));
    newind.setdim (1, right.dim(1));
    XplNumber<T> erg(newind);
    ne = dim(1);
    pe = right.dim(1);
    lse = ne*pe;
    nl = dim(0);
    pl = dim(1);
    lsl = nl*pl;
    nr = right.dim(0);
    pr = right.dim(1);
    lsr = nr*pr;
    layer = size()/lsl;
    ltptr = ptr;
    ergptr = erg.getptr();
    rtptr = right.getptr();
    for (tmp=0; tmp < layer; tmp++, ergptr += lse, ltptr += lsl, rtptr += lsr)
    { for (i=0; i<pl; i++)
      { for (j=0; j<pr; j++)
        { *(ergptr+j*ne+i) = 0;
          for (k=0; k<nl; k++)
            *(ergptr+j*ne+i) += *(ltptr+i*nl+k) * *(rtptr+j*nr+k);
        }
      }
    }
    return (erg);
  }

  template<class T> void XplNumber<T>::conv (const XplNumber<long> &xb, const XplNumber<long> &wx, const XplNumber<T> &wy, XplNumber<long> *sym,
             XplNumber<long> *xc, XplNumber<T> *yc, XplNumber<long> *or) const
  { XplIndex lbd;
    long maxlen, actlen, i, j, k, l, s, m, n, p, np, *maxp, *minp, 
         *maxptr, *minptr, *xp, *xptr;
    if (dim(0)!= xb.dim(0))    
    { XAerrort (DIMCON, "conv : rows(x) <> rows(y)");
      return; 
    }
    if (xb.dim(1)!= wx.dim(1))   
    { XAerrort (DIMCON, "conv : cols(x) <> cols(wx)");
      return; 
    }
    if (wx.dim(0)!=wy.dim(0)) 
    { XAerrort (DIMCON, "conv : rows(wx) <> rows(wy)");
      return; 
    }
    if ((sym==NULL) || (sym->dim(0)!=1) || (sym->dim(1)!=1))
    { XAerrort (DIMCON, "conv : scalar(sym) expected");
      return; 
    }
    lbd = xb.dim;
    lbd.setdim (0, 1);
    lbd.setdim (1, 1);
    n = xb.dim(0);
    p = xb.dim(1);
    np = n*p;
    for (i=2; i<MAX_XARRAY; i++)
    { if (dim(i)>1)
      { if (lbd(i)>1)         
        { XAerrort (DIMCON, "conv : layer(y)");
          return;
        }
        else 
          lbd.setdim (i, dim(i));
      }

      if (wx.dim(i)>1)
      { if (lbd(i)>1)         
          XAerrort (DIMCON, "conv : layer(wx)");
        else 
          lbd.setdim (i, wx.dim(i));
      }

      if (wy.dim(i)>1)
      { if (lbd(i)>1)         
        { XAerrort (DIMCON, "conv : layer(wy)");
          return;
	}
        else 
          lbd.setdim (i, wy.dim(i));
      }

      if (sym)
      { if (sym->dim(i)>1)
        { if (lbd(i)>1)         
          { XAerrort (DIMCON, "conv : layer(sym)");
            return;
          }
          else 
            lbd.setdim(i, sym->dim(i));
        }
      }
    }

    XplIndex maxbd, minbd, tmp, tmp2;
    maxbd = minbd = xb.dim;
    maxbd.setdim (0, 1);
    minbd.setdim (0, 1);
    XplNumber<long> maxb(maxbd), minb(minbd);
    
//long dimen[p];
    long symp;

    long *dimen;
#ifndef MEMDEBUG
    dimen = new long[p];
#else
    dimen = (long *) xmem.newptr (sizeof(long), p, "XplNumber", "conv", "dimen");
#endif  

    maxptr = maxb.getptr();
    minptr = minb.getptr();
    xptr   = xb.getptr();

    s = xb.dim.prod()/np;
    for (l=0; l<s; l++)
    { xp   = xptr+l*np;
      maxp = maxptr+l*p;
      minp = minptr+l*p;

      for (k=0; k<p; k++)
        maxp[k] = minp[k] = *(xp+k*n);
      for (m=1; m<n; m++)
      { for (k=0; k<p; k++)
        { if (*(xp+k*n+m) > maxp[k]) maxp[k] = *(xp+k*n+m);
          if (*(xp+k*n+m) < minp[k]) minp[k] = *(xp+k*n+m);
        }
      }
    }

    for (i=0; i<p; i++)
      dimen[i] = 0;
    maxlen = 0;
    for (l=0; l<s; l++)
    { actlen = 1;
      for (k=0; k<p; k++)
      { symp =  *(maxptr+l*p+k) - *(minptr+l*p+k) + 1;
        if (symp<1)
        { XAerrort (RANGE, "conv : size(x) < 0");
#ifndef MEMDBUG
          delete[] maxptr;
          delete[] minptr;
#else
          xmem.delptr (maxptr);
          xmem.delptr (minptr);
          maxptr = NULL;
          minptr = NULL;
#endif
          return;
	}
        if (symp>dimen[k]) dimen[k] = symp;
        actlen *= symp;
      }
      if (actlen>maxlen) maxlen = actlen;
    }

    if (s>1)
    { for (l=0; l<s; l++)
      { for (k=0; k<p; k++)
        { symp = (dimen[k] - *(maxptr+l*p+k) + *(minptr+l*p+k) - 1) / 2;
          *(minptr+l*p+k) -= symp;
          *(maxptr+l*p+k)-= *(minptr+l*p+k) + dimen[k] - 1;
        }
      }
    }

    if (MAXLONG / (maxlen*dim(1)) < lbd.prod())
    { XAerrort (RANGE, "conv : size(x) too large");
#ifndef MEMDEBUG
      delete[] maxptr;
      delete[] minptr;
#else
      xmem.delptr (maxptr);
      xmem.delptr (minptr);
      maxptr = NULL;
      minptr = NULL;
#endif
      return;
    }

    XplIndex xcbd, ycbd, orbd;   
    long *xcptr, *xcp, *wxptr, *wxp, *orptr, *orp, *symptr,
                       mima, wlen, yd1, sign, ai, mode, ret, 	
                       *actx, *addw,
                       *xori, cm, cp, index, twoexpdim;

#ifndef MEMDEBUG
    actx = new long[p];
    addw = new long[p];
    xori = new long[p];
#else
    actx = (long *) xmem.newptr (sizeof(long), p, "XplNumber", "conv", "actx");
    addw = (long *) xmem.newptr (sizeof(long), p, "XplNumber", "conv", "addw");
    xori = (long *) xmem.newptr (sizeof(long), p, "XplNumber", "conv", "xori");
#endif  

    T *ycptr, *ycp, *wyptr, *wyp, *ybptr, *ybp;

    xcbd = ycbd = orbd = lbd;
    xcbd.setdim (0, maxlen);
    ycbd.setdim (0, maxlen);
    orbd.setdim (0, maxlen);
    xcbd.setdim (1, (xb.dim)(1));
    ycbd.setdim (1, dim(1));
    yd1 = dim(1);
    orbd.setdim (1, 1);

    ybptr = getptr();
    wxptr = wx.getptr();
    wyptr = wy.getptr();
    if (sym)
      symptr = sym->getptr();
    else
      symptr = NULL;

#ifndef MEMDEBUG
    xcptr = new long[xcbd.prod()];
    orptr = new long[orbd.prod()];
    ycptr = new T[ycbd.prod()];    
#else
    xcptr = (long *) xmem.newptr (sizeof(long), xcbd.prod(), "XplNumber", "conv", "xcptr");
    orptr = (long *) xmem.newptr (sizeof(long), orbd.prod(), "XplNumber", "conv", "orptr");
    ycptr = (T *) xmem.newptr (sizeof(T), ycbd.prod(), "XplNumber", "conv", "ycptr"); 
#endif
    twoexpdim = 1;
    maxp = maxptr;
    for (i=0; i<p; i++) 
    { twoexpdim *= 2;
      *(maxp+i)  = 1;
    }
    wlen = wx.dim(0);

    lbd = lbd>>2;
    tmp = 0;
    xcp = xcptr;
    ycp = ycptr;
    orp = orptr;
    do
    { tmp2=tmp<<2;
      tmp2=tmp2%xb.dim; 
      mima=xb.dim.value(tmp2);
      xp  =xptr+mima;

      tmp2=tmp<<2;
      tmp2=tmp2%dim; ybp  = ybptr+dim.value(tmp2);

      tmp2=tmp<<2;
      tmp2=tmp2%wx.dim; wxp = wxptr+(wx.dim).value(tmp2);

      tmp2=tmp<<2;
      tmp2=tmp2%wy.dim; wyp = wyptr+(wy.dim).value(tmp2);

      if (symptr)
      { tmp2=tmp<<2;
        tmp2=tmp2%sym->dim; symp = *(symptr+(sym->dim).value(tmp2));
      }
      else
        symp = 0;

      mima /= n;
      minp = minptr+mima;
    
      fillgrid (xcp, p, dimen, minp, maxp); 
      for (i=0; i<maxlen; i++)
        *(orp+i) = 0;
      for (i=0; i<maxlen*yd1; i++)
        *(ycp+i) = 0;
      
// here comes XploRe 3.2

      for (i=0; i<n; i++)
      { for (j=0; j<yd1; j++)
          if (*(ybp+j*n+i)!=0) break; 
        if (j<yd1)
        { for (j=0; j<p; j++)
            xori[j] = *(xp+j*n+i);
          for (j=0; j<wlen; j++)
          { for (k=0; k<twoexpdim; k++)
            { sign = symp;
// int addweight (int *wx, int k, int dim, int *addw, int *symmode)
              ret = 1;
              mode = sign;
              sign = 1;
              for (ai=0; ai<p; ai++)
              { if ((*(wxp+ai*wlen+j)==0) && ((k>>ai) & 0X00000001))
                { ret = 0;
                  break;
                }
                if ((k>>ai) & 0X00000001)
                { addw[ai] = - *(wxp+ai*wlen+j);
                  if ((mode>>ai) & 0X00000001) sign = -sign;
                }
                else
                  addw[ai] = *(wxp+ai*wlen+j);
              }
// end of addweight
              if (ret)
              { memmove(actx, xori, sizeof(long)*p);
                cm = 0;
                cp = 1;
//                for (l=p-1; l>-1; l--)
                for (l=0; l<p; l++)
                { actx[l] += addw[l];
                  if ((actx[l]<minp[l]) || (actx[l]>=minp[l]+dimen[l]))
                  { l = p+1;
                    break;
                  }
                  cm += (actx[l]-minp[l]) * cp;
                  cp *= dimen[l];
                }
                if (l<=p)
                { for (index=0; index<yd1; index++)
                    *(ycp+index*maxlen+cm) += (sign * *(ybp+index*n+i)* *(wyp+j));
                  if ((j==0) && (k==0)) *(orp+cm) = 1;
                }
              }
            }
          }
        }
      }

      xcp += maxlen*p;
      ycp += maxlen*yd1;
      orp += maxlen;

    }
    while (tmp.inc(lbd));

    xc->setdim(xcbd);
    xc->setptr(xcptr);
    yc->setdim(ycbd);
    yc->setptr(ycptr);
    or->setdim(orbd);
    or->setptr(orptr);

#ifndef MEMDEBUG
    delete[] actx;
    delete[] addw;
    delete[] xori;
    delete[] dimen;
#else
    xmem.delptr (actx);
    xmem.delptr (addw);
    xmem.delptr (xori);
    xmem.delptr (dimen);
    actx = addw = xori = dimen = NULL;
#endif
  }

  template<class T> XplNumber<T> XplNumber<T>::grid (const XplNumber<T> &h, const XplNumber<long> &n) const
  { XplNumber<T> ret(1);
    XplIndex retbd, tmp, tmp2, loop;
    long i, m, *nptr, s;
    T *retptr, *retp, *xp, *hptr, *hp;
    
    if (dim(0)!=h.dim(0))
    { XAerrort (DIMCON, "grid : rows(x)<>rows(h)");
      return (ret);
    }
    if (dim(0)!=n.dim(0))
    { XAerrort (DIMCON, "grid : rows(x)<>rows(n)");
      return (ret);
    }
    if (dim(1)!=1)
    { XAerrort (RANGE, "grid : expected cols(x) = 1");
      return (ret);
    }
    if (h.dim(1)!=1)
    { XAerrort (RANGE, "grid : expected cols(h) = 1");
      return (ret);
    }
    if (n.dim(1)!=1)
    { XAerrort (RANGE, "grid : expected cols(n) = 1");
      return (ret);
    }

    s = n.size();
    for (i=0; i<s; i++)
    { if (n[i]<=0)
      { XAerrort (RANGE, "grid : n has to be positive");
        return (ret);
      }
    }

    retbd = dim;
    retbd.setdim (0, 1);
    retbd.setdim (1, dim(0));
    for (i=2; i<MAX_XARRAY; i++)
    { if (n.dim(i)!=1)
      { XAerrort (RANGE, "grid : expected layer(n) = 1");
        return (ret);
      }

      if (retbd(1)!=1)
      { if (h.dim(i)!=1)
        { XAerrort (DIMCON, "grid : layer(x)<>layer(h)");
          return (ret);
        }
        else
          retbd.setdim (i, h.dim(i));
      }
    }

    s = (n.dim).prod();
    nptr = n.getptr();
    m = 1;
    for (i=0; i<s; i++)
    { if (m > MAXLONG / *(nptr+i))
      { XAerrort (RANGE, "grid : grid to large");
        return (ret);
      }
      m *= *(nptr+i);
    }
    if (MAXLONG / retbd.prod() < m)
    { XAerrort (RANGE, "grid : grid to large");
      return (ret);
    }
    retbd.setdim (0, m);
    loop = retbd>>2;
#ifndef MEMDEBUG
    retp = retptr = new T[retbd.prod()];
#else
    retp = retptr = (T *) xmem.newptr (sizeof(T), retbd.prod(), "XplNumber", "conv", "retp/retptr");
#endif  
    hptr = h.getptr();

    tmp  = 0;
    do
    { tmp2 = tmp<<2;
      tmp2 = tmp2%dim;
      xp   = ptr+dim.value(tmp2);

      tmp2 = tmp<<2;
      tmp2 = tmp2%h.dim;
      hp   = hptr+(h.dim).value(tmp2);
 
      fillgrid (retp, dim(0), nptr, xp, hp);

      retp += dim(0)*m;

    }
    while (tmp.inc(loop));

    ret.setdim(retbd);
    ret.setptr(retptr);
    return (ret);
  }

  template<class T> XplNumber<T> XplNumber<T>::sum (long d, const XplNumber<long> *cond) const
  { XplNumber<T> ret(1);
    XplIndex retbd, tmp, tmp2, condbd;
    long i, s, ci, ca, *condptr, jmp, j, *condp;
    T *xp, *retptr, *retp;  
 
    if ((d<0) || (d>=MAX_XARRAY))
      XAerrort (RANGE, "sum : dim out of range");
    if (cond)
    { condbd = cond->dim;
      for (i=0; i<MAX_XARRAY; i++)
        if (dim(i)!=condbd(i))
          XAerrort(DIMCON, "sum: layer(x)<>layer(cond)");
      s = (cond->dim).prod();
      condptr = cond->getptr();
      ci = ca = *condptr;
      for (i=1; i<s; i++)
      { if (*(condptr+i) > ca) ca = *(condptr+i);
        if (*(condptr+i) < ci) ci = *(condptr+i);
      }
    }
    else
    { condptr = NULL;
      ci = ca = 0;
    }

    if (ci<0)
      XAerrort(RANGE, "sum : min(cond) < 0");
    
    retbd = dim;
    retbd.setdim (d, 1);
    if (MAXLONG / retbd.prod() < ca+1)
      XAerrort (RANGE, "sum : result too large");
    retbd.setdim (d, ca+1);
    s        = retbd.prod();
#ifndef MEMDEBUG
    retptr   = new T[s];
#else
    retptr = (T *) xmem.newptr (sizeof(T), s, "XplNumber", "sum", "retptr");
#endif  

    for (i=0; i<s; i++)
      *(retptr+i) = 0;

    jmp = 1;
    for (i=0; i<d; i++)
      jmp *= dim(i);

    tmp  = 0;

    if (condptr)
    { do
      { xp    = ptr+dim.value(tmp);
        retp  = retptr+retbd.value(tmp);
        condp = condptr+condbd.value(tmp);
        for (j=0; j<dim(d); j++, xp += jmp, condp += jmp)
          *(retp+jmp* *condp) += *xp;
      }
      while (tmp.inc(dim, d));
    }
    else
    { do
      { xp   = ptr+dim.value(tmp);
        retp = retptr+retbd.value(tmp);
        for (j=0; j<dim(d); j++, xp += jmp)
          *retp += *xp;
      }
      while (tmp.inc(dim, d));
    }

    ret.setdim(retbd);
    ret.setptr(retptr);

    return (ret);
  }

  // PC 20010125
  template<class T> XplNumber<T> XplNumber<T>::sumnan (long d) const
  { XplNumber<T> ret(1);
    XplIndex retbd, tmp, tmp2;
    long i, s, jmp, j;
    T *xp, *retptr, *retp;  
 
    if ((d<0) || (d>=MAX_XARRAY))
      XAerrort (RANGE, "sumnan : dim out of range");

    retbd = dim;
    retbd.setdim (d, 1);
    if (MAXLONG / retbd.prod() < 1)
      XAerrort (RANGE, "sumnan : result too large");
    s        = retbd.prod();
#ifndef MEMDEBUG
    retptr   = new T[s];
#else
    retptr = (T *) xmem.newptr (sizeof(T), s, "XplNumber", "sumnan", "retptr");
#endif  

    for (i=0; i<s; i++)
      *(retptr+i) = 0;

    jmp = 1;
    for (i=0; i<d; i++)
      jmp *= dim(i);

    tmp = 0;

    do
    { 
        xp   = ptr+dim.value(tmp);
        retp = retptr+retbd.value(tmp);
        for (j=0; j<dim(d); j++, xp += jmp)
          if (!isNaN(*xp))
            *retp += *xp;
    }
    while (tmp.inc(dim, d));

    ret.setdim(retbd);
    ret.setptr(retptr);

    return (ret);
  }

  template<class T> XplNumber<T> XplNumber<T>::mul (long d, const XplNumber<long> *cond) const
  { XplNumber<T> ret(1);
    XplIndex retbd, tmp, tmp2, condbd;
    long i, s, ci, ca, *condptr, jmp, j, *condp;
    T *xp, *retptr, *retp;  
 
    if ((d<0) || (d>=MAX_XARRAY))
      XAerrort (RANGE, "mul : dim out of range");
    if (cond)
    { condbd = cond->dim;
      for (i=0; i<MAX_XARRAY; i++)
        if (dim(i)!=condbd(i))
          XAerrort(DIMCON, "mul : layer(x)<>layer(cond)");
      s = (cond->dim).prod();
      condptr = cond->getptr();
      ci = ca = *condptr;
      for (i=1; i<s; i++)
      { if (*(condptr+i) > ca) ca = *(condptr+i);
        if (*(condptr+i) < ci) ci = *(condptr+i);
      }
    }
    else
    { condptr = NULL;
      ci = ca = 0;
    }

    if (ci<0)
      XAerrort(RANGE, "mul : min(cond) < 0");
    
    retbd = dim;
    retbd.setdim (d, 1);
    if (MAXLONG / retbd.prod() < ca+1)
      XAerrort (RANGE, "mul : result too large");
    retbd.setdim(d, ca+1);
    s        = retbd.prod();
#ifndef MEMDEBUG
    retptr   = new T[s];
#else
    retptr = (T *) xmem.newptr (sizeof(T), s, "XplNumber", "mul", "retptr");
#endif  

    for (i=0; i<s; i++)
      *(retptr+i) = 1;

    jmp = 1;
    for (i=0; i<d; i++)
      jmp *= dim(i);

    tmp  = 0;

    if (condptr)
    { do
      { xp    = ptr+dim.value(tmp);
        retp  = retptr+retbd.value(tmp);
        condp = condptr+condbd.value(tmp);
        for (j=0; j<dim(d); j++, xp += jmp, condp += jmp)
          *(retp+jmp* *condp) *= *xp;
      }
      while (tmp.inc(dim, d));
    }
    else
    { do
      { xp   = ptr+dim.value(tmp);
        retp = retptr+retbd.value(tmp);
        for (j=0; j<dim(d); j++, xp += jmp)
          *retp *= *xp;
      }
      while (tmp.inc(dim, d));
    }

    ret.setdim(retbd);
    ret.setptr(retptr);

    return (ret);
  }

  // PC 20010125
  template<class T> XplNumber<T> XplNumber<T>::mulnan (long d) const
  { XplNumber<T> ret(1);
    XplIndex retbd, tmp, tmp2;
    long i, s, jmp, j;
    T *xp, *retptr, *retp;  
 
    if ((d<0) || (d>=MAX_XARRAY))
      XAerrort (RANGE, "mulnan : dim out of range");

    retbd = dim;
    retbd.setdim (d, 1);
    if (MAXLONG / retbd.prod() < 1)
      XAerrort (RANGE, "mulnan : result too large");
    s        = retbd.prod();
#ifndef MEMDEBUG
    retptr   = new T[s];
#else
    retptr = (T *) xmem.newptr (sizeof(T), s, "XplNumber", "mulnan", "retptr");
#endif  

    for (i=0; i<s; i++)
      *(retptr+i) = 1;

    jmp = 1;
    for (i=0; i<d; i++)
      jmp *= dim(i);

    tmp  = 0;

    do
    {   
        xp   = ptr+dim.value(tmp);
        retp = retptr+retbd.value(tmp);
        for (j=0; j<dim(d); j++, xp += jmp)
          if (!isNaN(*xp))
            *retp *= *xp;
    }
    while (tmp.inc(dim, d));

    ret.setdim(retbd);
    ret.setptr(retptr);

    return (ret);
  }

  template<class T> XplNumber<T> XplNumber<T>::maximum (long d, const XplNumber<long> *cond) const
  { XplNumber<T> ret(1);
    XplIndex retbd, tmp, tmp2, condbd;
    long i, s, ci, ca, *condptr, jmp, j, *condp, *noval;
    T *xp, *retptr, *retp;  
 
    if ((d<0) || (d>=MAX_XARRAY))
      XAerrort (RANGE, "max : dim out of range");
    if (cond)
    { condbd = cond->dim;
      for (i=0; i<MAX_XARRAY; i++)
        if (dim(i)!=condbd(i))
          XAerrort(DIMCON, "max : layer(x)<>layer(cond)");
      s = (cond->dim).prod();
      condptr = cond->getptr();
      ci = ca = *condptr;
      for (i=1; i<s; i++)
      { if (*(condptr+i) > ca) ca = *(condptr+i);
        if (*(condptr+i) < ci) ci = *(condptr+i);
      }
    }
    else
    { condptr = NULL;
      ci = ca = 0;
    }

    if (ci<0)
      XAerrort(RANGE, "max : min(cond) < 0");
    
    retbd = dim;
    retbd.setdim (d, 1);
    if (MAXLONG / retbd.prod() < ca+1)
      XAerrort (RANGE, "max : result too large");
    retbd.setdim(d, ca+1);
    s        = retbd.prod();
#ifndef MEMDEBUG
    retptr   = new T[s];
    noval    = new long[s];
#else
    retptr = (T *) xmem.newptr (sizeof(T), s, "XplNumber", "max", "retptr");
    noval = (long *) xmem.newptr (sizeof(long), s, "XplNumber", "max", "noval");
#endif  

    for (i=0; i<s; i++)
    { ::SetMin ((retptr+i));
      noval[i] = 1;
    }

    jmp = 1;
    for (i=0; i<d; i++)
      jmp *= dim(i);

    tmp  = 0;

    if (condptr)
    { do
      { xp    = ptr+dim.value(tmp);
        retp  = retptr+retbd.value(tmp);
        condp = condptr+condbd.value(tmp);
        for (j=0; j<dim(d); j++, xp += jmp, condp += jmp)
        { if ((!isNaN (*xp)) && (*(retp+jmp* *condp) < *xp))
          { *(retp+jmp* *condp) = *xp;
            noval[jmp* *condp] = 0;
          }           
        }
      }
      while (tmp.inc(dim, d));
    }
    else
    { do
      { xp    = ptr+dim.value(tmp);
        i     = retbd.value(tmp);
        retp  = retptr+i;
        for (j=0; j<dim(d); j++, xp += jmp)
        { if ((!isNaN(*xp)) && (*retp < *xp)) 
          { *retp = *xp;
            noval[i] = 0;
          }
        }
      }
      while (tmp.inc(dim, d));
    }

    for (i=0; i<s; i++)
    { if (noval[i])
        ::SetNaN (retptr+i);
    }

    ret.setdim(retbd);
    ret.setptr(retptr);
#ifndef MEMDEBUG
    delete[] noval;
#else
    xmem.delptr (noval);
#endif
    return (ret);
  }

  template<class T> XplNumber<T> XplNumber<T>::minimum (long d, const XplNumber<long> *cond) const
  { XplNumber<T> ret(1);
    XplIndex retbd, tmp, tmp2, condbd;
    long i, s, ci, ca, *condptr, jmp, j, *condp, *noval;
    T *xp, *retptr, *retp;  
 
    if ((d<0) || (d>=MAX_XARRAY))
      XAerrort (RANGE, "min : dim out of range");
    if (cond)
    { condbd = cond->dim;
      for (i=0; i<MAX_XARRAY; i++)
        if (dim(i)!=condbd(i))
          XAerrort(DIMCON, "min : layer(x)<>layer(cond)");
      s = (cond->dim).prod();
      condptr = cond->getptr();
      ci = ca = *condptr;
      for (i=1; i<s; i++)
      { if (*(condptr+i) > ca) ca = *(condptr+i);
        if (*(condptr+i) < ci) ci = *(condptr+i);
      }
    }
    else
    { condptr = NULL;
      ci = ca = 0;
    }

    if (ci<0)
      XAerrort(RANGE, "min : min(cond) < 0");
    
    retbd = dim;
    retbd.setdim (d, 1);
    if (MAXLONG / retbd.prod() < ca+1)
      XAerrort (RANGE, "min : result too large");
    retbd.setdim(d, ca+1);
    s        = retbd.prod();
#ifndef MEMDEBUG
    retptr   = new T[s];
    noval    = new long[s];
#else
    retptr = (T *) xmem.newptr (sizeof(T), s, "XplNumber", "min", "retptr");
    noval = (long *) xmem.newptr (sizeof(long), s, "XplNumber", "min", "noval");
#endif  

    for (i=0; i<s; i++)
    { ::SetMax (retptr+i);
      noval[i] = 1;
    }

    jmp = 1;
    for (i=0; i<d; i++)
      jmp *= dim(i);

    tmp  = 0;

    if (condptr)
    { do
      { xp    = ptr+dim.value(tmp);
        retp  = retptr+retbd.value(tmp);
        condp = condptr+condbd.value(tmp);
        for (j=0; j<dim(d); j++, xp += jmp, condp += jmp)
        { if ((!isNaN(*xp)) && (*(retp+jmp* *condp) > *xp))
          { *(retp+jmp* *condp) = *xp;
            noval[jmp* *condp] = 0;
          }           
        }
      }
      while (tmp.inc(dim, d));
    }
    else
    { do
      { xp    = ptr+dim.value(tmp);
        i     = retbd.value(tmp);
        retp  = retptr+i;
        for (j=0; j<dim(d); j++, xp += jmp)
        { if ((!isNaN(*xp)) && (*retp > *xp))
          { *retp = *xp;
            noval[i] = 0;
          }
        }
      }
      while (tmp.inc(dim, d));
    }

    for (i=0; i<s; i++)
    { if (noval[i])
        ::SetNaN (retptr+i);
    }

    ret.setdim(retbd);
    ret.setptr(retptr);
#ifndef MEMDEBUG
    delete[] noval;
#else
    xmem.delptr (noval);
#endif

    return (ret);
  }

  template<class T> XplNumber<T> XplNumber<T>::cumsum (long d, const XplNumber<long> *cond) const
  { XplNumber<T> ret(1);
    XplIndex tmp, tmp2, condbd;
    long i, s, ci, ca, *condptr, jmp, j, *condp;
    T *xp, *retptr, *retp, *cs;  
 
    if ((d<0) || (d>=MAX_XARRAY))
      XAerrort (RANGE, "cumsum : dim out of range");
    if (cond)
    { condbd = cond->dim;
      for (i=0; i<MAX_XARRAY; i++)
        if (dim(i)!=condbd(i))
          XAerrort(DIMCON, "cumsum : layer(x)<>layer(cond)");
      s = (cond->dim).prod();
      condptr = cond->getptr();
      ci = ca = *condptr;
      for (i=1; i<s; i++)
      { if (*(condptr+i) > ca) ca = *(condptr+i);
        if (*(condptr+i) < ci) ci = *(condptr+i);
      }
    }
    else
    { condptr = NULL;
      ci = ca = 0;
    }

    if (ci<0)
      XAerrort(RANGE, "cumsum : min(cond) < 0");
    
    s        = dim.prod();
#ifndef MEMDEBUG
    retptr   = new T[s];
    cs       = new T[ca+1];
#else
    retptr = (T *) xmem.newptr (sizeof(T), s, "XplNumber", "cumsum", "retptr");
    cs = (T *) xmem.newptr (sizeof(T), ca+1, "XplNumber", "cumsum", "cs");
#endif  

    for (i=0; i<s; i++)
      *(retptr+i) = *(ptr+i);

    jmp = 1;
    for (i=0; i<d; i++)
      jmp *= dim(i);

    tmp  = 0;

    if (condptr)
    { do
      { retp  = retptr+dim.value(tmp);
        condp = condptr+condbd.value(tmp);
        for (i=0; i<=ca; i++)
          cs[i] = 0;

        for (j=0; j<dim(d); j++, retp += jmp, condp += jmp)
          cs[*condp] = (*retp += cs[*condp]); 
      }
      while (tmp.inc(dim, d));
    }
    else
    { do
      { retp  = retptr+dim.value(tmp);
        cs[0] = 0;
        
        for (j=0; j<dim(d); j++, retp += jmp)
          cs[0] = (*retp += cs[0]);
      }
      while (tmp.inc(dim, d));
    }
//    recinfo.print("DEL %p cs\n", cs);
#ifndef MEMDEBUG
    delete []cs;
#else
    xmem.delptr (cs);
    cs = NULL;
#endif
    ret.setdim(dim);
    ret.setptr(retptr);

    return (ret);
  }

  // PC 20010125
  template<class T> XplNumber<T> XplNumber<T>::cumsumnan (long d) const
  { XplNumber<T> ret(1);
    XplIndex tmp, tmp2;
    long i, s, jmp, j;
    T *xp, *retptr, *retp, cs;  
 
    if ((d<0) || (d>=MAX_XARRAY))
      XAerrort (RANGE, "cumsumnan : dim out of range");
    
    s        = dim.prod();
#ifndef MEMDEBUG
    retptr   = new T[s];
#else
    retptr = (T *) xmem.newptr (sizeof(T), s, "XplNumber", "cumsumnan", "retptr");
#endif  

    for (i=0; i<s; i++)
      *(retptr+i) = *(ptr+i);

    jmp = 1;
    for (i=0; i<d; i++)
      jmp *= dim(i);

    tmp  = 0;

    do
    {   
        retp  = retptr+dim.value(tmp);
        cs = 0;
        
        for (j=0; j<dim(d); j++, retp += jmp)
            if (!isNaN(*retp))
                cs = (*retp += cs);
    }
    while (tmp.inc(dim, d));

    ret.setdim(dim);
    ret.setptr(retptr);

    return (ret);
  }

  template<class T> XplNumber<T> XplNumber<T>::cummul (long d, const XplNumber<long> *cond) const
  { XplNumber<T> ret(1);
    XplIndex tmp, tmp2, condbd;
    long i, s, ci, ca, *condptr, jmp, j, *condp;
    T *xp, *retptr, *retp, *cs;  
 
    if ((d<0) || (d>=MAX_XARRAY))
      XAerrort (RANGE, "cummul : dim out of range");
    if (cond)
    { condbd = cond->dim;
      for (i=0; i<MAX_XARRAY; i++)
        if (dim(i)!=condbd(i))
          XAerrort(DIMCON, "cummul : layer(x)<>layer(cond)");
      s = (cond->dim).prod();
      condptr = cond->getptr();
      ci = ca = *condptr;
      for (i=1; i<s; i++)
      { if (*(condptr+i) > ca) ca = *(condptr+i);
        if (*(condptr+i) < ci) ci = *(condptr+i);
      }
    }
    else
    { condptr = NULL;
      ci = ca = 0;
    }

    if (ci<0)
      XAerrort(RANGE, "cummul : min(cond) < 0");
    
    s        = dim.prod();
#ifndef MEMDEBUG
    retptr   = new T[s];
    cs       = new T[ca+1];
#else
    retptr = (T *) xmem.newptr (sizeof(T), s, "XplNumber", "cummul", "retptr");
    cs = (T *) xmem.newptr (sizeof(T), ca+1, "XplNumber", "cummul", "cs");
#endif  

    for (i=0; i<s; i++)
      *(retptr+i) = *(ptr+i);

    jmp = 1;
    for (i=0; i<d; i++)
      jmp *= dim(i);

    tmp  = 0;

    if (condptr)
    { do
      { retp  = retptr+dim.value(tmp);
        condp = condptr+condbd.value(tmp);
        for (i=0; i<=ca; i++)
          cs[i] = 1;

        for (j=0; j<dim(d); j++, retp += jmp, condp += jmp)
          cs[*condp] = (*retp *= cs[*condp]); 
      }
      while (tmp.inc(dim, d));
    }
    else
    { do
      { retp  = retptr+dim.value(tmp);
        cs[0] = 1;
        
        for (j=0; j<dim(d); j++, retp += jmp)
          cs[0] = (*retp *= cs[0]);
      }
      while (tmp.inc(dim, d));
    }
#ifndef MEMDEBUG
    delete []cs;
#else
    xmem.delptr (cs);
    cs = NULL;
#endif
    ret.setdim(dim);
    ret.setptr(retptr);

    return (ret);
  }

  // PC 20010125
  template<class T> XplNumber<T> XplNumber<T>::cummulnan (long d) const
  { XplNumber<T> ret(1);
    XplIndex tmp, tmp2;
    long i, s, jmp, j;
    T *xp, *retptr, *retp, cs;  
 
    if ((d<0) || (d>=MAX_XARRAY))
      XAerrort (RANGE, "cummulnan : dim out of range");
    
    s        = dim.prod();
#ifndef MEMDEBUG
    retptr   = new T[s];
#else
    retptr = (T *) xmem.newptr (sizeof(T), s, "XplNumber", "cummulnan", "retptr");
#endif  

    for (i=0; i<s; i++)
      *(retptr+i) = *(ptr+i);

    jmp = 1;
    for (i=0; i<d; i++)
      jmp *= dim(i);

    tmp  = 0;

    do
    { 
        retp  = retptr+dim.value(tmp);
        cs = 1;
        
        for (j=0; j<dim(d); j++, retp += jmp)
          if (!isNaN(*retp))
            cs = (*retp *= cs);
    }
    while (tmp.inc(dim, d));
 
    ret.setdim(dim);
    ret.setptr(retptr);

    return (ret);
  }

  template<class T> void XplNumber<T>::fillvec (T start, T step, int op)
  { long i, max = dim.prod();
    T val = start;
    for (i=0; i<max; i++)
    { *(ptr+i) = val;
      if (op==1)
        val += step;
      else
        val *= step;
    }   
  }

  template<class T> XplNumber<long> XplNumber<T>::maxind (long d, const XplNumber<long> *cond) const
  { XplNumber<long> ret(1);
    XplIndex retbd, tmp, tmp2, condbd;
    long i, s, ci, ca, *condptr, jmp, j, *condp;
    T *xp;
    long *retptr, *retp, pos;  
 
    if ((d<0) || (d>=MAX_XARRAY))
      XAerrort (RANGE, "maxind : dim out of range");
    if (cond)
    { condbd = cond->dim;
      for (i=0; i<MAX_XARRAY; i++)
        if (dim(i)!=condbd(i))
          XAerrort(DIMCON, "maxind : layer(x)<>layer(cond)");
      s = (cond->dim).prod();
      condptr = cond->getptr();
      ci = ca = *condptr;
      for (i=1; i<s; i++)
      { if (*(condptr+i) > ca) ca = *(condptr+i);
        if (*(condptr+i) < ci) ci = *(condptr+i);
      }
    }
    else
    { condptr = NULL;
      ci = ca = 0;
    }

    if (ci<0)
      XAerrort(RANGE, "maxind : min(cond) < 0");
    
    retbd = dim;
    retbd.setdim (d, 1);
    if (MAXLONG / retbd.prod() < ca+1)
      XAerrort (RANGE, "maxind : result too large");
    retbd.setdim(d, ca+1);
    s        = retbd.prod();
#ifndef MEMDEBUG
    retptr   = new long[s];
#else
    retptr = (long *) xmem.newptr (sizeof(long), s, "XplNumber", "maxind", "retptr");
#endif  

    for (i=0; i<s; i++)
      *(retptr+i) = -1L;

    jmp = 1;
    for (i=0; i<d; i++)
      jmp *= dim(i);

    tmp  = 0;

    if (condptr)
    { do
      { pos   = dim.value(tmp);
        xp    = ptr+pos;
        retp  = retptr+retbd.value(tmp);
        condp = condptr+condbd.value(tmp);
        for (j=0; j<dim(d); j++, xp += jmp, condp += jmp, pos += jmp)
        { if (*(retp+jmp* *condp) == -1L)
            *(retp+jmp* *condp) = pos;
          else if (*(ptr+*(retp+jmp* *condp))  < *xp)
           *(retp+jmp* *condp) = pos;
        }
      }
      while (tmp.inc(dim, d));
    }
    else
    { do
      { pos   = dim.value(tmp);
        xp    = ptr+pos;
        retp  = retptr+retbd.value(tmp);
        for (j=0; j<dim(d); j++, xp += jmp, pos +=jmp)
          if (*retp == -1L)
            *retp = pos;
          else if (*(ptr+*retp) < *xp) 
            *retp = pos;
      }
      while (tmp.inc(dim, d));
    }

    ret.setdim(retbd);
    ret.setptr(retptr);

    for (i=0; i<retbd.prod(); i++)
    { if (*(retptr+i)>=0)
      { tmp         = dim.value(*(retptr+i));
        *(retptr+i) = tmp(d);
      }
      (*(retptr+i))++;
    }

    return (ret);
  }

  template<class T> XplNumber<long> XplNumber<T>::minind (long d, const XplNumber<long> *cond) const
  { XplNumber<long> ret(1);
    XplIndex retbd, tmp, tmp2, condbd;
    long i, s, ci, ca, *condptr, jmp, j, *condp;
    T *xp;
    long *retptr, *retp, pos;  
 
    if ((d<0) || (d>=MAX_XARRAY))
      XAerrort (RANGE, "minind : dim out of range");
    if (cond)
    { condbd = cond->dim;
      for (i=0; i<MAX_XARRAY; i++)
        if (dim(i)!=condbd(i))
          XAerrort(DIMCON, "minind : layer(x)<>layer(cond)");
      s = (cond->dim).prod();
      condptr = cond->getptr();
      ci = ca = *condptr;
      for (i=1; i<s; i++)
      { if (*(condptr+i) > ca) ca = *(condptr+i);
        if (*(condptr+i) < ci) ci = *(condptr+i);
      }
    }
    else
    { condptr = NULL;
      ci = ca = 0;
    }

    if (ci<0)
      XAerrort(RANGE, "minind : min(cond) < 0");
    
    retbd = dim;
    retbd.setdim (d, 1);
    if (MAXLONG / retbd.prod() < ca+1)
      XAerrort (RANGE, "minind : result too large");
    retbd.setdim(d, ca+1);
    s        = retbd.prod();
#ifndef MEMDEBUG
    retptr   = new long[s];
#else
    retptr = (long *) xmem.newptr (sizeof(long), s, "XplNumber", "minind", "retptr");
#endif  

    for (i=0; i<s; i++)
      *(retptr+i) = -1L;

    jmp = 1;
    for (i=0; i<d; i++)
      jmp *= dim(i);

    tmp  = 0;

    if (condptr)
    { do
      { pos   = dim.value(tmp);
        xp    = ptr+pos;
        retp  = retptr+retbd.value(tmp);
        condp = condptr+condbd.value(tmp);
        for (j=0; j<dim(d); j++, xp += jmp, condp += jmp, pos += jmp)
        { if (*(retp+jmp* *condp) == -1L)
            *(retp+jmp* *condp) = pos;
          else if (*(ptr+*(retp+jmp* *condp))  > *xp)
           *(retp+jmp* *condp) = pos;
        }
      }
      while (tmp.inc(dim, d));
    }
    else
    { do
      { pos   = dim.value(tmp);
        xp    = ptr+pos;
        retp  = retptr+retbd.value(tmp);
        for (j=0; j<dim(d); j++, xp += jmp, pos +=jmp)
          if (*retp == -1L)
            *retp = pos;
          else if (*(ptr+*retp) > *xp) 
            *retp = pos;
      }
      while (tmp.inc(dim, d));
    }

    ret.setdim(retbd);
    ret.setptr(retptr);

    for (i=0; i<retbd.prod(); i++)
    { if (*(retptr+i)>=0)
      { tmp         = dim.value(*(retptr+i));
        *(retptr+i) = tmp(d);
      }
      (*(retptr+i))++;
    }

    return (ret);
  }


template class XplNumber<int>;
template class XplNumber<long>;
template class XplNumber<double>;
