/* $Header: /home/xplore/cvs/xpl4gr/xpldllfun.cpp,v 1.3 2002/08/16 12:31:58 sigbert Exp $ */

// XploRe dynamic load functions
// see also xplfun.C and xplbasefun.C
// contains dynamic load interface

//  SK, 27.07.98

#include <windows.h>

#include "object.h"
#include "xplfun.h"
#include "init.h"
#include "xpldllfun.h"
#include "directory.h"

int maxDLL;
DLLctrl *DLLlib;

XplObject* DLLopen (Liste<XplObject*> *argl)
// expects a file name
{
  long       i;
/*  void       *DLLhandle = NULL;
  int        mode = RTLD_LAZY;
*/
  const char *t;
  XplDouble  *res;
  XplObject  *o;
  char       *fdir, loaddll[TEXTLENGTH];
  HINSTANCE  hinst;
/*
  static long counter = 1;
  */
  if (argl->laenge () != 1)
    {
    globalError.Set(ERR_ARGS, "DLLopen:  Must be 1");
    return (NULL);
    }

  o = (*argl)[0];
  if (o->DefaultType() != C_TEXT)
    {
    globalError.Set(ERR_TEXT, "DLLopen:  first argument");
    return (NULL);
    }

#ifdef _XPLCDEF_
  t = (*o->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  t = o->DefaultComponent()->Content().text;
#endif

  for (i=0; i<maxDLL; i++)           // equal names ?
    if (DLLlib[i].DLLid > -1)
      if (strcmp (DLLlib[i].name, t) == 0)
	globalWarning.Set (WARN_DLLOPEN, t);

  for (i=0; i<maxDLL; i++)           // search empty position
    if (DLLlib[i].DLLid == -1)
      break;

  if (i >= maxDLL)
    {
    globalError.Set (ERR_DLLOPEN, "too many libraries opened. Please close some.");
    return (NULL);
    }

/*
  fdir = FindDir (t, xpl4dll);      // search in global directory
  if (fdir == NULL)
    fdir = FindDir (t, ".");        // search in current dir
  if (fdir == NULL)
    fdir = FindDir (t, "");         // search absolut path name
*/

  fdir = openfile(DLL, t, "r");

  if (fdir == NULL)
    {
    globalError.Set (ERR_DLLOPEN, t);
    return (NULL);
    }
  sprintf (loaddll, "%s", fdir);
//  delete[] fdir;

  hinst = LoadLibrary (loaddll);

//  DLLhandle = dlopen (loaddll, mode);

  if (hinst == NULL)
    {
    globalError.Set (ERR_DLLOPEN, t);
    return (NULL);
    }
  DLLlib[i].name      = strdup (t);
  DLLlib[i].DLLid     = i; // counter;
  DLLlib[i].DLLhandle = GetModuleHandle (loaddll);
  //  DLLlib[i].DLLhandle = dlopen (t, mode);

  res = new XplDouble (1);
  (*res)(0) = i; // counter++;

  return (new XplObject (res, "dlopen"));

//   return (NULL);
   }

XplObject* DLLclose (Liste<XplObject*> *argl)
// expects nothing. DLLlist will be handled in the future
{
  XplObject  *o;
  XplDouble  *x = NULL;
  long       length = argl->laenge (), id = -1, i = -1;


  const char *t;
  char       *fdir, loaddll[TEXTLENGTH];
  int  hinst;

  if (length > 1)
  {
    globalError.Set(ERR_ARGS, "DLLclose:  expect no or one argument");
    return (NULL);
  }

  if (length == 1)
  {
    o = (*argl)[0];
    if (o->DefaultType () == C_TEXT)
    {
#ifdef _XPLCDEF_
      t = (*o->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
      t = o->DefaultComponent()->Content().text;
#endif

      for (i=0; i<maxDLL; i++)           // equal names ?
	     if (DLLlib[i].DLLid > -1)
	       if (strcmp (DLLlib[i].name, t) == 0)
	       {
	         id = DLLlib[i].DLLid;
	         break;
	       }
    }
    if (o->DefaultType () == C_XPLDOUBLE)
    {
      x = o->DefaultXplDouble ();
      id = (long) (*x)(0);
      if ((id < 0) || (id>=maxDLL) || (DLLlib[id].DLLid==-1))
	   {
        globalWarning.Set (WARN_DLLCLOSE, "invalid library handle");
	     return (NULL);
      }
    }
    if (id == -1)         // id not changed
    {
      globalError.Set(ERR_TYPE, "DLLclose:  first argument");
      return (NULL);
    }

    for (i=0; i<maxDLL; i++)
      if (DLLlib[i].DLLid == id)
	   {
	     delete[] (DLLlib[i].name);
        DLLlib[i].name  = NULL;
	     DLLlib[i].DLLid = -1;
	     if (FreeLibrary (DLLlib[i].DLLhandle) == 0)
	       globalError.Set (ERR_DLLCLOSE, t);
	     DLLlib[i].DLLhandle = 0;
        break;
      }
    if (i >= maxDLL)         // lib not found
    {
      globalWarning.Set (WARN_DLLCLOSE);
      return (NULL);
    }
  }
  else                              // close all
    for (i=0; i<maxDLL; i++)
      if (DLLlib[i].DLLid != -1)
    	{
	     delete[] (DLLlib[i].name);
	     DLLlib[i].name  = NULL;
	     DLLlib[i].DLLid = -1;
	     if (FreeLibrary (DLLlib[i].DLLhandle) == 0)
	       globalError.Set (ERR_DLLCLOSE, t);
        DLLlib[i].DLLhandle = 0;
      }

  return (NULL);
}

typedef int (*myproc0)(void);
typedef int (*myproc1)(double*);
typedef int (*myproc2)(double*, double*);
typedef int (*myproc3)(double*, double*, double*);
typedef int (*myproc4)(double*, double*, double*, double*);
typedef int (*myproc5)(double*, double*, double*, double*, double*);
typedef int (*myproc6)(double*, double*, double*, double*, double*, double*);
typedef int (*myproc7)(double*, double*, double*, double*, double*, double*, double*);
typedef int (*myproc8)(double*, double*, double*, double*, double*, double*, double*, double*);
typedef int (*myproc9)(double*, double*, double*, double*, double*, double*, double*, double*, double*);
typedef int (*myproca)(double*, double*, double*, double*, double*, double*, double*, double*, double*, double*);
typedef int (*myprocb)(double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*);
typedef int (*myprocc)(double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*);
typedef int (*myprocd)(double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*);
typedef int (*myproce)(double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*);
typedef int (*myprocf)(double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*, double*);

XplObject* DLLcall (Liste<XplObject*> *argl)
// expects a file name
{ /*
  long       ioffset, i, j, n, id, size, lres=-4165;
  void       *DLLsym = NULL;
  void       *DLLhandle = NULL;
*/

  HMODULE DLLhandle = 0;
  FARPROC DLLsym;
  long ppos = 0, i, length = argl->laenge ();
  double resv, *c[16];
  const char *t;
  XplObject  *o;
  XplDouble  *res, *x;

  if (length < 1)
    {
    globalError.Set(ERR_ARGS, "DLLcall:  Must be >= 1");
    return (NULL);
    }

  o = (*argl)[0];
  x = o->DefaultXplDouble ();
  if (x != NULL)
  {
     ppos++;

     i = (long) (*x)(0);
     if ((i<0) || (i>=maxDLL) || (DLLlib[i].DLLhandle==0))
	  {
	    globalError.Set(ERR_DLLCALL, "no library with this handler");
	    return (NULL);
	  }
     DLLhandle = DLLlib[i].DLLhandle;
     if (DLLhandle == 0)
     {
       globalError.Set(ERR_DLLCALL, "no library with this handler");
       return (NULL);
     }

     o = (*argl)[1];
  }

  if (o->DefaultType() != C_TEXT)
  {
    globalError.Set(ERR_TEXT, "DLLcall:  first argument");
    return (NULL);
  }

  ppos++;

#ifdef _XPLCDEF_
  t = (*o->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  t = o->DefaultComponent()->Content().text;
#endif

  if (DLLhandle == 0)
  {
    for (i=0; i<maxDLL; i++)
    { if (DLLlib[i].DLLid!=-1)
      { DLLsym = GetProcAddress (DLLlib[i].DLLhandle, t);
        if (DLLsym!=NULL) break;
      }
    }
  }
  else
    DLLsym = GetProcAddress (DLLhandle, t);

  if (DLLsym == NULL)
  {
    globalError.Set (ERR_DLLCALL, t);
    return (NULL);
  }

  for (i=ppos; i<length; i++)
  { x = (*argl)[i]->DefaultXplDouble();
    if (x==NULL)
    { char text[TEXTLENGTH];
      sprintf (text, "DLLcall: %ld argument", i-ppos+1);
      globalError.Set (ERR_NUM, text);
      return (NULL);
    }
    c[i-ppos] = x->getptr();
  }

  switch (length-ppos)
  { case  0 :
      resv = ((myproc0) DLLsym) ();
      break;
    case  1 :
      resv = ((myproc1) DLLsym) (c[0]);
      break;
    case  2 :
      resv = ((myproc2) DLLsym) (c[0], c[1]);
      break;
    case  3 :
      resv = ((myproc3) DLLsym) (c[0], c[1], c[2]);
      break;
    case  4 :
      resv = ((myproc4) DLLsym) (c[0], c[1], c[2], c[3]);
      break;
    case  5 :
      resv = ((myproc5) DLLsym) (c[0], c[1], c[2], c[3], c[4]);
      break;
    case  6 :
      resv = ((myproc6) DLLsym) (c[0], c[1], c[2], c[3], c[4], c[5]);
      break;
    case  7 :
      resv = ((myproc7) DLLsym) (c[0], c[1], c[2], c[3], c[4], c[5], c[6]);
      break;
    case  8 :
      resv = ((myproc8) DLLsym) (c[0], c[1], c[2], c[3], c[4], c[5], c[6], c[7]);
      break;
    case  9 :
      resv = ((myproc9) DLLsym) (c[0], c[1], c[2], c[3], c[4], c[5], c[6], c[7], c[8]);
      break;
    case 10 :
      resv = ((myproca) DLLsym) (c[0], c[1], c[2], c[3], c[4], c[5], c[6], c[7], c[8], c[9]);
      break;
    case 11 :
      resv = ((myprocb) DLLsym) (c[0], c[1], c[2], c[3], c[4], c[5], c[6], c[7], c[8], c[9], c[10]);
      break;
    case 12 :
      resv = ((myprocc) DLLsym) (c[0], c[1], c[2], c[3], c[4], c[5], c[6], c[7], c[8], c[9], c[10], c[11]);
      break;
    case 13 :
      resv = ((myprocd) DLLsym) (c[0], c[1], c[2], c[3], c[4], c[5], c[6], c[7], c[8], c[9], c[10], c[11], c[12]);
      break;
    case 14 :
      resv = ((myproce) DLLsym) (c[0], c[1], c[2], c[3], c[4], c[5], c[6], c[7], c[8], c[9], c[10], c[11], c[12], c[13]);
      break;
    case 15 :
      resv = ((myprocf) DLLsym) (c[0], c[1], c[2], c[3], c[4], c[5], c[6], c[7], c[8], c[9], c[10], c[11], c[12], c[13], c[14]);
      break;
    default :
      globalError.Set(ERR_DLLCALL, "too much parameters");
      return (NULL);
  }

  res = new XplDouble(1);
  (*res)(0) = resv;

  return (new XplObject (res, "dlcall"));
}


XplObject* DLLquery (Liste<XplObject*> *argl)
// expects a file name
{
  long       i, j = 0, countDLL = 0;
  XplDouble  *r1, *r2;
  XplObject  *o;
#ifdef _XPLCDEF_
  XplChar    *xc;
#endif

  if (argl->laenge () != 0)
    {
    globalError.Set(ERR_ARGS, "DLLquery:  No argument expected");
    return (NULL);
    }

  for (i=0; i<maxDLL; i++)           // count libs
    if (DLLlib[i].DLLid != -1)
      countDLL++;

  r1 = new XplDouble (1);
  (*r1)(0) = (double) countDLL;
  if (countDLL == 0)
    return (new XplObject (r1, "dlquery"));

  r2 = new XplDouble (countDLL);
#ifdef _XPLCDEF_
  xc = new XplChar   (countDLL);
#endif

  for (i=0; i<maxDLL; i++)           // count libs
    if (DLLlib[i].DLLid != -1)
      {
#ifdef _XPLCDEF_
      (*xc)(j) = xplstring (DLLlib[i].name);
#endif
      (*r2)(j++) = (double) DLLlib[i].DLLid;
      }

  o = new XplObject ("dlquery");
  o->AppendComponent (new Component (new XplObject (r1, "n")));
  o->AppendComponent (new Component (new XplObject (r2, "handle")));
#ifdef _XPLCDEF_
  o->AppendComponent (new Component (new XplObject (xc, "name")));
#endif

  return (o);
}

