/* $Header: /home/xplore/cvs/xpl4gr/xplfun.C,v 1.6 2003/10/30 08:32:40 xplore Exp $ */

// XploRe core functions
// see also xplfun2.C and xplbasefun.C

//  TTK, 15.2.95

//#pragma implementation

#include "machine.h"

#include <math.h>
#ifdef HAS_SMPMATH
#include "x4math.h"
#endif

#include <string.h>
#include <sys/stat.h>
#include <sys/stat.h>
#if !defined (__BORLANDC__) && !defined (WIN32) //LOOK!
#include <unistd.h>
#endif


#include "object.h"
#include "function.h"
#include "xplfun.h"
#include "xplerror.h"
#include "init.h"
#include "ttkio.h"
#include "xplerror.h"
#include "xplexec.h"
#include "fileinfo.h"
#include "directory.h"
#include "Dmath.h"

#ifndef MATRIX
#define rows() dimension(0)
#define cols() dimension(1)
#define out()  dump("%lg")
#endif

#include "nelmin4.h"

#ifdef __BORLANDC__
#include "xplwin.h"
#endif

#define TEXTLENGTH  1024L

// folgendes gehoert in irgeneinen Header von Sweta !!
#if defined (_GRAPHICS_)
extern "C" void refresh_macros();
extern "C" void edit(XplDouble &m);
extern "C" void edit_macro(const char*);
XplObject * readFromFileSelectionBox (void);
#endif

// XploRe core functions
// see also xplfun2.C and xplbasefun.C

//  TTK, 15.2.95

#include <math.h>
#include <string.h>

#include "object.h"
#include "function.h"
#include "xplfun.h"
#include "xplerror.h"
#include "init.h"
#include "ttkio.h"
#include "xplerror.h"
#include "xplexec.h"
#include "qsort.h"

#include "nelmin4.h"

#ifdef __BORLANDC__
#include "xplwin.h"
#endif

#define TEXTLENGTH  1024L

XplObject* Java2d (Liste<XplObject*> *argl)
{
  long length = argl->laenge(), i, n;
  XplDouble *rx;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "ifc: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "icf:");
    return (NULL);
    }

    rx = (*argl)[0]->DefaultXplDouble();

    n = rx->rows();
    if (rx->cols() < 2)
      {
      globalError.Set (ERR_INTERN, "icf: expect 2 columns");
      return (NULL);
    }

    cout << "_B_PLOT_" << endl << n;
    for (i=0; i<n; i++)
      cout << endl << (*rx)(i,0) << endl << (*rx)(i,1);
    cout << endl << "_E_PLOT_" << endl;
    return (NULL);
}

/*
XplObject* Java3d (Liste<XplObject*> *argl)
{
  long length = argl->laenge(), i, n;
  XplDouble *rx;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "ifc3d: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "icf3d:");
    return (NULL);
    }

    rx = (*argl)[0]->DefaultXplDouble();

    n = rx->rows();
    if (rx->cols() < 3)
      {
      globalError.Set (ERR_INTERN, "icf3d: expect 3 columns");
      return (NULL);
    }

#ifndef SOCKETSERVER
    cout << "_B_3DPLOT_";
    for (i=0; i<n; i++)
      cout << endl << "v " << (*rx)(i,0) << ' ' << (*rx)(i,1) << ' ' << (*rx)(i,2);
    cout << endl << "f";
    for (i=0; i<n; i++)
      cout << ' ' << i+1;
    cout << endl << 'E' << endl << "_E_3DPLOT_" << endl;
#else
    sockout ("_B_3DPLOT_");
    for (i=0; i<n; i++)
      {
      sockout ("\nv ");
      sockout ((*rx)(i, 0));
      sockout (' ');
      sockout ((*rx)(i, 1));
      sockout (' ');
      sockout ((*rx)(i, 2));
      }
      sockout ("\nf ");
    for (i=0; i<n; i++)
      {
      sockout (' ');
      sockout (i+1L);
      }
      sockout ("\nE\n_E_3DPLOT_\n");
#endif
    return (NULL);
}
*/

XplObject* catFile (Liste<XplObject*> *argl)
{
  long length = argl->laenge();
  const char *fun;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "catFile: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set (ERR_TEXT, "catFile:");
    return (NULL);
    }

#ifdef _XPLCDEF_
    fun = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    fun = (*argl)[0]->DefaultComponent()->Content().text;
#endif

    FILE *fin = fopen (fun, "r");
    char text[512];

    if (fin == NULL)
      return (NULL);

    while (!feof (fin))
      cout << fgets (text, 512, fin);
    cout << endl;

    return (NULL);
}


int PowOf2 (const long n)
{
long m = 1;

  while (m != 0)
    { 
    if (m == n)
      return (TRUE);
    m <<= 1;
    }
  return (FALSE);
}

char * FindDir (const char *name, const char *dirsorig, int env)
/* finds directory, where the file 'name' is. Candidates for the
   directories are given in 'dirsorig' and are separated with ':'.
   Usually dirsorig contains an environment variable. If env is TRUE
   (default), FindDir delivers only directories, which are contained
   in dirsorig, otherwise the full path to the file without the name
   itself(!). If no file is found, NULL will be returned. */
{
  char *dir, *dirs, *res, fname[TEXTLENGTH];
  FILE *fin;
  int  found;

  dirs = strdup (dirsorig);    // copy because strtok changes 1. arg
  dir  = strtok (dirs, ":");

  if (dir == NULL)
    sprintf (fname, "%s", name);
  else
    sprintf (fname, "%s/%s", dir, name);

  fin   = fopen (fname, "r");
  found = fin != NULL;

  while (!found)
    {
    dir = strtok (NULL, ":");  // get next candidate

    if (dir == NULL)           // there are no more, bye
      {
      delete dirs;
      return (NULL);
      }

    sprintf (fname, "%s/%s", dir, name);
    fin   = fopen (fname, "r");
    found = fin != NULL;
    }

  if (found)                   // otherwise filedescriptors overflow
    fclose (fin);
  if (env)
    {
    res = dir == NULL ? strdup ("") : strdup (dir);
    delete dirs;
    return (res);
    }
  res   = strdup (fname);
  int n = strlen (res);
  for (int i=n-1; i>=0; i--)
    if (res[i] == '/')
      {
      res[i+1] = '\0';
      delete dirs;
      return (res);
      }
  return (NULL);     // cannot happen
}

int alreadyReadFile (const char *macfile, int delBuffer)
/* returns TRUE if macfile has already been read and time of last
   has not been changed.
   if delBuffer == TRUE, the internal fileList will be deleted
   => no macro is any longer marked as read
*/
{
  static Vector<FileInfo*> fileList;

  if (delBuffer == TRUE)
    {
    fileList.remove ();
    return (FALSE);
    }

  struct stat buf;
  FileInfo *fi = GetFileInfo (fileList, macfile);

  if (0 != stat (macfile, &buf))
    {
    cerr << "Fehler: File Status" << endl;
    return (FALSE);                        // next call reads again
    }

  if (fi == NULL)          // read macfile
    {
    fileList.haengeAn (new FileInfo (buf.st_ctime, macfile));
    return (FALSE);
    }

  if (fi->GetTimeStamp() < buf.st_ctime)     // macfile has changed
    {
    fi->SetTimeStamp (buf.st_ctime);
    return (FALSE);
    }

  return (TRUE);
}


XplObject* testExec   (Liste<XplObject*> *argl)
{
  long length = argl->laenge(), i, translated = 0;
  const char *n[3];
  XplDouble xx(1);

  xx(0) = 44.0;

  if (length != 3)
    {
    globalError.Set (ERR_ARGS, "testExec: Must be 3");
    return (NULL);
    }

  for (i=0; i<length; i++)
    {
    if ((*argl)[i]->DefaultComponent()->Type() != C_TEXT)
      {
      globalError.Set (ERR_TEXT, "testExec:");
      return (NULL);
      }

#ifdef _XPLCDEF_
    n[i] = (*(*argl)[i]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    n[i] = (*argl)[i]->DefaultComponent()->Content().text;
#endif
    }

  void *id = StartExecution ();
  cerr << "generate " << GenerateXplObject (n[0], &xx, id) << endl;
  cerr << "generate " << GenerateXplObject (n[0], &xx, id, TRUE) << endl;
  cerr << "get  " << (long) GetXplObject (n[1], id) << endl;
  Execute (n[2], id, translated);
  EndExecution (id);

  return (NULL);
}

XplObject* testIntervall (Liste<XplObject*> *argl)
{
  long length = argl->laenge();
  const char *fun;
  XplDouble *lx, *rx;
  double r;

  if ((length != 3) && (length != 4))
    {
    globalError.Set (ERR_ARGS, "testIntervall: Must be 3 or 4");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set (ERR_TEXT, "testIntervall:");
    return (NULL);
    }

#ifdef _XPLCDEF_
    fun = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    fun = (*argl)[0]->DefaultComponent()->Content().text;
#endif
    lx = (*argl)[1]->DefaultXplDouble ();
    rx = (*argl)[2]->DefaultXplDouble ();

    r = (*rx)(0);

  if (length == 3)
    intervall (fun, (*lx)(0), r);
  else
    intervall2 (fun, (*lx)(0), r);

    rx = new XplDouble (1);
    (*rx)(0) = r;

  if (globalError.Get())
    {
    delete rx;
    return (NULL);
    }

  return (new XplObject (rx, "intervall"));
}

XplObject* testNelmin (Liste<XplObject*> *argl)
{
  long       length = argl->laenge();
  const char *fun;
  XplDouble  *start, *h, rx(1);
  XplObject  *res;
  double     step = 1.0,  eps = 1e-3;
  int        maxiter, iter = 50;

  if ((length < 2) || (length > 5))
    {
    globalError.Set (ERR_ARGS, "Nelmin: Must be 3, 4 or 5");
    return (NULL);
    }
  // start values
  if ((*argl)[0]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "Nelmin:");
    return (NULL);
    }
  // the function
  if ((*argl)[1]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set (ERR_TEXT, "Nelmin:");
    return (NULL);
    }
  // maximal iterations
if (length >= 3)
  if ((*argl)[2]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "Nelmin:");
    return (NULL);
    }
  // eps (optional)
if (length >= 4)
  if ((*argl)[3]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "Nelmin:");
    return (NULL);
    }
  // step? (optional)
if (length == 5)
  if ((*argl)[4]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
    globalError.Set (ERR_TEXT, "testNelmin:");
    return (NULL);
    }

#ifdef _XPLCDEF_
    fun = (*(*argl)[1]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    fun = (*argl)[1]->DefaultComponent()->Content().text;
#endif

    start = (*argl)[0]->DefaultXplDouble ();
    if (length >= 3)
      maxiter = iter = (int) (*(*argl)[2]->DefaultXplDouble ())(0);
    if (length >= 4)
      eps  = (*(*argl)[3]->DefaultXplDouble ())(0);
    if (length == 5)
      step  = (*(*argl)[4]->DefaultXplDouble ())(0);

  h  = new XplDouble (1);
  *h = nelmin (*start, fun, eps, step, iter);

  if (globalError.Get())
    {
    delete h;
    return (NULL);
    }

  res = new XplObject ("nelmin");
  res->AppendComponent (new Component (new XplObject (h, "minimum")));
  h       = new XplDouble (1);
  (*h)(0) = (double) iter;
  res->AppendComponent (new Component (new XplObject (h, "iter")));
  h       = new XplDouble (1);
  (*h)(0) = (double) (iter < maxiter);
  res->AppendComponent (new Component (new XplObject (h, "converged")));

  return (new XplObject (res, "nelmin"));
}

XplObject* testBFGS (Liste<XplObject*> *argl)
{
  long       length = argl->laenge();
  const char *fun, *der;
  XplDouble  *start, *h, *hesse;
  double     gamma = 1.0, eps = 1e-3;
  int        maxiter, iter = 50;
  XplObject  *res;

  if ((length < 3) || (length > 6))
    {
    globalError.Set (ERR_ARGS, "BFGS: Must be 4, 5 or 6");
    return (NULL);
    }
  // start values
  if ((*argl)[0]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "BFGS:");
    return (NULL);
    }
  // the function
  if ((*argl)[1]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set (ERR_TEXT, "BFGS:");
    return (NULL);
    }
  // and its derivative
  if ((*argl)[2]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set (ERR_TEXT, "BFGS:");
    return (NULL);
    }
  // maximal iterations
if (length >= 4)
  if ((*argl)[3]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "BFGS:");
    return (NULL);
    }
  // eps (optional)
if (length >= 5)
  if ((*argl)[4]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "BFGS:");
    return (NULL);
    }
  // gamma? (optional)
if (length >= 6)
  if ((*argl)[5]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "BFGS:");
    return (NULL);
    }
  // hesse? (optional)
if (length == 7)
  if ((*argl)[5]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "BFGS:");
    return (NULL);
    }

#ifdef _XPLCDEF_
    fun = (*(*argl)[1]->DefaultComponent()->Content().xplchar)(0).tocstr();
    der = (*(*argl)[2]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    fun = (*argl)[1]->DefaultComponent()->Content().text;
    der = (*argl)[2]->DefaultComponent()->Content().text;
#endif

    start = (*argl)[0]->DefaultXplDouble ();
    if (length >= 4)
      maxiter = iter = (int) (*(*argl)[3]->DefaultXplDouble ())(0);
    if (length >= 5)
      eps   = (*(*argl)[4]->DefaultXplDouble ())(0);
    if (length >= 6)
      gamma  = (*(*argl)[5]->DefaultXplDouble ())(0);
    if (length == 7)
      hesse  = (*argl)[6]->DefaultXplDouble ();

    h  = new XplDouble (1);
    *h = bfgs (*start, fun, der, iter, eps, gamma);

    /* SK 02.03.99
#ifndef PSGEN
      cerr << "bfgs iterationen: " << iter << endl;
#endif
*/
  if (globalError.Get())
    {
    delete h;
    return (NULL);
    }

  res = new XplObject ("bfgs");
  res->AppendComponent (new Component (new XplObject (h, "minimum")));
  h       = new XplDouble (1);
  (*h)(0) = (double) iter;
  res->AppendComponent (new Component (new XplObject (h, "iter")));
  h       = new XplDouble (1);
  (*h)(0) = (double) (iter < maxiter);
  res->AppendComponent (new Component (new XplObject (h, "converged")));

  return (new XplObject (res, "bfgs"));
}

XplObject* testSimpson (Liste<XplObject*> *argl)
{
  long length = argl->laenge();
  const char *fun;
  XplDouble *xa, *rx, *xb, *m;
  
  if (length != 4)
    {
    globalError.Set (ERR_ARGS, "testSimpson: Must be 4");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set (ERR_TEXT, "testSimpson:");
    return (NULL);
    }

#ifdef _XPLCDEF_
  fun = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  fun = (*argl)[0]->DefaultComponent()->Content().text;
#endif
  xa    = (*argl)[1]->DefaultXplDouble ();
  xb    = (*argl)[2]->DefaultXplDouble ();
  m     = (*argl)[3]->DefaultXplDouble ();
    
  rx = new XplDouble (1);

  *rx = simpson (fun, *xa, *xb, *m); 

  if (globalError.Get())
    {
    delete rx;
    return (NULL);
    }

  return (new XplObject (rx, "simpson"));
}


int LoadMacro (const char *fname, int reload)
/* loads macros. First LoadMacro tries to open the file fname.xpl. If
   it doesn't exist, fname is tested. If a file is found, it will be
   processed by parse and TRUE is returned, otherwise FALSE.
   If reload is TRUE, LoadMacro reloads the file in any case
   regardless, if it was already loaded before or not. reload is
   on default FALSE (Library mode). If reload is FALSE, the file is
   only reloaded if it is newer than at load time.
*/
{
  char macfile[TEXTLENGTH];
  FILE *fin;


  sprintf (macfile, "%s.xpl", fname);
  fin = fopen (macfile, "r");

  if (fin == NULL)
    {
    sprintf (macfile, "%s", fname);
    fin = fopen (macfile, "r");
    }

  if (fin == NULL)               // no such file in current directory
    return (FALSE);

  if (reload == FALSE)           // do not call alreadyReadFile !
    if (alreadyReadFile (macfile) == TRUE)
      {
      fclose (fin);
      return (TRUE);
      }

  parse (fin);
  fclose (fin);
  return (TRUE);
}


XplObject* print (Liste<XplObject*> *argl)
{
  long   i, length = argl->laenge ();
  XplObject *obj;

  for (i=0; i<length; i++)
    {
    obj = GetXplObject (objList, (*argl)[i]->Name ());
    if (obj != NULL)
      obj->Print ();
    else
      globalError.Set (ERR_COMMON,"print: obj == NULL");
    }

  return (NULL);
}

/*
XplObject* matrix   (Liste<XplObject*> *argl)
{
  XplDouble *x;
  long     i, length = argl->laenge(), r, c;

  if (length < 2)
    {
    ttkerror("matrix:  Error:  wrong number of arguments. Must == 2");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();
  r = (long) (*x)(0);
  x = (*argl)[1]->DefaultXplDouble ();
  c = (long) (*x)(0);

  return (new XplObject (new XplDouble (r,c)));
}
*/

XplObject* printMacroText (Liste<XplObject*> *argl)
{
  Macro *mac;

  if (argl->laenge () != 1)
    {
    globalError.Set(ERR_ARGS, "printMacroText: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() == C_TEXT)
    {
#ifdef _XPLCDEF_
    const char *t;
    t = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
    mac = GetMacro (macList, t);
#else
    mac = GetMacro (macList, (*argl)[0]->DefaultComponent()->Content().text);
#endif
    if (mac != NULL)
      {
      cout << mac->Text () << endl;
      return (NULL);
      }
    }

  globalError.Set (ERR_MAC, "printMacroText:");

  return (NULL);
}

XplObject* printMacroTL (Liste<XplObject*> *argl)
{
  Macro *mac;

  if (argl->laenge () != 1)
    {
    globalError.Set(ERR_ARGS, "printMacroText: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() == C_TEXT)
    {
#ifdef _XPLCDEF_
    const char *t;
    t = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
    mac = GetMacro (macList, t);
#else
    mac = GetMacro (macList, (*argl)[0]->DefaultComponent()->Content().text);
#endif
    if (mac != NULL)
      {
      ShowTokenList (mac->globalList());
      return (NULL);
      }
    }

  globalError.Set (ERR_MAC, "printMacroText:");

  return (NULL);
}

XplObject* saveMacroText (Liste<XplObject*> *argl)
{
  Macro *mac;
  FILE  *fout;
  const char  *t;

  if (argl->laenge () > 2)
    {
    globalError.Set(ERR_ARGS, "saveMacroText:  Must be 1 or 2");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() == C_TEXT)
    {
#ifdef _XPLCDEF_
//    const char *t;
    t = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    t = (*argl)[0]->DefaultComponent()->Content().text;
#endif
    mac = GetMacro (macList, t);
    if (mac == NULL)
      {
      globalError.Set (ERR_MAC, "saveMacroText: ");
      globalError.AppendText (ERR_MAC, t);
      return (NULL);
      }
    }

  if (argl->laenge () == 2)
    if ((*argl)[1]->DefaultComponent()->Type() == C_TEXT)
      {
#ifdef _XPLCDEF_
//      const char *t;
      t = (*(*argl)[1]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
      t = (*argl)[1]->DefaultComponent()->Content().text;
#endif
      fout = fopen (t, "w");
      }
    else
      {
      globalError.Set (ERR_TEXT, "saveMacroText:  Second argument ");
      return (NULL);
      }
  else
    {
#ifdef _XPLCDEF_
//    const char *t;
    t = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    t = (*argl)[0]->DefaultComponent()->Content().text;
#endif
    fout = fopen (t, "w");
    }

  if (fout == NULL)
    {
    globalError.Set (ERR_FILE, "saveMacroText: ");
    globalError.AppendText (ERR_MAC, t);
    return (NULL);
    }
  fputs (mac->Text (), fout);
  fclose (fout);

  return (NULL);
}

#ifdef MATRIX
XplObject*	runif (Liste<XplObject*> *argl)
{
  int row, col, i, j, length = argl->laenge();
  XplDouble *s, *t;

  if ((length != 1) && (length != 2))
    {
    globalError.Set (ERR_ARGS, "runif: Must be 1 or 2");
    return (NULL);
    }

  if ((s = (*argl)[0]->DefaultXplDouble()) == NULL)
    {
    globalError.Set (ERR_NUM, "runif: first argument");
    return (NULL);
    }

  if (!s->isScalar())
    {
    globalError.Set (ERR_DIM, "runif:  first argument has to be a scalar");
    return (NULL);
    }

  row = (int) (*s)(0);

  if (length == 2)
    {
    if ((s = (*argl)[1]->DefaultXplDouble()) == NULL)
      {
      globalError.Set (ERR_NUM, "runif: second argument");
      return (NULL);
      }

    if (!s->isScalar())
      {
      globalError.Set (ERR_DIM, "runif:  second argument has to be a scalar");
      return (NULL);
      }
    col = (int) (*s)(0);
    }
  else
    col = 1;
  
  t = new XplDouble(row, col);

  for (i=0; i<row; i++)
    for (j=0; j<col; j++)
#ifdef WIN32
      (*t)(i,j) = rand()/(double) ((1<<15) - 1);
#else
      (*t)(i,j) = rand()/(double) ((1<<31) - 1);
#endif

  return (new XplObject (t, "runif"));
}

#else    // of MATRIX

XplObject*	runif (Liste<XplObject*> *argl)
{
  long length = argl->laenge (), i, n;
  XplDouble *s1, *s;
  XplIndex xind;

  if ((length == 0) || (length > MAX_XARRAY))
    {
    globalError.Set (ERR_ARGS, "unif: too less or too many arguments");
    return (NULL);
    }

  for (i=0; i<length; i++)
    {
    s1 = (*argl)[i]->DefaultXplDouble ();
    if (s1 == NULL)
      {
      globalError.Set (ERR_NUM, "runif: first argument");
      return (NULL);
      }
#ifdef MATRIX
    if (!s->isScalar())
#else
    if (s1->dimension() != 0)
#endif
      {
      globalError.Set (ERR_DIM, "runif: first argument is not scalar");
      return (NULL);
      }

    n = (long) rint ((*s1)(0));
    if (n <= 0)
      {
      globalError.Set (ERR_VAL, "runif: arguments must be positiv");
      return (NULL);
      }
    xind.setdim (i, n);
  }

  s = new XplDouble (xind);
  s->random (1);             // XploRe 3.2 normal

  return (new XplObject (s, "runif"));
}
#endif

#ifdef MATRIX  
XplObject*	rnorm (Liste<XplObject*> *argl)
{
  double x, y;
  int row, col, i, j, length = argl->laenge();
  XplDouble *s, *t;

  if ((length != 1) && (length != 2))
    {
    globalError.Set (ERR_ARGS, "rnorm: Must be 1 or 2");
    return (NULL);
    }

  if ((s = (*argl)[0]->DefaultXplDouble()) == NULL)
    {
    globalError.Set (ERR_NUM, "rnorm: first argument");
    return (NULL);
    }

  if (!s->isScalar())
    {
    globalError.Set (ERR_DIM, "rnorm: first argument has to be a scalar");
    return (NULL);
    }

  row = (int) (*s)(0);

  if (length == 2)
    {
    if ((s = (*argl)[1]->DefaultXplDouble()) == NULL)
      {
      globalError.Set (ERR_NUM, "rnorm: second argument");
      return (NULL);
      }

    if (!s->isScalar())
      {
      globalError.Set (ERR_DIM, "rnorm: second argument has to be a scalar");
      return (NULL);
      }
    col = (int) (*s)(0);
    }
  else
    col = 1;
  
  t = new XplDouble(row, col);

  for (i=0; i<row; i++)
    for (j=0; j<col; j++)
      {
#ifdef WIN32
      x = rand()/(double) ((1<<15) - 1);
      y = rand()/(double) ((1<<15) - 1);
#else
      x = rand()/(double) ((1<<31) - 1);
      y = rand()/(double) ((1<<31) - 1);
#endif
      (*t)(i,j) = sqrt(-2.0*log(x))*cos(2.0*3.14159*y);
      }

  return (new XplObject (t, "rnorm"));
}

#else    // of MATRIX

XplObject*	rnorm (Liste<XplObject*> *argl)
{
  long length = argl->laenge (), i, n;
  XplDouble *s1, *s;
  XplIndex xind;

  if ((length == 0) || (length > MAX_XARRAY))
    {
    globalError.Set (ERR_ARGS, "rnorm: too less or too many arguments");
    return (NULL);
    }

  for (i=0; i<length; i++)
    {
    s1 = (*argl)[i]->DefaultXplDouble ();
    if (s1 == NULL)
      {
      globalError.Set (ERR_NUM, "rnorm: first argument");
      return (NULL);
      }
#ifdef MATRIX
    if (!s->isScalar())
#else
    if (s1->dimension() != 0)
#endif
      {
      globalError.Set (ERR_DIM, "rnorm: first argument is not scalar");
      return (NULL);
      }

    n = (long) rint ((*s1)(0));
    if (n <= 0)
      {
      globalError.Set (ERR_VAL, "rnorm: arguments must be positiv");
      return (NULL);
      }
    xind.setdim (i, n);
  }

  s = new XplDouble (xind);
  s->random (6);             // XploRe 3.2 normal 

  return (new XplObject (s, "rnorm"));
}
#endif


XplObject*	transpose (Liste<XplObject*> *argl)
{
  int d0 = 0, d1 = 1, length = argl->laenge();
  XplObject *x1;
  XplDouble *s1, *s2;

  if ((length != 1) && (length != 3))
    {
    globalError.Set (ERR_ARGS, "trans: Must be 1 or 3");
    return (NULL);
    }

  x1 = (*argl)[0];
  if ((s1 = x1->DefaultXplDouble()) == NULL)
    {
    globalError.Set (ERR_NUM, "trans: first argument");
    return (NULL);
    }

  if (length == 3)
    {
    x1 = (*argl)[1];
    if ((s2 = x1->DefaultXplDouble()) == NULL)
      {
      globalError.Set (ERR_NUM, "trans: second argument");
      return (NULL);
      }
    d0 = -1 + (int) (*s2)(0);
    x1 = (*argl)[2];
    if ((s2 = x1->DefaultXplDouble()) == NULL)
      {
      globalError.Set (ERR_NUM, "trans: third argument");
      return (NULL);
      }
    d1 = -1 + (int) (*s2)(0);
    }

  s2 = new XplDouble (s1);

#ifdef MATRIX
  s2->transpose();
#else
  *s2 = s1->trn(*s1, d0, d1);
#endif

  if (globalError.Get())
    {
    delete s2;
    return (NULL);
    }

  return (new XplObject (s2, "trans"));
}


XplObject* execFile (Liste<XplObject*> *argl)
{
  long        length = argl->laenge();
  GlobalList  gl;
  const char  *n;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "execFile: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set (ERR_TEXT, "execFile:");
    return (NULL);
    }

#ifdef _XPLCDEF_
  n = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  n = (*argl)[0]->DefaultComponent()->Content().text;
#endif


  if (LoadMacro (n, TRUE) == FALSE)
    globalError.Set (ERR_MAC, n);

  return (NULL);
}

XplObject* readMac (Liste<XplObject*> *argl)
{
  long        length = argl->laenge(), len;
  GlobalList  gl;
  char        *fdir, line[TEXTLENGTH], loadfile[TEXTLENGTH];
  const char  *n;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "readMac: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set (ERR_TEXT, "readMac:");
    return (NULL);
    }

#ifdef _XPLCDEF_
  n = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  n = (*argl)[0]->DefaultComponent()->Content().text;
#endif

  len = strlen (n);      // look for extension .xpl and append if necessary

  if ((n[len-4] == '.') && (n[len-3] == 'x') && 
      (n[len-2] == 'p') && (n[len-1] == 'l'))
    sprintf (line, "%s", n);
  else
    sprintf (line, "%s.xpl", n);
/*  fdir = FindDir (line, ".");          // search in current directory
  if (fdir == NULL)
    fdir = FindDir (line, "lib");      // search in current subdir lib
  if (fdir == NULL)
    fdir = FindDir (line, xpl4lib);    // search in xpl4lib
  if (fdir == NULL)
    fdir = FindDir (line, "/");        // absolut pathname
SK 23.06.98 */

  fdir = openfile (LIB, line, "r"); 
  if (fdir == NULL)
    {
    globalError.Set (ERR_MAC, line);
    return (NULL);
    }

  sprintf (loadfile, "%s", fdir);
//  delete[] fdir;

  LoadMacro (loadfile, TRUE);         // runs loadfile (reload = TRUE)

  return (NULL);
}

XplObject* X4LoadLibrary (Liste<XplObject*> *argl)
{
  long length = argl->laenge(), i, j, len, no;
  char *r, *fdir, *fdir2, *qn,
       *loadfile, libpath[TEXTLENGTH], line[TEXTLENGTH], libmain[TEXTLENGTH];
  const char *n;
  FILE *fin;

  static Liste<char*> loaded;     // list of loaded lib to check recursion
  static long counter = 0L;       // counts the recursive calls of function

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "LoadLibrary: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set (ERR_TEXT, "LoadLibrary:");
    return (NULL);
    }

#ifdef _XPLCDEF_
  n = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  n = (*argl)[0]->DefaultComponent()->Content().text;
#endif

  len = strlen (n);      // look for extension .lib and append if necessary

  if ((n[len-4] == '.') && (n[len-3] == 'l') && 
      (n[len-2] == 'i') && (n[len-1] == 'b'))
    sprintf (line, "%s", n);
  else
    sprintf (line, "%s.lib", n);

  // In the following, we need the fdir to open the lib-file and
  // fdir2 to open the xpl-file contained in the lib-file
 
  // SK 23.06.98
  // sprintf (libpath, "%s", xpl4lib); 
  // fdir  = FindDir (line, libpath);
  // fdir2 = FindDir (line, libpath, FALSE);

/*
  if (fdir == NULL)
    {
    sprintf (libpath, "./lib");
    fdir = FindDir (line, libpath);
    fdir2 = FindDir (line, libpath, FALSE);
    }

  if (fdir == NULL)
    {
    sprintf (libpath, ".");
    fdir = FindDir (line, libpath);
    fdir2 = FindDir (line, libpath, FALSE);
    }

  if (fdir == NULL)
    {
    globalError.Set (ERR_FILE, line);
    return (NULL);
    }

  sprintf (loadfile, "%s/%s", fdir, line);
*/
  loadfile = openfile (LIB, line, "r");
  if (loadfile==NULL)  // SK 03.08.98
  { sprintf (libpath, "Can not open library: %s\n", line);
    globalError.Set (ERR_INTERN, libpath);
    return (NULL);
  }

  // is current lib-file already loaded in this library-call
  for (i=0; i<loaded.laenge(); i++)
    {
    if (strcmp (loaded[i], loadfile) == 0)
      return NULL;
    }
  loaded.fuegeEin (strdup(loadfile), 0);       // store the name

  fin = fopen (loadfile, "r");

  if (fin == NULL)           // if the file descriptors overflow
    {
    globalError.Set (ERR_INTERN, "Fatal Error by loading library");
    globalError.AppendText (ERR_INTERN, "no file descriptor for");
    globalError.AppendText (ERR_INTERN, loadfile);
    return (NULL);
    }

  fdir2 = opendir(LIB, line, "r");

  // try to create mainfile name
  X4Filename fn;
  fn.setname(n);
  sprintf (libmain, "%smain", fn.getonlyfilename(true));          // now try to execute mainfile

  i = 0;
  r = fgets (line, 1024, fin);
  no = 1;
// while (! feof(fin))           // access to file necessarily to recognize eof
  while (r != NULL)           // access to file necessarily to recognize eof
    {
    while ((line[i] == ' ') || (line[i] == '\t'))
      i++;
    if ((line[i] == '\r') || (line[i] == '\n') || (line[i] == ';'))
      {
      i = 0;
      r = fgets (line, 1024, fin);
      continue;
      }
    j = i;
    while ((line[j] != ' ')  && (line[j] != '\t') &&
           (line[j] != '\n') && (line[j] != '\0') && (line[j] != '\r'))
      j++;

    line[j--] = '\0';

    if (line[j] == ';')             // if last letter is ';'
      line[j] = '\0';

//    len = strlen (line) - 1;
//    if (line[len] == '\n')
//      line[len] = '\0';

    qn  = line+i;
    len = strlen (qn);      // look for extension .lib and append if necessary

    if ((qn[len-4] == '.') && (qn[len-3] == 'x') && 
        (qn[len-2] == 'p') && (qn[len-1] == 'l'))
    { qn[len-4] = 0; }

    if (strcmp(qn, libmain)==0)
    { sprintf (libpath, "%s%s%s", fdir2, SEPCHAR, qn);
      if (!LoadMacro (libpath))
      { if (globalError.Get())
        { globalError.AppendText (ERR_FILE, libpath);
          break;                        // accept only one Error
        }
        else
	     { globalError.Set (ERR_INTERN, "Can not load quantlet");
          globalError.AppendText(ERR_INTERN, qn);
          globalError.AppendText(ERR_INTERN, "from library");
          globalError.AppendText(ERR_INTERN, loadfile);
        }
      }
    }
    else // now write in list
    { x4ml.insert (qn, fdir2);
    }
    i = 0;
    r = fgets (line, 1024, fin);
    no++;
  }

  fclose (fin);
//  delete[] fdir;
//  delete[] fdir2;

  if (NULL != GetMacro (macList, libmain))  // now try to execute mainfile
  { sprintf (line, "%s()", libmain);	// PC 20010510
    counter++;
    parse (line);
    counter--;
  }

  if (counter == 0L)                   // first call -> delete loaded list
  { for (i=0; i<loaded.laenge(); i++)
      delete[] loaded[i];
    loaded.remove ();
  }

	/*
  delete[] loaded[0];
  loaded.loesche (0);           // delete this lib from loaded list
  */
#if defined (_GRAPHICS_)
  refresh_macros();
#endif
  return (NULL);
}

XplObject* ExecCommand (Liste<XplObject*> *argl)
{
  long length = argl->laenge();

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "ExecCommand: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set (ERR_TEXT, "ExecCommand:");
    return (NULL);
    }

  const char *n;
#ifdef _XPLCDEF_
  n = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  n = (*argl)[0]->DefaultComponent()->Content().text;
#endif
  parse (n);

  return (NULL);
}

XplObject* saveMac (Liste<XplObject*> *argl)
{
  long length = argl->laenge();
  char        name[TEXTLENGTH];
  const char  *t;
  Macro       *mac;
  FILE *fout;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "saveMac: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set (ERR_TEXT, "saveMac:");
    return (NULL);
    }

#ifdef _XPLCDEF_
  t = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  t = (*argl)[0]->DefaultComponent()->Content().text;
#endif
  mac = GetMacro (macList, t);

  if (mac == NULL)
    {
    globalError.Set (ERR_MAC, "saveMac: ");
    globalError.AppendText (ERR_MAC, t);    
    return (NULL);
    }

  if (strlen(t) > 100)
    {
    globalError.Set (ERR_COMMON, "saveMac:  name too long!");
    return (NULL);
    }

  sprintf(name,"%s.xpl", t);

  fout = fopen(name, "w");
  if (fout == NULL)
    {
    globalError.Set (ERR_FILE, "savemac: ");
    globalError.AppendText (ERR_FILE, name);
    return (NULL);
    }

#ifdef _XPLCDEF_
  t = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  t = (*argl)[0]->DefaultComponent()->Content().text;
#endif
  mac = GetMacro (macList, t);
  fputs(mac->Text (), fout);

  fclose (fout);

  return (NULL);
}

#ifdef MATRIX
XplObject*	minc (Liste<XplObject*> *argl)
{
  long      length = argl->laenge();
  XplDouble *s, *x, *res;
  int       rows, cols, dir = 1;
  double    min;
 
  if (length > 2)
    {
    globalError.Set (ERR_ARGS, "min: Must be 1 or 2");
    return (NULL);
    }
  
  s = (*argl)[0]->DefaultXplDouble ();
  if (s == NULL)
    {
    globalError.Set (ERR_NUM, "min:");
    return (NULL);
    }

  if (length == 2)
    {
    x = (*argl)[1]->DefaultXplDouble ();
    if (x == NULL)
      {
      globalError.Set (ERR_NUM, "min:");
      return (NULL);
      }
    dir = (int) (*x)(0);
    if (dir != 1 && dir != 2)
      {
      globalError.Set (ERR_INTERN, "min: dir not allowed");
      return (NULL);
      }
    }

  rows = s->rows();
  cols = s->cols();

  if (dir == 1)
    {
    res = new XplDouble (1, cols);

    for (int i=0; i<cols; i++)
      {
      min = (*s)(0, i);
      for (int j=1; j<rows; j++)
	if (min > (*s)(j, i))
	  min = (*s)(j, i);
      (*res)(0, i) = min;
      }
    }
  else
    {
    res = new XplDouble (rows, 1);

    for (int j=0; j<rows; j++)
      {
      min = (*s)(j, 0);
      for (int i=1; i<cols; i++)
	if (min > (*s)(j, i))
	  min = (*s)(j, i);
      (*res)(j, 0) = min;
      }
    }
  return (new XplObject (res, "min"));
}

XplObject*	maxc (Liste<XplObject*> *argl)
{
  long      length = argl->laenge();
  XplDouble *s, *x, *res;
  int       rows, cols, dir = 1;
  double    max;
 
  if (length > 2)
    {
    globalError.Set (ERR_ARGS, "max: Must be 1 or 2");
    return (NULL);
    }
  
  s = (*argl)[0]->DefaultXplDouble ();
  if (s == NULL)
    {
    globalError.Set (ERR_NUM, "max:");
    return (NULL);
    }

  if (length == 2)
    {
    x = (*argl)[1]->DefaultXplDouble ();
    if (x == NULL)
      {
      globalError.Set (ERR_NUM, "max:");
      return (NULL);
      }
    dir = (int) (*x)(0);
    if (dir != 1 && dir != 2)
      {
      globalError.Set (ERR_INTERN, "max: dir not allowed");
      return (NULL);
      }
    }

  rows = s->rows();
  cols = s->cols();

  if (dir == 1)
    {
    res = new XplDouble (1, cols);

    for (int i=0; i<cols; i++)
      {
      max = (*s)(0, i);
      for (int j=1; j<rows; j++)
	if (max < (*s)(j, i))
	  max = (*s)(j, i);
      (*res)(0, i) = max;
      }
    }
  else
    {
    res = new XplDouble (rows, 1);

    for (int j=0; j<rows; j++)
      {
      max = (*s)(j, 0);
      for (int i=1; i<cols; i++)
	if (max > (*s)(j, i))
	  max = (*s)(j, i);
      (*res)(j, 0) = max;
      }
    }
  return (new XplObject (res, "max"));
}

XplObject*	sumc (Liste<XplObject*> *argl)
{
  long length = argl->laenge();
  XplDouble *s, *x, *res;
  int    rows, cols, dir = 1;
  double sum;
 
  if (length > 2)
    {
    globalError.Set (ERR_ARGS, "sumc: Must be 1 or 2");
    return (NULL);
    }
  
  s = (*argl)[0]->DefaultXplDouble ();
  if (s == NULL)
    {
    globalError.Set (ERR_NUM, "sumc:");
    return (NULL);
    }

  if (length == 2)
    {
    x = (*argl)[1]->DefaultXplDouble ();
    if (x == NULL)
      {
      globalError.Set (ERR_NUM, "prodc:");
      return (NULL);
      }
    dir = (int) (*x)(0);
    if (dir != 1 && dir != 2)
      {
      globalError.Set (ERR_INTERN, "prodc: dir not allowed");
      return (NULL);
      }
    }

  rows = s->rows();
  cols = s->cols();

  if (dir == 1)
    {
    res = new XplDouble (1, cols);

    for (int i=0; i<cols; i++)
      {
      sum = 0.0;
      for (int j=0; j<rows; j++)
	sum += (*s)(j, i);
      (*res)(0, i) = sum;
      }
    }
  else
    {
    res = new XplDouble (rows, 1);

    for (int j=0; j<rows; j++)
      {
      sum = 0.0;
      for (int i=0; i<cols; i++)
	sum += (*s)(j, i);
      (*res)(j, 0) = sum;
      }
    }
  return (new XplObject (res, "sum"));
}

XplObject*	prodc (Liste<XplObject*> *argl)
{
  long length = argl->laenge();  
  XplDouble *s, *x, *res;
  int    rows, cols, dir = 1;
  double prod;
 
  if (length > 2)
    {
    globalError.Set (ERR_ARGS, "prodc: Must be 1 or 2");
    return (NULL);
    }
  
  s = (*argl)[0]->DefaultXplDouble ();
  if (s == NULL)
    {
    globalError.Set (ERR_NUM, "prodc:");
    return (NULL);
    }

  if (length == 2)
    {
    x = (*argl)[1]->DefaultXplDouble ();
    if (x == NULL)
      {
      globalError.Set (ERR_NUM, "prodc:");
      return (NULL);
      }
    dir = (int) (*x)(0);
    if (dir != 1 && dir != 2)
      {
      globalError.Set (ERR_INTERN, "prodc: dir not allowed");
      return (NULL);
      }
    }

  rows = s->rows();
  cols = s->cols();

  if (dir == 1)
    {
    res = new XplDouble (1, cols);

    for (int i=0; i<cols; i++)
      {
      prod = 1.0;
      for (int j=0; j<rows; j++)
	prod *= (*s)(j, i);
      (*res)(0, i) = prod;
      }
    }
  else
    {
    res = new XplDouble (rows, 1);

    for (int j=0; j<rows; j++)
      {
      prod = 1.0;
      for (int i=0; i<cols; i++)
	prod *= (*s)(j, i);
      (*res)(j, 0) = prod;
      }
    }
  return (new XplObject (res, "prod"));
}
#endif

XplObject*	matrows (Liste<XplObject*> *argl)
{
  XplDouble *s, *t = new XplDouble(1);
  XplObject *o;

  if (argl->laenge() != 1)
    {
    globalError.Set (ERR_ARGS, "rows: Must be 1");
    return (NULL);
    }

  o = (*argl)[0];
  if (o->DefaultType () == C_XPLDOUBLE)
    {
    s = (*argl)[0]->DefaultXplDouble ();
    (*t)[0] = s->rows();
    return (new XplObject(t, "rows"));
    }

  if (o->DefaultType () == C_TEXT)
    {
#ifdef _XPLCDEF_
    (*t)[0] = o->DefaultComponent()->Content().xplchar->dimension (0);
#else
    (*t)(0) = 1.0;    // only single text
#endif
    return (new XplObject(t, "rows"));
    }

  globalError.Set (ERR_TYPE, "rows");
  return (NULL);
}

XplObject*	matcols (Liste<XplObject*> *argl)
{
  XplDouble *s, *t = new XplDouble(1);
  XplObject *o;
 
  if (argl->laenge() != 1)
    {
    globalError.Set (ERR_ARGS, "cols: Must be 1");
    return (NULL);
    }

  o = (*argl)[0];
  if (o->DefaultType () == C_XPLDOUBLE)
    {
    s = (*argl)[0]->DefaultXplDouble ();
    (*t)[0] = s->cols();
    return (new XplObject(t, "cols"));
    }

  if (o->DefaultType () == C_TEXT)
    {
#ifdef _XPLCDEF_
    (*t)[0] = o->DefaultComponent()->Content().xplchar->dimension (1);
#else
    (*t)(0) = 1.0;    // only single text
#endif
    return (new XplObject(t, "cols"));
    }

  globalError.Set (ERR_TYPE, "cols");
  return (NULL);
}

#ifdef MATRIX
XplObject*	eigen (Liste<XplObject*> *argl)
{
  XplDouble *s;
  XplObject *o1, *o2, *o;
 
  if (argl->laenge() != 1)
    {
    globalError.Set (ERR_ARGS, "eigen: Must be 1");
    return (NULL);
    }

  s = (*argl)[0]->DefaultXplDouble ();

  if (s == NULL)
    {
    globalError.Set (ERR_NUM, "eigen:");
    return (NULL);
    }

  XplDouble *evecs, *evals = new Matrix;  
  evecs = s->jacobi (evals);

  if (globalError.Get())
    {
    delete evals;
    return (NULL);
    }

  o1 = new XplObject (evals, "values");
  o2 = new XplObject (evecs, "vectors");

  o  = new XplObject ("etemp");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}
#endif

XplObject*	inverse (Liste<XplObject*> *argl)
{
  XplObject *x;
  XplDouble *s1;
 
  if (argl->laenge() != 1)
    {
    globalError.Set (ERR_ARGS, "inv: Must be 1");
    return (NULL);
    }

  s1 = (*argl)[0]->DefaultXplDouble ();

  if (s1 == NULL)
    {
    globalError.Set (ERR_NUM, "inv:");
    return (NULL);
    }

#ifdef MATRIX
  XplDouble *inv = new XplDouble (s1);  
  inv->inverse ();
  x = new XplObject (inv, "invers");
#else
  // SK: TTK 17.08.99
  //  XplDouble s(s1);
  //  s = s.inv(s);
  //  x = new XplObject (new XplDouble(s), "inv");
  XplDouble *inv = new XplDouble (s1);  
  *inv = inv->inv (*inv);
  x = new XplObject (inv, "invers");
#endif

  if (globalError.Get())
    {
#ifdef MATRIX
    delete inv;
#else
    delete x;
#endif
    return (NULL);
    }

  return (x);
}

XplObject*	bmatrix (Liste<XplObject*> *argl)
{
  long length = argl->laenge (), r = 1, c = 1;
  XplDouble *s1, *s2, *s3, *s, *x;
 
  if (length == 0)
    {
    globalError.Set (ERR_ARGS, "bmatrix: no argument");
    return (NULL);
    }

#ifdef MATRIX
  if (length > 2)
    {
    globalError.Set (ERR_COMMON, "bmatrix: Can't generate array. Running Matrix class.");
    return (NULL);
    }
#endif

  s1 = (*argl)[0]->DefaultXplDouble ();

  if (s1 == NULL)
    {
    globalError.Set (ERR_NUM, "bmatrix: first argument");
    return (NULL);
    }

#ifdef MATRIX
  if (!s1->isScalar ())
#else
  if (s1->dimension() != 0)
#endif
    {
    globalError.Set (ERR_DIM, "bmatrix: first argument is not scalar");
    return (NULL);
    }

  r = (long) (*s1)(0);

  if (length == 1)
    {
    x = new XplDouble (r);
    x->fill (1.0);
    return (new XplObject (x, "bmatrix"));
    }

  s2 = (*argl)[1]->DefaultXplDouble ();

  if (s2 == NULL)
    {
    globalError.Set (ERR_NUM, "bmatrix: second argument");
    return (NULL);
    }

#ifdef MATRIX
  if (!s2->isScalar ())
#else
  if (s2->dimension() != 0)
#endif
    {
    globalError.Set (ERR_DIM, "bmatrix: second argument is not scalar");
    return (NULL);
    }

  c = (long) (*s2)(0);

  if (length == 2)
    {
    x = new XplDouble (r, c);
    x->fill (1.0);
    return (new XplObject (x, "bmatrix"));
    }

  s3 = (*argl)[2]->DefaultXplDouble ();

  if (s3 == NULL)
    {
    globalError.Set (ERR_NUM, "bmatrix: third argument");
    return (NULL);
    }

  s = new XplDouble (r, c);

#ifdef MATRIX
  if (s3->isScalar ())
#else
  if (s->dimension() == 0)
#endif
    s->fill ((*s3)(1));
//  else
//    s->fill (*s3);

  return (new XplObject (s, "bmatrix"));

}

#ifndef MATRIX
XplObject*	dim (Liste<XplObject*> *argl)
{
  long length = argl->laenge (), r = 1, c = 1;
  unsigned long n;
  XplDouble *s1 = NULL, *s2;
  XplObject *o;
#ifdef _XPLCDEF_
  XplChar   *xc = NULL;
#endif

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "dim: Must be 1");
    return (NULL);
    }

  o = (*argl)[0];
  if (o->DefaultType () == C_XPLDOUBLE)
    s1 = (*argl)[0]->DefaultXplDouble ();

  if (o->DefaultType () == C_TEXT)
    {
#ifdef _XPLCDEF_
    xc = o->DefaultComponent()->Content().xplchar;
#else
    s1 = new XplDouble (1);
    (*s1)(0) = 1.0;    // only single text
    return (new XplObject(s1, "dim"));
#endif
    }

#ifdef _XPLCDEF_
  if ((xc == NULL) && (s1 == NULL))
#else
  if (s1 == NULL)
#endif
    {
    globalError.Set (ERR_TYPE, "dim: first argument");
    return (NULL);
    }

#ifdef _XPLCDEF_
  n  = s1 != NULL ? s1->dimension () : xc->dimension ();
#else
  n  = s1->dimension ();
#endif

  if (n == 0)
    n = 1;

  s2 = new XplDouble (n);
  for (unsigned long i=0; i<n; i++)
#ifdef _XPLCDEF_
    (*s2)(i)  = (double) (s1 != NULL ? s1->dimension (i) : xc->dimension (i));
#else
    (*s2)(i)  = (double) s1->dimension (i);
#endif

  return (new XplObject (s2, "dim"));
}

XplObject*	reshape (Liste<XplObject*> *argl)
{
  long d, result = TRUE, length = argl->laenge ();
  unsigned long elem1 = 1UL, elem2 = 1UL, i, n;
  XplDouble *s1 = NULL, *s2;
  XplObject *o;
  XplIndex  xind;
#ifdef _XPLCDEF_
  XplChar   *xc = NULL;
#endif
 
  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "reshape: Must be 2");
    return (NULL);
    }

  switch ((*argl)[0]->DefaultType())
    {
    case C_TEXT:
      const char *t;
#ifdef _XPLCDEF_
      xc = (*argl)[0]->DefaultComponent()->Content().xplchar;
      t  = (*xc)(0).tocstr();
      n  = xc->dimension ();
      if (n == 0)       // xplchar is only a single word
	{
	o = GetXplObject (objList, t);
	if (o == NULL)
	  {
	  globalError.Set (ERR_OBJ, "reshape: ");
	  globalError.AppendText (ERR_OBJ, t);
	  return (NULL);
          }
	xc = NULL;                     // necessary to distinguish s1 and xc
	if  (o->DefaultType() == C_TEXT)    // if object is xplchar
	  xc = o->DefaultComponent()->Content().xplchar;
	else
	  s1 = o->DefaultXplDouble ();
	result = FALSE;
        }
#else
      t = (*argl)[0]->DefaultComponent()->Content().text;
#endif
      break;

    case C_EMPTY:
      globalError.Set (ERR_INTERN, "reshape: empty arg");
      return (NULL);

    default:
      s1 = (*argl)[0]->DefaultXplDouble ();
    }

#ifdef _XPLCDEF_
  if ((xc == NULL) && (s1 == NULL))
#else
  if (s1 == NULL)
#endif
    {
    globalError.Set (ERR_NUM, "reshape: first argument");
    return (NULL);
    }

  s2 = (*argl)[1]->DefaultXplDouble ();

  if (s2 == NULL)
    {
    globalError.Set (ERR_NUM, "reshape: second argument");
    return (NULL);
    }

  n = s2->dimension ();
  if (n > 1)           // skalare (0) und Vektoren (1) erlaubt
    {
    globalError.Set (ERR_DIM, "reshape: second argument has to be a vector");
    return (NULL);
    }

  n = s2->dimension (0);
  if (n > 8)           // skalare (0) und Vektoren (1) erlaubt
    {
    globalError.Set (ERR_DIM, "reshape: second argument has more than 8 dims");
    return (NULL);
    }

  for (i=0; i<n; i++)
    {
    d = (long) (*s2)(i);
    if (d <= 0)
      {
      globalError.Set (ERR_VAL, "reshape: arguments must be positiv");
      return (NULL);
      }
    xind.setdim (i, d);
    elem2  *= d;
    }

#ifdef _XPLCDEF_
  n = s1 != NULL ? s1->dimension () : xc->dimension ();
#else
  n = s1->dimension ();
#endif

  for (i=0; i<n; i++)
#ifdef _XPLCDEF_
    elem1 *= s1 != NULL ? s1->dimension (i) : xc->dimension (i);
#else
    elem1 *= s1->dimension (i);
#endif

  if (elem1 != elem2)
    {
    globalError.Set (ERR_COMMON, "reshape: Can't change number of elements");
    return (NULL);
    }

#ifdef _XPLCDEF_
  if (xc != NULL)
    xc->reshape (xind);
  else
    s1->reshape (xind);
#else
  s1->reshape (xind);
#endif

  if (result)
#ifdef _XPLCDEF_
    if (xc != NULL)
      return (new XplObject (new XplChar (*xc), "reshape"));
    else
      return (new XplObject (new XplDouble (s1), "reshape"));
#else
    return (new XplObject (new XplDouble (s1), "reshape"));
#endif
  else
    return (NULL);
}

XplObject*	InitRandom (Liste<XplObject*> *argl)
{
  int       length = argl->laenge();
  XplDouble *s;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "InitRandom: Must be 1");
    return (NULL);
    }

  if ((s = (*argl)[0]->DefaultXplDouble()) == NULL)
    {
    globalError.Set (ERR_NUM, "InitRandom:");
    return (NULL);
    }

  if (s->dimension() != 0)
    {
    globalError.Set (ERR_DIM, "InitRandom: Argument has to be a scalar");
    return (NULL);
    }

  s->randomize (1, (*s)(0));        // initializes the uniform generator
  s->randomize (6, (*s)(0));        // initializes the normal generator

  return (NULL);
}

XplObject*	bmatrixnew (Liste<XplObject*> *argl)
{
  long n, length = argl->laenge (), i;
  XplDouble *s1, *s;
  XplIndex xind;
 
  if ((length == 0) || (length > MAX_XARRAY))
    {
    globalError.Set (ERR_ARGS, "matrix: too less or too many arguments");
    return (NULL);
    }

  for (i=0; i<length; i++)
    {
    s1 = (*argl)[i]->DefaultXplDouble ();

    if (s1 == NULL)
      {
      globalError.Set (ERR_NUM, "matrix: first argument");
      return (NULL);
      }

    if (s1->dimension() != 0)
      {
      globalError.Set (ERR_DIM, "matrix: first argument is not scalar");
      return (NULL);
      }
    n = (long) rint ((*s1)(0));
    if (n <= 0)
      {
      globalError.Set (ERR_VAL, "matrix: arguments must be positiv");
      return (NULL);
      }
    xind.setdim (i, n);
    }

  s = new XplDouble (xind);

  s->fill (1.0);

  return (new XplObject (s, "matrix"));

}

/* PC 2021122 - zeros */
XplObject*	bzeromatrixnew (Liste<XplObject*> *argl)
{
  long n, length = argl->laenge (), i;
  XplDouble *s1, *s;
  XplIndex xind;

  if ((length == 0) || (length > MAX_XARRAY))
    {
    globalError.Set (ERR_ARGS, "zeros: too less or too many arguments");
    return (NULL);
    }

  for (i=0; i<length; i++)
    {
    s1 = (*argl)[i]->DefaultXplDouble ();

    if (s1 == NULL)
      {
      globalError.Set (ERR_NUM, "zeros: first argument");
      return (NULL);
      }

    if (s1->dimension() != 0)
      {
      globalError.Set (ERR_DIM, "zeros: first argument is not scalar");
      return (NULL);
      }
    n = (long) rint ((*s1)(0));
    if (n <= 0)
      {
      globalError.Set (ERR_VAL, "zeros: arguments must be positiv");
      return (NULL);
      }
    xind.setdim (i, n);
    }

  s = new XplDouble (xind);

  s->fill (0.0);

  return (new XplObject (s, "zeros"));

}


XplObject*	xaMKnn (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *s1, *s2, *s3, *r;
  int    knn;
 
  if ((length != 2) && (length != 3))
    {
    globalError.Set (ERR_ARGS, "xaMKnn: Must be 2 or 3");
    return (NULL);
    }

  s1 = (*argl)[0]->DefaultXplDouble ();

  if (s1 == NULL)
    {
    globalError.Set (ERR_NUM, "xaMKnn: first argument");
    return (NULL);
    }

  s2 = (*argl)[1]->DefaultXplDouble ();

  if (s2 == NULL)
    {
    globalError.Set (ERR_NUM, "xaMKnn: second argument");
    return (NULL);
    }

  if (s2->dimension() != 0)
    {
    globalError.Set (ERR_DIM, "xaMKnn: second argument is not scalar");
    return (NULL);
    }

  knn = (int) (*s2)(0);

  if (length == 3)
    {
    s3 = (*argl)[2]->DefaultXplDouble ();

    if (s3 == NULL)
      {
      globalError.Set (ERR_NUM, "xaMKnn: third argument");
      return (NULL);
      }
    }
  else
    s3 = s1;

  r  = new XplDouble(1);
  *r = cast (s1->mknn (knn, *s3));

  if (globalError.Get())     // delete r
    {
    delete r;
    return (NULL);
    }

  return (new XplObject (r, "mknn"));
}

XplObject*	xaSknn (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *s1, *s2, *s3, *r;
 
  if (length != 3)
    {
    globalError.Set (ERR_ARGS, "xaSknn: Must be 3");
    return (NULL);
    }

  s1 = (*argl)[0]->DefaultXplDouble ();
  if (s1 == NULL)
    {
    globalError.Set (ERR_NUM, "xaSknn: first argument");
    return (NULL);
    }

  s2 = (*argl)[1]->DefaultXplDouble ();
  if (s2 == NULL)
    {
    globalError.Set (ERR_NUM, "xaSknn: second argument");
    return (NULL);
    }

  s3 = (*argl)[2]->DefaultXplDouble ();
  if (s3 == NULL)
    {
    globalError.Set (ERR_NUM, "xaSknn: third argument");
    return (NULL);
    }

  r  = new XplDouble(1);
  *r = s1->sknn (*s2, cast (*s3));

  if (globalError.Get())     // delete r
    {
    delete r;
    return (NULL);
    }

  return (new XplObject (r, "sknn"));
}

XplObject*	xaBinData (Liste<XplObject*> *argl)
{
  long length = argl->laenge (), n, p;
  XplDouble *x, *d, *orig, *y = NULL, *xb, *yb;
  XplLong   *xlb;
  XplObject *o, *o1, *o2;
 
  if ((length != 3) && (length != 4))
    {
    globalError.Set (ERR_ARGS, "xaBinData: Must be 3 or 4");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaBinData: first argument");
    return (NULL);
    }

  n = x->dimension (0);
  p = x->dimension (1);

  d = (*argl)[1]->DefaultXplDouble ();

  if (d == NULL)
    {
    globalError.Set (ERR_NUM, "xaBinData: second argument");
    return (NULL);
    }

  if (d->dimension (0) != p)
    {
    globalError.Set (ERR_DIM, "xaBinData: second argument: wrong number of rows");
    return (NULL);
    }
  
  orig = (*argl)[2]->DefaultXplDouble ();

  if (orig == NULL)
    {
    globalError.Set (ERR_NUM, "xaBinData: third argument");
    return (NULL);
    }

  if (orig->dimension (0) != p)
    {
    globalError.Set (ERR_DIM, "xaBinData: third argument: wrong number of rows");
    return (NULL);
    }

  if (length == 4)
    {
    y = (*argl)[3]->DefaultXplDouble ();

    if (y == NULL)
      {
      globalError.Set (ERR_NUM, "xaBinData: fourth argument");
      return (NULL);
      }

    if (y->dimension (0) != n)
      {
      globalError.Set (ERR_DIM, "xaBinData: fourth argument: wrong number of rows");
      return (NULL);
      }
    }

  xlb = new XplLong(1);
  xb  = new XplDouble(1);
  yb  = new XplDouble(1);

#ifndef __BORLANDC__              //SWS 16.09
  x->bindata (*d, *orig, y, xlb, yb);
#else
  XplNumber<double> *d2=d, *orig2=orig;
  x->bindata (*d2, *orig2, y, xlb, yb);
#endif

  if (globalError.Get())     // delete r
    {
    delete xlb;
    delete xb;
    delete yb;
    return (NULL);
    }

  *xb = cast (*xlb);
  delete xlb;                   // no longer needed

  o1 = new XplObject (xb, "xb");
  o2 = new XplObject (yb, "yb");

  o  = new XplObject ("bindata");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}

XplObject*	xaIndex (Liste<XplObject*> *argl)
{
  long length = argl->laenge (), n, p, i, j, col, row;
  XplDouble *x, *ind, *t, *r = NULL, mi, ma;
  XplSelection res;
  int nsel;
 
  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "xaIndex: Must be 2");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaIndex:  Error:  first argument");
    return (NULL);
    }

  n = x->dimension (0);
  p = x->dimension (1);

  ind = (*argl)[1]->DefaultXplDouble ();

  if (ind == NULL)
    {
    globalError.Set (ERR_NUM, "xaIndex: second argument");
    return (NULL);
    }

  if (ind->dimension () > 2)
    {
    globalError.Set (ERR_DIM, "xaIndex: second argument must be vector or matrix");
    return (NULL);
    }

  row = ind->dimension (0);
  col = ind->dimension (1);
  nsel = 1;
  t = new XplDouble(1);

  mi = ind->minimum (0);
  ma = ind->maximum (0);

  for (i=0; i<col; i++)
    {
    if ((mi(i) < 1) || (ma(i) > n))
      {
      globalError.Set (ERR_COMMON, "xaIndex: index values <0 or >n");
      return (NULL);
      }
    XplSelection d (row);
    for (j=0; j<row; j++)
      d[j] = (long) (*ind)(j, i) - 1L;
    res = d;
    t->selection (*x, nsel, &res);
    if (r == NULL)
      r = new XplDouble (t);
    else
      *r = r->bind (*t, 1);
    }

  return (new XplObject (r, "index"));
}

XplObject*	xaSort (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *x = NULL, *d, *r;
  XplObject *o;
  XplLong   dir(1);
  int       n;
#ifdef _XPLCDEF_
  XplChar *ergc, *xc = NULL;
#endif 

 
  if ((length != 1) && (length != 2))
    {
    globalError.Set (ERR_ARGS, "xaSort: Must be 1 or 2");
    return (NULL);
    }

  o = (*argl)[0];

#ifdef _XPLCDEF_
  if (o->DefaultType () == C_XPLCHAR)
    xc = o->DefaultComponent()->Content().xplchar;
#endif

  if (o->DefaultType () == C_XPLDOUBLE)
    x = o->DefaultXplDouble ();

#ifdef _XPLCDEF_
  if (x == NULL && xc == NULL)
#else
  if (x == NULL)
#endif
    {
    globalError.Set (ERR_TYPE, "xaSort: first argument (text or numeric)");
    return (NULL);
    }

  if (length == 2)
    {
    d = (*argl)[1]->DefaultXplDouble ();
    if (d == NULL)
      {
      globalError.Set (ERR_NUM, "xaSort: second argument");
      return (NULL);
      }
    dir = cast (*d); 
    }
  else
    dir(0) = 1;             // default is sorting regarding the 1. col

#ifdef _XPLCDEF_
  if (x != NULL)
    {
    r  = new XplDouble(1);
    *r = x->sortvec (dir);
    }
  else
    {
    ergc  = new XplChar (1);
    *ergc = xc->sortvec (dir);
    }
#else
  r  = new XplDouble(1);
  *r = x->sortvec (dir);
#endif 

  if (globalError.Get())     // error in sortvec
    {
    delete r;
    return (NULL);
    }

#ifdef _XPLCDEF_
  if (x == NULL)
    return (new XplObject (ergc, "sort"));
  else
    return (new XplObject (r, "sort"));
#endif

  return (new XplObject (r, "sort"));
}

XplObject*	xaFFT (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *x, *r;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaFFT: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaFFT: first argument");
    return (NULL);
    }

  if (x->dimension () < 2)
    {
    globalError.Set (ERR_DIM, "xaFFT: first argument must be a matrix or bigger");
    return (NULL);
    }

  if (x->dimension (1) != 2)
    {
    globalError.Set(ERR_DIM, "xaFFT: first argument must have two columns");
    return (NULL);
    }

  if (! PowOf2 (x->dimension (0)))
    {
    globalError.Set(ERR_DIM, "xaFFT: number of rows must be power of 2");
    return (NULL);
    }

  r = new XplDouble(1);

  *r = x->fft ();

  if (globalError.Get())     // delete r
    {
    delete r;
    return (NULL);
    }

  return (new XplObject (r, "fft"));
}

XplObject*	xaInvFFT (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *x, *r;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaInvFFT: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_ARGS, "xaInvFFT: first argument");
    return (NULL);
    }

  if (x->dimension () < 2)
    {
    globalError.Set (ERR_DIM, "xaInvFFT: first argument must be a matrix or bigger");
    return (NULL);
    }

  if (x->dimension (1) != 2)
    {
    globalError.Set (ERR_DIM, "xaInvFFT: first argument must have two columns");
    return (NULL);
    }

  if (! PowOf2 (x->dimension (0)))
    {
    globalError.Set (ERR_DIM, "xaInvFFT: number of rows must be power of 2");
    return (NULL);
    }

  r = new XplDouble(1);

  *r = x->invfft ();

  if (globalError.Get())    // delete r
    {
    delete r;
    return (NULL);
    }

  return (new XplObject (r, "invfft"));
}

XplObject*	xaFWT (Liste<XplObject*> *argl)
{
  long      i, length = argl->laenge ();
  XplDouble *x, *levd, *h, *a, *b;
  XplLong   levl(1);
  XplObject *o, *o1, *o2;
  char      text[TEXTLENGTH];
 
  if (length != 3)
    {
    globalError.Set (ERR_ARGS, "xaFWT: Must be 3");
    return (NULL);
    }

for (i=0; i<length; i++)
  if ((*argl)[i]->DefaultType () != C_XPLDOUBLE)
    {
    sprintf (text, "xaFWT: %d. argument", i);
    globalError.Set (ERR_NUM, text);
    return (NULL);
    }

  x    = (*argl)[0]->DefaultXplDouble ();
  levd = (*argl)[1]->DefaultXplDouble ();
  h    = (*argl)[2]->DefaultXplDouble ();

  levl = cast (*levd);

  a = new XplDouble(1);
  b = new XplDouble(1);

  x->fwt (levl, *h, *a, *b);

  if (globalError.Get())     // delete a b
    {
    delete a;
    delete b;
    return (NULL);
    }

  o1 = new XplObject (a, "fwtb");
  o2 = new XplObject (b, "fwta");
  o  = new XplObject ("fwt");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));

  o->SetDefaultXplDouble ();    // necessary

  return (o);
}

XplObject*	xaInvFWT (Liste<XplObject*> *argl)
{
  long      i, length = argl->laenge ();
  XplDouble *r, *a, *b, *nd, *ld, *h;
  XplLong   n(1), l(1);
  char      text[TEXTLENGTH];
 
  if (length != 5)
    {
    globalError.Set (ERR_ARGS, "xaInvFWT: Must be 5");
    return (NULL);
    }

for (i=0; i<length; i++)
  if ((*argl)[i]->DefaultType () != C_XPLDOUBLE)
    {
    sprintf (text, "xaFWT: %d. argument", i);
    globalError.Set (ERR_NUM, text);
    return (NULL);
    }

  a    = (*argl)[0]->DefaultXplDouble ();
  b    = (*argl)[1]->DefaultXplDouble ();
  nd   = (*argl)[2]->DefaultXplDouble ();
  ld   = (*argl)[3]->DefaultXplDouble ();
  h    = (*argl)[4]->DefaultXplDouble ();

  n = cast (*nd);
  l = cast (*ld);
  r = new XplDouble(1);

  r->invfwt (*a, *b, n, l, *h);

  if (globalError.Get())    // delete r
    {
    delete r;
    return (NULL);
    }

  return (new XplObject (r, "invfwt"));
}

XplObject*	xaFWTin (Liste<XplObject*> *argl)
{
  long      i, length = argl->laenge ();
  XplDouble *x, *da, *h, *t;
  XplLong   lda(1);
  XplObject *o;
  char      text[TEXTLENGTH];
 
  if (length != 3)
    {
    globalError.Set (ERR_ARGS, "xaFWTin: Must be 3");
    return (NULL);
    }

for (i=0; i<length; i++)
  if ((*argl)[i]->DefaultType () != C_XPLDOUBLE)
    {
    sprintf (text, "xaFWTin: %d. argument", i);
    globalError.Set (ERR_NUM, text);
    return (NULL);
    }

  x  = (*argl)[0]->DefaultXplDouble ();
  da = (*argl)[1]->DefaultXplDouble ();
  h  = (*argl)[2]->DefaultXplDouble ();

  lda = cast (*da);

  t = new XplDouble(1);

  x->fwtin (lda, *h, t);

  if (globalError.Get())     // delete a b
    {
    delete t;
    return (NULL);
    }

  o  = new XplObject (t, "fwtin");

  return (o);
}

XplObject*	xaInvFWTin (Liste<XplObject*> *argl)
{
  long      i, length = argl->laenge ();
  XplDouble *x, *da, *h, *t;
  XplLong   lda(1);
  char      text[TEXTLENGTH];
 
  if (length != 3)
    {
    globalError.Set (ERR_ARGS, "xaInvFWTin: Must be 3");
    return (NULL);
    }

for (i=0; i<length; i++)
  if ((*argl)[i]->DefaultType () != C_XPLDOUBLE)
    {
    sprintf (text, "xaInvFWTin: %d. argument", i);
    globalError.Set (ERR_NUM, text);
    return (NULL);
    }

  x  = (*argl)[0]->DefaultXplDouble ();
  da = (*argl)[1]->DefaultXplDouble ();
  h  = (*argl)[2]->DefaultXplDouble ();

  lda = cast (*da);
  t = new XplDouble(1);

  x->invfwtin (lda, *h, t);

  if (globalError.Get())    // delete r
    {
    delete t;
    return (NULL);
    }

  return (new XplObject (t, "invfwtin"));
}

XplObject*	xaFWTinShift (Liste<XplObject*> *argl)
{
  long      i, length = argl->laenge ();
  XplDouble *x, *p, *t;
  XplLong   lp(1);
  char      text[TEXTLENGTH];
 
  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "xaFWTinShift: Must be 2");
    return (NULL);
    }

for (i=0; i<length; i++)
  if ((*argl)[i]->DefaultType () != C_XPLDOUBLE)
    {
    sprintf (text, "xaFWTinShift: %d. argument", i);
    globalError.Set (ERR_NUM, text);
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();
  p = (*argl)[1]->DefaultXplDouble ();

  lp = cast (*p);
  t = new XplDouble(1);

  x->fwtin_shift (lp, t);

  if (globalError.Get())    // delete t
    {
    delete t;
    return (NULL);
    }

  return (new XplObject (t, "fwtinshift"));
}

XplObject*      xaNNrsetnet   (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *param, *nconn, *conn;
 
  if (length != 3)
    {
    globalError.Set (ERR_ARGS, "xaNNrsetnet: Must be 3");
    return (NULL);
    }

  param = (*argl)[0]->DefaultXplDouble ();
  if (param == NULL)
    {
    globalError.Set (ERR_NUM, "xxaNNrsetnet:  first argument");
    return (NULL);
    }

  nconn = (*argl)[1]->DefaultXplDouble ();
  if (nconn == NULL)
    {
    globalError.Set (ERR_NUM, "xxaNNrsetnet:  second argument");
    return (NULL);
    }

  conn = (*argl)[2]->DefaultXplDouble ();
  if (param == NULL)
    {
    globalError.Set (ERR_NUM, "xxaNNrsetnet:  third argument");
    return (NULL);
    }

  param->nnrsetnet (*param, *nconn, *conn);

  return (NULL);
}

XplObject*      xaNNrsettrain (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *ntr, *xy, *weights;
 
  if (length != 3)
    {
    globalError.Set (ERR_ARGS, "xaNNrsettrain: Must be 3");
    return (NULL);
    }

  ntr = (*argl)[0]->DefaultXplDouble ();
  if (ntr == NULL)
    {
    globalError.Set (ERR_NUM, "xxaNNrsettrain:  first argument");
    return (NULL);
    }

  xy = (*argl)[1]->DefaultXplDouble ();
  if (xy == NULL)
    {
    globalError.Set (ERR_NUM, "xxaNNrsettrain:  second argument");
    return (NULL);
    }

  weights = (*argl)[2]->DefaultXplDouble ();
  if (weights == NULL)
    {
    globalError.Set (ERR_NUM, "xxaNNrsettrain:  third argument");
    return (NULL);
    }

  ntr->nnrsettrain (*ntr, *xy, *weights);

  return (NULL);
}

XplObject*      xaNNrdovm     (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *param, *wts, *nwts, *nval;
  XplObject *o, *o1, *o2;

  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "xaNNrdovm: Must be 2");
    return (NULL);
    }

  param = (*argl)[0]->DefaultXplDouble ();
  if (param == NULL)
    {
    globalError.Set (ERR_NUM, "xxaNNrdovm:  first argument");
    return (NULL);
    }

  wts = (*argl)[1]->DefaultXplDouble ();
  if (wts == NULL)
    {
    globalError.Set (ERR_NUM, "xxaNNrdovm:  second argument");
    return (NULL);
    }

  nwts = new XplDouble(1);
  nval = new XplDouble(1);

  param->nnrdovm (*param, *wts, nwts, nval);

  if (globalError.Get())       //delete nwts, nval
    {
    delete nwts;
    delete nval;
    return (NULL);
    }

  o1 = new XplObject (nwts, "nwts");
  o2 = new XplObject (nval, "nval");

  o  = new XplObject ("nnrdovm");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}

XplObject*      xaNNrtest     (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *param, *xy, *wts, *yh, *he;
  XplObject *o, *o1, *o2;
 
  if (length != 3)
    {
    globalError.Set (ERR_ARGS, "xaNNrtest: Must be 3");
    return (NULL);
    }

  param = (*argl)[0]->DefaultXplDouble ();
  if (param == NULL)
    {
    globalError.Set (ERR_NUM, "xxaNNrtest:  first argument");
    return (NULL);
    }

  xy = (*argl)[1]->DefaultXplDouble ();
  if (xy == NULL)
    {
    globalError.Set (ERR_NUM, "xxaNNrtest:  second argument");
    return (NULL);
    }

  wts = (*argl)[2]->DefaultXplDouble ();
  if (wts == NULL)
    {
    globalError.Set (ERR_NUM, "xxaNNrtest:  third argument");
    return (NULL);
    }

  yh = new XplDouble(1);
  he = new XplDouble(1);
  param->nnrtest (*param, *xy, *wts, yh, he);

  if (globalError.Get())       //delete yh
    {
    delete yh;
    delete he;
    return (NULL);
    }

  o1 = new XplObject (yh, "result");
  o2 = new XplObject (he, "hess");

  o  = new XplObject ("nnrtest");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
  
}

XplObject*	xaEigsm (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *x, *vals, *vecs;
  XplObject *o, *o1, *o2;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaEigsm: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaEigsm:  first argument");
    return (NULL);
    }

  if (x->dimension(0) != x->dimension(1))
    {
    globalError.Set (ERR_DIM, "xaEigsm:  rows != cols");
    return (NULL);
    }

  vals = new XplDouble(1);
  vecs = new XplDouble(1);

  x->eigsm (vecs, vals);

  if (globalError.Get())       //delete vals vecs
    {
    delete vals;
    delete vecs;
    return (NULL);
    }

  o1 = new XplObject (vals, "values");
  o2 = new XplObject (vecs, "vectors");

  o  = new XplObject ("eigsm");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}

XplObject*	xaDet (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaDet: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaDet:  first argument");
    return (NULL);
    }

  res = new XplDouble(1);

  *res = x->det ();

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }


  o  = new XplObject (res, "det");

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}

XplObject*	xaLU (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *x, *l, *u, *ix;
  XplLong   *ind;
  XplObject *o, *o1, *o2, *o3;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaLU: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaLU:  first argument");
    return (NULL);
    }

  l   = new XplDouble(1);
  u   = new XplDouble(1);
  ind = new XplLong(1);

  x->lu (*l, *u, *ind);

  if (globalError.Get())
    {
    delete l;
    delete u;
    delete ind;
    return (NULL);
    }

  ix = new XplDouble(1);
  *ix = cast (*ind);
  delete ind;

  o1 = new XplObject (l,  "l");
  o2 = new XplObject (u,  "u");
  o3 = new XplObject (ix, "index");

  o  = new XplObject ("LU");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));
  o->AppendComponent (new Component (o3));

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}
/*
XplObject*	xaDistance (Liste<XplObject*> *argl)
{
  long       length = argl->laenge ();
  XplDouble  *x, *res;
  XplObject  *o;
  const char *t;
 
  if ((length != 1) && (length != 2))
    {
    globalError.Set (ERR_ARGS, "xaDistance: Must be 1 or 2");
    return (NULL);
    }

  if ((*argl)[0]->Type() != O_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "xaDistance:  first argument");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    cerr << "Error: xaDistance x=NULL. Should never happen!" << endl;
    exit (1);
    }

  if (length == 2)
    {
#ifdef _XPLCDEF_
    if ((*argl)[1]->Type() != O_XPLCHAR)
      {
      globalError.Set (ERR_TEXT, "xaDistance:  second argument");
      return (NULL);
      }
    t    = (*(*argl)[1]->DefaultComponent()->Content().xplchar)(0).tocstr();
    res  = new XplDouble(1);
    *res = x->distance (t);  
#else
    t    = (*argl)[1]->DefaultComponent()->Content().text;
    res  = new XplDouble(1);
    *res = x->distance (t);
#endif
    }
  else
    {
    res = new XplDouble(1);
    *res = x->distance ();
    }

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o  = new XplObject (res, "distance");

  return (o);
}
*/
#ifndef SKBUG
XplObject*	xaConv (Liste<XplObject*> *argl)
{
  long      i, length = argl->laenge ();
  XplDouble *a[4], *sym;
  XplLong   defaultsym(1);
  XplObject *o, *o1, *o2, *o3;
  char      errorText[TEXTLENGTH];

  if ((length != 4) && (length != 5))
    {
    globalError.Set (ERR_ARGS, "xaConv: Must be 4 or 5");
    return (NULL);
    }

  for (i=0; i<4; i++)       // read the first four args
    {
    a[i] = (*argl)[i]->DefaultXplDouble ();

    if (a[i] == NULL)
      {
      sprintf (errorText, "xaConv: %ld. argument", i);
      globalError.Set (ERR_NUM, errorText);
      return (NULL);
      }
    }

  if (length == 5)
    {
    sym = (*argl)[4]->DefaultXplDouble ();
    if (sym == NULL)
      {
      globalError.Set (ERR_NUM, "xaConv: fifth argument");
      return (NULL);
      }
    defaultsym(0) = (long) rint ((*sym)(0));       // using IEEE rounding
    }
  else
    defaultsym(0) = 0L;

  XplDouble *xcd, *ycd, *ord;
  XplLong   *wx, *xb, *xc, *or;

  xcd = new XplDouble(1);
  ycd = new XplDouble(1);
  ord = new XplDouble(1);

  wx = new XplLong(1);
  xb = new XplLong(1);
  xc = new XplLong(1);
  or = new XplLong(1);

  *xb = cast (*(a[0]));
  *wx = cast (*(a[2]));

  a[1]->conv (*xb, *wx, *(a[3]), &defaultsym, xc, ycd, or);

  if (globalError.Get())        //delete ??
    {
    delete xcd;
    delete ycd;
    delete ord;
    delete wx;
    delete xb;
    delete xc;
    delete or;
    return (NULL);
    }

  *xcd = cast (*xc);
  *ord = cast (*or);

  delete wx;
  delete xb;
  delete xc;
  delete or;

  o1 = new XplObject (xcd, "xc");
  o2 = new XplObject (ycd, "yc");
  o3 = new XplObject (ord, "or");

  o  = new XplObject ("conv");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));
  o->AppendComponent (new Component (o3));

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}

XplObject*	xaGrid (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *x, *h, *n;
  XplObject *o;
 
  if (length != 3)
    {
    globalError.Set (ERR_ARGS, "xaGrid: Must be 3");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaGrid:  first argument");
    return (NULL);
    }

  h = (*argl)[1]->DefaultXplDouble ();

  if (h == NULL)
    {
    globalError.Set (ERR_NUM, "xaGrid:  second argument");
    return (NULL);
    }

  n = (*argl)[2]->DefaultXplDouble ();

  if (n == NULL)
    {
    globalError.Set (ERR_NUM, "xaGrid:  third argument");
    return (NULL);
    }

  XplLong *nl = new XplLong (1);

  *nl = cast (*n);

  XplDouble *res = new XplDouble(1);

  *res = x->grid (*h, *nl);

  delete nl;

  if (globalError.Get())   // delete ??
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "grid");

  return (o);
}

// PC 20010125
XplObject*	xaSumNaN (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res;
  XplObject *o;
 
  if ((length == 0) || (length > 2))
    {
    globalError.Set (ERR_ARGS, "xaSumNaN: Must be 1 or 2");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaSumNaN:  first argument");
    return (NULL);
    }

  if (length == 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaSumNaN:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaSumNaN: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  res = new XplDouble(1);

  *res = x->sumnan (d);

  if (globalError.Get())    // delete res
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "sum");

  return (o);
}

XplObject*	xaSum (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res, *cond;
  XplObject *o;
  XplLong *condl;
 
  if ((length == 0) || (length > 3))
    {
    globalError.Set (ERR_ARGS, "xaSum: Must be 1, 2 or 3");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaSum:  first argument");
    return (NULL);
    }

  if (length >= 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaSum:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaSum: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  if (length == 3)
    {
    cond = (*argl)[2]->DefaultXplDouble ();

    if (cond == NULL)
      {
      globalError.Set (ERR_NUM, "xaSum:  third argument");
      return (NULL);
      }
    condl  = new XplLong (1);
    *condl = cast (*cond);
    }
  else
    condl = NULL;

  res = new XplDouble(1);

  *res = x->sum (d, condl);

  if (globalError.Get())    // delete res
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "sum");

  return (o);
}

XplObject*	xaSumC (Liste<XplObject*> *argl)
{
  long      length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaSumC: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaSumC:  first argument");
    return (NULL);
    }

  res = new XplDouble(1);

  *res = x->sum (0, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "sumc");

  return (o);
}

XplObject*	xaSumR (Liste<XplObject*> *argl)
{
  long      length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaSumR: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaSumR:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->sum (1, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "sumr");

  return (o);
}

// PC 20010125
XplObject*	xaMulNaN (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res;
  XplObject *o;
 
  if ((length == 0) || (length > 2))
    {
    globalError.Set (ERR_ARGS, "xaMulNaN: Must be 1 or 2");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMulNaN:  first argument");
    return (NULL);
    }

  if (length == 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaMulNaN:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaMulNaN: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  res  = new XplDouble(1);
  *res = x->mulnan (d);

  if (globalError.Get())   //delete ?
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "prod");

  return (o);
}

XplObject*	xaMul (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res, *cond;
  XplObject *o;
  XplLong *condl;
 
  if ((length == 0) || (length > 3))
    {
    globalError.Set (ERR_ARGS, "prod: Must be 2 or 3");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "prod:  first argument");
    return (NULL);
    }

  if (length >= 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "prod:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "prod: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  if (length == 3)
    {
    cond = (*argl)[2]->DefaultXplDouble ();

    if (cond == NULL)
      {
      globalError.Set (ERR_NUM, "prod:  third argument");
      return (NULL);
      }
    condl  = new XplLong (1);
    *condl = cast (*cond);
    }
  else
    condl = NULL;

  res  = new XplDouble(1);
  *res = x->mul (d, condl);

  if (globalError.Get())   //delete ?
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "prod");

  return (o);
}

XplObject*	xaMulC (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
  XplLong *condl;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaMulC: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMulC:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->mul (0, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "mulc");

  return (o);
}

XplObject*	xaMulR (Liste<XplObject*> *argl)
{
  long      length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaMulR: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMulR:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->mul (1, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "mulr");

  return (o);
}

XplObject*	xaMin (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res, *cond;
  XplObject *o;
  XplLong *condl;
 
  if ((length == 0) || (length > 3))
    {
    globalError.Set (ERR_ARGS, "xaMin: Must be 1, 2 or 3");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMin:  first argument");
    return (NULL);
    }

  if (length >= 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaMin:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaMin: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  if (length == 3)
    {
    cond = (*argl)[2]->DefaultXplDouble ();

    if (cond == NULL)
      {
      globalError.Set (ERR_NUM, "xaMin:  third argument");
      return (NULL);
      }
    condl  = new XplLong (1);
    *condl = cast (*cond);
    }
  else
    condl = NULL;

  res  = new XplDouble(1);
  *res = x->minimum (d, condl);

  if (globalError.Get())    //delete
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "min");

  return (o);
}

XplObject*	xaMinC (Liste<XplObject*> *argl)
{
  long      length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaMinC: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMinC:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->minimum (0, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "minc");

  return (o);
}

XplObject*	xaMinR (Liste<XplObject*> *argl)
{
  long      length = argl->laenge ();
  XplDouble *x, *res;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaMinR: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMinR:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->minimum (1, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  return (new XplObject (res, "minr"));
}

XplObject*	xaMax (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res, *cond;
  XplLong *condl;
 
  if ((length == 0) || (length > 3))
    {
    globalError.Set (ERR_ARGS, "xaMax: Must be 1, 2 or 3");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMax:  first argument");
    return (NULL);
    }

  if (length >= 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaMax:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaMax: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  if (length == 3)
    {
    cond = (*argl)[2]->DefaultXplDouble ();

    if (cond == NULL)
      {
      globalError.Set (ERR_NUM, "xaMax:  third argument");
      return (NULL);
      }
    condl  = new XplLong (1);
    *condl = cast (*cond);
    }
  else
    condl = NULL;

  res  = new XplDouble(1);
  *res = x->maximum (d, condl);

  if (globalError.Get())   //delete
    {
    delete res;
    return (NULL);
    }

  return (new XplObject (res, "max"));
}

XplObject*	xaMaxC (Liste<XplObject*> *argl)
{
  long      length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaMaxC: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMaxC:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->maximum (0, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "maxc");

  return (o);
}

XplObject*	xaMaxR (Liste<XplObject*> *argl)
{
  long      length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaMaxR: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMaxR:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->maximum (1, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "maxr");

  return (o);
}

// PC 20010125
XplObject*	xaCumsumNaN (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res;
  XplObject *o;
 
  if ((length == 0) || (length > 2))
    {
    globalError.Set (ERR_ARGS, "xaCumsumNaN: Must be 1 or 2");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaCumsumNaN:  first argument");
    return (NULL);
    }

  if (length == 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaCumsumNaN:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaCumsumNaN: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  res  = new XplDouble(1);
  *res = x->cumsumnan (d);

  if (globalError.Get())   // delete
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "cumsum");

  return (o);
}

XplObject*	xaCumsum (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res, *cond;
  XplObject *o;
  XplLong *condl;
 
  if ((length == 0) || (length > 3))
    {
    globalError.Set (ERR_ARGS, "xaCumsum: Must be 1, 2 or 3");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaCumsum:  first argument");
    return (NULL);
    }

  if (length >= 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaCumsum:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaCumsum: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  if (length == 3)
    {
    cond = (*argl)[2]->DefaultXplDouble ();

    if (cond == NULL)
      {
      globalError.Set (ERR_NUM, "xaCumsum:  third argument");
      return (NULL);
      }
    condl  = new XplLong (1);
    *condl = cast (*cond);
    }
  else
    condl = NULL;

  res  = new XplDouble(1);
  *res = x->cumsum (d, condl);

  if (globalError.Get())   // delete
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "cumsum");

  return (o);
}

XplObject*	xaCumsumC (Liste<XplObject*> *argl)
{
  long      length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaCumsumC: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaCumsumC:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->cumsum (0, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "cumsumc");

  return (o);
}

XplObject*	xaCumsumR (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
  XplLong *condl;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaCumsumR: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaCumsumR:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->cumsum (1, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "cumsumr");

  return (o);
}

// PC 20010125
XplObject*	xaCummulNaN (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res;
  XplObject *o;
 
  if ((length == 0) || (length > 2))
    {
    globalError.Set (ERR_ARGS, "xaCummulNaN: Must be 1 or 2");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaCummulNaN:  first argument");
    return (NULL);
    }

  if (length == 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaCummulNaN:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaCummulNaN: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  res  = new XplDouble(1);
  *res = x->cummulnan (d);

  if (globalError.Get())   //delete
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "cumprod");

  return (o);
}

XplObject*	xaCummul (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res, *cond;
  XplObject *o;
  XplLong *condl;
 
  if ((length == 0) || (length > 3))
    {
    globalError.Set (ERR_ARGS, "xaCummul: Must be 1, 2 or 3");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaCummul:  first argument");
    return (NULL);
    }

  if (length >= 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaCummul:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaCummul: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  if (length == 3)
    {
    cond = (*argl)[2]->DefaultXplDouble ();

    if (cond == NULL)
      {
      globalError.Set (ERR_NUM, "xaCummul:  third argument");
      return (NULL);
      }
    condl  = new XplLong (1);
    *condl = cast (*cond);
    }
  else
    condl = NULL;

  res  = new XplDouble(1);
  *res = x->cummul (d, condl);

  if (globalError.Get())   //delete
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "cumprod");

  return (o);
}

XplObject*	xaCummulC (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
  XplLong *condl;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaCummulC: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaCummulC:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->cummul (0, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "cummulc");

  return (o);
}

XplObject*	xaCummulR (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
  XplLong *condl;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaCummulR: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaCummulR:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->cummul (1, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "cummulr");

  return (o);
}

// PC 20010222
XplObject*      xaAseq (Liste<XplObject*> *argl)
{
  long n, length = argl->laenge ();
  XplDouble *x, *nn, *d, *res;
  XplObject *o;

  if (length != 3)
  { globalError.Set (ERR_ARGS, "xaAseq: Must be 3");
    return (NULL);
  }

  x = (*argl)[0]->DefaultXplDouble ();
  if (x == NULL)
  { globalError.Set (ERR_NUM, "xaAseq:  first argument");
    return (NULL);
  }

  nn = (*argl)[1]->DefaultXplDouble ();
  if (nn == NULL)
  { globalError.Set (ERR_NUM, "xaAseq:  second argument");
    return (NULL);
  }

  d = (*argl)[2]->DefaultXplDouble ();
  if (d == NULL)
  { globalError.Set (ERR_NUM, "xaAseq:  third argument");
    return (NULL);
  }

  if ((x->dimension()!=0)||(nn->dimension()!=0)||(d->dimension()!=0))
  { XAerrort (ERR_DIM, "xaAseq : all arguments must be scalars");
    return (NULL);
  }

  n = (long) rint ((*nn)(0));

  res  = new XplDouble(1);
  *res = x->aseq (n, d);

  if (globalError.Get())    // delete
  { delete res;
    return (NULL);
  }

  o = new XplObject (res, "aseq");

  return (o);
}               //xaAseq

// PC 20010222
XplObject*      xaMseq (Liste<XplObject*> *argl)
{
  long n, length = argl->laenge ();
  XplDouble *x, *nn, *d, *res;
  XplObject *o;

  if (length != 3)
  { globalError.Set (ERR_ARGS, "xaMseq: Must be 3");
    return (NULL);
  }

  x = (*argl)[0]->DefaultXplDouble ();
  if (x == NULL)
  { globalError.Set (ERR_NUM, "xaMseq:  first argument");
    return (NULL);
  }

  nn = (*argl)[1]->DefaultXplDouble ();
  if (nn == NULL)
  { globalError.Set (ERR_NUM, "xaMseq:  second argument");
    return (NULL);
  }

  d = (*argl)[2]->DefaultXplDouble ();
  if (d == NULL)
  { globalError.Set (ERR_NUM, "xaMseq:  third argument");
    return (NULL);
  }

  if ((x->dimension()!=0)||(nn->dimension()!=0)||(d->dimension()!=0))
  { XAerrort (ERR_DIM, "xaMseq: all arguments must be scalars");
    return (NULL);
  }

  n = (long) rint ((*nn)(0));

  res  = new XplDouble(1);
  *res = x->mseq (n, d);

  if (globalError.Get())    // delete
  { delete res;
    return (NULL);
  }

  o = new XplObject (res, "mseq");

  return (o);
}               //xaMseq

// PC 20010221
XplObject*	xaMedian (Liste<XplObject*> *argl)
{ int f;
  long length = argl->laenge ();
  XplDouble *x, *b, *res;
  XplObject *o;

  if ((length == 0) || (length > 2)) {
    globalError.Set (ERR_ARGS, "xaMedian: Must be 1 or 2");
    return (NULL);
  }

  x = (*argl)[0]->DefaultXplDouble ();
  if (x == NULL) {
    globalError.Set (ERR_NUM, "xaMedian:  first argument");
    return (NULL);
  }

  f = 0;  			             // default is the exact median
  if (length == 2) {
    b = (*argl)[1]->DefaultXplDouble ();
    if (b == NULL) {
      globalError.Set (ERR_NUM, "xaMedian:  second argument");
      return (NULL);
    }
    if ( ((*b)(0) < -0.001) || ((*b)(0) > 0.001) ) f = 1;
  }

  res  = new XplDouble(1);
  *res = x->median(f);

  if (globalError.Get())   // delete
  { delete res;
    return (NULL);
  }

  o = new XplObject (res, "median");
  return (o);
}	//xaMedian

XplObject*	xaMedianNaN (Liste<XplObject*> *argl)
{ int f;
  long length = argl->laenge ();
  XplDouble *x, *b, *res;
  XplObject *o;

  if ((length == 0) || (length > 2)) {
    globalError.Set (ERR_ARGS, "xaMedianNaN: Must be 1 or 2");
    return (NULL);
  }

  x = (*argl)[0]->DefaultXplDouble ();
  if (x == NULL) {
    globalError.Set (ERR_NUM, "xaMedianNaN:  first argument");
    return (NULL);
  }

  f = 0;  			             // default is the exact median
  if (length == 2) {
    b = (*argl)[1]->DefaultXplDouble ();
    if (b == NULL) {
      globalError.Set (ERR_NUM, "xaMedianNaN:  second argument");
      return (NULL);
    }
    if ( ((*b)(0) < -0.001) || ((*b)(0) > 0.001) ) f = 1;
  }

  res  = new XplDouble(1);
  *res = x->medianNaN(f);

  if (globalError.Get())   // delete
  { delete res;
    return (NULL);
  }

  o = new XplObject (res, "medianNaN");
  return (o);
}	//xaMedianNaN

// PC 20010125
XplObject*	xaMeanNaN (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res;
  XplObject *o;
 
  if ((length == 0) || (length > 2))
    {
    globalError.Set (ERR_ARGS, "xaMeanNaN: Must be 1 or 2");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMeanNaN:  first argument");
    return (NULL);
    }

  if (length == 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaMeanNaN:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaMeanNaN: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  res  = new XplDouble(1);
  *res = x->meannan (d);

  if (globalError.Get())    // delete
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "mean");

  return (o);
}

XplObject*	xaMean (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res, *cond;
  XplObject *o;
  XplLong *condl;
 
  if ((length == 0) || (length > 3))
    {
    globalError.Set (ERR_ARGS, "xaMean: Must be 2 or 3");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMean:  first argument");
    return (NULL);
    }

  if (length >= 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaMean:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaMean: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  if (length == 3)
    {
    cond = (*argl)[2]->DefaultXplDouble ();

    if (cond == NULL)
      {
      globalError.Set (ERR_NUM, "xaMean:  third argument");
      return (NULL);
      }
    condl  = new XplLong (1);
    *condl = cast (*cond);
    }
  else
    condl = NULL;

  res  = new XplDouble(1);
  *res = x->mean (d, condl);

  if (globalError.Get())    // delete
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "mean");

  return (o);
}


XplObject*	xaMeanC (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
  XplLong *condl;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaMeanC: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMeanC:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->mean (0, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "meanc");

  return (o);
}

XplObject*	xaMeanR (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
  XplLong *condl;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaMeanR: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMeanR:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->mean (1, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "meanr");

  return (o);
}

// PC 20010125
XplObject*	xaVarNaN (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res;
  XplObject *o;
 
  if ((length == 0) || (length > 2))
    {
    globalError.Set (ERR_ARGS, "xaVarNaN: Must be 1 or 2");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaVarNaN:  first argument");
    return (NULL);
    }

  if (length == 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaVarNaN:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaVarNaN: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  res  = new XplDouble(1);
  *res = x->varnan (d);

  if (globalError.Get())   // delete
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "var");

  return (o);
}

XplObject*	xaVar (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res, *cond;
  XplObject *o;
  XplLong *condl;
 
  if ((length == 0) || (length > 3))
    {
    globalError.Set (ERR_ARGS, "xaVar: Must be 2 or 3");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaVar:  first argument");
    return (NULL);
    }

  if (length >= 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaVar:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaVar: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  if (length == 3)
    {
    cond = (*argl)[2]->DefaultXplDouble ();

    if (cond == NULL)
      {
      globalError.Set (ERR_NUM, "xaVar:  third argument");
      return (NULL);
      }
    condl  = new XplLong (1);
    *condl = cast (*cond);
    }
  else
    condl = NULL;

  res  = new XplDouble(1);
  *res = x->var (d, condl);

  if (globalError.Get())   // delete
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "var");

  return (o);
}

XplObject*	xaVarC (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
  XplLong *condl;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaVarC: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaVarC:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->var (0, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "varc");

  return (o);
}

XplObject*	xaVarR (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;
  XplLong *condl;
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "xaVarR: Must be 1");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaVarR:  first argument");
    return (NULL);
    }

  res  = new XplDouble(1);
  *res = x->var (1, NULL);

  if (globalError.Get())
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "varr");

  return (o);
}

// PC 20010125
XplObject*  xaCovNaN (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *x, *res;
  XplObject *o;

  if (length != 1)
  {
    globalError.Set (ERR_ARGS, "xaCovNaN: Must be 1");
    return (NULL);
  }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
  {
    globalError.Set (ERR_NUM, "xaCovNaN:  first argument");
    return (NULL);
  }

  res  = new XplDouble(1);
  *res = x->covnan ();

  if (globalError.Get())   // delete
  {
    delete res;
    return (NULL);
  }

  o = new XplObject (res, "cov");

  return (o);
}   //xaCov

// PC 20010124
// PC 20010502 - added the second parameter
XplObject*  xaCov (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *x, *res, *cond;
  XplObject *o;
  XplLong *condl;

  if ((length == 0) || (length > 2))
  {
    globalError.Set (ERR_ARGS, "xaCov: Must be 1 or 2");
    return (NULL);
  }
  x = (*argl)[0]->DefaultXplDouble ();
  if (x == NULL)
  {
    globalError.Set (ERR_NUM, "xaCov:  first argument");
    return (NULL);
  }

  if (length == 2)
  {
    cond = (*argl)[1]->DefaultXplDouble ();
    if (cond == NULL)
    {
      globalError.Set (ERR_NUM, "xaCov:  second argument");
      return (NULL);
    }
    condl  = new XplLong (1);
    *condl = cast (*cond);
  }
  else
    condl = NULL;

  res  = new XplDouble(1);
  *res = x->cov(condl);

  if (globalError.Get())   // delete
  {
    delete res;
    return (NULL);
  }

  o = new XplObject (res, "cov");
  return (o);
}   //xaCov

#endif   // SKBUG

XplObject*	xaMinInd (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res, *cond;
  XplObject *o;
  XplLong *condl;

  if ((length == 0) || (length > 3))
    {
    globalError.Set (ERR_ARGS, "xaMinInd: Must be 2 or 3");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMinInd:  first argument");
    return (NULL);
    }

  if (length >= 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaMinInd:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaMinInd: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  if (length == 3)
    {
    cond = (*argl)[2]->DefaultXplDouble ();

    if (cond == NULL)
      {
      globalError.Set (ERR_NUM, "xaMinInd:  third argument");
      return (NULL);
      }
    condl  = new XplLong (1);
    *condl = cast (*cond);
    }
  else
    condl = NULL;

  res  = new XplDouble(1);
  *res = cast (x->minind (d, condl));

  if (globalError.Get())   // delete
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "minind");

  return (o);
}

XplObject*	xaMaxInd (Liste<XplObject*> *argl)
{
  long d, length = argl->laenge ();
  XplDouble *x, *dx, *res, *cond;
  XplObject *o;
  XplLong *condl;
 
  if ((length == 0) || (length > 3))
    {
    globalError.Set (ERR_ARGS, "xaMaxInd: Must be 2 or 3");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaMaxInd:  first argument");
    return (NULL);
    }

  if (length >= 2)
    {
    dx = (*argl)[1]->DefaultXplDouble ();
    if (dx == NULL)
      {
      globalError.Set (ERR_NUM, "xaMaxInd:  second argument");
      return (NULL);
      }
    if (dx->dimension() != 0)
      {
      globalError.Set (ERR_NUM, "xaMaxInd: second argument must be scalar");
      return (NULL);
      }
    d = (long) rint ((*dx)(0)) - 1;
    }
  else
    d = 0L;               // default is columnwise

  if (length == 3)
    {
    cond = (*argl)[2]->DefaultXplDouble ();

    if (cond == NULL)
      {
      globalError.Set (ERR_NUM, "xaMaxInd:  third argument");
      return (NULL);
      }
    condl  = new XplLong (1);
    *condl = cast (*cond);
    }
  else
    condl = NULL;

  res  = new XplDouble(1);
  *res = cast (x->maxind (d, condl));

  if (globalError.Get())   // delete
    {
    delete res;
    return (NULL);
    }

  o = new XplObject (res, "maxind");

  return (o);
}

#endif


XplObject* eye (Liste<XplObject*> *argl) //MS 20030717
{

  long i, n, length = argl->laenge ();
  XplDouble *s1, *s;
  double d;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "eye/unit: Must be 1");
    return (NULL);
    }

  s1 = (*argl)[0]->DefaultXplDouble ();

  if (s1 == NULL)
    {
    globalError.Set (ERR_NUM, "eye/unit: first argument");
    return (NULL);
    }

#ifdef MATRIX
  if (s1->cols () != 1)
#else
  if ((s1->dimension () != 1) && (s1->dimension () != 0))
#endif
    {
    globalError.Set (ERR_DIM, "eye/unit: argument has to be a scalar");
    return (NULL);
    }

#ifdef MATRIX
  n = s1->rows ();
#else
  n = s1->dimension (0);
#endif

  if (n > 1 )
    {
    globalError.Set (ERR_DIM, "eye/unit: argument has to be a scalar");
    return (NULL);
    }

  d = *(s1->getptr());

  if ( d < 1 )
    {
    globalError.Set (ERR_DIM, "eye/unit: dimension has to be positive");
    return (NULL);
    }

  s = new XplDouble (d, d);
  s->fill (0.0);

  for (i=0; i<d; i++)
    (*s)(i,i) = 1;

  return (new XplObject (s, "eye"));
}

XplObject*	diag (Liste<XplObject*> *argl)
{
  long i, n, length = argl->laenge ();
  XplDouble *s1, *s;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "diag: Must be 1");
    return (NULL);
    }

  s1 = (*argl)[0]->DefaultXplDouble ();

  if (s1 == NULL)
    {
    globalError.Set (ERR_NUM, "diag: first argument");
    return (NULL);
    }

#ifdef MATRIX
  if (s1->cols () != 1)
#else
  if ((s1->dimension () != 1) && (s1->dimension () != 0))
#endif
    {
    globalError.Set (ERR_DIM, "diag: argument has to be a vector");
    return (NULL);
    }

#ifdef MATRIX
  n = s1->rows ();
#else
  n = s1->dimension (0);
#endif

  s = new XplDouble (n, n);
  s->fill (0.0);

  for (i=0; i<n; i++)
    (*s)(i,i) = (*s1)(i);

  return (new XplObject (s, "diag"));
}


XplObject*	paf (Liste<XplObject*> *argl)
{
  int  d;
  long i, j, c, z, m, n, length = argl->laenge ();
  XplDouble *s1 = NULL, *s2, *erg;
  XplObject *o;
#ifndef MATRIX
  XplIndex  xindold, xindtmp;
#endif 
#ifdef _XPLCDEF_
  XplChar *ergc, *xc = NULL;
#endif 

  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "paf: Must be 2");
    return (NULL);
    }

  o = (*argl)[0];

#ifdef _XPLCDEF_
  if (o->DefaultType () == C_XPLCHAR)
    xc = o->DefaultComponent()->Content().xplchar;
#endif

  if (o->DefaultType () == C_XPLDOUBLE)
    s1 = o->DefaultXplDouble ();

#ifdef _XPLCDEF_
  if (s1 == NULL && xc == NULL)
#else
  if (s1 == NULL)
#endif
    {
    globalError.Set (ERR_TYPE, "paf: first argument (text or numeric)");
    return (NULL);
    }

  s2 = (*argl)[1]->DefaultXplDouble ();
  if (s2 == NULL)
    {
    globalError.Set (ERR_NUM, "paf: second argument");
    return (NULL);
    }

#ifdef MATRIX
  if (s2->cols () != 1)
#else
  if ((s2->dimension () != 1) && (s2->dimension () != 0))
#endif
    {
    globalError.Set (ERR_DIM, "paf: second arguments has to be vectors");
    return (NULL);
    }

#ifdef MATRIX
  n = s2->rows ();
  c = s1->cols ();
#else
  n = s2->dimension (0);
#ifdef _XPLCDEF_
  c = xc != NULL ? xc->dimension (1) : s1->dimension (1);
  m = xc != NULL ? xc->dimension (0) : s1->dimension (0);
#else
  c = s1->dimension (1);
  m = s1->dimension (0);
#endif  // xplc
#endif

#ifdef MATRIX
  if (s1->rows() != s2->rows ())
#else
  if (m != s2->dimension (0))
#endif
    {
    globalError.Set (ERR_DIM, "paf: arguments must have equal length");
    return (NULL);
    }

// SK 21.07.99

#ifndef MATRIX

  if (xc==NULL)
  { long n1, n2, r;
    XplIndex ind;
    double *res, *p1, *p2;

    erg = new XplDouble(1);
    ind = s1->getdim();
    n1  = s1->size();
    n2  = s2->size();
    p1  = s1->getptr();
    p2  = s2->getptr();
    res = Dpaf(p1, n1, p2, n2, &r);
    if (res==NULL)
    { delete erg;
      globalError.Set (ERR_DIM, "paf: selection vector always false");
      return (NULL);
    }
    ind.setdim(0, r);
    erg->setdim(ind);
    erg->setptr(res);

    return (new XplObject (erg, "paf"));
  }
#endif
 
  z = 0;

  for (i=0; i<n; i++)
    if ((*s2)(i) != 0.0)
      z++;

  if (z == 0)
    {
    globalError.Set (ERR_DIM, "paf: selection vector always false");
    return (NULL);
    }

#ifdef _XPLCDEF_
  if (xc != NULL)
    {
    ergc = new XplChar (z, c);
    z = 0;
    for (i=0; i<n; i++)
      if ((*s2)(i) != 0.0)
        {
        for (j=0; j<c; j++)
          (*ergc)(z, j) = (*xc)(i, j);
        z++;
        }
    return (new XplObject (ergc, "paf"));
    }
#endif

#ifndef MATRIX
  d = s1->dimension ();        // array to be paffed
  xindold = s1->getdim ();     // store dim for reshaping
  c = s1->dimension (1);       // number of columes

  if (d > 2)                   // more than a matrix
    {
    c = 1;                     // computes columes for reshaped array
    for (i=1; i<d; i++)
      c *= s1->dimension (i);
    xindtmp.setdim (0, s1->dimension(0));
    xindtmp.setdim (1, c);     // dimensions of reshaped matrix
    for (i=2; i<d; i++)        // layers ... set to one
      xindtmp.setdim (i, 1);

    s1->reshape (xindtmp);     // now we have a matrix 
    }
#endif

  erg = new XplDouble (z, c);
  z = 0;
  for (i=0; i<n; i++)
    if ((*s2)(i) != 0.0)
      {
      for (j=0; j<c; j++)
        (*erg)(z, j) = (*s1)(i, j);
      z++;
      }

#ifndef MATRIX
  xindold.setdim (0, z);        // erg has z only rows
  if (d > 2)
    erg->reshape (xindold);     // reshape to array
#endif

  return (new XplObject (erg, "paf"));
}

#ifdef MATRIX
XplObject*	sort (Liste<XplObject*> *argl)
{
  long i, j, r, c, length = argl->laenge ();
  XplDouble *s1, *s, order(1);
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "sort: Must be 1");
    return (NULL);
    }

  s1 = (*argl)[0]->DefaultXplDouble ();

  if (s1 == NULL)
    {
    globalError.Set (ERR_NUM, "sort: first argument");
    return (NULL);
    }

  s = new Matrix (s1);

  s->sort (order);

  r = (long) s1->rows ();
  c = (long) s1->cols ();

  for (i=0; i<r; i++)
    for (j=0; j<c; j++)
      (*s)(i, j) = (*s1)((long) order[i], j);

  return (new XplObject (s, "sort"));
}
#endif

// PC 20010608 - new readVar
XplObject* readVar (Liste<XplObject*> *argl)
{
     XplObject  *o;
     XplDouble  *res, *cond;
     XplLong *condl, *rowlist, *collist, *rowconds, *colconds;
     const char *n;

#ifdef _UNIX_
     if (argl->laenge () == 0)
     {
          o = readFromFileSelectionBox ();
          if (o == NULL)
               globalError.Set (ERR_EMPTY, "in readVar");

          return (o);
     }
#endif

     if ((argl->laenge () > 5) || (argl->laenge () < 1))
     {
#if _UNIX_
          globalError.Set (ERR_ARGS, "readVar: Must have 0 to 5 parameters");
#else
          globalError.Set (ERR_ARGS, "readVar: Must have 1 to 5 parameters");
#endif
          return (NULL);
     }

     // file name
     if ((*argl)[0]->DefaultComponent()->Type() == C_TEXT)
     {
#ifdef _XPLCDEF_
          n = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
          n = (*argl)[0]->DefaultComponent()->Content().text;
#endif

          res = new XplDouble(1);

    }

     // row list
     if (argl->laenge () >= 2)
     {
          cond = (*argl)[1]->DefaultXplDouble ();

          if (cond == NULL)
          {
               globalError.Set (ERR_NUM, "readVar:  second argument");
               return (NULL);
          }
          if ((cond->dim(1) == 2) && (cond->dim.prod(2) == cond->dim.prod(MAX_XARRAY)))
          {
               rowlist = new XplLong (1);
               *rowlist = cast (*cond);
          }
          else
          {
               rowlist = NULL;
          }
     }
     else
     {
          rowlist = NULL;
     }

     // col list
     if (argl->laenge () >= 3)
     {
          cond = (*argl)[2]->DefaultXplDouble ();

          if (cond == NULL)
          {
               globalError.Set (ERR_NUM, "readVar:  third argument");
               return (NULL);
          }
          if ((cond->dim(1) == 2) && (cond->dim.prod(2) == cond->dim.prod(MAX_XARRAY)))
          {
               collist = new XplLong (1);
               *collist = cast (*cond);
          }
          else
          {
               collist = NULL;
          }
     }
     else
     {
          collist = NULL;
     }

     // row conds
     if (argl->laenge () >= 4)
     {
          cond = (*argl)[3]->DefaultXplDouble ();

          if (cond == NULL)
          {
               globalError.Set (ERR_NUM, "readVar:  fourth argument");
               return (NULL);
          }
          
          if (cond->dim.prod(MAX_XARRAY) > 1)
          {
               rowconds = new XplLong (1);
               *rowconds = cast (*cond);
          }
          else
          {
               rowconds = NULL;
          }
     }
     else
     {
          rowconds = NULL;
     }

     // col conds
     if (argl->laenge () >= 5)
     {
          cond = (*argl)[4]->DefaultXplDouble ();

          if (cond == NULL)
          {
               globalError.Set (ERR_NUM, "readVar:  fifth argument");
               return (NULL);
          }
          
          
          if (cond->dim.prod(MAX_XARRAY) > 1)
          {
               colconds = new XplLong (1);
               *colconds = cast (*cond);
          }
          else
          {
               colconds = NULL;
          }
     }
     else
     {
          colconds = NULL;
     }

#ifdef MATRIX
     if (ReadMatrix (n, *res) == 0)
     {
#else
     if (res->ReadASCIIXplArray(n, rowlist, collist, rowconds, colconds) == 0)
     {
#endif
          globalError.Set  (ERR_FILE, "readVar: ");
          globalError.AppendText  (ERR_FILE, n);
          delete res;
          return (NULL);
     }
     
     return (new XplObject (res, "readVar"));
}

/* PC 20010608 - rewritten
XplObject* readVar (Liste<XplObject*> *argl)
{
  XplObject  *o;
  XplDouble  *res;
  const char *n;

#ifdef _UNIX_
  if (argl->laenge () == 0)
    {
    o = readFromFileSelectionBox ();
    if (o == NULL)
      globalError.Set (ERR_EMPTY, "in readVar");

    return (o);
    }
#endif

  if (argl->laenge () != 1)
    {
#if _UNIX_
    globalError.Set (ERR_ARGS, "readVar: Must be 0 or 1");
#else
    globalError.Set (ERR_ARGS, "readVar: Must be 1");
#endif
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() == C_TEXT)
    {
#ifdef _XPLCDEF_
    n = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    n = (*argl)[0]->DefaultComponent()->Content().text;
#endif

    res = new XplDouble(1);

#ifdef MATRIX
    if (ReadMatrix (n, *res) == 0)
      {
#else
    if (res->ReadASCIIXplArray (n) == 0)
      {
#endif
      globalError.Set  (ERR_FILE, "readVar: ");
      globalError.AppendText  (ERR_FILE, n);
      delete res;
      return (NULL);
      }
    }

  return (new XplObject (res, "readVar"));
}
*/

#ifndef MATRIX
XplObject* writeVar (Liste<XplObject*> *argl)
{
  const char *n;
  const char *fmt, *mode;
  int fmode = 1;
  XplDouble  *s1 = NULL;
  XplObject  *o;
#ifdef _XPLCDEF_
  XplChar   *xc = NULL;
#endif

  if ((argl->laenge () < 2) && (argl->laenge () >4))
    {
    globalError.Set (ERR_ARGS, "write: Must be 2, 3 or 4");
    return (NULL);
    }

  o = (*argl)[0];
  if (o->DefaultType () == C_XPLDOUBLE)
    s1 = o->DefaultXplDouble ();
  if (o->DefaultType () == C_TEXT)
    {
#ifdef _XPLCDEF_
    xc = o->DefaultComponent()->Content().xplchar;
#else
    cerr << "writeVar not implemented without XPLCDEF" << endl;
#endif
    }

#ifdef _XPLCDEF_
  if ((xc == NULL) && (s1 == NULL))
#else
  if (s1 == NULL)
#endif
    {
    globalError.Set (ERR_NUM, "write: first argument");
    return (NULL);
    }

  if ((*argl)[1]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set (ERR_TEXT, "write: second argument");
    return (NULL);
    }

#ifdef _XPLCDEF_
  n = (*(*argl)[1]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  n = (*argl)[1]->DefaultComponent()->Content().text;
#endif

  if (argl->laenge () >= 3)  	// SK 18.11.98 mode
    {
    if ((*argl)[2]->DefaultComponent()->Type() != C_TEXT)
      {
      globalError.Set (ERR_TEXT, "write: third argument");
      return (NULL);
      }
#ifdef _XPLCDEF_
    mode = (*(*argl)[2]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    mode = (*argl)[2]->DefaultComponent()->Content().text;
#endif
    fmode = (mode[0]!='a');
  }

  if (argl->laenge () >= 4)         // format string
    {
    if ((*argl)[3]->DefaultComponent()->Type() != C_TEXT)
      {
      globalError.Set (ERR_TEXT, "write: fourth argument");
      return (NULL);
      }
#ifdef _XPLCDEF_
    fmt = (*(*argl)[3]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    fmt = (*argl)[3]->DefaultComponent()->Content().text;
#endif

#ifdef _XPLCDEF_
    if (xc != NULL)             // write strings
      {
      if (*fmt == 'x')
      { if (fmode)
       	xc->WriteXXplArray (n);
        else
        {
          globalError.Set (ERR_TEXT, "write: can not append with x format");
          return (NULL);
         }
      }
      else
      	xc->WriteASCIIXplArray (n, fmt, fmode);
      }
    else                        // write figures
#endif
      if (*fmt == 'x')
      { if (fmode)
	       s1->WriteXXplArray (n);
        else
        {
          globalError.Set (ERR_TEXT, "write: can not append with x format");
          return (NULL);
        }
      }
      else
    	s1->WriteASCIIXplArray (n, fmt, fmode);
    }  // laenge = 3
  else
#ifdef _XPLCDEF_
    if (xc != NULL)             // write strings
      xc->WriteASCIIXplArray (n, "%s", fmode);
    else                        // write figures
#endif
      s1->WriteASCIIXplArray (n, "%f", fmode);

  return (NULL);
}

#endif

#if defined (_GRAPHICS_)

XplObject* editXplDouble (Liste<XplObject*> *argl)
{
  XplObject *obj;

  if (argl->laenge () != 1)
    {
    globalError.Set (ERR_ARGS, "editXplDouble: Must be 1");
    return (NULL);
    }

  obj = GetXplObject (objList, (*argl)[0]->Name ());

  if (obj != NULL)
    if (obj->DefaultXplDouble () != NULL)
      edit (*(obj->DefaultXplDouble ()));
  //      edit (obj->DefaultXplDouble ());
    else
      globalError.Set (ERR_NUM, "editXplDouble:");
  else
    globalError.Set (ERR_OBJ, "editXplDouble:");

  return (NULL);    // Vorabloesung, solange keine Referenzen moeglich sind
}

XplObject* editMacroText (Liste<XplObject*> *argl)
{
  Macro *mac;
  const char  *t;

  if (argl->laenge () != 1)
    {
    globalError.Set (ERR_ARGS, "editMacroText: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() == C_TEXT)
    {
#ifdef _XPLCDEF_
    t = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    t = (*argl)[0]->DefaultComponent()->Content().text;
#endif
    mac = GetMacro (macList, t);
    if (mac != NULL)
      {
      edit_macro (mac->Text ());
      return (NULL);
      }
    }

  globalError.Set (ERR_MAC, "editMacroText: ");
  globalError.AppendText (ERR_MAC, "editMacroText: ");

  return (NULL);
}

#endif    //  _GRAPHICS_

#ifndef MATRIX
#define rows() dimension(0)
#define cols() dimension(1)
#endif

XplObject * knn (Liste<XplObject*> *argl)
{
  XplDouble *x, *yn, *x1;
  int    n, k, length, i;
  double sx = 0.0;
  
  length = argl->laenge();
  
  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "knn: Must be 2");
    return (NULL);
    }

  x  = (*argl)[0]->DefaultXplDouble ();
  x1 = (*argl)[1]->DefaultXplDouble ();
  
  if (x->cols() != 1)
    {
    globalError.Set (ERR_NUM, "knn: first argument must be a vector");
    return (NULL);
    }

  n = x->rows();

/*
#ifdef MATRIX
  if (! x1->isScalar())
#else
  if (x->dimension() != 0)
#endif
    {
    globalError.Set (ERR_DIM, "knn: second argument has to be a scalar");
    return (NULL);
    }
*/
  k = (int) (*x1)(0);

  if ((n <= 2*k) || (k < 0))
    {
    globalError.Set (ERR_DIM, "knn: n < 2*k  value of k to large");
    return (NULL);
    }

  yn = new XplDouble (n);
  XplDouble &yg = *yn;

  for (i=0; i<2*k+1; i++)
    sx += (*x)[i];

  for (i=k; i<n-k-1; i++)
    {
    yg[i] = sx / (2*k + 1);
    sx += (*x)[i+k+1] - (*x)[i-k];
    }
  yg[i] = sx / (2*k + 1);         // don't compute sx for last i


  for (i=0; i<k; i++)
    {
    yg[i]     = yg[k];
    yg[n-1-i] = yg[n-1-k];
    }

  return (new XplObject (yn, "knn"));
}


