/* $Header: /home/xplore/cvs/xpl4gr/xplfun2.C,v 1.6 2003/06/12 13:14:14 cizek Exp $ */

// XploRe core functions
// see also xplfun2.C and xplbasefun.C
// contains Java interface functions


// #pragma implementation

//  TTK, 31.8.95  last change 15.9.96

#include <math.h>
#include <string.h>

#include "machine.h"
#include "object.h"
#include "function.h"
#include "xplfun.h"
#include "xplfun2.h"
#include "xplerror.h"
#include "init.h"
#include "ttkio.h"
#include "xplexec.h"
//#include "xsockio.h"  
#include "directory.h"
#include "global.h"
#include "logfile.h"
#include "remnan.h"




#ifndef MATRIX
#define rows() dimension(0)
#define cols() dimension(1)
#define out()  dump("%lg")
#endif

#define TEXTLENGTH  1024L

#ifdef __BORLANDC__
#include "xplwin.h"
#endif

// tk 120398 remove NaN's
#if defined(SOCKETSERVER) || defined(X4singleserver)
#include "remnan.h"
#include "xjprotocol.h"
extern class XJprotocol *protocol;
#endif
// tk 120398 end


#ifdef _XPLCDEF_
#include "xio.h"
XplObject* TestGemischtesLesen (Liste<XplObject*> *argl)
{
  XplObject *obj;
  const char *t;
  XplDouble rd(1);
  XplLong   rl, colvec;
  XplChar   rc;
  int       h;

  if (argl->laenge () != 1)
    {
    globalError.Set(ERR_ARGS, "TGL:  Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->Type() != O_TEXT)
    {
    globalError.Set(ERR_TEXT, "TGL:  first argument");
    return (NULL);
    }

  t = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();

  ReadXplArray (t, rc, rd, rl, colvec);

  if (globalError.Get ())
    return (NULL);

  h = (rd.size() != 0) + (rc.size() != 0) + (rl.size() != 0);

  if (h == 0)
    {
    globalError.Set(ERR_TEXT, "readm:  nothing read");
    return (NULL);
    }

  if (h == 1)
    {
    if (rd.size() > 0)       // rd is read
      obj = new XplObject (new XplDouble (rd));
    if (rc.size() > 0)       // rc is read
      obj = new XplObject (new XplChar (rc));
    if (rl.size() > 0)       // rl is read
      obj = new XplObject (new XplDouble (cast (rl)));
    return (obj);
    }

  obj = new XplObject ("readm");

  if (rd.size() > 0)       // rd is read
    obj->AppendComponent (new Component (new XplObject (new XplDouble(rd), "double")));
  if (rc.size() > 0)       // rc is read
    obj->AppendComponent (new Component (new XplObject (new XplChar(rc), "text")));
  if (rd.size() > 0)       // rl is read
    obj->AppendComponent (new Component (new XplObject (new XplDouble(cast (rl)), "integer")));

  obj->AppendComponent (new Component (new XplObject (new XplDouble(cast (colvec)), "type")));
  return (obj);
}
#endif   // of _XPLCDEF_

XplObject* showObjects (Liste<XplObject*> *argl)
{
  PrintXplObjectList (objList);

  return (NULL);
}

XplObject* setError (Liste<XplObject*> *argl)
{
  XplObject  *obj;
  const char *t;
  XplDouble  *x;

  if (argl->laenge () != 2)
    {
    globalError.Set(ERR_ARGS, "setError:  Must be 2");
    return (NULL);
    }

  obj = (*argl)[0];

  if (obj->Type() != O_XPLDOUBLE)
    {
    globalError.Set(ERR_NUM, "setError:  first argument");
    return (NULL);
    }

  x   = obj->DefaultXplDouble();
  obj = (*argl)[1];

  if (obj->Type() != O_XPLCHAR)
    {
    globalError.Set(ERR_NUM, "setError:  second argument");
    return (NULL);
    }

  if (!(int)(*x)[0])
    return (NULL);

#ifdef _XPLCDEF_
  t = (*obj->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  t = obj->DefaultComponent()->Content().text;
#endif
  globalError.Set (ERR_BREAK, t);

  return (NULL);
}

XplObject* setWarning (Liste<XplObject*> *argl)
{
  XplObject  *obj;
  const char *t;
  XplDouble  *x;

  if (argl->laenge () != 2)
    {
    globalError.Set(ERR_ARGS, "setWarning:  Must be 2");
    return (NULL);
    }

  obj = (*argl)[0];

  if (obj->Type() != O_XPLDOUBLE)
    {
    globalError.Set(ERR_NUM, "setWarning:  first argument");
    return (NULL);
    }

  x   = obj->DefaultXplDouble();
  obj = (*argl)[1];

  if (obj->Type() != O_XPLCHAR)
    {
    globalError.Set(ERR_NUM, "setWarning:  second argument");
    return (NULL);
    }

  if (!(int)(*x)[0])
    return (NULL);

#ifdef _XPLCDEF_
  t = (*obj->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  t = obj->DefaultComponent()->Content().text;
#endif
  globalWarning.Set (WARN_MACRO, t);

  return (NULL);
}

XplObject* isNotEmpty (Liste<XplObject*> *argl)
{
  XplObject  *obj, *o;
  const char *t;
  XplDouble  *res;
  long       i, otype, length = argl->laenge ();

  if (length == 0)
    {
    globalError.Set(ERR_ARGS, "isNotEmpty:  Must be >= 1");
    return (NULL);
    }

  res = new XplDouble (length);

  for (i=0; i<length; i++)
    {
    otype = -1;
    o = (*argl)[i]; 
    switch (o->Type())
      {
      case O_TEXT:
#ifdef _XPLCDEF_
	t = (*o->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
	t = o->DefaultComponent()->Content().text;
#endif
       	if (strcmp (o->Name (), "_tmp") == 0)     // exist ("x") 
	  {
	  obj = GetXplObject (objList, t);
	  if (obj != NULL)
	    {
	    switch (obj->Type())
	      {
	      case O_EMPTY: 	 otype = 0;  break;
	      case O_XPLDOUBLE:	 otype = 1;  break;
	      case O_TEXT: 	 otype = 2;  break;
	      case O_XPLTIME: 	 otype = 3;  break;
	      case O_DISPLAY: 	 otype = 4;  break;

	      default: 	         otype = 9;  break;
	      }
	    }
	  if (GetMacro (macList, t) != NULL)
	    {
	    otype = otype == -1 ? 10 : otype+10;
	    }
	  }
	else
	  otype = 2;                       // usual text
	(*res)(i) = (double) otype;
	//	(*res)(i) = double (otype);
	break;
      case O_EMPTY:
	(*res)(i) = 0.0;  break;           // is empty
      case O_XPLDOUBLE:
	(*res)(i) = 1.0;  break;
      case O_XPLTIME:
	(*res)(i) = 3.0;  break;
      case O_DISPLAY:
	(*res)(i) = 4.0;  break;
      case O_MACRO:
	(*res)(i) = 5.0;  break;           // not yet supported
      default:
	(*res)(i) = 9.0;  break;           // must be composed
      }
    }
  return (new XplObject (res, "exist"));
}

XplObject* isComp (Liste<XplObject*> *argl)
/* determines, whether an object has the specified component.
   return  -1   object with given name doesn't exist
            0   object doesn't have this component
            i   component is on the ith position in object
TTK, 15.5.96  */

{
  XplObject  *obj;
  const char *t1, *t2;
  long       pos;
  XplDouble  *res;

  if (argl->laenge () != 2)
    {
    globalError.Set(ERR_ARGS, "isComp:  Must be 2");
    return (NULL);
    }

  if ((*argl)[0]->Type() != O_XPLCHAR)
    {
    globalError.Set(ERR_TEXT, "isComp:  first argument");
    return (NULL);
    }

  if ((*argl)[1]->Type() != O_XPLCHAR)
    {
    globalError.Set(ERR_TEXT, "isComp:  second argument");
    return (NULL);
    }

#ifdef _XPLCDEF_
  t1 = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
  t2 = (*(*argl)[1]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  t1 = (*argl)[0]->DefaultComponent()->Content().text;
  t2 = (*argl)[1]->DefaultComponent()->Content().text;
#endif

  res = new XplDouble (1);
  obj = GetXplObject (objList, t1);

  if (obj == NULL)
    (*res)(0) = -1.0;              // doesn't exist
  else
    if (obj->GetComponent (t2, pos) == NULL)
      (*res)(0) = 0.0;             // component doesn't exist
    else
      (*res)(0) = (double) pos+1;

  return (new XplObject (res, "isComp"));
}

XplObject* existGlobal (Liste<XplObject*> *argl)
{
  XplObject  *obj;
  const char *t;
  XplDouble  *res;

  if (argl->laenge () != 1)
    {
    globalError.Set(ERR_ARGS, "existGlobal:  Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set(ERR_TEXT, "existGlobal:  first argument");
    return (NULL);
    }

  res = new XplDouble (1);
#ifdef _XPLCDEF_
  t = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  t = (*argl)[0]->DefaultComponent()->Content().text;
#endif

  obj = GetXplObject (globObjList, t);
  (*res)(0) = 0.0;             // if unknown (empty glob obj must not exist)

  if (obj != NULL)
    switch (obj->Type())
      {
      case O_EMPTY: 	 (*res)(0) = 0.0;  break;
      case O_XPLDOUBLE:	 (*res)(0) = 1.0;  break;
      case O_TEXT: 	 (*res)(0) = 2.0;  break;
      case O_XPLTIME: 	 (*res)(0) = 3.0;  break;
      case O_DISPLAY: 	 (*res)(0) = 4.0;  break;

      default: 	         (*res)(0) = 9.0;  break;
      }

  if (GetMacro (macList, t) != NULL)
    {
    (*res)(0) += 10.0;
    return (new XplObject (res, "exglb"));
    }

  return (new XplObject (res, "exglb"));
}

XplObject* getGlobal (Liste<XplObject*> *argl)
{
  XplObject  *obj;
  const char *t;

  if (argl->laenge () != 1)
    {
    globalError.Set(ERR_ARGS, "getGlobal:  Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set(ERR_TEXT, "getGlobal:  first argument");
    return (NULL);
    }

#ifdef _XPLCDEF_
  t = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  t = (*argl)[0]->DefaultComponent()->Content().text;
#endif
  obj = GetXplObject (globObjList, t);

  if (obj == NULL)
    {
    char text[TEXTLENGTH];
    sprintf (text, "getGlobal:  can not find global object %s", t);
    globalError.Set(ERR_INTERN, text);
    return (NULL);
    }

  return (new XplObject (obj));
}

XplObject* putGlobal (Liste<XplObject*> *argl)
{
  XplObject  *obj, *globObj;
  const char *t;
  long       pos;

  if (argl->laenge () != 1)
    {
    globalError.Set(ERR_ARGS, "putGlobal:  Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set(ERR_TEXT, "putGlobal:  first argument");
    return (NULL);
    }

#ifdef _XPLCDEF_
  t = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  t = (*argl)[0]->DefaultComponent()->Content().text;
#endif
  obj = GetXplObject (objList, t);

  if (obj == NULL)
    {
    globalError.Set(ERR_INTERN, "putGlobal: object not found");
    return (NULL);
    }

  if (globObjList == objList)    // nothing to do
    return (NULL);

  globObj = GetXplObject (globObjList, t, pos);

  if (globObj != NULL)           // overwrite existing global object
    {
    globObj->DelWriteProtection ();
    delete globObj;
    globObj = new XplObject (obj);
    globObj->SetWriteProtection ();	// PC 20020207 - SetWriteProtection missing, every global object should be protected inside a procedure!
    (*globObjList)[pos] = globObj;
    return (NULL);
    }
  else
    globObjList->haengeAn (new XplObject (obj));

  return (NULL);
}

XplObject* vectorize   (Liste<XplObject*> *argl)
{
  XplObject *s;
  XplDouble *t, tmp(1L);
  long      i, type, length = argl->laenge();
#ifndef MATRIX
  XplIndex  xind;
#endif
#ifdef _XPLCDEF_
  XplChar   xc(1), *tc;
#endif

  if (length < 1)
    {
    globalError.Set(ERR_ARGS, "vectorize: Must >= 1");
    return (NULL);
    }

  // Typ des ersten Elements
  s    = (*argl)[0];
  type = s->DefaultComponent()->Type();

  for (i=1; i<length; i++)
    {
    s = (*argl)[i];
    if (s->DefaultComponent()->Type() != type)
      {
      globalError.Set(ERR_TYPE, "vectorize: must all be the same");
      return (NULL);
      }
    }
#ifndef _XPLCDEF_
  if (type != C_XPLDOUBLE)
    {
    globalError.Set(ERR_NUM, "vectorize: no _XPLCDEF_");
    return (NULL);
    }
#endif

#ifdef MATRIX                      // pure MATRIX case
////////////////////////////////////////////////////////////////////////////
  for (i=0; i<length; i++)
    {
    s = (*argl)[i];
    tmp     = *s->DefaultXplDouble();

    XplDouble *t2, tmp2(tmp.rows() * tmp.cols());

    for (long j=0; j<tmp2.rows(); j++)
      tmp2[j] = tmp[j];

    if (i == 0)                    // generate t only at the beginning
      t = new XplDouble (tmp2);
    else
      {
      t2 = t;
      t = ColumnBind (*t, tmp);       // otherwise append vector tmp
      delete t2;                      // ColumnBind generates new Matrix
      }
    }

  return (new XplObject (t, "#"));
#else                             // XplArrays
////////////////////////////////////////////////////////////////////////////
  if (type == C_XPLDOUBLE)
    {
    for (i=0; i<length; i++)
      {
      s = (*argl)[i];
      tmp     = *s->DefaultXplDouble();
      xind    = 1L;
      xind.setdim (0, tmp.dim.prod());

      tmp.reshape (xind);
      if (i == 0)                    // generate t only at the beginning
	t = new XplDouble (tmp);
      else
	*t = t->bind (tmp, 0);       // otherwise append vector tmp
      }
    return (new XplObject (t, "#"));
    }
  else                // C_XPLCHAR
    {
    for (i=0; i<length; i++)
      {
      s    = (*argl)[i];
      xc   = *s->DefaultComponent()->Content().xplchar;
      xind = 1L;
      xind.setdim (0, xc.dim.prod());

      xc.reshape (xind);
      if (i == 0)                    // generate t only at the beginning
	tc = new XplChar (xc);
      else
	*tc = tc->bind (xc, 0);       // otherwise append vector tmp
      }
    return (new XplObject (tc, "#"));
    }

#endif

}

#ifdef HAS_NOPTRPTR
typedef XplDouble* XplDoubleP;   // SWS 16.09
typedef XplChar*   XplCharP;     // SWS 21.1.98
#endif

long decomposefmtstring (const char *fmt, long **pos) {
  long i, n;
  for (n=i=0; i<strlen(fmt); i++) {
    if (fmt[i] == '%') n++;
  }
  (*pos) = new long[n+1];
  for (n=i=0; i<strlen(fmt); i++) {
    if (fmt[i] == '%') {
      if (fmt[i+1] == '%') {
	i++;
      } else {
	(*pos)[n++] = i;
      } 
    }
  }
  return n;
}

// PC 20020628 - string functions converting %% to %
char *strncatproc(char *dest, const char *src, size_t maxlen)
{
  const char *s = src;
  char *d = dest + strlen(dest);
  size_t ncopy = 0;

  for( ; *d = *s; s++, d++)
  {
    ncopy++;
    if ((*s == '%') && (*(s+1) == '%'))
    {
      s++;
      ncopy++;
    }
    if (ncopy >= maxlen)
    {
      d++;
      *d = '\0';
      break;
    }
  }

  return dest;
}

char *strcpyproc(char *dest, const char *src)
{
  const char *s = src;
  char *d = dest;

  for( ; *d = *s; s++, d++)
  {
    if ((*s == '%') && (*(s+1) == '%'))
      s++;
  }

  return dest;
}

#ifdef _XPLCDEF_
#define MAXSTRINGLEN 65536L

//typedef char* charp;

// PC 20020628 - fixed crash, %% handled correctly
XplObject* xaMakeString  (Liste<XplObject*> *argl) {
  XplChar   *xplc;
  XplObject *s;
  XplDouble *t;
  XplChar   *ts;
  const char *fmt;
  char fmti[MAXSTRINGLEN], stri[MAXSTRINGLEN], resi[MAXSTRINGLEN];
  charp *res;
  long i, length = argl->laenge(), nvar, nvarall, nrow, *pos[1], k, row;

  if (length < 2) {
    globalError.Set(ERR_ARGS, "string: Must >= 2");
    return (NULL);
  }

  s = (*argl)[0];
  if (s->DefaultComponent()->Type() != C_XPLCHAR) {
    globalError.Set(ERR_TEXT, "string: expected formatstring as first parameter");
    return (NULL);
  }

  xplc = s->DefaultComponent()->Content().xplchar;
  // PC 20020811 - find number of variables
  nvarall = 0;
  for(i = 0; i < xplc->dim(0); i++)
  {
    fmt  = (*xplc)(i).tocstr();
    nvar = decomposefmtstring(fmt, pos);
    if (nvar > nvarall)
      nvarall = nvar;
  }

  if (nvarall >= length) {
    globalError.Set(ERR_TEXT, "string: number of parameters does not match number of parameters in format string");
    return (NULL);
  }

  nrow = 1;
  for (i=1; i<length; i++) {
    s = (*argl)[i];
    if (s->DefaultComponent()->Type() == C_XPLDOUBLE) {
      t = s->DefaultComponent()->Content().xpldouble;
      if (nrow==1) {
	nrow = t->dim(0);
      } else if ((nrow != t->dim(0)) && (t->dim(0)!=1)) {
	globalError.Set(ERR_TEXT, "string: parameter vectors do not match in the number of rows");
	return (NULL);
      }
    }
    if (s->DefaultComponent()->Type() == C_XPLCHAR) {
      ts = s->DefaultComponent()->Content().xplchar;
      if (nrow==1) {
	nrow = ts->dim(0);
      } else  if ((nrow != ts->dim(0)) && (ts->dim(0)!=1)) {
	globalError.Set(ERR_TEXT, "string: parameter vectors do not match in the number of rows");
	return (NULL);
      }
    }
  }

  // PC 20020811 - check format string dimension
  if ((nrow != xplc->dim(0)) && (xplc->dim(0) != 1)) {
	globalError.Set(ERR_TEXT, "string: format string vector does not match in the number of rows");
	return (NULL);
      }

// PC 20020628 - improved memory management
  res = new charp[nrow];
  for (row = 0; row < nrow; row++) {
  // PC 20020811 - format string array
    fmt  = (*xplc)(row%xplc->dim(0)).tocstr();
    nvar = decomposefmtstring(fmt, pos);

  //    res[i] = new char[MAXSTRINGLEN];
    resi[0] = 0;
    if (nvar>0) {
      if ((*pos)[0]>0) {
	     strncatproc(resi, fmt, (*pos)[0]); // PC 20020628
      }
    } else {
      strcpyproc(resi, fmt); // PC 20020628
    }

    for (i=1; i<=nvar; i++) {
      if (i==nvar) {
        k = strlen(fmt) - (*pos)[i-1] + 1;
        strncpy(fmti, &fmt[(*pos)[i-1]], k);
      } else {
        k = (*pos)[i] - (*pos)[i-1];
        strncpy (fmti, &fmt[(*pos)[i-1]], k);
      }
      fmti[k] = 0;

      s = (*argl)[i];
      if (s->DefaultComponent()->Type() == C_XPLDOUBLE) {
        t = s->DefaultXplDouble();
// PCopt        for (k=0; k<nrow; k++) {
        sprintf(stri, fmti, (*t)(row%t->dim(0)));
        strcat(resi, stri);
// PCopt       }
      }
      if (s->DefaultComponent()->Type() == C_XPLCHAR) {
        ts = s->DefaultComponent()->Content().xplchar;
// PC opt      for (k=0; k<nrow; k++) {            // PC 20020628 - corrected (t -> ts)
        sprintf(stri, fmti, (*ts)(row%ts->dim(0)).tocstr());
        strcat(resi, stri);
// PC opt      }
      }
    }

    // PC store results
    res[row] = strdup(resi);
  }
// PC 20020628 - end of memory management changes

  XplIndex ind(nrow);
  XplChar *result = new XplChar(ind);
  for (k=0; k<nrow; k++) {
    (*result)(k) = xplstring(res[k]);
    free(res[k]);		// PC changed delete -> free (res[k] done by strdup)
  }
  delete[] res;

  return (new XplObject (new Component (result), "string"));
}

XplObject*      xaAtof  (Liste<XplObject*> *argl)
{
  XplChar   *xplc;
  XplObject *s;
  XplDouble *x;
  long      length = argl->laenge();

  if (length != 1)
    {
    globalError.Set(ERR_ARGS, "atof: Number of parameters <> 1");
    return (NULL);
    }

  s = (*argl)[0];
  if (s->DefaultComponent()->Type() != C_XPLCHAR)
    {
    globalError.Set(ERR_TEXT, "atof: Text matrix expected");
    return (NULL);
    }

  xplc = s->DefaultComponent()->Content().xplchar;

  x  = new XplDouble (1);
  *x = xplc->atof ();

  if (globalError.Get ())
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (new Component (x), "atof"));
}

XplObject*      xaStrlen  (Liste<XplObject*> *argl)
{
  XplChar   *xplc;
  XplObject *s;
  XplDouble *x;
  long      length = argl->laenge();

  if (length != 1)
    {
    globalError.Set(ERR_ARGS, "strlen: Number of parameters <> 1");
    return (NULL);
    }

  s = (*argl)[0];
  if (s->DefaultComponent()->Type() != C_XPLCHAR)
    {
    globalError.Set(ERR_TEXT, "strlen: Text matrix expected");
    return (NULL);
    }

  xplc = s->DefaultComponent()->Content().xplchar;

  x  = new XplDouble (1);
  *x = xplc->strlen ();

  if (globalError.Get ())
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (new Component (x), "strlen"));
}

XplObject*      xaStrtok  (Liste<XplObject*> *argl)
{
  XplChar   *xplc, *xpld, *res;
  XplObject *s;
  long      length = argl->laenge();

  if (length != 2)
    {
    globalError.Set(ERR_ARGS, "strtok: Number of parameters <> 2");
    return (NULL);
    }

  s = (*argl)[0];
  if (s->DefaultComponent()->Type() != C_XPLCHAR)
    {
    globalError.Set(ERR_TEXT, "strtok: Text matrix expected");
    return (NULL);
    }

  xplc = s->DefaultComponent()->Content().xplchar;

  if (xplc->dim.prod(MAX_XARRAY)!=1)
    {
    globalError.Set(ERR_TEXT, "strtok: 1x1 text matrix expected");
    return (NULL);
    }

  s = (*argl)[1];
  if (s->DefaultComponent()->Type() != C_XPLCHAR)
    {
    globalError.Set(ERR_TEXT, "strlen: Text matrix expected");
    return (NULL);
    }

  xpld = s->DefaultComponent()->Content().xplchar;
  if (xpld->dim.prod(MAX_XARRAY)!=1)
    {
    globalError.Set(ERR_TEXT, "strtok: 1x1 text matrix expected");
    return (NULL);
    }

      res  = new XplChar (1);
      *res = xplc->strtok(*xpld);

  return (new XplObject (new Component (res), "strtok"));
  //  return (new XplObject (new Component (x), "strlen"));
}


XplObject*      xaSubString  (Liste<XplObject*> *argl)
{
  XplChar   *xplc, *rc;
  XplObject *s;
  XplDouble *lx, *rx;
  XplLong   left, right;
  long      length = argl->laenge();

  if (length != 3)
    {
    globalError.Set(ERR_ARGS, "xaAtof: Must be == 3");
    return (NULL);
    }

  s = (*argl)[0];
  if (s->DefaultComponent()->Type() != C_XPLCHAR)
    {
    globalError.Set(ERR_TEXT, "xaSubString:");
    return (NULL);
    }

  lx = (*argl)[1]->DefaultXplDouble ();
  if (lx == NULL)
    {
    globalError.Set (ERR_NUM, "xaSubString: second argument");
    return (NULL);
    }

  rx = (*argl)[2]->DefaultXplDouble ();
  if (rx == NULL)
    {
    globalError.Set (ERR_NUM, "xaSubString: third argument");
    return (NULL);
    }

  xplc  = s->DefaultComponent()->Content().xplchar;
  left  = cast (*lx);
  right = cast (*rx);

  rc = new XplChar (1);

  *rc = xplc->substr (left, right);

  if (globalError.Get ())
    {
    delete rc;
    return (NULL);
    }
  return (new XplObject (rc, "substr"));
}
#endif

#ifndef MATRIX
XplObject*	xaSker (Liste<XplObject*> *argl)
{
  long       length = argl->laenge ();
  XplDouble  *x, *bandwidth, *weight, *xest, *res;
  XplLong    *xlb = new XplLong;
  XplObject  *o;
  const char *kernel;
 
  if ((length != 4) && (length != 5))
    {
    globalError.Set (ERR_ARGS, "xaSker: Must be 4 or 5");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();

  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaSker: first argument");
    return (NULL);
    }

  bandwidth = (*argl)[1]->DefaultXplDouble ();

  if (bandwidth == NULL)
    {
    globalError.Set (ERR_NUM, "xaSker: second argument");
    return (NULL);
    }

  if ((*argl)[2]->DefaultComponent()->Type() != C_TEXT)
    {
    globalError.Set (ERR_TEXT, "xaSker: third argument");
    return (NULL);
    }

#ifdef _XPLCDEF_
  kernel = (*(*argl)[2]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  kernel = (*argl)[2]->DefaultComponent()->Content().text;
#endif

  weight = (*argl)[3]->DefaultXplDouble ();

  if (weight == NULL)
    {
    globalError.Set (ERR_NUM, "xaSker: fourth argument");
    return (NULL);
    }

  if (length == 5)
    {
    xest = (*argl)[4]->DefaultXplDouble ();

    if (xest == NULL)
      {
      globalError.Set (ERR_NUM, "xaSker: fifth argument");
      return (NULL);
      }
    }
  else
    xest = NULL;

  res = new XplDouble(1);

  *res = x->sker (*bandwidth, kernel, *weight, xest);

  o  = new XplObject (res, "sker");

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}

XplObject*	xaContour2 (Liste<XplObject*> *argl)
{
  long      length = argl->laenge ();
  XplDouble *x, *cut, *retp, *retxl;
  XplLong   *retl;
  XplObject *o, *o1, *o2;
 
  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "xaContour2: Must be 2");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();
  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaCountour2: first argument");
    return (NULL);
    }

  cut = (*argl)[1]->DefaultXplDouble ();
  if (cut == NULL)
    {
    globalError.Set (ERR_NUM, "xaCountour2: first argument");
    return (NULL);
    }

  retp = new XplDouble(1);
  retl = new XplLong(1);

  x->contour2 (*cut, retl, retp);

  if (globalError.Get ())
    {
    delete retp;
    delete retl;
    return (NULL);
    }

  retxl = new XplDouble(1);
  *retxl = cast (*retl);
  delete retl;

  o  = new XplObject ("contour2");
  o1 = new XplObject (retxl, "retl");
  o2 = new XplObject (retp,  "retp");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}

XplObject*	xaContour3 (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  XplDouble *x, *cut, *retp, *retxl;
  XplLong   *retl;
  XplObject *o, *o1, *o2;
 
  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "xaContour3: Must be 2");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();
  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "xaCountour3: first argument");
    return (NULL);
    }

  cut = (*argl)[1]->DefaultXplDouble ();
  if (cut == NULL)
    {
    globalError.Set (ERR_NUM, "xaCountour3: first argument");
    return (NULL);
    }

  retp = new XplDouble(1);
  retl = new XplLong(1);

  x->contour3 (*cut, retl, retp);

  if (globalError.Get ())
    {
    delete retp;
    delete retl;
    return (NULL);
    }

  retxl = new XplDouble(1);
  *retxl = cast (*retl);
  delete retl;

  o  = new XplObject ("contour3");
  o1 = new XplObject (retxl, "retl");
  o2 = new XplObject (retp,  "retp");

  o->AppendComponent (new Component (o1));
  o->AppendComponent (new Component (o2));

  o->SetDefaultXplDouble ();    // only for sure

  return (o);
}

#endif  // MATRIX

// alt XplDouble* arloop(XplDouble startval, XplDouble alpha, long n);
XplDouble* genar(XplDouble x, XplDouble startval, XplDouble alpha);

XplObject* testArloop (Liste<XplObject*> *argl)
{
  long length = argl->laenge();
  XplDouble *start, *alpha, *x, *rx;
  XplObject *res;

  if (length != 3)
    {
    globalError.Set (ERR_ARGS, "Genar: Must be 3");
    return (NULL);
    }

  if (NULL == (x = (*argl)[0]->DefaultXplDouble ()))
    {
    globalError.Set (ERR_NUM, "Genar: first argument");
    return (NULL);
    }
  if (NULL == (start = (*argl)[1]->DefaultXplDouble ()))
    {
    globalError.Set (ERR_NUM, "Genar: first argument");
    return (NULL);
    }

  if (NULL == (alpha = (*argl)[2]->DefaultXplDouble ()))
    {
    globalError.Set (ERR_NUM, "Genar: first argument");
    return (NULL);
    }

    rx = genar (*x, *start, *alpha);

    if (rx == NULL)
      {
      globalError.Set (ERR_INTERN, "genar: error occured");
      return (NULL);
      }

  res = new XplObject (rx, "genar");

  return (res);
}

XplObject* startNetscape (Liste<XplObject*> *argl)
{ return (NULL); }

XplObject* GenerateHTML (Liste<XplObject*> *argl)
{
  const char *fname;
  long       length = argl->laenge ();

  if (length != 1)
    {
    globalError.Set(ERR_ARGS, "GenerateHTML:  Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->Type() != O_TEXT)
    {
    globalError.Set(ERR_TEXT, "GenerateHTML:  first argument");
    return (NULL);
    }

#ifdef _XPLCDEF_
  fname = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  fname = (*argl)[0]->DefaultComponent()->Content().text;
#endif

  if (!GenHTML (fname))
    globalError.Set(ERR_FILE, fname);

  return (NULL);
}

int GenHTML (const char *fname)
/* invokes for a given procedure definition the HTML converter. Before 
   it checks, whether the filename is valid. It returns FALSE, if the
   filename was not valid. The function does NOT check, whether the
   converter is available!
   globalError.Show() is invoked here because GenHTML() is executed
   by a button not by the interpreter.
   The HTML file is written into xpl4home.
*/
{ globalError.Set (OBSOLETE, "Please use makehelp instead");
  globalError.ShowError();

/* SK 26.10.98
  char t[TEXTLENGTH], *fhtml;
  FILE *fin, *fout;
  int i, l = strlen (fname);

  fhtml = new char[strlen(fname)+6];    // extension !
  fhtml[0] = '\0';

  strncpy (fhtml, fname, l);

  if (strncmp (fname+l-4, ".xpl", 4) == 0)
    {
    fhtml[l-4] = '\0';
    strncat (fhtml, ".html", 5);
    }
  else
    {
    globalError.Set (ERR_FILE, "suffix '.xpl' expected for Make Help");
    globalError.ShowError ();
    return (FALSE);
    }

  fout = fopen (openfile(HELP, fhtml, "w"), "w"); 
can we write into this file ?
SK 23.06.98  

  if (fout == NULL)
    {
    globalError.Set (ERR_FILE, fname);
    globalError.ShowError ();
    return (FALSE);
    }

  if (fputs ("1234", fout) == 0)
    {
    fclose (fout);
    globalError.Set (ERR_FILE, t);
    globalError.ShowError ();
    return (FALSE);
    }
  fclose (fout);

sprintf (t, "hlp2html --htmlpath %s --macro %s &", xpl4home, fname);
SK 24.06.98
  system (t);
*/
  return (TRUE);
}

XplObject* PrintHelp (Liste<XplObject*> *argl)
{
  const char *fname;
  char       *res;
  long       length = argl->laenge ();

  if (length != 1)
    {
    globalError.Set(ERR_ARGS, "PrintHelp:  Must be 1");
    return (NULL);
    }

  if (length == 1)
    {
    if ((*argl)[0]->Type() != O_TEXT)
      {
      globalError.Set(ERR_TEXT, "PrintHelp:  first argument");
      return (NULL);
      }

#ifdef _XPLCDEF_
    fname = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    fname = (*argl)[0]->DefaultComponent()->Content().text;
#endif

    res = GetHelp (fname);
    /*
    cerr << "Content of Helpfile: "  << endl;
    if (res != NULL)
      {
	cerr << res << endl;
      delete res;
      }
    else
      cerr << "res = NULL !" << endl;
    cerr << "---" << endl;
    }
  else
    cerr << "no general help available yet" << endl;
    */
    }
  if (res != NULL)
    delete[] res;

  return (NULL);
}

char * GetHelp (const char *name)
/* searches the short help string for a given function. If no help
   could be found the result is NULL, otherwise a pointer to the text.
   The text is dynamically constructed, i.e., that the invoking function
   has to free the memory, if the text is not longer needed  */
{
  char help[TEXTLENGTH], *out, *out2;
  long outlength, outmaxlength, hlen;
  FILE *fin;

  sprintf (help, "text/%s.txt", name);
// SK 23.06.98 begin
  fin = fopen (openfile(HELP, help, "r"), "r");

  if (fin == NULL)
    {
    globalError.Set (ERR_HELP, name);
    return (NULL);
    }
// SK 23.06.98 end

  outmaxlength = 4*TEXTLENGTH;
  outlength    = 0;
  out  = new char [outmaxlength+1];
  *out = '\0';

  hlen = 1;
  while ((!feof (fin)) && (hlen > 0))     // if hlen==0, nothing to read
    {
    hlen = fread (help, sizeof (char), TEXTLENGTH, fin);
    if (outlength + hlen > outmaxlength)
      {
      outmaxlength += 2*TEXTLENGTH;
      out2  = new char[outmaxlength+1];
      *out2 = '\0';
      strncat (out2, out, outlength);
      delete out;
      out = out2;
      }
    strncat (out, help, hlen);
    outlength += hlen;
    }

  fclose (fin);
  return (out);
}

#ifndef MATRIX
XplObject* dump (Liste<XplObject*> *argl)
{
  char      *t;
  XplDouble *s;

  if (argl->laenge () != 1)
    {
    globalError.Set(ERR_ARGS, "dump:  Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultComponent()->Type() != C_XPLDOUBLE)
    {
    globalError.Set(ERR_NUM, "isNotEmpty:  first argument");
    return (NULL);
    }

//  t = tmpnam (NULL);
// Sk 17.07.98
  t = xtmpnam();
  s = (*argl)[0]->DefaultXplDouble ();

  s->WriteASCIIXplArray (t, "% 14.8lg");

  FILE *fin;
  char text[1024];

#ifdef INETD
cout << "\"-------=_aaaaaaa\"\nContent-Type: text/plain\n\n" << endl;
#endif

/*
  if (NULL == (fin = fopen (t, "r")))
    {
    globalError.Set (ERR_FILE, t);
    return (NULL);
    }

  while (!feof (fin))
    cout << fgets (text, 1024, fin);

  fclose (fin);
*/

#ifndef __BORLANDC__ //LOOK! (HAVE TO BE CHANGED)
  sprintf (text, "/bin/cat %s", t);
  system (text);

  //  sprintf (text, "/bin/rm -f %s", t);
  //  system (text);
#endif
//  free (t);
// SK 17.07.98
  remove(t);
  delete[] t;  
  
  return (NULL);
}
#endif

XplObject* logfile (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
 
  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "logfile: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->Type () != O_XPLCHAR)
    {
    globalError.Set (ERR_TEXT, "logfile: first argument");
    return (NULL);
    }

  const char *t;
  char       *n;
#ifdef _XPLCDEF_
  t = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  t = (*argl)[0]->DefaultComponent()->Content().text;
#endif

  long len = strlen (t);    // look for extension .log and append if necessary

  if (len >= 4)
    {
    if ((t[len-4] == '.') && (t[len-3] == 'l') && 
        (t[len-2] == 'o') && (t[len-1] == 'g'))
      n = strdup (t);
    else
      {
      n = new char[len+5];
      sprintf (n, "%s.log", t);
      }
    }
  else
    {
    n = new char[len+5];
    sprintf (n, "%s.log", t);
    }

  SetLogfileName (n);
  delete[] n;
  return (NULL);
}

XplObject* outputFile (Liste<XplObject*> *argl)
{
extern FILE *XplOutputFile;
  long       length = argl->laenge ();
  const char *fname, *opt;
  int        mode = 0;
  FILE       *fin;
 
  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "outputFile: Must be 2");
    return (NULL);
    }

  if ((*argl)[0]->Type () != O_XPLCHAR)
    {
    globalError.Set (ERR_TEXT, "outputFile: first argument");
    return (NULL);
    }
  if ((*argl)[1]->Type () != O_XPLCHAR)
    {
    globalError.Set (ERR_TEXT, "outputFile: second argument");
    return (NULL);
    }

#ifdef _XPLCDEF_
  fname = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
  opt   = (*(*argl)[1]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  fname = (*argl)[0]->DefaultComponent()->Content().text;
  opt   = (*argl)[1]->DefaultComponent()->Content().text;
#endif

  if (strcmp (opt, "reset") == 0)
    mode = 1;
  if (strcmp (opt, "append") == 0)
    mode = 2;
  if (strcmp (opt, "close") == 0)
    mode = 3;

  if (mode == 0)
    {
    globalError.Set (ERR_VAL, "outputFile: second argument");
    return (NULL);
    }

  if (mode == 3)
    {
    if (XplOutputFile == NULL)
      globalWarning.Set (WARN_OUTPUT, fname);
    else
      fclose (XplOutputFile);
    XplOutputFile = (FILE *) NULL;
    return (NULL);
    }

  if (XplOutputFile != NULL)     // close old file automatically
    {
    fclose (XplOutputFile);
    XplOutputFile = (FILE *) NULL;
    }

  if (mode == 1)
    fin = fopen (fname, "w");
  else
    fin = fopen (fname, "a");

  if (fin == NULL)
    {
    globalError.Set (ERR_FILE, fname);
    return (NULL);
    }

  XplOutputFile = fin;

  return (NULL);
}

// Neu

#if defined (SOCKETSERVER) || defined (_JAVA_)
XplObject* createJavaDisplay (Liste<XplObject*> *argl)
{
  long length = argl->laenge ();
  static long displayId = 1L;

  XplDouble *x, *r, *c;

  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "createJavaDisplay: Must be 2");
    return (NULL);
    }

  r = (*argl)[0]->DefaultXplDouble ();

  if (r == NULL)
    {
    globalError.Set (ERR_NUM, "createJavaDisplay: first argument");
    return (NULL);
    }

  c = (*argl)[1]->DefaultXplDouble ();
  if (c == NULL)
    {
    globalError.Set (ERR_NUM, "createJavaDisplay: second argument");
    return (NULL);
    }

  x = new XplDouble (3);
  (*x)(0) = displayId++;
  (*x)(1) = (*r)(0);
  (*x)(2) = (*c)(0);

  protocol->sendCommand (CREATE_DISPLAY);
  protocol->sendLongParameter ((long) (*x)(0));
  protocol->sendLongParameter ((long) (*r)(0));
  protocol->sendLongParameter ((long) (*c)(0));
  return (new XplObject (x, "displayJ"));
}

XplObject* showJava (Liste<XplObject*> *argl)
{
  unsigned long ms;
  long      col, n, m, i, j, k, pa, dispId, length = argl->laenge ();
  long      *polvec;
  int       numbOfDim;
  XplDouble *x, *r, *c, *pol = NULL;
//  XplMask   *mask;  SK+TK 02.11.98
  XplDouble *pstyle, *pcolor, *psize, *lstyle, *lcolor, *lsize, *lines, 
            *tcolor, *tdirection, *tsize;
  XplChar *ptext; 
  const char *ttext; 

  XplObject *o, *o1;
  Component *comp;

  if (length < 4)
    {
    globalError.Set (ERR_ARGS, "showJava: Must be at least 4");
    return (NULL);
    }

  x = (*argl)[0]->DefaultXplDouble ();
  if (x == NULL)
    {
    globalError.Set (ERR_NUM, "showJava: first argument");
    return (NULL);
    }
  dispId = (long) (*x)(0);

  r = (*argl)[1]->DefaultXplDouble ();
  if (r == NULL)
    {
    globalError.Set (ERR_NUM, "showJava: second argument");
    return (NULL);
    }

  c = (*argl)[2]->DefaultXplDouble ();
  if (c == NULL)
    {
    globalError.Set (ERR_NUM, "showJava: third argument");
    return (NULL);
    }

  if (((*r)(0) < 1) || ((*r)(0) > (*x)(1))) 
    {
    globalError.Set (ERR_NUM, "showJava: number of row invalid");
    return (NULL);
    }
  if (((*c)(0) < 1) || ((*c)(0) > (*x)(2))) 
    {
    globalError.Set (ERR_NUM, "showJava: number of col invalid");
    return (NULL);
    }

  // distinguish between text and graphics
  XplChar *xc;

  o = (*argl)[3];
  if (o->DefaultType () == C_TEXT)       // ok, forget the rest of args
    {
    xc = o->DefaultComponent()->Content().xplchar;

  protocol->sendCommand (SHOW2D);
  protocol->sendDisplayData (dispId, (*argl)[0]->Name (),
                             (long) (*r)(0), (long) (*c)(0), 1L, 2L);
  // Zeile, Spalte, ein Datapart, Dimension==2 SK+TK 25.01.99

  protocol->sendCommand (DATA_PART);
  protocol->sendLongParameter (2L);    // = Texttyp
  protocol->sendLongParameter (xc->dimension (0));
  //  protocol->sendLongParameter (xc->dimension (1));
  /*  sockout ("_BEGIN_SHOW_2D_\n");
  sockout (dispId);
  sockout ('\n');                    // id
  sockout ((*argl)[0]->Name ());
  sockout ('\n');                    // name
  sockout ((long) (*r)(0));
  sockout ('\n');                    // which row
  sockout ((long) (*c)(0));
  sockout ('\n');                    // which col
  sockout ('1');                     // a single data part
  sockout ('\n');                    // number of dataparts

// tk 050398 
// ******** DIESE ZEILEN BITTE NICHT LOESCHEN ********** (tk)
  if (!oldClientVersion)
      {
      sockout ((long)2);    // columns    only new server
      sockout ('\n');
      }
// tk 050398 end

    sockout ("_BEGIN_DATAPART_\n");
    sockout ("2\n");                 // graphics type
    sockout (xc->dimension(0));      // rows
    sockout ('\n');
/* wird vor datapar uebertragen, da fuer alle dataparts gleich  tk 070798
    if (oldClientVersion == FALSE)
      {
      sockout (xc->dimension(1));    // columns    only new server
      sockout ('\n');
      }
*/

    for (i=0; i<xc->dimension(0); i++)
      {
      ttext = (*xc)(i).tocstr();
      if (strlen(ttext)>0)
        protocol->sendStringParameter (ttext);
      else
        protocol->sendStringParameter (" ");
	//      sockout ((*xc)(i).tocstr());
	//      sockout ('\n');
      }

    //    sockout ("_END_DATAPART_\n");
    //    sockout ("_END_SHOW_2D_\n");
    return (NULL);
    }               // end of text

  numbOfDim = 3;                // show can handle 2- and 3-dim plots
  for (i=3; i<length; i++)      
    {
    x = (*argl)[i]->DefaultXplDouble ();
    if (x == NULL)
      {
      char t[TEXTLENGTH];
      sprintf (t, "showJava: %ld. argument", i);
      globalError.Set (ERR_NUM, t);
      return (NULL);
      }
    if (x->cols() < 2)
      {
      char t[TEXTLENGTH];
      sprintf (t, "showJava: %ld. argument too less columns", i);
      globalError.Set (ERR_INTERN, t);
      return (NULL);
      }
    numbOfDim = numbOfDim < x->cols () ? numbOfDim : x->cols ();   // Min
    }
  // numbOfBin = 2 when at least one argument is two-dimensional
  // numbOfBin = 3 when all arguments are at least three-dimensional

  /* TK + SK 25.01.99  
  if (numbOfDim == 2)
    protocol->sendCommand (SHOW2D);
  else
    protocol->sendCommand (SHOW3D);
    */
  protocol->sendCommand (SHOW2D);
  protocol->sendDisplayData (dispId, (*argl)[0]->Name (), 
			     (long) (*r)(0), (long) (*c)(0), length-3L, numbOfDim);
  // Zeile, Spalte, length-3 Dataparts

/*
  sockout ("_BEGIN_SHOW_2D_\n");
  sockout (dispId);
  sockout ('\n');   // id
  sockout ((*argl)[0]->Name ());
  sockout ('\n');   // name
  sockout ((long) (*r)(0));
  sockout ('\n');        // which row
  sockout ((long) (*c)(0));
  sockout ('\n');        // which col
  sockout (length-3);
  sockout ('\n');              // number of dataparts
// tk 050398
  if (!oldClientVersion)
    {
    sockout ((long) numbOfDim);    // columns    only new server
    sockout ('\n');
    }
// tk 050398 end
*/

  for (i=3; i<length; i++)
    {
    int delete_needed = FALSE;

    // mask = NULL; SK+TK 02.11.98
    pstyle = pcolor = psize = lstyle = lcolor = lsize = lines = tcolor = tdirection = tsize = NULL;
    ptext = NULL;
    o = (*argl)[i];
// tk 110298 test for NaN and Inf
    //    Fehler: RemoveNaN liefert nicht unbedingt neues XplObject !!!!!!
    // sollte jetzt gehen    tk 070798
        XplObject *oo = RemoveNaN(o);
        o = oo;
// tk 110298 end
    x = o->DefaultXplDouble ();
    n = x->rows();
    /*
    for (j=0; j<o->ComponentNumber (); j++)
      if ((*o)[j]->Type () == C_XplObject)
	{
	o1 = (*o)[j]->Content().xplobject;
        if (o1->DefaultType () == C_XPLMASK)
	  mask = o1->DefaultComponent()->Content().xplmask;
	}
	*/
/*
    comp = o->GetComponent ("_pmask");
    if (comp != NULL)
      mask = comp->Content().xplmask;
*/
    comp = o->GetComponent ("pstyle");
    if (comp != NULL) pstyle = comp->Content().xplobject->DefaultXplDouble ();
    comp = o->GetComponent ("psize");
    if (comp != NULL) psize  = comp->Content().xplobject->DefaultXplDouble ();
    comp = o->GetComponent ("pcolor");
    if (comp != NULL) pcolor = comp->Content().xplobject->DefaultXplDouble ();

    //    if (pstyle) printf ("%i %i", pstyle->dim(0), pstyle->dim(1));

    int r = 0, g = 0, b = 0, a = 3, s = 8;

  protocol->sendCommand   (DATA_PART);
  protocol->sendLongParameter (1L);    // = Graphiktyp
  protocol->sendLongParameter (n);
  //  protocol->sendLongParameter (xc->dimension (1));
/*
    sockout ("_BEGIN_DATAPART_\n");
    sockout ("1\n");
    sockout (n);
    sockout ('\n');
*/

#if defined (__BORLANDC__) || defined (WIN32)
	float *xcoord, *ycoord, *zcoord;
	long  *mvec;

	xcoord = new float[n];
	ycoord = new float[n];
	zcoord = new float[n];

	mvec = new long[n];

#else
    float xcoord[n], ycoord[n], zcoord[n];
    long  mvec[n];
#endif

    for (j=0; j<n; j++)
      {
       xcoord[j] = (float) (*x)(j, 0);
      ycoord[j] = (float) (*x)(j, 1);
      if (numbOfDim == 3)
	zcoord[j] = (float) (*x)(j, 2);

/*
      sockout ((*x)(j,0));
      sockout ('\n');
      sockout ((*x)(j,1));
      sockout ('\n');
      if ((numbOfDim == 3) && (!oldClientVersion))
	{
	sockout ((*x)(j,2));
    	sockout ('\n');
	}
*/

/*      if (mask != NULL)
        {
        (*mask)[j].GetRGB (&r, &g, &b);
	(*mask)[j].GetSymbol (&a);
	(*mask)[j].GetSize   (&s);
	}
*/
      if (pcolor!=NULL)
      { r = (int) (*pcolor)(j,0);
        g = (int) (*pcolor)(j,1);
        b = (int) (*pcolor)(j,2);
      }

      if (pstyle!=NULL)
      { a = (int) (*pstyle)(j);
      }
      if (psize!=NULL)
      { s = (int) (*psize)(j);
      }
      ms = r << 24 | g << 16 | b << 8 | a << 4 | s;
      mvec[j] = ms;

      //      sockout (ms);
      //      sockout ('\n');
      }

    protocol->sendFloat (xcoord, n);
    protocol->sendFloat (ycoord, n);
    if (numbOfDim == 3)
      protocol->sendFloat (zcoord, n);

    protocol->sendLong (mvec, n);

    r = 0;
    g = 0; 
    b = 0;
    a = 1; 
    s = 1;

    comp = o->GetComponent ("lines");
    if (comp != NULL) lines = comp->Content().xplobject->DefaultXplDouble ();

    if (lines!=NULL)
    {
      comp = o->GetComponent ("lcolor");
      if (comp != NULL) lcolor = comp->Content().xplobject->DefaultXplDouble ();
      comp = o->GetComponent ("lstyle");
      if (comp != NULL) lstyle = comp->Content().xplobject->DefaultXplDouble ();
      comp = o->GetComponent ("lsize");
      if (comp != NULL) lsize = comp->Content().xplobject->DefaultXplDouble ();

      col = lines->cols();
      for (k=0; k<lines->rows(); k++)
	{
	n = 0;  j = 0;
	while (j < col)
	  {
	  while (j<col && (*lines)(k,j) == 0)  j++;
	  pa = j;
	  while (j<col && (*lines)(k,j) != 0)  j++;
	  if (j-pa > 1)
	    {
	    protocol->sendCommand (POLYGON);
	    protocol->sendLongParameter (j-pa);

	    //	    sockout ("_BEGIN_POLYGON_\n");
	    //	    sockout (j-pa);  
	    //	    sockout ('\n');

/* SK+TK 02.11.98
	    if (mask != NULL)
	      {
	      (*mask)[k].GetRGB (&r, &g, &b);
	      (*mask)[k].GetSymbol (&a);
	      (*mask)[k].GetSize   (&s);
	      }
*/	    
            if (lcolor!=NULL)
            { r = (int) (*lcolor)(k,0);
              g = (int) (*lcolor)(k,1);
              b = (int) (*lcolor)(k,2);
            }

            if (lstyle!=NULL)
            { a = (int) (*lstyle)(k);
            }
            if (lsize!=NULL)
            { s = (int) (*lsize)(k);
            }

            ms = r << 24 | g << 16 | b << 8 | a << 4 | s;

	    protocol->sendLongParameter (ms);
	    polvec = new long[j-pa];
	    //	    sockout (ms);
	    //	    sockout ('\n');
            for (long l=pa; l<j; l++)
	      { 
		//	      sockout ((long) (*pol)(k,l));
		//	      sockout ('\n');
		polvec[l-pa] = (long) (*lines)(k,l); // TK+SK 25.01.99
	      }
	    protocol->sendLong (polvec, j-pa);
	    //	    sockout ("_END_POLYGON_\n");

	    }  // if 
	  }  // while 
        }  // for k
      }  // if

    // send text part TK+SK 21.04.99

    comp = o->GetComponent ("ptext");
    if (comp != NULL) ptext = comp->Content().xplobject->DefaultComponent()->Content().xplchar;

    if (ptext!=NULL)
      { // printf ("Point texts found !!\n");
      int r = 0, g = 0, b = 0, a = 0, s = 16;
      protocol->sendCommand (POINTTEXT);

      comp = o->GetComponent ("tcolor");
      if (comp != NULL) tcolor = comp->Content().xplobject->DefaultXplDouble ();
      comp = o->GetComponent ("tdirection");
      if (comp != NULL) tdirection = comp->Content().xplobject->DefaultXplDouble ();
      comp = o->GetComponent ("tsize");
      if (comp != NULL) tsize = comp->Content().xplobject->DefaultXplDouble ();

      // printf ("Sending %i data...\n", ptext->rows());
      for (k=0; k<ptext->rows(); k++)
      { // text 
	//       printf ("%i. %s ", k, (*ptext)(k).tocstr());
        // SK 28.08.2001
        const char *str = (*ptext)(k).tocstr();
        if (strlen(str))
          protocol->sendStringParameter ((*ptext)(k).tocstr());
        else
          protocol->sendStringParameter (" ");

        // color
        if (tcolor!=NULL)
        { r = (int) (*tcolor)(k,0);
          g = (int) (*tcolor)(k,1);
          b = (int) (*tcolor)(k,2);
        }
        // direction
        if (tdirection!=NULL)
          a = (int) (*tdirection)(k,0)+1; 
        // tsize
        if (tsize!=NULL)
          s = (int) (*tsize)(k,0)-1;

        ms = r << 24 | g << 16 | b << 8 | a << 4 | s;
        // printf ("r=%i g=%i b=%i a=%i s=%i -> %li\n", r, g, b, a, s, ms); 
        protocol->sendLongParameter (ms);
      }
    } 
    // end of send text

    protocol->sendCommand (END_DATA_PART);
	    //    sockout ("_END_DATAPART_\n");

    if (delete_needed)          // delete XplObject from removeNaN
      delete o;

    }  // for i

  return (NULL);
}
#endif

extern void logt (const char *txt);
extern void logl (long len);

#ifdef _XPLMASK_
#ifdef _XPLCDEF_

XplObject* selectItemJava (Liste<XplObject*> *argl)
{
  long n, i, length = argl->laenge ();
  const char *t;
  long       d;
  XplDouble  *r;
  XplChar    *xc;
  XplObject  *o, *item;

  if (length < 2)      // third arg will be ignored
    {
    globalError.Set (ERR_ARGS, "selectItemJava: Must be 2");
    return (NULL);
    }

  o = (*argl)[0];
  if (o->DefaultType () != C_XPLCHAR)
    {
    globalError.Set (ERR_TEXT, "selectItemJava: first argument");
    return (NULL);
    }

  item = (*argl)[1];
  if (o->DefaultType () != C_XPLCHAR)
    {
    globalError.Set (ERR_TEXT, "selectItemJava: second argument");
    return (NULL);
    }

#ifdef _XPLCDEF_
  t = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
  t = (*argl)[0]->DefaultComponent()->Content().text;
#endif

  xc = item->DefaultComponent()->Content().xplchar;
  n  = xc->rows();

#if defined(SOCKETSERVER) || defined(X4singleserver)
  protocol->sendCommand (SELECT_ITEM);
  protocol->sendStringParameter (t);     // title
  protocol->sendLongParameter (n);

  for (i=0; i<n; i++)
    protocol->sendStringParameter ((*xc)(i).tocstr());

#else
  cout << "_BEGIN_SELECTITEM_\n";
  cout << t << '\n';
  cout << n << '\n';

  for (i=0; i<n; i++)
    cout << (*xc)(i).tocstr() << '\n';
  cout << "_END_SELECTITEM_\n";
#endif
  /*
#if defined(SOCKETSERVER) || defined(X4singleserver)
  n = protocol->getLongParameter();
#else
  cin >> n;
#endif
  */
  r = new XplDouble (n);
#if defined(SOCKETSERVER) || defined(X4singleserver)
  d = protocol->getLongParameter (); // catch length SK 4.10.99
#endif
  for (i=0; i<n; i++)
    {
#if defined(SOCKETSERVER) || defined(X4singleserver)
    d = protocol->getLongParameter ();
#else
    cin >> d;
#endif
    (*r)(i) = d;
    }

  return (new XplObject (r, "selectitem"));
}
#endif

#ifdef _XPLCDEF_
XplObject* readValueJava (Liste<XplObject*> *argl)
{
  long       n, i, length = argl->laenge (),type;
  double     d;
  const char *t;
  char       *s;
  XplDouble  *x, *r;
  XplChar    *xc, *xt, *rt;
  XplObject  *o, *item;

  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "readValueJava: Must be 2");
    return (NULL);
    }

  o = (*argl)[0];
  if (o->DefaultType () != C_XPLCHAR)
    {
    globalError.Set (ERR_TEXT, "readValueJava: first argument");
    return (NULL);
    }

  item = (*argl)[1];

  if ((item->DefaultType () != C_XPLDOUBLE) && (item->DefaultType () != C_XPLCHAR))
    {
    globalError.Set (ERR_TYPE, "readValueJava: second argument");
    return (NULL);
    }

  if (item->DefaultType () == C_XPLDOUBLE)
    {
    x = item->DefaultXplDouble ();
    type = 1;
    }
  else
    {
    xt = item->DefaultComponent()->Content().xplchar; 
    type = 2;
    }
 
  rt = (*argl)[0]->DefaultComponent()->Content().xplchar; // TK+SK 29.01.99 )(0).tocstr();
  xc = o->DefaultComponent()->Content().xplchar;
  n  = xc->dimension(0);

#if defined(SOCKETSERVER) || defined(X4singleserver)
  logt ("Command: READ_VALUE");
  protocol->sendCommand (READ_VALUE);
  logt ("readvlaue: title");
  protocol->sendStringParameter ((*rt)(0).tocstr());       // title
  logt ("readvalue: number of values");
  protocol->sendLongParameter (n);         // number of values
  logt ("readvalue: type");
  protocol->sendLongParameter (type);      // 1 numeric, 2 text  

  for (i=0; i<n; i++) {
    logt ("readvalue: name");
    protocol->sendStringParameter ((*rt)(i).tocstr());       // name
    if (type == 1) {
      logt ("readvalue: double param");
      protocol->sendDoubleParameter ((*x)(i));
    }
    else {
      logt ("readvalue: text param");
      protocol->sendStringParameter ((*xt)(i).tocstr ());
    }
  }
#else
  cout << "_BEGIN_READVALUE_\n";
  cout << t << '\n';
  cout << n << '\n';

  for (i=0; i<n; i++)  
    {
    cout << (*xc)(i).tocstr() << '\n';
    cout << (*x)(i) << '\n';
    }
  cout << "_END_READVALUE_\n";
#endif

  if (type == 1)
    r = new XplDouble (n);
  else
    rt = new XplChar(n);

  for (i=0; i<n; i++) {
#if defined(SOCKETSERVER) || defined(X4singleserver)
    if (type == 1) {
      logt ("readvalue: get double param");
      d = protocol->getDoubleParameter ();
    }
    else {
      logt ("readvalue: get text param");
      s = protocol->getStringParameter ();
    }
#else
    cin >> d;
#endif

    if (type == 1)
      (*r)(i) = d;
    // tk+sws 150498 die "\n" am Ende stoeren bei der auswertung in X4
    else
      {
      int sl = strlen(s);
      if (sl>0 && s[sl-1]=='\n')
	s[sl-1] = '\0';
#ifdef WIN32
      XplChar rt_help(1);
      (*rt)(i) = rt_help(0) = xplstring (s);
#else
      (*rt)(i) = xplstring (s);
#endif
//      cout << s << "ends" << endl;
      }
    // tk-sws 150498 end
    }

  logt ("readvalue: return object");
  if (type == 1)
    return (new XplObject (r, "readvalue"));
  else
    return (new XplObject (rt, "readvalue"));

  return NULL;
}



void BeginXploReCommand (char *cmd)
{
#if defined(SOCKETSERVER) || defined(X4singleserver)
  protocol->sendCommand (BEGINXPLCMD);
  protocol->sendStringParameter (cmd);       
#endif
}

void EndXploReCommand ()
{ 
#if defined(SOCKETSERVER) || defined(X4singleserver)
  protocol->sendCommand (ENDXPLCMD);
#endif
 }

void SendNumericMatrix (char *name, XplDouble *x)
{ double *ptr; float *fptr;
  long i, size = 1;

#if defined(SOCKETSERVER) || defined(X4singleserver)

  protocol->sendCommand (BEGINNUMARRAY);
  protocol->sendStringParameter ((name==NULL) ? "(null)" : name);
  
  if (x==NULL) {
    protocol->sendLongParameter (MAX_XARRAY);
    for (i=0; i<MAX_XARRAY; i++) {
      protocol->sendLongParameter (0);
    }
  }
  else {
    protocol->sendLongParameter (MAX_XARRAY);
    for (i=0; i<MAX_XARRAY; i++) {
      size *= x->dimension(i);
      protocol->sendLongParameter (x->dimension(i));
    }
    ptr = x->getptr();
    fptr = new float[size];
    for (i=0; i<size; i++)
      fptr[i] = ptr[i];
    protocol->sendFloat (fptr, size);
    delete[] fptr;
  }
  
  protocol->sendCommand (ENDNUMARRAY);
#endif
}

XplDouble *GetNumericMatrix () { 
  XplDouble  *x = NULL;
  XplIndex ind;
  float *fptr;
  long *maxxarray, *size, gsize = 1, i, n;
#if defined(SOCKETSERVER) || defined(X4singleserver)
  
  maxxarray = protocol->getLong(1);
  n = maxxarray[0];
  size = protocol->getLong(n);
  for (i=0; i<n; i++) {
    ind.setdim(i, size[i]);
    gsize *= size[i];
  }
  
  fptr = protocol->getFloat(gsize);
  
  x = new XplDouble(gsize);
  for (i=0; i<gsize; i++)
    (*x)[i] = (double) fptr[i];
  
  delete[] fptr;
  
  x->setdim(ind);
  
  delete[] size;
  delete[] maxxarray;
#endif
  
  return x;
}

void SendTextMatrix (char *name, XplChar *x) {
  xplstring *ptr; 
  long i, size = 1;
  const char *elem;
#if defined(SOCKETSERVER) || defined(X4singleserver)
  
  protocol->sendCommand (BEGINTXTARRAY);
  protocol->sendStringParameter ((name==NULL) ? "(null)" : name);
  
  if (x==NULL) {
    protocol->sendLongParameter (MAX_XARRAY);
    for (i=0; i<MAX_XARRAY; i++) {
      protocol->sendLongParameter (0);
    }
  }
  else {
    protocol->sendLongParameter (MAX_XARRAY);
    for (i=0; i<MAX_XARRAY; i++) {
      size *= x->dimension(i);
      protocol->sendLongParameter (x->dimension(i));
    }
    ptr = x->getptr();
    for (i=0; i<size; i++) {
      elem = ptr[i].tocstr();
      if (strlen(elem)==0)
	protocol->sendStringParameter (" ");
      else
	protocol->sendStringParameter (ptr[i].tocstr());
    }
  }
  
  protocol->sendCommand (ENDTXTARRAY);
#endif
}

XplObject* slideValueJava (Liste<XplObject*> *argl) {
  long       i, length = argl->laenge ();
  XplDouble  *x;
  XplChar    *rt;
  XplObject  *o = NULL;
#if defined(SOCKETSERVER) || defined(X4singleserver)
  
  if (length != 4) {
    globalError.Set (ERR_ARGS, "slidevalue: Must be 4 arguments");
    return (NULL);
  }
  
  o = (*argl)[0];
  if (o->DefaultType () != C_XPLCHAR) {
    globalError.Set (ERR_TEXT, "slidevalue: first argument must be text");
    return (NULL);
  }
  
  for (i=1; i<length; i++) {
    o = (*argl)[i];
    if ((o->DefaultType () != C_XPLDOUBLE)) {
      globalError.Set (ERR_TYPE, "slidevalue: second, third and fourth argument must be numeric");
      return (NULL);
    }
  }
  
  BeginXploReCommand ("slidevalue");
  rt = (*argl)[0]->DefaultComponent()->Content().xplchar; // TK+SK 29.01.99 )(0).tocstr();
  SendTextMatrix ("valuesnames", rt);
  
  x  = (*argl)[1]->DefaultXplDouble();
  SendNumericMatrix ("defaults", x);
  
  x  = (*argl)[1]->DefaultXplDouble();
  SendNumericMatrix ("minima", x);
  
  x  = (*argl)[1]->DefaultXplDouble();
  SendNumericMatrix ("maxima", x);
  
  x  = GetNumericMatrix ();
  
  EndXploReCommand ();
#endif  
  return (new XplObject (x, "slidevalue"));
}

void SendStyles (int n, XplDouble *style, XplDouble *size, XplDouble *color) {
  long i, j, p, *mvec, ms, no;
  int r, g, b, a, s;

  // a s r g b oder 255 repeater
#if defined(SOCKETSERVER) || defined(X4singleserver)
 
  r = 0; g = 0; b = 0; a = 3; s = 8;
  mvec = new long[n+1];
  for (i=0, j=0; i<n; i++) {
    if (color !=NULL) { 
      r = (int) (*color)(j,0);
      g = (int) (*color)(j,1);
      b = (int) (*color)(j,2);
    }
    if (style !=NULL) a = (int) (*style)(j);
    if (size !=NULL) s = (int) (*size)(j);
    ms = a << 28 | s << 24 | r << 16 | g << 8 | b;
    if (i==0) {
      mvec[0] = ms;
      no = 1;
    }
    else if (mvec[j]==ms) {
      no++;
    }   
    else {
      if (no==1) {
        mvec[++j] = ms;
      }
      else {
	mvec[++j] = 0xff << 24 | no;
	mvec[++j] = ms;
        no = 1;
      }
    } 
  }
  if (no>1) { mvec[++j] = 0xff << 24 | no; }

  protocol->sendLong (mvec, j+1);

  delete[] mvec;
#endif
}

void SendDataPart (XplDouble *data, XplDouble *pstyle, XplDouble *psize, XplDouble *pcolor, 
                   XplDouble *lines, XplDouble *lcolor, XplDouble *lstyle, XplDouble *lsize, 
                   XplChar *ptext, XplDouble *tcolor, XplDouble *tdir, XplDouble *tsize) {
#if defined(SOCKETSERVER) || defined(X4singleserver)
  
  if (data==NULL) return;

  SendNumericMatrix("data", data);
  SendStyles (data->dimension(0), pstyle, psize, pcolor);
  
  if (lines) {
    SendNumericMatrix("lines", lines);
    SendStyles (lines->dimension(0), lstyle, lsize, lcolor);
  }

  if (ptext) {
    SendTextMatrix("ptext", ptext);
    SendStyles (ptext->dimension(0), tdir, tsize, tcolor);
  }
  
#endif
}

void SendGraphicData (char *name, Liste<XplObject*> *argl) {
  char errmsg[80], dataname[16];
  
  long i, j, dispId, length = argl->laenge (), numbOfDim;
  XplDouble *data, *pstyle, *pcolor, *psize, *lstyle, *lcolor, *lsize, *lines, 
    *tcolor, *tdir, *tsize, *x, *r, *c;
  XplChar *ptext; 
  XplObject *o, *oo;
  Component *comp;
#if defined(SOCKETSERVER) || defined(X4singleserver)
  
  if (length < 4) {
    sprintf (errmsg, "%s: Must be at least 4 arguments", name);
    globalError.Set (ERR_ARGS, errmsg);
    return;
  }
  
  x = (*argl)[0]->DefaultXplDouble ();
  if (x == NULL) {
    sprintf (errmsg, "%s: first argument must be display", name);
    globalError.Set (ERR_NUM, errmsg);
    return;
  }
  dispId = (long) (*x)(0);

  r = (*argl)[1]->DefaultXplDouble ();
  if (r == NULL) {
    sprintf (errmsg, "%s: second argument must be numeric", name);
    globalError.Set (ERR_NUM, errmsg);
    return;
  }
  if (((*r)(0) < 1) || ((*r)(0) > (*x)(1))) {
    sprintf (errmsg, "%s: number of row invalid", name);
    globalError.Set (ERR_NUM, errmsg);
    return;
  }

  c = (*argl)[2]->DefaultXplDouble ();
  if (c == NULL) {
    sprintf (errmsg, "%s: third argument must be numeric", name);
    globalError.Set (ERR_NUM, errmsg);
    return;
  }
  if (((*c)(0) < 1) || ((*c)(0) > (*x)(2))) {
    sprintf (errmsg, "%s: number of col invalid", name);
    globalError.Set (ERR_NUM, errmsg);
    return;
  }

  BeginXploReCommand (name);
  protocol->sendDisplayData (dispId, (*argl)[0]->Name (), (long) (*r)(0), (long) (*c)(0), length-3L, numbOfDim);

  for (i=3, j=1; i<length; i++) {
    sprintf (dataname, "data%i", j);
    protocol->sendCommand (DATA_PART);
    o = (*argl)[i];
    if (o->Type()==O_COMPOSED) { // list
      // grab all components
      oo = RemoveNaN (o);
      comp   = oo->GetComponent ("data");
      data   = (comp==NULL ? NULL : comp->Content().xplobject->DefaultXplDouble ());
      comp   = oo->GetComponent ("pstyle");
      pstyle = (comp==NULL ? NULL : comp->Content().xplobject->DefaultXplDouble ());
      comp   = oo->GetComponent ("psize");
      psize  = (comp==NULL ? NULL : comp->Content().xplobject->DefaultXplDouble ());
      comp   = oo->GetComponent ("pcolor");
      pcolor = (comp==NULL ? NULL : comp->Content().xplobject->DefaultXplDouble ());
      comp   = oo->GetComponent ("lines");
      lines  = (comp==NULL ? NULL : comp->Content().xplobject->DefaultXplDouble ());
      comp   = oo->GetComponent ("lcolor");
      lcolor = (comp==NULL ? NULL : comp->Content().xplobject->DefaultXplDouble ());
      comp   = oo->GetComponent ("lstyle");
      lstyle = (comp==NULL ? NULL : comp->Content().xplobject->DefaultXplDouble ());
      comp   = oo->GetComponent ("lsize");
      lsize  = (comp==NULL ? NULL : comp->Content().xplobject->DefaultXplDouble ());
      comp   = oo->GetComponent ("ptext");
      ptext  = (comp==NULL ? NULL : comp->Content().xplobject->DefaultComponent()->Content().xplchar);
      comp   = oo->GetComponent ("tcolor");
      tcolor = (comp==NULL ? NULL : comp->Content().xplobject->DefaultXplDouble ());
      comp   = oo->GetComponent ("tdirection");
      tdir   = (comp==NULL ? NULL : comp->Content().xplobject->DefaultXplDouble ());
      comp   = oo->GetComponent ("tsize");
      tsize  = (comp==NULL ? NULL : comp->Content().xplobject->DefaultXplDouble ());
      SendDataPart (data, pstyle, psize, pcolor, lines, lcolor, lstyle, lsize, ptext, tcolor, tdir, tsize);
    }
    else {
      if ((*argl)[i]->DefaultType () == C_XPLCHAR) {
	SendTextMatrix (dataname, o->DefaultComponent()->Content().xplchar);
	j++;
      }
      else if ((*argl)[i]->DefaultType () == C_XPLDOUBLE) {
	oo = RemoveNaN (o);
	SendDataPart (oo->DefaultXplDouble(), NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	j++;
      }
    }
    protocol->sendCommand (END_DATA_PART);
  }
  EndXploReCommand();
#endif
}

XplObject* addDataJava (Liste<XplObject*> *argl) 
{ SendGraphicData ("adddata", argl); 
  return (NULL);
}
#endif

void performSendData2Client (const char *oname)
{
  char       a[TEXTLENGTH], *fname = xtmpnam ();
  XplObject  *o;

  FILE *fout;

  o = GetXplObject (globObjList, oname);

  //  cerr << "pSD " << oname << endl;

  if (o == NULL || o->DefaultType () != C_XPLDOUBLE)
    {
//    globalError.Set (ERR_INTERN, "sendDataJava: Data type not supported");
#if defined(SOCKETSERVER) || defined(X4singleserver)
      //    sockout ("_END_DATA_\n");
    protocol->sendStringParameter ("\n_END_DATA_\n");
#else
    cout << "_END_DATA_\n";
#endif
    return;
    }

  o->DefaultXplDouble()->WriteASCIIXplArray (fname);

  //  cerr << "written " << oname << endl;

  fout = fopen (fname, "r");

#ifdef _XPLCDEF_             // opendatafile is implemented  
  fout = opendatafile (fname, "r");                          
#else                                                        
  fout = fopen (fname, "r");                                 
#endif                                                       

  while (TRUE)
    {
    fgets (a, 1024, fout);
    if (feof (fout))
      break;
#if defined(SOCKETSERVER) || defined(X4singleserver)
    //    sockout (a);
    protocol->collectString (a);
#else
    cout << a;
#endif
    }

  fclose (fout);
  remove (fname);

#if defined(SOCKETSERVER) || defined(X4singleserver)
  //  sockout ("\n_END_DATA_\n");
  // protocol->collectString ("\n_END_DATA_\n");
  protocol->sendCollectedString ();
#else
  cout << "\n_END_DATA_\n";
#endif
}

void performSendDouble2Client (const char *oname) { // SK 15.10.01
  XplObject  *o; double *ptr; float *fptr;
  long i, size = 1;
  XplDouble *x;

#if defined(SOCKETSERVER) || defined(X4singleserver)
  o = GetXplObject (globObjList, oname);
  //  cerr << "pSD " << oname << endl;
  if (o == NULL || o->DefaultType () != C_XPLDOUBLE) {
    protocol->sendLongParameter (MAX_XARRAY);
    for (i=0; i<MAX_XARRAY; i++) {
      protocol->sendLongParameter (0);
    }
  }
  else {
    x = o->DefaultXplDouble();
    protocol->sendLongParameter (MAX_XARRAY);
    for (i=0; i<MAX_XARRAY; i++) {
      size *= x->dimension(i);
      protocol->sendLongParameter (x->dimension(i));
    }
    ptr = x->getptr();
    fptr = new float[size];
    for (i=0; i<size; i++)
      fptr[i] = ptr[i];
    protocol->sendFloat (fptr, size);
    delete[] fptr;
  }
}

// client puts data
void performGetDataFromClient  (const char *oname)
{
  char       *fname = xtmpnam ();
  XplDouble  *x = new XplDouble (1);
  XplObject  *o;

  FILE *fin, *fout;

  //logt(fname);
#ifdef _XPLCDEF_             // opendatafile is implemented  
  fout = opendatafile (fname, "w");                          
#else                                                        
  fout = fopen (fname, "w");                                 
#endif                                                       

    //logt("try to read matrix data");
    char *res = protocol->getStringParameter ();
    //logt(res);
    // printf ("performGetDataFromClient: %s %p %s\n", fname, fout, res);
    fputs (res, fout);
    fputc ('\n', fout);
    
    delete[] res;
    /*
  while (TRUE)
    {
#ifdef SOCKETSERVER
    readLineFromSocket (a, 1024);
#else
    cin >> a;
#endif
    for (int j=0; j<strlen(a); j++)
      if (a[j] == '\r' || a[j] == '\n')
   	 {
        a[j] = '\0';
   	 break;
   	 }
    if (strncmp (a, "_END_DATA_", strlen ("_END_DATA_")) == 0)
      break;
    fputs (a, fout);
    fputc ('\n', fout);
    } 
    */

  fclose (fout);

  x->ReadASCIIXplArray (fname);

#ifdef _XPLCDEF_             // opendatafile is implemented   
  remove (fname);            // remove temporary file         
#endif                                                        

  o = GetXplObject (objList, oname);

  if (o == NULL)
    objList->haengeAn (new XplObject (x, oname));
  else
    {
    o->DeleteComponents ();       // replace content of o by x
    o->AppendComponent (new Component (x));
    }
#endif
  return;
}

void performGetDoubleFromClient  (const char *oname)
{
  XplDouble  *x;
  XplObject  *o;
  XplIndex ind;
  float *fptr;
  long *maxxarray, *size, gsize = 1, i, n;
#if defined(SOCKETSERVER) || defined(X4singleserver)

  maxxarray = protocol->getLong(1);
  n = maxxarray[0];
  logt ("MaxXarray");
  logl (n);
  size = protocol->getLong(n);
  for (i=0; i<n; i++) {
    logt ("Size[i]");
    logl (size[i]);
    logt ("Gsize");
    logl (gsize);
    ind.setdim(i, size[i]);
    gsize *= size[i];
  }

  logt ("Floatlenght");
  logl ((long) gsize);
  fptr = protocol->getFloat(gsize);

  x = new XplDouble(gsize);
  for (i=0; i<gsize; i++)
    (*x)[i] = (double) fptr[i];

  delete[] fptr;
  x->setdim(ind);

  if (*maxxarray==MAX_XARRAY) {
    o = GetXplObject (objList, oname);

    if (o == NULL)
      objList->haengeAn (new XplObject (x, oname));
    else {
      o->DeleteComponents ();       // replace content of o by x
      o->AppendComponent (new Component (x));
    }
    protocol->sendCommand (SUCCESS);
  }
  else
    protocol->sendCommand (FAIL);
  delete[] size;
  delete[] maxxarray;
#endif
  return;
}

#include "setgopt.h"

#if defined(SOCKETSERVER) || defined(X4singleserver)
int SearchForOption(const char * opt)
{	int i;
	for (i=0; i<OPTNUM; i++)
		if (! strcmp(options[i], opt))
			return(i);
	return(-1);
}
#endif
void logc (long cmd);

XplObject* AxesOnJava(Liste<XplObject*> *argl)
{ long size[2];
  int errno_;
  XplDouble *r, *c;
#if defined(SOCKETSERVER) || defined(X4singleserver)

  if (argl->laenge()!=0)
  { globalError.Set (ERR_INTERN, "axeson: no parameters required");
    return(NULL);
  }

  protocol->sendCommand (AXESON);
#endif
  return(NULL);
}

XplObject* AxesOffJava(Liste<XplObject*> *argl)
{ long size[2];
  int errno_;
  XplDouble *r, *c;
#if defined(SOCKETSERVER) || defined(X4singleserver)

  if (argl->laenge()!=0)
  { globalError.Set (ERR_INTERN, "axesoff: no parameters required");
    return(NULL);
  }

  protocol->sendCommand (AXESOFF);
#endif
  return(NULL);
}

XplObject* SetSizeJava(Liste<XplObject*> *argl)
{ long size[2];
  int errno_;
  XplDouble *r, *c;

  // logt ("in setsize");
#if defined(SOCKETSERVER) || defined(X4singleserver)

  if (argl->laenge()!=2)
  { globalError.Set (ERR_INTERN, "setsize: need 2 parameter");
    return(NULL);
  }

  r = (*argl)[0]->DefaultXplDouble ();
  if (r == NULL)
  { globalError.Set (ERR_NUM, "setsize: first argument");
    return (NULL);
  }

  c = (*argl)[1]->DefaultXplDouble ();
  if (c == NULL)
  { globalError.Set (ERR_NUM, "setsize: second argument");
    return (NULL);
  }

  errno_ = 0;
  //  logc (SETSIZE);
  protocol->sendCommand (SETSIZE);
  size[0] = (long int) (*r)(0);
  size[1] = (long int) (*c)(0);

  if (size[0]<50) size[0] = 50;
  if (size[1]<50) size[1] = 50;
  //  protocol->sendCommand (SET_DISPLAYSIZE);
  protocol->sendLong (size, 2);
  // logt ("end of SetSizejava");

error:
  //  protocol->sendCommand (END_OF_SETGOPT);
  // if (errno_) globalError.Set (ERR_INTERN, errmsg);
#endif
  return(NULL);
}


XplObject* SetGrOptionsJava(Liste<XplObject*> *argl)
{  
  XplDouble *x, *r, *c, *xpld;
  long dispId;
  int i, found, errno_;
  long size[2];
  char *tosi, *head_line;
  XplChar *xplc, *xplcc;
  char errmsg[256];
#if defined(SOCKETSERVER) || defined(X4singleserver)

  if (argl->laenge()<4)
  {  globalError.Set (ERR_INTERN, "setgopt: need at least 4 parameter");
    return(NULL);
  }

  x = (*argl)[0]->DefaultXplDouble ();
  if (x == NULL)
  { globalError.Set (ERR_NUM, "setgopt: first argument");
    return (NULL);
  }
  dispId = (long) (*x)(0);

  r = (*argl)[1]->DefaultXplDouble ();
  if (r == NULL)
  { globalError.Set (ERR_NUM, "setgopt: second argument");
    return (NULL);
  }

  c = (*argl)[2]->DefaultXplDouble ();
  if (c == NULL)
  { globalError.Set (ERR_NUM, "setgopt: third argument");
    return (NULL);
  }

  if (((*r)(0) < 1) || ((*r)(0) > (*x)(1)))
  { globalError.Set (ERR_NUM, "setgopt: number of row invalid");
    return (NULL);
  }
  if (((*c)(0) < 1) || ((*c)(0) > (*x)(2)))
  { globalError.Set (ERR_NUM, "setgopt: number of col invalid");
    return (NULL);
  }

  errno_ = 0;
  protocol->sendCommand (SETGOPT);
  protocol->sendPlotData (dispId, (long) (*r)(0), (long) (*c)(0));

  if (argl->laenge()==4) // setgopt(d,x,y,gropt)
  {
/*
    p=PlotRequested(argl);
    if (p==NULL)
    { globalError.Set (ERR_INTERN, "setgopt: no plot found!");
      return(NULL);
    }
#ifdef _BLABLA_
    cout<<(*argl)[3]->ComponentNumber()<<endl;
#endif
    for (i=1; i<(*argl)[3]->ComponentNumber(); i++)
    {  comp = (* ((*argl)[3]) )[i];
      if (comp==NULL)
      {  globalError.Set (ERR_INTERN, "setgopt: error!");
        return(NULL);
      }
#ifdef _BLABLA_
      cout<<comp->Name()<<endl;
#endif
      compname=comp->Name();
      found=SearchForOption(compname);
      if (found==-1)
      {  globalError.Set (ERR_INTERN, "setgopt: error!");
        return(NULL);
      }
      if (comp->Content().xplobject->Type()!=opt_type[found])
      {  globalError.Set (ERR_INTERN, "setgopt: error! Wrong type");
        return(NULL);
      }

    }
    for (i=1; i<(*argl)[3]->ComponentNumber(); i++)
    {  comp = (* ((*argl)[3]) )[i];
      compname=comp->Name();

      found=SearchForOption(compname);
      switch(found)
      {  case TITLE_NUM:
        xplcc=comp->Content().xplobject->
          DefaultComponent()->Content().xplchar;
        if ((*xplcc)(0).xplstrlen()==0)
      {  globalError.Set (ERR_INTERN, "setgopt: a bad string for title!");
          return(NULL);
      }
        head_line=(*xplcc)(0).tostr();
        p->SetHeadline(head_line);
        delete head_line;
        p->head_on=(1==1);
        break;

        case XLIM_NUM: case YLIM_NUM:
        xpld=comp->Content().xplobject->
          DefaultComponent()->Content().xpldouble;
        if (xpld->dimension(0)!=2)
      {  globalWarning.Set (ERR_INTERN, "setgopt: a bad value for xlim or ylim!");  
        xpld->mdump("%f");
        break;
      }        
        axismin= (*xpld)(0);
        axismax= (*xpld)(1);
        if (! (axismin<axismax))
      {  globalError.Set (ERR_INTERN, "setgopt: a bad value for xlim or ylim!");
        cout<<"(! (axismin<axismax))"<<endl;
        xpld->mdump("%f");
        return(NULL);
      }  
        if (found== XLIM_NUM )
          ach=new Achse(p->GetAchse(1));
        else
          ach=new Achse(p->GetAchse(2));    
        ach->SetPosition(axismin, axismax);
        p->SetAchse(*ach);
        delete ach;

        break;
            
        case XORIGIN_NUM: case YORIGIN_NUM:
        xpld=comp->Content().xplobject->
          DefaultComponent()->Content().xpldouble;
        if (xpld->dimension(0)!=1)
      {  globalError.Set (ERR_INTERN, "setgopt: a bad value for xorigin or yorigin!");
        return(NULL);
      }
          if (found==XORIGIN_NUM)
          ach = new Achse(p->GetAchse(1));
        else
          ach = new Achse(p->GetAchse(2));

        ach->SetTicks((*xpld)(0), -1);
        p->SetAchse(*ach);
        delete ach;
        break;
          
        case XMAJOR_NUM:case YMAJOR_NUM:  
        xpld=comp->Content().xplobject->
          DefaultComponent()->Content().xpldouble;
        if (xpld->dimension(0)!=1)
      {  globalError.Set (ERR_INTERN, "setgopt: a bad value for xmajor or ymajor!");
        return(NULL);
      }
          if (found==XMAJOR_NUM)
          ach = new Achse(p->GetAchse(1));
        else
          ach = new Achse(p->GetAchse(2));

        ach->SetTicks(0,  
         (*xpld)(0));
        p->SetAchse(*ach);
        delete ach;
        break;

        case XLABEL_NUM: case YLABEL_NUM:
        xplcc=comp->Content().xplobject->
          DefaultComponent()->Content().xplchar;
        tosi=(*xplcc)(0).tostr();   
        if (strlen(tosi)==0)
      {  globalError.Set (ERR_INTERN, "setgopt: a bad string for label!");
        return(NULL);
      }        
        if (found==XLABEL_NUM)
          ach = new Achse(p->GetAchse(1));
        else
          ach = new Achse(p->GetAchse(2));

        ach->SetString(tosi);
        delete tosi;
        p->SetAchse(*ach);
        delete ach;
        break;
      
        case XVALUE_NUM: case YVALUE_NUM:
        xpld=comp->Content().xplobject->
          DefaultComponent()->Content().xpldouble;
        if (xpld->dimension(0)!=2)
      {  globalError.Set (ERR_INTERN, "setgopt: a bad value for xtrans or ytrans!");
        return(NULL);
      }
        if (found==XVALUE_NUM)
          ach = new Achse(p->GetAchse(1));
        else
          ach = new Achse(p->GetAchse(2));

        ach->SetValues((*xpld)(0), (*xpld)(1));
        p->SetAchse(*ach);
        delete ach;
        break;
      
        case ROTPOINT_NUM:  //rotpoint
        xpld=comp->Content().xplobject->
          DefaultComponent()->Content().xpldouble;
        xplm=XplDouble2XplMatrix(*xpld);
        p->SetTransformation(&xplm, 
          NULL, NULL, NULL, NULL);
        break;
      
         case ROTCOS_NUM:  
         xpld=comp->Content().xplobject->
           DefaultComponent()->Content().xpldouble;
        xplm=XplDouble2XplMatrix(*xpld);
        p->SetTransformation(NULL, NULL,
        &xplm, NULL, NULL);
        break;
        
      
        case SCAL_NUM:  
        xpld=comp->Content().xplobject->
          DefaultComponent()->Content().xpldouble;
        xplm=XplDouble2XplMatrix(*xpld);
        p->SetTransformation(NULL, NULL, NULL,
        &xplm, NULL);
        break;
        
        case FSCAL_NUM:  
        xpld=comp->Content().xplobject->
          DefaultComponent()->Content().xpldouble;
        xplm=XplDouble2XplMatrix(*xpld);
        p->SetTransformation(NULL,  
        &xplm, NULL, NULL, NULL);
        break;
        
      
        case TRANS_NUM:  
        xpld=comp->Content().xplobject->
          DefaultComponent()->Content().xpldouble;
        xplm=XplDouble2XplMatrix(*xpld);
        p->SetTransformation(NULL, NULL, NULL, NULL,
          &xplm);
        break;  
        
        case XOFFSET_NUM: case YOFFSET_NUM:
        xpld=comp->Content().xplobject->
          DefaultComponent()->Content().xpldouble;
        if (xpld->dimension(0)!=2)
      {  globalError.Set (ERR_INTERN, "setgopt: a bad value for xoffset");
        return(NULL);
      }        
        if ((*xpld)(0)<0 || (*xpld)(0)>100 ||
          (*xpld)(1)>100 || (*xpld)(1)<0
          || (*xpld)(0)+(*xpld)(1)>100)
      {  globalError.Set (ERR_INTERN, "setgopt: a bad value for xoffset or yoffset!");
        return(NULL);
      }  
        if (found==XOFFSET_NUM)
          p->SetHOffset((int)((*xpld)(0)+0.5), 
            (int)((*xpld)(1)+0.5));  
        else
          p->SetVOffset((int)((*xpld)(0)+0.5), 
            (int)((*xpld)(1)+0.5));  
        p->offset_equal=false;
        break;
        
        case BRUSHSIZE_NUM:
        xpld=comp->Content().xplobject->
          DefaultComponent()->Content().xpldouble;
        int dim=xpld->dimension(0);
        if (  dim!=2 && dim!=4)
      {  globalError.Set (ERR_INTERN, 
        "setgopt: a bad value for brushsize");
        return(NULL);
      }  
        int ddd;
        for (ddd=0; ddd<dim; ddd++)
          if ((*xpld)(ddd)<0 || (*xpld)(ddd)>100) 
      {  globalError.Set (ERR_INTERN, 
        "setgopt: a bad value for brushsize");
        return(NULL);
      }        
        switch(dim)
        {  case 2:
          p->brush_size[0]=(int)(*xpld)(0);
          p->brush_size[2]=(int)(*xpld)(0);
          p->brush_size[1]=(int)(*xpld)(1);
          p->brush_size[3]=(int)(*xpld)(1);
          break;
          case 4:
          p->brush_size[2]=(int)(*xpld)(0);
          p->brush_size[0]=(int)(*xpld)(2);
          p->brush_size[1]=(int)(*xpld)(1);
          p->brush_size[3]=(int)(*xpld)(3);
          break;
        }
        break;
      }
    }
    p->Refresh();
    return(NULL);    */
  }
  else  
  { for (i=3; i<argl->laenge(); i+=2)
    { if ((*argl)[i]->Type()!=O_XPLCHAR)
      { sprintf (errmsg, "setgopt: arg %i wrong, key expected", i);
        errno_ = 1;
        goto error;
      }
      xplc=(*argl)[i]->DefaultComponent()->Content().xplchar;
      tosi=(*xplc)(0).tostr();
      found=SearchForOption(tosi);
      sprintf (errmsg, "setgopt: no such option '%s'", tosi);
      delete tosi;
      if (found==-1)
      { errno_ = 1;
        goto error;
      }
      if ((*argl)[i+1]->Type()!=opt_type[found])
      { sprintf (errmsg, "setgopt: wrong type");
        errno_ = 1;
        goto error;
      }
    }
    for (i=0; 3+i<argl->laenge(); i+=2)
    { xplc=(*argl)[3+i]->DefaultComponent()->Content().xplchar;
      tosi=(*xplc)(0).tostr();
      found=SearchForOption(tosi);
      delete tosi;
      switch(found) { 
	/* send one string */
      case TITLE_NUM:   // title
      case XLABEL_NUM:  // xlabel
      case YLABEL_NUM:  // ylabel
	xplcc=(*argl)[4+i]->DefaultComponent()->Content().xplchar;
	if ((*xplcc)(0).xplstrlen()==0) { 
	  sprintf (errmsg, "setgopt: a zero length string as parameter");
	  errno_ = 1;
	  goto error;
	}
	head_line=(*xplcc)(0).tostr();
	protocol->sendCommand (SETGOPT_BASE+found);
	protocol->sendStringParameter (head_line);
	delete head_line;
	break;
	/* send two integers */
      case DISPSIZE_NUM: // dispsize
      case DISPPOS_NUM:  // disppos
	xpld=(*argl)[4+i]->DefaultXplDouble();
	size[0]= (long) (*xpld)(0);
	size[1]= (long) (*xpld)(1);
	if (size[0]<0) size[0] = 0;
	if (size[1]<0) size[1] = 0;
	protocol->sendCommand (SETGOPT_BASE+found);
	protocol->sendLong (size, 2);
	break;
	/* send one boolean */
      case XAXIS_NUM:    // xaxis
      case YAXIS_NUM:    // yaxis
      case ZAXIS_NUM:    // zaxis
      case BORDER_NUM:   // border
	xpld=(*argl)[4+i]->DefaultXplDouble();
	size[0]= (((int) (*xpld)(0)) !=0);
	protocol->sendCommand (SETGOPT_BASE+found);
	protocol->sendLongParameter (size[0]);
	break;
	  /*
        case XLIM_NUM:
        case YLIM_NUM:    //xlim, ylim
          xpld=(*argl)[4+i]->DefaultXplDouble();
          if (xpld->dimension(0)!=2)
          { globalError.Set (ERR_INTERN, "setgopt: a bad value for xlim!");
            return(NULL);
          }
          axismin= (*xpld)(0);
          axismax= (*xpld)(1);
          if (! (axismin<axismax))
          { globalError.Set (ERR_INTERN, "setgopt: a bad value for xlim!");
            return(NULL);
          }
          if (found==XLIM_NUM)
            ach = new Achse(p->GetAchse(1));
          else
            ach = new Achse(p->GetAchse(2));

          ach->SetPosition(axismin, axismax);
          p->SetAchse(*ach);
          delete ach;
          break;

        case XORIGIN_NUM:
        case YORIGIN_NUM:  //xorigin, yorigin
          if (found==XORIGIN_NUM)
            ach = new Achse(p->GetAchse(1));
          else
            ach = new Achse(p->GetAchse(2));

          xpld=(*argl)[4+i]->DefaultXplDouble();
          ach->SetTicks((*xpld)(0), -1);
          p->SetAchse(*ach);
          delete ach;
          break;

        case XMAJOR_NUM:
        case YMAJOR_NUM:  //xmajor, ymajor
          if (found==XMAJOR_NUM)
            ach = new Achse(p->GetAchse(1));
          else
            ach = new Achse(p->GetAchse(2));

          xpld=(*argl)[4+i]->DefaultXplDouble();
          ach->SetTicks(0,  //origin default...
            (*xpld)(0));
          p->SetAchse(*ach);
          delete ach;
          break;
	  */
	/*
      case XVALUE_NUM:
      case YVALUE_NUM:
        xpld=(*argl)[4+i]->DefaultXplDouble();
        if (xpld->dimension(0)!=2)
        { globalError.Set (ERR_INTERN, "setgopt: a bad value for xtrans or ytrans!");
          return(NULL);
        }
        if (found==XVALUE_NUM)
          ach = new Achse(p->GetAchse(1));
        else
          ach = new Achse(p->GetAchse(2));

        ach->SetValues((*xpld)(0), (*xpld)(1));
        p->SetAchse(*ach);
        delete ach;
        break;

      case ROTPOINT_NUM:  //rotpoint
        xpld=(*argl)[4+i]->DefaultComponent()->
            Content().xpldouble;
        xplm=XplDouble2XplMatrix(*xpld);
        p->SetTransformation(&xplm,
          NULL, NULL, NULL, NULL);
        break;

      case ROTCOS_NUM:  //rotcos
        xpld=(*argl)[4+i]->DefaultComponent()
            ->Content().xpldouble;
        xplm=XplDouble2XplMatrix(*xpld);
        p->SetTransformation(NULL, NULL,
          &xplm, NULL, NULL);
      break;

      case FSCAL_NUM:  //first scal
        xpld=(*argl)[4+i]->DefaultComponent()
           ->Content().xpldouble;
        xplm=XplDouble2XplMatrix(*xpld);
        p->SetTransformation(NULL,
          &xplm, NULL, NULL, NULL);
        break;

      case SCAL_NUM:  //scal
        xpld=(*argl)[4+i]->DefaultComponent()
            ->Content().xpldouble;
        xplm=XplDouble2XplMatrix(*xpld);
        p->SetTransformation(NULL, NULL, NULL,
          &xplm, NULL);
        break;

      case TRANS_NUM:  //transl
        xpld=(*argl)[4+i]->DefaultComponent()
            ->Content().xpldouble;
        xplm=XplDouble2XplMatrix(*xpld);
        p->SetTransformation(NULL, NULL, NULL, NULL,
            &xplm);
        break;

      case XOFFSET_NUM:
      case YOFFSET_NUM:
        xpld=(*argl)[4+i]->
          DefaultComponent()->Content().xpldouble;
        if (xpld->dimension(0)!=2)
        { globalError.Set (ERR_INTERN, "setgopt: a bad value for xoffset");
          return(NULL);
        }
        if ((*xpld)(0)<0 || (*xpld)(0)>100 ||
          (*xpld)(1)>100 || (*xpld)(1)<0
          || (*xpld)(0)+(*xpld)(1)>100)
        {  globalError.Set (ERR_INTERN, "setgopt: a bad value for xoffset or yoffset!");
          return(NULL);
        }
        if (found==XOFFSET_NUM)
          p->SetHOffset((int)((*xpld)(0)+0.5),
            (int)((*xpld)(1)+0.5));
        else
          p->SetVOffset((int)((*xpld)(0)+0.5),
            (int)((*xpld)(1)+0.5));
        p->offset_equal=false;
        break;

      case BRUSHSIZE_NUM:
        xpld=(*argl)[4+i]->
          DefaultComponent()->Content().xpldouble;
        int dim=xpld->dimension(0);
        if (  dim!=2 && dim!=4)
        { globalError.Set (ERR_INTERN, "setgopt: a bad value for brushsize");
          return(NULL);
        }
        int ddd;
        for (ddd=0; ddd<dim; ddd++)
          if ((*xpld)(ddd)<0 || (*xpld)(ddd)>100)
          { globalError.Set (ERR_INTERN, "setgopt: a bad value for brushsize");
            return(NULL);
          }
        switch(dim)
        { case 2:
            p->brush_size[0]=(int)(*xpld)(0);
            p->brush_size[2]=(int)(*xpld)(0);
            p->brush_size[1]=(int)(*xpld)(1);
            p->brush_size[3]=(int)(*xpld)(1);
            break;
          case 4:
            p->brush_size[2]=(int)(*xpld)(0);
            p->brush_size[0]=(int)(*xpld)(2);
            p->brush_size[1]=(int)(*xpld)(1);
            p->brush_size[3]=(int)(*xpld)(3);
          break;
        }
        break;
	  */
      }
    }
  }

error:
  protocol->sendCommand (END_OF_SETGOPT);
  if (errno_) globalError.Set (ERR_INTERN, errmsg);
#endif
  return(NULL);
}


#endif     // defined (SOCKETSERVER) || defined (_JAVA_)

//#endif     // _XPLMASK_

#if defined(SOCKETSERVER) || defined(X4singleserver)
// TTK, 23.11.97
XplObject* setMaskpJava  (Liste<XplObject*> *argl) { return (NULL); }
XplObject* setMasklJava  (Liste<XplObject*> *argl) { return (NULL); }
//void performGetDataFromClient (char const *)       {}
//void performSendData2Client   (char const *)       {}
// XplObject* showJava (Liste<XplObject*> *argl)      {}
#endif


#if defined(SOCKETSERVER) || defined(X4singleserver)

void statusmessage (const char *msg)
{ protocol->sendCommand (STATUSMSG);
  protocol->sendStringParameter (msg);
}

#endif


XplObject *xaInfo (Liste<XplObject*> *argl) {
  XplObject *res;
  XplChar   *func, *macro, *obj;  
  const char *tmp;
  int i, j, len;

  if (argl->laenge () != 0) {
    globalError.Set(ERR_ARGS, "info: no arguments required");
    return (NULL);
  }

  res = new XplObject ("info");

  len = objList->laenge()+constList->laenge() ;
  //  printf ("obj len=%i\n", len);
  if (len) {
    obj = new XplChar(len);
     for (j=i=0; i<constList->laenge(); j++,i++) {
      tmp = (*constList)[i]->Name ();
      //  printf ("%i %s\n", i, tmp);
      (*obj)[j] = xplstring(tmp);
    }
    for (i=0; i<objList->laenge(); j++,i++) {
      tmp = (*objList)[i]->Name ();
      //  printf ("%i %s\n", i, tmp);
      (*obj)[j] = xplstring(tmp);
    }
    res->AppendComponent (new Component (new XplObject (obj, "objects")));
  }

  len = funList->laenge();
  // printf ("fun len=%i\n", len);
  if (len) {
    for (i=j=0; j<len; j++) {
      tmp = (*funList)[j]->Name ();
      if (tmp[0]!='#') i++;
    }
    if (i) {
      func = new XplChar(i);
      for (j=i=0; i<funList->laenge(); i++) { 
	tmp = (*funList)[i]->Name ();
	// printf ("%i %s\n", i, tmp);
	if (tmp[0]!='#') (*func)[j++] = xplstring(tmp);
      }
      res->AppendComponent (new Component (new XplObject (func, "functions")));
    }
  }

  len = macList->laenge();
  // printf ("mac len=%i\n", len);
  if (len) {
    for (i=j=0; j<x4ml.len; j++)
      if (x4ml.macroname[j]) i++;
    macro = new XplChar(len+i);
    for (i=0; i<macList->laenge(); i++) { 
      tmp =(*macList)[i]->Name ();
      // printf ("%i %s\n", i, tmp);
      (*macro)[i] = xplstring (tmp);
    }
    len = i;
    for (i=j=0; j<x4ml.len; j++) { 
      if (x4ml.macroname[j]) {
	tmp = x4ml.macroname[j];
        if (tmp) {
	  // printf ("%i %s\n", len+i, tmp);
	  (*macro)[len+i] = xplstring (tmp);
	  i++;
	}
      }
    }
    res->AppendComponent (new Component (new XplObject (macro, "quantlets")));
  }

  return (res);
}



/*

XplObject *xaInfo (Liste<XplObject*> *argl) {
  XplObject *res;
  XplChar   *func, *macro, *obj;  
  const char *tmp;
  int i, j, len;

  if (argl->laenge () != 0) {
    globalError.Set(ERR_ARGS, "info: no arguments required");
    return (NULL);
  }

  res = new XplObject ("info");

  len = objList->laenge();
  //  printf ("obj len=%i\n", len);
  if (len) {
    obj = new XplChar(len);
    for (i=0; i<len; i++) {
      tmp = (*objList)[i]->Name ();
      //  printf ("%i %s\n", i, tmp);
      (*obj)[i] = xplstring(tmp);
    }
    res->AppendComponent (new Component (new XplObject (obj, "objects")));
  }

  len = funList->laenge();
  // printf ("fun len=%i\n", len);
  if (len) {
    for (i=j=0; j<len; j++) {
      tmp = (*funList)[j]->Name ();
      if (tmp[0]!='#') i++;
    }
    if (i) {
      func = new XplChar(i);
      for (j=i=0; i<funList->laenge(); i++) { 
	tmp = (*funList)[i]->Name ();
	// printf ("%i %s\n", i, tmp);
	if (tmp[0]!='#') (*func)[j++] = xplstring(tmp);
      }
      res->AppendComponent (new Component (new XplObject (func, "functions")));
    }
  }

  len = macList->laenge();
  // printf ("mac len=%i\n", len);
  if (len) {
    for (i=j=0; j<x4ml.len; j++)
      if (x4ml.macroname[j]) i++;
    macro = new XplChar(len+i);
    for (i=0; i<macList->laenge(); i++) { 
      tmp =(*macList)[i]->Name ();
      // printf ("%i %s\n", i, tmp);
      (*macro)[i] = xplstring (tmp);
    }
    len = i;
    for (i=j=0; j<x4ml.len; j++) { 
      if (x4ml.macroname[j]) {
	tmp = x4ml.macroname[j];
        if (tmp) {
	  // printf ("%i %s\n", len+i, tmp);
	  (*macro)[len+i] = xplstring (tmp);
	  i++;
	}
      }
    }
    res->AppendComponent (new Component (new XplObject (macro, "quantlets")));
  }

  return (res);
}
*/

