/* $Header: /home/xplore/cvs/xpl4gr/xplfunctions.c,v 1.3 2002/08/16 12:31:59 sigbert Exp $ */

#ifdef _RPCXGOBI_

/***********************************************************************
 * Permission is hereby granted to any individual or institution       *
 * for use, copying, or redistribution of the AV2XGobi C code          *
 * and associated documentation, provided such code and documentation  *
 * are not sold for profit and the following copyright notice is       *
 * retained in the code and documentation:                             *
 *                                                                     *
 *   Copyright (c) 1995 Iowa State University                          *
 *                                                                     *
 * We encourage you to share questions, comments and modifications.    *
 *                                                                     *
 *   Juergen Symanzik (symanzik@iastate.edu)                           *
 *   Dianne Cook (dicook@iastate.edu)                                  *
 *   James J. Majure (majure@iastate.edu)                              *
 *                                                                     *
 * The code in this file is based on the file functions.c              *
 * provided by ESRI.                                                   *
 * It has been modified to provide the functionality required for      *
 * the AV2XGOBI link.                                                  *
 * For completeness, we maintain the original Copyright notice:        *
 *                                                                     *
 ***********************************************************************/

/*
*
*-----------------------------------------------------------------------
*
*HB {Manual} {001011} {IAC}
*
*-----------------------------------------------------------------------
*
*N  Stubs for server functions. 
*
*-----------------------------------------------------------------------
*
*P  Purpose:
*
*   This file contains the stubs for server functions. These functions
*   are invoked from aiserver_svc_proc.c. These functions simply transfer
*   control to a user written function, where they are defined, and return
*   a "Procedure not defined" string otherwise. This is the file to be modified
*   if you want to add your own functions. 
*
*E
*
*-----------------------------------------------------------------------
*
*A  Arguments:
*
*   {{instr,outstr}}
*
*   {instr    <Input>    === (char *) Input string argument, if any}
*   {outstr   <Output>   === (char *) Results of the operation}
*
*E
*
*-----------------------------------------------------------------------
*
*H  History:
*
*    Ravi Narasimhan          [4/27/94]          Original coding.
*E
*HE
*-----------------------------------------------------------------------
*/


#include <string.h>

void Function1 (instr,outstr)
char *instr, *outstr;
{
	RPC_Xpl_Execute (instr,outstr);
}
void Function2 (instr,outstr)
char *instr, *outstr;
{
	RPC_Xpl_Brush_Some (instr,outstr);
}
void Function3 (instr,outstr)
char *instr, *outstr;
{
	RPC_Xpl_Return_Variable (instr,outstr);
}
void Function4 (instr,outstr)
char *instr, *outstr;
{
/*	RPC_Xpl_Return_Dimension (instr,outstr); */
}
void Function5 (instr,outstr)
char *instr, *outstr;
{
	RPC_Xpl_Busy (instr,outstr); 
}
void Function6 (instr,outstr)
char *instr, *outstr;
{
/*	RPC_Xpl_Execute_File (instr,outstr); */
}
void Function7 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 7 not implemented");
}
void Function8 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 8 not implemented");
}
void Function9 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 9 not implemented");
}
void Function10 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 10 not implemented");
}
void Function11 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 11 not implemented");
}
void Function12 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 12 not implemented");
}
void Function13 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 13 not implemented");
}
void Function14 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 14 not implemented");
}
void Function15 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 15 not implemented");
}
void Function16 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 16 not implemented");
}
void Function17 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 17 not implemented");
}
void Function18 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 18 not implemented");
}
void Function19 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 19 not implemented");
}
void Function20 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 20 not implemented");
}
void Function21 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 21 not implemented");
}
void Function22 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 22 not implemented");
}
void Function23 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 23 not implemented");
}
void Function24 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 24 not implemented");
}
void Function25 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 25 not implemented");
}
void Function26 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 26 not implemented");
}
void Function27 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 27 not implemented");
}
void Function28 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 28 not implemented");
}
void Function29 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 29 not implemented");
}
void Function30 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 30 not implemented");
}
void Function31 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 31 not implemented");
}
void Function32 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 32 not implemented");
}
void Function33 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 33 not implemented");
}
void Function34 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 34 not implemented");
}
void Function35 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 35 not implemented");
}
void Function36 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 36 not implemented");
}
void Function37 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 37 not implemented");
}
void Function38 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 38 not implemented");
}
void Function39 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 39 not implemented");
}
void Function40 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 40 not implemented");
}
void Function41 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 41 not implemented");
}
void Function42 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 42 not implemented");
}
void Function43 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 43 not implemented");
}
void Function44 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 44 not implemented");
}
void Function45 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 45 not implemented");
}
void Function46 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 46 not implemented");
}
void Function47 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 47 not implemented");
}
void Function48 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 48 not implemented");
}
void Function49 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 49 not implemented");
}
void Function50 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 50 not implemented");
}
void Function51 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 51 not implemented");
}
void Function52 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 52 not implemented");
}
void Function53 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 53 not implemented");
}
void Function54 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 54 not implemented");
}
void Function55 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 55 not implemented");
}
void Function56 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 56 not implemented");
}
void Function57 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 57 not implemented");
}
void Function58 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 58 not implemented");
}
void Function59 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 59 not implemented");
}
void Function60 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 60 not implemented");
}
void Function61 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 61 not implemented");
}
void Function62 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 62 not implemented");
}
void Function63 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 63 not implemented");
}
void Function64 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 64 not implemented");
}
void Function65 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 65 not implemented");
}
void Function66 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 66 not implemented");
}
void Function67 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 67 not implemented");
}
void Function68 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 68 not implemented");
}
void Function69 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 69 not implemented");
}
void Function70 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 70 not implemented");
}
void Function71 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 71 not implemented");
}
void Function72 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 72 not implemented");
}
void Function73 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 73 not implemented");
}
void Function74 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 74 not implemented");
}
void Function75 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 75 not implemented");
}
void Function76 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 76 not implemented");
}
void Function77 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 77 not implemented");
}
void Function78 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 78 not implemented");
}
void Function79 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 79 not implemented");
}
void Function80 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 80 not implemented");
}
void Function81 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 81 not implemented");
}
void Function82 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 82 not implemented");
}
void Function83 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 83 not implemented");
}
void Function84 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 84 not implemented");
}
void Function85 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 85 not implemented");
}
void Function86 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 86 not implemented");
}
void Function87 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 87 not implemented");
}
void Function88 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 88 not implemented");
}
void Function89 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 89 not implemented");
}
void Function90 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 90 not implemented");
}
void Function91 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 91 not implemented");
}
void Function92 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 92 not implemented");
}
void Function93 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 93 not implemented");
}
void Function94 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 94 not implemented");
}
void Function95 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 95 not implemented");
}
void Function96 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 96 not implemented");
}
void Function97 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 97 not implemented");
}
void Function98 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 98 not implemented");
}
void Function99 (instr,outstr)
char *instr, *outstr;
{
	strcpy (outstr,"XploRe: Procedure 99 not implemented");
}

#endif
