/* $Header: /home/xplore/cvs/xpl4gr/xplio.C,v 1.4 2003/05/23 17:33:45 cizek Exp $ */

//	SWS 25.09 SWS
#ifdef _UNIX_
#include "motif.h"
#endif
#include "xplio.h"

#include "machine.h"

#ifdef HAS_IOSTREAMH
#include <iostream.h>
#else
#include <stream.h>
#endif

#include <string.h>
#include "object.h"
#include "xchar.hpp"
#include <sys/types.h>

#include "xplore_strings.h"

#ifdef _GUIDO_
extern char *gformat;
extern int starttime;
extern char *gfname;
#endif

#ifdef __BORLANDC__
#include "xplwin.h"
#endif


#ifdef _UNIX_

extern "C" 	{

#include <Xm/Text.h>
#include <Xm/MessageB.h>

extern	Widget out_text;
extern Widget error_text; 
extern Widget warning_text; 

int lines_count(char *text)
{	int i, lc, sl;
	lc=i=0;
	sl=strlen(text);
	for (i=0; i< sl; i++)
		if (text[i]=='\n')
			lc++;
	return(lc);
}
	
void motif_message_str(char *text)
{	int pos;

	pos=XmTextGetLastPosition(out_text);	
	XmTextInsert(out_text, pos, text);
//	XmTextScroll(out_text, lines_count(text));
//	XtVaSetValues(out_text, XmNtopCharacter, pos, NULL);
}
void motif_message_double(double d)
{	int pos;
	char text[16];

	sprintf(text, "%g", d);
	pos=XmTextGetLastPosition(out_text);	
	XmTextInsert(out_text, pos, text);
//	XmTextScroll(out_text, lines_count(text));
//	XtVaSetValues(out_text, XmNtopCharacter, pos, NULL);
}
void motif_message_char(char t)
{	int pos;
	char text[16];

	sprintf(text, "%c", t);
	pos=XmTextGetLastPosition(out_text);	
	XmTextInsert(out_text, pos, text);
//	XmTextScroll(out_text, lines_count(text));
//	XtVaSetValues(out_text, XmNtopCharacter, pos, NULL);
}
void motif_message_int(int i)
{	int pos;
	char text[16];

	sprintf(text, "%ld", i);
	pos=XmTextGetLastPosition(out_text);
	XmTextInsert(out_text, pos, text);
//	XmTextScroll(out_text, lines_count(text));
//	XtVaSetValues(out_text, XmNtopCharacter, pos, NULL);
}
void motif_error(const char *str)
{	if (str==NULL)	//SWS 9.3.
	{	cerr<<"Error is invalid"<<endl;
		return;
	}	
	if (strlen(str)==0)
	{	cerr<<"Error is invalid"<<endl;
		return;
	}
	if (error_text==NULL)
	{	cerr<<str<<endl;
		return;
	}
	XmString already;
	char *newstr= new char [strlen(str)+1];	//SWS 10.3.
	
/*	//SWS 10.3.
	if (str[strlen(str)-1]!='\n')
		sprintf(newstr, "%s", str);
	else
		sprintf(newstr, "%s\n", str);
*/
	sprintf(newstr, "%s", str);	//SWS 10.3.

	
	XmString xms=XmStringCreateLtoR(newstr, XmSTRING_DEFAULT_CHARSET);
	
	XtVaGetValues(error_text, XmNmessageString, &already, NULL);
	
	XmString result=XmStringConcat(already, xms);
	
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "ErrorW", "SHOW",
			str);
	fclose(gfile);
#endif	
	XtVaSetValues(error_text, XmNmessageString, result, NULL);
	XtManageChild(error_text);
	XmStringFree(xms);	//OK
	XmStringFree(already);	//SWS 9.3.
	XmStringFree(result);	//SWS 9.3.
	delete newstr;
}

void motif_warning(const char *str)
{	if (strlen(str)==0)
		return;
	XmString already;
	char *newstr= new char [strlen(str)+1];
	
/*	//SWS 10.3.
	if (str[strlen(str)-1]!='\n')
		sprintf(newstr, "%s", str);
	else
		sprintf(newstr, "%s\n", str);
*/
	sprintf(newstr, "%s", str);	//SWS 10.3.

	XmString xms=XmStringCreateLtoR(newstr, XmSTRING_DEFAULT_CHARSET);
	
	XtVaGetValues(warning_text, XmNmessageString, &already, NULL);
	
	XmString result=XmStringConcat(already, xms);
	
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "WarningW", "SHOW",
			str);
	fclose(gfile);
#endif	
	XtVaSetValues(warning_text, XmNmessageString, result, NULL);
	XtManageChild(warning_text);
	XmStringFree(xms);	//OK
	delete newstr;
}	
	}	//end from extern "C"
	

void xplmessage(const char *text)
{
	char *tt=strdup(text);
	motif_message_str(tt);
	delete tt;
}

void xplmessage(char *text)
{	
	motif_message_str(text);
}

void xplmessage(char t)
{	
	motif_message_char(t);
}

void xplmessage(double d)
{	
	motif_message_double(d);
}

void xplmessage(int i)
{	
	motif_message_int(i);
}

void xplmessage(long i)                       // TTK 13.12.94
{	
	motif_message_int((long)i);

}

void ttkmessage(const char *text)
{	//motif_message_str(text);
	char *tt=strdup(text);
	xplmessage(tt);
	delete tt;
}

void ttkmessage(char *text)
{	//motif_message_str(text);
	xplmessage(text);
}	

void ttkmessage(char t)
{	//motif_message_char(t);
	xplmessage(t);
}

void ttkmessage(double d)
{	//motif_message_double(d);
	xplmessage(d);
}

void ttkmessage(int i)
{	//motif_message_int(i);
	xplmessage(i);
}

void ttkmessage(long i)                       // TTK 13.12.94
{	//motif_message_int((long)i);
	xplmessage(i);
}
void ttkerror(char z)
{	cerr<<"Error:"<<z<<endl;
}
void ttkmerror(double z)
{	cerr<<"Error:"<<z<<endl;
}
void ttkerror(long z)
{	cerr<<"Error:"<<z<<endl;
}
void ttkerror(int z)
{	cerr<<"Error:"<<z<<endl;
}
#else

void xplmessage(char *text)
{ cout<<text; }

void xplmessage(const char *text)
{  char *t = strdup(text);
   xplmessage(t);
   delete[] t;
}

void xplmessage(char t)
{	
	cout<<t;
}

void xplmessage(double d)
{
	cout<<d;
}

void xplmessage(int i)
{	
	cout<<i;
}

void xplmessage(long i)                       // TTK 13.12.94
{	
	cout<<i;

}
#endif



extern FILE *XplOutputFile;

void xplout(XplDouble &x, const char *varstr, const char *str)
  {     char *tt, *cp;
        int lc=0;

/*      xplmessage("Content of object ");
        tt=strdup(varstr);
        xplmessage(tt);
        delete tt;

        if (x.dimension(0)*x.dimension(1)>2047)
        {               
#ifdef __BORLANDC__
                xplmessage("\r\nSorry, this object is too big\r\n");
#else
                xplmessage("\nSorry, this object is too big\n");
#endif
                                return;
        }
*/
        Xplostream txt;
        x.mdump("%f", &txt, varstr);
        cp =strdup(txt.ptr());

        int le=strlen(cp);
        if (le>32767)
        {               
#ifdef __BORLANDC__
                xplmessage(XMSGW_OBJECT_LARGER_32K_STR);
#else
                xplmessage(XMSGU_OBJECT_LARGER_32K_STR);
#endif
                delete cp;
                return;
        }
        if (XplOutputFile!=NULL)
                fprintf(XplOutputFile, "%s\n", cp);
        xplmessage(cp);
        delete cp;
#ifdef _UNIX_
        Widget scbar;
        XtVaGetValues(XtParent(out_text), XmNverticalScrollBar, &scbar, NULL);
        int mini, maxi, sli, vali, sc;
        XtVaGetValues(scbar, XmNvalue, &vali,
                                XmNsliderSize, &sli,
                                XmNmaximum, &maxi,
                                XmNminimum, &mini, NULL);
        sc=maxi-sli-vali;
        if (sc>0)
                XmTextScroll(out_text, sc);
#endif
        return;

}

void xplout(XplChar &x, const char *varstr, const char *fst )
  {     char *tt, *cp;
        //int lc=0;

/*      xplmessage("Content of object ");
        tt=strdup(varstr);
        xplmessage(tt);
        delete tt;

        if (x.dimension(0)*x.dimension(1)>2047)
        {               
#ifdef __BORLANDC__
                xplmessage("\r\nSorry, this object is too big\r\n");
#else
                xplmessage("\nSorry, this object is too big\n");
#endif
                                return;
        }
*/
        Xplostream txt;
        x.mdump("%s", &txt, varstr);
   cp=strdup(txt.ptr());
        xplmessage(cp);
        
        if (XplOutputFile!=NULL)
                fprintf(XplOutputFile, "%s\n", cp);
        delete cp;
#ifdef _UNIX_
        Widget scbar;
        XtVaGetValues(XtParent(out_text), XmNverticalScrollBar, &scbar, NULL);
        int mini, maxi, sli, vali, sc;
        XtVaGetValues(scbar, XmNvalue, &vali, 
                                XmNsliderSize, &sli,
                                XmNmaximum, &maxi,
                                XmNminimum, &mini, NULL);
        sc=maxi-sli-vali;
        if (sc>0)
                XmTextScroll(out_text, sc);
#endif  
        return;

}


/*void xplout(XplDouble &x, const char *varstr, const char *str)
  { 	char *tt, *cp;
	int lc=0;

	xplmessage("Content of object ");
	tt=strdup(varstr);
	xplmessage(tt);
	delete tt;

	if (x.dimension(0)*x.dimension(1)>2047)
	{       	
#ifdef __BORLANDC__
		xplmessage("\r\nSorry, this object is too big\r\n");
#else
		xplmessage("\nSorry, this object is too big\n");
#endif
				return;
	}

	Xplostream txt;
	x.mdump("%f", &txt);
	cp =strdup(txt.ptr());

	int le=strlen(cp);
	if (le>32767)
	{       	
#ifdef __BORLANDC__
		xplmessage("\r\nSorry, this object is too big\r\n");
#else
		xplmessage("\nSorry, this object is too big\n");
#endif
		delete cp;
		return;
	}
	if (XplOutputFile!=NULL)
		fprintf(XplOutputFile, "%s\n", cp);
	xplmessage(cp);
	delete cp;
#ifdef _UNIX_
	Widget scbar;
	XtVaGetValues(XtParent(out_text), XmNverticalScrollBar, &scbar, NULL);
	int mini, maxi, sli, vali, sc;
	XtVaGetValues(scbar, XmNvalue, &vali,
				XmNsliderSize, &sli,
				XmNmaximum, &maxi,
				XmNminimum, &mini, NULL);
	sc=maxi-sli-vali;
	if (sc>0)
		XmTextScroll(out_text, sc);
#endif
	return;

}



void xplout(XplChar &x, const char *varstr, const char *fst )
  { 	char *tt, *cp;
	//int lc=0;

	xplmessage("Content of object ");
	tt=strdup(varstr);
	xplmessage(tt);
	delete tt;

	if (x.dimension(0)*x.dimension(1)>2047)
	{       	
#ifdef __BORLANDC__
		xplmessage("\r\nSorry, this object is too big\r\n");
#else
		xplmessage("\nSorry, this object is too big\n");
#endif
				return;
	}
	Xplostream txt;
	x.mdump("%s", &txt);
   cp=strdup(txt.ptr());
	xplmessage(cp);
	
	if (XplOutputFile!=NULL)
		fprintf(XplOutputFile, "%s\n", cp);
	delete cp;
#ifdef _UNIX_
 	Widget scbar;
  	XtVaGetValues(XtParent(out_text), XmNverticalScrollBar, &scbar, NULL);
	int mini, maxi, sli, vali, sc;
 	XtVaGetValues(scbar, XmNvalue, &vali, 
				XmNsliderSize, &sli,
				XmNmaximum, &maxi,
				XmNminimum, &mini, NULL);
	sc=maxi-sli-vali;
	if (sc>0)
		XmTextScroll(out_text, sc);
#endif	
 	return;

}

*/

#ifdef _UNIX_
void xplerror(char *str)
{	
	motif_error(str);
}
void ttkerror(const char *str)
{	
	motif_error(str);
}
void ttkerror(char *str)
{	
	motif_error(str);
}
void ttkwarning(char *str)
{	
	motif_warning(str);
}
#else
void xplerror(char *str)
{	
	cerr<<str<<endl;
}
/*
void ttkerror(char *str)
{	
	cerr<<str<<endl;
}
*/
#endif

void xplerror(char z)
{	cerr<<"Error:"<<z<<endl;
}
void xplerror(double z)
{	cerr<<"Error:"<<z<<endl;
}
void xplerror(long z)
{	cerr<<"Error:"<<z<<endl;
}
void xplerror(int z)
{	cerr<<"Error:"<<z<<endl;
}



