/* $Header: /home/xplore/cvs/xpl4gr/xplmask.hpp,v 1.3 2002/08/16 12:31:59 sigbert Exp $ */

#ifndef XPLMASK
#define XPLMASK

#include <math.h>

#define MASK_RED      0x000000ff
#define MASK_GREEN    0x0000ff00
#define MASK_BLUE     0x00ff0000
#define MASK_SYMBOL   0x0f000000
#define MASK_SIZE     0xf0000000

#define COLOR_BLACK   0x00ffffff
#define COLOR_BLUE    0x00ff0000
#define COLOR_GREEN   0x0000ff00
#define COLOR_CYAN    0x00ffff00
#define COLOR_RED     0x000000ff
#define COLOR_MAGENTA 0x00ff00ff
#define COLOR_YELLOW  0x0000ffff
#define COLOR_WHITE   0x00000000

class xplmask
{ unsigned int red    : 8,
               green  : 8,
               blue   : 8,
               symbol : 4,
               size   : 4;
  
  public:

  xplmask ();
  xplmask (int r, int g, int b);
  xplmask (int r, int g, int b, int sy, int si);
  xplmask (long mask);
  xplmask (double dmask);
  void SetRGB (int r, int g, int b);
  void SetHLS (float h, float l, float s);
  void SetRed (int r);
  void SetBlue (int b);
  void SetGreen (int g);
  void SetSymbol (int sy);
  void SetSize (int si);
  void GetRGB (int *r, int *g, int *b) const;
  void GetRed (int *r) const;
  void GetBlue (int *b) const;
  void GetGreen (int *g) const;
  void GetSymbol (int *sy) const;
  void GetSize (int *si) const;
  int operator!= (const xplmask r) const;
  int operator== (const xplmask r) const;
  int operator< (const xplmask r) const;
  int operator> (const xplmask r) const;

};


#endif
