/* $Header: /home/xplore/cvs/xpl4gr/xplmat.C,v 1.4 2003/02/23 17:10:01 cizek Exp $ */

// XplMatrix Klasse  24.8.95 Swe


int swedebug;

//extern int matrix_count;

// PC MAC
#if !defined(__BORLANDC__) && !defined(__APPLE_CC__)
#include <stream.h>
#else
#include <iostream.h>
#endif

#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "xplmat.h"
#include "ttkio.h"
#include "xplio.h"

extern bool NANorINF(double x);

XplMatrix::~XplMatrix ()
{
#ifdef SWEDEBUG
extern int swedebug;
if (swedebug)
  cerr<<"Mat: destruct\t\t"<<this<<endl;
#endif

//matrix_count--;
//	cout<<"~XplMatrix: MatrixCount ist "<<matrix_count<<endl;
  if (elem!=NULL)
  	delete[] elem;
}

XplMatrix::XplMatrix ()		: row (0), col (0), elem (NULL) 
{	//matrix_count++;
	//	cout<<"~XplMatrix: MatrixCount ist "<<matrix_count<<endl;
	extern int swedebug;
	if (swedebug)
  	cout<<"Mat:\tconstruct\t"<<this<<endl;
}



XplMatrix::XplMatrix (int r):row(r), col(1)
{
  if (r < 1)
    {
    xplerror("Error: Constructor XplMatrix: row =");
    xplerror((long int)r);
    exit (0);
    }
  elem = XplMatrixAlloc (row, col);
  
 // matrix_count++;
//	cout<<"XplMatrix(int r): MatrixCount ist "<<matrix_count<<endl;

#ifdef SWEDEBUG
if (swedebug)
cerr << "Mat:\tconstruct\t" << this << endl;
#endif
}

XplMatrix::XplMatrix (int r, int c):row(r), col(c)
{
  if ((row < 1) || (col < 1))
    {
	char stri[256];
    	sprintf(stri, "%s %d %d",  
    	"Error: Constructor XplMatrix: row, col =", row, col);
    	xplerror(stri);
    exit (0);
    }
  elem = XplMatrixAlloc (row, col);

 //matrix_count++;
//	cout<<"XplMatrix(int r, int c): MatrixCount ist "<<matrix_count<<endl;

#ifdef SWEDEBUG
if (swedebug)
cerr << "Mat:\tconstruct\t" << this << endl;
#endif
}


XplMatrix::XplMatrix (int r, int c, int i):row(r), col(c)
{
  int n, m;
  
  if ((row < 1) || (col < 1))
    {
    xplerror("Error: Constructor XplMatrix: row = ");
    xplerror((long int)row);
    xplerror("  col =");
    xplerror((long int)col);
    exit (0);
    }
  if (! (i==1 && row==col) )
    {
    xplerror("Error: Constructor XplMatrix: i must be 1");
    exit (0);
    }
  elem = XplMatrixAlloc (row, col);
  for (n=0; n<row; n++)
  for (m=0; m<col; m++)
  if (m==n) 
  	elem[m*row+n]=1;
  else elem[m*row+n]=0;

 //matrix_count++;
//	cout<<"XplMatrix(int r, int c, int i): MatrixCount ist "<<matrix_count<<endl;

#ifdef SWEDEBUG
if (swedebug)
cerr << "Mat:\tconstruct\t" << this << endl;
#endif
}

XplMatrix::XplMatrix (const XplMatrix& v):row(v.row), col(v.col)
{
  int	length, i;
  
  length = row*col;
  elem = XplMatrixAlloc (row, col);
  
  for (i=0; i<length; i++)
    elem[i] = v.elem[i];
  

 //matrix_count++;
//	cout<<"XplMatrix(const XplMatrix&): MatrixCount ist "<<matrix_count<<endl;

#ifdef SWEDEBUG
if (swedebug)
cerr << "Mat:\tconstruct\t" << this << endl;
#endif
  return;
}  
   
XplMatrix::XplMatrix (XplMatrix* const v):row(v->row), col(v->col)
{
  int		i, length;
  
  if (v == NULL)
    {
    elem = NULL;
    row = col = 0;
    return;
    }
  
  length = row*col;
  elem = XplMatrixAlloc (row, col);
    
  for (i=0; i<length; i++)
    elem[i] = v->elem[i];
  
#ifdef SWEDEBUG
if (swedebug)
cerr << "Mat:\tconstruct\t" << this << endl;
#endif

 //matrix_count++;
//	cout<<"XplMatrix(XplMatrix *const ): MatrixCount ist "<<matrix_count<<endl;

  return;
}  
   
double& XplMatrix::operator() (int i, int j)
// i : 0 .. row-1, j : 0 .. col-1
{
  if ((i > row-1) || (j > col-1))
    {
    xplerror("Error: op () XplMatrix(");
    xplerror((long int)row);
    xplerror((long int)col);
    xplerror((long int)i);
    xplerror((long int)j);
    exit (0);
    }
  return (elem[i*col+j]);
}



double XplMatrix::operator() (int i, int j) const
// i : 0 .. row-1, j : 0 .. col-1
{
  if ((i > row-1) || (j > col-1))
    {
    xplerror("Error: op () XplMatrix(");
    xplerror((long int)row);
    xplerror((long int)col);
    xplerror((long int)i);
    xplerror((long int)j);
    exit (0);
    }
  return (elem[i*col+j]);
}

XplMatrix& XplMatrix::operator= (const XplMatrix& v)
{
  int 	length;

  if (this == &v)  return (*this);
  
  int i;
  
  row = v.row;
  col = v.col;
  
  if (elem != NULL)
    delete[] elem;
  elem = XplMatrixAlloc (row, col);

  length = row*col;
  
  for (i=0; i<length; i++)
    elem[i] = v.elem[i];

  return (*this);
}


XplMatrix XplMatrix::operator+ (const XplMatrix& r)
{
  int		i, len, j;
  double	t;
  double *links, *rechts, *resel;
 XplMatrix erret;
 
  if (r.isScalar())
    {
    XplMatrix	res(row, col);
    len = row*col;
    t = r.elem[0];
    for (i=0; i<len; i++)
      res.elem[i] = elem[i] + t;
    
    return (res);
    }
  
  if (isScalar())
    {
    XplMatrix	res(r.row, r.col);
    len = r.row*r.col;
    t = elem[0];
    for (i=0; i<len; i++)
      res.elem[i] = r.elem[i] + t;
    
    return (res);
    }
  
 
  links=elem;
  rechts=r.elem;

 if (match(r))
   {  XplMatrix	res(row, col);
   	len = row*col;
    	resel=res.elem;

  	for (i=0; i<len; i++, resel++, links++, rechts++)
    	resel[0] = links[0] + rechts[0];
  
  return (res);
   }
 
  if ((col!=r.col) || (row!=1 && r.row!=1))
    {
    xplerror("Error: op + Matrices don't match");
    cerr<<" Error: op + Matrices don't match"<<endl;
    return(erret);
    }

 if (row==1)    		//erste matrix ist ein vector
   { 	XplMatrix	res(r.row, r.col);
    	resel=res.elem;

	for (j=0; j<col; j++, links++)
	{	for (i=0; i<r.row; i++, resel+=col, rechts++)
			resel[0]=links[0] + rechts[0];
		rechts=r.elem+j+1;
 		resel=res.elem+j+1;
	}
  return (res);
   }

 if (r.row==1)    		//zweite matrix ist ein vector
   { 	XplMatrix	res(row, col);
   	resel=res.elem;

	for (j=0; j<col; j++, rechts++)
	{	for (i=0; i<row; i++, resel+=col, links+=col)
		{	resel[0]=links[0] + rechts[0];				
 		}
 		links=elem+j+1;
 		resel=res.elem+j+1;
 	}
  	return (res);
   }
    xplerror("Error: op + Matrices don't match");
    cerr<<" Error: op + Something is wrong"<<endl;
    return(erret);
}

XplMatrix XplMatrix::operator- (const XplMatrix& r)
{
  int		i, len, j;
  double	t;
  XplMatrix erret;
 
  if (r.isScalar())
    {
    XplMatrix	res(row, col);
    len = row*col;
    t = r.elem[0];
    for (i=0; i<len; i++)
      res.elem[i] = elem[i] - t;
    
    return (res);
    }
  
  if (isScalar())
    {
    XplMatrix	res(r.row, r.col);
    len = r.row*r.col;
    t = elem[0];
    for (i=0; i<len; i++)
      res.elem[i] = t - r.elem[i];
 
    return (res);
    }
  
 
 if (match(r))
   {  XplMatrix	res(row, col);
  len = row*col;

  for (i=0; i<len; i++)
    res.elem[i] = elem[i] - r.elem[i];
  
  return (res);
   }
 
  if ((col!=r.col) || (row!=1 && r.row!=1))
    {
    xplerror("Error: op - Matrices don't match");
    cerr<<" Error: op - Matrices don't match"<<endl;
    exit (0);
    }

  double *links, *rechts, *resel;
  links=elem;
  rechts=r.elem;
  
   if (row==1)    		//erste matrix ist ein vector
   { 	XplMatrix	res(r.row, r.col);
    	resel=res.elem;

	for (j=0; j<col; j++, links++)
	{	for (i=0; i<r.row; i++, resel+=col, rechts++)
			resel[0]=links[0] - rechts[0];
		rechts=r.elem+j+1;
 		resel=res.elem+j+1;
	}
  return (res);
   }

 if (r.row==1)    		//zweite matrix ist ein vector
   { 	XplMatrix	res(row, col);
   	resel=res.elem;

	for (j=0; j<col; j++, rechts++)
	{	for (i=0; i<row; i++, resel+=col, links+=col)
		{	resel[0]=links[0] - rechts[0];				
 		}
 		links=elem+j+1;
 		resel=res.elem+j+1;
 	}
  	return (res);
   }

    xplerror("Error: op  Matrices don't match");
    cerr<<" Error: op  Something is wrong"<<endl;
     return(erret);

}

XplMatrix XplMatrix::operator* (const double r)
{  
  XplMatrix	res(row, col);
  int i;
  int len = row*col;

  for (i=0; i<len; i++)
    res.elem[i] = elem[i] * r;
  
  return (res);
}

XplMatrix XplMatrix::operator/ (const double r)
{
  int		i, len;
  
    XplMatrix	res(row, col);
    len = row*col;
    for (i=0; i<len; i++)
      res.elem[i] = elem[i]/r;
 
    return (res);  

}

Boolean XplMatrix::operator== (const XplMatrix& r)
{
  int		i, len;
  
  if ( !(row==r.row && col==r.col))
  	return(False);
    len = row*col;
    for (i=0; i<len && elem[i]==r.elem[i]; i++)
    	;
    if (i==len)
    	return(True);
    else
  	return (False);
}

Boolean XplMatrix::operator!= (const XplMatrix& r)
{	if ( ( ( *this)==r)==False)
		return(True);
	else return(False);
}

XplMatrix XplMatrix::min_col(void) const
{
	XplMatrix res(1, col);
	
	int i, j;
	for (j=0; j<col; j++)
		res.elem[j]=elem[j];
	for (j=0; j<col; j++)
		for (i=1; i<row; i++)
			if (!NANorINF(elem[i*col+j]) && 
				res.elem[j]>elem[i*col+j])
				res.elem[j]=elem[i*col+j];
#ifdef _BLABLA_
	res.out();
#endif
  	return res;
}

XplMatrix XplMatrix::max_col(void) const
{
	XplMatrix res(1, col);
	int i, j;
	for (j=0; j<col; j++)
		res.elem[j]=elem[j];
	for (i=1; i<row; i++)
		for (j=0; j<col; j++)
		{	if (!NANorINF(elem[i*col+j]) && 
				res.elem[j]<elem[i*col+j])
					res.elem[j]=elem[i*col+j];
		}
#ifdef _BLABLA_
	res.out();
#endif
  	return res;
}

XplMatrix XplMatrix::extremum(void) const
{
	XplMatrix res(2, col);
	int i, j;
	//	cout<<"XplMatrix::extremumlXplMatrix::min_col"<<endl;
	//	out();
	for (i=0; i<row; i++)
		for (j=0; j<col; j++)
		{	if (i==0)
			{	res.elem[j]=elem[j];
				res.elem[col+j]=elem[j];
			}
			else
			{	if (res.elem[j]>elem[i*col+j])
					res.elem[j]=elem[i*col+j];
				if (res.elem[j+col]<elem[i*col+j])
					res.elem[j+col]=elem[i*col+j];
			}
		}
	//	res.out();
  	return res;
}

  
XplMatrix XplMatrix::operator*(const  XplMatrix & r)	//Sweta
{
  int i, j, k, links_col, links_row, rechts_row, rechts_col;
  double *links, *rechts, *res;

  links_row = row;
  links_col = col;
  rechts_col = r.col;
  rechts_row = r.row;
  
    XplMatrix tmp(links_row, rechts_col);
  double sum;
  
/*	cout<<"  XplMatrix::operator*(const  XplMatrix & r) mit r="<<endl;
	r.out();
	cout<<"fuer this="<<endl;
	this->out();
*/
  if (links_col != rechts_row)
    {
    xplerror("XplMatrix::mult: Error:  Matrices don't match");
    cerr<<"XplMatrix::mult: Error:  Matrices don't match"<<endl;
    exit;
    }

  	res=tmp.elem;
  	for (i=0; i<links_row; i++)
    		for (j=0; j<rechts_col; j++)
	{	sum=0.0;
		links=elem+i*links_col;
		rechts=r.elem+j;
      		for (k=0; k<col; k++, links++, rechts+=rechts_col)
		{	//	cout<<links[0]<<"*"<<rechts[0]<<"+";
			sum+=links[0]*rechts[0];
		}
		//	cout<<"="<<sum<<"=res["<<i<<","<<j<<"]\n";
		res[0]=sum;
		res++;
	}
/*
  for (i=0; i<n; i++)
    for (j=0; j<p; j++)
      {
      for (k=0; k<m; k++)
         sum += elem[m*i+k] * r.elem[k*p+j];
      tmp.elem[i*m+j] = sum;
      sum = 0.0;
      }
*/
    
/*    	cout<<"Resultat:"<<endl;
    	tmp.out();
*/   
   return(tmp);
}

XplMatrix XplMatrix::transpose (void) const
{
  XplMatrix tmp(col, row);
  int	i, j;
  
//	cout<<"Transpose with:"<<endl;
//	out();

  for (i=0; i<row; i++)
    for (j=0; j<col; j++)
      tmp.elem[j*row+i] = elem[i*col+j];
    
//	cout<<"ergibt:"<<endl;
//	tmp.out();
  return (tmp);
}

XplMatrix XplMatrix::inv(void) const
{
  XplMatrix tmp(col, row);
  int	i;
  
	if (! row==col )
	{	cout<<"invert mit nicht diag,. mat."<<endl;
		out();
		exit(0);
	}
	tmp.fill(0.0);
  for (i=0; i<row; i++)
  	if (elem[i*row+i]==0)
  		tmp.elem[i*row+i] = 0.0;
  	else tmp.elem[i*row+i]=1.0/elem[i*row+i];
 
  return (tmp);
}

void XplMatrix::out (void) const
{
  int i, j, length, dim;
  
  length = row*col;
  
  /*
  if (length>100)
  {	cout<<"keine lust, matrix ist zu gross"<<endl;
  	return;
  }
  */
  if (col == 1)
    dim = 1;
  else
    dim = 2;


  cout << "Dim: " << dim << '\n';  
  cout<<"Addr: "<<elem<<endl;

  switch (dim) {
  case 1:	for (i=0; i<length; i++)
                  
  		  cout << elem[i] << '\t'; 
		  
		  break;
  case 2:	for (i=0; i<row; i++)
  		  {
  		  for (j=0; j<col; j++)
  		    cout << elem[i*col+j] << '\t';
  		  cout << '\n';
  		  }
  		break;
  default:	xplerror("Error: out XplMatrix");
  		exit (0);
  		break;
  }
    
  		  cout << '\n';


}

int XplMatrix::match (const XplMatrix &v)
{
  return ((row==v.row) && (col==v.col));
}

void XplMatrix::fill (const double v)
{
  long i, n = row*col;
  double *p = elem;

  for (i=0; i<n; i++)
    *p++ = v;
}


double * XplMatrixAlloc (int row, int col)
{
  double *res, *p;
  long i, n = row*col;
  
  if (NULL == (res = new double[row*col]))
    {
    xplerror("Error: Tried to allocate ");
    xplerror((long int)(row*col*(int) sizeof(double)));
    xplerror("Bytes !");
    exit (0);
    }

  p = res;

  for (i=0; i<n; i++)
    *p++ = 0.0;

  return (res);
}
void Compute(const XplMatrix & data, const XplMatrix & mult, 
			const XplMatrix & add, MyPoint * wohin)
{		
//		add.out();

/*		XplMatrix mult=multt;
		
		mult.fill(0.0);
		mult.elem[0]=1.0;
		mult.elem[3]=1.0;

*/
//		mult.out();
		
		int co=data.row;
		int el_count=data.col;
		int mult_cols=mult.col;
		int add_cols=add.col;
		int i, j;
		double * data_elem=data.elem;
		double * add_elem=add.elem;
		double * mult_elem=mult.elem;
		
		MyPoint *wowo=wohin;
		
		for (j=0; j<co; j++)
		{	mult_elem=mult.elem;
			add_elem=add.elem;
			double resx=0;
			double resy=0;
			
			for (i=0; i<el_count; i++)
			{	//cout<<i<<" Spalte von data "<<resx;
				resx=resx+(*data_elem)*(*mult_elem);
				mult_elem++;	//zweite Spalte fuer y
				resy=resy+(*data_elem)*(*mult_elem);
				data_elem++;
				mult_elem+=(mult_cols-1);
			}

			resx=resx+(*add_elem);	//fuer X
			add_elem++;
			resy=resy+(*add_elem);	//Fuer Y
			

			wohin->x=(short)(resx+0.5);
			wohin->y=(short)(resy+0.5);
			
//			cout<<j<<" Zeile von data "<<endl;
			
			wohin++;
		}
		
/*		wohin=wowo;
		for (i=0; i<co; i++)
		{	cout<<wohin->x<<", "<<wohin->y<<endl;
			wohin++;
		}
		cout<<"Zum Vergleich:"<<endl;
		XplMatrix xplm=data;	//wegen const..
		XplMatrix resres=xplm*mult;
		resres=resres+add;
		resres.out();
		int j;
		for (j=0; j<co; j++)
		{	wohin->x=(short)(resres(j,0)+0.5);
			wohin->y=height-(short)(resres(j,1)+0.5);
			wohin++;
		}
*/
	}
XplMatrix  XplDouble2XplMatrix(XplDouble &xpld)
{	int rows=xpld.dimension(0);
	int cols=xpld.dimension(1);
	int i, j;
	XplMatrix mat(rows, cols);
		
		
	for (i=0; i<rows; i++)
			for (j=0; j<cols; j++)
				mat(i, j)=xpld(i, j);
	return(mat);
}



XplDouble  XplMatrix2XplDouble(XplMatrix &xplma)
{	int rows=xplma.rows();
	int cols=xplma.cols();
	int i, j;
	XplDouble xpld(rows, cols);
		
	for (i=0; i<rows; i++)
			for (j=0; j<cols; j++)
				xpld(i, j)=xplma(i, j);
	return(xpld);
}





