/* $Header: /home/xplore/cvs/xpl4gr/xplore.cpp,v 1.4 2002/09/27 14:37:09 cizek Exp $ */

//----------------------------------------------------------------------------
//                       XploRe  4.0 for Win Main File
//----------------------------------------------------------------------------
#include <owl\color.h>
#include <owl\messageb.h>
#include <math.h>
#include <float.h>
#include <dir.h>
#include <string.h>
#include <stdlib.h>
#include "xplwinap.h"
#include "xplore.h"
#include "xplwin.h"
#include "owl\picklist.h"

#include "xplerror.h"
#include "property.h"
#include "directory.h"
#include "hlp2html.h"

#include "printing.h"
// commented out by PC 16.5.2000
// #include <owl\richedpr.h>

// localized strings - PC 20010320
#include "xplore_strings.h"
#include "wed_strings.h"

#define STR_L 1000

TApplication *myapp;
TWindow *GrossVater;

// global printer object
TPrinter *Printer = NULL;

char *outstr = new char[STR_L];
char *errstr = new char[STR_L];
void startxplore (void);
void parse (const char *);
TProfile* TXploreClient::profile;
int TInput::InputCount=0;
TXploreClient* TXploreClient::Client=0;
TOutput* TOutput::globout=0;
extern char *xpl4homewin = "";
//extern char *xpl4help;
//extern char *xpl4home;
int argc;
char** argv;
// PC: cannot be used - text has not a limited length: char tmpbuf[MAX_TEXT_LENGTH];

//-------------------------------------------------------------------
//                           TOutput class
//-------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TOutput, TMDIChild)
  EV_WM_SIZE,
END_RESPONSE_TABLE;

TOutput::TOutput(TXploreClient& MDIclient, TInput* Par) : TMDIChild(MDIclient)
{
      Parent = Par;
      if (Parent)
        Parent->OutExists=TRUE; // SK 23.01.98
// Outtext = new TListBox(this, 220, 10, 10, 150, 150);
// Outtext->Attr.Style &= ~LBS_SORT;
// Outtext->Attr.Style |= (WS_HSCROLL);

	Outtext = new TEdit(this, 112, "", 10, 10, 10, 10, 0, true);
   //Outtext->SetReadOnly(true);

	SetBkgndColor(TColor::LtGray);

	Outtext->SetTextLimit(32560);
   SetIcon(myapp, AAA32);
   SetIconSm(myapp, AAA32);
}
TOutput::~TOutput()
{
	 /*		TXploreClient::profile->WriteInt("OutputX", Attr.X);
			TXploreClient::profile->WriteInt("OutputY", Attr.Y);
			TXploreClient::profile->WriteInt("OutputW", Attr.W);
			TXploreClient::profile->WriteInt("OutputH", Attr.H);
	  */
  if (Parent) Parent->OutExists=FALSE; // SK 23.01.98
  delete Outtext;
}

bool
TOutput::CanClose()
{ return (false); }

void
TOutput::SetupWindow() {

   TMDIChild::SetupWindow();
 //int x, y, w, h;
	TRect parViewable(Parent->Parent->GetClientRect());

//   wpm.getwin (WIN_OUTPUT, &x, &y, &w, &h);
	wpm.getwin (WIN_OUTPUT, &parViewable);
/*   Attr.X=TXploreClient::profile->GetInt("OutputX", parViewable.Left());
   Attr.Y=TXploreClient::profile->GetInt("OutputY", parViewable.Top());
   Attr.W=TXploreClient::profile->GetInt("OutputW", parViewable.Width());
   Attr.H=TXploreClient::profile->GetInt("OutputH", parViewable.Height());*/
   MoveWindow( parViewable );
//setBkgndColor(140);
// podryadthis->AddAnswer();
	globout = this;
   Outtext->SetReadOnly(true);
   HFONT tfont=(HFONT) GetStockObject(SYSTEM_FIXED_FONT);
   Outtext->SetWindowFont(tfont, FALSE);
}
void
TOutput::EvSize(UINT sizeType, TSize& size)
{
  TMDIChild::EvSize(sizeType, size);

  // Force Windows to repaint the entire window region
  Invalidate(TRUE);

  int newXmax = size.cx;
  int newYmax = size.cy;
  if (Outtext)
  Outtext->MoveWindow(5, 5, newXmax-10, newYmax-10, TRUE);

}

void
TOutput::AddAnswer() {
}

//--------------------------------------------------------------------
//----------------------   TInput ------------------------------------
//--------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TInput, TMDIChild)
  EV_COMMAND(CM_OUT, CmOutput),
  EV_COMMAND(CM_CLEAR, CmClear),
  EV_COMMAND(VK_RETURN, CmReturn),
//  EV_COMMAND(VK_UP, CmUp),
//  EV_COMMAND(VK_DOWN, CmDown),
  EV_WM_SIZE,
  EV_LBN_SELCHANGE(111, EvListBoxSelChange),
  EV_LBN_KILLFOCUS(111, EvListBoxKillFocus),
  EV_LBN_SETFOCUS(111, EvListBoxSetFocus),
END_RESPONSE_TABLE;

//
TInput::TInput(TXploreClient& MDIclient) : TMDIChild(MDIclient)
 {
	 SetBkgndColor(TColor::LtGray);
	 TXploreClient::Client->input_child=this;
	 LostFocus=TRUE;
	 OutExists=FALSE;
	 Attr.AccelTable = "XPLOREINPUT";
	 InputCount++;
	 CaptNumber=InputCount;

	 ListBox = new TListBox(this, 111, 10, 10, 200, 300);
	 ListBox->Attr.Style &= ~(LBS_SORT);
	 ListBox->Attr.Style |= (WS_HSCROLL | LBS_MULTIPLESEL);


	 Prompt = new TEdit(this, 112, "", 10, 10, 10, 10);
	 Prompt->SetFocus();

	 Prompt->Attr.Style ;
	 Output=0;

//	 SetBkgndColor(7);
   	SetIcon(myapp, AAA32);
      SetIconSm(myapp, AAA32);
 }

bool
TInput::CanClose()
{ return (false); }

TInput::~TInput() {
/*			TXploreClient::profile->WriteInt("InputX", Attr.X);
			TXploreClient::profile->WriteInt("InputY", Attr.Y);
			TXploreClient::profile->WriteInt("InputW", Attr.W);
			TXploreClient::profile->WriteInt("InputH", Attr.H);*/
if (TXploreClient::Client->input_child==this) TXploreClient::Client->input_child=0;
if (CaptNumber==InputCount) InputCount--;
if (OutExists==TRUE) {
  char title[40];
  strcpy(title,Output->Title);
  strcat(title, XMSG_OUTPUT_TITLE_DONE_STR);
  Output->SetCaption(title);
  if (ListBox) {
		delete ListBox;
		ListBox = 0;
  }
  if (Prompt) {
		delete Prompt;
		Prompt = 0;
  }

};


}

void TInput::SetupWindow() {
   TMDIChild::SetupWindow();
 //int x, y, w, h;
	TRect parViewable(Parent->GetClientRect());

//   wpm.getwin (WIN_INPUT, &x, &y, &w, &h);
	wpm.getwin (WIN_INPUT, &parViewable);
/*   Attr.X=TXploreClient::profile->GetInt("InputX", parViewable.Left());
   Attr.Y=TXploreClient::profile->GetInt("InputY", parViewable.Top());
   Attr.W=TXploreClient::profile->GetInt("InputW", parViewable.Width());
   Attr.H=TXploreClient::profile->GetInt("InputH", parViewable.Height());*/
   MoveWindow( parViewable );
}

void
TInput::EvSize(UINT sizeType, TSize& size) {
  TMDIChild::EvSize(sizeType, size);

  // Force Windows to repaint the entire window region
  Invalidate(TRUE);

  int newXmax = size.cx;
  int newYmax = size.cy;
  if (ListBox)
  ListBox->MoveWindow(5, 5, newXmax-10, newYmax-45 , TRUE);
  if (Prompt)
  Prompt->MoveWindow(5, newYmax-35, newXmax-10, 30, TRUE);
  Prompt->SetFocus();
}


//------------------- KILL/SET FOCUS --------------------------------


void
TInput::EvListBoxKillFocus() {
  LostFocus=TRUE;
}

void
TInput::EvListBoxSetFocus() {
  LostFocus=FALSE;
}


//---------------- If selection is changed ----------------------

void
TInput::EvListBoxSelChange() {
	 char command[STR_L];
	 int index= ListBox->GetCaretIndex();
	 if (ListBox->GetSel(index)) {
	 ListBox->GetString(command, index);
	 Prompt->Insert(command);
	 } else {
	  int indexes[400];
	 ListBox->GetSelIndexes(indexes, 400);
	 ListBox->SetSelIndexes(indexes, -1, FALSE);
	 Prompt->Clear();

	 }
}


void
TInput::CmClear()
{
 Prompt->Clear();
 ListBox->ClearList();

}

void
TInput::CmOutput()
{
	  if (!OutExists) {
		  //Output = new TOutput(this);
		  Output = new TOutput(*TXploreClient::Client, this);
     	  Output->SetMenuDescr(TMenuDescr(101,0,0,0,0,0,0));


			 // Set Caption of Output WIndow
			Output->SetCaption(XMSG_OUTPUT_WIN_CAPTION_STR);
			Output->Create();
	  };
}



void
TInput::CmUp () {

//	if (ListBox->GetSelCount()<=0) {
//	 ListBox->SetCaretIndex(ListBox->GetCount()-1, -1);
//	} else {
	if (LostFocus) {
		ListBox->SetFocus();
		ListBox->SetCaretIndex(ListBox->GetCount()-1, TRUE);
	} else {
	  int index = ListBox->GetCaretIndex();
	  if (index != 0) {
		 index--;
		 ListBox->SetCaretIndex(index,-1);
	  };
	};
}

void
TInput::CmDown () {

	int index = ListBox->GetCaretIndex();
	if (index != ListBox->GetCount()-1)  {
		index++;
		ListBox->SetCaretIndex(index,-1);
	}
	else Prompt->SetFocus();


}


void
TInput::CmReturn()
{
  char command[STR_L];
  int anzahl = Prompt->GetText(command, STR_L);
  if (anzahl != 0) {
	  DoCommand(command, 1);

     // SK 18.05.99
     BringWindowToTop();
     SetActiveWindow();
     SetFocus();

     ListBox->SetCaretIndex(ListBox->GetCount()-1,1);

	  //Unselect Lisbox and Clear Prompt
	  int indexes[400];
	  ListBox->GetSelIndexes(indexes, 400);
	  ListBox->SetSelIndexes(indexes, -1, FALSE);

	  ListBox->SetCaretIndex(ListBox->GetCount()-1, -1);

	  Prompt->Clear();
	  Prompt->SetFocus();
  };

}

int MacroListLength = -1;
int ObjListLength = -1;

void
TInput::DoCommand(char *command, int ShowInHistory)
{ if (strlen(command) > 0 )
  { char *p = strdup(command);
    while ((*p==' ') || (*p=='\t') || (*p=='\n')|| (*p=='\r')) p++;

    if (ShowInHistory)
    { ListBox->AddString(p);
      ListBox->SetCaretIndex(ListBox->GetCount()-1,1);
    }
    Response(p);
		  //	cout<<"RESPONSE"<<endl;
    if (globalError.Get()  ) return;
    if (!OutExists) CmOutput();
    if (TXploreClient::Client->ObjectList) TXploreClient::Client->ObjectList->UpdateLists();
    if (TXploreClient::Client->MacroList)
    { if (MacroListLength!=TXploreClient::Client->MacroList->ListLength())
      { TXploreClient::Client->MacroList->UpdateLists();
        MacroListLength = TXploreClient::Client->MacroList->ListLength();
      }
    }
    Output->AddAnswer();

    if (globalError.Get()) return;
  }
	// } 	while ((p = strtok(NULL, ";"))!=NULL);
}

// PC: commented out - not needed anymore for the new editor
//-------------------------------------------------------------------
//                       TGotoLineDialog class
//-------------------------------------------------------------------
//
//
//DEFINE_RESPONSE_TABLE1(TGotoLineDialog, TDialog)
//	EV_EN_SETFOCUS(506, EvEnSetFocus),
//	EV_EN_UPDATE(506, EvEnUpdate),
//END_RESPONSE_TABLE;
//
//TGotoLineDialog::TGotoLineDialog (TWindow* parent) : TDialog (parent, 201)
//{ }
//
//void
//TGotoLineDialog::SetLine (long lineno)
//{ sprintf (lno, "%i", lineno+1); }
//
//long
//TGotoLineDialog::GetLine ()
//{ return (atoi(lno)-1); }
//
//void
//TGotoLineDialog::EvEnSetFocus()
//{ SetDlgItemText ( 506, lno);
//}
//
//void
//TGotoLineDialog::EvEnUpdate()
//{ GetDlgItemText (506, lno, MAXLINELEN-1);
//}
//
//-------------------------------------------------------------------
//                       TMakeHelpDialog class
//-------------------------------------------------------------------


DEFINE_RESPONSE_TABLE1(TMakeHelpDialog, TDialog)
	EV_EN_SETFOCUS(102, EvEnSetFocus),
	EV_EN_UPDATE(102, EvEnUpdate),
   EV_BN_CLICKED(104, EvBnHTML),
   EV_BN_CLICKED(105, EvBnASCII),
   EV_BN_CLICKED(103, EvBnNewHelp),
   EV_BN_CLICKED(108, EvBnNewFile),
END_RESPONSE_TABLE;


TMakeHelpDialog::TMakeHelpDialog (TWindow* parent) : TDialog (parent, 409)
{ mhtml  = new TCheckBox (this, 104);
  mascii = new TCheckBox (this, 105);
}

TMakeHelpDialog::~TMakeHelpDialog()
{ delete mhtml;
  delete mascii;
}
void
TMakeHelpDialog::SetupWindow() {
	TDialog::SetupWindow();

	  mhtml->Create();
     mhtml->SetCheck (phtml==1);

     mascii->Create();
     mascii->SetCheck (pascii==1);

}
void
TMakeHelpDialog::SetParam (char *newname, char *newdirmacro, char *newdirhelpsys,
                           char makehtml, char makeascii)
{ strcpy (name, newname);
  if (newdirmacro)
    strcpy (dirmacro, newdirmacro);
  else
    strcpy (dirmacro, "");
  if (newdirhelpsys)
    strcpy (dirhelpsys, newdirhelpsys);
  else
    strcpy (dirhelpsys, "");
  phtml=makehtml;
  pascii=makeascii;
}

void
TMakeHelpDialog::GetParam (char *actname, char *acthtml, char *actascii)
{ strcpy (actname, name);
  *acthtml = phtml;
  *actascii = pascii;
}

void
TMakeHelpDialog::EvEnSetFocus()
{ SetDlgItemText (102, name);
  SetDlgItemText (508, dirhelpsys);
  SetDlgItemText (510, dirmacro);
}

void
TMakeHelpDialog::EvEnUpdate()
{ GetDlgItemText (102, name, MAXLINELEN-1);
}

void
TMakeHelpDialog::EvBnNewHelp()
{ Destroy (103);
}

void
TMakeHelpDialog::EvBnNewFile()
{ Destroy (108);
}

void
TMakeHelpDialog::EvBnHTML()
{ phtml = 1-phtml;
}

void
TMakeHelpDialog::EvBnASCII()
{ pascii = 1-pascii;
}

//-------------------------------------------------------------------
//                       TXplEditor class
//-------------------------------------------------------------------


DEFINE_RESPONSE_TABLE1(TXplEditor, TEditFile)
// PC: save, print, open, paste, keydown, timer, gotoline commands commented - not needed for the new editor
//  //  EV_COMMAND(CM_FILENEW, CmFileNew),
//  EV_COMMAND(CM_FILEOPEN, CmFileOpen),
	 EV_COMMAND(CM_FILEPRINT, CmFilePrint),
	 EV_COMMAND(CM_FILEPAGESETUP, CmFilePageSetup),
// PC: 	 EV_COMMAND(CM_FILESAVEAS, CmFileSaveAs),
// PC:   EV_COMMAND(CM_EDITPASTE, CmEditPaste),
    EV_COMMAND(CM_EXECFILE, CmExecFile),
// PC:	 EV_COMMAND(CM_GOTOLINE, CmGotoLine),
    EV_COMMAND(CM_FORMAT, CmFormatSource),
//    EV_COMMAND(CM_OPENHELP, CmHelpContents),
//    EV_COMMAND(CM_MAKEHELP, CmMakeHelp),
    EV_COMMAND(CM_INSERTHELP, CmInsertHelp),
    EV_COMMAND(CM_OPENMACRO, CmOpenMacro),
// PC:   EV_WM_TIMER, // DS 12.99
// PC:   EV_WM_KEYDOWN,
    EV_WM_SETFOCUS,	// PC 29.5.2000
END_RESPONSE_TABLE;

//TXplEditor::TXplEditor(char *filename) : TEditFile(0,0,0,0,0,0,0,filename)
// PC: TXplEditor::TXplEditor(char *filename, bool asEnable, int asTime) : TEditFile(0,0,0,0,0,0,0,filename)
TXplEditor::TXplEditor(char *filename, bool asEnable, int asTime) : TEditFile()
{ //SWS 23.2.98 BEGIN
     HFONT tfont=(HFONT) GetStockObject(SYSTEM_FIXED_FONT);
     TWindow::SetWindowFont(tfont, TRUE);
//	SetBkgndColor(TColor::LtGray);
 //SWS 23.2.98 END

// PC:  FileData.SetFilter("XploRe macro files (*.xpl)|*.xpl|Data files (*.dat)|*.dat|All files (*.*)|*.*|");
     SetFilter(XMSG_XPL_EDITOR_FILE_FILTER_STR);
// Make dialogs
// PC:  gld    = new TGotoLineDialog (this);
     mhd    = new TMakeHelpDialog (this);

     isAutosave = asEnable;
     autosaveTime = asTime;
     useTmpPath = false;

// PC: set editor preferences for autosave
     Prefs.autosave = isAutosave;
     Prefs.autosave_interval = autosaveTime;

     // PC: init highlighting information
     extern BOOL InitHighlightInfo(void);
     (void) InitHighlightInfo();

// PC: open file
//  if (filename) SetFileName(filename);
     if (filename)
          CmOpenFilename(filename);
}

// MakeTempName()
//
// Creates an temporary filename for the actual editfile
// expl. $NONAME.TMP
// PC: not needed any more
//void TXplEditor::MakeTempName() // 01.00 DS
//{
//  char str[1024];
//
//  memset(str, 0, 1024);
//  if( useTmpPath )
//  {
//  	 char *tok = 0;
//    str[0] = 0;
//    dump(str, TEMP, 0);
//    tok = strtok(str, "="); tok = strtok(NULL, "=");
//    strcpy( tempfilename, tok);
//    strcat( tempfilename, "\\$" );
//  }
//  else
//    strcpy( tempfilename, "$" );
//  strncpy( str, GetFileName(), strcspn( GetFileName(), "."));
//  char *lasttok = 0;
//  for( char *tok = strtok(str, "\\"); tok; tok = strtok( NULL, "\\" ) )
//  	 lasttok = tok;
//  if( lasttok )
//    strcat( tempfilename, lasttok );
//  else
//    strcat( tempfilename, str );
//  strcat( tempfilename, ".tmp" );
//}

// PC: not needed
//int *tabs = NULL;

// Setup global TPrinter object
TPrinter *SetUpPrinter(bool message) 		// PC 20010710 - added message parameter
{ 
     TPrinter *DefaultPrinter;
     TPrintDialog::TData *printerdata;
     DefaultPrinter = new TPrinter;
     
     if (DefaultPrinter == NULL) 
          return (NULL);
     
     printerdata = DefaultPrinter->GetData();
     if (printerdata->Error)
     {
     		 if (message)	// PC20010710
          {
          	MessageBox (NULL, XMSG_NO_PRINTER_ACCESS_STR, XMSG_XPLORE_ERROR_STR, MB_ICONSTOP|MB_OK);
          }
          delete DefaultPrinter;
          return (NULL);
     }
     
     return (DefaultPrinter);
}

void TXplEditor::SetupWindow()
{
     TEditFile::SetupWindow();
  //SWS 23.2.98 BEGIN
     HFONT tfont=(HFONT) GetStockObject(SYSTEM_FIXED_FONT);
     TWindow::SetWindowFont(tfont, TRUE);

// PC: set the tabbing in preferences - done internally
//   int i;
//   if (tabs==NULL)
//   {	tabs = new int [10];
//		for (i=0; i<10; i++)
//  			tabs[i]=8*i;
//   }
   
// PC:  //SetTabStops(10, tabs);
// PC:	SetBkgndColor(TColor::LtBlue);
// Initialize printer
     if (Printer == NULL) 
          Printer = SetUpPrinter(false);	// PC 20010710

// PC: setting done in constructor
// PC:  if( isAutosave )
//  	SetTimer ( 1, 100*60*autosaveTime );

// PC: Transfer from Mac and Unix to Win - done internally
// PC:  GetText (tmpbuf, MAX_TEXT_LENGTH);
// PC:  something2dos (tmpbuf, MAX_TEXT_LENGTH);
// PC:  SetText (tmpbuf);
// PC:  //MakeTempName();
}

// EvTimer
//
// Waits for an EV_WM_TIMER Message, tries to save the actual editfile
// in the actual XploRe workdirectory, if it fails it uses the windows
// TEMP-Directory.
//
// Autosave will be disabled if it fails at all

// PC: autosave is done internally by the editor
//void TXplEditor::EvTimer( uint TimerId ) //DS 12.99
//{
//	if( !isAutosave || !IsModified() ) return;
//   isAutosave = false;
//	MakeTempName();
//   if ( !Write( tempfilename ) )
//   {
//   	useTmpPath = true;
//      if( !Write( tempfilename ) )
//        statusmessage( "Not able to write autosave file! Autosave disabled!" );
//      else
//        isAutosave = true;
//   }
//   else
//     isAutosave = true;
//   SendMessage(EM_SETMODIFY, 1);
//}

// PC: Paste not necessary - done by editor
//void TXplEditor::CmEditPaste()
//{
//  long oldpos, newpos;
// //      vpos = GetFirstVisibleLine(),
// //      ypos = GetLineFromPos(pos),
// //      xpos = pos-GetLineIndex(ypos);
//  oldpos = GetCurrentPosition();
//  Paste();
//  newpos = GetCurrentPosition();
//  GetText (tmpbuf, MAX_TEXT_LENGTH);
//  something2dos (tmpbuf, MAX_TEXT_LENGTH);
//  SetText (tmpbuf);
////  SetSelection(0,0); // pos,pos);
////  Scroll (xpos, vpos);
//  SetSelection(oldpos,newpos);
//  SendMessage(EM_SCROLLCARET);
//  SendMessage(EM_SETMODIFY, 1);
//}


TXplEditor::~TXplEditor()
{ 
     statusmessage ("");
// kill dialogs
// PC: done by editor destuctor  DeleteFile( tempfilename );
// PC:  delete gld;
     delete mhd;
}

// Page Setup
void TXplEditor::CmFilePageSetup()    // Execute File:Page-setup command
{
     if (Printer) 
          Printer->Setup(this);
}

// ptr!
bool PrintAsPicture = true;	// has to be true by default - graphics printing
char *printheader = NULL;
// PC: char printtext[32550];
char *printtext = NULL;
long textlen = 0;

// PC: 12. 7. 2000: reworked
// main printing routine
void TXplEditor::CmFilePrint()
{
     // setup printer
     if (Printer == NULL)
     {
          Printer = SetUpPrinter(true);		// PC 20010710
	  		 if (Printer == NULL)
               return;
     }

     // obtain the text
     ULONG numlines = GetNumLines();

     if (numlines <= 0)
     {
          MessageBox(XMSG_NO_TEXT_TO_PRINT_STR, XMSG_XPLORE_ERROR_STR, MB_ICONSTOP|MB_OK);
          return;
     }

     // get text buffer
     ULONG textsize = GetTextSize(FALSE, FALSE, FALSE) + 2;	// for CH_EOL
     char *str = new char[textsize];

     if (str == NULL)
     {
          MessageBox(XMSG_NO_MEMORY_TO_PRINT_STR, XMSG_XPLORE_ERROR_STR, MB_ICONSTOP|MB_OK);
          return;
     }

     // get text
     GetEditFileText(str, textsize, FALSE, FALSE);
     strcat(str, "\n");

     // set up printer variables
     printtext = str;
     textlen = strlen(str);
     PrintAsPicture = false;	// have to be false, true is for graphs
     printheader = strdup(GetFileName(TRUE));

     // printtext, textlen must be set!
     // initialize printing object (3rd parameter is zero -> page num not used, numlines used instead)
     TWindowPrintout printout(XMSG_TITLE_PRINT_WIN_STR, this, 0, numlines,
                              &(Printer->GetSetup()).Margin,
                              &(Printer->GetSetup()).PaperSize,
                              (unsigned) Prefs.tab_size,
                              Prefs.fontname, (unsigned) Prefs.fontheight);

     // set print dialog options
     Printer->SetFlags(Printer->GetFlags() | PD_ALLPAGES | PD_NOSELECTION | PD_NOPAGENUMS | PD_USEDEVMODECOPIESANDCOLLATE | PD_SHOWHELP);
     
     //
     // Using OWL's banding support under Win95 _when_ the EXE's marked 4.0
     // (under Options|Project|Linker|General) will cause the print to fail.
     //

     if(!TSystem::IsWin95())
          printout.SetBanding(true);
     Printer->SetBandRect(TRect(0, 0, 500, 500));
     
     printout.ActPage = 1;	// set to 1 = printout should init itself from global print vars
     Printer->Print(this, printout, true);
     printout.ActPage = 1;

     // reset to the original value
     PrintAsPicture = true; 	

     // free resources
     delete[] str;
     printtext = NULL;

     if (printheader)
          delete[] printheader;
     printheader = NULL;
}

// PC: FileSaveAs done internally by editor
//void
//TXplEditor::CmFileSaveAs()  // SK 27.01.98
//{
//  char fn[512];
//  int i, ext;
//  FileData.SetFilter("XploRe quantlet files (*.xpl)|*.xpl|Data files (*.dat)|*.dat|XploRe library files (*.lib)|*.lib|All files (*.*)|*.*|");
//  TFileSaveDialog(this, FileData).DoExecute();
//  strcpy (fn, FileData.FileName);
//  if (fn[0]==0) return;
//  ext = 0;
//  for (i=strlen(fn)-1; i>-1; i--)
//  { if (fn[i]=='.')
//    { ext = 1;
//      break;
//    }
//    if (fn[i]=='\\') break;
//  }
//  if (ext==0)
//  { switch (FileData.FilterIndex)
//    { case 1:
//        strcat (fn, ".xpl");
//        break;
//      case 2:
//        strcat (fn, ".dat");
//        break;
//      case 3:
//        strcat (fn, ".lib");
//        break;
//    }
//  }
//
//  TEditFile::SetFileName (fn);
//// TEditFile::Write(fn);
//  TEditFile::Write();
////  TEditFile::CmFileSaveAs();
//}

// PC: removed for now - what is it good for?
//void TXplEditor::SetFileName( const char far* filename )
//{
//	TEditFile::SetFileName( filename );
//   MakeTempName();
//}

// PC: 30. 5. 2000 function completely rewritten
// execute the file or the selected text
void TXplEditor::CmExecFile()  //SK 10.2.98
{
     if (!TXploreClient::Client->input_child)
          TXploreClient::Client->CmInput();

     ULONG i = GetNumLines();

     if (i > 0)
     {
          ULONG textsize = GetTextSize(FALSE, FALSE, FALSE);
          char *str = new char[textsize];

          if (str == NULL)
               Information(this, GS(MSG_NOT_ENOUGH_MEMORY));
          else // execute
          {
               char *name, backupname[512];

               // backup
               name = getenv ("TEMP");
               if (name)
               { 
                    strcpy(backupname, name);
                    strcat(backupname, "\\");
               }
               else *backupname = '\0';

               strcat(backupname, GetFileName(FALSE));
               strcat (backupname, ".$$$");
               
               (void) CmSaveTempFilename(backupname, FALSE);

               // get text
               GetEditFileText(str, textsize, FALSE, FALSE);

               // PC 20020304 - waiting cursor during executing
               ChangePointer(this, GS(MSG_CONTENT_EXECUTING), TRUE, TRUE);
               TXploreClient::Client->input_child->DoCommand(str, 0);
               ChangePointer(this, this->GetEditFile()->name, FALSE, FALSE);

               // delete buffer
               delete[] str;
          }
     }

     // PC: update highlighting information
     extern BOOL InitHighlightInfo(void);
     if (InitHighlightInfo())
          RedrawWindow();
}

// PC: not needed - done internally by editor
//void TXplEditor::CmGotoLine()
//{
//  long lineno, newlineno;
//
//  lineno = GetLineFromPos(GetCurrentPosition());
//  gld->SetLine (lineno);
//  if (gld->Execute()==IDOK)
//  { newlineno = gld->GetLine();
//	 if (newlineno < 0)
//	 { lineno = -lineno; }
//	 else if (newlineno > GetNumLines())
//	 { lineno = GetNumLines() - lineno; }
//	 else
//	 { lineno = newlineno - lineno; }
//	 if (lineno>0)
//	 {	while (lineno)
//		{ SendMessage (WM_KEYDOWN, VK_DOWN, 1);
//		  lineno--;
//		}
//	 }
//	 else if (lineno<0)
//	 { lineno = -lineno;
//		while (lineno)
//		{ SendMessage (WM_KEYDOWN, VK_UP, 1);
//		  lineno--;
//		}
//	 }
//  }
//}

void TXplEditor::CmMakeHelp()    // SK 10.12.97
{
  char fn[MAXLINELEN], makeascii = 0, makehtml = 1, path[256], *gfn, *tmp,
       *argv[] = {"hlp2html.exe", "C:\XploRe", "filter", "-ascii", "-html"};
  int c, ret, argc, err = 0;
  HCURSOR hc;

  gfn = strdup(GetFileName(TRUE));

  tmp = property.getProperty ("XPL4OUTHELP");
  if (strncmp (&tmp[strlen(tmp)-5], "\\help", 5)==0)
  { tmp[strlen(tmp)-5] = 0;
    mhd->SetParam (gfn, property.getProperty("XPL4OUTHELP"),
                        property.getProperty("XPL4OUTHELP"),
                        makehtml, makeascii);
  }
  else
  { tmp = NULL;
    mhd->SetParam (gfn, property.getProperty("XPL4OUTHELP"), NULL,
                        makehtml, makeascii);
  }

  ret = mhd->Execute();
  mhd->GetParam (fn, &makehtml, &makeascii);

  hc = ::LoadCursor (NULL, IDC_WAIT);
  hc = ::SetCursor (hc);
  if (ret==108)
  { // generate completely new helpsystem
    if (tmp)
    { for (c=ret=0; ret<strlen(gfn); ret++)
        if (ret && (gfn[ret-1]=='\\')) c = ret;
      strcpy (fn, &gfn[c]);
      gfn[c-1] = 0;

      if (fn[0])
      { sprintf (path, "%s\\%s\\%s", tmp, "help", fn);
// PC:        if (Write (path))
        if (CmSaveTempFilename(path, FALSE))
        { argv[1] = tmp;
          argc = 2;
          if (makehtml) argv[argc++] = "-html";
          if (makeascii) argv[argc++] = "-ascii";

          dohlp2html (argc, argv);
        }
      }
      else
        err = 2;
    }
    else
      err = 3;
  }
  else if (ret==103)
  { // generate one or more help file(s)
// PC:    Save();
    CmSave();
    argv[1] = gfn;
//    argv[2] = fn;
//    argc = 3;
    argc = 2;

    if (makehtml)  argv[argc++] = "-html";
    if (makeascii) argv[argc++] = "-ascii";
    dohlp2html (argc, argv);
  }
  ::SetCursor(hc);

  if (err==1) ::MessageBox (NULL, XMSG_ERROR_CANNOT_WRITE_QUANTLET_STR,  XMSG_XPLORE_ERROR_STR, MB_ICONSTOP|MB_OK);
  if (err==2) ::MessageBox (NULL, XMSG_ERROR_NO_QUANTLET_NAME_STR,  XMSG_XPLORE_ERROR_STR, MB_ICONSTOP|MB_OK);
  if (err==3) ::MessageBox (NULL, XMSG_ERROR_CANNOT_CREATE_HELP_STR, XMSG_XPLORE_ERROR_STR, MB_ICONSTOP|MB_OK);

  delete[] gfn;
}

// PC: not needed - see setfilepos
//const int CN_UPDATE             = 300;
//char linemsg[256];

// PC: now done inside the editor
//void TXplEditor::setfilepos()
//{
//// PC: lno and pos changed to ulong
//     ULONG lno, pos;
//  
//// PC:  pos = GetCurrentPosition();
//     pos = GetCursorCol();
//// PC:  lno = GetLineFromPos(pos);
//     lno = GetCursorLine();
//// PC:  sprintf (linemsg, "%s (%i,%i)", GetFileName(), 1+lno, pos-GetLineIndex(lno)+1);
//     sprintf (linemsg, "%s (%lu,%lu)", GetFileName(TRUE), lno, pos);
//
//     statusmessage (linemsg);
//}
//
//void TXplEditor::EvKeyDown(uint key, uint repeatCount, uint flags)
//{
//// PC:  TEdit::EvKeyDown(key, repeatCount, flags);
//     TEditFile::EvKeyDown(key, repeatCount, flags);
//     Parent->SendNotification(Attr.Id, CN_UPDATE, HWindow);
//
//     setfilepos();
//}

// PC: added in order to check syntax highlighting strings
void TXplEditor::EvSetFocus(HWND hWndLostFocus)
{
     extern BOOL InitHighlightInfo(void);

     TEditFile::EvSetFocus(hWndLostFocus);

     if (InitHighlightInfo())
          RedrawWindow();
}

// PC 7. 7. 2000: rewritten completely
void TXplEditor::CmFormatSource()
{
     ULONG numlines;
     ULONG textsize = GetTextSize(FALSE, TRUE, TRUE) + 4;
     ULONG curline = GetCursorLine(), curcol = GetCursorCol();
     long nb = 0, ab = 0, spaces, newline, i;
     int fchar;
#define FORMAT_INSLEN      256
     char insert[FORMAT_INSLEN + 4];
     char *word = new char[textsize];
     
     char s1[]="proc";
     char s2[]="if";
     char s3[]="else";
     char s4[]="while";
     char s5[]="do";
     char s7[]="case";
     char s6[]="switch";
     char s8[]="default";
     char c1[]="endp";
     char c2[]="endif";
     char c3[]="endo";
     char c4[]="until";
     char c5[]="endsw";
     char leer[]=" ";
     
     if (word == NULL)
     {
          MessageBox(XMSG_NO_MEMORY_TO_PRINT_STR, XMSG_XPLORE_ERROR_STR, MB_ICONSTOP|MB_OK);
          return;
     }

     CmKeyboard(IDK_KEYB_BEGFILE); // two times - for the case of selected block
     CmKeyboard(IDK_KEYB_BEGFILE);

     for(numlines = GetNumLines(); numlines > 0; numlines--)
     {
          BOOL emptyline = TRUE;
          char *pomuk;

          GetEditFileText(word, textsize, FALSE, TRUE);

          for(pomuk = word; *pomuk; pomuk++)
               if ((32 < *pomuk) && (*pomuk <= 127))
                    emptyline = FALSE;

          if (NOT emptyline)
          {
               // remove white spaces?
               fchar = GetCursorChar();
               if ((fchar == ' ') || (fchar == '\t'))
                    CmKeyboard(IDK_KEYB_DELNEXTWORD);

               // get first word & analyze offset
               newline = 0;
               spaces = 0;

               fchar = GetCursorChar();
               if (fchar != '\n')
               {
                    int nlnec = 0, wordlen = 0;

                    // line to be read once again - without spaces
                    GetEditFileText(word, textsize, FALSE, TRUE);

                    // PC 20010719 - get word len
                    for(pomuk = word; *pomuk; pomuk++)
                      if (isalpha(*pomuk))
                           wordlen++;
                      else break;

                    if ((strncmp(word, s1, strlen(s1)) == 0) && (wordlen == strlen(s1)))
                    {
                         if(isalnum(word[strlen(s1)]) == 0)
                              nb += 2;
                    }
                    if ((strncmp(word, c1, strlen(c1)) == 0) && (wordlen == strlen(c1)))
                    {
                         nlnec = !isalnum(word[strlen(c1)]);

                         if(nlnec)
                         {
                              ab -= 2;
                              nb -= 2;
                         }
                    }
                    if ((strncmp(word, s2, strlen(s2)) == 0) && (wordlen == strlen(s2)))
                    {
                         nb += 2;
                    }
                    if ((strncmp(word, s3, strlen(s3)) == 0) && (wordlen == strlen(s3)))
                    {
                         ab -= 2;
                    }
                    if ((strncmp(word, c2, strlen(c2)) == 0) && (wordlen == strlen(c2)))
                    {
                         ab -= 2;
                         nb -= 2;
                    }
                    if ((strncmp(word, s4, strlen(s4)) == 0) && (wordlen == strlen(s4)))
                    {
                         nb += 2;
                    }
                    if ((strncmp(word, c3, strlen(c3)) == 0) && (wordlen == strlen(c3)))
                    {
                         ab -= 2;
                         nb -= 2;
                    }
                    if ((strncmp(word, s5, strlen(s5)) == 0) && (wordlen == strlen(s5)))
                    {
                         nb += 2;
                    }
                    if ((strncmp(word, c4, strlen(c4)) == 0) && (wordlen == strlen(c4)))
                    {
                         ab -= 2;
                         nb -= 2;
                    }
                    if ((strncmp(word, s6, strlen(s6)) == 0) && (wordlen == strlen(s6)))
                    {
                         nb += 2;
                    }
                    if ((strncmp(word, s7, strlen(s7)) == 0) && (wordlen == strlen(s7)))
                    {
                         ab -= 2;
                    }
                    if ((strncmp(word, s8, strlen(s8)) == 0) && (wordlen == strlen(s8)))
                    {
                         ab -= 2;
                    }
                    if ((strncmp(word, c5, strlen(c5)) == 0) && (wordlen == strlen(c5)))
                    {
                         ab -= 2;
                         nb -= 2;
                    }
                    if (strncmp(word, ";", 1) == 0)
                         ab = 0;
                    if (strncmp(word, "//", 2) == 0)
                         ab = 0;

                    spaces = ab;
//                         ignored for now...
//                         if (nlnec)
//                              newline = 1;
                    ab = nb;
               }

               // offset the line by the appropriate number of spaces
               for(i = 0; (i < spaces) && (i < FORMAT_INSLEN); i++)
                    insert[i] = ' ';
               insert[i] = '\0';
                    
               InsertEditFileText(insert, FALSE);

               // create newline? - not done at all
//               if (newline)
//               {
//                    CmKeyboard(IDK_KEYB_END);
//                    EvChar(VK_RETURN, 1, 0);
//               }
          }
          
          // move to the next line
          CmKeyboard(IDK_KEYB_HOME);
          CmKeyboard(IDK_KEYB_DOWN);
     }

     // return to the original position
     CmGotoGivenLine(curline);
     CmGotoGivenColumn(curcol);

     if (word)
          delete[] word;
}

#define TRENNER "; ---------------------------------------------------------------------\r\n"

int build_help (char *inbuf, char *outbuf, int maxlen)
{ int j, k, pos[5] = {-1, -1, -1, -1, -1};
  bool listout;
  char *user;

// PC: nobody takes care about maxlen of the output buffer!!!

  if (strncmp(inbuf, "proc(", 5)!=0) return 0;
  for (k=j=0; j<strlen(inbuf); j++)
  { switch (k)
    { case 0: if (inbuf[j]=='(') pos[k++] = j;
              break;
      case 1: if (inbuf[j]==')') pos[k++] = j;
              break;
      case 2: if (inbuf[j]=='=') pos[k++] = j;
              break;
      case 3: if (inbuf[j]=='(') pos[k++] = j;
              break;
      case 4: if (inbuf[j]==')') pos[k++] = j;
              break;
    }
  }
  if (pos[4]<0) return 1;

  outbuf[0] = 0;
  strcat  (outbuf, TRENNER);
  strcat  (outbuf, "; Library     \r\n");
  strcat  (outbuf, TRENNER);
  strcat  (outbuf, "; See_also    \r\n");
  strcat  (outbuf, TRENNER);
  strcat  (outbuf, "; Macro       ");
  strncat (outbuf, &inbuf[pos[2]+1], pos[3]-pos[2]-1);
  strcat  (outbuf, "\r\n");
  strcat  (outbuf, TRENNER);
  strcat  (outbuf, "; Description \r\n");
  strcat  (outbuf, TRENNER);
  strcat  (outbuf, "; Usage       ");
//  strcat  (outbuf, &inbuf[4]);
// PC 20010719 - improved version of "usage" section
  // is there an output list or just one variable
  if (pos[0]+1<pos[1])
  {
    listout = false;
    for (j=pos[0]; j<=pos[1]; j++)
    {
      if (inbuf[j]==',')
        listout = true;
    }
  }
  else listout = false;

  // print "usage" section
  if (pos[0]+1<pos[1])
  {
    if (listout)
      strcat (outbuf, "{");
    strncat (outbuf, inbuf + pos[0] + 1, pos[1] - pos[0] - 1);
    if (listout)
      strcat (outbuf, "}");
    strcat (outbuf, " = ");
  }
  if (pos[2] + 1 <= pos[4])
    strncat (outbuf, inbuf + pos[2] + 1, pos[4] - pos[2]);

  strcat  (outbuf, "\r\n");
  strcat  (outbuf, "; Input       \r\n");
  if (pos[3]+1<pos[4])
  { for (k=j=pos[3]; j<=pos[4]; j++)
    { if ((inbuf[j]==',') || (inbuf[j]==')'))
      { strcat  (outbuf, "; Parameter   ");
        strncat (outbuf, &inbuf[k+1], j-k-1);
        strcat  (outbuf, "\r\n");
        strcat  (outbuf, "; Definition  \r\n");
        k=j;
      }
    }
  }
  strcat  (outbuf, "; Output      \r\n");
  if (pos[0]+1<pos[1])
  { for (k=j=pos[0]; j<=pos[1]; j++)
    { if ((inbuf[j]==',') || (inbuf[j]==')'))
      { strcat  (outbuf, "; Parameter   ");
        strncat (outbuf, &inbuf[k+1], j-k-1);
        strcat  (outbuf, "\r\n");
        strcat  (outbuf, "; Definition  \r\n");
        k=j;
      }
    }
  }
  strcat (outbuf, TRENNER);
  strcat (outbuf, "; Notes       \r\n");
  strcat (outbuf, TRENNER);
  strcat (outbuf, "; Example     \r\n");
  strcat (outbuf, TRENNER);
  strcat (outbuf, "; Result      \r\n");
  strcat (outbuf, TRENNER);
  strcat (outbuf, "; Keywords    \r\n");
  strcat (outbuf, TRENNER);
  strcat (outbuf, "; Reference   \r\n");
  strcat (outbuf, TRENNER);
  strcat (outbuf, "; Link        \r\n");
  strcat (outbuf, TRENNER);
  strcat (outbuf, "; Author      ");
  user = ::getenv ("USERNAME");
  if (user) strcat (outbuf, user);
  strcat (outbuf, "\r\n");
  strcat (outbuf, TRENNER);
  return 2;
}

void
TXplEditor::CmInsertHelp()
{
// maximum length of the line with proc definition
#define PROCLINELENGTH   4096
// maximum size of the inserted help
#define INSHELPSIZE      32000
     ULONG textsize = GetTextSize(FALSE, TRUE, TRUE);
     long i, j, k, lineno, res = 0;
     char *ostr = new char[(textsize >= INSHELPSIZE) ? textsize : INSHELPSIZE], *lstr = new char[PROCLINELENGTH];

     if ((ostr == NULL) || (lstr == NULL))
     {
          if (ostr) delete[] ostr;
          if (lstr) delete[] lstr;
          
          Information(this, GS(MSG_NOT_ENOUGH_MEMORY));
          return;
     }
               
     // we have to place cursor to the beginning of the line before insertion
     CmKeyboard(IDK_KEYB_HOME);    // done two times - just for the case of selected block
     CmKeyboard(IDK_KEYB_HOME);
     lineno = (long) GetCursorLine();

     for (i = lineno; (i > 0) && (res == 0); i--)
     { 
       // get the line content
          GetEditFileText(ostr, textsize, FALSE, TRUE);
          j = 0;

       // Build line and clean all whitespaces
          for (k = 0; (ostr[j] != '\n') && (ostr[j] != 0) && k + 1 < PROCLINELENGTH; j++)
          { 
               if ((ostr[j]!=' ') && (ostr[j]!='\t') && (ostr[j]!='\r') && (ostr[j]!='\n'))
                    lstr[k++] = ostr[j];
          }
          lstr[k] = 0;
          
          res = build_help(lstr, ostr, INSHELPSIZE);

          if (res==1)
          { 
               sprintf (ostr, XMSG_INCORRECT_QUANTLET_DEFINITION_STR, i, lstr);
               ::MessageBox (NULL, ostr, XMSG_XPLORE_ERROR_STR,
               MB_APPLMODAL | MB_ICONEXCLAMATION | MB_OK | MB_SETFOREGROUND);
          }
          else if (res==2)
          { 
               CmKeyboard(IDK_KEYB_DOWN);
               InsertEditFileText(ostr, FALSE);
          }
          else CmKeyboard(IDK_KEYB_UP);
     }
     
     // delete char arrays
     delete[] ostr;
     delete[] lstr;
}

void TXplEditor::CmOpenMacro()
{ 
     TXploreClient::Client->FileOpen(NULL); 
}

// PC: not needed - done internally by editor
//bool TXplEditor::CanClose()
//{
//  if (IsModified())
//  { char msg[256];
//    int ret;
//    sprintf (msg, "%s\r\nhas changed, save it ?", GetFileName());
//    ret = MessageBox(msg, "Save", MB_ICONQUESTION|MB_YESNOCANCEL|MB_SETFOREGROUND);
//    if (ret==IDYES)
//    { if (strcmp("noname.xpl", GetFileName())==0)
//        CmFileSaveAs();
//      else
//        Write();
//    }
//    else if (ret==IDCANCEL)
//      return (false);
//  }
//  return (true);
//}

//----- EditorWindow

TXplEditorWindow::TXplEditorWindow(TXploreClient& MDIclient, char* title, TWindow* client, int where)
: TMDIChild(MDIclient,title,client)
{ //int x, y, w, h;
     TRect parViewable(MDIclient.GetClientRect());

     winid = wpm.getwin (where, &parViewable);	// PC 20011211: remember position
     Attr.X=TXploreClient::profile->GetInt("EditorX", parViewable.Left());
     Attr.Y=TXploreClient::profile->GetInt("EditorY", parViewable.Top());
     Attr.W=TXploreClient::profile->GetInt("EditorW", parViewable.Width());
     Attr.H=TXploreClient::profile->GetInt("EditorH", parViewable.Height());

     SetBkgndColor(TColor::LtGray);

     SetIcon(myapp, AAA32);
     SetIconSm(myapp, AAA32);
//SWS 23.2.98 BEGIN
     HFONT tfont=(HFONT) GetStockObject(SYSTEM_FIXED_FONT);
     SetWindowFont(tfont, FALSE);
//SWS 23.2.98 END
// PC: changed to fileditaccel
     Attr.AccelTable = "FILEEDITACCEL";
}

TXplEditorWindow::~TXplEditorWindow() {
		/*	TXploreClient::profile->WriteInt("EditorX", Attr.X);
			TXploreClient::profile->WriteInt("EditorY", Attr.Y);
			TXploreClient::profile->WriteInt("EditorW", Attr.W);
			TXploreClient::profile->WriteInt("EditorH", Attr.H);
		*/

     wpm.removeedwinid(winid);	// PC 20011211: free position

     //  delete lineno;
}

//-------------------------------------------------------------------
//                       TLibEditor class
//-------------------------------------------------------------------


DEFINE_RESPONSE_TABLE1(TLibEditor, TEditFile)
// PC: print, save, open, gotoline, keydown - commented, not needed for the new editor
	 EV_COMMAND(CM_FILEPRINT, CmFilePrint),
	 EV_COMMAND(CM_FILEPAGESETUP, CmFilePageSetup),
// PC: 	 EV_COMMAND(CM_FILESAVEAS, CmFileSaveAs),
// PC:	 EV_COMMAND(CM_GOTOLINE, CmGotoLine),
    EV_COMMAND(CM_OPENMACRO, CmOpenMacro),
// PC:   EV_WM_KEYDOWN,
    EV_WM_SETFOCUS,	// PC 29.5.2000
END_RESPONSE_TABLE;

// PC: TLibEditor::TLibEditor(char *filename) : TEditFile(0,0,0,0,0,0,0,filename)
TLibEditor::TLibEditor(char *filename) : TEditFile()
{ int x, y, w, h;

/*  wpm.getwin (WIN_EDIT, &x, &y, &w, &h);
  Attr.X=TXploreClient::profile->GetInt("EditorX", x);
  Attr.Y=TXploreClient::profile->GetInt("EditorY", y);
  Attr.W=TXploreClient::profile->GetInt("EditorW", w);
  Attr.H=TXploreClient::profile->GetInt("EditorH", h);
*/
 //editor = new TEditFile(this,0,0,0,0,0,0,filename);

 //SWS 23.2.98 BEGIN
     HFONT tfont=(HFONT) GetStockObject(SYSTEM_FIXED_FONT);
     TWindow::SetWindowFont(tfont, TRUE);
//	SetBkgndColor(TColor::LtGray);
 //SWS 23.2.98 END
// PC:  FileData.SetFilter("XploRe macro files (*.xpl)|*.xpl|Data files (*.dat)|*.dat|All files (*.*)|*.*|");
     SetFilter(XMSG_XPL_EDITOR_FILE_FILTER_STR);
     
// Make dialogs
// PC:  gld    = new TGotoLineDialog (this);

     // PC: init highlighting information
     extern BOOL InitHighlightInfo(void);
     (void) InitHighlightInfo();

// PC: open file
//  if (filename) SetFileName(filename);
     if (filename)
          CmOpenFilename(filename);
}

void TLibEditor::SetupWindow()
{ 
     TEditFile::SetupWindow();
  //SWS 23.2.98 BEGIN
     HFONT tfont=(HFONT) GetStockObject(SYSTEM_FIXED_FONT);
     TWindow::SetWindowFont(tfont, TRUE);
     
// PC: not needed anymore - editor handles tabs and EOLs
//  int i;
//  if (tabs==NULL)
//  {	tabs = new int [10];
//		for (i=0; i<10; i++)
//  			tabs[i]=8*i;
//  }
//  SetTabStops(10, tabs);
// set in constructor

// PC:	SetBkgndColor(TColor::LtBlue);

// init global printer object
     if (Printer == NULL)
          Printer = SetUpPrinter(false);	// PC 20010710

// Transfer from Mac and Unix to Win - done internally by editor
//  PC: conversion not needed
//  GetText (tmpbuf, MAX_TEXT_LENGTH);
//  something2dos (tmpbuf, MAX_TEXT_LENGTH);
//  SetText (tmpbuf);
}


TLibEditor::~TLibEditor() {
     statusmessage ("");
// kill dialogs
// PC:     delete gld;
}

// Page Setup
void TLibEditor::CmFilePageSetup()    // Execute File:Page-setup command
{
     if (Printer) 
          Printer->Setup(this); 
}

// PC: 12. 7. 2000: reworked
// main printing routine
void TLibEditor::CmFilePrint()
{
     // setup printer
     if (Printer == NULL)
     {
          Printer = SetUpPrinter(true);	// PC 20010710
          if (Printer == NULL)
               return;
     }

     // obtain the text
     ULONG numlines = GetNumLines();

     if (numlines <= 0)
     {
          MessageBox(XMSG_NO_TEXT_TO_PRINT_STR, XMSG_XPLORE_ERROR_STR, MB_ICONSTOP|MB_OK);
          return;
     }

     // get text buffer
     ULONG textsize = GetTextSize(FALSE, FALSE, FALSE) + 2;	// for CH_EOL
     char *str = new char[textsize];

     if (str == NULL)
     {
          MessageBox(XMSG_NO_MEMORY_TO_PRINT_STR, XMSG_XPLORE_ERROR_STR, MB_ICONSTOP|MB_OK);
          return;
     }

     // get text
     GetEditFileText(str, textsize, FALSE, FALSE);
     strcat(str, "\n");

     // set up printer variables
     printtext = str;
     textlen = strlen(str);
     PrintAsPicture = false;	// have to be false, true is for graphs
     printheader = strdup(GetFileName(TRUE));

     // printtext, textlen must be set!
     // initialize printing object (3rd parameter is zero -> page num not used, numlines used instead)
     TWindowPrintout printout(XMSG_TITLE_PRINT_WIN_STR, this, 0, numlines,
                              &(Printer->GetSetup()).Margin,
                              &(Printer->GetSetup()).PaperSize,
                              (unsigned) Prefs.tab_size,
                              Prefs.fontname, (unsigned) Prefs.fontheight);

     // set print dialog options
     Printer->SetFlags(Printer->GetFlags() | PD_ALLPAGES | PD_NOSELECTION | PD_NOPAGENUMS | PD_USEDEVMODECOPIESANDCOLLATE | PD_SHOWHELP);
     
     //
     // Using OWL's banding support under Win95 _when_ the EXE's marked 4.0
     // (under Options|Project|Linker|General) will cause the print to fail.
     //

     if(!TSystem::IsWin95())
          printout.SetBanding(true);
     Printer->SetBandRect(TRect(0, 0, 500, 500));
     
     printout.ActPage = 1;	// set to 1 = printout should init itself from global print vars
     Printer->Print(this, printout, true);
     printout.ActPage = 1;

     // reset to the original value
     PrintAsPicture = true; 	

     // free resources
     delete[] str;
     printtext = NULL;

     if (printheader)
          delete[] printheader;
     printheader = NULL;
}

// PC: not needed - done internally by editor
//void TLibEditor::CmFileSaveAs()  // SK 27.01.98
//{
//  char fn[512];
//  int i, ext;
//  FileData.SetFilter("XploRe quantlet files (*.xpl)|*.xpl|Data files (*.dat)|*.dat|XploRe library files (*.lib)|*.lib|All files (*.*)|*.*|");
//  TFileSaveDialog(this, FileData).DoExecute();
//  strcpy (fn, FileData.FileName);
//  if (fn[0]==0) return;
//  ext = 0;
//  for (i=strlen(fn)-1; i>-1; i--)
//  { if (fn[i]=='.')
//    { ext = 1;
//      break;
//    }
//    if (fn[i]=='\\') break;
//  }
//  if (ext==0)
//  { switch (FileData.FilterIndex)
//    { case 1:
//        strcat (fn, ".xpl");
//        break;
//      case 2:
//        strcat (fn, ".dat");
//        break;
//      case 3:
//        strcat (fn, ".lib");
//        break;
//    }
//  }
//
//  TEditFile::SetFileName (fn);
//  TEditFile::Write(fn);
//   //  TEditFile::CmFileSaveAs();
//}

// PC: not needed - done internally by editor
//void TLibEditor::CmGotoLine()
//{
//  long lineno, newlineno;
//
//  lineno = GetLineFromPos(GetCurrentPosition());
//  gld->SetLine (lineno);
//  if (gld->Execute()==IDOK)
//  { newlineno = gld->GetLine();
//	 if (newlineno < 0)
//	 { lineno = -lineno; }
//	 else if (newlineno > GetNumLines())
//	 { lineno = GetNumLines() - lineno; }
//	 else
//	 { lineno = newlineno - lineno; }
//	 if (lineno>0)
//	 {	while (lineno)
//		{ SendMessage (WM_KEYDOWN, VK_DOWN, 1);
//		  lineno--;
//		}
//	 }
//	 else if (lineno<0)
//	 { lineno = -lineno;
//		while (lineno)
//		{ SendMessage (WM_KEYDOWN, VK_UP, 1);
//		  lineno--;
//		}
//	 }
//  }
//*/
//}

// PC: moved to the editor itself
//void TLibEditor::setfilepos()
//{
//// PC: lno and pos changed to long
//     ULONG lno, pos;
//  
//// PC:  pos = GetCurrentPosition();
//     pos = GetCursorCol();
//// PC:  lno = GetLineFromPos(pos);
//     lno = GetCursorLine();
//// PC:  sprintf (linemsg, "%s (%i,%i)", GetFileName(), 1+lno, pos-GetLineIndex(lno)+1);
//     sprintf (linemsg, "%s (%lu,%lu)", GetFileName(TRUE), lno, pos);
//     
//     statusmessage (linemsg);
//}
//
//void TLibEditor::EvKeyDown(uint key, uint repeatCount, uint flags)
//{
//// PC:  TEdit::EvKeyDown(key, repeatCount, flags);
//     TEditFile::EvKeyDown(key, repeatCount, flags);
//     Parent->SendNotification(Attr.Id, CN_UPDATE, HWindow);
//
//     setfilepos();
//}

void TLibEditor::CmOpenMacro()
{
     ULONG linesize = GetCurrentLineLength();
     char *str = new char[linesize + 4];     // we need space for CH_EOL & \0
     char filename[512];
     int i, j, mode;

     if (str == NULL)
     {
          Information(this, GS(MSG_NOT_ENOUGH_MEMORY));
          return;
     }
               
     // get line
     GetEditFileText(str, linesize + 4, FALSE, TRUE);
     
     for (mode = j = i = 0; (i < strlen(str)) && (mode < 2); i++)
     { 
          switch (mode)
          { 
               case 0:
                    if ((str[i]!=' ') && (str[i]!='\t'))
                    { 
                         if (isalpha(str[i]))
                         { 
                              str[j++] = str[i];
                              mode = 1;
                         }
                         else mode = 2;
                    }
                    break;

               case 1:
                    if (isalnum(str[i]))
                         str[j++] = str[i];
                    else mode = 2;
                    break;
          }
     }
     str[j] = 0;

     if (strlen(str))
     { 
          strcpy(filename, GetFileName(TRUE));
          
          for (i = strlen(filename); i > -1; i--)
          { 
               if ((filename[i]==':') || (filename[i]=='\\')) 
                    break; 
          }
          filename[i+1] = 0;
          strcat (filename, str);
          strcat (filename, ".xpl");
          
          TXploreClient::Client->FileOpen(filename);
     }
     else TXploreClient::Client->FileOpen(NULL);

     delete[] str;
}

// PC: added in order to check syntax highlighting strings
void TLibEditor::EvSetFocus(HWND hWndLostFocus)
{
     extern BOOL InitHighlightInfo(void);

     TEditFile::EvSetFocus(hWndLostFocus);

     if (InitHighlightInfo())
          RedrawWindow();
}

// PC: handled internally by editor
//bool TLibEditor::CanClose()
//{
//  if (IsModified())
//  { char msg[256];
//    int ret;
//    sprintf (msg, "%s\r\nhas changed, save it ?", GetFileName());
//    ret = MessageBox(msg, "Save", MB_ICONQUESTION |MB_YESNOCANCEL|MB_SETFOREGROUND);
//    if (ret==IDYES)
//      Write();
//    else if (ret==IDCANCEL)
//      return (false);
//  }
//  return (true);
//}


//----------------- TXploreClient ----------------------------------
//----------------- TXploreClient ----------------------------------
//----------------- TXploreClient ----------------------------------

DEFINE_RESPONSE_TABLE1(TXploreClient, TMDIClient)
  EV_COMMAND(CM_INPUT, CmInput),
  EV_WM_PAINT,
  EV_COMMAND(CM_FILENEW, CmFileNew),
    EV_COMMAND(CM_FILEOPEN, CmFileOpen),
    EV_COMMAND(CM_OPENMACRO, CmFileOpen),//ds
  EV_COMMAND(CM_OPENDATA, CmDataOpen),
  EV_COMMAND(CM_DISPLAY, CmDisplay),
  EV_COMMAND(CM_FUNCTIONLIST, CmFunctionList),
  EV_COMMAND(CM_OBJECTLIST, CmObjectList),
  EV_COMMAND(CM_MACROLIST, CmMacroList),
  //  EV_COMMAND(CM_FILESAVEAS, CmFileSaveAs),
  EV_COMMAND(CM_ABOUT, CmAbout),
  EV_COMMAND(CM_INFO, CmInfo),   //SWS 27.1.98
  EV_COMMAND(CM_ERASEXPLOREOUTPUT, CmClearOutput),   // PC 20010420

  EV_COMMAND(CM_HELPCONTENTS, CmHelpContents),
  EV_COMMAND(CM_AUTOSAVE, CmAutosave), // DS 15.12.99
// SWS 5.6.98      EV_COMMAND(CM_HELPOVERVIEW, CmHelpOverview),
// SWS 5.6.98    EV_COMMAND(CM_HELPFUNINDEX, CmHelpFunIndex),
// SWS 5.6.98  EV_COMMAND(CM_HELPMACROINDEX, CmHelpMacroIndex),
// SWS 5.6.98      EV_COMMAND(CM_HELPTUTORIALS, CmHelpTutorials),
// SWS 5.6.98    EV_COMMAND(CM_HELPHOMEPAGE, CmHelpHomePage),
  EV_WM_DROPFILES,	// PC 20020927
END_RESPONSE_TABLE;

TXploreClient::TXploreClient() : TMDIClient() {
			 Attr.Style |= WS_TABSTOP;
			 Client=this;
			 FunctionList = ObjectList = MacroList = 0;
			 input_child=0;
			 profile=new TProfile("MDI","xplore_old.ini");
			 FileData.SetFilter("XploRe quantlet files (*.xpl)|*.xpl|Data files (*.dat)|*.dat|XploRe library files (*.lib)|*.lib|All files (*.*)|*.*");
			 xpl4homewin = new char[100];
			 getcwd(xpl4homewin, 100);
                         autosaveTime = 5;
                         isAutosave = true;
//			 profile->GetString("HOME", xpl4homewin, 100, "C:\\XPLORE4");
 //			 freopen("OUTPUT.TXT", "w", stdout);

//			 cout.close();
}

TXploreClient::~TXploreClient()  {
	delete xpl4homewin;
	CloseChildren();

	if (FunctionList) {
		delete FunctionList;
		FunctionList = 0;
	}
	if (ObjectList) {
		delete ObjectList;
		ObjectList = 0;
	}
	if (MacroList) {
		delete MacroList;
		MacroList = 0;
	}

	 if (profile) {
		 //	 delete profile;
		 //profile = 0;
	 }

}

extern "C" void startup(char *argv0);

//TMDIChild *labelchild;
//TStatic *labelstatic;

extern int argc;
extern char** argv;
extern void X4Start (int argc, char **argv);

void TXploreClient::EvPaint()
{
  TMDIClient::EvPaint();
  this->CmInput();
  this->CmInitEditorFiles();	// PC 20010216
}

// PC 20020927
void TXploreClient::EvDropFiles(TDropInfo dropInfo)
{
#define DROPFILENAMELEN 1024
  char name[DROPFILENAMELEN+4];
  uint i, nfiles = dropInfo.DragQueryFile(0xFFFFFFFF, name, DROPFILENAMELEN);

  for (i = 0; i < nfiles; i++)
  {
    dropInfo.DragQueryFile(i, name, DROPFILENAMELEN);
    FileOpen(name);
  }

  dropInfo.DragFinish();
}

void TXploreClient::SetupWindow() {
  TWindow::SetupWindow();
  DragAcceptFiles(true);
//  SetBkgndColor(55);

   /*  int x=50;
      int y=50;
  labelchild=new TMDIChild(*TXploreClient::Client,"HIHI");
          labelchild->Create();
          	labelchild->Attr.X=100;//child->Attr.X+x;
   	labelchild->Attr.Y=100; //child->Attr.Y+y;
   	labelchild->Attr.W=100;
   	labelchild->Attr.H=100;
      labelstatic=new TStatic(this, -1, "uhu", 0, 0, 100 , 100);
     labelstatic->SetText("Hallo Hallo");
     labelchild->ShowWindow(SW_SHOW);
	*/
}

 bool TXploreClient::CloseChildren() {
	bool alldeleted = TMDIClient::CloseChildren();
	if (!alldeleted) {
       return false;
 	}
   return true;
}

bool closeall=false; // fuer selectitem und readvalue
bool isrunning=false;

bool
TXploreClient::CanClose()
{
    if (isrunning)
 	 {	MessageBox(XMSG_CLOSE_SELECT_ITEM_STR, XMSG_XPLORE_SORRY_STR,
							 MB_OK);
    	return false;
    }

	 switch(MessageBox(XMSG_WANT_TO_QUIT_STR, XMSG_XPLORE_QUESTION_STR,
							 MB_YESNO | MB_ICONQUESTION)) {
		case IDNO:
		  return false;
		case IDYES:
      	return true;
 	}
  return true;
 }

void
TXploreClient::CmFileNew()
{
	 TXplEditor* editor = new TXplEditor( 0,isAutosave, autosaveTime );
	 TMDIChild *ed = new TXplEditorWindow(*this,XMSG_EDITOR_WIN_NAME_STR,editor,WIN_EDIT);
 // char title[25]="XploRe Editor";
	 ed->SetMenuDescr(TMenuDescr(501, 1, 2, 0, 0, 0, 0));
	 ed->Create();
    editor->Create();
// PC: not needed, handled by editor    editor->SetFileName("noname.xpl");
    editor->setfilepos();
}

long FileLength (char *fname)
{ long size;
  HANDLE hndl = CreateFile (fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
                            FILE_ATTRIBUTE_NORMAL, NULL);
  if (hndl==INVALID_HANDLE_VALUE) return (-1);
  size = GetFileSize(hndl, NULL);
  if (size == 0xFFFFFFFF) return (-2);
  CloseHandle(hndl);
  return (size);
}

void TXploreClient::FileOpen (char *fname)
{ long size;
  FileData.SetFilter(XMSG_XPLLIB_EDITOR_FILE_FILTER_STR);
  *FileData.FileName = 0;
  if ((fname!=NULL) || (TFileOpenDialog(this, FileData).Execute() == IDOK))
  { char fn[512];
    int i, ext;
    if (fname==NULL)
      strcpy (fn, FileData.FileName);
    else
      strcpy (fn, fname);
    ext = 0;
    for (i=strlen(fn)-1; i>-1; i--)
    { if (fn[i]=='.')
      { ext = 1;
        break;
      }
      if (fn[i]=='\\') break;
    }
    if ((ext==0) && (FileData.FilterIndex==1)) strcat (fn, ".xpl");
    if ((ext==0) && (FileData.FilterIndex==2)) strcat (fn, ".lib");

    i = strlen(fn);
    size = FileLength(fn);
// PC: no need for size check   if ((size>-1) && (size < 32700))
    if (size>-1)
    {
      if ((i>4) && (stricmp(&fn[i-4], ".lib")==0))
      {
        TLibEditor *editor = new TLibEditor(fn);
        TMDIChild *ed = new TXplEditorWindow(*this, "", editor, WIN_LIB);
        ed->SetMenuDescr(TMenuDescr(701, 1, 2, 0, 0, 0, 0));

	     ed->Create();
        HFONT tfont=(HFONT) GetStockObject(SYSTEM_FIXED_FONT);
        ed->SetWindowFont(tfont, FALSE);
        editor->setfilepos();
      }
      else
      {
        TXplEditor *editor = new TXplEditor(fn, isAutosave, autosaveTime );
        TMDIChild *ed = new TXplEditorWindow(*this, "", editor, WIN_EDIT);
        ed->SetMenuDescr(TMenuDescr(501, 1, 2, 0, 0, 0, 0));

	     ed->Create();
        HFONT tfont=(HFONT) GetStockObject(SYSTEM_FIXED_FONT);
        ed->SetWindowFont(tfont, FALSE);
/* PC: the rest is done by the construtor of editor
        if (fname) editor->SetFileName(fname);
        editor->Read(fname);
        editor->GetText (tmpbuf, MAX_TEXT_LENGTH);    // SK 18.04.2000
        something2dos (tmpbuf, MAX_TEXT_LENGTH);
        editor->SetText (tmpbuf);
*/
        editor->setfilepos();
      }
    }
    else if (size==-1)
      ::MessageBox (NULL, XMSG_CANNOT_OPEN_FILE_STR,  XMSG_XPLORE_ERROR_STR, MB_ICONSTOP|MB_OK);
    else if (size==-2)
      ::MessageBox (NULL, XMSG_CANNOT_GET_FILESIZE_STR,  XMSG_XPLORE_ERROR_STR, MB_ICONSTOP|MB_OK);
    else
      ::MessageBox (NULL, XMSG_FILE_TOO_LARGE_STR,  XMSG_XPLORE_ERROR_STR, MB_ICONSTOP|MB_OK);
  }
}

void
TXploreClient::CmFileOpen()
{ FileOpen(NULL); }

void
TXploreClient::CmDataOpen()
{ char str[1024];

  *FileData.FileName = 0;
  FileData.InitialDir = property.getProperty("XPL4DATAOUT");
  FileData.SetFilter(XMSG_DATA_FILE_FILTER_STR);
  if (TFileOpenDialog(this, FileData).Execute() == IDOK) {
	 sprintf (str, "noname=read(\"%s\")", FileData.FileName);
	 input_child->DoCommand (str, 1);
    //SK 18.05.99
    /*
    BringWindowToTop();
    SetActiveWindow();
    SetFocus();
    */
  }
}

void
TXploreClient::CmInput()
{
	 if (Input) return;

    Input = new TInput(*this);
	 Input->SetMenuDescr(TMenuDescr(101,0,0,0,0,0,0));
	 Input->SetCaption(XMSG_INPUT_WIN_CAPTION_STR);

	 Input->Create();

	 Input->TInput::CmOutput();  //Creates Output window (with Input)
    X4Start(argc, argv);
    startup(argv[0]);
}

void
TXploreClient::CmInitEditorFiles() // PC 20010216
{
  if (initeditorfiles)
    return;
  initeditorfiles = true;

  // PC 20010216
// parse argc, argv to get filenames
  char **argv = ::argv;
  int argc = ::argc;
  int i, prevopt, opt;

  for(i = 1, prevopt = opt = 0; i < argc; i++, prevopt = opt)
  {
    opt = ( *(argv[i]) == '-' );
    if (opt) continue;
    if (prevopt) continue;

    // now, it is supposed to be a file name - argv[i]
    Client->FileOpen(argv[i]);
  }
}

void
TXploreClient::CmDisplay()
{

}

void
TXploreClient::CmObjectList()
{
  if (!ObjectList) {

  ObjectList = new TFuncWin(*this, OBJ_TITLE);
  ObjectList->Create();
  }
}
void
TXploreClient::CmMacroList()
{
  if (!MacroList) {

  MacroList = new TFuncWin(*this, MAC_TITLE);
  MacroList->Create();
  }
}
void
TXploreClient::CmFunctionList()
{
  if (!FunctionList) {

  FunctionList = new TFuncWin(*this, FUN_TITLE);
  FunctionList->Create();
  }
}

extern void infostring(char *str);

void TXploreClient::CmAutosave() // DS 15.12.99
{
	AutosaveDlg dlg( this );
//   char temp[4];
   if( dlg.Execute(isAutosave, autosaveTime) == IDOK )
   {
	   isAutosave = dlg.isAutosave;
   	autosaveTime = dlg.autosaveTime;
   }
}

void
TXploreClient::CmInfo()    //SK 15.03.99
{ InfoDialog(this, IDD_DIALOG2).Execute(); }

void
TXploreClient::CmClearOutput()    // PC 20010420
{
 	char *buf = Input->Output->Outtext->LockBuffer();
   *buf = '\0';
   Input->Output->Outtext->UnlockBuffer(buf, true);
}

void
TXploreClient::CmAbout()
{
  TDialog(this, XMSG_ABOUT_WIN_CAPTION_STR).Execute();

}

/*********************************************************************
*						  Calls HelpFile  											*
*																							*
*********************************************************************/

void
TXploreClient::CmHelpContents()
{
//	  WinHelp(HelpFile, HELP_INDEX, 0);
// SK 28.10.98

 /*  char *bw = property.getProperty ("browser"),
        *sp = openfile (HELP, "_Xpl_Start.html", "r"),
        cmdline[256];
   if (bw)
     sprintf (cmdline, "%s %s", bw, sp);
   else
     sprintf (cmdline, "%s", sp);
	ShellExecute (NULL, "open", cmdline,
   					"","",SW_SHOWNORMAL);
*/
	char path[300], *tmp;
   tmp = openfile (HELP, "_Xpl_Start.html", "r");
   if (tmp)
   { strcpy(path, tmp);
     // strcat(path, "\\_Xpl_Start.html");
     ShellExecute(NULL,"open",path,"","",SW_SHOWNORMAL);
   }

}

void
TXploreClient::CmHelpOverview()
{	char path[300], *tmp;
   tmp = openfile (HELP, "x4intro.html", "r");
   if (tmp)
   { strcpy(path, tmp);
     ShellExecute(NULL,"open",path,"","",SW_SHOWNORMAL);
   }
}

void
TXploreClient::CmHelpFunIndex()
{
//	  WinHelp(HelpFile, HELP_CONTEXT, whatsnew);
	char path[300], *tmp;
   tmp = openfile (HELP, "HelpIndex.html", "r");
   if (tmp)
   { strcpy(path, tmp);
  //   strcat(path, "\\HelpIndex.html");
     ShellExecute(NULL,"open",path,"","",SW_SHOWNORMAL);
   }
}

void
TXploreClient::CmHelpMacroIndex()
{
//	  WinHelp(HelpFile, HELP_CONTEXT, whatsnew);
	char path[300], *tmp;
   tmp = openfile (HELP, "MacroIndex.html", "r");
   if (tmp)
   { strcpy(path, tmp);
     //strcat(path, "\\MacroIndex.html");
     ShellExecute(NULL,"open",path,"","",SW_SHOWNORMAL);
   }
}

void
TXploreClient::CmHelpTutorials()
{
//	  WinHelp(HelpFile, HELP_CONTEXT, whatsnew);
	char path[300], *tmp;
   tmp = openfile (HELP, "Tutorials.html", "r");
   if (tmp)
   { strcpy(path, tmp);
     //strcat(path, "\\Tutorials.html");
     ShellExecute(NULL,"open",path,"","",SW_SHOWNORMAL);
   }
}

void
TXploreClient::CmHelpHomePage()
{
//	  WinHelp(HelpFile, HELP_CONTEXT, whatsnew);
   char *bw = property.getProperty ("browser"),
        *sp = openfile (HELP, "_Xpl_Start.html", "r"),
        cmdline[256];
   if (bw)
     sprintf (cmdline, "%s %s", bw, sp);
   else
     sprintf (cmdline, "%s", sp);
	ShellExecute (NULL, "open", cmdline,
   					"","",SW_SHOWNORMAL);

//"http://wotan.wiwi.hu-berlin.de/xplore/",
}

TMessageBar *mb;

void statusmessage (const char *msg)
{ mb->SetText (msg);
  mb->RedrawWindow (0, 0);
}

class TXploreMainWindow : public TDecoratedMDIFrame
{
  TMessageBar* StatusBar;
  TControlBar* ControlBar;
  TBitmap *bm;

  public:

//  TBrush *BkgndBrush;

  TXploreMainWindow (const char far* title, TResId menuResId, TMDIClient &clientWnd, HINSTANCE hinst)
    : TDecoratedMDIFrame (title, menuResId, clientWnd)
  { // Build StatusBar
    Attr.AccelTable = "EDITACCEL";
    mb = StatusBar = new TMessageBar(this);
    Insert(*StatusBar, TDecoratedFrame::Bottom);
    // Build ControlBar
    ControlBar = new TControlBar(this, TControlBar::Horizontal);
// PC: CM_#? commands replaced by IDM_#? editor commands
    ControlBar->Insert(*new TButtonGadget(IDB_BITMAP5, CM_FILENEW));
    ControlBar->Insert(*new TButtonGadget(IDB_BITMAP6, CM_FILEOPEN));
    ControlBar->Insert(*new TButtonGadget(IDB_BITMAP7, IDM_MENU_SAVE /* CM_FILESAVE */));
//    ControlBar->Insert(*new TButtonGadget(IDB_BITMAP8, CM_FILECLOSE));
    ControlBar->Insert(*new TSeparatorGadget);
    ControlBar->Insert(*new TButtonGadget(IDB_BITMAP9, IDM_MENU_CUT /* CM_EDITCUT */));
    ControlBar->Insert(*new TButtonGadget(IDB_BITMAP10, IDM_MENU_COPY /* CM_EDITCOPY */));
    ControlBar->Insert(*new TButtonGadget(IDB_BITMAP11, IDM_MENU_PASTE /* CM_EDITPASTE */));
    ControlBar->Insert(*new TSeparatorGadget);
    ControlBar->Insert(*new TButtonGadget(IDB_BITMAP13, CM_FILEPRINT));
    ControlBar->Insert(*new TButtonGadget(IDB_BITMAP12, CM_EXECFILE));
    ControlBar->Insert(*new TButtonGadget(IDB_BITMAP14, CM_HELPCONTENTS));
    Insert(*ControlBar, TDecoratedFrame::Top);
    // Load background image
    bm = new TBitmap(hinst, IDB_BITMAP3);
  }

  ~TXploreMainWindow()
  { delete StatusBar;
    delete ControlBar;
    delete bm;
  }


//  void Paint (TDC& dc, bool erase, TRect& rect)
//  { if (bm)
//    { /*TBrush hbrush (*bm);
//
//      dc.SelectObject(hbrush);
//      int i= dc.PatBlt(0, 0, bm->Width(), bm->Height());
//      dc.RestoreBrush(); */
//      TMemoryDC MemDC;
//      MemDC.SelectObject (*bm);
//      dc.BitBlt ((GetClientRect().Width()-bm->Width())/2,
//                 (GetClientRect().Height()-bm->Height())/2,
//                 bm->Width(), bm->Height(), MemDC, 0, 0, SRCCOPY);
//      /*char msg[256];
//      sprintf (msg, "Try to draw %ix%i Bitmap = %i", bm->Width(), bm->Height(), i);
//      ::MessageBox (NULL, msg, "MSG", MB_OK); */
//    }
//  }
//
//  DECLARE_RESPONSE_TABLE(TXploreMainWindow);

  };

//DEFINE_RESPONSE_TABLE1(TXploreMainWindow, TDecoratedMDIFrame)
//  EV_WM_PAINT,
//END_RESPONSE_TABLE;

//-------------------Application Class-----------------------------
class TXploreApp : public TApplication {
  public:
  TXploreClient *MDIClient;

	 TXploreApp() : TApplication()
    {
      nCmdShow=SW_SHOWMAXIMIZED;
      MDIClient=new TXploreClient;
      LoadIcon (MAKEINTRESOURCE(AAA32));
    }

	 ~TXploreApp() {
	  //	 MDIClient->CloseChildren();
		// delete MDIClient;
	 }

	 void   InitMainWindow();
};


void TXploreApp::InitMainWindow()
{

//  MainWindow = new TMDIFrame("XploRe for Windows",101,  *MDIClient);
//  MainWindow = new TMDIFrame("XploRe",101,  *MDIClient);

  MainWindow = new TXploreMainWindow (XMSG_XPLORE_WIN_CAPTION_STR,101,*MDIClient, this->HInstance);
  MainWindow->SetMenuDescr(TMenuDescr(101,1,0,1,0,1,1));
  MainWindow->SetIcon(this, AAA32);
  MainWindow->SetIconSm(this, AAA32);
// PC: 000925  changed background of MDI window
  MDIClient->SetBkgndColor(TColor(170,170,255));

//  GrossVater=this;

//  MainWindow->AssignMenu(IDM_DISPLAY);

}

//-----------------------------------------------------------------------

int write_to_log (char *cmd);

//-----Hope this one is already implemented.
void Response(char command[STR_L]) {
#ifndef __XPLWIN__
write_to_log (command);
parse(command);
#else
cout << "Test version\n";
#endif
//cout.close();
}

HINSTANCE hinst;

int
X4OwlMain(int argc, char* argv [])
{
_control87(MCW_EM,MCW_EM);
::argc=argc; ::argv=argv;

// PC 20010118 - the whole ifdef - endif checks for registry entry InstallDate
// and is used only for 90 days version of XploRe
#ifdef X4WIN_90DAYS
  {
#define _REG_DATA_BUFFER_	64
    char data[_REG_DATA_BUFFER_];
    DWORD type, cbdata = _REG_DATA_BUFFER_;
    HKEY ksoft, kmdtech, kxplore, kle90;
    LONG err;

    err = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE", NULL, KEY_EXECUTE, &ksoft);
    if (err == ERROR_SUCCESS)
    {
      err = RegOpenKeyEx(ksoft, "MD*Tech", NULL, KEY_EXECUTE, &kmdtech);
      if (err == ERROR_SUCCESS)
      {
        err = RegOpenKeyEx(kmdtech, "XploRe", NULL, KEY_EXECUTE, &kxplore);
        if (err == ERROR_SUCCESS)
        {
          err = RegOpenKeyEx(kxplore, "LE90", NULL, KEY_EXECUTE, &kle90);
          if (err == ERROR_SUCCESS)
          {
            err = RegQueryValueEx(kle90, "InstallDate", NULL, &type, data, &cbdata);
            (void) RegCloseKey(kle90);
          }
          (void) RegCloseKey(kxplore);
        }
        (void) RegCloseKey(kmdtech);
      }
      (void) RegCloseKey(ksoft);
    }

    if (err != ERROR_SUCCESS)
    {
      (void) MessageBox(NULL, XMSG_NINETY_DAYS_LIMIT_STR, XMSG_XPLORE_MESSAGE_STR, MB_OK);
      return 0;
    }
    if ((cbdata <= 0) || (cbdata >= 60))
      return 0;

    data[cbdata - 1] = '-';
    data[cbdata] = '\0';
    // data contains now a nul terminated string with a date MM-DD-YYYY
    int mdy[3] = { 0, 0, 0 };
    char *p = data, *t;
    struct tm it = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };

    int i = 0;
    while (t = strchr(p, '-'))
      if (t)
      {
        *t = '\0';
        mdy[i] = atoi(p);
        p = t + 1;
        i++;
      }
    it.tm_mday = mdy[1];
    it.tm_mon  = mdy[0];
    if (it.tm_mon > 0) it.tm_mon--;
    it.tm_year = mdy[2];
    it.tm_year = (it.tm_year > 1900) ? it.tm_year - 1900 : 0; 

    time_t itime = mktime(&it);
    time_t ctime = time(NULL);

    // PC 20011127 - reduced to 30 days
    if (ctime > itime + 30*60*60*24)
    {
      (void) MessageBox(NULL, XMSG_NINETY_DAYS_LIMIT_STR, XMSG_XPLORE_MESSAGE_STR, MB_OK);
      return 0;
    }
  }
#endif

  myapp = new TXploreApp;
  hinst = myapp->GetInstance();
  int my=myapp->Run();
  return(my);
}

