/* $Header: /home/xplore/cvs/xpl4gr/xplore.h,v 1.4 2002/09/27 14:33:44 cizek Exp $ */

//
// XploRe Header File
//
#ifndef _XPLORE_H_
#define _XPLORE_H_

#include <string.h>
#include <owl\messageb.h>     //SK 19.11.97
#include <owl\mdi.h>
#include <owl\mdichild.h>
#include <owl\dialog.h>
#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\checkbox.h>   // SK 21.01.98
#include <owl\listbox.h>
#include <owl\edit.h>

// commented out by PC 16.5.2000 and added buttonga.h, controlb.h
//#include <owl\editfile.h>
//#include <owl\richedit.h>
#include <owl\buttonga.h>
#include <owl\controlb.h>

#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#include <owl\profile.h>
#include <owl/printdia.h>
#define TRUE  1
#define FALSE 0

// added by PC 16.5.2000
#include "wed_editor.h"
#include "wed_editor.rh"

#include "xplore.rh"

static char HelpFile[] = "XPLORE.HLP";
//----------------------------------------------------------------------
//
//
//----------------------------------------------------------------------

//const char AppName[] = "XploRe 4.0";
const int ListBoxID = 102;
const int ID_DISPLAY = 300;
const int MenuId = 101;
class TXploreClient;
void Response(char*);
//-----------------------Output Window----------------------------
class TInput;

class TOutput : public TMDIChild {
  public:
	 TInput* Parent;
	 static TOutput *globout;
	 TOutput(TXploreClient& MDIclient, TInput* Par);
	 TEdit* Outtext;

	 //void Paint(TDC& dc, bool erase, TRect& rect);
	 ~TOutput();
	 void AddAnswer(void);
    bool CanClose();

  protected:
  void EvSize(uint sizeType, TSize& size);
  void SetupWindow();

  private:
	//TListBox* Outtext;

	DECLARE_RESPONSE_TABLE(TOutput);
};


//------------------------Input Window--------------------------

class TInput : public TMDIChild {
  public:
	 TInput(TXploreClient& MDIclient);
	 ~TInput();
	 static int InputCount;  // Input shell window count
	 BOOL LostFocus;         // ListBox focus state
	 BOOL OutExists;         // existence of Output window
	 int CaptNumber;         // Input window caption number

	TOutput*          Output;                  //Output
	 void CmOutput();
	void              DoCommand(char* command, int ShowInHistory);
    bool CanClose();
    
  protected:
	 void CmReturn();
	 void CmUp();
	 void CmDown();
	 void CmClear();
	 void EvSize(uint sizeType, TSize& size);
	 void EvListBoxSelChange();
	 void EvListBoxKillFocus();
	 void EvListBoxSetFocus();
    void SetupWindow();


  private:
	TListBox*         ListBox;                 // list box.
	TEdit*            Prompt;                  //text box.
	TOutput*        child;                   // TWindow client for Output



	DECLARE_RESPONSE_TABLE(TInput);
	DECLARE_CASTABLE;
};


//----------------------------------------------------------------------------
//                    TXplEditorXpl class
//----------------------------------------------------------------------------

////-------------------- TGotoLineDialog ---------------------------------------
//
#define MAXLINELEN 80
// PC: not needed anymore - done by editor
//class TGotoLineDialog : public TDialog {
//  char lno[MAXLINELEN];
//
//  public:
//  TGotoLineDialog (TWindow* parent);
//  void SetLine (long lineno);
//  long GetLine ();
//  void EvEnSetFocus ();
//  void EvEnUpdate ();
//
//  DECLARE_RESPONSE_TABLE(TGotoLineDialog);
//};

class TMakeHelpDialog : public TDialog {
  char name[MAXLINELEN], dirmacro[MAXLINELEN], dirhelpsys[MAXLINELEN], phtml, pascii;
  TCheckBox *mhtml, *mascii;

  public:
  TMakeHelpDialog (TWindow* parent);
  ~TMakeHelpDialog ();
  void SetParam (char *newname, char *newdirmacro, char* newdirhelpsys, char newhtml, char newascii);
  void GetParam (char *actname, char *acthtml, char *actascii);
  void EvEnSetFocus ();
  void EvEnUpdate ();
  void EvBnNewHelp ();
  void EvBnNewFile ();
  void EvBnHTML();
  void EvBnASCII();
  void SetupWindow ();

  DECLARE_RESPONSE_TABLE(TMakeHelpDialog);
};

class TXplEditorWindow;

//class TXplEditor : public TEditFile {
class TXplEditor : public TEditFile {
private:
// PC: not needed  TGotoLineDialog *gld;
  TMakeHelpDialog *mhd;
  TXplEditorWindow *ed;
  bool isAutosave;
  bool useTmpPath;
  int autosaveTime;
  char tempfilename[255];

  public:
  TXplEditor(char *filename=0, bool asEnable=false, int asTime=5);
  ~TXplEditor();
  void CmExecFile();
// PC: not needed for the new editor
// PC:  void CmFileSaveAs();
// PC:  void CmGotoLine();
  void CmMakeHelp(); // SK 10.12.97
  void CmFilePrint();
  void CmFilePageSetup();
// PC:  void EvKeyDown(uint key, uint repeatCount, uint flags); // SK 04.11.98
// PC:  void setfilepos();                                      // SK 05.11.98
  void CmFormatSource();           // Sk 10.11.98
  void CmInsertHelp();
  void CmOpenMacro();           // Sk 22.11.98
// PC: not needed anymore
// PC:  bool CanClose();
// PC:  void CmEditPaste();
// PC:  void EvTimer( uint TimerId );
// PC:  void SetFileName( const char far* filename );
  void EvSetFocus(HWND hWndLostFocus);	// PC 29.5.2000

  protected:
// PC:  void MakeTempName();
  void SetupWindow();

//  TEditFile *editor;
  DECLARE_RESPONSE_TABLE(TXplEditor);

};

class TLibEditor : public TEditFile {
private:
// PC: not needed anymore  TGotoLineDialog *gld;
  TXplEditorWindow *ed;

  public:
  TLibEditor(char *filename=0);
  ~TLibEditor();
// PC: not needed for the new editor
// PC:  void CmFileSaveAs();
// PC:  void CmGotoLine();
  void CmFilePrint();
  void CmFilePageSetup();
  void EvLButtonDblClk(uint modKeys, TPoint& point);
// PC:  void EvKeyDown(uint key, uint repeatCount, uint flags); // SK 04.11.98
// PC:  void setfilepos();                                      // SK 05.11.98
  void CmOpenMacro();           // Sk 22.11.98
// PC:  bool CanClose();
  void EvSetFocus(HWND hWndLostFocus);

  protected:
  void SetupWindow();

  DECLARE_RESPONSE_TABLE(TLibEditor);

};


class TXplEditorWindow : public TMDIChild {
    int winid;		// PC 20011211: identification for position manager

  public:
	 TXplEditorWindow(TXploreClient& MDIclient, char* title, TWindow* client, int where);
	 ~TXplEditorWindow();

  };


//----------------------------------------------------------------------------
//                     TXploreClient class
//----------------------------------------------------------------------------
class TFuncWin;

class TXploreClient : public TMDIClient {
  private:
  TInput* Input;
  bool initeditorfiles;

  public:
  static TXploreClient *Client;
  static TProfile *profile;
  TInput *input_child;
  char *outbuff; //output buffer string (redirected from stdout)
  TOpenSaveDialog::TData   FileData;

  TPrintDialog::TData PrintData;

//	 TControlBar*             ControlBar;
//	 int                      ControlBarLoc;

	 TXploreClient();
	 ~TXploreClient();
	 int CaptNumber;
	 void SetupWindow();
	 void CmInput();
    void CmInitEditorFiles();  // PC 20010216
	 TFuncWin *FunctionList;
	 TFuncWin *ObjectList;
	 TFuncWin *MacroList;
	 virtual bool CloseChildren();
    void FileOpen (char *name);
    int autosaveTime;
    bool isAutosave;
    void CmAutosave();	//DS 15.12.99
  protected:
    void EvPaint();
	 bool CanClose();
	 void CmFileNew();
	 void CmDataOpen();     // SK 18.11.97
	 void CmFileOpen();
	 void CmFileSaveAs();
	 void CmDisplay();
	 void CmFunctionList();
	 void CmObjectList();
	 void CmMacroList();
	 void CmAbout();
    void CmInfo();       //SWS 27.1.98
    void CmClearOutput();	// PC 20010420

  	 void CmHelpOverview();
	 void CmHelpContents();
	 void CmHelpFunIndex();
  	 void CmHelpMacroIndex();
	 void CmHelpTutorials();
	 void CmHelpHomePage();

    void EvDropFiles(TDropInfo dropInfo); // PC 20020927

  DECLARE_RESPONSE_TABLE(TXploreClient);
};

void statusmessage (const char *msg);

#endif

