/* $Header: /home/xplore/cvs/xpl4gr/xplore.l,v 1.3 2002/08/16 12:32:00 sigbert Exp $ */

/*
Lexikalische Analyse fuer mdcalc (Prototyp fuer XploRe 4 Interpreter):

by TTK 30.6.94  1.12.94  23.1.95   12.10.95

folgenede Token werden an yacc/bison Parser uebergeben:

	Token		Bedeutung
	
	CONSTANT	Zahlkonstante ohne Vorzeichen
	VARIABLE	Bezeichner, der in der Variablenliste vorhanden ist
	NEWSTRING	Bezeichner, der weder in der Variablen- noch Funktionsliste ist
        STRCONST        neuer String
	FUNCTION	Bezeichner, der in der Funktionsliste ist
        MACRO           Macro aus Macroliste
        XPROC  ENDP      Prozedurstart und Ende
        IF ELSE ENDIF
        WHILE ENDO
	SMULT		'.*' zur Kennzeichnung elementweiser Mulitplikation
        OP_PM           +, -
        OP_PM           *, /
        OP_REL          <, <=, >, >=
        OP_EQ           ==, !=
        OP_AND          &&
        OP_OR           ||
        OP_SEQ          :
        OP_TRANS        '

        ;und folgender Text wird ignoriert, Kommentar

Folgende Zeichenketten werden noch verabeitet:

	String		Aktion

	info            Gibt varlist, funlist und macrolist aus
	quit | bye	Rueckgabe von 0 an Parser (Endesignal)
	[ \t]+		Ueberlesen von Tabulatoren und Leerzeichen
	info		Ausgabe der Variablen- und Funktionsliste, verursacht Parsererror

Alle uebrigen Zeichen werden dem Parser uebergeben.



*/

%{
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "object.h"
#include "function.h"

MacroText *mtp, *origmtp;  // origmtp is initialized in init.C

#define YY_DECL	int mylex (void)
#define AD      mtp->AppendText (yytext)

long pos;
extern char *programId;       // defined in init.C
extern int checkdebug;
extern long XplObjectId;
%}


ziffern		([0-9]+)
/* gebrochen	(({ziffern}?[.]{ziffern})|({ziffern}[.]?)) */
gebrochen	(({ziffern}?[.]{ziffern})|({ziffern}))
exponent	([eE][+-]?{ziffern})
reel		(({gebrochen}{exponent}?)|({ziffern}{exponent}))
bezeichner	([a-zA-Z]+[a-zA-Z0-9]*)
endstring       ((^[\\])\")

%%

docheck         { docheck = 1; }
dontcheck       { docheck = 0; }
checkdebug      { checkdebug = 1; }
yydebug         { yydebug |= 1; }
ttkdebug        { ttkdebug |= 1; }
trace           { tracedebug = 1; }
traceoff        { tracedebug = 0; }
debug           { yydebug = 1;  ttkdebug = 1; }
info3		{ extern Liste<XplObject*> *globObjList, *displayList;
                  cout << " ---- \ndisplayList\n";
                  PrintXplObjectNameList (displayList);
                  cout << " ---- \nglob Objects\n";
                  PrintXplObjectNameList (globObjList);
                  cout << " ---- \nEnde\n";
                  cout << "XplObjectId " << XplObjectId;;
                  cout << "\nobjects in system " << objcounter;
                  cout << "\n";

                }
info2		{ extern Liste<XplObject*> *objList;
                  int i;
                  cout << " ---- \nFunctions\n";
		  for (i=0; i<funList->laenge(); i++)
		    {
		    cout << (long) (*funList)[i]->Name () << '\t' << (*funList)[i]->Name () << '\n';
		    }

                  cout << " ---- \nXplObjects\n";
                  PrintXplObjectNameList (objList);
                  cout << " ---- \nMacros\n";
		  for (i=0; i<macList->laenge(); i++)
		    {
		    cout << (*macList)[i]->Name() << '\n';
		    }
                  cout << " ---- \nVersion:\n";
                  cout << programId << endl;
  cout << "XploRe 4 home set to " << xpl4home << endl;
  cout << "XploRe 4 lib  set to " << xpl4lib  << endl;
  cout << "XploRe 4 help set to " << xpl4help << endl;
  cout << "XploRe 4 data set to " << xpl4data << endl;
		}

info		{ extern Liste<XplObject*> *objList;
                  int i;
                  cout << " ---- \nXplObjects\n";
                  PrintXplObjectNameList (objList);
                  cout << " ---- \nMacros\n";
		  for (i=0; i<macList->laenge(); i++)
		    {
		    cout << (*macList)[i]->Name() << '\n';
		    }
                  cout << " ---- \nVersion:\n";
                  cout << programId << endl;
		}


[ \t]+	        AD;                          // ignore spaces and tabs

^[ \t]*;.*\n     { AD; return (COMMENT); }    // ignore comment lines
\/\*             { AD; return (COMBEGIN);}    // comment block begin '/*'
\*\/             { AD; return (COMEND);  }    // comment block end '*/'

;.*\n            { AD; return ('\n');    }    // separates commands
\/\/.*\n         { AD; return ('\n');    }    // separates commands

\"[^\"]*\"   { AD;
//                        yylval.Name = new char[strlen(yytext)-1];
//					strcpy (yylval.Name, yytext+1);
//                                        yylval.Name[strlen(yytext)-2] = '\0';
                        yytext[strlen (yytext)-1] = '\0';
                        yylval.Name = strdup (yytext+1);
		    			return (STRCONST); }

quit		|
bye		{ ExitXpl (0); }


proc|PROC	{ mtp = new MacroText();     // store source in MacroText
                  yylval.MacText = mtp;
                  mtp->Rewind ();
		  mtp->Record (TRUE);  AD;
		  return (XPROC);
		}

endp|ENDP	{ AD;
                  mtp->Record (FALSE);
                  yylval.Branch = -5;
		  return (ENDP);
		}

while|WHILE	{ yylval.Branch = -6; AD;
		  return (WHILE);
		}
endo|ENDO	{ yylval.Branch = -6; AD;
		  return (ENDO);
		}

repeat|REPEAT|do|DO	{ yylval.Branch = -7; AD;
		  return (REPEAT);
		}
until|UNITL	{ yylval.Branch = -7; AD;
		  return (UNTIL);
		}

if|IF   	{ yylval.Branch = -4; AD;
		  return (IF);
		}

else|ELSE	{ AD; return (ELSE);    }
		  
endif|ENDIF	{ AD; return (ENDIF);   }

switch|SWITCH	{ AD; return (SWITCH);  }
case|CASE	{ AD; return (CASE);    }
break|BREAK	{ AD; return (BREAK);   }
default|DEFAULT	{ AD; return (DEFAULT); }
endsw|ENDSW	{ AD; return (ENDSW);   }


\+		{ AD; yylval.Index = PLUS;		return (OP_PM); }
\.\+		{ AD; yylval.Index = PLUS;		return (OP_PM); }
\-		{ AD; yylval.Index = MINUS;		return (OP_PM); }
\.\-		{ AD; yylval.Index = MINUS;		return (OP_PM); }
\/		{ AD; yylval.Index = DIV;		return (OP_MD); }
\.\/		{ AD; yylval.Index = DIV;		return (OP_MD); }
\*		{ AD; yylval.Index = MMULT;		return (OP_MD); }
\.\*		{ AD; yylval.Index = MULT;		return (OP_MD); }
\'\*		{ AD; yylval.Index = TMULT;		return (OP_TMD); }
%		{ AD; yylval.Index = MOD;		return (OP_MD); }
\.%		{ AD; yylval.Index = MOD;		return (OP_MD); }
\^		{ AD; yylval.Index = POW;		return (OP_P); }
\.\^		{ AD; yylval.Index = POW;		return (OP_P); }
\<		{ AD; yylval.Index = LESS;		return (OP_REL); }
\.\<		{ AD; yylval.Index = LESS;		return (OP_REL); }
\<=		{ AD; yylval.Index = LEQ;		return (OP_REL); }
\.\<=		{ AD; yylval.Index = LEQ;		return (OP_REL); }
\>		{ AD; yylval.Index = GREATER;	        return (OP_REL); }
\.\>		{ AD; yylval.Index = GREATER;	        return (OP_REL); }
\>=		{ AD; yylval.Index = GEQ;		return (OP_REL); }
\.\>=		{ AD; yylval.Index = GEQ;		return (OP_REL); }
==		{ AD; yylval.Index = EQUAL;		return (OP_EQ); }
\.==		{ AD; yylval.Index = EQUAL;		return (OP_EQ); }
\.=		{ AD; yylval.Index = EQUAL;		return (OP_EQ); }
!=		{ AD; yylval.Index = NEQ;		return (OP_EQ); }
\.!=		{ AD; yylval.Index = NEQ;		return (OP_EQ); }
\<\>		{ AD; yylval.Index = NEQ;		return (OP_EQ); }
\.\<\>		{ AD; yylval.Index = NEQ;		return (OP_EQ); }
&&		{ AD; yylval.Index = AND;		return (OP_AND); }
\|\|		{ AD; yylval.Index = OR;		return (OP_OR); }
:		{ AD; yylval.Index = SEQ;		return (OP_SEQ); }
~		{ AD; yylval.Index = CBIND;		return (OP_CON); }
\|		{ AD; yylval.Index = RBIND;		return (OP_CON); }

\'		{ AD; yylval.Index = TRANS;		return (SINGLE_OPN); }
!		{ AD; yylval.Index = NOT;		return (SINGLE_OPV); }


{bezeichner}	{ AD;
		    	yylval.Name = strdup (yytext);
		    	return (NEWSTRING);


//                  switch (EvalString (yytext, pos))
//		    {
//		    case FUNCTION:	yylval.Fun = (*funList)[pos];
//		    			return (FUNCTION);
//		    			break;
//		    case NEWSTRING:	yylval.Name = new char[strlen(yytext)+1];
//					strcpy (yylval.Name, yytext);
//                    case FUNCTION: ;
//		    case NEWSTRING:	yylval.Name = strdup (yytext);
//		    			return (NEWSTRING);
//		    			break;
//		    }
                }


\# 		{ AD;  
  	yylval.Name = strdup ("##");
	return (NEWSTRING);
// EvalString2 ("##", pos);
//                  yylval.Fun = (*funList)[pos];
//                  return (FUNCTION);  
}


_{bezeichner}	{ AD;
		  yylval.Name = new char[strlen(yytext)];
		  strcpy (yylval.Name, yytext+1);
		  return (REFMAC);
                }

\.	        { AD; return (DOT); }

{reel}		{ AD; yylval.Real  = strtod (yytext, NULL); 
                  return (CONSTANT); }
\\		{ AD; return ('\n'); }        // separates commands
\r		{ AD; return ('\n'); }
\n		{ AD; return ('\n'); }

=		{ AD; return ('='); }
\(		{ AD; return ('('); }
\)		{ AD; return (')'); }
\[		{ AD; return ('['); }
\]		{ AD; return (']'); }
[ \t]+\{	{ AD; return (ASSIGNBRACKET); }  // distinguish assignment
^\{	        { AD; return (ASSIGNBRACKET); }  // and list selection
\{		{ AD; return ('{'); }            // first in line or with blank
\}		{ AD; return ('}'); }            // order  important
,		{ AD; return (','); }


.		{ AD; yylval.Name = strdup (yytext);
                      return (UNKNOWNINPUT); }


