/* $Header: /home/xplore/cvs/xpl4gr/xplpp.C,v 1.6 2003/07/28 17:06:08 cizek Exp $ */

// Preprocessor 
    
// by TTK  15.9.94


// last modification:   11.4.95  TTK

// PC MAC
#if !defined(__APPLE_CC__) && !defined (__BORLANDC__) && !defined (WIN32) //LOOK!
#include <stream.h>
#else
#include <iostream.h>
#endif

#include <string.h>
#include "machine.h"
#include "liste.h"
#include "qsort.h"
#include "object.h"
#include "function.h"
#include "globlist.h"
#include "xplpp.h"
#include "ttkio.h"
#include "xplerror.h"
#include "init.h"
#include "directory.h"
#ifdef SOCKETSERVER
#include "socket.h"   // SK 20.02.99
#endif
#include "fileinfo.h"
#include "property.h" // SK 19.01.99
#include "singleserver.h" // SK 09.02.99 

#include "xplore_strings.h" // PC 20030517

#ifdef SOCKETSERVER
#include <errno.h>
#include <signal.h>

#if !defined (__BORLANDC__) && !defined (WIN32) //LOOK!
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

#endif

#include <sys/types.h>


XJprotocol *protocol;
#endif

#ifdef RPC
#include "xplfort.h"
#include <rpc/rpc.h>
#include <rpc/pmap_clnt.h> /* for pmap_unset */
#endif


#ifndef MATRIX
#include"xreal.hpp"
#endif

#ifdef __BORLANDC__
#include "xplwin.h"
#endif

#define MAXFRAME 128

#ifdef TTKDEBUG
extern int ttkdebug;
#endif
void logt (const char *txt);

//static long frame = 0;            // Frame counter for ParseMacro

// header of xplfun2.h ??
void performSendData2Client   (const char *oname);
void performSendDouble2Client   (const char *oname);
void performGetDataFromClient (const char *oname);
void performGetDoubleFromClient (const char *oname);
extern int LoadMacro (const char *fname, int reload = FALSE);

GlobalList parselist;
long switchcount = 0;

int quiet;

long CaseHandler (XplObject *m, int jump)
{
  if (m == NULL)
    {
    globalError.Set (ERR_INTERN, "empty object in CASE");
    return (0L);
    }

  if (switchcount == 0)
    {
    globalError.Set (ERR_SYNTAX, "CASE without SWITCH");
    return (0L);
    }

  if (m->DefaultType () != C_XPLDOUBLE)
    {
    globalError.Set (ERR_CASE, "argument not numeric");
    return (0L);
    }

  if (! (*(m->DefaultXplDouble()))[0])
    parselist.SetJump (jump);

  if (! m->WriteProtection ())
    delete m;
  return 0L;
}

long IfHandler (XplObject *m, int jump)
{
  if (m == NULL)
    {
    globalError.Set (ERR_INTERN, "empty object in IF");
    return (0L);
    }

  if (m->DefaultType () != C_XPLDOUBLE)
    {
    globalError.Set (ERR_IF, "argument not numeric");
    return (0L);
    }

  if (! (*(m->DefaultXplDouble()))[0])
    parselist.SetJump (jump + 1);

  if (! m->WriteProtection ())
    delete m;
  return 0L;
}

long WhileHandler (XplObject *m, int jump)
{
  if (m == NULL)
    {
    globalError.Set (ERR_INTERN, "empty object in WHILE");
    return (0L);
    }

  if (m->DefaultType () != C_XPLDOUBLE)
    {
    globalError.Set (ERR_WHILE, "argument not numeric");
    return (0L);
    }

  if (! (*(m->DefaultXplDouble()))[0])
    parselist.SetJump (jump + 1);

  if (! m->WriteProtection ())
    delete m;
  return 0L;
}

long UntilHandler (XplObject *m, int jump)
{
  if (m == NULL)
    {
    globalError.Set (ERR_INTERN, "empty object in UNTIL");
    return (0L);
    }

  if (m->DefaultType () != C_XPLDOUBLE)
    {
    globalError.Set (ERR_UNTIL, "argument not numeric");
    return (0L);
    }

  if (! (*(m->DefaultXplDouble()))[0])
    parselist.SetJump (jump + 1);

  if (! m->WriteProtection ())
    delete m;
  return 0L;
}

long SwitchHandler (XplObject *m, int casetokpos)
{
  TokenElement current, casetok, consttok;
  long pos = parselist.Pos ();
  Vector<TokenElement> *tl = parselist.GetTokenList ();
  
  current    = (*tl)[pos];
  casetok    = (*tl)[casetokpos];
  consttok   = (*tl)[casetokpos+1];

  while (TRUE)
    {
    if (consttok.token != VARIABLE)
      {
#ifdef INETD
cout << "\"-------=_aaaaaaa\"\nContent-Type: text/plain\n\n";
#endif
      cerr << "Error:  SwitchHandler:  Missing VAR after CASE" << endl;
      return (0L);
      }
    if ((casetok.token == DEFAULT) || (casetok.token == ENDSW))
      {
      parselist.SetJump (casetokpos+1);   // DEFAULT
      if (m == NULL)
	{
	globalError.Set (ERR_INTERN, "empty object in SWITCHhandler");
	return (0L);
        }
      if (! m->WriteProtection ())
	delete m;
      return (0L);
      }
    if (IsEqual (m, consttok.content.Var->GetXplObject ()))
      {
      parselist.SetJump (casetokpos+2);   // CASE CONST
      if (! m->WriteProtection ())
	delete m;
      return (0L);
      }
    casetokpos = casetok.content.Branch;
    casetok    = (*tl)[casetokpos];
    consttok   = (*tl)[casetokpos+1];
    }

  if (! m->WriteProtection ())
    delete m;
  return 0L;
}

GlobalList* CopyTokenList ()
/* copys a macro definition of the GlobalList parselist into a new GlobalList
   copies until ENDP token and appends EOTL ('\0') token
Invoked by: yyparse
Invokes:    liste operations
Input:   none (parselist)
Output:  GlobalList
dynamic: new GlobalList    */
{
  Vector<TokenElement> *tl, tl2;      // globlist changed new Liste<TokenElement>;
  TokenElement	current;
  long line = 0;
  
  tl = &tl2;

  while (TRUE)
     {
     current = parselist.Next ();
     line = line == 0 ? current.SourceLine : line;
//     current.SourceLine -= line - 1;
     if (current.token == '\n')         // ignore line feeds
       {
       tl->haengeAn (current);        // don't ignore 26.1.  {a,b}=
       line++;
       continue;
       }
     if (current.token != ENDP)
       tl->haengeAn (current);
     else break;
     if (current.token == 0)
       {
       break;
       }
/*       globalError.Set (ERR_INTERN, "CopyTokenList: Token 0 in TokenList\n");
       return (NULL);
// ATTENTION: *tl has to be deleted !!
       }
*/     }
  current.token = '\0';               // for sure
//  current.SourceLine -= line - 1;
  tl->haengeAn (current);
  
//  cout << "CTL: len = " << tl->laenge();

  return (new GlobalList (tl));
}

void	BuildTokenList (GlobalList *gl, int end)
/* builds tokenlist from textual input (lex). Separates scanning and parsing.
   stores tokens in the tokenlist of GlobaList gl until token 'end' is read
Invoked by: main
Invokes:    liste operations
Input:  GlobalList *gl, end
Output: none (tokenlist of gl)
dynamic: nothing  */
{
  TokenElement        current;
  long                line     = 1, paropen = 0, selopen = 0;
  Vector<TokenElement> *tl = new Vector<TokenElement>;
  int                 comblock, tok, procFlag = FALSE;
  char                text[TEXTLENGTH];

extern MacroText *mtp, *origmtp;      // for mylex, *mtp has to point to an
mtp = origmtp;                        // existing MacroText !

// SK 20.02.99
// #if !defined (INETD) && !defined (_GRAPHICS_) && !defined (__BORLANDC__) && !defined (SOCKETSERVER)
// cerr << "Next Command:" << endl;
// #endif
//#ifdef SOCKETSERVER
//  sockout (">\n");
//#endif

  do {
     current.token = mylex ();
     current.content = yylval;
     current.jump = 0;
     current.SourceLine = line;

     /* lohnt sich vielleicht bei Umsortierung der Token:
        if (current.token >= XPROC) ...
     if (current.token != XPROC && current.token != ENDP &&
         current.token != COMMENT && current.token != COMBEGIN &&
	 current.token != COMEND  && current.token != '\n' &&
	 current.token != '('     && current.token != ')'  &&
	 current.token != '['     && current.token != ']')
       tl->haengeAn (current);
     else
     */
     switch (current.token)
       {
       case XPROC:         procFlag = TRUE;   tl->haengeAn (current); break;
       case ENDP:          procFlag = FALSE;  tl->haengeAn (current); break;
       case COMMENT:       line++;  continue; cerr << "NEVER" << endl;
       case COMBEGIN:      comblock = 1;
			   while (comblock != 0)
			     {
			     tok = mylex ();
			     if (tok == end)
			       {
			       globalError.Set (ERR_COMEND, "missing");
			       current.token = end;
			       break;
			       }
			     switch (tok)
			       {
			       case COMBEGIN:  comblock++;  break;
			       case COMEND:    comblock--;  break;
			       case '\n':      line++;      break;
			       default: ;
			       }
			     }
			   break;
       case COMEND:        globalError.Set (ERR_COMBEGIN, "missing");
			   break;
       case '\n':         line++;
                          if (paropen != 0)
			    {
			    if (paropen > 0)
			      if (paropen == 1)
           sprintf (text, "one parenthesis ( not closed. Line %ld\n", line-1);
			      else
           sprintf (text, "%ld parentheses ( not closed. Line %ld\n", paropen, line-1);
			    else
			      if (paropen == -1)
           sprintf (text, "one parenthesis ) unmatched. Line %ld\n", line-1);
			      else
           sprintf (text, "%ld parentheses ) unmatched. Line %ld\n", labs(paropen), line-1);
			    globalError.Set (ERR_PAR, text);
			    }
                          if (selopen != 0)
			    {
			    if (selopen > 0)
			      if (selopen == 1)
           sprintf (text, "one bracket [ not closed. Line %ld\n", line-1);
			      else
           sprintf (text, "%ld brackets [ not closed. Line %ld\n", selopen, line-1);
			    else
			      if (selopen == -1)
           sprintf (text, "one bracket ] unmatched. Line %ld\n", line-1);
			      else
           sprintf (text, "%ld brackets ] unmatched. Line %ld\n", labs(selopen), line-1);
			    globalError.Set (ERR_PAR, text);
			    }
			  if (procFlag)     // within proc defs \n are not allowed !
                            current.token = NOP;
//			    continue;       // TTK, 28.9.96
			  tl->haengeAn (current);
			  break;
       case '(':          paropen++;  tl->haengeAn (current); break;
       case ')':          paropen--;  tl->haengeAn (current); break;
       case '[':          selopen++;  tl->haengeAn (current); break;
       case ']':          selopen--;  tl->haengeAn (current); break;
       default:           tl->haengeAn (current); 
       }
     } while (current.token != end);

/*  TTK, 5.1.99 no shell output
  if (paropen != 0)
    cerr << "Klammern() stimmen nicht" << endl;
  if (selopen != 0)
    cerr << "Klammern[] stimmen nicht" << endl;
*/

  current.token = '\0';               // for sure
  current.SourceLine = line;
  tl->haengeAn (current);
  gl->SetTokenList (tl);
}

int	ParseTokenList (const GlobalList &gl)
/* invokes the parser with tokenlist of gl
Invoked by: main, ParseMacro
Invokes:    yyparse, liste operations
Input:  GlobalList &gl
Output: TRUE, if no error occured, otherwise FALSE
dynamic: nothing   */
{
  int result = TRUE;

/*  if ((globalError.Get()) && frame != 0)
    {
    cerr << "globalError = TRUE at call of parsetokenlist frame = " << frame << endl;
    return (NULL);
    }

    cerr << "globalError:  frame = " << frame << endl;
    cerr << "objList " << objList << endl;
    cerr << "objList " << objList << endl;
*/

  if (frame>MAXFRAME) // SK 2.11.2000
  { globalError.Set (ERR_INTERN, "Max frame number reached\nCheck for recursive quantlet call !");
    return (TRUE);
  }

  frame++;

//  GlobalList oldgl = parselist;     // this invokes the copy contructor
                                      // not operator= !
  GlobalList oldgl;// (parselist);       // FLAT copy, standard copy constr!!

  oldgl = parselist;

  parselist = gl;

/*  if (frame == 1)
    {
    try
      {
      yyparse ();
      }
    catch (...)
      {
      cerr << "Catch: got it" << endl;
      cerr << "Frame: " << frame << endl;
      }
    }
  else
*/
  yyparse ();
  result = globalError.Get ();      // is error occured ?

#ifndef INETD
//  cerr << "Frame: " << frame << endl;
#endif
  frame--;
  parselist = oldgl;

  if (frame == 0)               // back in command line
    {
    TidyUp (objList);           // removes empty objects
    globalError.ShowError();    // now show errors, if there are any
    globalWarning.ShowError();  // now show warnings, if there are any
    }
  return (result);
}

void	CheckTokenList (const GlobalList &gl)
/* invokes the parser only for checking with tokenlist of gl
Invoked by: main, ParseMacro
Invokes:    yyparse, liste operations
Input:  GlobalList &gl
Output: none
dynamic: nothing   */
{
  static long frame = 0;

  if (frame>MAXFRAME) // SK 2.11.2000
  { globalError.Set (ERR_INTERN, "Max frame number reached\nCheck for recursive quantlet call !");
    return;
  }

  frame++;

  GlobalList oldgl;         // FLAT copy, standard copy constr!!

  oldgl = parselist;

  parselist = gl;


#ifdef TTKDEBUG
if (ttkdebug)
  {
  cerr << "Checkparse ..." << endl;
  ShowTokenList (&parselist);
  }
#endif

  checkparse ();
//  ScanKeyword (&parselist);

#ifndef INETD
//  cerr << "Frame: " << frame << endl;
#endif
  frame--;
  parselist = oldgl;

// show errors outside (CheckMacro)
//  if (frame == 0)               // back in command line
//    globalError.ShowError();    // now show errors, if there are any

#ifdef TTKDEBUG
if (ttkdebug)
  cerr << "... Checkparse" << endl;
#endif
}

void	ShowTokenList (const GlobalList *gl)
/* shows tokenlist of gl
Invoked by: many
Invokes:    nothing
Input:  GlobalList *gl
Output: none
dynamic: nothing     */
{
  long		i, length;
  Vector<TokenElement> *tl = gl->GetTokenList();

  length = tl->laenge();

  for (i=0; i<length; i++)
    {
    ttkmessage(i);
    ttkmessage(":\t");
    ttkmessage((long)(*tl)[i].token);
    ttkmessage(":\t");
    ttkmessage((*tl)[i].SourceLine);
    ttkmessage('\t');
    switch ((*tl)[i].token) {
    case VARIABLE:	 ttkmessage("VARIABLE");	break;
    case NEWSTRING:	 ttkmessage("NEWSTRING");	break;
    case STRCONST:	 ttkmessage("STRCONST");	break;
    case CONSTANT:	 ttkmessage("CONST");	break;
    case FUNCTION:	 ttkmessage("FUNCTION");	break;
    case MACRO:		 ttkmessage("MACRO");	break;
    case MFCAND:       	 ttkmessage("MFCAND");	break;
    case XPROC:	 ttkmessage("PROC");	break;
    case ENDP:	 ttkmessage("ENDP");	break;
    case IF:	 ttkmessage("IF");	break;
    case ELSE:	 ttkmessage("ELSE");	break;
    case ENDIF:	 ttkmessage("ENDIF");	break;
    case WHILE:	 ttkmessage("WHILE");	break;
    case ENDO:	 ttkmessage("ENDO");	break;
    case REPEAT:	 ttkmessage("REPEAT");	break;
    case UNTIL:	 ttkmessage("UNTIL");	break;
    case SWITCH:	 ttkmessage("SWITCH");	break;
    case CASE:	 ttkmessage("CASE");	break;
    case BREAK:	 ttkmessage("BREAK");	break;
    case DEFAULT:	 ttkmessage("DEFAULT");	break;
    case ENDSW:	 ttkmessage("ENDSW");	break;
    case OP_PM:	 ttkmessage("OP_PM");	break;
    case OP_MD:	 ttkmessage("OP_MD");	break;
    case OP_REL:	 ttkmessage("OP_REL");	break;
    case OP_EQ:	 ttkmessage("OP_EQ");	break;
    case OP_AND:	 ttkmessage("OP_AND");	break;
    case OP_OR:	 ttkmessage("OP_OR");	break;
    case OP_SEQ:	 ttkmessage("OP_SEQ");	break;
    case OP_CON:	 ttkmessage("OP_CON");	break;
    case SINGLE_OPN:	 ttkmessage("SINGLE_OPN");	break;
    case SINGLE_OPV:	 ttkmessage("SINGLE_OPV");	break;
    case SIGN:	 ttkmessage("SIGN");	break;
//    case STRCONST:	 ttkmessage("STRCONST");	break;
    case DOT:	 ttkmessage("DOT");	break;
    case ASSIGNBRACKET:	 ttkmessage("A{");	break;
    case '\n':	 ttkmessage("NEWLINE");	break;
    case '\0':	 ttkmessage("EOTL");	break;

    default:	ttkmessage("UNKNOWN ");
		ttkmessage((long) (*tl)[i].token);
		ttkmessage((char) (*tl)[i].token);	break;
    }
    ttkmessage('\t');
    if ((*tl)[i].token == VARIABLE)
      {
      ttkmessage((*tl)[i].content.Var->Position());
    ttkmessage("  ");
      ttkmessage((*tl)[i].content.Var->Name());
    ttkmessage("  ");
//      ttkmessage((long)(*tl)[i].content.Var->GetXplObject(1));
    ttkmessage('\n');
      continue;
      }
    if ((*tl)[i].token == FUNCTION)
      ttkmessage((*tl)[i].content.Fun->Name());
    if ((*tl)[i].token == MACRO)
      ttkmessage((*tl)[i].content.Mac->Name());
    if (((*tl)[i].token == NEWSTRING) || ((*tl)[i].token == STRCONST) || ((*tl)[i].token == MFCAND))
      ttkmessage((*tl)[i].content.Name);
    else
      ttkmessage((*tl)[i].content.Branch);
    ttkmessage('\n');
    }
}

void	PrintToken (int token)
/* shows single token
Invoked by: many
Invokes:    nothing
Input:  token
Output: none
dynamic: nothing     */
{
    ttkmessage("Token:\t");
    ttkmessage((long)token);
    ttkmessage('\t');
    switch (token) {
    case VARIABLE:	 ttkmessage("VARIABLE");	break;
    case NEWSTRING:	 ttkmessage("NEWSTRING");	break;
    case STRCONST:	 ttkmessage("STRCONST");	break;
    case CONSTANT:	 ttkmessage("CONST");	break;
    case FUNCTION:	 ttkmessage("FUNCTION");	break;
    case MACRO:		 ttkmessage("MACRO");	break;
    case MFCAND:	 ttkmessage("MFCAND");	break;
    case XPROC:	 ttkmessage("PROC");	break;
    case ENDP:	 ttkmessage("ENDP");	break;
    case IF:	 ttkmessage("IF");	break;
    case ELSE:	 ttkmessage("ELSE");	break;
    case ENDIF:	 ttkmessage("ENDIF");	break;
    case WHILE:	 ttkmessage("WHILE");	break;
    case ENDO:	 ttkmessage("ENDO");	break;
    case SWITCH:	 ttkmessage("SWITCH");	break;
    case CASE:	 ttkmessage("CASE");	break;
    case BREAK:	 ttkmessage("BREAK");	break;
    case DEFAULT:	 ttkmessage("DEFAULT");	break;
    case ENDSW:	 ttkmessage("ENDSW");	break;
    case OP_PM:	 ttkmessage("OP_PM");	break;
    case OP_MD:	 ttkmessage("OP_MD");	break;
    case OP_REL:	 ttkmessage("OP_REL");	break;
    case OP_EQ:	 ttkmessage("OP_EQ");	break;
    case OP_AND:	 ttkmessage("OP_AND");	break;
    case OP_OR:	 ttkmessage("OP_OR");	break;
    case OP_SEQ:	 ttkmessage("OP_SEQ");	break;
    case OP_CON:	 ttkmessage("OP_CON");	break;
    case SINGLE_OPN:	 ttkmessage("SINGLE_OPN");	break;
    case SINGLE_OPV:	 ttkmessage("SINGLE_OPV");	break;
    case SIGN:	 ttkmessage("SIGN");	break;
//    case STRCONST:	 ttkmessage("STRCONST");	break;
    case ASSIGNBRACKET:	 ttkmessage("A{");	break;
    case DOT:	 ttkmessage("DOT");	break;
    case '\n':	 ttkmessage("NEWLINE");	break;
    case '\0':	 ttkmessage("EOTL");	break;
    case '(':	 ttkmessage("(");	break;
    case ')':	 ttkmessage(")");	break;
    case '{':	 ttkmessage("}");	break;
    case '}':	 ttkmessage("}");	break;
    case '=':	 ttkmessage("=");	break;

    default:	ttkmessage((char)token);	break;
    }
  ttkmessage('\n');
}

void	PrintXplObjectList (Liste<XplObject*> *objList)
/* prints all XplObjects of objList
Input:  Liste<XplObject*>
Invoked by: many
Invokes:    XplObject operations
Output: none
dynamic: nothing    */
{
  long i, length = objList->laenge ();

  for (i=0; i<length; i++)
    (*objList)[i]->Print ();
}

void	PrintXplObjectNameList (Liste<XplObject*> *objList)
/* prints all names of all XplObjects of objList
Input:  Liste<XplObject*>
Invoked by: many
Invokes:    XplObject operations
Output: none
dynamic: nothing    */
{
  long i, length = objList->laenge ();

  for (i=0; i<length; i++)
    {
    cout << i << '\t' << (*objList)[i]->Name ();
#ifndef MATRIX
    if ((*objList)[i]->DefaultXplDouble() != NULL)
      {
      for (unsigned int j=0; j<(*objList)[i]->DefaultXplDouble()->dimension(); j++)
	cout << '\t' << (*objList)[i]->DefaultXplDouble()->dimension(j);
      }
#endif
    cout << '\n';
    }
}

void	CopyXplObjectList  (Liste<XplObject*> *objList, Liste<XplObject*> *mobjList)
/* copys all XplObjects of mobjList into objList
Invoked by: ParseMacro
Invokes:    XplObject operations
Input:  Liste<XplObject*> *objList, *mobjList
Output: none (objList)
dynamic: new XplObject    */
{
  long i, length = mobjList->laenge ();

  for (i=0; i<length; i++)
    objList->haengeAn (new XplObject ((*mobjList)[i]->Name ()));
}

int yywrap ()
/* needed by the yacc parser */
{
  return (1);
}

void yyerror (const char *s)
/* needed by the yacc parser, prints out an error string */
{
#ifdef INETD
  ttkerror("\"-------=_aaaaaaa\"\n");
  ttkerror("Content-Type: text/plain\n\n");
#endif
/*
  ttkerror("**##** TTK Error: ");
  ttkerror(s);
  ttkerror('\n');
*/
  char text[TEXTLENGTH];

  parselist.PrintCurrentToken ();
  if (strcmp(s, "parse error") == 0)
       globalError.Set (ERR_SYNTAX, XMSG_PARSER_PARSERROR_STR);
  else globalError.Set (ERR_SYNTAX, s);
  parselist.GetCurrentToken (text);
  globalError.AppendText (ERR_SYNTAX, text);
}

int checklex (YYSTYPE *lvalp)
/* redefintion of the scanner for syntax check. 
   Tokens are read from the GlobalList parselist.
   Doesn't follow jump instructions.
Invoked by: yyparse
Invokes:    EvalVariable, GlobalList ops
Input:  none
Output: token and lvalp (content pointer)
dynamic: nothing   */
{
  static long		pos = 0;
  TokenElement		current;
  int 			token;
  long			length;

  if (globalError.Get())             // if there is an error, don't proceed
    return ('\0');
  
  length = parselist.GetTokenList()->laenge();
  
  pos = parselist.Pos();
  
  if (pos < length)
    {
    do {
      current = parselist.Next();
      pos     = parselist.Pos();
      *lvalp  = current.content;
      token   = current.token;
      } while (token == NOP && pos < length);
    if (pos < length)
      return (token);
    }

  parselist.SetPos (0L);
  return ('\0');
}

int yylex (YYSTYPE *lvalp)
/* redefintion of the scanner. Tokens are read from the GlobalList parselist.
Invoked by: yyparse
Invokes:    EvalVariable, GlobalList ops
Input:  none
Output: token and lvalp (content pointer)
dynamic: nothing   */
{
  static long		pos = 0;
  TokenElement		current;
  int 			token, hide = TRUE;
  Vector<TokenElement>	*tl;
  long			length;
  XplObject             *obj;

  if (globalError.Get())             // if there is an error, don't proceed
    return ('\0');

  
  tl = parselist.GetTokenList();
  length = tl->laenge();
  
  pos = parselist.Pos();
  
  if (parselist.Jump())
    {
    pos = parselist.Jump();
    parselist.SetJump(0L);
    parselist.SetPos(pos);
    if ((pos > length) || (pos < 0))
      globalError.Set (ERR_INTERN, "yylex: Jump to far");
    }
    
  if (pos < length)
    {
    do {
      current = parselist.Next();
      pos = parselist.Pos();
      *lvalp = current.content;
      token  = current.token;
      switch (token) {
        case NOP:	hide = FALSE;  break;       // do nothing, separator for NEWSTRING '('
        case ENDO:	parselist.SetPos (lvalp->Branch);  break;
        case BREAK:	parselist.SetPos (lvalp->Branch);  break;

        case SWITCH:   switchcount++; continue; // parselist.SetPos (lvalp->Branch);  break;
        case ENDSW:    switchcount--; continue; // parselist.SetPos (lvalp->Branch);  break;
        case DEFAULT:	continue; // parselist.SetPos (lvalp->Branch);  break;

        case ENDIF:	break;
        case ELSE:	if (lvalp->Branch >= length)
        		  return ('\0');
        		parselist.SetPos (lvalp->Branch + 1L);  break;
	case REPEAT:	break;
	case VARIABLE:	pos--;
			current.content.Var = EvalVariable (tl, pos);
			if (current.content.Var == NULL)
			  return ('\0');
			// pos points to NEXT position in tokenlist
			parselist.SetPos (pos);
			hide = FALSE;
			obj = current.content.Var->GetXplObject ();
#ifdef TTKDEBUG
if (ttkdebug)
			if (obj->Type() & O_COMPOSED)
			  {
			  cerr << "yylex delivers composed VAR" << endl;
			  }
#endif
			if (obj->Type() & O_SIMPLE)
			  if (obj->DefaultType() == C_MACRO)
			    {
			    current.content.Mac = obj->DefaultComponent()->Content().macro;
			    current.token = token = MACRO;
			    }
			break;
        default:	hide = FALSE; break;
        }
      } while (hide);
    return (token);
    }
  else
    {
    parselist.SetPos (0L);
    return ('\0');
    }
}

void    ScanConstants   (GlobalList *gl)
/* translates from tokenlist (gl) CONST in VARIABLES (only for macros),
Invoked by: Macro::SetRun
Invokes:    GlobalList ops, 
Input:  
Output: token and lvalp (content pointer)
dynamic: nothing   */
{
  Vector<TokenElement> *tl = gl->GetTokenList ();
  long     i, oldpos, length = tl->laenge ();
  XplObject       *obj;
  XplDouble    *x;
  TokenElement *current;

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "ScanConstants" << endl;
#endif
  
  oldpos = gl->Pos();

  gl->SetPos (0);  
  
  for (i=0; i<length; i++)
    {
    current = &(gl->Next ());
    if (current->token == CONSTANT)
      {
      x = new XplDouble (1);
      (*x)(0) = current->content.Real;
      obj = new XplObject (x);
      obj->SetWriteProtection ();       // must not deleted from TL
      current->token = VARIABLE;        // think about because of reference !
      current->content.Var = new Variable (obj);
      }
    }
  gl->SetPos (oldpos);
}

void ScanKeyword (GlobalList *gl)
/* checks different errors connected with keywords
Invoked by: Macro::SetRun
Invokes:    GlobalList ops, 
Input:      GlobalList ops, 
Output: 
dynamic: nothing   */
{
  Vector<TokenElement> *tl = gl->GetTokenList ();
  long  i, oldpos, length = tl->laenge ();
  int   mif, mwhile, mdo, mswitch, mproc, token, expectpar = FALSE;
  const char  *macname, empty[] = "";
  TokenElement *current;

#ifdef TTKDEBUG
if (ttkdebug)
  cerr << "ScanKeyword" << endl;
#endif

  mif = mwhile = mdo = mswitch = mproc = 0;
  macname = empty;

  oldpos = gl->Pos();

  gl->SetPos (0);  
  
  for (i=0; i<length;)      // i is incremented by Next
    {
    current = &(gl->Next ());  i++;
    token = current->token;
    if (expectpar)
      {
      if (token != '(')
        {
        globalError.Set (ERR_SYNTAX, "expect '('", macname, current->SourceLine);
        return;
        }
      expectpar = FALSE;
      continue;
      }

    switch (token)
      {
      case UNKNOWNINPUT:
	            {
	            globalError.Set (ERR_INPUT, current->content.Name, macname, current->SourceLine);
		    return;
                    }
                    break;
      case IF:      if (mproc == 0)
	              {
	              globalError.Set (ERR_INTERN, "Control flow only within procedures", macname, current->SourceLine);
		      return;
		      }
		    mif++;  expectpar = TRUE;  break;
      case ELSE:    if (mif == 0)
                      {
	              globalError.Set (ERR_ELSE, "", macname, current->SourceLine);
	              return;
                      }
                    break;
      case ENDIF:   if (mif-- == 0)
                      {
                      globalError.Set (ERR_ENDIF, "", macname, current->SourceLine);
               return;
               }
              break;
      case WHILE:   if (mproc == 0)
	              {
	              globalError.Set (ERR_INTERN, "Control flow only within procedures", macname, current->SourceLine);
		      return;
		      }
		    mwhile++;  expectpar = TRUE;  break;
      case ENDO:    if (mwhile-- == 0)
                      {
               globalError.Set (ERR_ENDO);
               return;
               }
              break;
      case REPEAT:  if (mproc == 0)
	              {
	              globalError.Set (ERR_INTERN, "Control flow only within procedures", macname, current->SourceLine);
		      return;
		      }
		    mdo++;  break;
      case UNTIL:   if (mdo-- == 0)
                      {
               globalError.Set (ERR_UNTIL, "", macname, current->SourceLine);
               return;
               }
              expectpar = TRUE;  break;
      case SWITCH:  if (mproc == 0)
	              {
	              globalError.Set (ERR_INTERN, "Control flow only within procedures", macname, current->SourceLine);
		      return;
		      }
		    mswitch++;  break;
      case CASE:    if (mswitch == 0)
                      {
               globalError.Set (ERR_CASE, "missing switch", macname, current->SourceLine);
               return;
               }
              expectpar = TRUE;  break;
      case DEFAULT: if (mswitch == 0)
                      {
               globalError.Set (ERR_DEFAULT, "missing switch", macname, current->SourceLine);
               return;
               }
              break;
      case BREAK:   if (mswitch == 0)
                      {
               globalError.Set (ERR_SBREAK, "missing switch", macname, current->SourceLine);
               return;
               }
              break;
      case ENDSW:   if (mswitch-- == 0)
                      {
               globalError.Set (ERR_ENDSW, "missing switch", macname, current->SourceLine);
               return;
               }
              break;
      case XPROC:
	if (mif != 0)
	  {
	  globalError.Set (ERR_IF, "expect endif before new procedure", macname, current->SourceLine);
	  return;
	  }
		      if (mwhile != 0)
                      {
               globalError.Set (ERR_WHILE, "expect endo before new procedure", macname, current->SourceLine);
               return;
               }
                if (mdo != 0)
                      {
               globalError.Set (ERR_REPEAT, "expect until before new procedure", macname, current->SourceLine);
               return;
               }
                if (mswitch != 0)
                      {
               globalError.Set (ERR_SWITCH, "expect endsw before new procedure", macname, current->SourceLine);
               return;
               }
                if (mproc++ != 0)
                      {
               globalError.Set (ERR_PROC, "nested procedures are not allowed", macname, current->SourceLine);
               return;
               }
// now read and check the procedure's header
                    if (i+1 >= length)
                      {
               globalError.Set (ERR_PROC, "unexpected EOF in definition of procedure", macname, current->SourceLine);
               return;
               }
               current = &(gl->Next ());  i++;
               token = current->token;
                    if (token != '(')
                      {
               globalError.Set (ERR_PROC, "expect '(' after proc", macname, current->SourceLine);
               return;
               }
              while (i < length)
                      {
               current = &(gl->Next ());  i++;
               token = current->token;
               if (token == ')')  break;
               }
                    if (token != ')')
                      {
               globalError.Set (ERR_PROC, "missing ')'", macname, current->SourceLine);
               return;
               }
                    if (i+1 >= length)
                      {
               globalError.Set (ERR_PROC, "unexpected EOF in definition of procedure", macname, current->SourceLine);
               return;
               }
               current = &(gl->Next ());  i++;
               token = current->token;
                    if (token != '=')
                      {
               globalError.Set (ERR_PROC, "expect '=' after parameter list", macname, current->SourceLine);
               return;
               }
                    if (i+1 >= length)
                      {
               globalError.Set (ERR_PROC, "unexpected EOF in definition of procedure", macname, current->SourceLine);
               return;
               }
               current = &(gl->Next ());  i++;
               token = current->token;
              if (token == FUNCTION)
                      {
               globalError.Set (ERR_PROC, "cannot overwrite function ");
               globalError.AppendText (ERR_PROC, current->content.Fun->Name ());
               return;
               }
              if ((token != NEWSTRING) && (token != MACRO))
                      {
               globalError.Set (ERR_PROC, "expect name after '='");
               return;
               }
                    if (i+1 >= length)
                      {
               globalError.Set (ERR_PROC, "unexpected EOF in definition of procedure", macname, current->SourceLine);
               return;
               }
               macname = (token == MACRO) ? current->content.Mac->Name() : current->content.Name;
               current = &(gl->Next ());  i++;
               token = current->token;
                    if (token != '(')
                      {
               globalError.Set (ERR_PROC, "expect '(' after name", macname, current->SourceLine);
               return;
               }
              while (i < length)
                      {
               current = &(gl->Next ());  i++;
               token = current->token;
               if (token == ')')  break;
               }
                    if (token != ')')
                      {
               globalError.Set (ERR_PROC, "missing ')'", macname, current->SourceLine);
               return;
               }
              break;
      case ENDP:    if (mproc-- == 0)
                      {
               globalError.Set (ERR_ENDP, "", macname, current->SourceLine);
               return;
               }
                    if (mif != 0)
                      {
               globalError.Set (ERR_IF, "dangling endif", macname, current->SourceLine);
               return;
               }
                if (mwhile != 0)
                      {
               globalError.Set (ERR_WHILE, "dangling endo", macname, current->SourceLine);
               return;
               }
                if (mdo != 0)
                      {
               globalError.Set (ERR_REPEAT, "dangling do", macname, current->SourceLine);
               return;
               }
                if (mswitch != 0)
                      {
               globalError.Set (ERR_SWITCH, "dangling switch", macname, current->SourceLine);
               return;
               }
               macname = empty;  break;
       }  // switch
    }  // for
  gl->SetPos (oldpos);
  if (mif != 0)
    globalError.Set (ERR_IF, "missing endif", macname, current->SourceLine);
  if (mwhile != 0)
    globalError.Set (ERR_WHILE, "missing endo", macname, current->SourceLine);
  if (mdo != 0)
    globalError.Set (ERR_UNTIL, "missing until", macname, current->SourceLine);
  if (mswitch != 0)
    globalError.Set (ERR_SWITCH, "missing endsw", macname, current->SourceLine);
  if (mproc != 0)
    globalError.Set (ERR_PROC, "missing endp", macname, current->SourceLine);

}  // ScanKeyword

void    ScanFunsAndMacs    (GlobalList *gl)
/* scans tokenlist (gl) for NEWSTRING, if they are FUNS or MACS
Invoked by: Macro::SetRun, main
Invokes:    GlobalList ops, 
Input:      gl
Output: none (tokenlist)
dynamic: nothing   */
{
  Vector<TokenElement> *tl = gl->GetTokenList ();
  long     i, oldpos, length = tl->laenge () - 1;
  Macro    *mac;
  Function *fun;
  TokenElement	*current, *next;

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "ScanFunsAndMacs" << endl;
#endif
  
  oldpos = gl->Pos();

  gl->SetPos (0);  
  
  next = &(gl->Next ());
  for (i=0; i<length; i++)
    {
    current = next;
    next = &(gl->Next ());
    if (next->token != '(')       // can't be proc or fun
      continue;
    if ((current->token == NEWSTRING) || (current->token == MFCAND))
      {
      if ((fun = GetFunction (current->content.Name)) != NULL)
	{
	delete[] current->content.Name;
	current->token = FUNCTION;
	current->content.Fun = fun;
	continue;
        } // changed checking order from Mac,Func to Func,Mac, SK 11.09.2000
      if ((mac = GetMacro (macList, current->content.Name)) != NULL)
	{
	delete[] current->content.Name;
	current->token = MACRO;
	current->content.Mac = mac;
	continue;
        }
      }
    }
  gl->SetPos (oldpos);
}


void    ScanMacroVariables (Liste<XplObject*> *objList, const GlobalList *gl)
/* translates every NEWSTRING of tokenlist (gl) into VARIABLE (only sensible for macros)
Invoked by: Macro::SetRun
Invokes:    GlobalList ops, 
Input:      objList, gl
Output: none (tokenlist)
dynamic: new Variable   */
{
  Vector<TokenElement> *tl = gl->GetTokenList ();
  long i, pos, lastObj = objList->laenge (),
               length  = tl->laenge ();
//  int           tok, flag = FALSE;
  char          *n;
  XplObject     *obj;
  TokenElement	*current, *last = NULL;

#ifdef TTKDEBUG
if (ttkdebug)
  cerr << "ScanMacroVariabless" << endl;
#endif

  for (i=0; i<length; i++)
    {
    current = &(*tl)[i];
    if (current->token == XPROC)             // skip proc defs
      while ((current->token != ENDP) && (i < length))
		current = &(*tl)[i++];
    if (current->token == NEWSTRING)
      {
      if ((*tl)[i+1].token == '(')        // instead of VAR, MACRO is meant
        {
#ifdef TTKDEBUG
if (ttkdebug)
  cerr << "SMV: replace " << current->content.Name << endl;
#endif
		current->token = MFCAND;
        continue;
        }
      //n = strdup (current->content.Name);    // must be more effective
      //delete[] current->content.Name;

	  n = current->content.Name; //  TTK, 6.1.99

      // Try   n = current->content.Name; //  will be deleted at the right time
      // TTK, 9.2.98

      obj = GetXplObject (constList, n, pos);
      if (obj != NULL)           // first, check for CONSTVARs
		{
		current->token = CONSTVAR;
		current->content.Obj = obj;
		continue;
        }

      obj = GetXplObject (objList, n, pos);
      if (obj == NULL)
		{
		current->token = VARIABLE;
		current->content.Var = new Variable (n, lastObj++);
		objList->haengeAn (new XplObject (n));
		delete[] n;
		continue;
        }
      else
		{
		current->token = VARIABLE;
		current->content.Var = new Variable (n, pos);
        delete[] n;
		continue;
        }

      // kann nicht auftreten ! check  TTK, 9.2.98
	  // TTK 6.1.99
	  exit (2);
	}
  }

/*
	  if (flag && tok == DOT)        // translate VAR DOT -> simpleVar = FALSE
       {
#ifdef TTKDEBUG
if (ttkdebug)
       cerr << "SMVError:  VAR followd by DOT" << endl;
#endif
       last->content.Var->SetSimpleVar (FALSE);
       }

      }
    flag  = (tok == VARIABLE);        // set VAR flag 
    last  = current;
    }
*/
}

int    ScanVariables (Liste<XplObject*> *objList, const GlobalList *gl)
/* translates NEWSTRING of tokenlist (gl) into VARIABLE or CONSTVAR,
   if they are in objList or constList, respectively.
Invoked by: Macro::SetRun, main
Invokes:    GlobalList ops, 
Input:      objList, gl
Output: none (tokenlist)
dynamic: new Variable   */
{
  Vector<TokenElement> *tl = gl->GetTokenList ();
  long i, pos, length  = tl->laenge (),
               flag = FALSE, flag2 = FALSE, tok;
  char *n;
  XplObject *obj;
  TokenElement	*current, *last = NULL;
  int result = TRUE;

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "ScanVariables" << endl;
#endif

  for (i=0; i<length; i++)
    {
    current = &(*tl)[i];
    tok = current->token;
    if (tok == XPROC)                    // skip proc defs
      while ((tok != ENDP) && (i < length))
	current = &(*tl)[i++];
    if (tok == NEWSTRING)       // check whether Token is in constList
      {
      obj = GetXplObject (constList, current->content.Name, pos);
      if (obj != NULL)
	{
	delete[] current->content.Name;
	current->token = CONSTVAR;
	current->content.Obj = obj;
	last = current;
	continue;
        }

      obj = GetXplObject (objList, current->content.Name, pos);
      if (obj != NULL)       // check whether Token is in objList
	{
	n = current->content.Name;
	current->token = VARIABLE;
	current->content.Var = new Variable (n, pos);
 flag = TRUE;
        delete[] n;                   // last chance to delete NEWSTRING
	last = current;
	continue;
        }
      }
     if (flag && tok == '(')        // translate VAR '('  to MFCAND '(' 
       {
       result = FALSE;
       cerr << "Error:  VAR followd by (" << endl;
       last->token = MFCAND;
       n = strdup (last->content.Var->Name ());
       delete last->content.Var;
       last->content.Name = n;
       }

     if (flag2 && tok == '(')        // translate NEWSTRING '('  to MFCAND '(' 
       {
       result = FALSE;
       //       cerr << "Error:  NEWSTRING followd by (" << endl;
       last->token = MFCAND;         // type of NEWSTRING and MFCAND are equal
       }

     if (flag && tok == DOT)        // translate VAR DOT -> simpleVar = FALSE
       {
#ifdef TTKDEBUG
if (ttkdebug)
       cerr << "Error:  VAR followd by DOT" << endl;
#endif
       last->content.Var->SetSimpleVar (FALSE);
       }

     flag  = (tok == VARIABLE);        // set VAR flag 
     flag2 = (tok == NEWSTRING);       // set NEWSTRING flag 
     if (flag)
      {
#ifdef TTKDEBUG
if (ttkdebug)
  {
      ttkmessage((*tl)[i].content.Var->Position());
      ttkmessage((*tl)[i].content.Var->Name());
      ttkmessage('\n');
  }
#endif
      if (! current->content.Var->Constant())     // kein CONST
	current->content.Var->SetUseXplObject (NULL);
        // forces parser to get objects via name or pos
      }
    last  = current;
    }
  return (result);
}
      

void    SetVariables2Null (GlobalList *gl)
/* sets all VARIABLEs in tokenlist of gl to NULL. Necessary because after recursion
   Furthermore VAR are checked whether there are simple or followed by DOT
   the information regarding useObj within VARIABLE is NOT valid !
Invoked by: ParseMacro
Invokes:    GlobalList ops, 
Input:      gl
Output: none (tokenlist)
dynamic: nothing   */
{
  Vector<TokenElement> *tl = gl->GetTokenList ();
  long          i, length  = tl->laenge ();
  TokenElement	*current, *last = NULL;
  int           flag = FALSE;

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "SetVariables2Null" << endl;
#endif

  for (i=0; i<length; i++)
    {
    current = &(*tl)[i];
    if (current->token == VARIABLE)
      {
      if (! current->content.Var->Constant())
	current->content.Var->SetUseXplObject (NULL);
      }
    if (flag && current->token == DOT)
      last->content.Var->SetSimpleVar (FALSE);
    flag = current->token == VARIABLE;
    last = current;      
    }
}

void    ScanXplObjects (Liste<XplObject*> *objList, const GlobalList *gl)
/* ?? NECESSARY ??

Can probably be deleted!   TTK 4.6.96

   follows XplObject hierarchy of NEWSTRING and VARIABLE
   Invoked by: main 
Invokes:    EvalXplObject, GetXplObject
Input:      objList, gl
Output: none (tokenlist)
dynamic: new Variable   */
{
  Vector<TokenElement> *tl = gl->GetTokenList ();
  long pos = 0, length = tl->laenge ();
  XplObject *obj;

#ifdef TTKDEBUG
if (ttkdebug)
cerr << "ScanXplObjects" << endl;
#endif


  while (1)
    {
    while ((pos < length) && ((*tl)[pos].token != NEWSTRING) && ((*tl)[pos].token != VARIABLE))
      pos++;
    
    if (pos == length)               // no more NEWSTRINGs found
      break;

    if ((*tl)[pos].token == NEWSTRING)
      obj = GetXplObject (objList, (*tl)[pos].content.Name);
    else
      obj = GetXplObject (objList, (*tl)[pos].content.Var->Name ());

    if (obj == NULL)                 // NEWSTRING is not an XplObject
      {
      pos++;
      continue;
      }
pos++;
//    EvalXplObject (objList, tl, pos);   // EvalVariable should do the job
    }
}

Variable * EvalVariable (Vector<TokenElement> *tl, long &pos)
/* follows XplObject hierarchy of VARIABLE on position pos in tokenlist
   Invoked by: yylex, main 
Invokes:    GetXplObject
Input:      gl
Output: none (tokenlist)
dynamic: new Variable   */
/* Following improvement should be implemented (TTK, 4.6.96)
   The handling of SimpleVars is probably incorrect. Positions of components
   of composed Objects are ALWAYS NOT fixed. Therefore the setting of
   SimpleVar by composed object are NEVER correct.

   Solution: Check VAR, if there are followed by DOT. If not, set SimpleVar,
   otherwise it is not simple and must be checked by each call.
*/

{
  Variable  *var = (*tl)[pos].content.Var;
  XplObject *obj, *mother;
  Component *comp;

  if ((*tl)[pos++].token != VARIABLE)
    {
    globalError.Set (ERR_INTERN, "EvalVariable: Tokenlist doesn't start with VARIABLE");
    return (NULL);
    }

/*
   if (var->SimpleVar () == TRUE)     // TEST IT !!
     {
     while ((*tl)[pos++].token == DOT)         // skip over Tokens
       if ((*tl)[pos++].token != VARIABLE)     // and count pos
	 {
	 globalError.Set (ERR_DOT, var->Name());
	 return (NULL);
         }
     pos--;
     return (var);
     }
*/

   if ((*tl)[pos].token != DOT)          // constant or simple var
     return (var);
/*      TTK, 29.12.98
     {
     if (! var->GetXplObject()->WriteProtection ())
       {
       cerr << var->GetXplObject()->Name () << " was not protected (EvalVal)" << endl;
       exit (0);           // if this never happens, optimize
       }
     var->GetXplObject()->SetWriteProtection ();
     return (var);
     }
*/

  var->SetUseXplObject (NULL);        // this guarantees that composed names
  obj = var->GetXplObject ();         // will be evaluated here from scratch
  mother = obj;                       // if composed, the ancestor
  while ((*tl)[pos++].token == DOT)
    {
    switch ((*tl)[pos].token)
      {
      case VARIABLE: 
	comp = obj->GetComponent ((*tl)[pos++].content.Var->Name ());
	break;
      case NEWSTRING:
        comp = obj->GetComponent ((*tl)[pos++].content.Name);
	break;
      case MACRO:
        comp = obj->GetComponent ((*tl)[pos++].content.Mac->Name ());
	break;
      case FUNCTION:
        comp = obj->GetComponent ((*tl)[pos++].content.Fun->Name ());
	break;
      default:
        globalError.Set (ERR_COMP, "EvalVariable: DOT without NEWSTRING\n");
        globalError.AppendText (ERR_COMP, var->GetXplObject()->Name());
        return (NULL);
      }
    if (comp == NULL)
      {
      globalError.Set (ERR_COMP, "EvalVariable: Component doesn't exist\n");
      globalError.AppendText (ERR_COMP, var->GetXplObject()->Name());
      return (NULL);
      }

//    var->SetComponent (comp);

    if (comp->Type() != C_XplObject)
      break;

    obj = comp->Content().xplobject;
    var->SetUseXplObject (obj);

//    var->SetSimpleVar (TRUE);         // TEST IT !!  don't set it
    }

  pos--;               // while increases pos !

  if (obj != mother)   // set only if we have a list
    obj->SetMotherId (mother->Id ());
  obj->SetWriteProtection ();    // VAR must not be deleted 
  return (var);
}

/* Original function SK 11.09.2000
Macro *  GetMacro (Vector<Macro*> *macList, const char *n)
{
  long r, length = macList->laenge ();
  long a, b, m;

  static long lastlength = 0;          // if length has changed -> sort

  if (length == 0)                     // empty macList
    return (NULL);

  if (lastlength != length)            // sort again
    {
    if (length - lastlength == 1)      // only a single new element
      bsortlist (*macList);  //, 0, length-1);
    else
      qsortlist (*macList, 0, length-1);
    lastlength = length;
//    cerr << lastlength << " GetM: sorted " << length << '\t' << length << endl;
    }

  a = 0;
  b = length-1;

  while (a <= b)                 // binary search
    {
    m = (a+b) / 2;
    r = strcmp ((*macList)[m]->Name (), n);
    if (r < 0)
      {
      a = m+1;
      continue;
      }
    if (r > 0)
      {
      b = m-1;
      continue;
      }
    return ((*macList)[m]);
    }

  r = strcmp ((*macList)[m]->Name (), n);
  if (r == 0)
    return ((*macList)[m]);

  return (NULL);
} */

/* Modified SK 11.09.2000 */



Macro *  GetMacro (Vector<Macro*> *macList, const char *n)
{
  long r, length = macList->laenge ();
  long a, b, m;
  char *fdir, loadfile[TEXTLENGTH], line[TEXTLENGTH];

  static long lastlength = 0;          // if length has changed -> sort

  // first try

  length = macList->laenge ();
  if (length>0)
  { if (lastlength != length)            // sort again
    { if (length - lastlength == 1)      // only a single new element
        bsortlist (*macList);  //, 0, length-1);
      else
        qsortlist (*macList, 0, length-1);
      lastlength = length;
    }

    a = 0;
    b = length-1;
    while (a <= b)                 // binary search
    { m = (a+b) / 2;
      r = strcmp ((*macList)[m]->Name (), n);
      if (r < 0)
      { a = m+1;
        continue;
      }
      if (r > 0)
      { b = m-1;
        continue;
      }
      logt ("Macro found");
      return ((*macList)[m]);
    }
    r = strcmp ((*macList)[m]->Name (), n);
    if (r == 0)
    { logt ("Macro found");
      return ((*macList)[m]);
    }
  }

  // start autoloading

  fdir = x4ml.getdir (n);
  if (fdir==NULL) return (NULL);

  sprintf (loadfile, "%s%s%s", fdir, SEPCHAR, n);
  LoadMacro (loadfile, TRUE);         // runs loadfile (reload = TRUE)
  delete[] fdir;

  // second try

  length = macList->laenge ();
  if (length>0)
  { if (lastlength != length)            // sort again
    { if (length - lastlength == 1)      // only a single new element
        bsortlist (*macList);  //, 0, length-1);
      else
        qsortlist (*macList, 0, length-1);
      lastlength = length;
    }

    a = 0;
    b = length-1;
    while (a <= b)                 // binary search
    { m = (a+b) / 2;
      r = strcmp ((*macList)[m]->Name (), n);
      if (r < 0)
      { a = m+1;
        continue;
      }
      if (r > 0)
      { b = m-1;
        continue;
      }
      return ((*macList)[m]);
    }
    r = strcmp ((*macList)[m]->Name (), n);
    if (r == 0) return ((*macList)[m]);
  }
  return (NULL);
}



Function * GetFunction  (const char *n)
{
  long r, length = funList->laenge ();
  /* old definition

  for (i=0; i<length; i++)
    if (strcmp ((*funList)[i]->Name (), n) == 0)
      return ((*funList)[i]);

  return (NULL);
  */


  // new
  long a, b, m;

  a = 0;
  b = length-1;

  while (a <= b)                 // binary search
    {
    m = (a+b) / 2;
    r = strcmp ((*funList)[m]->Name (), n);
    if (r < 0)
      {
      a = m+1;
      continue;
      }
    if (r > 0)
      {
      b = m-1;
      continue;
      }
    return ((*funList)[m]);
    }

  r = strcmp ((*funList)[m]->Name (), n);
  if (r == 0)
    return ((*funList)[m]);

  return (NULL);
}

FileInfo *  GetFileInfo (Vector<FileInfo*> &fileList, const char *n)
{
  long r, length = fileList.laenge ();
  long a, b, m;

  static long lastlength = 0;          // if length has changed -> sort

  if (length == 0)                     // empty fileList
    return (NULL);

  if (lastlength != length)            // sort again
    {
    if (length - lastlength == 1)      // only a single new element
      bsortlist (fileList);
    else
      qsortlist (fileList, 0, length-1);
    lastlength = length;
    }

  a = 0;
  b = length-1;

  while (a <= b)                 // binary search
    {
    m = (a+b) / 2;
    r = strcmp (fileList[m]->Name (), n);
    if (r < 0)
      {
      a = m+1;
      continue;
      }
    if (r > 0)
      {
      b = m-1;
      continue;
      }
    return (fileList[m]);
    }

  r = strcmp (fileList[m]->Name (), n);
  if (r == 0)
    return (fileList[m]);

  return (NULL);
}

XplObject *  GetXplObject (Liste<XplObject*> *objList, const char *n)
{
  long i, length = objList->laenge ();

  for (i=0; i<length; i++) {
    //    printf ("%i %s\n", i, (*objList)[i]->Name ());
    if (strcmp ((*objList)[i]->Name (), n) == 0)
      return ((*objList)[i]);
  }
  return (NULL);
}

int  DeleteXplObject (Liste<XplObject*> *objList, const char *n)
{
  long i, length = objList->laenge ();

  for (i=0; i<length; i++)
    if (strcmp ((*objList)[i]->Name (), n) == 0)
      {
      objList->loesche (i);
      return (TRUE);
      }

  return (FALSE);
}

XplObject *  GetXplObject (Liste<XplObject*> *objList, const char *n, long &pos)
{
  long i, length = objList->laenge ();

  for (i=0; i<length; i++)
    if (strcmp ((*objList)[i]->Name (), n) == 0)
      {
      pos = i;
      return ((*objList)[i]);
      }

  pos = -1;
  return (NULL);
}

XplObject *  GetXplObject (Liste<XplObject*> *objList, const long id, long &pos)
{
  long i, length = objList->laenge ();

  for (i=0; i<length; i++)
    if ((*objList)[i]->Id () == id)
      {
      pos = i;
      return ((*objList)[i]);
      }

  return (NULL);
}

XplObject *  GetXplObject (Liste<XplObject*> *objList, const long id)
{
  long i, length = objList->laenge ();

  for (i=0; i<length; i++)
    if ((*objList)[i]->Id () == id)
      return ((*objList)[i]);

  return (NULL);
}

XplObject *  GetContainerXplObject (Liste<XplObject*> *objList, const long id)
{
  long i, length = objList->laenge ();
  XplObject *o, *r;

  for (i=0; i<length; i++)     // a little bit redundant, but this is
    {                          // the most likely case
    o = (*objList)[i];
    if (o->Id () == id)
      return (o);
    }

  for (i=0; i<length; i++)
    {
    o = (*objList)[i];
    r = o->ContainsXplObject (id);    // o contains r
    if (r != NULL)
      return (o);
    }
  return (NULL);
}

int EvalString (char *b, long &pos)
// for xplore.l
// actually this function is not needed any longer. now returns immediately
// TTK, 27.6.97
{
  return 0;
  int i, length;
 
  length = funList->laenge ();
  
  for (i=0; i<length; i++)
    if (strcmp (b, (*funList)[i]->Name ()) == 0)
      {
      pos = i;
      return (FUNCTION);
      }
  
/*  length = macList->laenge ();    // macro names in parlist allowed
  
  for (i=0; i<length; i++)
    if (strcmp (b, (*macList)[i]->Name()) == 0)
      {
      pos = i;
      return (MACRO);
      }
*/
  return (NEWSTRING);
} 

void	InputBranch (const GlobalList *gl, long pos)
{
  while ((pos = InputIfBranch     (gl, pos)) != 0);
  while ((pos = InputWhileBranch  (gl, pos)) != 0);
  while ((pos = InputUntilBranch  (gl, pos)) != 0);
  while ((pos = InputSwitchBranch (gl, pos)) != 0);
}

long	InputIfBranch (const GlobalList *gl, long pos)
{
  long  oldpos, length;
  int	elseflag = TRUE;
  Vector<TokenElement> *tl = gl->GetTokenList();

  if (globalError.Get ())
    return (0);

  length = tl->laenge();
  
  while ((pos < length) && ((*tl)[pos].token != IF))
    pos++;
  
  if (pos == length)
    return (0);			// Token IF nicht vorhanden
  
  oldpos = pos;
  
  while (1)
    {
    pos++;
    if (pos == length)
      {
      globalError.Set (ERR_INTERN, "if without endif\n");
      return (0);
      }
    switch ((*tl)[pos].token)
      {
      case IF:		pos = InputIfBranch (gl, pos);
			if (pos == 0)
			  return (0);
			break;
      case ELSE:	if (elseflag)
      			  {
      			  (*tl)[oldpos].content.Branch = pos;
      			  oldpos = pos;
      			  elseflag = FALSE;
      			  }
			else
			  {
			  globalError.Set (ERR_INTERN, "ELSE Error in InputIfBranch\n");
			  return (0);
			  }
      			break;
      case ENDIF:	(*tl)[oldpos].content.Branch = pos;  return (pos);
      
//      case '\n':
      case '\0':	globalError.Set (ERR_INTERN, "Unexpected EOF in InputIfBranch\n");
      			return (0);
      			break;
      default:		;
      }
    }
  return (0);
}

long	InputWhileBranch (const GlobalList *gl, long pos)
{
  long oldpos, length;
  Vector<TokenElement> *tl = gl->GetTokenList();

  if (globalError.Get ())
    return (0);

  length = tl->laenge();
  
  while ((pos < length) && ((*tl)[pos].token != WHILE))
    pos++;
  
  if (pos == length)
    return (0);			// Token WHILE nicht vorhanden
  
  oldpos = pos;
  
  while (1)
    {
    pos++;
    if (pos == length)
      {
      globalError.Set (ERR_INTERN, "while without endo\n");
      return (0);
      }
    switch ((*tl)[pos].token)
      {
      case WHILE:     pos = InputWhileBranch (gl, pos);
		      if (pos == 0)
			return (0);
		      break;
      case ENDO:      (*tl)[pos].content.Branch = oldpos;
      		      (*tl)[oldpos].content.Branch = pos;
      		      return (pos);
      
//      case '\n':
      case '\0':      globalError.Set (ERR_INTERN, "Unexpected EOF in InputWhileBranch\n");
      		      return (0);
      		      break;
      default:	      ;
      }
    }
  return (0);
}

long	InputUntilBranch (const GlobalList *gl, long pos)
{
  long repeatpos, length;
  Vector<TokenElement> *tl = gl->GetTokenList();

  if (globalError.Get ())
    return (0);

  length = tl->laenge();
  
  while ((pos < length) && ((*tl)[pos].token != REPEAT))
    pos++;
  
  if (pos == length)
    return (0);			// Token REPEAT nicht vorhanden
  
  repeatpos = pos;
  
  while (1)
    {
    pos++;
    if (pos == length)
      {
      globalError.Set (ERR_INTERN, "do without until\n");
      return (0);
      }
    switch ((*tl)[pos].token)
      {
      case REPEAT:    pos = InputUntilBranch (gl, pos);
		      if (pos == 0)
			return (0);
		      break;
      case UNTIL:     (*tl)[pos].content.Branch = repeatpos;
//     			(*tl)[oldpos].content.Branch = pos;
      		      return (pos);
      
//      case '\n':
      case '\0':      globalError.Set (ERR_INTERN, "Unexpected EOF in InputUntilBranch\n");
      		      return (0);
      		      break;
      default:	      ;
      }
    }
  return (0);
}

long	InputSwitchBranch (const GlobalList *gl, long pos)
{
  long swpos, casepos, defpos, endswpos, length, endsw = 1L;
  int  defaultflag = FALSE, tok;
  Vector<TokenElement> *tl = gl->GetTokenList();

  if (globalError.Get ())
    return (0);

  length = tl->laenge();
  
  while ((pos < length) && ((*tl)[pos].token != SWITCH))
    pos++;
  
  if (pos == length)
    return (0);			// Token SWITCH nicht vorhanden
  
  swpos = casepos = pos++;

  while (pos < length)          // find the end of this switch block
    {
    tok = (*tl)[pos].token;
    if (tok == SWITCH)
      endsw++;
    if (tok == ENDSW)
      endsw--;
    if (endsw == 0)
      {
      endswpos = pos;            // this is the right position
      break;
      }
    pos++;
    }

  if (endsw != 0)
    {
    globalError.Set (ERR_SYNTAX, "InputSwitchBranch: number of ENDSW doesn't match");
    return (0);
    }

  pos = swpos;
  
  while (1)
    {
    pos++;
    if (pos == length)
      {
      globalError.Set (ERR_INTERN, "switch without endsw\n");
      return (0);
      }
    switch ((*tl)[pos].token)
      {
      case SWITCH:	pos = InputSwitchBranch (gl, pos);
			if (pos == 0)
			  return (0);
			break;
      case CASE:	(*tl)[casepos].content.Branch = pos;
			casepos = pos;  break;
      case BREAK:	(*tl)[pos].content.Branch = endswpos;  break;
      case DEFAULT:	if (defaultflag)
	                  {
			  globalError.Set (ERR_SYNTAX, "second default in switch");
			  return (0);
			  }
			(*tl)[casepos].content.Branch = pos;
			defpos = pos;
			defaultflag = TRUE;  break;
      case ENDSW:	if (!defaultflag)
	                  (*tl)[casepos].content.Branch = pos;  // last CASE
			(*tl)[pos].content.Branch = endswpos;    // for ENDSW
			return (pos);
//      case '\n':
      case '\0':      globalError.Set(ERR_SYNTAX, "Unexpected EOF in InputSwitchBranch\n");
      		      return (0);
      		      break;
      default:	      ;
      }
    }
  return (0);
}

XplObject *	ParseMacro (Macro *m, Liste<XplObject*> *args)
{
  Liste<const char*>   inp = m->inPar(), outp = m->outPar();
  long	  	       length, l, i, j;
  XplObject            *obj, *go, *robj = NULL;
  Liste<XplObject*>*   oldObjList;
  char                 errorText[1024];
  const char           *oldMacroName;
  int                  expandcount = 0, expand = FALSE;

  static unsigned long frame = 0;
  static int           errorFlag = FALSE;

  if (frame>MAXFRAME) // SK 2.11.2000
  { globalError.Set (ERR_INTERN, "Max frame number reached\nCheck for recursive quantlet call !");
  }


  if (globalError.Get())      // if there is an error, don't proceed
    return (NULL);

  if (m->CheckMacro () == FALSE)
    {
    globalError.Set (ERR_REF, " in macro");
    globalError.AppendText (ERR_REF, m->Name ());
    return (NULL);
    }

  SetVariables2Null (m->globalList ());   // resets the VARs in tl (recursion!)

  length = inp.laenge();  
  if (length < args->laenge())     // allow to have less than defined
    {
    globalError.Set (ERR_NUMARG, m->Name() );
    return (NULL);
    }
  
  oldMacroName = CurrentMacro;
  CurrentMacro = m->Name ();

  frame++;          // counts the depth of calling ParseMacro

  oldObjList = objList;
  objList = new Liste<XplObject*>;

  CopyXplObjectList (objList, m->XplObjectList());

//  cout << "Nach CopyXplObj: objList" << endl;
//  PrintXplObjectList (objList);
//  cout << "Nach CopyXplObj: m->objList" << endl;
//  PrintXplObjectList (m->XplObjectList());
// cout << "ende" << endl;

// try to expand a single object, if more than one are expected


  if ((length > 1) && (args->laenge () == 1))
    {
    XplObject *oo, *o = (*args)[0];
    if (o->Type () & O_COMPOSED)    // if first obj is simple proceed
     {
    expand = TRUE;
    for (i=0; i<length; i++)
      for (j=0; j<o->ComponentNumber(); j++)
	{
	if ((*o)[j]->Type() != C_XplObject)
	  {
cerr << "expand geht nicht 2" << (*o)[j]->Name() << endl;
continue;
}
else
          oo = (*o)[j]->Content().xplobject;
          {
          if (strcmp (inp[i], oo->Name ()) == 0)
	    {
expandcount++;
            (*objList)[i]->TransferComponents (oo);
	    break;   // for (j)
	    }
          }
        }
     }
//    cout << "expand list: " << length << "\n";
//    PrintXplObjectList (objList);
    }

if (!expand || expandcount == 0)    // common interpretation of parameters
{                                   // respectively no expansion could be done
  length = args->laenge();
  for (i=0; i<length; i++)
    {
    if ((*args)[i]->Type () == O_EMPTY)    // input arg is empty
      globalError.Set (ERR_EMPTY, (*args)[i]->Name ());

    if ((*args)[i]->Type () != O_DISPLAY)
      (*objList)[i]->TransferComponents ((*args)[i]);
    else
      {
      (*objList)[i]->CopyElements ((*args)[i]);
      (*args)[i]->DeleteElements ();         // transfer ??
/*      if ((*args)[i]->MotherId () != 0 )     // for nested procs
	(*objList)[i]->SetMotherId ((*args)[i]->MotherId ());
      else
*/	(*objList)[i]->SetMotherId ((*args)[i]->Id ());
      }
    }
//  PrintXplObjectList (objList);
}

  ScanXplObjects (objList, m->globalList());   // resolves remaining(?) NEWSTRINGs
                                          // are some NEWSTRINGS  resolved ?
                                          // should not happen !

  // modify ScanVariables: only to reset the variables, the rest is
  // already done in CheckMacro    TTK, 27.1.96
//  ScanVariables (objList, m->globalList());     // reset VARIABLES

  // delete! only necessary to translate MFCAND into FUN or MAC
  // should be done in xplore.y  
//  ScanFunsAndMacs (objList, m->globalList ());  // for still unknown macros

//  ShowTokenList (m->globalList ());

#ifdef TTKDEBUG
int checkdebug = 0;
if (checkdebug)
  PrintXplObjectList (objList);
#endif

  if (!globalError.Get ())         // error in args ?
    {
    m->SetRun (TRUE);
    ParseTokenList (*(m->globalList()));
    m->SetRun (FALSE);
    }

CurrentMacro = oldMacroName;        // restore the calling name

  if (globalError.Get ())             // if an error happened
    {
    errorFlag = TRUE;
    sprintf (errorText, "%s frame: %ld\n", m->Name(), frame);
    globalError.AppendText (errorText);
//    return (NULL);
    }

  length = objList->laenge ();
  for (i=0; i<length; i++)
    (*objList)[i]->DelWriteProtection ();     // allow all XplObjects to delete

//  PrintXplObjectList (objList);

/*  length = inp.laenge ();              // check input parameter for DISPLAY

  for (i=0; i<length; i++)
    {
    obj = GetXplObject (objList, inp[i]);
    if (obj->Type () == O_DISPLAY)
      obj->DeleteElements ();         // delete only pointers, sets type
    }
*/
  length = outp.laenge ();

  if (length > 0)                          // are there output parameter ?
    {
    obj = GetXplObject (objList, outp[0]);
    if (obj == NULL)
      {
      sprintf (errorText, "%s in macro %s\n", obj->Name(), m->Name());
      globalError.Set (ERR_RETARG, errorText);
      }
    if (length > 1)                             // result single obj or list ?
      robj = new XplObject (new Component (obj));    // it is a list
    else
      robj = obj;                                 // it is only an obj
    }

  if (length > 0)                          // if there is an output object
    DeleteXplObject (objList, outp[0]);    // delete this obj from objList

  for (i=1; i<length; i++)
    {
    obj = GetXplObject (objList, outp[i]);
    if (obj == NULL)
      {
      sprintf (errorText, "%s in macro %s\n", obj->Name(), m->Name());
      globalError.Set (ERR_RETARG, errorText);
      }
    robj->AppendComponent (new Component (obj));
    DeleteXplObject (objList, outp[i]);            // delete this obj from objList
    }
    
extern   Liste<XplObject*>*   globObjList;

/*  l = objList->laenge ();         // delete remaining XplObjects
  for (i=0; i<l; i++)
    {
    go  = NULL;                      // because of last if
    obj = (*objList)[i];
    if (obj->Type() == O_DISPLAY)    // generated in macro
      {
      go = GetXplObject (globObjList, obj->Name ());
      if (go == NULL)                // new ?
	{
	go = GetXplObject (globObjList, obj->MotherId ());
	if (go == NULL)                // copy of global ?
	  {
	  go = new XplObject (obj->Name ());
	  go->TransferComponents (obj);      // get the display
	  globObjList->haengeAn (go);
          }
	else
	  if (go->DefaultComponent()->Content().display != obj->DefaultComponent()->Content().display)
	    go->TransferComponents (obj);     // shift display to glob obj
          else  // go is global. was input for macro
	    continue;        // if there are equal, don't delete !!
        }
      else   // go is global, but no input
	  if (go->DefaultComponent()->Content().display != obj->DefaultComponent()->Content().display)
	    go->TransferComponents (obj);     // shift display to glob obj
          else
	    continue;        // if there are equal, don't delete !!
      }
    if (go != obj)                      //
      delete obj;                       // now local obj can be deleted
    }
*/

/*  for (i=0; i<l; i++)
    {
    go  = NULL;                      // because of last if
    obj = (*objList)[i];
    if (obj->Type() == O_DISPLAY)    // generated in macro
      {
      go = GetXplObject (globObjList, obj->Name ());
      if (go == NULL)                // new ?
	{
	go = GetXplObject (globObjList, obj->MotherId ());
	if (go == NULL)                   // go generated in macro
	  {
	  go = new XplObject (obj->Name ());
	  go->TransferComponents (obj);      // get the display
	  globObjList->haengeAn (go);
          }
	else                              // MotherId is known
	  {
	  if (go->DefaultType () != O_EMPTY)
	    {
	    cerr << "Error in ParseMacro: glob obj was expected to be empty ";
	    cerr << "obj name: " << go->Name() << endl;
	    exit (1);
	    }
	  go->TransferComponents (obj);     // shift display to glob obj
	  }
        }
      else  // go is global, known by name
	{
	if (go->DefaultType () != C_EMPTY)
	  if (go->DefaultComponent()->Content().display == obj->DefaultComponent()->Content().display)
	    {
	    obj->DeleteElements ();
	    delete obj;
	    continue;
	    }
	go->DelWriteProtection ();           // remove old global
	go->DeleteComponents ();
	go->TransferComponents (obj);
        }
      }
*/

  l = objList->laenge ();         // delete remaining XplObjects
  for (i=0; i<l; i++)
    {
    go  = NULL;                      // because of last if
    obj = (*objList)[i];
    if (obj->Type() == O_DISPLAY)    // generated in macro
      {
      if (obj->MotherId() != 0)      // was it delivered  
        {
        go = GetXplObject (oldObjList, obj->MotherId ());
        if (go == NULL)
          {
          cerr << "Fatal error: lost delivered display ";
          cerr << obj->Name() << endl;
          exit (1);
          }
        if (!go->isEmpty ())
          {
          cerr << "Fatal error: delivered display not empty ";
          cerr << go->Name() << endl;
          exit (1);
          }
        go->TransferComponents (obj);      // get the display
	// if necessary delete obj from displayList
	long pos;
	XplObject *o = GetXplObject (displayList, obj->Id(), pos);
	if (o == obj)
	  displayList->loesche (pos);

        delete obj;
        continue;
        }
      go = GetXplObject (globObjList, obj->Name ());
      if (go != NULL)                   // go generated in macro
	{
        go->DelWriteProtection ();
        go->DeleteComponents ();
        go->TransferComponents (obj);
        delete obj;
        continue;
        }
      else
	{
	go = new XplObject (obj->Name ());
	go->TransferComponents (obj);      // get the display
	globObjList->haengeAn (go);
        delete obj;
        continue;
        }
      }
    if (go == obj)                      //
      {
      cerr << "Error in ParseMacro: glob obj equal to local display";
      cerr << "should never happen  g obj: " << go->Name ();
      exit (1);
      }
    delete obj;                       // now local obj can be deleted
    }

  objList->remove ();                 // remove objList
  delete objList;
  objList = oldObjList;
  
  SetVariables2Null (m->globalList ());   // resets the VARs in tl (recursion!)

  frame--;

  if (globalError.Get())      // if an error occured in called macro
    {
    if (robj != NULL)
      delete robj;
    return (NULL);
    }

  if (length > 0)                         // if there is an output object
    return (robj);                        // deliver robj
  else
    return (NULL);
}

void    DeleteVariables (GlobalList *gl)
{
  Vector<TokenElement> *tl = gl->GetTokenList ();
  long pos = 0, length = tl->laenge ();

  while (1)
    {
    while ((pos < length) && ((*tl)[pos].token != VARIABLE))
      pos++;
    
    if (pos == length)               // no more VARIABLEs found
      break;

    delete (*tl)[pos++].content.Var;
    }
}

void AssignLocalVariables (GlobalList *gl, Liste<XplObject*> *objList)
{
  TokenElement	*current;
  long pos = 0, length, oldpos, i;
  Vector<TokenElement> *tl = gl->GetTokenList();
  XplObject *obj;
  
  oldpos = gl->Pos();
  
  length = tl->laenge();
  
  
  for (i=oldpos; i<length; i++)
    {
     current = &gl->Next ();
     switch (current->token)  {
       case NEWSTRING:
       		if (EvalString (current->content.Name, pos) == MACRO)
		  {
		  current->token = MACRO;
		  current->content.Mac = (*macList)[pos];
		  break;
		  }
		obj = GetXplObject (objList, current->content.Name);
       		if (obj == NULL)
		  {
		  current->token = VARIABLE;
		  current->content.Var = new Variable (current->content.Name, -1);
		  (*objList).fuegeEin (obj);
		  }
		else
		  {
		  current->token = VARIABLE;
		  current->content.Var = new Variable (obj);
		  }
		break;
	case VARIABLE:
		obj = GetXplObject (objList, current->content.Name);
		if (obj != NULL)
		  {
		  current->content.Var = new Variable ((*objList)[pos]);
		  }
		break;
	default: ;
        }
      }
   gl->SetPos (oldpos);
}

/*
int EvalString (char *b, int &pos)
{
  int i, length = objList->laenge();
  
  for (i=0; i<length; i++)
    if (strcmp (b, (*objList)[i]->Name ()) == 0)
      {
      pos = i;
      return (VARIABLE);
      }
  
  length = funList->laenge();
  
  for (i=0; i<length; i++)
    if (strcmp (b, (*funList)[i]->Name ()) == 0)
      {
      pos = i;
      return (FUNCTION);
      }
  
  length = macList->laenge();
  
  for (i=0; i<length; i++)
    if (strcmp (b, (*macList)[i]->Name ()) == 0)
      {
      pos = i;
      return (MACRO);
      }
  return (NEWSTRING);
} 
*/

void parse (const char *line)
{	
  FILE       *fout, *fin;
  GlobalList gl;
  Vector<TokenElement> *t1;
  Vector<TokenElement> t2;
  TokenElement current;
  long         i, length;
  int          ParseError = FALSE;

  if (strlen (line) == 0)
    return;
  
  //  printf ("xpl4parsefile=%s\n",xpl4parsefile);
  if (NULL == (fout = fopen (xpl4parsefile, "w")))
    {
    cerr << "Execute (parse): can't open temporary file" << endl;
    globalError.Set (ERR_INTERN, "Execute (parse): can't open temporary file");
    globalError.ShowError ();
    return;
    }
  fputs (line, fout);
  fputc ('\n', fout);
  fclose (fout);
  
  fin = fopen (xpl4parsefile, "r");
  yyrestart (fin);

  BuildTokenList (&gl, '\0');

  fclose (fin);
  remove (xpl4parsefile);

  t1 = gl.GetTokenList ();

  i = 0;
  length = t1->laenge ();

  while ((i<length) && !ParseError)    // don't proceed by errors
    {
    do
      {
      current = (*t1)[i++];
      if (current.token != '\0')
	t2.haengeAn (current);
      } while ((current.token != '\n') && (current.token != '\0'));

    if (t2.laenge() == 0)         // TL consists only of '\0'
      continue;

    current.token = '\n';         // parser needs '\n' for the end of a
    t2.haengeAn (current);        // command

    GlobalList gl1 (&t2);

    ScanKeyword (&gl1);
    ScanFunsAndMacs (&gl1);
    ScanVariables (objList, &gl1);
    InputBranch (&gl1, 0L);
#ifdef TTKDEBUG
if (ttkdebug)
    ShowTokenList (&gl1);
#endif
    ParseError = ParseTokenList (gl1);
    DeleteVariables (&gl1);

    t2.remove ();
    }

  yyrestart (stdin);
}

void parse (FILE *fin)
{	
  GlobalList gl;
  Vector<TokenElement> *t1;
  Vector<TokenElement> t2;
  long i, length;
  TokenElement current;
  int procflag = FALSE;

  if (fin == NULL)
    return;
  
  yyrestart (fin);

  BuildTokenList (&gl, '\0');

  t1 = gl.GetTokenList ();

  i = 0;
  length = t1->laenge ();

  while (i<length)
    {
    do
      {
      current = (*t1)[i++];
      if (i >= length)            // don't read after the end
	break;
      if (current.token == XPROC)
	if (procflag)
	  {
	  globalError.Set (ERR_INTERN, "parse: second proc token without previous endp");
	  return;
	  }
        else
	  procflag = TRUE;
      if (current.token == ENDP)
	  procflag = FALSE;
      if (current.token != '\0')
	t2.haengeAn (current);
      } while(procflag || (current.token != '\n') && (current.token != '\0'));

    t2.haengeAn (current);   // TTK 26.1.96   {a,b}=  error
    GlobalList gl1 (&t2);

    ScanKeyword (&gl1);
    ScanFunsAndMacs (&gl1);
    ScanVariables (objList, &gl1);
    InputBranch (&gl1, 0L);
#ifdef TTKDEBUG
if (ttkdebug)
    ShowTokenList (&gl1);
#endif
    ParseTokenList (gl1);
    DeleteVariables (&gl1);

    t2.remove ();
    }

  yyrestart (stdin);
}

int GenerateTempXplObjects (Liste<XplObject*> *argl)
//  invoked of the parser
//  Don't copy plots or displays !!! 
//  Check for empty objects
{
  long i, length = argl->laenge();
  XplObject *x;

  for (i=0; i<length; i++)
    {
    x = (*argl)[i];
    if (x->Type () == O_EMPTY)
      {
      globalError.Set (ERR_EMPTY, x->Name());
      return (FALSE);
      }
    if (x->WriteProtection ())
      {
      if ((x->Type () == O_PLOT) || (x->Type () == O_DISPLAY))
	continue;
      (*argl)[i] = new XplObject (x);
      }
    }
  return (TRUE);
}

#ifndef MATRIX
XplSelection *  
   GenerateXplSelection (XplIndex dimx, int &nsel, Liste<XplDouble*> *xd)
{
// TTK, 25.3.96
// executes selection, ATTENTION: xd has to be removed!
//
  long i, j, n, ind, length;
  XplSelection *res;
  XplDouble one(1);

  if (xd==NULL) return (NULL);
  length = xd->laenge();
  one[0] = 1.0;

  // Bestimmung von dimension sehr unsauber mit SK Code. Leider keine
  // Memberfunktion vorhanden. MAX_XARRAY auf 8 gesetzt

#define MAX_XARRAY 8
  i = 0;
    for (j=MAX_XARRAY-1; j>-1; j--)
      if (dimx(j)>1)
	{
	i = j+1;
        break;
        }
#undef MAX_XARRAY

//  i = x->dimension();

  i = i == 0 ? 1 : i;   // scalar has dimension 0!!

  if (length > i)       // forget last selections
    while (i != length)
      {
/* nobody wants to have warnings    TTK, 7.2.97
      if (((*xd)[i] == NULL) || (*xd)[i]->dimension() != 0)     // more than a scalar
	{
        sprintf (text, "Dimension %ld", i+1);
  	  globalWarning.Set (WARN_SELECT, text);
        }
*/
      xd->loesche (length--);
      }

  if (length < i)       // fill up with one
    for (;length<i; length++)
      xd->haengeAn ((XplDouble*) NULL);       // full selection &one);

  nsel = length;

  res = new XplSelection[nsel];

  if (res == NULL)
    {
    globalError.Set (ERR_SELECT, "memory allocation error");
    return (NULL);
    }

  for (i=0; i<nsel; i++)
    {
    if ((*xd)[i] == NULL)          // full selection
      {
      XplSelection d(dimx(i));
      res[i] = d;
      }
    else
      {
      n = (*xd)[i]->dimension(0);
      XplSelection d(n);
      for (j=0; j<n; j++)
	{
	ind =  (long) (*(*xd)[i])(j);
	if (ind == 0)
	  {
	  globalError.Set (ERR_SELECT, "Index is 0");
	  delete[] res;
	  return (NULL);
	  }
	d[j] = ind - 1L;
        }
      res[i] = d;
      }
    }

  xd->remove ();
  delete xd;

  return (res);
}
    
XplObject * SelectComponents (XplObject *root, XplObject *sel)
{
  long      i, pos, len;
  XplObject *o, *res;
  XplDouble *x;

  if (root == NULL)
    {
    globalError.Set (ERR_SELECT, " first argument empty");
    return (NULL);
    }

  if (sel == NULL)
    {
    globalError.Set (ERR_SELECT, " second argument empty");
    return (NULL);
    }

  if (root->Type () == O_SIMPLE)
    {
    globalError.Set (ERR_SELECT, " first argument is not composed");
    return (NULL);
    }

  if (sel->Type () != O_XPLDOUBLE)
    {
    globalError.Set (ERR_SELECT, " second argument not numeric");
    return (NULL);
    }

  x = sel->DefaultXplDouble ();

  if ((x->dimension() != 0) && (x->dimension() != 1))
    {
    globalError.Set (ERR_SELECT, " second argument must be vector");
    return (NULL);
    }

// now take the first element of the list and create the result object o
  pos = -1 + (long) (*x)(0);
  if ((pos < 0) || pos >= root->ComponentNumber ())
    {
    globalError.Set (ERR_SELECT, " out of range");
    return (NULL);
    }
  if (root->WriteProtection ())
    switch ((*root)[pos]->Type ())
      {
      case C_XPLDOUBLE:
      {
      o = new XplObject ("selcomp");
      XplDouble *x = new XplDouble ((*root)[pos]->Content().xpldouble); 
      o->AppendComponent (new Component (x));
      }
             break;
#ifdef _XPLCDEF_
      case C_XPLCHAR:
      {
      o = new XplObject ("selcomp");
      XplChar *xplc = new XplChar (*(*root)[pos]->Content().xplchar);
      o->AppendComponent (new Component (xplc));
      }
             break;
#else
      case C_TEXT:
      {
      o = new XplObject ("selcomp");
      o->AppendComponent (new Component(strdup((*root)[pos]->Content().text)));
      }
             break;
#endif
      case C_XplObject:
      {
      o = new XplObject ((*root)[pos]->Content().xplobject);
             break;
      default:  cerr << "SelectComponents:  unknown type" << endl;
             exit (1);
      }
    }
  else
/*    if (root->WriteProtection ())
      o->CopyComponent ((*root)[pos]);
    else
      o->CopyComponent ((*root)[pos], FALSE);
*/
    {
    o = new XplObject ("selcomp");
    switch ((*root)[pos]->Type ())
      {
      case C_XPLDOUBLE:    o->AppendComponent ((*root)[pos]);
                           break;
#ifdef _XPLCDEF_
      case C_XPLCHAR:      o->AppendComponent ((*root)[pos]);
                           break;
#else
      case C_TEXT:         o->AppendComponent ((*root)[pos]);
                           break;
#endif
      case C_XplObject:
                   o->TransferComponents ((*root)[pos]->Content().xplobject);
                           cerr << "SelComp2: !writeprot: Problems!" << endl;
                           break;
      default:             cerr << "SelectComponents:  unknown type" << endl;
                           exit (1);
      }
    }

// if necessary append the next objects to o
  len = x->dimension () == 0 ? 1 : x->dimension (0);

  if (len == 1)         // only one component, bye
    {
    if (! root->WriteProtection ())
      root->DeleteComponent (pos);     // this component was transfered
    return (o);
    }

  res = new XplObject ("selcompres");
  res->AppendComponent (new Component (o));

#ifdef _XPLCDEF_
  XplChar *xplc;
#endif

  for (i=1; i<len; i++)
    {
    pos = -1 + (long) (*x)(i);
    if ((pos < 0) || pos >= root->ComponentNumber ())
      {
      globalError.Set (ERR_SELECT, " out of range");
      delete res;
      return (NULL);
      }
    if (root->WriteProtection ())
      switch ((*root)[pos]->Type ())
	{
	case C_XPLDOUBLE:
	o = new XplObject ("selcomp");
        x = new XplDouble ((*root)[pos]->Content().xpldouble); 
        o->AppendComponent (new Component (x));
             break;
#ifdef _XPLCDEF_
	case C_XPLCHAR:
	o = new XplObject ("selcomp");
        xplc = new XplChar (*(*root)[pos]->Content().xplchar);
        o->AppendComponent (new Component (xplc));
             break;
#else
	case C_TEXT:
	o = new XplObject ("selcomp");
       o->AppendComponent(new Component(strdup((*root)[pos]->Content().text)));
             break;
#endif
	case C_XplObject:
        o = new XplObject ((*root)[pos]->Content().xplobject);
             break;
        default:  cerr << "SelectComponents:  unknown type" << endl;
             exit (1);
	}
    else
/*    if (root->WriteProtection ())
      o->CopyComponent ((*root)[pos]);
    else
      o->CopyComponent ((*root)[pos], FALSE);
*/
      switch ((*root)[pos]->Type ())
	{
	case C_XPLDOUBLE:    o->AppendComponent ((*root)[pos]);
                             break;
#ifdef _XPLCDEF_
	case C_XPLCHAR:      o->AppendComponent ((*root)[pos]);
                             break;
#else
	case C_TEXT:         o->AppendComponent ((*root)[pos]);
                             break;
#endif
	case C_XplObject:
                   o->TransferComponents ((*root)[pos]->Content().xplobject);
                             cerr << "SelComp1: !writeprot: Problems!" << endl;
                             break;
        default:             cerr << "SelectComponents:  unknown type" << endl;
                             exit (1);
	}
    res->AppendComponent (new Component (o));
    }

  if (! root->WriteProtection ())
    for (i=0; i<len; i++)         // deleting changes the length of sel
      {                           // so it has to be done afterwards
      pos = -1 + (long) (*x)(i);
      root->DeleteComponent (pos);
//      root->elements.loesche (pos);   // pointer must not be freed !!
      }

  return (res);
}

#endif  // of !MATRIX
  
XplObject * SelectComponentList (XplObject *root, Liste<XplObject*> *sel)
{
  long      pos, i, length = sel->laenge ();
  XplObject *rtmp = root;

  if (root == NULL)
    {
    globalError.Set (ERR_INTERN, "SCL selector list empty");
    return (NULL);
    }

  if (length == 0)
    {
    globalError.Set (ERR_INTERN, "SCL selection list empty");
    return (NULL);
    }

  for (i=0; i<length; i++)
    {
    pos  = -1 + (long) (*(*sel)[i]->DefaultXplDouble ())[0];
    if ((pos < 0) || (pos >= rtmp->ComponentNumber ()))
      {
      globalError.Set (ERR_INTERN, "selection index not valid");
      return (NULL);
      }
    if ((*rtmp)[pos]->Type () != C_XplObject)
      {
      globalError.Set (ERR_INTERN, "no such component");
      return (NULL);
      } 
    rtmp = (*rtmp)[pos]->Content().xplobject;
    }
  return (rtmp);
}

void        AssignSelection     (XplObject *dest, XplObject *source)
{

  if (dest == NULL)
    {
    globalError.Set (ERR_SELECT, " first argument empty");
    return;
    }

  if (source == NULL)
    {
    globalError.Set (ERR_SELECT, " second argument empty");
    return;
    }

//  if (dest->ComponentNumber () != source->ComponentNumber ())
//    {
//    globalError.Set (ERR_SELECT, " number of components doesn't fit");
//    return;
//    }

  dest->TransferComponents (source);
  dest->SetDefaultXplDouble ();         // it can change !!
}

int RemoveDisplay (XplObject *o)
// deletes given object, if it contains a display
// globObjList and displayList are updated
{
  XplObject *obj;
  long      pos;

  if (o == NULL)
    {
#ifdef TTKDEBUG
if (ttkdebug)
    cerr << "Error in RemoveObject: Argument is NULL" << endl;
#endif
    return (FALSE);
    }

  obj = GetXplObject (globObjList, o->Name(), pos);

  if (obj->Type () != O_DISPLAY)
    {
#ifdef TTKDEBUG
if (ttkdebug)
    cerr << "Error in RemoveObject: Object is no display" << endl;
#endif
    return (FALSE);
    }

  if (obj == o)
    {
    globObjList->loesche (pos);
    obj = GetXplObject (displayList, o->Name(), pos);
    if (obj == o)
      {
      displayList->loesche (pos);
      obj->DelWriteProtection ();   // allow deletion
      obj->DeleteComponents ();     // explicit deletion of display !!
      delete obj;
      return (TRUE);
      }
    else
      {
      cerr << "Error in RemoveObject: globObjList and displayList contain differnt objects" << endl;
      exit (1);
      }

    if (obj == NULL)
      {
      cerr << "Error in RemoveObject: globObjList and displayList inconsistent" << endl;
      exit (1);
      }
    }

  cerr << "Error in RemoveObject: wrong object found" << endl;
  exit (1);
  return (FALSE);         // only for the compiler
}


#if defined (_GRAPHICS_) || defined (PSGEN) || defined (__BORLANDC__)

XplObject* GetXplObject (const class XplDisplay *d)
// delivers object which contains display d
{
  long i, length = displayList->laenge ();

  for (i=0; i<length; i++)
    {
    if ((*displayList)[i]->DefaultType () != C_DISPLAY)
      {
      cerr << "Empty (Display) ignore i= " << i << endl;
      continue;
      }

    if ((*displayList)[i]->DefaultComponent()->Content().display == d)
      return ((*displayList)[i]);
    }

  return (NULL);
}
#endif


void TidyUp (Liste<XplObject*> *objList)
// removes empty objects from objList
// intended to remove displays, which were locally overwritten and
// therefore empty
{
  long i;

  for (i=0; i<objList->laenge (); i++)
    if ((*objList)[i]->isEmpty())
      {
      delete (*objList)[i];
      objList->loesche (i);
      i = 0;                       // list changes during deletion
      }
}

Liste<XplDouble*>* MakeArglist (Liste<XplObject*> *mm, XplObject *o)
{
  int 			i, length, marker, count = 1;
  Liste<XplDouble*>	*pml = new Liste<XplDouble*>;
  XplObject             *obj;
#ifdef _XPLCDEF_
  XplChar               *oxc, *nxc;
  XplDouble             *x;     // wo wieder freigeben ?
#endif

  length = mm->laenge();
  
  for (i=0; i<length; i++)
    {
    if ((*mm)[i] == NULL)
      continue;
    if ((*mm)[i]->DefaultXplDouble () == NULL)
#ifdef _XPLCDEF_
      if (!((*mm)[i]->Type () & O_XPLCHAR))
#endif
        {
        globalError.Set (ERR_SELECT, "cannot use object ");
	globalError.AppendText (ERR_SELECT, (*mm)[i]->Name ());
	return (NULL);
        }
    }

  obj = (*mm)[0];
  if (obj == NULL)
    {
    marker = FALSE;
    count++;
    pml->haengeAn ((XplDouble*) NULL);
    }
  else
    {
    marker = TRUE;
#ifdef _XPLCDEF_
    char name[16];
    sprintf (name, "names%d", count++);
    if (obj->Type () & O_XPLCHAR)
      {
      oxc = GetDefaultXplChar (obj);
      nxc = GetXplChar (o, name);
      x   = LabelSelection (oxc, nxc);
      pml->haengeAn (x);
      }
    else
#endif
    pml->haengeAn (obj->DefaultXplDouble ());
    }

  if (length == 1)
    {
    if (marker == FALSE)
      pml->haengeAn ((XplDouble*) NULL);
    return (pml);
    }

  for (i=1; i<length; i++)
    {
    obj = (*mm)[i];
    if (obj == NULL)
      {
      if (marker == FALSE)
	{
	count++;               // counts the dimensions for name
        pml->haengeAn ((XplDouble*) NULL);
        }
      else
        marker = FALSE;
      }
    else
      {
      if (marker == TRUE)
	{
        globalError.Set (ERR_SELECT, "missing , ");
	return (NULL);
        }
 
#ifdef _XPLCDEF_
    char name[16];
    sprintf (name, "names%d", count++);
    if (obj->Type () & O_XPLCHAR)
      {
      oxc = GetDefaultXplChar (obj);
      nxc = GetXplChar (o, name);
      x   = LabelSelection (oxc, nxc);
      pml->haengeAn (x);
      }
    else
#endif
      {
      pml->haengeAn (obj->DefaultXplDouble ());
      marker = TRUE;
      }
      }
    }  // of for i

  if (marker == FALSE)
    pml->haengeAn ((XplDouble*) NULL);
  
  return (pml);
}

#ifdef _XPLCDEF_
// const SK didn't it
XplChar* GetDefaultXplChar (const XplObject *o)
// extracts XplChar from default component
// if nothing can be found, NULL is the result
{
  if (o == NULL)
    {
    globalError.Set (ERR_SELECT, "GDXC got NULL pointer");
    return (NULL);
    }

  Component *c = o->DefaultComponent ();

  if (c == NULL)
    {
    globalError.Set (ERR_SELECT, "can not find object's component ");
    globalError.AppendText (ERR_SELECT, o->Name ());
    return (NULL);
    }

  if (c->Type () != C_XPLCHAR)
    {
    globalError.Set (ERR_SELECT, "object does not have a text component ");
    globalError.AppendText (ERR_SELECT, o->Name ());
    return (NULL);
    }

  return (c->Content ().xplchar);
}

//const SK didn't it
XplChar* GetXplChar (const XplObject *o, const char *name)
// extracts XplChar from  component 'name' if it is contains an XplObject
// of type XPLCHAR. If nothing can be found, NULL is the result
{
  if ((o == NULL) || (name == NULL))
    {
    globalError.Set (ERR_SELECT, "GXC got NULL pointer");
    return (NULL);
    }

  Component *c = o->GetComponent (name);

  if (c == NULL)
    {
    globalError.Set (ERR_SELECT, "can not find object's component ");
    globalError.AppendText (ERR_SELECT, o->Name ());
    return (NULL);
    }

  if (c->Type () != C_XplObject)
    {
    globalError.Set (ERR_SELECT, "object does not have appropriated sub object ");
    globalError.AppendText (ERR_SELECT, o->Name ());
    return (NULL);
    }

  return (GetDefaultXplChar (c->Content ().xplobject));
}

XplDouble * LabelSelection (XplChar *sel, XplChar *base)
// generates a selection vector. sel contains the text, which is looked up
// in base. The result *x contains for each selection the position in base
{
  long i, j, m, n;

  if ((sel == NULL) || (base == NULL))
    return (NULL);

  m = sel->dimension (0);
  n = base->dimension (0);

  XplDouble *x = new XplDouble (m);

  for (i=0; i<m; i++)
    {
    (*x)(i) = 0.0;
    for (j=0; j<n; j++)
      if ((*sel)(i) == (*base)(j))
	(*x)(i) = (double) j+1;
    if ((*x)(i) == 0.0)
      {
      globalError.Set (ERR_SELECT, "name not found ");
      globalError.AppendText (ERR_SELECT, (*base)(j).tocstr());
      return (NULL);
      }
    }

  return (x);
}
#endif

// Server section  TTK, 5.5.97  20.3.98

#ifdef RPC
extern "C" {
static void
xplfort_1(struct svc_req *rqstp, register SVCXPRT *transp)
{
        union {
                TSData send_ts_1_arg;
                int get_ts_1_arg;
                Command send_cmd_1_arg;
                int quit_1_arg;
        } argument;
        char *result;
        xdrproc_t xdr_argument, xdr_result;
        char *(*local)(char *, struct svc_req *);

        switch (rqstp->rq_proc) {
        case NULLPROC:
                (void) svc_sendreply(transp, (xdrproc_t) xdr_void, (char *)NULL)
;
                return;

        case INIT:
                xdr_argument = (xdrproc_t) xdr_void;
                xdr_result = (xdrproc_t) xdr_int;
                local = (char *(*)(char *, struct svc_req *)) init_1_svc;
                break;

        case SEND_TS:
                xdr_argument = (xdrproc_t) xdr_TSData;
                xdr_result = (xdrproc_t) xdr_int;
                local = (char *(*)(char *, struct svc_req *)) send_ts_1_svc;
                break;

        case GET_TS:
                xdr_argument = (xdrproc_t) xdr_int;
                xdr_result = (xdrproc_t) xdr_TSData;
                local = (char *(*)(char *, struct svc_req *)) get_ts_1_svc;
                break;

        case SEND_CMD:
                xdr_argument = (xdrproc_t) xdr_Command;
                xdr_result = (xdrproc_t) xdr_int;
                local = (char *(*)(char *, struct svc_req *)) send_cmd_1_svc;
                break;

        case QUIT:
                xdr_argument = (xdrproc_t) xdr_int;
                xdr_result = (xdrproc_t) xdr_void;
                local = (char *(*)(char *, struct svc_req *)) quit_1_svc;
                break;

        default:
                svcerr_noproc(transp);
                return;
        }
        (void) memset((char *)&argument, 0, sizeof (argument));
        if (!svc_getargs(transp, xdr_argument, (caddr_t) &argument)) {
                svcerr_decode(transp);
                return;
        }
        result = (*local)((char *)&argument, rqstp);
        if (result != NULL && !svc_sendreply(transp, xdr_result, result)) {
                svcerr_systemerr(transp);
        }
        if (!svc_freeargs(transp, xdr_argument, (caddr_t) &argument)) {
                fprintf(stderr, "unable to free arguments");
                exit(1);
        }
        return;
}

};  // extern C


void  StartRPCServer (int argc, char **argv)
{
  // copy the RPC server
  /* -------- RPC ---------- */
        register SVCXPRT *transp;

        (void) pmap_unset(XPLFORT, EINS);

	/*
        transp = svcudp_create(RPC_ANYSOCK);
        if (transp == NULL) {
                fprintf(stderr, "cannot create udp service.");
                exit(1);
        }
        if (!svc_register(transp, XPLFORT, EINS, xplfort_1, IPPROTO_UDP)) {
                fprintf(stderr, "unable to register (XPLFORT, EINS, udp).");
                exit(1);
        }
	*/
        transp = svctcp_create(RPC_ANYSOCK, 0, 0);
        if (transp == NULL) {
                fprintf(stderr, "cannot create tcp service.");
                exit(1);
        }
        if (!svc_register(transp, XPLFORT, EINS, xplfort_1, IPPROTO_TCP)) {
                fprintf(stderr, "unable to register (XPLFORT, EINS, tcp).");
                exit(1);
        }

        svc_run();
        fprintf(stderr, "svc_run returned");
        exit(1);
        /* NOTREACHED */
        /* ------------ RPC end ---------- */

}
#endif            // RPC

#ifdef SOCKETSERVER
#define BUFLENGTH 1024

long genKey (long k)
{
  // home brewed key generator, period ~ 45055, sufficient here
  long k1, k2, k3, kk;

  k1 = 0xfff & k;
  k2 = (0xfff000 & k) >> 12;
  k3 = (0x7000000 & k) >> 18;

  k1 = (k ^ (7113*k1 + 41655)) & 0x7ffffff;
  k2 = (k ^ (13179*k2 + 13187)) & 0x7ffffff;
  k3 = (k ^ (201781*k3 + 76361)) & 0x7ffffff;

  k1 = 0xfff & k1;
  k2 = (0xfff000 & k2) >> 12;
  k3 = (0x7000000 & k3) >> 18;

  kk = k3 << 18 | k2 << 12 | k1;
  return (kk ^ k);
}

void  StartSocketServer (int argc, char **argv)
{
  char *buffer;
  int  i, n, s1; // port = 4435;
  int port;

  SocketServer *server;

  time_t sec;
  time (&sec);
  struct tm *ts;

// close socket when catching INT or HUP
#ifndef WIN32
  if ((long) signal (SIGINT, SIG_IGN) != (long) SIG_IGN)
    signal (SIGINT, InterruptHandler);
  if ((long) signal (SIGHUP, SIG_IGN) != (long) SIG_IGN)
    signal (SIGHUP, InterruptHandler);
#endif

// SK 20.01.99
  buffer = property.getProperty("port");
  if (buffer==NULL)
    { // printf ("No port\n"); 
      exit(1); }
  port = atoi(buffer);

/*  for (i=0; i<argc; i++)
    if (strcmp (argv[i], "port") == 0)
      port = atoi (argv[i+1]);
*/
  printf ("Port=%i\n", port);
// SK end
  server = new SocketServer ();
  
  protocol = new XJprotocol (server->open (port));

  int MaxClients = 2, MaxRetry = 5, retry = 0;

//  tk, 10/16/97  begin  the can specify the max number of clients

// SK 20.01.99
  buffer = property.getProperty("maxclients");
  if (buffer!=NULL) MaxClients = atoi(buffer);

/*  for (i=0; i<argc; i++)
    if (strcmp (argv[i], "maxClients") == 0)
      MaxClients = atoi (argv[i+1]); // no check whether this exists!
*/
//  tk, 10/16/97  end

  printf ("MaxClients=%i\n", MaxClients);
// SK end

  int options, *status = new int;

#ifndef WIN32
  options = WNOHANG;
#endif

  long child[50], keys[50], pid, key, k;
  int Retry;

  for (i=0; i<MaxClients; i++)
    child[i] = 0L;

  while (1)
    {
    Retry = 2;

    time (&sec);
    ts = localtime (&sec);      // get time now

    // connect protocol object with socket 
    protocol->append (server->accept ());

    switch (protocol->checkProtocol ())
      {
      case XJ_TRANSMISSION_ERROR:
//	cout << asctime (ts) << "\tXploRe(" << (long) getpid();
	cout << ")\ttransmission error for unknown client" << endl;
	continue;
      case XJ_DENIED:
//	cout << asctime (ts) << "\tXploRe(" << (long) getpid();
	cout << ")\tclient denied: unknown protocol" << endl;
	continue;
      }

    // check whether children still live
    //    for (i=0; i<MaxClients; i++)
    //  printf ("%i %i\n", i, child[i]);

    for (i=0; i<MaxClients; i++)
      if (child[i] != 0L)
        {
      // n = 0, child runs
#ifndef WIN32
	n = waitpid (child[i], status, options);
#endif
	if (n == -1)
	  {
	  perror ("\tXploRe\t");
//	  write (s1, "reject", 6);
	  close (s1);
	  cerr << endl;
	  continue;
	 }
	if (n == child[i])  // this has exited
	  child[i] = 0L;
        }

    //    for (i=0; i<MaxClients; i++)
    //  printf ("%i %i\n", i, child[i]);

    switch (protocol->getCommand ())
      {
      case REQUEST2PING:
	{
	int found = FALSE;
	protocol->sendString ("Server is alive\n");
	protocol->close ();
	continue;

	pid = protocol->getCommand ();
	key = protocol->getCommand ();
//	cout << asctime (ts) << "\tXploRe(" << (long) getpid();
	cout << ")\tClient (" << pid << ") requests ping"  << endl;
	for (i=0; i<MaxClients; i++)    // do we serve this client ?
	  if (child[i] == pid)
	    {
	    found = TRUE;
	    k = genKey (keys[i]);       // is client authorized ?
	    if (k == key)
	      {
	      protocol->sendString ("Server is alive\n");
	      keys[i] = k;              // is the new key for another request
	      }
	    else
	      protocol->sendString ("Request not authorized. Restart the client.\n");
	    }

	if (!found)
	  protocol->sendString ("Server is down. Restart the client\n.");
	protocol->close ();
	continue;
	}
      case REQUEST2BREAK:
	{
        pid = protocol->getCommand ();
        key = protocol->getCommand ();
//	cout << asctime (ts) << "\tXploRe(" << (long) getpid();
	cout << ")\tClient (" << pid << ") requests break"  << endl;
	for (i=0; i<MaxClients; i++)    // do we serve this client ?
	  if (child[i] == pid)
	    {
	    k = genKey (keys[i]);       // is client authorized ?
	    if (k == key)
	      {
//	      kill (pid, SIGINT);       // send HUP causing break
	      keys[i] = k;              // is the new key for another request
	      }
	    else
	      cout << "but is NOT authorized!" << endl;
	    }
	protocol->close ();
	continue;
	}
      
/*
    // determine client address
    i      = getpeername (sock,  (struct sockaddr*) &client, &cllen);
    // translate into dot notation
    ipaddr = inet_ntoa (client.sin_addr);
    // try to get the host name where the client runs
    in     = inet_addr (inet_ntoa (client.sin_addr));
    host   = gethostbyaddr ((char*)&in, sizeof(in), AF_INET);
*/

      case REQUEST2SERVE:
/*
// tk 210198 begin
  	{
	oldClientVersion = FALSE;
	if (strncmp (buffer, "request2serveV11", strlen ("request2serveV11")) != 0)
	  oldClientVersion = TRUE;
	}
// tk 210198 end
*/   
	for (i=0; i<MaxClients; i++)
	  {
	  if (child[i] == 0L)
	    break;
	  }

	if (i >= MaxClients)    // do not serve this request
	  {
	  protocol->sendCommand (XJ_TOO_MANY_CLIENTS);
	  protocol->close ();

	  cerr << asctime (ts) << "\tXploRe(" << pid;
/*	  cerr << "):  request from " << ipaddr;
	  if (host != NULL)
	    cerr << '\t' << host->h_name;
*/	  
	  cerr << " but " << MaxClients << " clients are already running" << endl;

	  continue;
	  }
	break;       // now serve the client

      default:
	{
	cerr << asctime (ts) << "\tXploRe(" << pid;
/*	cerr << "): Unknown request from " << ipaddr;
	if (host != NULL)
	  cerr << '\t' << host->h_name;
*/
	cerr << "\t Content: " << buffer << endl;

	protocol->close ();
	continue;
	}
      }

#ifndef SINGLESOCKET
    pid_t p;   // SK 18.01.99 
    if ((p = fork ()) == 0)   // child
#endif
      {
//      pid = (long) getpid ();
      key = genKey (pid);

      protocol->sendCommand (ACCEPTED);

      //      protocol->sendString ("accepted\n");
      //      protocol->sendCommand (pid);              // pid for break signal   
      //      protocol->sendCommand (key);	        // key holds authorisation

      cout << asctime (ts) << "\tXploRe(" << pid;
/*      cout << ")\tClient (" << ipaddr;
      if (host != NULL)
	cout << '\t' << host->h_name;
*/
      cout << ") requests service"  << endl;

      InitializeInterpreter (argc, argv);  

      while (1)
	{
// Null kann passieren. Gegenseite ist dann tot.  30.5.97
	  //	readLineFromSocket (buffer, 1024);

	  switch (long lcmd = protocol->getCommand ())
	    {
	    char *oname;

	    case END_OF_SESSION:
	      {
              logt("END_OF_SESSION");
//	      cout << asctime (ts) << "\tXploRe socket server(" << (long) getpid();
/*	      cout << ")\tClient (" << ipaddr;
	      if (host != NULL)
		cout << '\t' << host->h_name;
*/
	      cout << "): End of session. Good bye ... " << endl;
	      delete protocol;

	      /*
	      char *path, **arg;

	      path = strdup (argv[0]);
	      *arg = (char*) calloc (argc, sizeof(char*));
	      for (int kk=0; kk<argc-1; kk++)
		arg[kk] = strdup (argv[kk+1]);
	      arg[argc-1] = NULL;
	      execv (path, arg);
	      */
	      exit (0);
	      break;
	      }

	    case SEND_COMMANDS:
	      {
              logt ("SEND_COMMANDS");
	      buffer = protocol->readXploReCommands ();
              logt ("buffer cehcek");
	      if (buffer == NULL)
		{               logt ("buffer==NULL");

//		cerr << asctime (ts) << "\tXploRe(" << (long) getpid();
		cerr << "): Error by read from socket. Exit ... " << endl;
		perror ("\tTTKbreak\t");

		protocol->close ();
		exit (0);
		}

              logt ("time");

	      time (&sec);
	      ts = localtime (&sec);        // get time now
	      
	      if (strlen (buffer) == 0)
		{
		  logt ("strlen(buffer)==0");
		if (retry++ < MaxRetry)
		  {
//		  cerr << asctime (ts) << "\tXploRe(" << (long) getpid();
		  cerr << "): Error by read from socket. Retry ... " << endl;
//		  sleep (retry);
		  continue;
		  }
//		cerr << asctime (ts) << "\tXploRe(" << (long) getpid();
/*		cerr << ")\tClient (" << ipaddr;
		if (host != NULL)
		  cout << '\t' << host->h_name;
*/
		cerr << "): Connection lost. Exit ... " << endl;

		protocol->close ();
		exit (0);
		}
	      retry = 0;
/*	      puts ("-received-");
	      puts (buffer);
	      puts ("---");       
*/
	      logt("Parsing");
	      logt(buffer);
	      parse (buffer);
		  delete[] buffer;
	      protocol->sendCommand (END_OF_XPLORE);

	      continue;
	      }
	    break;
	  case REQUEST2PING:
            logt ("REQUEST2PING");
            protocol->sendString ("Server is alive ...");
	    break;

	  case REQUEST_DATA:
	    oname = protocol->getStringParameter ();
	    performSendData2Client (oname);        // sends object data to client
	    delete[] oname;
	    continue;

	  case TRANSMIT_DATA:
	    oname = protocol->getStringParameter ();
	    performGetDataFromClient (oname); 
	    delete[] oname;
	    continue;

	  default:
	    {
//	    cout << asctime (ts) << "\tXploRe socket server(" << (long) getpid();
/*	    cout << ")\tClient (" << ipaddr;
	    if (host != NULL)
	    cout << '\t' << host->h_name;
*/
	    cout << "): Unknown command: " << lcmd << endl;
	    delete protocol;
	    exit (0);
	    break;
	    }
	  }
	}
      }

#ifndef SINGLESOCKET
    else // parent
      {
      child[i] = p;
      key  = p;
      keys[i]  = key; // genKey (p);
      }
#endif
    }
}
#endif
 
// Some check routines
   

//#define PROTLOG  "prot.log"
//#define PROTLOG  "C:\\prot.log"

void loginit ()
{
#ifdef PROTLOG 
  FILE *plog;
  plog = fopen (PROTLOG, "w");
  if (plog) fclose(plog);
#endif
}

void logt (const char *txt)
{ 
#ifdef PROTLOG
  FILE *plog;
  plog = fopen (PROTLOG, "a");
  if (plog) 
  { fprintf (plog, "Txt: %s\n", txt);
    fclose(plog);
  }
#endif
}

void logp (char *ptr, long size)
{
#ifdef PROTLOG
  FILE *plog = fopen (PROTLOG, "a");
  long i;
  if (plog)
  { fprintf (plog, "Data of length %li:\n", size);
    for (i=0; i<size; i++)
    { fprintf (plog, "%3i ", ptr[i]);
      if (i%25==24) fprintf(plog, "\n");
    }
    fprintf(plog, "\n");
    fclose(plog);
  }
#endif
}

void logptr (void *ptr)
{
#ifdef PROTLOG
  FILE *plog = fopen (PROTLOG, "a");
  long i;
  if (plog)
  { fprintf (plog, "Ptr : %p\n", ptr);
    fclose(plog);
  }
#endif
}

void logc (long cmd)
{
#ifdef PROTLOG
  FILE *plog = fopen (PROTLOG, "a");
  if (plog)
  { fprintf (plog, "Cmd: %li\n", cmd);
    fclose(plog);
  }
#endif
}

void logl (long len)
{ 
#ifdef PROTLOG
  FILE *plog = fopen (PROTLOG, "a");
  if (plog)
  { fprintf (plog, "Len: %li\n", len);
    fclose(plog);
  }
#endif
}

#if !defined (RPC) && !defined (SOCKETSERVER)

#ifndef X4singleserver
void  StartXploRe (int argc, char **argv)
{
  char cmd[100000];
  while (1)
  {
  FILE *ftmp;
  char *fname;

#ifndef _JAVA_
  //if (feof (stdin))
  //  break;
  // SendServerReady(); // SK 9.02.99
  if (!quiet) { // SK 16.11.04
    cout << "\nEnter command:\n";  // SK 29.04.99
    fflush (stdout);
  }  
  fgets (cmd, 100000, stdin);  
  if (feof (stdin))
    break;
  /*
printf ("Ascii: ");
 for(int i=0; i<strlen(cmd); i++)
   { if ((cmd[i]==10)||(cmd[i]==13)) cmd[i] = 0;
   printf ("%03i ", cmd[i]);
   }
 printf ("Cmd: %s", cmd);
  */
  parse (cmd);
  fflush (stdout);
#else

  fname = xtmpnam (); // SK 05.06.2000
  //  logt ("Open tmpfile");
  //logt (fname);
  ftmp = fopen (fname, "w");

  while (TRUE)
    {
    if (feof(stdin))
      {
      char text[strlen(fname)+10];
      sprintf(text, "rm %s &", fname);
      system (text);
      exit (0); 
      }
    fgets (cmd, 100000, stdin);
    if (strncmp (cmd,  "_END_OF_JAVA_", 13) == 0)
      {  
      fclose (ftmp);
      ftmp = fopen (fname, "r");
      parse (ftmp);
      fflush (stdout);
      fclose (ftmp);
      cout << "\n_END_OF_XPLORE_" << endl;
      ftmp = fopen (fname, "w");
      }
    else
      {
      if (cmd[0] != '\0')
        fputs (cmd, ftmp);
      }
    }
#endif
  }
}
#else // batch server
XJprotocol *protocol;

void  StartXploRe (int argc, char **argv)
{ long lcmd; 
  char *oname;
  char *buffer;
  int MaxRetry = 5, retry = 0;
  time_t sec;
  time (&sec);
  struct tm *ts;

  //  logt ("StartXploRe");
  protocol = new XJprotocol (new SocketIO());
  while (1)
  { //protocol->sendCommand(READY2SERVE);
    //logc(READY2SERVE);

    lcmd = protocol->getCommand (); 

    // cerr << "Server: getCommand = " << lcmd << endl;
    logc(lcmd);
    switch (lcmd)
    { case END_OF_SESSION:
        cerr << "): End of SingleServer session. Good bye ... " << endl;
	delete protocol;
	exit (0);
	break;
      case SEND_COMMANDS:
        logt("SEND_COMMANDS");
        buffer = protocol->readXploReCommands ();
        logt(buffer);
	if (buffer == NULL)
	{ logt("buffer==NULL");
	// cerr << "): Error by read from stdin. Exit ... " << endl;
	  protocol->close ();
	  exit (0);
        }
        logt("gettime");
	time (&sec);
	ts = localtime (&sec);        // get time now
	if (strlen (buffer) == 0)
	{ logt("strlen(buffer==0)");
	  if (retry++ < MaxRetry)
	  { cerr << "): Error by read from stdin. Retry ... " << endl;
	    continue;
	  }
	  cerr << "): stdin Connection lost. Exit ... " << endl;
	  protocol->close ();
	  exit (0);
	}
        logt("parse");
	retry = 0;
	parse (buffer);
        logt("end of parse");
	delete[] buffer;
        logc (END_OF_XPLORE);
	protocol->sendCommand (END_OF_XPLORE);
	break;
      case REQUEST_DATA:
	oname = protocol->getStringParameter ();
        logc(REQUEST_DATA);
        // logt(oname);
	performSendData2Client (oname);        // sends object data to client
	delete[] oname;
	continue;
      case REQUEST_DOUBLE:
	oname = protocol->getStringParameter ();
        logt(oname);
	performSendDouble2Client (oname);        // sends object data to client
	delete[] oname;
	continue;
      case TRANSMIT_DATA:
	oname = protocol->getStringParameter ();
        logc(TRANSMIT_DATA);
        // logt(oname);
	performGetDataFromClient (oname); 
	delete[] oname;
        continue;
      case TRANSMIT_DOUBLE:
	oname = protocol->getStringParameter ();
        logc(TRANSMIT_DOUBLE);
        // logt(oname);
	performGetDoubleFromClient (oname); 
	delete[] oname;
        continue;
      default:
        // logt ("Unknown command");
	cerr << "): Unknown command: " << lcmd << endl;
	delete protocol;
	exit (0);
	break;
    }
  }
}
#endif

#endif


void X4Start (int argc, char **argv)
{ // logt ("InitializeProperties");
  InitializeProperties(argc, argv);
  property.dump();
  // logt ("InitializeInterpreter");
  InitializeInterpreter(argc, argv);
}


