/* $Header: /home/xplore/cvs/xpl4gr/xplqr.C,v 1.3 2002/08/16 12:32:02 sigbert Exp $ */

#include <iostream.h>
#include <math.h>

/* Table of constant values */

static int c__1 = 1;

#ifndef __HPUXFUN__
inline double abs(double x)
{
if (x>=0)
 return x;
else 
 return -x;
}
#endif


inline double r_sign(double a_1, double a_2)
{
if(a_2 >= 0.0)
  return a_1;
else
  return -a_1;
  
}

inline long min(long a, long b)
{
if (a>=b)
 return b;
else
 return a;
}
inline double max(double a, double b)
{
if (a < b)
 return b;
else
 return a;
}


inline double sing(double x){ if(x>=0) return 1.0; else return -1.0;} 
/*
void sqrdc_(double **x, 
            long ldx, 
            long nrow, 
            long ncol,
            double  *qraux)
 
{
long i,k,j;
double norm, cdot;
for(k=0;k<min(ncol,nrow);k++){
    norm = 0.0;
    for(i=k;i<nrow;i++)
        norm+=x[i][k]*x[i][k];
    norm=sqrt(norm);
    qraux[k]=0.0;
    if(norm!=0){
        qraux[k]=1.0+abs(x[k][k])/norm;
        for(i=k+1;i<nrow;i++)
           x[i][k]=sing(x[k][k])*x[i][k]/norm;
         x[k][k]= -sing(x[k][k])*norm;
      
// update the remaining col.
    for(j=k+1;j< ncol;j++){
        cdot=qraux[k]*x[k][j];
        for(i=k+1;i<nrow;i++)
           cdot+=x[i][k]*x[i][j];
        x[k][j]-=cdot;   
        for(i=k+1;i<nrow;i++)
           x[i][j]-=x[i][k]*cdot/qraux[k];
      }
  }
}
}

*/

double **matrix_(long nrow, long ncol)

{
	long i;
	double **m;

  
	m = new double*[nrow];
    
	for(i=0;i<nrow;i++)
	{
		m[i]=new double[ncol];
	}
   
	return m;
}
void  delete_matrix_(double **m, long nrow)
{
 long i;
 for(i=0;i<nrow;i++)
 {
	delete[] m[i];
 }
 delete[] m;
}


void qrR(double *QR, long nrow, long ncol, double *R){

long i,k;
long shift=0;
for(k=0; k < ncol; k++){
  for(i=0; i< nrow; i++)
     if(i<=k)
       R[i+shift]=QR[i+shift];
     else
       R[i+shift]=0.0; 
 shift +=nrow;}
}


void qrQ(double *QR, double *raux, long nrow,long ncol, double *Q,
           double eps)
{
int i,k,j;
double dot, t1,t2;
long dim=min(nrow,ncol);
long shift_j, shift_k;

// initiate matrix Q
shift_k=0;
for(k=0; k < nrow; k++){
  for(i=0; i < nrow; i++){
      if(i==k)   
        Q[i+i*nrow]=1.0;
      else
        Q[i+shift_k]=0.0;}
  shift_k+=nrow;
}

j=dim-1;
shift_j = j*nrow;
shift_k = j*nrow;
for(k=j; k < nrow; k++){
   t2=QR[k+shift_j];
   if(k==j) 
       t2 = raux[j];
   for(i=j; i < nrow; i++){
       t1 = QR[i+shift_j];
       if(i==j) 
          t1 = raux[j];
       if(abs(raux[j]) > eps)
        Q[i+shift_k]  -= t1*t2/raux[j];
      }
   shift_k+=nrow;
 }

if (dim< 2) return;

// update matrix Q
shift_j=(dim-2)*nrow;
for(j=dim-2;j>= 0; j--){ 
      Q[j+j*nrow]=1.0-raux[j];     
 
     // fill the first col. j
     for(k=j+1; k < nrow;k++)
        Q[k+shift_j]=-QR[k+shift_j];    
     shift_k = (j+1)*nrow;
     for(k=j+1; k< nrow; k++){
       dot = 0.0;
      // update col. k
       for(i=j+1; i< nrow; i++)
          dot += Q[i+shift_k]*QR[i+shift_j]; 
       if(abs(raux[j])>eps){
       Q[j+shift_k]-=dot;
       for(i=j+1;i<nrow;i++)
          Q[i+shift_k]-= QR[i+shift_j]*dot/raux[j];}  
       shift_k +=nrow;
     }
  shift_j-=nrow;
}        


}






void matrix_vector(double **mat, long nrow, long ncol, double *x){

long i,k;
for(k=0;k< ncol;k++)
  for(i=0; i < nrow; i++)
     x[i+k*nrow]= mat[i][k];

}
void vector_matrix(double *x, long nrow, long ncol, double **mat){

long i,k;
for(k=0;k< ncol;k++)
  for(i=0; i < nrow; i++)
     mat[i][k]= x[i+k*nrow];

}



void  sqrdc(double **x,
            long ldx,
            long n,
            long p,
            double *qraux,
            long *jpvt,
            double *work,
            long job)
{ /*   
c
c     sqrdc uses householder transformations to compute the qr
c     factorization of an n by p matrix x.  column pivoting
c     based on the 2-norms of the reduced columns may be
c     performed at the users option.
c
c     on entry
c
c        x       real(ldx,p), where ldx .ge. n.
c                x contains the matrix whose decomposition is to be
c                computed.
c
c        ldx     integer.
c                ldx is the leading dimension of the array x.
c
c        n       integer.
c                n is the number of rows of the matrix x.
c
c        p       integer.
c                p is the number of columns of the matrix x.
c
c        jpvt    integer(p).
c                jpvt contains integers that control the selection
c                of the pivot columns.  the k-th column x(k) of x
c                is placed in one of three classes according to the
c                value of jpvt(k).
c
c                   if jpvt(k) .gt. 0, then x(k) is an initial
c                                      column.
c
c                   if jpvt(k) .eq. 0, then x(k) is a free column.
c
c                   if jpvt(k) .lt. 0, then x(k) is a final column.
c
c                before the decomposition is computed, initial columns
c                are moved to the beginning of the array x and final
c                columns to the end.  both initial and final columns
c                are frozen in place during the computation and only
c                free columns are moved.  at the k-th stage of the
c                reduction, if x(k) is occupied by a free column
c                it is interchanged with the free column of largest
c                reduced norm.  jpvt is not referenced if
c                job .eq. 0.
c
c        work    real(p).
c                work is a work array.  work is not referenced if
c                job .eq. 0.
c
c        job     integer.
c                job is an integer that initiates column pivoting.
c                if job .eq. 0, no pivoting is done.
c                if job .ne. 0, pivoting is done.
c
c     on return
c
c        x       x contains in its upper triangle the upper
c                triangular matrix r of the qr factorization.
c                below its diagonal x contains information from
c                which the orthogonal part of the decomposition
c                can be recovered.  note that if pivoting has
c                been requested, the decomposition is not that
c                of the original matrix x but that of x
c                with its columns permuted as described by jpvt.
c
c        qraux   real(p).
c                qraux contains further information required to recover
c                the orthogonal part of the decomposition.
c
c        jpvt    jpvt(k) contains the index of the column of the
c                original matrix that has been interchanged into
c                the k-th column, if pivoting was requested.
c
c     linpack. this version dated 08/14/78 .
c     g.w. stewart, university of maryland, argonne national lab.
c
c     sqrdc uses the following functions and subprograms.
c
c     blas saxpy,sdot,sscal,sswap,snrm2
c     fortran abs,amax1,min0,sqrt
c
c     internal variables
c
*/
      long j,jp,l,lp1,lup,maxj,pl,pu;
      double maxnrm,snrm2,tt;
      double  sdot,nrmxl,t,temp;
      int negj,swapj;

      pl = 0;
      pu = 0;
      if (job == 0) goto L60;
long k,jj;
//c
//c        pivoting has been requested.  rearrange the columns
//c        according to jpvt.
//c
         for( j = 0;j< p;j++){
            swapj = (jpvt[j] > 0);
            negj = (jpvt[j] < 0);
            jpvt[j] = j;
            if (negj) jpvt[j] = -j-10;
            if (!swapj) goto L10;
               if (j != pl) {
           //sswap(n,x(1,pl),1,x(1,j),1)
              for(k=0; k<n;k++)
                  {temp=x[k][pl]; x[k][pl]=x[k][j]; x[k][j]=temp;}
              }
               jpvt[j] = jpvt[pl];
               jpvt[pl] = j;
  
               pl = pl + 1;
         L10: ;
         }
        
         pu = p-1;
         for( jj = 0;jj< p;jj++){
            j = p - jj - 1;
            if (jpvt[j] >= 0) goto L40;
               jpvt[j] = -jpvt[j]-10;
               if (j == pu) goto L30;
                  //call sswap(n,x(1,pu),1,x(1,j),1)
                  for(k=0; k<n; k++)
                     {temp=x[k][pu]; x[k][pu]=x[k][j]; x[k][j]=temp;}
      
           jp = jpvt[pu];
                  jpvt[pu] = jpvt[j];
                  jpvt[j] = jp;

   L30:          
               pu = pu - 1;
   L40:       ;
        }
    
   L60: 
//c
//c     compute the norms of the free columns.
//c

      if (pu <  pl) goto L80;
      for(j = pl; j<= pu; j++){
         qraux[j] = 0.0;
         // snrm2(n,x(1,j),1)
          for(k=0; k< n;k++)
                   qraux[j]  +=x[k][j]*x[k][j];
         qraux[j]=sqrt(qraux[j]);
         work[j] = qraux[j];
      }
      L80: 
  
//c
//c     perform the householder reduction of x.
//c
      lup = min(n,p);
      for( l = 0; l<= lup-1; l++){

         if (l <  pl || l >= pu) goto L120;
//c
//c           locate the column of largest norm and bring it
//c           into the pivot position.
//c
            maxnrm = 0.0e0;
            maxj = l;
            for(j = l;j<= pu;j++){
               if (qraux[j] > maxnrm){
                  maxnrm = qraux[j];
                  maxj = j;
		}
            }    
    
            if (maxj == l) goto L110;
               //call sswap(n,x(1,l),1,x(1,maxj),1)
               for(k=0; k<n;k++){
                   temp = x[k][l];
                   x[k][l]=x[k][maxj];
                   x[k][maxj]=temp; }
    
 
          qraux[maxj] = qraux[l];
	  work[maxj] = work[l];
	  jp = jpvt[maxj];
	  jpvt[maxj] = jpvt[l];
	  jpvt[l] = jp;
      
  L110:    ;
  L120:    ;
         qraux[l] = 0.0;
         if (l == (n-1)) goto L190;
//c
//c           compute the householder transformation for column l.
//c
            nrmxl = 0.0;
     //     snrm2(n-l+1,x(l,l),1)
            for(k=l; k<n;k++)
                 nrmxl+=x[k][l]*x[k][l];
            nrmxl=sqrt(nrmxl);
            if (nrmxl == 0.0e0) goto L180;
               if (x[l][l] != 0.0) 
                  nrmxl = sing(x[l][l])*nrmxl;
              // sscal(n-l+1,1.0e0/nrmxl,x(l,l),1)
               for(k=l; k<n;k++)
                 x[k][l] = x[k][l]/nrmxl;
               x[l][l] = 1.0 + x[l][l];
//c
//c              apply the transformation to the remaining columns,
//c              updating the norms.
//c
               lp1 = l + 1;
               if (p-1 <  lp1) goto L170;
               for(j = lp1; j< p; j++){
                  //t = -sdot(n-l+1,x(l,l),1,x(l,j),1)/x(l,l)
                   t=0.0;
                   for(k=l;k<n;k++)
                      t +=x[k][l]*x[k][j];
                   t=-t/x[l][l];
                 // call saxpy(n-l+1,t,x(l,l),1,x(l,j),1)
                    for(k=l;k<n;k++)
                      x[k][j] +=t*x[k][l];
                  if (j < pl || j >  pu) goto L150;
                  if (qraux[j] == 0.0) goto L150;
                     tt = 1.0 - x[l][j]/qraux[j]*x[l][j]/qraux[j];
                     tt = max(tt,0.0);
                     t = tt;
                     tt = 1.0 + 0.05e0*tt*qraux[j]/work[j]*qraux[j]/work[j];
                     if (tt == 1.0e0) goto L130;
                        qraux[j] = qraux[j]*sqrt(t);
                     goto L140;
  L130: ;              
                      qraux[j] =0.0; 
   // snrm2(n-l,x(l+1,j),1)
                     for(k=l+1;k<n;k++)
                          qraux[j]+=x[k][j]*x[k][j];
                     qraux[j]=sqrt(qraux[j]);  
                        work[j] = qraux[j];
  L140: ;
  L150: ; 
              }
  L170: ;          
//c
//c              save the transformation.
//c
               qraux[l] = x[l][l];
               x[l][l] = -nrmxl;
  L180:    ;
  L190:   ;
 }
      return;
}

void sqrdc_(double *x, 
            long ldx, 
            long nrow, 
            long ncol,
            double  *qraux,
            long  *jpvt,
            int job)
{
double **m;
m=matrix_(nrow,ncol);
vector_matrix(x,nrow,ncol,m);
double *work;
work = new double[ncol];
 sqrdc(m, 
        ldx, 
        nrow, 
        ncol,
        qraux,
        jpvt,
        work,
        job);
matrix_vector(m,nrow,ncol,x);
delete_matrix_(m,nrow);
delete[] work;
}



