/* $Header: /home/xplore/cvs/xpl4gr/xpltimefun.C,v 1.3 2002/08/16 12:32:02 sigbert Exp $ */

// XploRe core function for XplTime

//  TTK, 21.5.96

#ifdef _XPLTIME_

#include "object.h"
#include "function.h"
#include "xpltimefun.h"
#include "xplerror.h"
#include "init.h"
#include "ttkio.h"

#ifdef PSGEN
#include "plot.h"
#endif


#define TEXTLENGTH  1024L

XplObject*	nyear       (Liste<XplObject*> *argl)
// gets year as number
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplDouble *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "nyear: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "nyear: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplDouble(1);
  *x = cast (((XplLong) t->nyear()));

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "year"));
}

XplObject*	nmonth       (Liste<XplObject*> *argl)
// gets month as number
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplDouble *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "nmonth: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "nmonth: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplDouble(1);
  *x = cast (((XplLong) t->nmonth()));

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "month"));
}

XplObject*	ndayofmonth       (Liste<XplObject*> *argl)
// gets dayofmonth as number
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplDouble *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, ": Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "ndayofmonth: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplDouble(1);
  *x = cast (((XplLong) t->ndayofmonth()));

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "dayofmonth"));
}

XplObject*	ndayofweek       (Liste<XplObject*> *argl)
// gets dayofweek as number
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplDouble *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, ": Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "ndayofweek: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplDouble(1);
  *x = cast (((XplLong) t->ndayofweek()));

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "dayofweek"));
}

XplObject*	nhour       (Liste<XplObject*> *argl)
// gets hour as number
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplDouble *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, ": Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "nhour: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplDouble(1);
  *x = cast (((XplLong) t->nhour()));

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "hour"));
}

XplObject*	nminute       (Liste<XplObject*> *argl)
// gets minute as number
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplDouble *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, ": Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "nminute: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplDouble(1);
  *x = cast (((XplLong) t->nminute()));

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "minute"));
}

XplObject*	nsecond       (Liste<XplObject*> *argl)
// gets second as number
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplDouble *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, ": Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "nsecond: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplDouble(1);
  *x = cast (((XplLong) t->nsecond()));

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "second"));
}

#ifdef _XPLCDEF_
XplObject*	year       (Liste<XplObject*> *argl)
// gets year as text
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplChar   *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "year: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "year: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplChar (1);
  *x = t->year();

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "year"));
}

XplObject*	month       (Liste<XplObject*> *argl)
// gets month as text
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplChar   *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "month: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "month: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplChar (1);
  *x = t->month();

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "month"));
}

XplObject*	dayofmonth       (Liste<XplObject*> *argl)
// gets dayofmonth as text
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplChar   *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "dayofmonth: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "dayofmonth: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplChar (1);
  *x = t->dayofmonth();

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "dayofmonth"));
}

XplObject*	dayofweek       (Liste<XplObject*> *argl)
// gets dayofweek as text
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplChar   *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "dayofweek: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "dayofweek: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplChar (1);
  *x = t->dayofweek();

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "dayofweek"));
}

XplObject*	hour       (Liste<XplObject*> *argl)
// gets hour as text
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplChar   *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "hour: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "hour: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplChar (1);
  *x = t->hour();

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "hour"));
}

XplObject*	minute       (Liste<XplObject*> *argl)
// gets minute as text
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplChar   *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "minute: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "minute: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplChar (1);
  *x = t->minute();

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "minute"));
}

XplObject*	second       (Liste<XplObject*> *argl)
// gets second as text
{
  long      length = argl->laenge ();
  XplTime   *t;
  XplChar   *x;

  if (length != 1)
    {
    globalError.Set (ERR_ARGS, "second: Must be 1");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "second: first argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x  = new XplChar (1);
  *x = t->second();

  if (globalError.Get())     // delete r
    {
    delete x;
    return (NULL);
    }

  return (new XplObject (x, "second"));
}
#endif   // of _XPLCDEF_

/*
XplObject*	settime     (Liste<XplObject*> *argl)
// sets time given a numerical vector
{
  long      length = argl->laenge ();
  XplDouble *x1, *x2;
  XplTime   *t;
  XGran     g = Xmonth;

  if ((length != 1) && (length != 2))
    {
    globalError.Set (ERR_ARGS, "settime: Must be 1 or 2");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "settime: first argument");
    return (NULL);
    }

  if (length == 2)
    {
    if ((*argl)[1]->DefaultType () != C_XPLDOUBLE)
      {
      globalError.Set (ERR_NUM, "settime: second argument");
      return (NULL);
      }
    x2 = (*argl)[1]->DefaultXplDouble();
    switch ((long) x2[0])
      {
      case 1:  g = Xsec;     break;
      case 2:  g = Xminute;  break;
      case 3:  g = Xhour;    break;
      case 4:  g = Xday;     break;
      case 5:  g = Xweek;    break;
      case 6:  g = Xmonth;   break;
      case 7:  g = Xyear;    break;
      default:  globalError.Set (ERR_VAL, "settime: second arg 1..7");
                return (NULL);
      }
    }

  x1 = (*argl)[0]->DefaultXplDouble();
  t  = new XplTime;
  t.SetXplTimeGran (g);

  if (globalError.Get())     // delete r
    {
    delete t;
    return (NULL);
    }

  return (new XplObject (t, "time"));
}
*/

XplObject*	settimegran (Liste<XplObject*> *argl)
// sets time given a numerical vector
{
  long      length = argl->laenge ();
  XplDouble *x1, *x2;
  XplTime   *t;
  XGran     g = Xmonth;

  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "settimegran: Must be 2");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "settimegran: first argument");
    return (NULL);
    }

  if ((*argl)[1]->DefaultType () != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "settimegran: second argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x2 = (*argl)[1]->DefaultXplDouble();
  switch ((long) (*x2)[0])
    {
    case 1:  g = Xsec;     break;
    case 2:  g = Xminute;  break;
    case 3:  g = Xhour;    break;
    case 4:  g = Xday;     break;
    case 5:  g = Xweek;    break;
    case 6:  g = Xmonth;   break;
    case 7:  g = Xyear;    break;
    default:  globalError.Set (ERR_VAL, "settimegran: second arg 1..7");
              return (NULL);
    }

  t->SetXplTimeGran (g);

//  return (new XplObject (t, "time"));
  return (NULL);
}

XplObject*	settimezero (Liste<XplObject*> *argl)
// sets zero date of time 
{
  long      length = argl->laenge ();
  XplDouble *x1, *x2;
  XplTime   *t;
  XGran     g = Xmonth;

  if (length != 2)
    {
    globalError.Set (ERR_ARGS, "settimezero: Must be 2");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "settimezero: first argument");
    return (NULL);
    }

  if ((*argl)[1]->DefaultType () != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "settimezero: second argument");
    return (NULL);
    }

  t  = (*argl)[0]->DefaultComponent()->Content().xpltime;
  x2 = (*argl)[1]->DefaultXplDouble();
  t->SetXplTimeZero ((long) (*x2)[0]);

  return (NULL);
}

XplObject*	filltime (Liste<XplObject*> *argl)
// sequence of time 
{
  long      n, step = 1, length = argl->laenge ();
  XplDouble *x2, *x3, *x4;
  XplTime   *t, *t2;
  XGran     g = Xmonth;

  if ((length < 2) || (length > 4))
    {
    globalError.Set (ERR_ARGS, "filltime: Must be 2, 3 or 4");
    return (NULL);
    }

  if ((*argl)[0]->DefaultType () != C_XPLTIME)
    {
    globalError.Set (ERR_TIME, "filltime: first argument");
    return (NULL);
    }
  t = (*argl)[0]->DefaultComponent()->Content().xpltime;

  if ((*argl)[1]->DefaultType () != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "filltime: second argument");
    return (NULL);
    }
  x2 = (*argl)[1]->DefaultXplDouble ();
  n  = (long) (*x2)[0];

if (length > 2)
  {
  if ((*argl)[2]->DefaultType () != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "filltime: third argument");
    return (NULL);
    }
  x3 = (*argl)[2]->DefaultXplDouble();
  switch ((long) (*x3)[0])
    {
    case 1:  g = Xsec;     break;
    case 2:  g = Xminute;  break;
    case 3:  g = Xhour;    break;
    case 4:  g = Xday;     break;
    case 5:  g = Xweek;    break;
    case 6:  g = Xmonth;   break;
    case 7:  g = Xyear;    break;
    default:  globalError.Set (ERR_VAL, "settime: second arg 1..7");
              return (NULL);
    }
  }

  if (length > 3)
  { if ((*argl)[3]->DefaultType () != C_XPLDOUBLE)
    {
    globalError.Set (ERR_NUM, "filltime: fourth argument");
    return (NULL);
    }
    x2   = (*argl)[3]->DefaultXplDouble ();
    step = (long) (*x2)[0];
  }
  else
    step = 1;

  t2 = new XplTime (*t);
  (*t2) = t2->fill (g, n, step);

  if (globalError.Get())     // delete r
    {
    delete t2;
    return (NULL);
    }

  return (new XplObject (t2, "filltime"));
}


XplObject*	settime     (Liste<XplObject*> *argl)
// sets time for given numerical vectors
{
  long      i, length = argl->laenge ();
  XplDouble *x[6];
  XplLong   *l[6], ll[6];
  XplTime   *t;
  XGran     g = Xmonth;
  char      text[512];
  if ((length < 1) >> (length > 6))
    {
    globalError.Set (ERR_ARGS, "settime: Must be between 1 and 6");
    return (NULL);
    }

  for (i=0; i<6; i++)
    x[i] = NULL;

  for (i=0; i<length; i++)
    {
    if ((*argl)[0]->DefaultType () != C_XPLDOUBLE)
      {
      sprintf (text, "settime: %d. argument", i);
      globalError.Set (ERR_NUM, text);
      return (NULL);
      }
      x[i] = (*argl)[i]->DefaultXplDouble();
    }

  for (i=0; i<6; i++)
    if (x[i] != NULL)
      {
      ll[i] = cast (*(x[i]));
      l[i]  = ll+i;
      }
    else
      l[i] = NULL;


  t = new XplTime;
  t->time (*(l[0]), l[1], l[2], l[3], l[4], l[5]); 

  if (globalError.Get())     // delete r
    {
    delete t;
    return (NULL);
    }

  return (new XplObject (t, "time"));
}

XplObject*	getnow     (Liste<XplObject*> *argl)
// gets current time
{
  long      length = argl->laenge ();
  XplDouble *x;
  XplTime   *t;
  XGran     g = Xday;

  if ((length != 0) && (length != 1))
    {
    globalError.Set (ERR_ARGS, "getnow: Must be between 0 or 1");
    return (NULL);
    }

  if (length == 1)
    {
    if ((*argl)[0]->DefaultType () != C_XPLDOUBLE)
      {
      globalError.Set (ERR_NUM, "getlocalnow: first argument");
      return (NULL);
      }
    x = (*argl)[0]->DefaultXplDouble();
    switch ((long) (*x)[0])
      {
      case 1:  g = Xsec;     break;
      case 2:  g = Xminute;  break;
      case 3:  g = Xhour;    break;
      case 4:  g = Xday;     break;
      case 5:  g = Xweek;    break;
      case 6:  g = Xmonth;   break;
      case 7:  g = Xyear;    break;
      default:  globalError.Set (ERR_VAL, "getnow: second arg 1..7");
                return (NULL);
      }
    }

  t = new XplTime;  
  t->now (g);

  if (globalError.Get())     // delete t
    {
    delete t;
    return (NULL);
    }

  return (new XplObject (t, "time"));
}

XplObject*	getlocalnow     (Liste<XplObject*> *argl)
// gets current time
{
  long      length = argl->laenge ();
  XplDouble *x;
  XplTime   *t;
  XGran     g = Xday;

  if ((length != 0) && (length != 1))
    {
    globalError.Set (ERR_ARGS, "getlocalnow: Must be between 0 or 1");
    return (NULL);
    }

  if (length == 1)
    {
    if ((*argl)[0]->DefaultType () != C_XPLDOUBLE)
      {
      globalError.Set (ERR_NUM, "getlocalnow: first argument");
      return (NULL);
      }
    x = (*argl)[0]->DefaultXplDouble();
    switch ((long) (*x)[0])
      {
      case 1:  g = Xsec;     break;
      case 2:  g = Xminute;  break;
      case 3:  g = Xhour;    break;
      case 4:  g = Xday;     break;
      case 5:  g = Xweek;    break;
      case 6:  g = Xmonth;   break;
      case 7:  g = Xyear;    break;
      default:  globalError.Set (ERR_VAL, "getnow: second arg 1..7");
                return (NULL);
      }
    }

  t = new XplTime;
  t->nowlocal (g);

  if (globalError.Get())     // delete r
    {
    delete t;
    return (NULL);
    }

  return (new XplObject (t, "time"));
}

#endif
