/* $Header: /home/xplore/cvs/xpl4gr/xplwinap.cpp,v 1.3 2002/08/16 12:32:02 sigbert Exp $ */

//----------------------------------------------------------------------------
//                       XploRe  4.0 for Win Main File
//----------------------------------------------------------------------------

//#include "xplore.h"
//#include <windows.h>
#include "liste.h"
#include "xplwinap.h"
#include "function.h"
#include "macro.h"
#include "xplmat.h"
#include "directory.h"

#include "object.h"
#include "wdisp.h"
#include "xplwin.h"

#include "directory.h"
#include "dir.h"
#include "logfile.h"

// localized strings - PC 20010320
#include "xplore_strings.h"

#define OBJECTS	1

extern Liste<XplObject*> *objList;
extern Vector<Function*> *funList;
extern Vector<Macro*> *macList;
const int ID_LB_BASE      = 200;
const int ID_MULTI_SEL    = ID_LB_BASE + 1;
//extern TXploreClient* TXploreClient::Client;
//extern char* xpl4lib;

extern TApplication *myapp;

WinPosManager wpm;

char stret[MAX_TEXT_LENGTH];

void something2dos (char *txt, int maxlen)
{ int i, k;
  for (k=i=0; (i<strlen(txt)) && (i<maxlen); i++, k++)
  { if (txt[i]=='\r')
    { if (txt[i+1]=='\n')
      { stret[k] = txt[i];
        i++;
        k++;
        stret[k] = txt[i];
      }
      else
      { stret[k] = txt[i];
        k++;
        stret[k] = '\n';
      }
    }
    else if (txt[i]=='\n')
    { stret[k] = '\r';
      k++;
      stret[k] = txt[i];
    }
    else
      stret[k] = txt[i];
  }
  stret[k] = 0;
  strcpy(txt, stret);
}

DEFINE_RESPONSE_TABLE1(TFuncWin, TMDIChild)
//  EV_CBN_SELCHANGE(ID_COMBOBOX,  EvCBNSelChange),
  EV_WM_SIZE,
  EV_WM_CLOSE,
//  EV_LBN_DBLCLK(ID_FUNCTIONS, EvFuncDblClk),
  EV_LBN_DBLCLK(ID_OBJECTS, EvItemDblClk),
//  EV_LBN_SETFOCUS(ID_OBJECTS, EvSetFocus),
//  EV_LBN_DBLCLK(ID_MACROS, EvMacDblClk),
END_RESPONSE_TABLE;

TFuncWin::TFuncWin(TXploreClient& parent, const char far* title) : TMDIChild(parent, title)
{ //int x, y, w, h;
  TRect parViewable;
  Parent = &parent;

  objects = NULL;
  info    = NULL;
  strcpy(Title, title);

//  if (!strcmp(Title,OBJ_TITLE))
//    wpm.getwin(WIN_OBJ, &x, &y, &w, &h);
//  else if (!strcmp(Title,FUN_TITLE))
//    wpm.getwin(WIN_FUNC, &x, &y, &w, &h);
//  else if (!strcmp(Title,MAC_TITLE))
//    wpm.getwin(WIN_MACRO, &x, &y, &w, &h);
  parViewable = Parent->GetClientRect();
  if (!strcmp(Title,OBJ_TITLE))
    wpm.getwin(WIN_OBJ, &parViewable);
  else if (!strcmp(Title,FUN_TITLE))
    wpm.getwin(WIN_FUNC, &parViewable);
  else if (!strcmp(Title,MAC_TITLE))
    wpm.getwin(WIN_MACRO, &parViewable);

  Attr.X=parViewable.Left();
  Attr.Y=parViewable.Top();
  Attr.W=parViewable.Width();
  Attr.H=parViewable.Height();
}

TFuncWin::~TFuncWin()
{
  if (objects)
  { objects->Destroy();
	 delete objects;
	 objects = 0;
  }
  if (info)
  { info->Destroy();
	 delete info;
	 info = 0;
  }

  if (!strcmp(Title,OBJ_TITLE))
    Parent->ObjectList = 0;
  else if (!strcmp(Title,FUN_TITLE))
    Parent->FunctionList = 0;
  else if (!strcmp(Title,MAC_TITLE))
    Parent->MacroList = 0;
}

  // remove this by next compilation
void
TFuncWin::EvClose() {
	  TMDIChild::EvClose();
}

void
TFuncWin::SetupWindow() {
	TMDIChild::SetupWindow();
	SetBkgndColor(TColor::LtGray);

	objects = new TListBox(this, ID_OBJECTS, 10, 10, 150, 150);
	objects->Attr.Style |= (WS_HSCROLL);
	objects->Create();
	// objects->Show(SW_HIDE);

   info = new TEdit(this, ID_INFO, "", 160, 10, 90, 150, MAX_INFO_LENGTH, true);
   info->Create();
   info->SetReadOnly(true);

   SetIcon (myapp, AAA32);
   SetIconSm (myapp, AAA32);

	UpdateLists();

}

void
TFuncWin::EvSize(UINT sizeType, TSize& size)
{
  TMDIChild::EvSize(sizeType, size);
  int width;
  // Force Windows to repaint the entire window region
  Invalidate(TRUE);

  if (objects)
  { width = size.cx*0.4;
    if (width>150) width=150;
    objects->MoveWindow(10, 10, width-10, size.cy-10, TRUE);
  }
  if (info)
    info->MoveWindow (width+10, 10, size.cx-width-10, size.cy-10, TRUE);

}

void
TFuncWin::EvItemDblClk() {
  char str[50] = "", str2[10]="";
  objects->GetSelString(str, 16);
  if (!strcmp(Title,OBJ_TITLE))
    ObjDblClk(str);
  else if (!strcmp(Title,FUN_TITLE))
    FunDblClk(str);
  else if (!strcmp(Title,MAC_TITLE))
    MacDblClk(str);
}

/*void
TFuncWin::EvSetFocus()
{ UpdateLists(); }
*/

//char * GetHelp (const char *);

void
TFuncWin::FunDblClk(char* name) {
  char textdir[256], *file;

  sprintf (textdir, "text\\%s.txt", name);
  file = openfile (HELP, textdir, "r");

  FILE *stream;
  char buf[MAX_INFO_LENGTH];

  if ((stream = fopen(file, "r"))
       == NULL)
  { sprintf(buf, XMSG_CANNOT_OPEN_HELP_FILE_STR, textdir);
    ::MessageBox (NULL, buf,  XMSG_XPLORE_ERROR_STR,  MB_APPLMODAL | MB_ICONEXCLAMATION | MB_OK | MB_SETFOREGROUND);
    fclose(stream);
    return;
  }

  int read=fread(buf, 1, MAX_INFO_LENGTH, stream);

  int i;
  for (i=0; i<read; i++)
  {	//cout<<(int)(buf[i])<<", "<<endl;
    if ((int)(buf[i])<0)
    {	buf[i]='\0';
     	i=read;
    }
  }
  buf[i]= '\0';

  fclose(stream);
  if (info)
  { something2dos(buf, MAX_INFO_LENGTH);
    info->SetText (buf);
  } // SK 19.11.98

  //Parent->MessageBox(buf, "Function Short Help", MB_OK);
  return ;
}

MyMessageBox (char *str, char *SelItem, uint type)
{
	MessageBox (NULL, str, SelItem, MB_ICONINFORMATION |MB_SETFOREGROUND);
}

void TFuncWin::ObjDblClk(char* SelItem)
{ char name[100];

  sprintf(name, XMSG_OBJECT_DBLCLK_NAME_STR, SelItem);

  int i, j;
  for (i=0; i<objList->laenge(); i++)
  		if (!strcmp((*objList)[i]->Name(), SelItem))
      	break;

  if (i==objList->laenge())
  { cerr<<"An impossible error seems to be occured..."<<endl;
    return;
  }

  char textstr[MAX_TEXT_LENGTH];
  textstr[0]='\0';

  if ( (*objList)[i]->ComponentNumber() > 1)
  { strcat(textstr, XMSG_OBJECT_LIST_COMPONENTS_STR);
    for (j=0; j<(*objList)[i]->ComponentNumber(); j++)
    { strcat(textstr, ( *( (*objList)[i] ) )[j]->Name());
      strcat(textstr, "\r\n ");
    }
      //Parent->MessageBox (textstr, name, MB_OK | MB_ICONINFORMATION |MB_SETFOREGROUND);
  }
  else
   { char *t;
	  XplDouble *xpld;
	  int k, ro, co, x, y;
     Component *comp=(*objList)[i]->DefaultComponent();

	  XplChar *xxx;
	  int r, c;
     SubDisplay *sd;
     char muell[16];
	  switch	(comp->Type())
	  { case C_XPLDOUBLE:
         xpld=comp->Content().xpldouble;
			ro=xpld->dimension(0);
			co=xpld->dimension(1);
			if (ro>20 || co>10)
			{	sprintf(textstr, "%s\r\n%s%d%s%d%s\r\n",
				XMSG_OBJECT_1MATRIX_LARGE_STR,
				XMSG_OBJECT_2MATRIX_LARGE_STR,
				20,
				XMSG_OBJECT_3MATRIX_LARGE_STR, 10, XMSG_OBJECT_4MATRIX_LARGE_STR);
				ro=ro>20 ? 20 : ro;
				co=co>10 ? 10 : co;
			}
         for (j=0; j<ro ; j++)
         {	for (k=0; k<co; k++)
         	{	sprintf(muell, "%7.7f ", (*xpld)(j,k));
            	strcat(textstr, muell);
            }
            strcat(textstr, "\r\n");
         }
			break;
	    case C_DISPLAY:
  			r=comp->Content().display->GetRows();
			c=comp->Content().display->GetColumns();
			for (j=1; j<c+1; j++)
			for (k=1; k<r+1; k++)
			{	sd=comp->Content().display->GetElement(k, j);
				switch(sd->WhatIs())
				{case TEXT:
					sprintf(muell, XMSG_OBJECT_TEXT_PLOT_STR);

				 	break;
				 case WPLOT:
					sprintf(muell, XMSG_OBJECT_PLOT_PLOT_STR);
					 break;
				 default:
					sprintf(muell, XMSG_OBJECT_DEFAULT_PLOT_STR);
					 break;
				}
            strcat(textstr, muell);
  				if (j==c)
					strcat(textstr, "\r\n");
			}
			break;

		 case C_XPLCHAR:
#ifdef _XPLCDEF_
			xxx=comp->Content().xplchar;
  			t = (*xxx)(0).tostr();	//OK!
#else
  			t = comp->Content().text;
#endif
			sprintf(textstr, "%s", t);
#ifdef _XPLCDEF_
			delete t;
#endif
			break;
		 default:
			cout<<"XPLUNKNOWN"<<endl;
 			sprintf(textstr, XMSG_OBJECT_UNKNOWN_STR);
			break;
	  }
   }

  textstr[MAX_INFO_LENGTH-1] = 0;
  if (info) info->SetText (textstr);
}

void
TFuncWin::MacDblClk(char* name) {
  char textdir[100], *file;

  sprintf (textdir, "text\\%s.txt", name);
  file = openfile (HELP, textdir, "r");

  FILE *stream;
  char buf[MAX_INFO_LENGTH];

  if ((stream = fopen(file, "r"))== NULL)
  { sprintf(buf, XMSG_CANNOT_OPEN_HELP_FILE_STR, textdir);
    ::MessageBox (NULL, buf,  XMSG_XPLORE_ERROR_STR,  MB_APPLMODAL | MB_ICONEXCLAMATION | MB_OK | MB_SETFOREGROUND);
    fclose(stream);
    return;
  }

  int read=fread(buf, 1, 3255, stream);
  int i;
  for (i=0; i<strlen(buf); i++)
    if ((int)(buf[i])<0)
    {	buf[i]='\0';
     	i=MAX_INFO_LENGTH;
    }
  buf[read]='\0';
  fclose(stream);
  // Parent->MessageBox(buf, "Macro Short Help", MB_OK);
  if (info)
  { something2dos (buf, MAX_INFO_LENGTH);
    info->SetText(buf);
  }
  return ;
}

TFuncWin::ListLength()
{ int ret = 0;
  if (!strcmp(Title,OBJ_TITLE))
    ret = objList->laenge();
  else if (!strcmp(Title,FUN_TITLE))
    ret = funList->laenge();
  else if (!strcmp(Title,MAC_TITLE))
    ret = macList->laenge();
  return (ret);
}

void
TFuncWin::UpdateLists()
{ int i, j;
  const char *tmp;
  objects->ClearList();
  if (!strcmp(Title,OBJ_TITLE))
  { for (i=0; i<objList->laenge(); i++)
      objects->AddString((*objList)[i]->Name ());
  }
  else if (!strcmp(Title,FUN_TITLE))
  { for (i=0; i<funList->laenge(); i++)
	 { tmp = (*funList)[i]->Name ();
    	if (tmp[0]!='#') objects->AddString(tmp);
    }
  }
  else if (!strcmp(Title,MAC_TITLE))
  { for (i=0; i<macList->laenge(); i++)
      objects->AddString((*macList)[i]->Name ());
    for (j=0; j<x4ml.len; j++)  // SK 15.11.00
    { if (x4ml.macroname[j])
        objects->AddString(x4ml.macroname[j]);
    }
  }
}

  WinPosManager::WinPosManager()
  {
     width = height = k = 0;
     for(int i = 0; i < MAXEDWINDOWSPOS; i++)	// PC 20011211: clear window positions
        windowpos[i] = 0;
  }

  // PC 20011211: finds a suitable position for the next ed window
  int WinPosManager::getedwinid(void)
  {
     long min = windowpos[0];
     int pos = 0, i;

     for(i = 1; i < MAXEDWINDOWSPOS; i++)
       if (windowpos[i] < min)
       {
         pos = i;
         min = windowpos[i];
       }
     windowpos[pos] += 1;

     return pos;
  }

  // PC 20011211: clears blocked position
  void WinPosManager::removeedwinid(int winid)
  {
     if ((0 <= winid) && (winid < MAXEDWINDOWSPOS))
       if (windowpos[winid] > 0)
         windowpos[winid] -= 1;
  }

  int WinPosManager::getwin (int type, TRect *viewable)//int *x, int *y, int *w, int *h)
  { int r;
//    width  = GetSystemMetrics (SM_CXFULLSCREEN);
//    height = GetSystemMetrics (SM_CYFULLSCREEN);

    r = -1;
    switch (type)
    { case WIN_INPUT:
        viewable->SetWH( 0, 0.7*viewable->Height()+1, 0.5*viewable->Width(), 0.3*viewable->Height());
        break;
      case WIN_OUTPUT:
        viewable->SetWH( 0.5*viewable->Width(), 0, 0.5*viewable->Width(), viewable->Height());
        break;
      case WIN_LIB:
		  viewable->SetWH( 0.75*viewable->Width()+1, 0, 0.25*viewable->Width()-2, 0.8*viewable->Height()-1);
        break;
      case WIN_MACRO:
        viewable->SetWH( 0.05*viewable->Width(), 0.55*viewable->Height(), 0.50*viewable->Width()-1,
                         0.25*viewable->Height()-1);
        break;
      case WIN_FUNC:
        viewable->SetWH( 0.10*viewable->Width(), 0.60*viewable->Height(), 0.50*viewable->Width()-1,
                        0.25*viewable->Height()-1);
        break;
      case WIN_OBJ:
        viewable->SetWH( 0.15*viewable->Width(), 0.65*viewable->Height(), 0.50*viewable->Width()-1,
								0.25*viewable->Height()-1);
        break;
      default: // WIN_EDIT
        k = getedwinid();	// PC 20011211: get new window position
        viewable->SetWH( (k%MAXEDWINDOWSPOS)*0.05*viewable->Width(), (k%MAXEDWINDOWSPOS)*0.05*viewable->Height(),
                        0.5*viewable->Width(), 0.7*viewable->Height());
        r = k;
    }
    return (r);
  }


InfoDialog::InfoDialog (TWindow* parent, TResId resId, TModule* module) :
  TDialog (parent, resId, module)
{
  xpl4data = new TEdit (this, IDC_EDIT6, 1024);
  xpl4lib = new TEdit (this, IDC_EDIT7, 1024);
  xpl4dll = new TEdit (this, IDC_EDIT5, 1024);
  xpl4help = new TEdit (this, IDC_EDIT9, 1024);
  xpl4prog = new TEdit (this, IDC_EDIT10, 1024);
  xpl4temp = new TEdit (this, IDC_EDIT8, 1024);

  xpl4outdata = new TEdit (this, IDC_EDIT12, 1024);
  xpl4outlib = new TEdit (this, IDC_EDIT13, 1024);
  xpl4outdll = new TEdit (this, IDC_EDIT11, 1024);
  xpl4outhelp = new TEdit (this, IDC_EDIT15, 1024);
  xpl4outprog = new TEdit (this, IDC_EDIT16, 1024);
  xpl4outtemp = new TEdit (this, IDC_EDIT14, 1024);

  xpl4log = new TEdit (this, IDC_EDIT17, 1024);
}

extern getlogfilename(char *buf);

void InfoDialog::SetupWindow ()
{ char str[1024], *tok;

  TDialog::SetupWindow();

  str[0] = 0; dump(str, DATA, 0);
  tok = strtok(str, "="); tok = strtok(NULL, "=");
  xpl4data->SetText (tok);
  str[0] = 0; dump(str, LIB, 0);
  tok = strtok(str, "="); tok = strtok(NULL, "=");
  xpl4lib->SetText (tok);
  str[0] = 0; dump(str, DLL, 0);
  tok = strtok(str, "="); tok = strtok(NULL, "=");
  xpl4dll->SetText (tok);
  str[0] = 0; dump(str, HELP, 0);
  tok = strtok(str, "="); tok = strtok(NULL, "=");
  xpl4help->SetText (tok);
  str[0] = 0; dump(str, PROG, 0);
  tok = strtok(str, "="); tok = strtok(NULL, "=");
  xpl4prog->SetText (tok);
  str[0] = 0; dump(str, TEMP, 0);
  tok = strtok(str, "="); tok = strtok(NULL, "=");
  xpl4temp->SetText (tok);
  str[0] = 0; dump(str, DATA, 1);
  tok = strtok(str, "="); tok = strtok(NULL, "=");
  xpl4outdata->SetText (tok);
  str[0] = 0; dump(str, LIB, 1);
  tok = strtok(str, "="); tok = strtok(NULL, "=");
  xpl4outlib->SetText (tok);
  str[0] = 0; dump(str, DLL, 1);
  tok = strtok(str, "="); tok = strtok(NULL, "=");
  xpl4outdll->SetText (tok);
  str[0] = 0; dump(str, HELP, 1);
  tok = strtok(str, "="); tok = strtok(NULL, "=");
  xpl4outhelp->SetText (tok);
  str[0] = 0; dump(str, PROG, 1);
  tok = strtok(str, "="); tok = strtok(NULL, "=");
  xpl4outprog->SetText (tok);
  str[0] = 0; dump(str, TEMP, 1);
  tok = strtok(str, "="); tok = strtok(NULL, "=");
  xpl4outtemp->SetText (tok);

  str[0]=0; getlogfilename(str);
  xpl4log->SetText (str);
}

DEFINE_RESPONSE_TABLE1(InfoDialog, TDialog)
END_RESPONSE_TABLE;

AutosaveDlg::AutosaveDlg (TWindow* parent, TResId resId, TModule* module) :
	TDialog(parent, resId, module), TWindow(parent)
{
//	TDialog::TDialog( parent, resId, module );
   asenable = new TCheckBox( this, IDC_ASENABLE );
   astimer = new TEdit( this, IDC_ASTIMER, 3 );
   asadjust = new TUpDown( this, IDC_ASTIMERADJUST, astimer );
   asadjust->SetRange(60, 1);
   asadjust->SetPos(autosaveTime);
}

void AutosaveDlg::SetupWindow()
{
	TDialog::SetupWindow();
	asenable->Create();
   astimer->Create();
   asadjust->Create();
   asadjust->SetRange(60, 1);
   asadjust->SetPos(autosaveTime);
   asenable->SetCheck( isAutosave ? BF_CHECKED : BF_UNCHECKED );
   astimer->EnableWindow( asenable->GetCheck() == BF_CHECKED );
   asadjust->EnableWindow( asenable->GetCheck() == BF_CHECKED );
}

AutosaveDlg::~AutosaveDlg()// : TDialog()
{
	if( asenable )
   	delete asenable;
   if( astimer )
   	delete astimer;
   if( asadjust )
   	delete asadjust;
//   TDialog::~TDialog();
}

bool AutosaveDlg::CanClose()
{
	isAutosave = ( asenable->GetCheck() == BF_CHECKED );
   autosaveTime = asadjust->GetPos();
   return true;
}

int AutosaveDlg::Execute( bool asenable = false, int astime = 5 )
{
	isAutosave = asenable;
   autosaveTime = astime;
   TDialog::Execute();
}

void AutosaveDlg::evAsEnable()
{
   astimer->EnableWindow( asenable->GetCheck() == BF_CHECKED );
   asadjust->EnableWindow( asenable->GetCheck() == BF_CHECKED );
}

DEFINE_RESPONSE_TABLE1(AutosaveDlg, TDialog)
  EV_BN_CLICKED( IDC_ASENABLE, evAsEnable ),
END_RESPONSE_TABLE;

#define FUNCTIONS   2
#define OBJECTS     1
#define MACROS      0

int GetNames (int type, char ***names, bool only_counts)
{ int i, j, ret;
  char **array;

  switch (type)
  { case OBJECTS:
      if (objList == NULL)
      { *names = NULL; return 0; }
      ret = objList->laenge();
      if (only_counts) break;
      if (ret == 0)
      { *names = NULL; return 0; }

      *names = array = new char*[ret];
      if (array == NULL) return 0;

      for (i=0; i<ret; i++)
        array[i] = strdup((*objList)[i]->Name ());
      break;

    case FUNCTIONS:
      if (funList == NULL)
      { *names = NULL; return 0; }
      ret = funList->laenge();
      if (only_counts) break;
      if (ret == 0)
      { *names = NULL; return 0; }

      *names = array = new char*[ret];
      if (array == NULL) return 0;

      for (i=0; i<ret; i++)
        array[i] = strdup((*funList)[i]->Name ());
      break;
    default:
      if (macList == NULL)
      { *names = NULL; return 0; }
      ret = macList->laenge()+x4ml.length();
      if (only_counts) break;
      if (ret == 0)
      { *names = NULL; return 0; }

      *names = array = new char*[ret];
      if (array == NULL) return 0;

      for (i=0; i<macList->laenge(); i++)
        array[i] = strdup((*macList)[i]->Name ());
      for (j=0; j<x4ml.len; j++)  // SK 15.11.00
      { if (x4ml.macroname[j])
        { array[i] = strdup(x4ml.macroname[j]);
          i++;
        }
      }
      break;
  }
  return (ret);
}

