/* $Header: /home/xplore/cvs/xpl4gr/xplxgobi.c,v 1.3 2002/08/16 12:32:03 sigbert Exp $ */

#ifdef _RPCXGOBI_

/*  XGobi - XploRe  by JS, TTK  8.1.97  */

#include <stdlib.h>
#include <math.h>
#include <sys/types.h>
#include <string.h>
#include "aiserver.h"
#include "aiiac.h"


#define TIMEOUT 20.0  /* Seconds */
static double timeout = TIMEOUT;

int server_id, status;

unsigned long xpl_client_number = 0x42000000, 
              xpl_server_number = 0x43000000;
int xpl_start_as_link = FALSE;
int xpl_server_active = FALSE;


int read_brush_string(char *);
void ccparse (char *line);

/*
   Usage:     In - client_id, commandstr : long, str
   Function:  01
*/

long we_are_busy = 0;

void RPC_Xpl_Execute (char *instr, char *outstr)
{
  int i = 0;
  long client_id;
  char *tokptr;

  we_are_busy++;

  tokptr = strtok (instr," ");
  if (!sscanf (tokptr, "%x", &client_id))
  {
    printf ("no id read");
    return;
  }

  tokptr = strtok (NULL, "\0");

  ccparse(tokptr);

  sprintf (outstr, "01.00");

  we_are_busy--;
}


void RPC_Xpl_Return_Variable (char *instr, char *outstr)

{
  static int fertig = 1;
  static char tempstr[1024];
  static char *fullstr;
  static count = 0;
  
  /* during the first call, the output string has to be created -
     during follow-up calls, 1K segments of this string are being
     passed to the client - this patch is necessary since the 
     RPC mechanism cannot handle return strings > 1K
     JS 7/22/99
  */
  
  if (fertig) 
  {
    writevarinstring (instr, outstr); 
    fullstr = strdup(outstr);
    fertig = 0;
  }
  
  if (strlen(fullstr + count) > 1023)
  {
    strncpy(tempstr, fullstr + count, 1023);
    tempstr[1023] = 0;
    count += 1023;
    strcpy(outstr, tempstr);
  }
  else
    {
      strcpy(tempstr, fullstr + count);
      count = 0;
      fertig = 1;
      strcpy(outstr, tempstr);
    }
}


void RPC_Xpl_Busy (char *instr, char *outstr)
{
  sprintf (outstr, "%li", we_are_busy);

}


int split_color_glyph_size (int i, int pointtype)
{
  int remainder;

/*
  lastf[i] = pointtype;

  size[i] = pointtype / 1000 + 1;
  if (size[i] < 1 || size[i] > NGLYPHSIZES)
  {
    return (1);
  }

  remainder = pointtype % 1000;
  glyph[i] = remainder / 100 + 1;
  if (glyph[i] < 1 || glyph[i] > NGLYPHTYPES)
  {
    return (1);
  }

  remainder = remainder % 100;
  erase[i] = remainder / (NCOLORS + 1);
  if (erase[i] != 0 && erase[i] != 1)
  {
    return (1);
  }

  if (!mono)
  {
    color[i] = remainder % (NCOLORS + 1);
  }
*/

  return (0);
}



/*
   Usage:     In - client_id, list of index:size_color_glyph : long, list of (int:int)
   Function:  02
*/

void RPC_Xpl_Brush_Some (char *instr, char *outstr)
{
  int i;
  long client_id;
  int pointtype;
  char *tokptr;


  read_brush_string(instr);
  return;
}



int internRPCStartClient (unsigned long cl_prognum)
{
  static char hostname[HOSTNAMELEN];

  gethostname(hostname, HOSTNAMELEN);
  
  server_id = aiconnect (hostname, cl_prognum, (u_long) 1);
  if (server_id > 99)
  {
    printf ("XploRe: Error in connecting to server - %d\n", server_id);
    return (-1);
  }
  
  printf("XploRe: Connected to host=%s, using prognum=%x and serverid=%d\n",
   hostname, cl_prognum, server_id);
   
 return(server_id);
}


void internRPCStopClient (int server_id)

{
  char RetStr[256];


  airequest (server_id, Quit, "", RetStr, timeout);

  status = aidisconnect (server_id);
  if (status != 1) 
    printf ("XploRe: Error when disconnecting - %d\n", status);
}


void internRPCStartServer (unsigned long serverportnumber)

{
  if (xpl_server_active)
  {
    //xplmessage("Only one active RPC server permitted.\n");
    printf ("XploRe: Only one active RPC server permitted.\nRoutine internRPCStartServer aborted.\n");
    return;
  }
  
  rpc_server_main (serverportnumber, (u_long) 1); 
  xpl_server_number = serverportnumber;
  xpl_server_active = TRUE;
}


void internRPCStopServer ()

{
  if (!xpl_server_active)
  {
    printf ("XploRe: No active RPC server.\nRoutine internRPCStopServer aborted.\n");
    // xplmessage("No active RPC server.\n");
    return;
  }
  
  xpl_server_active = FALSE;
}


char * internRPCSendRequest (int server_id, int functnr, char *RequStr, double timeout)

{
  char *RetStr;

  RetStr = (char *) XtMalloc (4096);

  status = airequest (server_id, functnr, RequStr, RetStr, timeout);
  if (status != 0)
  {
    printf ("XploRe: Error in submitting request - %d\n", status);
    sprintf(RetStr, "");
  }
      
  return((char *) RetStr);
}


char * xgobi_const_colors ()

{
  char *RetStr;

/*
  sprintf(outstr, "%d %d %d %s %s %s %s %s %s %s %s %s %s", 
    NGLYPHSIZES, NGLYPHTYPES, NCOLORS,
    appdata.brushColor0, appdata.brushColor1, appdata.brushColor2,
    appdata.brushColor3, appdata.brushColor4, appdata.brushColor5,
    appdata.brushColor6, appdata.brushColor7, appdata.brushColor8,
    appdata.brushColor9);
*/


  RetStr = (char *) XtMalloc ((unsigned int) 512);

  status = airequest (server_id, 4, "", RetStr, timeout);
  if (status != 0) 
    printf ("XploRe: Error in submitting request - %d\n", status);
  return(strdup(RetStr));

  XtFree ((char *) RetStr);
}


int rpc_xfer_brush_to_xgobi (char *RequStr, int server_id)

{
  char *RetStr;


  RetStr = (char *) XtMalloc ((unsigned int) 512);
   
  status = airequest (server_id, 16, RequStr, RetStr, timeout);
  if (status != 0) 
    printf ("XploRe: Error in submitting request - %d\n", status);

  XtFree ((char *) RetStr);
}


#endif   // _RPCXGOBI_
