/* $Header: /home/xplore/cvs/xpl4gr/xreal.hpp,v 1.4 2003/02/23 17:15:11 cizek Exp $ */

#include <stdlib.h>
#include <math.h>

#include "xnumber.hpp"
#include "wavelet.h"
#include "nnet.hpp"
#include "distinv.h"
//#include "waveyuri.h"

#ifndef XPLREAL
#define XPLREAL

#define TINY            1.0e-20
#define SMALL           1.0e-6
#define BIG 		10000000

#ifndef PI
#define PI		3.14159265358979323846
#endif
#ifndef LOG2
#define LOG2		0.30102999566398119521
#endif 
#ifndef LN2
#define LN2		0.6931471805599453094172321
#endif
#ifndef LOG2T
#define LOG2T		3.32192809488736234787
#endif
#ifndef LOG2E
#define LOG2E		1.4426950408889634074	/* 1/LN2		*/
#endif

#ifndef M_E
#define	M_E		2.7182818284590452354
#endif
#ifndef M_LOG10E
#define	M_LOG10E	0.43429448190325182765
#endif
#ifndef M_LN10
#define	M_LN10		2.30258509299404568402
#endif
#ifndef M_PI_2
#define	M_PI_2		1.57079632679489661923
#endif
#ifndef M_PI_4
#define	M_PI_4		0.78539816339744830962
#endif
#ifndef M_1_PI
#define	M_1_PI		0.31830988618379067154
#endif
#ifndef M_2_PI
#define	M_2_PI		0.63661977236758134308
#endif

#ifndef M_2_SQRTPI
#define	M_2_SQRTPI	1.12837916709551257390
#endif
#ifndef M_SQRT2
#define	M_SQRT2		1.41421356237309504880
#endif
#ifndef M_SQRT1_2
#define	M_SQRT1_2	0.70710678118654752440
#endif
#ifndef M_1_SQRTPI
#define M_1_SQRTPI      0.564189583547756286948
#endif
#ifndef M_SQRT_2
#define M_SQRT_2        0.707106781186547524401
#endif

#define max1(a,b)  (a<b ? b : a)
#define min1(a,b)  (a>b ? b : a)
#define sqr(x)     ((x)*(x))

// swap a and b with help of temp 
#define SWAP(a,b,temp) { temp=(a); (a)=(b); (b)=temp; }

// fuer lowess SK 970204
#define YS(i)	    *(ys+(i)-1)
#define AYS(i)     (ys+(i)-1)
#define Y(i)       *(y+(i)-1) 
#define X(i)       *(x+(i)-1)
#define RES(i)     *(res+(i)-1)
#define RW(i)      *(rw+(i)-1)
#define W(i)       *(w+(i)-1)
#define SQR(x)     ((x)*(x))
#define TRI(x)     ((x)*(x)*(x))
#define FOR(i,a,b) for((i)=(a); (i)<=(b); (i)++)



#define DATAXR(k)    (*(data + ((k - 1) % 2) * nn + (k - 1) / 2))
#define SWAP2(a,b) { tempr = (a); (a) = (b); (b) = tempr;}
#define MAXJACLOOP  50

#define R1_M1 259200
#define R1_IA1 7141
#define R1_IC1 54773
#define R1_RM1 (1.0/R1_M1)
#define R1_M2 134456
#define R1_IA2 8121
#define R1_IC2 28411
#define R1_RM2 (1.0/R1_M2)
#define R1_M3 243000
#define R1_IA3 4561
#define R1_IC3 51349
#define R2_M 714025
#define R2_IA 1366
#define R2_IC 150889
#define R3_MBIG 1000000000
#define R3_MSEED 161803398
#define R3_MZ 0
#define R3_FAC (1.0/R3_MBIG)

#define INUNIT  -1
#define OUTUNIT  1

extern double randomval, nrand;
extern int nset;

typedef double* doublep;

class CartSplit
{ int i, *nl, *nr;
  doublep *dl, *dr;

  public:
  CartSplit (int maxlen);
  ~CartSplit();
  void append (int nli, double *dli, int nri, double *dri);
  int length ();
  int operator() (int v, int ni);
  double operator() (int v, int ni, int nj);

};

#ifdef HAS_SMPMATH
double acosh (double x);
double asinh (double x);
double atanh (double x);
#ifndef __APPLE_CC__
double erf (double x);
double erfc (double x);
#endif
double expm1 (double x);
double logb (double x);
double gamma (double x);
#endif


double suniform (double x);
double striangle (double x);
double sepanechnikov (double x);
double squartic (double x);
double striweight (double x);
void triangle (double f1, double f2, double f3,
                      double x1, double x2, double x3,
                      double y1, double y2, double y3,
                      double cut, double *lx, double *ly,
                      long *ln);
int notpowof2 (long n);

  int ludcmp (double *lu, long n, long *indx, double *d);
  void lubksb (double *lu, long n, long *indx, double *x);
  void matinv (double *tptr, long n, long p);
  void matlu (double *tptr, long n, long p, double *tptrl, double *tptru, long *indx);
  void matdet (double *tptr, long n, long p, double *res);

  void initrandom(double start);
  double uniformrandom();
  double normalrandom();
  double ran0 (int *idum);
  double ran0 (void);
  double ran1(int *idum);
  double ran1 (void);
  double ran2(long *idum);
  double ran2 (void);
  double ran3(int *idum);
  double ran3 (void);
  double expdev_base(double (*func) (void));
  double expdev(void);
  double expdev0(void);
  double expdev1(void);
  double expdev2(void);
  double expdev3(void);
  double gasdev_base(double (*func) (void));
  double gasdev(void);
  double gasdev0(void);
  double gasdev1(void);
  double gasdev2(void);
  double gasdev3(void);

  void matdist (double *in, long n, long p, double *out, char *distm);
  double gammaln (double xx);

#ifdef HAS_SMPMATH
  double lgamma (double x);
  double logb (double x);
  double log1p (double x);
#endif

  double spdfb(double x, double a, double b);
  void matpdfb (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);
  double spdfc(double x, double n);
  void matpdfc (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);
  double spdff(double x, double n1, double n2);
  void matpdff (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);
  double spdfn (double x);
  void matpdfn (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);
  double spdft(double x, double n);
  void matpdft (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);

  double gammaser (double x, double a, double *gln);
  double gammacf (double x, double a, double *gln);
  double stgamma(double x, double a);

  double scdfn (double x);
  void matcdfn (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);
  double scdft (double x, double n);
  void matcdft (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);
  double scdfc(double x, double n);
  void matcdfc (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);
  double betacf (double x, double a, double b);
  double scdfb(double x, double a, double b);
  void matcdfb (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);
  double scdff(double x, double n1, double n2);
  void matcdff (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);
  double sqfn (double k);
  double sqft(double x, double df1);
  // double sqfc(double x, double df1);
  double sqff(double x, double df1, double df2);
  void matqfn (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);
  void matqft (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);
  void matqfc (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);
  void matqff (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);
  void matatan2 (double *resptr, long nr, long pr, double *aptr, long naa, long paa, double *bptr, long nbb, long pbb);

  long circle(long x, long period);
  void fwt_int (double *data, long length, long level, double *h, int hrange);
  void filter_mother_father(double *x, long length, double* h, long hrange);
  void filter_father_father(double *x, long length, double* h, long hrange);
  void invert_fwt(double *data, int length, int level, double* h, long hrange);

  void sisoreg (double *resvec, long n);
  void s_knn(double *x, double *y, long n, long k, double *sk);

  void swap(long l, long r, double *window, long *outlist, long *nrlist);
  void siftup(long l, long r, double *window, long *outlist, long *nrlist);
  void heapsort(long low, long up, double* window, long *outlist, long *nrlist);
  void inittree(long n, long k, long k2, double *data, double *window, long *outlist, long *nrlist);
  void toroot(long outvirt, long k, long nrnew, long outnext, double *data, double *window, long *outlist, long *nrlist);
  void downtoleave(long outvirt, long k, double *window, long *outlist, long *nrlist);
  void uptoleave(long outvirt, long k, double *window, long *outlist, long *nrlist);
  void upperoutupperin(long outvirt, long k,double *window, long *outlist, long *nrlist);
  void upperoutdownin(long outvirt, long k, long nrnew, long outnext, double *data, double *window, long *outlist, long *nrlist);
  void downoutdownin(long outvirt, long k, double *window, long *outlist, long *nrlist);
  void downoutupperin(long outvirt, long k, long nrnew, long outnext, double *data, double *window, long *outlist, long *nrlist);
  void wentoutone (long k, double *window, long *outlist, long *nrlist);
  void wentouttwo(long k, double *window, long *outlist, long *nrlist);
  void runmedint(long n, long k, long k2, double *data, double *median, double *window, long *outlist, long *nrlist);

  void runmed(long n, long k, double *data, double *median);
  void sl1line (long n, double *x, double *y, double *b);
  void slowess (double *x_in, double *y_in, long n_in, double f_in, long nsteps_in, double delta_in, double *ys_out);
  void lowest (double *x, double *y, long n, double xs, double *ys, long nleft, long nright, double *w, long userw, double *rw, long *ok);

  int less (const void *a, const void *b);
  void lowess_int (double *x, double *y, long n, double f, long nsteps, double delta, double *ys, double *rw, double *res);
  void kmeans(long *ik, double *xx, double *cw, double *v, double *wk,
        double *we, double *xm, long n, long p, long nclu, long npass);
  void agglom(long *ka, long *kb, double *h, long *kp, double *q, double *x,
          long n, long mtd, double beta, double *y, double *wy, long knr);
  long build_tree (double *vec, long i, long *pos, double *x, double *y,
                    double *linex, double *liney, double *ind, long *linen,
                    long m, long *no);
  long greatertree (double l, double r);
  long smallertree (double l, double r);
  void distance(double *x, int mtc, double *w, int n, int p, double *d);
  double select(long k, long n, double arr); // PC 20010221

template<class T> class XplReal : public XplNumber<T> {

  public:
  
  XplReal (const XplIndex newdim);
  XplReal ();
  XplReal (long d0, long d1=1, long d2=1, long d3=1, long d4=1, long d5=1, long d6=1, long d7=1);
  XplReal (XplNumber<T> x);
  XplReal (XplArray<T> x);
//  XplReal (const XplReal<T> &x); 
  XplReal (const XplReal<T> *x);
  ~XplReal ();

  XplReal<T>& operator= (const XplReal<T> &x);		
  XplReal<T>& operator= (const XplNumber<T> &x);		
  XplReal<T>& operator= (const XplArray<T> &x); 

  XplReal<T> acos (void);     
  XplReal<T> acosh (void);    
  XplReal<T> asin (void);     
  XplReal<T> asinh (void);    
  XplReal<T> atan (void);     
  XplReal<T> atanh (void);    
  XplReal<T> ceil (void);     
  XplReal<T> cos (void);      
  XplReal<T> cosh (void);     
  XplReal<T> erf (void);      
  XplReal<T> erfc (void);     
  XplReal<T> exp (void);      
  XplReal<T> expm1 (void);    
  XplReal<T> fabs (void);     
  XplReal<T> floor (void);    
  XplReal<T> gamma (void);    
  XplReal<T> lgamma (void);   
  XplReal<T> log (void);      
  XplReal<T> log10 (void);    
  XplReal<T> log1p (void);    
  XplReal<T> logb (void);     
  XplReal<T> rint (void);     
  XplReal<T> sin (void);      
  XplReal<T> sinh (void);     
  XplReal<T> sqrt (void);     
  XplReal<T> tan (void);      
  XplReal<T> tanh (void);     

//double  copysign(double,double);
//double  frexp(double, int*);
//double  hypot(double,double);
//double  infnan(int);
//int     isinf(double);
//int     isnan(double);
//double  j0(double);
//double  j1(double);
//double  jn(int, double);
//double  ldexp(double, int);
//double  modf(double, double*);
//double  pow(double, double);
//double  y0(double);
//double  y1(double);
//double  yn(int, double);
//double aint(double);
//double anint(double);
//int irint(double);
//int nint(double);

  XplReal<T> inv (const XplReal<T> &x);
  void lu (XplReal<T> &l, XplReal<T> &u, XplNumber<long> &ix) const;      
  XplArray<T> det (void) const;       

  XplReal<T>& randomize (int no, T init);
  XplReal<T>& random (int no);

  XplReal<T> fft (void) const;      
  XplReal<T> invfft (void) const;      

  void eigsm (XplNumber<T> *xb, XplNumber<T> *yb) const;

  XplReal<T> mean (long d, const XplNumber<long> *cond=NULL) const;
  XplReal<T> meannan (long d) const;
  XplReal<T> var (long d, const XplNumber<long> *cond=NULL) const;
  XplReal<T> varnan (long d) const;
  XplReal<T> cov (const XplNumber<long> *cond) const;
  XplReal<T> covnan (void) const;
  XplReal<T> median (char f); // PC 20010221
  XplReal<T> medianNaN (char f); // PC 20010221

  XplReal<T> mseq (long n, const XplReal<T> *d) const; // PC 20010222
  XplReal<T> aseq (long n, const XplReal<T> *d) const; // PC 20010222
  
  XplReal<T> sker (const XplReal<T>& bandwidth, const char *kernel, const XplReal<T>& weight, XplReal<T> *xest=NULL) const; 

  XplReal<T> distance (const char *dist = "L2") const;

  XplReal<T> pdfb (const XplReal<T> &a, const XplReal<T> &b) const;
  XplReal<T> pdfc (const XplReal<T> &a) const;
  XplReal<T> pdff (const XplReal<T> &a, const XplReal<T> &b) const;
  XplReal<T> pdfn (void) const;
  XplReal<T> pdft (const XplReal<T> &a) const;
  XplReal<T> cdfn (void) const;
  XplReal<T> cdft (const XplReal<T> &a) const;
  XplReal<T> cdfc (const XplReal<T> &a) const;
  XplReal<T> cdfb (const XplReal<T> &a, const XplReal<T> &b) const;
  XplReal<T> cdff (const XplReal<T> &a, const XplReal<T> &b) const;
  XplReal<T> qfn (void) const;
  XplReal<T> qft (const XplReal<T> &a) const;
  XplReal<T> qfc (const XplReal<T> &a) const;
  XplReal<T> qff (const XplReal<T> &a, const XplReal<T> &b) const;

  XplReal<T> atan2 (const XplReal<T> &a) const;

  void fwt (const XplNumber<long> &level, const XplReal<T> &h, XplReal<T> &a, XplReal<T> &b);
  void invfwt (const XplReal<T> &a, const XplReal<T> &b, const XplNumber<long> &n, const XplNumber<long> &l,const  XplReal<T> &h);

  XplReal<T> ons (const char *base, const XplNumber<long>& order);

  void contour2 (const XplReal<T> &cuta, XplNumber<long> *retl, XplReal<T> *retp);
  void contour3 (const XplReal<T> &cuta, XplNumber<long> *retl, XplReal<T> *retp);

  void nninit (const XplReal<T> &unit, XplNumber<long> *sortweiarray);
  void nnfunc (const XplReal<T> &unitarray, const XplReal<T> &xarray, XplReal<T> *yarray);
  void nnvisu (const XplReal<T> &xvarray, XplReal<T> *xvdarray, XplReal<T> *verrarray);

  XplReal<T> isoreg (void) const;
  XplReal<T> sknn (const XplReal<T> &yarray, const XplNumber<long> &karray) const;
  XplReal<T> rmed (const XplNumber<long> &karray) const;
  XplReal<T> l1line (const XplReal<T> &yarray) const;
  XplReal<T> lowess (const XplReal<T> &yarray, const XplReal<T> *farray = NULL) const;

  void fwtin (const XplNumber<long> &deptharray, const XplReal<T> &hvec, XplReal<T> *ti) const;
  void invfwtin (const XplNumber<long> &deptharray, const XplReal<T> &hvec, XplReal<T> *ti) const;
  void fwtin_shift (const XplNumber<long> &param, XplReal<T> *ti) const;

  void nnrsetnet (const XplReal<T> &param, const XplReal<T> &nconn, const XplReal<T> &conn) const;
  void nnrsettrain (const XplReal<T> &ntr, const XplReal<T> &xy, const XplReal<T> &weights) const;
  void nnrdovm (const XplReal<T> &param, const XplReal<T> &wts, XplReal<T> *nwts, XplReal<T> *nval) const;
  void nnrtest (const XplReal<T> &param, const XplReal<T> &xy, const XplReal<T> &wts, XplReal<T> *yh, XplReal<T> *he) const; 
  int svd (XplReal<T> *u, XplReal<T> *l, XplReal<T> *v) const;

  void xplkmeans (const XplNumber<long> &bmat, XplNumber<long> *rmat, 
                  XplNumber<long> *gmat, XplReal<T> *cmat, 
                  XplReal<T> *vmat, XplReal<T> *smat,
                  XplReal<T> *wmat = NULL, XplReal<T> *mmat = NULL) const;

  void xplagglom (int imtd, XplNumber<long> lmat, 
                  XplReal<T> *pmat, XplReal<T> *tmat, XplReal<T> *gmat,
                  XplReal<T> *pd, XplReal<T> *dmat, XplReal<T> *opt = NULL) const;

  void xpltree (double cut, long opt, XplReal<T> *g, XplReal<T> *mind) const;
  void xpldistance (int mtc, XplReal<T> *d, XplReal<T> *w = NULL) const;
  void invfwt2 (XplReal<T> *res, XplReal<T> *hvec, long level, long asm_index) const;
  void fwt2 (XplReal<T> *res, XplReal<T> *hvec, long level, long asm_index) const;

  void dwt (const XplNumber<long> &level, const XplReal<T> &h, XplReal<T> &d) const;
  void invdwt (XplReal<T> &x, const XplNumber<long> &l, const XplReal<T> &h) const;
  void cartsplit (const XplReal<T> &y, const XplReal<T> &d, const XplReal<T> &t, 
                  const XplReal<T> &n, XplReal<T> *splitvec, CartSplit *splitval,
                  XplReal<T> *splitmean, XplReal<T> *splitvar, 
                  XplReal<T> *splitn, long nmaxgrp, long nmingrp, T vmaxgrp,
                  XplReal<T> *endpoint) const;
  void eiggn (XplReal<T> *vecr, XplReal<T> *veci,
	      XplReal<T> *valr, XplReal<T> *vali,
              XplReal<T> *imag = NULL);
};

template<class T> XplReal<T> singlefunc (XplReal<T> &x, double (*func) (double l));

#endif





