/* $Header: /home/xplore/cvs/xpl4gr/xsockio.C,v 1.3 2002/08/16 12:32:03 sigbert Exp $ */

#ifdef SOCKETSERVER

#include <string.h>
#include <errno.h>
#include "xsockio.h"

int oldClientVersion;      // flag to distinguish between old and new server

/*long readLineFromSocket (char *s, long max)
{
  char buf[max+1];

  static int ReadAgain = TRUE, sockintern = -1, bpos;
  int        m, i;

  cerr << sock << " enter rlfs" << endl;

  if (sockintern != sock)
    {
    sockintern = sock;
    ReadAgain  = TRUE;
    }

  i = 0;
  while (1)
    {
    if (ReadAgain)
      {
      bpos = 0;
      if ((m = read (sock, buf, max)) < 0)
	{
	if (errno == EINTR)
	  continue;
	cerr << "readLine: Error by read " << endl;
	if (doExit)
	  {
	  close (sock);
	  exit (1);
      }
	}
      if (m == 0)
	{
        cerr << "readLine: 0 chars read: should not happen " << endl;
	close (sock);
	exit (0);
	}
      buf[m+1] = '\0';           // to be sure
      }

    cerr << "#\n" << buf << "#\n";
    cerr << "rlfs m = " << m;

    while (bpos < m && buf[bpos] != '\n' && buf[bpos] != '\r')
      s[i++] = buf[bpos++];

    ReadAgain = bpos >= m;

    if (buf[bpos++] == '\n')
      {
      s[i+1] = '\n';
      break;
      }
    }
  cerr << "\ti = " << i << "\te rlfs s = \t#" << s << '#' << endl;

}
*/
long readLineFromSocket (char *s, long max, int doExit)
{
  long i, m, retry = 2;
  char c;

  for (i=0; i<max-1; i++)
    {
    if ((m = read (sock, &c, 1)) < 0)
      {
      if (errno == EINTR)
	continue;
      cerr << "readLine: Error by read " << endl;
      if (doExit)
        {
        close (sock);
        exit (0);
        }
      }
    if (m == 0)
      {
      cerr << "readLine: 0 chars read: should not happen " << endl;
      if (retry--)
	{
	//	sleep (1);
	continue;
        }
      else
	if (doExit)
	  {
	  close (sock);
	  exit (0);
	  }
        else
	  return (0);
      }
    if (m > 1)
      {
      cerr << "readLine: to many chars read: should not happen " << endl;
      if (doExit)
        {
        close (sock);
	exit (0);
        }
      else
	return (0);
      }
    s[i] = c;
    if (c == '\n')      // only CR. DOS and Win 95/NT still like \r\n  
      break;
    }
  s[i+1] = '\0';        // for sure
  //  cerr << "rLFS: " << i << "\t#" << s << '#' << endl;     // only debugging
  return (i);
}

void sockin  (long &d)
{
  char buf[1024];

  readLineFromSocket (buf, 1024);
  sscanf (buf, "%ld", &d);
}

void sockin  (double &d)
{
  char buf[1024];

  readLineFromSocket (buf, 1024);
  sscanf (buf, "%lf", &d);
}

void sockin  (char *s)
{
  char buf[1024];

  readLineFromSocket (buf, 1024);
  strcpy (s, buf);
}

void sockout (double d, const char *fmt)
{
  char buf[1024];

  sprintf (buf, fmt, d);
  write (sock, buf, strlen (buf));
}

void sockout (long d, const char *fmt)
{
  char buf[1024];

  sprintf (buf, fmt, d);
  write (sock, buf, strlen (buf));
}

void sockout (unsigned long d, const char *fmt)
{
  char buf[1024];

  sprintf (buf, fmt, d);
  write (sock, buf, strlen (buf));
}

void sockout (const char *d)
{
  write (sock, d, strlen (d));
}

void sockout (const char c)
{
  write (sock, &c, 1);
}

#ifndef MATRIX
void sockout (XplDouble &x, const char *varstr, char *str)
{
  char line[1024], *fname;
		
  fname = xtmpnam();   // SK 05.06.2000
  //logt ("sockout #ifndef MATRIX");
  //logt (fname);
  fstream f (fname, ios::out);

  if (f.bad ())
    {
    cerr << "Couldn't open temporary file (out). Exit ..." << endl;
    exit (1);
    }

  Xplostream tmpstream(f);     // tk + sk 20.2.98
  if (str != NULL)
    x.mdump (str, &tmpstream);
   else
    x.mdump ("%5.5g", &tmpstream);

  f.close();
  
  fstream fi (fname, ios::in);
  if (fi.bad ())
    {
    cerr << "Couldn't open temporary file (in). Exit ..." << endl;
    exit (1);
    }

  write (sock, "\nContent of object ", strlen ("\nContent of object "));
  write (sock, varstr, strlen (varstr));
  write (sock, "\n", 1);

  while ( fi.getline(line, 1023, '\n'))
    {
    write (sock, line, strlen (line));
    write (sock, "\n", 1);
    }

  write (sock, "\n", 1);
  remove (fname);
}
#else
void sockout (XplDouble &x, const char *varstr, char *str)
{
  x.out ();
}
#endif  // !MATRIX

#ifdef _XPLCDEF_
void sockout (XplChar &x, const char *varstr, char *fst )
{
  char line[1024], *fname;
		
  fname = xtmpnam();  // SK 05.06.2000
  //  logt ("sockout #ifdef _XPLCDEF_");
  //logt (fname);
  fstream f(fname, ios::out);
  if (f.bad())
    {  
    cerr << "Couldn't open temporary file (out). Exit ..." << endl;
    exit (1);
    }
  Xplostream tmpstream(f);      // tk + sk 20.2.98
  x.mdump ("%s", &tmpstream);
  f.close ();
  	
  fstream fi(fname, ios::in);
  if (fi.bad ())
    {
    cerr << "Couldn't open temporary file (in). Exit ..." << endl;
    exit (1);
    }

  write (sock, "\nContent of object ", strlen ("\nContent of object "));
  write (sock, varstr, strlen (varstr));
  write (sock, "\n", 1);

  while (fi.getline(line, 1023, '\n'))
    {
    write (sock, line, strlen (line));
    write (sock, "\n", 1);
    }

  remove(fname);

}
#endif   // XPLCDEF


#endif   // SOCKETSERVER
