/* $Header: /home/xplore/cvs/xpl4gr/xsort.C,v 1.3 2002/08/16 12:32:04 sigbert Exp $ */

#include <stdlib.h>

#include "initxa.hpp"
#include "xstring.hpp"
#include "xsort.hpp"

template<class T> long XplSort<T>::qsgreater (long a, long b)
  { if (isNaN(sv[a])) 
      return (isNaN(sv[b]) ? 0 : -1);
    if (isNaN(sv[b])) 
      return -1;
    if (sv[a]==sv[b])
       return(0);
    return ((sv[a] > sv[b]) ? 1 : -1);
  }

template<class T> long XplSort<T>::qssmaller (long a, long b)
  { 
    if (isNaN(sv[a])) 
      return (isNaN(sv[b]) ? 0 : -1);
    if (isNaN(sv[b])) 
      return 1;
    if (sv[a]==sv[b]) 
      return(0);
    return ((sv[a] < sv[b]) ? 1 : -1);
  }

template<class T> void XplSort<T>::bubble (long l, long r)
  { long i, j, h;
#if SKDEBUG
    printf ("bubble %li %li\n", l, r);
#endif

    for (i=l; i<r; i++)
    { 
#if SKDEBUG
      printf ("Bubbl %i\n", i);
#endif      
      for (j=i+1; j <=r; j++)
      { 
      #ifdef HAS_STDSORT //LOOK!
      if (proc(feld[i], feld[j])>0)
      #else
      if (((this->*proc) (feld[i], feld[j]))>0)
      #endif
        { h = feld[i];
          feld[i] = feld[j];
          feld[j] = h;
	}
      }
    }
  }

template<class T> void XplSort<T>::quicki (long l, long r)
  { long zl, zr, z, h;
    zl = z = l;
    zr = r;
    if ((r-l) < 6)
    { bubble(l, r);
      return;
    }
#if SKDEBUG
    printf ("quicki %li %li\n", l, r);
#endif
    do
    { 
    #ifdef HAS_STDSORT //LOOK!
      if (proc(feld[zl],feld[zr])>-1)
    #else
      if ((this->*proc)(feld[zl],feld[zr])>-1)
    #endif
      { h = feld[zl];
        feld[zl] = feld[zr];
        feld[zr] = h;
	z = zl+zr-z;
      }
      if (z==zl)
        zr--;
      else
        zl++;
    }
    while (zl!=zr);
    if (l<zl-1)
      quicki(l, zl-1);
    if (r>zr+1)
      quicki(zr+1, r);
  }

template<class T> void XplSort<T>::heapsort (long n)
  { int l,j,ir,i;
    long rra;
    l=(n >> 1)+1;
    ir=n;
    for (;;) 
    { if (l > 1)
      { l--;
        rra=feld[l-1];
      }
      else 
      { rra=feld[ir-1];
        feld[ir-1]=feld[0];
        if (--ir == 1) 
        { feld[0]=rra;
	  return;
        }
      }
      i=l;
      j=l << 1;
      while (j <= ir)
      { //if (j < ir && feld[j] < feld[j+1]) ++j;
#ifdef HAS_STDSORT //LOOK!
        if (j < ir && (proc(feld[j-1],feld[j])>-1)) ++j;
        if (proc(rra,feld[j-1])>-1)
#else
        if (j < ir && ((this->*proc)(feld[j-1],feld[j])>-1)) ++j;
        if ((this->*proc)(rra,feld[j-1])>-1)
#endif
//	if (rra < feld[j-1]) 
        { feld[i-1]=feld[j-1];
	  j += (i=j);
        }
	else j=ir+1;
      }
      feld[i-1]=rra;
    }
  }

template<class T> XplSort<T>::XplSort() { sv = NULL; }

template<class T> void XplSort<T>::sortvec (T *ptr)
  { sv = ptr; }

template<class T> void XplSort<T>::quicksort (long *base, long n, int type)
  { if (n<2) return;
    feld = base;
    #ifdef HAS_STDSORT //LOOK!
    if (type)
//      proc = qsgreater; // for quicki
      proc = qssmaller; // for heapsort   
    else
//      proc = qssmaller; // for quicki
      proc = qsgreater; // for heapsort
    #else
    if (type)
//       proc = (&XplSort<T>::qsgreater);
       proc = &XplSort<T>::qssmaller;
    else
//       proc = &XplSort<T>::qssmaller;
      proc = (&XplSort<T>::qsgreater);
    #endif
//    quicki(0, n-1);
    heapsort (n);
  }



template class XplSort<int>;
template class XplSort<long>;
template class XplSort<double>;
template class XplSort<xplmask>;
template class XplSort<xplstring>;
