/* $Header: /home/xplore/cvs/xpl4gr/xtime.hpp,v 1.3 2002/08/16 12:32:04 sigbert Exp $ */

#include "xchar.hpp"
#include "initxa.hpp"

#ifndef XPLTIME
#define XPLTIME

typedef enum {Xsec, Xminute, Xhour, Xday, Xweek, Xmonth, Xyear} XGran;

long _juldnj(struct tm *bdt, long Transition);
struct tm* julcdj (long jd, long Transition = 2361222L);
long juldnj (struct tm *bdt, long Transition = 2361222L);

class XplTime : public XplArray<long> {

  XGran granularity;
  long zeroday;

  public:
  
  XplTime (const XplIndex newdim);

  XplTime (long d0=1, long d1=1, long d2=1, long d3=1, long d4=1, long d5=1, long d6=1, long d7=1);
  ~XplTime ();
//  XplTime (const XplTime& x);
  XplTime (const XplArray<long>& x);

  void SetXplTimeGran (XGran newgran);
  void SetXplTimeZero (long newzeroday);

  XplTime& time (const XplArray<long> &newtime, XGran newgran = Xsec);
  XplTime &time (const XplArray<long> &newyear, const XplArray<long> *newmonth = NULL, 
                 const XplArray<long> *newday = NULL, const XplArray<long> *newhour = NULL,
                 const XplArray<long> *newminute = NULL, const XplArray<long> *newsecond = NULL);

  XplChar year () const;
  XplChar month () const;
  XplChar dayofmonth () const;
  XplChar dayofweek () const;
  XplChar hour () const;
  XplChar minute () const;
  XplChar second () const;

  XplArray<long> nyear () const;
  XplArray<long> nmonth () const;
  XplArray<long> ndayofmonth () const;
  XplArray<long> ndayofweek () const;
  XplArray<long> nhour () const;
  XplArray<long> nminute () const;
  XplArray<long> nsecond () const;

  XplArray<long> getlong (void) const;

  XplTime fill (XGran stepgran, long elem, long step = 1);

  void mdump (const char *fmt, Xplostream *stream = NULL, const char *varname=NULL,
              int pdim = 1) const;
  void now (XGran newgran = Xsec, long newzeroday = 2440588L);
  void nowlocal (XGran newgran = Xsec, long newzeroday = 2440588L);
  int WriteXArray (FILE *f) const;

};

#endif





	
